/* libgtk_s7.c */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdbool.h>
#include "s7.h"

#define HAVE_CAIRO_1_8    ((CAIRO_VERSION_MAJOR >= 1) && (CAIRO_VERSION_MINOR >= 8))
#define HAVE_CAIRO_1_9_12 ((CAIRO_VERSION_MAJOR >= 1) && (CAIRO_VERSION_MINOR >= 9) && (CAIRO_VERSION_MICRO >= 12))

#if ((!__NetBSD__) && ((_MSC_VER) || (!defined(__STC__)) || (defined(__STDC_VERSION__) && (__STDC_VERSION__ < 199901L))))
  #define __func__ __FUNCTION__
#endif

#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#if (!GTK_CHECK_VERSION(3, 0, 0))
  #include <gdk/gdkkeysyms.h>
#endif
#include <glib-object.h>
#include <pango/pango.h>
#include <cairo/cairo.h>
static s7_pointer lg_true, lg_false;
static bool lg_boolean(s7_pointer val) {return(val != lg_false);}
#define s7_make_type_with_c_pointer(Sc, Type, Ptr) s7_make_c_pointer_with_type(Sc, Ptr, Type, lg_false)


static int xm_obj_tag;
static void xm_obj_free(void *val)
{
  free(val);
}
static bool s7_equalp_xm(void *x1, void *x2)
{
  return(x1 == x2);
}
static s7_pointer make_xm_obj(s7_scheme *sc, void *ptr)
{
  return(s7_make_c_object(sc, xm_obj_tag, ptr));
}
static void define_xm_obj(s7_scheme *sc)
{
  xm_obj_tag = s7_make_c_type(sc, "XgObj");
  s7_c_type_set_free(sc, xm_obj_tag, xm_obj_free);
  s7_c_type_set_equal(sc, xm_obj_tag, s7_equalp_xm);
}  

static s7_pointer GdkEventScroll__sym, GtkScrollbar__sym, GtkCenterBox__sym, GtkCheckButton__sym, GdkDrawContext__sym,
                  GtkDrawingAreaDrawFunc_sym, GtkShortcutLabel__sym, GtkPadActionType_sym, GtkPadActionEntry__sym, GActionGroup__sym,
                  GtkPadController__sym, GdkDevicePadFeature_sym, GdkDevicePad__sym, GdkDrawingContext__sym, GdkSubpixelLayout_sym,
                  GdkMonitor__sym, GdkDeviceTool__sym, GdkAxisFlags_sym, GdkSeatGrabPrepareFunc_sym, GdkSeatCapabilities_sym,
                  GdkGrabStatus_sym, GtkPopoverConstraint_sym, GtkShortcutsWindow__sym, GtkStackSidebar__sym, GtkSearchEntry__sym,
                  GtkPopoverMenu__sym, GtkStyleContext__sym, GdkGLContext__sym, GtkGLArea__sym, GtkPropagationPhase_sym,
                  GtkEventController__sym, GtkGestureZoom__sym, GtkGestureSwipe__sym, GtkGestureSingle__sym, GtkGestureRotate__sym,
                  GtkGestureMultiPress__sym, GtkGesturePan__sym, GtkGestureDrag__sym, GdkEventSequence__sym, GtkEventSequenceState_sym,
                  GtkGesture__sym, GtkAllocation__sym, GtkPopover__sym, GtkActionBar__sym, GtkFlowBox__sym,
                  GtkFlowBoxChild__sym, GdkEventType_sym, GtkSearchBar__sym, GtkListBox__sym, GtkListBoxRow__sym,
                  GtkHeaderBar__sym, GtkRevealerTransitionType_sym, GtkRevealer__sym, GtkStackTransitionType_sym, GtkStack__sym,
                  GtkStackSwitcher__sym, GtkPlacesSidebar__sym, GtkPlacesOpenFlags_sym, GtkBaselinePosition_sym, GdkFullscreenMode_sym,
                  GtkInputHints_sym, GtkInputPurpose_sym, GtkLevelBarMode_sym, GtkLevelBar__sym, GtkMenuButton__sym,
                  GtkColorChooser__sym, GtkApplicationWindow__sym, GtkApplication__sym, GMenuModel__sym, guint___sym,
                  GdkModifierIntent_sym, GtkFontChooser__sym, GdkScrollDirection_sym, GtkOverlay__sym, GtkWidgetPath__sym,
                  GtkStateFlags_sym, GdkScreen___sym, GtkToolShell__sym, GtkWindowGroup__sym, GtkInvisible__sym,
                  GtkOrientable__sym, GtkCellArea__sym, GtkBorder__sym, GtkSwitch__sym, GtkScrollablePolicy_sym,
                  GtkScrollable__sym, GtkGrid__sym, GdkRGBA__sym, GtkComboBoxText__sym, GtkAlign_sym,
                  GtkSizeRequestMode_sym, cairo_region_overlap_t_sym, cairo_rectangle_int_t__sym, double__sym, cairo_rectangle_t__sym,
                  cairo_device_t__sym, cairo_bool_t_sym, cairo_text_cluster_flags_t__sym, cairo_text_cluster_t___sym, cairo_glyph_t___sym,
                  cairo_text_cluster_flags_t_sym, cairo_text_cluster_t__sym, cairo_region_t__sym, GtkMessageDialog__sym, GdkDevice__sym,
                  GtkAccessible__sym, GdkModifierType__sym, GtkToolPaletteDragTargets_sym, GtkToolItemGroup__sym, GtkToolPalette__sym,
                  GtkSpinner__sym, GtkEntryBuffer__sym, GtkMessageType_sym, GtkInfoBar__sym, GIcon__sym,
                  GtkEntryIconPosition_sym, GFile__sym, GtkScaleButton__sym, GtkCalendarDetailFunc_sym, GtkTooltip__sym,
                  cairo_rectangle_list_t__sym, void__sym, cairo_filter_t_sym, cairo_extend_t_sym, cairo_format_t_sym,
                  cairo_path_t__sym, cairo_destroy_func_t_sym, cairo_user_data_key_t__sym, cairo_text_extents_t__sym, cairo_font_extents_t__sym,
                  cairo_font_face_t__sym, cairo_glyph_t__sym, cairo_scaled_font_t__sym, cairo_font_weight_t_sym, cairo_font_slant_t_sym,
                  cairo_hint_metrics_t_sym, cairo_hint_style_t_sym, cairo_subpixel_order_t_sym, cairo_status_t_sym, bool_sym,
                  cairo_matrix_t__sym, cairo_line_join_t_sym, cairo_line_cap_t_sym, cairo_fill_rule_t_sym, cairo_antialias_t_sym,
                  cairo_operator_t_sym, cairo_pattern_t__sym, cairo_content_t_sym, GtkPageSet_sym, GtkPageRange__sym,
                  GtkPrintPages_sym, GtkPrintQuality_sym, GtkPrintDuplex_sym, GtkPaperSize__sym, GtkPageOrientation_sym,
                  GtkPrintSettingsFunc_sym, GtkPageSetupDoneFunc_sym, GtkPrintStatus_sym, GtkPrintOperationAction_sym, GtkPrintOperationResult_sym,
                  GtkUnit_sym, GtkPrintSettings__sym, GtkPrintOperation__sym, GtkPageSetup__sym, GtkPrintContext__sym,
                  cairo_surface_t__sym, GtkTreeViewGridLines_sym, GtkRecentData__sym, GtkTextBufferDeserializeFunc_sym, GtkTextBufferSerializeFunc_sym,
                  time_t_sym, GtkRecentChooserMenu__sym, GtkRecentManager__sym, GtkRecentFilter__sym, GtkRecentSortFunc_sym,
                  GtkRecentSortType_sym, GtkRecentChooser__sym, GtkLinkButton__sym, GtkAssistantPageType_sym, GtkAssistantPageFunc_sym,
                  GtkAssistant__sym, GDestroyNotify_sym, GtkTreeViewSearchPositionFunc_sym, GtkSensitivityType_sym, GtkClipboardRichTextReceivedFunc_sym,
                  GtkMenuBar__sym, GtkPackDirection_sym, GtkIconViewDropPosition_sym, GValue__sym, GLogFunc_sym,
                  PangoMatrix__sym, PangoRenderPart_sym, PangoRenderer__sym, GtkClipboardImageReceivedFunc_sym, GtkMenuToolButton__sym,
                  GtkFileChooserButton__sym, PangoScriptIter__sym, PangoScript_sym, PangoAttrFilterFunc_sym, PangoEllipsizeMode_sym,
                  GtkIconViewForeachFunc_sym, GtkAboutDialog__sym, GtkTreeViewRowSeparatorFunc_sym, GtkCellView__sym, GtkAccelMap__sym,
                  GtkClipboardTargetsReceivedFunc_sym, GtkOrientation_sym, GtkToolButton__sym, GtkIconLookupFlags_sym, GtkIconInfo__sym,
                  GtkIconTheme__sym, GtkFileChooser__sym, GtkCellLayoutDataFunc_sym, GtkCellLayout__sym, GtkFileFilterFunc_sym,
                  GtkFileFilterFlags_sym, GtkFileFilter__sym, GSourceFunc_sym, GtkToggleToolButton__sym, GtkSeparatorToolItem__sym,
                  GtkRadioToolButton__sym, GtkEntryCompletionMatchFunc_sym, GtkFontButton__sym, GtkExpander__sym, GtkComboBox__sym,
                  GtkTreeModelFilter__sym, GtkFileChooserAction_sym, GtkToolItem__sym, GtkCalendarDisplayOptions_sym, GdkScreen__sym,
                  PangoLayoutRun__sym, PangoLayoutIter__sym, PangoLayoutLine__sym, int__sym, PangoAlignment_sym,
                  PangoWrapMode_sym, PangoItem__sym, PangoGlyphString__sym, PangoFontMap__sym, PangoGlyph_sym,
                  PangoFontFace__sym, PangoFontFace___sym, PangoFontFamily__sym, PangoFontMask_sym, PangoFontDescription___sym,
                  PangoCoverageLevel_sym, PangoCoverage__sym, PangoFontMetrics__sym, PangoFontset__sym, PangoFont__sym,
                  PangoFontFamily___sym, PangoLogAttr__sym, PangoAnalysis__sym, PangoAttrList___sym, PangoAttrIterator__sym,
                  PangoRectangle__sym, PangoUnderline_sym, PangoStretch_sym, PangoVariant_sym, PangoWeight_sym,
                  PangoStyle_sym, guint16_sym, PangoAttribute__sym, PangoAttrType_sym, PangoColor__sym,
                  GdkGravity_sym, GtkWindowPosition_sym, GtkWindowType_sym, GtkWindow__sym, GtkTextDirection_sym,
                  AtkObject__sym, GtkDirectionType_sym, GtkViewport__sym, GtkTreeViewSearchEqualFunc_sym, GtkTreeViewDropPosition_sym,
                  GtkTreeViewMappingFunc_sym, GtkTreeViewColumnDropFunc_sym, GtkTreeViewColumnSizing_sym, GtkTreeCellDataFunc_sym, GtkTreeStore__sym,
                  GtkTreeIterCompareFunc_sym, GtkSortType_sym, GtkTreeSortable__sym, GtkTreeSelectionForeachFunc_sym, GtkTreeModel___sym,
                  GtkTreeSelectionFunc_sym, GtkSelectionMode_sym, GtkTreeModelSort__sym, GtkTreeModelForeachFunc_sym, GtkTreeModelFlags_sym,
                  GtkTreeRowReference__sym, GtkTreeDragDest__sym, GtkTreeDragSource__sym, GtkToolbarStyle_sym, GtkToolbar__sym,
                  GtkToggleButton__sym, PangoTabArray__sym, GtkWrapMode_sym, GtkTextWindowType_sym, GtkTextView__sym,
                  GtkTextTagTableForeach_sym, GtkTextAttributes__sym, GtkTextSearchFlags_sym, GtkTextCharPredicate_sym, GtkTextMark__sym,
                  GtkTextChildAnchor__sym, GtkTextIter__sym, GtkTextTagTable__sym, GtkTextBuffer__sym, GtkStatusbar__sym,
                  GtkSpinType_sym, GtkSpinButtonUpdatePolicy_sym, GtkSpinButton__sym, GtkSizeGroupMode_sym, GtkSizeGroup__sym,
                  GtkSettings__sym, GtkCornerType_sym, GtkPolicyType_sym, GtkScrolledWindow__sym, GtkScale__sym,
                  GtkRange__sym, GtkRadioMenuItem__sym, GtkRadioButton__sym, GtkProgressBar__sym, GtkPaned__sym,
                  GtkPositionType_sym, GtkNotebook__sym, GtkMenuShell__sym, gint__sym, GtkMenuItem__sym,
                  GtkMenu__sym, PangoLanguage__sym, GtkListStore__sym, GtkLayout__sym, GtkJustification_sym,
                  GtkLabel__sym, guint16__sym, GtkIMContextSimple__sym, GdkEventKey__sym, PangoAttrList__sym,
                  GtkIMContext__sym, GtkImageType_sym, GtkImage__sym, GtkShadowType_sym, GtkFrame__sym,
                  GtkFixed__sym, PangoLayout__sym, GtkEntry__sym, GtkEditable__sym, GtkTargetList__sym,
                  GtkDestDefaults_sym, etc_sym, GtkDialog__sym, GtkCallback_sym, GtkContainer__sym,
                  GtkClipboardTextReceivedFunc_sym, GtkClipboardReceivedFunc_sym, GtkClipboardClearFunc_sym, GtkClipboardGetFunc_sym, GtkTargetEntry__sym,
                  GtkCheckMenuItem__sym, GtkCellRendererToggle__sym, GtkCellRendererText__sym, GtkCellRendererState_sym, GtkCellEditable__sym,
                  GtkCalendar__sym, GtkReliefStyle_sym, GtkButton__sym, GtkPackType_sym, GtkBox__sym,
                  GtkBin__sym, GtkBindingSet__sym, GtkButtonBox__sym, GtkButtonBoxStyle_sym, GtkAspectFrame__sym,
                  GtkAdjustment__sym, GtkAccelMapForeach_sym, GtkAccelLabel__sym, GtkAccelGroupEntry__sym, lambda3_sym,
                  GSList__sym, GObject__sym, GtkAccelFlags_sym, GtkAccelGroup__sym, GTimeVal__sym,
                  GdkPixbufAnimationIter__sym, GdkPixbufAnimation__sym, GdkInterpType_sym, double_sym, gfloat_sym,
                  guchar_sym, char___sym, GdkPixbufDestroyNotify_sym, GError__sym, int_sym,
                  GdkColorspace_sym, GdkWindowTypeHint_sym, GdkWindowHints_sym, GdkGeometry__sym, GdkWindowEdge_sym,
                  GdkWMFunction_sym, GdkWMDecoration_sym, GdkEventMask_sym, GdkWindowState_sym, GdkFilterFunc_sym,
                  GdkWindowType_sym, GdkPropMode_sym, guchar__sym, PangoContext__sym, PangoDirection_sym,
                  GdkKeymapKey__sym, GdkKeymap__sym, GdkRectangle__sym, char__sym, gchar___sym,
                  GdkEventFunc_sym, gdouble_sym, GList__sym, guint32_sym, GdkDragAction_sym,
                  GdkDragContext__sym, GdkCursorType_sym, GdkDisplay__sym, GdkCursor__sym, GSignalMatchType_sym,
                  GConnectFlags_sym, GtkDestroyNotify_sym, GSignalEmissionHook_sym, gulong_sym, GSignalInvocationHint__sym,
                  GQuark_sym, guint__sym, GSignalQuery__sym, GType__sym, GSignalCMarshaller_sym,
                  gpointer_sym, GSignalAccumulator_sym, GSignalFlags_sym, GType_sym, GClosureNotify_sym,
                  GCallback_sym, GNormalizeMode_sym, glong_sym, gssize_sym, gunichar__sym,
                  void_sym, GtkDrawingArea__sym, GdkSeat__sym, GtkRecentInfo__sym, gsize_sym,
                  guint8__sym, GdkAtom_sym, GLogLevelFlags_sym, GdkPixbuf__sym, GtkIconView__sym,
                  GtkEntryCompletion__sym, GtkFileFilterInfo__sym, GtkTreeSelection__sym, GtkCellRenderer__sym, GtkTreeViewColumn__sym,
                  GtkTreeView__sym, gunichar_sym, gint_sym, GdkAtom__sym, GtkSelectionData__sym,
                  GtkClipboard__sym, GtkTreeIter__sym, GtkTreePath__sym, GtkTreeModel__sym, gboolean_sym,
                  GdkModifierType_sym, guint_sym, gchar__sym, GtkTextTag__sym, GdkXEvent__sym,
                  GtkWidget__sym, lambda_data_sym, GClosure__sym, GtkAccelKey__sym, GdkEventMotion__sym,
                  gdouble__sym, GdkEventAny__sym, GdkEvent__sym, GdkWindow__sym, cairo_t__sym,
                  cairo_font_options_t__sym, PangoFontDescription__sym, idler_sym, GtkCellRendererPixbuf__sym, GtkSeparator__sym,
                  GtkSeparatorMenuItem__sym, GdkEventExpose__sym, GdkEventNoExpose__sym, GdkEventVisibility__sym, GdkEventButton__sym,
                  GdkEventCrossing__sym, GdkEventFocus__sym, GdkEventConfigure__sym, GdkEventProperty__sym, GdkEventSelection__sym,
                  GdkEventProximity__sym, GdkEventSetting__sym, GdkEventWindowState__sym, GdkEventDND__sym, GtkFileChooserDialog__sym,
                  GtkFileChooserWidget__sym, GtkColorButton__sym, GtkAccelMap_sym, GtkCellRendererCombo__sym, GtkCellRendererProgress__sym,
                  GtkCellRendererAccel__sym, GtkCellRendererSpin__sym, GtkRecentChooserDialog__sym, GtkRecentChooserWidget__sym, GtkCellRendererSpinner__sym,
                  gboolean__sym, GtkFontChooserDialog__sym, GtkFontChooserWidget__sym, GtkColorChooserDialog__sym, GtkColorChooserWidget__sym,
                  GtkColorWidget__sym, GtkGestureLongPress__sym;

#define lg_is_list(Arg) s7_is_list(sc, Arg)
static s7_scheme *cbsc = NULL;
static gboolean lg_find_func(GtkAccelKey* key, GClosure* closure, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, key),
                   s7_make_c_pointer(cbsc, closure),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_func2(GtkWidget* w, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, w),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_timer_func(gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 1,
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_destroy_func(gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_cadddr((s7_pointer)func_info), 
           s7_list(cbsc, 1,
                   s7_cadr((s7_pointer)func_info)));
}

static GdkFilterReturn lg_filter_func(GdkXEvent* xevent, GdkEvent* event, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((GdkFilterReturn)0);
  return((GdkFilterReturn)s7_c_pointer(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, xevent),
                   s7_make_c_pointer(cbsc, event),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_event_func(GdkEvent* event, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, event),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_text_tag_table_foreach(GtkTextTag* tag, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, tag),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_accel_map_foreach(gpointer func_info, const gchar* accel_path, guint accel_key, GdkModifierType accel_mods, gboolean changed)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_cadr((s7_pointer)func_info),
                   s7_make_string(cbsc, accel_path),
                   s7_make_integer(cbsc, accel_key),
                   s7_make_integer(cbsc, accel_mods),
                   s7_make_boolean(cbsc, changed)));
}

static gboolean lg_model_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, model),
                   s7_make_c_pointer(cbsc, path),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_tree_selection_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, model),
                   s7_make_c_pointer(cbsc, path),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_received(GtkClipboard* clipboard, GtkSelectionData* selection_data, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_c_pointer(cbsc, selection_data),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_text_received(GtkClipboard* clipboard, const gchar* text, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_string(cbsc, text),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_targets_received(GtkClipboard* clipboard, GdkAtom* atoms, gint n_atoms, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_c_pointer(cbsc, atoms),
                   s7_make_integer(cbsc, n_atoms),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_text_char_predicate(gunichar ch, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_integer(cbsc, ch),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_tree_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, GtkTreeViewColumn* prev_column, GtkTreeViewColumn* next_column, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_make_c_pointer(cbsc, tree_view),
                   s7_make_c_pointer(cbsc, column),
                   s7_make_c_pointer(cbsc, prev_column),
                   s7_make_c_pointer(cbsc, next_column),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_tree_mapping(GtkTreeView* tree_view, GtkTreePath* path, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, tree_view),
                   s7_make_c_pointer(cbsc, path),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_tree_search(GtkTreeModel* model, gint column, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_make_c_pointer(cbsc, model),
                   s7_make_integer(cbsc, column),
                   s7_make_string(cbsc, key),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_cell_data(GtkTreeViewColumn* tree_column, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_make_c_pointer(cbsc, tree_column),
                   s7_make_c_pointer(cbsc, cell),
                   s7_make_c_pointer(cbsc, tree_model),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)));
}

static gint lg_iter_compare(GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gint)0);
  return((gint)s7_integer(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, model),
                   s7_make_c_pointer(cbsc, a),
                   s7_make_c_pointer(cbsc, b),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_tree_selection(GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_make_c_pointer(cbsc, selection),
                   s7_make_c_pointer(cbsc, model),
                   s7_make_c_pointer(cbsc, path),
                   s7_make_boolean(cbsc, path_currently_selected),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_clip_get(GtkClipboard* clipboard, GtkSelectionData* selection_data, guint info, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_c_pointer(cbsc, selection_data),
                   s7_make_integer(cbsc, info),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_clear(GtkClipboard* clipboard, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_caddr((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_file_filter(const GtkFileFilterInfo* info, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, (void *)info),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_entry_completion_match(GtkEntryCompletion* completion, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_c_pointer(cbsc, completion),
                   s7_make_string(cbsc, key),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_row_separator(GtkTreeModel* model, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, model),
                   s7_make_c_pointer(cbsc, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_icon_view_foreach(GtkIconView* icon_view, GtkTreePath* path, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, icon_view),
                   s7_make_c_pointer(cbsc, path),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_image_received(GtkClipboard* clipboard, GdkPixbuf* pixbuf, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_c_pointer(cbsc, pixbuf),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_g_message_log_func(const gchar* domain, GLogLevelFlags log_level, const gchar* message, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_string(cbsc, domain),
                   s7_make_integer(cbsc, log_level),
                   s7_make_string(cbsc, message),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_clip_rich_text_received(GtkClipboard* clipboard, GdkAtom format, const guint8* text, gsize length, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  #if (!(defined(__cplusplus)))
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   s7_make_c_pointer(cbsc, clipboard),
                   s7_make_c_pointer(cbsc, format),
                   s7_make_c_pointer(cbsc, (void *)text),
                   s7_make_integer(cbsc, length),
                   s7_cadr((s7_pointer)func_info)));
  #endif
}

static void lg_search_position(GtkTreeView* tree_view, GtkWidget* search_dialog, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, tree_view),
                   s7_make_c_pointer(cbsc, search_dialog),
                   s7_cadr((s7_pointer)func_info)));
}

static gint lg_page_func(gint current_page, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gint)0);
  return((gint)s7_integer(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_integer(cbsc, current_page),
                   s7_cadr((s7_pointer)func_info)))));
}

static gint lg_recent_sort(GtkRecentInfo* a, GtkRecentInfo* b, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gint)0);
  return((gint)s7_integer(s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, a),
                   s7_make_c_pointer(cbsc, b),
                   s7_cadr((s7_pointer)func_info)))));
}

#if GTK_CHECK_VERSION(3, 20, 0)
static void lg_prepare_func(GdkSeat* seat, GdkWindow* window, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   s7_make_c_pointer(cbsc, seat),
                   s7_make_c_pointer(cbsc, window),
                   s7_cadr((s7_pointer)func_info)));
}
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static void lg_draw_func(GtkDrawingArea* self, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_apply_function(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_c_pointer(cbsc, self),
                   s7_cadr((s7_pointer)func_info)));
}
#endif


static gboolean lg_func3(GtkWidget *w, GdkEventAny *ev, gpointer data)
{
  return(s7_apply_function(cbsc, s7_car((s7_pointer)data),
                             s7_list(cbsc, 3, s7_make_c_pointer_with_type(cbsc, w, GtkWidget__sym, lg_false),
                                              s7_make_c_pointer_with_type(cbsc, ev, GdkEventAny__sym, lg_false),
                                              s7_cadr((s7_pointer)data))) != lg_false);
}

static gboolean lg_func4(GtkPrintOperation *op, GtkPrintContext *context, gint page_nr, gpointer data)
{
  return(s7_apply_function(cbsc, s7_car((s7_pointer)data),
                            s7_list(cbsc, 4, s7_make_c_pointer_with_type(cbsc, op, GtkPrintOperation__sym, lg_false),
                                             s7_make_c_pointer_with_type(cbsc, context, GtkPrintContext__sym, lg_false),
                                             s7_make_integer(cbsc, page_nr),
                                             s7_cadr((s7_pointer)data))) != lg_false);
}

#if (!GTK_CHECK_VERSION(3, 90, 0))
static s7_pointer lg_gtk_widget_set_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_events "void gtk_widget_set_events(GtkWidget* widget, gint events)"
  s7_pointer widget, events;
  widget = s7_car(args);
  events = s7_cadr(args);
  gtk_widget_set_events((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(events));
  return(lg_false);
}
#endif

static s7_pointer lg_g_unichar_validate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_validate "gboolean g_unichar_validate(gunichar ch)"
  s7_pointer ch;
  ch = s7_car(args);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "g_unichar_validate", 1, ch, "gunichar");
  return(s7_make_boolean(sc, g_unichar_validate(s7_integer(ch))));
}

static s7_pointer lg_g_unichar_isalnum(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isalnum "gboolean g_unichar_isalnum(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isalnum", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isalnum(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isalpha(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isalpha "gboolean g_unichar_isalpha(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isalpha", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isalpha(s7_integer(c))));
}

static s7_pointer lg_g_unichar_iscntrl(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iscntrl "gboolean g_unichar_iscntrl(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iscntrl", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iscntrl(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isdefined(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isdefined "gboolean g_unichar_isdefined(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isdefined", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isdefined(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isdigit(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isdigit "gboolean g_unichar_isdigit(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isdigit", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isdigit(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isgraph(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isgraph "gboolean g_unichar_isgraph(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isgraph", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isgraph(s7_integer(c))));
}

static s7_pointer lg_g_unichar_islower(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_islower "gboolean g_unichar_islower(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_islower", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_islower(s7_integer(c))));
}

static s7_pointer lg_g_unichar_ismark(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_ismark "gboolean g_unichar_ismark(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_ismark", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_ismark(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isprint(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isprint "gboolean g_unichar_isprint(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isprint", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isprint(s7_integer(c))));
}

static s7_pointer lg_g_unichar_ispunct(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_ispunct "gboolean g_unichar_ispunct(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_ispunct", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_ispunct(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isspace(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isspace "gboolean g_unichar_isspace(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isspace", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isspace(s7_integer(c))));
}

static s7_pointer lg_g_unichar_istitle(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_istitle "gboolean g_unichar_istitle(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_istitle", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_istitle(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isupper(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isupper "gboolean g_unichar_isupper(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isupper", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isupper(s7_integer(c))));
}

static s7_pointer lg_g_unichar_isxdigit(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isxdigit "gboolean g_unichar_isxdigit(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isxdigit", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isxdigit(s7_integer(c))));
}

static s7_pointer lg_g_unichar_iswide(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iswide "gboolean g_unichar_iswide(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iswide", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iswide(s7_integer(c))));
}

static s7_pointer lg_g_unichar_iswide_cjk(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iswide_cjk "gboolean g_unichar_iswide_cjk(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iswide_cjk", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iswide_cjk(s7_integer(c))));
}

static s7_pointer lg_g_unichar_iszerowidth(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iszerowidth "gboolean g_unichar_iszerowidth(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iszerowidth", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iszerowidth(s7_integer(c))));
}

static s7_pointer lg_g_unichar_toupper(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_toupper "gunichar g_unichar_toupper(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_toupper", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_toupper(s7_integer(c))));
}

static s7_pointer lg_g_unichar_tolower(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_tolower "gunichar g_unichar_tolower(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_tolower", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_tolower(s7_integer(c))));
}

static s7_pointer lg_g_unichar_totitle(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_totitle "gunichar g_unichar_totitle(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_totitle", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_totitle(s7_integer(c))));
}

static s7_pointer lg_g_unichar_digit_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_digit_value "gint g_unichar_digit_value(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_digit_value", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_digit_value(s7_integer(c))));
}

static s7_pointer lg_g_unichar_xdigit_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_xdigit_value "gint g_unichar_xdigit_value(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_xdigit_value", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_xdigit_value(s7_integer(c))));
}

static s7_pointer lg_g_unichar_combining_class(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_combining_class "gint g_unichar_combining_class(gunichar uc)"
  s7_pointer uc;
  uc = s7_car(args);
  if (!s7_is_integer(uc)) s7_wrong_type_arg_error(sc, "g_unichar_combining_class", 1, uc, "gunichar");
  return(s7_make_integer(sc, g_unichar_combining_class(s7_integer(uc))));
}

static s7_pointer lg_g_unicode_canonical_ordering(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unicode_canonical_ordering "void g_unicode_canonical_ordering(gunichar* string, gsize len)"
  s7_pointer _p;
  s7_pointer string, len;
  _p = args;
  string = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(string, gunichar__sym)) s7_wrong_type_arg_error(sc, "g_unicode_canonical_ordering", 1, string, "gunichar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_unicode_canonical_ordering", 2, len, "gsize");
  g_unicode_canonical_ordering(s7_c_pointer(string), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_g_utf8_get_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_get_char "gunichar g_utf8_get_char(gchar* p)"
  s7_pointer p;
  p = s7_car(args);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_get_char", 1, p, "gchar*");
  return(s7_make_integer(sc, g_utf8_get_char((const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_get_char_validated(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_get_char_validated "gunichar g_utf8_get_char_validated(gchar* p, gssize max_len)"
  s7_pointer _p;
  s7_pointer p, max_len;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_get_char_validated", 1, p, "gchar*");
  max_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_len)) s7_wrong_type_arg_error(sc, "g_utf8_get_char_validated", 2, max_len, "gssize");
  return(s7_make_integer(sc, g_utf8_get_char_validated((const gchar*)s7_string(p), s7_integer(max_len))));
}

static s7_pointer lg_g_utf8_prev_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_prev_char "gchar* g_utf8_prev_char(gchar* p)"
  s7_pointer p;
  p = s7_car(args);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_prev_char", 1, p, "gchar*");
  return(s7_make_string(sc, g_utf8_prev_char((const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_find_next_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_find_next_char "gchar* g_utf8_find_next_char(gchar* p, gchar* end)"
  s7_pointer _p;
  s7_pointer p, end;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_find_next_char", 1, p, "gchar*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(end)) s7_wrong_type_arg_error(sc, "g_utf8_find_next_char", 2, end, "gchar*");
  return(s7_make_string(sc, g_utf8_find_next_char((const gchar*)s7_string(p), (const gchar*)s7_string(end))));
}

static s7_pointer lg_g_utf8_find_prev_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_find_prev_char "gchar* g_utf8_find_prev_char(gchar* str, gchar* p)"
  s7_pointer _p;
  s7_pointer str, p;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_find_prev_char", 1, str, "gchar*");
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_find_prev_char", 2, p, "gchar*");
  return(s7_make_string(sc, g_utf8_find_prev_char((const gchar*)s7_string(str), (const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_strlen(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strlen "glong g_utf8_strlen(gchar* p, gssize max)"
  s7_pointer _p;
  s7_pointer p, max;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strlen", 1, p, "gchar*");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max)) s7_wrong_type_arg_error(sc, "g_utf8_strlen", 2, max, "gssize");
  return(s7_make_integer(sc, g_utf8_strlen((const gchar*)s7_string(p), s7_integer(max))));
}

static s7_pointer lg_g_utf8_strchr(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strchr "gchar* g_utf8_strchr(gchar* p, gssize len, gunichar c)"
  s7_pointer _p;
  s7_pointer p, len, c;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 1, p, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 2, len, "gssize");
  c = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 3, c, "gunichar");
  return(s7_make_string(sc, g_utf8_strchr((const gchar*)s7_string(p), s7_integer(len), s7_integer(c))));
}

static s7_pointer lg_g_utf8_strrchr(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strrchr "gchar* g_utf8_strrchr(gchar* p, gssize len, gunichar c)"
  s7_pointer _p;
  s7_pointer p, len, c;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 1, p, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 2, len, "gssize");
  c = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 3, c, "gunichar");
  return(s7_make_string(sc, g_utf8_strrchr((const gchar*)s7_string(p), s7_integer(len), s7_integer(c))));
}

static s7_pointer lg_g_utf8_strreverse(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strreverse "gchar* g_utf8_strreverse(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strreverse", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strreverse", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strreverse((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_utf8_validate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_validate "gboolean g_utf8_validate(gchar* str, gssize max_len, gchar** [end])"
  s7_pointer _p;
  s7_pointer str, max_len;
  gchar* ref_end = NULL;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_validate", 1, str, "gchar*");
  max_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_len)) s7_wrong_type_arg_error(sc, "g_utf8_validate", 2, max_len, "gssize");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, g_utf8_validate((const gchar*)s7_string(str), s7_integer(max_len), (const gchar**)&ref_end));
      return(s7_list(sc, 2, result, s7_make_string(sc, ref_end)));
   }
}

static s7_pointer lg_g_utf8_strup(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strup "gchar* g_utf8_strup(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strup", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strup", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strup((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_utf8_strdown(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strdown "gchar* g_utf8_strdown(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strdown", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strdown", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strdown((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_utf8_casefold(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_casefold "gchar* g_utf8_casefold(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_casefold", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_casefold", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_casefold((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_utf8_normalize(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_normalize "gchar* g_utf8_normalize(gchar* str, gssize len, GNormalizeMode mode)"
  s7_pointer _p;
  s7_pointer str, len, mode;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 2, len, "gssize");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 3, mode, "GNormalizeMode");
  return(s7_make_string(sc, g_utf8_normalize((const gchar*)s7_string(str), s7_integer(len), s7_integer(mode))));
}

static s7_pointer lg_g_utf8_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate "gint g_utf8_collate(gchar* str1, gchar* str2)"
  s7_pointer _p;
  s7_pointer str1, str2;
  _p = args;
  str1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str1)) s7_wrong_type_arg_error(sc, "g_utf8_collate", 1, str1, "gchar*");
  str2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str2)) s7_wrong_type_arg_error(sc, "g_utf8_collate", 2, str2, "gchar*");
  return(s7_make_integer(sc, g_utf8_collate((const gchar*)s7_string(str1), (const gchar*)s7_string(str2))));
}

static s7_pointer lg_g_utf8_collate_key(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate_key "gchar* g_utf8_collate_key(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_collate_key((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_utf8_collate_key_for_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate_key_for_filename "gchar* g_utf8_collate_key_for_filename(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key_for_filename", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key_for_filename", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_collate_key_for_filename((const gchar*)s7_string(str), s7_integer(len))));
}

static s7_pointer lg_g_cclosure_new(s7_scheme *sc, s7_pointer args)
{
  #define H_g_cclosure_new "GClosure* g_cclosure_new(GCallback func, lambda_data func_info, GClosureNotify destroy_data)"
  s7_pointer _p;
  s7_pointer func, func_info, destroy_data;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GCallback_sym)) s7_wrong_type_arg_error(sc, "g_cclosure_new", 1, func, "GCallback");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "g_cclosure_new", 2, func_info, "lambda_data");
  destroy_data = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(destroy_data, GClosureNotify_sym)) && (destroy_data != lg_false)) s7_wrong_type_arg_error(sc, "g_cclosure_new", 3, destroy_data, "GClosureNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_c_pointer(sc, g_cclosure_new(s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy_data)));
    return(result);
   }
}

static s7_pointer lg_g_signal_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_newv "guint g_signal_newv(gchar* signal_name, GType itype, GSignalFlags signal_flags, \
GClosure* class_closure, GSignalAccumulator accumulator, gpointer accu_data, GSignalCMarshaller c_marshaller, \
GType return_type, guint n_params, GType* param_types)"
  s7_pointer _p;
  s7_pointer signal_name, itype, signal_flags, class_closure, accumulator, accu_data, c_marshaller, return_type, n_params, param_types;
  _p = args;
  signal_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(signal_name)) s7_wrong_type_arg_error(sc, "g_signal_newv", 1, signal_name, "gchar*");
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_newv", 2, itype, "GType");
  signal_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_flags)) s7_wrong_type_arg_error(sc, "g_signal_newv", 3, signal_flags, "GSignalFlags");
  class_closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(class_closure, GClosure__sym)) && (class_closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_newv", 4, class_closure, "GClosure*");
  accumulator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accumulator, GSignalAccumulator_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 5, accumulator, "GSignalAccumulator");
  accu_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accu_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 6, accu_data, "gpointer");
  c_marshaller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(c_marshaller, GSignalCMarshaller_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 7, c_marshaller, "GSignalCMarshaller");
  return_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(return_type)) s7_wrong_type_arg_error(sc, "g_signal_newv", 8, return_type, "GType");
  n_params = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_params)) s7_wrong_type_arg_error(sc, "g_signal_newv", 9, n_params, "guint");
  param_types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(param_types, GType__sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 10, param_types, "GType*");
  return(s7_make_integer(sc, g_signal_newv(s7_string(signal_name), s7_integer(itype), s7_integer(signal_flags), s7_c_pointer(class_closure), s7_c_pointer(accumulator), s7_c_pointer(accu_data), s7_c_pointer(c_marshaller), s7_integer(return_type), s7_integer(n_params), s7_c_pointer(param_types))));
}

static s7_pointer lg_g_signal_lookup(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_lookup "guint g_signal_lookup(gchar* name, GType itype)"
  s7_pointer _p;
  s7_pointer name, itype;
  _p = args;
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_signal_lookup", 1, name, "gchar*");
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_lookup", 2, itype, "GType");
  return(s7_make_integer(sc, g_signal_lookup(s7_string(name), s7_integer(itype))));
}

static s7_pointer lg_g_signal_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_name "gchar* g_signal_name(guint signal_id)"
  s7_pointer signal_id;
  signal_id = s7_car(args);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_name", 1, signal_id, "guint");
  return(s7_make_string(sc, g_signal_name(s7_integer(signal_id))));
}

static s7_pointer lg_g_signal_query(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_query "void g_signal_query(guint signal_id, GSignalQuery* query)"
  s7_pointer _p;
  s7_pointer signal_id, query;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_query", 1, signal_id, "guint");
  query = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(query, GSignalQuery__sym)) s7_wrong_type_arg_error(sc, "g_signal_query", 2, query, "GSignalQuery*");
  g_signal_query(s7_integer(signal_id), s7_c_pointer(query));
  return(lg_false);
}

static s7_pointer lg_g_signal_list_ids(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_list_ids "guint* g_signal_list_ids(GType itype, guint* n_ids)"
  s7_pointer _p;
  s7_pointer itype, n_ids;
  _p = args;
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_list_ids", 1, itype, "GType");
  n_ids = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(n_ids, guint__sym)) s7_wrong_type_arg_error(sc, "g_signal_list_ids", 2, n_ids, "guint*");
  return(s7_make_type_with_c_pointer(sc, guint__sym, g_signal_list_ids(s7_integer(itype), s7_c_pointer(n_ids))));
}

static s7_pointer lg_g_signal_parse_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_parse_name "gboolean g_signal_parse_name(gchar* detailed_signal, GType itype, guint* [signal_id_p], \
GQuark* [detail_p], gboolean force_detail_quark)"
  s7_pointer _p;
  s7_pointer detailed_signal, itype, force_detail_quark;
  guint ref_signal_id_p;
  GQuark ref_detail_p;
  _p = args;
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 1, detailed_signal, "gchar*");
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 2, itype, "GType");
  force_detail_quark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(force_detail_quark)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 5, force_detail_quark, "gboolean");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, g_signal_parse_name(s7_string(detailed_signal), s7_integer(itype), &ref_signal_id_p, &ref_detail_p, lg_boolean(force_detail_quark)));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_signal_id_p), s7_make_integer(sc, ref_detail_p)));
   }
}

static s7_pointer lg_g_signal_get_invocation_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_get_invocation_hint "GSignalInvocationHint* g_signal_get_invocation_hint(gpointer instance)"
  s7_pointer instance;
  instance = s7_car(args);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_get_invocation_hint", 1, instance, "gpointer");
  return(s7_make_type_with_c_pointer(sc, GSignalInvocationHint__sym, g_signal_get_invocation_hint(s7_c_pointer(instance))));
}

static s7_pointer lg_g_signal_stop_emission(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_stop_emission "void g_signal_stop_emission(gpointer instance, guint signal_id, GQuark detail)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 2, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 3, detail, "GQuark");
  g_signal_stop_emission(s7_c_pointer(instance), s7_integer(signal_id), s7_integer(detail));
  return(lg_false);
}

static s7_pointer lg_g_signal_stop_emission_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_stop_emission_by_name "void g_signal_stop_emission_by_name(gpointer instance, gchar* detailed_signal)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission_by_name", 1, instance, "gpointer");
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission_by_name", 2, detailed_signal, "gchar*");
  g_signal_stop_emission_by_name(s7_c_pointer(instance), s7_string(detailed_signal));
  return(lg_false);
}

static s7_pointer lg_g_signal_add_emission_hook(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_add_emission_hook "gulong g_signal_add_emission_hook(guint signal_id, GQuark quark, \
GSignalEmissionHook hook_func, lambda_data func_info, GtkDestroyNotify data_destroy)"
  s7_pointer _p;
  s7_pointer signal_id, quark, hook_func, func_info, data_destroy;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 1, signal_id, "guint");
  quark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(quark)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 2, quark, "GQuark");
  hook_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(hook_func, GSignalEmissionHook_sym)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 3, hook_func, "GSignalEmissionHook");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 4, func_info, "lambda_data");
  data_destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data_destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 5, data_destroy, "GtkDestroyNotify");
  {
    s7_pointer result;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, data_destroy);
    result = s7_make_integer(sc, g_signal_add_emission_hook(s7_integer(signal_id), s7_integer(quark), s7_c_pointer(hook_func), (gpointer)lg_ptr, s7_c_pointer(data_destroy)));
    return(result);
   }
}

static s7_pointer lg_g_signal_remove_emission_hook(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_remove_emission_hook "void g_signal_remove_emission_hook(guint signal_id, gulong hook_id)"
  s7_pointer _p;
  s7_pointer signal_id, hook_id;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_remove_emission_hook", 1, signal_id, "guint");
  hook_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hook_id)) s7_wrong_type_arg_error(sc, "g_signal_remove_emission_hook", 2, hook_id, "gulong");
  g_signal_remove_emission_hook(s7_integer(signal_id), s7_integer(hook_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_has_handler_pending(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_has_handler_pending "gboolean g_signal_has_handler_pending(gpointer instance, guint signal_id, \
GQuark detail, gboolean may_be_blocked)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail, may_be_blocked;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 2, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 3, detail, "GQuark");
  may_be_blocked = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(may_be_blocked)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 4, may_be_blocked, "gboolean");
  return(s7_make_boolean(sc, g_signal_has_handler_pending(s7_c_pointer(instance), s7_integer(signal_id), s7_integer(detail), lg_boolean(may_be_blocked))));
}

static s7_pointer lg_g_signal_connect_closure_by_id(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_closure_by_id "gulong g_signal_connect_closure_by_id(gpointer instance, \
guint signal_id, GQuark detail, GClosure* closure, gboolean after)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail, closure, after;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 2, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 3, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(closure, GClosure__sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 4, closure, "GClosure*");
  after = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(after)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 5, after, "gboolean");
  return(s7_make_integer(sc, g_signal_connect_closure_by_id(s7_c_pointer(instance), s7_integer(signal_id), s7_integer(detail), s7_c_pointer(closure), lg_boolean(after))));
}

static s7_pointer lg_g_signal_connect_closure(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_closure "gulong g_signal_connect_closure(gpointer instance, gchar* detailed_signal, \
GClosure* closure, gboolean after)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal, closure, after;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 1, instance, "gpointer");
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 2, detailed_signal, "gchar*");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(closure, GClosure__sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 3, closure, "GClosure*");
  after = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(after)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 4, after, "gboolean");
  return(s7_make_integer(sc, g_signal_connect_closure(s7_c_pointer(instance), s7_string(detailed_signal), s7_c_pointer(closure), lg_boolean(after))));
}

static s7_pointer lg_g_signal_connect_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_data "gulong g_signal_connect_data(gpointer instance, gchar* detailed_signal, \
GCallback func, lambda_data func_info, GClosureNotify destroy_data, GConnectFlags connect_flags)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal, func, func_info, destroy_data, connect_flags;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 1, instance, "gpointer");
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 2, detailed_signal, "gchar*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GCallback_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 3, func, "GCallback");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 4, func_info, "lambda_data");
  destroy_data = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(destroy_data, GClosureNotify_sym)) && (destroy_data != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 5, destroy_data, "GClosureNotify");
  connect_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(connect_flags)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 6, connect_flags, "GConnectFlags");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, g_signal_connect_data(s7_c_pointer(instance), s7_string(detailed_signal), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy_data), s7_integer(connect_flags)));
    return(result);
   }
}

static s7_pointer lg_g_signal_handler_block(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_block "void g_signal_handler_block(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_block", 1, instance, "gpointer");
  handler_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_block", 2, handler_id, "gulong");
  g_signal_handler_block(s7_c_pointer(instance), s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_unblock(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_unblock "void g_signal_handler_unblock(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_unblock", 1, instance, "gpointer");
  handler_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_unblock", 2, handler_id, "gulong");
  g_signal_handler_unblock(s7_c_pointer(instance), s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_disconnect(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_disconnect "void g_signal_handler_disconnect(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_disconnect", 1, instance, "gpointer");
  handler_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_disconnect", 2, handler_id, "gulong");
  g_signal_handler_disconnect(s7_c_pointer(instance), s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_is_connected(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_is_connected "gboolean g_signal_handler_is_connected(gpointer instance, \
gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_is_connected", 1, instance, "gpointer");
  handler_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_is_connected", 2, handler_id, "gulong");
  return(s7_make_boolean(sc, g_signal_handler_is_connected(s7_c_pointer(instance), s7_integer(handler_id))));
}

static s7_pointer lg_g_signal_handler_find(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_find "gulong g_signal_handler_find(gpointer instance, GSignalMatchType mask, \
guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 6, func, "gpointer");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handler_find(s7_c_pointer(instance), s7_integer(mask), s7_integer(signal_id), s7_integer(detail), s7_c_pointer(closure), s7_c_pointer(func), s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_block_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_block_matched "guint g_signal_handlers_block_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 6, func, "gpointer");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_block_matched(s7_c_pointer(instance), s7_integer(mask), s7_integer(signal_id), s7_integer(detail), s7_c_pointer(closure), s7_c_pointer(func), s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_unblock_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_unblock_matched "guint g_signal_handlers_unblock_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 6, func, "gpointer");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_unblock_matched(s7_c_pointer(instance), s7_integer(mask), s7_integer(signal_id), s7_integer(detail), s7_c_pointer(closure), s7_c_pointer(func), s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_disconnect_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_disconnect_matched "guint g_signal_handlers_disconnect_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 6, func, "gpointer");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_disconnect_matched(s7_c_pointer(instance), s7_integer(mask), s7_integer(signal_id), s7_integer(detail), s7_c_pointer(closure), s7_c_pointer(func), s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_destroy "void g_signal_handlers_destroy(gpointer instance)"
  s7_pointer instance;
  instance = s7_car(args);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_destroy", 1, instance, "gpointer");
  g_signal_handlers_destroy(s7_c_pointer(instance));
  return(lg_false);
}

static s7_pointer lg_g_object_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_ref "gpointer g_object_ref(gpointer object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_ref", 1, object, "gpointer");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, g_object_ref(s7_c_pointer(object))));
}

static s7_pointer lg_g_object_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_unref "void g_object_unref(gpointer object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_unref", 1, object, "gpointer");
  g_object_unref(s7_c_pointer(object));
  return(lg_false);
}

static s7_pointer lg_gdk_cursor_new_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_for_display "GdkCursor* gdk_cursor_new_for_display(GdkDisplay* display, GdkCursorType cursor_type)"
  s7_pointer _p;
  s7_pointer display, cursor_type;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_for_display", 1, display, "GdkDisplay*");
  cursor_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(cursor_type)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_for_display", 2, cursor_type, "GdkCursorType");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_cursor_new_for_display(s7_c_pointer(display), s7_integer(cursor_type))));
}

static s7_pointer lg_gdk_cursor_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_display "GdkDisplay* gdk_cursor_get_display(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_display", 1, cursor, "GdkCursor*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_cursor_get_display(s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_drag_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_status "void gdk_drag_status(GdkDragContext* context, GdkDragAction action, guint32 time)"
  s7_pointer _p;
  s7_pointer context, action, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_status", 1, context, "GdkDragContext*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gdk_drag_status", 2, action, "GdkDragAction");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_drag_status", 3, time, "guint32");
  gdk_drag_status(s7_c_pointer(context), s7_integer(action), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_drop_reply(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_reply "void gdk_drop_reply(GdkDragContext* context, gboolean ok, guint32 time)"
  s7_pointer _p;
  s7_pointer context, ok, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_reply", 1, context, "GdkDragContext*");
  ok = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(ok)) s7_wrong_type_arg_error(sc, "gdk_drop_reply", 2, ok, "gboolean");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_drop_reply", 3, time, "guint32");
  gdk_drop_reply(s7_c_pointer(context), lg_boolean(ok), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_drop_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_finish "void gdk_drop_finish(GdkDragContext* context, gboolean success, guint32 time)"
  s7_pointer _p;
  s7_pointer context, success, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_finish", 1, context, "GdkDragContext*");
  success = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(success)) s7_wrong_type_arg_error(sc, "gdk_drop_finish", 2, success, "gboolean");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_drop_finish", 3, time, "guint32");
  gdk_drop_finish(s7_c_pointer(context), lg_boolean(success), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_get_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_selection "GdkAtom gdk_drag_get_selection(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_selection", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gdk_drag_get_selection(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_drag_begin(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_begin "GdkDragContext* gdk_drag_begin(GdkWindow* window, GList* targets)"
  s7_pointer _p;
  s7_pointer window, targets;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 1, window, "GdkWindow*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GList__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 2, targets, "GList*");
  return(s7_make_type_with_c_pointer(sc, GdkDragContext__sym, gdk_drag_begin(s7_c_pointer(window), s7_c_pointer(targets))));
}

static s7_pointer lg_gdk_drag_drop(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_drop "void gdk_drag_drop(GdkDragContext* context, guint32 time)"
  s7_pointer _p;
  s7_pointer context, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_drop", 1, context, "GdkDragContext*");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_drag_drop", 2, time, "guint32");
  gdk_drag_drop(s7_c_pointer(context), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_abort(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_abort "void gdk_drag_abort(GdkDragContext* context, guint32 time)"
  s7_pointer _p;
  s7_pointer context, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_abort", 1, context, "GdkDragContext*");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_drag_abort", 2, time, "guint32");
  gdk_drag_abort(s7_c_pointer(context), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_events_pending(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_pending "gboolean gdk_events_pending( void)"
  return(s7_make_boolean(sc, gdk_events_pending()));
}

static s7_pointer lg_gdk_event_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get "GdkEvent* gdk_event_get( void)"
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gdk_event_get()));
}

static s7_pointer lg_gdk_event_peek(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_peek "GdkEvent* gdk_event_peek( void)"
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gdk_event_peek()));
}

static s7_pointer lg_gdk_event_put(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_put "void gdk_event_put(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_put", 1, event, "GdkEvent*");
  gdk_event_put(s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_event_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_copy "GdkEvent* gdk_event_copy(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_copy", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gdk_event_copy(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_free "void gdk_event_free(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_free", 1, event, "GdkEvent*");
  gdk_event_free(s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_time "guint32 gdk_event_get_time(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gdk_event_get_time", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_event_get_time(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_state "gboolean gdk_event_get_state(GdkEvent* event, GdkModifierType* [state])"
  s7_pointer _p;
  s7_pointer event;
  GdkModifierType ref_state;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_state", 1, event, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_event_get_state(s7_c_pointer(event), &ref_state));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_state)));
   }
}

static s7_pointer lg_gdk_event_get_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_coords "gboolean gdk_event_get_coords(GdkEvent* event, gdouble* [x_win], gdouble* [y_win])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_x_win;
  gdouble ref_y_win;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_coords", 1, event, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_event_get_coords(s7_c_pointer(event), &ref_x_win, &ref_y_win));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x_win), s7_make_real(sc, ref_y_win)));
   }
}

static s7_pointer lg_gdk_event_get_root_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_root_coords "gboolean gdk_event_get_root_coords(GdkEvent* event, gdouble* [x_root], \
gdouble* [y_root])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_x_root;
  gdouble ref_y_root;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_root_coords", 1, event, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_event_get_root_coords(s7_c_pointer(event), &ref_x_root, &ref_y_root));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x_root), s7_make_real(sc, ref_y_root)));
   }
}

static s7_pointer lg_gdk_event_handler_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_handler_set "void gdk_event_handler_set(GdkEventFunc func, lambda_data func_info, \
GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer func, func_info, notify;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GdkEventFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_event_handler_set", 1, func, "GdkEventFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gdk_event_handler_set", 2, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_event_handler_set", 3, notify, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, notify);
    gdk_event_handler_set(s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify));
    return(lg_false);
   }
}

static s7_pointer lg_gdk_set_show_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_set_show_events "void gdk_set_show_events(gboolean show_events)"
  s7_pointer show_events;
  show_events = s7_car(args);
  if (!s7_is_boolean(show_events)) s7_wrong_type_arg_error(sc, "gdk_set_show_events", 1, show_events, "gboolean");
  gdk_set_show_events(lg_boolean(show_events));
  return(lg_false);
}

static s7_pointer lg_gdk_get_show_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_get_show_events "gboolean gdk_get_show_events( void)"
  return(s7_make_boolean(sc, gdk_get_show_events()));
}

static s7_pointer lg_gdk_init(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_init "void gdk_init(gint* {argc}, gchar*** |argv|)"
  s7_pointer argc, argv;
  argc = s7_car(args);
  argv = s7_cadr(args);
  gint ref_argc;
  gchar** ref_argv = NULL;
  ref_argc = (gint)s7_integer(argc);
  ref_argv = (gchar**)calloc(ref_argc, sizeof(gchar*));
  {
    int i;
    s7_pointer lst;
    lst = argv;
    for (i = 0; i < ref_argc; i++, lst = s7_cdr(lst)) ref_argv[i] = (gchar*)s7_string(s7_car(lst));
  }
  gdk_init(&ref_argc, &ref_argv);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_argc), s7_make_c_pointer(sc, ref_argv)));
}

static s7_pointer lg_gdk_init_check(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_init_check "gboolean gdk_init_check(gint* {argc}, gchar*** |argv|)"
  s7_pointer argc, argv;
  argc = s7_car(args);
  argv = s7_cadr(args);
  gint ref_argc;
  gchar** ref_argv = NULL;
  ref_argc = (gint)s7_integer(argc);
  ref_argv = (gchar**)calloc(ref_argc, sizeof(gchar*));
  {
    int i;
    s7_pointer lst;
    lst = argv;
    for (i = 0; i < ref_argc; i++, lst = s7_cdr(lst)) ref_argv[i] = (gchar*)s7_string(s7_car(lst));
  }
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_init_check(&ref_argc, &ref_argv));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_argc), s7_make_c_pointer(sc, ref_argv)));
   }
}

static s7_pointer lg_gdk_get_program_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_get_program_class "char* gdk_get_program_class( void)"
  return(s7_make_string(sc, gdk_get_program_class()));
}

static s7_pointer lg_gdk_set_program_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_set_program_class "void gdk_set_program_class(char* program_class)"
  s7_pointer program_class;
  program_class = s7_car(args);
  if (!s7_is_string(program_class)) s7_wrong_type_arg_error(sc, "gdk_set_program_class", 1, program_class, "char*");
  gdk_set_program_class((char*)s7_string(program_class));
  return(lg_false);
}

static s7_pointer lg_gdk_error_trap_push(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_error_trap_push "void gdk_error_trap_push( void)"
  gdk_error_trap_push();
  return(lg_false);
}

static s7_pointer lg_gdk_error_trap_pop(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_error_trap_pop "gint gdk_error_trap_pop( void)"
  return(s7_make_integer(sc, gdk_error_trap_pop()));
}

static s7_pointer lg_gdk_get_display_arg_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_get_display_arg_name "gchar* gdk_get_display_arg_name( void)"
  return(s7_make_string(sc, gdk_get_display_arg_name()));
}

static s7_pointer lg_gdk_notify_startup_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_notify_startup_complete "void gdk_notify_startup_complete( void)"
  gdk_notify_startup_complete();
  return(lg_false);
}

static s7_pointer lg_gdk_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_flush "void gdk_flush( void)"
  gdk_flush();
  return(lg_false);
}

static s7_pointer lg_gdk_beep(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_beep "void gdk_beep( void)"
  gdk_beep();
  return(lg_false);
}

static s7_pointer lg_gdk_set_double_click_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_set_double_click_time "void gdk_set_double_click_time(guint msec)"
  s7_pointer msec;
  msec = s7_car(args);
  if (!s7_is_integer(msec)) s7_wrong_type_arg_error(sc, "gdk_set_double_click_time", 1, msec, "guint");
  gdk_set_double_click_time(s7_integer(msec));
  return(lg_false);
}

static s7_pointer lg_gdk_rectangle_intersect(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_intersect "gboolean gdk_rectangle_intersect(GdkRectangle* src1, GdkRectangle* src2, \
GdkRectangle* dest)"
  s7_pointer _p;
  s7_pointer src1, src2, dest;
  _p = args;
  src1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 1, src1, "GdkRectangle*");
  src2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 2, src2, "GdkRectangle*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 3, dest, "GdkRectangle*");
  return(s7_make_boolean(sc, gdk_rectangle_intersect(s7_c_pointer(src1), s7_c_pointer(src2), s7_c_pointer(dest))));
}

static s7_pointer lg_gdk_rectangle_union(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_union "void gdk_rectangle_union(GdkRectangle* src1, GdkRectangle* src2, GdkRectangle* dest)"
  s7_pointer _p;
  s7_pointer src1, src2, dest;
  _p = args;
  src1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 1, src1, "GdkRectangle*");
  src2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 2, src2, "GdkRectangle*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 3, dest, "GdkRectangle*");
  gdk_rectangle_union(s7_c_pointer(src1), s7_c_pointer(src2), s7_c_pointer(dest));
  return(lg_false);
}

static s7_pointer lg_gdk_keymap_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_default "GdkKeymap* gdk_keymap_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GdkKeymap__sym, gdk_keymap_get_default()));
}

static s7_pointer lg_gdk_keymap_lookup_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_lookup_key "guint gdk_keymap_lookup_key(GdkKeymap* keymap, GdkKeymapKey* key)"
  s7_pointer _p;
  s7_pointer keymap, key;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_lookup_key", 1, keymap, "GdkKeymap*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, GdkKeymapKey__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_lookup_key", 2, key, "GdkKeymapKey*");
  return(s7_make_integer(sc, gdk_keymap_lookup_key(s7_c_pointer(keymap), s7_c_pointer(key))));
}

static s7_pointer lg_gdk_keymap_get_entries_for_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_entries_for_keyval "gboolean gdk_keymap_get_entries_for_keyval(GdkKeymap* keymap, \
guint keyval, GdkKeymapKey** [keys], gint* [n_keys])"
  s7_pointer _p;
  s7_pointer keymap, keyval;
  GdkKeymapKey* ref_keys = NULL;
  gint ref_n_keys;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_entries_for_keyval", 1, keymap, "GdkKeymap*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_entries_for_keyval", 2, keyval, "guint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_keymap_get_entries_for_keyval(s7_c_pointer(keymap), s7_integer(keyval), &ref_keys, &ref_n_keys));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_keys), s7_make_integer(sc, ref_n_keys)));
   }
}

static s7_pointer lg_gdk_keymap_get_entries_for_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_entries_for_keycode "gboolean gdk_keymap_get_entries_for_keycode(GdkKeymap* keymap, \
guint hardware_keycode, GdkKeymapKey** [keys], guint** [keyvals], gint* [n_entries])"
  s7_pointer _p;
  s7_pointer keymap, hardware_keycode;
  GdkKeymapKey* ref_keys = NULL;
  guint* ref_keyvals = NULL;
  gint ref_n_entries;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_entries_for_keycode", 1, keymap, "GdkKeymap*");
  hardware_keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hardware_keycode)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_entries_for_keycode", 2, hardware_keycode, "guint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_keymap_get_entries_for_keycode(s7_c_pointer(keymap), s7_integer(hardware_keycode), &ref_keys, &ref_keyvals, &ref_n_entries));
      return(s7_list(sc, 4, result, s7_make_c_pointer(sc, ref_keys), s7_make_c_pointer(sc, ref_keyvals), s7_make_integer(sc, ref_n_entries)));
   }
}

static s7_pointer lg_gdk_keymap_get_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_direction "PangoDirection gdk_keymap_get_direction(GdkKeymap* keymap)"
  s7_pointer keymap;
  keymap = s7_car(args);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_direction", 1, keymap, "GdkKeymap*");
  return(s7_make_integer(sc, gdk_keymap_get_direction(s7_c_pointer(keymap))));
}

static s7_pointer lg_gdk_keyval_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_name "gchar* gdk_keyval_name(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_name", 1, keyval, "guint");
  return(s7_make_string(sc, gdk_keyval_name(s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_from_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_from_name "guint gdk_keyval_from_name(gchar* keyval_name)"
  s7_pointer keyval_name;
  keyval_name = s7_car(args);
  if (!s7_is_string(keyval_name)) s7_wrong_type_arg_error(sc, "gdk_keyval_from_name", 1, keyval_name, "gchar*");
  return(s7_make_integer(sc, gdk_keyval_from_name(s7_string(keyval_name))));
}

static s7_pointer lg_gdk_keyval_convert_case(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_convert_case "void gdk_keyval_convert_case(guint symbol, guint* [lower], guint* [upper])"
  s7_pointer _p;
  s7_pointer symbol;
  guint ref_lower;
  guint ref_upper;
  _p = args;
  symbol = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(symbol)) s7_wrong_type_arg_error(sc, "gdk_keyval_convert_case", 1, symbol, "guint");
  gdk_keyval_convert_case(s7_integer(symbol), &ref_lower, &ref_upper);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_lower), s7_make_integer(sc, ref_upper)));
}

static s7_pointer lg_gdk_keyval_to_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_upper "guint gdk_keyval_to_upper(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_upper", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_upper(s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_to_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_lower "guint gdk_keyval_to_lower(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_lower", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_lower(s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_is_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_is_upper "gboolean gdk_keyval_is_upper(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_is_upper", 1, keyval, "guint");
  return(s7_make_boolean(sc, gdk_keyval_is_upper(s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_is_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_is_lower "gboolean gdk_keyval_is_lower(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_is_lower", 1, keyval, "guint");
  return(s7_make_boolean(sc, gdk_keyval_is_lower(s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_to_unicode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_unicode "guint32 gdk_keyval_to_unicode(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_unicode", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_unicode(s7_integer(keyval))));
}

static s7_pointer lg_gdk_unicode_to_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_unicode_to_keyval "guint gdk_unicode_to_keyval(guint32 wc)"
  s7_pointer wc;
  wc = s7_car(args);
  if (!s7_is_integer(wc)) s7_wrong_type_arg_error(sc, "gdk_unicode_to_keyval", 1, wc, "guint32");
  return(s7_make_integer(sc, gdk_unicode_to_keyval(s7_integer(wc))));
}

static s7_pointer lg_gdk_pango_context_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_context_get "PangoContext* gdk_pango_context_get( void)"
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, gdk_pango_context_get()));
}

static s7_pointer lg_gdk_atom_intern(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_atom_intern "GdkAtom gdk_atom_intern(gchar* atom_name, gboolean only_if_exists)"
  s7_pointer _p;
  s7_pointer atom_name, only_if_exists;
  _p = args;
  atom_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(atom_name)) s7_wrong_type_arg_error(sc, "gdk_atom_intern", 1, atom_name, "gchar*");
  only_if_exists = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(only_if_exists)) s7_wrong_type_arg_error(sc, "gdk_atom_intern", 2, only_if_exists, "gboolean");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gdk_atom_intern(s7_string(atom_name), lg_boolean(only_if_exists))));
}

static s7_pointer lg_gdk_atom_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_atom_name "gchar* gdk_atom_name(GdkAtom atom)"
  s7_pointer atom;
  atom = s7_car(args);
  if (!s7_is_c_pointer_of_type(atom, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_atom_name", 1, atom, "GdkAtom");
  {
    gchar* result;
    s7_pointer rtn;
    result = gdk_atom_name(s7_c_pointer(atom));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gdk_property_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_property_get "gboolean gdk_property_get(GdkWindow* window, GdkAtom property, GdkAtom type, \
gulong offset, gulong length, gint pdelete, GdkAtom* [actual_property_type], gint* [actual_format], gint* [actual_length], \
guchar** [data])"
  s7_pointer _p;
  s7_pointer window, property, type, offset, length, pdelete;
  GdkAtom ref_actual_property_type;
  gint ref_actual_format;
  gint ref_actual_length;
  guchar* ref_data = NULL;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_property_get", 1, window, "GdkWindow*");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(property, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_property_get", 2, property, "GdkAtom");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(type, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_property_get", 3, type, "GdkAtom");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset)) s7_wrong_type_arg_error(sc, "gdk_property_get", 4, offset, "gulong");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gdk_property_get", 5, length, "gulong");
  pdelete = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pdelete)) s7_wrong_type_arg_error(sc, "gdk_property_get", 6, pdelete, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_property_get(s7_c_pointer(window), s7_c_pointer(property), s7_c_pointer(type), s7_integer(offset), s7_integer(length), s7_integer(pdelete), &ref_actual_property_type, &ref_actual_format, &ref_actual_length, &ref_data));
    {
      s7_pointer data_val = lg_false;
      if (ref_actual_property_type == GDK_TARGET_STRING)
	data_val = s7_make_string(sc, (char *)ref_data);
      else if (ref_actual_length > 0) data_val = s7_make_string_with_length(sc, (char *)ref_data, ref_actual_length * ref_actual_format / 8);
     return(s7_list(sc, 5, result, s7_make_c_pointer(sc, ref_actual_property_type), s7_make_integer(sc, ref_actual_format), 
                       s7_make_integer(sc, ref_actual_length), data_val));
    }
  }
}

static s7_pointer lg_gdk_property_change(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_property_change "void gdk_property_change(GdkWindow* window, GdkAtom property, GdkAtom type, \
gint format, GdkPropMode mode, guchar* data, gint nelements)"
  s7_pointer _p;
  s7_pointer window, property, type, format, mode, data, nelements;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_property_change", 1, window, "GdkWindow*");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(property, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_property_change", 2, property, "GdkAtom");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(type, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_property_change", 3, type, "GdkAtom");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "gdk_property_change", 4, format, "gint");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gdk_property_change", 5, mode, "GdkPropMode");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "gdk_property_change", 6, data, "guchar*");
  nelements = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(nelements)) s7_wrong_type_arg_error(sc, "gdk_property_change", 7, nelements, "gint");
  gdk_property_change(s7_c_pointer(window), s7_c_pointer(property), s7_c_pointer(type), s7_integer(format), s7_integer(mode), s7_c_pointer(data), s7_integer(nelements));
  return(lg_false);
}

static s7_pointer lg_gdk_property_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_property_delete "void gdk_property_delete(GdkWindow* window, GdkAtom property)"
  s7_pointer _p;
  s7_pointer window, property;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_property_delete", 1, window, "GdkWindow*");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(property, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_property_delete", 2, property, "GdkAtom");
  gdk_property_delete(s7_c_pointer(window), s7_c_pointer(property));
  return(lg_false);
}

static s7_pointer lg_gdk_utf8_to_string_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_utf8_to_string_target "gchar* gdk_utf8_to_string_target(gchar* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gdk_utf8_to_string_target", 1, str, "gchar*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gdk_utf8_to_string_target(s7_string(str));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gdk_selection_owner_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_owner_set "gboolean gdk_selection_owner_set(GdkWindow* owner, GdkAtom selection, \
guint32 time, gboolean send_event)"
  s7_pointer _p;
  s7_pointer owner, selection, time, send_event;
  _p = args;
  owner = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(owner, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_owner_set", 1, owner, "GdkWindow*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_owner_set", 2, selection, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_selection_owner_set", 3, time, "guint32");
  send_event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(send_event)) s7_wrong_type_arg_error(sc, "gdk_selection_owner_set", 4, send_event, "gboolean");
  return(s7_make_boolean(sc, gdk_selection_owner_set(s7_c_pointer(owner), s7_c_pointer(selection), s7_integer(time), lg_boolean(send_event))));
}

static s7_pointer lg_gdk_selection_owner_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_owner_get "GdkWindow* gdk_selection_owner_get(GdkAtom selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_owner_get", 1, selection, "GdkAtom");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_selection_owner_get(s7_c_pointer(selection))));
}

static s7_pointer lg_gdk_selection_convert(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_convert "void gdk_selection_convert(GdkWindow* requestor, GdkAtom selection, \
GdkAtom target, guint32 time)"
  s7_pointer _p;
  s7_pointer requestor, selection, target, time;
  _p = args;
  requestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(requestor, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_convert", 1, requestor, "GdkWindow*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_convert", 2, selection, "GdkAtom");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_convert", 3, target, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gdk_selection_convert", 4, time, "guint32");
  gdk_selection_convert(s7_c_pointer(requestor), s7_c_pointer(selection), s7_c_pointer(target), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gdk_selection_property_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_property_get "gboolean gdk_selection_property_get(GdkWindow* requestor, guchar** [data], \
GdkAtom* [prop_type], gint* [prop_format])"
  s7_pointer _p;
  s7_pointer requestor;
  guchar* ref_data = NULL;
  GdkAtom ref_prop_type;
  gint ref_prop_format;
  _p = args;
  requestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(requestor, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_property_get", 1, requestor, "GdkWindow*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_selection_property_get(s7_c_pointer(requestor), &ref_data, &ref_prop_type, &ref_prop_format));
      return(s7_list(sc, 4, result, s7_make_c_pointer(sc, ref_data), s7_make_c_pointer(sc, ref_prop_type), s7_make_integer(sc, ref_prop_format)));
   }
}

static s7_pointer lg_gdk_window_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_destroy "void gdk_window_destroy(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_destroy", 1, window, "GdkWindow*");
  gdk_window_destroy(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_window_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_window_type "GdkWindowType gdk_window_get_window_type(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_window_type", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_window_type(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_show(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_show "void gdk_window_show(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_show", 1, window, "GdkWindow*");
  gdk_window_show(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_hide(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_hide "void gdk_window_hide(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_hide", 1, window, "GdkWindow*");
  gdk_window_hide(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_withdraw(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_withdraw "void gdk_window_withdraw(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_withdraw", 1, window, "GdkWindow*");
  gdk_window_withdraw(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_show_unraised(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_show_unraised "void gdk_window_show_unraised(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_show_unraised", 1, window, "GdkWindow*");
  gdk_window_show_unraised(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_move(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_move "void gdk_window_move(GdkWindow* window, gint x, gint y)"
  s7_pointer _p;
  s7_pointer window, x, y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_move", 1, window, "GdkWindow*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_window_move", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_window_move", 3, y, "gint");
  gdk_window_move(s7_c_pointer(window), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gdk_window_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_resize "void gdk_window_resize(GdkWindow* window, gint width, gint height)"
  s7_pointer _p;
  s7_pointer window, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_resize", 1, window, "GdkWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_resize", 2, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_resize", 3, height, "gint");
  gdk_window_resize(s7_c_pointer(window), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gdk_window_move_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_move_resize "void gdk_window_move_resize(GdkWindow* window, gint x, gint y, gint width, \
gint height)"
  s7_pointer _p;
  s7_pointer window, x, y, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_move_resize", 1, window, "GdkWindow*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_window_move_resize", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_window_move_resize", 3, y, "gint");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_move_resize", 4, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_move_resize", 5, height, "gint");
  gdk_window_move_resize(s7_c_pointer(window), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gdk_window_raise(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_raise "void gdk_window_raise(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_raise", 1, window, "GdkWindow*");
  gdk_window_raise(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_lower "void gdk_window_lower(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_lower", 1, window, "GdkWindow*");
  gdk_window_lower(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_focus "void gdk_window_focus(GdkWindow* window, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_focus", 1, window, "GdkWindow*");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_window_focus", 2, timestamp, "guint32");
  gdk_window_focus(s7_c_pointer(window), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_user_data "void gdk_window_set_user_data(GdkWindow* window, gpointer user_data)"
  s7_pointer _p;
  s7_pointer window, user_data;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(window, GdkWindow__sym)) && (window != lg_false)) s7_wrong_type_arg_error(sc, "gdk_window_set_user_data", 1, window, "GdkWindow*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_user_data", 2, user_data, "gpointer");
  gdk_window_set_user_data(s7_c_pointer(window), s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_window_add_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_add_filter "void gdk_window_add_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer window, func, func_info;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_add_filter", 1, window, "GdkWindow*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GdkFilterFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_window_add_filter", 2, func, "GdkFilterFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_window_add_filter", 3, func_info, "lambda_data");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gdk_window_add_filter(s7_c_pointer(window), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gdk_window_remove_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_remove_filter "void gdk_window_remove_filter(GdkWindow* window, GdkFilterFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer window, func, func_info;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_remove_filter", 1, window, "GdkWindow*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GdkFilterFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_window_remove_filter", 2, func, "GdkFilterFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_window_remove_filter", 3, func_info, "lambda_data");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gdk_window_remove_filter(s7_c_pointer(window), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gdk_window_scroll(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_scroll "void gdk_window_scroll(GdkWindow* window, gint dx, gint dy)"
  s7_pointer _p;
  s7_pointer window, dx, dy;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_scroll", 1, window, "GdkWindow*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "gdk_window_scroll", 2, dx, "gint");
  dy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "gdk_window_scroll", 3, dy, "gint");
  gdk_window_scroll(s7_c_pointer(window), s7_integer(dx), s7_integer(dy));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_child_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_child_shapes "void gdk_window_set_child_shapes(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_child_shapes", 1, window, "GdkWindow*");
  gdk_window_set_child_shapes(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_merge_child_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_merge_child_shapes "void gdk_window_merge_child_shapes(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_merge_child_shapes", 1, window, "GdkWindow*");
  gdk_window_merge_child_shapes(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_is_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_is_visible "gboolean gdk_window_is_visible(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_is_visible", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_is_visible(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_is_viewable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_is_viewable "gboolean gdk_window_is_viewable(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_is_viewable", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_is_viewable(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_state "GdkWindowState gdk_window_get_state(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_state", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_state(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_root_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_root_origin "void gdk_window_get_root_origin(GdkWindow* window, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_x;
  gint ref_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_root_origin", 1, window, "GdkWindow*");
  gdk_window_get_root_origin(s7_c_pointer(window), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gdk_window_get_frame_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_frame_extents "void gdk_window_get_frame_extents(GdkWindow* window, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer window, rect;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_frame_extents", 1, window, "GdkWindow*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_frame_extents", 2, rect, "GdkRectangle*");
  gdk_window_get_frame_extents(s7_c_pointer(window), s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_parent "GdkWindow* gdk_window_get_parent(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_parent", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_get_parent(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_toplevel "GdkWindow* gdk_window_get_toplevel(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_toplevel", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_get_toplevel(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_children "GList* gdk_window_get_children(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_children", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_window_get_children(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_peek_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_peek_children "GList* gdk_window_peek_children(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_peek_children", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_window_peek_children(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_events "GdkEventMask gdk_window_get_events(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_events", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_events(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_set_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_events "void gdk_window_set_events(GdkWindow* window, GdkEventMask event_mask)"
  s7_pointer _p;
  s7_pointer window, event_mask;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_events", 1, window, "GdkWindow*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_set_events", 2, event_mask, "GdkEventMask");
  gdk_window_set_events(s7_c_pointer(window), s7_integer(event_mask));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_icon_list "void gdk_window_set_icon_list(GdkWindow* window, GList* pixbufs)"
  s7_pointer _p;
  s7_pointer window, pixbufs;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_icon_list", 1, window, "GdkWindow*");
  pixbufs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbufs, GList__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_icon_list", 2, pixbufs, "GList*");
  gdk_window_set_icon_list(s7_c_pointer(window), s7_c_pointer(pixbufs));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_icon_name "void gdk_window_set_icon_name(GdkWindow* window, gchar* name)"
  s7_pointer _p;
  s7_pointer window, name;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_icon_name", 1, window, "GdkWindow*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gdk_window_set_icon_name", 2, name, "gchar*");
  gdk_window_set_icon_name(s7_c_pointer(window), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_group "void gdk_window_set_group(GdkWindow* window, GdkWindow* leader)"
  s7_pointer _p;
  s7_pointer window, leader;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_group", 1, window, "GdkWindow*");
  leader = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(leader, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_group", 2, leader, "GdkWindow*");
  gdk_window_set_group(s7_c_pointer(window), s7_c_pointer(leader));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_decorations(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_decorations "void gdk_window_set_decorations(GdkWindow* window, GdkWMDecoration decorations)"
  s7_pointer _p;
  s7_pointer window, decorations;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_decorations", 1, window, "GdkWindow*");
  decorations = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(decorations)) s7_wrong_type_arg_error(sc, "gdk_window_set_decorations", 2, decorations, "GdkWMDecoration");
  gdk_window_set_decorations(s7_c_pointer(window), s7_integer(decorations));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_decorations(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_decorations "gboolean gdk_window_get_decorations(GdkWindow* window, GdkWMDecoration* [decorations])"
  s7_pointer _p;
  s7_pointer window;
  GdkWMDecoration ref_decorations;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_decorations", 1, window, "GdkWindow*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_window_get_decorations(s7_c_pointer(window), &ref_decorations));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_decorations)));
   }
}

static s7_pointer lg_gdk_window_set_functions(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_functions "void gdk_window_set_functions(GdkWindow* window, GdkWMFunction functions)"
  s7_pointer _p;
  s7_pointer window, functions;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_functions", 1, window, "GdkWindow*");
  functions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(functions)) s7_wrong_type_arg_error(sc, "gdk_window_set_functions", 2, functions, "GdkWMFunction");
  gdk_window_set_functions(s7_c_pointer(window), s7_integer(functions));
  return(lg_false);
}

static s7_pointer lg_gdk_window_iconify(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_iconify "void gdk_window_iconify(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_iconify", 1, window, "GdkWindow*");
  gdk_window_iconify(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_deiconify(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_deiconify "void gdk_window_deiconify(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_deiconify", 1, window, "GdkWindow*");
  gdk_window_deiconify(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_stick(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_stick "void gdk_window_stick(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_stick", 1, window, "GdkWindow*");
  gdk_window_stick(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_unstick(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_unstick "void gdk_window_unstick(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_unstick", 1, window, "GdkWindow*");
  gdk_window_unstick(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_maximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_maximize "void gdk_window_maximize(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_maximize", 1, window, "GdkWindow*");
  gdk_window_maximize(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_unmaximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_unmaximize "void gdk_window_unmaximize(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_unmaximize", 1, window, "GdkWindow*");
  gdk_window_unmaximize(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_register_dnd(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_register_dnd "void gdk_window_register_dnd(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_register_dnd", 1, window, "GdkWindow*");
  gdk_window_register_dnd(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_begin_resize_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_begin_resize_drag "void gdk_window_begin_resize_drag(GdkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, edge, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 1, window, "GdkWindow*");
  edge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(edge)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 2, edge, "GdkWindowEdge");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 3, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 4, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 5, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag", 6, timestamp, "guint32");
  gdk_window_begin_resize_drag(s7_c_pointer(window), s7_integer(edge), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_window_begin_move_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_begin_move_drag "void gdk_window_begin_move_drag(GdkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag", 1, window, "GdkWindow*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag", 2, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag", 3, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag", 4, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag", 5, timestamp, "guint32");
  gdk_window_begin_move_drag(s7_c_pointer(window), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_window_invalidate_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_invalidate_rect "void gdk_window_invalidate_rect(GdkWindow* window, GdkRectangle* rect, \
gboolean invalidate_children)"
  s7_pointer _p;
  s7_pointer window, rect, invalidate_children;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_rect", 1, window, "GdkWindow*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_rect", 2, rect, "GdkRectangle*");
  invalidate_children = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(invalidate_children)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_rect", 3, invalidate_children, "gboolean");
  gdk_window_invalidate_rect(s7_c_pointer(window), s7_c_pointer(rect), lg_boolean(invalidate_children));
  return(lg_false);
}

static s7_pointer lg_gdk_window_freeze_updates(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_freeze_updates "void gdk_window_freeze_updates(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_freeze_updates", 1, window, "GdkWindow*");
  gdk_window_freeze_updates(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_thaw_updates(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_thaw_updates "void gdk_window_thaw_updates(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_thaw_updates", 1, window, "GdkWindow*");
  gdk_window_thaw_updates(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_constrain_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_constrain_size "void gdk_window_constrain_size(GdkGeometry* geometry, GdkWindowHints flags, \
gint width, gint height, gint* [new_width], gint* [new_height])"
  s7_pointer _p;
  s7_pointer geometry, flags, width, height;
  gint ref_new_width;
  gint ref_new_height;
  _p = args;
  geometry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(geometry, GdkGeometry__sym)) s7_wrong_type_arg_error(sc, "gdk_window_constrain_size", 1, geometry, "GdkGeometry*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gdk_window_constrain_size", 2, flags, "GdkWindowHints");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_constrain_size", 3, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_constrain_size", 4, height, "gint");
  gdk_window_constrain_size(s7_c_pointer(geometry), s7_integer(flags), s7_integer(width), s7_integer(height), &ref_new_width, &ref_new_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_new_width), s7_make_integer(sc, ref_new_height)));
}

static s7_pointer lg_gdk_window_set_type_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_type_hint "void gdk_window_set_type_hint(GdkWindow* window, GdkWindowTypeHint hint)"
  s7_pointer _p;
  s7_pointer window, hint;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_type_hint", 1, window, "GdkWindow*");
  hint = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hint)) s7_wrong_type_arg_error(sc, "gdk_window_set_type_hint", 2, hint, "GdkWindowTypeHint");
  gdk_window_set_type_hint(s7_c_pointer(window), s7_integer(hint));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_modal_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_modal_hint "void gdk_window_set_modal_hint(GdkWindow* window, gboolean modal)"
  s7_pointer _p;
  s7_pointer window, modal;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_modal_hint", 1, window, "GdkWindow*");
  modal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gdk_window_set_modal_hint", 2, modal, "gboolean");
  gdk_window_set_modal_hint(s7_c_pointer(window), lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_title "void gdk_window_set_title(GdkWindow* window, gchar* title)"
  s7_pointer _p;
  s7_pointer window, title;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_title", 1, window, "GdkWindow*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gdk_window_set_title", 2, title, "gchar*");
  gdk_window_set_title(s7_c_pointer(window), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_role(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_role "void gdk_window_set_role(GdkWindow* window, gchar* role)"
  s7_pointer _p;
  s7_pointer window, role;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_role", 1, window, "GdkWindow*");
  role = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(role)) s7_wrong_type_arg_error(sc, "gdk_window_set_role", 2, role, "gchar*");
  gdk_window_set_role(s7_c_pointer(window), s7_string(role));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_transient_for "void gdk_window_set_transient_for(GdkWindow* window, GdkWindow* parent)"
  s7_pointer _p;
  s7_pointer window, parent;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_transient_for", 1, window, "GdkWindow*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_transient_for", 2, parent, "GdkWindow*");
  gdk_window_set_transient_for(s7_c_pointer(window), s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_cursor "void gdk_window_set_cursor(GdkWindow* window, GdkCursor* cursor)"
  s7_pointer _p;
  s7_pointer window, cursor;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_cursor", 1, window, "GdkWindow*");
  cursor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_cursor", 2, cursor, "GdkCursor*");
  gdk_window_set_cursor(s7_c_pointer(window), s7_c_pointer(cursor));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_user_data "void gdk_window_get_user_data(GdkWindow* window, gpointer* [data])"
  s7_pointer _p;
  s7_pointer window;
  gpointer ref_data;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_user_data", 1, window, "GdkWindow*");
  gdk_window_get_user_data(s7_c_pointer(window), &ref_data);
    return(s7_list(sc, 1, s7_make_c_pointer(sc, ref_data)));
}

static s7_pointer lg_gdk_window_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_position "void gdk_window_get_position(GdkWindow* window, gint* [x], gint* [y])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_x;
  gint ref_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_position", 1, window, "GdkWindow*");
  gdk_window_get_position(s7_c_pointer(window), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gdk_window_get_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_origin "gint gdk_window_get_origin(GdkWindow* window, gint* [x], gint* [y])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_x;
  gint ref_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_origin", 1, window, "GdkWindow*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, gdk_window_get_origin(s7_c_pointer(window), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
   }
}

static s7_pointer lg_gdk_get_default_root_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_get_default_root_window "GdkWindow* gdk_get_default_root_window( void)"
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_get_default_root_window()));
}

static s7_pointer lg_gdk_pixbuf_error_quark(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_error_quark "GQuark gdk_pixbuf_error_quark( void)"
  return(s7_make_integer(sc, gdk_pixbuf_error_quark()));
}

static s7_pointer lg_gdk_pixbuf_get_colorspace(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_colorspace "GdkColorspace gdk_pixbuf_get_colorspace(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_colorspace", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_colorspace(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_n_channels(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_n_channels "int gdk_pixbuf_get_n_channels(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_n_channels", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_n_channels(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_has_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_has_alpha "gboolean gdk_pixbuf_get_has_alpha(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_has_alpha", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_boolean(sc, gdk_pixbuf_get_has_alpha(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_bits_per_sample(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_bits_per_sample "int gdk_pixbuf_get_bits_per_sample(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_bits_per_sample", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_bits_per_sample(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_pixels(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_pixels "guchar* gdk_pixbuf_get_pixels(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_pixels", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_type_with_c_pointer(sc, guchar__sym, gdk_pixbuf_get_pixels(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_width "int gdk_pixbuf_get_width(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_width", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_width(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_height "int gdk_pixbuf_get_height(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_height", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_height(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_rowstride(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_rowstride "int gdk_pixbuf_get_rowstride(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_rowstride", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_rowstride(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new "GdkPixbuf* gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, \
int width, int height)"
  s7_pointer _p;
  s7_pointer colorspace, has_alpha, bits_per_sample, width, height;
  _p = args;
  colorspace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colorspace)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 1, colorspace, "GdkColorspace");
  has_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 2, has_alpha, "gboolean");
  bits_per_sample = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bits_per_sample)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 3, bits_per_sample, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 5, height, "int");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_new(s7_integer(colorspace), lg_boolean(has_alpha), s7_integer(bits_per_sample), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_gdk_pixbuf_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_copy "GdkPixbuf* gdk_pixbuf_copy(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_copy(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_new_subpixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_subpixbuf "GdkPixbuf* gdk_pixbuf_new_subpixbuf(GdkPixbuf* src_pixbuf, int src_x, \
int src_y, int width, int height)"
  s7_pointer _p;
  s7_pointer src_pixbuf, src_x, src_y, width, height;
  _p = args;
  src_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 1, src_pixbuf, "GdkPixbuf*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 2, src_x, "int");
  src_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 3, src_y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 5, height, "int");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_new_subpixbuf(s7_c_pointer(src_pixbuf), s7_integer(src_x), s7_integer(src_y), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_gdk_pixbuf_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_file "GdkPixbuf* gdk_pixbuf_new_from_file(char* filename, GError** [error])"
  s7_pointer _p;
  s7_pointer filename;
  GError* ref_error = NULL;
  _p = args;
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_file", 1, filename, "char*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_file((char*)s7_string(filename), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_pixbuf_new_from_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_data "GdkPixbuf* gdk_pixbuf_new_from_data(guchar* data, GdkColorspace colorspace, \
gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride, GdkPixbufDestroyNotify destroy_fn, \
gpointer destroy_fn_data)"
  s7_pointer _p;
  s7_pointer data, colorspace, has_alpha, bits_per_sample, width, height, rowstride, destroy_fn, destroy_fn_data;
  _p = args;
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 1, data, "guchar*");
  colorspace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colorspace)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 2, colorspace, "GdkColorspace");
  has_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 3, has_alpha, "gboolean");
  bits_per_sample = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bits_per_sample)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 4, bits_per_sample, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 5, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 6, height, "int");
  rowstride = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rowstride)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 7, rowstride, "int");
  destroy_fn = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy_fn, GdkPixbufDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 8, destroy_fn, "GdkPixbufDestroyNotify");
  destroy_fn_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy_fn_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 9, destroy_fn_data, "gpointer");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_data(s7_c_pointer(data), s7_integer(colorspace), lg_boolean(has_alpha), s7_integer(bits_per_sample), s7_integer(width), s7_integer(height), s7_integer(rowstride), s7_c_pointer(destroy_fn), s7_c_pointer(destroy_fn_data))));
}

static s7_pointer lg_gdk_pixbuf_new_from_xpm_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_xpm_data "GdkPixbuf* gdk_pixbuf_new_from_xpm_data(char** data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_xpm_data", 1, data, "char**");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_xpm_data((const char**)s7_c_pointer(data))));
}

static s7_pointer lg_gdk_pixbuf_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_fill "void gdk_pixbuf_fill(GdkPixbuf* pixbuf, guint32 pixel)"
  s7_pointer _p;
  s7_pointer pixbuf, pixel;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_fill", 1, pixbuf, "GdkPixbuf*");
  pixel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pixel)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_fill", 2, pixel, "guint32");
  gdk_pixbuf_fill(s7_c_pointer(pixbuf), s7_integer(pixel));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_savev(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_savev "gboolean gdk_pixbuf_savev(GdkPixbuf* pixbuf, char* filename, char* type, \
char** option_keys, char** option_values, GError** [error])"
  s7_pointer _p;
  s7_pointer pixbuf, filename, type, option_keys, option_values;
  GError* ref_error = NULL;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 1, pixbuf, "GdkPixbuf*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 2, filename, "char*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 3, type, "char*");
  option_keys = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(option_keys, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 4, option_keys, "char**");
  option_values = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(option_values, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 5, option_values, "char**");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_pixbuf_savev(s7_c_pointer(pixbuf), (char*)s7_string(filename), (char*)s7_string(type), s7_c_pointer(option_keys), s7_c_pointer(option_values), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_pixbuf_add_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_add_alpha "GdkPixbuf* gdk_pixbuf_add_alpha(GdkPixbuf* pixbuf, gboolean substitute_color, \
guchar r, guchar g, guchar b)"
  s7_pointer _p;
  s7_pointer pixbuf, substitute_color, r, g, b;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 1, pixbuf, "GdkPixbuf*");
  substitute_color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(substitute_color)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 2, substitute_color, "gboolean");
  r = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(r)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 3, r, "guchar");
  g = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(g)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 4, g, "guchar");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(b)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 5, b, "guchar");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_add_alpha(s7_c_pointer(pixbuf), lg_boolean(substitute_color), s7_integer(r), s7_integer(g), s7_integer(b))));
}

static s7_pointer lg_gdk_pixbuf_copy_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_copy_area "void gdk_pixbuf_copy_area(GdkPixbuf* src_pixbuf, int src_x, int src_y, \
int width, int height, GdkPixbuf* dest_pixbuf, int dest_x, int dest_y)"
  s7_pointer _p;
  s7_pointer src_pixbuf, src_x, src_y, width, height, dest_pixbuf, dest_x, dest_y;
  _p = args;
  src_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 1, src_pixbuf, "GdkPixbuf*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 2, src_x, "int");
  src_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 3, src_y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 5, height, "int");
  dest_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 6, dest_pixbuf, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 7, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 8, dest_y, "int");
  gdk_pixbuf_copy_area(s7_c_pointer(src_pixbuf), s7_integer(src_x), s7_integer(src_y), s7_integer(width), s7_integer(height), s7_c_pointer(dest_pixbuf), s7_integer(dest_x), s7_integer(dest_y));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_saturate_and_pixelate(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_saturate_and_pixelate "void gdk_pixbuf_saturate_and_pixelate(GdkPixbuf* src, GdkPixbuf* dest, \
gfloat saturation, gboolean pixelate)"
  s7_pointer _p;
  s7_pointer src, dest, saturation, pixelate;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 2, dest, "GdkPixbuf*");
  saturation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(saturation)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 3, saturation, "gfloat");
  pixelate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(pixelate)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 4, pixelate, "gboolean");
  gdk_pixbuf_saturate_and_pixelate(s7_c_pointer(src), s7_c_pointer(dest), s7_real(saturation), lg_boolean(pixelate));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_scale "void gdk_pixbuf_scale(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, int dest_y, \
int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 10, scale_y, "double");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 11, interp_type, "GdkInterpType");
  gdk_pixbuf_scale(s7_c_pointer(src), s7_c_pointer(dest), s7_integer(dest_x), s7_integer(dest_y), s7_integer(dest_width), s7_integer(dest_height), s7_real(offset_x), s7_real(offset_y), s7_real(scale_x), s7_real(scale_y), s7_integer(interp_type));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_composite(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite "void gdk_pixbuf_composite(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, \
int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, \
GdkInterpType interp_type, int overall_alpha)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 10, scale_y, "double");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 11, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 12, overall_alpha, "int");
  gdk_pixbuf_composite(s7_c_pointer(src), s7_c_pointer(dest), s7_integer(dest_x), s7_integer(dest_y), s7_integer(dest_width), s7_integer(dest_height), s7_real(offset_x), s7_real(offset_y), s7_real(scale_x), s7_real(scale_y), s7_integer(interp_type), s7_integer(overall_alpha));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_composite_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite_color "void gdk_pixbuf_composite_color(GdkPixbuf* src, GdkPixbuf* dest, \
int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, \
double scale_y, GdkInterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, \
guint32 color1, guint32 color2)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha, check_x, check_y, check_size, color1, color2;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 10, scale_y, "double");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 11, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 12, overall_alpha, "int");
  check_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 13, check_x, "int");
  check_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 14, check_y, "int");
  check_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_size)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 15, check_size, "int");
  color1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color1)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 16, color1, "guint32");
  color2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color2)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 17, color2, "guint32");
  gdk_pixbuf_composite_color(s7_c_pointer(src), s7_c_pointer(dest), s7_integer(dest_x), s7_integer(dest_y), s7_integer(dest_width), s7_integer(dest_height), s7_real(offset_x), s7_real(offset_y), s7_real(scale_x), s7_real(scale_y), s7_integer(interp_type), s7_integer(overall_alpha), s7_integer(check_x), s7_integer(check_y), s7_integer(check_size), s7_integer(color1), s7_integer(color2));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_scale_simple(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_scale_simple "GdkPixbuf* gdk_pixbuf_scale_simple(GdkPixbuf* src, int dest_width, \
int dest_height, GdkInterpType interp_type)"
  s7_pointer _p;
  s7_pointer src, dest_width, dest_height, interp_type;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 1, src, "GdkPixbuf*");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 2, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 3, dest_height, "int");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 4, interp_type, "GdkInterpType");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_scale_simple(s7_c_pointer(src), s7_integer(dest_width), s7_integer(dest_height), s7_integer(interp_type))));
}

static s7_pointer lg_gdk_pixbuf_composite_color_simple(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite_color_simple "GdkPixbuf* gdk_pixbuf_composite_color_simple(GdkPixbuf* src, \
int dest_width, int dest_height, GdkInterpType interp_type, int overall_alpha, int check_size, guint32 color1, \
guint32 color2)"
  s7_pointer _p;
  s7_pointer src, dest_width, dest_height, interp_type, overall_alpha, check_size, color1, color2;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 1, src, "GdkPixbuf*");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 2, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 3, dest_height, "int");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 4, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 5, overall_alpha, "int");
  check_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_size)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 6, check_size, "int");
  color1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color1)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 7, color1, "guint32");
  color2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color2)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 8, color2, "guint32");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_composite_color_simple(s7_c_pointer(src), s7_integer(dest_width), s7_integer(dest_height), s7_integer(interp_type), s7_integer(overall_alpha), s7_integer(check_size), s7_integer(color1), s7_integer(color2))));
}

static s7_pointer lg_gdk_pixbuf_animation_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_new_from_file "GdkPixbufAnimation* gdk_pixbuf_animation_new_from_file(char* filename, \
GError** [error])"
  s7_pointer _p;
  s7_pointer filename;
  GError* ref_error = NULL;
  _p = args;
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_new_from_file", 1, filename, "char*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkPixbufAnimation__sym, gdk_pixbuf_animation_new_from_file((char*)s7_string(filename), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_pixbuf_animation_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_get_width "int gdk_pixbuf_animation_get_width(GdkPixbufAnimation* animation)"
  s7_pointer animation;
  animation = s7_car(args);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_get_width", 1, animation, "GdkPixbufAnimation*");
  return(s7_make_integer(sc, gdk_pixbuf_animation_get_width(s7_c_pointer(animation))));
}

static s7_pointer lg_gdk_pixbuf_animation_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_get_height "int gdk_pixbuf_animation_get_height(GdkPixbufAnimation* animation)"
  s7_pointer animation;
  animation = s7_car(args);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_get_height", 1, animation, "GdkPixbufAnimation*");
  return(s7_make_integer(sc, gdk_pixbuf_animation_get_height(s7_c_pointer(animation))));
}

static s7_pointer lg_gdk_pixbuf_animation_is_static_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_is_static_image "gboolean gdk_pixbuf_animation_is_static_image(GdkPixbufAnimation* animation)"
  s7_pointer animation;
  animation = s7_car(args);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_is_static_image", 1, animation, "GdkPixbufAnimation*");
  return(s7_make_boolean(sc, gdk_pixbuf_animation_is_static_image(s7_c_pointer(animation))));
}

static s7_pointer lg_gdk_pixbuf_animation_get_static_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_get_static_image "GdkPixbuf* gdk_pixbuf_animation_get_static_image(GdkPixbufAnimation* animation)"
  s7_pointer animation;
  animation = s7_car(args);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_get_static_image", 1, animation, "GdkPixbufAnimation*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_animation_get_static_image(s7_c_pointer(animation))));
}

static s7_pointer lg_gdk_pixbuf_animation_get_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_get_iter "GdkPixbufAnimationIter* gdk_pixbuf_animation_get_iter(GdkPixbufAnimation* animation, \
GTimeVal* start_time)"
  s7_pointer _p;
  s7_pointer animation, start_time;
  _p = args;
  animation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_get_iter", 1, animation, "GdkPixbufAnimation*");
  start_time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start_time, GTimeVal__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_get_iter", 2, start_time, "GTimeVal*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbufAnimationIter__sym, gdk_pixbuf_animation_get_iter(s7_c_pointer(animation), s7_c_pointer(start_time))));
}

static s7_pointer lg_gdk_pixbuf_animation_iter_get_delay_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_iter_get_delay_time "int gdk_pixbuf_animation_iter_get_delay_time(GdkPixbufAnimationIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GdkPixbufAnimationIter__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_iter_get_delay_time", 1, iter, "GdkPixbufAnimationIter*");
  return(s7_make_integer(sc, gdk_pixbuf_animation_iter_get_delay_time(s7_c_pointer(iter))));
}

static s7_pointer lg_gdk_pixbuf_animation_iter_get_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_iter_get_pixbuf "GdkPixbuf* gdk_pixbuf_animation_iter_get_pixbuf(GdkPixbufAnimationIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GdkPixbufAnimationIter__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_iter_get_pixbuf", 1, iter, "GdkPixbufAnimationIter*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_pixbuf_animation_iter_get_pixbuf(s7_c_pointer(iter))));
}

static s7_pointer lg_gdk_pixbuf_animation_iter_on_currently_loading_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_iter_on_currently_loading_frame "gboolean gdk_pixbuf_animation_iter_on_currently_loading_frame(GdkPixbufAnimationIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GdkPixbufAnimationIter__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_iter_on_currently_loading_frame", 1, iter, "GdkPixbufAnimationIter*");
  return(s7_make_boolean(sc, gdk_pixbuf_animation_iter_on_currently_loading_frame(s7_c_pointer(iter))));
}

static s7_pointer lg_gdk_pixbuf_animation_iter_advance(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_animation_iter_advance "gboolean gdk_pixbuf_animation_iter_advance(GdkPixbufAnimationIter* iter, \
GTimeVal* current_time)"
  s7_pointer _p;
  s7_pointer iter, current_time;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GdkPixbufAnimationIter__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_iter_advance", 1, iter, "GdkPixbufAnimationIter*");
  current_time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(current_time, GTimeVal__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_animation_iter_advance", 2, current_time, "GTimeVal*");
  return(s7_make_boolean(sc, gdk_pixbuf_animation_iter_advance(s7_c_pointer(iter), s7_c_pointer(current_time))));
}

static s7_pointer lg_gdk_pixbuf_get_option(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_option "gchar* gdk_pixbuf_get_option(GdkPixbuf* pixbuf, gchar* key)"
  s7_pointer _p;
  s7_pointer pixbuf, key;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_option", 1, pixbuf, "GdkPixbuf*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_option", 2, key, "gchar*");
  return(s7_make_string(sc, gdk_pixbuf_get_option(s7_c_pointer(pixbuf), s7_string(key))));
}

static s7_pointer lg_gtk_accel_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_new "GtkAccelGroup* gtk_accel_group_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkAccelGroup__sym, gtk_accel_group_new()));
}

static s7_pointer lg_gtk_accel_group_lock(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_lock "void gtk_accel_group_lock(GtkAccelGroup* accel_group)"
  s7_pointer accel_group;
  accel_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_lock", 1, accel_group, "GtkAccelGroup*");
  gtk_accel_group_lock(s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_group_unlock(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_unlock "void gtk_accel_group_unlock(GtkAccelGroup* accel_group)"
  s7_pointer accel_group;
  accel_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_unlock", 1, accel_group, "GtkAccelGroup*");
  gtk_accel_group_unlock(s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_group_connect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_connect "void gtk_accel_group_connect(GtkAccelGroup* accel_group, guint accel_key, \
GdkModifierType accel_mods, GtkAccelFlags accel_flags, GClosure* closure)"
  s7_pointer _p;
  s7_pointer accel_group, accel_key, accel_mods, accel_flags, closure;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect", 1, accel_group, "GtkAccelGroup*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect", 3, accel_mods, "GdkModifierType");
  accel_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_flags)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect", 4, accel_flags, "GtkAccelFlags");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect", 5, closure, "GClosure*");
  gtk_accel_group_connect(s7_c_pointer(accel_group), s7_integer(accel_key), s7_integer(accel_mods), s7_integer(accel_flags), s7_c_pointer(closure));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_group_connect_by_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_connect_by_path "void gtk_accel_group_connect_by_path(GtkAccelGroup* accel_group, \
gchar* accel_path, GClosure* closure)"
  s7_pointer _p;
  s7_pointer accel_group, accel_path, closure;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect_by_path", 1, accel_group, "GtkAccelGroup*");
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect_by_path", 2, accel_path, "gchar*");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_group_connect_by_path", 3, closure, "GClosure*");
  gtk_accel_group_connect_by_path(s7_c_pointer(accel_group), s7_string(accel_path), s7_c_pointer(closure));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_group_disconnect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_disconnect "gboolean gtk_accel_group_disconnect(GtkAccelGroup* accel_group, \
GClosure* closure)"
  s7_pointer _p;
  s7_pointer accel_group, closure;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_disconnect", 1, accel_group, "GtkAccelGroup*");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_group_disconnect", 2, closure, "GClosure*");
  return(s7_make_boolean(sc, gtk_accel_group_disconnect(s7_c_pointer(accel_group), s7_c_pointer(closure))));
}

static s7_pointer lg_gtk_accel_group_disconnect_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_disconnect_key "gboolean gtk_accel_group_disconnect_key(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods)"
  s7_pointer _p;
  s7_pointer accel_group, accel_key, accel_mods;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_disconnect_key", 1, accel_group, "GtkAccelGroup*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_group_disconnect_key", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_group_disconnect_key", 3, accel_mods, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_accel_group_disconnect_key(s7_c_pointer(accel_group), s7_integer(accel_key), s7_integer(accel_mods))));
}

static s7_pointer lg_gtk_accel_groups_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_groups_activate "gboolean gtk_accel_groups_activate(GObject* object, guint accel_key, \
GdkModifierType accel_mods)"
  s7_pointer _p;
  s7_pointer object, accel_key, accel_mods;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_groups_activate", 1, object, "GObject*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_groups_activate", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_groups_activate", 3, accel_mods, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_accel_groups_activate(s7_c_pointer(object), s7_integer(accel_key), s7_integer(accel_mods))));
}

static s7_pointer lg_gtk_accel_groups_from_object(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_groups_from_object "GSList* gtk_accel_groups_from_object(GObject* object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_groups_from_object", 1, object, "GObject*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_accel_groups_from_object(s7_c_pointer(object))));
}

static s7_pointer lg_gtk_accel_group_find(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_find "GtkAccelKey* gtk_accel_group_find(GtkAccelGroup* accel_group, lambda3 func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer accel_group, func, func_info;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_find", 1, accel_group, "GtkAccelGroup*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, lambda3_sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_find", 2, func, "lambda3");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_group_find", 3, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_c_pointer(sc, gtk_accel_group_find(s7_c_pointer(accel_group), s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gtk_accel_group_from_accel_closure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_from_accel_closure "GtkAccelGroup* gtk_accel_group_from_accel_closure(GClosure* closure)"
  s7_pointer closure;
  closure = s7_car(args);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_group_from_accel_closure", 1, closure, "GClosure*");
  return(s7_make_type_with_c_pointer(sc, GtkAccelGroup__sym, gtk_accel_group_from_accel_closure(s7_c_pointer(closure))));
}

static s7_pointer lg_gtk_accelerator_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_valid "gboolean gtk_accelerator_valid(guint keyval, GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer keyval, modifiers;
  _p = args;
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_accelerator_valid", 1, keyval, "guint");
  modifiers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_accelerator_valid", 2, modifiers, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_accelerator_valid(s7_integer(keyval), s7_integer(modifiers))));
}

static s7_pointer lg_gtk_accelerator_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_parse "void gtk_accelerator_parse(gchar* accelerator, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  s7_pointer _p;
  s7_pointer accelerator;
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  _p = args;
  accelerator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse", 1, accelerator, "gchar*");
  gtk_accelerator_parse(s7_string(accelerator), &ref_accelerator_key, &ref_accelerator_mods);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_accelerator_key), s7_make_integer(sc, ref_accelerator_mods)));
}

static s7_pointer lg_gtk_accelerator_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_name "gchar* gtk_accelerator_name(guint accelerator_key, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator_key, accelerator_mods;
  _p = args;
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name", 1, accelerator_key, "guint");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name", 2, accelerator_mods, "GdkModifierType");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_accelerator_name(s7_integer(accelerator_key), s7_integer(accelerator_mods));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_accelerator_set_default_mod_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_set_default_mod_mask "void gtk_accelerator_set_default_mod_mask(GdkModifierType default_mod_mask)"
  s7_pointer default_mod_mask;
  default_mod_mask = s7_car(args);
  if (!s7_is_integer(default_mod_mask)) s7_wrong_type_arg_error(sc, "gtk_accelerator_set_default_mod_mask", 1, default_mod_mask, "GdkModifierType");
  gtk_accelerator_set_default_mod_mask(s7_integer(default_mod_mask));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_group_query(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_query "GtkAccelGroupEntry* gtk_accel_group_query(GtkAccelGroup* accel_group, \
guint accel_key, GdkModifierType accel_mods, guint* [n_entries])"
  s7_pointer _p;
  s7_pointer accel_group, accel_key, accel_mods;
  guint ref_n_entries;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_query", 1, accel_group, "GtkAccelGroup*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_group_query", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_group_query", 3, accel_mods, "GdkModifierType");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GtkAccelGroupEntry__sym, gtk_accel_group_query(s7_c_pointer(accel_group), s7_integer(accel_key), s7_integer(accel_mods), &ref_n_entries));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_n_entries)));
   }
}

static s7_pointer lg_gtk_accel_group_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_activate "gboolean gtk_accel_group_activate(GtkAccelGroup* accel_group, GQuark accel_quark, \
GObject* acceleratable, guint accel_key, GdkModifierType accel_mods)"
  s7_pointer _p;
  s7_pointer accel_group, accel_quark, acceleratable, accel_key, accel_mods;
  _p = args;
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_activate", 1, accel_group, "GtkAccelGroup*");
  accel_quark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_quark)) s7_wrong_type_arg_error(sc, "gtk_accel_group_activate", 2, accel_quark, "GQuark");
  acceleratable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(acceleratable, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_activate", 3, acceleratable, "GObject*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_group_activate", 4, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_group_activate", 5, accel_mods, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_accel_group_activate(s7_c_pointer(accel_group), s7_integer(accel_quark), s7_c_pointer(acceleratable), s7_integer(accel_key), s7_integer(accel_mods))));
}

static s7_pointer lg_gtk_accel_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_new "GtkWidget* gtk_accel_label_new(gchar* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "gtk_accel_label_new", 1, string, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_accel_label_new(s7_string(string))));
}

static s7_pointer lg_gtk_accel_label_get_accel_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel_widget "GtkWidget* gtk_accel_label_get_accel_widget(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel_widget", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_accel_label_get_accel_widget(s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_label_get_accel_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel_width "guint gtk_accel_label_get_accel_width(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel_width", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_integer(sc, gtk_accel_label_get_accel_width(s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_label_set_accel_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_accel_widget "void gtk_accel_label_set_accel_widget(GtkAccelLabel* accel_label, \
GtkWidget* accel_widget)"
  s7_pointer _p;
  s7_pointer accel_label, accel_widget;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel_widget", 1, accel_label, "GtkAccelLabel*");
  accel_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel_widget", 2, accel_widget, "GtkWidget*");
  gtk_accel_label_set_accel_widget(s7_c_pointer(accel_label), s7_c_pointer(accel_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_set_accel_closure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_accel_closure "void gtk_accel_label_set_accel_closure(GtkAccelLabel* accel_label, \
GClosure* closure)"
  s7_pointer _p;
  s7_pointer accel_label, closure;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel_closure", 1, accel_label, "GtkAccelLabel*");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel_closure", 2, closure, "GClosure*");
  gtk_accel_label_set_accel_closure(s7_c_pointer(accel_label), s7_c_pointer(closure));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_refetch(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_refetch "gboolean gtk_accel_label_refetch(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_refetch", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_boolean(sc, gtk_accel_label_refetch(s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_map_add_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_add_entry "void gtk_accel_map_add_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods)"
  s7_pointer _p;
  s7_pointer accel_path, accel_key, accel_mods;
  _p = args;
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_map_add_entry", 1, accel_path, "gchar*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_map_add_entry", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_map_add_entry", 3, accel_mods, "GdkModifierType");
  gtk_accel_map_add_entry(s7_string(accel_path), s7_integer(accel_key), s7_integer(accel_mods));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_lookup_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_lookup_entry "gboolean gtk_accel_map_lookup_entry(gchar* accel_path, GtkAccelKey* key)"
  s7_pointer _p;
  s7_pointer accel_path, key;
  _p = args;
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_map_lookup_entry", 1, accel_path, "gchar*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, GtkAccelKey__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_map_lookup_entry", 2, key, "GtkAccelKey*");
  return(s7_make_boolean(sc, gtk_accel_map_lookup_entry(s7_string(accel_path), s7_c_pointer(key))));
}

static s7_pointer lg_gtk_accel_map_change_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_change_entry "gboolean gtk_accel_map_change_entry(gchar* accel_path, guint accel_key, \
GdkModifierType accel_mods, gboolean replace)"
  s7_pointer _p;
  s7_pointer accel_path, accel_key, accel_mods, replace;
  _p = args;
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_map_change_entry", 1, accel_path, "gchar*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_accel_map_change_entry", 2, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_map_change_entry", 3, accel_mods, "GdkModifierType");
  replace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(replace)) s7_wrong_type_arg_error(sc, "gtk_accel_map_change_entry", 4, replace, "gboolean");
  return(s7_make_boolean(sc, gtk_accel_map_change_entry(s7_string(accel_path), s7_integer(accel_key), s7_integer(accel_mods), lg_boolean(replace))));
}

static s7_pointer lg_gtk_accel_map_load(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_load "void gtk_accel_map_load(gchar* file_name)"
  s7_pointer file_name;
  file_name = s7_car(args);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_accel_map_load", 1, file_name, "gchar*");
  gtk_accel_map_load(s7_string(file_name));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_save(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_save "void gtk_accel_map_save(gchar* file_name)"
  s7_pointer file_name;
  file_name = s7_car(args);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_accel_map_save", 1, file_name, "gchar*");
  gtk_accel_map_save(s7_string(file_name));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_foreach "void gtk_accel_map_foreach(lambda_data func_info, GtkAccelMapForeach func)"
  s7_pointer _p;
  s7_pointer func_info, func;
  _p = args;
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_accel_map_foreach", 1, func_info, "lambda_data");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkAccelMapForeach_sym)) s7_wrong_type_arg_error(sc, "gtk_accel_map_foreach", 2, func, "GtkAccelMapForeach");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_accel_map_foreach((gpointer)lg_ptr, s7_c_pointer(func));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_accel_map_load_fd(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_load_fd "void gtk_accel_map_load_fd(gint fd)"
  s7_pointer fd;
  fd = s7_car(args);
  if (!s7_is_integer(fd)) s7_wrong_type_arg_error(sc, "gtk_accel_map_load_fd", 1, fd, "gint");
  gtk_accel_map_load_fd(s7_integer(fd));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_save_fd(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_save_fd "void gtk_accel_map_save_fd(gint fd)"
  s7_pointer fd;
  fd = s7_car(args);
  if (!s7_is_integer(fd)) s7_wrong_type_arg_error(sc, "gtk_accel_map_save_fd", 1, fd, "gint");
  gtk_accel_map_save_fd(s7_integer(fd));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_add_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_add_filter "void gtk_accel_map_add_filter(gchar* filter_pattern)"
  s7_pointer filter_pattern;
  filter_pattern = s7_car(args);
  if (!s7_is_string(filter_pattern)) s7_wrong_type_arg_error(sc, "gtk_accel_map_add_filter", 1, filter_pattern, "gchar*");
  gtk_accel_map_add_filter(s7_string(filter_pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_foreach_unfiltered(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_foreach_unfiltered "void gtk_accel_map_foreach_unfiltered(lambda_data func_info, \
GtkAccelMapForeach func)"
  s7_pointer _p;
  s7_pointer func_info, func;
  _p = args;
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_accel_map_foreach_unfiltered", 1, func_info, "lambda_data");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkAccelMapForeach_sym)) s7_wrong_type_arg_error(sc, "gtk_accel_map_foreach_unfiltered", 2, func, "GtkAccelMapForeach");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_accel_map_foreach_unfiltered((gpointer)lg_ptr, s7_c_pointer(func));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_adjustment_clamp_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_clamp_page "void gtk_adjustment_clamp_page(GtkAdjustment* adjustment, gdouble lower, \
gdouble upper)"
  s7_pointer _p;
  s7_pointer adjustment, lower, upper;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 1, adjustment, "GtkAdjustment*");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 2, lower, "gdouble");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 3, upper, "gdouble");
  gtk_adjustment_clamp_page(s7_c_pointer(adjustment), s7_real(lower), s7_real(upper));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_value "gdouble gtk_adjustment_get_value(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_value", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_value(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_value "void gtk_adjustment_set_value(GtkAdjustment* adjustment, gdouble value)"
  s7_pointer _p;
  s7_pointer adjustment, value;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_value", 1, adjustment, "GtkAdjustment*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_value", 2, value, "gdouble");
  gtk_adjustment_set_value(s7_c_pointer(adjustment), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_aspect_frame_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_new "GtkWidget* gtk_aspect_frame_new(gchar* label, gfloat xalign, gfloat yalign, \
gfloat ratio, gboolean obey_child)"
  s7_pointer _p;
  s7_pointer label, xalign, yalign, ratio, obey_child;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 1, label, "gchar*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 2, xalign, "gfloat");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 3, yalign, "gfloat");
  ratio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ratio)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 4, ratio, "gfloat");
  obey_child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(obey_child)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 5, obey_child, "gboolean");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_aspect_frame_new(s7_string(label), s7_real(xalign), s7_real(yalign), s7_real(ratio), lg_boolean(obey_child))));
}

static s7_pointer lg_gtk_aspect_frame_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_set "void gtk_aspect_frame_set(GtkAspectFrame* aspect_frame, gfloat xalign, \
gfloat yalign, gfloat ratio, gboolean obey_child)"
  s7_pointer _p;
  s7_pointer aspect_frame, xalign, yalign, ratio, obey_child;
  _p = args;
  aspect_frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(aspect_frame, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set", 1, aspect_frame, "GtkAspectFrame*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set", 2, xalign, "gfloat");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set", 3, yalign, "gfloat");
  ratio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ratio)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set", 4, ratio, "gfloat");
  obey_child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(obey_child)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set", 5, obey_child, "gboolean");
  gtk_aspect_frame_set(s7_c_pointer(aspect_frame), s7_real(xalign), s7_real(yalign), s7_real(ratio), lg_boolean(obey_child));
  return(lg_false);
}

static s7_pointer lg_gtk_button_box_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_get_layout "GtkButtonBoxStyle gtk_button_box_get_layout(GtkButtonBox* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_get_layout", 1, widget, "GtkButtonBox*");
  return(s7_make_integer(sc, gtk_button_box_get_layout(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_button_box_set_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_set_layout "void gtk_button_box_set_layout(GtkButtonBox* widget, GtkButtonBoxStyle layout_style)"
  s7_pointer _p;
  s7_pointer widget, layout_style;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_layout", 1, widget, "GtkButtonBox*");
  layout_style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(layout_style)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_layout", 2, layout_style, "GtkButtonBoxStyle");
  gtk_button_box_set_layout(s7_c_pointer(widget), s7_integer(layout_style));
  return(lg_false);
}

static s7_pointer lg_gtk_button_box_set_child_secondary(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_set_child_secondary "void gtk_button_box_set_child_secondary(GtkButtonBox* widget, \
GtkWidget* child, gboolean is_secondary)"
  s7_pointer _p;
  s7_pointer widget, child, is_secondary;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_secondary", 1, widget, "GtkButtonBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_secondary", 2, child, "GtkWidget*");
  is_secondary = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_secondary)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_secondary", 3, is_secondary, "gboolean");
  gtk_button_box_set_child_secondary(s7_c_pointer(widget), s7_c_pointer(child), lg_boolean(is_secondary));
  return(lg_false);
}

static s7_pointer lg_gtk_binding_set_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_set_new "GtkBindingSet* gtk_binding_set_new(gchar* set_name)"
  s7_pointer set_name;
  set_name = s7_car(args);
  if (!s7_is_string(set_name)) s7_wrong_type_arg_error(sc, "gtk_binding_set_new", 1, set_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkBindingSet__sym, gtk_binding_set_new(s7_string(set_name))));
}

static s7_pointer lg_gtk_binding_set_by_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_set_by_class "GtkBindingSet* gtk_binding_set_by_class(gpointer object_class)"
  s7_pointer object_class;
  object_class = s7_car(args);
  if (!s7_is_c_pointer_of_type(object_class, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_binding_set_by_class", 1, object_class, "gpointer");
  return(s7_make_type_with_c_pointer(sc, GtkBindingSet__sym, gtk_binding_set_by_class(s7_c_pointer(object_class))));
}

static s7_pointer lg_gtk_binding_set_find(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_set_find "GtkBindingSet* gtk_binding_set_find(gchar* set_name)"
  s7_pointer set_name;
  set_name = s7_car(args);
  if (!s7_is_string(set_name)) s7_wrong_type_arg_error(sc, "gtk_binding_set_find", 1, set_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkBindingSet__sym, gtk_binding_set_find(s7_string(set_name))));
}

static s7_pointer lg_gtk_binding_entry_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_entry_remove "void gtk_binding_entry_remove(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer binding_set, keyval, modifiers;
  _p = args;
  binding_set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(binding_set, GtkBindingSet__sym)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_remove", 1, binding_set, "GtkBindingSet*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_remove", 2, keyval, "guint");
  modifiers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_remove", 3, modifiers, "GdkModifierType");
  gtk_binding_entry_remove(s7_c_pointer(binding_set), s7_integer(keyval), s7_integer(modifiers));
  return(lg_false);
}

static s7_pointer lg_gtk_bin_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_bin_get_child "GtkWidget* gtk_bin_get_child(GtkBin* bin)"
  s7_pointer bin;
  bin = s7_car(args);
  if (!s7_is_c_pointer_of_type(bin, GtkBin__sym)) s7_wrong_type_arg_error(sc, "gtk_bin_get_child", 1, bin, "GtkBin*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_bin_get_child(s7_c_pointer(bin))));
}

static s7_pointer lg_gtk_box_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_homogeneous "void gtk_box_set_homogeneous(GtkBox* box, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer box, homogeneous;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_homogeneous", 1, box, "GtkBox*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_box_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_box_set_homogeneous(s7_c_pointer(box), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_homogeneous "gboolean gtk_box_get_homogeneous(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_homogeneous", 1, box, "GtkBox*");
  return(s7_make_boolean(sc, gtk_box_get_homogeneous(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_box_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_spacing "void gtk_box_set_spacing(GtkBox* box, gint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_spacing", 1, box, "GtkBox*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_box_set_spacing", 2, spacing, "gint");
  gtk_box_set_spacing(s7_c_pointer(box), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_spacing "gint gtk_box_get_spacing(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_spacing", 1, box, "GtkBox*");
  return(s7_make_integer(sc, gtk_box_get_spacing(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_box_reorder_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_reorder_child "void gtk_box_reorder_child(GtkBox* box, GtkWidget* child, gint position)"
  s7_pointer _p;
  s7_pointer box, child, position;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child", 3, position, "gint");
  gtk_box_reorder_child(s7_c_pointer(box), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_box_query_child_packing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_query_child_packing "void gtk_box_query_child_packing(GtkBox* box, GtkWidget* child, \
gboolean* [expand], gboolean* [fill], guint* [padding], GtkPackType* [pack_type])"
  s7_pointer _p;
  s7_pointer box, child;
  gboolean ref_expand;
  gboolean ref_fill;
  guint ref_padding;
  GtkPackType ref_pack_type;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_query_child_packing", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_query_child_packing", 2, child, "GtkWidget*");
  gtk_box_query_child_packing(s7_c_pointer(box), s7_c_pointer(child), &ref_expand, &ref_fill, &ref_padding, &ref_pack_type);
    return(s7_list(sc, 4, s7_make_boolean(sc, ref_expand), s7_make_boolean(sc, ref_fill), s7_make_integer(sc, ref_padding), s7_make_integer(sc, ref_pack_type)));
}

static s7_pointer lg_gtk_box_set_child_packing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_child_packing "void gtk_box_set_child_packing(GtkBox* box, GtkWidget* child, \
gboolean expand, gboolean fill, guint padding, GtkPackType pack_type)"
  s7_pointer _p;
  s7_pointer box, child, expand, fill, padding, pack_type;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 2, child, "GtkWidget*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 3, expand, "gboolean");
  fill = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(fill)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 4, fill, "gboolean");
  padding = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(padding)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 5, padding, "guint");
  pack_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pack_type)) s7_wrong_type_arg_error(sc, "gtk_box_set_child_packing", 6, pack_type, "GtkPackType");
  gtk_box_set_child_packing(s7_c_pointer(box), s7_c_pointer(child), lg_boolean(expand), lg_boolean(fill), s7_integer(padding), s7_integer(pack_type));
  return(lg_false);
}

static s7_pointer lg_gtk_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new "GtkWidget* gtk_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_button_new()));
}

static s7_pointer lg_gtk_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new_with_label "GtkWidget* gtk_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_new_with_label", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_button_new_with_label(s7_string(label))));
}

static s7_pointer lg_gtk_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new_with_mnemonic "GtkWidget* gtk_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_button_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_button_clicked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_clicked "void gtk_button_clicked(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_clicked", 1, button, "GtkButton*");
  gtk_button_clicked(s7_c_pointer(button));
  return(lg_false);
}

static s7_pointer lg_gtk_button_set_relief(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_relief "void gtk_button_set_relief(GtkButton* button, GtkReliefStyle newstyle)"
  s7_pointer _p;
  s7_pointer button, newstyle;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_relief", 1, button, "GtkButton*");
  newstyle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(newstyle)) s7_wrong_type_arg_error(sc, "gtk_button_set_relief", 2, newstyle, "GtkReliefStyle");
  gtk_button_set_relief(s7_c_pointer(button), s7_integer(newstyle));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_relief(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_relief "GtkReliefStyle gtk_button_get_relief(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_relief", 1, button, "GtkButton*");
  return(s7_make_integer(sc, gtk_button_get_relief(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_button_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_label "void gtk_button_set_label(GtkButton* button, gchar* label)"
  s7_pointer _p;
  s7_pointer button, label;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_label", 1, button, "GtkButton*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_set_label", 2, label, "gchar*");
  gtk_button_set_label(s7_c_pointer(button), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_label "gchar* gtk_button_get_label(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_label", 1, button, "GtkButton*");
  return(s7_make_string(sc, gtk_button_get_label(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_button_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_use_underline "void gtk_button_set_use_underline(GtkButton* button, gboolean use_underline)"
  s7_pointer _p;
  s7_pointer button, use_underline;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_use_underline", 1, button, "GtkButton*");
  use_underline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_button_set_use_underline", 2, use_underline, "gboolean");
  gtk_button_set_use_underline(s7_c_pointer(button), lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_use_underline "gboolean gtk_button_get_use_underline(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_use_underline", 1, button, "GtkButton*");
  return(s7_make_boolean(sc, gtk_button_get_use_underline(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_calendar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_new "GtkWidget* gtk_calendar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_calendar_new()));
}

static s7_pointer lg_gtk_calendar_select_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_select_day "void gtk_calendar_select_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_day", 2, day, "guint");
  gtk_calendar_select_day(s7_c_pointer(calendar), s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_clear_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_clear_marks "void gtk_calendar_clear_marks(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_clear_marks", 1, calendar, "GtkCalendar*");
  gtk_calendar_clear_marks(s7_c_pointer(calendar));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_date(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_date "void gtk_calendar_get_date(GtkCalendar* calendar, guint* [year], guint* [month], \
guint* [day])"
  s7_pointer _p;
  s7_pointer calendar;
  guint ref_year;
  guint ref_month;
  guint ref_day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_date", 1, calendar, "GtkCalendar*");
  gtk_calendar_get_date(s7_c_pointer(calendar), &ref_year, &ref_month, &ref_day);
    return(s7_list(sc, 3, s7_make_integer(sc, ref_year), s7_make_integer(sc, ref_month), s7_make_integer(sc, ref_day)));
}

static s7_pointer lg_gtk_cell_editable_start_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_start_editing "void gtk_cell_editable_start_editing(GtkCellEditable* cell_editable, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer cell_editable, event;
  _p = args;
  cell_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_start_editing", 1, cell_editable, "GtkCellEditable*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_start_editing", 2, event, "GdkEvent*");
  gtk_cell_editable_start_editing(s7_c_pointer(cell_editable), s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_editable_editing_done(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_editing_done "void gtk_cell_editable_editing_done(GtkCellEditable* cell_editable)"
  s7_pointer cell_editable;
  cell_editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_editing_done", 1, cell_editable, "GtkCellEditable*");
  gtk_cell_editable_editing_done(s7_c_pointer(cell_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_editable_remove_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_remove_widget "void gtk_cell_editable_remove_widget(GtkCellEditable* cell_editable)"
  s7_pointer cell_editable;
  cell_editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_remove_widget", 1, cell_editable, "GtkCellEditable*");
  gtk_cell_editable_remove_widget(s7_c_pointer(cell_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_activate "gboolean gtk_cell_renderer_activate(GtkCellRenderer* cell, GdkEvent* event, \
GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags)"
  s7_pointer _p;
  s7_pointer cell, event, widget, path, background_area, cell_area, flags;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 1, cell, "GtkCellRenderer*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 2, event, "GdkEvent*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 3, widget, "GtkWidget*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 4, path, "gchar*");
  background_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(background_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 5, background_area, "GdkRectangle*");
  cell_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 6, cell_area, "GdkRectangle*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 7, flags, "GtkCellRendererState");
  return(s7_make_boolean(sc, gtk_cell_renderer_activate(s7_c_pointer(cell), s7_c_pointer(event), s7_c_pointer(widget), s7_string(path), s7_c_pointer(background_area), s7_c_pointer(cell_area), s7_integer(flags))));
}

static s7_pointer lg_gtk_cell_renderer_start_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_start_editing "GtkCellEditable* gtk_cell_renderer_start_editing(GtkCellRenderer* cell, \
GdkEvent* event, GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, \
GtkCellRendererState flags)"
  s7_pointer _p;
  s7_pointer cell, event, widget, path, background_area, cell_area, flags;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 1, cell, "GtkCellRenderer*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 2, event, "GdkEvent*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 3, widget, "GtkWidget*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 4, path, "gchar*");
  background_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(background_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 5, background_area, "GdkRectangle*");
  cell_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 6, cell_area, "GdkRectangle*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 7, flags, "GtkCellRendererState");
  return(s7_make_type_with_c_pointer(sc, GtkCellEditable__sym, gtk_cell_renderer_start_editing(s7_c_pointer(cell), s7_c_pointer(event), s7_c_pointer(widget), s7_string(path), s7_c_pointer(background_area), s7_c_pointer(cell_area), s7_integer(flags))));
}

static s7_pointer lg_gtk_cell_renderer_set_fixed_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_fixed_size "void gtk_cell_renderer_set_fixed_size(GtkCellRenderer* cell, \
gint width, gint height)"
  s7_pointer _p;
  s7_pointer cell, width, height;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 1, cell, "GtkCellRenderer*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 2, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 3, height, "gint");
  gtk_cell_renderer_set_fixed_size(s7_c_pointer(cell), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_fixed_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_fixed_size "void gtk_cell_renderer_get_fixed_size(GtkCellRenderer* cell, \
gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer cell;
  gint ref_width;
  gint ref_height;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_fixed_size", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_fixed_size(s7_c_pointer(cell), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_cell_renderer_pixbuf_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_pixbuf_new "GtkCellRenderer* gtk_cell_renderer_pixbuf_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_pixbuf_new()));
}

static s7_pointer lg_gtk_cell_renderer_text_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_text_new "GtkCellRenderer* gtk_cell_renderer_text_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_text_new()));
}

static s7_pointer lg_gtk_cell_renderer_text_set_fixed_height_from_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_text_set_fixed_height_from_font "void gtk_cell_renderer_text_set_fixed_height_from_font(GtkCellRendererText* renderer, \
gint number_of_rows)"
  s7_pointer _p;
  s7_pointer renderer, number_of_rows;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, GtkCellRendererText__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", 1, renderer, "GtkCellRendererText*");
  number_of_rows = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(number_of_rows)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", 2, number_of_rows, "gint");
  gtk_cell_renderer_text_set_fixed_height_from_font(s7_c_pointer(renderer), s7_integer(number_of_rows));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_toggle_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_new "GtkCellRenderer* gtk_cell_renderer_toggle_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_toggle_new()));
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_radio "gboolean gtk_cell_renderer_toggle_get_radio(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_radio", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_radio(s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_radio "void gtk_cell_renderer_toggle_set_radio(GtkCellRendererToggle* toggle, \
gboolean radio)"
  s7_pointer _p;
  s7_pointer toggle, radio;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_radio", 1, toggle, "GtkCellRendererToggle*");
  radio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(radio)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_radio", 2, radio, "gboolean");
  gtk_cell_renderer_toggle_set_radio(s7_c_pointer(toggle), lg_boolean(radio));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_active "gboolean gtk_cell_renderer_toggle_get_active(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_active", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_active(s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_active "void gtk_cell_renderer_toggle_set_active(GtkCellRendererToggle* toggle, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer toggle, setting;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_active", 1, toggle, "GtkCellRendererToggle*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_active", 2, setting, "gboolean");
  gtk_cell_renderer_toggle_set_active(s7_c_pointer(toggle), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new "GtkWidget* gtk_check_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_button_new()));
}

static s7_pointer lg_gtk_check_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new_with_label "GtkWidget* gtk_check_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_button_new_with_label", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_button_new_with_label(s7_string(label))));
}

static s7_pointer lg_gtk_check_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new_with_mnemonic "GtkWidget* gtk_check_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_button_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_button_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_check_menu_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_new "GtkWidget* gtk_check_menu_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_menu_item_new()));
}

static s7_pointer lg_gtk_check_menu_item_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_new_with_label "GtkWidget* gtk_check_menu_item_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_new_with_label", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_menu_item_new_with_label(s7_string(label))));
}

static s7_pointer lg_gtk_check_menu_item_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_new_with_mnemonic "GtkWidget* gtk_check_menu_item_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_check_menu_item_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_check_menu_item_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_set_active "void gtk_check_menu_item_set_active(GtkCheckMenuItem* check_menu_item, \
gboolean is_active)"
  s7_pointer _p;
  s7_pointer check_menu_item, is_active;
  _p = args;
  check_menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_active", 1, check_menu_item, "GtkCheckMenuItem*");
  is_active = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_active", 2, is_active, "gboolean");
  gtk_check_menu_item_set_active(s7_c_pointer(check_menu_item), lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_check_menu_item_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_get_active "gboolean gtk_check_menu_item_get_active(GtkCheckMenuItem* check_menu_item)"
  s7_pointer check_menu_item;
  check_menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_get_active", 1, check_menu_item, "GtkCheckMenuItem*");
  return(s7_make_boolean(sc, gtk_check_menu_item_get_active(s7_c_pointer(check_menu_item))));
}

static s7_pointer lg_gtk_check_menu_item_toggled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_toggled "void gtk_check_menu_item_toggled(GtkCheckMenuItem* check_menu_item)"
  s7_pointer check_menu_item;
  check_menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_toggled", 1, check_menu_item, "GtkCheckMenuItem*");
  gtk_check_menu_item_toggled(s7_c_pointer(check_menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_check_menu_item_set_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_set_inconsistent "void gtk_check_menu_item_set_inconsistent(GtkCheckMenuItem* check_menu_item, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer check_menu_item, setting;
  _p = args;
  check_menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_inconsistent", 1, check_menu_item, "GtkCheckMenuItem*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_inconsistent", 2, setting, "gboolean");
  gtk_check_menu_item_set_inconsistent(s7_c_pointer(check_menu_item), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_check_menu_item_get_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_get_inconsistent "gboolean gtk_check_menu_item_get_inconsistent(GtkCheckMenuItem* check_menu_item)"
  s7_pointer check_menu_item;
  check_menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_get_inconsistent", 1, check_menu_item, "GtkCheckMenuItem*");
  return(s7_make_boolean(sc, gtk_check_menu_item_get_inconsistent(s7_c_pointer(check_menu_item))));
}

static s7_pointer lg_gtk_clipboard_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get "GtkClipboard* gtk_clipboard_get(GdkAtom selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get", 1, selection, "GdkAtom");
  return(s7_make_type_with_c_pointer(sc, GtkClipboard__sym, gtk_clipboard_get(s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_clipboard_set_with_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_set_with_data "gboolean gtk_clipboard_set_with_data(GtkClipboard* clipboard, \
GtkTargetEntry* targets, guint n_targets, GtkClipboardGetFunc func, GtkClipboardClearFunc clear_func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, targets, n_targets, func, clear_func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 1, clipboard, "GtkClipboard*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 2, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 3, n_targets, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardGetFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 4, func, "GtkClipboardGetFunc");
  clear_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clear_func, GtkClipboardClearFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 5, clear_func, "GtkClipboardClearFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_with_data", 6, func_info, "lambda_data");
  {
    s7_pointer result;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, clear_func);
    result = s7_make_boolean(sc, gtk_clipboard_set_with_data(s7_c_pointer(clipboard), s7_c_pointer(targets), s7_integer(n_targets), s7_c_pointer(func), s7_c_pointer(clear_func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gtk_clipboard_get_owner(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get_owner "GObject* gtk_clipboard_get_owner(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_owner", 1, clipboard, "GtkClipboard*");
  return(s7_make_type_with_c_pointer(sc, GObject__sym, gtk_clipboard_get_owner(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_clipboard_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_clear "void gtk_clipboard_clear(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_clear", 1, clipboard, "GtkClipboard*");
  gtk_clipboard_clear(s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_set_text "void gtk_clipboard_set_text(GtkClipboard* clipboard, gchar* text, \
gint len)"
  s7_pointer _p;
  s7_pointer clipboard, text, len;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_text", 1, clipboard, "GtkClipboard*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_text", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_text", 3, len, "gint");
  gtk_clipboard_set_text(s7_c_pointer(clipboard), s7_string(text), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_request_contents(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_request_contents "void gtk_clipboard_request_contents(GtkClipboard* clipboard, \
GdkAtom target, GtkClipboardReceivedFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, target, func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_contents", 1, clipboard, "GtkClipboard*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_contents", 2, target, "GdkAtom");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardReceivedFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_contents", 3, func, "GtkClipboardReceivedFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_contents", 4, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_clipboard_request_contents(s7_c_pointer(clipboard), s7_c_pointer(target), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_clipboard_request_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_request_text "void gtk_clipboard_request_text(GtkClipboard* clipboard, GtkClipboardTextReceivedFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_text", 1, clipboard, "GtkClipboard*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardTextReceivedFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_text", 2, func, "GtkClipboardTextReceivedFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_text", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_clipboard_request_text(s7_c_pointer(clipboard), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_clipboard_wait_for_contents(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_for_contents "GtkSelectionData* gtk_clipboard_wait_for_contents(GtkClipboard* clipboard, \
GdkAtom target)"
  s7_pointer _p;
  s7_pointer clipboard, target;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_contents", 1, clipboard, "GtkClipboard*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_contents", 2, target, "GdkAtom");
  return(s7_make_type_with_c_pointer(sc, GtkSelectionData__sym, gtk_clipboard_wait_for_contents(s7_c_pointer(clipboard), s7_c_pointer(target))));
}

static s7_pointer lg_gtk_clipboard_wait_for_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_for_text "gchar* gtk_clipboard_wait_for_text(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_text", 1, clipboard, "GtkClipboard*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_clipboard_wait_for_text(s7_c_pointer(clipboard));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_clipboard_wait_is_text_available(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_is_text_available "gboolean gtk_clipboard_wait_is_text_available(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_text_available", 1, clipboard, "GtkClipboard*");
  return(s7_make_boolean(sc, gtk_clipboard_wait_is_text_available(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_container_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_add "void gtk_container_add(GtkContainer* container, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer container, widget;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_add", 1, container, "GtkContainer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_add", 2, widget, "GtkWidget*");
  gtk_container_add(s7_c_pointer(container), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_container_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_remove "void gtk_container_remove(GtkContainer* container, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer container, widget;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_remove", 1, container, "GtkContainer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_remove", 2, widget, "GtkWidget*");
  gtk_container_remove(s7_c_pointer(container), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_container_check_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_check_resize "void gtk_container_check_resize(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_check_resize", 1, container, "GtkContainer*");
  gtk_container_check_resize(s7_c_pointer(container));
  return(lg_false);
}

static s7_pointer lg_gtk_container_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_foreach "void gtk_container_foreach(GtkContainer* container, GtkCallback func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer container, func, func_info;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_foreach", 1, container, "GtkContainer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkCallback_sym)) s7_wrong_type_arg_error(sc, "gtk_container_foreach", 2, func, "GtkCallback");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_container_foreach", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_container_foreach(s7_c_pointer(container), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_container_get_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_get_children "GList* gtk_container_get_children(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_get_children", 1, container, "GtkContainer*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_container_get_children(s7_c_pointer(container))));
}

static s7_pointer lg_gtk_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_new "GtkWidget* gtk_dialog_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_dialog_new()));
}

static s7_pointer lg_gtk_dialog_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_action_widget "void gtk_dialog_add_action_widget(GtkDialog* dialog, GtkWidget* child, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, child, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 1, dialog, "GtkDialog*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 2, child, "GtkWidget*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 3, response_id, "gint");
  gtk_dialog_add_action_widget(s7_c_pointer(dialog), s7_c_pointer(child), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_add_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_button "GtkWidget* gtk_dialog_add_button(GtkDialog* dialog, gchar* button_text, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, button_text, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 1, dialog, "GtkDialog*");
  button_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(button_text)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 2, button_text, "gchar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 3, response_id, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_dialog_add_button(s7_c_pointer(dialog), s7_string(button_text), s7_integer(response_id))));
}

static s7_pointer lg_gtk_dialog_add_buttons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_buttons "void gtk_dialog_add_buttons(GtkDialog* dialog, etc buttons)"
  s7_pointer _p;
  s7_pointer dialog, buttons;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_buttons", 1, dialog, "GtkDialog*");
  buttons = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(buttons)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_buttons", 2, buttons, "etc");
  {
    int etc_len = 0;
    GtkDialog* p_arg0;
    if (s7_is_list(sc, buttons)) etc_len = s7_list_length(sc, buttons);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list len must be multiple of 2");
    p_arg0 = (GtkDialog*)s7_c_pointer(dialog);
    switch (etc_len)
      {
        case 2: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), NULL); break;
        case 4: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), NULL); break;
        case 6: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), NULL); break;
        case 8: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), NULL); break;
        case 10: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), s7_string(s7_list_ref(sc, buttons, 8)), s7_integer(s7_list_ref(sc, buttons, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_dialog_set_response_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_set_response_sensitive "void gtk_dialog_set_response_sensitive(GtkDialog* dialog, \
gint response_id, gboolean setting)"
  s7_pointer _p;
  s7_pointer dialog, response_id, setting;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 2, response_id, "gint");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 3, setting, "gboolean");
  gtk_dialog_set_response_sensitive(s7_c_pointer(dialog), s7_integer(response_id), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_set_default_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_set_default_response "void gtk_dialog_set_default_response(GtkDialog* dialog, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_default_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_default_response", 2, response_id, "gint");
  gtk_dialog_set_default_response(s7_c_pointer(dialog), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_response "void gtk_dialog_response(GtkDialog* dialog, gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_response", 2, response_id, "gint");
  gtk_dialog_response(s7_c_pointer(dialog), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_run(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_run "gint gtk_dialog_run(GtkDialog* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_run", 1, dialog, "GtkDialog*");
  return(s7_make_integer(sc, gtk_dialog_run(s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_drag_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_get_data "void gtk_drag_get_data(GtkWidget* widget, GdkDragContext* context, GdkAtom target, \
guint32 time)"
  s7_pointer _p;
  s7_pointer widget, context, target, time;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_get_data", 1, widget, "GtkWidget*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_get_data", 2, context, "GdkDragContext*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_drag_get_data", 3, target, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gtk_drag_get_data", 4, time, "guint32");
  gtk_drag_get_data(s7_c_pointer(widget), s7_c_pointer(context), s7_c_pointer(target), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_finish "void gtk_drag_finish(GdkDragContext* context, gboolean success, gboolean del, \
guint32 time)"
  s7_pointer _p;
  s7_pointer context, success, del, time;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_finish", 1, context, "GdkDragContext*");
  success = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(success)) s7_wrong_type_arg_error(sc, "gtk_drag_finish", 2, success, "gboolean");
  del = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(del)) s7_wrong_type_arg_error(sc, "gtk_drag_finish", 3, del, "gboolean");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gtk_drag_finish", 4, time, "guint32");
  gtk_drag_finish(s7_c_pointer(context), lg_boolean(success), lg_boolean(del), s7_integer(time));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_get_source_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_get_source_widget "GtkWidget* gtk_drag_get_source_widget(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_get_source_widget", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_drag_get_source_widget(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_drag_highlight(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_highlight "void gtk_drag_highlight(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_highlight", 1, widget, "GtkWidget*");
  gtk_drag_highlight(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_unhighlight(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_unhighlight "void gtk_drag_unhighlight(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_unhighlight", 1, widget, "GtkWidget*");
  gtk_drag_unhighlight(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_set "void gtk_drag_dest_set(GtkWidget* widget, GtkDestDefaults flags, GtkTargetEntry* targets, \
gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer widget, flags, targets, n_targets, actions;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set", 1, widget, "GtkWidget*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set", 2, flags, "GtkDestDefaults");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set", 3, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set", 4, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set", 5, actions, "GdkDragAction");
  gtk_drag_dest_set(s7_c_pointer(widget), s7_integer(flags), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_unset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_unset "void gtk_drag_dest_unset(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_unset", 1, widget, "GtkWidget*");
  gtk_drag_dest_unset(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_find_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_find_target "GdkAtom gtk_drag_dest_find_target(GtkWidget* widget, GdkDragContext* context, \
GtkTargetList* target_list)"
  s7_pointer _p;
  s7_pointer widget, context, target_list;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_find_target", 1, widget, "GtkWidget*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_find_target", 2, context, "GdkDragContext*");
  target_list = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(target_list, GtkTargetList__sym)) && (target_list != lg_false)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_find_target", 3, target_list, "GtkTargetList*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_drag_dest_find_target(s7_c_pointer(widget), s7_c_pointer(context), s7_c_pointer(target_list))));
}

static s7_pointer lg_gtk_drag_dest_get_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_get_target_list "GtkTargetList* gtk_drag_dest_get_target_list(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_get_target_list", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_drag_dest_get_target_list(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_drag_dest_set_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_set_target_list "void gtk_drag_dest_set_target_list(GtkWidget* widget, GtkTargetList* target_list)"
  s7_pointer _p;
  s7_pointer widget, target_list;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set_target_list", 1, widget, "GtkWidget*");
  target_list = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(target_list, GtkTargetList__sym)) && (target_list != lg_false)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set_target_list", 2, target_list, "GtkTargetList*");
  gtk_drag_dest_set_target_list(s7_c_pointer(widget), s7_c_pointer(target_list));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set "void gtk_drag_source_set(GtkWidget* widget, GdkModifierType start_button_mask, \
GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer widget, start_button_mask, targets, n_targets, actions;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set", 1, widget, "GtkWidget*");
  start_button_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_button_mask)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set", 2, start_button_mask, "GdkModifierType");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set", 3, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set", 4, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set", 5, actions, "GdkDragAction");
  gtk_drag_source_set(s7_c_pointer(widget), s7_integer(start_button_mask), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_unset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_unset "void gtk_drag_source_unset(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_unset", 1, widget, "GtkWidget*");
  gtk_drag_source_unset(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_set_icon_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_icon_pixbuf "void gtk_drag_source_set_icon_pixbuf(GtkWidget* widget, \
GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer widget, pixbuf;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_pixbuf", 1, widget, "GtkWidget*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_pixbuf", 2, pixbuf, "GdkPixbuf*");
  gtk_drag_source_set_icon_pixbuf(s7_c_pointer(widget), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_set_icon_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_widget "void gtk_drag_set_icon_widget(GdkDragContext* context, GtkWidget* widget, \
gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer context, widget, hot_x, hot_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_widget", 1, context, "GdkDragContext*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_widget", 2, widget, "GtkWidget*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_widget", 3, hot_x, "gint");
  hot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_widget", 4, hot_y, "gint");
  gtk_drag_set_icon_widget(s7_c_pointer(context), s7_c_pointer(widget), s7_integer(hot_x), s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_set_icon_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_pixbuf "void gtk_drag_set_icon_pixbuf(GdkDragContext* context, GdkPixbuf* pixbuf, \
gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer context, pixbuf, hot_x, hot_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_pixbuf", 1, context, "GdkDragContext*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_pixbuf", 2, pixbuf, "GdkPixbuf*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_pixbuf", 3, hot_x, "gint");
  hot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_pixbuf", 4, hot_y, "gint");
  gtk_drag_set_icon_pixbuf(s7_c_pointer(context), s7_c_pointer(pixbuf), s7_integer(hot_x), s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_set_icon_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_default "void gtk_drag_set_icon_default(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_default", 1, context, "GdkDragContext*");
  gtk_drag_set_icon_default(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_check_threshold(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_check_threshold "gboolean gtk_drag_check_threshold(GtkWidget* widget, gint start_x, \
gint start_y, gint current_x, gint current_y)"
  s7_pointer _p;
  s7_pointer widget, start_x, start_y, current_x, current_y;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 1, widget, "GtkWidget*");
  start_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_x)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 2, start_x, "gint");
  start_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_y)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 3, start_y, "gint");
  current_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(current_x)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 4, current_x, "gint");
  current_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(current_y)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 5, current_y, "gint");
  return(s7_make_boolean(sc, gtk_drag_check_threshold(s7_c_pointer(widget), s7_integer(start_x), s7_integer(start_y), s7_integer(current_x), s7_integer(current_y))));
}

static s7_pointer lg_gtk_drawing_area_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_new "GtkWidget* gtk_drawing_area_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_drawing_area_new()));
}

static s7_pointer lg_gtk_editable_select_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_select_region "void gtk_editable_select_region(GtkEditable* editable, gint start, \
gint end)"
  s7_pointer _p;
  s7_pointer editable, start, end;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 1, editable, "GtkEditable*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 2, start, "gint");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 3, end, "gint");
  gtk_editable_select_region(s7_c_pointer(editable), s7_integer(start), s7_integer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_selection_bounds "gboolean gtk_editable_get_selection_bounds(GtkEditable* editable, \
gint* [start], gint* [end])"
  s7_pointer _p;
  s7_pointer editable;
  gint ref_start;
  gint ref_end;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_selection_bounds", 1, editable, "GtkEditable*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_editable_get_selection_bounds(s7_c_pointer(editable), &ref_start, &ref_end));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
   }
}

static s7_pointer lg_gtk_editable_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_insert_text "void gtk_editable_insert_text(GtkEditable* editable, gchar* new_text, \
gint new_text_length, gint* [position])"
  s7_pointer _p;
  s7_pointer editable, new_text, new_text_length;
  gint ref_position;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 1, editable, "GtkEditable*");
  new_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(new_text)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 2, new_text, "gchar*");
  new_text_length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(new_text_length)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 3, new_text_length, "gint");
  gtk_editable_insert_text(s7_c_pointer(editable), s7_string(new_text), s7_integer(new_text_length), &ref_position);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_position)));
}

static s7_pointer lg_gtk_editable_delete_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delete_text "void gtk_editable_delete_text(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  s7_pointer _p;
  s7_pointer editable, start_pos, end_pos;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 1, editable, "GtkEditable*");
  start_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 2, start_pos, "gint");
  end_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 3, end_pos, "gint");
  gtk_editable_delete_text(s7_c_pointer(editable), s7_integer(start_pos), s7_integer(end_pos));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_chars "gchar* gtk_editable_get_chars(GtkEditable* editable, gint start_pos, \
gint end_pos)"
  s7_pointer _p;
  s7_pointer editable, start_pos, end_pos;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 1, editable, "GtkEditable*");
  start_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 2, start_pos, "gint");
  end_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 3, end_pos, "gint");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_editable_get_chars(s7_c_pointer(editable), s7_integer(start_pos), s7_integer(end_pos));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_editable_cut_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_cut_clipboard "void gtk_editable_cut_clipboard(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_cut_clipboard", 1, editable, "GtkEditable*");
  gtk_editable_cut_clipboard(s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_copy_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_copy_clipboard "void gtk_editable_copy_clipboard(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_copy_clipboard", 1, editable, "GtkEditable*");
  gtk_editable_copy_clipboard(s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_paste_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_paste_clipboard "void gtk_editable_paste_clipboard(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_paste_clipboard", 1, editable, "GtkEditable*");
  gtk_editable_paste_clipboard(s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_delete_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delete_selection "void gtk_editable_delete_selection(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_selection", 1, editable, "GtkEditable*");
  gtk_editable_delete_selection(s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_position "void gtk_editable_set_position(GtkEditable* editable, gint position)"
  s7_pointer _p;
  s7_pointer editable, position;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_position", 1, editable, "GtkEditable*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_editable_set_position", 2, position, "gint");
  gtk_editable_set_position(s7_c_pointer(editable), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_position "gint gtk_editable_get_position(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_position", 1, editable, "GtkEditable*");
  return(s7_make_integer(sc, gtk_editable_get_position(s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_editable_set_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_editable "void gtk_editable_set_editable(GtkEditable* editable, gboolean is_editable)"
  s7_pointer _p;
  s7_pointer editable, is_editable;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_editable", 1, editable, "GtkEditable*");
  is_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_editable)) s7_wrong_type_arg_error(sc, "gtk_editable_set_editable", 2, is_editable, "gboolean");
  gtk_editable_set_editable(s7_c_pointer(editable), lg_boolean(is_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_editable "gboolean gtk_editable_get_editable(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_editable", 1, editable, "GtkEditable*");
  return(s7_make_boolean(sc, gtk_editable_get_editable(s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_new "GtkWidget* gtk_entry_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_entry_new()));
}

static s7_pointer lg_gtk_entry_set_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_visibility "void gtk_entry_set_visibility(GtkEntry* entry, gboolean visible)"
  s7_pointer _p;
  s7_pointer entry, visible;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_visibility", 1, entry, "GtkEntry*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_entry_set_visibility", 2, visible, "gboolean");
  gtk_entry_set_visibility(s7_c_pointer(entry), lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_visibility "gboolean gtk_entry_get_visibility(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_visibility", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_visibility(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_invisible_char "void gtk_entry_set_invisible_char(GtkEntry* entry, gunichar ch)"
  s7_pointer _p;
  s7_pointer entry, ch;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_invisible_char", 1, entry, "GtkEntry*");
  ch = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "gtk_entry_set_invisible_char", 2, ch, "gunichar");
  gtk_entry_set_invisible_char(s7_c_pointer(entry), s7_integer(ch));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_invisible_char "gunichar gtk_entry_get_invisible_char(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_invisible_char", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_invisible_char(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_has_frame "void gtk_entry_set_has_frame(GtkEntry* entry, gboolean setting)"
  s7_pointer _p;
  s7_pointer entry, setting;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_has_frame", 1, entry, "GtkEntry*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_entry_set_has_frame", 2, setting, "gboolean");
  gtk_entry_set_has_frame(s7_c_pointer(entry), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_has_frame "gboolean gtk_entry_get_has_frame(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_has_frame", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_has_frame(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_max_length "void gtk_entry_set_max_length(GtkEntry* entry, gint max)"
  s7_pointer _p;
  s7_pointer entry, max;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_length", 1, entry, "GtkEntry*");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_length", 2, max, "gint");
  gtk_entry_set_max_length(s7_c_pointer(entry), s7_integer(max));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_max_length "gint gtk_entry_get_max_length(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_max_length", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_max_length(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_activates_default "void gtk_entry_set_activates_default(GtkEntry* entry, gboolean setting)"
  s7_pointer _p;
  s7_pointer entry, setting;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_activates_default", 1, entry, "GtkEntry*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_entry_set_activates_default", 2, setting, "gboolean");
  gtk_entry_set_activates_default(s7_c_pointer(entry), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_activates_default "gboolean gtk_entry_get_activates_default(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_activates_default", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_activates_default(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_width_chars "void gtk_entry_set_width_chars(GtkEntry* entry, gint n_chars)"
  s7_pointer _p;
  s7_pointer entry, n_chars;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_width_chars", 1, entry, "GtkEntry*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_set_width_chars", 2, n_chars, "gint");
  gtk_entry_set_width_chars(s7_c_pointer(entry), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_width_chars "gint gtk_entry_get_width_chars(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_width_chars", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_width_chars(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_text "void gtk_entry_set_text(GtkEntry* entry, gchar* text)"
  s7_pointer _p;
  s7_pointer entry, text;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_text", 1, entry, "GtkEntry*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_entry_set_text", 2, text, "gchar*");
  gtk_entry_set_text(s7_c_pointer(entry), s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_text "gchar* gtk_entry_get_text(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_text", 1, entry, "GtkEntry*");
  return(s7_make_string(sc, gtk_entry_get_text(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_layout "PangoLayout* gtk_entry_get_layout(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_layout", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, gtk_entry_get_layout(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_get_layout_offsets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_layout_offsets "void gtk_entry_get_layout_offsets(GtkEntry* entry, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer entry;
  gint ref_x;
  gint ref_y;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_layout_offsets", 1, entry, "GtkEntry*");
  gtk_entry_get_layout_offsets(s7_c_pointer(entry), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_fixed_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_new "GtkWidget* gtk_fixed_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_fixed_new()));
}

static s7_pointer lg_gtk_fixed_put(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_put "void gtk_fixed_put(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  s7_pointer _p;
  s7_pointer fixed, widget, x, y;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 1, fixed, "GtkFixed*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 2, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 3, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 4, y, "gint");
  gtk_fixed_put(s7_c_pointer(fixed), s7_c_pointer(widget), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_fixed_move(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_move "void gtk_fixed_move(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  s7_pointer _p;
  s7_pointer fixed, widget, x, y;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 1, fixed, "GtkFixed*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 2, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 3, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 4, y, "gint");
  gtk_fixed_move(s7_c_pointer(fixed), s7_c_pointer(widget), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_new "GtkWidget* gtk_frame_new(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_frame_new", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_frame_new(s7_string(label))));
}

static s7_pointer lg_gtk_frame_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label "void gtk_frame_set_label(GtkFrame* frame, gchar* label)"
  s7_pointer _p;
  s7_pointer frame, label;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label", 1, frame, "GtkFrame*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label", 2, label, "gchar*");
  gtk_frame_set_label(s7_c_pointer(frame), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label "gchar* gtk_frame_get_label(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label", 1, frame, "GtkFrame*");
  return(s7_make_string(sc, gtk_frame_get_label(s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_frame_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label_widget "void gtk_frame_set_label_widget(GtkFrame* frame, GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer frame, label_widget;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_widget", 1, frame, "GtkFrame*");
  label_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_frame_set_label_widget(s7_c_pointer(frame), s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label_widget "GtkWidget* gtk_frame_get_label_widget(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label_widget", 1, frame, "GtkFrame*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_frame_get_label_widget(s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_frame_set_label_align(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label_align "void gtk_frame_set_label_align(GtkFrame* frame, gfloat xalign, \
gfloat yalign)"
  s7_pointer _p;
  s7_pointer frame, xalign, yalign;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_align", 1, frame, "GtkFrame*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_align", 2, xalign, "gfloat");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_align", 3, yalign, "gfloat");
  gtk_frame_set_label_align(s7_c_pointer(frame), s7_real(xalign), s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label_align(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label_align "void gtk_frame_get_label_align(GtkFrame* frame, gfloat* [xalign], \
gfloat* [yalign])"
  s7_pointer _p;
  s7_pointer frame;
  gfloat ref_xalign;
  gfloat ref_yalign;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label_align", 1, frame, "GtkFrame*");
  gtk_frame_get_label_align(s7_c_pointer(frame), &ref_xalign, &ref_yalign);
    return(s7_list(sc, 2, s7_make_real(sc, ref_xalign), s7_make_real(sc, ref_yalign)));
}

static s7_pointer lg_gtk_frame_set_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_shadow_type "void gtk_frame_set_shadow_type(GtkFrame* frame, GtkShadowType type)"
  s7_pointer _p;
  s7_pointer frame, type;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_shadow_type", 1, frame, "GtkFrame*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_frame_set_shadow_type", 2, type, "GtkShadowType");
  gtk_frame_set_shadow_type(s7_c_pointer(frame), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_shadow_type "GtkShadowType gtk_frame_get_shadow_type(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_shadow_type", 1, frame, "GtkFrame*");
  return(s7_make_integer(sc, gtk_frame_get_shadow_type(s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_image_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new "GtkWidget* gtk_image_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new()));
}

static s7_pointer lg_gtk_image_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_file "GtkWidget* gtk_image_new_from_file(gchar* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_file", 1, filename, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new_from_file(s7_string(filename))));
}

static s7_pointer lg_gtk_image_new_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_pixbuf "GtkWidget* gtk_image_new_from_pixbuf(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if ((!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) && (pixbuf != lg_false)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_pixbuf", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new_from_pixbuf(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_image_new_from_animation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_animation "GtkWidget* gtk_image_new_from_animation(GdkPixbufAnimation* animation)"
  s7_pointer animation;
  animation = s7_car(args);
  if (!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_animation", 1, animation, "GdkPixbufAnimation*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new_from_animation(s7_c_pointer(animation))));
}

static s7_pointer lg_gtk_image_set_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_file "void gtk_image_set_from_file(GtkImage* image, gchar* filename)"
  s7_pointer _p;
  s7_pointer image, filename;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_file", 1, image, "GtkImage*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_file", 2, filename, "gchar*");
  gtk_image_set_from_file(s7_c_pointer(image), s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_pixbuf "void gtk_image_set_from_pixbuf(GtkImage* image, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer image, pixbuf;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_pixbuf", 1, image, "GtkImage*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) && (pixbuf != lg_false)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_pixbuf", 2, pixbuf, "GdkPixbuf*");
  gtk_image_set_from_pixbuf(s7_c_pointer(image), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_from_animation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_animation "void gtk_image_set_from_animation(GtkImage* image, GdkPixbufAnimation* animation)"
  s7_pointer _p;
  s7_pointer image, animation;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_animation", 1, image, "GtkImage*");
  animation = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(animation, GdkPixbufAnimation__sym)) && (animation != lg_false)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_animation", 2, animation, "GdkPixbufAnimation*");
  gtk_image_set_from_animation(s7_c_pointer(image), s7_c_pointer(animation));
  return(lg_false);
}

static s7_pointer lg_gtk_image_get_storage_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_storage_type "GtkImageType gtk_image_get_storage_type(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_storage_type", 1, image, "GtkImage*");
  return(s7_make_integer(sc, gtk_image_get_storage_type(s7_c_pointer(image))));
}

static s7_pointer lg_gtk_image_get_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_pixbuf "GdkPixbuf* gtk_image_get_pixbuf(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_pixbuf", 1, image, "GtkImage*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_image_get_pixbuf(s7_c_pointer(image))));
}

static s7_pointer lg_gtk_image_get_animation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_animation "GdkPixbufAnimation* gtk_image_get_animation(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_animation", 1, image, "GtkImage*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbufAnimation__sym, gtk_image_get_animation(s7_c_pointer(image))));
}

static s7_pointer lg_gtk_im_context_get_preedit_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_get_preedit_string "void gtk_im_context_get_preedit_string(GtkIMContext* context, \
gchar** [str], PangoAttrList** [attrs], gint* [cursor_pos])"
  s7_pointer _p;
  s7_pointer context;
  gchar* ref_str = NULL;
  PangoAttrList* ref_attrs = NULL;
  gint ref_cursor_pos;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_get_preedit_string", 1, context, "GtkIMContext*");
  gtk_im_context_get_preedit_string(s7_c_pointer(context), &ref_str, &ref_attrs, &ref_cursor_pos);
    return(s7_list(sc, 3, s7_make_string(sc, ref_str), s7_make_c_pointer(sc, ref_attrs), s7_make_integer(sc, ref_cursor_pos)));
}

static s7_pointer lg_gtk_im_context_filter_keypress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_filter_keypress "gboolean gtk_im_context_filter_keypress(GtkIMContext* context, \
GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer context, event;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_filter_keypress", 1, context, "GtkIMContext*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_filter_keypress", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_im_context_filter_keypress(s7_c_pointer(context), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_im_context_focus_in(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_focus_in "void gtk_im_context_focus_in(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_focus_in", 1, context, "GtkIMContext*");
  gtk_im_context_focus_in(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_focus_out(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_focus_out "void gtk_im_context_focus_out(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_focus_out", 1, context, "GtkIMContext*");
  gtk_im_context_focus_out(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_reset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_reset "void gtk_im_context_reset(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_reset", 1, context, "GtkIMContext*");
  gtk_im_context_reset(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_cursor_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_cursor_location "void gtk_im_context_set_cursor_location(GtkIMContext* context, \
GdkRectangle* area)"
  s7_pointer _p;
  s7_pointer context, area;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_cursor_location", 1, context, "GtkIMContext*");
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_cursor_location", 2, area, "GdkRectangle*");
  gtk_im_context_set_cursor_location(s7_c_pointer(context), s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_use_preedit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_use_preedit "void gtk_im_context_set_use_preedit(GtkIMContext* context, \
gboolean use_preedit)"
  s7_pointer _p;
  s7_pointer context, use_preedit;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_use_preedit", 1, context, "GtkIMContext*");
  use_preedit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_preedit)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_use_preedit", 2, use_preedit, "gboolean");
  gtk_im_context_set_use_preedit(s7_c_pointer(context), lg_boolean(use_preedit));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_surrounding "void gtk_im_context_set_surrounding(GtkIMContext* context, \
gchar* text, gint len, gint cursor_index)"
  s7_pointer _p;
  s7_pointer context, text, len, cursor_index;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 1, context, "GtkIMContext*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 3, len, "gint");
  cursor_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(cursor_index)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 4, cursor_index, "gint");
  gtk_im_context_set_surrounding(s7_c_pointer(context), s7_string(text), s7_integer(len), s7_integer(cursor_index));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_get_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_get_surrounding "gboolean gtk_im_context_get_surrounding(GtkIMContext* context, \
gchar** [text], gint* [cursor_index])"
  s7_pointer _p;
  s7_pointer context;
  gchar* ref_text = NULL;
  gint ref_cursor_index;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_get_surrounding", 1, context, "GtkIMContext*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_im_context_get_surrounding(s7_c_pointer(context), &ref_text, &ref_cursor_index));
      return(s7_list(sc, 3, result, s7_make_string(sc, ref_text), s7_make_integer(sc, ref_cursor_index)));
   }
}

static s7_pointer lg_gtk_im_context_delete_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_delete_surrounding "gboolean gtk_im_context_delete_surrounding(GtkIMContext* context, \
gint offset, gint n_chars)"
  s7_pointer _p;
  s7_pointer context, offset, n_chars;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 1, context, "GtkIMContext*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 2, offset, "gint");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 3, n_chars, "gint");
  return(s7_make_boolean(sc, gtk_im_context_delete_surrounding(s7_c_pointer(context), s7_integer(offset), s7_integer(n_chars))));
}

static s7_pointer lg_gtk_im_context_simple_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_simple_new "GtkIMContext* gtk_im_context_simple_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkIMContext__sym, gtk_im_context_simple_new()));
}

static s7_pointer lg_gtk_im_context_simple_add_table(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_simple_add_table "void gtk_im_context_simple_add_table(GtkIMContextSimple* context_simple, \
guint16* data, gint max_seq_len, gint n_seqs)"
  s7_pointer _p;
  s7_pointer context_simple, data, max_seq_len, n_seqs;
  _p = args;
  context_simple = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context_simple, GtkIMContextSimple__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 1, context_simple, "GtkIMContextSimple*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guint16__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 2, data, "guint16*");
  max_seq_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_seq_len)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 3, max_seq_len, "gint");
  n_seqs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_seqs)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 4, n_seqs, "gint");
  gtk_im_context_simple_add_table(s7_c_pointer(context_simple), s7_c_pointer(data), s7_integer(max_seq_len), s7_integer(n_seqs));
  return(lg_false);
}

static s7_pointer lg_gtk_invisible_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_invisible_new "GtkWidget* gtk_invisible_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_invisible_new()));
}

static s7_pointer lg_gtk_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_new "GtkWidget* gtk_label_new(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_new", 1, str, "char*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_label_new((char*)s7_string(str))));
}

static s7_pointer lg_gtk_label_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_new_with_mnemonic "GtkWidget* gtk_label_new_with_mnemonic(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_new_with_mnemonic", 1, str, "char*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_label_new_with_mnemonic((char*)s7_string(str))));
}

static s7_pointer lg_gtk_label_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_text "void gtk_label_set_text(GtkLabel* label, char* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_text", 1, label, "GtkLabel*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_text", 2, str, "char*");
  gtk_label_set_text(s7_c_pointer(label), (char*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_text "gchar* gtk_label_get_text(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_text", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_text(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_attributes "void gtk_label_set_attributes(GtkLabel* label, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer label, attrs;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_attributes", 1, label, "GtkLabel*");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_attributes", 2, attrs, "PangoAttrList*");
  gtk_label_set_attributes(s7_c_pointer(label), s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_attributes "PangoAttrList* gtk_label_get_attributes(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_attributes", 1, label, "GtkLabel*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, gtk_label_get_attributes(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_label "void gtk_label_set_label(GtkLabel* label, gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_label", 1, label, "GtkLabel*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_label", 2, str, "gchar*");
  gtk_label_set_label(s7_c_pointer(label), s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_label "gchar* gtk_label_get_label(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_label", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_label(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_markup "void gtk_label_set_markup(GtkLabel* label, gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup", 1, label, "GtkLabel*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup", 2, str, "gchar*");
  gtk_label_set_markup(s7_c_pointer(label), s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_use_markup "void gtk_label_set_use_markup(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_markup", 1, label, "GtkLabel*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_markup", 2, setting, "gboolean");
  gtk_label_set_use_markup(s7_c_pointer(label), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_use_markup "gboolean gtk_label_get_use_markup(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_use_markup", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_use_markup(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_use_underline "void gtk_label_set_use_underline(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_underline", 1, label, "GtkLabel*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_underline", 2, setting, "gboolean");
  gtk_label_set_use_underline(s7_c_pointer(label), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_use_underline "gboolean gtk_label_get_use_underline(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_use_underline", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_use_underline(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_markup_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_markup_with_mnemonic "void gtk_label_set_markup_with_mnemonic(GtkLabel* label, \
gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup_with_mnemonic", 1, label, "GtkLabel*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup_with_mnemonic", 2, str, "gchar*");
  gtk_label_set_markup_with_mnemonic(s7_c_pointer(label), s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_mnemonic_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_mnemonic_keyval "guint gtk_label_get_mnemonic_keyval(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_mnemonic_keyval", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_mnemonic_keyval(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_mnemonic_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_mnemonic_widget "void gtk_label_set_mnemonic_widget(GtkLabel* label, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer label, widget;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_mnemonic_widget", 1, label, "GtkLabel*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_mnemonic_widget", 2, widget, "GtkWidget*");
  gtk_label_set_mnemonic_widget(s7_c_pointer(label), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_mnemonic_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_mnemonic_widget "GtkWidget* gtk_label_get_mnemonic_widget(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_mnemonic_widget", 1, label, "GtkLabel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_label_get_mnemonic_widget(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_text_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_text_with_mnemonic "void gtk_label_set_text_with_mnemonic(GtkLabel* label, \
gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_text_with_mnemonic", 1, label, "GtkLabel*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_text_with_mnemonic", 2, str, "gchar*");
  gtk_label_set_text_with_mnemonic(s7_c_pointer(label), s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_justify "void gtk_label_set_justify(GtkLabel* label, GtkJustification jtype)"
  s7_pointer _p;
  s7_pointer label, jtype;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_justify", 1, label, "GtkLabel*");
  jtype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(jtype)) s7_wrong_type_arg_error(sc, "gtk_label_set_justify", 2, jtype, "GtkJustification");
  gtk_label_set_justify(s7_c_pointer(label), s7_integer(jtype));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_justify "GtkJustification gtk_label_get_justify(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_justify", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_justify(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_pattern(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_pattern "void gtk_label_set_pattern(GtkLabel* label, gchar* pattern)"
  s7_pointer _p;
  s7_pointer label, pattern;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_pattern", 1, label, "GtkLabel*");
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(pattern)) s7_wrong_type_arg_error(sc, "gtk_label_set_pattern", 2, pattern, "gchar*");
  gtk_label_set_pattern(s7_c_pointer(label), s7_string(pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_line_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_line_wrap "void gtk_label_set_line_wrap(GtkLabel* label, gboolean wrap)"
  s7_pointer _p;
  s7_pointer label, wrap;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_line_wrap", 1, label, "GtkLabel*");
  wrap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(wrap)) s7_wrong_type_arg_error(sc, "gtk_label_set_line_wrap", 2, wrap, "gboolean");
  gtk_label_set_line_wrap(s7_c_pointer(label), lg_boolean(wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_line_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_line_wrap "gboolean gtk_label_get_line_wrap(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_line_wrap", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_line_wrap(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_selectable "void gtk_label_set_selectable(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_selectable", 1, label, "GtkLabel*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_selectable", 2, setting, "gboolean");
  gtk_label_set_selectable(s7_c_pointer(label), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_selectable "gboolean gtk_label_get_selectable(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_selectable", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_selectable(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_select_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_select_region "void gtk_label_select_region(GtkLabel* label, gint start_offset, \
gint end_offset)"
  s7_pointer _p;
  s7_pointer label, start_offset, end_offset;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 1, label, "GtkLabel*");
  start_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_offset)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 2, start_offset, "gint");
  end_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end_offset)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 3, end_offset, "gint");
  gtk_label_select_region(s7_c_pointer(label), s7_integer(start_offset), s7_integer(end_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_selection_bounds "gboolean gtk_label_get_selection_bounds(GtkLabel* label, \
gint* [start], gint* [end])"
  s7_pointer _p;
  s7_pointer label;
  gint ref_start;
  gint ref_end;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_selection_bounds", 1, label, "GtkLabel*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_label_get_selection_bounds(s7_c_pointer(label), &ref_start, &ref_end));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
   }
}

static s7_pointer lg_gtk_label_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_layout "PangoLayout* gtk_label_get_layout(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_layout", 1, label, "GtkLabel*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, gtk_label_get_layout(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_get_layout_offsets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_layout_offsets "void gtk_label_get_layout_offsets(GtkLabel* label, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer label;
  gint ref_x;
  gint ref_y;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_layout_offsets", 1, label, "GtkLabel*");
  gtk_label_get_layout_offsets(s7_c_pointer(label), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_new "GtkWidget* gtk_layout_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer hadjustment, vadjustment;
  _p = args;
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_layout_new", 1, hadjustment, "GtkAdjustment*");
  vadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) && (vadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_layout_new", 2, vadjustment, "GtkAdjustment*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_layout_new(s7_c_pointer(hadjustment), s7_c_pointer(vadjustment))));
}

static s7_pointer lg_gtk_layout_put(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_put "void gtk_layout_put(GtkLayout* layout, GtkWidget* child_widget, gint x, gint y)"
  s7_pointer _p;
  s7_pointer layout, child_widget, x, y;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_put", 1, layout, "GtkLayout*");
  child_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_put", 2, child_widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_layout_put", 3, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_layout_put", 4, y, "gint");
  gtk_layout_put(s7_c_pointer(layout), s7_c_pointer(child_widget), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_move(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_move "void gtk_layout_move(GtkLayout* layout, GtkWidget* child_widget, gint x, \
gint y)"
  s7_pointer _p;
  s7_pointer layout, child_widget, x, y;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_move", 1, layout, "GtkLayout*");
  child_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_move", 2, child_widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_layout_move", 3, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_layout_move", 4, y, "gint");
  gtk_layout_move(s7_c_pointer(layout), s7_c_pointer(child_widget), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_set_size "void gtk_layout_set_size(GtkLayout* layout, guint width, guint height)"
  s7_pointer _p;
  s7_pointer layout, width, height;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_set_size", 1, layout, "GtkLayout*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_layout_set_size", 2, width, "guint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_layout_set_size", 3, height, "guint");
  gtk_layout_set_size(s7_c_pointer(layout), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_get_size "void gtk_layout_get_size(GtkLayout* layout, guint* [width], guint* [height])"
  s7_pointer _p;
  s7_pointer layout;
  guint ref_width;
  guint ref_height;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_get_size", 1, layout, "GtkLayout*");
  gtk_layout_get_size(s7_c_pointer(layout), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_list_store_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_new "GtkListStore* gtk_list_store_new(gint n_columns, etc types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_new", 1, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(types)) s7_wrong_type_arg_error(sc, "gtk_list_store_new", 2, types, "etc");
  {
    int etc_len = 0;
    GtkListStore* result = NULL;
    gint p_arg0;
    if (s7_is_list(sc, types)) etc_len = s7_list_length(sc, types);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_list_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_list_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = (gint)s7_integer(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0))); break;
        case 2: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1))); break;
        case 3: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2))); break;
        case 4: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3))); break;
        case 5: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4))); break;
        case 6: result = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4)), s7_c_pointer(s7_list_ref(sc, types, 5))); break;
      }
    return(s7_make_c_pointer(sc, result));
  }
}

static s7_pointer lg_gtk_list_store_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_newv "GtkListStore* gtk_list_store_newv(gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_newv", 1, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_newv", 2, types, "GType*");
  return(s7_make_type_with_c_pointer(sc, GtkListStore__sym, gtk_list_store_newv(s7_integer(n_columns), s7_c_pointer(types))));
}

static s7_pointer lg_gtk_list_store_set_column_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_set_column_types "void gtk_list_store_set_column_types(GtkListStore* list_store, \
gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer list_store, n_columns, types;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 1, list_store, "GtkListStore*");
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 2, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 3, types, "GType*");
  gtk_list_store_set_column_types(s7_c_pointer(list_store), s7_integer(n_columns), s7_c_pointer(types));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_set "void gtk_list_store_set(GtkListStore* list_store, GtkTreeIter* iter, \
etc values)"
  s7_pointer _p;
  s7_pointer list_store, iter, values;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 2, iter, "GtkTreeIter*");
  values = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(values)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 3, values, "etc");
  {
    int etc_len = 0;
    GtkListStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (s7_is_list(sc, values)) etc_len = s7_list_length(sc, values);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = (GtkListStore*)s7_c_pointer(list_store);
    p_arg1 = (GtkTreeIter*)s7_c_pointer(iter);
    switch (etc_len)
      {
        case 2: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), -1); break;
        case 4: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), -1); break;
        case 6: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), -1); break;
        case 8: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), -1); break;
        case 10: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), s7_integer(s7_list_ref(sc, values, 8)), s7_string(s7_list_ref(sc, values, 9)), -1); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_list_store_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert "void gtk_list_store_insert(GtkListStore* list_store, GtkTreeIter* iter, \
gint position)"
  s7_pointer _p;
  s7_pointer list_store, iter, position;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 3, position, "gint");
  gtk_list_store_insert(s7_c_pointer(list_store), s7_c_pointer(iter), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_before "void gtk_list_store_insert_before(GtkListStore* list_store, \
GtkTreeIter* iter, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer list_store, iter, sibling;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 2, iter, "GtkTreeIter*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 3, sibling, "GtkTreeIter*");
  gtk_list_store_insert_before(s7_c_pointer(list_store), s7_c_pointer(iter), s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_after "void gtk_list_store_insert_after(GtkListStore* list_store, GtkTreeIter* iter, \
GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer list_store, iter, sibling;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 2, iter, "GtkTreeIter*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 3, sibling, "GtkTreeIter*");
  gtk_list_store_insert_after(s7_c_pointer(list_store), s7_c_pointer(iter), s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_prepend "void gtk_list_store_prepend(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_prepend", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_prepend", 2, iter, "GtkTreeIter*");
  gtk_list_store_prepend(s7_c_pointer(list_store), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_append "void gtk_list_store_append(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_append", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_append", 2, iter, "GtkTreeIter*");
  gtk_list_store_append(s7_c_pointer(list_store), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_clear "void gtk_list_store_clear(GtkListStore* list_store)"
  s7_pointer list_store;
  list_store = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_clear", 1, list_store, "GtkListStore*");
  gtk_list_store_clear(s7_c_pointer(list_store));
  return(lg_false);
}

static s7_pointer lg_gtk_check_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_version "gchar* gtk_check_version(guint required_major, guint required_minor, guint required_micro)"
  s7_pointer _p;
  s7_pointer required_major, required_minor, required_micro;
  _p = args;
  required_major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(required_major)) s7_wrong_type_arg_error(sc, "gtk_check_version", 1, required_major, "guint");
  required_minor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(required_minor)) s7_wrong_type_arg_error(sc, "gtk_check_version", 2, required_minor, "guint");
  required_micro = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(required_micro)) s7_wrong_type_arg_error(sc, "gtk_check_version", 3, required_micro, "guint");
    return(s7_make_string(sc, (gchar*)gtk_check_version(s7_integer(required_major), s7_integer(required_minor), s7_integer(required_micro))));
}

static s7_pointer lg_gtk_disable_setlocale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_disable_setlocale "void gtk_disable_setlocale( void)"
  gtk_disable_setlocale();
  return(lg_false);
}

static s7_pointer lg_gtk_get_default_language(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_default_language "PangoLanguage* gtk_get_default_language( void)"
  return(s7_make_type_with_c_pointer(sc, PangoLanguage__sym, gtk_get_default_language()));
}

static s7_pointer lg_gtk_events_pending(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_events_pending "gint gtk_events_pending( void)"
  return(s7_make_integer(sc, gtk_events_pending()));
}

static s7_pointer lg_gtk_main_do_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main_do_event "void gtk_main_do_event(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_main_do_event", 1, event, "GdkEvent*");
  gtk_main_do_event(s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gtk_main(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main "void gtk_main( void)"
  gtk_main();
  return(lg_false);
}

static s7_pointer lg_gtk_main_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main_level "guint gtk_main_level( void)"
  return(s7_make_integer(sc, gtk_main_level()));
}

static s7_pointer lg_gtk_main_quit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main_quit "void gtk_main_quit( void)"
  gtk_main_quit();
  return(lg_false);
}

static s7_pointer lg_gtk_main_iteration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main_iteration "gboolean gtk_main_iteration( void)"
  return(s7_make_boolean(sc, gtk_main_iteration()));
}

static s7_pointer lg_gtk_main_iteration_do(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_main_iteration_do "gboolean gtk_main_iteration_do(gboolean blocking)"
  s7_pointer blocking;
  blocking = s7_car(args);
  if (!s7_is_boolean(blocking)) s7_wrong_type_arg_error(sc, "gtk_main_iteration_do", 1, blocking, "gboolean");
  return(s7_make_boolean(sc, gtk_main_iteration_do(lg_boolean(blocking))));
}

static s7_pointer lg_gtk_true(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_true "gboolean gtk_true( void)"
  return(s7_make_boolean(sc, gtk_true()));
}

static s7_pointer lg_gtk_false(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_false "gboolean gtk_false( void)"
  return(s7_make_boolean(sc, gtk_false()));
}

static s7_pointer lg_gtk_grab_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grab_add "void gtk_grab_add(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grab_add", 1, widget, "GtkWidget*");
  gtk_grab_add(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_grab_get_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grab_get_current "GtkWidget* gtk_grab_get_current( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_grab_get_current()));
}

static s7_pointer lg_gtk_grab_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grab_remove "void gtk_grab_remove(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grab_remove", 1, widget, "GtkWidget*");
  gtk_grab_remove(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_get_current_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_current_event "GdkEvent* gtk_get_current_event( void)"
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gtk_get_current_event()));
}

static s7_pointer lg_gtk_get_current_event_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_current_event_time "guint32 gtk_get_current_event_time( void)"
  return(s7_make_integer(sc, gtk_get_current_event_time()));
}

static s7_pointer lg_gtk_get_current_event_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_current_event_state "gboolean gtk_get_current_event_state(GdkModifierType* [state])"
  GdkModifierType ref_state;
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_get_current_event_state(&ref_state));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_state)));
   }
}

static s7_pointer lg_gtk_get_event_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_event_widget "GtkWidget* gtk_get_event_widget(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gtk_get_event_widget", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_get_event_widget(s7_c_pointer(event))));
}

static s7_pointer lg_gtk_propagate_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_propagate_event "void gtk_propagate_event(GtkWidget* widget, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer widget, event;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_propagate_event", 1, widget, "GtkWidget*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_propagate_event", 2, event, "GdkEvent*");
  gtk_propagate_event(s7_c_pointer(widget), s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_new "GtkWidget* gtk_menu_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_bar_new()));
}

static s7_pointer lg_gtk_menu_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_new "GtkWidget* gtk_menu_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_new()));
}

static s7_pointer lg_gtk_menu_reposition(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_reposition "void gtk_menu_reposition(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_reposition", 1, menu, "GtkMenu*");
  gtk_menu_reposition(s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popdown "void gtk_menu_popdown(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popdown", 1, menu, "GtkMenu*");
  gtk_menu_popdown(s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_active "GtkWidget* gtk_menu_get_active(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_active", 1, menu, "GtkMenu*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_get_active(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_menu_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_active "void gtk_menu_set_active(GtkMenu* menu, guint index)"
  s7_pointer _p;
  s7_pointer menu, index;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_active", 1, menu, "GtkMenu*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_menu_set_active", 2, index, "guint");
  gtk_menu_set_active(s7_c_pointer(menu), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_set_accel_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_accel_group "void gtk_menu_set_accel_group(GtkMenu* menu, GtkAccelGroup* accel_group)"
  s7_pointer _p;
  s7_pointer menu, accel_group;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_accel_group", 1, menu, "GtkMenu*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) && (accel_group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_menu_set_accel_group", 2, accel_group, "GtkAccelGroup*");
  gtk_menu_set_accel_group(s7_c_pointer(menu), s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_get_accel_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_accel_group "GtkAccelGroup* gtk_menu_get_accel_group(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_accel_group", 1, menu, "GtkMenu*");
  return(s7_make_type_with_c_pointer(sc, GtkAccelGroup__sym, gtk_menu_get_accel_group(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_menu_set_accel_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_accel_path "void gtk_menu_set_accel_path(GtkMenu* menu, gchar* accel_path)"
  s7_pointer _p;
  s7_pointer menu, accel_path;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_accel_path", 1, menu, "GtkMenu*");
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_menu_set_accel_path", 2, accel_path, "gchar*");
  gtk_menu_set_accel_path(s7_c_pointer(menu), s7_string(accel_path));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_detach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_detach "void gtk_menu_detach(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_detach", 1, menu, "GtkMenu*");
  gtk_menu_detach(s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_get_attach_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_attach_widget "GtkWidget* gtk_menu_get_attach_widget(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_attach_widget", 1, menu, "GtkMenu*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_get_attach_widget(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_menu_reorder_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_reorder_child "void gtk_menu_reorder_child(GtkMenu* menu, GtkWidget* child, gint position)"
  s7_pointer _p;
  s7_pointer menu, child, position;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_reorder_child", 1, menu, "GtkMenu*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_reorder_child", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_menu_reorder_child", 3, position, "gint");
  gtk_menu_reorder_child(s7_c_pointer(menu), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_set_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_monitor "void gtk_menu_set_monitor(GtkMenu* menu, gint monitor_num)"
  s7_pointer _p;
  s7_pointer menu, monitor_num;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_monitor", 1, menu, "GtkMenu*");
  monitor_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(monitor_num)) s7_wrong_type_arg_error(sc, "gtk_menu_set_monitor", 2, monitor_num, "gint");
  gtk_menu_set_monitor(s7_c_pointer(menu), s7_integer(monitor_num));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_new "GtkWidget* gtk_menu_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_item_new()));
}

static s7_pointer lg_gtk_menu_item_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_new_with_label "GtkWidget* gtk_menu_item_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_menu_item_new_with_label", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_item_new_with_label(s7_string(label))));
}

static s7_pointer lg_gtk_menu_item_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_new_with_mnemonic "GtkWidget* gtk_menu_item_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_menu_item_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_item_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_menu_item_set_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_set_submenu "void gtk_menu_item_set_submenu(GtkMenuItem* menu_item, GtkWidget* submenu)"
  s7_pointer _p;
  s7_pointer menu_item, submenu;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_submenu", 1, menu_item, "GtkMenuItem*");
  submenu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(submenu, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_submenu", 2, submenu, "GtkWidget*");
  gtk_menu_item_set_submenu(s7_c_pointer(menu_item), s7_c_pointer(submenu));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_get_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_get_submenu "GtkWidget* gtk_menu_item_get_submenu(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_get_submenu", 1, menu_item, "GtkMenuItem*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_item_get_submenu(s7_c_pointer(menu_item))));
}

static s7_pointer lg_gtk_menu_item_select(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_select "void gtk_menu_item_select(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_select", 1, menu_item, "GtkMenuItem*");
  gtk_menu_item_select(s7_c_pointer(menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_deselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_deselect "void gtk_menu_item_deselect(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_deselect", 1, menu_item, "GtkMenuItem*");
  gtk_menu_item_deselect(s7_c_pointer(menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_activate "void gtk_menu_item_activate(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_activate", 1, menu_item, "GtkMenuItem*");
  gtk_menu_item_activate(s7_c_pointer(menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_toggle_size_request(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_toggle_size_request "void gtk_menu_item_toggle_size_request(GtkMenuItem* menu_item, \
gint* requisition)"
  s7_pointer _p;
  s7_pointer menu_item, requisition;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_toggle_size_request", 1, menu_item, "GtkMenuItem*");
  requisition = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(requisition, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_toggle_size_request", 2, requisition, "gint*");
  gtk_menu_item_toggle_size_request(s7_c_pointer(menu_item), s7_c_pointer(requisition));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_toggle_size_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_toggle_size_allocate "void gtk_menu_item_toggle_size_allocate(GtkMenuItem* menu_item, \
gint allocation)"
  s7_pointer _p;
  s7_pointer menu_item, allocation;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_toggle_size_allocate", 1, menu_item, "GtkMenuItem*");
  allocation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(allocation)) s7_wrong_type_arg_error(sc, "gtk_menu_item_toggle_size_allocate", 2, allocation, "gint");
  gtk_menu_item_toggle_size_allocate(s7_c_pointer(menu_item), s7_integer(allocation));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_set_accel_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_set_accel_path "void gtk_menu_item_set_accel_path(GtkMenuItem* menu_item, gchar* accel_path)"
  s7_pointer _p;
  s7_pointer menu_item, accel_path;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_accel_path", 1, menu_item, "GtkMenuItem*");
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_accel_path", 2, accel_path, "gchar*");
  gtk_menu_item_set_accel_path(s7_c_pointer(menu_item), s7_string(accel_path));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_append "void gtk_menu_shell_append(GtkMenuShell* menu_shell, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer menu_shell, child;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_append", 1, menu_shell, "GtkMenuShell*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_append", 2, child, "GtkWidget*");
  gtk_menu_shell_append(s7_c_pointer(menu_shell), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_prepend "void gtk_menu_shell_prepend(GtkMenuShell* menu_shell, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer menu_shell, child;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_prepend", 1, menu_shell, "GtkMenuShell*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_prepend", 2, child, "GtkWidget*");
  gtk_menu_shell_prepend(s7_c_pointer(menu_shell), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_insert "void gtk_menu_shell_insert(GtkMenuShell* menu_shell, GtkWidget* child, \
gint position)"
  s7_pointer _p;
  s7_pointer menu_shell, child, position;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_insert", 1, menu_shell, "GtkMenuShell*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_insert", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_insert", 3, position, "gint");
  gtk_menu_shell_insert(s7_c_pointer(menu_shell), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_deactivate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_deactivate "void gtk_menu_shell_deactivate(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_deactivate", 1, menu_shell, "GtkMenuShell*");
  gtk_menu_shell_deactivate(s7_c_pointer(menu_shell));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_select_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_select_item "void gtk_menu_shell_select_item(GtkMenuShell* menu_shell, GtkWidget* menu_item)"
  s7_pointer _p;
  s7_pointer menu_shell, menu_item;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_select_item", 1, menu_shell, "GtkMenuShell*");
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_select_item", 2, menu_item, "GtkWidget*");
  gtk_menu_shell_select_item(s7_c_pointer(menu_shell), s7_c_pointer(menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_deselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_deselect "void gtk_menu_shell_deselect(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_deselect", 1, menu_shell, "GtkMenuShell*");
  gtk_menu_shell_deselect(s7_c_pointer(menu_shell));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_activate_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_activate_item "void gtk_menu_shell_activate_item(GtkMenuShell* menu_shell, \
GtkWidget* menu_item, gboolean force_deactivate)"
  s7_pointer _p;
  s7_pointer menu_shell, menu_item, force_deactivate;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_activate_item", 1, menu_shell, "GtkMenuShell*");
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_activate_item", 2, menu_item, "GtkWidget*");
  force_deactivate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(force_deactivate)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_activate_item", 3, force_deactivate, "gboolean");
  gtk_menu_shell_activate_item(s7_c_pointer(menu_shell), s7_c_pointer(menu_item), lg_boolean(force_deactivate));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_new "GtkWidget* gtk_notebook_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_notebook_new()));
}

static s7_pointer lg_gtk_notebook_remove_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_remove_page "void gtk_notebook_remove_page(GtkNotebook* notebook, gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_remove_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_remove_page", 2, page_num, "gint");
  gtk_notebook_remove_page(s7_c_pointer(notebook), s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_current_page "gint gtk_notebook_get_current_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_current_page", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_current_page(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_get_nth_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_nth_page "GtkWidget* gtk_notebook_get_nth_page(GtkNotebook* notebook, gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_nth_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_nth_page", 2, page_num, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_notebook_get_nth_page(s7_c_pointer(notebook), s7_integer(page_num))));
}

static s7_pointer lg_gtk_notebook_page_num(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_page_num "gint gtk_notebook_page_num(GtkNotebook* notebook, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_page_num", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_page_num", 2, child, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_page_num(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_current_page "void gtk_notebook_set_current_page(GtkNotebook* notebook, \
gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_current_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_current_page", 2, page_num, "gint");
  gtk_notebook_set_current_page(s7_c_pointer(notebook), s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_next_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_next_page "void gtk_notebook_next_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_next_page", 1, notebook, "GtkNotebook*");
  gtk_notebook_next_page(s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_prev_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prev_page "void gtk_notebook_prev_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prev_page", 1, notebook, "GtkNotebook*");
  gtk_notebook_prev_page(s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_show_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_show_border "void gtk_notebook_set_show_border(GtkNotebook* notebook, gboolean show_border)"
  s7_pointer _p;
  s7_pointer notebook, show_border;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_border", 1, notebook, "GtkNotebook*");
  show_border = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_border)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_border", 2, show_border, "gboolean");
  gtk_notebook_set_show_border(s7_c_pointer(notebook), lg_boolean(show_border));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_show_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_show_border "gboolean gtk_notebook_get_show_border(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_show_border", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_show_border(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_show_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_show_tabs "void gtk_notebook_set_show_tabs(GtkNotebook* notebook, gboolean show_tabs)"
  s7_pointer _p;
  s7_pointer notebook, show_tabs;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_tabs", 1, notebook, "GtkNotebook*");
  show_tabs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_tabs)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_tabs", 2, show_tabs, "gboolean");
  gtk_notebook_set_show_tabs(s7_c_pointer(notebook), lg_boolean(show_tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_show_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_show_tabs "gboolean gtk_notebook_get_show_tabs(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_show_tabs", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_show_tabs(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_tab_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_pos "void gtk_notebook_set_tab_pos(GtkNotebook* notebook, GtkPositionType pos)"
  s7_pointer _p;
  s7_pointer notebook, pos;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_pos", 1, notebook, "GtkNotebook*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_pos", 2, pos, "GtkPositionType");
  gtk_notebook_set_tab_pos(s7_c_pointer(notebook), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_pos "GtkPositionType gtk_notebook_get_tab_pos(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_pos", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_tab_pos(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_scrollable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_scrollable "void gtk_notebook_set_scrollable(GtkNotebook* notebook, gboolean scrollable)"
  s7_pointer _p;
  s7_pointer notebook, scrollable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_scrollable", 1, notebook, "GtkNotebook*");
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(scrollable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_scrollable", 2, scrollable, "gboolean");
  gtk_notebook_set_scrollable(s7_c_pointer(notebook), lg_boolean(scrollable));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_scrollable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_scrollable "gboolean gtk_notebook_get_scrollable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_scrollable", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_scrollable(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_popup_enable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_popup_enable "void gtk_notebook_popup_enable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_popup_enable", 1, notebook, "GtkNotebook*");
  gtk_notebook_popup_enable(s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_popup_disable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_popup_disable "void gtk_notebook_popup_disable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_popup_disable", 1, notebook, "GtkNotebook*");
  gtk_notebook_popup_disable(s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_label "GtkWidget* gtk_notebook_get_tab_label(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label", 2, child, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_notebook_get_tab_label(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_label "void gtk_notebook_set_tab_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 3, tab_label, "GtkWidget*");
  gtk_notebook_set_tab_label(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_tab_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_label_text "void gtk_notebook_set_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* tab_text)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_text;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 2, child, "GtkWidget*");
  tab_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tab_text)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 3, tab_text, "gchar*");
  gtk_notebook_set_tab_label_text(s7_c_pointer(notebook), s7_c_pointer(child), s7_string(tab_text));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_label_text "gchar* gtk_notebook_get_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label_text", 2, child, "GtkWidget*");
  return(s7_make_string(sc, gtk_notebook_get_tab_label_text(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_get_menu_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_menu_label "GtkWidget* gtk_notebook_get_menu_label(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label", 2, child, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_notebook_get_menu_label(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_menu_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_menu_label "void gtk_notebook_set_menu_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 2, child, "GtkWidget*");
  menu_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 3, menu_label, "GtkWidget*");
  gtk_notebook_set_menu_label(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(menu_label));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_menu_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_menu_label_text "void gtk_notebook_set_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* menu_text)"
  s7_pointer _p;
  s7_pointer notebook, child, menu_text;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 2, child, "GtkWidget*");
  menu_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(menu_text)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 3, menu_text, "gchar*");
  gtk_notebook_set_menu_label_text(s7_c_pointer(notebook), s7_c_pointer(child), s7_string(menu_text));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_menu_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_menu_label_text "gchar* gtk_notebook_get_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label_text", 2, child, "GtkWidget*");
  return(s7_make_string(sc, gtk_notebook_get_menu_label_text(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_reorder_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_reorder_child "void gtk_notebook_reorder_child(GtkNotebook* notebook, GtkWidget* child, \
gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 3, position, "gint");
  gtk_notebook_reorder_child(s7_c_pointer(notebook), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_append_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_append_page "gint gtk_notebook_append_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 3, tab_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_append_page(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label))));
}

static s7_pointer lg_gtk_notebook_append_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_append_page_menu "gint gtk_notebook_append_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 4, menu_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_append_page_menu(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label), s7_c_pointer(menu_label))));
}

static s7_pointer lg_gtk_notebook_prepend_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prepend_page "gint gtk_notebook_prepend_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 3, tab_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_prepend_page(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label))));
}

static s7_pointer lg_gtk_notebook_prepend_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prepend_page_menu "gint gtk_notebook_prepend_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 4, menu_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_prepend_page_menu(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label), s7_c_pointer(menu_label))));
}

static s7_pointer lg_gtk_notebook_insert_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_insert_page "gint gtk_notebook_insert_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label, gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 3, tab_label, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 4, position, "gint");
  return(s7_make_integer(sc, gtk_notebook_insert_page(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label), s7_integer(position))));
}

static s7_pointer lg_gtk_notebook_insert_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_insert_page_menu "gint gtk_notebook_insert_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label, gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 4, menu_label, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 5, position, "gint");
  return(s7_make_integer(sc, gtk_notebook_insert_page_menu(s7_c_pointer(notebook), s7_c_pointer(child), s7_c_pointer(tab_label), s7_c_pointer(menu_label), s7_integer(position))));
}

static s7_pointer lg_gtk_paned_add1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_add1 "void gtk_paned_add1(GtkPaned* paned, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer paned, child;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add1", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add1", 2, child, "GtkWidget*");
  gtk_paned_add1(s7_c_pointer(paned), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_add2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_add2 "void gtk_paned_add2(GtkPaned* paned, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer paned, child;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add2", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add2", 2, child, "GtkWidget*");
  gtk_paned_add2(s7_c_pointer(paned), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_pack1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_pack1 "void gtk_paned_pack1(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  s7_pointer _p;
  s7_pointer paned, child, resize, shrink;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 2, child, "GtkWidget*");
  resize = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resize)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 3, resize, "gboolean");
  shrink = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(shrink)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 4, shrink, "gboolean");
  gtk_paned_pack1(s7_c_pointer(paned), s7_c_pointer(child), lg_boolean(resize), lg_boolean(shrink));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_pack2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_pack2 "void gtk_paned_pack2(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  s7_pointer _p;
  s7_pointer paned, child, resize, shrink;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 2, child, "GtkWidget*");
  resize = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resize)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 3, resize, "gboolean");
  shrink = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(shrink)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 4, shrink, "gboolean");
  gtk_paned_pack2(s7_c_pointer(paned), s7_c_pointer(child), lg_boolean(resize), lg_boolean(shrink));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_position "gint gtk_paned_get_position(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_position", 1, paned, "GtkPaned*");
  return(s7_make_integer(sc, gtk_paned_get_position(s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_paned_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_set_position "void gtk_paned_set_position(GtkPaned* paned, gint position)"
  s7_pointer _p;
  s7_pointer paned, position;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_set_position", 1, paned, "GtkPaned*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_paned_set_position", 2, position, "gint");
  gtk_paned_set_position(s7_c_pointer(paned), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_new "GtkWidget* gtk_progress_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_progress_bar_new()));
}

static s7_pointer lg_gtk_progress_bar_pulse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_pulse "void gtk_progress_bar_pulse(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_pulse", 1, pbar, "GtkProgressBar*");
  gtk_progress_bar_pulse(s7_c_pointer(pbar));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_text "void gtk_progress_bar_set_text(GtkProgressBar* pbar, gchar* text)"
  s7_pointer _p;
  s7_pointer pbar, text;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_text", 1, pbar, "GtkProgressBar*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_text", 2, text, "gchar*");
  gtk_progress_bar_set_text(s7_c_pointer(pbar), s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_fraction "void gtk_progress_bar_set_fraction(GtkProgressBar* pbar, gdouble fraction)"
  s7_pointer _p;
  s7_pointer pbar, fraction;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_fraction", 1, pbar, "GtkProgressBar*");
  fraction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_fraction", 2, fraction, "gdouble");
  gtk_progress_bar_set_fraction(s7_c_pointer(pbar), s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_pulse_step "void gtk_progress_bar_set_pulse_step(GtkProgressBar* pbar, \
gdouble fraction)"
  s7_pointer _p;
  s7_pointer pbar, fraction;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_pulse_step", 1, pbar, "GtkProgressBar*");
  fraction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_pulse_step", 2, fraction, "gdouble");
  gtk_progress_bar_set_pulse_step(s7_c_pointer(pbar), s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_text "gchar* gtk_progress_bar_get_text(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_text", 1, pbar, "GtkProgressBar*");
  return(s7_make_string(sc, gtk_progress_bar_get_text(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_progress_bar_get_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_fraction "gdouble gtk_progress_bar_get_fraction(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_fraction", 1, pbar, "GtkProgressBar*");
  return(s7_make_real(sc, gtk_progress_bar_get_fraction(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_progress_bar_get_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_pulse_step "gdouble gtk_progress_bar_get_pulse_step(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_pulse_step", 1, pbar, "GtkProgressBar*");
  return(s7_make_real(sc, gtk_progress_bar_get_pulse_step(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_radio_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new "GtkWidget* gtk_radio_button_new(GSList* group)"
  s7_pointer group;
  group = s7_car(args);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new", 1, group, "GSList*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_button_new_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_from_widget "GtkWidget* gtk_radio_button_new_from_widget(GtkRadioButton* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_from_widget", 1, group, "GtkRadioButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new_from_widget(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_label "GtkWidget* gtk_radio_button_new_with_label(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label", 1, group, "GSList*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new_with_label(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_label_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_label_from_widget "GtkWidget* gtk_radio_button_new_with_label_from_widget(GtkRadioButton* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label_from_widget", 1, group, "GtkRadioButton*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label_from_widget", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new_with_label_from_widget(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_mnemonic "GtkWidget* gtk_radio_button_new_with_mnemonic(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic", 1, group, "GSList*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new_with_mnemonic(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_mnemonic_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_button_new_with_mnemonic_from_widget(GtkRadioButton* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic_from_widget", 1, group, "GtkRadioButton*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic_from_widget", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_button_new_with_mnemonic_from_widget(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_get_group "GSList* gtk_radio_button_get_group(GtkRadioButton* radio_button)"
  s7_pointer radio_button;
  radio_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_get_group", 1, radio_button, "GtkRadioButton*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_radio_button_get_group(s7_c_pointer(radio_button))));
}

static s7_pointer lg_gtk_radio_button_set_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_set_group "void gtk_radio_button_set_group(GtkRadioButton* radio_button, \
GSList* group)"
  s7_pointer _p;
  s7_pointer radio_button, group;
  _p = args;
  radio_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_set_group", 1, radio_button, "GtkRadioButton*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_set_group", 2, group, "GSList*");
  gtk_radio_button_set_group(s7_c_pointer(radio_button), s7_c_pointer(group));
  return(lg_false);
}

static s7_pointer lg_gtk_radio_menu_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new "GtkWidget* gtk_radio_menu_item_new(GSList* group)"
  s7_pointer group;
  group = s7_car(args);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new", 1, group, "GSList*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_menu_item_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new_with_label "GtkWidget* gtk_radio_menu_item_new_with_label(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_label", 1, group, "GSList*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_label", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new_with_label(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_menu_item_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic "GtkWidget* gtk_radio_menu_item_new_with_mnemonic(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_mnemonic", 1, group, "GSList*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_mnemonic", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new_with_mnemonic(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_menu_item_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_get_group "GSList* gtk_radio_menu_item_get_group(GtkRadioMenuItem* radio_menu_item)"
  s7_pointer radio_menu_item;
  radio_menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(radio_menu_item, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_get_group", 1, radio_menu_item, "GtkRadioMenuItem*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_radio_menu_item_get_group(s7_c_pointer(radio_menu_item))));
}

static s7_pointer lg_gtk_radio_menu_item_set_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_set_group "void gtk_radio_menu_item_set_group(GtkRadioMenuItem* radio_menu_item, \
GSList* group)"
  s7_pointer _p;
  s7_pointer radio_menu_item, group;
  _p = args;
  radio_menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_menu_item, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_set_group", 1, radio_menu_item, "GtkRadioMenuItem*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_set_group", 2, group, "GSList*");
  gtk_radio_menu_item_set_group(s7_c_pointer(radio_menu_item), s7_c_pointer(group));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_adjustment "void gtk_range_set_adjustment(GtkRange* range, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer range, adjustment;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_adjustment", 1, range, "GtkRange*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_range_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_range_set_adjustment(s7_c_pointer(range), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_adjustment "GtkAdjustment* gtk_range_get_adjustment(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_adjustment", 1, range, "GtkRange*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_range_get_adjustment(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_inverted "void gtk_range_set_inverted(GtkRange* range, gboolean setting)"
  s7_pointer _p;
  s7_pointer range, setting;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_inverted", 1, range, "GtkRange*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_range_set_inverted", 2, setting, "gboolean");
  gtk_range_set_inverted(s7_c_pointer(range), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_inverted "gboolean gtk_range_get_inverted(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_inverted", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_inverted(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_increments "void gtk_range_set_increments(GtkRange* range, gdouble step, gdouble page)"
  s7_pointer _p;
  s7_pointer range, step, page;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 1, range, "GtkRange*");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 2, step, "gdouble");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 3, page, "gdouble");
  gtk_range_set_increments(s7_c_pointer(range), s7_real(step), s7_real(page));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_range "void gtk_range_set_range(GtkRange* range, gdouble min, gdouble max)"
  s7_pointer _p;
  s7_pointer range, min, max;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 1, range, "GtkRange*");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 2, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 3, max, "gdouble");
  gtk_range_set_range(s7_c_pointer(range), s7_real(min), s7_real(max));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_value "void gtk_range_set_value(GtkRange* range, gdouble value)"
  s7_pointer _p;
  s7_pointer range, value;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_value", 1, range, "GtkRange*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_range_set_value", 2, value, "gdouble");
  gtk_range_set_value(s7_c_pointer(range), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_value "gdouble gtk_range_get_value(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_value", 1, range, "GtkRange*");
  return(s7_make_real(sc, gtk_range_get_value(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_scale_set_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_digits "void gtk_scale_set_digits(GtkScale* scale, gint digits)"
  s7_pointer _p;
  s7_pointer scale, digits;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_digits", 1, scale, "GtkScale*");
  digits = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_scale_set_digits", 2, digits, "gint");
  gtk_scale_set_digits(s7_c_pointer(scale), s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_digits "gint gtk_scale_get_digits(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_digits", 1, scale, "GtkScale*");
  return(s7_make_integer(sc, gtk_scale_get_digits(s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_set_draw_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_draw_value "void gtk_scale_set_draw_value(GtkScale* scale, gboolean draw_value)"
  s7_pointer _p;
  s7_pointer scale, draw_value;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_draw_value", 1, scale, "GtkScale*");
  draw_value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(draw_value)) s7_wrong_type_arg_error(sc, "gtk_scale_set_draw_value", 2, draw_value, "gboolean");
  gtk_scale_set_draw_value(s7_c_pointer(scale), lg_boolean(draw_value));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_draw_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_draw_value "gboolean gtk_scale_get_draw_value(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_draw_value", 1, scale, "GtkScale*");
  return(s7_make_boolean(sc, gtk_scale_get_draw_value(s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_set_value_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_value_pos "void gtk_scale_set_value_pos(GtkScale* scale, GtkPositionType pos)"
  s7_pointer _p;
  s7_pointer scale, pos;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_value_pos", 1, scale, "GtkScale*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_scale_set_value_pos", 2, pos, "GtkPositionType");
  gtk_scale_set_value_pos(s7_c_pointer(scale), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_value_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_value_pos "GtkPositionType gtk_scale_get_value_pos(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_value_pos", 1, scale, "GtkScale*");
  return(s7_make_integer(sc, gtk_scale_get_value_pos(s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scrolled_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_new "GtkWidget* gtk_scrolled_window_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer hadjustment, vadjustment;
  _p = args;
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_new", 1, hadjustment, "GtkAdjustment*");
  vadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) && (vadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_new", 2, vadjustment, "GtkAdjustment*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scrolled_window_new(s7_c_pointer(hadjustment), s7_c_pointer(vadjustment))));
}

static s7_pointer lg_gtk_scrolled_window_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_hadjustment "void gtk_scrolled_window_set_hadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrolled_window, hadjustment;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_hadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_hadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrolled_window_set_hadjustment(s7_c_pointer(scrolled_window), s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_vadjustment "void gtk_scrolled_window_set_vadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrolled_window, hadjustment;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_vadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_vadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrolled_window_set_vadjustment(s7_c_pointer(scrolled_window), s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_hadjustment "GtkAdjustment* gtk_scrolled_window_get_hadjustment(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_hadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_scrolled_window_get_hadjustment(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_get_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_vadjustment "GtkAdjustment* gtk_scrolled_window_get_vadjustment(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_vadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_scrolled_window_get_vadjustment(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_policy "void gtk_scrolled_window_set_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType hscrollbar_policy, GtkPolicyType vscrollbar_policy)"
  s7_pointer _p;
  s7_pointer scrolled_window, hscrollbar_policy, vscrollbar_policy;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 1, scrolled_window, "GtkScrolledWindow*");
  hscrollbar_policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hscrollbar_policy)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 2, hscrollbar_policy, "GtkPolicyType");
  vscrollbar_policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(vscrollbar_policy)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 3, vscrollbar_policy, "GtkPolicyType");
  gtk_scrolled_window_set_policy(s7_c_pointer(scrolled_window), s7_integer(hscrollbar_policy), s7_integer(vscrollbar_policy));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_policy "void gtk_scrolled_window_get_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType* [hscrollbar_policy], GtkPolicyType* [vscrollbar_policy])"
  s7_pointer _p;
  s7_pointer scrolled_window;
  GtkPolicyType ref_hscrollbar_policy;
  GtkPolicyType ref_vscrollbar_policy;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_policy", 1, scrolled_window, "GtkScrolledWindow*");
  gtk_scrolled_window_get_policy(s7_c_pointer(scrolled_window), &ref_hscrollbar_policy, &ref_vscrollbar_policy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_hscrollbar_policy), s7_make_integer(sc, ref_vscrollbar_policy)));
}

static s7_pointer lg_gtk_scrolled_window_set_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_placement "void gtk_scrolled_window_set_placement(GtkScrolledWindow* scrolled_window, \
GtkCornerType window_placement)"
  s7_pointer _p;
  s7_pointer scrolled_window, window_placement;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_placement", 1, scrolled_window, "GtkScrolledWindow*");
  window_placement = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(window_placement)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_placement", 2, window_placement, "GtkCornerType");
  gtk_scrolled_window_set_placement(s7_c_pointer(scrolled_window), s7_integer(window_placement));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_placement "GtkCornerType gtk_scrolled_window_get_placement(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_placement", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_placement(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_shadow_type "void gtk_scrolled_window_set_shadow_type(GtkScrolledWindow* scrolled_window, \
GtkShadowType type)"
  s7_pointer _p;
  s7_pointer scrolled_window, type;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_shadow_type", 1, scrolled_window, "GtkScrolledWindow*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_shadow_type", 2, type, "GtkShadowType");
  gtk_scrolled_window_set_shadow_type(s7_c_pointer(scrolled_window), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_shadow_type "GtkShadowType gtk_scrolled_window_get_shadow_type(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_shadow_type", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_shadow_type(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_target_list_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_new "GtkTargetList* gtk_target_list_new(GtkTargetEntry* targets, guint ntargets)"
  s7_pointer _p;
  s7_pointer targets, ntargets;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) && (targets != lg_false)) s7_wrong_type_arg_error(sc, "gtk_target_list_new", 1, targets, "GtkTargetEntry*");
  ntargets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ntargets)) s7_wrong_type_arg_error(sc, "gtk_target_list_new", 2, ntargets, "guint");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_target_list_new(s7_c_pointer(targets), s7_integer(ntargets))));
}

static s7_pointer lg_gtk_target_list_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_unref "void gtk_target_list_unref(GtkTargetList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_unref", 1, list, "GtkTargetList*");
  gtk_target_list_unref(s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add "void gtk_target_list_add(GtkTargetList* list, GdkAtom target, guint flags, \
guint info)"
  s7_pointer _p;
  s7_pointer list, target, flags, info;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add", 1, list, "GtkTargetList*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add", 2, target, "GdkAtom");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_target_list_add", 3, flags, "guint");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_list_add", 4, info, "guint");
  gtk_target_list_add(s7_c_pointer(list), s7_c_pointer(target), s7_integer(flags), s7_integer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_add_table(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add_table "void gtk_target_list_add_table(GtkTargetList* list, GtkTargetEntry* targets, \
guint ntargets)"
  s7_pointer _p;
  s7_pointer list, targets, ntargets;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_table", 1, list, "GtkTargetList*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_table", 2, targets, "GtkTargetEntry*");
  ntargets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ntargets)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_table", 3, ntargets, "guint");
  gtk_target_list_add_table(s7_c_pointer(list), s7_c_pointer(targets), s7_integer(ntargets));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_remove "void gtk_target_list_remove(GtkTargetList* list, GdkAtom target)"
  s7_pointer _p;
  s7_pointer list, target;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_remove", 1, list, "GtkTargetList*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_remove", 2, target, "GdkAtom");
  gtk_target_list_remove(s7_c_pointer(list), s7_c_pointer(target));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_find(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_find "gboolean gtk_target_list_find(GtkTargetList* list, GdkAtom target, \
guint* [info])"
  s7_pointer _p;
  s7_pointer list, target;
  guint ref_info;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_find", 1, list, "GtkTargetList*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_find", 2, target, "GdkAtom");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_target_list_find(s7_c_pointer(list), s7_c_pointer(target), &ref_info));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_info)));
   }
}

static s7_pointer lg_gtk_selection_owner_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_owner_set "gboolean gtk_selection_owner_set(GtkWidget* widget, GdkAtom selection, \
guint32 time)"
  s7_pointer _p;
  s7_pointer widget, selection, time;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) && (widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set", 2, selection, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set", 3, time, "guint32");
  return(s7_make_boolean(sc, gtk_selection_owner_set(s7_c_pointer(widget), s7_c_pointer(selection), s7_integer(time))));
}

static s7_pointer lg_gtk_selection_add_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_add_target "void gtk_selection_add_target(GtkWidget* widget, GdkAtom selection, \
GdkAtom target, guint info)"
  s7_pointer _p;
  s7_pointer widget, selection, target, info;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_target", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_target", 2, selection, "GdkAtom");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_target", 3, target, "GdkAtom");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_selection_add_target", 4, info, "guint");
  gtk_selection_add_target(s7_c_pointer(widget), s7_c_pointer(selection), s7_c_pointer(target), s7_integer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_add_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_add_targets "void gtk_selection_add_targets(GtkWidget* widget, GdkAtom selection, \
GtkTargetEntry* targets, guint ntargets)"
  s7_pointer _p;
  s7_pointer widget, selection, targets, ntargets;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_targets", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_targets", 2, selection, "GdkAtom");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_add_targets", 3, targets, "GtkTargetEntry*");
  ntargets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ntargets)) s7_wrong_type_arg_error(sc, "gtk_selection_add_targets", 4, ntargets, "guint");
  gtk_selection_add_targets(s7_c_pointer(widget), s7_c_pointer(selection), s7_c_pointer(targets), s7_integer(ntargets));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_clear_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_clear_targets "void gtk_selection_clear_targets(GtkWidget* widget, GdkAtom selection)"
  s7_pointer _p;
  s7_pointer widget, selection;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_clear_targets", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_clear_targets", 2, selection, "GdkAtom");
  gtk_selection_clear_targets(s7_c_pointer(widget), s7_c_pointer(selection));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_convert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_convert "gboolean gtk_selection_convert(GtkWidget* widget, GdkAtom selection, \
GdkAtom target, guint32 time)"
  s7_pointer _p;
  s7_pointer widget, selection, target, time;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_convert", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_convert", 2, selection, "GdkAtom");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_convert", 3, target, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gtk_selection_convert", 4, time, "guint32");
  return(s7_make_boolean(sc, gtk_selection_convert(s7_c_pointer(widget), s7_c_pointer(selection), s7_c_pointer(target), s7_integer(time))));
}

static s7_pointer lg_gtk_selection_data_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_set "void gtk_selection_data_set(GtkSelectionData* selection_data, GdkAtom type, \
gint format, guchar* data, gint length)"
  s7_pointer _p;
  s7_pointer selection_data, type, format, data, length;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set", 1, selection_data, "GtkSelectionData*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(type, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set", 2, type, "GdkAtom");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set", 3, format, "gint");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set", 4, data, "guchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set", 5, length, "gint");
  gtk_selection_data_set(s7_c_pointer(selection_data), s7_c_pointer(type), s7_integer(format), s7_c_pointer(data), s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_data_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_set_text "gboolean gtk_selection_data_set_text(GtkSelectionData* selection_data, \
gchar* str, gint len)"
  s7_pointer _p;
  s7_pointer selection_data, str, len;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_text", 1, selection_data, "GtkSelectionData*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_text", 2, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_text", 3, len, "gint");
  return(s7_make_boolean(sc, gtk_selection_data_set_text(s7_c_pointer(selection_data), s7_string(str), s7_integer(len))));
}

static s7_pointer lg_gtk_selection_data_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_text "guchar* gtk_selection_data_get_text(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_text", 1, selection_data, "GtkSelectionData*");
  {
    guchar* result;
    s7_pointer rtn;
    result = gtk_selection_data_get_text(s7_c_pointer(selection_data));
    rtn = s7_make_c_pointer(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_selection_data_get_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_targets "gboolean gtk_selection_data_get_targets(GtkSelectionData* selection_data, \
GdkAtom** [targets], gint* [n_atoms])"
  s7_pointer _p;
  s7_pointer selection_data;
  GdkAtom* ref_targets = NULL;
  gint ref_n_atoms;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_targets", 1, selection_data, "GtkSelectionData*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_selection_data_get_targets(s7_c_pointer(selection_data), &ref_targets, &ref_n_atoms));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_targets), s7_make_integer(sc, ref_n_atoms)));
   }
}

static s7_pointer lg_gtk_selection_data_targets_include_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_targets_include_text "gboolean gtk_selection_data_targets_include_text(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_text", 1, selection_data, "GtkSelectionData*");
  return(s7_make_boolean(sc, gtk_selection_data_targets_include_text(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_remove_all "void gtk_selection_remove_all(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_remove_all", 1, widget, "GtkWidget*");
  gtk_selection_remove_all(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_data_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_copy "GtkSelectionData* gtk_selection_data_copy(GtkSelectionData* data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_copy", 1, data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GtkSelectionData__sym, gtk_selection_data_copy(s7_c_pointer(data))));
}

static s7_pointer lg_gtk_selection_data_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_free "void gtk_selection_data_free(GtkSelectionData* data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_free", 1, data, "GtkSelectionData*");
  gtk_selection_data_free(s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gtk_separator_menu_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_menu_item_new "GtkWidget* gtk_separator_menu_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_separator_menu_item_new()));
}

static s7_pointer lg_gtk_settings_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_get_default "GtkSettings* gtk_settings_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GtkSettings__sym, gtk_settings_get_default()));
}

static s7_pointer lg_gtk_size_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_new "GtkSizeGroup* gtk_size_group_new(GtkSizeGroupMode mode)"
  s7_pointer mode;
  mode = s7_car(args);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_size_group_new", 1, mode, "GtkSizeGroupMode");
  return(s7_make_type_with_c_pointer(sc, GtkSizeGroup__sym, gtk_size_group_new(s7_integer(mode))));
}

static s7_pointer lg_gtk_size_group_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_set_mode "void gtk_size_group_set_mode(GtkSizeGroup* size_group, GtkSizeGroupMode mode)"
  s7_pointer _p;
  s7_pointer size_group, mode;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_set_mode", 1, size_group, "GtkSizeGroup*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_size_group_set_mode", 2, mode, "GtkSizeGroupMode");
  gtk_size_group_set_mode(s7_c_pointer(size_group), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_size_group_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_get_mode "GtkSizeGroupMode gtk_size_group_get_mode(GtkSizeGroup* size_group)"
  s7_pointer size_group;
  size_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_get_mode", 1, size_group, "GtkSizeGroup*");
  return(s7_make_integer(sc, gtk_size_group_get_mode(s7_c_pointer(size_group))));
}

static s7_pointer lg_gtk_size_group_add_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_add_widget "void gtk_size_group_add_widget(GtkSizeGroup* size_group, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer size_group, widget;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_add_widget", 1, size_group, "GtkSizeGroup*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_add_widget", 2, widget, "GtkWidget*");
  gtk_size_group_add_widget(s7_c_pointer(size_group), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_size_group_remove_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_remove_widget "void gtk_size_group_remove_widget(GtkSizeGroup* size_group, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer size_group, widget;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_remove_widget", 1, size_group, "GtkSizeGroup*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_remove_widget", 2, widget, "GtkWidget*");
  gtk_size_group_remove_widget(s7_c_pointer(size_group), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_configure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_configure "void gtk_spin_button_configure(GtkSpinButton* spin_button, GtkAdjustment* adjustment, \
gdouble climb_rate, guint digits)"
  s7_pointer _p;
  s7_pointer spin_button, adjustment, climb_rate, digits;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 1, spin_button, "GtkSpinButton*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 2, adjustment, "GtkAdjustment*");
  climb_rate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(climb_rate)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 3, climb_rate, "gdouble");
  digits = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 4, digits, "guint");
  gtk_spin_button_configure(s7_c_pointer(spin_button), s7_c_pointer(adjustment), s7_real(climb_rate), s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_new "GtkWidget* gtk_spin_button_new(GtkAdjustment* adjustment, gdouble climb_rate, \
guint digits)"
  s7_pointer _p;
  s7_pointer adjustment, climb_rate, digits;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 1, adjustment, "GtkAdjustment*");
  climb_rate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(climb_rate)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 2, climb_rate, "gdouble");
  digits = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 3, digits, "guint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_spin_button_new(s7_c_pointer(adjustment), s7_real(climb_rate), s7_integer(digits))));
}

static s7_pointer lg_gtk_spin_button_new_with_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_new_with_range "GtkWidget* gtk_spin_button_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  s7_pointer _p;
  s7_pointer min, max, step;
  _p = args;
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 1, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 2, max, "gdouble");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 3, step, "gdouble");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_spin_button_new_with_range(s7_real(min), s7_real(max), s7_real(step))));
}

static s7_pointer lg_gtk_spin_button_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_adjustment "void gtk_spin_button_set_adjustment(GtkSpinButton* spin_button, \
GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer spin_button, adjustment;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_adjustment", 1, spin_button, "GtkSpinButton*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_spin_button_set_adjustment(s7_c_pointer(spin_button), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_adjustment "GtkAdjustment* gtk_spin_button_get_adjustment(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_adjustment", 1, spin_button, "GtkSpinButton*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_spin_button_get_adjustment(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_digits "void gtk_spin_button_set_digits(GtkSpinButton* spin_button, guint digits)"
  s7_pointer _p;
  s7_pointer spin_button, digits;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_digits", 1, spin_button, "GtkSpinButton*");
  digits = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_digits", 2, digits, "guint");
  gtk_spin_button_set_digits(s7_c_pointer(spin_button), s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_digits "guint gtk_spin_button_get_digits(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_digits", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_digits(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_increments "void gtk_spin_button_set_increments(GtkSpinButton* spin_button, \
gdouble step, gdouble page)"
  s7_pointer _p;
  s7_pointer spin_button, step, page;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 1, spin_button, "GtkSpinButton*");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 2, step, "gdouble");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 3, page, "gdouble");
  gtk_spin_button_set_increments(s7_c_pointer(spin_button), s7_real(step), s7_real(page));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_increments "void gtk_spin_button_get_increments(GtkSpinButton* spin_button, \
gdouble* [step], gdouble* [page])"
  s7_pointer _p;
  s7_pointer spin_button;
  gdouble ref_step;
  gdouble ref_page;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_increments", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_get_increments(s7_c_pointer(spin_button), &ref_step, &ref_page);
    return(s7_list(sc, 2, s7_make_real(sc, ref_step), s7_make_real(sc, ref_page)));
}

static s7_pointer lg_gtk_spin_button_set_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_range "void gtk_spin_button_set_range(GtkSpinButton* spin_button, gdouble min, \
gdouble max)"
  s7_pointer _p;
  s7_pointer spin_button, min, max;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 1, spin_button, "GtkSpinButton*");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 2, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 3, max, "gdouble");
  gtk_spin_button_set_range(s7_c_pointer(spin_button), s7_real(min), s7_real(max));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_range "void gtk_spin_button_get_range(GtkSpinButton* spin_button, gdouble* [min], \
gdouble* [max])"
  s7_pointer _p;
  s7_pointer spin_button;
  gdouble ref_min;
  gdouble ref_max;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_range", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_get_range(s7_c_pointer(spin_button), &ref_min, &ref_max);
    return(s7_list(sc, 2, s7_make_real(sc, ref_min), s7_make_real(sc, ref_max)));
}

static s7_pointer lg_gtk_spin_button_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_value "gdouble gtk_spin_button_get_value(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_value", 1, spin_button, "GtkSpinButton*");
  return(s7_make_real(sc, gtk_spin_button_get_value(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_get_value_as_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_value_as_int "gint gtk_spin_button_get_value_as_int(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_value_as_int", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_value_as_int(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_value "void gtk_spin_button_set_value(GtkSpinButton* spin_button, gdouble value)"
  s7_pointer _p;
  s7_pointer spin_button, value;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_value", 1, spin_button, "GtkSpinButton*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_value", 2, value, "gdouble");
  gtk_spin_button_set_value(s7_c_pointer(spin_button), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_set_update_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_update_policy "void gtk_spin_button_set_update_policy(GtkSpinButton* spin_button, \
GtkSpinButtonUpdatePolicy policy)"
  s7_pointer _p;
  s7_pointer spin_button, policy;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_update_policy", 1, spin_button, "GtkSpinButton*");
  policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_update_policy", 2, policy, "GtkSpinButtonUpdatePolicy");
  gtk_spin_button_set_update_policy(s7_c_pointer(spin_button), s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_update_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_update_policy "GtkSpinButtonUpdatePolicy gtk_spin_button_get_update_policy(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_update_policy", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_update_policy(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_numeric(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_numeric "void gtk_spin_button_set_numeric(GtkSpinButton* spin_button, \
gboolean numeric)"
  s7_pointer _p;
  s7_pointer spin_button, numeric;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_numeric", 1, spin_button, "GtkSpinButton*");
  numeric = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(numeric)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_numeric", 2, numeric, "gboolean");
  gtk_spin_button_set_numeric(s7_c_pointer(spin_button), lg_boolean(numeric));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_numeric(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_numeric "gboolean gtk_spin_button_get_numeric(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_numeric", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_numeric(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_spin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_spin "void gtk_spin_button_spin(GtkSpinButton* spin_button, GtkSpinType direction, \
gdouble increment)"
  s7_pointer _p;
  s7_pointer spin_button, direction, increment;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 1, spin_button, "GtkSpinButton*");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 2, direction, "GtkSpinType");
  increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(increment)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 3, increment, "gdouble");
  gtk_spin_button_spin(s7_c_pointer(spin_button), s7_integer(direction), s7_real(increment));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_set_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_wrap "void gtk_spin_button_set_wrap(GtkSpinButton* spin_button, gboolean wrap)"
  s7_pointer _p;
  s7_pointer spin_button, wrap;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_wrap", 1, spin_button, "GtkSpinButton*");
  wrap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(wrap)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_wrap", 2, wrap, "gboolean");
  gtk_spin_button_set_wrap(s7_c_pointer(spin_button), lg_boolean(wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_wrap "gboolean gtk_spin_button_get_wrap(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_wrap", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_wrap(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_snap_to_ticks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_snap_to_ticks "void gtk_spin_button_set_snap_to_ticks(GtkSpinButton* spin_button, \
gboolean snap_to_ticks)"
  s7_pointer _p;
  s7_pointer spin_button, snap_to_ticks;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_snap_to_ticks", 1, spin_button, "GtkSpinButton*");
  snap_to_ticks = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(snap_to_ticks)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_snap_to_ticks", 2, snap_to_ticks, "gboolean");
  gtk_spin_button_set_snap_to_ticks(s7_c_pointer(spin_button), lg_boolean(snap_to_ticks));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_snap_to_ticks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_snap_to_ticks "gboolean gtk_spin_button_get_snap_to_ticks(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_snap_to_ticks", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_snap_to_ticks(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_update(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_update "void gtk_spin_button_update(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_update", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_update(s7_c_pointer(spin_button));
  return(lg_false);
}

static s7_pointer lg_gtk_statusbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_new "GtkWidget* gtk_statusbar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_statusbar_new()));
}

static s7_pointer lg_gtk_statusbar_get_context_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_get_context_id "guint gtk_statusbar_get_context_id(GtkStatusbar* statusbar, \
gchar* context_description)"
  s7_pointer _p;
  s7_pointer statusbar, context_description;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_get_context_id", 1, statusbar, "GtkStatusbar*");
  context_description = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(context_description)) s7_wrong_type_arg_error(sc, "gtk_statusbar_get_context_id", 2, context_description, "gchar*");
  return(s7_make_integer(sc, gtk_statusbar_get_context_id(s7_c_pointer(statusbar), s7_string(context_description))));
}

static s7_pointer lg_gtk_statusbar_push(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_push "guint gtk_statusbar_push(GtkStatusbar* statusbar, guint context_id, gchar* text)"
  s7_pointer _p;
  s7_pointer statusbar, context_id, text;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 2, context_id, "guint");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 3, text, "gchar*");
  return(s7_make_integer(sc, gtk_statusbar_push(s7_c_pointer(statusbar), s7_integer(context_id), s7_string(text))));
}

static s7_pointer lg_gtk_statusbar_pop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_pop "void gtk_statusbar_pop(GtkStatusbar* statusbar, guint context_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_pop", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_pop", 2, context_id, "guint");
  gtk_statusbar_pop(s7_c_pointer(statusbar), s7_integer(context_id));
  return(lg_false);
}

static s7_pointer lg_gtk_statusbar_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_remove "void gtk_statusbar_remove(GtkStatusbar* statusbar, guint context_id, \
guint message_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id, message_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 2, context_id, "guint");
  message_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(message_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 3, message_id, "guint");
  gtk_statusbar_remove(s7_c_pointer(statusbar), s7_integer(context_id), s7_integer(message_id));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_new "GtkTextBuffer* gtk_text_buffer_new(GtkTextTagTable* table)"
  s7_pointer table;
  table = s7_car(args);
  if ((!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) && (table != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_new", 1, table, "GtkTextTagTable*");
  return(s7_make_type_with_c_pointer(sc, GtkTextBuffer__sym, gtk_text_buffer_new(s7_c_pointer(table))));
}

static s7_pointer lg_gtk_text_buffer_get_line_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_line_count "gint gtk_text_buffer_get_line_count(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_line_count", 1, buffer, "GtkTextBuffer*");
  return(s7_make_integer(sc, gtk_text_buffer_get_line_count(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_char_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_char_count "gint gtk_text_buffer_get_char_count(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_char_count", 1, buffer, "GtkTextBuffer*");
  return(s7_make_integer(sc, gtk_text_buffer_get_char_count(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_tag_table(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_tag_table "GtkTextTagTable* gtk_text_buffer_get_tag_table(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_tag_table", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkTextTagTable__sym, gtk_text_buffer_get_tag_table(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_text "void gtk_text_buffer_set_text(GtkTextBuffer* buffer, gchar* text, \
gint len)"
  s7_pointer _p;
  s7_pointer buffer, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 3, len, "gint");
  gtk_text_buffer_set_text(s7_c_pointer(buffer), s7_string(text), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert "void gtk_text_buffer_insert(GtkTextBuffer* buffer, GtkTextIter* iter, \
gchar* text, gint len)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 4, len, "gint");
  gtk_text_buffer_insert(s7_c_pointer(buffer), s7_c_pointer(iter), s7_string(text), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_at_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_at_cursor "void gtk_text_buffer_insert_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len)"
  s7_pointer _p;
  s7_pointer buffer, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 3, len, "gint");
  gtk_text_buffer_insert_at_cursor(s7_c_pointer(buffer), s7_string(text), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_interactive "gboolean gtk_text_buffer_insert_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 4, len, "gint");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 5, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_interactive(s7_c_pointer(buffer), s7_c_pointer(iter), s7_string(text), s7_integer(len), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_interactive_at_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_interactive_at_cursor "gboolean gtk_text_buffer_insert_interactive_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, text, len, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 3, len, "gint");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_interactive_at_cursor(s7_c_pointer(buffer), s7_string(text), s7_integer(len), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_range "void gtk_text_buffer_insert_range(GtkTextBuffer* buffer, GtkTextIter* iter, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, iter, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 2, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 4, end, "GtkTextIter*");
  gtk_text_buffer_insert_range(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_range_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_range_interactive "gboolean gtk_text_buffer_insert_range_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextIter* start, GtkTextIter* end, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, start, end, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 2, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 4, end, "GtkTextIter*");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 5, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_range_interactive(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(start), s7_c_pointer(end), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_with_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_with_tags "void gtk_text_buffer_insert_with_tags(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 4, len, "gint");
  tags = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(tags)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 5, tags, "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags", 4, tags, "... list too long (max len: 6)");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (GtkTextIter*)s7_c_pointer(iter);
    p_arg2 = (gchar*)s7_string(text);
    p_arg3 = (gint)s7_integer(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), NULL); break;
        case 2: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_c_pointer(s7_list_ref(sc, tags, 2)), NULL); break;
        case 4: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_c_pointer(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_c_pointer(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), s7_c_pointer(s7_list_ref(sc, tags, 4)), NULL); break;
        case 6: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, s7_c_pointer(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_c_pointer(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), s7_c_pointer(s7_list_ref(sc, tags, 4)), s7_c_pointer(s7_list_ref(sc, tags, 5)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_text_buffer_insert_with_tags_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_with_tags_by_name "void gtk_text_buffer_insert_with_tags_by_name(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, len, "gint");
  tags = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(tags)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 5, tags, "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list len must be multiple of 2");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (GtkTextIter*)s7_c_pointer(iter);
    p_arg2 = (gchar*)s7_string(text);
    p_arg3 = (gint)s7_integer(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), s7_integer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), s7_integer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_integer(s7_list_ref(sc, tags, 3)), s7_string(s7_list_ref(sc, tags, 4)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_text_buffer_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete "void gtk_text_buffer_delete(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 3, end, "GtkTextIter*");
  gtk_text_buffer_delete(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_interactive "gboolean gtk_text_buffer_delete_interactive(GtkTextBuffer* buffer, \
GtkTextIter* start_iter, GtkTextIter* end_iter, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, start_iter, end_iter, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 1, buffer, "GtkTextBuffer*");
  start_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 2, start_iter, "GtkTextIter*");
  end_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 3, end_iter, "GtkTextIter*");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_delete_interactive(s7_c_pointer(buffer), s7_c_pointer(start_iter), s7_c_pointer(end_iter), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_text "gchar* gtk_text_buffer_get_text(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  s7_pointer _p;
  s7_pointer buffer, start, end, include_hidden_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 3, end, "GtkTextIter*");
  include_hidden_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(include_hidden_chars)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 4, include_hidden_chars, "gboolean");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_buffer_get_text(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end), lg_boolean(include_hidden_chars));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_buffer_get_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_slice "gchar* gtk_text_buffer_get_slice(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  s7_pointer _p;
  s7_pointer buffer, start, end, include_hidden_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 3, end, "GtkTextIter*");
  include_hidden_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(include_hidden_chars)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 4, include_hidden_chars, "gboolean");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_buffer_get_slice(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end), lg_boolean(include_hidden_chars));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_buffer_insert_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_pixbuf "void gtk_text_buffer_insert_pixbuf(GtkTextBuffer* buffer, \
GtkTextIter* iter, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer buffer, iter, pixbuf;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_pixbuf", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_pixbuf", 2, iter, "GtkTextIter*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_pixbuf", 3, pixbuf, "GdkPixbuf*");
  gtk_text_buffer_insert_pixbuf(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_child_anchor "void gtk_text_buffer_insert_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer buffer, iter, anchor;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 2, iter, "GtkTextIter*");
  anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_buffer_insert_child_anchor(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_create_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_child_anchor "GtkTextChildAnchor* gtk_text_buffer_create_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_child_anchor", 2, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTextChildAnchor__sym, gtk_text_buffer_create_child_anchor(s7_c_pointer(buffer), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_buffer_create_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_mark "GtkTextMark* gtk_text_buffer_create_mark(GtkTextBuffer* buffer, \
gchar* mark_name, GtkTextIter* where, gboolean left_gravity)"
  s7_pointer _p;
  s7_pointer buffer, mark_name, where, left_gravity;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 1, buffer, "GtkTextBuffer*");
  mark_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mark_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 2, mark_name, "gchar*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 3, where, "GtkTextIter*");
  left_gravity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(left_gravity)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 4, left_gravity, "gboolean");
  return(s7_make_type_with_c_pointer(sc, GtkTextMark__sym, gtk_text_buffer_create_mark(s7_c_pointer(buffer), s7_string(mark_name), s7_c_pointer(where), lg_boolean(left_gravity))));
}

static s7_pointer lg_gtk_text_buffer_move_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_move_mark "void gtk_text_buffer_move_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, mark, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 2, mark, "GtkTextMark*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 3, where, "GtkTextIter*");
  gtk_text_buffer_move_mark(s7_c_pointer(buffer), s7_c_pointer(mark), s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_mark "void gtk_text_buffer_delete_mark(GtkTextBuffer* buffer, GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer buffer, mark;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark", 2, mark, "GtkTextMark*");
  gtk_text_buffer_delete_mark(s7_c_pointer(buffer), s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_mark "GtkTextMark* gtk_text_buffer_get_mark(GtkTextBuffer* buffer, gchar* name)"
  s7_pointer _p;
  s7_pointer buffer, name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_mark", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_mark", 2, name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkTextMark__sym, gtk_text_buffer_get_mark(s7_c_pointer(buffer), s7_string(name))));
}

static s7_pointer lg_gtk_text_buffer_move_mark_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_move_mark_by_name "void gtk_text_buffer_move_mark_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, name, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 2, name, "gchar*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 3, where, "GtkTextIter*");
  gtk_text_buffer_move_mark_by_name(s7_c_pointer(buffer), s7_string(name), s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_mark_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_mark_by_name "void gtk_text_buffer_delete_mark_by_name(GtkTextBuffer* buffer, \
gchar* name)"
  s7_pointer _p;
  s7_pointer buffer, name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark_by_name", 2, name, "gchar*");
  gtk_text_buffer_delete_mark_by_name(s7_c_pointer(buffer), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_insert "GtkTextMark* gtk_text_buffer_get_insert(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_insert", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkTextMark__sym, gtk_text_buffer_get_insert(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_selection_bound(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_selection_bound "GtkTextMark* gtk_text_buffer_get_selection_bound(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bound", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkTextMark__sym, gtk_text_buffer_get_selection_bound(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_place_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_place_cursor "void gtk_text_buffer_place_cursor(GtkTextBuffer* buffer, GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_place_cursor", 1, buffer, "GtkTextBuffer*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_place_cursor", 2, where, "GtkTextIter*");
  gtk_text_buffer_place_cursor(s7_c_pointer(buffer), s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_apply_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_apply_tag "void gtk_text_buffer_apply_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, tag, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 1, buffer, "GtkTextBuffer*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 2, tag, "GtkTextTag*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 4, end, "GtkTextIter*");
  gtk_text_buffer_apply_tag(s7_c_pointer(buffer), s7_c_pointer(tag), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_tag "void gtk_text_buffer_remove_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, tag, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 1, buffer, "GtkTextBuffer*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 2, tag, "GtkTextTag*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 4, end, "GtkTextIter*");
  gtk_text_buffer_remove_tag(s7_c_pointer(buffer), s7_c_pointer(tag), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_apply_tag_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_apply_tag_by_name "void gtk_text_buffer_apply_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, name, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 2, name, "gchar*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 4, end, "GtkTextIter*");
  gtk_text_buffer_apply_tag_by_name(s7_c_pointer(buffer), s7_string(name), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_tag_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_tag_by_name "void gtk_text_buffer_remove_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, name, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 2, name, "gchar*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 4, end, "GtkTextIter*");
  gtk_text_buffer_remove_tag_by_name(s7_c_pointer(buffer), s7_string(name), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_all_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_all_tags "void gtk_text_buffer_remove_all_tags(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 3, end, "GtkTextIter*");
  gtk_text_buffer_remove_all_tags(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_create_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_tag "GtkTextTag* gtk_text_buffer_create_tag(GtkTextBuffer* buffer, \
gchar* tag_name, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, tag_name, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 1, buffer, "GtkTextBuffer*");
  tag_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tag_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 2, tag_name, "gchar*");
  tags = s7_car(_p); _p = s7_cdr(_p);
  if ((!lg_is_list(tags)) && (tags != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 3, tags, "etc");
  {
    int etc_len = 0;
    GtkTextTag* result = NULL;
    GtkTextBuffer* p_arg0;
    gchar* p_arg1;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_create_tag", 2, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_text_buffer_create_tag", 2, tags, "... list len must be multiple of 2");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (gchar*)s7_string(tag_name);
    switch (etc_len)
      {
        case 0: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, NULL); break;
        case 2: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), NULL); break;
        case 4: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), NULL); break;
        case 6: result = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), s7_string(s7_list_ref(sc, tags, 4)), s7_c_pointer(s7_list_ref(sc, tags, 5)), NULL); break;
      }
    return(s7_make_c_pointer(sc, result));
  }
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line_offset "void gtk_text_buffer_get_iter_at_line_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint char_offset)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number, char_offset;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 3, line_number, "gint");
  char_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 4, char_offset, "gint");
  gtk_text_buffer_get_iter_at_line_offset(s7_c_pointer(buffer), s7_c_pointer(iter), s7_integer(line_number), s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line_index "void gtk_text_buffer_get_iter_at_line_index(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint byte_index)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number, byte_index;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 3, line_number, "gint");
  byte_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(byte_index)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 4, byte_index, "gint");
  gtk_text_buffer_get_iter_at_line_index(s7_c_pointer(buffer), s7_c_pointer(iter), s7_integer(line_number), s7_integer(byte_index));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_offset "void gtk_text_buffer_get_iter_at_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint char_offset)"
  s7_pointer _p;
  s7_pointer buffer, iter, char_offset;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 2, iter, "GtkTextIter*");
  char_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 3, char_offset, "gint");
  gtk_text_buffer_get_iter_at_offset(s7_c_pointer(buffer), s7_c_pointer(iter), s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line "void gtk_text_buffer_get_iter_at_line(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 3, line_number, "gint");
  gtk_text_buffer_get_iter_at_line(s7_c_pointer(buffer), s7_c_pointer(iter), s7_integer(line_number));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_start_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_start_iter "void gtk_text_buffer_get_start_iter(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_start_iter", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_start_iter", 2, iter, "GtkTextIter*");
  gtk_text_buffer_get_start_iter(s7_c_pointer(buffer), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_end_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_end_iter "void gtk_text_buffer_get_end_iter(GtkTextBuffer* buffer, GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_end_iter", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_end_iter", 2, iter, "GtkTextIter*");
  gtk_text_buffer_get_end_iter(s7_c_pointer(buffer), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_bounds "void gtk_text_buffer_get_bounds(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 3, end, "GtkTextIter*");
  gtk_text_buffer_get_bounds(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_mark "void gtk_text_buffer_get_iter_at_mark(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer buffer, iter, mark;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 2, iter, "GtkTextIter*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 3, mark, "GtkTextMark*");
  gtk_text_buffer_get_iter_at_mark(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_child_anchor "void gtk_text_buffer_get_iter_at_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer buffer, iter, anchor;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 2, iter, "GtkTextIter*");
  anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_buffer_get_iter_at_child_anchor(s7_c_pointer(buffer), s7_c_pointer(iter), s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_modified "gboolean gtk_text_buffer_get_modified(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_modified", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_modified(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_modified "void gtk_text_buffer_set_modified(GtkTextBuffer* buffer, gboolean setting)"
  s7_pointer _p;
  s7_pointer buffer, setting;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_modified", 1, buffer, "GtkTextBuffer*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_modified", 2, setting, "gboolean");
  gtk_text_buffer_set_modified(s7_c_pointer(buffer), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_add_selection_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_add_selection_clipboard "void gtk_text_buffer_add_selection_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_selection_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_selection_clipboard", 2, clipboard, "GtkClipboard*");
  gtk_text_buffer_add_selection_clipboard(s7_c_pointer(buffer), s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_selection_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_selection_clipboard "void gtk_text_buffer_remove_selection_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_selection_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_selection_clipboard", 2, clipboard, "GtkClipboard*");
  gtk_text_buffer_remove_selection_clipboard(s7_c_pointer(buffer), s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_cut_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_cut_clipboard "void gtk_text_buffer_cut_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, clipboard, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 2, clipboard, "GtkClipboard*");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 3, default_editable, "gboolean");
  gtk_text_buffer_cut_clipboard(s7_c_pointer(buffer), s7_c_pointer(clipboard), lg_boolean(default_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_copy_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_copy_clipboard "void gtk_text_buffer_copy_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_copy_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_copy_clipboard", 2, clipboard, "GtkClipboard*");
  gtk_text_buffer_copy_clipboard(s7_c_pointer(buffer), s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_paste_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_paste_clipboard "void gtk_text_buffer_paste_clipboard(GtkTextBuffer* buffer, \
GtkClipboard* clipboard, GtkTextIter* override_location, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, clipboard, override_location, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 2, clipboard, "GtkClipboard*");
  override_location = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(override_location, GtkTextIter__sym)) && (override_location != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 3, override_location, "GtkTextIter*");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 4, default_editable, "gboolean");
  gtk_text_buffer_paste_clipboard(s7_c_pointer(buffer), s7_c_pointer(clipboard), s7_c_pointer(override_location), lg_boolean(default_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_selection_bounds "gboolean gtk_text_buffer_get_selection_bounds(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 3, end, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_selection_bounds(s7_c_pointer(buffer), s7_c_pointer(start), s7_c_pointer(end))));
}

static s7_pointer lg_gtk_text_buffer_delete_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_selection "gboolean gtk_text_buffer_delete_selection(GtkTextBuffer* buffer, \
gboolean interactive, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, interactive, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 1, buffer, "GtkTextBuffer*");
  interactive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(interactive)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 2, interactive, "gboolean");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 3, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_delete_selection(s7_c_pointer(buffer), lg_boolean(interactive), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_begin_user_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_begin_user_action "void gtk_text_buffer_begin_user_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_begin_user_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_begin_user_action(s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_end_user_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_end_user_action "void gtk_text_buffer_end_user_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_end_user_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_end_user_action(s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_child_anchor_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_new "GtkTextChildAnchor* gtk_text_child_anchor_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTextChildAnchor__sym, gtk_text_child_anchor_new()));
}

static s7_pointer lg_gtk_text_child_anchor_get_widgets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_get_widgets "GList* gtk_text_child_anchor_get_widgets(GtkTextChildAnchor* anchor)"
  s7_pointer anchor;
  anchor = s7_car(args);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_child_anchor_get_widgets", 1, anchor, "GtkTextChildAnchor*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_text_child_anchor_get_widgets(s7_c_pointer(anchor))));
}

static s7_pointer lg_gtk_text_child_anchor_get_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_get_deleted "gboolean gtk_text_child_anchor_get_deleted(GtkTextChildAnchor* anchor)"
  s7_pointer anchor;
  anchor = s7_car(args);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_child_anchor_get_deleted", 1, anchor, "GtkTextChildAnchor*");
  return(s7_make_boolean(sc, gtk_text_child_anchor_get_deleted(s7_c_pointer(anchor))));
}

static s7_pointer lg_gtk_text_iter_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_buffer "GtkTextBuffer* gtk_text_iter_get_buffer(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_buffer", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTextBuffer__sym, gtk_text_iter_get_buffer(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_copy "GtkTextIter* gtk_text_iter_copy(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_copy", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTextIter__sym, gtk_text_iter_copy(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_free "void gtk_text_iter_free(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_free", 1, iter, "GtkTextIter*");
  gtk_text_iter_free(s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_offset "gint gtk_text_iter_get_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_offset(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line "gint gtk_text_iter_get_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line_offset "gint gtk_text_iter_get_line_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line_offset(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line_index "gint gtk_text_iter_get_line_index(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line_index", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line_index(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_visible_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_line_offset "gint gtk_text_iter_get_visible_line_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_line_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_visible_line_offset(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_visible_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_line_index "gint gtk_text_iter_get_visible_line_index(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_line_index", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_visible_line_index(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_char "gunichar gtk_text_iter_get_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_char", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_char(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_slice "gchar* gtk_text_iter_get_slice(GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_slice", 1, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_slice", 2, end, "GtkTextIter*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_iter_get_slice(s7_c_pointer(start), s7_c_pointer(end));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_text "gchar* gtk_text_iter_get_text(GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_text", 1, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_text", 2, end, "GtkTextIter*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_iter_get_text(s7_c_pointer(start), s7_c_pointer(end));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_visible_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_slice "gchar* gtk_text_iter_get_visible_slice(GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_slice", 1, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_slice", 2, end, "GtkTextIter*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_iter_get_visible_slice(s7_c_pointer(start), s7_c_pointer(end));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_visible_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_text "gchar* gtk_text_iter_get_visible_text(GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_text", 1, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_text", 2, end, "GtkTextIter*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_text_iter_get_visible_text(s7_c_pointer(start), s7_c_pointer(end));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_pixbuf "GdkPixbuf* gtk_text_iter_get_pixbuf(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_pixbuf", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_text_iter_get_pixbuf(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_marks "GSList* gtk_text_iter_get_marks(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_marks", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_text_iter_get_marks(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_child_anchor "GtkTextChildAnchor* gtk_text_iter_get_child_anchor(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_child_anchor", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTextChildAnchor__sym, gtk_text_iter_get_child_anchor(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_toggled_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_toggled_tags "GSList* gtk_text_iter_get_toggled_tags(GtkTextIter* iter, \
gboolean toggled_on)"
  s7_pointer _p;
  s7_pointer iter, toggled_on;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_toggled_tags", 1, iter, "GtkTextIter*");
  toggled_on = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(toggled_on)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_toggled_tags", 2, toggled_on, "gboolean");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_text_iter_get_toggled_tags(s7_c_pointer(iter), lg_boolean(toggled_on))));
}

static s7_pointer lg_gtk_text_iter_ends_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_tag "gboolean gtk_text_iter_ends_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_tag(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_toggles_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_toggles_tag "gboolean gtk_text_iter_toggles_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_toggles_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_toggles_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_toggles_tag(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_has_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_has_tag "gboolean gtk_text_iter_has_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_has_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_has_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_has_tag(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_get_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_tags "GSList* gtk_text_iter_get_tags(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_tags", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_text_iter_get_tags(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_editable "gboolean gtk_text_iter_editable(GtkTextIter* iter, gboolean default_setting)"
  s7_pointer _p;
  s7_pointer iter, default_setting;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_editable", 1, iter, "GtkTextIter*");
  default_setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_setting)) s7_wrong_type_arg_error(sc, "gtk_text_iter_editable", 2, default_setting, "gboolean");
  return(s7_make_boolean(sc, gtk_text_iter_editable(s7_c_pointer(iter), lg_boolean(default_setting))));
}

static s7_pointer lg_gtk_text_iter_can_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_can_insert "gboolean gtk_text_iter_can_insert(GtkTextIter* iter, gboolean default_editability)"
  s7_pointer _p;
  s7_pointer iter, default_editability;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_can_insert", 1, iter, "GtkTextIter*");
  default_editability = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editability)) s7_wrong_type_arg_error(sc, "gtk_text_iter_can_insert", 2, default_editability, "gboolean");
  return(s7_make_boolean(sc, gtk_text_iter_can_insert(s7_c_pointer(iter), lg_boolean(default_editability))));
}

static s7_pointer lg_gtk_text_iter_starts_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_word "gboolean gtk_text_iter_starts_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_word(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_word "gboolean gtk_text_iter_ends_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_word(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_inside_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_inside_word "gboolean gtk_text_iter_inside_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_inside_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_inside_word(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_starts_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_sentence "gboolean gtk_text_iter_starts_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_sentence(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_sentence "gboolean gtk_text_iter_ends_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_sentence(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_inside_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_inside_sentence "gboolean gtk_text_iter_inside_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_inside_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_inside_sentence(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_starts_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_line "gboolean gtk_text_iter_starts_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_line "gboolean gtk_text_iter_ends_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_cursor_position "gboolean gtk_text_iter_is_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_cursor_position(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_chars_in_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_chars_in_line "gint gtk_text_iter_get_chars_in_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_chars_in_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_chars_in_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_bytes_in_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_bytes_in_line "gint gtk_text_iter_get_bytes_in_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_bytes_in_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_bytes_in_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_language(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_language "PangoLanguage* gtk_text_iter_get_language(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_language", 1, iter, "GtkTextIter*");
  return(s7_make_type_with_c_pointer(sc, PangoLanguage__sym, gtk_text_iter_get_language(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_end "gboolean gtk_text_iter_is_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_end(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_start "gboolean gtk_text_iter_is_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_start(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_char "gboolean gtk_text_iter_forward_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_char", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_char(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_char "gboolean gtk_text_iter_backward_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_char", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_char(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_chars "gboolean gtk_text_iter_forward_chars(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_chars", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_chars", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_chars(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_chars "gboolean gtk_text_iter_backward_chars(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_chars", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_chars", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_chars(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_line "gboolean gtk_text_iter_forward_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_line "gboolean gtk_text_iter_backward_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_lines "gboolean gtk_text_iter_forward_lines(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_lines(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_lines "gboolean gtk_text_iter_backward_lines(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_lines(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_word_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_word_end "gboolean gtk_text_iter_forward_word_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_word_end(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_word_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_word_start "gboolean gtk_text_iter_backward_word_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_word_start(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_word_ends(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_word_ends "gboolean gtk_text_iter_forward_word_ends(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_ends", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_ends", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_word_ends(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_word_starts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_word_starts "gboolean gtk_text_iter_backward_word_starts(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_starts", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_starts", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_word_starts(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_sentence_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_sentence_end "gboolean gtk_text_iter_forward_sentence_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_sentence_end(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_sentence_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_sentence_start "gboolean gtk_text_iter_backward_sentence_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_sentence_start(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_sentence_ends(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_sentence_ends "gboolean gtk_text_iter_forward_sentence_ends(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_ends", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_ends", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_sentence_ends(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_sentence_starts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_sentence_starts "gboolean gtk_text_iter_backward_sentence_starts(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_starts", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_starts", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_sentence_starts(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_cursor_position "gboolean gtk_text_iter_forward_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_cursor_position(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_cursor_position "gboolean gtk_text_iter_backward_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_cursor_position(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_cursor_positions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_cursor_positions "gboolean gtk_text_iter_forward_cursor_positions(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_positions", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_positions", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_cursor_positions(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_cursor_positions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_cursor_positions "gboolean gtk_text_iter_backward_cursor_positions(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_positions", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_positions", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_cursor_positions(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_set_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_offset "void gtk_text_iter_set_offset(GtkTextIter* iter, gint char_offset)"
  s7_pointer _p;
  s7_pointer iter, char_offset;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_offset", 1, iter, "GtkTextIter*");
  char_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_offset", 2, char_offset, "gint");
  gtk_text_iter_set_offset(s7_c_pointer(iter), s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line "void gtk_text_iter_set_line(GtkTextIter* iter, gint line_number)"
  s7_pointer _p;
  s7_pointer iter, line_number;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line", 1, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line", 2, line_number, "gint");
  gtk_text_iter_set_line(s7_c_pointer(iter), s7_integer(line_number));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line_offset "void gtk_text_iter_set_line_offset(GtkTextIter* iter, gint char_on_line)"
  s7_pointer _p;
  s7_pointer iter, char_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_offset", 1, iter, "GtkTextIter*");
  char_on_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(char_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_offset", 2, char_on_line, "gint");
  gtk_text_iter_set_line_offset(s7_c_pointer(iter), s7_integer(char_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line_index "void gtk_text_iter_set_line_index(GtkTextIter* iter, gint byte_on_line)"
  s7_pointer _p;
  s7_pointer iter, byte_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_index", 1, iter, "GtkTextIter*");
  byte_on_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(byte_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_index", 2, byte_on_line, "gint");
  gtk_text_iter_set_line_index(s7_c_pointer(iter), s7_integer(byte_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_end "void gtk_text_iter_forward_to_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_end", 1, iter, "GtkTextIter*");
  gtk_text_iter_forward_to_end(s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_line_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_line_end "gboolean gtk_text_iter_forward_to_line_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_line_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_to_line_end(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_set_visible_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_visible_line_offset "void gtk_text_iter_set_visible_line_offset(GtkTextIter* iter, \
gint char_on_line)"
  s7_pointer _p;
  s7_pointer iter, char_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_offset", 1, iter, "GtkTextIter*");
  char_on_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(char_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_offset", 2, char_on_line, "gint");
  gtk_text_iter_set_visible_line_offset(s7_c_pointer(iter), s7_integer(char_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_visible_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_visible_line_index "void gtk_text_iter_set_visible_line_index(GtkTextIter* iter, \
gint byte_on_line)"
  s7_pointer _p;
  s7_pointer iter, byte_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_index", 1, iter, "GtkTextIter*");
  byte_on_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(byte_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_index", 2, byte_on_line, "gint");
  gtk_text_iter_set_visible_line_index(s7_c_pointer(iter), s7_integer(byte_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_tag_toggle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_tag_toggle "gboolean gtk_text_iter_forward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_tag_toggle", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_tag_toggle", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_to_tag_toggle(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_backward_to_tag_toggle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_to_tag_toggle "gboolean gtk_text_iter_backward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_to_tag_toggle", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_to_tag_toggle", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_to_tag_toggle(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_forward_find_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_find_char "gboolean gtk_text_iter_forward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, pred, func_info, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 1, iter, "GtkTextIter*");
  pred = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pred, GtkTextCharPredicate_sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 2, pred, "GtkTextCharPredicate");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 3, func_info, "lambda_data");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 4, limit, "GtkTextIter*");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_boolean(sc, gtk_text_iter_forward_find_char(s7_c_pointer(iter), s7_c_pointer(pred), (gpointer)lg_ptr, s7_c_pointer(limit)));
    return(result);
   }
}

static s7_pointer lg_gtk_text_iter_backward_find_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_find_char "gboolean gtk_text_iter_backward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, pred, func_info, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 1, iter, "GtkTextIter*");
  pred = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pred, GtkTextCharPredicate_sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 2, pred, "GtkTextCharPredicate");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 3, func_info, "lambda_data");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 4, limit, "GtkTextIter*");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_boolean(sc, gtk_text_iter_backward_find_char(s7_c_pointer(iter), s7_c_pointer(pred), (gpointer)lg_ptr, s7_c_pointer(limit)));
    return(result);
   }
}

static s7_pointer lg_gtk_text_iter_forward_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_search "gboolean gtk_text_iter_forward_search(GtkTextIter* iter, gchar* str, \
GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, str, flags, match_start, match_end, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 1, iter, "GtkTextIter*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 2, str, "gchar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 3, flags, "GtkTextSearchFlags");
  match_start = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_start, GtkTextIter__sym)) && (match_start != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 4, match_start, "GtkTextIter*");
  match_end = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_end, GtkTextIter__sym)) && (match_end != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 5, match_end, "GtkTextIter*");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 6, limit, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_search(s7_c_pointer(iter), s7_string(str), s7_integer(flags), s7_c_pointer(match_start), s7_c_pointer(match_end), s7_c_pointer(limit))));
}

static s7_pointer lg_gtk_text_iter_backward_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_search "gboolean gtk_text_iter_backward_search(GtkTextIter* iter, \
gchar* str, GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, str, flags, match_start, match_end, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 1, iter, "GtkTextIter*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 2, str, "gchar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 3, flags, "GtkTextSearchFlags");
  match_start = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_start, GtkTextIter__sym)) && (match_start != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 4, match_start, "GtkTextIter*");
  match_end = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_end, GtkTextIter__sym)) && (match_end != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 5, match_end, "GtkTextIter*");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 6, limit, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_search(s7_c_pointer(iter), s7_string(str), s7_integer(flags), s7_c_pointer(match_start), s7_c_pointer(match_end), s7_c_pointer(limit))));
}

static s7_pointer lg_gtk_text_iter_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_equal "gboolean gtk_text_iter_equal(GtkTextIter* lhs, GtkTextIter* rhs)"
  s7_pointer _p;
  s7_pointer lhs, rhs;
  _p = args;
  lhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(lhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_equal", 1, lhs, "GtkTextIter*");
  rhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_equal", 2, rhs, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_equal(s7_c_pointer(lhs), s7_c_pointer(rhs))));
}

static s7_pointer lg_gtk_text_iter_compare(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_compare "gint gtk_text_iter_compare(GtkTextIter* lhs, GtkTextIter* rhs)"
  s7_pointer _p;
  s7_pointer lhs, rhs;
  _p = args;
  lhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(lhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_compare", 1, lhs, "GtkTextIter*");
  rhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_compare", 2, rhs, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_compare(s7_c_pointer(lhs), s7_c_pointer(rhs))));
}

static s7_pointer lg_gtk_text_iter_in_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_in_range "gboolean gtk_text_iter_in_range(GtkTextIter* iter, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer iter, start, end;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 1, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 3, end, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_in_range(s7_c_pointer(iter), s7_c_pointer(start), s7_c_pointer(end))));
}

static s7_pointer lg_gtk_text_iter_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_order "void gtk_text_iter_order(GtkTextIter* first, GtkTextIter* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_order", 1, first, "GtkTextIter*");
  second = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(second, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_order", 2, second, "GtkTextIter*");
  gtk_text_iter_order(s7_c_pointer(first), s7_c_pointer(second));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_set_visible "void gtk_text_mark_set_visible(GtkTextMark* mark, gboolean setting)"
  s7_pointer _p;
  s7_pointer mark, setting;
  _p = args;
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_set_visible", 1, mark, "GtkTextMark*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_mark_set_visible", 2, setting, "gboolean");
  gtk_text_mark_set_visible(s7_c_pointer(mark), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_visible "gboolean gtk_text_mark_get_visible(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_visible", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_visible(s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_name "char* gtk_text_mark_get_name(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_name", 1, mark, "GtkTextMark*");
  return(s7_make_string(sc, gtk_text_mark_get_name(s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_deleted "gboolean gtk_text_mark_get_deleted(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_deleted", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_deleted(s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_buffer "GtkTextBuffer* gtk_text_mark_get_buffer(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_buffer", 1, mark, "GtkTextMark*");
  return(s7_make_type_with_c_pointer(sc, GtkTextBuffer__sym, gtk_text_mark_get_buffer(s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_left_gravity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_left_gravity "gboolean gtk_text_mark_get_left_gravity(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_left_gravity", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_left_gravity(s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_tag_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_new "GtkTextTag* gtk_text_tag_new(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_tag_new", 1, name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkTextTag__sym, gtk_text_tag_new(s7_string(name))));
}

static s7_pointer lg_gtk_text_tag_get_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_get_priority "gint gtk_text_tag_get_priority(GtkTextTag* tag)"
  s7_pointer tag;
  tag = s7_car(args);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_get_priority", 1, tag, "GtkTextTag*");
  return(s7_make_integer(sc, gtk_text_tag_get_priority(s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_tag_set_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_set_priority "void gtk_text_tag_set_priority(GtkTextTag* tag, gint priority)"
  s7_pointer _p;
  s7_pointer tag, priority;
  _p = args;
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_set_priority", 1, tag, "GtkTextTag*");
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gtk_text_tag_set_priority", 2, priority, "gint");
  gtk_text_tag_set_priority(s7_c_pointer(tag), s7_integer(priority));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_event "gboolean gtk_text_tag_event(GtkTextTag* tag, GObject* event_object, GdkEvent* event, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer tag, event_object, event, iter;
  _p = args;
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_event", 1, tag, "GtkTextTag*");
  event_object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event_object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_event", 2, event_object, "GObject*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_event", 3, event, "GdkEvent*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_event", 4, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_tag_event(s7_c_pointer(tag), s7_c_pointer(event_object), s7_c_pointer(event), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_attributes_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_attributes_new "GtkTextAttributes* gtk_text_attributes_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTextAttributes__sym, gtk_text_attributes_new()));
}

static s7_pointer lg_gtk_text_attributes_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_attributes_copy "GtkTextAttributes* gtk_text_attributes_copy(GtkTextAttributes* src)"
  s7_pointer src;
  src = s7_car(args);
  if (!s7_is_c_pointer_of_type(src, GtkTextAttributes__sym)) s7_wrong_type_arg_error(sc, "gtk_text_attributes_copy", 1, src, "GtkTextAttributes*");
  return(s7_make_type_with_c_pointer(sc, GtkTextAttributes__sym, gtk_text_attributes_copy(s7_c_pointer(src))));
}

static s7_pointer lg_gtk_text_attributes_copy_values(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_attributes_copy_values "void gtk_text_attributes_copy_values(GtkTextAttributes* src, \
GtkTextAttributes* dest)"
  s7_pointer _p;
  s7_pointer src, dest;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GtkTextAttributes__sym)) s7_wrong_type_arg_error(sc, "gtk_text_attributes_copy_values", 1, src, "GtkTextAttributes*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GtkTextAttributes__sym)) s7_wrong_type_arg_error(sc, "gtk_text_attributes_copy_values", 2, dest, "GtkTextAttributes*");
  gtk_text_attributes_copy_values(s7_c_pointer(src), s7_c_pointer(dest));
  return(lg_false);
}

static s7_pointer lg_gtk_text_attributes_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_attributes_unref "void gtk_text_attributes_unref(GtkTextAttributes* values)"
  s7_pointer values;
  values = s7_car(args);
  if (!s7_is_c_pointer_of_type(values, GtkTextAttributes__sym)) s7_wrong_type_arg_error(sc, "gtk_text_attributes_unref", 1, values, "GtkTextAttributes*");
  gtk_text_attributes_unref(s7_c_pointer(values));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_new "GtkTextTagTable* gtk_text_tag_table_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTextTagTable__sym, gtk_text_tag_table_new()));
}

static s7_pointer lg_gtk_text_tag_table_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_add "void gtk_text_tag_table_add(GtkTextTagTable* table, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer table, tag;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_add", 1, table, "GtkTextTagTable*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_add", 2, tag, "GtkTextTag*");
  gtk_text_tag_table_add(s7_c_pointer(table), s7_c_pointer(tag));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_remove "void gtk_text_tag_table_remove(GtkTextTagTable* table, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer table, tag;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_remove", 1, table, "GtkTextTagTable*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_remove", 2, tag, "GtkTextTag*");
  gtk_text_tag_table_remove(s7_c_pointer(table), s7_c_pointer(tag));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_lookup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_lookup "GtkTextTag* gtk_text_tag_table_lookup(GtkTextTagTable* table, \
gchar* name)"
  s7_pointer _p;
  s7_pointer table, name;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_lookup", 1, table, "GtkTextTagTable*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_lookup", 2, name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkTextTag__sym, gtk_text_tag_table_lookup(s7_c_pointer(table), s7_string(name))));
}

static s7_pointer lg_gtk_text_tag_table_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_foreach "void gtk_text_tag_table_foreach(GtkTextTagTable* table, GtkTextTagTableForeach func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer table, func, func_info;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_foreach", 1, table, "GtkTextTagTable*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTextTagTableForeach_sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_foreach", 2, func, "GtkTextTagTableForeach");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_foreach", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_text_tag_table_foreach(s7_c_pointer(table), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_text_tag_table_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_get_size "gint gtk_text_tag_table_get_size(GtkTextTagTable* table)"
  s7_pointer table;
  table = s7_car(args);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_get_size", 1, table, "GtkTextTagTable*");
  return(s7_make_integer(sc, gtk_text_tag_table_get_size(s7_c_pointer(table))));
}

static s7_pointer lg_gtk_text_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_new "GtkWidget* gtk_text_view_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_text_view_new()));
}

static s7_pointer lg_gtk_text_view_new_with_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_new_with_buffer "GtkWidget* gtk_text_view_new_with_buffer(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_new_with_buffer", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_text_view_new_with_buffer(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_view_set_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_buffer "void gtk_text_view_set_buffer(GtkTextView* text_view, GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer text_view, buffer;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_buffer", 1, text_view, "GtkTextView*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_buffer", 2, buffer, "GtkTextBuffer*");
  gtk_text_view_set_buffer(s7_c_pointer(text_view), s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_buffer "GtkTextBuffer* gtk_text_view_get_buffer(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_buffer", 1, text_view, "GtkTextView*");
  return(s7_make_type_with_c_pointer(sc, GtkTextBuffer__sym, gtk_text_view_get_buffer(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_scroll_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_to_iter "gboolean gtk_text_view_scroll_to_iter(GtkTextView* text_view, \
GtkTextIter* iter, gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  s7_pointer _p;
  s7_pointer text_view, iter, within_margin, use_align, xalign, yalign;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 2, iter, "GtkTextIter*");
  within_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(within_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 3, within_margin, "gdouble");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 4, use_align, "gboolean");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 5, xalign, "gdouble");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 6, yalign, "gdouble");
  return(s7_make_boolean(sc, gtk_text_view_scroll_to_iter(s7_c_pointer(text_view), s7_c_pointer(iter), s7_real(within_margin), lg_boolean(use_align), s7_real(xalign), s7_real(yalign))));
}

static s7_pointer lg_gtk_text_view_scroll_to_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_to_mark "void gtk_text_view_scroll_to_mark(GtkTextView* text_view, GtkTextMark* mark, \
gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  s7_pointer _p;
  s7_pointer text_view, mark, within_margin, use_align, xalign, yalign;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 1, text_view, "GtkTextView*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 2, mark, "GtkTextMark*");
  within_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(within_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 3, within_margin, "gdouble");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 4, use_align, "gboolean");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 5, xalign, "gdouble");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 6, yalign, "gdouble");
  gtk_text_view_scroll_to_mark(s7_c_pointer(text_view), s7_c_pointer(mark), s7_real(within_margin), lg_boolean(use_align), s7_real(xalign), s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_scroll_mark_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_mark_onscreen "void gtk_text_view_scroll_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer text_view, mark;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_mark_onscreen", 1, text_view, "GtkTextView*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_mark_onscreen", 2, mark, "GtkTextMark*");
  gtk_text_view_scroll_mark_onscreen(s7_c_pointer(text_view), s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_move_mark_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_mark_onscreen "gboolean gtk_text_view_move_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer text_view, mark;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_mark_onscreen", 1, text_view, "GtkTextView*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_mark_onscreen", 2, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_view_move_mark_onscreen(s7_c_pointer(text_view), s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_view_place_cursor_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_place_cursor_onscreen "gboolean gtk_text_view_place_cursor_onscreen(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_place_cursor_onscreen", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_place_cursor_onscreen(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_get_visible_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_visible_rect "void gtk_text_view_get_visible_rect(GtkTextView* text_view, \
GdkRectangle* visible_rect)"
  s7_pointer _p;
  s7_pointer text_view, visible_rect;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_visible_rect", 1, text_view, "GtkTextView*");
  visible_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(visible_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_visible_rect", 2, visible_rect, "GdkRectangle*");
  gtk_text_view_get_visible_rect(s7_c_pointer(text_view), s7_c_pointer(visible_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_cursor_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_cursor_visible "void gtk_text_view_set_cursor_visible(GtkTextView* text_view, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer text_view, setting;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_cursor_visible", 1, text_view, "GtkTextView*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_cursor_visible", 2, setting, "gboolean");
  gtk_text_view_set_cursor_visible(s7_c_pointer(text_view), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_cursor_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_cursor_visible "gboolean gtk_text_view_get_cursor_visible(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_cursor_visible", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_cursor_visible(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_get_iter_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_location "void gtk_text_view_get_iter_location(GtkTextView* text_view, \
GtkTextIter* iter, GdkRectangle* location)"
  s7_pointer _p;
  s7_pointer text_view, iter, location;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 2, iter, "GtkTextIter*");
  location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(location, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 3, location, "GdkRectangle*");
  gtk_text_view_get_iter_location(s7_c_pointer(text_view), s7_c_pointer(iter), s7_c_pointer(location));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_line_yrange(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_line_yrange "void gtk_text_view_get_line_yrange(GtkTextView* text_view, \
GtkTextIter* iter, gint* [y], gint* [height])"
  s7_pointer _p;
  s7_pointer text_view, iter;
  gint ref_y;
  gint ref_height;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_yrange", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_yrange", 2, iter, "GtkTextIter*");
  gtk_text_view_get_line_yrange(s7_c_pointer(text_view), s7_c_pointer(iter), &ref_y, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_y), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_text_view_get_line_at_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_line_at_y "void gtk_text_view_get_line_at_y(GtkTextView* text_view, GtkTextIter* target_iter, \
gint y, gint* [line_top])"
  s7_pointer _p;
  s7_pointer text_view, target_iter, y;
  gint ref_line_top;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 1, text_view, "GtkTextView*");
  target_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 2, target_iter, "GtkTextIter*");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 3, y, "gint");
  gtk_text_view_get_line_at_y(s7_c_pointer(text_view), s7_c_pointer(target_iter), s7_integer(y), &ref_line_top);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_line_top)));
}

static s7_pointer lg_gtk_text_view_buffer_to_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_buffer_to_window_coords "void gtk_text_view_buffer_to_window_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint buffer_x, gint buffer_y, gint* [window_x], gint* [window_y])"
  s7_pointer _p;
  s7_pointer text_view, win, buffer_x, buffer_y;
  gint ref_window_x;
  gint ref_window_y;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 2, win, "GtkTextWindowType");
  buffer_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(buffer_x)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 3, buffer_x, "gint");
  buffer_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(buffer_y)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 4, buffer_y, "gint");
  gtk_text_view_buffer_to_window_coords(s7_c_pointer(text_view), s7_integer(win), s7_integer(buffer_x), s7_integer(buffer_y), &ref_window_x, &ref_window_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_window_x), s7_make_integer(sc, ref_window_y)));
}

static s7_pointer lg_gtk_text_view_window_to_buffer_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_window_to_buffer_coords "void gtk_text_view_window_to_buffer_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint window_x, gint window_y, gint* [buffer_x], gint* [buffer_y])"
  s7_pointer _p;
  s7_pointer text_view, win, window_x, window_y;
  gint ref_buffer_x;
  gint ref_buffer_y;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 2, win, "GtkTextWindowType");
  window_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(window_x)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 3, window_x, "gint");
  window_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(window_y)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 4, window_y, "gint");
  gtk_text_view_window_to_buffer_coords(s7_c_pointer(text_view), s7_integer(win), s7_integer(window_x), s7_integer(window_y), &ref_buffer_x, &ref_buffer_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_buffer_x), s7_make_integer(sc, ref_buffer_y)));
}

static s7_pointer lg_gtk_text_view_get_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_window "GdkWindow* gtk_text_view_get_window(GtkTextView* text_view, GtkTextWindowType win)"
  s7_pointer _p;
  s7_pointer text_view, win;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_window", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_window", 2, win, "GtkTextWindowType");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gtk_text_view_get_window(s7_c_pointer(text_view), s7_integer(win))));
}

static s7_pointer lg_gtk_text_view_get_window_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_window_type "GtkTextWindowType gtk_text_view_get_window_type(GtkTextView* text_view, \
GdkWindow* window)"
  s7_pointer _p;
  s7_pointer text_view, window;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_window_type", 1, text_view, "GtkTextView*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_window_type", 2, window, "GdkWindow*");
  return(s7_make_integer(sc, gtk_text_view_get_window_type(s7_c_pointer(text_view), s7_c_pointer(window))));
}

static s7_pointer lg_gtk_text_view_set_border_window_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_border_window_size "void gtk_text_view_set_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type, gint size)"
  s7_pointer _p;
  s7_pointer text_view, type, size;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 1, text_view, "GtkTextView*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 2, type, "GtkTextWindowType");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 3, size, "gint");
  gtk_text_view_set_border_window_size(s7_c_pointer(text_view), s7_integer(type), s7_integer(size));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_border_window_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_border_window_size "gint gtk_text_view_get_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type)"
  s7_pointer _p;
  s7_pointer text_view, type;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_border_window_size", 1, text_view, "GtkTextView*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_border_window_size", 2, type, "GtkTextWindowType");
  return(s7_make_integer(sc, gtk_text_view_get_border_window_size(s7_c_pointer(text_view), s7_integer(type))));
}

static s7_pointer lg_gtk_text_view_forward_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_forward_display_line "gboolean gtk_text_view_forward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_forward_display_line(s7_c_pointer(text_view), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_backward_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_backward_display_line "gboolean gtk_text_view_backward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_backward_display_line(s7_c_pointer(text_view), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_forward_display_line_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_forward_display_line_end "gboolean gtk_text_view_forward_display_line_end(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line_end", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line_end", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_forward_display_line_end(s7_c_pointer(text_view), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_backward_display_line_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_backward_display_line_start "gboolean gtk_text_view_backward_display_line_start(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line_start", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line_start", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_backward_display_line_start(s7_c_pointer(text_view), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_starts_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_starts_display_line "gboolean gtk_text_view_starts_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_starts_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_starts_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_starts_display_line(s7_c_pointer(text_view), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_move_visually(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_visually "gboolean gtk_text_view_move_visually(GtkTextView* text_view, \
GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer text_view, iter, count;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 2, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 3, count, "gint");
  return(s7_make_boolean(sc, gtk_text_view_move_visually(s7_c_pointer(text_view), s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_view_add_child_at_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_add_child_at_anchor "void gtk_text_view_add_child_at_anchor(GtkTextView* text_view, \
GtkWidget* child, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer text_view, child, anchor;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 2, child, "GtkWidget*");
  anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_view_add_child_at_anchor(s7_c_pointer(text_view), s7_c_pointer(child), s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_add_child_in_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_add_child_in_window "void gtk_text_view_add_child_in_window(GtkTextView* text_view, \
GtkWidget* child, GtkTextWindowType which_window, gint xpos, gint ypos)"
  s7_pointer _p;
  s7_pointer text_view, child, which_window, xpos, ypos;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_in_window", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_in_window", 2, child, "GtkWidget*");
  which_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(which_window)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_in_window", 3, which_window, "GtkTextWindowType");
  xpos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpos)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_in_window", 4, xpos, "gint");
  ypos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ypos)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_in_window", 5, ypos, "gint");
  gtk_text_view_add_child_in_window(s7_c_pointer(text_view), s7_c_pointer(child), s7_integer(which_window), s7_integer(xpos), s7_integer(ypos));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_move_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_child "void gtk_text_view_move_child(GtkTextView* text_view, GtkWidget* child, \
gint xpos, gint ypos)"
  s7_pointer _p;
  s7_pointer text_view, child, xpos, ypos;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_child", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_child", 2, child, "GtkWidget*");
  xpos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpos)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_child", 3, xpos, "gint");
  ypos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ypos)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_child", 4, ypos, "gint");
  gtk_text_view_move_child(s7_c_pointer(text_view), s7_c_pointer(child), s7_integer(xpos), s7_integer(ypos));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_wrap_mode "void gtk_text_view_set_wrap_mode(GtkTextView* text_view, GtkWrapMode wrap_mode)"
  s7_pointer _p;
  s7_pointer text_view, wrap_mode;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_wrap_mode", 1, text_view, "GtkTextView*");
  wrap_mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wrap_mode)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_wrap_mode", 2, wrap_mode, "GtkWrapMode");
  gtk_text_view_set_wrap_mode(s7_c_pointer(text_view), s7_integer(wrap_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_wrap_mode "GtkWrapMode gtk_text_view_get_wrap_mode(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_wrap_mode", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_wrap_mode(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_editable "void gtk_text_view_set_editable(GtkTextView* text_view, gboolean setting)"
  s7_pointer _p;
  s7_pointer text_view, setting;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_editable", 1, text_view, "GtkTextView*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_editable", 2, setting, "gboolean");
  gtk_text_view_set_editable(s7_c_pointer(text_view), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_editable "gboolean gtk_text_view_get_editable(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_editable", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_editable(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_above_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_above_lines "void gtk_text_view_set_pixels_above_lines(GtkTextView* text_view, \
gint pixels_above_lines)"
  s7_pointer _p;
  s7_pointer text_view, pixels_above_lines;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_above_lines", 1, text_view, "GtkTextView*");
  pixels_above_lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pixels_above_lines)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_above_lines", 2, pixels_above_lines, "gint");
  gtk_text_view_set_pixels_above_lines(s7_c_pointer(text_view), s7_integer(pixels_above_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_above_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_above_lines "gint gtk_text_view_get_pixels_above_lines(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_above_lines", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_above_lines(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_below_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_below_lines "void gtk_text_view_set_pixels_below_lines(GtkTextView* text_view, \
gint pixels_below_lines)"
  s7_pointer _p;
  s7_pointer text_view, pixels_below_lines;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_below_lines", 1, text_view, "GtkTextView*");
  pixels_below_lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pixels_below_lines)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_below_lines", 2, pixels_below_lines, "gint");
  gtk_text_view_set_pixels_below_lines(s7_c_pointer(text_view), s7_integer(pixels_below_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_below_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_below_lines "gint gtk_text_view_get_pixels_below_lines(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_below_lines", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_below_lines(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_inside_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_inside_wrap "void gtk_text_view_set_pixels_inside_wrap(GtkTextView* text_view, \
gint pixels_inside_wrap)"
  s7_pointer _p;
  s7_pointer text_view, pixels_inside_wrap;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_inside_wrap", 1, text_view, "GtkTextView*");
  pixels_inside_wrap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pixels_inside_wrap)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_inside_wrap", 2, pixels_inside_wrap, "gint");
  gtk_text_view_set_pixels_inside_wrap(s7_c_pointer(text_view), s7_integer(pixels_inside_wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_inside_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_inside_wrap "gint gtk_text_view_get_pixels_inside_wrap(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_inside_wrap", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_inside_wrap(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_justification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_justification "void gtk_text_view_set_justification(GtkTextView* text_view, \
GtkJustification justification)"
  s7_pointer _p;
  s7_pointer text_view, justification;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_justification", 1, text_view, "GtkTextView*");
  justification = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(justification)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_justification", 2, justification, "GtkJustification");
  gtk_text_view_set_justification(s7_c_pointer(text_view), s7_integer(justification));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_justification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_justification "GtkJustification gtk_text_view_get_justification(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_justification", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_justification(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_left_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_left_margin "void gtk_text_view_set_left_margin(GtkTextView* text_view, \
gint left_margin)"
  s7_pointer _p;
  s7_pointer text_view, left_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_left_margin", 1, text_view, "GtkTextView*");
  left_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_left_margin", 2, left_margin, "gint");
  gtk_text_view_set_left_margin(s7_c_pointer(text_view), s7_integer(left_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_left_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_left_margin "gint gtk_text_view_get_left_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_left_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_left_margin(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_right_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_right_margin "void gtk_text_view_set_right_margin(GtkTextView* text_view, \
gint right_margin)"
  s7_pointer _p;
  s7_pointer text_view, right_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_right_margin", 1, text_view, "GtkTextView*");
  right_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(right_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_right_margin", 2, right_margin, "gint");
  gtk_text_view_set_right_margin(s7_c_pointer(text_view), s7_integer(right_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_right_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_right_margin "gint gtk_text_view_get_right_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_right_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_right_margin(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_indent "void gtk_text_view_set_indent(GtkTextView* text_view, gint indent)"
  s7_pointer _p;
  s7_pointer text_view, indent;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_indent", 1, text_view, "GtkTextView*");
  indent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(indent)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_indent", 2, indent, "gint");
  gtk_text_view_set_indent(s7_c_pointer(text_view), s7_integer(indent));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_indent "gint gtk_text_view_get_indent(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_indent", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_indent(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_tabs "void gtk_text_view_set_tabs(GtkTextView* text_view, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer text_view, tabs;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_tabs", 1, text_view, "GtkTextView*");
  tabs = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) && (tabs != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_tabs", 2, tabs, "PangoTabArray*");
  gtk_text_view_set_tabs(s7_c_pointer(text_view), s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_tabs "PangoTabArray* gtk_text_view_get_tabs(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_tabs", 1, text_view, "GtkTextView*");
  return(s7_make_type_with_c_pointer(sc, PangoTabArray__sym, gtk_text_view_get_tabs(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_toggle_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new "GtkWidget* gtk_toggle_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_toggle_button_new()));
}

static s7_pointer lg_gtk_toggle_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new_with_label "GtkWidget* gtk_toggle_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_new_with_label", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_toggle_button_new_with_label(s7_string(label))));
}

static s7_pointer lg_gtk_toggle_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new_with_mnemonic "GtkWidget* gtk_toggle_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_toggle_button_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_toggle_button_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_set_active "void gtk_toggle_button_set_active(GtkToggleButton* toggle_button, \
gboolean is_active)"
  s7_pointer _p;
  s7_pointer toggle_button, is_active;
  _p = args;
  toggle_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_set_active", 1, toggle_button, "GtkToggleButton*");
  is_active = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_set_active", 2, is_active, "gboolean");
  gtk_toggle_button_set_active(s7_c_pointer(toggle_button), lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_toggle_button_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_get_active "gboolean gtk_toggle_button_get_active(GtkToggleButton* toggle_button)"
  s7_pointer toggle_button;
  toggle_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_get_active", 1, toggle_button, "GtkToggleButton*");
  return(s7_make_boolean(sc, gtk_toggle_button_get_active(s7_c_pointer(toggle_button))));
}

static s7_pointer lg_gtk_toggle_button_toggled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_toggled "void gtk_toggle_button_toggled(GtkToggleButton* toggle_button)"
  s7_pointer toggle_button;
  toggle_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_toggled", 1, toggle_button, "GtkToggleButton*");
  gtk_toggle_button_toggled(s7_c_pointer(toggle_button));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_new "GtkWidget* gtk_toolbar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_toolbar_new()));
}

static s7_pointer lg_gtk_toolbar_set_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_set_style "void gtk_toolbar_set_style(GtkToolbar* toolbar, GtkToolbarStyle style)"
  s7_pointer _p;
  s7_pointer toolbar, style;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_style", 1, toolbar, "GtkToolbar*");
  style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_style", 2, style, "GtkToolbarStyle");
  gtk_toolbar_set_style(s7_c_pointer(toolbar), s7_integer(style));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_unset_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_unset_style "void gtk_toolbar_unset_style(GtkToolbar* toolbar)"
  s7_pointer toolbar;
  toolbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_unset_style", 1, toolbar, "GtkToolbar*");
  gtk_toolbar_unset_style(s7_c_pointer(toolbar));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_get_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_style "GtkToolbarStyle gtk_toolbar_get_style(GtkToolbar* toolbar)"
  s7_pointer toolbar;
  toolbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_style", 1, toolbar, "GtkToolbar*");
  return(s7_make_integer(sc, gtk_toolbar_get_style(s7_c_pointer(toolbar))));
}

static s7_pointer lg_gtk_tree_drag_source_row_draggable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_source_row_draggable "gboolean gtk_tree_drag_source_row_draggable(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer drag_source, path;
  _p = args;
  drag_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_source, GtkTreeDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_row_draggable", 1, drag_source, "GtkTreeDragSource*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_row_draggable", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_drag_source_row_draggable(s7_c_pointer(drag_source), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_drag_source_drag_data_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_source_drag_data_delete "gboolean gtk_tree_drag_source_drag_data_delete(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer drag_source, path;
  _p = args;
  drag_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_source, GtkTreeDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_delete", 1, drag_source, "GtkTreeDragSource*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_delete", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_drag_source_drag_data_delete(s7_c_pointer(drag_source), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_drag_source_drag_data_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_source_drag_data_get "gboolean gtk_tree_drag_source_drag_data_get(GtkTreeDragSource* drag_source, \
GtkTreePath* path, GtkSelectionData* selection_data)"
  s7_pointer _p;
  s7_pointer drag_source, path, selection_data;
  _p = args;
  drag_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_source, GtkTreeDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_get", 1, drag_source, "GtkTreeDragSource*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_get", 2, path, "GtkTreePath*");
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_get", 3, selection_data, "GtkSelectionData*");
  return(s7_make_boolean(sc, gtk_tree_drag_source_drag_data_get(s7_c_pointer(drag_source), s7_c_pointer(path), s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_tree_drag_dest_drag_data_received(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_dest_drag_data_received "gboolean gtk_tree_drag_dest_drag_data_received(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest, GtkSelectionData* selection_data)"
  s7_pointer _p;
  s7_pointer drag_dest, dest, selection_data;
  _p = args;
  drag_dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_dest, GtkTreeDragDest__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 1, drag_dest, "GtkTreeDragDest*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 2, dest, "GtkTreePath*");
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 3, selection_data, "GtkSelectionData*");
  return(s7_make_boolean(sc, gtk_tree_drag_dest_drag_data_received(s7_c_pointer(drag_dest), s7_c_pointer(dest), s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_tree_drag_dest_row_drop_possible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_dest_row_drop_possible "gboolean gtk_tree_drag_dest_row_drop_possible(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest_path, GtkSelectionData* selection_data)"
  s7_pointer _p;
  s7_pointer drag_dest, dest_path, selection_data;
  _p = args;
  drag_dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_dest, GtkTreeDragDest__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 1, drag_dest, "GtkTreeDragDest*");
  dest_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 2, dest_path, "GtkTreePath*");
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 3, selection_data, "GtkSelectionData*");
  return(s7_make_boolean(sc, gtk_tree_drag_dest_row_drop_possible(s7_c_pointer(drag_dest), s7_c_pointer(dest_path), s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_tree_set_row_drag_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_set_row_drag_data "gboolean gtk_tree_set_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel* tree_model, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection_data, tree_model, path;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_set_row_drag_data", 1, selection_data, "GtkSelectionData*");
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_set_row_drag_data", 2, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_set_row_drag_data", 3, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_set_row_drag_data(s7_c_pointer(selection_data), s7_c_pointer(tree_model), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_get_row_drag_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_get_row_drag_data "gboolean gtk_tree_get_row_drag_data(GtkSelectionData* selection_data, \
GtkTreeModel** [tree_model], GtkTreePath** [path])"
  s7_pointer _p;
  s7_pointer selection_data;
  GtkTreeModel* ref_tree_model = NULL;
  GtkTreePath* ref_path = NULL;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_get_row_drag_data", 1, selection_data, "GtkSelectionData*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_get_row_drag_data(s7_c_pointer(selection_data), &ref_tree_model, &ref_path));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_tree_model), s7_make_c_pointer(sc, ref_path)));
   }
}

static s7_pointer lg_gtk_tree_path_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new "GtkTreePath* gtk_tree_path_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_path_new()));
}

static s7_pointer lg_gtk_tree_path_new_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new_from_string "GtkTreePath* gtk_tree_path_new_from_string(gchar* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_tree_path_new_from_string", 1, path, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_path_new_from_string(s7_string(path))));
}

static s7_pointer lg_gtk_tree_path_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_to_string "gchar* gtk_tree_path_to_string(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_to_string", 1, path, "GtkTreePath*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_tree_path_to_string(s7_c_pointer(path));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_tree_path_new_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new_first "GtkTreePath* gtk_tree_path_new_first( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_path_new_first()));
}

static s7_pointer lg_gtk_tree_path_append_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_append_index "void gtk_tree_path_append_index(GtkTreePath* path, gint index)"
  s7_pointer _p;
  s7_pointer path, index;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_append_index", 1, path, "GtkTreePath*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_path_append_index", 2, index, "gint");
  gtk_tree_path_append_index(s7_c_pointer(path), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_prepend_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_prepend_index "void gtk_tree_path_prepend_index(GtkTreePath* path, gint index)"
  s7_pointer _p;
  s7_pointer path, index;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prepend_index", 1, path, "GtkTreePath*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prepend_index", 2, index, "gint");
  gtk_tree_path_prepend_index(s7_c_pointer(path), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_get_depth(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_get_depth "gint gtk_tree_path_get_depth(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_get_depth", 1, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_tree_path_get_depth(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_get_indices(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_get_indices "gint* gtk_tree_path_get_indices(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_get_indices", 1, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, gint__sym, gtk_tree_path_get_indices(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_free "void gtk_tree_path_free(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_free", 1, path, "GtkTreePath*");
  gtk_tree_path_free(s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_copy "GtkTreePath* gtk_tree_path_copy(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_copy", 1, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_path_copy(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_compare(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_compare "gint gtk_tree_path_compare(GtkTreePath* a, GtkTreePath* b)"
  s7_pointer _p;
  s7_pointer a, b;
  _p = args;
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_compare", 1, a, "GtkTreePath*");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_compare", 2, b, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_tree_path_compare(s7_c_pointer(a), s7_c_pointer(b))));
}

static s7_pointer lg_gtk_tree_path_next(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_next "void gtk_tree_path_next(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_next", 1, path, "GtkTreePath*");
  gtk_tree_path_next(s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_prev(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_prev "gboolean gtk_tree_path_prev(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prev", 1, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_prev(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_up "gboolean gtk_tree_path_up(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_up", 1, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_up(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_down(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_down "void gtk_tree_path_down(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_down", 1, path, "GtkTreePath*");
  gtk_tree_path_down(s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_is_ancestor "gboolean gtk_tree_path_is_ancestor(GtkTreePath* path, GtkTreePath* descendant)"
  s7_pointer _p;
  s7_pointer path, descendant;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_ancestor", 1, path, "GtkTreePath*");
  descendant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(descendant, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_ancestor", 2, descendant, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_is_ancestor(s7_c_pointer(path), s7_c_pointer(descendant))));
}

static s7_pointer lg_gtk_tree_path_is_descendant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_is_descendant "gboolean gtk_tree_path_is_descendant(GtkTreePath* path, GtkTreePath* ancestor)"
  s7_pointer _p;
  s7_pointer path, ancestor;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_descendant", 1, path, "GtkTreePath*");
  ancestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ancestor, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_descendant", 2, ancestor, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_is_descendant(s7_c_pointer(path), s7_c_pointer(ancestor))));
}

static s7_pointer lg_gtk_tree_row_reference_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_new "GtkTreeRowReference* gtk_tree_row_reference_new(GtkTreeModel* model, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer model, path;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new", 1, model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new", 2, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeRowReference__sym, gtk_tree_row_reference_new(s7_c_pointer(model), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_row_reference_new_proxy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_new_proxy "GtkTreeRowReference* gtk_tree_row_reference_new_proxy(GObject* proxy, \
GtkTreeModel* model, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, model, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 1, proxy, "GObject*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 2, model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 3, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeRowReference__sym, gtk_tree_row_reference_new_proxy(s7_c_pointer(proxy), s7_c_pointer(model), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_row_reference_get_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_get_path "GtkTreePath* gtk_tree_row_reference_get_path(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_get_path", 1, reference, "GtkTreeRowReference*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_row_reference_get_path(s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_row_reference_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_valid "gboolean gtk_tree_row_reference_valid(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_valid", 1, reference, "GtkTreeRowReference*");
  return(s7_make_boolean(sc, gtk_tree_row_reference_valid(s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_row_reference_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_free "void gtk_tree_row_reference_free(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_free", 1, reference, "GtkTreeRowReference*");
  gtk_tree_row_reference_free(s7_c_pointer(reference));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_inserted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_inserted "void gtk_tree_row_reference_inserted(GObject* proxy, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_inserted", 1, proxy, "GObject*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_inserted", 2, path, "GtkTreePath*");
  gtk_tree_row_reference_inserted(s7_c_pointer(proxy), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_deleted "void gtk_tree_row_reference_deleted(GObject* proxy, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_deleted", 1, proxy, "GObject*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_deleted", 2, path, "GtkTreePath*");
  gtk_tree_row_reference_deleted(s7_c_pointer(proxy), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_reordered(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_reordered "void gtk_tree_row_reference_reordered(GObject* proxy, GtkTreePath* path, \
GtkTreeIter* iter, gint* new_order)"
  s7_pointer _p;
  s7_pointer proxy, path, iter, new_order;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 1, proxy, "GObject*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 4, new_order, "gint*");
  gtk_tree_row_reference_reordered(s7_c_pointer(proxy), s7_c_pointer(path), s7_c_pointer(iter), s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_iter_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_iter_copy "GtkTreeIter* gtk_tree_iter_copy(GtkTreeIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_iter_copy", 1, iter, "GtkTreeIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeIter__sym, gtk_tree_iter_copy(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_iter_free "void gtk_tree_iter_free(GtkTreeIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_iter_free", 1, iter, "GtkTreeIter*");
  gtk_tree_iter_free(s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_get_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_flags "GtkTreeModelFlags gtk_tree_model_get_flags(GtkTreeModel* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_flags", 1, tree_model, "GtkTreeModel*");
  return(s7_make_integer(sc, gtk_tree_model_get_flags(s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_get_n_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_n_columns "gint gtk_tree_model_get_n_columns(GtkTreeModel* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_n_columns", 1, tree_model, "GtkTreeModel*");
  return(s7_make_integer(sc, gtk_tree_model_get_n_columns(s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_get_column_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_column_type "GType gtk_tree_model_get_column_type(GtkTreeModel* tree_model, \
gint index)"
  s7_pointer _p;
  s7_pointer tree_model, index;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_column_type", 1, tree_model, "GtkTreeModel*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_column_type", 2, index, "gint");
  return(s7_make_integer(sc, gtk_tree_model_get_column_type(s7_c_pointer(tree_model), s7_integer(index))));
}

static s7_pointer lg_gtk_tree_model_get_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter "gboolean gtk_tree_model_get_iter(GtkTreeModel* tree_model, GtkTreeIter* iter, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_model, iter, path;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 2, iter, "GtkTreeIter*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 3, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter(s7_c_pointer(tree_model), s7_c_pointer(iter), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_model_get_iter_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter_from_string "gboolean gtk_tree_model_get_iter_from_string(GtkTreeModel* tree_model, \
GtkTreeIter* iter, gchar* path_string)"
  s7_pointer _p;
  s7_pointer tree_model, iter, path_string;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 2, iter, "GtkTreeIter*");
  path_string = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path_string)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 3, path_string, "gchar*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter_from_string(s7_c_pointer(tree_model), s7_c_pointer(iter), s7_string(path_string))));
}

static s7_pointer lg_gtk_tree_model_get_iter_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter_first "gboolean gtk_tree_model_get_iter_first(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_first", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_first", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter_first(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_get_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_path "GtkTreePath* gtk_tree_model_get_path(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_path", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_path", 2, iter, "GtkTreeIter*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_model_get_path(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_next(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_next "gboolean gtk_tree_model_iter_next(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_next", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_next", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_next(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_children "gboolean gtk_tree_model_iter_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_model, iter, parent;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 3, parent, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_children(s7_c_pointer(tree_model), s7_c_pointer(iter), s7_c_pointer(parent))));
}

static s7_pointer lg_gtk_tree_model_iter_has_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_has_child "gboolean gtk_tree_model_iter_has_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_has_child", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_has_child", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_has_child(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_n_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_n_children "gint gtk_tree_model_iter_n_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_n_children", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_n_children", 2, iter, "GtkTreeIter*");
  return(s7_make_integer(sc, gtk_tree_model_iter_n_children(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_nth_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_nth_child "gboolean gtk_tree_model_iter_nth_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent, gint n)"
  s7_pointer _p;
  s7_pointer tree_model, iter, parent, n;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 3, parent, "GtkTreeIter*");
  n = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 4, n, "gint");
  return(s7_make_boolean(sc, gtk_tree_model_iter_nth_child(s7_c_pointer(tree_model), s7_c_pointer(iter), s7_c_pointer(parent), s7_integer(n))));
}

static s7_pointer lg_gtk_tree_model_iter_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_parent "gboolean gtk_tree_model_iter_parent(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* child)"
  s7_pointer _p;
  s7_pointer tree_model, iter, child;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 2, iter, "GtkTreeIter*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 3, child, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_parent(s7_c_pointer(tree_model), s7_c_pointer(iter), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_tree_model_ref_node(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_ref_node "void gtk_tree_model_ref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_ref_node", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_ref_node", 2, iter, "GtkTreeIter*");
  gtk_tree_model_ref_node(s7_c_pointer(tree_model), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_unref_node(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_unref_node "void gtk_tree_model_unref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_unref_node", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_unref_node", 2, iter, "GtkTreeIter*");
  gtk_tree_model_unref_node(s7_c_pointer(tree_model), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_foreach "void gtk_tree_model_foreach(GtkTreeModel* model, GtkTreeModelForeachFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer model, func, func_info;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_foreach", 1, model, "GtkTreeModel*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeModelForeachFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_foreach", 2, func, "GtkTreeModelForeachFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_foreach", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_model_foreach(s7_c_pointer(model), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_model_row_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_changed "void gtk_tree_model_row_changed(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_changed(s7_c_pointer(tree_model), s7_c_pointer(path), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_inserted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_inserted "void gtk_tree_model_row_inserted(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_inserted(s7_c_pointer(tree_model), s7_c_pointer(path), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_has_child_toggled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_has_child_toggled "void gtk_tree_model_row_has_child_toggled(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_has_child_toggled(s7_c_pointer(tree_model), s7_c_pointer(path), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_deleted "void gtk_tree_model_row_deleted(GtkTreeModel* tree_model, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_model, path;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_deleted", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_deleted", 2, path, "GtkTreePath*");
  gtk_tree_model_row_deleted(s7_c_pointer(tree_model), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_rows_reordered(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_rows_reordered "void gtk_tree_model_rows_reordered(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter, new_order;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 4, new_order, "gint*");
  gtk_tree_model_rows_reordered(s7_c_pointer(tree_model), s7_c_pointer(path), s7_c_pointer(iter), s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_new_with_model "GtkTreeModel* gtk_tree_model_sort_new_with_model(GtkTreeModel* child_model)"
  s7_pointer child_model;
  child_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(child_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_new_with_model", 1, child_model, "GtkTreeModel*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_model_sort_new_with_model(s7_c_pointer(child_model))));
}

static s7_pointer lg_gtk_tree_model_sort_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_get_model "GtkTreeModel* gtk_tree_model_sort_get_model(GtkTreeModelSort* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_get_model", 1, tree_model, "GtkTreeModelSort*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_model_sort_get_model(s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_child_path_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_child_path_to_path "GtkTreePath* gtk_tree_model_sort_convert_child_path_to_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* child_path)"
  s7_pointer _p;
  s7_pointer tree_model_sort, child_path;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_path_to_path", 1, tree_model_sort, "GtkTreeModelSort*");
  child_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_path_to_path", 2, child_path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_model_sort_convert_child_path_to_path(s7_c_pointer(tree_model_sort), s7_c_pointer(child_path))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_child_iter_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_child_iter_to_iter "void gtk_tree_model_sort_convert_child_iter_to_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* sort_iter, GtkTreeIter* child_iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, sort_iter, child_iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 1, tree_model_sort, "GtkTreeModelSort*");
  sort_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sort_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 2, sort_iter, "GtkTreeIter*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 3, child_iter, "GtkTreeIter*");
  gtk_tree_model_sort_convert_child_iter_to_iter(s7_c_pointer(tree_model_sort), s7_c_pointer(sort_iter), s7_c_pointer(child_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_convert_path_to_child_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_path_to_child_path "GtkTreePath* gtk_tree_model_sort_convert_path_to_child_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* sorted_path)"
  s7_pointer _p;
  s7_pointer tree_model_sort, sorted_path;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_path_to_child_path", 1, tree_model_sort, "GtkTreeModelSort*");
  sorted_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sorted_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_path_to_child_path", 2, sorted_path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_model_sort_convert_path_to_child_path(s7_c_pointer(tree_model_sort), s7_c_pointer(sorted_path))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_iter_to_child_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_iter_to_child_iter "void gtk_tree_model_sort_convert_iter_to_child_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* child_iter, GtkTreeIter* sorted_iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, child_iter, sorted_iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 1, tree_model_sort, "GtkTreeModelSort*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 2, child_iter, "GtkTreeIter*");
  sorted_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sorted_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 3, sorted_iter, "GtkTreeIter*");
  gtk_tree_model_sort_convert_iter_to_child_iter(s7_c_pointer(tree_model_sort), s7_c_pointer(child_iter), s7_c_pointer(sorted_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_reset_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_reset_default_sort_func "void gtk_tree_model_sort_reset_default_sort_func(GtkTreeModelSort* tree_model_sort)"
  s7_pointer tree_model_sort;
  tree_model_sort = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_reset_default_sort_func", 1, tree_model_sort, "GtkTreeModelSort*");
  gtk_tree_model_sort_reset_default_sort_func(s7_c_pointer(tree_model_sort));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_clear_cache(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_clear_cache "void gtk_tree_model_sort_clear_cache(GtkTreeModelSort* tree_model_sort)"
  s7_pointer tree_model_sort;
  tree_model_sort = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_clear_cache", 1, tree_model_sort, "GtkTreeModelSort*");
  gtk_tree_model_sort_clear_cache(s7_c_pointer(tree_model_sort));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_set_mode "void gtk_tree_selection_set_mode(GtkTreeSelection* selection, \
GtkSelectionMode type)"
  s7_pointer _p;
  s7_pointer selection, type;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_mode", 1, selection, "GtkTreeSelection*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_mode", 2, type, "GtkSelectionMode");
  gtk_tree_selection_set_mode(s7_c_pointer(selection), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_mode "GtkSelectionMode gtk_tree_selection_get_mode(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_mode", 1, selection, "GtkTreeSelection*");
  return(s7_make_integer(sc, gtk_tree_selection_get_mode(s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_set_select_function(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_set_select_function "void gtk_tree_selection_set_select_function(GtkTreeSelection* selection, \
GtkTreeSelectionFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer selection, func, func_info, destroy;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_select_function", 1, selection, "GtkTreeSelection*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeSelectionFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_select_function", 2, func, "GtkTreeSelectionFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_select_function", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_select_function", 4, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_selection_set_select_function(s7_c_pointer(selection), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_selection_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_user_data "gpointer gtk_tree_selection_get_user_data(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_user_data", 1, selection, "GtkTreeSelection*");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, gtk_tree_selection_get_user_data(s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_get_tree_view(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_tree_view "GtkTreeView* gtk_tree_selection_get_tree_view(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_tree_view", 1, selection, "GtkTreeSelection*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeView__sym, gtk_tree_selection_get_tree_view(s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_get_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_selected "gboolean gtk_tree_selection_get_selected(GtkTreeSelection* selection, \
GtkTreeModel** model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, model, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 1, selection, "GtkTreeSelection*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 2, model, "GtkTreeModel**");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 3, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_selection_get_selected(s7_c_pointer(selection), s7_c_pointer(model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_selection_selected_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_selected_foreach "void gtk_tree_selection_selected_foreach(GtkTreeSelection* selection, \
GtkTreeSelectionForeachFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer selection, func, func_info;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_selected_foreach", 1, selection, "GtkTreeSelection*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeSelectionForeachFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_selected_foreach", 2, func, "GtkTreeSelectionForeachFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_selected_foreach", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_selection_selected_foreach(s7_c_pointer(selection), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_selection_select_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_path "void gtk_tree_selection_select_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_path", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_path", 2, path, "GtkTreePath*");
  gtk_tree_selection_select_path(s7_c_pointer(selection), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_path "void gtk_tree_selection_unselect_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_path", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_path", 2, path, "GtkTreePath*");
  gtk_tree_selection_unselect_path(s7_c_pointer(selection), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_select_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_iter "void gtk_tree_selection_select_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_iter", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_iter", 2, iter, "GtkTreeIter*");
  gtk_tree_selection_select_iter(s7_c_pointer(selection), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_iter "void gtk_tree_selection_unselect_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_iter", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_iter", 2, iter, "GtkTreeIter*");
  gtk_tree_selection_unselect_iter(s7_c_pointer(selection), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_path_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_path_is_selected "gboolean gtk_tree_selection_path_is_selected(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_path_is_selected", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_path_is_selected", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_selection_path_is_selected(s7_c_pointer(selection), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_selection_iter_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_iter_is_selected "gboolean gtk_tree_selection_iter_is_selected(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_iter_is_selected", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_iter_is_selected", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_selection_iter_is_selected(s7_c_pointer(selection), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_selection_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_all "void gtk_tree_selection_select_all(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_all", 1, selection, "GtkTreeSelection*");
  gtk_tree_selection_select_all(s7_c_pointer(selection));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_all "void gtk_tree_selection_unselect_all(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_all", 1, selection, "GtkTreeSelection*");
  gtk_tree_selection_unselect_all(s7_c_pointer(selection));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_select_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_range "void gtk_tree_selection_select_range(GtkTreeSelection* selection, \
GtkTreePath* start_path, GtkTreePath* end_path)"
  s7_pointer _p;
  s7_pointer selection, start_path, end_path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 1, selection, "GtkTreeSelection*");
  start_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 2, start_path, "GtkTreePath*");
  end_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 3, end_path, "GtkTreePath*");
  gtk_tree_selection_select_range(s7_c_pointer(selection), s7_c_pointer(start_path), s7_c_pointer(end_path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_sort_column_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_sort_column_changed "void gtk_tree_sortable_sort_column_changed(GtkTreeSortable* sortable)"
  s7_pointer sortable;
  sortable = s7_car(args);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_sort_column_changed", 1, sortable, "GtkTreeSortable*");
  gtk_tree_sortable_sort_column_changed(s7_c_pointer(sortable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_get_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_get_sort_column_id "gboolean gtk_tree_sortable_get_sort_column_id(GtkTreeSortable* sortable, \
gint* [sort_column_id], GtkSortType* [order])"
  s7_pointer _p;
  s7_pointer sortable;
  gint ref_sort_column_id;
  GtkSortType ref_order;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_get_sort_column_id", 1, sortable, "GtkTreeSortable*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_sortable_get_sort_column_id(s7_c_pointer(sortable), &ref_sort_column_id, &ref_order));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_sort_column_id), s7_make_integer(sc, ref_order)));
   }
}

static s7_pointer lg_gtk_tree_sortable_set_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_sort_column_id "void gtk_tree_sortable_set_sort_column_id(GtkTreeSortable* sortable, \
gint sort_column_id, GtkSortType order)"
  s7_pointer _p;
  s7_pointer sortable, sort_column_id, order;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 1, sortable, "GtkTreeSortable*");
  sort_column_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 2, sort_column_id, "gint");
  order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(order)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 3, order, "GtkSortType");
  gtk_tree_sortable_set_sort_column_id(s7_c_pointer(sortable), s7_integer(sort_column_id), s7_integer(order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_set_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_sort_func "void gtk_tree_sortable_set_sort_func(GtkTreeSortable* sortable, \
gint sort_column_id, GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer sortable, sort_column_id, func, func_info, destroy;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 1, sortable, "GtkTreeSortable*");
  sort_column_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 2, sort_column_id, "gint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeIterCompareFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 3, func, "GtkTreeIterCompareFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 4, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 5, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_sortable_set_sort_func(s7_c_pointer(sortable), s7_integer(sort_column_id), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_sortable_set_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_default_sort_func "void gtk_tree_sortable_set_default_sort_func(GtkTreeSortable* sortable, \
GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer sortable, func, func_info, destroy;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_default_sort_func", 1, sortable, "GtkTreeSortable*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeIterCompareFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_default_sort_func", 2, func, "GtkTreeIterCompareFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_default_sort_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_default_sort_func", 4, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_sortable_set_default_sort_func(s7_c_pointer(sortable), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_sortable_has_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_has_default_sort_func "gboolean gtk_tree_sortable_has_default_sort_func(GtkTreeSortable* sortable)"
  s7_pointer sortable;
  sortable = s7_car(args);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_has_default_sort_func", 1, sortable, "GtkTreeSortable*");
  return(s7_make_boolean(sc, gtk_tree_sortable_has_default_sort_func(s7_c_pointer(sortable))));
}

static s7_pointer lg_gtk_tree_store_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_new "GtkTreeStore* gtk_tree_store_new(gint n_columns, etc types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_new", 1, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(types)) s7_wrong_type_arg_error(sc, "gtk_tree_store_new", 2, types, "etc");
  {
    int etc_len = 0;
    GtkTreeStore* result = NULL;
    gint p_arg0;
    if (s7_is_list(sc, types)) etc_len = s7_list_length(sc, types);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_tree_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_tree_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = (gint)s7_integer(n_columns);
    switch (etc_len)
      {
        case 1: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0))); break;
        case 2: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1))); break;
        case 3: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2))); break;
        case 4: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3))); break;
        case 5: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4))); break;
        case 6: result = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4)), s7_c_pointer(s7_list_ref(sc, types, 5))); break;
      }
    return(s7_make_c_pointer(sc, result));
  }
}

static s7_pointer lg_gtk_tree_store_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_newv "GtkTreeStore* gtk_tree_store_newv(gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_newv", 1, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_newv", 2, types, "GType*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeStore__sym, gtk_tree_store_newv(s7_integer(n_columns), s7_c_pointer(types))));
}

static s7_pointer lg_gtk_tree_store_set_column_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_set_column_types "void gtk_tree_store_set_column_types(GtkTreeStore* tree_store, \
gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer tree_store, n_columns, types;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 1, tree_store, "GtkTreeStore*");
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 2, n_columns, "gint");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 3, types, "GType*");
  gtk_tree_store_set_column_types(s7_c_pointer(tree_store), s7_integer(n_columns), s7_c_pointer(types));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_set "void gtk_tree_store_set(GtkTreeStore* tree_store, GtkTreeIter* iter, \
etc values)"
  s7_pointer _p;
  s7_pointer tree_store, iter, values;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 2, iter, "GtkTreeIter*");
  values = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(values)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 3, values, "etc");
  {
    int etc_len = 0;
    GtkTreeStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (s7_is_list(sc, values)) etc_len = s7_list_length(sc, values);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeStore*)s7_c_pointer(tree_store);
    p_arg1 = (GtkTreeIter*)s7_c_pointer(iter);
    switch (etc_len)
      {
        case 2: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), -1); break;
        case 4: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), -1); break;
        case 6: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), -1); break;
        case 8: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), -1); break;
        case 10: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), s7_integer(s7_list_ref(sc, values, 8)), s7_string(s7_list_ref(sc, values, 9)), -1); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_tree_store_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_remove "void gtk_tree_store_remove(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_store, iter;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_remove", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_remove", 2, iter, "GtkTreeIter*");
  gtk_tree_store_remove(s7_c_pointer(tree_store), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert "void gtk_tree_store_insert(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, gint position)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, position;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 3, parent, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 4, position, "gint");
  gtk_tree_store_insert(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(parent), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert_before "void gtk_tree_store_insert_before(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* parent, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, sibling;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 3, parent, "GtkTreeIter*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 4, sibling, "GtkTreeIter*");
  gtk_tree_store_insert_before(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(parent), s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert_after "void gtk_tree_store_insert_after(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, sibling;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 3, parent, "GtkTreeIter*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 4, sibling, "GtkTreeIter*");
  gtk_tree_store_insert_after(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(parent), s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_prepend "void gtk_tree_store_prepend(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 3, parent, "GtkTreeIter*");
  gtk_tree_store_prepend(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_append "void gtk_tree_store_append(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 3, parent, "GtkTreeIter*");
  gtk_tree_store_append(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_is_ancestor "gboolean gtk_tree_store_is_ancestor(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* descendant)"
  s7_pointer _p;
  s7_pointer tree_store, iter, descendant;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 2, iter, "GtkTreeIter*");
  descendant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(descendant, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 3, descendant, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_store_is_ancestor(s7_c_pointer(tree_store), s7_c_pointer(iter), s7_c_pointer(descendant))));
}

static s7_pointer lg_gtk_tree_store_iter_depth(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_iter_depth "gint gtk_tree_store_iter_depth(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_store, iter;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_iter_depth", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_iter_depth", 2, iter, "GtkTreeIter*");
  return(s7_make_integer(sc, gtk_tree_store_iter_depth(s7_c_pointer(tree_store), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_store_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_clear "void gtk_tree_store_clear(GtkTreeStore* tree_store)"
  s7_pointer tree_store;
  tree_store = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_clear", 1, tree_store, "GtkTreeStore*");
  gtk_tree_store_clear(s7_c_pointer(tree_store));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new "GtkTreeViewColumn* gtk_tree_view_column_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewColumn__sym, gtk_tree_view_column_new()));
}

static s7_pointer lg_gtk_tree_view_column_new_with_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new_with_attributes "GtkTreeViewColumn* gtk_tree_view_column_new_with_attributes(gchar* title, \
GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer title, cell, attributes;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 1, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 2, cell, "GtkCellRenderer*");
  attributes = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* result = NULL;
    gchar* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (gchar*)s7_string(title);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: result = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(s7_make_c_pointer(sc, result));
  }
}

static s7_pointer lg_gtk_tree_view_column_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_pack_start "void gtk_tree_view_column_pack_start(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, cell, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 3, expand, "gboolean");
  gtk_tree_view_column_pack_start(s7_c_pointer(tree_column), s7_c_pointer(cell), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_pack_end "void gtk_tree_view_column_pack_end(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, cell, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 3, expand, "gboolean");
  gtk_tree_view_column_pack_end(s7_c_pointer(tree_column), s7_c_pointer(cell), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clear "void gtk_tree_view_column_clear(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_clear(s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_add_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_add_attribute "void gtk_tree_view_column_add_attribute(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gchar* attribute, gint column)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, attribute, column;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 2, cell_renderer, "GtkCellRenderer*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 3, attribute, "gchar*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 4, column, "gint");
  gtk_tree_view_column_add_attribute(s7_c_pointer(tree_column), s7_c_pointer(cell_renderer), s7_string(attribute), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_attributes "void gtk_tree_view_column_set_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, etc attributes)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, attributes;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 2, cell_renderer, "GtkCellRenderer*");
  attributes = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeViewColumn*)s7_c_pointer(tree_column);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell_renderer);
    switch (etc_len)
      {
        case 2: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_tree_view_column_set_cell_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_cell_data_func "void gtk_tree_view_column_set_cell_data_func(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, GtkTreeCellDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, func, func_info, destroy;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 2, cell_renderer, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeCellDataFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 3, func, "GtkTreeCellDataFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 4, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 5, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_column_set_cell_data_func(s7_c_pointer(tree_column), s7_c_pointer(cell_renderer), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_column_clear_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clear_attributes "void gtk_tree_view_column_clear_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear_attributes", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear_attributes", 2, cell_renderer, "GtkCellRenderer*");
  gtk_tree_view_column_clear_attributes(s7_c_pointer(tree_column), s7_c_pointer(cell_renderer));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_spacing "void gtk_tree_view_column_set_spacing(GtkTreeViewColumn* tree_column, \
gint spacing)"
  s7_pointer _p;
  s7_pointer tree_column, spacing;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_spacing", 1, tree_column, "GtkTreeViewColumn*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_spacing", 2, spacing, "gint");
  gtk_tree_view_column_set_spacing(s7_c_pointer(tree_column), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_spacing "gint gtk_tree_view_column_get_spacing(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_spacing", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_spacing(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_visible "void gtk_tree_view_column_set_visible(GtkTreeViewColumn* tree_column, \
gboolean visible)"
  s7_pointer _p;
  s7_pointer tree_column, visible;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_visible", 1, tree_column, "GtkTreeViewColumn*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_visible", 2, visible, "gboolean");
  gtk_tree_view_column_set_visible(s7_c_pointer(tree_column), lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_visible "gboolean gtk_tree_view_column_get_visible(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_visible", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_visible(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_resizable "void gtk_tree_view_column_set_resizable(GtkTreeViewColumn* tree_column, \
gboolean resizable)"
  s7_pointer _p;
  s7_pointer tree_column, resizable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_resizable", 1, tree_column, "GtkTreeViewColumn*");
  resizable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resizable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_resizable", 2, resizable, "gboolean");
  gtk_tree_view_column_set_resizable(s7_c_pointer(tree_column), lg_boolean(resizable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_resizable "gboolean gtk_tree_view_column_get_resizable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_resizable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_resizable(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sizing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sizing "void gtk_tree_view_column_set_sizing(GtkTreeViewColumn* tree_column, \
GtkTreeViewColumnSizing type)"
  s7_pointer _p;
  s7_pointer tree_column, type;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sizing", 1, tree_column, "GtkTreeViewColumn*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sizing", 2, type, "GtkTreeViewColumnSizing");
  gtk_tree_view_column_set_sizing(s7_c_pointer(tree_column), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sizing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sizing "GtkTreeViewColumnSizing gtk_tree_view_column_get_sizing(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sizing", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sizing(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_width "gint gtk_tree_view_column_get_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_width(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_get_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_fixed_width "gint gtk_tree_view_column_get_fixed_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_fixed_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_fixed_width(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_fixed_width "void gtk_tree_view_column_set_fixed_width(GtkTreeViewColumn* tree_column, \
gint fixed_width)"
  s7_pointer _p;
  s7_pointer tree_column, fixed_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_fixed_width", 1, tree_column, "GtkTreeViewColumn*");
  fixed_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(fixed_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_fixed_width", 2, fixed_width, "gint");
  gtk_tree_view_column_set_fixed_width(s7_c_pointer(tree_column), s7_integer(fixed_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_min_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_min_width "void gtk_tree_view_column_set_min_width(GtkTreeViewColumn* tree_column, \
gint min_width)"
  s7_pointer _p;
  s7_pointer tree_column, min_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_min_width", 1, tree_column, "GtkTreeViewColumn*");
  min_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(min_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_min_width", 2, min_width, "gint");
  gtk_tree_view_column_set_min_width(s7_c_pointer(tree_column), s7_integer(min_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_min_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_min_width "gint gtk_tree_view_column_get_min_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_min_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_min_width(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_max_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_max_width "void gtk_tree_view_column_set_max_width(GtkTreeViewColumn* tree_column, \
gint max_width)"
  s7_pointer _p;
  s7_pointer tree_column, max_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_max_width", 1, tree_column, "GtkTreeViewColumn*");
  max_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_max_width", 2, max_width, "gint");
  gtk_tree_view_column_set_max_width(s7_c_pointer(tree_column), s7_integer(max_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_max_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_max_width "gint gtk_tree_view_column_get_max_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_max_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_max_width(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_clicked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clicked "void gtk_tree_view_column_clicked(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clicked", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_clicked(s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_title "void gtk_tree_view_column_set_title(GtkTreeViewColumn* tree_column, \
gchar* title)"
  s7_pointer _p;
  s7_pointer tree_column, title;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_title", 1, tree_column, "GtkTreeViewColumn*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_title", 2, title, "gchar*");
  gtk_tree_view_column_set_title(s7_c_pointer(tree_column), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_title "gchar* gtk_tree_view_column_get_title(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_title", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_string(sc, gtk_tree_view_column_get_title(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_clickable "void gtk_tree_view_column_set_clickable(GtkTreeViewColumn* tree_column, \
gboolean clickable)"
  s7_pointer _p;
  s7_pointer tree_column, clickable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_clickable", 1, tree_column, "GtkTreeViewColumn*");
  clickable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(clickable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_clickable", 2, clickable, "gboolean");
  gtk_tree_view_column_set_clickable(s7_c_pointer(tree_column), lg_boolean(clickable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_clickable "gboolean gtk_tree_view_column_get_clickable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_clickable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_clickable(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_widget "void gtk_tree_view_column_set_widget(GtkTreeViewColumn* tree_column, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer tree_column, widget;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_widget", 1, tree_column, "GtkTreeViewColumn*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) && (widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_widget", 2, widget, "GtkWidget*");
  gtk_tree_view_column_set_widget(s7_c_pointer(tree_column), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_widget "GtkWidget* gtk_tree_view_column_get_widget(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_widget", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tree_view_column_get_widget(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_alignment "void gtk_tree_view_column_set_alignment(GtkTreeViewColumn* tree_column, \
gfloat xalign)"
  s7_pointer _p;
  s7_pointer tree_column, xalign;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_alignment", 1, tree_column, "GtkTreeViewColumn*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_alignment", 2, xalign, "gfloat");
  gtk_tree_view_column_set_alignment(s7_c_pointer(tree_column), s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_alignment "gfloat gtk_tree_view_column_get_alignment(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_alignment", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_real(sc, gtk_tree_view_column_get_alignment(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_reorderable "void gtk_tree_view_column_set_reorderable(GtkTreeViewColumn* tree_column, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer tree_column, reorderable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_reorderable", 1, tree_column, "GtkTreeViewColumn*");
  reorderable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_reorderable", 2, reorderable, "gboolean");
  gtk_tree_view_column_set_reorderable(s7_c_pointer(tree_column), lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_reorderable "gboolean gtk_tree_view_column_get_reorderable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_reorderable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_reorderable(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_column_id "void gtk_tree_view_column_set_sort_column_id(GtkTreeViewColumn* tree_column, \
gint sort_column_id)"
  s7_pointer _p;
  s7_pointer tree_column, sort_column_id;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_column_id", 1, tree_column, "GtkTreeViewColumn*");
  sort_column_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_column_id", 2, sort_column_id, "gint");
  gtk_tree_view_column_set_sort_column_id(s7_c_pointer(tree_column), s7_integer(sort_column_id));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_column_id "gint gtk_tree_view_column_get_sort_column_id(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_column_id", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sort_column_id(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_indicator "void gtk_tree_view_column_set_sort_indicator(GtkTreeViewColumn* tree_column, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer tree_column, setting;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_indicator", 1, tree_column, "GtkTreeViewColumn*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_indicator", 2, setting, "gboolean");
  gtk_tree_view_column_set_sort_indicator(s7_c_pointer(tree_column), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_indicator "gboolean gtk_tree_view_column_get_sort_indicator(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_indicator", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_sort_indicator(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_order "void gtk_tree_view_column_set_sort_order(GtkTreeViewColumn* tree_column, \
GtkSortType order)"
  s7_pointer _p;
  s7_pointer tree_column, order;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_order", 1, tree_column, "GtkTreeViewColumn*");
  order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(order)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_order", 2, order, "GtkSortType");
  gtk_tree_view_column_set_sort_order(s7_c_pointer(tree_column), s7_integer(order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_order "GtkSortType gtk_tree_view_column_get_sort_order(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_order", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sort_order(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_cell_set_cell_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_set_cell_data "void gtk_tree_view_column_cell_set_cell_data(GtkTreeViewColumn* tree_column, \
GtkTreeModel* tree_model, GtkTreeIter* iter, gboolean is_expander, gboolean is_expanded)"
  s7_pointer _p;
  s7_pointer tree_column, tree_model, iter, is_expander, is_expanded;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 1, tree_column, "GtkTreeViewColumn*");
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 2, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 3, iter, "GtkTreeIter*");
  is_expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_expander)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 4, is_expander, "gboolean");
  is_expanded = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_expanded)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 5, is_expanded, "gboolean");
  gtk_tree_view_column_cell_set_cell_data(s7_c_pointer(tree_column), s7_c_pointer(tree_model), s7_c_pointer(iter), lg_boolean(is_expander), lg_boolean(is_expanded));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_cell_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_get_size "void gtk_tree_view_column_cell_get_size(GtkTreeViewColumn* tree_column, \
GdkRectangle* cell_area, gint* [x_offset], gint* [y_offset], gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer tree_column, cell_area;
  gint ref_x_offset;
  gint ref_y_offset;
  gint ref_width;
  gint ref_height;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_size", 1, tree_column, "GtkTreeViewColumn*");
  cell_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_size", 2, cell_area, "GdkRectangle*");
  gtk_tree_view_column_cell_get_size(s7_c_pointer(tree_column), s7_c_pointer(cell_area), &ref_x_offset, &ref_y_offset, &ref_width, &ref_height);
    return(s7_list(sc, 4, s7_make_integer(sc, ref_x_offset), s7_make_integer(sc, ref_y_offset), s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_tree_view_column_cell_is_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_is_visible "gboolean gtk_tree_view_column_cell_is_visible(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_is_visible", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_cell_is_visible(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_cell_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_get_position "gboolean gtk_tree_view_column_cell_get_position(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gint* [start_pos], gint* [width])"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer;
  gint ref_start_pos;
  gint ref_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_position", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_position", 2, cell_renderer, "GtkCellRenderer*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_column_cell_get_position(s7_c_pointer(tree_column), s7_c_pointer(cell_renderer), &ref_start_pos, &ref_width));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_start_pos), s7_make_integer(sc, ref_width)));
   }
}

static s7_pointer lg_gtk_tree_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_new "GtkWidget* gtk_tree_view_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tree_view_new()));
}

static s7_pointer lg_gtk_tree_view_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_new_with_model "GtkWidget* gtk_tree_view_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_new_with_model", 1, model, "GtkTreeModel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tree_view_new_with_model(s7_c_pointer(model))));
}

static s7_pointer lg_gtk_tree_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_model "GtkTreeModel* gtk_tree_view_get_model(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_model", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_view_get_model(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_model "void gtk_tree_view_set_model(GtkTreeView* tree_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer tree_view, model;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_model", 1, tree_view, "GtkTreeView*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_model", 2, model, "GtkTreeModel*");
  gtk_tree_view_set_model(s7_c_pointer(tree_view), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_selection "GtkTreeSelection* gtk_tree_view_get_selection(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_selection", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeSelection__sym, gtk_tree_view_get_selection(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_get_headers_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_headers_visible "gboolean gtk_tree_view_get_headers_visible(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_headers_visible", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_headers_visible(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_headers_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_headers_visible "void gtk_tree_view_set_headers_visible(GtkTreeView* tree_view, \
gboolean headers_visible)"
  s7_pointer _p;
  s7_pointer tree_view, headers_visible;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_visible", 1, tree_view, "GtkTreeView*");
  headers_visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(headers_visible)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_visible", 2, headers_visible, "gboolean");
  gtk_tree_view_set_headers_visible(s7_c_pointer(tree_view), lg_boolean(headers_visible));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_columns_autosize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_columns_autosize "void gtk_tree_view_columns_autosize(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_columns_autosize", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_columns_autosize(s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_headers_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_headers_clickable "void gtk_tree_view_set_headers_clickable(GtkTreeView* tree_view, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer tree_view, setting;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_clickable", 1, tree_view, "GtkTreeView*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_clickable", 2, setting, "gboolean");
  gtk_tree_view_set_headers_clickable(s7_c_pointer(tree_view), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_append_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_append_column "gint gtk_tree_view_append_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_append_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_append_column", 2, column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_append_column(s7_c_pointer(tree_view), s7_c_pointer(column))));
}

static s7_pointer lg_gtk_tree_view_remove_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_remove_column "gint gtk_tree_view_remove_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_remove_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_remove_column", 2, column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_remove_column(s7_c_pointer(tree_view), s7_c_pointer(column))));
}

static s7_pointer lg_gtk_tree_view_insert_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column "gint gtk_tree_view_insert_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, \
gint position)"
  s7_pointer _p;
  s7_pointer tree_view, column, position;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 2, column, "GtkTreeViewColumn*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 3, position, "gint");
  return(s7_make_integer(sc, gtk_tree_view_insert_column(s7_c_pointer(tree_view), s7_c_pointer(column), s7_integer(position))));
}

static s7_pointer lg_gtk_tree_view_insert_column_with_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column_with_attributes "gint gtk_tree_view_insert_column_with_attributes(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer tree_view, position, title, cell, attributes;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 1, tree_view, "GtkTreeView*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 2, position, "gint");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 3, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, cell, "GtkCellRenderer*");
  attributes = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 5, attributes, "etc");
  {
    int etc_len = 0;
    gint result = 0;
    GtkTreeView* p_arg0;
    gint p_arg1;
    gchar* p_arg2;
    GtkCellRenderer* p_arg3;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeView*)s7_c_pointer(tree_view);
    p_arg1 = (gint)s7_integer(position);
    p_arg2 = (gchar*)s7_string(title);
    p_arg3 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: result = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(s7_make_integer(sc, result));
  }
}

static s7_pointer lg_gtk_tree_view_insert_column_with_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column_with_data_func "gint gtk_tree_view_insert_column_with_data_func(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, GtkTreeCellDataFunc func, lambda_data func_info, \
GtkDestroyNotify dnotify)"
  s7_pointer _p;
  s7_pointer tree_view, position, title, cell, func, func_info, dnotify;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 1, tree_view, "GtkTreeView*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 2, position, "gint");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 3, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 4, cell, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeCellDataFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 5, func, "GtkTreeCellDataFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 6, func_info, "lambda_data");
  dnotify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dnotify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 7, dnotify, "GtkDestroyNotify");
  {
    s7_pointer result;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, dnotify);
    result = s7_make_integer(sc, gtk_tree_view_insert_column_with_data_func(s7_c_pointer(tree_view), s7_integer(position), s7_string(title), s7_c_pointer(cell), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(dnotify)));
    return(result);
   }
}

static s7_pointer lg_gtk_tree_view_get_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_column "GtkTreeViewColumn* gtk_tree_view_get_column(GtkTreeView* tree_view, \
gint n)"
  s7_pointer _p;
  s7_pointer tree_view, n;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_column", 1, tree_view, "GtkTreeView*");
  n = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_column", 2, n, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewColumn__sym, gtk_tree_view_get_column(s7_c_pointer(tree_view), s7_integer(n))));
}

static s7_pointer lg_gtk_tree_view_get_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_columns "GList* gtk_tree_view_get_columns(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_columns", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_tree_view_get_columns(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_move_column_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_move_column_after "void gtk_tree_view_move_column_after(GtkTreeView* tree_view, \
GtkTreeViewColumn* column, GtkTreeViewColumn* base_column)"
  s7_pointer _p;
  s7_pointer tree_view, column, base_column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 2, column, "GtkTreeViewColumn*");
  base_column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(base_column, GtkTreeViewColumn__sym)) && (base_column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 3, base_column, "GtkTreeViewColumn*");
  gtk_tree_view_move_column_after(s7_c_pointer(tree_view), s7_c_pointer(column), s7_c_pointer(base_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_expander_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_expander_column "void gtk_tree_view_set_expander_column(GtkTreeView* tree_view, \
GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_expander_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_expander_column", 2, column, "GtkTreeViewColumn*");
  gtk_tree_view_set_expander_column(s7_c_pointer(tree_view), s7_c_pointer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_expander_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_expander_column "GtkTreeViewColumn* gtk_tree_view_get_expander_column(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_expander_column", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewColumn__sym, gtk_tree_view_get_expander_column(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_column_drag_function(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_column_drag_function "void gtk_tree_view_set_column_drag_function(GtkTreeView* tree_view, \
GtkTreeViewColumnDropFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_column_drag_function", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewColumnDropFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_column_drag_function", 2, func, "GtkTreeViewColumnDropFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_column_drag_function", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_column_drag_function", 4, destroy, "GtkDestroyNotify");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_set_column_drag_function(s7_c_pointer(tree_view), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_scroll_to_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_scroll_to_point "void gtk_tree_view_scroll_to_point(GtkTreeView* tree_view, \
gint tree_x, gint tree_y)"
  s7_pointer _p;
  s7_pointer tree_view, tree_x, tree_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 1, tree_view, "GtkTreeView*");
  tree_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tree_x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 2, tree_x, "gint");
  tree_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tree_y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 3, tree_y, "gint");
  gtk_tree_view_scroll_to_point(s7_c_pointer(tree_view), s7_integer(tree_x), s7_integer(tree_y));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_scroll_to_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_scroll_to_cell "void gtk_tree_view_scroll_to_cell(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, gboolean use_align, gfloat row_align, gfloat col_align)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, use_align, row_align, col_align;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 3, column, "GtkTreeViewColumn*");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 4, use_align, "gboolean");
  row_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(row_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 5, row_align, "gfloat");
  col_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(col_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 6, col_align, "gfloat");
  gtk_tree_view_scroll_to_cell(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(column), lg_boolean(use_align), s7_real(row_align), s7_real(col_align));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_row_activated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_row_activated "void gtk_tree_view_row_activated(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, path, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 3, column, "GtkTreeViewColumn*");
  gtk_tree_view_row_activated(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_expand_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_all "void gtk_tree_view_expand_all(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_all", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_expand_all(s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_collapse_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_collapse_all "void gtk_tree_view_collapse_all(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_all", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_collapse_all(s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_expand_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_row "gboolean gtk_tree_view_expand_row(GtkTreeView* tree_view, GtkTreePath* path, \
gboolean open_all)"
  s7_pointer _p;
  s7_pointer tree_view, path, open_all;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 2, path, "GtkTreePath*");
  open_all = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(open_all)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 3, open_all, "gboolean");
  return(s7_make_boolean(sc, gtk_tree_view_expand_row(s7_c_pointer(tree_view), s7_c_pointer(path), lg_boolean(open_all))));
}

static s7_pointer lg_gtk_tree_view_collapse_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_collapse_row "gboolean gtk_tree_view_collapse_row(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_row", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_row", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_view_collapse_row(s7_c_pointer(tree_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_map_expanded_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_map_expanded_rows "void gtk_tree_view_map_expanded_rows(GtkTreeView* tree_view, \
GtkTreeViewMappingFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_map_expanded_rows", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewMappingFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_map_expanded_rows", 2, func, "GtkTreeViewMappingFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_map_expanded_rows", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_view_map_expanded_rows(s7_c_pointer(tree_view), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_row_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_row_expanded "gboolean gtk_tree_view_row_expanded(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_expanded", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_expanded", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_view_row_expanded(s7_c_pointer(tree_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_reorderable "void gtk_tree_view_set_reorderable(GtkTreeView* tree_view, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer tree_view, reorderable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_reorderable", 1, tree_view, "GtkTreeView*");
  reorderable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_reorderable", 2, reorderable, "gboolean");
  gtk_tree_view_set_reorderable(s7_c_pointer(tree_view), lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_reorderable "gboolean gtk_tree_view_get_reorderable(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_reorderable", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_reorderable(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_cursor "void gtk_tree_view_set_cursor(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* focus_column, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer tree_view, path, focus_column, start_editing;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 2, path, "GtkTreePath*");
  focus_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 3, focus_column, "GtkTreeViewColumn*");
  start_editing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 4, start_editing, "gboolean");
  gtk_tree_view_set_cursor(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(focus_column), lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_cursor "void gtk_tree_view_get_cursor(GtkTreeView* tree_view, GtkTreePath** [path], \
GtkTreeViewColumn** [focus_column])"
  s7_pointer _p;
  s7_pointer tree_view;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_focus_column = NULL;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cursor", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_get_cursor(s7_c_pointer(tree_view), &ref_path, &ref_focus_column);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_focus_column)));
}

static s7_pointer lg_gtk_tree_view_get_path_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_path_at_pos "gboolean gtk_tree_view_get_path_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  s7_pointer _p;
  s7_pointer tree_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 1, tree_view, "GtkTreeView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 3, y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_get_path_at_pos(s7_c_pointer(tree_view), s7_integer(x), s7_integer(y), &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
      return(s7_list(sc, 5, result, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_column), s7_make_integer(sc, ref_cell_x), s7_make_integer(sc, ref_cell_y)));
   }
}

static s7_pointer lg_gtk_tree_view_get_cell_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_cell_area "void gtk_tree_view_get_cell_area(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 3, column, "GtkTreeViewColumn*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 4, rect, "GdkRectangle*");
  gtk_tree_view_get_cell_area(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(column), s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_background_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_background_area "void gtk_tree_view_get_background_area(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* column, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 3, column, "GtkTreeViewColumn*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 4, rect, "GdkRectangle*");
  gtk_tree_view_get_background_area(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(column), s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_visible_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_visible_rect "void gtk_tree_view_get_visible_rect(GtkTreeView* tree_view, \
GdkRectangle* visible_rect)"
  s7_pointer _p;
  s7_pointer tree_view, visible_rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_rect", 1, tree_view, "GtkTreeView*");
  visible_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(visible_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_rect", 2, visible_rect, "GdkRectangle*");
  gtk_tree_view_get_visible_rect(s7_c_pointer(tree_view), s7_c_pointer(visible_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_enable_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_enable_model_drag_source "void gtk_tree_view_enable_model_drag_source(GtkTreeView* tree_view, \
GdkModifierType start_button_mask, GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer tree_view, start_button_mask, targets, n_targets, actions;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 1, tree_view, "GtkTreeView*");
  start_button_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_button_mask)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 2, start_button_mask, "GdkModifierType");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 3, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 4, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 5, actions, "GdkDragAction");
  gtk_tree_view_enable_model_drag_source(s7_c_pointer(tree_view), s7_integer(start_button_mask), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_enable_model_drag_dest(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_enable_model_drag_dest "void gtk_tree_view_enable_model_drag_dest(GtkTreeView* tree_view, \
GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer tree_view, targets, n_targets, actions;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_dest", 1, tree_view, "GtkTreeView*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_dest", 2, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_dest", 3, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_dest", 4, actions, "GdkDragAction");
  gtk_tree_view_enable_model_drag_dest(s7_c_pointer(tree_view), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_unset_rows_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_unset_rows_drag_source "void gtk_tree_view_unset_rows_drag_source(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_unset_rows_drag_source", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_source(s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_unset_rows_drag_dest(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_unset_rows_drag_dest "void gtk_tree_view_unset_rows_drag_dest(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_unset_rows_drag_dest", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_dest(s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_drag_dest_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_drag_dest_row "void gtk_tree_view_set_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewDropPosition pos)"
  s7_pointer _p;
  s7_pointer tree_view, path, pos;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_drag_dest_row", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_drag_dest_row", 2, path, "GtkTreePath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_drag_dest_row", 3, pos, "GtkTreeViewDropPosition");
  gtk_tree_view_set_drag_dest_row(s7_c_pointer(tree_view), s7_c_pointer(path), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_drag_dest_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_drag_dest_row "void gtk_tree_view_get_drag_dest_row(GtkTreeView* tree_view, \
GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer tree_view;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_drag_dest_row", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_get_drag_dest_row(s7_c_pointer(tree_view), &ref_path, &ref_pos);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
}

static s7_pointer lg_gtk_tree_view_get_dest_row_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_dest_row_at_pos "gboolean gtk_tree_view_get_dest_row_at_pos(GtkTreeView* tree_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer tree_view, drag_x, drag_y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 1, tree_view, "GtkTreeView*");
  drag_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 2, drag_x, "gint");
  drag_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 3, drag_y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_get_dest_row_at_pos(s7_c_pointer(tree_view), s7_integer(drag_x), s7_integer(drag_y), &ref_path, &ref_pos));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
   }
}

static s7_pointer lg_gtk_tree_view_set_enable_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_enable_search "void gtk_tree_view_set_enable_search(GtkTreeView* tree_view, \
gboolean enable_search)"
  s7_pointer _p;
  s7_pointer tree_view, enable_search;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_search", 1, tree_view, "GtkTreeView*");
  enable_search = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enable_search)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_search", 2, enable_search, "gboolean");
  gtk_tree_view_set_enable_search(s7_c_pointer(tree_view), lg_boolean(enable_search));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_enable_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_enable_search "gboolean gtk_tree_view_get_enable_search(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_enable_search", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_enable_search(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_get_search_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_column "gint gtk_tree_view_get_search_column(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_column", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_search_column(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_column "void gtk_tree_view_set_search_column(GtkTreeView* tree_view, \
gint column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_column", 2, column, "gint");
  gtk_tree_view_set_search_column(s7_c_pointer(tree_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_search_equal_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_equal_func "GtkTreeViewSearchEqualFunc gtk_tree_view_get_search_equal_func(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_equal_func", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewSearchEqualFunc_sym, gtk_tree_view_get_search_equal_func(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_equal_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_equal_func "void gtk_tree_view_set_search_equal_func(GtkTreeView* tree_view, \
GtkTreeViewSearchEqualFunc func, lambda_data func_info, GtkDestroyNotify search_destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, search_destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_equal_func", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewSearchEqualFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_equal_func", 2, func, "GtkTreeViewSearchEqualFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_equal_func", 3, func_info, "lambda_data");
  search_destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(search_destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_equal_func", 4, search_destroy, "GtkDestroyNotify");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, search_destroy);
    gtk_tree_view_set_search_equal_func(s7_c_pointer(tree_view), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(search_destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_viewport_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_new "GtkWidget* gtk_viewport_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer hadjustment, vadjustment;
  _p = args;
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_viewport_new", 1, hadjustment, "GtkAdjustment*");
  vadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) && (vadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_viewport_new", 2, vadjustment, "GtkAdjustment*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_viewport_new(s7_c_pointer(hadjustment), s7_c_pointer(vadjustment))));
}

static s7_pointer lg_gtk_viewport_set_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_set_shadow_type "void gtk_viewport_set_shadow_type(GtkViewport* viewport, GtkShadowType type)"
  s7_pointer _p;
  s7_pointer viewport, type;
  _p = args;
  viewport = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(viewport, GtkViewport__sym)) s7_wrong_type_arg_error(sc, "gtk_viewport_set_shadow_type", 1, viewport, "GtkViewport*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_viewport_set_shadow_type", 2, type, "GtkShadowType");
  gtk_viewport_set_shadow_type(s7_c_pointer(viewport), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_viewport_get_shadow_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_get_shadow_type "GtkShadowType gtk_viewport_get_shadow_type(GtkViewport* viewport)"
  s7_pointer viewport;
  viewport = s7_car(args);
  if (!s7_is_c_pointer_of_type(viewport, GtkViewport__sym)) s7_wrong_type_arg_error(sc, "gtk_viewport_get_shadow_type", 1, viewport, "GtkViewport*");
  return(s7_make_integer(sc, gtk_viewport_get_shadow_type(s7_c_pointer(viewport))));
}

static s7_pointer lg_gtk_widget_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_destroy "void gtk_widget_destroy(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_destroy", 1, widget, "GtkWidget*");
  gtk_widget_destroy(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_destroyed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_destroyed "void gtk_widget_destroyed(GtkWidget* widget, GtkWidget** [widget_pointer])"
  s7_pointer _p;
  s7_pointer widget;
  GtkWidget* ref_widget_pointer = NULL;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_destroyed", 1, widget, "GtkWidget*");
  gtk_widget_destroyed(s7_c_pointer(widget), &ref_widget_pointer);
    return(s7_list(sc, 1, s7_make_c_pointer(sc, ref_widget_pointer)));
}

static s7_pointer lg_gtk_widget_unparent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unparent "void gtk_widget_unparent(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unparent", 1, widget, "GtkWidget*");
  gtk_widget_unparent(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_show(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_show "void gtk_widget_show(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_show", 1, widget, "GtkWidget*");
  gtk_widget_show(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_show_now(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_show_now "void gtk_widget_show_now(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_show_now", 1, widget, "GtkWidget*");
  gtk_widget_show_now(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_hide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_hide "void gtk_widget_hide(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_hide", 1, widget, "GtkWidget*");
  gtk_widget_hide(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_map "void gtk_widget_map(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_map", 1, widget, "GtkWidget*");
  gtk_widget_map(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unmap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unmap "void gtk_widget_unmap(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unmap", 1, widget, "GtkWidget*");
  gtk_widget_unmap(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_realize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_realize "void gtk_widget_realize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_realize", 1, widget, "GtkWidget*");
  gtk_widget_realize(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unrealize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unrealize "void gtk_widget_unrealize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unrealize", 1, widget, "GtkWidget*");
  gtk_widget_unrealize(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_draw "void gtk_widget_queue_draw(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw", 1, widget, "GtkWidget*");
  gtk_widget_queue_draw(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_draw_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_draw_area "void gtk_widget_queue_draw_area(GtkWidget* widget, gint x, gint y, \
gint width, gint height)"
  s7_pointer _p;
  s7_pointer widget, x, y, width, height;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw_area", 1, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw_area", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw_area", 3, y, "gint");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw_area", 4, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw_area", 5, height, "gint");
  gtk_widget_queue_draw_area(s7_c_pointer(widget), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_resize "void gtk_widget_queue_resize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_resize", 1, widget, "GtkWidget*");
  gtk_widget_queue_resize(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_add_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_add_accelerator "void gtk_widget_add_accelerator(GtkWidget* widget, gchar* accel_signal, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods, GtkAccelFlags accel_flags)"
  s7_pointer _p;
  s7_pointer widget, accel_signal, accel_group, accel_key, accel_mods, accel_flags;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 1, widget, "GtkWidget*");
  accel_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_signal)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 2, accel_signal, "gchar*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 3, accel_group, "GtkAccelGroup*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 4, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 5, accel_mods, "GdkModifierType");
  accel_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_flags)) s7_wrong_type_arg_error(sc, "gtk_widget_add_accelerator", 6, accel_flags, "GtkAccelFlags");
  gtk_widget_add_accelerator(s7_c_pointer(widget), s7_string(accel_signal), s7_c_pointer(accel_group), s7_integer(accel_key), s7_integer(accel_mods), s7_integer(accel_flags));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_remove_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_remove_accelerator "gboolean gtk_widget_remove_accelerator(GtkWidget* widget, \
GtkAccelGroup* accel_group, guint accel_key, GdkModifierType accel_mods)"
  s7_pointer _p;
  s7_pointer widget, accel_group, accel_key, accel_mods;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_accelerator", 1, widget, "GtkWidget*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_accelerator", 2, accel_group, "GtkAccelGroup*");
  accel_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_key)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_accelerator", 3, accel_key, "guint");
  accel_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_mods)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_accelerator", 4, accel_mods, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_widget_remove_accelerator(s7_c_pointer(widget), s7_c_pointer(accel_group), s7_integer(accel_key), s7_integer(accel_mods))));
}

static s7_pointer lg_gtk_widget_list_accel_closures(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_list_accel_closures "GList* gtk_widget_list_accel_closures(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_list_accel_closures", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_widget_list_accel_closures(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_mnemonic_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_mnemonic_activate "gboolean gtk_widget_mnemonic_activate(GtkWidget* widget, gboolean group_cycling)"
  s7_pointer _p;
  s7_pointer widget, group_cycling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_mnemonic_activate", 1, widget, "GtkWidget*");
  group_cycling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(group_cycling)) s7_wrong_type_arg_error(sc, "gtk_widget_mnemonic_activate", 2, group_cycling, "gboolean");
  return(s7_make_boolean(sc, gtk_widget_mnemonic_activate(s7_c_pointer(widget), lg_boolean(group_cycling))));
}

static s7_pointer lg_gtk_widget_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_event "gboolean gtk_widget_event(GtkWidget* widget, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer widget, event;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_event", 1, widget, "GtkWidget*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_widget_event(s7_c_pointer(widget), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_widget_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_activate "gboolean gtk_widget_activate(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_activate(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_intersect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_intersect "gboolean gtk_widget_intersect(GtkWidget* widget, GdkRectangle* area, \
GdkRectangle* intersection)"
  s7_pointer _p;
  s7_pointer widget, area, intersection;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_intersect", 1, widget, "GtkWidget*");
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_intersect", 2, area, "GdkRectangle*");
  intersection = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(intersection, GdkRectangle__sym)) && (intersection != lg_false)) s7_wrong_type_arg_error(sc, "gtk_widget_intersect", 3, intersection, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_widget_intersect(s7_c_pointer(widget), s7_c_pointer(area), s7_c_pointer(intersection))));
}

static s7_pointer lg_gtk_widget_freeze_child_notify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_freeze_child_notify "void gtk_widget_freeze_child_notify(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_freeze_child_notify", 1, widget, "GtkWidget*");
  gtk_widget_freeze_child_notify(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_child_notify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_child_notify "void gtk_widget_child_notify(GtkWidget* widget, gchar* child_property)"
  s7_pointer _p;
  s7_pointer widget, child_property;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_child_notify", 1, widget, "GtkWidget*");
  child_property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(child_property)) s7_wrong_type_arg_error(sc, "gtk_widget_child_notify", 2, child_property, "gchar*");
  gtk_widget_child_notify(s7_c_pointer(widget), s7_string(child_property));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_thaw_child_notify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_thaw_child_notify "void gtk_widget_thaw_child_notify(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_thaw_child_notify", 1, widget, "GtkWidget*");
  gtk_widget_thaw_child_notify(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_is_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_focus "gboolean gtk_widget_is_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_focus(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_grab_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_grab_focus "void gtk_widget_grab_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_grab_focus", 1, widget, "GtkWidget*");
  gtk_widget_grab_focus(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_grab_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_grab_default "void gtk_widget_grab_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_grab_default", 1, widget, "GtkWidget*");
  gtk_widget_grab_default(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_name "void gtk_widget_set_name(GtkWidget* widget, gchar* name)"
  s7_pointer _p;
  s7_pointer widget, name;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_name", 1, widget, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_set_name", 2, name, "gchar*");
  gtk_widget_set_name(s7_c_pointer(widget), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_name "gchar* gtk_widget_get_name(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_name", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_name(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_sensitive "void gtk_widget_set_sensitive(GtkWidget* widget, gboolean sensitive)"
  s7_pointer _p;
  s7_pointer widget, sensitive;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_sensitive", 1, widget, "GtkWidget*");
  sensitive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_widget_set_sensitive", 2, sensitive, "gboolean");
  gtk_widget_set_sensitive(s7_c_pointer(widget), lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_redraw_on_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_redraw_on_allocate "void gtk_widget_set_redraw_on_allocate(GtkWidget* widget, \
gboolean redraw_on_allocate)"
  s7_pointer _p;
  s7_pointer widget, redraw_on_allocate;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_redraw_on_allocate", 1, widget, "GtkWidget*");
  redraw_on_allocate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(redraw_on_allocate)) s7_wrong_type_arg_error(sc, "gtk_widget_set_redraw_on_allocate", 2, redraw_on_allocate, "gboolean");
  gtk_widget_set_redraw_on_allocate(s7_c_pointer(widget), lg_boolean(redraw_on_allocate));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_parent "void gtk_widget_set_parent(GtkWidget* widget, GtkWidget* parent)"
  s7_pointer _p;
  s7_pointer widget, parent;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent", 1, widget, "GtkWidget*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent", 2, parent, "GtkWidget*");
  gtk_widget_set_parent(s7_c_pointer(widget), s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_parent_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_parent_window "void gtk_widget_set_parent_window(GtkWidget* widget, GdkWindow* parent_window)"
  s7_pointer _p;
  s7_pointer widget, parent_window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent_window", 1, widget, "GtkWidget*");
  parent_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent_window", 2, parent_window, "GdkWindow*");
  gtk_widget_set_parent_window(s7_c_pointer(widget), s7_c_pointer(parent_window));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_child_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_child_visible "void gtk_widget_set_child_visible(GtkWidget* widget, gboolean is_visible)"
  s7_pointer _p;
  s7_pointer widget, is_visible;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_child_visible", 1, widget, "GtkWidget*");
  is_visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_visible)) s7_wrong_type_arg_error(sc, "gtk_widget_set_child_visible", 2, is_visible, "gboolean");
  gtk_widget_set_child_visible(s7_c_pointer(widget), lg_boolean(is_visible));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_accel_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_accel_path "void gtk_widget_set_accel_path(GtkWidget* widget, gchar* accel_path, \
GtkAccelGroup* accel_group)"
  s7_pointer _p;
  s7_pointer widget, accel_path, accel_group;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_accel_path", 1, widget, "GtkWidget*");
  accel_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_widget_set_accel_path", 2, accel_path, "gchar*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_accel_path", 3, accel_group, "GtkAccelGroup*");
  gtk_widget_set_accel_path(s7_c_pointer(widget), s7_string(accel_path), s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_child_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_child_visible "gboolean gtk_widget_get_child_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_child_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_child_visible(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_parent "GtkWidget* gtk_widget_get_parent(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_parent", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_parent(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_parent_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_parent_window "GdkWindow* gtk_widget_get_parent_window(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_parent_window", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gtk_widget_get_parent_window(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_child_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_child_focus "gboolean gtk_widget_child_focus(GtkWidget* widget, GtkDirectionType direction)"
  s7_pointer _p;
  s7_pointer widget, direction;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_child_focus", 1, widget, "GtkWidget*");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_widget_child_focus", 2, direction, "GtkDirectionType");
  return(s7_make_boolean(sc, gtk_widget_child_focus(s7_c_pointer(widget), s7_integer(direction))));
}

static s7_pointer lg_gtk_widget_set_size_request(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_size_request "void gtk_widget_set_size_request(GtkWidget* widget, gint width, \
gint height)"
  s7_pointer _p;
  s7_pointer widget, width, height;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 1, widget, "GtkWidget*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 2, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 3, height, "gint");
  gtk_widget_set_size_request(s7_c_pointer(widget), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_size_request(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_size_request "void gtk_widget_get_size_request(GtkWidget* widget, gint* [width], \
gint* [height])"
  s7_pointer _p;
  s7_pointer widget;
  gint ref_width;
  gint ref_height;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_size_request", 1, widget, "GtkWidget*");
  gtk_widget_get_size_request(s7_c_pointer(widget), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_widget_get_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_toplevel "GtkWidget* gtk_widget_get_toplevel(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_toplevel", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_toplevel(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_ancestor "GtkWidget* gtk_widget_get_ancestor(GtkWidget* widget, GType widget_type)"
  s7_pointer _p;
  s7_pointer widget, widget_type;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_ancestor", 1, widget, "GtkWidget*");
  widget_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(widget_type)) s7_wrong_type_arg_error(sc, "gtk_widget_get_ancestor", 2, widget_type, "GType");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_ancestor(s7_c_pointer(widget), s7_integer(widget_type))));
}

static s7_pointer lg_gtk_widget_get_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_settings "GtkSettings* gtk_widget_get_settings(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_settings", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkSettings__sym, gtk_widget_get_settings(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_accessible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_accessible "AtkObject* gtk_widget_get_accessible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_accessible", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, AtkObject__sym, gtk_widget_get_accessible(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_ancestor "gboolean gtk_widget_is_ancestor(GtkWidget* widget, GtkWidget* ancestor)"
  s7_pointer _p;
  s7_pointer widget, ancestor;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_ancestor", 1, widget, "GtkWidget*");
  ancestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ancestor, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_ancestor", 2, ancestor, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_ancestor(s7_c_pointer(widget), s7_c_pointer(ancestor))));
}

static s7_pointer lg_gtk_widget_translate_coordinates(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_translate_coordinates "gboolean gtk_widget_translate_coordinates(GtkWidget* src_widget, \
GtkWidget* dest_widget, gint src_x, gint src_y, gint* [dest_x], gint* [dest_y])"
  s7_pointer _p;
  s7_pointer src_widget, dest_widget, src_x, src_y;
  gint ref_dest_x;
  gint ref_dest_y;
  _p = args;
  src_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 1, src_widget, "GtkWidget*");
  dest_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 2, dest_widget, "GtkWidget*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 3, src_x, "gint");
  src_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 4, src_y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_widget_translate_coordinates(s7_c_pointer(src_widget), s7_c_pointer(dest_widget), s7_integer(src_x), s7_integer(src_y), &ref_dest_x, &ref_dest_y));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_dest_x), s7_make_integer(sc, ref_dest_y)));
   }
}

static s7_pointer lg_gtk_widget_hide_on_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_hide_on_delete "gboolean gtk_widget_hide_on_delete(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_hide_on_delete", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_hide_on_delete(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_create_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_create_pango_context "PangoContext* gtk_widget_create_pango_context(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_context", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, gtk_widget_create_pango_context(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_pango_context "PangoContext* gtk_widget_get_pango_context(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_pango_context", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, gtk_widget_get_pango_context(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_create_pango_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_create_pango_layout "PangoLayout* gtk_widget_create_pango_layout(GtkWidget* widget, \
gchar* text)"
  s7_pointer _p;
  s7_pointer widget, text;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_layout", 1, widget, "GtkWidget*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_layout", 2, text, "gchar*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, gtk_widget_create_pango_layout(s7_c_pointer(widget), s7_string(text))));
}

static s7_pointer lg_gtk_widget_set_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_direction "void gtk_widget_set_direction(GtkWidget* widget, GtkTextDirection dir)"
  s7_pointer _p;
  s7_pointer widget, dir;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_direction", 1, widget, "GtkWidget*");
  dir = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dir)) s7_wrong_type_arg_error(sc, "gtk_widget_set_direction", 2, dir, "GtkTextDirection");
  gtk_widget_set_direction(s7_c_pointer(widget), s7_integer(dir));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_direction "GtkTextDirection gtk_widget_get_direction(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_direction", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_direction(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_default_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_default_direction "void gtk_widget_set_default_direction(GtkTextDirection dir)"
  s7_pointer dir;
  dir = s7_car(args);
  if (!s7_is_integer(dir)) s7_wrong_type_arg_error(sc, "gtk_widget_set_default_direction", 1, dir, "GtkTextDirection");
  gtk_widget_set_default_direction(s7_integer(dir));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_default_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_default_direction "GtkTextDirection gtk_widget_get_default_direction( void)"
  return(s7_make_integer(sc, gtk_widget_get_default_direction()));
}

static s7_pointer lg_gtk_widget_can_activate_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_can_activate_accel "gboolean gtk_widget_can_activate_accel(GtkWidget* widget, \
guint signal_id)"
  s7_pointer _p;
  s7_pointer widget, signal_id;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_can_activate_accel", 1, widget, "GtkWidget*");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "gtk_widget_can_activate_accel", 2, signal_id, "guint");
  return(s7_make_boolean(sc, gtk_widget_can_activate_accel(s7_c_pointer(widget), s7_integer(signal_id))));
}

static s7_pointer lg_gtk_window_is_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_is_active "gboolean gtk_window_is_active(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_is_active", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_is_active(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_new "GtkWidget* gtk_window_new(GtkWindowType type)"
  s7_pointer type;
  type = s7_car(args);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_window_new", 1, type, "GtkWindowType");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_new(s7_integer(type))));
}

static s7_pointer lg_gtk_window_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_title "void gtk_window_set_title(GtkWindow* window, gchar* title)"
  s7_pointer _p;
  s7_pointer window, title;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_title", 1, window, "GtkWindow*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_window_set_title", 2, title, "gchar*");
  gtk_window_set_title(s7_c_pointer(window), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_auto_startup_notification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_auto_startup_notification "void gtk_window_set_auto_startup_notification(gboolean setting)"
  s7_pointer setting;
  setting = s7_car(args);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_auto_startup_notification", 1, setting, "gboolean");
  gtk_window_set_auto_startup_notification(lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_title "gchar* gtk_window_get_title(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_title", 1, window, "GtkWindow*");
  return(s7_make_string(sc, gtk_window_get_title(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_role(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_role "void gtk_window_set_role(GtkWindow* window, gchar* role)"
  s7_pointer _p;
  s7_pointer window, role;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_role", 1, window, "GtkWindow*");
  role = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(role)) s7_wrong_type_arg_error(sc, "gtk_window_set_role", 2, role, "gchar*");
  gtk_window_set_role(s7_c_pointer(window), s7_string(role));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_role(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_role "gchar* gtk_window_get_role(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_role", 1, window, "GtkWindow*");
  return(s7_make_string(sc, gtk_window_get_role(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_add_accel_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_add_accel_group "void gtk_window_add_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  s7_pointer _p;
  s7_pointer window, accel_group;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_add_accel_group", 1, window, "GtkWindow*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_add_accel_group", 2, accel_group, "GtkAccelGroup*");
  gtk_window_add_accel_group(s7_c_pointer(window), s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_window_remove_accel_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_remove_accel_group "void gtk_window_remove_accel_group(GtkWindow* window, GtkAccelGroup* accel_group)"
  s7_pointer _p;
  s7_pointer window, accel_group;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_remove_accel_group", 1, window, "GtkWindow*");
  accel_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_remove_accel_group", 2, accel_group, "GtkAccelGroup*");
  gtk_window_remove_accel_group(s7_c_pointer(window), s7_c_pointer(accel_group));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_position "void gtk_window_set_position(GtkWindow* window, GtkWindowPosition position)"
  s7_pointer _p;
  s7_pointer window, position;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_position", 1, window, "GtkWindow*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_window_set_position", 2, position, "GtkWindowPosition");
  gtk_window_set_position(s7_c_pointer(window), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_window_activate_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_activate_focus "gboolean gtk_window_activate_focus(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_focus", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_activate_focus(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_focus "void gtk_window_set_focus(GtkWindow* window, GtkWidget* focus)"
  s7_pointer _p;
  s7_pointer window, focus;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus", 1, window, "GtkWindow*");
  focus = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(focus, GtkWidget__sym)) && (focus != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus", 2, focus, "GtkWidget*");
  gtk_window_set_focus(s7_c_pointer(window), s7_c_pointer(focus));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_focus "GtkWidget* gtk_window_get_focus(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_focus", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_get_focus(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default "void gtk_window_set_default(GtkWindow* window, GtkWidget* default_widget)"
  s7_pointer _p;
  s7_pointer window, default_widget;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default", 1, window, "GtkWindow*");
  default_widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(default_widget, GtkWidget__sym)) && (default_widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_default", 2, default_widget, "GtkWidget*");
  gtk_window_set_default(s7_c_pointer(window), s7_c_pointer(default_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_activate_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_activate_default "gboolean gtk_window_activate_default(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_default", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_activate_default(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_transient_for "void gtk_window_set_transient_for(GtkWindow* window, GtkWindow* parent)"
  s7_pointer _p;
  s7_pointer window, parent;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_transient_for", 1, window, "GtkWindow*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_transient_for", 2, parent, "GtkWindow*");
  gtk_window_set_transient_for(s7_c_pointer(window), s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_transient_for "GtkWindow* gtk_window_get_transient_for(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_transient_for", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWindow__sym, gtk_window_get_transient_for(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_type_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_type_hint "void gtk_window_set_type_hint(GtkWindow* window, GdkWindowTypeHint hint)"
  s7_pointer _p;
  s7_pointer window, hint;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_type_hint", 1, window, "GtkWindow*");
  hint = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hint)) s7_wrong_type_arg_error(sc, "gtk_window_set_type_hint", 2, hint, "GdkWindowTypeHint");
  gtk_window_set_type_hint(s7_c_pointer(window), s7_integer(hint));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_type_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_type_hint "GdkWindowTypeHint gtk_window_get_type_hint(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_type_hint", 1, window, "GtkWindow*");
  return(s7_make_integer(sc, gtk_window_get_type_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_destroy_with_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_destroy_with_parent "void gtk_window_set_destroy_with_parent(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_destroy_with_parent", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_destroy_with_parent", 2, setting, "gboolean");
  gtk_window_set_destroy_with_parent(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_destroy_with_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_destroy_with_parent "gboolean gtk_window_get_destroy_with_parent(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_destroy_with_parent", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_destroy_with_parent(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_resizable "void gtk_window_set_resizable(GtkWindow* window, gboolean resizable)"
  s7_pointer _p;
  s7_pointer window, resizable;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_resizable", 1, window, "GtkWindow*");
  resizable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resizable)) s7_wrong_type_arg_error(sc, "gtk_window_set_resizable", 2, resizable, "gboolean");
  gtk_window_set_resizable(s7_c_pointer(window), lg_boolean(resizable));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_resizable "gboolean gtk_window_get_resizable(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_resizable", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_resizable(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_gravity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_gravity "void gtk_window_set_gravity(GtkWindow* window, GdkGravity gravity)"
  s7_pointer _p;
  s7_pointer window, gravity;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_gravity", 1, window, "GtkWindow*");
  gravity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(gravity)) s7_wrong_type_arg_error(sc, "gtk_window_set_gravity", 2, gravity, "GdkGravity");
  gtk_window_set_gravity(s7_c_pointer(window), s7_integer(gravity));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_gravity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_gravity "GdkGravity gtk_window_get_gravity(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_gravity", 1, window, "GtkWindow*");
  return(s7_make_integer(sc, gtk_window_get_gravity(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_geometry_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_geometry_hints "void gtk_window_set_geometry_hints(GtkWindow* window, GtkWidget* geometry_widget, \
GdkGeometry* geometry, GdkWindowHints geom_mask)"
  s7_pointer _p;
  s7_pointer window, geometry_widget, geometry, geom_mask;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_geometry_hints", 1, window, "GtkWindow*");
  geometry_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(geometry_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_geometry_hints", 2, geometry_widget, "GtkWidget*");
  geometry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(geometry, GdkGeometry__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_geometry_hints", 3, geometry, "GdkGeometry*");
  geom_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(geom_mask)) s7_wrong_type_arg_error(sc, "gtk_window_set_geometry_hints", 4, geom_mask, "GdkWindowHints");
  gtk_window_set_geometry_hints(s7_c_pointer(window), s7_c_pointer(geometry_widget), s7_c_pointer(geometry), s7_integer(geom_mask));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_decorated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_decorated "void gtk_window_set_decorated(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_decorated", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_decorated", 2, setting, "gboolean");
  gtk_window_set_decorated(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_decorated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_decorated "gboolean gtk_window_get_decorated(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_decorated", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_decorated(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_icon_list "void gtk_window_set_icon_list(GtkWindow* window, GList* list)"
  s7_pointer _p;
  s7_pointer window, list;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_list", 1, window, "GtkWindow*");
  list = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_list", 2, list, "GList*");
  gtk_window_set_icon_list(s7_c_pointer(window), s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_icon_list "GList* gtk_window_get_icon_list(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_icon_list", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_window_get_icon_list(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_icon "void gtk_window_set_icon(GtkWindow* window, GdkPixbuf* icon)"
  s7_pointer _p;
  s7_pointer window, icon;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon", 1, window, "GtkWindow*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(icon, GdkPixbuf__sym)) && (icon != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon", 2, icon, "GdkPixbuf*");
  gtk_window_set_icon(s7_c_pointer(window), s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_icon "GdkPixbuf* gtk_window_get_icon(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_icon", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_window_get_icon(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_default_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_icon_list "void gtk_window_set_default_icon_list(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_icon_list", 1, list, "GList*");
  gtk_window_set_default_icon_list(s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_default_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_icon_list "GList* gtk_window_get_default_icon_list( void)"
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_window_get_default_icon_list()));
}

static s7_pointer lg_gtk_window_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_modal "void gtk_window_set_modal(GtkWindow* window, gboolean modal)"
  s7_pointer _p;
  s7_pointer window, modal;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_modal", 1, window, "GtkWindow*");
  modal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_window_set_modal", 2, modal, "gboolean");
  gtk_window_set_modal(s7_c_pointer(window), lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_modal "gboolean gtk_window_get_modal(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_modal", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_modal(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_list_toplevels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_list_toplevels "GList* gtk_window_list_toplevels( void)"
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_window_list_toplevels()));
}

static s7_pointer lg_gtk_window_add_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_add_mnemonic "void gtk_window_add_mnemonic(GtkWindow* window, guint keyval, GtkWidget* target)"
  s7_pointer _p;
  s7_pointer window, keyval, target;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_add_mnemonic", 1, window, "GtkWindow*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_window_add_mnemonic", 2, keyval, "guint");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_add_mnemonic", 3, target, "GtkWidget*");
  gtk_window_add_mnemonic(s7_c_pointer(window), s7_integer(keyval), s7_c_pointer(target));
  return(lg_false);
}

static s7_pointer lg_gtk_window_remove_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_remove_mnemonic "void gtk_window_remove_mnemonic(GtkWindow* window, guint keyval, \
GtkWidget* target)"
  s7_pointer _p;
  s7_pointer window, keyval, target;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_remove_mnemonic", 1, window, "GtkWindow*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_window_remove_mnemonic", 2, keyval, "guint");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_remove_mnemonic", 3, target, "GtkWidget*");
  gtk_window_remove_mnemonic(s7_c_pointer(window), s7_integer(keyval), s7_c_pointer(target));
  return(lg_false);
}

static s7_pointer lg_gtk_window_mnemonic_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_mnemonic_activate "gboolean gtk_window_mnemonic_activate(GtkWindow* window, guint keyval, \
GdkModifierType modifier)"
  s7_pointer _p;
  s7_pointer window, keyval, modifier;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_mnemonic_activate", 1, window, "GtkWindow*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_window_mnemonic_activate", 2, keyval, "guint");
  modifier = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifier)) s7_wrong_type_arg_error(sc, "gtk_window_mnemonic_activate", 3, modifier, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_window_mnemonic_activate(s7_c_pointer(window), s7_integer(keyval), s7_integer(modifier))));
}

static s7_pointer lg_gtk_window_set_mnemonic_modifier(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_mnemonic_modifier "void gtk_window_set_mnemonic_modifier(GtkWindow* window, \
GdkModifierType modifier)"
  s7_pointer _p;
  s7_pointer window, modifier;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonic_modifier", 1, window, "GtkWindow*");
  modifier = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifier)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonic_modifier", 2, modifier, "GdkModifierType");
  gtk_window_set_mnemonic_modifier(s7_c_pointer(window), s7_integer(modifier));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_mnemonic_modifier(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_mnemonic_modifier "GdkModifierType gtk_window_get_mnemonic_modifier(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_mnemonic_modifier", 1, window, "GtkWindow*");
  return(s7_make_integer(sc, gtk_window_get_mnemonic_modifier(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_present(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_present "void gtk_window_present(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_present", 1, window, "GtkWindow*");
  gtk_window_present(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_iconify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_iconify "void gtk_window_iconify(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_iconify", 1, window, "GtkWindow*");
  gtk_window_iconify(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_deiconify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_deiconify "void gtk_window_deiconify(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_deiconify", 1, window, "GtkWindow*");
  gtk_window_deiconify(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_stick(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_stick "void gtk_window_stick(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_stick", 1, window, "GtkWindow*");
  gtk_window_stick(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unstick(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unstick "void gtk_window_unstick(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unstick", 1, window, "GtkWindow*");
  gtk_window_unstick(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_maximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_maximize "void gtk_window_maximize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_maximize", 1, window, "GtkWindow*");
  gtk_window_maximize(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unmaximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unmaximize "void gtk_window_unmaximize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unmaximize", 1, window, "GtkWindow*");
  gtk_window_unmaximize(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_begin_resize_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_begin_resize_drag "void gtk_window_begin_resize_drag(GtkWindow* window, GdkWindowEdge edge, \
gint button, gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, edge, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 1, window, "GtkWindow*");
  edge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(edge)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 2, edge, "GdkWindowEdge");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 3, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 4, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 5, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_window_begin_resize_drag", 6, timestamp, "guint32");
  gtk_window_begin_resize_drag(s7_c_pointer(window), s7_integer(edge), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_window_begin_move_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_begin_move_drag "void gtk_window_begin_move_drag(GtkWindow* window, gint button, \
gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_begin_move_drag", 1, window, "GtkWindow*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gtk_window_begin_move_drag", 2, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gtk_window_begin_move_drag", 3, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gtk_window_begin_move_drag", 4, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_window_begin_move_drag", 5, timestamp, "guint32");
  gtk_window_begin_move_drag(s7_c_pointer(window), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_default_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_size "void gtk_window_set_default_size(GtkWindow* window, gint width, \
gint height)"
  s7_pointer _p;
  s7_pointer window, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 1, window, "GtkWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 2, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 3, height, "gint");
  gtk_window_set_default_size(s7_c_pointer(window), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_default_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_size "void gtk_window_get_default_size(GtkWindow* window, gint* [width], \
gint* [height])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_width;
  gint ref_height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_default_size", 1, window, "GtkWindow*");
  gtk_window_get_default_size(s7_c_pointer(window), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_window_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_resize "void gtk_window_resize(GtkWindow* window, gint width, gint height)"
  s7_pointer _p;
  s7_pointer window, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 1, window, "GtkWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 2, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 3, height, "gint");
  gtk_window_resize(s7_c_pointer(window), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_size "void gtk_window_get_size(GtkWindow* window, gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_width;
  gint ref_height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_size", 1, window, "GtkWindow*");
  gtk_window_get_size(s7_c_pointer(window), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_window_move(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_move "void gtk_window_move(GtkWindow* window, gint x, gint y)"
  s7_pointer _p;
  s7_pointer window, x, y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_move", 1, window, "GtkWindow*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_window_move", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_window_move", 3, y, "gint");
  gtk_window_move(s7_c_pointer(window), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_position "void gtk_window_get_position(GtkWindow* window, gint* [root_x], \
gint* [root_y])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_root_x;
  gint ref_root_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_position", 1, window, "GtkWindow*");
  gtk_window_get_position(s7_c_pointer(window), &ref_root_x, &ref_root_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_root_x), s7_make_integer(sc, ref_root_y)));
}

static s7_pointer lg_pango_color_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_copy "PangoColor* pango_color_copy(PangoColor* src)"
  s7_pointer src;
  src = s7_car(args);
  if (!s7_is_c_pointer_of_type(src, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_copy", 1, src, "PangoColor*");
  return(s7_make_type_with_c_pointer(sc, PangoColor__sym, pango_color_copy(s7_c_pointer(src))));
}

static s7_pointer lg_pango_color_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_free "void pango_color_free(PangoColor* color)"
  s7_pointer color;
  color = s7_car(args);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_free", 1, color, "PangoColor*");
  pango_color_free(s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_pango_color_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_parse "gboolean pango_color_parse(PangoColor* color, char* spec)"
  s7_pointer _p;
  s7_pointer color, spec;
  _p = args;
  color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_parse", 1, color, "PangoColor*");
  spec = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(spec)) s7_wrong_type_arg_error(sc, "pango_color_parse", 2, spec, "char*");
  return(s7_make_boolean(sc, pango_color_parse(s7_c_pointer(color), (char*)s7_string(spec))));
}

static s7_pointer lg_pango_attr_type_register(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_type_register "PangoAttrType pango_attr_type_register(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "pango_attr_type_register", 1, name, "gchar*");
  return(s7_make_integer(sc, pango_attr_type_register(s7_string(name))));
}

static s7_pointer lg_pango_attribute_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_copy "PangoAttribute* pango_attribute_copy(PangoAttribute* attr)"
  s7_pointer attr;
  attr = s7_car(args);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_copy", 1, attr, "PangoAttribute*");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attribute_copy(s7_c_pointer(attr))));
}

static s7_pointer lg_pango_attribute_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_destroy "void pango_attribute_destroy(PangoAttribute* attr)"
  s7_pointer attr;
  attr = s7_car(args);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_destroy", 1, attr, "PangoAttribute*");
  pango_attribute_destroy(s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attribute_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_equal "gboolean pango_attribute_equal(PangoAttribute* attr1, PangoAttribute* attr2)"
  s7_pointer _p;
  s7_pointer attr1, attr2;
  _p = args;
  attr1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr1, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_equal", 1, attr1, "PangoAttribute*");
  attr2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr2, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_equal", 2, attr2, "PangoAttribute*");
  return(s7_make_boolean(sc, pango_attribute_equal(s7_c_pointer(attr1), s7_c_pointer(attr2))));
}

static s7_pointer lg_pango_attr_language_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_language_new "PangoAttribute* pango_attr_language_new(PangoLanguage* language)"
  s7_pointer language;
  language = s7_car(args);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_attr_language_new", 1, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_language_new(s7_c_pointer(language))));
}

static s7_pointer lg_pango_attr_family_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_family_new "PangoAttribute* pango_attr_family_new(char* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_attr_family_new", 1, family, "char*");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_family_new((char*)s7_string(family))));
}

static s7_pointer lg_pango_attr_foreground_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_foreground_new "PangoAttribute* pango_attr_foreground_new(guint16 red, guint16 green, \
guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 2, green, "guint16");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 3, blue, "guint16");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_foreground_new(s7_integer(red), s7_integer(green), s7_integer(blue))));
}

static s7_pointer lg_pango_attr_background_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_background_new "PangoAttribute* pango_attr_background_new(guint16 red, guint16 green, \
guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 2, green, "guint16");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 3, blue, "guint16");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_background_new(s7_integer(red), s7_integer(green), s7_integer(blue))));
}

static s7_pointer lg_pango_attr_size_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_size_new "PangoAttribute* pango_attr_size_new(int size)"
  s7_pointer size;
  size = s7_car(args);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_attr_size_new", 1, size, "int");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_size_new(s7_integer(size))));
}

static s7_pointer lg_pango_attr_style_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_style_new "PangoAttribute* pango_attr_style_new(PangoStyle style)"
  s7_pointer style;
  style = s7_car(args);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "pango_attr_style_new", 1, style, "PangoStyle");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_style_new(s7_integer(style))));
}

static s7_pointer lg_pango_attr_weight_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_weight_new "PangoAttribute* pango_attr_weight_new(PangoWeight weight)"
  s7_pointer weight;
  weight = s7_car(args);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "pango_attr_weight_new", 1, weight, "PangoWeight");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_weight_new(s7_integer(weight))));
}

static s7_pointer lg_pango_attr_variant_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_variant_new "PangoAttribute* pango_attr_variant_new(PangoVariant variant)"
  s7_pointer variant;
  variant = s7_car(args);
  if (!s7_is_integer(variant)) s7_wrong_type_arg_error(sc, "pango_attr_variant_new", 1, variant, "PangoVariant");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_variant_new(s7_integer(variant))));
}

static s7_pointer lg_pango_attr_stretch_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_stretch_new "PangoAttribute* pango_attr_stretch_new(PangoStretch stretch)"
  s7_pointer stretch;
  stretch = s7_car(args);
  if (!s7_is_integer(stretch)) s7_wrong_type_arg_error(sc, "pango_attr_stretch_new", 1, stretch, "PangoStretch");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_stretch_new(s7_integer(stretch))));
}

static s7_pointer lg_pango_attr_font_desc_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_font_desc_new "PangoAttribute* pango_attr_font_desc_new(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_attr_font_desc_new", 1, desc, "PangoFontDescription*");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_font_desc_new(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_attr_underline_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_underline_new "PangoAttribute* pango_attr_underline_new(PangoUnderline underline)"
  s7_pointer underline;
  underline = s7_car(args);
  if (!s7_is_integer(underline)) s7_wrong_type_arg_error(sc, "pango_attr_underline_new", 1, underline, "PangoUnderline");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_underline_new(s7_integer(underline))));
}

static s7_pointer lg_pango_attr_strikethrough_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_strikethrough_new "PangoAttribute* pango_attr_strikethrough_new(gboolean strikethrough)"
  s7_pointer strikethrough;
  strikethrough = s7_car(args);
  if (!s7_is_boolean(strikethrough)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_new", 1, strikethrough, "gboolean");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_strikethrough_new(lg_boolean(strikethrough))));
}

static s7_pointer lg_pango_attr_rise_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_rise_new "PangoAttribute* pango_attr_rise_new(int rise)"
  s7_pointer rise;
  rise = s7_car(args);
  if (!s7_is_integer(rise)) s7_wrong_type_arg_error(sc, "pango_attr_rise_new", 1, rise, "int");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_rise_new(s7_integer(rise))));
}

static s7_pointer lg_pango_attr_shape_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_shape_new "PangoAttribute* pango_attr_shape_new(PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer ink_rect, logical_rect;
  _p = args;
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_attr_shape_new", 1, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_attr_shape_new", 2, logical_rect, "PangoRectangle*");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_shape_new(s7_c_pointer(ink_rect), s7_c_pointer(logical_rect))));
}

static s7_pointer lg_pango_attr_scale_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_scale_new "PangoAttribute* pango_attr_scale_new(double scale_factor)"
  s7_pointer scale_factor;
  scale_factor = s7_car(args);
  if (!s7_is_real(scale_factor)) s7_wrong_type_arg_error(sc, "pango_attr_scale_new", 1, scale_factor, "double");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_scale_new(s7_real(scale_factor))));
}

static s7_pointer lg_pango_attr_list_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_new "PangoAttrList* pango_attr_list_new( void)"
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, pango_attr_list_new()));
}

static s7_pointer lg_pango_attr_list_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_unref "void pango_attr_list_unref(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_unref", 1, list, "PangoAttrList*");
  pango_attr_list_unref(s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_copy "PangoAttrList* pango_attr_list_copy(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_copy", 1, list, "PangoAttrList*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, pango_attr_list_copy(s7_c_pointer(list))));
}

static s7_pointer lg_pango_attr_list_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_insert "void pango_attr_list_insert(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert", 1, list, "PangoAttrList*");
  attr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert", 2, attr, "PangoAttribute*");
  pango_attr_list_insert(s7_c_pointer(list), s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_insert_before "void pango_attr_list_insert_before(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert_before", 1, list, "PangoAttrList*");
  attr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert_before", 2, attr, "PangoAttribute*");
  pango_attr_list_insert_before(s7_c_pointer(list), s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_change(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_change "void pango_attr_list_change(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_change", 1, list, "PangoAttrList*");
  attr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_change", 2, attr, "PangoAttribute*");
  pango_attr_list_change(s7_c_pointer(list), s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_splice(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_splice "void pango_attr_list_splice(PangoAttrList* list, PangoAttrList* other, \
gint pos, gint len)"
  s7_pointer _p;
  s7_pointer list, other, pos, len;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 1, list, "PangoAttrList*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 2, other, "PangoAttrList*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 3, pos, "gint");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 4, len, "gint");
  pango_attr_list_splice(s7_c_pointer(list), s7_c_pointer(other), s7_integer(pos), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_get_iterator(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_get_iterator "PangoAttrIterator* pango_attr_list_get_iterator(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_get_iterator", 1, list, "PangoAttrList*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrIterator__sym, pango_attr_list_get_iterator(s7_c_pointer(list))));
}

static s7_pointer lg_pango_attr_iterator_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_range "void pango_attr_iterator_range(PangoAttrIterator* iterator, gint* [start], \
gint* [end])"
  s7_pointer _p;
  s7_pointer iterator;
  gint ref_start;
  gint ref_end;
  _p = args;
  iterator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_range", 1, iterator, "PangoAttrIterator*");
  pango_attr_iterator_range(s7_c_pointer(iterator), &ref_start, &ref_end);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
}

static s7_pointer lg_pango_attr_iterator_next(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_next "gboolean pango_attr_iterator_next(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_next", 1, iterator, "PangoAttrIterator*");
  return(s7_make_boolean(sc, pango_attr_iterator_next(s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_attr_iterator_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_copy "PangoAttrIterator* pango_attr_iterator_copy(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_copy", 1, iterator, "PangoAttrIterator*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrIterator__sym, pango_attr_iterator_copy(s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_attr_iterator_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_destroy "void pango_attr_iterator_destroy(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_destroy", 1, iterator, "PangoAttrIterator*");
  pango_attr_iterator_destroy(s7_c_pointer(iterator));
  return(lg_false);
}

static s7_pointer lg_pango_attr_iterator_get(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get "PangoAttribute* pango_attr_iterator_get(PangoAttrIterator* iterator, \
PangoAttrType type)"
  s7_pointer _p;
  s7_pointer iterator, type;
  _p = args;
  iterator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get", 1, iterator, "PangoAttrIterator*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get", 2, type, "PangoAttrType");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_iterator_get(s7_c_pointer(iterator), s7_integer(type))));
}

static s7_pointer lg_pango_attr_iterator_get_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get_font "void pango_attr_iterator_get_font(PangoAttrIterator* iterator, \
PangoFontDescription* desc, PangoLanguage** [language], GSList** [extra_attrs])"
  s7_pointer _p;
  s7_pointer iterator, desc;
  PangoLanguage* ref_language = NULL;
  GSList* ref_extra_attrs = NULL;
  _p = args;
  iterator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_font", 1, iterator, "PangoAttrIterator*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_font", 2, desc, "PangoFontDescription*");
  pango_attr_iterator_get_font(s7_c_pointer(iterator), s7_c_pointer(desc), &ref_language, &ref_extra_attrs);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_language), s7_make_c_pointer(sc, ref_extra_attrs)));
}

static s7_pointer lg_pango_parse_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_parse_markup "gboolean pango_parse_markup(char* markup_text, int length, gunichar accel_marker, \
PangoAttrList** attr_list, char** text, gunichar* accel_char, GError** [error])"
  s7_pointer _p;
  s7_pointer markup_text, length, accel_marker, attr_list, text, accel_char;
  GError* ref_error = NULL;
  _p = args;
  markup_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup_text)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 1, markup_text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 2, length, "int");
  accel_marker = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_marker)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 3, accel_marker, "gunichar");
  attr_list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr_list, PangoAttrList___sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 4, attr_list, "PangoAttrList**");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text, char___sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 5, text, "char**");
  accel_char = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_char, gunichar__sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 6, accel_char, "gunichar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, pango_parse_markup((char*)s7_string(markup_text), s7_integer(length), s7_integer(accel_marker), s7_c_pointer(attr_list), s7_c_pointer(text), s7_c_pointer(accel_char), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_pango_break(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_break "void pango_break(gchar* text, int length, PangoAnalysis* analysis, PangoLogAttr* attrs, \
int attrs_len)"
  s7_pointer _p;
  s7_pointer text, length, analysis, attrs, attrs_len;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_break", 1, text, "gchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_break", 2, length, "int");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_break", 3, analysis, "PangoAnalysis*");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoLogAttr__sym)) s7_wrong_type_arg_error(sc, "pango_break", 4, attrs, "PangoLogAttr*");
  attrs_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(attrs_len)) s7_wrong_type_arg_error(sc, "pango_break", 5, attrs_len, "int");
  pango_break(s7_string(text), s7_integer(length), s7_c_pointer(analysis), s7_c_pointer(attrs), s7_integer(attrs_len));
  return(lg_false);
}

static s7_pointer lg_pango_find_paragraph_boundary(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_find_paragraph_boundary "void pango_find_paragraph_boundary(gchar* text, gint length, \
gint* [paragraph_delimiter_index], gint* [next_paragraph_start])"
  s7_pointer _p;
  s7_pointer text, length;
  gint ref_paragraph_delimiter_index;
  gint ref_next_paragraph_start;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_find_paragraph_boundary", 1, text, "gchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_find_paragraph_boundary", 2, length, "gint");
  pango_find_paragraph_boundary(s7_string(text), s7_integer(length), &ref_paragraph_delimiter_index, &ref_next_paragraph_start);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_paragraph_delimiter_index), s7_make_integer(sc, ref_next_paragraph_start)));
}

static s7_pointer lg_pango_get_log_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_get_log_attrs "void pango_get_log_attrs(char* text, int length, int level, PangoLanguage* language, \
PangoLogAttr* log_attrs, int attrs_len)"
  s7_pointer _p;
  s7_pointer text, length, level, language, log_attrs, attrs_len;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 1, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 2, length, "int");
  level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(level)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 3, level, "int");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 4, language, "PangoLanguage*");
  log_attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(log_attrs, PangoLogAttr__sym)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 5, log_attrs, "PangoLogAttr*");
  attrs_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(attrs_len)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 6, attrs_len, "int");
  pango_get_log_attrs((char*)s7_string(text), s7_integer(length), s7_integer(level), s7_c_pointer(language), s7_c_pointer(log_attrs), s7_integer(attrs_len));
  return(lg_false);
}

static s7_pointer lg_pango_context_list_families(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_list_families "void pango_context_list_families(PangoContext* context, PangoFontFamily*** [families], \
int* [n_families])"
  s7_pointer _p;
  s7_pointer context;
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_list_families", 1, context, "PangoContext*");
  pango_context_list_families(s7_c_pointer(context), &ref_families, &ref_n_families);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_families), s7_make_integer(sc, ref_n_families)));
}

static s7_pointer lg_pango_context_load_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_load_font "PangoFont* pango_context_load_font(PangoContext* context, PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer context, desc;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_font", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_font", 2, desc, "PangoFontDescription*");
  return(s7_make_type_with_c_pointer(sc, PangoFont__sym, pango_context_load_font(s7_c_pointer(context), s7_c_pointer(desc))));
}

static s7_pointer lg_pango_context_load_fontset(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_load_fontset "PangoFontset* pango_context_load_fontset(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, desc, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 2, desc, "PangoFontDescription*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 3, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoFontset__sym, pango_context_load_fontset(s7_c_pointer(context), s7_c_pointer(desc), s7_c_pointer(language))));
}

static s7_pointer lg_pango_context_get_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_metrics "PangoFontMetrics* pango_context_get_metrics(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, desc, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 2, desc, "PangoFontDescription*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 3, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoFontMetrics__sym, pango_context_get_metrics(s7_c_pointer(context), s7_c_pointer(desc), s7_c_pointer(language))));
}

static s7_pointer lg_pango_context_set_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_font_description "void pango_context_set_font_description(PangoContext* context, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer context, desc;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_font_description", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_font_description", 2, desc, "PangoFontDescription*");
  pango_context_set_font_description(s7_c_pointer(context), s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_context_get_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_font_description "PangoFontDescription* pango_context_get_font_description(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_font_description", 1, context, "PangoContext*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_context_get_font_description(s7_c_pointer(context))));
}

static s7_pointer lg_pango_context_get_language(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_language "PangoLanguage* pango_context_get_language(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_language", 1, context, "PangoContext*");
  return(s7_make_type_with_c_pointer(sc, PangoLanguage__sym, pango_context_get_language(s7_c_pointer(context))));
}

static s7_pointer lg_pango_context_set_language(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_language "void pango_context_set_language(PangoContext* context, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_language", 1, context, "PangoContext*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_language", 2, language, "PangoLanguage*");
  pango_context_set_language(s7_c_pointer(context), s7_c_pointer(language));
  return(lg_false);
}

static s7_pointer lg_pango_context_set_base_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_base_dir "void pango_context_set_base_dir(PangoContext* context, PangoDirection direction)"
  s7_pointer _p;
  s7_pointer context, direction;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_base_dir", 1, context, "PangoContext*");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "pango_context_set_base_dir", 2, direction, "PangoDirection");
  pango_context_set_base_dir(s7_c_pointer(context), s7_integer(direction));
  return(lg_false);
}

static s7_pointer lg_pango_context_get_base_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_base_dir "PangoDirection pango_context_get_base_dir(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_base_dir", 1, context, "PangoContext*");
  return(s7_make_integer(sc, pango_context_get_base_dir(s7_c_pointer(context))));
}

static s7_pointer lg_pango_itemize(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_itemize "GList* pango_itemize(PangoContext* context, char* text, int start_index, int length, \
PangoAttrList* attrs, PangoAttrIterator* cached_iter)"
  s7_pointer _p;
  s7_pointer context, text, start_index, length, attrs, cached_iter;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 1, context, "PangoContext*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_itemize", 2, text, "char*");
  start_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_index)) s7_wrong_type_arg_error(sc, "pango_itemize", 3, start_index, "int");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_itemize", 4, length, "int");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 5, attrs, "PangoAttrList*");
  cached_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cached_iter, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 6, cached_iter, "PangoAttrIterator*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, pango_itemize(s7_c_pointer(context), (char*)s7_string(text), s7_integer(start_index), s7_integer(length), s7_c_pointer(attrs), s7_c_pointer(cached_iter))));
}

static s7_pointer lg_pango_coverage_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_new "PangoCoverage* pango_coverage_new( void)"
  return(s7_make_type_with_c_pointer(sc, PangoCoverage__sym, pango_coverage_new()));
}

static s7_pointer lg_pango_coverage_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_ref "PangoCoverage* pango_coverage_ref(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_ref", 1, coverage, "PangoCoverage*");
  return(s7_make_type_with_c_pointer(sc, PangoCoverage__sym, pango_coverage_ref(s7_c_pointer(coverage))));
}

static s7_pointer lg_pango_coverage_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_unref "void pango_coverage_unref(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_unref", 1, coverage, "PangoCoverage*");
  pango_coverage_unref(s7_c_pointer(coverage));
  return(lg_false);
}

static s7_pointer lg_pango_coverage_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_copy "PangoCoverage* pango_coverage_copy(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_copy", 1, coverage, "PangoCoverage*");
  return(s7_make_type_with_c_pointer(sc, PangoCoverage__sym, pango_coverage_copy(s7_c_pointer(coverage))));
}

static s7_pointer lg_pango_coverage_get(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_get "PangoCoverageLevel pango_coverage_get(PangoCoverage* coverage, int index)"
  s7_pointer _p;
  s7_pointer coverage, index;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_get", 1, coverage, "PangoCoverage*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_coverage_get", 2, index, "int");
  return(s7_make_integer(sc, pango_coverage_get(s7_c_pointer(coverage), s7_integer(index))));
}

static s7_pointer lg_pango_coverage_set(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_set "void pango_coverage_set(PangoCoverage* coverage, int index, PangoCoverageLevel level)"
  s7_pointer _p;
  s7_pointer coverage, index, level;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 1, coverage, "PangoCoverage*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 2, index, "int");
  level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(level)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 3, level, "PangoCoverageLevel");
  pango_coverage_set(s7_c_pointer(coverage), s7_integer(index), s7_integer(level));
  return(lg_false);
}

static s7_pointer lg_pango_coverage_max(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_max "void pango_coverage_max(PangoCoverage* coverage, PangoCoverage* other)"
  s7_pointer _p;
  s7_pointer coverage, other;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_max", 1, coverage, "PangoCoverage*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_max", 2, other, "PangoCoverage*");
  pango_coverage_max(s7_c_pointer(coverage), s7_c_pointer(other));
  return(lg_false);
}

static s7_pointer lg_pango_coverage_to_bytes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_to_bytes "void pango_coverage_to_bytes(PangoCoverage* coverage, guchar** [bytes], \
int* [n_bytes])"
  s7_pointer _p;
  s7_pointer coverage;
  guchar* ref_bytes = NULL;
  int ref_n_bytes;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_to_bytes", 1, coverage, "PangoCoverage*");
  pango_coverage_to_bytes(s7_c_pointer(coverage), &ref_bytes, &ref_n_bytes);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_bytes), s7_make_integer(sc, ref_n_bytes)));
}

static s7_pointer lg_pango_coverage_from_bytes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_from_bytes "PangoCoverage* pango_coverage_from_bytes(guchar* bytes, int n_bytes)"
  s7_pointer _p;
  s7_pointer bytes, n_bytes;
  _p = args;
  bytes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bytes, guchar__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_from_bytes", 1, bytes, "guchar*");
  n_bytes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_bytes)) s7_wrong_type_arg_error(sc, "pango_coverage_from_bytes", 2, n_bytes, "int");
  return(s7_make_type_with_c_pointer(sc, PangoCoverage__sym, pango_coverage_from_bytes(s7_c_pointer(bytes), s7_integer(n_bytes))));
}

static s7_pointer lg_pango_font_description_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_new "PangoFontDescription* pango_font_description_new( void)"
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_description_new()));
}

static s7_pointer lg_pango_font_description_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_copy "PangoFontDescription* pango_font_description_copy(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_copy", 1, desc, "PangoFontDescription*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_description_copy(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_copy_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_copy_static "PangoFontDescription* pango_font_description_copy_static(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_copy_static", 1, desc, "PangoFontDescription*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_description_copy_static(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_hash(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_hash "guint pango_font_description_hash(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_hash", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_hash(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_equal "gboolean pango_font_description_equal(PangoFontDescription* desc1, \
PangoFontDescription* desc2)"
  s7_pointer _p;
  s7_pointer desc1, desc2;
  _p = args;
  desc1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc1, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_equal", 1, desc1, "PangoFontDescription*");
  desc2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc2, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_equal", 2, desc2, "PangoFontDescription*");
  return(s7_make_boolean(sc, pango_font_description_equal(s7_c_pointer(desc1), s7_c_pointer(desc2))));
}

static s7_pointer lg_pango_font_description_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_free "void pango_font_description_free(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_free", 1, desc, "PangoFontDescription*");
  pango_font_description_free(s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_font_descriptions_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_descriptions_free "void pango_font_descriptions_free(PangoFontDescription** descs, \
int n_descs)"
  s7_pointer _p;
  s7_pointer descs, n_descs;
  _p = args;
  descs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(descs, PangoFontDescription___sym)) s7_wrong_type_arg_error(sc, "pango_font_descriptions_free", 1, descs, "PangoFontDescription**");
  n_descs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_descs)) s7_wrong_type_arg_error(sc, "pango_font_descriptions_free", 2, n_descs, "int");
  pango_font_descriptions_free(s7_c_pointer(descs), s7_integer(n_descs));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_set_family(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_family "void pango_font_description_set_family(PangoFontDescription* desc, \
char* family)"
  s7_pointer _p;
  s7_pointer desc, family;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family", 1, desc, "PangoFontDescription*");
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family", 2, family, "char*");
  pango_font_description_set_family(s7_c_pointer(desc), (char*)s7_string(family));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_set_family_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_family_static "void pango_font_description_set_family_static(PangoFontDescription* desc, \
char* family)"
  s7_pointer _p;
  s7_pointer desc, family;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family_static", 1, desc, "PangoFontDescription*");
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family_static", 2, family, "char*");
  pango_font_description_set_family_static(s7_c_pointer(desc), (char*)s7_string(family));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_family(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_family "char* pango_font_description_get_family(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_family", 1, desc, "PangoFontDescription*");
  return(s7_make_string(sc, pango_font_description_get_family(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_style(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_style "void pango_font_description_set_style(PangoFontDescription* desc, \
PangoStyle style)"
  s7_pointer _p;
  s7_pointer desc, style;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_style", 1, desc, "PangoFontDescription*");
  style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "pango_font_description_set_style", 2, style, "PangoStyle");
  pango_font_description_set_style(s7_c_pointer(desc), s7_integer(style));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_style(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_style "PangoStyle pango_font_description_get_style(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_style", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_style(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_variant(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_variant "void pango_font_description_set_variant(PangoFontDescription* desc, \
PangoVariant variant)"
  s7_pointer _p;
  s7_pointer desc, variant;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_variant", 1, desc, "PangoFontDescription*");
  variant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(variant)) s7_wrong_type_arg_error(sc, "pango_font_description_set_variant", 2, variant, "PangoVariant");
  pango_font_description_set_variant(s7_c_pointer(desc), s7_integer(variant));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_variant(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_variant "PangoVariant pango_font_description_get_variant(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_variant", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_variant(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_weight "void pango_font_description_set_weight(PangoFontDescription* desc, \
PangoWeight weight)"
  s7_pointer _p;
  s7_pointer desc, weight;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_weight", 1, desc, "PangoFontDescription*");
  weight = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "pango_font_description_set_weight", 2, weight, "PangoWeight");
  pango_font_description_set_weight(s7_c_pointer(desc), s7_integer(weight));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_weight "PangoWeight pango_font_description_get_weight(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_weight", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_weight(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_stretch(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_stretch "void pango_font_description_set_stretch(PangoFontDescription* desc, \
PangoStretch stretch)"
  s7_pointer _p;
  s7_pointer desc, stretch;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_stretch", 1, desc, "PangoFontDescription*");
  stretch = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(stretch)) s7_wrong_type_arg_error(sc, "pango_font_description_set_stretch", 2, stretch, "PangoStretch");
  pango_font_description_set_stretch(s7_c_pointer(desc), s7_integer(stretch));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_stretch(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_stretch "PangoStretch pango_font_description_get_stretch(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_stretch", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_stretch(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_size "void pango_font_description_set_size(PangoFontDescription* desc, \
gint size)"
  s7_pointer _p;
  s7_pointer desc, size;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_size", 1, desc, "PangoFontDescription*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_font_description_set_size", 2, size, "gint");
  pango_font_description_set_size(s7_c_pointer(desc), s7_integer(size));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_size "gint pango_font_description_get_size(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_size", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_size(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_get_set_fields(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_set_fields "PangoFontMask pango_font_description_get_set_fields(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_set_fields", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_set_fields(s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_unset_fields(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_unset_fields "void pango_font_description_unset_fields(PangoFontDescription* desc, \
PangoFontMask to_unset)"
  s7_pointer _p;
  s7_pointer desc, to_unset;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_unset_fields", 1, desc, "PangoFontDescription*");
  to_unset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(to_unset)) s7_wrong_type_arg_error(sc, "pango_font_description_unset_fields", 2, to_unset, "PangoFontMask");
  pango_font_description_unset_fields(s7_c_pointer(desc), s7_integer(to_unset));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_merge(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_merge "void pango_font_description_merge(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  s7_pointer _p;
  s7_pointer desc, desc_to_merge, replace_existing;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 1, desc, "PangoFontDescription*");
  desc_to_merge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc_to_merge, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 2, desc_to_merge, "PangoFontDescription*");
  replace_existing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(replace_existing)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 3, replace_existing, "gboolean");
  pango_font_description_merge(s7_c_pointer(desc), s7_c_pointer(desc_to_merge), lg_boolean(replace_existing));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_merge_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_merge_static "void pango_font_description_merge_static(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  s7_pointer _p;
  s7_pointer desc, desc_to_merge, replace_existing;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 1, desc, "PangoFontDescription*");
  desc_to_merge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc_to_merge, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 2, desc_to_merge, "PangoFontDescription*");
  replace_existing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(replace_existing)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 3, replace_existing, "gboolean");
  pango_font_description_merge_static(s7_c_pointer(desc), s7_c_pointer(desc_to_merge), lg_boolean(replace_existing));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_better_match(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_better_match "gboolean pango_font_description_better_match(PangoFontDescription* desc, \
PangoFontDescription* old_match, PangoFontDescription* new_match)"
  s7_pointer _p;
  s7_pointer desc, old_match, new_match;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 1, desc, "PangoFontDescription*");
  old_match = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(old_match, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 2, old_match, "PangoFontDescription*");
  new_match = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_match, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 3, new_match, "PangoFontDescription*");
  return(s7_make_boolean(sc, pango_font_description_better_match(s7_c_pointer(desc), s7_c_pointer(old_match), s7_c_pointer(new_match))));
}

static s7_pointer lg_pango_font_description_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_from_string "PangoFontDescription* pango_font_description_from_string(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "pango_font_description_from_string", 1, str, "char*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_description_from_string((char*)s7_string(str))));
}

static s7_pointer lg_pango_font_description_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_to_string "char* pango_font_description_to_string(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_to_string", 1, desc, "PangoFontDescription*");
  {
    char* result;
    s7_pointer rtn;
    result = pango_font_description_to_string(s7_c_pointer(desc));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_pango_font_description_to_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_to_filename "char* pango_font_description_to_filename(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_to_filename", 1, desc, "PangoFontDescription*");
  {
    char* result;
    s7_pointer rtn;
    result = pango_font_description_to_filename(s7_c_pointer(desc));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_pango_font_metrics_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_ref "PangoFontMetrics* pango_font_metrics_ref(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_ref", 1, metrics, "PangoFontMetrics*");
  return(s7_make_type_with_c_pointer(sc, PangoFontMetrics__sym, pango_font_metrics_ref(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_unref "void pango_font_metrics_unref(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_unref", 1, metrics, "PangoFontMetrics*");
  pango_font_metrics_unref(s7_c_pointer(metrics));
  return(lg_false);
}

static s7_pointer lg_pango_font_metrics_get_ascent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_ascent "int pango_font_metrics_get_ascent(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_ascent", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_ascent(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_descent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_descent "int pango_font_metrics_get_descent(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_descent", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_descent(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_approximate_char_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_approximate_char_width "int pango_font_metrics_get_approximate_char_width(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_approximate_char_width", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_approximate_char_width(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_approximate_digit_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_approximate_digit_width "int pango_font_metrics_get_approximate_digit_width(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_approximate_digit_width", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_approximate_digit_width(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_family_list_faces(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_list_faces "void pango_font_family_list_faces(PangoFontFamily* family, \
PangoFontFace*** [faces], int* [n_faces])"
  s7_pointer _p;
  s7_pointer family;
  PangoFontFace** ref_faces = NULL;
  int ref_n_faces;
  _p = args;
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_list_faces", 1, family, "PangoFontFamily*");
  pango_font_family_list_faces(s7_c_pointer(family), &ref_faces, &ref_n_faces);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_faces), s7_make_integer(sc, ref_n_faces)));
}

static s7_pointer lg_pango_font_family_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_get_name "char* pango_font_family_get_name(PangoFontFamily* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_get_name", 1, family, "PangoFontFamily*");
  return(s7_make_string(sc, pango_font_family_get_name(s7_c_pointer(family))));
}

static s7_pointer lg_pango_font_face_describe(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_describe "PangoFontDescription* pango_font_face_describe(PangoFontFace* face)"
  s7_pointer face;
  face = s7_car(args);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_describe", 1, face, "PangoFontFace*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_face_describe(s7_c_pointer(face))));
}

static s7_pointer lg_pango_font_face_get_face_name(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_get_face_name "char* pango_font_face_get_face_name(PangoFontFace* face)"
  s7_pointer face;
  face = s7_car(args);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_get_face_name", 1, face, "PangoFontFace*");
  return(s7_make_string(sc, pango_font_face_get_face_name(s7_c_pointer(face))));
}

static s7_pointer lg_pango_font_describe(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_describe "PangoFontDescription* pango_font_describe(PangoFont* font)"
  s7_pointer font;
  font = s7_car(args);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_describe", 1, font, "PangoFont*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, pango_font_describe(s7_c_pointer(font))));
}

static s7_pointer lg_pango_font_get_coverage(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_coverage "PangoCoverage* pango_font_get_coverage(PangoFont* font, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer font, language;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_coverage", 1, font, "PangoFont*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_coverage", 2, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoCoverage__sym, pango_font_get_coverage(s7_c_pointer(font), s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_get_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_metrics "PangoFontMetrics* pango_font_get_metrics(PangoFont* font, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer font, language;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_metrics", 1, font, "PangoFont*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_metrics", 2, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoFontMetrics__sym, pango_font_get_metrics(s7_c_pointer(font), s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_get_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_glyph_extents "void pango_font_get_glyph_extents(PangoFont* font, PangoGlyph glyph, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer font, glyph, ink_rect, logical_rect;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 1, font, "PangoFont*");
  glyph = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(glyph)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 2, glyph, "PangoGlyph");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 3, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 4, logical_rect, "PangoRectangle*");
  pango_font_get_glyph_extents(s7_c_pointer(font), s7_integer(glyph), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_font_map_load_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_load_font "PangoFont* pango_font_map_load_font(PangoFontMap* fontmap, PangoContext* context, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer fontmap, context, desc;
  _p = args;
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 1, fontmap, "PangoFontMap*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 2, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 3, desc, "PangoFontDescription*");
  return(s7_make_type_with_c_pointer(sc, PangoFont__sym, pango_font_map_load_font(s7_c_pointer(fontmap), s7_c_pointer(context), s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_map_load_fontset(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_load_fontset "PangoFontset* pango_font_map_load_fontset(PangoFontMap* fontmap, \
PangoContext* context, PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer fontmap, context, desc, language;
  _p = args;
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 1, fontmap, "PangoFontMap*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 2, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 3, desc, "PangoFontDescription*");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 4, language, "PangoLanguage*");
  return(s7_make_type_with_c_pointer(sc, PangoFontset__sym, pango_font_map_load_fontset(s7_c_pointer(fontmap), s7_c_pointer(context), s7_c_pointer(desc), s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_map_list_families(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_list_families "void pango_font_map_list_families(PangoFontMap* fontmap, PangoFontFamily*** [families], \
int* [n_families])"
  s7_pointer _p;
  s7_pointer fontmap;
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  _p = args;
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_list_families", 1, fontmap, "PangoFontMap*");
  pango_font_map_list_families(s7_c_pointer(fontmap), &ref_families, &ref_n_families);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_families), s7_make_integer(sc, ref_n_families)));
}

static s7_pointer lg_pango_glyph_string_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_new "PangoGlyphString* pango_glyph_string_new( void)"
  return(s7_make_type_with_c_pointer(sc, PangoGlyphString__sym, pango_glyph_string_new()));
}

static s7_pointer lg_pango_glyph_string_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_set_size "void pango_glyph_string_set_size(PangoGlyphString* string, gint new_len)"
  s7_pointer _p;
  s7_pointer string, new_len;
  _p = args;
  string = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_set_size", 1, string, "PangoGlyphString*");
  new_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(new_len)) s7_wrong_type_arg_error(sc, "pango_glyph_string_set_size", 2, new_len, "gint");
  pango_glyph_string_set_size(s7_c_pointer(string), s7_integer(new_len));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_copy "PangoGlyphString* pango_glyph_string_copy(PangoGlyphString* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_copy", 1, string, "PangoGlyphString*");
  return(s7_make_type_with_c_pointer(sc, PangoGlyphString__sym, pango_glyph_string_copy(s7_c_pointer(string))));
}

static s7_pointer lg_pango_glyph_string_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_free "void pango_glyph_string_free(PangoGlyphString* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_free", 1, string, "PangoGlyphString*");
  pango_glyph_string_free(s7_c_pointer(string));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_extents "void pango_glyph_string_extents(PangoGlyphString* glyphs, PangoFont* font, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer glyphs, font, ink_rect, logical_rect;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 1, glyphs, "PangoGlyphString*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 2, font, "PangoFont*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 3, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 4, logical_rect, "PangoRectangle*");
  pango_glyph_string_extents(s7_c_pointer(glyphs), s7_c_pointer(font), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_extents_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_extents_range "void pango_glyph_string_extents_range(PangoGlyphString* glyphs, \
int start, int end, PangoFont* font, PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer glyphs, start, end, font, ink_rect, logical_rect;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 1, glyphs, "PangoGlyphString*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 2, start, "int");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 3, end, "int");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 4, font, "PangoFont*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 5, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 6, logical_rect, "PangoRectangle*");
  pango_glyph_string_extents_range(s7_c_pointer(glyphs), s7_integer(start), s7_integer(end), s7_c_pointer(font), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_get_logical_widths(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_get_logical_widths "void pango_glyph_string_get_logical_widths(PangoGlyphString* glyphs, \
char* text, int length, int embedding_level, int* [logical_widths])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, embedding_level;
  int ref_logical_widths;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 3, length, "int");
  embedding_level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(embedding_level)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 4, embedding_level, "int");
  pango_glyph_string_get_logical_widths(s7_c_pointer(glyphs), (char*)s7_string(text), s7_integer(length), s7_integer(embedding_level), &ref_logical_widths);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_logical_widths)));
}

static s7_pointer lg_pango_glyph_string_index_to_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_index_to_x "void pango_glyph_string_index_to_x(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int index, gboolean trailing, int* [x_pos])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, analysis, index, trailing;
  int ref_x_pos;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 3, length, "int");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 4, analysis, "PangoAnalysis*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 5, index, "int");
  trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 6, trailing, "gboolean");
  pango_glyph_string_index_to_x(s7_c_pointer(glyphs), (char*)s7_string(text), s7_integer(length), s7_c_pointer(analysis), s7_integer(index), lg_boolean(trailing), &ref_x_pos);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_pango_glyph_string_x_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_x_to_index "void pango_glyph_string_x_to_index(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int x_pos, int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, analysis, x_pos;
  int ref_index;
  int ref_trailing;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 3, length, "int");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 4, analysis, "PangoAnalysis*");
  x_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_pos)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 5, x_pos, "int");
  pango_glyph_string_x_to_index(s7_c_pointer(glyphs), (char*)s7_string(text), s7_integer(length), s7_c_pointer(analysis), s7_integer(x_pos), &ref_index, &ref_trailing);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
}

static s7_pointer lg_pango_shape(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_shape "void pango_shape(gchar* text, gint length, PangoAnalysis* analysis, PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer text, length, analysis, glyphs;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_shape", 1, text, "gchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_shape", 2, length, "gint");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_shape", 3, analysis, "PangoAnalysis*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_shape", 4, glyphs, "PangoGlyphString*");
  pango_shape(s7_string(text), s7_integer(length), s7_c_pointer(analysis), s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_reorder_items(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_reorder_items "GList* pango_reorder_items(GList* logical_items)"
  s7_pointer logical_items;
  logical_items = s7_car(args);
  if (!s7_is_c_pointer_of_type(logical_items, GList__sym)) s7_wrong_type_arg_error(sc, "pango_reorder_items", 1, logical_items, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, pango_reorder_items(s7_c_pointer(logical_items))));
}

static s7_pointer lg_pango_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_new "PangoItem* pango_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, PangoItem__sym, pango_item_new()));
}

static s7_pointer lg_pango_item_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_copy "PangoItem* pango_item_copy(PangoItem* item)"
  s7_pointer item;
  item = s7_car(args);
  if (!s7_is_c_pointer_of_type(item, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_copy", 1, item, "PangoItem*");
  return(s7_make_type_with_c_pointer(sc, PangoItem__sym, pango_item_copy(s7_c_pointer(item))));
}

static s7_pointer lg_pango_item_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_free "void pango_item_free(PangoItem* item)"
  s7_pointer item;
  item = s7_car(args);
  if (!s7_is_c_pointer_of_type(item, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_free", 1, item, "PangoItem*");
  pango_item_free(s7_c_pointer(item));
  return(lg_false);
}

static s7_pointer lg_pango_item_split(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_split "PangoItem* pango_item_split(PangoItem* orig, int split_index, int split_offset)"
  s7_pointer _p;
  s7_pointer orig, split_index, split_offset;
  _p = args;
  orig = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(orig, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_split", 1, orig, "PangoItem*");
  split_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(split_index)) s7_wrong_type_arg_error(sc, "pango_item_split", 2, split_index, "int");
  split_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(split_offset)) s7_wrong_type_arg_error(sc, "pango_item_split", 3, split_offset, "int");
  return(s7_make_type_with_c_pointer(sc, PangoItem__sym, pango_item_split(s7_c_pointer(orig), s7_integer(split_index), s7_integer(split_offset))));
}

static s7_pointer lg_pango_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_new "PangoLayout* pango_layout_new(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_layout_new", 1, context, "PangoContext*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, pango_layout_new(s7_c_pointer(context))));
}

static s7_pointer lg_pango_layout_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_copy "PangoLayout* pango_layout_copy(PangoLayout* src)"
  s7_pointer src;
  src = s7_car(args);
  if (!s7_is_c_pointer_of_type(src, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_copy", 1, src, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, pango_layout_copy(s7_c_pointer(src))));
}

static s7_pointer lg_pango_layout_get_context(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_context "PangoContext* pango_layout_get_context(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_context", 1, layout, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, pango_layout_get_context(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_attributes "void pango_layout_set_attributes(PangoLayout* layout, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer layout, attrs;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_attributes", 1, layout, "PangoLayout*");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_attributes", 2, attrs, "PangoAttrList*");
  pango_layout_set_attributes(s7_c_pointer(layout), s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_attributes "PangoAttrList* pango_layout_get_attributes(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_attributes", 1, layout, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, pango_layout_get_attributes(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_text "void pango_layout_set_text(PangoLayout* layout, char* text, int length)"
  s7_pointer _p;
  s7_pointer layout, text, length;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 1, layout, "PangoLayout*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 3, length, "int");
  pango_layout_set_text(s7_c_pointer(layout), (char*)s7_string(text), s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_text "char* pango_layout_get_text(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_text", 1, layout, "PangoLayout*");
  return(s7_make_string(sc, pango_layout_get_text(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_markup "void pango_layout_set_markup(PangoLayout* layout, char* markup, \
int length)"
  s7_pointer _p;
  s7_pointer layout, markup, length;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 1, layout, "PangoLayout*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 2, markup, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 3, length, "int");
  pango_layout_set_markup(s7_c_pointer(layout), (char*)s7_string(markup), s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_markup_with_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_markup_with_accel "void pango_layout_set_markup_with_accel(PangoLayout* layout, \
char* markup, int length, gunichar accel_marker, gunichar* accel_char)"
  s7_pointer _p;
  s7_pointer layout, markup, length, accel_marker, accel_char;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 1, layout, "PangoLayout*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 2, markup, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 3, length, "int");
  accel_marker = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_marker)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 4, accel_marker, "gunichar");
  accel_char = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_char, gunichar__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 5, accel_char, "gunichar*");
  pango_layout_set_markup_with_accel(s7_c_pointer(layout), (char*)s7_string(markup), s7_integer(length), s7_integer(accel_marker), s7_c_pointer(accel_char));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_font_description "void pango_layout_set_font_description(PangoLayout* layout, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer layout, desc;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_font_description", 1, layout, "PangoLayout*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_font_description", 2, desc, "PangoFontDescription*");
  pango_layout_set_font_description(s7_c_pointer(layout), s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_width "void pango_layout_set_width(PangoLayout* layout, int width)"
  s7_pointer _p;
  s7_pointer layout, width;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_width", 1, layout, "PangoLayout*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_layout_set_width", 2, width, "int");
  pango_layout_set_width(s7_c_pointer(layout), s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_width "int pango_layout_get_width(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_width", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_width(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_wrap "void pango_layout_set_wrap(PangoLayout* layout, PangoWrapMode wrap)"
  s7_pointer _p;
  s7_pointer layout, wrap;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_wrap", 1, layout, "PangoLayout*");
  wrap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wrap)) s7_wrong_type_arg_error(sc, "pango_layout_set_wrap", 2, wrap, "PangoWrapMode");
  pango_layout_set_wrap(s7_c_pointer(layout), s7_integer(wrap));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_wrap "PangoWrapMode pango_layout_get_wrap(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_wrap", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_wrap(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_indent "void pango_layout_set_indent(PangoLayout* layout, int indent)"
  s7_pointer _p;
  s7_pointer layout, indent;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_indent", 1, layout, "PangoLayout*");
  indent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(indent)) s7_wrong_type_arg_error(sc, "pango_layout_set_indent", 2, indent, "int");
  pango_layout_set_indent(s7_c_pointer(layout), s7_integer(indent));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_indent "int pango_layout_get_indent(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_indent", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_indent(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_spacing "void pango_layout_set_spacing(PangoLayout* layout, int spacing)"
  s7_pointer _p;
  s7_pointer layout, spacing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_spacing", 1, layout, "PangoLayout*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "pango_layout_set_spacing", 2, spacing, "int");
  pango_layout_set_spacing(s7_c_pointer(layout), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_spacing "int pango_layout_get_spacing(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_spacing", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_spacing(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_justify "void pango_layout_set_justify(PangoLayout* layout, gboolean justify)"
  s7_pointer _p;
  s7_pointer layout, justify;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_justify", 1, layout, "PangoLayout*");
  justify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(justify)) s7_wrong_type_arg_error(sc, "pango_layout_set_justify", 2, justify, "gboolean");
  pango_layout_set_justify(s7_c_pointer(layout), lg_boolean(justify));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_justify "gboolean pango_layout_get_justify(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_justify", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_justify(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_alignment "void pango_layout_set_alignment(PangoLayout* layout, PangoAlignment alignment)"
  s7_pointer _p;
  s7_pointer layout, alignment;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_alignment", 1, layout, "PangoLayout*");
  alignment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(alignment)) s7_wrong_type_arg_error(sc, "pango_layout_set_alignment", 2, alignment, "PangoAlignment");
  pango_layout_set_alignment(s7_c_pointer(layout), s7_integer(alignment));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_alignment "PangoAlignment pango_layout_get_alignment(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_alignment", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_alignment(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_tabs "void pango_layout_set_tabs(PangoLayout* layout, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer layout, tabs;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_tabs", 1, layout, "PangoLayout*");
  tabs = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) && (tabs != lg_false)) s7_wrong_type_arg_error(sc, "pango_layout_set_tabs", 2, tabs, "PangoTabArray*");
  pango_layout_set_tabs(s7_c_pointer(layout), s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_tabs "PangoTabArray* pango_layout_get_tabs(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_tabs", 1, layout, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, PangoTabArray__sym, pango_layout_get_tabs(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_single_paragraph_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_single_paragraph_mode "void pango_layout_set_single_paragraph_mode(PangoLayout* layout, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer layout, setting;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_single_paragraph_mode", 1, layout, "PangoLayout*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "pango_layout_set_single_paragraph_mode", 2, setting, "gboolean");
  pango_layout_set_single_paragraph_mode(s7_c_pointer(layout), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_single_paragraph_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_single_paragraph_mode "gboolean pango_layout_get_single_paragraph_mode(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_single_paragraph_mode", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_single_paragraph_mode(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_context_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_context_changed "void pango_layout_context_changed(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_context_changed", 1, layout, "PangoLayout*");
  pango_layout_context_changed(s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_log_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_log_attrs "void pango_layout_get_log_attrs(PangoLayout* layout, PangoLogAttr** [attrs], \
gint* [n_attrs])"
  s7_pointer _p;
  s7_pointer layout;
  PangoLogAttr* ref_attrs = NULL;
  gint ref_n_attrs;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_log_attrs", 1, layout, "PangoLayout*");
  pango_layout_get_log_attrs(s7_c_pointer(layout), &ref_attrs, &ref_n_attrs);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_attrs), s7_make_integer(sc, ref_n_attrs)));
}

static s7_pointer lg_pango_layout_index_to_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_index_to_pos "void pango_layout_index_to_pos(PangoLayout* layout, int index, \
PangoRectangle* pos)"
  s7_pointer _p;
  s7_pointer layout, index, pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 1, layout, "PangoLayout*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 2, index, "int");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 3, pos, "PangoRectangle*");
  pango_layout_index_to_pos(s7_c_pointer(layout), s7_integer(index), s7_c_pointer(pos));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_cursor_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_cursor_pos "void pango_layout_get_cursor_pos(PangoLayout* layout, int index, \
PangoRectangle* strong_pos, PangoRectangle* weak_pos)"
  s7_pointer _p;
  s7_pointer layout, index, strong_pos, weak_pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 1, layout, "PangoLayout*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 2, index, "int");
  strong_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(strong_pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 3, strong_pos, "PangoRectangle*");
  weak_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(weak_pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 4, weak_pos, "PangoRectangle*");
  pango_layout_get_cursor_pos(s7_c_pointer(layout), s7_integer(index), s7_c_pointer(strong_pos), s7_c_pointer(weak_pos));
  return(lg_false);
}

static s7_pointer lg_pango_layout_move_cursor_visually(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_move_cursor_visually "void pango_layout_move_cursor_visually(PangoLayout* layout, \
gboolean strong, int old_index, int old_trailing, int direction, int* new_index, int* new_trailing)"
  s7_pointer _p;
  s7_pointer layout, strong, old_index, old_trailing, direction, new_index, new_trailing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 1, layout, "PangoLayout*");
  strong = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(strong)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 2, strong, "gboolean");
  old_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(old_index)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 3, old_index, "int");
  old_trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(old_trailing)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 4, old_trailing, "int");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 5, direction, "int");
  new_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_index, int__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 6, new_index, "int*");
  new_trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_trailing, int__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 7, new_trailing, "int*");
  pango_layout_move_cursor_visually(s7_c_pointer(layout), lg_boolean(strong), s7_integer(old_index), s7_integer(old_trailing), s7_integer(direction), s7_c_pointer(new_index), s7_c_pointer(new_trailing));
  return(lg_false);
}

static s7_pointer lg_pango_layout_xy_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_xy_to_index "gboolean pango_layout_xy_to_index(PangoLayout* layout, int x, int y, \
int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer layout, x, y;
  int ref_index;
  int ref_trailing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 1, layout, "PangoLayout*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 3, y, "int");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, pango_layout_xy_to_index(s7_c_pointer(layout), s7_integer(x), s7_integer(y), &ref_index, &ref_trailing));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
   }
}

static s7_pointer lg_pango_layout_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_extents "void pango_layout_get_extents(PangoLayout* layout, PangoRectangle* ink_rect, \
PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout, ink_rect, logical_rect;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 1, layout, "PangoLayout*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_get_extents(s7_c_pointer(layout), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_pixel_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_pixel_extents "void pango_layout_get_pixel_extents(PangoLayout* layout, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout, ink_rect, logical_rect;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 1, layout, "PangoLayout*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_get_pixel_extents(s7_c_pointer(layout), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_size "void pango_layout_get_size(PangoLayout* layout, int* [width], int* [height])"
  s7_pointer _p;
  s7_pointer layout;
  int ref_width;
  int ref_height;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_size", 1, layout, "PangoLayout*");
  pango_layout_get_size(s7_c_pointer(layout), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_pango_layout_get_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_pixel_size "void pango_layout_get_pixel_size(PangoLayout* layout, int* [width], \
int* [height])"
  s7_pointer _p;
  s7_pointer layout;
  int ref_width;
  int ref_height;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_size", 1, layout, "PangoLayout*");
  pango_layout_get_pixel_size(s7_c_pointer(layout), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_pango_layout_get_line_count(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_line_count "int pango_layout_get_line_count(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_line_count", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_line_count(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_line "PangoLayoutLine* pango_layout_get_line(PangoLayout* layout, int line)"
  s7_pointer _p;
  s7_pointer layout, line;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_line", 1, layout, "PangoLayout*");
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line)) s7_wrong_type_arg_error(sc, "pango_layout_get_line", 2, line, "int");
  return(s7_make_type_with_c_pointer(sc, PangoLayoutLine__sym, pango_layout_get_line(s7_c_pointer(layout), s7_integer(line))));
}

static s7_pointer lg_pango_layout_get_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_lines "GSList* pango_layout_get_lines(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_lines", 1, layout, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, pango_layout_get_lines(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_line_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_unref "void pango_layout_line_unref(PangoLayoutLine* line)"
  s7_pointer line;
  line = s7_car(args);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_unref", 1, line, "PangoLayoutLine*");
  pango_layout_line_unref(s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_layout_line_x_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_x_to_index "gboolean pango_layout_line_x_to_index(PangoLayoutLine* line, \
int x_pos, int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer line, x_pos;
  int ref_index;
  int ref_trailing;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_x_to_index", 1, line, "PangoLayoutLine*");
  x_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_pos)) s7_wrong_type_arg_error(sc, "pango_layout_line_x_to_index", 2, x_pos, "int");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, pango_layout_line_x_to_index(s7_c_pointer(line), s7_integer(x_pos), &ref_index, &ref_trailing));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
   }
}

static s7_pointer lg_pango_layout_line_index_to_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_index_to_x "void pango_layout_line_index_to_x(PangoLayoutLine* line, int index, \
gboolean trailing, int* [x_pos])"
  s7_pointer _p;
  s7_pointer line, index, trailing;
  int ref_x_pos;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 1, line, "PangoLayoutLine*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 2, index, "int");
  trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 3, trailing, "gboolean");
  pango_layout_line_index_to_x(s7_c_pointer(line), s7_integer(index), lg_boolean(trailing), &ref_x_pos);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_pango_layout_line_get_x_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_x_ranges "void pango_layout_line_get_x_ranges(PangoLayoutLine* line, \
int start_index, int end_index, int** [ranges], int* [n_ranges])"
  s7_pointer _p;
  s7_pointer line, start_index, end_index;
  int* ref_ranges = NULL;
  int ref_n_ranges;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 1, line, "PangoLayoutLine*");
  start_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_index)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 2, start_index, "int");
  end_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end_index)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 3, end_index, "int");
  pango_layout_line_get_x_ranges(s7_c_pointer(line), s7_integer(start_index), s7_integer(end_index), &ref_ranges, &ref_n_ranges);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_ranges), s7_make_integer(sc, ref_n_ranges)));
}

static s7_pointer lg_pango_layout_line_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_extents "void pango_layout_line_get_extents(PangoLayoutLine* line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer line, ink_rect, logical_rect;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 1, line, "PangoLayoutLine*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_line_get_extents(s7_c_pointer(line), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_line_get_pixel_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_pixel_extents "void pango_layout_line_get_pixel_extents(PangoLayoutLine* layout_line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout_line, ink_rect, logical_rect;
  _p = args;
  layout_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout_line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 1, layout_line, "PangoLayoutLine*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_line_get_pixel_extents(s7_c_pointer(layout_line), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_iter "PangoLayoutIter* pango_layout_get_iter(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_iter", 1, layout, "PangoLayout*");
  return(s7_make_type_with_c_pointer(sc, PangoLayoutIter__sym, pango_layout_get_iter(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_free "void pango_layout_iter_free(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_free", 1, iter, "PangoLayoutIter*");
  pango_layout_iter_free(s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_index "int pango_layout_iter_get_index(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_index", 1, iter, "PangoLayoutIter*");
  return(s7_make_integer(sc, pango_layout_iter_get_index(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_run(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_run "PangoLayoutRun* pango_layout_iter_get_run(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run", 1, iter, "PangoLayoutIter*");
  return(s7_make_type_with_c_pointer(sc, PangoLayoutRun__sym, pango_layout_iter_get_run(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line "PangoLayoutLine* pango_layout_iter_get_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line", 1, iter, "PangoLayoutIter*");
  return(s7_make_type_with_c_pointer(sc, PangoLayoutLine__sym, pango_layout_iter_get_line(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_at_last_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_at_last_line "gboolean pango_layout_iter_at_last_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_at_last_line", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_at_last_line(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_char(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_char "gboolean pango_layout_iter_next_char(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_char", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_char(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_cluster(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_cluster "gboolean pango_layout_iter_next_cluster(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_cluster", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_cluster(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_run(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_run "gboolean pango_layout_iter_next_run(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_run", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_run(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_line "gboolean pango_layout_iter_next_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_line", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_line(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_char_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_char_extents "void pango_layout_iter_get_char_extents(PangoLayoutIter* iter, \
PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_char_extents", 1, iter, "PangoLayoutIter*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_char_extents", 2, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_char_extents(s7_c_pointer(iter), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_cluster_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_cluster_extents "void pango_layout_iter_get_cluster_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_cluster_extents(s7_c_pointer(iter), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_run_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_run_extents "void pango_layout_iter_get_run_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_run_extents(s7_c_pointer(iter), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_line_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line_extents "void pango_layout_iter_get_line_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_line_extents(s7_c_pointer(iter), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_line_yrange(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line_yrange "void pango_layout_iter_get_line_yrange(PangoLayoutIter* iter, \
int* [y0], int* [y1])"
  s7_pointer _p;
  s7_pointer iter;
  int ref_y0;
  int ref_y1;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_yrange", 1, iter, "PangoLayoutIter*");
  pango_layout_iter_get_line_yrange(s7_c_pointer(iter), &ref_y0, &ref_y1);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_y0), s7_make_integer(sc, ref_y1)));
}

static s7_pointer lg_pango_layout_iter_get_layout_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_layout_extents "void pango_layout_iter_get_layout_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_layout_extents(s7_c_pointer(iter), s7_c_pointer(ink_rect), s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_baseline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_baseline "int pango_layout_iter_get_baseline(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_baseline", 1, iter, "PangoLayoutIter*");
  return(s7_make_integer(sc, pango_layout_iter_get_baseline(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_language_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_language_from_string "PangoLanguage* pango_language_from_string(char* language)"
  s7_pointer language;
  language = s7_car(args);
  if (!s7_is_string(language)) s7_wrong_type_arg_error(sc, "pango_language_from_string", 1, language, "char*");
  return(s7_make_type_with_c_pointer(sc, PangoLanguage__sym, pango_language_from_string((char*)s7_string(language))));
}

static s7_pointer lg_pango_language_matches(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_language_matches "gboolean pango_language_matches(PangoLanguage* language, char* range_list)"
  s7_pointer _p;
  s7_pointer language, range_list;
  _p = args;
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_language_matches", 1, language, "PangoLanguage*");
  range_list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(range_list)) s7_wrong_type_arg_error(sc, "pango_language_matches", 2, range_list, "char*");
  return(s7_make_boolean(sc, pango_language_matches(s7_c_pointer(language), (char*)s7_string(range_list))));
}

static s7_pointer lg_G_OBJECT_TYPE(s7_scheme *sc, s7_pointer args)
{
  #define H_G_OBJECT_TYPE "GType G_OBJECT_TYPE(GObject* object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "G_OBJECT_TYPE", 1, object, "GObject*");
  return(s7_make_integer(sc, G_OBJECT_TYPE(s7_c_pointer(object))));
}

static s7_pointer lg_gtk_tree_model_get_string_from_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_string_from_iter "gchar* gtk_tree_model_get_string_from_iter(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_string_from_iter", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_string_from_iter", 2, iter, "GtkTreeIter*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_tree_model_get_string_from_iter(s7_c_pointer(tree_model), s7_c_pointer(iter));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_tree_model_sort_iter_is_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_iter_is_valid "gboolean gtk_tree_model_sort_iter_is_valid(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_iter_is_valid", 1, tree_model_sort, "GtkTreeModelSort*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_iter_is_valid", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_sort_iter_is_valid(s7_c_pointer(tree_model_sort), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_view_expand_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_to_path "void gtk_tree_view_expand_to_path(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_to_path", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_to_path", 2, path, "GtkTreePath*");
  gtk_tree_view_expand_to_path(s7_c_pointer(tree_view), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_get_selected_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_selected_rows "GList* gtk_tree_selection_get_selected_rows(GtkTreeSelection* selection, \
GtkTreeModel** model)"
  s7_pointer _p;
  s7_pointer selection, model;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected_rows", 1, selection, "GtkTreeSelection*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected_rows", 2, model, "GtkTreeModel**");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_tree_selection_get_selected_rows(s7_c_pointer(selection), s7_c_pointer(model))));
}

static s7_pointer lg_gtk_tree_selection_count_selected_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_count_selected_rows "int gtk_tree_selection_count_selected_rows(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_count_selected_rows", 1, selection, "GtkTreeSelection*");
  return(s7_make_integer(sc, gtk_tree_selection_count_selected_rows(s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_menu_shell_select_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_select_first "void gtk_menu_shell_select_first(GtkMenuShell* menu_shell, gboolean search_sensitive)"
  s7_pointer _p;
  s7_pointer menu_shell, search_sensitive;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_select_first", 1, menu_shell, "GtkMenuShell*");
  search_sensitive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(search_sensitive)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_select_first", 2, search_sensitive, "gboolean");
  gtk_menu_shell_select_first(s7_c_pointer(menu_shell), lg_boolean(search_sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_n_pages "int gtk_notebook_get_n_pages(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_n_pages", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_n_pages(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_list_store_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_reorder "void gtk_list_store_reorder(GtkListStore* store, int* new_order)"
  s7_pointer _p;
  s7_pointer store, new_order;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_reorder", 1, store, "GtkListStore*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, int__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_reorder", 2, new_order, "int*");
  gtk_list_store_reorder(s7_c_pointer(store), s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_swap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_swap "void gtk_list_store_swap(GtkListStore* store, GtkTreeIter* a, GtkTreeIter* b)"
  s7_pointer _p;
  s7_pointer store, a, b;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 1, store, "GtkListStore*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 2, a, "GtkTreeIter*");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 3, b, "GtkTreeIter*");
  gtk_list_store_swap(s7_c_pointer(store), s7_c_pointer(a), s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_move_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_move_after "void gtk_list_store_move_after(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  s7_pointer _p;
  s7_pointer store, iter, position;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 1, store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(position, GtkTreeIter__sym)) && (position != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 3, position, "GtkTreeIter*");
  gtk_list_store_move_after(s7_c_pointer(store), s7_c_pointer(iter), s7_c_pointer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_move_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_move_before "void gtk_list_store_move_before(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  s7_pointer _p;
  s7_pointer store, iter, position;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 1, store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(position, GtkTreeIter__sym)) && (position != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 3, position, "GtkTreeIter*");
  gtk_list_store_move_before(s7_c_pointer(store), s7_c_pointer(iter), s7_c_pointer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_reorder "void gtk_tree_store_reorder(GtkTreeStore* tree_store, GtkTreeIter* parent, \
int* new_order)"
  s7_pointer _p;
  s7_pointer tree_store, parent, new_order;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 1, tree_store, "GtkTreeStore*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 2, parent, "GtkTreeIter*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, int__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 3, new_order, "int*");
  gtk_tree_store_reorder(s7_c_pointer(tree_store), s7_c_pointer(parent), s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_swap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_swap "void gtk_tree_store_swap(GtkTreeStore* tree_store, GtkTreeIter* a, GtkTreeIter* b)"
  s7_pointer _p;
  s7_pointer tree_store, a, b;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 1, tree_store, "GtkTreeStore*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 2, a, "GtkTreeIter*");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 3, b, "GtkTreeIter*");
  gtk_tree_store_swap(s7_c_pointer(tree_store), s7_c_pointer(a), s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_gdk_display_open(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_open "GdkDisplay* gdk_display_open(gchar* display_name)"
  s7_pointer display_name;
  display_name = s7_car(args);
  if (!s7_is_string(display_name)) s7_wrong_type_arg_error(sc, "gdk_display_open", 1, display_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_display_open(s7_string(display_name))));
}

static s7_pointer lg_gdk_display_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_name "gchar* gdk_display_get_name(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_name", 1, display, "GdkDisplay*");
  return(s7_make_string(sc, gdk_display_get_name(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_default_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_screen "GdkScreen* gdk_display_get_default_screen(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_screen", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gdk_display_get_default_screen(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_beep(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_beep "void gdk_display_beep(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_beep", 1, display, "GdkDisplay*");
  gdk_display_beep(s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_sync(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_sync "void gdk_display_sync(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_sync", 1, display, "GdkDisplay*");
  gdk_display_sync(s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_close(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_close "void gdk_display_close(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_close", 1, display, "GdkDisplay*");
  gdk_display_close(s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_get_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_event "GdkEvent* gdk_display_get_event(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_event", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gdk_display_get_event(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_peek_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_peek_event "GdkEvent* gdk_display_peek_event(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_peek_event", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, gdk_display_peek_event(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_put_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_put_event "void gdk_display_put_event(GdkDisplay* display, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer display, event;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_put_event", 1, display, "GdkDisplay*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_display_put_event", 2, event, "GdkEvent*");
  gdk_display_put_event(s7_c_pointer(display), s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_display_set_double_click_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_set_double_click_time "void gdk_display_set_double_click_time(GdkDisplay* display, \
guint msec)"
  s7_pointer _p;
  s7_pointer display, msec;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_set_double_click_time", 1, display, "GdkDisplay*");
  msec = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(msec)) s7_wrong_type_arg_error(sc, "gdk_display_set_double_click_time", 2, msec, "guint");
  gdk_display_set_double_click_time(s7_c_pointer(display), s7_integer(msec));
  return(lg_false);
}

static s7_pointer lg_gdk_display_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default "GdkDisplay* gdk_display_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_display_get_default()));
}

static s7_pointer lg_gdk_screen_get_root_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_get_root_window "GdkWindow* gdk_screen_get_root_window(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gdk_screen_get_root_window", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_screen_get_root_window(s7_c_pointer(screen))));
}

static s7_pointer lg_gdk_screen_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_get_display "GdkDisplay* gdk_screen_get_display(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gdk_screen_get_display", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_screen_get_display(s7_c_pointer(screen))));
}

static s7_pointer lg_gdk_screen_get_toplevel_windows(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_get_toplevel_windows "GList* gdk_screen_get_toplevel_windows(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gdk_screen_get_toplevel_windows", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_screen_get_toplevel_windows(s7_c_pointer(screen))));
}

static s7_pointer lg_gdk_screen_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_get_default "GdkScreen* gdk_screen_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gdk_screen_get_default()));
}

static s7_pointer lg_gtk_clipboard_get_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get_for_display "GtkClipboard* gtk_clipboard_get_for_display(GdkDisplay* display, \
GdkAtom selection)"
  s7_pointer _p;
  s7_pointer display, selection;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_for_display", 1, display, "GdkDisplay*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_for_display", 2, selection, "GdkAtom");
  return(s7_make_type_with_c_pointer(sc, GtkClipboard__sym, gtk_clipboard_get_for_display(s7_c_pointer(display), s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_clipboard_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get_display "GdkDisplay* gtk_clipboard_get_display(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_display", 1, clipboard, "GtkClipboard*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gtk_clipboard_get_display(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_widget_get_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_screen "GdkScreen* gtk_widget_get_screen(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_screen", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gtk_widget_get_screen(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_has_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_screen "gboolean gtk_widget_has_screen(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_screen", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_screen(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_display "GdkDisplay* gtk_widget_get_display(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_display", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gtk_widget_get_display(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_clipboard "GtkClipboard* gtk_widget_get_clipboard(GtkWidget* widget, GdkAtom selection)"
  s7_pointer _p;
  s7_pointer widget, selection;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_clipboard", 1, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_clipboard", 2, selection, "GdkAtom");
  return(s7_make_type_with_c_pointer(sc, GtkClipboard__sym, gtk_widget_get_clipboard(s7_c_pointer(widget), s7_c_pointer(selection))));
}

static s7_pointer lg_g_list_free(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_free "void g_list_free(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_free", 1, list, "GList*");
  g_list_free(s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_g_list_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_reverse "GList* g_list_reverse(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_reverse", 1, list, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, g_list_reverse(s7_c_pointer(list))));
}

static s7_pointer lg_g_list_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_copy "GList* g_list_copy(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_copy", 1, list, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, g_list_copy(s7_c_pointer(list))));
}

static s7_pointer lg_g_list_last(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_last "GList* g_list_last(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_last", 1, list, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, g_list_last(s7_c_pointer(list))));
}

static s7_pointer lg_g_list_first(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_first "GList* g_list_first(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_first", 1, list, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, g_list_first(s7_c_pointer(list))));
}

static s7_pointer lg_g_list_length(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_length "guint g_list_length(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_length", 1, list, "GList*");
  return(s7_make_integer(sc, g_list_length(s7_c_pointer(list))));
}

static s7_pointer lg_g_free(s7_scheme *sc, s7_pointer args)
{
  #define H_g_free "void g_free(gpointer mem)"
  s7_pointer mem;
  mem = s7_car(args);
  if (!s7_is_c_pointer_of_type(mem, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_free", 1, mem, "gpointer");
  g_free(s7_c_pointer(mem));
  return(lg_false);
}

static s7_pointer lg_g_list_remove_link(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_remove_link "GList* g_list_remove_link(GList* list, GList* llink)"
  s7_pointer _p;
  s7_pointer list, llink;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_remove_link", 1, list, "GList*");
  llink = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(llink, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_remove_link", 2, llink, "GList*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, g_list_remove_link(s7_c_pointer(list), s7_c_pointer(llink))));
}

static s7_pointer lg_g_object_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_get_data "gpointer g_object_get_data(GObject* object, gchar* key)"
  s7_pointer _p;
  s7_pointer object, key;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "g_object_get_data", 1, object, "GObject*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "g_object_get_data", 2, key, "gchar*");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, g_object_get_data(s7_c_pointer(object), (const gchar*)s7_string(key))));
}

static s7_pointer lg_g_object_set_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_set_data "void g_object_set_data(GObject* object, gchar* key, gpointer data)"
  s7_pointer _p;
  s7_pointer object, key, data;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "g_object_set_data", 1, object, "GObject*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "g_object_set_data", 2, key, "gchar*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_set_data", 3, data, "gpointer");
  g_object_set_data(s7_c_pointer(object), (const gchar*)s7_string(key), s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gdk_cursor_new_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_from_pixbuf "GdkCursor* gdk_cursor_new_from_pixbuf(GdkDisplay* display, GdkPixbuf* pixbuf, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer display, pixbuf, x, y;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_pixbuf", 1, display, "GdkDisplay*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_pixbuf", 2, pixbuf, "GdkPixbuf*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_pixbuf", 3, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_pixbuf", 4, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_cursor_new_from_pixbuf(s7_c_pointer(display), s7_c_pointer(pixbuf), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gdk_display_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_flush "void gdk_display_flush(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_flush", 1, display, "GdkDisplay*");
  gdk_display_flush(s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_supports_cursor_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_cursor_alpha "gboolean gdk_display_supports_cursor_alpha(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_cursor_alpha", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_cursor_alpha(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_supports_cursor_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_cursor_color "gboolean gdk_display_supports_cursor_color(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_cursor_color", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_cursor_color(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_default_cursor_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_cursor_size "guint gdk_display_get_default_cursor_size(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_cursor_size", 1, display, "GdkDisplay*");
  return(s7_make_integer(sc, gdk_display_get_default_cursor_size(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_maximal_cursor_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_maximal_cursor_size "void gdk_display_get_maximal_cursor_size(GdkDisplay* display, \
guint* [width], guint* [height])"
  s7_pointer _p;
  s7_pointer display;
  guint ref_width;
  guint ref_height;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_maximal_cursor_size", 1, display, "GdkDisplay*");
  gdk_display_get_maximal_cursor_size(s7_c_pointer(display), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gdk_window_set_keep_above(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_keep_above "void gdk_window_set_keep_above(GdkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_keep_above", 1, window, "GdkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gdk_window_set_keep_above", 2, setting, "gboolean");
  gdk_window_set_keep_above(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_keep_below(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_keep_below "void gdk_window_set_keep_below(GdkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_keep_below", 1, window, "GdkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gdk_window_set_keep_below", 2, setting, "gboolean");
  gdk_window_set_keep_below(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_button_box_get_child_secondary(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_get_child_secondary "gboolean gtk_button_box_get_child_secondary(GtkButtonBox* widget, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer widget, child;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_get_child_secondary", 1, widget, "GtkButtonBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_get_child_secondary", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_button_box_get_child_secondary(s7_c_pointer(widget), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_calendar_set_display_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_display_options "void gtk_calendar_set_display_options(GtkCalendar* calendar, \
GtkCalendarDisplayOptions flags)"
  s7_pointer _p;
  s7_pointer calendar, flags;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_display_options", 1, calendar, "GtkCalendar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_display_options", 2, flags, "GtkCalendarDisplayOptions");
  gtk_calendar_set_display_options(s7_c_pointer(calendar), s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_display_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_display_options "GtkCalendarDisplayOptions gtk_calendar_get_display_options(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_display_options", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_display_options(s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_check_menu_item_set_draw_as_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_set_draw_as_radio "void gtk_check_menu_item_set_draw_as_radio(GtkCheckMenuItem* check_menu_item, \
gboolean draw_as_radio)"
  s7_pointer _p;
  s7_pointer check_menu_item, draw_as_radio;
  _p = args;
  check_menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_draw_as_radio", 1, check_menu_item, "GtkCheckMenuItem*");
  draw_as_radio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(draw_as_radio)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_set_draw_as_radio", 2, draw_as_radio, "gboolean");
  gtk_check_menu_item_set_draw_as_radio(s7_c_pointer(check_menu_item), lg_boolean(draw_as_radio));
  return(lg_false);
}

static s7_pointer lg_gtk_check_menu_item_get_draw_as_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_menu_item_get_draw_as_radio "gboolean gtk_check_menu_item_get_draw_as_radio(GtkCheckMenuItem* check_menu_item)"
  s7_pointer check_menu_item;
  check_menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_menu_item, GtkCheckMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_check_menu_item_get_draw_as_radio", 1, check_menu_item, "GtkCheckMenuItem*");
  return(s7_make_boolean(sc, gtk_check_menu_item_get_draw_as_radio(s7_c_pointer(check_menu_item))));
}

static s7_pointer lg_gtk_entry_set_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_completion "void gtk_entry_set_completion(GtkEntry* entry, GtkEntryCompletion* completion)"
  s7_pointer _p;
  s7_pointer entry, completion;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_completion", 1, entry, "GtkEntry*");
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_completion", 2, completion, "GtkEntryCompletion*");
  gtk_entry_set_completion(s7_c_pointer(entry), s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_completion "GtkEntryCompletion* gtk_entry_get_completion(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_completion", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, GtkEntryCompletion__sym, gtk_entry_get_completion(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_menu_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_attach "void gtk_menu_attach(GtkMenu* menu, GtkWidget* child, guint left_attach, \
guint right_attach, guint top_attach, guint bottom_attach)"
  s7_pointer _p;
  s7_pointer menu, child, left_attach, right_attach, top_attach, bottom_attach;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 1, menu, "GtkMenu*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 2, child, "GtkWidget*");
  left_attach = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left_attach)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 3, left_attach, "guint");
  right_attach = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(right_attach)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 4, right_attach, "guint");
  top_attach = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top_attach)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 5, top_attach, "guint");
  bottom_attach = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bottom_attach)) s7_wrong_type_arg_error(sc, "gtk_menu_attach", 6, bottom_attach, "guint");
  gtk_menu_attach(s7_c_pointer(menu), s7_c_pointer(child), s7_integer(left_attach), s7_integer(right_attach), s7_integer(top_attach), s7_integer(bottom_attach));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_select_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_select_range "void gtk_text_buffer_select_range(GtkTextBuffer* buffer, GtkTextIter* ins, \
GtkTextIter* bound)"
  s7_pointer _p;
  s7_pointer buffer, ins, bound;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 1, buffer, "GtkTextBuffer*");
  ins = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ins, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 2, ins, "GtkTextIter*");
  bound = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bound, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 3, bound, "GtkTextIter*");
  gtk_text_buffer_select_range(s7_c_pointer(buffer), s7_c_pointer(ins), s7_c_pointer(bound));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_overwrite(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_overwrite "void gtk_text_view_set_overwrite(GtkTextView* text_view, gboolean overwrite)"
  s7_pointer _p;
  s7_pointer text_view, overwrite;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_overwrite", 1, text_view, "GtkTextView*");
  overwrite = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(overwrite)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_overwrite", 2, overwrite, "gboolean");
  gtk_text_view_set_overwrite(s7_c_pointer(text_view), lg_boolean(overwrite));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_overwrite(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_overwrite "gboolean gtk_text_view_get_overwrite(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_overwrite", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_overwrite(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_accepts_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_accepts_tab "void gtk_text_view_set_accepts_tab(GtkTextView* text_view, \
gboolean accepts_tab)"
  s7_pointer _p;
  s7_pointer text_view, accepts_tab;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_accepts_tab", 1, text_view, "GtkTextView*");
  accepts_tab = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(accepts_tab)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_accepts_tab", 2, accepts_tab, "gboolean");
  gtk_text_view_set_accepts_tab(s7_c_pointer(text_view), lg_boolean(accepts_tab));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_accepts_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_accepts_tab "gboolean gtk_text_view_get_accepts_tab(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_accepts_tab", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_accepts_tab(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_toolbar_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_insert "void gtk_toolbar_insert(GtkToolbar* toolbar, GtkToolItem* item, gint pos)"
  s7_pointer _p;
  s7_pointer toolbar, item, pos;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_insert", 1, toolbar, "GtkToolbar*");
  item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_insert", 2, item, "GtkToolItem*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_toolbar_insert", 3, pos, "gint");
  gtk_toolbar_insert(s7_c_pointer(toolbar), s7_c_pointer(item), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_get_item_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_item_index "gint gtk_toolbar_get_item_index(GtkToolbar* toolbar, GtkToolItem* item)"
  s7_pointer _p;
  s7_pointer toolbar, item;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_item_index", 1, toolbar, "GtkToolbar*");
  item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_item_index", 2, item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_toolbar_get_item_index(s7_c_pointer(toolbar), s7_c_pointer(item))));
}

static s7_pointer lg_gtk_toolbar_get_n_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_n_items "gint gtk_toolbar_get_n_items(GtkToolbar* toolbar)"
  s7_pointer toolbar;
  toolbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_n_items", 1, toolbar, "GtkToolbar*");
  return(s7_make_integer(sc, gtk_toolbar_get_n_items(s7_c_pointer(toolbar))));
}

static s7_pointer lg_gtk_toolbar_get_nth_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_nth_item "GtkToolItem* gtk_toolbar_get_nth_item(GtkToolbar* toolbar, gint n)"
  s7_pointer _p;
  s7_pointer toolbar, n;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_nth_item", 1, toolbar, "GtkToolbar*");
  n = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_nth_item", 2, n, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_toolbar_get_nth_item(s7_c_pointer(toolbar), s7_integer(n))));
}

static s7_pointer lg_gtk_toolbar_set_show_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_set_show_arrow "void gtk_toolbar_set_show_arrow(GtkToolbar* toolbar, gboolean show_arrow)"
  s7_pointer _p;
  s7_pointer toolbar, show_arrow;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_show_arrow", 1, toolbar, "GtkToolbar*");
  show_arrow = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_arrow)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_show_arrow", 2, show_arrow, "gboolean");
  gtk_toolbar_set_show_arrow(s7_c_pointer(toolbar), lg_boolean(show_arrow));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_get_show_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_show_arrow "gboolean gtk_toolbar_get_show_arrow(GtkToolbar* toolbar)"
  s7_pointer toolbar;
  toolbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_show_arrow", 1, toolbar, "GtkToolbar*");
  return(s7_make_boolean(sc, gtk_toolbar_get_show_arrow(s7_c_pointer(toolbar))));
}

static s7_pointer lg_gtk_toolbar_get_drop_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_get_drop_index "gint gtk_toolbar_get_drop_index(GtkToolbar* toolbar, gint x, \
gint y)"
  s7_pointer _p;
  s7_pointer toolbar, x, y;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_drop_index", 1, toolbar, "GtkToolbar*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_drop_index", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_toolbar_get_drop_index", 3, y, "gint");
  return(s7_make_integer(sc, gtk_toolbar_get_drop_index(s7_c_pointer(toolbar), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_tree_view_column_set_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_expand "void gtk_tree_view_column_set_expand(GtkTreeViewColumn* tree_column, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_expand", 1, tree_column, "GtkTreeViewColumn*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_expand", 2, expand, "gboolean");
  gtk_tree_view_column_set_expand(s7_c_pointer(tree_column), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_expand "gboolean gtk_tree_view_column_get_expand(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_expand", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_expand(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_widget_queue_resize_no_redraw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_resize_no_redraw "void gtk_widget_queue_resize_no_redraw(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_resize_no_redraw", 1, widget, "GtkWidget*");
  gtk_widget_queue_resize_no_redraw(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_default_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_icon "void gtk_window_set_default_icon(GdkPixbuf* icon)"
  s7_pointer icon;
  icon = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_icon", 1, icon, "GdkPixbuf*");
  gtk_window_set_default_icon(s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_keep_above(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_keep_above "void gtk_window_set_keep_above(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_keep_above", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_keep_above", 2, setting, "gboolean");
  gtk_window_set_keep_above(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_keep_below(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_keep_below "void gtk_window_set_keep_below(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_keep_below", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_keep_below", 2, setting, "gboolean");
  gtk_window_set_keep_below(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_dialog_new "GtkWidget* gtk_file_chooser_dialog_new(gchar* title, GtkWindow* parent, \
GtkFileChooserAction action, etc buttons)"
  s7_pointer _p;
  s7_pointer title, parent, action, buttons;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 1, title, "gchar*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 2, parent, "GtkWindow*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 3, action, "GtkFileChooserAction");
  buttons = s7_car(_p); _p = s7_cdr(_p);
  if ((!lg_is_list(buttons)) && (buttons != lg_false)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 4, buttons, "etc");
  {
    int etc_len = 0;
    GtkWidget* result = NULL;
    gchar* p_arg0;
    GtkWindow* p_arg1;
    GtkFileChooserAction p_arg2;
    if (s7_is_list(sc, buttons)) etc_len = s7_list_length(sc, buttons);
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_file_chooser_dialog_new", 3, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_file_chooser_dialog_new", 3, buttons, "... list len must be multiple of 2");
    p_arg0 = (gchar*)s7_string(title);
    p_arg1 = (GtkWindow*)s7_c_pointer(parent);
    p_arg2 = (GtkFileChooserAction)s7_integer(action);
    switch (etc_len)
      {
        case 0: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, NULL, NULL); break;
        case 2: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), NULL); break;
        case 4: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), NULL); break;
        case 6: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), NULL); break;
        case 8: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), NULL); break;
        case 10: result = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), s7_string(s7_list_ref(sc, buttons, 8)), s7_integer(s7_list_ref(sc, buttons, 9)), NULL); break;
      }
    return(s7_make_c_pointer(sc, result));
  }
}

static s7_pointer lg_gtk_file_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_widget_new "GtkWidget* gtk_file_chooser_widget_new(GtkFileChooserAction action)"
  s7_pointer action;
  action = s7_car(args);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_widget_new", 1, action, "GtkFileChooserAction");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_file_chooser_widget_new(s7_integer(action))));
}

static s7_pointer lg_gtk_tree_model_filter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_new "GtkTreeModel* gtk_tree_model_filter_new(GtkTreeModel* child_model, \
GtkTreePath* root)"
  s7_pointer _p;
  s7_pointer child_model, root;
  _p = args;
  child_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_new", 1, child_model, "GtkTreeModel*");
  root = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(root, GtkTreePath__sym)) && (root != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_new", 2, root, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_model_filter_new(s7_c_pointer(child_model), s7_c_pointer(root))));
}

static s7_pointer lg_gtk_tree_model_filter_set_visible_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_set_visible_column "void gtk_tree_model_filter_set_visible_column(GtkTreeModelFilter* filter, \
gint column)"
  s7_pointer _p;
  s7_pointer filter, column;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_set_visible_column", 1, filter, "GtkTreeModelFilter*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_set_visible_column", 2, column, "gint");
  gtk_tree_model_filter_set_visible_column(s7_c_pointer(filter), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_get_model "GtkTreeModel* gtk_tree_model_filter_get_model(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_get_model", 1, filter, "GtkTreeModelFilter*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_model_filter_get_model(s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_iter_to_child_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_iter_to_child_iter "void gtk_tree_model_filter_convert_iter_to_child_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* child_iter, GtkTreeIter* filter_iter)"
  s7_pointer _p;
  s7_pointer filter, child_iter, filter_iter;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 1, filter, "GtkTreeModelFilter*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 2, child_iter, "GtkTreeIter*");
  filter_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 3, filter_iter, "GtkTreeIter*");
  gtk_tree_model_filter_convert_iter_to_child_iter(s7_c_pointer(filter), s7_c_pointer(child_iter), s7_c_pointer(filter_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_convert_child_path_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_child_path_to_path "GtkTreePath* gtk_tree_model_filter_convert_child_path_to_path(GtkTreeModelFilter* filter, \
GtkTreePath* child_path)"
  s7_pointer _p;
  s7_pointer filter, child_path;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_path_to_path", 1, filter, "GtkTreeModelFilter*");
  child_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_path_to_path", 2, child_path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_model_filter_convert_child_path_to_path(s7_c_pointer(filter), s7_c_pointer(child_path))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_path_to_child_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_path_to_child_path "GtkTreePath* gtk_tree_model_filter_convert_path_to_child_path(GtkTreeModelFilter* path, \
GtkTreePath* filter_path)"
  s7_pointer _p;
  s7_pointer path, filter_path;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_path_to_child_path", 1, path, "GtkTreeModelFilter*");
  filter_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_path_to_child_path", 2, filter_path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_tree_model_filter_convert_path_to_child_path(s7_c_pointer(path), s7_c_pointer(filter_path))));
}

static s7_pointer lg_gtk_tree_model_filter_refilter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_refilter "void gtk_tree_model_filter_refilter(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_refilter", 1, filter, "GtkTreeModelFilter*");
  gtk_tree_model_filter_refilter(s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_clear_cache(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_clear_cache "void gtk_tree_model_filter_clear_cache(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_clear_cache", 1, filter, "GtkTreeModelFilter*");
  gtk_tree_model_filter_clear_cache(s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new "GtkWidget* gtk_combo_box_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_new()));
}

static s7_pointer lg_gtk_combo_box_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_model "GtkWidget* gtk_combo_box_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_new_with_model", 1, model, "GtkTreeModel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_new_with_model(s7_c_pointer(model))));
}

static s7_pointer lg_gtk_combo_box_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_model "void gtk_combo_box_set_model(GtkComboBox* combo_box, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer combo_box, model;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_model", 1, combo_box, "GtkComboBox*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_model", 2, model, "GtkTreeModel*");
  gtk_combo_box_set_model(s7_c_pointer(combo_box), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_wrap_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_wrap_width "void gtk_combo_box_set_wrap_width(GtkComboBox* combo_box, gint width)"
  s7_pointer _p;
  s7_pointer combo_box, width;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_wrap_width", 1, combo_box, "GtkComboBox*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_wrap_width", 2, width, "gint");
  gtk_combo_box_set_wrap_width(s7_c_pointer(combo_box), s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_row_span_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_row_span_column "void gtk_combo_box_set_row_span_column(GtkComboBox* combo_box, \
gint row_span)"
  s7_pointer _p;
  s7_pointer combo_box, row_span;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_span_column", 1, combo_box, "GtkComboBox*");
  row_span = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row_span)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_span_column", 2, row_span, "gint");
  gtk_combo_box_set_row_span_column(s7_c_pointer(combo_box), s7_integer(row_span));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_column_span_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_column_span_column "void gtk_combo_box_set_column_span_column(GtkComboBox* combo_box, \
gint column_span)"
  s7_pointer _p;
  s7_pointer combo_box, column_span;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_column_span_column", 1, combo_box, "GtkComboBox*");
  column_span = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column_span)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_column_span_column", 2, column_span, "gint");
  gtk_combo_box_set_column_span_column(s7_c_pointer(combo_box), s7_integer(column_span));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active "gint gtk_combo_box_get_active(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_active(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active "void gtk_combo_box_set_active(GtkComboBox* combo_box, gint index)"
  s7_pointer _p;
  s7_pointer combo_box, index;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active", 1, combo_box, "GtkComboBox*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active", 2, index, "gint");
  gtk_combo_box_set_active(s7_c_pointer(combo_box), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active_iter "gboolean gtk_combo_box_get_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer combo_box, iter;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_iter", 1, combo_box, "GtkComboBox*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_iter", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_combo_box_get_active_iter(s7_c_pointer(combo_box), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_combo_box_set_active_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active_iter "void gtk_combo_box_set_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer combo_box, iter;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_iter", 1, combo_box, "GtkComboBox*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_iter", 2, iter, "GtkTreeIter*");
  gtk_combo_box_set_active_iter(s7_c_pointer(combo_box), s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_model "GtkTreeModel* gtk_combo_box_get_model(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_model", 1, combo_box, "GtkComboBox*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_combo_box_get_model(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_expander_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_new "GtkWidget* gtk_expander_new(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_new", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_expander_new(s7_string(label))));
}

static s7_pointer lg_gtk_expander_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_new_with_mnemonic "GtkWidget* gtk_expander_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_new_with_mnemonic", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_expander_new_with_mnemonic(s7_string(label))));
}

static s7_pointer lg_gtk_expander_set_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_expanded "void gtk_expander_set_expanded(GtkExpander* expander, gboolean expanded)"
  s7_pointer _p;
  s7_pointer expander, expanded;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_expanded", 1, expander, "GtkExpander*");
  expanded = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expanded)) s7_wrong_type_arg_error(sc, "gtk_expander_set_expanded", 2, expanded, "gboolean");
  gtk_expander_set_expanded(s7_c_pointer(expander), lg_boolean(expanded));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_expanded "gboolean gtk_expander_get_expanded(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_expanded", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_expanded(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_label "void gtk_expander_set_label(GtkExpander* expander, gchar* label)"
  s7_pointer _p;
  s7_pointer expander, label;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label", 1, expander, "GtkExpander*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label", 2, label, "gchar*");
  gtk_expander_set_label(s7_c_pointer(expander), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_label "gchar* gtk_expander_get_label(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_label", 1, expander, "GtkExpander*");
  return(s7_make_string(sc, gtk_expander_get_label(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_use_underline "void gtk_expander_set_use_underline(GtkExpander* expander, \
gboolean use_underline)"
  s7_pointer _p;
  s7_pointer expander, use_underline;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_underline", 1, expander, "GtkExpander*");
  use_underline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_underline", 2, use_underline, "gboolean");
  gtk_expander_set_use_underline(s7_c_pointer(expander), lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_use_underline "gboolean gtk_expander_get_use_underline(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_use_underline", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_use_underline(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_label_widget "void gtk_expander_set_label_widget(GtkExpander* expander, \
GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer expander, label_widget;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_widget", 1, expander, "GtkExpander*");
  label_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_expander_set_label_widget(s7_c_pointer(expander), s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_label_widget "GtkWidget* gtk_expander_get_label_widget(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_label_widget", 1, expander, "GtkExpander*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_expander_get_label_widget(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_use_markup "void gtk_expander_set_use_markup(GtkExpander* expander, gboolean use_markup)"
  s7_pointer _p;
  s7_pointer expander, use_markup;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_markup", 1, expander, "GtkExpander*");
  use_markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_markup)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_markup", 2, use_markup, "gboolean");
  gtk_expander_set_use_markup(s7_c_pointer(expander), lg_boolean(use_markup));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_use_markup "gboolean gtk_expander_get_use_markup(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_use_markup", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_use_markup(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_font_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_new "GtkWidget* gtk_font_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_font_button_new()));
}

static s7_pointer lg_gtk_font_button_new_with_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_new_with_font "GtkWidget* gtk_font_button_new_with_font(gchar* fontname)"
  s7_pointer fontname;
  fontname = s7_car(args);
  if (!s7_is_string(fontname)) s7_wrong_type_arg_error(sc, "gtk_font_button_new_with_font", 1, fontname, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_font_button_new_with_font(s7_string(fontname))));
}

static s7_pointer lg_gtk_font_button_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_title "gchar* gtk_font_button_get_title(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_title", 1, font_button, "GtkFontButton*");
  return(s7_make_string(sc, gtk_font_button_get_title(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_title "void gtk_font_button_set_title(GtkFontButton* font_button, gchar* title)"
  s7_pointer _p;
  s7_pointer font_button, title;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_title", 1, font_button, "GtkFontButton*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_title", 2, title, "gchar*");
  gtk_font_button_set_title(s7_c_pointer(font_button), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_use_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_use_font "gboolean gtk_font_button_get_use_font(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_use_font", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_use_font(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_use_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_use_font "void gtk_font_button_set_use_font(GtkFontButton* font_button, \
gboolean use_font)"
  s7_pointer _p;
  s7_pointer font_button, use_font;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_font", 1, font_button, "GtkFontButton*");
  use_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_font)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_font", 2, use_font, "gboolean");
  gtk_font_button_set_use_font(s7_c_pointer(font_button), lg_boolean(use_font));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_use_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_use_size "gboolean gtk_font_button_get_use_size(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_use_size", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_use_size(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_use_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_use_size "void gtk_font_button_set_use_size(GtkFontButton* font_button, \
gboolean use_size)"
  s7_pointer _p;
  s7_pointer font_button, use_size;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_size", 1, font_button, "GtkFontButton*");
  use_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_size)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_size", 2, use_size, "gboolean");
  gtk_font_button_set_use_size(s7_c_pointer(font_button), lg_boolean(use_size));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_font_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_font_name "gchar* gtk_font_button_get_font_name(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_font_name", 1, font_button, "GtkFontButton*");
  return(s7_make_string(sc, gtk_font_button_get_font_name(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_font_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_font_name "gboolean gtk_font_button_set_font_name(GtkFontButton* font_button, \
gchar* fontname)"
  s7_pointer _p;
  s7_pointer font_button, fontname;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_font_name", 1, font_button, "GtkFontButton*");
  fontname = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(fontname)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_font_name", 2, fontname, "gchar*");
  return(s7_make_boolean(sc, gtk_font_button_set_font_name(s7_c_pointer(font_button), s7_string(fontname))));
}

static s7_pointer lg_gtk_font_button_get_show_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_show_style "gboolean gtk_font_button_get_show_style(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_show_style", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_show_style(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_show_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_show_style "void gtk_font_button_set_show_style(GtkFontButton* font_button, \
gboolean show_style)"
  s7_pointer _p;
  s7_pointer font_button, show_style;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_show_style", 1, font_button, "GtkFontButton*");
  show_style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_style)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_show_style", 2, show_style, "gboolean");
  gtk_font_button_set_show_style(s7_c_pointer(font_button), lg_boolean(show_style));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_show_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_show_size "gboolean gtk_font_button_get_show_size(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_show_size", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_show_size(s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_show_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_show_size "void gtk_font_button_set_show_size(GtkFontButton* font_button, \
gboolean show_size)"
  s7_pointer _p;
  s7_pointer font_button, show_size;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_show_size", 1, font_button, "GtkFontButton*");
  show_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_size)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_show_size", 2, show_size, "gboolean");
  gtk_font_button_set_show_size(s7_c_pointer(font_button), lg_boolean(show_size));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_new "GtkEntryCompletion* gtk_entry_completion_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkEntryCompletion__sym, gtk_entry_completion_new()));
}

static s7_pointer lg_gtk_entry_completion_get_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_entry "GtkWidget* gtk_entry_completion_get_entry(GtkEntryCompletion* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_entry", 1, entry, "GtkEntryCompletion*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_entry_completion_get_entry(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_completion_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_model "void gtk_entry_completion_set_model(GtkEntryCompletion* completion, \
GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer completion, model;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_model", 1, completion, "GtkEntryCompletion*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_model", 2, model, "GtkTreeModel*");
  gtk_entry_completion_set_model(s7_c_pointer(completion), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_model "GtkTreeModel* gtk_entry_completion_get_model(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_model", 1, completion, "GtkEntryCompletion*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_entry_completion_get_model(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_match_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_match_func "void gtk_entry_completion_set_match_func(GtkEntryCompletion* completion, \
GtkEntryCompletionMatchFunc func, lambda_data func_info, GtkDestroyNotify func_notify)"
  s7_pointer _p;
  s7_pointer completion, func, func_info, func_notify;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_match_func", 1, completion, "GtkEntryCompletion*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkEntryCompletionMatchFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_match_func", 2, func, "GtkEntryCompletionMatchFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_match_func", 3, func_info, "lambda_data");
  func_notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_notify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_match_func", 4, func_notify, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, func_notify);
    gtk_entry_completion_set_match_func(s7_c_pointer(completion), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(func_notify));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_entry_completion_set_minimum_key_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_minimum_key_length "void gtk_entry_completion_set_minimum_key_length(GtkEntryCompletion* completion, \
gint length)"
  s7_pointer _p;
  s7_pointer completion, length;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_minimum_key_length", 1, completion, "GtkEntryCompletion*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_minimum_key_length", 2, length, "gint");
  gtk_entry_completion_set_minimum_key_length(s7_c_pointer(completion), s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_minimum_key_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_minimum_key_length "gint gtk_entry_completion_get_minimum_key_length(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_minimum_key_length", 1, completion, "GtkEntryCompletion*");
  return(s7_make_integer(sc, gtk_entry_completion_get_minimum_key_length(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_complete "void gtk_entry_completion_complete(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_complete", 1, completion, "GtkEntryCompletion*");
  gtk_entry_completion_complete(s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_insert_action_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_action_text "void gtk_entry_completion_insert_action_text(GtkEntryCompletion* completion, \
gint index, gchar* text)"
  s7_pointer _p;
  s7_pointer completion, index, text;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 2, index, "gint");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 3, text, "gchar*");
  gtk_entry_completion_insert_action_text(s7_c_pointer(completion), s7_integer(index), s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_insert_action_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_action_markup "void gtk_entry_completion_insert_action_markup(GtkEntryCompletion* completion, \
gint index, gchar* markup)"
  s7_pointer _p;
  s7_pointer completion, index, markup;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 2, index, "gint");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 3, markup, "gchar*");
  gtk_entry_completion_insert_action_markup(s7_c_pointer(completion), s7_integer(index), s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_delete_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_delete_action "void gtk_entry_completion_delete_action(GtkEntryCompletion* completion, \
gint index)"
  s7_pointer _p;
  s7_pointer completion, index;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_delete_action", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_delete_action", 2, index, "gint");
  gtk_entry_completion_delete_action(s7_c_pointer(completion), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_set_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_text_column "void gtk_entry_completion_set_text_column(GtkEntryCompletion* completion, \
gint column)"
  s7_pointer _p;
  s7_pointer completion, column;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_text_column", 1, completion, "GtkEntryCompletion*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_text_column", 2, column, "gint");
  gtk_entry_completion_set_text_column(s7_c_pointer(completion), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_radio_tool_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_tool_button_new "GtkToolItem* gtk_radio_tool_button_new(GSList* group)"
  s7_pointer group;
  group = s7_car(args);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_tool_button_new", 1, group, "GSList*");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_radio_tool_button_new(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_tool_button_new_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_tool_button_new_from_widget "GtkToolItem* gtk_radio_tool_button_new_from_widget(GtkRadioToolButton* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkRadioToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_tool_button_new_from_widget", 1, group, "GtkRadioToolButton*");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_radio_tool_button_new_from_widget(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_tool_button_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_tool_button_get_group "GSList* gtk_radio_tool_button_get_group(GtkRadioToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkRadioToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_tool_button_get_group", 1, button, "GtkRadioToolButton*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_radio_tool_button_get_group(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_radio_tool_button_set_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_tool_button_set_group "void gtk_radio_tool_button_set_group(GtkRadioToolButton* button, \
GSList* group)"
  s7_pointer _p;
  s7_pointer button, group;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkRadioToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_tool_button_set_group", 1, button, "GtkRadioToolButton*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_tool_button_set_group", 2, group, "GSList*");
  gtk_radio_tool_button_set_group(s7_c_pointer(button), s7_c_pointer(group));
  return(lg_false);
}

static s7_pointer lg_gtk_separator_tool_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_tool_item_new "GtkToolItem* gtk_separator_tool_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_separator_tool_item_new()));
}

static s7_pointer lg_gtk_separator_tool_item_get_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_tool_item_get_draw "gboolean gtk_separator_tool_item_get_draw(GtkSeparatorToolItem* item)"
  s7_pointer item;
  item = s7_car(args);
  if (!s7_is_c_pointer_of_type(item, GtkSeparatorToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_separator_tool_item_get_draw", 1, item, "GtkSeparatorToolItem*");
  return(s7_make_boolean(sc, gtk_separator_tool_item_get_draw(s7_c_pointer(item))));
}

static s7_pointer lg_gtk_separator_tool_item_set_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_tool_item_set_draw "void gtk_separator_tool_item_set_draw(GtkSeparatorToolItem* tool_item, \
gboolean draw)"
  s7_pointer _p;
  s7_pointer tool_item, draw;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkSeparatorToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_separator_tool_item_set_draw", 1, tool_item, "GtkSeparatorToolItem*");
  draw = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(draw)) s7_wrong_type_arg_error(sc, "gtk_separator_tool_item_set_draw", 2, draw, "gboolean");
  gtk_separator_tool_item_set_draw(s7_c_pointer(tool_item), lg_boolean(draw));
  return(lg_false);
}

static s7_pointer lg_gtk_toggle_tool_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_tool_button_new "GtkToolItem* gtk_toggle_tool_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_toggle_tool_button_new()));
}

static s7_pointer lg_gtk_toggle_tool_button_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_tool_button_set_active "void gtk_toggle_tool_button_set_active(GtkToggleToolButton* button, \
gboolean is_active)"
  s7_pointer _p;
  s7_pointer button, is_active;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToggleToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_tool_button_set_active", 1, button, "GtkToggleToolButton*");
  is_active = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_toggle_tool_button_set_active", 2, is_active, "gboolean");
  gtk_toggle_tool_button_set_active(s7_c_pointer(button), lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_toggle_tool_button_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_tool_button_get_active "gboolean gtk_toggle_tool_button_get_active(GtkToggleToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToggleToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_tool_button_get_active", 1, button, "GtkToggleToolButton*");
  return(s7_make_boolean(sc, gtk_toggle_tool_button_get_active(s7_c_pointer(button))));
}

static s7_pointer lg_g_timeout_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_g_timeout_add_full "guint g_timeout_add_full(gint priority, guint interval, GSourceFunc func, \
lambda_data func_info, GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, interval, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 1, priority, "gint");
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 2, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 3, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 4, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 5, notify, "GtkDestroyNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, notify);
    result = s7_make_integer(sc, g_timeout_add_full(s7_integer(priority), s7_integer(interval), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify)));
    return(result);
   }
}

static s7_pointer lg_g_timeout_add(s7_scheme *sc, s7_pointer args)
{
  #define H_g_timeout_add "guint g_timeout_add(guint interval, GSourceFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer interval, func, func_info;
  _p = args;
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "g_timeout_add", 1, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "g_timeout_add", 2, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "g_timeout_add", 3, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, g_timeout_add(s7_integer(interval), s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_g_idle_add(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_add "guint g_idle_add(GSourceFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer func, func_info;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "g_idle_add", 1, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "g_idle_add", 2, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, g_idle_add(s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_g_idle_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_add_full "guint g_idle_add_full(gint priority, GSourceFunc func, lambda_data func_info, \
GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "g_idle_add_full", 1, priority, "gint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "g_idle_add_full", 2, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "g_idle_add_full", 3, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "g_idle_add_full", 4, notify, "GtkDestroyNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, notify);
    result = s7_make_integer(sc, g_idle_add_full(s7_integer(priority), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify)));
    return(result);
   }
}

static s7_pointer lg_g_idle_remove_by_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_remove_by_data "gboolean g_idle_remove_by_data(gpointer data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_idle_remove_by_data", 1, data, "gpointer");
  return(s7_make_boolean(sc, g_idle_remove_by_data(s7_c_pointer(data))));
}

static s7_pointer lg_g_source_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_g_source_remove "gboolean g_source_remove(guint tag)"
  s7_pointer tag;
  tag = s7_car(args);
  if (!s7_is_integer(tag)) s7_wrong_type_arg_error(sc, "g_source_remove", 1, tag, "guint");
  return(s7_make_boolean(sc, g_source_remove(s7_integer(tag))));
}

static s7_pointer lg_gtk_file_filter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_new "GtkFileFilter* gtk_file_filter_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkFileFilter__sym, gtk_file_filter_new()));
}

static s7_pointer lg_gtk_file_filter_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_set_name "void gtk_file_filter_set_name(GtkFileFilter* filter, gchar* name)"
  s7_pointer _p;
  s7_pointer filter, name;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_set_name", 1, filter, "GtkFileFilter*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_file_filter_set_name", 2, name, "gchar*");
  gtk_file_filter_set_name(s7_c_pointer(filter), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_get_name "gchar* gtk_file_filter_get_name(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_get_name", 1, filter, "GtkFileFilter*");
  return(s7_make_string(sc, gtk_file_filter_get_name(s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_file_filter_add_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_mime_type "void gtk_file_filter_add_mime_type(GtkFileFilter* filter, \
gchar* mime_type)"
  s7_pointer _p;
  s7_pointer filter, mime_type;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_mime_type", 1, filter, "GtkFileFilter*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_mime_type", 2, mime_type, "gchar*");
  gtk_file_filter_add_mime_type(s7_c_pointer(filter), s7_string(mime_type));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_add_pattern(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_pattern "void gtk_file_filter_add_pattern(GtkFileFilter* filter, gchar* pattern)"
  s7_pointer _p;
  s7_pointer filter, pattern;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pattern", 1, filter, "GtkFileFilter*");
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(pattern)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pattern", 2, pattern, "gchar*");
  gtk_file_filter_add_pattern(s7_c_pointer(filter), s7_string(pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_add_custom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_custom "void gtk_file_filter_add_custom(GtkFileFilter* filter, GtkFileFilterFlags needed, \
GtkFileFilterFunc func, lambda_data func_info, GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer filter, needed, func, func_info, notify;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 1, filter, "GtkFileFilter*");
  needed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(needed)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 2, needed, "GtkFileFilterFlags");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkFileFilterFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 3, func, "GtkFileFilterFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 4, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 5, notify, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, notify);
    gtk_file_filter_add_custom(s7_c_pointer(filter), s7_integer(needed), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_file_filter_get_needed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_get_needed "GtkFileFilterFlags gtk_file_filter_get_needed(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_get_needed", 1, filter, "GtkFileFilter*");
  return(s7_make_integer(sc, gtk_file_filter_get_needed(s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_file_filter_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_filter "gboolean gtk_file_filter_filter(GtkFileFilter* filter, GtkFileFilterInfo* filter_info)"
  s7_pointer _p;
  s7_pointer filter, filter_info;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_filter", 1, filter, "GtkFileFilter*");
  filter_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter_info, GtkFileFilterInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_filter", 2, filter_info, "GtkFileFilterInfo*");
  return(s7_make_boolean(sc, gtk_file_filter_filter(s7_c_pointer(filter), s7_c_pointer(filter_info))));
}

static s7_pointer lg_gtk_cell_layout_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_pack_start "void gtk_cell_layout_pack_start(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, expand;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 3, expand, "gboolean");
  gtk_cell_layout_pack_start(s7_c_pointer(cell_layout), s7_c_pointer(cell), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_pack_end "void gtk_cell_layout_pack_end(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, expand;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 3, expand, "gboolean");
  gtk_cell_layout_pack_end(s7_c_pointer(cell_layout), s7_c_pointer(cell), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_clear "void gtk_cell_layout_clear(GtkCellLayout* cell_layout)"
  s7_pointer cell_layout;
  cell_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear", 1, cell_layout, "GtkCellLayout*");
  gtk_cell_layout_clear(s7_c_pointer(cell_layout));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_set_attributes "void gtk_cell_layout_set_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, attributes;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 2, cell, "GtkCellRenderer*");
  attributes = s7_car(_p); _p = s7_cdr(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkCellLayout* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkCellLayout*)s7_c_pointer(cell_layout);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_cell_layout_add_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_add_attribute "void gtk_cell_layout_add_attribute(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, gchar* attribute, gint column)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, attribute, column;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 2, cell, "GtkCellRenderer*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 3, attribute, "gchar*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 4, column, "gint");
  gtk_cell_layout_add_attribute(s7_c_pointer(cell_layout), s7_c_pointer(cell), s7_string(attribute), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_set_cell_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_set_cell_data_func "void gtk_cell_layout_set_cell_data_func(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, GtkCellLayoutDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, func, func_info, destroy;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 2, cell, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkCellLayoutDataFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 3, func, "GtkCellLayoutDataFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 4, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 5, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_cell_layout_set_cell_data_func(s7_c_pointer(cell_layout), s7_c_pointer(cell), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_cell_layout_clear_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_clear_attributes "void gtk_cell_layout_clear_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer cell_layout, cell;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear_attributes", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear_attributes", 2, cell, "GtkCellRenderer*");
  gtk_cell_layout_clear_attributes(s7_c_pointer(cell_layout), s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_action "void gtk_file_chooser_set_action(GtkFileChooser* chooser, GtkFileChooserAction action)"
  s7_pointer _p;
  s7_pointer chooser, action;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_action", 1, chooser, "GtkFileChooser*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_action", 2, action, "GtkFileChooserAction");
  gtk_file_chooser_set_action(s7_c_pointer(chooser), s7_integer(action));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_action "GtkFileChooserAction gtk_file_chooser_get_action(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_action", 1, chooser, "GtkFileChooser*");
  return(s7_make_integer(sc, gtk_file_chooser_get_action(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_local_only "void gtk_file_chooser_set_local_only(GtkFileChooser* chooser, \
gboolean files_only)"
  s7_pointer _p;
  s7_pointer chooser, files_only;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_local_only", 1, chooser, "GtkFileChooser*");
  files_only = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(files_only)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_local_only", 2, files_only, "gboolean");
  gtk_file_chooser_set_local_only(s7_c_pointer(chooser), lg_boolean(files_only));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_local_only "gboolean gtk_file_chooser_get_local_only(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_local_only", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_local_only(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_select_multiple "void gtk_file_chooser_set_select_multiple(GtkFileChooser* chooser, \
gboolean select_multiple)"
  s7_pointer _p;
  s7_pointer chooser, select_multiple;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_select_multiple", 1, chooser, "GtkFileChooser*");
  select_multiple = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(select_multiple)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_select_multiple", 2, select_multiple, "gboolean");
  gtk_file_chooser_set_select_multiple(s7_c_pointer(chooser), lg_boolean(select_multiple));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_select_multiple "gboolean gtk_file_chooser_get_select_multiple(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_select_multiple", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_select_multiple(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_current_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_current_name "void gtk_file_chooser_set_current_name(GtkFileChooser* chooser, \
gchar* name)"
  s7_pointer _p;
  s7_pointer chooser, name;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_name", 1, chooser, "GtkFileChooser*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_name", 2, name, "gchar*");
  gtk_file_chooser_set_current_name(s7_c_pointer(chooser), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_filename "gchar* gtk_file_chooser_get_filename(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_filename", 1, chooser, "GtkFileChooser*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_filename(s7_c_pointer(chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_set_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_filename "gboolean gtk_file_chooser_set_filename(GtkFileChooser* chooser, \
char* filename)"
  s7_pointer _p;
  s7_pointer chooser, filename;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filename", 1, chooser, "GtkFileChooser*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filename", 2, filename, "char*");
  return(s7_make_boolean(sc, gtk_file_chooser_set_filename(s7_c_pointer(chooser), (char*)s7_string(filename))));
}

static s7_pointer lg_gtk_file_chooser_select_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_filename "gboolean gtk_file_chooser_select_filename(GtkFileChooser* chooser, \
char* filename)"
  s7_pointer _p;
  s7_pointer chooser, filename;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_filename", 1, chooser, "GtkFileChooser*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_filename", 2, filename, "char*");
  return(s7_make_boolean(sc, gtk_file_chooser_select_filename(s7_c_pointer(chooser), (char*)s7_string(filename))));
}

static s7_pointer lg_gtk_file_chooser_unselect_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_filename "void gtk_file_chooser_unselect_filename(GtkFileChooser* chooser, \
char* filename)"
  s7_pointer _p;
  s7_pointer chooser, filename;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_filename", 1, chooser, "GtkFileChooser*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_filename", 2, filename, "char*");
  gtk_file_chooser_unselect_filename(s7_c_pointer(chooser), (char*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_all "void gtk_file_chooser_select_all(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_all", 1, chooser, "GtkFileChooser*");
  gtk_file_chooser_select_all(s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_all "void gtk_file_chooser_unselect_all(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_all", 1, chooser, "GtkFileChooser*");
  gtk_file_chooser_unselect_all(s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_filenames(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_filenames "GSList* gtk_file_chooser_get_filenames(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_filenames", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_get_filenames(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_current_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_current_folder "gboolean gtk_file_chooser_set_current_folder(GtkFileChooser* chooser, \
gchar* filename)"
  s7_pointer _p;
  s7_pointer chooser, filename;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder", 1, chooser, "GtkFileChooser*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder", 2, filename, "gchar*");
  return(s7_make_boolean(sc, gtk_file_chooser_set_current_folder(s7_c_pointer(chooser), s7_string(filename))));
}

static s7_pointer lg_gtk_file_chooser_get_current_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_folder "gchar* gtk_file_chooser_get_current_folder(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_folder", 1, chooser, "GtkFileChooser*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_current_folder(s7_c_pointer(chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_get_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_uri "gchar* gtk_file_chooser_get_uri(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_uri", 1, chooser, "GtkFileChooser*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_uri(s7_c_pointer(chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_set_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_uri "gboolean gtk_file_chooser_set_uri(GtkFileChooser* chooser, char* uri)"
  s7_pointer _p;
  s7_pointer chooser, uri;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_uri", 1, chooser, "GtkFileChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_uri", 2, uri, "char*");
  return(s7_make_boolean(sc, gtk_file_chooser_set_uri(s7_c_pointer(chooser), (char*)s7_string(uri))));
}

static s7_pointer lg_gtk_file_chooser_select_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_uri "gboolean gtk_file_chooser_select_uri(GtkFileChooser* chooser, \
char* uri)"
  s7_pointer _p;
  s7_pointer chooser, uri;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_uri", 1, chooser, "GtkFileChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_uri", 2, uri, "char*");
  return(s7_make_boolean(sc, gtk_file_chooser_select_uri(s7_c_pointer(chooser), (char*)s7_string(uri))));
}

static s7_pointer lg_gtk_file_chooser_unselect_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_uri "void gtk_file_chooser_unselect_uri(GtkFileChooser* chooser, \
char* uri)"
  s7_pointer _p;
  s7_pointer chooser, uri;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_uri", 1, chooser, "GtkFileChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_uri", 2, uri, "char*");
  gtk_file_chooser_unselect_uri(s7_c_pointer(chooser), (char*)s7_string(uri));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_uris(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_uris "GSList* gtk_file_chooser_get_uris(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_uris", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_get_uris(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_current_folder_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_current_folder_uri "gboolean gtk_file_chooser_set_current_folder_uri(GtkFileChooser* chooser, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer chooser, uri;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder_uri", 1, chooser, "GtkFileChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder_uri", 2, uri, "gchar*");
  return(s7_make_boolean(sc, gtk_file_chooser_set_current_folder_uri(s7_c_pointer(chooser), s7_string(uri))));
}

static s7_pointer lg_gtk_file_chooser_get_current_folder_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_folder_uri "gchar* gtk_file_chooser_get_current_folder_uri(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_folder_uri", 1, chooser, "GtkFileChooser*");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_current_folder_uri(s7_c_pointer(chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_set_preview_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_preview_widget "void gtk_file_chooser_set_preview_widget(GtkFileChooser* chooser, \
GtkWidget* preview_widget)"
  s7_pointer _p;
  s7_pointer chooser, preview_widget;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_preview_widget", 1, chooser, "GtkFileChooser*");
  preview_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(preview_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_preview_widget", 2, preview_widget, "GtkWidget*");
  gtk_file_chooser_set_preview_widget(s7_c_pointer(chooser), s7_c_pointer(preview_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_preview_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_preview_widget "GtkWidget* gtk_file_chooser_get_preview_widget(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_preview_widget", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_file_chooser_get_preview_widget(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_preview_widget_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_preview_widget_active "void gtk_file_chooser_set_preview_widget_active(GtkFileChooser* chooser, \
gboolean active)"
  s7_pointer _p;
  s7_pointer chooser, active;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_preview_widget_active", 1, chooser, "GtkFileChooser*");
  active = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(active)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_preview_widget_active", 2, active, "gboolean");
  gtk_file_chooser_set_preview_widget_active(s7_c_pointer(chooser), lg_boolean(active));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_preview_widget_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_preview_widget_active "gboolean gtk_file_chooser_get_preview_widget_active(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_preview_widget_active", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_preview_widget_active(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_get_preview_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_preview_filename "char* gtk_file_chooser_get_preview_filename(GtkFileChooser* file_chooser)"
  s7_pointer file_chooser;
  file_chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(file_chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_preview_filename", 1, file_chooser, "GtkFileChooser*");
  {
    char* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_preview_filename(s7_c_pointer(file_chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_get_preview_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_preview_uri "char* gtk_file_chooser_get_preview_uri(GtkFileChooser* file_chooser)"
  s7_pointer file_chooser;
  file_chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(file_chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_preview_uri", 1, file_chooser, "GtkFileChooser*");
  {
    char* result;
    s7_pointer rtn;
    result = gtk_file_chooser_get_preview_uri(s7_c_pointer(file_chooser));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_set_extra_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_extra_widget "void gtk_file_chooser_set_extra_widget(GtkFileChooser* chooser, \
GtkWidget* extra_widget)"
  s7_pointer _p;
  s7_pointer chooser, extra_widget;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_extra_widget", 1, chooser, "GtkFileChooser*");
  extra_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extra_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_extra_widget", 2, extra_widget, "GtkWidget*");
  gtk_file_chooser_set_extra_widget(s7_c_pointer(chooser), s7_c_pointer(extra_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_extra_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_extra_widget "GtkWidget* gtk_file_chooser_get_extra_widget(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_extra_widget", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_file_chooser_get_extra_widget(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_filter "void gtk_file_chooser_add_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_add_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_remove_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_filter "void gtk_file_chooser_remove_filter(GtkFileChooser* chooser, \
GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_remove_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_list_filters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_list_filters "GSList* gtk_file_chooser_list_filters(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_list_filters", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_list_filters(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_filter "void gtk_file_chooser_set_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_set_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_filter "GtkFileFilter* gtk_file_chooser_get_filter(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_filter", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GtkFileFilter__sym, gtk_file_chooser_get_filter(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_shortcut_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_shortcut_folder "gboolean gtk_file_chooser_add_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, folder;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(folder)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder", 2, folder, "char*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_add_shortcut_folder(s7_c_pointer(chooser), (char*)s7_string(folder), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_remove_shortcut_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_shortcut_folder "gboolean gtk_file_chooser_remove_shortcut_folder(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, folder;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(folder)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder", 2, folder, "char*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_remove_shortcut_folder(s7_c_pointer(chooser), (char*)s7_string(folder), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_list_shortcut_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_list_shortcut_folders "GSList* gtk_file_chooser_list_shortcut_folders(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_list_shortcut_folders", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_list_shortcut_folders(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_shortcut_folder_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_shortcut_folder_uri "gboolean gtk_file_chooser_add_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, folder;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder_uri", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(folder)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder_uri", 2, folder, "char*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_add_shortcut_folder_uri(s7_c_pointer(chooser), (char*)s7_string(folder), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_remove_shortcut_folder_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_shortcut_folder_uri "gboolean gtk_file_chooser_remove_shortcut_folder_uri(GtkFileChooser* chooser, \
char* folder, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, folder;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder_uri", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(folder)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder_uri", 2, folder, "char*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_remove_shortcut_folder_uri(s7_c_pointer(chooser), (char*)s7_string(folder), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_list_shortcut_folder_uris(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_list_shortcut_folder_uris "GSList* gtk_file_chooser_list_shortcut_folder_uris(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_list_shortcut_folder_uris", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_list_shortcut_folder_uris(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_icon_theme_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_new "GtkIconTheme* gtk_icon_theme_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkIconTheme__sym, gtk_icon_theme_new()));
}

static s7_pointer lg_gtk_icon_theme_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_default "GtkIconTheme* gtk_icon_theme_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GtkIconTheme__sym, gtk_icon_theme_get_default()));
}

static s7_pointer lg_gtk_icon_theme_get_for_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_for_screen "GtkIconTheme* gtk_icon_theme_get_for_screen(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_for_screen", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GtkIconTheme__sym, gtk_icon_theme_get_for_screen(s7_c_pointer(screen))));
}

static s7_pointer lg_gtk_icon_theme_set_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_set_screen "void gtk_icon_theme_set_screen(GtkIconTheme* icon_theme, GdkScreen* screen)"
  s7_pointer _p;
  s7_pointer icon_theme, screen;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_screen", 1, icon_theme, "GtkIconTheme*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) && (screen != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_screen", 2, screen, "GdkScreen*");
  gtk_icon_theme_set_screen(s7_c_pointer(icon_theme), s7_c_pointer(screen));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_get_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_search_path "void gtk_icon_theme_get_search_path(GtkIconTheme* icon_theme, \
gchar*** [path], gint* [n_elements])"
  s7_pointer _p;
  s7_pointer icon_theme;
  gchar** ref_path = NULL;
  gint ref_n_elements;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_search_path", 1, icon_theme, "GtkIconTheme*");
  gtk_icon_theme_get_search_path(s7_c_pointer(icon_theme), &ref_path, &ref_n_elements);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_n_elements)));
}

static s7_pointer lg_gtk_icon_theme_append_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_append_search_path "void gtk_icon_theme_append_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  s7_pointer _p;
  s7_pointer icon_theme, path;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_append_search_path", 1, icon_theme, "GtkIconTheme*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_append_search_path", 2, path, "gchar*");
  gtk_icon_theme_append_search_path(s7_c_pointer(icon_theme), s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_prepend_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_prepend_search_path "void gtk_icon_theme_prepend_search_path(GtkIconTheme* icon_theme, \
gchar* path)"
  s7_pointer _p;
  s7_pointer icon_theme, path;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_prepend_search_path", 1, icon_theme, "GtkIconTheme*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_prepend_search_path", 2, path, "gchar*");
  gtk_icon_theme_prepend_search_path(s7_c_pointer(icon_theme), s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_set_custom_theme(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_set_custom_theme "void gtk_icon_theme_set_custom_theme(GtkIconTheme* icon_theme, \
gchar* theme_name)"
  s7_pointer _p;
  s7_pointer icon_theme, theme_name;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_custom_theme", 1, icon_theme, "GtkIconTheme*");
  theme_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(theme_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_custom_theme", 2, theme_name, "gchar*");
  gtk_icon_theme_set_custom_theme(s7_c_pointer(icon_theme), s7_string(theme_name));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_has_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_has_icon "gboolean gtk_icon_theme_has_icon(GtkIconTheme* icon_theme, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_has_icon", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_has_icon", 2, icon_name, "gchar*");
  return(s7_make_boolean(sc, gtk_icon_theme_has_icon(s7_c_pointer(icon_theme), s7_string(icon_name))));
}

static s7_pointer lg_gtk_icon_theme_lookup_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_icon "GtkIconInfo* gtk_icon_theme_lookup_icon(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name, size, flags;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 2, icon_name, "gchar*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 3, size, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 4, flags, "GtkIconLookupFlags");
  return(s7_make_type_with_c_pointer(sc, GtkIconInfo__sym, gtk_icon_theme_lookup_icon(s7_c_pointer(icon_theme), s7_string(icon_name), s7_integer(size), s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_theme_load_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_load_icon "GdkPixbuf* gtk_icon_theme_load_icon(GtkIconTheme* icon_theme, gchar* icon_name, \
gint size, GtkIconLookupFlags flags, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name, size, flags;
  GError* ref_error = NULL;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon", 2, icon_name, "gchar*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon", 3, size, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon", 4, flags, "GtkIconLookupFlags");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_icon_theme_load_icon(s7_c_pointer(icon_theme), s7_string(icon_name), s7_integer(size), s7_integer(flags), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_icon_theme_list_icons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_list_icons "GList* gtk_icon_theme_list_icons(GtkIconTheme* icon_theme, gchar* context)"
  s7_pointer _p;
  s7_pointer icon_theme, context;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_list_icons", 1, icon_theme, "GtkIconTheme*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(context)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_list_icons", 2, context, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_icon_theme_list_icons(s7_c_pointer(icon_theme), s7_string(context))));
}

static s7_pointer lg_gtk_icon_theme_get_example_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_example_icon_name "char* gtk_icon_theme_get_example_icon_name(GtkIconTheme* icon_theme)"
  s7_pointer icon_theme;
  icon_theme = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_example_icon_name", 1, icon_theme, "GtkIconTheme*");
  return(s7_make_string(sc, gtk_icon_theme_get_example_icon_name(s7_c_pointer(icon_theme))));
}

static s7_pointer lg_gtk_icon_theme_rescan_if_needed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_rescan_if_needed "gboolean gtk_icon_theme_rescan_if_needed(GtkIconTheme* icon_theme)"
  s7_pointer icon_theme;
  icon_theme = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_rescan_if_needed", 1, icon_theme, "GtkIconTheme*");
  return(s7_make_boolean(sc, gtk_icon_theme_rescan_if_needed(s7_c_pointer(icon_theme))));
}

static s7_pointer lg_gtk_icon_info_get_base_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_get_base_size "gint gtk_icon_info_get_base_size(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_get_base_size", 1, icon_info, "GtkIconInfo*");
  return(s7_make_integer(sc, gtk_icon_info_get_base_size(s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_icon_info_get_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_get_filename "gchar* gtk_icon_info_get_filename(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_get_filename", 1, icon_info, "GtkIconInfo*");
  return(s7_make_string(sc, gtk_icon_info_get_filename(s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_icon_info_load_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_load_icon "GdkPixbuf* gtk_icon_info_load_icon(GtkIconInfo* icon_info, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_info;
  GError* ref_error = NULL;
  _p = args;
  icon_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_load_icon", 1, icon_info, "GtkIconInfo*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_icon_info_load_icon(s7_c_pointer(icon_info), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_tool_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_new "GtkToolItem* gtk_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  s7_pointer _p;
  s7_pointer icon_widget, label;
  _p = args;
  icon_widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(icon_widget, GtkWidget__sym)) && (icon_widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tool_button_new", 1, icon_widget, "GtkWidget*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_tool_button_new", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_tool_button_new(s7_c_pointer(icon_widget), s7_string(label))));
}

static s7_pointer lg_gtk_tool_button_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_set_label "void gtk_tool_button_set_label(GtkToolButton* button, gchar* label)"
  s7_pointer _p;
  s7_pointer button, label;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_label", 1, button, "GtkToolButton*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_label", 2, label, "gchar*");
  gtk_tool_button_set_label(s7_c_pointer(button), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_button_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_get_label "gchar* gtk_tool_button_get_label(GtkToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_get_label", 1, button, "GtkToolButton*");
  return(s7_make_string(sc, gtk_tool_button_get_label(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_tool_button_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_set_use_underline "void gtk_tool_button_set_use_underline(GtkToolButton* button, \
gboolean use_underline)"
  s7_pointer _p;
  s7_pointer button, use_underline;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_use_underline", 1, button, "GtkToolButton*");
  use_underline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_use_underline", 2, use_underline, "gboolean");
  gtk_tool_button_set_use_underline(s7_c_pointer(button), lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_button_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_get_use_underline "gboolean gtk_tool_button_get_use_underline(GtkToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_get_use_underline", 1, button, "GtkToolButton*");
  return(s7_make_boolean(sc, gtk_tool_button_get_use_underline(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_tool_button_set_icon_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_set_icon_widget "void gtk_tool_button_set_icon_widget(GtkToolButton* button, \
GtkWidget* icon_widget)"
  s7_pointer _p;
  s7_pointer button, icon_widget;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_icon_widget", 1, button, "GtkToolButton*");
  icon_widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(icon_widget, GtkWidget__sym)) && (icon_widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_icon_widget", 2, icon_widget, "GtkWidget*");
  gtk_tool_button_set_icon_widget(s7_c_pointer(button), s7_c_pointer(icon_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_button_get_icon_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_get_icon_widget "GtkWidget* gtk_tool_button_get_icon_widget(GtkToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_get_icon_widget", 1, button, "GtkToolButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_button_get_icon_widget(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_tool_button_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_set_label_widget "void gtk_tool_button_set_label_widget(GtkToolButton* button, \
GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer button, label_widget;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_label_widget", 1, button, "GtkToolButton*");
  label_widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) && (label_widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_tool_button_set_label_widget(s7_c_pointer(button), s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_button_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_get_label_widget "GtkWidget* gtk_tool_button_get_label_widget(GtkToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_get_label_widget", 1, button, "GtkToolButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_button_get_label_widget(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_tool_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_new "GtkToolItem* gtk_tool_item_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_tool_item_new()));
}

static s7_pointer lg_gtk_tool_item_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_homogeneous "void gtk_tool_item_set_homogeneous(GtkToolItem* tool_item, \
gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer tool_item, homogeneous;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_homogeneous", 1, tool_item, "GtkToolItem*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_tool_item_set_homogeneous(s7_c_pointer(tool_item), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_homogeneous "gboolean gtk_tool_item_get_homogeneous(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_homogeneous", 1, tool_item, "GtkToolItem*");
  return(s7_make_boolean(sc, gtk_tool_item_get_homogeneous(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_set_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_expand "void gtk_tool_item_set_expand(GtkToolItem* tool_item, gboolean expand)"
  s7_pointer _p;
  s7_pointer tool_item, expand;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_expand", 1, tool_item, "GtkToolItem*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_expand", 2, expand, "gboolean");
  gtk_tool_item_set_expand(s7_c_pointer(tool_item), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_get_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_expand "gboolean gtk_tool_item_get_expand(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_expand", 1, tool_item, "GtkToolItem*");
  return(s7_make_boolean(sc, gtk_tool_item_get_expand(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_set_visible_horizontal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_visible_horizontal "void gtk_tool_item_set_visible_horizontal(GtkToolItem* toolitem, \
gboolean visible_horizontal)"
  s7_pointer _p;
  s7_pointer toolitem, visible_horizontal;
  _p = args;
  toolitem = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolitem, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_visible_horizontal", 1, toolitem, "GtkToolItem*");
  visible_horizontal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible_horizontal)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_visible_horizontal", 2, visible_horizontal, "gboolean");
  gtk_tool_item_set_visible_horizontal(s7_c_pointer(toolitem), lg_boolean(visible_horizontal));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_get_visible_horizontal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_visible_horizontal "gboolean gtk_tool_item_get_visible_horizontal(GtkToolItem* toolitem)"
  s7_pointer toolitem;
  toolitem = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolitem, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_visible_horizontal", 1, toolitem, "GtkToolItem*");
  return(s7_make_boolean(sc, gtk_tool_item_get_visible_horizontal(s7_c_pointer(toolitem))));
}

static s7_pointer lg_gtk_tool_item_set_visible_vertical(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_visible_vertical "void gtk_tool_item_set_visible_vertical(GtkToolItem* toolitem, \
gboolean visible_vertical)"
  s7_pointer _p;
  s7_pointer toolitem, visible_vertical;
  _p = args;
  toolitem = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolitem, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_visible_vertical", 1, toolitem, "GtkToolItem*");
  visible_vertical = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible_vertical)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_visible_vertical", 2, visible_vertical, "gboolean");
  gtk_tool_item_set_visible_vertical(s7_c_pointer(toolitem), lg_boolean(visible_vertical));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_get_visible_vertical(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_visible_vertical "gboolean gtk_tool_item_get_visible_vertical(GtkToolItem* toolitem)"
  s7_pointer toolitem;
  toolitem = s7_car(args);
  if (!s7_is_c_pointer_of_type(toolitem, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_visible_vertical", 1, toolitem, "GtkToolItem*");
  return(s7_make_boolean(sc, gtk_tool_item_get_visible_vertical(s7_c_pointer(toolitem))));
}

static s7_pointer lg_gtk_tool_item_get_is_important(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_is_important "gboolean gtk_tool_item_get_is_important(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_is_important", 1, tool_item, "GtkToolItem*");
  return(s7_make_boolean(sc, gtk_tool_item_get_is_important(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_set_is_important(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_is_important "void gtk_tool_item_set_is_important(GtkToolItem* tool_item, \
gboolean is_important)"
  s7_pointer _p;
  s7_pointer tool_item, is_important;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_is_important", 1, tool_item, "GtkToolItem*");
  is_important = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_important)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_is_important", 2, is_important, "gboolean");
  gtk_tool_item_set_is_important(s7_c_pointer(tool_item), lg_boolean(is_important));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_orientation "GtkOrientation gtk_tool_item_get_orientation(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_orientation", 1, tool_item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_tool_item_get_orientation(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_get_toolbar_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_toolbar_style "GtkToolbarStyle gtk_tool_item_get_toolbar_style(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_toolbar_style", 1, tool_item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_tool_item_get_toolbar_style(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_retrieve_proxy_menu_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_retrieve_proxy_menu_item "GtkWidget* gtk_tool_item_retrieve_proxy_menu_item(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_retrieve_proxy_menu_item", 1, tool_item, "GtkToolItem*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_item_retrieve_proxy_menu_item(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_get_proxy_menu_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_proxy_menu_item "GtkWidget* gtk_tool_item_get_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id)"
  s7_pointer _p;
  s7_pointer tool_item, menu_item_id;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_proxy_menu_item", 1, tool_item, "GtkToolItem*");
  menu_item_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(menu_item_id)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_proxy_menu_item", 2, menu_item_id, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_item_get_proxy_menu_item(s7_c_pointer(tool_item), s7_string(menu_item_id))));
}

static s7_pointer lg_gtk_tool_item_set_proxy_menu_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_proxy_menu_item "void gtk_tool_item_set_proxy_menu_item(GtkToolItem* tool_item, \
gchar* menu_item_id, GtkWidget* menu_item)"
  s7_pointer _p;
  s7_pointer tool_item, menu_item_id, menu_item;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) && (tool_item != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_proxy_menu_item", 1, tool_item, "GtkToolItem*");
  menu_item_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(menu_item_id)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_proxy_menu_item", 2, menu_item_id, "gchar*");
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(menu_item, GtkWidget__sym)) && (menu_item != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_proxy_menu_item", 3, menu_item, "GtkWidget*");
  gtk_tool_item_set_proxy_menu_item(s7_c_pointer(tool_item), s7_string(menu_item_id), s7_c_pointer(menu_item));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_remove "gboolean gtk_list_store_remove(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_remove", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_remove", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_list_store_remove(s7_c_pointer(list_store), s7_c_pointer(iter))));
}

static s7_pointer lg_gdk_display_set_double_click_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_set_double_click_distance "void gdk_display_set_double_click_distance(GdkDisplay* display, \
guint distance)"
  s7_pointer _p;
  s7_pointer display, distance;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_set_double_click_distance", 1, display, "GdkDisplay*");
  distance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(distance)) s7_wrong_type_arg_error(sc, "gdk_display_set_double_click_distance", 2, distance, "guint");
  gdk_display_set_double_click_distance(s7_c_pointer(display), s7_integer(distance));
  return(lg_false);
}

static s7_pointer lg_gdk_display_get_default_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_group "GdkWindow* gdk_display_get_default_group(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_group", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_display_get_default_group(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_window_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_group "GdkWindow* gdk_window_get_group(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_group", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_get_group(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_cell_layout_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_reorder "void gtk_cell_layout_reorder(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gint position)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, position;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 2, cell, "GtkCellRenderer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 3, position, "gint");
  gtk_cell_layout_reorder(s7_c_pointer(cell_layout), s7_c_pointer(cell), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_request_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_request_targets "void gtk_clipboard_request_targets(GtkClipboard* clipboard, \
GtkClipboardTargetsReceivedFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_targets", 1, clipboard, "GtkClipboard*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardTargetsReceivedFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_targets", 2, func, "GtkClipboardTargetsReceivedFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_targets", 3, func_info, "lambda_data");
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_clipboard_request_targets(s7_c_pointer(clipboard), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_clipboard_wait_for_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_for_targets "gboolean gtk_clipboard_wait_for_targets(GtkClipboard* clipboard, \
GdkAtom** [targets], gint* [n_targets])"
  s7_pointer _p;
  s7_pointer clipboard;
  GdkAtom* ref_targets = NULL;
  gint ref_n_targets;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_targets", 1, clipboard, "GtkClipboard*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_clipboard_wait_for_targets(s7_c_pointer(clipboard), &ref_targets, &ref_n_targets));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_targets), s7_make_integer(sc, ref_n_targets)));
   }
}

static s7_pointer lg_gtk_menu_shell_cancel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_cancel "void gtk_menu_shell_cancel(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_cancel", 1, menu_shell, "GtkMenuShell*");
  gtk_menu_shell_cancel(s7_c_pointer(menu_shell));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_child1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_child1 "GtkWidget* gtk_paned_get_child1(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_child1", 1, paned, "GtkPaned*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_paned_get_child1(s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_paned_get_child2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_child2 "GtkWidget* gtk_paned_get_child2(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_child2", 1, paned, "GtkPaned*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_paned_get_child2(s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_window_set_accept_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_accept_focus "void gtk_window_set_accept_focus(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_accept_focus", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_accept_focus", 2, setting, "gboolean");
  gtk_window_set_accept_focus(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_accept_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_accept_focus "gboolean gtk_window_get_accept_focus(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_accept_focus", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_accept_focus(s7_c_pointer(window))));
}

static s7_pointer lg_g_list_nth_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_nth_data "gpointer g_list_nth_data(GList* list, guint n)"
  s7_pointer _p;
  s7_pointer list, n;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_nth_data", 1, list, "GList*");
  n = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "g_list_nth_data", 2, n, "guint");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, g_list_nth_data(s7_c_pointer(list), s7_integer(n))));
}

static s7_pointer lg_gtk_accel_map_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_get "GtkAccelMap* gtk_accel_map_get( void)"
  return(s7_make_type_with_c_pointer(sc, GtkAccelMap__sym, gtk_accel_map_get()));
}

static s7_pointer lg_gtk_combo_box_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popup "void gtk_combo_box_popup(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup", 1, combo_box, "GtkComboBox*");
  gtk_combo_box_popup(s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popdown "void gtk_combo_box_popdown(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popdown", 1, combo_box, "GtkComboBox*");
  gtk_combo_box_popdown(s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_radio_menu_item_new_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new_from_widget "GtkWidget* gtk_radio_menu_item_new_from_widget(GtkRadioMenuItem* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_from_widget", 1, group, "GtkRadioMenuItem*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new_from_widget(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_menu_item_new_with_mnemonic_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_menu_item_new_with_mnemonic_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_mnemonic_from_widget", 1, group, "GtkRadioMenuItem*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_mnemonic_from_widget", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new_with_mnemonic_from_widget(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_radio_menu_item_new_with_label_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_new_with_label_from_widget "GtkWidget* gtk_radio_menu_item_new_with_label_from_widget(GtkRadioMenuItem* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_label_from_widget", 1, group, "GtkRadioMenuItem*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_new_with_label_from_widget", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_radio_menu_item_new_with_label_from_widget(s7_c_pointer(group), s7_string(label))));
}

static s7_pointer lg_gtk_scale_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_layout "PangoLayout* gtk_scale_get_layout(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_layout", 1, scale, "GtkScale*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, gtk_scale_get_layout(s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_get_layout_offsets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_layout_offsets "void gtk_scale_get_layout_offsets(GtkScale* scale, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer scale;
  gint ref_x;
  gint ref_y;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_layout_offsets", 1, scale, "GtkScale*");
  gtk_scale_get_layout_offsets(s7_c_pointer(scale), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_drag_source_get_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_get_target_list "GtkTargetList* gtk_drag_source_get_target_list(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_get_target_list", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_drag_source_get_target_list(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_drag_source_set_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_target_list "void gtk_drag_source_set_target_list(GtkWidget* widget, \
GtkTargetList* target_list)"
  s7_pointer _p;
  s7_pointer widget, target_list;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_target_list", 1, widget, "GtkWidget*");
  target_list = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(target_list, GtkTargetList__sym)) && (target_list != lg_false)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_target_list", 2, target_list, "GtkTargetList*");
  gtk_drag_source_set_target_list(s7_c_pointer(widget), s7_c_pointer(target_list));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_alignment "void gtk_entry_set_alignment(GtkEntry* entry, gfloat xalign)"
  s7_pointer _p;
  s7_pointer entry, xalign;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_alignment", 1, entry, "GtkEntry*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_entry_set_alignment", 2, xalign, "gfloat");
  gtk_entry_set_alignment(s7_c_pointer(entry), s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_alignment "gfloat gtk_entry_get_alignment(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_alignment", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_alignment(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_file_chooser_set_use_preview_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_use_preview_label "void gtk_file_chooser_set_use_preview_label(GtkFileChooser* chooser, \
gboolean use_label)"
  s7_pointer _p;
  s7_pointer chooser, use_label;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_use_preview_label", 1, chooser, "GtkFileChooser*");
  use_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_label)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_use_preview_label", 2, use_label, "gboolean");
  gtk_file_chooser_set_use_preview_label(s7_c_pointer(chooser), lg_boolean(use_label));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_use_preview_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_use_preview_label "gboolean gtk_file_chooser_get_use_preview_label(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_use_preview_label", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_use_preview_label(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_widget_list_mnemonic_labels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_list_mnemonic_labels "GList* gtk_widget_list_mnemonic_labels(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_list_mnemonic_labels", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_widget_list_mnemonic_labels(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_add_mnemonic_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_add_mnemonic_label "void gtk_widget_add_mnemonic_label(GtkWidget* widget, GtkWidget* label)"
  s7_pointer _p;
  s7_pointer widget, label;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_mnemonic_label", 1, widget, "GtkWidget*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_mnemonic_label", 2, label, "GtkWidget*");
  gtk_widget_add_mnemonic_label(s7_c_pointer(widget), s7_c_pointer(label));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_remove_mnemonic_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_remove_mnemonic_label "void gtk_widget_remove_mnemonic_label(GtkWidget* widget, \
GtkWidget* label)"
  s7_pointer _p;
  s7_pointer widget, label;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_mnemonic_label", 1, widget, "GtkWidget*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_mnemonic_label", 2, label, "GtkWidget*");
  gtk_widget_remove_mnemonic_label(s7_c_pointer(widget), s7_c_pointer(label));
  return(lg_false);
}

static s7_pointer lg_gtk_window_activate_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_activate_key "gboolean gtk_window_activate_key(GtkWindow* window, GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer window, event;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_key", 1, window, "GtkWindow*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_key", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_window_activate_key(s7_c_pointer(window), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_window_propagate_key_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_propagate_key_event "gboolean gtk_window_propagate_key_event(GtkWindow* window, \
GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer window, event;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_propagate_key_event", 1, window, "GtkWindow*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_window_propagate_key_event", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_window_propagate_key_event(s7_c_pointer(window), s7_c_pointer(event))));
}

static s7_pointer lg_g_quark_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_g_quark_from_string "GQuark g_quark_from_string(gchar* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "g_quark_from_string", 1, string, "gchar*");
  return(s7_make_integer(sc, g_quark_from_string(s7_string(string))));
}

static s7_pointer lg_g_quark_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_g_quark_to_string "gchar* g_quark_to_string(GQuark quark)"
  s7_pointer quark;
  quark = s7_car(args);
  if (!s7_is_integer(quark)) s7_wrong_type_arg_error(sc, "g_quark_to_string", 1, quark, "GQuark");
  return(s7_make_string(sc, g_quark_to_string(s7_integer(quark))));
}

static s7_pointer lg_gtk_cell_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new "GtkWidget* gtk_cell_view_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_cell_view_new()));
}

static s7_pointer lg_gtk_cell_view_new_with_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_text "GtkWidget* gtk_cell_view_new_with_text(gchar* text)"
  s7_pointer text;
  text = s7_car(args);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_text", 1, text, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_cell_view_new_with_text(s7_string(text))));
}

static s7_pointer lg_gtk_cell_view_new_with_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_markup "GtkWidget* gtk_cell_view_new_with_markup(gchar* markup)"
  s7_pointer markup;
  markup = s7_car(args);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_markup", 1, markup, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_cell_view_new_with_markup(s7_string(markup))));
}

static s7_pointer lg_gtk_cell_view_new_with_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_pixbuf "GtkWidget* gtk_cell_view_new_with_pixbuf(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_pixbuf", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_cell_view_new_with_pixbuf(s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_cell_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_model "void gtk_cell_view_set_model(GtkCellView* cell_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer cell_view, model;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_model", 1, cell_view, "GtkCellView*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_model", 2, model, "GtkTreeModel*");
  gtk_cell_view_set_model(s7_c_pointer(cell_view), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_set_displayed_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_displayed_row "void gtk_cell_view_set_displayed_row(GtkCellView* cell_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer cell_view, path;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_displayed_row", 1, cell_view, "GtkCellView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_displayed_row", 2, path, "GtkTreePath*");
  gtk_cell_view_set_displayed_row(s7_c_pointer(cell_view), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_displayed_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_displayed_row "GtkTreePath* gtk_cell_view_get_displayed_row(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_displayed_row", 1, cell_view, "GtkCellView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_cell_view_get_displayed_row(s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_combo_box_get_wrap_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_wrap_width "gint gtk_combo_box_get_wrap_width(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_wrap_width", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_wrap_width(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_get_row_span_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_row_span_column "gint gtk_combo_box_get_row_span_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_row_span_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_row_span_column(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_get_column_span_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_column_span_column "gint gtk_combo_box_get_column_span_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_column_span_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_column_span_column(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_drag_dest_add_text_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_add_text_targets "void gtk_drag_dest_add_text_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_add_text_targets", 1, widget, "GtkWidget*");
  gtk_drag_dest_add_text_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_add_text_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_add_text_targets "void gtk_drag_source_add_text_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_add_text_targets", 1, widget, "GtkWidget*");
  gtk_drag_source_add_text_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_insert_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_prefix "void gtk_entry_completion_insert_prefix(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_prefix", 1, completion, "GtkEntryCompletion*");
  gtk_entry_completion_insert_prefix(s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_set_inline_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_inline_completion "void gtk_entry_completion_set_inline_completion(GtkEntryCompletion* completion, \
gboolean inline_completion)"
  s7_pointer _p;
  s7_pointer completion, inline_completion;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_completion", 1, completion, "GtkEntryCompletion*");
  inline_completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(inline_completion)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_completion", 2, inline_completion, "gboolean");
  gtk_entry_completion_set_inline_completion(s7_c_pointer(completion), lg_boolean(inline_completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_inline_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_inline_completion "gboolean gtk_entry_completion_get_inline_completion(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_inline_completion", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_inline_completion(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_popup_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_completion "void gtk_entry_completion_set_popup_completion(GtkEntryCompletion* completion, \
gboolean popup_completion)"
  s7_pointer _p;
  s7_pointer completion, popup_completion;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_completion", 1, completion, "GtkEntryCompletion*");
  popup_completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(popup_completion)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_completion", 2, popup_completion, "gboolean");
  gtk_entry_completion_set_popup_completion(s7_c_pointer(completion), lg_boolean(popup_completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_completion "gboolean gtk_entry_completion_get_popup_completion(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_completion", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_completion(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_get_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_text_column "gint gtk_entry_completion_get_text_column(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_text_column", 1, completion, "GtkEntryCompletion*");
  return(s7_make_integer(sc, gtk_entry_completion_get_text_column(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_icon_theme_get_icon_sizes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_icon_sizes "gint* gtk_icon_theme_get_icon_sizes(GtkIconTheme* icon_theme, \
gchar* icon_name)"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_icon_sizes", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_icon_sizes", 2, icon_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, gint__sym, gtk_icon_theme_get_icon_sizes(s7_c_pointer(icon_theme), s7_string(icon_name))));
}

static s7_pointer lg_gtk_menu_get_for_attach_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_for_attach_widget "GList* gtk_menu_get_for_attach_widget(GtkWidget* widget, \
)"
  s7_pointer widget ;
  widget  = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget , GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_for_attach_widget", 1, widget , "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_menu_get_for_attach_widget(s7_c_pointer(widget ))));
}

static s7_pointer lg_gtk_tree_view_set_fixed_height_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_fixed_height_mode "void gtk_tree_view_set_fixed_height_mode(GtkTreeView* tree_view, \
gboolean enable)"
  s7_pointer _p;
  s7_pointer tree_view, enable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_fixed_height_mode", 1, tree_view, "GtkTreeView*");
  enable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_fixed_height_mode", 2, enable, "gboolean");
  gtk_tree_view_set_fixed_height_mode(s7_c_pointer(tree_view), lg_boolean(enable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_fixed_height_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_fixed_height_mode "gboolean gtk_tree_view_get_fixed_height_mode(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_fixed_height_mode", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_fixed_height_mode(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_hover_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_hover_selection "void gtk_tree_view_set_hover_selection(GtkTreeView* tree_view, \
gboolean hover)"
  s7_pointer _p;
  s7_pointer tree_view, hover;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_selection", 1, tree_view, "GtkTreeView*");
  hover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(hover)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_selection", 2, hover, "gboolean");
  gtk_tree_view_set_hover_selection(s7_c_pointer(tree_view), lg_boolean(hover));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_hover_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_hover_selection "gboolean gtk_tree_view_get_hover_selection(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_hover_selection", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_hover_selection(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_row_separator_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_row_separator_func "void gtk_tree_view_set_row_separator_func(GtkTreeView* tree_view, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_row_separator_func", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewRowSeparatorFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_row_separator_func", 2, func, "GtkTreeViewRowSeparatorFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_row_separator_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_row_separator_func", 4, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_set_row_separator_func(s7_c_pointer(tree_view), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_window_set_focus_on_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_focus_on_map "void gtk_window_set_focus_on_map(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_on_map", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_on_map", 2, setting, "gboolean");
  gtk_window_set_focus_on_map(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_focus_on_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_focus_on_map "gboolean gtk_window_get_focus_on_map(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_focus_on_map", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_focus_on_map(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_icon_name "void gtk_window_set_icon_name(GtkWindow* window, gchar* name)"
  s7_pointer _p;
  s7_pointer window, name;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_name", 1, window, "GtkWindow*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_name", 2, name, "gchar*");
  gtk_window_set_icon_name(s7_c_pointer(window), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_icon_name "gchar* gtk_window_get_icon_name(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_icon_name", 1, window, "GtkWindow*");
  return(s7_make_string(sc, gtk_window_get_icon_name(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_default_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_icon_name "void gtk_window_set_default_icon_name(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_icon_name", 1, name, "gchar*");
  gtk_window_set_default_icon_name(s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_new "GtkWidget* gtk_about_dialog_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_about_dialog_new()));
}

static s7_pointer lg_gtk_about_dialog_get_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_version "gchar* gtk_about_dialog_get_version(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_version", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_version(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_version "void gtk_about_dialog_set_version(GtkAboutDialog* about, gchar* version)"
  s7_pointer _p;
  s7_pointer about, version;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_version", 1, about, "GtkAboutDialog*");
  version = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(version)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_version", 2, version, "gchar*");
  gtk_about_dialog_set_version(s7_c_pointer(about), s7_string(version));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_copyright(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_copyright "gchar* gtk_about_dialog_get_copyright(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_copyright", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_copyright(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_copyright(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_copyright "void gtk_about_dialog_set_copyright(GtkAboutDialog* about, \
gchar* copyright)"
  s7_pointer _p;
  s7_pointer about, copyright;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_copyright", 1, about, "GtkAboutDialog*");
  copyright = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(copyright)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_copyright", 2, copyright, "gchar*");
  gtk_about_dialog_set_copyright(s7_c_pointer(about), s7_string(copyright));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_comments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_comments "gchar* gtk_about_dialog_get_comments(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_comments", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_comments(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_comments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_comments "void gtk_about_dialog_set_comments(GtkAboutDialog* about, \
gchar* comments)"
  s7_pointer _p;
  s7_pointer about, comments;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_comments", 1, about, "GtkAboutDialog*");
  comments = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(comments)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_comments", 2, comments, "gchar*");
  gtk_about_dialog_set_comments(s7_c_pointer(about), s7_string(comments));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_website(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_website "gchar* gtk_about_dialog_get_website(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_website", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_website(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_website(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_website "void gtk_about_dialog_set_website(GtkAboutDialog* about, gchar* website)"
  s7_pointer _p;
  s7_pointer about, website;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website", 1, about, "GtkAboutDialog*");
  website = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(website)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website", 2, website, "gchar*");
  gtk_about_dialog_set_website(s7_c_pointer(about), s7_string(website));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_website_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_website_label "gchar* gtk_about_dialog_get_website_label(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_website_label", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_website_label(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_website_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_website_label "void gtk_about_dialog_set_website_label(GtkAboutDialog* about, \
gchar* website_label)"
  s7_pointer _p;
  s7_pointer about, website_label;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website_label", 1, about, "GtkAboutDialog*");
  website_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(website_label)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website_label", 2, website_label, "gchar*");
  gtk_about_dialog_set_website_label(s7_c_pointer(about), s7_string(website_label));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_authors(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_authors "gchar** gtk_about_dialog_get_authors(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_authors", 1, about, "GtkAboutDialog*");
    return(s7_make_type_with_c_pointer(sc, gchar___sym, (gchar**)gtk_about_dialog_get_authors(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_authors(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_authors "void gtk_about_dialog_set_authors(GtkAboutDialog* about, gchar** authors)"
  s7_pointer _p;
  s7_pointer about, authors;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_authors", 1, about, "GtkAboutDialog*");
  authors = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(authors, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_authors", 2, authors, "gchar**");
  gtk_about_dialog_set_authors(s7_c_pointer(about), (const gchar**)s7_c_pointer(authors));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_documenters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_documenters "gchar** gtk_about_dialog_get_documenters(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_documenters", 1, about, "GtkAboutDialog*");
    return(s7_make_type_with_c_pointer(sc, gchar___sym, (gchar**)gtk_about_dialog_get_documenters(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_documenters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_documenters "void gtk_about_dialog_set_documenters(GtkAboutDialog* about, \
gchar** documenters)"
  s7_pointer _p;
  s7_pointer about, documenters;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_documenters", 1, about, "GtkAboutDialog*");
  documenters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(documenters, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_documenters", 2, documenters, "gchar**");
  gtk_about_dialog_set_documenters(s7_c_pointer(about), (const gchar**)s7_c_pointer(documenters));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_artists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_artists "gchar** gtk_about_dialog_get_artists(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_artists", 1, about, "GtkAboutDialog*");
    return(s7_make_type_with_c_pointer(sc, gchar___sym, (gchar**)gtk_about_dialog_get_artists(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_artists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_artists "void gtk_about_dialog_set_artists(GtkAboutDialog* about, gchar** artists)"
  s7_pointer _p;
  s7_pointer about, artists;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_artists", 1, about, "GtkAboutDialog*");
  artists = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(artists, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_artists", 2, artists, "gchar**");
  gtk_about_dialog_set_artists(s7_c_pointer(about), (const gchar**)s7_c_pointer(artists));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_translator_credits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_translator_credits "gchar* gtk_about_dialog_get_translator_credits(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_translator_credits", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_translator_credits(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_translator_credits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_translator_credits "void gtk_about_dialog_set_translator_credits(GtkAboutDialog* about, \
gchar* translator_credits)"
  s7_pointer _p;
  s7_pointer about, translator_credits;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_translator_credits", 1, about, "GtkAboutDialog*");
  translator_credits = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(translator_credits)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_translator_credits", 2, translator_credits, "gchar*");
  gtk_about_dialog_set_translator_credits(s7_c_pointer(about), s7_string(translator_credits));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_logo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_logo "GdkPixbuf* gtk_about_dialog_get_logo(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_logo", 1, about, "GtkAboutDialog*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_about_dialog_get_logo(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_logo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_logo "void gtk_about_dialog_set_logo(GtkAboutDialog* about, GdkPixbuf* logo)"
  s7_pointer _p;
  s7_pointer about, logo;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo", 1, about, "GtkAboutDialog*");
  logo = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(logo, GdkPixbuf__sym)) && (logo != lg_false)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo", 2, logo, "GdkPixbuf*");
  gtk_about_dialog_set_logo(s7_c_pointer(about), s7_c_pointer(logo));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_program_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_program_name "gchar* gtk_about_dialog_get_program_name(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_program_name", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_program_name(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_program_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_program_name "void gtk_about_dialog_set_program_name(GtkAboutDialog* about, \
gchar* name)"
  s7_pointer _p;
  s7_pointer about, name;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_program_name", 1, about, "GtkAboutDialog*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_program_name", 2, name, "gchar*");
  gtk_about_dialog_set_program_name(s7_c_pointer(about), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new "GtkWidget* gtk_icon_view_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_icon_view_new()));
}

static s7_pointer lg_gtk_icon_view_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new_with_model "GtkWidget* gtk_icon_view_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_new_with_model", 1, model, "GtkTreeModel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_icon_view_new_with_model(s7_c_pointer(model))));
}

static s7_pointer lg_gtk_icon_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_model "void gtk_icon_view_set_model(GtkIconView* icon_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer icon_view, model;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_model", 1, icon_view, "GtkIconView*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_model", 2, model, "GtkTreeModel*");
  gtk_icon_view_set_model(s7_c_pointer(icon_view), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_model "GtkTreeModel* gtk_icon_view_get_model(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_model", 1, icon_view, "GtkIconView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_icon_view_get_model(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_text_column "void gtk_icon_view_set_text_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_text_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_text_column", 2, column, "gint");
  gtk_icon_view_set_text_column(s7_c_pointer(icon_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_text_column "gint gtk_icon_view_get_text_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_text_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_text_column(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_markup_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_markup_column "void gtk_icon_view_set_markup_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_markup_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_markup_column", 2, column, "gint");
  gtk_icon_view_set_markup_column(s7_c_pointer(icon_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_markup_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_markup_column "gint gtk_icon_view_get_markup_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_markup_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_markup_column(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_pixbuf_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_pixbuf_column "void gtk_icon_view_set_pixbuf_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_pixbuf_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_pixbuf_column", 2, column, "gint");
  gtk_icon_view_set_pixbuf_column(s7_c_pointer(icon_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_pixbuf_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_pixbuf_column "gint gtk_icon_view_get_pixbuf_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_pixbuf_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_pixbuf_column(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_get_path_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_path_at_pos "GtkTreePath* gtk_icon_view_get_path_at_pos(GtkIconView* icon_view, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer icon_view, x, y;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 1, icon_view, "GtkIconView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 3, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkTreePath__sym, gtk_icon_view_get_path_at_pos(s7_c_pointer(icon_view), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_icon_view_selected_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_selected_foreach "void gtk_icon_view_selected_foreach(GtkIconView* icon_view, \
GtkIconViewForeachFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer icon_view, func, func_info;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_selected_foreach", 1, icon_view, "GtkIconView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkIconViewForeachFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_selected_foreach", 2, func, "GtkIconViewForeachFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_view_selected_foreach", 3, func_info, "lambda_data");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_icon_view_selected_foreach(s7_c_pointer(icon_view), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_icon_view_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_selection_mode "void gtk_icon_view_set_selection_mode(GtkIconView* icon_view, \
GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer icon_view, mode;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_selection_mode", 1, icon_view, "GtkIconView*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_icon_view_set_selection_mode(s7_c_pointer(icon_view), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_selection_mode "GtkSelectionMode gtk_icon_view_get_selection_mode(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_selection_mode", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_selection_mode(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_select_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_select_path "void gtk_icon_view_select_path(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_path", 2, path, "GtkTreePath*");
  gtk_icon_view_select_path(s7_c_pointer(icon_view), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unselect_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unselect_path "void gtk_icon_view_unselect_path(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_path", 2, path, "GtkTreePath*");
  gtk_icon_view_unselect_path(s7_c_pointer(icon_view), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_path_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_path_is_selected "gboolean gtk_icon_view_path_is_selected(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_path_is_selected", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_path_is_selected", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_icon_view_path_is_selected(s7_c_pointer(icon_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_icon_view_get_selected_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_selected_items "GList* gtk_icon_view_get_selected_items(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_selected_items", 1, icon_view, "GtkIconView*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_icon_view_get_selected_items(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_select_all "void gtk_icon_view_select_all(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_all", 1, icon_view, "GtkIconView*");
  gtk_icon_view_select_all(s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unselect_all "void gtk_icon_view_unselect_all(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_all", 1, icon_view, "GtkIconView*");
  gtk_icon_view_unselect_all(s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_item_activated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_item_activated "void gtk_icon_view_item_activated(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_item_activated", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_item_activated", 2, path, "GtkTreePath*");
  gtk_icon_view_item_activated(s7_c_pointer(icon_view), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_combo_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_combo_new "GtkCellRenderer* gtk_cell_renderer_combo_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_combo_new()));
}

static s7_pointer lg_gtk_cell_renderer_progress_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_progress_new "GtkCellRenderer* gtk_cell_renderer_progress_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_progress_new()));
}

static s7_pointer lg_gtk_combo_box_set_row_separator_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_row_separator_func "void gtk_combo_box_set_row_separator_func(GtkComboBox* combo_box, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer combo_box, func, func_info, destroy;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_separator_func", 1, combo_box, "GtkComboBox*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewRowSeparatorFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_separator_func", 2, func, "GtkTreeViewRowSeparatorFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_separator_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GtkDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_separator_func", 4, destroy, "GtkDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_combo_box_set_row_separator_func(s7_c_pointer(combo_box), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_label_set_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_ellipsize "void gtk_label_set_ellipsize(GtkLabel* label, PangoEllipsizeMode mode)"
  s7_pointer _p;
  s7_pointer label, mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_ellipsize", 1, label, "GtkLabel*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_ellipsize", 2, mode, "PangoEllipsizeMode");
  gtk_label_set_ellipsize(s7_c_pointer(label), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_ellipsize "PangoEllipsizeMode gtk_label_get_ellipsize(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_ellipsize", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_ellipsize(s7_c_pointer(label))));
}

static s7_pointer lg_pango_attr_fallback_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_fallback_new "PangoAttribute* pango_attr_fallback_new(gboolean enable_fallback)"
  s7_pointer enable_fallback;
  enable_fallback = s7_car(args);
  if (!s7_is_boolean(enable_fallback)) s7_wrong_type_arg_error(sc, "pango_attr_fallback_new", 1, enable_fallback, "gboolean");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_fallback_new(lg_boolean(enable_fallback))));
}

static s7_pointer lg_pango_attr_letter_spacing_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_letter_spacing_new "PangoAttribute* pango_attr_letter_spacing_new(int letter_spacing)"
  s7_pointer letter_spacing;
  letter_spacing = s7_car(args);
  if (!s7_is_integer(letter_spacing)) s7_wrong_type_arg_error(sc, "pango_attr_letter_spacing_new", 1, letter_spacing, "int");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_letter_spacing_new(s7_integer(letter_spacing))));
}

static s7_pointer lg_pango_attr_list_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_filter "PangoAttrList* pango_attr_list_filter(PangoAttrList* list, PangoAttrFilterFunc func, \
gpointer data)"
  s7_pointer _p;
  s7_pointer list, func, data;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 1, list, "PangoAttrList*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, PangoAttrFilterFunc_sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 2, func, "PangoAttrFilterFunc");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 3, data, "gpointer");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, pango_attr_list_filter(s7_c_pointer(list), s7_c_pointer(func), s7_c_pointer(data))));
}

static s7_pointer lg_pango_attr_iterator_get_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get_attrs "GSList* pango_attr_iterator_get_attrs(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_attrs", 1, iterator, "PangoAttrIterator*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, pango_attr_iterator_get_attrs(s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_font_metrics_get_underline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_underline_position "int pango_font_metrics_get_underline_position(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_underline_position", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_underline_position(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_underline_thickness(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_underline_thickness "int pango_font_metrics_get_underline_thickness(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_underline_thickness", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_underline_thickness(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_strikethrough_position(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_strikethrough_position "int pango_font_metrics_get_strikethrough_position(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_strikethrough_position", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_strikethrough_position(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_strikethrough_thickness(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_strikethrough_thickness "int pango_font_metrics_get_strikethrough_thickness(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_strikethrough_thickness", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_strikethrough_thickness(s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_family_is_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_is_monospace "gboolean pango_font_family_is_monospace(PangoFontFamily* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_is_monospace", 1, family, "PangoFontFamily*");
  return(s7_make_boolean(sc, pango_font_family_is_monospace(s7_c_pointer(family))));
}

static s7_pointer lg_pango_font_face_list_sizes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_list_sizes "void pango_font_face_list_sizes(PangoFontFace* face, int** [sizes], \
int* [n_sizes])"
  s7_pointer _p;
  s7_pointer face;
  int* ref_sizes = NULL;
  int ref_n_sizes;
  _p = args;
  face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_list_sizes", 1, face, "PangoFontFace*");
  pango_font_face_list_sizes(s7_c_pointer(face), &ref_sizes, &ref_n_sizes);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_sizes), s7_make_integer(sc, ref_n_sizes)));
}

static s7_pointer lg_pango_layout_set_auto_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_auto_dir "void pango_layout_set_auto_dir(PangoLayout* layout, gboolean auto_dir)"
  s7_pointer _p;
  s7_pointer layout, auto_dir;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_auto_dir", 1, layout, "PangoLayout*");
  auto_dir = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(auto_dir)) s7_wrong_type_arg_error(sc, "pango_layout_set_auto_dir", 2, auto_dir, "gboolean");
  pango_layout_set_auto_dir(s7_c_pointer(layout), lg_boolean(auto_dir));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_auto_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_auto_dir "gboolean pango_layout_get_auto_dir(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_auto_dir", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_auto_dir(s7_c_pointer(layout))));
}

static s7_pointer lg_pango_script_for_unichar(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_for_unichar "PangoScript pango_script_for_unichar(gunichar ch)"
  s7_pointer ch;
  ch = s7_car(args);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "pango_script_for_unichar", 1, ch, "gunichar");
  return(s7_make_integer(sc, pango_script_for_unichar(s7_integer(ch))));
}

static s7_pointer lg_pango_script_iter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_new "PangoScriptIter* pango_script_iter_new(char* text, int length)"
  s7_pointer _p;
  s7_pointer text, length;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_script_iter_new", 1, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_script_iter_new", 2, length, "int");
  return(s7_make_type_with_c_pointer(sc, PangoScriptIter__sym, pango_script_iter_new((char*)s7_string(text), s7_integer(length))));
}

static s7_pointer lg_pango_script_iter_get_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_get_range "void pango_script_iter_get_range(PangoScriptIter* iter, char** [start], \
char** [end], PangoScript* [script])"
  s7_pointer _p;
  s7_pointer iter;
  char* ref_start = NULL;
  char* ref_end = NULL;
  PangoScript ref_script;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_get_range", 1, iter, "PangoScriptIter*");
  pango_script_iter_get_range(s7_c_pointer(iter), (const char**)&ref_start, (const char**)&ref_end, &ref_script);
    return(s7_list(sc, 3, s7_make_string(sc, ref_start), s7_make_string(sc, ref_end), s7_make_integer(sc, ref_script)));
}

static s7_pointer lg_pango_script_iter_next(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_next "gboolean pango_script_iter_next(PangoScriptIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_next", 1, iter, "PangoScriptIter*");
  return(s7_make_boolean(sc, pango_script_iter_next(s7_c_pointer(iter))));
}

static s7_pointer lg_pango_script_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_free "void pango_script_iter_free(PangoScriptIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_free", 1, iter, "PangoScriptIter*");
  pango_script_iter_free(s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_button_new_with_dialog(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_new_with_dialog "GtkWidget* gtk_file_chooser_button_new_with_dialog(GtkWidget* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new_with_dialog", 1, dialog, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_file_chooser_button_new_with_dialog(s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_file_chooser_button_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_get_title "gchar* gtk_file_chooser_button_get_title(GtkFileChooserButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_get_title", 1, button, "GtkFileChooserButton*");
  return(s7_make_string(sc, gtk_file_chooser_button_get_title(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_file_chooser_button_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_set_title "void gtk_file_chooser_button_set_title(GtkFileChooserButton* button, \
gchar* title)"
  s7_pointer _p;
  s7_pointer button, title;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_title", 1, button, "GtkFileChooserButton*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_title", 2, title, "gchar*");
  gtk_file_chooser_button_set_title(s7_c_pointer(button), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_drop_succeeded(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_drop_succeeded "gboolean gdk_drag_drop_succeeded(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_drop_succeeded", 1, context, "GdkDragContext*");
  return(s7_make_boolean(sc, gdk_drag_drop_succeeded(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_entry_layout_index_to_text_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_layout_index_to_text_index "gint gtk_entry_layout_index_to_text_index(GtkEntry* entry, \
gint layout_index)"
  s7_pointer _p;
  s7_pointer entry, layout_index;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_layout_index_to_text_index", 1, entry, "GtkEntry*");
  layout_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(layout_index)) s7_wrong_type_arg_error(sc, "gtk_entry_layout_index_to_text_index", 2, layout_index, "gint");
  return(s7_make_integer(sc, gtk_entry_layout_index_to_text_index(s7_c_pointer(entry), s7_integer(layout_index))));
}

static s7_pointer lg_gtk_entry_text_index_to_layout_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_text_index_to_layout_index "gint gtk_entry_text_index_to_layout_index(GtkEntry* entry, \
gint text_index)"
  s7_pointer _p;
  s7_pointer entry, text_index;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_text_index_to_layout_index", 1, entry, "GtkEntry*");
  text_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(text_index)) s7_wrong_type_arg_error(sc, "gtk_entry_text_index_to_layout_index", 2, text_index, "gint");
  return(s7_make_integer(sc, gtk_entry_text_index_to_layout_index(s7_c_pointer(entry), s7_integer(text_index))));
}

static s7_pointer lg_gtk_file_chooser_set_show_hidden(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_show_hidden "void gtk_file_chooser_set_show_hidden(GtkFileChooser* chooser, \
gboolean show_hidden)"
  s7_pointer _p;
  s7_pointer chooser, show_hidden;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_show_hidden", 1, chooser, "GtkFileChooser*");
  show_hidden = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_hidden)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_show_hidden", 2, show_hidden, "gboolean");
  gtk_file_chooser_set_show_hidden(s7_c_pointer(chooser), lg_boolean(show_hidden));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_show_hidden(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_show_hidden "gboolean gtk_file_chooser_get_show_hidden(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_show_hidden", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_show_hidden(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_tree_view_set_hover_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_hover_expand "void gtk_tree_view_set_hover_expand(GtkTreeView* tree_view, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_view, expand;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_expand", 1, tree_view, "GtkTreeView*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_expand", 2, expand, "gboolean");
  gtk_tree_view_set_hover_expand(s7_c_pointer(tree_view), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_hover_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_hover_expand "gboolean gtk_tree_view_get_hover_expand(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_hover_expand", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_hover_expand(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tool_item_rebuild_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_rebuild_menu "void gtk_tool_item_rebuild_menu(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_rebuild_menu", 1, tool_item, "GtkToolItem*");
  gtk_tool_item_rebuild_menu(s7_c_pointer(tool_item));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_tool_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_tool_button_new "GtkToolItem* gtk_menu_tool_button_new(GtkWidget* icon_widget, gchar* label)"
  s7_pointer _p;
  s7_pointer icon_widget, label;
  _p = args;
  icon_widget = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(icon_widget, GtkWidget__sym)) && (icon_widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_new", 1, icon_widget, "GtkWidget*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_new", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_menu_tool_button_new(s7_c_pointer(icon_widget), s7_string(label))));
}

static s7_pointer lg_gtk_menu_tool_button_set_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_tool_button_set_menu "void gtk_menu_tool_button_set_menu(GtkMenuToolButton* button, \
GtkWidget* menu)"
  s7_pointer _p;
  s7_pointer button, menu;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkMenuToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_menu", 1, button, "GtkMenuToolButton*");
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_menu", 2, menu, "GtkWidget*");
  gtk_menu_tool_button_set_menu(s7_c_pointer(button), s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_tool_button_get_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_tool_button_get_menu "GtkWidget* gtk_menu_tool_button_get_menu(GtkMenuToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkMenuToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_get_menu", 1, button, "GtkMenuToolButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_tool_button_get_menu(s7_c_pointer(button))));
}

static s7_pointer lg_gdk_display_supports_clipboard_persistence(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_clipboard_persistence "gboolean gdk_display_supports_clipboard_persistence(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_clipboard_persistence", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_clipboard_persistence(s7_c_pointer(display))));
}

static s7_pointer lg_gtk_about_dialog_get_logo_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_logo_icon_name "gchar* gtk_about_dialog_get_logo_icon_name(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_logo_icon_name", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_logo_icon_name(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_logo_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_logo_icon_name "void gtk_about_dialog_set_logo_icon_name(GtkAboutDialog* about, \
gchar* icon_name)"
  s7_pointer _p;
  s7_pointer about, icon_name;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo_icon_name", 1, about, "GtkAboutDialog*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo_icon_name", 2, icon_name, "gchar*");
  gtk_about_dialog_set_logo_icon_name(s7_c_pointer(about), s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_get_label "gchar* gtk_accelerator_get_label(guint accelerator_key, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator_key, accelerator_mods;
  _p = args;
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label", 1, accelerator_key, "guint");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label", 2, accelerator_mods, "GdkModifierType");
  {
    gchar* result;
    s7_pointer rtn;
    result = gtk_accelerator_get_label(s7_integer(accelerator_key), s7_integer(accelerator_mods));
    rtn = s7_make_string(sc, result);
    g_free(result);
    return(rtn);
  }
}

static s7_pointer lg_gtk_clipboard_wait_is_target_available(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_is_target_available "gboolean gtk_clipboard_wait_is_target_available(GtkClipboard* clipboard, \
GdkAtom target)"
  s7_pointer _p;
  s7_pointer clipboard, target;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_target_available", 1, clipboard, "GtkClipboard*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_target_available", 2, target, "GdkAtom");
  return(s7_make_boolean(sc, gtk_clipboard_wait_is_target_available(s7_c_pointer(clipboard), s7_c_pointer(target))));
}

static s7_pointer lg_gtk_clipboard_set_can_store(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_set_can_store "void gtk_clipboard_set_can_store(GtkClipboard* clipboard, GtkTargetEntry* targets, \
gint n_targets)"
  s7_pointer _p;
  s7_pointer clipboard, targets, n_targets;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_can_store", 1, clipboard, "GtkClipboard*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) && (targets != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_can_store", 2, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_can_store", 3, n_targets, "gint");
  gtk_clipboard_set_can_store(s7_c_pointer(clipboard), s7_c_pointer(targets), s7_integer(n_targets));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_store(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_store "void gtk_clipboard_store(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_store", 1, clipboard, "GtkClipboard*");
  gtk_clipboard_store(s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_add_image_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_add_image_targets "void gtk_drag_dest_add_image_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_add_image_targets", 1, widget, "GtkWidget*");
  gtk_drag_dest_add_image_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_add_uri_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_add_uri_targets "void gtk_drag_dest_add_uri_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_add_uri_targets", 1, widget, "GtkWidget*");
  gtk_drag_dest_add_uri_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_add_image_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_add_image_targets "void gtk_drag_source_add_image_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_add_image_targets", 1, widget, "GtkWidget*");
  gtk_drag_source_add_image_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_add_uri_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_add_uri_targets "void gtk_drag_source_add_uri_targets(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_add_uri_targets", 1, widget, "GtkWidget*");
  gtk_drag_source_add_uri_targets(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_button_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_get_width_chars "gint gtk_file_chooser_button_get_width_chars(GtkFileChooserButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_get_width_chars", 1, button, "GtkFileChooserButton*");
  return(s7_make_integer(sc, gtk_file_chooser_button_get_width_chars(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_file_chooser_button_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_set_width_chars "void gtk_file_chooser_button_set_width_chars(GtkFileChooserButton* button, \
gint n_chars)"
  s7_pointer _p;
  s7_pointer button, n_chars;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_width_chars", 1, button, "GtkFileChooserButton*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_width_chars", 2, n_chars, "gint");
  gtk_file_chooser_button_set_width_chars(s7_c_pointer(button), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_pixel_size "void gtk_image_set_pixel_size(GtkImage* image, gint pixel_size)"
  s7_pointer _p;
  s7_pointer image, pixel_size;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_pixel_size", 1, image, "GtkImage*");
  pixel_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pixel_size)) s7_wrong_type_arg_error(sc, "gtk_image_set_pixel_size", 2, pixel_size, "gint");
  gtk_image_set_pixel_size(s7_c_pointer(image), s7_integer(pixel_size));
  return(lg_false);
}

static s7_pointer lg_gtk_image_get_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_pixel_size "gint gtk_image_get_pixel_size(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_pixel_size", 1, image, "GtkImage*");
  return(s7_make_integer(sc, gtk_image_get_pixel_size(s7_c_pointer(image))));
}

static s7_pointer lg_gtk_label_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_width_chars "void gtk_label_set_width_chars(GtkLabel* label, gint n_chars)"
  s7_pointer _p;
  s7_pointer label, n_chars;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_width_chars", 1, label, "GtkLabel*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_label_set_width_chars", 2, n_chars, "gint");
  gtk_label_set_width_chars(s7_c_pointer(label), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_width_chars "gint gtk_label_get_width_chars(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_width_chars", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_width_chars(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_target_list_add_text_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add_text_targets "void gtk_target_list_add_text_targets(GtkTargetList* list, \
guint info)"
  s7_pointer _p;
  s7_pointer list, info;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_text_targets", 1, list, "GtkTargetList*");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_text_targets", 2, info, "guint");
  gtk_target_list_add_text_targets(s7_c_pointer(list), s7_integer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_add_image_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add_image_targets "void gtk_target_list_add_image_targets(GtkTargetList* list, \
guint info, gboolean writable)"
  s7_pointer _p;
  s7_pointer list, info, writable;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_image_targets", 1, list, "GtkTargetList*");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_image_targets", 2, info, "guint");
  writable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(writable)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_image_targets", 3, writable, "gboolean");
  gtk_target_list_add_image_targets(s7_c_pointer(list), s7_integer(info), lg_boolean(writable));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_add_uri_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add_uri_targets "void gtk_target_list_add_uri_targets(GtkTargetList* list, \
guint info)"
  s7_pointer _p;
  s7_pointer list, info;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_uri_targets", 1, list, "GtkTargetList*");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_uri_targets", 2, info, "guint");
  gtk_target_list_add_uri_targets(s7_c_pointer(list), s7_integer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_data_set_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_set_pixbuf "gboolean gtk_selection_data_set_pixbuf(GtkSelectionData* selection_data, \
GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer selection_data, pixbuf;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_pixbuf", 1, selection_data, "GtkSelectionData*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_pixbuf", 2, pixbuf, "GdkPixbuf*");
  return(s7_make_boolean(sc, gtk_selection_data_set_pixbuf(s7_c_pointer(selection_data), s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_selection_data_get_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_pixbuf "GdkPixbuf* gtk_selection_data_get_pixbuf(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_pixbuf", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_selection_data_get_pixbuf(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_data_set_uris(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_set_uris "gboolean gtk_selection_data_set_uris(GtkSelectionData* selection_data, \
gchar** uris)"
  s7_pointer _p;
  s7_pointer selection_data, uris;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_uris", 1, selection_data, "GtkSelectionData*");
  uris = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(uris, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_set_uris", 2, uris, "gchar**");
  return(s7_make_boolean(sc, gtk_selection_data_set_uris(s7_c_pointer(selection_data), s7_c_pointer(uris))));
}

static s7_pointer lg_gtk_selection_data_get_uris(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_uris "gchar** gtk_selection_data_get_uris(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_uris", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, gchar___sym, gtk_selection_data_get_uris(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_text_buffer_backspace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_backspace "gboolean gtk_text_buffer_backspace(GtkTextBuffer* buffer, GtkTextIter* iter, \
gboolean interactive, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, interactive, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 2, iter, "GtkTextIter*");
  interactive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(interactive)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 3, interactive, "gboolean");
  default_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_backspace(s7_c_pointer(buffer), s7_c_pointer(iter), lg_boolean(interactive), lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_clipboard_set_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_set_image "void gtk_clipboard_set_image(GtkClipboard* clipboard, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer clipboard, pixbuf;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_image", 1, clipboard, "GtkClipboard*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_set_image", 2, pixbuf, "GdkPixbuf*");
  gtk_clipboard_set_image(s7_c_pointer(clipboard), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_request_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_request_image "void gtk_clipboard_request_image(GtkClipboard* clipboard, GtkClipboardImageReceivedFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_image", 1, clipboard, "GtkClipboard*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardImageReceivedFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_image", 2, func, "GtkClipboardImageReceivedFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_image", 3, func_info, "lambda_data");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_clipboard_request_image(s7_c_pointer(clipboard), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_clipboard_wait_for_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_for_image "GdkPixbuf* gtk_clipboard_wait_for_image(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_image", 1, clipboard, "GtkClipboard*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_clipboard_wait_for_image(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_clipboard_wait_is_image_available(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_is_image_available "gboolean gtk_clipboard_wait_is_image_available(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_image_available", 1, clipboard, "GtkClipboard*");
  return(s7_make_boolean(sc, gtk_clipboard_wait_is_image_available(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_file_filter_add_pixbuf_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_pixbuf_formats "void gtk_file_filter_add_pixbuf_formats(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pixbuf_formats", 1, filter, "GtkFileFilter*");
  gtk_file_filter_add_pixbuf_formats(s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_single_line_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_single_line_mode "void gtk_label_set_single_line_mode(GtkLabel* label, gboolean single_line_mode)"
  s7_pointer _p;
  s7_pointer label, single_line_mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_single_line_mode", 1, label, "GtkLabel*");
  single_line_mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(single_line_mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_single_line_mode", 2, single_line_mode, "gboolean");
  gtk_label_set_single_line_mode(s7_c_pointer(label), lg_boolean(single_line_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_single_line_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_single_line_mode "gboolean gtk_label_get_single_line_mode(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_single_line_mode", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_single_line_mode(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_progress_bar_set_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_ellipsize "void gtk_progress_bar_set_ellipsize(GtkProgressBar* pbar, \
PangoEllipsizeMode mode)"
  s7_pointer _p;
  s7_pointer pbar, mode;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_ellipsize", 1, pbar, "GtkProgressBar*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_ellipsize", 2, mode, "PangoEllipsizeMode");
  gtk_progress_bar_set_ellipsize(s7_c_pointer(pbar), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_ellipsize "PangoEllipsizeMode gtk_progress_bar_get_ellipsize(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_ellipsize", 1, pbar, "GtkProgressBar*");
  return(s7_make_integer(sc, gtk_progress_bar_get_ellipsize(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_selection_data_targets_include_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_targets_include_image "gboolean gtk_selection_data_targets_include_image(GtkSelectionData* selection_data, \
gboolean writable)"
  s7_pointer _p;
  s7_pointer selection_data, writable;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_image", 1, selection_data, "GtkSelectionData*");
  writable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(writable)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_image", 2, writable, "gboolean");
  return(s7_make_boolean(sc, gtk_selection_data_targets_include_image(s7_c_pointer(selection_data), lg_boolean(writable))));
}

static s7_pointer lg_gtk_menu_set_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_screen "void gtk_menu_set_screen(GtkMenu* menu, GdkScreen* screen)"
  s7_pointer _p;
  s7_pointer menu, screen;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_screen", 1, menu, "GtkMenu*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) && (screen != lg_false)) s7_wrong_type_arg_error(sc, "gtk_menu_set_screen", 2, screen, "GdkScreen*");
  gtk_menu_set_screen(s7_c_pointer(menu), s7_c_pointer(screen));
  return(lg_false);
}

static s7_pointer lg_pango_attr_underline_color_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_underline_color_new "PangoAttribute* pango_attr_underline_color_new(guint16 red, \
guint16 green, guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 2, green, "guint16");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 3, blue, "guint16");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_underline_color_new(s7_integer(red), s7_integer(green), s7_integer(blue))));
}

static s7_pointer lg_pango_attr_strikethrough_color_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_strikethrough_color_new "PangoAttribute* pango_attr_strikethrough_color_new(guint16 red, \
guint16 green, guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 2, green, "guint16");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 3, blue, "guint16");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_strikethrough_color_new(s7_integer(red), s7_integer(green), s7_integer(blue))));
}

static s7_pointer lg_pango_renderer_draw_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_layout "void pango_renderer_draw_layout(PangoRenderer* renderer, PangoLayout* layout, \
int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, layout, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 1, renderer, "PangoRenderer*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 2, layout, "PangoLayout*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 3, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 4, y, "int");
  pango_renderer_draw_layout(s7_c_pointer(renderer), s7_c_pointer(layout), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_layout_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_layout_line "void pango_renderer_draw_layout_line(PangoRenderer* renderer, \
PangoLayoutLine* line, int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, line, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 1, renderer, "PangoRenderer*");
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 2, line, "PangoLayoutLine*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 3, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 4, y, "int");
  pango_renderer_draw_layout_line(s7_c_pointer(renderer), s7_c_pointer(line), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_glyphs "void pango_renderer_draw_glyphs(PangoRenderer* renderer, PangoFont* font, \
PangoGlyphString* glyphs, int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, font, glyphs, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 1, renderer, "PangoRenderer*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 2, font, "PangoFont*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 3, glyphs, "PangoGlyphString*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 4, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 5, y, "int");
  pango_renderer_draw_glyphs(s7_c_pointer(renderer), s7_c_pointer(font), s7_c_pointer(glyphs), s7_integer(x), s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_rectangle "void pango_renderer_draw_rectangle(PangoRenderer* renderer, \
PangoRenderPart part, int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer renderer, part, x, y, width, height;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 2, part, "PangoRenderPart");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 3, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 4, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 5, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 6, height, "int");
  pango_renderer_draw_rectangle(s7_c_pointer(renderer), s7_integer(part), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_error_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_error_underline "void pango_renderer_draw_error_underline(PangoRenderer* renderer, \
int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer renderer, x, y, width, height;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 1, renderer, "PangoRenderer*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 3, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 5, height, "int");
  pango_renderer_draw_error_underline(s7_c_pointer(renderer), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_trapezoid(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_trapezoid "void pango_renderer_draw_trapezoid(PangoRenderer* renderer, \
PangoRenderPart part, double y1, double x11, double x21, double y2, double x12, double x22)"
  s7_pointer _p;
  s7_pointer renderer, part, y1, x11, x21, y2, x12, x22;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 2, part, "PangoRenderPart");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 3, y1, "double");
  x11 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x11)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 4, x11, "double");
  x21 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x21)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 5, x21, "double");
  y2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y2)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 6, y2, "double");
  x12 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x12)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 7, x12, "double");
  x22 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x22)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 8, x22, "double");
  pango_renderer_draw_trapezoid(s7_c_pointer(renderer), s7_integer(part), s7_real(y1), s7_real(x11), s7_real(x21), s7_real(y2), s7_real(x12), s7_real(x22));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_glyph(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_glyph "void pango_renderer_draw_glyph(PangoRenderer* renderer, PangoFont* font, \
PangoGlyph glyph, double x, double y)"
  s7_pointer _p;
  s7_pointer renderer, font, glyph, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 1, renderer, "PangoRenderer*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 2, font, "PangoFont*");
  glyph = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(glyph)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 3, glyph, "PangoGlyph");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 4, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 5, y, "double");
  pango_renderer_draw_glyph(s7_c_pointer(renderer), s7_c_pointer(font), s7_integer(glyph), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_activate "void pango_renderer_activate(PangoRenderer* renderer)"
  s7_pointer renderer;
  renderer = s7_car(args);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_activate", 1, renderer, "PangoRenderer*");
  pango_renderer_activate(s7_c_pointer(renderer));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_deactivate(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_deactivate "void pango_renderer_deactivate(PangoRenderer* renderer)"
  s7_pointer renderer;
  renderer = s7_car(args);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_deactivate", 1, renderer, "PangoRenderer*");
  pango_renderer_deactivate(s7_c_pointer(renderer));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_part_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_part_changed "void pango_renderer_part_changed(PangoRenderer* renderer, PangoRenderPart part)"
  s7_pointer _p;
  s7_pointer renderer, part;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_part_changed", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_part_changed", 2, part, "PangoRenderPart");
  pango_renderer_part_changed(s7_c_pointer(renderer), s7_integer(part));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_set_color(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_set_color "void pango_renderer_set_color(PangoRenderer* renderer, PangoRenderPart part, \
PangoColor* color)"
  s7_pointer _p;
  s7_pointer renderer, part, color;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 2, part, "PangoRenderPart");
  color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 3, color, "PangoColor*");
  pango_renderer_set_color(s7_c_pointer(renderer), s7_integer(part), s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_get_color(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_get_color "PangoColor* pango_renderer_get_color(PangoRenderer* renderer, PangoRenderPart part)"
  s7_pointer _p;
  s7_pointer renderer, part;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_get_color", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_get_color", 2, part, "PangoRenderPart");
  return(s7_make_type_with_c_pointer(sc, PangoColor__sym, pango_renderer_get_color(s7_c_pointer(renderer), s7_integer(part))));
}

static s7_pointer lg_pango_renderer_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_set_matrix "void pango_renderer_set_matrix(PangoRenderer* renderer, PangoMatrix* matrix)"
  s7_pointer _p;
  s7_pointer renderer, matrix;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_matrix", 1, renderer, "PangoRenderer*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, PangoMatrix__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_matrix", 2, matrix, "PangoMatrix*");
  pango_renderer_set_matrix(s7_c_pointer(renderer), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_g_log_set_handler(s7_scheme *sc, s7_pointer args)
{
  #define H_g_log_set_handler "guint g_log_set_handler(gchar* log_domain, GLogLevelFlags log_levels, \
GLogFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer log_domain, log_levels, func, func_info;
  _p = args;
  log_domain = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(log_domain)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 1, log_domain, "gchar*");
  log_levels = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(log_levels)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 2, log_levels, "GLogLevelFlags");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GLogFunc_sym)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 3, func, "GLogFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 4, func_info, "lambda_data");
  {
    s7_pointer result;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    result = s7_make_integer(sc, g_log_set_handler(s7_string(log_domain), s7_integer(log_levels), s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_g_log_remove_handler(s7_scheme *sc, s7_pointer args)
{
  #define H_g_log_remove_handler "void g_log_remove_handler(gchar* log_domain, guint handler_id)"
  s7_pointer _p;
  s7_pointer log_domain, handler_id;
  _p = args;
  log_domain = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(log_domain)) s7_wrong_type_arg_error(sc, "g_log_remove_handler", 1, log_domain, "gchar*");
  handler_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_log_remove_handler", 2, handler_id, "guint");
  g_log_remove_handler(s7_string(log_domain), s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_stop_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_stop_editing "void gtk_cell_renderer_stop_editing(GtkCellRenderer* cell, \
gboolean canceled)"
  s7_pointer _p;
  s7_pointer cell, canceled;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_stop_editing", 1, cell, "GtkCellRenderer*");
  canceled = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(canceled)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_stop_editing", 2, canceled, "gboolean");
  gtk_cell_renderer_stop_editing(s7_c_pointer(cell), lg_boolean(canceled));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_new "GtkWidget* gtk_file_chooser_button_new(gchar* title, GtkFileChooserAction action)"
  s7_pointer _p;
  s7_pointer title, action;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new", 1, title, "gchar*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new", 2, action, "GtkFileChooserAction");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_file_chooser_button_new((const gchar*)s7_string(title), s7_integer(action))));
}

static s7_pointer lg_gtk_icon_view_set_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_columns "void gtk_icon_view_set_columns(GtkIconView* icon_view, gint columns)"
  s7_pointer _p;
  s7_pointer icon_view, columns;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_columns", 1, icon_view, "GtkIconView*");
  columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(columns)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_columns", 2, columns, "gint");
  gtk_icon_view_set_columns(s7_c_pointer(icon_view), s7_integer(columns));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_columns "gint gtk_icon_view_get_columns(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_columns", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_columns(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_item_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_width "void gtk_icon_view_set_item_width(GtkIconView* icon_view, gint item_width)"
  s7_pointer _p;
  s7_pointer icon_view, item_width;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_width", 1, icon_view, "GtkIconView*");
  item_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(item_width)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_width", 2, item_width, "gint");
  gtk_icon_view_set_item_width(s7_c_pointer(icon_view), s7_integer(item_width));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_width "gint gtk_icon_view_get_item_width(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_width", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_width(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_spacing "void gtk_icon_view_set_spacing(GtkIconView* icon_view, gint spacing)"
  s7_pointer _p;
  s7_pointer icon_view, spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_spacing", 1, icon_view, "GtkIconView*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_spacing", 2, spacing, "gint");
  gtk_icon_view_set_spacing(s7_c_pointer(icon_view), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_spacing "gint gtk_icon_view_get_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_spacing(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_row_spacing "void gtk_icon_view_set_row_spacing(GtkIconView* icon_view, \
gint row_spacing)"
  s7_pointer _p;
  s7_pointer icon_view, row_spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_row_spacing", 1, icon_view, "GtkIconView*");
  row_spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row_spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_row_spacing", 2, row_spacing, "gint");
  gtk_icon_view_set_row_spacing(s7_c_pointer(icon_view), s7_integer(row_spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_row_spacing "gint gtk_icon_view_get_row_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_row_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_row_spacing(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_column_spacing "void gtk_icon_view_set_column_spacing(GtkIconView* icon_view, \
gint column_spacing)"
  s7_pointer _p;
  s7_pointer icon_view, column_spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_column_spacing", 1, icon_view, "GtkIconView*");
  column_spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column_spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_column_spacing", 2, column_spacing, "gint");
  gtk_icon_view_set_column_spacing(s7_c_pointer(icon_view), s7_integer(column_spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_column_spacing "gint gtk_icon_view_get_column_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_column_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_column_spacing(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_margin "void gtk_icon_view_set_margin(GtkIconView* icon_view, gint margin)"
  s7_pointer _p;
  s7_pointer icon_view, margin;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_margin", 1, icon_view, "GtkIconView*");
  margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_margin", 2, margin, "gint");
  gtk_icon_view_set_margin(s7_c_pointer(icon_view), s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_margin "gint gtk_icon_view_get_margin(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_margin", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_margin(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_label_set_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_max_width_chars "void gtk_label_set_max_width_chars(GtkLabel* label, gint n_chars)"
  s7_pointer _p;
  s7_pointer label, n_chars;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_max_width_chars", 1, label, "GtkLabel*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_label_set_max_width_chars", 2, n_chars, "gint");
  gtk_label_set_max_width_chars(s7_c_pointer(label), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_max_width_chars "gint gtk_label_get_max_width_chars(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_max_width_chars", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_max_width_chars(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_list_store_insert_with_values(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_with_values "void gtk_list_store_insert_with_values(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, ...)"
  s7_pointer _p;
  s7_pointer list_store, iter, position;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 3, position, "gint");
  gtk_list_store_insert_with_values(s7_c_pointer(list_store), s7_c_pointer(iter), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_with_valuesv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_with_valuesv "void gtk_list_store_insert_with_valuesv(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, gint* columns, GValue* values, gint n_values)"
  s7_pointer _p;
  s7_pointer list_store, iter, position, columns, values, n_values;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 3, position, "gint");
  columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(columns, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 4, columns, "gint*");
  values = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(values, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 5, values, "GValue*");
  n_values = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_values)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 6, n_values, "gint");
  gtk_list_store_insert_with_valuesv(s7_c_pointer(list_store), s7_c_pointer(iter), s7_integer(position), s7_c_pointer(columns), s7_c_pointer(values), s7_integer(n_values));
  return(lg_false);
}

static s7_pointer lg_pango_attr_size_new_absolute(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_size_new_absolute "PangoAttribute* pango_attr_size_new_absolute(int size)"
  s7_pointer size;
  size = s7_car(args);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_attr_size_new_absolute", 1, size, "int");
  return(s7_make_type_with_c_pointer(sc, PangoAttribute__sym, pango_attr_size_new_absolute(s7_integer(size))));
}

static s7_pointer lg_pango_font_description_set_absolute_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_absolute_size "void pango_font_description_set_absolute_size(PangoFontDescription* desc, \
double size)"
  s7_pointer _p;
  s7_pointer desc, size;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_absolute_size", 1, desc, "PangoFontDescription*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "pango_font_description_set_absolute_size", 2, size, "double");
  pango_font_description_set_absolute_size(s7_c_pointer(desc), s7_real(size));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_font_description "PangoFontDescription* pango_layout_get_font_description(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_font_description", 1, layout, "PangoLayout*");
    return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, (PangoFontDescription*)pango_layout_get_font_description(s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_cursor_new_from_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_from_name "GdkCursor* gdk_cursor_new_from_name(GdkDisplay* display, gchar* name)"
  s7_pointer _p;
  s7_pointer display, name;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_name", 1, display, "GdkDisplay*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_name", 2, name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_cursor_new_from_name(s7_c_pointer(display), (const gchar*)s7_string(name))));
}

static s7_pointer lg_gdk_cursor_get_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_image "GdkPixbuf* gdk_cursor_get_image(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_image", 1, cursor, "GdkCursor*");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gdk_cursor_get_image(s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_window_set_urgency_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_urgency_hint "void gdk_window_set_urgency_hint(GdkWindow* window, gboolean urgent)"
  s7_pointer _p;
  s7_pointer window, urgent;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_urgency_hint", 1, window, "GdkWindow*");
  urgent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(urgent)) s7_wrong_type_arg_error(sc, "gdk_window_set_urgency_hint", 2, urgent, "gboolean");
  gdk_window_set_urgency_hint(s7_c_pointer(window), lg_boolean(urgent));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_get_response_for_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_response_for_widget "gint gtk_dialog_get_response_for_widget(GtkDialog* dialog, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer dialog, widget;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_response_for_widget", 1, dialog, "GtkDialog*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_response_for_widget", 2, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_dialog_get_response_for_widget(s7_c_pointer(dialog), s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_drag_source_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_icon_name "void gtk_drag_source_set_icon_name(GtkWidget* widget, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer widget, icon_name;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_name", 1, widget, "GtkWidget*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_name", 2, icon_name, "gchar*");
  gtk_drag_source_set_icon_name(s7_c_pointer(widget), (const gchar*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_name "void gtk_drag_set_icon_name(GdkDragContext* context, gchar* icon_name, \
gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer context, icon_name, hot_x, hot_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_name", 1, context, "GdkDragContext*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_name", 2, icon_name, "gchar*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_name", 3, hot_x, "gint");
  hot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_name", 4, hot_y, "gint");
  gtk_drag_set_icon_name(s7_c_pointer(context), (const gchar*)s7_string(icon_name), s7_integer(hot_x), s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_set_popup_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_set_width "void gtk_entry_completion_set_popup_set_width(GtkEntryCompletion* completion, \
gboolean popup_set_width)"
  s7_pointer _p;
  s7_pointer completion, popup_set_width;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_set_width", 1, completion, "GtkEntryCompletion*");
  popup_set_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(popup_set_width)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_set_width", 2, popup_set_width, "gboolean");
  gtk_entry_completion_set_popup_set_width(s7_c_pointer(completion), lg_boolean(popup_set_width));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_set_width "gboolean gtk_entry_completion_get_popup_set_width(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_set_width", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_set_width(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_popup_single_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_single_match "void gtk_entry_completion_set_popup_single_match(GtkEntryCompletion* completion, \
gboolean popup_single_match)"
  s7_pointer _p;
  s7_pointer completion, popup_single_match;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_single_match", 1, completion, "GtkEntryCompletion*");
  popup_single_match = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(popup_single_match)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_single_match", 2, popup_single_match, "gboolean");
  gtk_entry_completion_set_popup_single_match(s7_c_pointer(completion), lg_boolean(popup_single_match));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_single_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_single_match "gboolean gtk_entry_completion_get_popup_single_match(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_single_match", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_single_match(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_icon_view_get_item_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_at_pos "gboolean gtk_icon_view_get_item_at_pos(GtkIconView* icon_view, \
gint x, gint y, GtkTreePath** [path], GtkCellRenderer** [cell])"
  s7_pointer _p;
  s7_pointer icon_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 1, icon_view, "GtkIconView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 3, y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_icon_view_get_item_at_pos(s7_c_pointer(icon_view), s7_integer(x), s7_integer(y), &ref_path, &ref_cell));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_cell)));
   }
}

static s7_pointer lg_gtk_icon_view_get_visible_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_visible_range "gboolean gtk_icon_view_get_visible_range(GtkIconView* icon_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  s7_pointer _p;
  s7_pointer icon_view;
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_visible_range", 1, icon_view, "GtkIconView*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_icon_view_get_visible_range(s7_c_pointer(icon_view), &ref_start_path, &ref_end_path));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_start_path), s7_make_c_pointer(sc, ref_end_path)));
   }
}

static s7_pointer lg_gtk_icon_view_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_cursor "void gtk_icon_view_set_cursor(GtkIconView* icon_view, GtkTreePath* path, \
GtkCellRenderer* cell, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer icon_view, path, cell, start_editing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 2, path, "GtkTreePath*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 3, cell, "GtkCellRenderer*");
  start_editing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 4, start_editing, "gboolean");
  gtk_icon_view_set_cursor(s7_c_pointer(icon_view), s7_c_pointer(path), s7_c_pointer(cell), lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_cursor "gboolean gtk_icon_view_get_cursor(GtkIconView* icon_view, GtkTreePath** [path], \
GtkCellRenderer** [cell])"
  s7_pointer _p;
  s7_pointer icon_view;
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_cursor", 1, icon_view, "GtkIconView*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_icon_view_get_cursor(s7_c_pointer(icon_view), &ref_path, &ref_cell));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_cell)));
   }
}

static s7_pointer lg_gtk_icon_view_scroll_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_scroll_to_path "void gtk_icon_view_scroll_to_path(GtkIconView* icon_view, GtkTreePath* path, \
gboolean use_align, gfloat row_align, gfloat col_align)"
  s7_pointer _p;
  s7_pointer icon_view, path, use_align, row_align, col_align;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 2, path, "GtkTreePath*");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 3, use_align, "gboolean");
  row_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(row_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 4, row_align, "gfloat");
  col_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(col_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 5, col_align, "gfloat");
  gtk_icon_view_scroll_to_path(s7_c_pointer(icon_view), s7_c_pointer(path), lg_boolean(use_align), s7_real(row_align), s7_real(col_align));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_enable_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_enable_model_drag_source "void gtk_icon_view_enable_model_drag_source(GtkIconView* icon_view, \
GdkModifierType start_button_mask, GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer icon_view, start_button_mask, targets, n_targets, actions;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 1, icon_view, "GtkIconView*");
  start_button_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_button_mask)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 2, start_button_mask, "GdkModifierType");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 3, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 4, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 5, actions, "GdkDragAction");
  gtk_icon_view_enable_model_drag_source(s7_c_pointer(icon_view), s7_integer(start_button_mask), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_enable_model_drag_dest(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_enable_model_drag_dest "void gtk_icon_view_enable_model_drag_dest(GtkIconView* icon_view, \
GtkTargetEntry* targets, gint n_targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer icon_view, targets, n_targets, actions;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_dest", 1, icon_view, "GtkIconView*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_dest", 2, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_dest", 3, n_targets, "gint");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_dest", 4, actions, "GdkDragAction");
  gtk_icon_view_enable_model_drag_dest(s7_c_pointer(icon_view), s7_c_pointer(targets), s7_integer(n_targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unset_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unset_model_drag_source "void gtk_icon_view_unset_model_drag_source(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unset_model_drag_source", 1, icon_view, "GtkIconView*");
  gtk_icon_view_unset_model_drag_source(s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unset_model_drag_dest(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unset_model_drag_dest "void gtk_icon_view_unset_model_drag_dest(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unset_model_drag_dest", 1, icon_view, "GtkIconView*");
  gtk_icon_view_unset_model_drag_dest(s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_reorderable "void gtk_icon_view_set_reorderable(GtkIconView* icon_view, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer icon_view, reorderable;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_reorderable", 1, icon_view, "GtkIconView*");
  reorderable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_reorderable", 2, reorderable, "gboolean");
  gtk_icon_view_set_reorderable(s7_c_pointer(icon_view), lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_reorderable "gboolean gtk_icon_view_get_reorderable(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_reorderable", 1, icon_view, "GtkIconView*");
  return(s7_make_boolean(sc, gtk_icon_view_get_reorderable(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_drag_dest_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_drag_dest_item "void gtk_icon_view_set_drag_dest_item(GtkIconView* icon_view, \
GtkTreePath* path, GtkIconViewDropPosition pos)"
  s7_pointer _p;
  s7_pointer icon_view, path, pos;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_drag_dest_item", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_drag_dest_item", 2, path, "GtkTreePath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_drag_dest_item", 3, pos, "GtkIconViewDropPosition");
  gtk_icon_view_set_drag_dest_item(s7_c_pointer(icon_view), s7_c_pointer(path), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_drag_dest_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_drag_dest_item "void gtk_icon_view_get_drag_dest_item(GtkIconView* icon_view, \
GtkTreePath** [path], GtkIconViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer icon_view;
  GtkTreePath* ref_path = NULL;
  GtkIconViewDropPosition ref_pos;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_drag_dest_item", 1, icon_view, "GtkIconView*");
  gtk_icon_view_get_drag_dest_item(s7_c_pointer(icon_view), &ref_path, &ref_pos);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
}

static s7_pointer lg_gtk_icon_view_get_dest_item_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_dest_item_at_pos "gboolean gtk_icon_view_get_dest_item_at_pos(GtkIconView* icon_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkIconViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer icon_view, drag_x, drag_y;
  GtkTreePath* ref_path = NULL;
  GtkIconViewDropPosition ref_pos;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 1, icon_view, "GtkIconView*");
  drag_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 2, drag_x, "gint");
  drag_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 3, drag_y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_icon_view_get_dest_item_at_pos(s7_c_pointer(icon_view), s7_integer(drag_x), s7_integer(drag_y), &ref_path, &ref_pos));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
   }
}

static s7_pointer lg_gtk_image_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_clear "void gtk_image_clear(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_clear", 1, image, "GtkImage*");
  gtk_image_clear(s7_c_pointer(image));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_bar_get_pack_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_get_pack_direction "GtkPackDirection gtk_menu_bar_get_pack_direction(GtkMenuBar* menubar)"
  s7_pointer menubar;
  menubar = s7_car(args);
  if (!s7_is_c_pointer_of_type(menubar, GtkMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_get_pack_direction", 1, menubar, "GtkMenuBar*");
  return(s7_make_integer(sc, gtk_menu_bar_get_pack_direction(s7_c_pointer(menubar))));
}

static s7_pointer lg_gtk_menu_bar_set_pack_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_set_pack_direction "void gtk_menu_bar_set_pack_direction(GtkMenuBar* menubar, \
GtkPackDirection pack_dir)"
  s7_pointer _p;
  s7_pointer menubar, pack_dir;
  _p = args;
  menubar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menubar, GtkMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_set_pack_direction", 1, menubar, "GtkMenuBar*");
  pack_dir = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pack_dir)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_set_pack_direction", 2, pack_dir, "GtkPackDirection");
  gtk_menu_bar_set_pack_direction(s7_c_pointer(menubar), s7_integer(pack_dir));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_bar_get_child_pack_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_get_child_pack_direction "GtkPackDirection gtk_menu_bar_get_child_pack_direction(GtkMenuBar* menubar)"
  s7_pointer menubar;
  menubar = s7_car(args);
  if (!s7_is_c_pointer_of_type(menubar, GtkMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_get_child_pack_direction", 1, menubar, "GtkMenuBar*");
  return(s7_make_integer(sc, gtk_menu_bar_get_child_pack_direction(s7_c_pointer(menubar))));
}

static s7_pointer lg_gtk_menu_bar_set_child_pack_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_set_child_pack_direction "void gtk_menu_bar_set_child_pack_direction(GtkMenuBar* menubar, \
GtkPackDirection child_pack_dir)"
  s7_pointer _p;
  s7_pointer menubar, child_pack_dir;
  _p = args;
  menubar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menubar, GtkMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_set_child_pack_direction", 1, menubar, "GtkMenuBar*");
  child_pack_dir = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(child_pack_dir)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_set_child_pack_direction", 2, child_pack_dir, "GtkPackDirection");
  gtk_menu_bar_set_child_pack_direction(s7_c_pointer(menubar), s7_integer(child_pack_dir));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_get_take_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_get_take_focus "gboolean gtk_menu_shell_get_take_focus(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_get_take_focus", 1, menu_shell, "GtkMenuShell*");
  return(s7_make_boolean(sc, gtk_menu_shell_get_take_focus(s7_c_pointer(menu_shell))));
}

static s7_pointer lg_gtk_menu_shell_set_take_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_set_take_focus "void gtk_menu_shell_set_take_focus(GtkMenuShell* menu_shell, \
gboolean take_focus)"
  s7_pointer _p;
  s7_pointer menu_shell, take_focus;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_set_take_focus", 1, menu_shell, "GtkMenuShell*");
  take_focus = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(take_focus)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_set_take_focus", 2, take_focus, "gboolean");
  gtk_menu_shell_set_take_focus(s7_c_pointer(menu_shell), lg_boolean(take_focus));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_visible_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_visible_line "gboolean gtk_text_iter_forward_visible_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_visible_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_visible_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_visible_line "gboolean gtk_text_iter_backward_visible_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_visible_line(s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_visible_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_visible_lines "gboolean gtk_text_iter_forward_visible_lines(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_visible_lines(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_visible_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_visible_lines "gboolean gtk_text_iter_backward_visible_lines(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_visible_lines(s7_c_pointer(iter), s7_integer(count))));
}

static s7_pointer lg_gtk_tool_button_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_set_icon_name "void gtk_tool_button_set_icon_name(GtkToolButton* button, \
gchar* icon_name)"
  s7_pointer _p;
  s7_pointer button, icon_name;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_icon_name", 1, button, "GtkToolButton*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_tool_button_set_icon_name", 2, icon_name, "gchar*");
  gtk_tool_button_set_icon_name(s7_c_pointer(button), (const gchar*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_button_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_button_get_icon_name "gchar* gtk_tool_button_get_icon_name(GtkToolButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_button_get_icon_name", 1, button, "GtkToolButton*");
    return(s7_make_string(sc, (gchar*)gtk_tool_button_get_icon_name(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_window_set_urgency_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_urgency_hint "void gtk_window_set_urgency_hint(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_urgency_hint", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_urgency_hint", 2, setting, "gboolean");
  gtk_window_set_urgency_hint(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_urgency_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_urgency_hint "gboolean gtk_window_get_urgency_hint(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_urgency_hint", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_urgency_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_present_with_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_present_with_time "void gtk_window_present_with_time(GtkWindow* window, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_present_with_time", 1, window, "GtkWindow*");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_window_present_with_time", 2, timestamp, "guint32");
  gtk_window_present_with_time(s7_c_pointer(window), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_do_overwrite_confirmation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_do_overwrite_confirmation "void gtk_file_chooser_set_do_overwrite_confirmation(GtkFileChooser* chooser, \
gboolean do_overwrite_confirmation)"
  s7_pointer _p;
  s7_pointer chooser, do_overwrite_confirmation;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_do_overwrite_confirmation", 1, chooser, "GtkFileChooser*");
  do_overwrite_confirmation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(do_overwrite_confirmation)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_do_overwrite_confirmation", 2, do_overwrite_confirmation, "gboolean");
  gtk_file_chooser_set_do_overwrite_confirmation(s7_c_pointer(chooser), lg_boolean(do_overwrite_confirmation));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_do_overwrite_confirmation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_do_overwrite_confirmation "gboolean gtk_file_chooser_get_do_overwrite_confirmation(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_do_overwrite_confirmation", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_do_overwrite_confirmation(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_tree_row_reference_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_get_model "GtkTreeModel* gtk_tree_row_reference_get_model(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_get_model", 1, reference, "GtkTreeRowReference*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_tree_row_reference_get_model(s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_view_column_queue_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_queue_resize "void gtk_tree_view_column_queue_resize(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_queue_resize", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_queue_resize(s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_visible_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_visible_range "gboolean gtk_tree_view_get_visible_range(GtkTreeView* tree_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  s7_pointer _p;
  s7_pointer tree_view;
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_range", 1, tree_view, "GtkTreeView*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_get_visible_range(s7_c_pointer(tree_view), &ref_start_path, &ref_end_path));
      return(s7_list(sc, 3, result, s7_make_c_pointer(sc, ref_start_path), s7_make_c_pointer(sc, ref_end_path)));
   }
}

static s7_pointer lg_gtk_text_attributes_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_attributes_ref "GtkTextAttributes* gtk_text_attributes_ref(GtkTextAttributes* values)"
  s7_pointer values;
  values = s7_car(args);
  if (!s7_is_c_pointer_of_type(values, GtkTextAttributes__sym)) s7_wrong_type_arg_error(sc, "gtk_text_attributes_ref", 1, values, "GtkTextAttributes*");
  return(s7_make_type_with_c_pointer(sc, GtkTextAttributes__sym, gtk_text_attributes_ref(s7_c_pointer(values))));
}

static s7_pointer lg_pango_attr_list_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_ref "PangoAttrList* pango_attr_list_ref(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_ref", 1, list, "PangoAttrList*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, pango_attr_list_ref(s7_c_pointer(list))));
}

static s7_pointer lg_pango_layout_line_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_ref "PangoLayoutLine* pango_layout_line_ref(PangoLayoutLine* line)"
  s7_pointer line;
  line = s7_car(args);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_ref", 1, line, "PangoLayoutLine*");
  return(s7_make_type_with_c_pointer(sc, PangoLayoutLine__sym, pango_layout_line_ref(s7_c_pointer(line))));
}

static s7_pointer lg_pango_layout_index_to_line_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_index_to_line_x "void pango_layout_index_to_line_x(PangoLayout* layout, int index_, \
gboolean trailing, int* [line], int* [x_pos])"
  s7_pointer _p;
  s7_pointer layout, index_, trailing;
  int ref_line;
  int ref_x_pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 1, layout, "PangoLayout*");
  index_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index_)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 2, index_, "int");
  trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 3, trailing, "gboolean");
  pango_layout_index_to_line_x(s7_c_pointer(layout), s7_integer(index_), lg_boolean(trailing), &ref_line, &ref_x_pos);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_line), s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_gtk_target_list_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_ref "GtkTargetList* gtk_target_list_ref(GtkTargetList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_ref", 1, list, "GtkTargetList*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_target_list_ref(s7_c_pointer(list))));
}

static s7_pointer lg_gdk_display_supports_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_shapes "gboolean gdk_display_supports_shapes(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_shapes", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_shapes(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_supports_input_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_input_shapes "gboolean gdk_display_supports_input_shapes(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_input_shapes", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_input_shapes(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_screen_set_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_set_resolution "void gdk_screen_set_resolution(GdkScreen* screen, gdouble dpi)"
  s7_pointer _p;
  s7_pointer screen, dpi;
  _p = args;
  screen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gdk_screen_set_resolution", 1, screen, "GdkScreen*");
  dpi = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dpi)) s7_wrong_type_arg_error(sc, "gdk_screen_set_resolution", 2, dpi, "gdouble");
  gdk_screen_set_resolution(s7_c_pointer(screen), s7_real(dpi));
  return(lg_false);
}

static s7_pointer lg_gdk_screen_get_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_screen_get_resolution "gdouble gdk_screen_get_resolution(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gdk_screen_get_resolution", 1, screen, "GdkScreen*");
  return(s7_make_real(sc, gdk_screen_get_resolution(s7_c_pointer(screen))));
}

static s7_pointer lg_gdk_window_get_type_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_type_hint "GdkWindowTypeHint gdk_window_get_type_hint(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_type_hint", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_type_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_clipboard_request_rich_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_request_rich_text "void gtk_clipboard_request_rich_text(GtkClipboard* clipboard, \
GtkTextBuffer* buffer, GtkClipboardRichTextReceivedFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer clipboard, buffer, func, func_info;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_rich_text", 1, clipboard, "GtkClipboard*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_rich_text", 2, buffer, "GtkTextBuffer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkClipboardRichTextReceivedFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_rich_text", 3, func, "GtkClipboardRichTextReceivedFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_clipboard_request_rich_text", 4, func_info, "lambda_data");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_clipboard_request_rich_text(s7_c_pointer(clipboard), s7_c_pointer(buffer), s7_c_pointer(func), (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_clipboard_wait_for_rich_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_for_rich_text "guint8* gtk_clipboard_wait_for_rich_text(GtkClipboard* clipboard, \
GtkTextBuffer* buffer, GdkAtom* format, gsize* [length])"
  s7_pointer _p;
  s7_pointer clipboard, buffer, format;
  gsize ref_length;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_rich_text", 1, clipboard, "GtkClipboard*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_rich_text", 2, buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_for_rich_text", 3, format, "GdkAtom*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, guint8__sym, gtk_clipboard_wait_for_rich_text(s7_c_pointer(clipboard), s7_c_pointer(buffer), s7_c_pointer(format), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_clipboard_wait_is_rich_text_available(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_is_rich_text_available "gboolean gtk_clipboard_wait_is_rich_text_available(GtkClipboard* clipboard, \
GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer clipboard, buffer;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_rich_text_available", 1, clipboard, "GtkClipboard*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_rich_text_available", 2, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_clipboard_wait_is_rich_text_available(s7_c_pointer(clipboard), s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_drag_dest_set_track_motion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_set_track_motion "void gtk_drag_dest_set_track_motion(GtkWidget* widget, gboolean track_motion)"
  s7_pointer _p;
  s7_pointer widget, track_motion;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set_track_motion", 1, widget, "GtkWidget*");
  track_motion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(track_motion)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_set_track_motion", 2, track_motion, "gboolean");
  gtk_drag_dest_set_track_motion(s7_c_pointer(widget), lg_boolean(track_motion));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_dest_get_track_motion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_dest_get_track_motion "gboolean gtk_drag_dest_get_track_motion(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_dest_get_track_motion", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_drag_dest_get_track_motion(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_notebook_get_tab_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_reorderable "gboolean gtk_notebook_get_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_reorderable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_reorderable", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_notebook_get_tab_reorderable(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_reorderable "void gtk_notebook_set_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child, gboolean reorderable)"
  s7_pointer _p;
  s7_pointer notebook, child, reorderable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 2, child, "GtkWidget*");
  reorderable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 3, reorderable, "gboolean");
  gtk_notebook_set_tab_reorderable(s7_c_pointer(notebook), s7_c_pointer(child), lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_detachable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_detachable "gboolean gtk_notebook_get_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_detachable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_detachable", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_notebook_get_tab_detachable(s7_c_pointer(notebook), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_detachable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_detachable "void gtk_notebook_set_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child, gboolean detachable)"
  s7_pointer _p;
  s7_pointer notebook, child, detachable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 2, child, "GtkWidget*");
  detachable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(detachable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 3, detachable, "gboolean");
  gtk_notebook_set_tab_detachable(s7_c_pointer(notebook), s7_c_pointer(child), lg_boolean(detachable));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_lower_stepper_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_lower_stepper_sensitivity "void gtk_range_set_lower_stepper_sensitivity(GtkRange* range, \
GtkSensitivityType sensitivity)"
  s7_pointer _p;
  s7_pointer range, sensitivity;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_lower_stepper_sensitivity", 1, range, "GtkRange*");
  sensitivity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sensitivity)) s7_wrong_type_arg_error(sc, "gtk_range_set_lower_stepper_sensitivity", 2, sensitivity, "GtkSensitivityType");
  gtk_range_set_lower_stepper_sensitivity(s7_c_pointer(range), s7_integer(sensitivity));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_lower_stepper_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_lower_stepper_sensitivity "GtkSensitivityType gtk_range_get_lower_stepper_sensitivity(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_lower_stepper_sensitivity", 1, range, "GtkRange*");
  return(s7_make_integer(sc, gtk_range_get_lower_stepper_sensitivity(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_upper_stepper_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_upper_stepper_sensitivity "void gtk_range_set_upper_stepper_sensitivity(GtkRange* range, \
GtkSensitivityType sensitivity)"
  s7_pointer _p;
  s7_pointer range, sensitivity;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_upper_stepper_sensitivity", 1, range, "GtkRange*");
  sensitivity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sensitivity)) s7_wrong_type_arg_error(sc, "gtk_range_set_upper_stepper_sensitivity", 2, sensitivity, "GtkSensitivityType");
  gtk_range_set_upper_stepper_sensitivity(s7_c_pointer(range), s7_integer(sensitivity));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_upper_stepper_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_upper_stepper_sensitivity "GtkSensitivityType gtk_range_get_upper_stepper_sensitivity(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_upper_stepper_sensitivity", 1, range, "GtkRange*");
  return(s7_make_integer(sc, gtk_range_get_upper_stepper_sensitivity(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_scrolled_window_unset_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_unset_placement "void gtk_scrolled_window_unset_placement(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_unset_placement", 1, scrolled_window, "GtkScrolledWindow*");
  gtk_scrolled_window_unset_placement(s7_c_pointer(scrolled_window));
  return(lg_false);
}

static s7_pointer lg_gtk_target_list_add_rich_text_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_list_add_rich_text_targets "void gtk_target_list_add_rich_text_targets(GtkTargetList* list, \
guint info, gboolean deserializable, GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer list, info, deserializable, buffer;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_rich_text_targets", 1, list, "GtkTargetList*");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_rich_text_targets", 2, info, "guint");
  deserializable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(deserializable)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_rich_text_targets", 3, deserializable, "gboolean");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_target_list_add_rich_text_targets", 4, buffer, "GtkTextBuffer*");
  gtk_target_list_add_rich_text_targets(s7_c_pointer(list), s7_integer(info), lg_boolean(deserializable), s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_target_table_new_from_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_table_new_from_list "GtkTargetEntry* gtk_target_table_new_from_list(GtkTargetList* list, \
gint* [n_targets])"
  s7_pointer _p;
  s7_pointer list;
  gint ref_n_targets;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_target_table_new_from_list", 1, list, "GtkTargetList*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GtkTargetEntry__sym, gtk_target_table_new_from_list(s7_c_pointer(list), &ref_n_targets));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_n_targets)));
   }
}

static s7_pointer lg_gtk_target_table_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_table_free "void gtk_target_table_free(GtkTargetEntry* targets, gint n_targets)"
  s7_pointer _p;
  s7_pointer targets, n_targets;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_target_table_free", 1, targets, "GtkTargetEntry*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_target_table_free", 2, n_targets, "gint");
  gtk_target_table_free(s7_c_pointer(targets), s7_integer(n_targets));
  return(lg_false);
}

static s7_pointer lg_gtk_selection_data_targets_include_rich_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_targets_include_rich_text "gboolean gtk_selection_data_targets_include_rich_text(GtkSelectionData* selection_data, \
GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer selection_data, buffer;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_rich_text", 1, selection_data, "GtkSelectionData*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_rich_text", 2, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_selection_data_targets_include_rich_text(s7_c_pointer(selection_data), s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_selection_data_targets_include_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_targets_include_uri "gboolean gtk_selection_data_targets_include_uri(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_targets_include_uri", 1, selection_data, "GtkSelectionData*");
  return(s7_make_boolean(sc, gtk_selection_data_targets_include_uri(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_targets_include_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_targets_include_text "gboolean gtk_targets_include_text(GdkAtom* targets, gint n_targets)"
  s7_pointer _p;
  s7_pointer targets, n_targets;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GdkAtom__sym)) s7_wrong_type_arg_error(sc, "gtk_targets_include_text", 1, targets, "GdkAtom*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_targets_include_text", 2, n_targets, "gint");
  return(s7_make_boolean(sc, gtk_targets_include_text(s7_c_pointer(targets), s7_integer(n_targets))));
}

static s7_pointer lg_gtk_targets_include_rich_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_targets_include_rich_text "gboolean gtk_targets_include_rich_text(GdkAtom* targets, gint n_targets, \
GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer targets, n_targets, buffer;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GdkAtom__sym)) s7_wrong_type_arg_error(sc, "gtk_targets_include_rich_text", 1, targets, "GdkAtom*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_targets_include_rich_text", 2, n_targets, "gint");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_targets_include_rich_text", 3, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_targets_include_rich_text(s7_c_pointer(targets), s7_integer(n_targets), s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_targets_include_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_targets_include_image "gboolean gtk_targets_include_image(GdkAtom* targets, gint n_targets, \
gboolean writable)"
  s7_pointer _p;
  s7_pointer targets, n_targets, writable;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GdkAtom__sym)) s7_wrong_type_arg_error(sc, "gtk_targets_include_image", 1, targets, "GdkAtom*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_targets_include_image", 2, n_targets, "gint");
  writable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(writable)) s7_wrong_type_arg_error(sc, "gtk_targets_include_image", 3, writable, "gboolean");
  return(s7_make_boolean(sc, gtk_targets_include_image(s7_c_pointer(targets), s7_integer(n_targets), lg_boolean(writable))));
}

static s7_pointer lg_gtk_targets_include_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_targets_include_uri "gboolean gtk_targets_include_uri(GdkAtom* targets, gint n_targets)"
  s7_pointer _p;
  s7_pointer targets, n_targets;
  _p = args;
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GdkAtom__sym)) s7_wrong_type_arg_error(sc, "gtk_targets_include_uri", 1, targets, "GdkAtom*");
  n_targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_targets)) s7_wrong_type_arg_error(sc, "gtk_targets_include_uri", 2, n_targets, "gint");
  return(s7_make_boolean(sc, gtk_targets_include_uri(s7_c_pointer(targets), s7_integer(n_targets))));
}

static s7_pointer lg_gtk_size_group_get_widgets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_get_widgets "GSList* gtk_size_group_get_widgets(GtkSizeGroup* size_group)"
  s7_pointer size_group;
  size_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_get_widgets", 1, size_group, "GtkSizeGroup*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_size_group_get_widgets(s7_c_pointer(size_group))));
}

static s7_pointer lg_gtk_text_buffer_get_has_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_has_selection "gboolean gtk_text_buffer_get_has_selection(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_has_selection", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_has_selection(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_copy_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_copy_target_list "GtkTargetList* gtk_text_buffer_get_copy_target_list(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_copy_target_list", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_text_buffer_get_copy_target_list(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_paste_target_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_paste_target_list "GtkTargetList* gtk_text_buffer_get_paste_target_list(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_paste_target_list", 1, buffer, "GtkTextBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetList__sym, gtk_text_buffer_get_paste_target_list(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_tree_view_get_headers_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_headers_clickable "gboolean gtk_tree_view_get_headers_clickable(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_headers_clickable", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_headers_clickable(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_get_search_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_entry "GtkEntry* gtk_tree_view_get_search_entry(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_entry", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkEntry__sym, gtk_tree_view_get_search_entry(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_entry "void gtk_tree_view_set_search_entry(GtkTreeView* tree_view, \
GtkEntry* entry)"
  s7_pointer _p;
  s7_pointer tree_view, entry;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_entry", 1, tree_view, "GtkTreeView*");
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_entry", 2, entry, "GtkEntry*");
  gtk_tree_view_set_search_entry(s7_c_pointer(tree_view), s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_search_position_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_position_func "GtkTreeViewSearchPositionFunc gtk_tree_view_get_search_position_func(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_position_func", 1, tree_view, "GtkTreeView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewSearchPositionFunc_sym, gtk_tree_view_get_search_position_func(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_position_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_position_func "void gtk_tree_view_set_search_position_func(GtkTreeView* tree_view, \
GtkTreeViewSearchPositionFunc func, lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_position_func", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkTreeViewSearchPositionFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_position_func", 2, func, "GtkTreeViewSearchPositionFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_position_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_position_func", 4, destroy, "GDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_tree_view_set_search_position_func(s7_c_pointer(tree_view), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_window_set_deletable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_deletable "void gtk_window_set_deletable(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_deletable", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_deletable", 2, setting, "gboolean");
  gtk_window_set_deletable(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_deletable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_deletable "gboolean gtk_window_get_deletable(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_deletable", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_deletable(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_assistant_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_new "GtkWidget* gtk_assistant_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_assistant_new()));
}

static s7_pointer lg_gtk_assistant_get_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_current_page "gint gtk_assistant_get_current_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_current_page", 1, assistant, "GtkAssistant*");
  return(s7_make_integer(sc, gtk_assistant_get_current_page(s7_c_pointer(assistant))));
}

static s7_pointer lg_gtk_assistant_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_current_page "void gtk_assistant_set_current_page(GtkAssistant* assistant, \
gint page_num)"
  s7_pointer _p;
  s7_pointer assistant, page_num;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_current_page", 1, assistant, "GtkAssistant*");
  page_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_current_page", 2, page_num, "gint");
  gtk_assistant_set_current_page(s7_c_pointer(assistant), s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_n_pages "gint gtk_assistant_get_n_pages(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_n_pages", 1, assistant, "GtkAssistant*");
  return(s7_make_integer(sc, gtk_assistant_get_n_pages(s7_c_pointer(assistant))));
}

static s7_pointer lg_gtk_assistant_get_nth_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_nth_page "GtkWidget* gtk_assistant_get_nth_page(GtkAssistant* assistant, \
gint page_num)"
  s7_pointer _p;
  s7_pointer assistant, page_num;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_nth_page", 1, assistant, "GtkAssistant*");
  page_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_nth_page", 2, page_num, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_assistant_get_nth_page(s7_c_pointer(assistant), s7_integer(page_num))));
}

static s7_pointer lg_gtk_assistant_prepend_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_prepend_page "gint gtk_assistant_prepend_page(GtkAssistant* assistant, GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_prepend_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_prepend_page", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_prepend_page(s7_c_pointer(assistant), s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_append_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_append_page "gint gtk_assistant_append_page(GtkAssistant* assistant, GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_append_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_append_page", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_append_page(s7_c_pointer(assistant), s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_insert_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_insert_page "gint gtk_assistant_insert_page(GtkAssistant* assistant, GtkWidget* page, \
gint position)"
  s7_pointer _p;
  s7_pointer assistant, page, position;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 2, page, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 3, position, "gint");
  return(s7_make_integer(sc, gtk_assistant_insert_page(s7_c_pointer(assistant), s7_c_pointer(page), s7_integer(position))));
}

static s7_pointer lg_gtk_assistant_set_forward_page_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_forward_page_func "void gtk_assistant_set_forward_page_func(GtkAssistant* assistant, \
GtkAssistantPageFunc page_func, lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer assistant, page_func, func_info, destroy;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_forward_page_func", 1, assistant, "GtkAssistant*");
  page_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_func, GtkAssistantPageFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_forward_page_func", 2, page_func, "GtkAssistantPageFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_forward_page_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_forward_page_func", 4, destroy, "GDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_assistant_set_forward_page_func(s7_c_pointer(assistant), s7_c_pointer(page_func), (gpointer)lg_ptr, s7_c_pointer(destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_assistant_set_page_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_type "void gtk_assistant_set_page_type(GtkAssistant* assistant, GtkWidget* page, \
GtkAssistantPageType type)"
  s7_pointer _p;
  s7_pointer assistant, page, type;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 2, page, "GtkWidget*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 3, type, "GtkAssistantPageType");
  gtk_assistant_set_page_type(s7_c_pointer(assistant), s7_c_pointer(page), s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_type "GtkAssistantPageType gtk_assistant_get_page_type(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_type", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_type", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_get_page_type(s7_c_pointer(assistant), s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_set_page_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_title "void gtk_assistant_set_page_title(GtkAssistant* assistant, \
GtkWidget* page, gchar* title)"
  s7_pointer _p;
  s7_pointer assistant, page, title;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 2, page, "GtkWidget*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 3, title, "gchar*");
  gtk_assistant_set_page_title(s7_c_pointer(assistant), s7_c_pointer(page), s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_title "gchar* gtk_assistant_get_page_title(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_title", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_title", 2, page, "GtkWidget*");
  return(s7_make_string(sc, gtk_assistant_get_page_title(s7_c_pointer(assistant), s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_set_page_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_complete "void gtk_assistant_set_page_complete(GtkAssistant* assistant, \
GtkWidget* page, gboolean complete)"
  s7_pointer _p;
  s7_pointer assistant, page, complete;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 2, page, "GtkWidget*");
  complete = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(complete)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 3, complete, "gboolean");
  gtk_assistant_set_page_complete(s7_c_pointer(assistant), s7_c_pointer(page), lg_boolean(complete));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_complete "gboolean gtk_assistant_get_page_complete(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_complete", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_complete", 2, page, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_assistant_get_page_complete(s7_c_pointer(assistant), s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_add_action_widget "void gtk_assistant_add_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer assistant, child;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_add_action_widget", 1, assistant, "GtkAssistant*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_add_action_widget", 2, child, "GtkWidget*");
  gtk_assistant_add_action_widget(s7_c_pointer(assistant), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_remove_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_remove_action_widget "void gtk_assistant_remove_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer assistant, child;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_remove_action_widget", 1, assistant, "GtkAssistant*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_remove_action_widget", 2, child, "GtkWidget*");
  gtk_assistant_remove_action_widget(s7_c_pointer(assistant), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_update_buttons_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_update_buttons_state "void gtk_assistant_update_buttons_state(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_update_buttons_state", 1, assistant, "GtkAssistant*");
  gtk_assistant_update_buttons_state(s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_accel_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_accel_new "GtkCellRenderer* gtk_cell_renderer_accel_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_accel_new()));
}

static s7_pointer lg_gtk_cell_renderer_spin_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_spin_new "GtkCellRenderer* gtk_cell_renderer_spin_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_spin_new()));
}

static s7_pointer lg_gtk_link_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_new "GtkWidget* gtk_link_button_new(gchar* uri)"
  s7_pointer uri;
  uri = s7_car(args);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_new", 1, uri, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_link_button_new(s7_string(uri))));
}

static s7_pointer lg_gtk_link_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_new_with_label "GtkWidget* gtk_link_button_new_with_label(gchar* uri, gchar* label)"
  s7_pointer _p;
  s7_pointer uri, label;
  _p = args;
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_new_with_label", 1, uri, "gchar*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_link_button_new_with_label", 2, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_link_button_new_with_label(s7_string(uri), s7_string(label))));
}

static s7_pointer lg_gtk_link_button_get_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_get_uri "gchar* gtk_link_button_get_uri(GtkLinkButton* link_button)"
  s7_pointer link_button;
  link_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_get_uri", 1, link_button, "GtkLinkButton*");
  return(s7_make_string(sc, gtk_link_button_get_uri(s7_c_pointer(link_button))));
}

static s7_pointer lg_gtk_link_button_set_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_set_uri "void gtk_link_button_set_uri(GtkLinkButton* link_button, gchar* uri)"
  s7_pointer _p;
  s7_pointer link_button, uri;
  _p = args;
  link_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_uri", 1, link_button, "GtkLinkButton*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_uri", 2, uri, "gchar*");
  gtk_link_button_set_uri(s7_c_pointer(link_button), s7_string(uri));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_error_quark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_error_quark "GQuark gtk_recent_chooser_error_quark( void)"
  return(s7_make_integer(sc, gtk_recent_chooser_error_quark()));
}

static s7_pointer lg_gtk_recent_chooser_set_show_private(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_show_private "void gtk_recent_chooser_set_show_private(GtkRecentChooser* chooser, \
gboolean show_private)"
  s7_pointer _p;
  s7_pointer chooser, show_private;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_private", 1, chooser, "GtkRecentChooser*");
  show_private = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_private)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_private", 2, show_private, "gboolean");
  gtk_recent_chooser_set_show_private(s7_c_pointer(chooser), lg_boolean(show_private));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_show_private(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_show_private "gboolean gtk_recent_chooser_get_show_private(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_show_private", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_show_private(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_show_not_found(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_show_not_found "void gtk_recent_chooser_set_show_not_found(GtkRecentChooser* chooser, \
gboolean show_not_found)"
  s7_pointer _p;
  s7_pointer chooser, show_not_found;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_not_found", 1, chooser, "GtkRecentChooser*");
  show_not_found = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_not_found)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_not_found", 2, show_not_found, "gboolean");
  gtk_recent_chooser_set_show_not_found(s7_c_pointer(chooser), lg_boolean(show_not_found));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_show_not_found(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_show_not_found "gboolean gtk_recent_chooser_get_show_not_found(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_show_not_found", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_show_not_found(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_select_multiple "void gtk_recent_chooser_set_select_multiple(GtkRecentChooser* chooser, \
gboolean select_multiple)"
  s7_pointer _p;
  s7_pointer chooser, select_multiple;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_select_multiple", 1, chooser, "GtkRecentChooser*");
  select_multiple = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(select_multiple)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_select_multiple", 2, select_multiple, "gboolean");
  gtk_recent_chooser_set_select_multiple(s7_c_pointer(chooser), lg_boolean(select_multiple));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_select_multiple "gboolean gtk_recent_chooser_get_select_multiple(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_select_multiple", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_select_multiple(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_limit "void gtk_recent_chooser_set_limit(GtkRecentChooser* chooser, \
gint limit)"
  s7_pointer _p;
  s7_pointer chooser, limit;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_limit", 1, chooser, "GtkRecentChooser*");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(limit)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_limit", 2, limit, "gint");
  gtk_recent_chooser_set_limit(s7_c_pointer(chooser), s7_integer(limit));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_limit "gint gtk_recent_chooser_get_limit(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_limit", 1, chooser, "GtkRecentChooser*");
  return(s7_make_integer(sc, gtk_recent_chooser_get_limit(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_local_only "void gtk_recent_chooser_set_local_only(GtkRecentChooser* chooser, \
gboolean local_only)"
  s7_pointer _p;
  s7_pointer chooser, local_only;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_local_only", 1, chooser, "GtkRecentChooser*");
  local_only = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(local_only)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_local_only", 2, local_only, "gboolean");
  gtk_recent_chooser_set_local_only(s7_c_pointer(chooser), lg_boolean(local_only));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_local_only "gboolean gtk_recent_chooser_get_local_only(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_local_only", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_local_only(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_show_tips(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_show_tips "void gtk_recent_chooser_set_show_tips(GtkRecentChooser* chooser, \
gboolean show_tips)"
  s7_pointer _p;
  s7_pointer chooser, show_tips;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_tips", 1, chooser, "GtkRecentChooser*");
  show_tips = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_tips)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_tips", 2, show_tips, "gboolean");
  gtk_recent_chooser_set_show_tips(s7_c_pointer(chooser), lg_boolean(show_tips));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_show_tips(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_show_tips "gboolean gtk_recent_chooser_get_show_tips(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_show_tips", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_show_tips(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_show_icons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_show_icons "void gtk_recent_chooser_set_show_icons(GtkRecentChooser* chooser, \
gboolean show_icons)"
  s7_pointer _p;
  s7_pointer chooser, show_icons;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_icons", 1, chooser, "GtkRecentChooser*");
  show_icons = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_icons)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_show_icons", 2, show_icons, "gboolean");
  gtk_recent_chooser_set_show_icons(s7_c_pointer(chooser), lg_boolean(show_icons));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_show_icons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_show_icons "gboolean gtk_recent_chooser_get_show_icons(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_show_icons", 1, chooser, "GtkRecentChooser*");
  return(s7_make_boolean(sc, gtk_recent_chooser_get_show_icons(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_sort_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_sort_type "void gtk_recent_chooser_set_sort_type(GtkRecentChooser* chooser, \
GtkRecentSortType sort_type)"
  s7_pointer _p;
  s7_pointer chooser, sort_type;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_type", 1, chooser, "GtkRecentChooser*");
  sort_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_type)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_type", 2, sort_type, "GtkRecentSortType");
  gtk_recent_chooser_set_sort_type(s7_c_pointer(chooser), s7_integer(sort_type));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_sort_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_sort_type "GtkRecentSortType gtk_recent_chooser_get_sort_type(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_sort_type", 1, chooser, "GtkRecentChooser*");
  return(s7_make_integer(sc, gtk_recent_chooser_get_sort_type(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_sort_func "void gtk_recent_chooser_set_sort_func(GtkRecentChooser* chooser, \
GtkRecentSortFunc func, lambda_data func_info, GDestroyNotify data_destroy)"
  s7_pointer _p;
  s7_pointer chooser, func, func_info, data_destroy;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_func", 1, chooser, "GtkRecentChooser*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkRecentSortFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_func", 2, func, "GtkRecentSortFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_func", 3, func_info, "lambda_data");
  data_destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data_destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_sort_func", 4, data_destroy, "GDestroyNotify");
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_recent_chooser_set_sort_func(s7_c_pointer(chooser), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(data_destroy));
    return(lg_false);
   }
}

static s7_pointer lg_gtk_recent_chooser_set_current_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_current_uri "gboolean gtk_recent_chooser_set_current_uri(GtkRecentChooser* chooser, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, uri;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_current_uri", 1, chooser, "GtkRecentChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_current_uri", 2, uri, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_recent_chooser_set_current_uri(s7_c_pointer(chooser), s7_string(uri), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_chooser_get_current_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_current_uri "gchar* gtk_recent_chooser_get_current_uri(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_current_uri", 1, chooser, "GtkRecentChooser*");
  return(s7_make_string(sc, gtk_recent_chooser_get_current_uri(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_get_current_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_current_item "GtkRecentInfo* gtk_recent_chooser_get_current_item(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_current_item", 1, chooser, "GtkRecentChooser*");
  return(s7_make_type_with_c_pointer(sc, GtkRecentInfo__sym, gtk_recent_chooser_get_current_item(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_select_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_select_uri "gboolean gtk_recent_chooser_select_uri(GtkRecentChooser* chooser, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, uri;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_select_uri", 1, chooser, "GtkRecentChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_select_uri", 2, uri, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_recent_chooser_select_uri(s7_c_pointer(chooser), s7_string(uri), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_chooser_unselect_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_unselect_uri "void gtk_recent_chooser_unselect_uri(GtkRecentChooser* chooser, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer chooser, uri;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_unselect_uri", 1, chooser, "GtkRecentChooser*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_unselect_uri", 2, uri, "gchar*");
  gtk_recent_chooser_unselect_uri(s7_c_pointer(chooser), s7_string(uri));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_select_all "void gtk_recent_chooser_select_all(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_select_all", 1, chooser, "GtkRecentChooser*");
  gtk_recent_chooser_select_all(s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_unselect_all "void gtk_recent_chooser_unselect_all(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_unselect_all", 1, chooser, "GtkRecentChooser*");
  gtk_recent_chooser_unselect_all(s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_items "GList* gtk_recent_chooser_get_items(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_items", 1, chooser, "GtkRecentChooser*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_recent_chooser_get_items(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_get_uris(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_uris "gchar** gtk_recent_chooser_get_uris(GtkRecentChooser* chooser, \
gsize* [length])"
  s7_pointer _p;
  s7_pointer chooser;
  gsize ref_length;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_uris", 1, chooser, "GtkRecentChooser*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, gchar___sym, gtk_recent_chooser_get_uris(s7_c_pointer(chooser), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_recent_chooser_add_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_add_filter "void gtk_recent_chooser_add_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_add_filter", 1, chooser, "GtkRecentChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_add_filter", 2, filter, "GtkRecentFilter*");
  gtk_recent_chooser_add_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_remove_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_remove_filter "void gtk_recent_chooser_remove_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_remove_filter", 1, chooser, "GtkRecentChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_remove_filter", 2, filter, "GtkRecentFilter*");
  gtk_recent_chooser_remove_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_list_filters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_list_filters "GSList* gtk_recent_chooser_list_filters(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_list_filters", 1, chooser, "GtkRecentChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_recent_chooser_list_filters(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_set_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_set_filter "void gtk_recent_chooser_set_filter(GtkRecentChooser* chooser, \
GtkRecentFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_filter", 1, chooser, "GtkRecentChooser*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_set_filter", 2, filter, "GtkRecentFilter*");
  gtk_recent_chooser_set_filter(s7_c_pointer(chooser), s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_get_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_get_filter "GtkRecentFilter* gtk_recent_chooser_get_filter(GtkRecentChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkRecentChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_get_filter", 1, chooser, "GtkRecentChooser*");
  return(s7_make_type_with_c_pointer(sc, GtkRecentFilter__sym, gtk_recent_chooser_get_filter(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_recent_chooser_menu_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_menu_new "GtkWidget* gtk_recent_chooser_menu_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_recent_chooser_menu_new()));
}

static s7_pointer lg_gtk_recent_chooser_menu_new_for_manager(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_menu_new_for_manager "GtkWidget* gtk_recent_chooser_menu_new_for_manager(GtkRecentManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_menu_new_for_manager", 1, manager, "GtkRecentManager*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_recent_chooser_menu_new_for_manager(s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_recent_chooser_menu_get_show_numbers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_menu_get_show_numbers "gboolean gtk_recent_chooser_menu_get_show_numbers(GtkRecentChooserMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkRecentChooserMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_menu_get_show_numbers", 1, menu, "GtkRecentChooserMenu*");
  return(s7_make_boolean(sc, gtk_recent_chooser_menu_get_show_numbers(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_recent_chooser_menu_set_show_numbers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_menu_set_show_numbers "void gtk_recent_chooser_menu_set_show_numbers(GtkRecentChooserMenu* menu, \
gboolean show_numbers)"
  s7_pointer _p;
  s7_pointer menu, show_numbers;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkRecentChooserMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_menu_set_show_numbers", 1, menu, "GtkRecentChooserMenu*");
  show_numbers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_numbers)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_menu_set_show_numbers", 2, show_numbers, "gboolean");
  gtk_recent_chooser_menu_set_show_numbers(s7_c_pointer(menu), lg_boolean(show_numbers));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_widget_new "GtkWidget* gtk_recent_chooser_widget_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_recent_chooser_widget_new()));
}

static s7_pointer lg_gtk_recent_chooser_widget_new_for_manager(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_chooser_widget_new_for_manager "GtkWidget* gtk_recent_chooser_widget_new_for_manager(GtkRecentManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_chooser_widget_new_for_manager", 1, manager, "GtkRecentManager*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_recent_chooser_widget_new_for_manager(s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_recent_filter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_new "GtkRecentFilter* gtk_recent_filter_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkRecentFilter__sym, gtk_recent_filter_new()));
}

static s7_pointer lg_gtk_recent_filter_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_set_name "void gtk_recent_filter_set_name(GtkRecentFilter* filter, gchar* name)"
  s7_pointer _p;
  s7_pointer filter, name;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_set_name", 1, filter, "GtkRecentFilter*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_set_name", 2, name, "gchar*");
  gtk_recent_filter_set_name(s7_c_pointer(filter), s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_get_name "gchar* gtk_recent_filter_get_name(GtkRecentFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_get_name", 1, filter, "GtkRecentFilter*");
    return(s7_make_string(sc, (gchar*)gtk_recent_filter_get_name(s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_recent_filter_add_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_mime_type "void gtk_recent_filter_add_mime_type(GtkRecentFilter* filter, \
gchar* mime_type)"
  s7_pointer _p;
  s7_pointer filter, mime_type;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_mime_type", 1, filter, "GtkRecentFilter*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_mime_type", 2, mime_type, "gchar*");
  gtk_recent_filter_add_mime_type(s7_c_pointer(filter), s7_string(mime_type));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_add_pattern(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_pattern "void gtk_recent_filter_add_pattern(GtkRecentFilter* filter, \
gchar* pattern)"
  s7_pointer _p;
  s7_pointer filter, pattern;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_pattern", 1, filter, "GtkRecentFilter*");
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(pattern)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_pattern", 2, pattern, "gchar*");
  gtk_recent_filter_add_pattern(s7_c_pointer(filter), s7_string(pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_add_pixbuf_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_pixbuf_formats "void gtk_recent_filter_add_pixbuf_formats(GtkRecentFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_pixbuf_formats", 1, filter, "GtkRecentFilter*");
  gtk_recent_filter_add_pixbuf_formats(s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_add_application(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_application "void gtk_recent_filter_add_application(GtkRecentFilter* filter, \
gchar* application)"
  s7_pointer _p;
  s7_pointer filter, application;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_application", 1, filter, "GtkRecentFilter*");
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(application)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_application", 2, application, "gchar*");
  gtk_recent_filter_add_application(s7_c_pointer(filter), s7_string(application));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_add_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_group "void gtk_recent_filter_add_group(GtkRecentFilter* filter, gchar* group)"
  s7_pointer _p;
  s7_pointer filter, group;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_group", 1, filter, "GtkRecentFilter*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(group)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_group", 2, group, "gchar*");
  gtk_recent_filter_add_group(s7_c_pointer(filter), s7_string(group));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_filter_add_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_filter_add_age "void gtk_recent_filter_add_age(GtkRecentFilter* filter, gint days)"
  s7_pointer _p;
  s7_pointer filter, days;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkRecentFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_age", 1, filter, "GtkRecentFilter*");
  days = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(days)) s7_wrong_type_arg_error(sc, "gtk_recent_filter_add_age", 2, days, "gint");
  gtk_recent_filter_add_age(s7_c_pointer(filter), s7_integer(days));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_manager_error_quark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_error_quark "GQuark gtk_recent_manager_error_quark( void)"
  return(s7_make_integer(sc, gtk_recent_manager_error_quark()));
}

static s7_pointer lg_gtk_recent_manager_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_new "GtkRecentManager* gtk_recent_manager_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkRecentManager__sym, gtk_recent_manager_new()));
}

static s7_pointer lg_gtk_recent_manager_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_get_default "GtkRecentManager* gtk_recent_manager_get_default( void)"
  return(s7_make_type_with_c_pointer(sc, GtkRecentManager__sym, gtk_recent_manager_get_default()));
}

static s7_pointer lg_gtk_recent_manager_remove_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_remove_item "gboolean gtk_recent_manager_remove_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_remove_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_remove_item", 2, uri, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_recent_manager_remove_item(s7_c_pointer(manager), s7_string(uri), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_lookup_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_lookup_item "GtkRecentInfo* gtk_recent_manager_lookup_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_lookup_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_lookup_item", 2, uri, "gchar*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GtkRecentInfo__sym, gtk_recent_manager_lookup_item(s7_c_pointer(manager), s7_string(uri), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_has_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_has_item "gboolean gtk_recent_manager_has_item(GtkRecentManager* manager, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer manager, uri;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_has_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_has_item", 2, uri, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_manager_has_item(s7_c_pointer(manager), s7_string(uri))));
}

static s7_pointer lg_gtk_recent_manager_move_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_move_item "gboolean gtk_recent_manager_move_item(GtkRecentManager* manager, \
gchar* uri, gchar* new_uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri, new_uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 2, uri, "gchar*");
  new_uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(new_uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 3, new_uri, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_recent_manager_move_item(s7_c_pointer(manager), s7_string(uri), s7_string(new_uri), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_get_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_get_items "GList* gtk_recent_manager_get_items(GtkRecentManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_get_items", 1, manager, "GtkRecentManager*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_recent_manager_get_items(s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_recent_manager_purge_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_purge_items "gint gtk_recent_manager_purge_items(GtkRecentManager* manager, \
GError** [error])"
  s7_pointer _p;
  s7_pointer manager;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_purge_items", 1, manager, "GtkRecentManager*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, gtk_recent_manager_purge_items(s7_c_pointer(manager), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_info_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_ref "GtkRecentInfo* gtk_recent_info_ref(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_ref", 1, info, "GtkRecentInfo*");
  return(s7_make_type_with_c_pointer(sc, GtkRecentInfo__sym, gtk_recent_info_ref(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_unref "void gtk_recent_info_unref(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_unref", 1, info, "GtkRecentInfo*");
  gtk_recent_info_unref(s7_c_pointer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_info_get_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_uri "gchar* gtk_recent_info_get_uri(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_uri", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_uri(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_display_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_display_name "gchar* gtk_recent_info_get_display_name(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_display_name", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_display_name(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_description(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_description "gchar* gtk_recent_info_get_description(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_description", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_description(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_mime_type "gchar* gtk_recent_info_get_mime_type(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_mime_type", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_mime_type(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_added(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_added "time_t gtk_recent_info_get_added(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_added", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_added(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_modified "time_t gtk_recent_info_get_modified(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_modified", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_modified(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_visited "time_t gtk_recent_info_get_visited(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_visited", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_visited(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_private_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_private_hint "gboolean gtk_recent_info_get_private_hint(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_private_hint", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_get_private_hint(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_applications(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_applications "gchar** gtk_recent_info_get_applications(GtkRecentInfo* info, \
gsize* [length])"
  s7_pointer _p;
  s7_pointer info;
  gsize ref_length;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_applications", 1, info, "GtkRecentInfo*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, gchar___sym, gtk_recent_info_get_applications(s7_c_pointer(info), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_recent_info_last_application(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_last_application "gchar* gtk_recent_info_last_application(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_last_application", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_last_application(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_has_application(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_has_application "gboolean gtk_recent_info_has_application(GtkRecentInfo* info, \
gchar* app_name)"
  s7_pointer _p;
  s7_pointer info, app_name;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_application", 1, info, "GtkRecentInfo*");
  app_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(app_name)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_application", 2, app_name, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_info_has_application(s7_c_pointer(info), s7_string(app_name))));
}

static s7_pointer lg_gtk_recent_info_get_groups(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_groups "gchar** gtk_recent_info_get_groups(GtkRecentInfo* info, gsize* [length])"
  s7_pointer _p;
  s7_pointer info;
  gsize ref_length;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_groups", 1, info, "GtkRecentInfo*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, gchar___sym, gtk_recent_info_get_groups(s7_c_pointer(info), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_recent_info_has_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_has_group "gboolean gtk_recent_info_has_group(GtkRecentInfo* info, gchar* group_name)"
  s7_pointer _p;
  s7_pointer info, group_name;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_group", 1, info, "GtkRecentInfo*");
  group_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(group_name)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_group", 2, group_name, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_info_has_group(s7_c_pointer(info), s7_string(group_name))));
}

static s7_pointer lg_gtk_recent_info_get_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_icon "GdkPixbuf* gtk_recent_info_get_icon(GtkRecentInfo* info, gint size)"
  s7_pointer _p;
  s7_pointer info, size;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_icon", 1, info, "GtkRecentInfo*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_icon", 2, size, "gint");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_recent_info_get_icon(s7_c_pointer(info), s7_integer(size))));
}

static s7_pointer lg_gtk_recent_info_get_short_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_short_name "gchar* gtk_recent_info_get_short_name(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_short_name", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_short_name(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_uri_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_uri_display "gchar* gtk_recent_info_get_uri_display(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_uri_display", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_uri_display(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_age "gint gtk_recent_info_get_age(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_age", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_age(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_is_local(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_is_local "gboolean gtk_recent_info_is_local(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_is_local", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_is_local(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_exists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_exists "gboolean gtk_recent_info_exists(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_exists", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_exists(s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_match "gboolean gtk_recent_info_match(GtkRecentInfo* info_a, GtkRecentInfo* info_b)"
  s7_pointer _p;
  s7_pointer info_a, info_b;
  _p = args;
  info_a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_a, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_match", 1, info_a, "GtkRecentInfo*");
  info_b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_b, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_match", 2, info_b, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_match(s7_c_pointer(info_a), s7_c_pointer(info_b))));
}

static s7_pointer lg_gtk_text_buffer_register_serialize_format(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_register_serialize_format "GdkAtom gtk_text_buffer_register_serialize_format(GtkTextBuffer* buffer, \
gchar* mime_type, GtkTextBufferSerializeFunc function, gpointer user_data, GDestroyNotify user_data_destroy)"
  s7_pointer _p;
  s7_pointer buffer, mime_type, function, user_data, user_data_destroy;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_format", 1, buffer, "GtkTextBuffer*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_format", 2, mime_type, "gchar*");
  function = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(function, GtkTextBufferSerializeFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_format", 3, function, "GtkTextBufferSerializeFunc");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_format", 4, user_data, "gpointer");
  user_data_destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data_destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_format", 5, user_data_destroy, "GDestroyNotify");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_text_buffer_register_serialize_format(s7_c_pointer(buffer), s7_string(mime_type), s7_c_pointer(function), s7_c_pointer(user_data), s7_c_pointer(user_data_destroy))));
}

static s7_pointer lg_gtk_text_buffer_register_serialize_tagset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_register_serialize_tagset "GdkAtom gtk_text_buffer_register_serialize_tagset(GtkTextBuffer* buffer, \
gchar* tagset_name)"
  s7_pointer _p;
  s7_pointer buffer, tagset_name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_tagset", 1, buffer, "GtkTextBuffer*");
  tagset_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tagset_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_serialize_tagset", 2, tagset_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_text_buffer_register_serialize_tagset(s7_c_pointer(buffer), s7_string(tagset_name))));
}

static s7_pointer lg_gtk_text_buffer_register_deserialize_format(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_register_deserialize_format "GdkAtom gtk_text_buffer_register_deserialize_format(GtkTextBuffer* buffer, \
gchar* mime_type, GtkTextBufferDeserializeFunc function, gpointer user_data, GDestroyNotify user_data_destroy)"
  s7_pointer _p;
  s7_pointer buffer, mime_type, function, user_data, user_data_destroy;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_format", 1, buffer, "GtkTextBuffer*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_format", 2, mime_type, "gchar*");
  function = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(function, GtkTextBufferDeserializeFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_format", 3, function, "GtkTextBufferDeserializeFunc");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_format", 4, user_data, "gpointer");
  user_data_destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data_destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_format", 5, user_data_destroy, "GDestroyNotify");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_text_buffer_register_deserialize_format(s7_c_pointer(buffer), s7_string(mime_type), s7_c_pointer(function), s7_c_pointer(user_data), s7_c_pointer(user_data_destroy))));
}

static s7_pointer lg_gtk_text_buffer_register_deserialize_tagset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_register_deserialize_tagset "GdkAtom gtk_text_buffer_register_deserialize_tagset(GtkTextBuffer* buffer, \
gchar* tagset_name)"
  s7_pointer _p;
  s7_pointer buffer, tagset_name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_tagset", 1, buffer, "GtkTextBuffer*");
  tagset_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tagset_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_register_deserialize_tagset", 2, tagset_name, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_text_buffer_register_deserialize_tagset(s7_c_pointer(buffer), s7_string(tagset_name))));
}

static s7_pointer lg_gtk_text_buffer_unregister_serialize_format(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_unregister_serialize_format "void gtk_text_buffer_unregister_serialize_format(GtkTextBuffer* buffer, \
GdkAtom format)"
  s7_pointer _p;
  s7_pointer buffer, format;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_unregister_serialize_format", 1, buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_unregister_serialize_format", 2, format, "GdkAtom");
  gtk_text_buffer_unregister_serialize_format(s7_c_pointer(buffer), s7_c_pointer(format));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_unregister_deserialize_format(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_unregister_deserialize_format "void gtk_text_buffer_unregister_deserialize_format(GtkTextBuffer* buffer, \
GdkAtom format)"
  s7_pointer _p;
  s7_pointer buffer, format;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_unregister_deserialize_format", 1, buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_unregister_deserialize_format", 2, format, "GdkAtom");
  gtk_text_buffer_unregister_deserialize_format(s7_c_pointer(buffer), s7_c_pointer(format));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_deserialize_set_can_create_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_deserialize_set_can_create_tags "void gtk_text_buffer_deserialize_set_can_create_tags(GtkTextBuffer* buffer, \
GdkAtom format, gboolean can_create_tags)"
  s7_pointer _p;
  s7_pointer buffer, format, can_create_tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize_set_can_create_tags", 1, buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize_set_can_create_tags", 2, format, "GdkAtom");
  can_create_tags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(can_create_tags)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize_set_can_create_tags", 3, can_create_tags, "gboolean");
  gtk_text_buffer_deserialize_set_can_create_tags(s7_c_pointer(buffer), s7_c_pointer(format), lg_boolean(can_create_tags));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_deserialize_get_can_create_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_deserialize_get_can_create_tags "gboolean gtk_text_buffer_deserialize_get_can_create_tags(GtkTextBuffer* buffer, \
GdkAtom format)"
  s7_pointer _p;
  s7_pointer buffer, format;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize_get_can_create_tags", 1, buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize_get_can_create_tags", 2, format, "GdkAtom");
  return(s7_make_boolean(sc, gtk_text_buffer_deserialize_get_can_create_tags(s7_c_pointer(buffer), s7_c_pointer(format))));
}

static s7_pointer lg_gtk_text_buffer_get_serialize_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_serialize_formats "GdkAtom* gtk_text_buffer_get_serialize_formats(GtkTextBuffer* buffer, \
gint* [n_formats])"
  s7_pointer _p;
  s7_pointer buffer;
  gint ref_n_formats;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_serialize_formats", 1, buffer, "GtkTextBuffer*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkAtom__sym, gtk_text_buffer_get_serialize_formats(s7_c_pointer(buffer), &ref_n_formats));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_n_formats)));
   }
}

static s7_pointer lg_gtk_text_buffer_get_deserialize_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_deserialize_formats "GdkAtom* gtk_text_buffer_get_deserialize_formats(GtkTextBuffer* buffer, \
gint* [n_formats])"
  s7_pointer _p;
  s7_pointer buffer;
  gint ref_n_formats;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_deserialize_formats", 1, buffer, "GtkTextBuffer*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkAtom__sym, gtk_text_buffer_get_deserialize_formats(s7_c_pointer(buffer), &ref_n_formats));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_n_formats)));
   }
}

static s7_pointer lg_gtk_text_buffer_serialize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_serialize "guint8* gtk_text_buffer_serialize(GtkTextBuffer* register_buffer, \
GtkTextBuffer* content_buffer, GdkAtom format, GtkTextIter* start, GtkTextIter* end, gsize* [length])"
  s7_pointer _p;
  s7_pointer register_buffer, content_buffer, format, start, end;
  gsize ref_length;
  _p = args;
  register_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(register_buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_serialize", 1, register_buffer, "GtkTextBuffer*");
  content_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(content_buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_serialize", 2, content_buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_serialize", 3, format, "GdkAtom");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_serialize", 4, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_serialize", 5, end, "GtkTextIter*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, guint8__sym, gtk_text_buffer_serialize(s7_c_pointer(register_buffer), s7_c_pointer(content_buffer), s7_c_pointer(format), s7_c_pointer(start), s7_c_pointer(end), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_text_buffer_deserialize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_deserialize "gboolean gtk_text_buffer_deserialize(GtkTextBuffer* register_buffer, \
GtkTextBuffer* content_buffer, GdkAtom format, GtkTextIter* iter, guint8* data, gsize length, GError** [error])"
  s7_pointer _p;
  s7_pointer register_buffer, content_buffer, format, iter, data, length;
  GError* ref_error = NULL;
  _p = args;
  register_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(register_buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 1, register_buffer, "GtkTextBuffer*");
  content_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(content_buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 2, content_buffer, "GtkTextBuffer*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(format, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 3, format, "GdkAtom");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 4, iter, "GtkTextIter*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guint8__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 5, data, "guint8*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_deserialize", 6, length, "gsize");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_text_buffer_deserialize(s7_c_pointer(register_buffer), s7_c_pointer(content_buffer), s7_c_pointer(format), s7_c_pointer(iter), s7_c_pointer(data), s7_integer(length), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_add_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_add_item "gboolean gtk_recent_manager_add_item(GtkRecentManager* manager, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer manager, uri;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_item", 2, uri, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_manager_add_item(s7_c_pointer(manager), s7_string(uri))));
}

static s7_pointer lg_gtk_recent_manager_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_add_full "gboolean gtk_recent_manager_add_full(GtkRecentManager* manager, \
gchar* uri, GtkRecentData* recent_data)"
  s7_pointer _p;
  s7_pointer manager, uri, recent_data;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 2, uri, "gchar*");
  recent_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(recent_data, GtkRecentData__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 3, recent_data, "GtkRecentData*");
  return(s7_make_boolean(sc, gtk_recent_manager_add_full(s7_c_pointer(manager), s7_string(uri), s7_c_pointer(recent_data))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_child_iter_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_child_iter_to_iter "gboolean gtk_tree_model_filter_convert_child_iter_to_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* filter_iter, GtkTreeIter* child_iter)"
  s7_pointer _p;
  s7_pointer filter, filter_iter, child_iter;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 1, filter, "GtkTreeModelFilter*");
  filter_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 2, filter_iter, "GtkTreeIter*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 3, child_iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_filter_convert_child_iter_to_iter(s7_c_pointer(filter), s7_c_pointer(filter_iter), s7_c_pointer(child_iter))));
}

static s7_pointer lg_gtk_tree_view_get_grid_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_grid_lines "GtkTreeViewGridLines gtk_tree_view_get_grid_lines(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_grid_lines", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_grid_lines(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_grid_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_grid_lines "void gtk_tree_view_set_grid_lines(GtkTreeView* tree_view, GtkTreeViewGridLines grid_lines)"
  s7_pointer _p;
  s7_pointer tree_view, grid_lines;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_grid_lines", 1, tree_view, "GtkTreeView*");
  grid_lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(grid_lines)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_grid_lines", 2, grid_lines, "GtkTreeViewGridLines");
  gtk_tree_view_set_grid_lines(s7_c_pointer(tree_view), s7_integer(grid_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_enable_tree_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_enable_tree_lines "gboolean gtk_tree_view_get_enable_tree_lines(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_enable_tree_lines", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_enable_tree_lines(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_enable_tree_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_enable_tree_lines "void gtk_tree_view_set_enable_tree_lines(GtkTreeView* tree_view, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer tree_view, enabled;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_tree_lines", 1, tree_view, "GtkTreeView*");
  enabled = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_tree_lines", 2, enabled, "gboolean");
  gtk_tree_view_set_enable_tree_lines(s7_c_pointer(tree_view), lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_line_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_line_wrap_mode "void gtk_label_set_line_wrap_mode(GtkLabel* label, PangoWrapMode wrap_mode)"
  s7_pointer _p;
  s7_pointer label, wrap_mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_line_wrap_mode", 1, label, "GtkLabel*");
  wrap_mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wrap_mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_line_wrap_mode", 2, wrap_mode, "PangoWrapMode");
  gtk_label_set_line_wrap_mode(s7_c_pointer(label), s7_integer(wrap_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_line_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_line_wrap_mode "PangoWrapMode gtk_label_get_line_wrap_mode(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_line_wrap_mode", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_line_wrap_mode(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_print_context_get_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_cairo_context "cairo_t* gtk_print_context_get_cairo_context(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_cairo_context", 1, context, "GtkPrintContext*");
  return(s7_make_type_with_c_pointer(sc, cairo_t__sym, gtk_print_context_get_cairo_context(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_page_setup "GtkPageSetup* gtk_print_context_get_page_setup(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_page_setup", 1, context, "GtkPrintContext*");
  return(s7_make_type_with_c_pointer(sc, GtkPageSetup__sym, gtk_print_context_get_page_setup(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_width "gdouble gtk_print_context_get_width(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_width", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_width(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_height "gdouble gtk_print_context_get_height(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_height", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_height(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_dpi_x(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_dpi_x "gdouble gtk_print_context_get_dpi_x(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_dpi_x", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_dpi_x(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_dpi_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_dpi_y "gdouble gtk_print_context_get_dpi_y(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_dpi_y", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_dpi_y(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_create_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_create_pango_context "PangoContext* gtk_print_context_create_pango_context(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_create_pango_context", 1, context, "GtkPrintContext*");
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, gtk_print_context_create_pango_context(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_create_pango_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_create_pango_layout "PangoLayout* gtk_print_context_create_pango_layout(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_create_pango_layout", 1, context, "GtkPrintContext*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, gtk_print_context_create_pango_layout(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_set_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_set_cairo_context "void gtk_print_context_set_cairo_context(GtkPrintContext* context, \
cairo_t* cr, double dpi_x, double dpi_y)"
  s7_pointer _p;
  s7_pointer context, cr, dpi_x, dpi_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 1, context, "GtkPrintContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 2, cr, "cairo_t*");
  dpi_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dpi_x)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 3, dpi_x, "double");
  dpi_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dpi_y)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 4, dpi_y, "double");
  gtk_print_context_set_cairo_context(s7_c_pointer(context), s7_c_pointer(cr), s7_real(dpi_x), s7_real(dpi_y));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_new "GtkPrintOperation* gtk_print_operation_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkPrintOperation__sym, gtk_print_operation_new()));
}

static s7_pointer lg_gtk_print_operation_set_default_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_default_page_setup "void gtk_print_operation_set_default_page_setup(GtkPrintOperation* op, \
GtkPageSetup* default_page_setup)"
  s7_pointer _p;
  s7_pointer op, default_page_setup;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_default_page_setup", 1, op, "GtkPrintOperation*");
  default_page_setup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(default_page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_default_page_setup", 2, default_page_setup, "GtkPageSetup*");
  gtk_print_operation_set_default_page_setup(s7_c_pointer(op), s7_c_pointer(default_page_setup));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_default_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_default_page_setup "GtkPageSetup* gtk_print_operation_get_default_page_setup(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_default_page_setup", 1, op, "GtkPrintOperation*");
  return(s7_make_type_with_c_pointer(sc, GtkPageSetup__sym, gtk_print_operation_get_default_page_setup(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_set_print_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_print_settings "void gtk_print_operation_set_print_settings(GtkPrintOperation* op, \
GtkPrintSettings* print_settings)"
  s7_pointer _p;
  s7_pointer op, print_settings;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_print_settings", 1, op, "GtkPrintOperation*");
  print_settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(print_settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_print_settings", 2, print_settings, "GtkPrintSettings*");
  gtk_print_operation_set_print_settings(s7_c_pointer(op), s7_c_pointer(print_settings));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_print_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_print_settings "GtkPrintSettings* gtk_print_operation_get_print_settings(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_print_settings", 1, op, "GtkPrintOperation*");
  return(s7_make_type_with_c_pointer(sc, GtkPrintSettings__sym, gtk_print_operation_get_print_settings(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_set_job_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_job_name "void gtk_print_operation_set_job_name(GtkPrintOperation* op, \
gchar* job_name)"
  s7_pointer _p;
  s7_pointer op, job_name;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_job_name", 1, op, "GtkPrintOperation*");
  job_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(job_name)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_job_name", 2, job_name, "gchar*");
  gtk_print_operation_set_job_name(s7_c_pointer(op), s7_string(job_name));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_n_pages "void gtk_print_operation_set_n_pages(GtkPrintOperation* op, \
gint n_pages)"
  s7_pointer _p;
  s7_pointer op, n_pages;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_n_pages", 1, op, "GtkPrintOperation*");
  n_pages = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_pages)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_n_pages", 2, n_pages, "gint");
  gtk_print_operation_set_n_pages(s7_c_pointer(op), s7_integer(n_pages));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_current_page "void gtk_print_operation_set_current_page(GtkPrintOperation* op, \
gint current_page)"
  s7_pointer _p;
  s7_pointer op, current_page;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_current_page", 1, op, "GtkPrintOperation*");
  current_page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(current_page)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_current_page", 2, current_page, "gint");
  gtk_print_operation_set_current_page(s7_c_pointer(op), s7_integer(current_page));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_use_full_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_use_full_page "void gtk_print_operation_set_use_full_page(GtkPrintOperation* op, \
gboolean full_page)"
  s7_pointer _p;
  s7_pointer op, full_page;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_use_full_page", 1, op, "GtkPrintOperation*");
  full_page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(full_page)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_use_full_page", 2, full_page, "gboolean");
  gtk_print_operation_set_use_full_page(s7_c_pointer(op), lg_boolean(full_page));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_unit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_unit "void gtk_print_operation_set_unit(GtkPrintOperation* op, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer op, unit;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_unit", 1, op, "GtkPrintOperation*");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_unit", 2, unit, "GtkUnit");
  gtk_print_operation_set_unit(s7_c_pointer(op), s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_export_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_export_filename "void gtk_print_operation_set_export_filename(GtkPrintOperation* op, \
gchar* filename)"
  s7_pointer _p;
  s7_pointer op, filename;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_export_filename", 1, op, "GtkPrintOperation*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_export_filename", 2, filename, "gchar*");
  gtk_print_operation_set_export_filename(s7_c_pointer(op), s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_track_print_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_track_print_status "void gtk_print_operation_set_track_print_status(GtkPrintOperation* op, \
gboolean track_status)"
  s7_pointer _p;
  s7_pointer op, track_status;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_track_print_status", 1, op, "GtkPrintOperation*");
  track_status = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(track_status)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_track_print_status", 2, track_status, "gboolean");
  gtk_print_operation_set_track_print_status(s7_c_pointer(op), lg_boolean(track_status));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_show_progress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_show_progress "void gtk_print_operation_set_show_progress(GtkPrintOperation* op, \
gboolean show_progress)"
  s7_pointer _p;
  s7_pointer op, show_progress;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_show_progress", 1, op, "GtkPrintOperation*");
  show_progress = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_progress)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_show_progress", 2, show_progress, "gboolean");
  gtk_print_operation_set_show_progress(s7_c_pointer(op), lg_boolean(show_progress));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_allow_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_allow_async "void gtk_print_operation_set_allow_async(GtkPrintOperation* op, \
gboolean allow_async)"
  s7_pointer _p;
  s7_pointer op, allow_async;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_allow_async", 1, op, "GtkPrintOperation*");
  allow_async = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(allow_async)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_allow_async", 2, allow_async, "gboolean");
  gtk_print_operation_set_allow_async(s7_c_pointer(op), lg_boolean(allow_async));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_custom_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_custom_tab_label "void gtk_print_operation_set_custom_tab_label(GtkPrintOperation* op, \
gchar* label)"
  s7_pointer _p;
  s7_pointer op, label;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_custom_tab_label", 1, op, "GtkPrintOperation*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_custom_tab_label", 2, label, "gchar*");
  gtk_print_operation_set_custom_tab_label(s7_c_pointer(op), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_run(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_run "GtkPrintOperationResult gtk_print_operation_run(GtkPrintOperation* op, \
GtkPrintOperationAction action, GtkWindow* parent, GError** [error])"
  s7_pointer _p;
  s7_pointer op, action, parent;
  GError* ref_error = NULL;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 1, op, "GtkPrintOperation*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 2, action, "GtkPrintOperationAction");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 3, parent, "GtkWindow*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, gtk_print_operation_run(s7_c_pointer(op), s7_integer(action), s7_c_pointer(parent), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_print_operation_get_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_error "void gtk_print_operation_get_error(GtkPrintOperation* op, \
GError** [error])"
  s7_pointer _p;
  s7_pointer op;
  GError* ref_error = NULL;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_error", 1, op, "GtkPrintOperation*");
  gtk_print_operation_get_error(s7_c_pointer(op), &ref_error);
    return(s7_list(sc, 1, s7_make_c_pointer(sc, ref_error)));
}

static s7_pointer lg_gtk_print_operation_get_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_status "GtkPrintStatus gtk_print_operation_get_status(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_status", 1, op, "GtkPrintOperation*");
  return(s7_make_integer(sc, gtk_print_operation_get_status(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_get_status_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_status_string "gchar* gtk_print_operation_get_status_string(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_status_string", 1, op, "GtkPrintOperation*");
  return(s7_make_string(sc, gtk_print_operation_get_status_string(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_is_finished(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_is_finished "gboolean gtk_print_operation_is_finished(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_is_finished", 1, op, "GtkPrintOperation*");
  return(s7_make_boolean(sc, gtk_print_operation_is_finished(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_cancel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_cancel "void gtk_print_operation_cancel(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_cancel", 1, op, "GtkPrintOperation*");
  gtk_print_operation_cancel(s7_c_pointer(op));
  return(lg_false);
}

static s7_pointer lg_gtk_print_run_page_setup_dialog(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_run_page_setup_dialog "GtkPageSetup* gtk_print_run_page_setup_dialog(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings)"
  s7_pointer _p;
  s7_pointer parent, page_setup, settings;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 1, parent, "GtkWindow*");
  page_setup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 2, page_setup, "GtkPageSetup*");
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 3, settings, "GtkPrintSettings*");
  return(s7_make_type_with_c_pointer(sc, GtkPageSetup__sym, gtk_print_run_page_setup_dialog(s7_c_pointer(parent), s7_c_pointer(page_setup), s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_run_page_setup_dialog_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_run_page_setup_dialog_async "void gtk_print_run_page_setup_dialog_async(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings, GtkPageSetupDoneFunc done_cb, gpointer data)"
  s7_pointer _p;
  s7_pointer parent, page_setup, settings, done_cb, data;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 1, parent, "GtkWindow*");
  page_setup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 2, page_setup, "GtkPageSetup*");
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 3, settings, "GtkPrintSettings*");
  done_cb = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(done_cb, GtkPageSetupDoneFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 4, done_cb, "GtkPageSetupDoneFunc");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 5, data, "gpointer");
  gtk_print_run_page_setup_dialog_async(s7_c_pointer(parent), s7_c_pointer(page_setup), s7_c_pointer(settings), s7_c_pointer(done_cb), s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_new "GtkPrintSettings* gtk_print_settings_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkPrintSettings__sym, gtk_print_settings_new()));
}

static s7_pointer lg_gtk_print_settings_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_copy "GtkPrintSettings* gtk_print_settings_copy(GtkPrintSettings* other)"
  s7_pointer other;
  other = s7_car(args);
  if (!s7_is_c_pointer_of_type(other, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_copy", 1, other, "GtkPrintSettings*");
  return(s7_make_type_with_c_pointer(sc, GtkPrintSettings__sym, gtk_print_settings_copy(s7_c_pointer(other))));
}

static s7_pointer lg_gtk_print_settings_has_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_has_key "gboolean gtk_print_settings_has_key(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_has_key", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_has_key", 2, key, "gchar*");
  return(s7_make_boolean(sc, gtk_print_settings_has_key(s7_c_pointer(settings), s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get "gchar* gtk_print_settings_get(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get", 2, key, "gchar*");
  return(s7_make_string(sc, gtk_print_settings_get(s7_c_pointer(settings), s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set "void gtk_print_settings_set(GtkPrintSettings* settings, gchar* key, \
gchar* value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 3, value, "gchar*");
  gtk_print_settings_set(s7_c_pointer(settings), s7_string(key), s7_string(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_unset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_unset "void gtk_print_settings_unset(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_unset", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_unset", 2, key, "gchar*");
  gtk_print_settings_unset(s7_c_pointer(settings), s7_string(key));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_foreach "void gtk_print_settings_foreach(GtkPrintSettings* settings, GtkPrintSettingsFunc func, \
gpointer user_data)"
  s7_pointer _p;
  s7_pointer settings, func, user_data;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 1, settings, "GtkPrintSettings*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkPrintSettingsFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 2, func, "GtkPrintSettingsFunc");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 3, user_data, "gpointer");
  gtk_print_settings_foreach(s7_c_pointer(settings), s7_c_pointer(func), s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_bool(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_bool "gboolean gtk_print_settings_get_bool(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_bool", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_bool", 2, key, "gchar*");
  return(s7_make_boolean(sc, gtk_print_settings_get_bool(s7_c_pointer(settings), s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_set_bool(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_bool "void gtk_print_settings_set_bool(GtkPrintSettings* settings, \
gchar* key, gboolean value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 3, value, "gboolean");
  gtk_print_settings_set_bool(s7_c_pointer(settings), s7_string(key), lg_boolean(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_double "gdouble gtk_print_settings_get_double(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double", 2, key, "gchar*");
  return(s7_make_real(sc, gtk_print_settings_get_double(s7_c_pointer(settings), s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get_double_with_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_double_with_default "gdouble gtk_print_settings_get_double_with_default(GtkPrintSettings* settings, \
gchar* key, gdouble def)"
  s7_pointer _p;
  s7_pointer settings, key, def;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 2, key, "gchar*");
  def = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(def)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 3, def, "gdouble");
  return(s7_make_real(sc, gtk_print_settings_get_double_with_default(s7_c_pointer(settings), s7_string(key), s7_real(def))));
}

static s7_pointer lg_gtk_print_settings_set_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_double "void gtk_print_settings_set_double(GtkPrintSettings* settings, \
gchar* key, gdouble value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 3, value, "gdouble");
  gtk_print_settings_set_double(s7_c_pointer(settings), s7_string(key), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_length "gdouble gtk_print_settings_get_length(GtkPrintSettings* settings, \
gchar* key, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, key, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 2, key, "gchar*");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 3, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_length(s7_c_pointer(settings), s7_string(key), s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_length "void gtk_print_settings_set_length(GtkPrintSettings* settings, \
gchar* key, gdouble value, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, key, value, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 3, value, "gdouble");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 4, unit, "GtkUnit");
  gtk_print_settings_set_length(s7_c_pointer(settings), s7_string(key), s7_real(value), s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_int "gint gtk_print_settings_get_int(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int", 2, key, "gchar*");
  return(s7_make_integer(sc, gtk_print_settings_get_int(s7_c_pointer(settings), s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get_int_with_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_int_with_default "gint gtk_print_settings_get_int_with_default(GtkPrintSettings* settings, \
gchar* key, gint def)"
  s7_pointer _p;
  s7_pointer settings, key, def;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 2, key, "gchar*");
  def = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(def)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 3, def, "gint");
  return(s7_make_integer(sc, gtk_print_settings_get_int_with_default(s7_c_pointer(settings), s7_string(key), s7_integer(def))));
}

static s7_pointer lg_gtk_print_settings_set_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_int "void gtk_print_settings_set_int(GtkPrintSettings* settings, gchar* key, \
gint value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 3, value, "gint");
  gtk_print_settings_set_int(s7_c_pointer(settings), s7_string(key), s7_integer(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_printer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_printer "gchar* gtk_print_settings_get_printer(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_printer", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_printer(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_printer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_printer "void gtk_print_settings_set_printer(GtkPrintSettings* settings, \
gchar* printer)"
  s7_pointer _p;
  s7_pointer settings, printer;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_printer", 1, settings, "GtkPrintSettings*");
  printer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(printer)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_printer", 2, printer, "gchar*");
  gtk_print_settings_set_printer(s7_c_pointer(settings), s7_string(printer));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_orientation "GtkPageOrientation gtk_print_settings_get_orientation(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_orientation", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_orientation(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_orientation "void gtk_print_settings_set_orientation(GtkPrintSettings* settings, \
GtkPageOrientation orientation)"
  s7_pointer _p;
  s7_pointer settings, orientation;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_orientation", 1, settings, "GtkPrintSettings*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_orientation", 2, orientation, "GtkPageOrientation");
  gtk_print_settings_set_orientation(s7_c_pointer(settings), s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_size "GtkPaperSize* gtk_print_settings_get_paper_size(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_size", 1, settings, "GtkPrintSettings*");
  return(s7_make_type_with_c_pointer(sc, GtkPaperSize__sym, gtk_print_settings_get_paper_size(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_paper_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_size "void gtk_print_settings_set_paper_size(GtkPrintSettings* settings, \
GtkPaperSize* paper_size)"
  s7_pointer _p;
  s7_pointer settings, paper_size;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_size", 1, settings, "GtkPrintSettings*");
  paper_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paper_size, GtkPaperSize__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_size", 2, paper_size, "GtkPaperSize*");
  gtk_print_settings_set_paper_size(s7_c_pointer(settings), s7_c_pointer(paper_size));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_width "gdouble gtk_print_settings_get_paper_width(GtkPrintSettings* settings, \
GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_width", 1, settings, "GtkPrintSettings*");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_width", 2, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_paper_width(s7_c_pointer(settings), s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_paper_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_width "void gtk_print_settings_set_paper_width(GtkPrintSettings* settings, \
gdouble width, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, width, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 1, settings, "GtkPrintSettings*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 2, width, "gdouble");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 3, unit, "GtkUnit");
  gtk_print_settings_set_paper_width(s7_c_pointer(settings), s7_real(width), s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_height "gdouble gtk_print_settings_get_paper_height(GtkPrintSettings* settings, \
GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_height", 1, settings, "GtkPrintSettings*");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_height", 2, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_paper_height(s7_c_pointer(settings), s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_paper_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_height "void gtk_print_settings_set_paper_height(GtkPrintSettings* settings, \
gdouble height, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, height, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 1, settings, "GtkPrintSettings*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 2, height, "gdouble");
  unit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 3, unit, "GtkUnit");
  gtk_print_settings_set_paper_height(s7_c_pointer(settings), s7_real(height), s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_use_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_use_color "gboolean gtk_print_settings_get_use_color(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_use_color", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_use_color(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_use_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_use_color "void gtk_print_settings_set_use_color(GtkPrintSettings* settings, \
gboolean use_color)"
  s7_pointer _p;
  s7_pointer settings, use_color;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_use_color", 1, settings, "GtkPrintSettings*");
  use_color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_color)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_use_color", 2, use_color, "gboolean");
  gtk_print_settings_set_use_color(s7_c_pointer(settings), lg_boolean(use_color));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_collate "gboolean gtk_print_settings_get_collate(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_collate", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_collate(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_collate "void gtk_print_settings_set_collate(GtkPrintSettings* settings, \
gboolean collate)"
  s7_pointer _p;
  s7_pointer settings, collate;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_collate", 1, settings, "GtkPrintSettings*");
  collate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(collate)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_collate", 2, collate, "gboolean");
  gtk_print_settings_set_collate(s7_c_pointer(settings), lg_boolean(collate));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_reverse "gboolean gtk_print_settings_get_reverse(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_reverse", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_reverse(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_reverse "void gtk_print_settings_set_reverse(GtkPrintSettings* settings, \
gboolean reverse)"
  s7_pointer _p;
  s7_pointer settings, reverse;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_reverse", 1, settings, "GtkPrintSettings*");
  reverse = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reverse)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_reverse", 2, reverse, "gboolean");
  gtk_print_settings_set_reverse(s7_c_pointer(settings), lg_boolean(reverse));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_duplex(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_duplex "GtkPrintDuplex gtk_print_settings_get_duplex(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_duplex", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_duplex(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_duplex(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_duplex "void gtk_print_settings_set_duplex(GtkPrintSettings* settings, \
GtkPrintDuplex duplex)"
  s7_pointer _p;
  s7_pointer settings, duplex;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_duplex", 1, settings, "GtkPrintSettings*");
  duplex = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(duplex)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_duplex", 2, duplex, "GtkPrintDuplex");
  gtk_print_settings_set_duplex(s7_c_pointer(settings), s7_integer(duplex));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_quality(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_quality "GtkPrintQuality gtk_print_settings_get_quality(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_quality", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_quality(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_quality(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_quality "void gtk_print_settings_set_quality(GtkPrintSettings* settings, \
GtkPrintQuality quality)"
  s7_pointer _p;
  s7_pointer settings, quality;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_quality", 1, settings, "GtkPrintSettings*");
  quality = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(quality)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_quality", 2, quality, "GtkPrintQuality");
  gtk_print_settings_set_quality(s7_c_pointer(settings), s7_integer(quality));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_n_copies(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_n_copies "gint gtk_print_settings_get_n_copies(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_n_copies", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_n_copies(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_n_copies(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_n_copies "void gtk_print_settings_set_n_copies(GtkPrintSettings* settings, \
gint num_copies)"
  s7_pointer _p;
  s7_pointer settings, num_copies;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_n_copies", 1, settings, "GtkPrintSettings*");
  num_copies = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_copies)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_n_copies", 2, num_copies, "gint");
  gtk_print_settings_set_n_copies(s7_c_pointer(settings), s7_integer(num_copies));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_number_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_number_up "gint gtk_print_settings_get_number_up(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_number_up", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_number_up(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_number_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_number_up "void gtk_print_settings_set_number_up(GtkPrintSettings* settings, \
gint number_up)"
  s7_pointer _p;
  s7_pointer settings, number_up;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_number_up", 1, settings, "GtkPrintSettings*");
  number_up = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(number_up)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_number_up", 2, number_up, "gint");
  gtk_print_settings_set_number_up(s7_c_pointer(settings), s7_integer(number_up));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_resolution "gint gtk_print_settings_get_resolution(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_resolution", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_resolution(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_resolution "void gtk_print_settings_set_resolution(GtkPrintSettings* settings, \
gint resolution)"
  s7_pointer _p;
  s7_pointer settings, resolution;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_resolution", 1, settings, "GtkPrintSettings*");
  resolution = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(resolution)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_resolution", 2, resolution, "gint");
  gtk_print_settings_set_resolution(s7_c_pointer(settings), s7_integer(resolution));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_scale "gdouble gtk_print_settings_get_scale(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_scale", 1, settings, "GtkPrintSettings*");
  return(s7_make_real(sc, gtk_print_settings_get_scale(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_scale "void gtk_print_settings_set_scale(GtkPrintSettings* settings, \
gdouble scale)"
  s7_pointer _p;
  s7_pointer settings, scale;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_scale", 1, settings, "GtkPrintSettings*");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_scale", 2, scale, "gdouble");
  gtk_print_settings_set_scale(s7_c_pointer(settings), s7_real(scale));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_print_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_print_pages "GtkPrintPages gtk_print_settings_get_print_pages(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_print_pages", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_print_pages(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_print_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_print_pages "void gtk_print_settings_set_print_pages(GtkPrintSettings* settings, \
GtkPrintPages pages)"
  s7_pointer _p;
  s7_pointer settings, pages;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_print_pages", 1, settings, "GtkPrintSettings*");
  pages = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pages)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_print_pages", 2, pages, "GtkPrintPages");
  gtk_print_settings_set_print_pages(s7_c_pointer(settings), s7_integer(pages));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_page_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_page_ranges "GtkPageRange* gtk_print_settings_get_page_ranges(GtkPrintSettings* settings, \
gint* num_ranges)"
  s7_pointer _p;
  s7_pointer settings, num_ranges;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_ranges", 1, settings, "GtkPrintSettings*");
  num_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(num_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_ranges", 2, num_ranges, "gint*");
  return(s7_make_type_with_c_pointer(sc, GtkPageRange__sym, gtk_print_settings_get_page_ranges(s7_c_pointer(settings), s7_c_pointer(num_ranges))));
}

static s7_pointer lg_gtk_print_settings_set_page_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_page_ranges "void gtk_print_settings_set_page_ranges(GtkPrintSettings* settings, \
GtkPageRange* page_ranges, gint num_ranges)"
  s7_pointer _p;
  s7_pointer settings, page_ranges, num_ranges;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 1, settings, "GtkPrintSettings*");
  page_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_ranges, GtkPageRange__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 2, page_ranges, "GtkPageRange*");
  num_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_ranges)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 3, num_ranges, "gint");
  gtk_print_settings_set_page_ranges(s7_c_pointer(settings), s7_c_pointer(page_ranges), s7_integer(num_ranges));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_page_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_page_set "GtkPageSet gtk_print_settings_get_page_set(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_set", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_page_set(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_page_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_page_set "void gtk_print_settings_set_page_set(GtkPrintSettings* settings, \
GtkPageSet page_set)"
  s7_pointer _p;
  s7_pointer settings, page_set;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_set", 1, settings, "GtkPrintSettings*");
  page_set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(page_set)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_set", 2, page_set, "GtkPageSet");
  gtk_print_settings_set_page_set(s7_c_pointer(settings), s7_integer(page_set));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_default_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_default_source "gchar* gtk_print_settings_get_default_source(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_default_source", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_default_source(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_default_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_default_source "void gtk_print_settings_set_default_source(GtkPrintSettings* settings, \
gchar* default_source)"
  s7_pointer _p;
  s7_pointer settings, default_source;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_default_source", 1, settings, "GtkPrintSettings*");
  default_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(default_source)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_default_source", 2, default_source, "gchar*");
  gtk_print_settings_set_default_source(s7_c_pointer(settings), s7_string(default_source));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_media_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_media_type "gchar* gtk_print_settings_get_media_type(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_media_type", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_media_type(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_media_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_media_type "void gtk_print_settings_set_media_type(GtkPrintSettings* settings, \
gchar* media_type)"
  s7_pointer _p;
  s7_pointer settings, media_type;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_media_type", 1, settings, "GtkPrintSettings*");
  media_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(media_type)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_media_type", 2, media_type, "gchar*");
  gtk_print_settings_set_media_type(s7_c_pointer(settings), s7_string(media_type));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_dither(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_dither "gchar* gtk_print_settings_get_dither(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_dither", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_dither(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_dither(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_dither "void gtk_print_settings_set_dither(GtkPrintSettings* settings, \
gchar* dither)"
  s7_pointer _p;
  s7_pointer settings, dither;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_dither", 1, settings, "GtkPrintSettings*");
  dither = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(dither)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_dither", 2, dither, "gchar*");
  gtk_print_settings_set_dither(s7_c_pointer(settings), s7_string(dither));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_finishings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_finishings "gchar* gtk_print_settings_get_finishings(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_finishings", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_finishings(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_finishings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_finishings "void gtk_print_settings_set_finishings(GtkPrintSettings* settings, \
gchar* finishings)"
  s7_pointer _p;
  s7_pointer settings, finishings;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_finishings", 1, settings, "GtkPrintSettings*");
  finishings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(finishings)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_finishings", 2, finishings, "gchar*");
  gtk_print_settings_set_finishings(s7_c_pointer(settings), s7_string(finishings));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_output_bin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_output_bin "gchar* gtk_print_settings_get_output_bin(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_output_bin", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_output_bin(s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_output_bin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_output_bin "void gtk_print_settings_set_output_bin(GtkPrintSettings* settings, \
gchar* output_bin)"
  s7_pointer _p;
  s7_pointer settings, output_bin;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_output_bin", 1, settings, "GtkPrintSettings*");
  output_bin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(output_bin)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_output_bin", 2, output_bin, "gchar*");
  gtk_print_settings_set_output_bin(s7_c_pointer(settings), s7_string(output_bin));
  return(lg_false);
}

static s7_pointer lg_gtk_settings_get_for_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_get_for_screen "GtkSettings* gtk_settings_get_for_screen(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_settings_get_for_screen", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GtkSettings__sym, gtk_settings_get_for_screen(s7_c_pointer(screen))));
}

static s7_pointer lg_pango_cairo_create_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_create_layout "PangoLayout* pango_cairo_create_layout(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_create_layout", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, PangoLayout__sym, pango_cairo_create_layout(s7_c_pointer(cr))));
}

static s7_pointer lg_pango_cairo_update_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_update_layout "void pango_cairo_update_layout(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_layout", 1, cr, "cairo_t*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_layout", 2, layout, "PangoLayout*");
  pango_cairo_update_layout(s7_c_pointer(cr), s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_update_context(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_update_context "void pango_cairo_update_context(cairo_t* cr, PangoContext* context)"
  s7_pointer _p;
  s7_pointer cr, context;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_context", 1, cr, "cairo_t*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_context", 2, context, "PangoContext*");
  pango_cairo_update_context(s7_c_pointer(cr), s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_set_font_options "void pango_cairo_context_set_font_options(PangoContext* context, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer context, options;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_font_options", 1, context, "PangoContext*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_font_options", 2, options, "cairo_font_options_t*");
  pango_cairo_context_set_font_options(s7_c_pointer(context), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_get_font_options "cairo_font_options_t* pango_cairo_context_get_font_options(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_get_font_options", 1, context, "PangoContext*");
    return(s7_make_type_with_c_pointer(sc, cairo_font_options_t__sym, (cairo_font_options_t*)pango_cairo_context_get_font_options(s7_c_pointer(context))));
}

static s7_pointer lg_pango_cairo_context_set_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_set_resolution "void pango_cairo_context_set_resolution(PangoContext* context, \
gdouble dpi)"
  s7_pointer _p;
  s7_pointer context, dpi;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_resolution", 1, context, "PangoContext*");
  dpi = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dpi)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_resolution", 2, dpi, "gdouble");
  pango_cairo_context_set_resolution(s7_c_pointer(context), s7_real(dpi));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_get_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_get_resolution "gdouble pango_cairo_context_get_resolution(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_get_resolution", 1, context, "PangoContext*");
  return(s7_make_real(sc, pango_cairo_context_get_resolution(s7_c_pointer(context))));
}

static s7_pointer lg_pango_cairo_show_glyph_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_glyph_string "void pango_cairo_show_glyph_string(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer cr, font, glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 1, cr, "cairo_t*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 2, font, "PangoFont*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 3, glyphs, "PangoGlyphString*");
  pango_cairo_show_glyph_string(s7_c_pointer(cr), s7_c_pointer(font), s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_layout_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_layout_line "void pango_cairo_show_layout_line(cairo_t* cr, PangoLayoutLine* line)"
  s7_pointer _p;
  s7_pointer cr, line;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout_line", 1, cr, "cairo_t*");
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout_line", 2, line, "PangoLayoutLine*");
  pango_cairo_show_layout_line(s7_c_pointer(cr), s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_layout "void pango_cairo_show_layout(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout", 1, cr, "cairo_t*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout", 2, layout, "PangoLayout*");
  pango_cairo_show_layout(s7_c_pointer(cr), s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_error_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_error_underline "void pango_cairo_show_error_underline(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 3, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 4, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 5, height, "gdouble");
  pango_cairo_show_error_underline(s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_glyph_string_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_glyph_string_path "void pango_cairo_glyph_string_path(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer cr, font, glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 1, cr, "cairo_t*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 2, font, "PangoFont*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 3, glyphs, "PangoGlyphString*");
  pango_cairo_glyph_string_path(s7_c_pointer(cr), s7_c_pointer(font), s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_layout_line_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_layout_line_path "void pango_cairo_layout_line_path(cairo_t* cr, PangoLayoutLine* line)"
  s7_pointer _p;
  s7_pointer cr, line;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_line_path", 1, cr, "cairo_t*");
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_line_path", 2, line, "PangoLayoutLine*");
  pango_cairo_layout_line_path(s7_c_pointer(cr), s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_layout_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_layout_path "void pango_cairo_layout_path(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_path", 1, cr, "cairo_t*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_path", 2, layout, "PangoLayout*");
  pango_cairo_layout_path(s7_c_pointer(cr), s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_error_underline_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_error_underline_path "void pango_cairo_error_underline_path(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 3, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 4, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 5, height, "gdouble");
  pango_cairo_error_underline_path(s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gdk_cairo_set_source_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_set_source_pixbuf "void gdk_cairo_set_source_pixbuf(cairo_t* cr, GdkPixbuf* pixbuf, \
gdouble pixbuf_x, gdouble pixbuf_y)"
  s7_pointer _p;
  s7_pointer cr, pixbuf, pixbuf_x, pixbuf_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 1, cr, "cairo_t*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 2, pixbuf, "GdkPixbuf*");
  pixbuf_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(pixbuf_x)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 3, pixbuf_x, "gdouble");
  pixbuf_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(pixbuf_y)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 4, pixbuf_y, "gdouble");
  gdk_cairo_set_source_pixbuf(s7_c_pointer(cr), s7_c_pointer(pixbuf), s7_real(pixbuf_x), s7_real(pixbuf_y));
  return(lg_false);
}

static s7_pointer lg_gdk_cairo_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_rectangle "void gdk_cairo_rectangle(cairo_t* cr, GdkRectangle* rectangle)"
  s7_pointer _p;
  s7_pointer cr, rectangle;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_rectangle", 1, cr, "cairo_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_rectangle", 2, rectangle, "GdkRectangle*");
  gdk_cairo_rectangle(s7_c_pointer(cr), s7_c_pointer(rectangle));
  return(lg_false);
}

static s7_pointer lg_gdk_event_request_motions(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_request_motions "void gdk_event_request_motions(GdkEventMotion* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEventMotion__sym)) s7_wrong_type_arg_error(sc, "gdk_event_request_motions", 1, event, "GdkEventMotion*");
  gdk_event_request_motions(s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_notify_startup_complete_with_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_notify_startup_complete_with_id "void gdk_notify_startup_complete_with_id(gchar* startup_id)"
  s7_pointer startup_id;
  startup_id = s7_car(args);
  if (!s7_is_string(startup_id)) s7_wrong_type_arg_error(sc, "gdk_notify_startup_complete_with_id", 1, startup_id, "gchar*");
  gdk_notify_startup_complete_with_id(s7_string(startup_id));
  return(lg_false);
}

static s7_pointer lg_gdk_threads_add_idle_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_idle_full "guint gdk_threads_add_idle_full(gint priority, GSourceFunc func, \
lambda_data func_info, GDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle_full", 1, priority, "gint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle_full", 2, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle_full", 3, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle_full", 4, notify, "GDestroyNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_idle_full(s7_integer(priority), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify)));
    return(result);
   }
}

static s7_pointer lg_gdk_threads_add_idle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_idle "guint gdk_threads_add_idle(GSourceFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer func, func_info;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle", 1, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_threads_add_idle", 2, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_idle(s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gdk_threads_add_timeout_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_timeout_full "guint gdk_threads_add_timeout_full(gint priority, guint interval, \
GSourceFunc func, lambda_data func_info, GDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, interval, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_full", 1, priority, "gint");
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_full", 2, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_full", 3, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_full", 4, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_full", 5, notify, "GDestroyNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_timeout_full(s7_integer(priority), s7_integer(interval), s7_c_pointer(func), (gpointer)lg_ptr, s7_c_pointer(notify)));
    return(result);
   }
}

static s7_pointer lg_gdk_threads_add_timeout(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_timeout "guint gdk_threads_add_timeout(guint interval, GSourceFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer interval, func, func_info;
  _p = args;
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout", 1, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout", 2, func, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout", 3, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_timeout(s7_integer(interval), s7_c_pointer(func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gdk_window_set_startup_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_startup_id "void gdk_window_set_startup_id(GdkWindow* window, gchar* startup_id)"
  s7_pointer _p;
  s7_pointer window, startup_id;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_startup_id", 1, window, "GdkWindow*");
  startup_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(startup_id)) s7_wrong_type_arg_error(sc, "gdk_window_set_startup_id", 2, startup_id, "gchar*");
  gdk_window_set_startup_id(s7_c_pointer(window), s7_string(startup_id));
  return(lg_false);
}

static s7_pointer lg_gdk_window_beep(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_beep "void gdk_window_beep(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_beep", 1, window, "GdkWindow*");
  gdk_window_beep(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_opacity(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_opacity "void gdk_window_set_opacity(GdkWindow* window, gdouble opacity)"
  s7_pointer _p;
  s7_pointer window, opacity;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_opacity", 1, window, "GdkWindow*");
  opacity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(opacity)) s7_wrong_type_arg_error(sc, "gdk_window_set_opacity", 2, opacity, "gdouble");
  gdk_window_set_opacity(s7_c_pointer(window), s7_real(opacity));
  return(lg_false);
}

static s7_pointer lg_gtk_binding_entry_skip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_entry_skip "void gtk_binding_entry_skip(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer binding_set, keyval, modifiers;
  _p = args;
  binding_set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(binding_set, GtkBindingSet__sym)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_skip", 1, binding_set, "GtkBindingSet*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_skip", 2, keyval, "guint");
  modifiers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_binding_entry_skip", 3, modifiers, "GdkModifierType");
  gtk_binding_entry_skip(s7_c_pointer(binding_set), s7_integer(keyval), s7_integer(modifiers));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_get_cells(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_get_cells "GList* gtk_cell_layout_get_cells(GtkCellLayout* cell_layout)"
  s7_pointer cell_layout;
  cell_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_get_cells", 1, cell_layout, "GtkCellLayout*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_cell_layout_get_cells(s7_c_pointer(cell_layout))));
}

static s7_pointer lg_gtk_entry_completion_set_inline_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_inline_selection "void gtk_entry_completion_set_inline_selection(GtkEntryCompletion* completion, \
gboolean inline_selection)"
  s7_pointer _p;
  s7_pointer completion, inline_selection;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_selection", 1, completion, "GtkEntryCompletion*");
  inline_selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(inline_selection)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_selection", 2, inline_selection, "gboolean");
  gtk_entry_completion_set_inline_selection(s7_c_pointer(completion), lg_boolean(inline_selection));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_inline_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_inline_selection "gboolean gtk_entry_completion_get_inline_selection(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_inline_selection", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_inline_selection(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_get_completion_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_completion_prefix "gchar* gtk_entry_completion_get_completion_prefix(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_completion_prefix", 1, completion, "GtkEntryCompletion*");
  return(s7_make_string(sc, gtk_entry_completion_get_completion_prefix(s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_set_cursor_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_cursor_hadjustment "void gtk_entry_set_cursor_hadjustment(GtkEntry* entry, \
GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer entry, adjustment;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_cursor_hadjustment", 1, entry, "GtkEntry*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_cursor_hadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_entry_set_cursor_hadjustment(s7_c_pointer(entry), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_cursor_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_cursor_hadjustment "GtkAdjustment* gtk_entry_get_cursor_hadjustment(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_cursor_hadjustment", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_entry_get_cursor_hadjustment(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_icon_theme_list_contexts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_list_contexts "GList* gtk_icon_theme_list_contexts(GtkIconTheme* icon_theme)"
  s7_pointer icon_theme;
  icon_theme = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_list_contexts", 1, icon_theme, "GtkIconTheme*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_icon_theme_list_contexts(s7_c_pointer(icon_theme))));
}

static s7_pointer lg_gtk_print_settings_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_new_from_file "GtkPrintSettings* gtk_print_settings_new_from_file(gchar* file_name, \
GError** [error])"
  s7_pointer _p;
  s7_pointer file_name;
  GError* ref_error = NULL;
  _p = args;
  file_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_print_settings_new_from_file", 1, file_name, "gchar*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GtkPrintSettings__sym, gtk_print_settings_new_from_file(s7_string(file_name), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_print_settings_to_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_to_file "gboolean gtk_print_settings_to_file(GtkPrintSettings* settings, \
gchar* file_name, GError** [error])"
  s7_pointer _p;
  s7_pointer settings, file_name;
  GError* ref_error = NULL;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_to_file", 1, settings, "GtkPrintSettings*");
  file_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_print_settings_to_file", 2, file_name, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_print_settings_to_file(s7_c_pointer(settings), s7_string(file_name), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_range_set_show_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_show_fill_level "void gtk_range_set_show_fill_level(GtkRange* range,  gboolean, \
show_fill_level)"
  s7_pointer _p;
  s7_pointer range, show_fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_show_fill_level", 1, range, "GtkRange*");
  show_fill_level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_show_fill_level", 2, show_fill_level, "gboolean");
  gtk_range_set_show_fill_level(s7_c_pointer(range), lg_boolean(show_fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_show_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_show_fill_level "gboolean gtk_range_get_show_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_show_fill_level", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_show_fill_level(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_restrict_to_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_restrict_to_fill_level "void gtk_range_set_restrict_to_fill_level(GtkRange* range, \
 gboolean, restrict_to_fill_level)"
  s7_pointer _p;
  s7_pointer range, restrict_to_fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_restrict_to_fill_level", 1, range, "GtkRange*");
  restrict_to_fill_level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(restrict_to_fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_restrict_to_fill_level", 2, restrict_to_fill_level, "gboolean");
  gtk_range_set_restrict_to_fill_level(s7_c_pointer(range), lg_boolean(restrict_to_fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_restrict_to_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_restrict_to_fill_level "gboolean gtk_range_get_restrict_to_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_restrict_to_fill_level", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_restrict_to_fill_level(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_fill_level "void gtk_range_set_fill_level(GtkRange* range,  gdouble, fill_level)"
  s7_pointer _p;
  s7_pointer range, fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_fill_level", 1, range, "GtkRange*");
  fill_level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_fill_level", 2, fill_level, "gdouble");
  gtk_range_set_fill_level(s7_c_pointer(range), s7_real(fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_fill_level "gdouble gtk_range_get_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_fill_level", 1, range, "GtkRange*");
  return(s7_make_real(sc, gtk_range_get_fill_level(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_tree_view_set_show_expanders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_show_expanders "void gtk_tree_view_set_show_expanders(GtkTreeView* tree_view, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer tree_view, enabled;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_show_expanders", 1, tree_view, "GtkTreeView*");
  enabled = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_show_expanders", 2, enabled, "gboolean");
  gtk_tree_view_set_show_expanders(s7_c_pointer(tree_view), lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_show_expanders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_show_expanders "gboolean gtk_tree_view_get_show_expanders(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_show_expanders", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_show_expanders(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_level_indentation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_level_indentation "void gtk_tree_view_set_level_indentation(GtkTreeView* tree_view, \
gint indentation)"
  s7_pointer _p;
  s7_pointer tree_view, indentation;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_level_indentation", 1, tree_view, "GtkTreeView*");
  indentation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(indentation)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_level_indentation", 2, indentation, "gint");
  gtk_tree_view_set_level_indentation(s7_c_pointer(tree_view), s7_integer(indentation));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_level_indentation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_level_indentation "gint gtk_tree_view_get_level_indentation(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_level_indentation", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_level_indentation(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_widget_keynav_failed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_keynav_failed "gboolean gtk_widget_keynav_failed(GtkWidget* widget, GtkDirectionType direction)"
  s7_pointer _p;
  s7_pointer widget, direction;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_keynav_failed", 1, widget, "GtkWidget*");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_widget_keynav_failed", 2, direction, "GtkDirectionType");
  return(s7_make_boolean(sc, gtk_widget_keynav_failed(s7_c_pointer(widget), s7_integer(direction))));
}

static s7_pointer lg_gtk_widget_error_bell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_error_bell "void gtk_widget_error_bell(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_error_bell", 1, widget, "GtkWidget*");
  gtk_widget_error_bell(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_tooltip_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_tooltip_window "void gtk_widget_set_tooltip_window(GtkWidget* widget, GtkWindow* custom_window)"
  s7_pointer _p;
  s7_pointer widget, custom_window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_window", 1, widget, "GtkWidget*");
  custom_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(custom_window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_window", 2, custom_window, "GtkWindow*");
  gtk_widget_set_tooltip_window(s7_c_pointer(widget), s7_c_pointer(custom_window));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_tooltip_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_tooltip_window "GtkWindow* gtk_widget_get_tooltip_window(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_tooltip_window", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWindow__sym, gtk_widget_get_tooltip_window(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_trigger_tooltip_query(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_trigger_tooltip_query "void gtk_widget_trigger_tooltip_query(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_trigger_tooltip_query", 1, widget, "GtkWidget*");
  gtk_widget_trigger_tooltip_query(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_startup_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_startup_id "void gtk_window_set_startup_id(GtkWindow* window, gchar* startup_id)"
  s7_pointer _p;
  s7_pointer window, startup_id;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_startup_id", 1, window, "GtkWindow*");
  startup_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(startup_id)) s7_wrong_type_arg_error(sc, "gtk_window_set_startup_id", 2, startup_id, "gchar*");
  gtk_window_set_startup_id(s7_c_pointer(window), s7_string(startup_id));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_add_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_add_mark "void gtk_text_buffer_add_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, mark, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 2, mark, "GtkTextMark*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 3, where, "GtkTextIter*");
  gtk_text_buffer_add_mark(s7_c_pointer(buffer), s7_c_pointer(mark), s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_new "GtkTextMark* gtk_text_mark_new(gchar* name, gboolean left_gravity)"
  s7_pointer _p;
  s7_pointer name, left_gravity;
  _p = args;
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_mark_new", 1, name, "gchar*");
  left_gravity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(left_gravity)) s7_wrong_type_arg_error(sc, "gtk_text_mark_new", 2, left_gravity, "gboolean");
  return(s7_make_type_with_c_pointer(sc, GtkTextMark__sym, gtk_text_mark_new(s7_string(name), lg_boolean(left_gravity))));
}

static s7_pointer lg_gtk_tree_view_column_get_tree_view(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_tree_view "GtkWidget* gtk_tree_view_column_get_tree_view(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_tree_view", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tree_view_column_get_tree_view(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tooltip_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_text "void gtk_tooltip_set_text(GtkTooltip* tooltip, gchar* text)"
  s7_pointer _p;
  s7_pointer tooltip, text;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_text", 1, tooltip, "GtkTooltip*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_text", 2, text, "gchar*");
  gtk_tooltip_set_text(s7_c_pointer(tooltip), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_convert_widget_to_tree_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_widget_to_tree_coords "void gtk_tree_view_convert_widget_to_tree_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [tx], gint* [ty])"
  s7_pointer _p;
  s7_pointer tree_view, wx, wy;
  gint ref_tx;
  gint ref_ty;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 1, tree_view, "GtkTreeView*");
  wx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 2, wx, "gint");
  wy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wy)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 3, wy, "gint");
  gtk_tree_view_convert_widget_to_tree_coords(s7_c_pointer(tree_view), s7_integer(wx), s7_integer(wy), &ref_tx, &ref_ty);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_tx), s7_make_integer(sc, ref_ty)));
}

static s7_pointer lg_gtk_tree_view_convert_tree_to_widget_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_tree_to_widget_coords "void gtk_tree_view_convert_tree_to_widget_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [wx], gint* [wy])"
  s7_pointer _p;
  s7_pointer tree_view, tx, ty;
  gint ref_wx;
  gint ref_wy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 1, tree_view, "GtkTreeView*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 2, tx, "gint");
  ty = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ty)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 3, ty, "gint");
  gtk_tree_view_convert_tree_to_widget_coords(s7_c_pointer(tree_view), s7_integer(tx), s7_integer(ty), &ref_wx, &ref_wy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_wx), s7_make_integer(sc, ref_wy)));
}

static s7_pointer lg_gtk_tree_view_convert_widget_to_bin_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_widget_to_bin_window_coords "void gtk_tree_view_convert_widget_to_bin_window_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [bx], gint* [by])"
  s7_pointer _p;
  s7_pointer tree_view, wx, wy;
  gint ref_bx;
  gint ref_by;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 1, tree_view, "GtkTreeView*");
  wx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 2, wx, "gint");
  wy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wy)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 3, wy, "gint");
  gtk_tree_view_convert_widget_to_bin_window_coords(s7_c_pointer(tree_view), s7_integer(wx), s7_integer(wy), &ref_bx, &ref_by);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_bx), s7_make_integer(sc, ref_by)));
}

static s7_pointer lg_gtk_tree_view_convert_bin_window_to_widget_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_bin_window_to_widget_coords "void gtk_tree_view_convert_bin_window_to_widget_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [wx], gint* [wy])"
  s7_pointer _p;
  s7_pointer tree_view, bx, by;
  gint ref_wx;
  gint ref_wy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 1, tree_view, "GtkTreeView*");
  bx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 2, bx, "gint");
  by = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(by)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 3, by, "gint");
  gtk_tree_view_convert_bin_window_to_widget_coords(s7_c_pointer(tree_view), s7_integer(bx), s7_integer(by), &ref_wx, &ref_wy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_wx), s7_make_integer(sc, ref_wy)));
}

static s7_pointer lg_gtk_tree_view_convert_tree_to_bin_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_tree_to_bin_window_coords "void gtk_tree_view_convert_tree_to_bin_window_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [bx], gint* [by])"
  s7_pointer _p;
  s7_pointer tree_view, tx, ty;
  gint ref_bx;
  gint ref_by;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 1, tree_view, "GtkTreeView*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 2, tx, "gint");
  ty = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ty)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 3, ty, "gint");
  gtk_tree_view_convert_tree_to_bin_window_coords(s7_c_pointer(tree_view), s7_integer(tx), s7_integer(ty), &ref_bx, &ref_by);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_bx), s7_make_integer(sc, ref_by)));
}

static s7_pointer lg_gtk_tree_view_convert_bin_window_to_tree_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_bin_window_to_tree_coords "void gtk_tree_view_convert_bin_window_to_tree_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [tx], gint* [ty])"
  s7_pointer _p;
  s7_pointer tree_view, bx, by;
  gint ref_tx;
  gint ref_ty;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 1, tree_view, "GtkTreeView*");
  bx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 2, bx, "gint");
  by = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(by)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 3, by, "gint");
  gtk_tree_view_convert_bin_window_to_tree_coords(s7_c_pointer(tree_view), s7_integer(bx), s7_integer(by), &ref_tx, &ref_ty);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_tx), s7_make_integer(sc, ref_ty)));
}

static s7_pointer lg_gtk_widget_set_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_tooltip_text "void gtk_widget_set_tooltip_text(GtkWidget* widget, gchar* text)"
  s7_pointer _p;
  s7_pointer widget, text;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_text", 1, widget, "GtkWidget*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_text", 2, text, "gchar*");
  gtk_widget_set_tooltip_text(s7_c_pointer(widget), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_tooltip_text "gchar* gtk_widget_get_tooltip_text(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_tooltip_text", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_tooltip_text(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_tooltip_markup "void gtk_widget_set_tooltip_markup(GtkWidget* widget, gchar* markup)"
  s7_pointer _p;
  s7_pointer widget, markup;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_markup", 1, widget, "GtkWidget*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_markup", 2, markup, "gchar*");
  gtk_widget_set_tooltip_markup(s7_c_pointer(widget), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_tooltip_markup "gchar* gtk_widget_get_tooltip_markup(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_tooltip_markup", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_tooltip_markup(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_tree_view_is_rubber_banding_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_is_rubber_banding_active "gboolean gtk_tree_view_is_rubber_banding_active(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_rubber_banding_active", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_is_rubber_banding_active(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_icon_view_set_tooltip_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_item "void gtk_icon_view_set_tooltip_item(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, tooltip, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 1, icon_view, "GtkIconView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 3, path, "GtkTreePath*");
  gtk_icon_view_set_tooltip_item(s7_c_pointer(icon_view), s7_c_pointer(tooltip), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_set_tooltip_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_cell "void gtk_icon_view_set_tooltip_cell(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer icon_view, tooltip, path, cell;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 1, icon_view, "GtkIconView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 3, path, "GtkTreePath*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 4, cell, "GtkCellRenderer*");
  gtk_icon_view_set_tooltip_cell(s7_c_pointer(icon_view), s7_c_pointer(tooltip), s7_c_pointer(path), s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_tooltip_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_tooltip_context "gboolean gtk_icon_view_get_tooltip_context(GtkIconView* icon_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer icon_view, keyboard_tip, iter;
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 1, icon_view, "GtkIconView*");
  keyboard_tip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(keyboard_tip)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 4, keyboard_tip, "gboolean");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 7, iter, "GtkTreeIter*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_icon_view_get_tooltip_context(s7_c_pointer(icon_view), &ref_x, &ref_y, lg_boolean(keyboard_tip), &ref_model, &ref_path, s7_c_pointer(iter)));
      return(s7_list(sc, 5, result, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_c_pointer(sc, ref_model), s7_make_c_pointer(sc, ref_path)));
   }
}

static s7_pointer lg_gtk_icon_view_set_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_column "void gtk_icon_view_set_tooltip_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_column", 2, column, "gint");
  gtk_icon_view_set_tooltip_column(s7_c_pointer(icon_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_tooltip_column "gint gtk_icon_view_get_tooltip_column(GtkIconView* icon_view, \
)"
  s7_pointer icon_view ;
  icon_view  = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view , GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_column", 1, icon_view , "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_tooltip_column(s7_c_pointer(icon_view ))));
}

static s7_pointer lg_gtk_menu_tool_button_set_arrow_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_tool_button_set_arrow_tooltip_text "void gtk_menu_tool_button_set_arrow_tooltip_text(GtkMenuToolButton* button, \
gchar* text)"
  s7_pointer _p;
  s7_pointer button, text;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkMenuToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_arrow_tooltip_text", 1, button, "GtkMenuToolButton*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_arrow_tooltip_text", 2, text, "gchar*");
  gtk_menu_tool_button_set_arrow_tooltip_text(s7_c_pointer(button), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_tool_button_set_arrow_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_tool_button_set_arrow_tooltip_markup "void gtk_menu_tool_button_set_arrow_tooltip_markup(GtkMenuToolButton* button, \
gchar* markup)"
  s7_pointer _p;
  s7_pointer button, markup;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkMenuToolButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_arrow_tooltip_markup", 1, button, "GtkMenuToolButton*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_menu_tool_button_set_arrow_tooltip_markup", 2, markup, "gchar*");
  gtk_menu_tool_button_set_arrow_tooltip_markup(s7_c_pointer(button), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_set_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_tooltip_text "void gtk_tool_item_set_tooltip_text(GtkToolItem* tool_item, \
gchar* text)"
  s7_pointer _p;
  s7_pointer tool_item, text;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_tooltip_text", 1, tool_item, "GtkToolItem*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_tooltip_text", 2, text, "gchar*");
  gtk_tool_item_set_tooltip_text(s7_c_pointer(tool_item), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_set_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_set_tooltip_markup "void gtk_tool_item_set_tooltip_markup(GtkToolItem* tool_item, \
gchar* markup)"
  s7_pointer _p;
  s7_pointer tool_item, markup;
  _p = args;
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_tooltip_markup", 1, tool_item, "GtkToolItem*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_tool_item_set_tooltip_markup", 2, markup, "gchar*");
  gtk_tool_item_set_tooltip_markup(s7_c_pointer(tool_item), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_tip_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_tip_area "void gtk_tooltip_set_tip_area(GtkTooltip* tooltip, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tooltip, rect;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_tip_area", 1, tooltip, "GtkTooltip*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_tip_area", 2, rect, "GdkRectangle*");
  gtk_tooltip_set_tip_area(s7_c_pointer(tooltip), s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_tooltip_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_row "void gtk_tree_view_set_tooltip_row(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, tooltip, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 1, tree_view, "GtkTreeView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 3, path, "GtkTreePath*");
  gtk_tree_view_set_tooltip_row(s7_c_pointer(tree_view), s7_c_pointer(tooltip), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_tooltip_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_cell "void gtk_tree_view_set_tooltip_cell(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkTreeViewColumn* column, GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer tree_view, tooltip, path, column, cell;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 1, tree_view, "GtkTreeView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 3, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 4, column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 5, cell, "GtkCellRenderer*");
  gtk_tree_view_set_tooltip_cell(s7_c_pointer(tree_view), s7_c_pointer(tooltip), s7_c_pointer(path), s7_c_pointer(column), s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_tooltip_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_tooltip_context "gboolean gtk_tree_view_get_tooltip_context(GtkTreeView* tree_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_view, keyboard_tip, iter;
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 1, tree_view, "GtkTreeView*");
  keyboard_tip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(keyboard_tip)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 4, keyboard_tip, "gboolean");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 7, iter, "GtkTreeIter*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_get_tooltip_context(s7_c_pointer(tree_view), &ref_x, &ref_y, lg_boolean(keyboard_tip), &ref_model, &ref_path, s7_c_pointer(iter)));
      return(s7_list(sc, 5, result, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_c_pointer(sc, ref_model), s7_make_c_pointer(sc, ref_path)));
   }
}

static s7_pointer lg_gtk_tree_view_set_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_column "void gtk_tree_view_set_tooltip_column(GtkTreeView* tree_view, \
gint column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_column", 2, column, "gint");
  gtk_tree_view_set_tooltip_column(s7_c_pointer(tree_view), s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_tooltip_column "gint gtk_tree_view_get_tooltip_column(GtkTreeView* tree_view, \
)"
  s7_pointer tree_view ;
  tree_view  = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view , GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_column", 1, tree_view , "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_tooltip_column(s7_c_pointer(tree_view ))));
}

static s7_pointer lg_gtk_widget_set_has_tooltip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_has_tooltip "void gtk_widget_set_has_tooltip(GtkWidget* widget, gboolean has_tooltip)"
  s7_pointer _p;
  s7_pointer widget, has_tooltip;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_tooltip", 1, widget, "GtkWidget*");
  has_tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_tooltip)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_tooltip", 2, has_tooltip, "gboolean");
  gtk_widget_set_has_tooltip(s7_c_pointer(widget), lg_boolean(has_tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_has_tooltip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_has_tooltip "gboolean gtk_widget_get_has_tooltip(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_has_tooltip", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_has_tooltip(s7_c_pointer(widget))));
}

#if GTK_CHECK_VERSION(2, 14, 0)
static s7_pointer lg_gtk_calendar_set_detail_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_func "void gtk_calendar_set_detail_func(GtkCalendar* calendar, GtkCalendarDetailFunc func, \
gpointer data, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer calendar, func, data, destroy;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 1, calendar, "GtkCalendar*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkCalendarDetailFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 2, func, "GtkCalendarDetailFunc");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 3, data, "gpointer");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 4, destroy, "GDestroyNotify");
  gtk_calendar_set_detail_func(s7_c_pointer(calendar), s7_c_pointer(func), s7_c_pointer(data), s7_c_pointer(destroy));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_set_detail_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_width_chars "void gtk_calendar_set_detail_width_chars(GtkCalendar* calendar, \
gint chars)"
  s7_pointer _p;
  s7_pointer calendar, chars;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_width_chars", 1, calendar, "GtkCalendar*");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(chars)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_width_chars", 2, chars, "gint");
  gtk_calendar_set_detail_width_chars(s7_c_pointer(calendar), s7_integer(chars));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_set_detail_height_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_height_rows "void gtk_calendar_set_detail_height_rows(GtkCalendar* calendar, \
gint rows)"
  s7_pointer _p;
  s7_pointer calendar, rows;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_height_rows", 1, calendar, "GtkCalendar*");
  rows = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rows)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_height_rows", 2, rows, "gint");
  gtk_calendar_set_detail_height_rows(s7_c_pointer(calendar), s7_integer(rows));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_detail_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_detail_width_chars "gint gtk_calendar_get_detail_width_chars(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_detail_width_chars", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_detail_width_chars(s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_calendar_get_detail_height_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_detail_height_rows "gint gtk_calendar_get_detail_height_rows(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_detail_height_rows", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_detail_height_rows(s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_accel_group_get_is_locked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_get_is_locked "gboolean gtk_accel_group_get_is_locked(GtkAccelGroup* accel_group)"
  s7_pointer accel_group;
  accel_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_get_is_locked", 1, accel_group, "GtkAccelGroup*");
  return(s7_make_boolean(sc, gtk_accel_group_get_is_locked(s7_c_pointer(accel_group))));
}

static s7_pointer lg_gtk_dialog_get_content_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_content_area "GtkWidget* gtk_dialog_get_content_area(GtkDialog* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_content_area", 1, dialog, "GtkDialog*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_dialog_get_content_area(s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_entry_set_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_overwrite_mode "void gtk_entry_set_overwrite_mode(GtkEntry* entry, gboolean overwrite)"
  s7_pointer _p;
  s7_pointer entry, overwrite;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_overwrite_mode", 1, entry, "GtkEntry*");
  overwrite = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(overwrite)) s7_wrong_type_arg_error(sc, "gtk_entry_set_overwrite_mode", 2, overwrite, "gboolean");
  gtk_entry_set_overwrite_mode(s7_c_pointer(entry), lg_boolean(overwrite));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_overwrite_mode "gboolean gtk_entry_get_overwrite_mode(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_overwrite_mode", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_overwrite_mode(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_get_text_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_text_length "guint16 gtk_entry_get_text_length(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_text_length", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_text_length(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_menu_get_accel_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_accel_path "gchar* gtk_menu_get_accel_path(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_accel_path", 1, menu, "GtkMenu*");
  return(s7_make_string(sc, gtk_menu_get_accel_path(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_menu_get_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_monitor "gint gtk_menu_get_monitor(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_monitor", 1, menu, "GtkMenu*");
  return(s7_make_integer(sc, gtk_menu_get_monitor(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_menu_item_get_accel_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_get_accel_path "gchar* gtk_menu_item_get_accel_path(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_get_accel_path", 1, menu_item, "GtkMenuItem*");
  return(s7_make_string(sc, gtk_menu_item_get_accel_path(s7_c_pointer(menu_item))));
}

static s7_pointer lg_gtk_scale_button_get_plus_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_plus_button "GtkWidget* gtk_scale_button_get_plus_button(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_plus_button", 1, button, "GtkScaleButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scale_button_get_plus_button(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_scale_button_get_minus_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_minus_button "GtkWidget* gtk_scale_button_get_minus_button(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_minus_button", 1, button, "GtkScaleButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scale_button_get_minus_button(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_scale_button_get_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_popup "GtkWidget* gtk_scale_button_get_popup(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_popup", 1, button, "GtkScaleButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scale_button_get_popup(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_selection_data_get_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_target "GdkAtom gtk_selection_data_get_target(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_target", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_selection_data_get_target(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_data_get_data_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_data_type "GdkAtom gtk_selection_data_get_data_type(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_data_type", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_selection_data_get_data_type(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_data_get_format(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_format "gint gtk_selection_data_get_format(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_format", 1, selection_data, "GtkSelectionData*");
  return(s7_make_integer(sc, gtk_selection_data_get_format(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_data_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_display "GdkDisplay* gtk_selection_data_get_display(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_display", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gtk_selection_data_get_display(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_widget_get_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_window "GdkWindow* gtk_widget_get_window(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_window", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gtk_widget_get_window(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_accel_group_get_modifier_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_group_get_modifier_mask "GdkModifierType gtk_accel_group_get_modifier_mask(GtkAccelGroup* accel_group)"
  s7_pointer accel_group;
  accel_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_group, GtkAccelGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_group_get_modifier_mask", 1, accel_group, "GtkAccelGroup*");
  return(s7_make_integer(sc, gtk_accel_group_get_modifier_mask(s7_c_pointer(accel_group))));
}

static s7_pointer lg_gdk_threads_add_timeout_seconds_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_timeout_seconds_full "guint gdk_threads_add_timeout_seconds_full(gint priority, \
guint interval, GSourceFunc function, lambda_data func_info, GDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, interval, function, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds_full", 1, priority, "gint");
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds_full", 2, interval, "guint");
  function = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(function, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds_full", 3, function, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds_full", 4, func_info, "lambda_data");
  notify = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notify, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds_full", 5, notify, "GDestroyNotify");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_timeout_seconds_full(s7_integer(priority), s7_integer(interval), s7_c_pointer(function), (gpointer)lg_ptr, s7_c_pointer(notify)));
    return(result);
   }
}

static s7_pointer lg_gdk_threads_add_timeout_seconds(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_threads_add_timeout_seconds "guint gdk_threads_add_timeout_seconds(guint interval, GSourceFunc function, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer interval, function, func_info;
  _p = args;
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds", 1, interval, "guint");
  function = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(function, GSourceFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds", 2, function, "GSourceFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_threads_add_timeout_seconds", 3, func_info, "lambda_data");
  {
    s7_pointer result;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    result = s7_make_integer(sc, gdk_threads_add_timeout_seconds(s7_integer(interval), s7_c_pointer(function), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gtk_adjustment_get_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_lower "gdouble gtk_adjustment_get_lower(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_lower", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_lower(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_lower "void gtk_adjustment_set_lower(GtkAdjustment* adjustment, gdouble lower)"
  s7_pointer _p;
  s7_pointer adjustment, lower;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_lower", 1, adjustment, "GtkAdjustment*");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_lower", 2, lower, "gdouble");
  gtk_adjustment_set_lower(s7_c_pointer(adjustment), s7_real(lower));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_upper "gdouble gtk_adjustment_get_upper(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_upper", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_upper(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_upper "void gtk_adjustment_set_upper(GtkAdjustment* adjustment, gdouble upper)"
  s7_pointer _p;
  s7_pointer adjustment, upper;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_upper", 1, adjustment, "GtkAdjustment*");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_upper", 2, upper, "gdouble");
  gtk_adjustment_set_upper(s7_c_pointer(adjustment), s7_real(upper));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_step_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_step_increment "gdouble gtk_adjustment_get_step_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_step_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_step_increment(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_step_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_step_increment "void gtk_adjustment_set_step_increment(GtkAdjustment* adjustment, \
gdouble step_increment)"
  s7_pointer _p;
  s7_pointer adjustment, step_increment;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_step_increment", 1, adjustment, "GtkAdjustment*");
  step_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_step_increment", 2, step_increment, "gdouble");
  gtk_adjustment_set_step_increment(s7_c_pointer(adjustment), s7_real(step_increment));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_page_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_page_increment "gdouble gtk_adjustment_get_page_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_page_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_page_increment(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_page_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_page_increment "void gtk_adjustment_set_page_increment(GtkAdjustment* adjustment, \
gdouble page_increment)"
  s7_pointer _p;
  s7_pointer adjustment, page_increment;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_increment", 1, adjustment, "GtkAdjustment*");
  page_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_increment", 2, page_increment, "gdouble");
  gtk_adjustment_set_page_increment(s7_c_pointer(adjustment), s7_real(page_increment));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_page_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_page_size "gdouble gtk_adjustment_get_page_size(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_page_size", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_page_size(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_page_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_page_size "void gtk_adjustment_set_page_size(GtkAdjustment* adjustment, \
gdouble page_size)"
  s7_pointer _p;
  s7_pointer adjustment, page_size;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_size", 1, adjustment, "GtkAdjustment*");
  page_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_size", 2, page_size, "gdouble");
  gtk_adjustment_set_page_size(s7_c_pointer(adjustment), s7_real(page_size));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_configure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_configure "void gtk_adjustment_configure(GtkAdjustment* adjustment, gdouble value, \
gdouble lower, gdouble upper, gdouble step_increment, gdouble page_increment, gdouble page_size)"
  s7_pointer _p;
  s7_pointer adjustment, value, lower, upper, step_increment, page_increment, page_size;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 1, adjustment, "GtkAdjustment*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 2, value, "gdouble");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 3, lower, "gdouble");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 4, upper, "gdouble");
  step_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 5, step_increment, "gdouble");
  page_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 6, page_increment, "gdouble");
  page_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 7, page_size, "gdouble");
  gtk_adjustment_configure(s7_c_pointer(adjustment), s7_real(value), s7_real(lower), s7_real(upper), s7_real(step_increment), s7_real(page_increment), s7_real(page_size));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_button_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_button_sensitivity "void gtk_combo_box_set_button_sensitivity(GtkComboBox* combo_box, \
GtkSensitivityType sensitivity)"
  s7_pointer _p;
  s7_pointer combo_box, sensitivity;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_button_sensitivity", 1, combo_box, "GtkComboBox*");
  sensitivity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sensitivity)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_button_sensitivity", 2, sensitivity, "GtkSensitivityType");
  gtk_combo_box_set_button_sensitivity(s7_c_pointer(combo_box), s7_integer(sensitivity));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_button_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_button_sensitivity "GtkSensitivityType gtk_combo_box_get_button_sensitivity(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_button_sensitivity", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_button_sensitivity(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_file_chooser_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_file "GFile* gtk_file_chooser_get_file(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_file", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GFile__sym, gtk_file_chooser_get_file(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_file "gboolean gtk_file_chooser_set_file(GtkFileChooser* chooser, GFile* file, \
GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, file;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_file", 2, file, "GFile*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_set_file(s7_c_pointer(chooser), s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_select_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_file "gboolean gtk_file_chooser_select_file(GtkFileChooser* chooser, \
GFile* file, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, file;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_file", 2, file, "GFile*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_select_file(s7_c_pointer(chooser), s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_unselect_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_file "void gtk_file_chooser_unselect_file(GtkFileChooser* chooser, \
GFile* file)"
  s7_pointer _p;
  s7_pointer chooser, file;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_file", 2, file, "GFile*");
  gtk_file_chooser_unselect_file(s7_c_pointer(chooser), s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_files(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_files "GSList* gtk_file_chooser_get_files(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_files", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_file_chooser_get_files(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_current_folder_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_current_folder_file "gboolean gtk_file_chooser_set_current_folder_file(GtkFileChooser* chooser, \
GFile* file, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, file;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder_file", 2, file, "GFile*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_file_chooser_set_current_folder_file(s7_c_pointer(chooser), s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_get_current_folder_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_folder_file "GFile* gtk_file_chooser_get_current_folder_file(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_folder_file", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GFile__sym, gtk_file_chooser_get_current_folder_file(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_get_preview_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_preview_file "GFile* gtk_file_chooser_get_preview_file(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_preview_file", 1, chooser, "GtkFileChooser*");
  return(s7_make_type_with_c_pointer(sc, GFile__sym, gtk_file_chooser_get_preview_file(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_window_get_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_widget "GtkWidget* gtk_window_get_default_widget(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_default_widget", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_get_default_widget(s7_c_pointer(window))));
}

#endif

#if GTK_CHECK_VERSION(2, 16, 0)
static s7_pointer lg_gtk_link_button_get_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_get_visited "gboolean gtk_link_button_get_visited(GtkLinkButton* link_button)"
  s7_pointer link_button;
  link_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_get_visited", 1, link_button, "GtkLinkButton*");
  return(s7_make_boolean(sc, gtk_link_button_get_visited(s7_c_pointer(link_button))));
}

static s7_pointer lg_gtk_link_button_set_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_set_visited "void gtk_link_button_set_visited(GtkLinkButton* link_button, \
bool visited)"
  s7_pointer _p;
  s7_pointer link_button, visited;
  _p = args;
  link_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_visited", 1, link_button, "GtkLinkButton*");
  visited = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visited)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_visited", 2, visited, "bool");
  gtk_link_button_set_visited(s7_c_pointer(link_button), lg_boolean(visited));
  return(lg_false);
}

static s7_pointer lg_gdk_keymap_get_caps_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_caps_lock_state "gboolean gdk_keymap_get_caps_lock_state(GdkKeymap* keymap)"
  s7_pointer keymap;
  keymap = s7_car(args);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_caps_lock_state", 1, keymap, "GdkKeymap*");
  return(s7_make_boolean(sc, gdk_keymap_get_caps_lock_state(s7_c_pointer(keymap))));
}

static s7_pointer lg_gtk_cell_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_model "GtkTreeModel* gtk_cell_view_get_model(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_model", 1, cell_view, "GtkCellView*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeModel__sym, gtk_cell_view_get_model(s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_entry_unset_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_unset_invisible_char "void gtk_entry_unset_invisible_char(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_unset_invisible_char", 1, entry, "GtkEntry*");
  gtk_entry_unset_invisible_char(s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_progress_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_progress_fraction "void gtk_entry_set_progress_fraction(GtkEntry* entry, gdouble fraction)"
  s7_pointer _p;
  s7_pointer entry, fraction;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_fraction", 1, entry, "GtkEntry*");
  fraction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_fraction", 2, fraction, "gdouble");
  gtk_entry_set_progress_fraction(s7_c_pointer(entry), s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_progress_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_progress_fraction "gdouble gtk_entry_get_progress_fraction(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_progress_fraction", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_progress_fraction(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_progress_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_progress_pulse_step "void gtk_entry_set_progress_pulse_step(GtkEntry* entry, \
gdouble fraction)"
  s7_pointer _p;
  s7_pointer entry, fraction;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_pulse_step", 1, entry, "GtkEntry*");
  fraction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_pulse_step", 2, fraction, "gdouble");
  gtk_entry_set_progress_pulse_step(s7_c_pointer(entry), s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_progress_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_progress_pulse_step "gdouble gtk_entry_get_progress_pulse_step(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_progress_pulse_step", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_progress_pulse_step(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_progress_pulse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_progress_pulse "void gtk_entry_progress_pulse(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_progress_pulse", 1, entry, "GtkEntry*");
  gtk_entry_progress_pulse(s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_from_pixbuf "void gtk_entry_set_icon_from_pixbuf(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, pixbuf;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_pixbuf", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_pixbuf", 2, icon_pos, "GtkEntryIconPosition");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_pixbuf", 3, pixbuf, "GdkPixbuf*");
  gtk_entry_set_icon_from_pixbuf(s7_c_pointer(entry), s7_integer(icon_pos), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_from_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_from_icon_name "void gtk_entry_set_icon_from_icon_name(GtkEntry* entry, \
GtkEntryIconPosition icon_pos, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, icon_name;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_icon_name", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_icon_name", 2, icon_pos, "GtkEntryIconPosition");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_icon_name", 3, icon_name, "gchar*");
  gtk_entry_set_icon_from_icon_name(s7_c_pointer(entry), s7_integer(icon_pos), s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_from_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_from_gicon "void gtk_entry_set_icon_from_gicon(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GIcon* icon)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, icon;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_gicon", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_gicon", 2, icon_pos, "GtkEntryIconPosition");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_from_gicon", 3, icon, "GIcon*");
  gtk_entry_set_icon_from_gicon(s7_c_pointer(entry), s7_integer(icon_pos), s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_name "gchar* gtk_entry_get_icon_name(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_name", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_name", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_name(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_set_icon_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_activatable "void gtk_entry_set_icon_activatable(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean activatable)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, activatable;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 2, icon_pos, "GtkEntryIconPosition");
  activatable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(activatable)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 3, activatable, "gboolean");
  gtk_entry_set_icon_activatable(s7_c_pointer(entry), s7_integer(icon_pos), lg_boolean(activatable));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_activatable "gboolean gtk_entry_get_icon_activatable(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_activatable", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_activatable", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_boolean(sc, gtk_entry_get_icon_activatable(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_set_icon_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_sensitive "void gtk_entry_set_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean sensitive)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, sensitive;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 2, icon_pos, "GtkEntryIconPosition");
  sensitive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 3, sensitive, "gboolean");
  gtk_entry_set_icon_sensitive(s7_c_pointer(entry), s7_integer(icon_pos), lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_sensitive "gboolean gtk_entry_get_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_sensitive", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_sensitive", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_boolean(sc, gtk_entry_get_icon_sensitive(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_at_pos "gint gtk_entry_get_icon_at_pos(GtkEntry* entry, gint x, gint y)"
  s7_pointer _p;
  s7_pointer entry, x, y;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 1, entry, "GtkEntry*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 3, y, "gint");
  return(s7_make_integer(sc, gtk_entry_get_icon_at_pos(s7_c_pointer(entry), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_entry_set_icon_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_tooltip_text "void gtk_entry_set_icon_tooltip_text(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gchar* tooltip)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, tooltip;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 2, icon_pos, "GtkEntryIconPosition");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tooltip)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 3, tooltip, "gchar*");
  gtk_entry_set_icon_tooltip_text(s7_c_pointer(entry), s7_integer(icon_pos), s7_string(tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_tooltip_markup "void gtk_entry_set_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos, gchar* tooltip)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, tooltip;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 2, icon_pos, "GtkEntryIconPosition");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tooltip)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 3, tooltip, "gchar*");
  gtk_entry_set_icon_tooltip_markup(s7_c_pointer(entry), s7_integer(icon_pos), s7_string(tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_drag_source "void gtk_entry_set_icon_drag_source(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GtkTargetList* target_list, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, target_list, actions;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 2, icon_pos, "GtkEntryIconPosition");
  target_list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target_list, GtkTargetList__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 3, target_list, "GtkTargetList*");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 4, actions, "GdkDragAction");
  gtk_entry_set_icon_drag_source(s7_c_pointer(entry), s7_integer(icon_pos), s7_c_pointer(target_list), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_current_icon_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_current_icon_drag_source "gint gtk_entry_get_current_icon_drag_source(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_current_icon_drag_source", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_current_icon_drag_source(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_menu_item_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_set_label "void gtk_menu_item_set_label(GtkMenuItem* menu_item, gchar* label)"
  s7_pointer _p;
  s7_pointer menu_item, label;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_label", 1, menu_item, "GtkMenuItem*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_label", 2, label, "gchar*");
  gtk_menu_item_set_label(s7_c_pointer(menu_item), s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_get_label "gchar* gtk_menu_item_get_label(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_get_label", 1, menu_item, "GtkMenuItem*");
  return(s7_make_string(sc, gtk_menu_item_get_label(s7_c_pointer(menu_item))));
}

static s7_pointer lg_gtk_menu_item_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_set_use_underline "void gtk_menu_item_set_use_underline(GtkMenuItem* menu_item, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer menu_item, setting;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_use_underline", 1, menu_item, "GtkMenuItem*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_use_underline", 2, setting, "gboolean");
  gtk_menu_item_set_use_underline(s7_c_pointer(menu_item), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_get_use_underline "gboolean gtk_menu_item_get_use_underline(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_get_use_underline", 1, menu_item, "GtkMenuItem*");
  return(s7_make_boolean(sc, gtk_menu_item_get_use_underline(s7_c_pointer(menu_item))));
}

static s7_pointer lg_gtk_selection_data_get_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_selection "GdkAtom gtk_selection_data_get_selection(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_selection", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_selection_data_get_selection(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_entry_get_icon_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_tooltip_text "gchar* gtk_entry_get_icon_tooltip_text(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_text", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_text", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_tooltip_text(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_tooltip_markup "gchar* gtk_entry_get_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_markup", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_markup", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_tooltip_markup(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_scale_add_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_add_mark "void gtk_scale_add_mark(GtkScale* scale, gdouble value, GtkPositionType position, \
gchar* markup)"
  s7_pointer _p;
  s7_pointer scale, value, position, markup;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 1, scale, "GtkScale*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 2, value, "gdouble");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 3, position, "GtkPositionType");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 4, markup, "gchar*");
  gtk_scale_add_mark(s7_c_pointer(scale), s7_real(value), s7_integer(position), s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_clear_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_clear_marks "void gtk_scale_clear_marks(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_clear_marks", 1, scale, "GtkScale*");
  gtk_scale_clear_marks(s7_c_pointer(scale));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(2, 18, 0)
static s7_pointer lg_gtk_window_get_default_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_icon_name "gchar* gtk_window_get_default_icon_name( void)"
  return(s7_make_string(sc, gtk_window_get_default_icon_name()));
}

static s7_pointer lg_gtk_label_get_current_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_current_uri "gchar* gtk_label_get_current_uri(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_current_uri", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_current_uri(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_info_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_new "GtkWidget* gtk_info_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_info_bar_new()));
}

static s7_pointer lg_gtk_info_bar_get_action_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_action_area "GtkWidget* gtk_info_bar_get_action_area(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_action_area", 1, info_bar, "GtkInfoBar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_info_bar_get_action_area(s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_info_bar_get_content_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_content_area "GtkWidget* gtk_info_bar_get_content_area(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_content_area", 1, info_bar, "GtkInfoBar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_info_bar_get_content_area(s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_info_bar_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_add_action_widget "void gtk_info_bar_add_action_widget(GtkInfoBar* info_bar, \
GtkWidget* child, gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, child, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 1, info_bar, "GtkInfoBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 2, child, "GtkWidget*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 3, response_id, "gint");
  gtk_info_bar_add_action_widget(s7_c_pointer(info_bar), s7_c_pointer(child), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_add_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_add_button "GtkWidget* gtk_info_bar_add_button(GtkInfoBar* info_bar, gchar* button_text, \
gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, button_text, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 1, info_bar, "GtkInfoBar*");
  button_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(button_text)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 2, button_text, "gchar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 3, response_id, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_info_bar_add_button(s7_c_pointer(info_bar), s7_string(button_text), s7_integer(response_id))));
}

static s7_pointer lg_gtk_info_bar_set_response_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_response_sensitive "void gtk_info_bar_set_response_sensitive(GtkInfoBar* info_bar, \
gint response_id, gboolean setting)"
  s7_pointer _p;
  s7_pointer info_bar, response_id, setting;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 2, response_id, "gint");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 3, setting, "gboolean");
  gtk_info_bar_set_response_sensitive(s7_c_pointer(info_bar), s7_integer(response_id), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_default_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_default_response "void gtk_info_bar_set_default_response(GtkInfoBar* info_bar, \
gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_default_response", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_default_response", 2, response_id, "gint");
  gtk_info_bar_set_default_response(s7_c_pointer(info_bar), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_response "void gtk_info_bar_response(GtkInfoBar* info_bar, gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_response", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_response", 2, response_id, "gint");
  gtk_info_bar_response(s7_c_pointer(info_bar), s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_message_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_message_type "void gtk_info_bar_set_message_type(GtkInfoBar* info_bar, GtkMessageType message_type)"
  s7_pointer _p;
  s7_pointer info_bar, message_type;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_message_type", 1, info_bar, "GtkInfoBar*");
  message_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(message_type)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_message_type", 2, message_type, "GtkMessageType");
  gtk_info_bar_set_message_type(s7_c_pointer(info_bar), s7_integer(message_type));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_message_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_message_type "GtkMessageType gtk_info_bar_get_message_type(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_message_type", 1, info_bar, "GtkInfoBar*");
  return(s7_make_integer(sc, gtk_info_bar_get_message_type(s7_c_pointer(info_bar))));
}

static s7_pointer lg_gdk_window_get_root_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_root_coords "void gdk_window_get_root_coords(GdkWindow* window, gint x, gint y, \
gint* [root_x], gint* [root_y])"
  s7_pointer _p;
  s7_pointer window, x, y;
  gint ref_root_x;
  gint ref_root_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_root_coords", 1, window, "GdkWindow*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_window_get_root_coords", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_window_get_root_coords", 3, y, "gint");
  gdk_window_get_root_coords(s7_c_pointer(window), s7_integer(x), s7_integer(y), &ref_root_x, &ref_root_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_root_x), s7_make_integer(sc, ref_root_y)));
}

static s7_pointer lg_gtk_menu_set_reserve_toggle_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_set_reserve_toggle_size "void gtk_menu_set_reserve_toggle_size(GtkMenu* menu, gboolean reserve_toggle_size)"
  s7_pointer _p;
  s7_pointer menu, reserve_toggle_size;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_set_reserve_toggle_size", 1, menu, "GtkMenu*");
  reserve_toggle_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reserve_toggle_size)) s7_wrong_type_arg_error(sc, "gtk_menu_set_reserve_toggle_size", 2, reserve_toggle_size, "gboolean");
  gtk_menu_set_reserve_toggle_size(s7_c_pointer(menu), lg_boolean(reserve_toggle_size));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_get_reserve_toggle_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_get_reserve_toggle_size "gboolean gtk_menu_get_reserve_toggle_size(GtkMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_get_reserve_toggle_size", 1, menu, "GtkMenu*");
  return(s7_make_boolean(sc, gtk_menu_get_reserve_toggle_size(s7_c_pointer(menu))));
}

static s7_pointer lg_gtk_entry_new_with_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_new_with_buffer "GtkWidget* gtk_entry_new_with_buffer(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_new_with_buffer", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_entry_new_with_buffer(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_buffer "GtkEntryBuffer* gtk_entry_get_buffer(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_buffer", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, GtkEntryBuffer__sym, gtk_entry_get_buffer(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_buffer "void gtk_entry_set_buffer(GtkEntry* entry, GtkEntryBuffer* buffer)"
  s7_pointer _p;
  s7_pointer entry, buffer;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_buffer", 1, entry, "GtkEntry*");
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_buffer", 2, buffer, "GtkEntryBuffer*");
  gtk_entry_set_buffer(s7_c_pointer(entry), s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_track_visited_links(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_track_visited_links "void gtk_label_set_track_visited_links(GtkLabel* label, \
gboolean track_links)"
  s7_pointer _p;
  s7_pointer label, track_links;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_track_visited_links", 1, label, "GtkLabel*");
  track_links = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(track_links)) s7_wrong_type_arg_error(sc, "gtk_label_set_track_visited_links", 2, track_links, "gboolean");
  gtk_label_set_track_visited_links(s7_c_pointer(label), lg_boolean(track_links));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_track_visited_links(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_track_visited_links "gboolean gtk_label_get_track_visited_links(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_track_visited_links", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_track_visited_links(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_print_operation_set_embed_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_embed_page_setup "void gtk_print_operation_set_embed_page_setup(GtkPrintOperation* op, \
gboolean embed)"
  s7_pointer _p;
  s7_pointer op, embed;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_embed_page_setup", 1, op, "GtkPrintOperation*");
  embed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(embed)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_embed_page_setup", 2, embed, "gboolean");
  gtk_print_operation_set_embed_page_setup(s7_c_pointer(op), lg_boolean(embed));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_embed_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_embed_page_setup "gboolean gtk_print_operation_get_embed_page_setup(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_embed_page_setup", 1, op, "GtkPrintOperation*");
  return(s7_make_boolean(sc, gtk_print_operation_get_embed_page_setup(s7_c_pointer(op))));
}

static s7_pointer lg_gtk_entry_buffer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_new "GtkEntryBuffer* gtk_entry_buffer_new(gchar* initial_chars, gint n_initial_chars)"
  s7_pointer _p;
  s7_pointer initial_chars, n_initial_chars;
  _p = args;
  initial_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(initial_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_new", 1, initial_chars, "gchar*");
  n_initial_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_initial_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_new", 2, n_initial_chars, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkEntryBuffer__sym, gtk_entry_buffer_new(s7_string(initial_chars), s7_integer(n_initial_chars))));
}

static s7_pointer lg_gtk_entry_buffer_get_bytes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_bytes "gsize gtk_entry_buffer_get_bytes(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_bytes", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_bytes(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_get_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_length "guint gtk_entry_buffer_get_length(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_length", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_length(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_text "gchar* gtk_entry_buffer_get_text(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_text", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_string(sc, gtk_entry_buffer_get_text(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_set_text "void gtk_entry_buffer_set_text(GtkEntryBuffer* buffer, gchar* chars, \
gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 1, buffer, "GtkEntryBuffer*");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 2, chars, "gchar*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 3, n_chars, "gint");
  gtk_entry_buffer_set_text(s7_c_pointer(buffer), s7_string(chars), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_set_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_set_max_length "void gtk_entry_buffer_set_max_length(GtkEntryBuffer* buffer, \
guint max_length)"
  s7_pointer _p;
  s7_pointer buffer, max_length;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_max_length", 1, buffer, "GtkEntryBuffer*");
  max_length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_length)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_max_length", 2, max_length, "guint");
  gtk_entry_buffer_set_max_length(s7_c_pointer(buffer), s7_integer(max_length));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_get_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_max_length "guint gtk_entry_buffer_get_max_length(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_max_length", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_max_length(s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_insert_text "guint gtk_entry_buffer_insert_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 2, position, "guint");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 3, chars, "gchar*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 4, n_chars, "gint");
  return(s7_make_integer(sc, gtk_entry_buffer_insert_text(s7_c_pointer(buffer), s7_integer(position), s7_string(chars), s7_integer(n_chars))));
}

static s7_pointer lg_gtk_entry_buffer_delete_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_delete_text "guint gtk_entry_buffer_delete_text(GtkEntryBuffer* buffer, \
guint position, gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 2, position, "guint");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 3, n_chars, "gint");
  return(s7_make_integer(sc, gtk_entry_buffer_delete_text(s7_c_pointer(buffer), s7_integer(position), s7_integer(n_chars))));
}

static s7_pointer lg_gtk_entry_buffer_emit_inserted_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_emit_inserted_text "void gtk_entry_buffer_emit_inserted_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, guint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 2, position, "guint");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 3, chars, "gchar*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 4, n_chars, "guint");
  gtk_entry_buffer_emit_inserted_text(s7_c_pointer(buffer), s7_integer(position), s7_string(chars), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_emit_deleted_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_emit_deleted_text "void gtk_entry_buffer_emit_deleted_text(GtkEntryBuffer* buffer, \
guint position, guint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 2, position, "guint");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 3, n_chars, "guint");
  gtk_entry_buffer_emit_deleted_text(s7_c_pointer(buffer), s7_integer(position), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_alignment "void gtk_cell_renderer_set_alignment(GtkCellRenderer* cell, \
gfloat xalign, gfloat yalign)"
  s7_pointer _p;
  s7_pointer cell, xalign, yalign;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 1, cell, "GtkCellRenderer*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 2, xalign, "gfloat");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 3, yalign, "gfloat");
  gtk_cell_renderer_set_alignment(s7_c_pointer(cell), s7_real(xalign), s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_alignment "void gtk_cell_renderer_get_alignment(GtkCellRenderer* cell, \
gfloat* [xalign], gfloat* [yalign])"
  s7_pointer _p;
  s7_pointer cell;
  gfloat ref_xalign;
  gfloat ref_yalign;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_alignment", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_alignment(s7_c_pointer(cell), &ref_xalign, &ref_yalign);
    return(s7_list(sc, 2, s7_make_real(sc, ref_xalign), s7_make_real(sc, ref_yalign)));
}

static s7_pointer lg_gtk_cell_renderer_set_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_padding "void gtk_cell_renderer_set_padding(GtkCellRenderer* cell, \
gint xpad, gint ypad)"
  s7_pointer _p;
  s7_pointer cell, xpad, ypad;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 1, cell, "GtkCellRenderer*");
  xpad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpad)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 2, xpad, "gint");
  ypad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ypad)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 3, ypad, "gint");
  gtk_cell_renderer_set_padding(s7_c_pointer(cell), s7_integer(xpad), s7_integer(ypad));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_padding "void gtk_cell_renderer_get_padding(GtkCellRenderer* cell, \
gint* [xpad], gint* [ypad])"
  s7_pointer _p;
  s7_pointer cell;
  gint ref_xpad;
  gint ref_ypad;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_padding", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_padding(s7_c_pointer(cell), &ref_xpad, &ref_ypad);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_xpad), s7_make_integer(sc, ref_ypad)));
}

static s7_pointer lg_gtk_cell_renderer_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_visible "void gtk_cell_renderer_set_visible(GtkCellRenderer* cell, \
gboolean visible)"
  s7_pointer _p;
  s7_pointer cell, visible;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_visible", 1, cell, "GtkCellRenderer*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_visible", 2, visible, "gboolean");
  gtk_cell_renderer_set_visible(s7_c_pointer(cell), lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_visible "gboolean gtk_cell_renderer_get_visible(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_visible", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_visible(s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_set_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_sensitive "void gtk_cell_renderer_set_sensitive(GtkCellRenderer* cell, \
gboolean sensitive)"
  s7_pointer _p;
  s7_pointer cell, sensitive;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_sensitive", 1, cell, "GtkCellRenderer*");
  sensitive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_sensitive", 2, sensitive, "gboolean");
  gtk_cell_renderer_set_sensitive(s7_c_pointer(cell), lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_sensitive "gboolean gtk_cell_renderer_get_sensitive(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_sensitive", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_sensitive(s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_activatable "gboolean gtk_cell_renderer_toggle_get_activatable(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_activatable", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_activatable(s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_activatable "void gtk_cell_renderer_toggle_set_activatable(GtkCellRendererToggle* toggle, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer toggle, setting;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_activatable", 1, toggle, "GtkCellRendererToggle*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_activatable", 2, setting, "gboolean");
  gtk_cell_renderer_toggle_set_activatable(s7_c_pointer(toggle), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_can_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_can_focus "void gtk_widget_set_can_focus(GtkWidget* widget, gboolean can_focus)"
  s7_pointer _p;
  s7_pointer widget, can_focus;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_focus", 1, widget, "GtkWidget*");
  can_focus = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(can_focus)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_focus", 2, can_focus, "gboolean");
  gtk_widget_set_can_focus(s7_c_pointer(widget), lg_boolean(can_focus));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_can_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_can_focus "gboolean gtk_widget_get_can_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_can_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_can_focus(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_has_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_focus "gboolean gtk_widget_has_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_focus(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_can_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_can_default "void gtk_widget_set_can_default(GtkWidget* widget, gboolean can_default)"
  s7_pointer _p;
  s7_pointer widget, can_default;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_default", 1, widget, "GtkWidget*");
  can_default = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(can_default)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_default", 2, can_default, "gboolean");
  gtk_widget_set_can_default(s7_c_pointer(widget), lg_boolean(can_default));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_can_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_can_default "gboolean gtk_widget_get_can_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_can_default", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_can_default(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_has_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_default "gboolean gtk_widget_has_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_default", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_default(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_sensitive "gboolean gtk_widget_get_sensitive(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_sensitive", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_sensitive(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_sensitive "gboolean gtk_widget_is_sensitive(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_sensitive", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_sensitive(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_has_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_has_window "void gtk_widget_set_has_window(GtkWidget* widget, gboolean has_window)"
  s7_pointer _p;
  s7_pointer widget, has_window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_window", 1, widget, "GtkWidget*");
  has_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_window)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_window", 2, has_window, "gboolean");
  gtk_widget_set_has_window(s7_c_pointer(widget), lg_boolean(has_window));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_has_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_has_window "gboolean gtk_widget_get_has_window(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_has_window", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_has_window(s7_c_pointer(widget))));
}

static s7_pointer lg_gdk_window_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_cursor "GdkCursor* gdk_window_get_cursor(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_cursor", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_window_get_cursor(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_file_chooser_set_create_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_create_folders "void gtk_file_chooser_set_create_folders(GtkFileChooser* chooser, \
gboolean create_folders)"
  s7_pointer _p;
  s7_pointer chooser, create_folders;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_create_folders", 1, chooser, "GtkFileChooser*");
  create_folders = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(create_folders)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_create_folders", 2, create_folders, "gboolean");
  gtk_file_chooser_set_create_folders(s7_c_pointer(chooser), lg_boolean(create_folders));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_create_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_create_folders "gboolean gtk_file_chooser_get_create_folders(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_create_folders", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_create_folders(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_icon_view_set_item_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_padding "void gtk_icon_view_set_item_padding(GtkIconView* icon_view, \
gint item_padding)"
  s7_pointer _p;
  s7_pointer icon_view, item_padding;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_padding", 1, icon_view, "GtkIconView*");
  item_padding = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(item_padding)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_padding", 2, item_padding, "gint");
  gtk_icon_view_set_item_padding(s7_c_pointer(icon_view), s7_integer(item_padding));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_padding "gint gtk_icon_view_get_item_padding(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_padding", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_padding(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_widget_has_grab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_grab "gboolean gtk_widget_has_grab(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_grab", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_grab(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_visible "void gtk_widget_set_visible(GtkWidget* widget, gboolean visible)"
  s7_pointer _p;
  s7_pointer widget, visible;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_visible", 1, widget, "GtkWidget*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_widget_set_visible", 2, visible, "gboolean");
  gtk_widget_set_visible(s7_c_pointer(widget), lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_visible "gboolean gtk_widget_get_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_visible(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_range_set_flippable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_flippable "void gtk_range_set_flippable(GtkRange* range, gboolean flippable)"
  s7_pointer _p;
  s7_pointer range, flippable;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_flippable", 1, range, "GtkRange*");
  flippable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(flippable)) s7_wrong_type_arg_error(sc, "gtk_range_set_flippable", 2, flippable, "gboolean");
  gtk_range_set_flippable(s7_c_pointer(range), lg_boolean(flippable));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_flippable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_flippable "gboolean gtk_range_get_flippable(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_flippable", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_flippable(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_widget_is_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_toplevel "gboolean gtk_widget_is_toplevel(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_toplevel", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_toplevel(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_drawable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_drawable "gboolean gtk_widget_is_drawable(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_drawable", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_drawable(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_window "void gtk_widget_set_window(GtkWidget* widget, GdkWindow* window)"
  s7_pointer _p;
  s7_pointer widget, window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_window", 1, widget, "GtkWidget*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_window", 2, window, "GdkWindow*");
  gtk_widget_set_window(s7_c_pointer(widget), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gdk_window_is_destroyed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_is_destroyed "gboolean gdk_window_is_destroyed(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_is_destroyed", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_is_destroyed(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_restack(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_restack "void gdk_window_restack(GdkWindow* window, GdkWindow* sibling, gboolean above)"
  s7_pointer _p;
  s7_pointer window, sibling, above;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_restack", 1, window, "GdkWindow*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sibling, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_restack", 2, sibling, "GdkWindow*");
  above = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(above)) s7_wrong_type_arg_error(sc, "gdk_window_restack", 3, above, "gboolean");
  gdk_window_restack(s7_c_pointer(window), s7_c_pointer(sibling), lg_boolean(above));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_receives_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_receives_default "void gtk_widget_set_receives_default(GtkWidget* widget, \
gboolean receives_default)"
  s7_pointer _p;
  s7_pointer widget, receives_default;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_receives_default", 1, widget, "GtkWidget*");
  receives_default = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(receives_default)) s7_wrong_type_arg_error(sc, "gtk_widget_set_receives_default", 2, receives_default, "gboolean");
  gtk_widget_set_receives_default(s7_c_pointer(widget), lg_boolean(receives_default));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_receives_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_receives_default "gboolean gtk_widget_get_receives_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_receives_default", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_receives_default(s7_c_pointer(widget))));
}

#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static s7_pointer lg_gtk_dialog_get_widget_for_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_widget_for_response "GtkWidget* gtk_dialog_get_widget_for_response(GtkDialog* dialog, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_widget_for_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_widget_for_response", 2, response_id, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_dialog_get_widget_for_response(s7_c_pointer(dialog), s7_integer(response_id))));
}

static s7_pointer lg_gtk_spinner_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_new "GtkWidget* gtk_spinner_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_spinner_new()));
}

static s7_pointer lg_gtk_spinner_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_start "void gtk_spinner_start(GtkSpinner* spinner)"
  s7_pointer spinner;
  spinner = s7_car(args);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_start", 1, spinner, "GtkSpinner*");
  gtk_spinner_start(s7_c_pointer(spinner));
  return(lg_false);
}

static s7_pointer lg_gtk_spinner_stop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_stop "void gtk_spinner_stop(GtkSpinner* spinner)"
  s7_pointer spinner;
  spinner = s7_car(args);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_stop", 1, spinner, "GtkSpinner*");
  gtk_spinner_stop(s7_c_pointer(spinner));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_spinner_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_spinner_new "GtkCellRenderer* gtk_cell_renderer_spinner_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkCellRenderer__sym, gtk_cell_renderer_spinner_new()));
}

static s7_pointer lg_gtk_notebook_get_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_action_widget "GtkWidget* gtk_notebook_get_action_widget(GtkNotebook* notebook, \
GtkPackType pack_type)"
  s7_pointer _p;
  s7_pointer notebook, pack_type;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_action_widget", 1, notebook, "GtkNotebook*");
  pack_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pack_type)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_action_widget", 2, pack_type, "GtkPackType");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_notebook_get_action_widget(s7_c_pointer(notebook), s7_integer(pack_type))));
}

static s7_pointer lg_gtk_notebook_set_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_action_widget "void gtk_notebook_set_action_widget(GtkNotebook* notebook, \
GtkWidget* widget, GtkPackType pack_type)"
  s7_pointer _p;
  s7_pointer notebook, widget, pack_type;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 1, notebook, "GtkNotebook*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 2, widget, "GtkWidget*");
  pack_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pack_type)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 3, pack_type, "GtkPackType");
  gtk_notebook_set_action_widget(s7_c_pointer(notebook), s7_c_pointer(widget), s7_integer(pack_type));
  return(lg_false);
}

static s7_pointer lg_gtk_statusbar_get_message_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_get_message_area "GtkWidget* gtk_statusbar_get_message_area(GtkStatusbar* statusbar)"
  s7_pointer statusbar;
  statusbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_get_message_area", 1, statusbar, "GtkStatusbar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_statusbar_get_message_area(s7_c_pointer(statusbar))));
}

static s7_pointer lg_gtk_tool_item_get_ellipsize_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_ellipsize_mode "PangoEllipsizeMode gtk_tool_item_get_ellipsize_mode(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_ellipsize_mode", 1, tool_item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_tool_item_get_ellipsize_mode(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_get_text_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_text_alignment "gfloat gtk_tool_item_get_text_alignment(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_text_alignment", 1, tool_item, "GtkToolItem*");
  return(s7_make_real(sc, gtk_tool_item_get_text_alignment(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_get_text_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_text_orientation "GtkOrientation gtk_tool_item_get_text_orientation(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_text_orientation", 1, tool_item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_tool_item_get_text_orientation(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_item_get_text_size_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_get_text_size_group "GtkSizeGroup* gtk_tool_item_get_text_size_group(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_get_text_size_group", 1, tool_item, "GtkToolItem*");
  return(s7_make_type_with_c_pointer(sc, GtkSizeGroup__sym, gtk_tool_item_get_text_size_group(s7_c_pointer(tool_item))));
}

static s7_pointer lg_gtk_tool_palette_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_new "GtkWidget* gtk_tool_palette_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_palette_new()));
}

static s7_pointer lg_gtk_tool_palette_set_group_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_set_group_position "void gtk_tool_palette_set_group_position(GtkToolPalette* palette, \
GtkToolItemGroup* group, gint position)"
  s7_pointer _p;
  s7_pointer palette, group, position;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_group_position", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_group_position", 2, group, "GtkToolItemGroup*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_group_position", 3, position, "gint");
  gtk_tool_palette_set_group_position(s7_c_pointer(palette), s7_c_pointer(group), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_set_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_set_exclusive "void gtk_tool_palette_set_exclusive(GtkToolPalette* palette, \
GtkToolItemGroup* group, gboolean exclusive)"
  s7_pointer _p;
  s7_pointer palette, group, exclusive;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_exclusive", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_exclusive", 2, group, "GtkToolItemGroup*");
  exclusive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(exclusive)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_exclusive", 3, exclusive, "gboolean");
  gtk_tool_palette_set_exclusive(s7_c_pointer(palette), s7_c_pointer(group), lg_boolean(exclusive));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_set_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_set_expand "void gtk_tool_palette_set_expand(GtkToolPalette* palette, GtkToolItemGroup* group, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer palette, group, expand;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_expand", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_expand", 2, group, "GtkToolItemGroup*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_expand", 3, expand, "gboolean");
  gtk_tool_palette_set_expand(s7_c_pointer(palette), s7_c_pointer(group), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_get_group_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_group_position "gint gtk_tool_palette_get_group_position(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  s7_pointer _p;
  s7_pointer palette, group;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_group_position", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_group_position", 2, group, "GtkToolItemGroup*");
  return(s7_make_integer(sc, gtk_tool_palette_get_group_position(s7_c_pointer(palette), s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_palette_get_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_exclusive "gboolean gtk_tool_palette_get_exclusive(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  s7_pointer _p;
  s7_pointer palette, group;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_exclusive", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_exclusive", 2, group, "GtkToolItemGroup*");
  return(s7_make_boolean(sc, gtk_tool_palette_get_exclusive(s7_c_pointer(palette), s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_palette_get_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_expand "gboolean gtk_tool_palette_get_expand(GtkToolPalette* palette, \
GtkToolItemGroup* group)"
  s7_pointer _p;
  s7_pointer palette, group;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_expand", 1, palette, "GtkToolPalette*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_expand", 2, group, "GtkToolItemGroup*");
  return(s7_make_boolean(sc, gtk_tool_palette_get_expand(s7_c_pointer(palette), s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_palette_unset_icon_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_unset_icon_size "void gtk_tool_palette_unset_icon_size(GtkToolPalette* palette)"
  s7_pointer palette;
  palette = s7_car(args);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_unset_icon_size", 1, palette, "GtkToolPalette*");
  gtk_tool_palette_unset_icon_size(s7_c_pointer(palette));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_set_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_set_style "void gtk_tool_palette_set_style(GtkToolPalette* palette, GtkToolbarStyle style)"
  s7_pointer _p;
  s7_pointer palette, style;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_style", 1, palette, "GtkToolPalette*");
  style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_style", 2, style, "GtkToolbarStyle");
  gtk_tool_palette_set_style(s7_c_pointer(palette), s7_integer(style));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_unset_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_unset_style "void gtk_tool_palette_unset_style(GtkToolPalette* palette)"
  s7_pointer palette;
  palette = s7_car(args);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_unset_style", 1, palette, "GtkToolPalette*");
  gtk_tool_palette_unset_style(s7_c_pointer(palette));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_get_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_style "GtkToolbarStyle gtk_tool_palette_get_style(GtkToolPalette* palette)"
  s7_pointer palette;
  palette = s7_car(args);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_style", 1, palette, "GtkToolPalette*");
  return(s7_make_integer(sc, gtk_tool_palette_get_style(s7_c_pointer(palette))));
}

static s7_pointer lg_gtk_tool_palette_get_drop_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_drop_item "GtkToolItem* gtk_tool_palette_get_drop_item(GtkToolPalette* palette, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer palette, x, y;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_item", 1, palette, "GtkToolPalette*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_item", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_item", 3, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_tool_palette_get_drop_item(s7_c_pointer(palette), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_tool_palette_get_drop_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_drop_group "GtkToolItemGroup* gtk_tool_palette_get_drop_group(GtkToolPalette* palette, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer palette, x, y;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_group", 1, palette, "GtkToolPalette*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_group", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drop_group", 3, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkToolItemGroup__sym, gtk_tool_palette_get_drop_group(s7_c_pointer(palette), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_tool_palette_get_drag_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_drag_item "GtkWidget* gtk_tool_palette_get_drag_item(GtkToolPalette* palette, \
GtkSelectionData* selection)"
  s7_pointer _p;
  s7_pointer palette, selection;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drag_item", 1, palette, "GtkToolPalette*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_get_drag_item", 2, selection, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_palette_get_drag_item(s7_c_pointer(palette), s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tool_palette_set_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_set_drag_source "void gtk_tool_palette_set_drag_source(GtkToolPalette* palette, \
GtkToolPaletteDragTargets targets)"
  s7_pointer _p;
  s7_pointer palette, targets;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_drag_source", 1, palette, "GtkToolPalette*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(targets)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_set_drag_source", 2, targets, "GtkToolPaletteDragTargets");
  gtk_tool_palette_set_drag_source(s7_c_pointer(palette), s7_integer(targets));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_add_drag_dest(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_add_drag_dest "void gtk_tool_palette_add_drag_dest(GtkToolPalette* palette, \
GtkWidget* widget, GtkDestDefaults flags, GtkToolPaletteDragTargets targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer palette, widget, flags, targets, actions;
  _p = args;
  palette = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(palette, GtkToolPalette__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_add_drag_dest", 1, palette, "GtkToolPalette*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_add_drag_dest", 2, widget, "GtkWidget*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_add_drag_dest", 3, flags, "GtkDestDefaults");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(targets)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_add_drag_dest", 4, targets, "GtkToolPaletteDragTargets");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_tool_palette_add_drag_dest", 5, actions, "GdkDragAction");
  gtk_tool_palette_add_drag_dest(s7_c_pointer(palette), s7_c_pointer(widget), s7_integer(flags), s7_integer(targets), s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_palette_get_drag_target_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_drag_target_item "GtkTargetEntry* gtk_tool_palette_get_drag_target_item( void)"
    return(s7_make_type_with_c_pointer(sc, GtkTargetEntry__sym, (GtkTargetEntry*)gtk_tool_palette_get_drag_target_item()));
}

static s7_pointer lg_gtk_tool_palette_get_drag_target_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_palette_get_drag_target_group "GtkTargetEntry* gtk_tool_palette_get_drag_target_group( void)"
    return(s7_make_type_with_c_pointer(sc, GtkTargetEntry__sym, (GtkTargetEntry*)gtk_tool_palette_get_drag_target_group()));
}

static s7_pointer lg_gtk_tool_item_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_new "GtkWidget* gtk_tool_item_group_new(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_new", 1, label, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_item_group_new((const gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_tool_item_group_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_label "void gtk_tool_item_group_set_label(GtkToolItemGroup* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_label", 1, group, "GtkToolItemGroup*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_label", 2, label, "gchar*");
  gtk_tool_item_group_set_label(s7_c_pointer(group), (const gchar*)s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_label_widget "void gtk_tool_item_group_set_label_widget(GtkToolItemGroup* group, \
GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer group, label_widget;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_label_widget", 1, group, "GtkToolItemGroup*");
  label_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_tool_item_group_set_label_widget(s7_c_pointer(group), s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_set_collapsed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_collapsed "void gtk_tool_item_group_set_collapsed(GtkToolItemGroup* group, \
gboolean collapsed)"
  s7_pointer _p;
  s7_pointer group, collapsed;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_collapsed", 1, group, "GtkToolItemGroup*");
  collapsed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(collapsed)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_collapsed", 2, collapsed, "gboolean");
  gtk_tool_item_group_set_collapsed(s7_c_pointer(group), lg_boolean(collapsed));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_set_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_ellipsize "void gtk_tool_item_group_set_ellipsize(GtkToolItemGroup* group, \
PangoEllipsizeMode ellipsize)"
  s7_pointer _p;
  s7_pointer group, ellipsize;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_ellipsize", 1, group, "GtkToolItemGroup*");
  ellipsize = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(ellipsize)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_ellipsize", 2, ellipsize, "PangoEllipsizeMode");
  gtk_tool_item_group_set_ellipsize(s7_c_pointer(group), s7_integer(ellipsize));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_set_header_relief(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_header_relief "void gtk_tool_item_group_set_header_relief(GtkToolItemGroup* group, \
GtkReliefStyle style)"
  s7_pointer _p;
  s7_pointer group, style;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_header_relief", 1, group, "GtkToolItemGroup*");
  style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_header_relief", 2, style, "GtkReliefStyle");
  gtk_tool_item_group_set_header_relief(s7_c_pointer(group), s7_integer(style));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_label "gchar* gtk_tool_item_group_get_label(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_label", 1, group, "GtkToolItemGroup*");
  return(s7_make_string(sc, gtk_tool_item_group_get_label(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_label_widget "GtkWidget* gtk_tool_item_group_get_label_widget(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_label_widget", 1, group, "GtkToolItemGroup*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tool_item_group_get_label_widget(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_get_collapsed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_collapsed "gboolean gtk_tool_item_group_get_collapsed(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_collapsed", 1, group, "GtkToolItemGroup*");
  return(s7_make_boolean(sc, gtk_tool_item_group_get_collapsed(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_get_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_ellipsize "PangoEllipsizeMode gtk_tool_item_group_get_ellipsize(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_ellipsize", 1, group, "GtkToolItemGroup*");
  return(s7_make_integer(sc, gtk_tool_item_group_get_ellipsize(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_get_header_relief(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_header_relief "GtkReliefStyle gtk_tool_item_group_get_header_relief(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_header_relief", 1, group, "GtkToolItemGroup*");
  return(s7_make_integer(sc, gtk_tool_item_group_get_header_relief(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_insert "void gtk_tool_item_group_insert(GtkToolItemGroup* group, GtkToolItem* item, \
gint position)"
  s7_pointer _p;
  s7_pointer group, item, position;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_insert", 1, group, "GtkToolItemGroup*");
  item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_insert", 2, item, "GtkToolItem*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_insert", 3, position, "gint");
  gtk_tool_item_group_insert(s7_c_pointer(group), s7_c_pointer(item), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_set_item_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_set_item_position "void gtk_tool_item_group_set_item_position(GtkToolItemGroup* group, \
GtkToolItem* item, gint position)"
  s7_pointer _p;
  s7_pointer group, item, position;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_item_position", 1, group, "GtkToolItemGroup*");
  item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_item_position", 2, item, "GtkToolItem*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_set_item_position", 3, position, "gint");
  gtk_tool_item_group_set_item_position(s7_c_pointer(group), s7_c_pointer(item), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_group_get_item_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_item_position "gint gtk_tool_item_group_get_item_position(GtkToolItemGroup* group, \
GtkToolItem* item)"
  s7_pointer _p;
  s7_pointer group, item;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_item_position", 1, group, "GtkToolItemGroup*");
  item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_item_position", 2, item, "GtkToolItem*");
  return(s7_make_integer(sc, gtk_tool_item_group_get_item_position(s7_c_pointer(group), s7_c_pointer(item))));
}

static s7_pointer lg_gtk_tool_item_group_get_n_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_n_items "guint gtk_tool_item_group_get_n_items(GtkToolItemGroup* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_n_items", 1, group, "GtkToolItemGroup*");
  return(s7_make_integer(sc, gtk_tool_item_group_get_n_items(s7_c_pointer(group))));
}

static s7_pointer lg_gtk_tool_item_group_get_nth_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_nth_item "GtkToolItem* gtk_tool_item_group_get_nth_item(GtkToolItemGroup* group, \
guint index)"
  s7_pointer _p;
  s7_pointer group, index;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_nth_item", 1, group, "GtkToolItemGroup*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_nth_item", 2, index, "guint");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_tool_item_group_get_nth_item(s7_c_pointer(group), s7_integer(index))));
}

static s7_pointer lg_gtk_tool_item_group_get_drop_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_group_get_drop_item "GtkToolItem* gtk_tool_item_group_get_drop_item(GtkToolItemGroup* group, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer group, x, y;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkToolItemGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_drop_item", 1, group, "GtkToolItemGroup*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_drop_item", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tool_item_group_get_drop_item", 3, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkToolItem__sym, gtk_tool_item_group_get_drop_item(s7_c_pointer(group), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_window_set_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_mnemonics_visible "void gtk_window_set_mnemonics_visible(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonics_visible", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonics_visible", 2, setting, "gboolean");
  gtk_window_set_mnemonics_visible(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_mnemonics_visible "gboolean gtk_window_get_mnemonics_visible(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_mnemonics_visible", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_mnemonics_visible(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_range_set_slider_size_fixed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_slider_size_fixed "void gtk_range_set_slider_size_fixed(GtkRange* range, gboolean size_fixed)"
  s7_pointer _p;
  s7_pointer range, size_fixed;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_slider_size_fixed", 1, range, "GtkRange*");
  size_fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(size_fixed)) s7_wrong_type_arg_error(sc, "gtk_range_set_slider_size_fixed", 2, size_fixed, "gboolean");
  gtk_range_set_slider_size_fixed(s7_c_pointer(range), lg_boolean(size_fixed));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_slider_size_fixed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_slider_size_fixed "gboolean gtk_range_get_slider_size_fixed(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_slider_size_fixed", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_slider_size_fixed(s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_get_range_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_range_rect "void gtk_range_get_range_rect(GtkRange* range, GdkRectangle* range_rect)"
  s7_pointer _p;
  s7_pointer range, range_rect;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_range_rect", 1, range, "GtkRange*");
  range_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_range_rect", 2, range_rect, "GdkRectangle*");
  gtk_range_get_range_rect(s7_c_pointer(range), s7_c_pointer(range_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_slider_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_slider_range "void gtk_range_get_slider_range(GtkRange* range, gint* [slider_start], \
gint* [slider_end])"
  s7_pointer _p;
  s7_pointer range;
  gint ref_slider_start;
  gint ref_slider_end;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_slider_range", 1, range, "GtkRange*");
  gtk_range_get_slider_range(s7_c_pointer(range), &ref_slider_start, &ref_slider_end);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_slider_start), s7_make_integer(sc, ref_slider_end)));
}

static s7_pointer lg_gtk_widget_set_realized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_realized "void gtk_widget_set_realized(GtkWidget* widget, gboolean realized)"
  s7_pointer _p;
  s7_pointer widget, realized;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_realized", 1, widget, "GtkWidget*");
  realized = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(realized)) s7_wrong_type_arg_error(sc, "gtk_widget_set_realized", 2, realized, "gboolean");
  gtk_widget_set_realized(s7_c_pointer(widget), lg_boolean(realized));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_realized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_realized "gboolean gtk_widget_get_realized(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_realized", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_realized(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_mapped(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_mapped "gboolean gtk_widget_get_mapped(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_mapped", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_mapped(s7_c_pointer(widget))));
}

#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_gdk_window_get_geometry(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_geometry "void gdk_window_get_geometry(GdkWindow* window, gint* [x], gint* [y], \
gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_x;
  gint ref_y;
  gint ref_width;
  gint ref_height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_geometry", 1, window, "GdkWindow*");
  gdk_window_get_geometry(s7_c_pointer(window), &ref_x, &ref_y, &ref_width, &ref_height);
    return(s7_list(sc, 4, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gdk_keymap_add_virtual_modifiers(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_add_virtual_modifiers "void gdk_keymap_add_virtual_modifiers(GdkKeymap* keymap, \
GdkModifierType* state)"
  s7_pointer _p;
  s7_pointer keymap, state;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_add_virtual_modifiers", 1, keymap, "GdkKeymap*");
  state = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(state, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_add_virtual_modifiers", 2, state, "GdkModifierType*");
  gdk_keymap_add_virtual_modifiers(s7_c_pointer(keymap), s7_c_pointer(state));
  return(lg_false);
}

static s7_pointer lg_gdk_window_coords_to_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_coords_to_parent "void gdk_window_coords_to_parent(GdkWindow* window, gdouble x, \
gdouble y, gdouble* [parent_x], gdouble* [parent_y])"
  s7_pointer _p;
  s7_pointer window, x, y;
  gdouble ref_parent_x;
  gdouble ref_parent_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_coords_to_parent", 1, window, "GdkWindow*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gdk_window_coords_to_parent", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gdk_window_coords_to_parent", 3, y, "gdouble");
  gdk_window_coords_to_parent(s7_c_pointer(window), s7_real(x), s7_real(y), &ref_parent_x, &ref_parent_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_parent_x), s7_make_real(sc, ref_parent_y)));
}

static s7_pointer lg_gdk_window_coords_from_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_coords_from_parent "void gdk_window_coords_from_parent(GdkWindow* window, gdouble parent_x, \
gdouble parent_y, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer window, parent_x, parent_y;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_coords_from_parent", 1, window, "GdkWindow*");
  parent_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(parent_x)) s7_wrong_type_arg_error(sc, "gdk_window_coords_from_parent", 2, parent_x, "gdouble");
  parent_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(parent_y)) s7_wrong_type_arg_error(sc, "gdk_window_coords_from_parent", 3, parent_y, "gdouble");
  gdk_window_coords_from_parent(s7_c_pointer(window), s7_real(parent_x), s7_real(parent_y), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_gtk_accessible_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accessible_get_widget "GtkWidget* gtk_accessible_get_widget(GtkAccessible* accessible)"
  s7_pointer accessible;
  accessible = s7_car(args);
  if (!s7_is_c_pointer_of_type(accessible, GtkAccessible__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_get_widget", 1, accessible, "GtkAccessible*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_accessible_get_widget(s7_c_pointer(accessible))));
}

static s7_pointer lg_gtk_widget_send_focus_change(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_send_focus_change "gboolean gtk_widget_send_focus_change(GtkWidget* widget, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer widget, event;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_send_focus_change", 1, widget, "GtkWidget*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_send_focus_change", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_widget_send_focus_change(s7_c_pointer(widget), s7_c_pointer(event))));
}

static s7_pointer lg_gdk_drag_context_set_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_set_device "void gdk_drag_context_set_device(GdkDragContext* context, GdkDevice* device)"
  s7_pointer _p;
  s7_pointer context, device;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_set_device", 1, context, "GdkDragContext*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_set_device", 2, device, "GdkDevice*");
  gdk_drag_context_set_device(s7_c_pointer(context), s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_context_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_get_device "GdkDevice* gdk_drag_context_get_device(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_get_device", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gdk_drag_context_get_device(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_drag_context_list_targets(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_list_targets "GList* gdk_drag_context_list_targets(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_list_targets", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_drag_context_list_targets(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_event_set_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_device "void gdk_event_set_device(GdkEvent* event, GdkDevice* device)"
  s7_pointer _p;
  s7_pointer event, device;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device", 1, event, "GdkEvent*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device", 2, device, "GdkDevice*");
  gdk_event_set_device(s7_c_pointer(event), s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_device "GdkDevice* gdk_event_get_device(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_device", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gdk_event_get_device(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_events_get_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_distance "gboolean gdk_events_get_distance(GdkEvent* event1, GdkEvent* event2, \
gdouble* [distance])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_distance;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_distance", 1, event1, "GdkEvent*");
  event2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_distance", 2, event2, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_events_get_distance(s7_c_pointer(event1), s7_c_pointer(event2), &ref_distance));
      return(s7_list(sc, 2, result, s7_make_real(sc, ref_distance)));
   }
}

static s7_pointer lg_gdk_events_get_angle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_angle "gboolean gdk_events_get_angle(GdkEvent* event1, GdkEvent* event2, gdouble* [angle])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_angle;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_angle", 1, event1, "GdkEvent*");
  event2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_angle", 2, event2, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_events_get_angle(s7_c_pointer(event1), s7_c_pointer(event2), &ref_angle));
      return(s7_list(sc, 2, result, s7_make_real(sc, ref_angle)));
   }
}

static s7_pointer lg_gdk_events_get_center(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_center "gboolean gdk_events_get_center(GdkEvent* event1, GdkEvent* event2, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_center", 1, event1, "GdkEvent*");
  event2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_center", 2, event2, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_events_get_center(s7_c_pointer(event1), s7_c_pointer(event2), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gdk_window_get_accept_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_accept_focus "gboolean gdk_window_get_accept_focus(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_accept_focus", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_get_accept_focus(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_focus_on_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_focus_on_map "gboolean gdk_window_get_focus_on_map(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_focus_on_map", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_get_focus_on_map(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_is_input_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_is_input_only "gboolean gdk_window_is_input_only(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_is_input_only", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_is_input_only(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_is_shaped(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_is_shaped "gboolean gdk_window_is_shaped(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_is_shaped", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_is_shaped(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_modal_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_modal_hint "gboolean gdk_window_get_modal_hint(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_modal_hint", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_get_modal_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_set_device_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_device_cursor "void gdk_window_set_device_cursor(GdkWindow* window, GdkDevice* device, \
GdkCursor* cursor)"
  s7_pointer _p;
  s7_pointer window, device, cursor;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_cursor", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_cursor", 2, device, "GdkDevice*");
  cursor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_cursor", 3, cursor, "GdkCursor*");
  gdk_window_set_device_cursor(s7_c_pointer(window), s7_c_pointer(device), s7_c_pointer(cursor));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_device_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_device_cursor "GdkCursor* gdk_window_get_device_cursor(GdkWindow* window, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer window, device;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_cursor", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_cursor", 2, device, "GdkDevice*");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_window_get_device_cursor(s7_c_pointer(window), s7_c_pointer(device))));
}

static s7_pointer lg_gdk_window_get_device_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_device_position "GdkWindow* gdk_window_get_device_position(GdkWindow* window, \
GdkDevice* device, gint* [x], gint* [y], GdkModifierType* [mask])"
  s7_pointer _p;
  s7_pointer window, device;
  gint ref_x;
  gint ref_y;
  GdkModifierType ref_mask;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_position", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_position", 2, device, "GdkDevice*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_get_device_position(s7_c_pointer(window), s7_c_pointer(device), &ref_x, &ref_y, &ref_mask));
      return(s7_list(sc, 4, result, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_integer(sc, ref_mask)));
   }
}

static s7_pointer lg_gdk_window_set_device_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_device_events "void gdk_window_set_device_events(GdkWindow* window, GdkDevice* device, \
GdkEventMask event_mask)"
  s7_pointer _p;
  s7_pointer window, device, event_mask;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_events", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_events", 2, device, "GdkDevice*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_set_device_events", 3, event_mask, "GdkEventMask");
  gdk_window_set_device_events(s7_c_pointer(window), s7_c_pointer(device), s7_integer(event_mask));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_device_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_device_events "GdkEventMask gdk_window_get_device_events(GdkWindow* window, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer window, device;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_events", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_events", 2, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_window_get_device_events(s7_c_pointer(window), s7_c_pointer(device))));
}

static s7_pointer lg_gtk_combo_box_popup_for_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popup_for_device "void gtk_combo_box_popup_for_device(GtkComboBox* combo_box, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer combo_box, device;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup_for_device", 1, combo_box, "GtkComboBox*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup_for_device", 2, device, "GdkDevice*");
  gtk_combo_box_popup_for_device(s7_c_pointer(combo_box), s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gtk_device_grab_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_device_grab_add "void gtk_device_grab_add(GtkWidget* widget, GdkDevice* device, gboolean block_others)"
  s7_pointer _p;
  s7_pointer widget, device, block_others;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_device_grab_add", 1, widget, "GtkWidget*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_device_grab_add", 2, device, "GdkDevice*");
  block_others = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(block_others)) s7_wrong_type_arg_error(sc, "gtk_device_grab_add", 3, block_others, "gboolean");
  gtk_device_grab_add(s7_c_pointer(widget), s7_c_pointer(device), lg_boolean(block_others));
  return(lg_false);
}

static s7_pointer lg_gtk_device_grab_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_device_grab_remove "void gtk_device_grab_remove(GtkWidget* widget, GdkDevice* device)"
  s7_pointer _p;
  s7_pointer widget, device;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_device_grab_remove", 1, widget, "GtkWidget*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_device_grab_remove", 2, device, "GdkDevice*");
  gtk_device_grab_remove(s7_c_pointer(widget), s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gtk_get_current_event_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_current_event_device "GdkDevice* gtk_get_current_event_device( void)"
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gtk_get_current_event_device()));
}

static s7_pointer lg_gtk_paned_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_new "GtkWidget* gtk_paned_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_paned_new", 1, orientation, "GtkOrientation");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_paned_new(s7_integer(orientation))));
}

static s7_pointer lg_gtk_scale_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_new "GtkWidget* gtk_scale_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer orientation, adjustment;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scale_new", 1, orientation, "GtkOrientation");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_new", 2, adjustment, "GtkAdjustment*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scale_new(s7_integer(orientation), s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_scale_new_with_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_new_with_range "GtkWidget* gtk_scale_new_with_range(GtkOrientation orientation, \
gdouble min, gdouble max, gdouble step)"
  s7_pointer _p;
  s7_pointer orientation, min, max, step;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 1, orientation, "GtkOrientation");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 2, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 3, max, "gdouble");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 4, step, "gdouble");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scale_new_with_range(s7_integer(orientation), s7_real(min), s7_real(max), s7_real(step))));
}

static s7_pointer lg_gtk_scrollbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_new "GtkWidget* gtk_scrollbar_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer orientation, adjustment;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_new", 1, orientation, "GtkOrientation");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_new", 2, adjustment, "GtkAdjustment*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_scrollbar_new(s7_integer(orientation), s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_separator_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_new "GtkWidget* gtk_separator_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_separator_new", 1, orientation, "GtkOrientation");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_separator_new(s7_integer(orientation))));
}

static s7_pointer lg_gtk_widget_device_is_shadowed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_device_is_shadowed "gboolean gtk_widget_device_is_shadowed(GtkWidget* widget, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer widget, device;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_device_is_shadowed", 1, widget, "GtkWidget*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_device_is_shadowed", 2, device, "GdkDevice*");
  return(s7_make_boolean(sc, gtk_widget_device_is_shadowed(s7_c_pointer(widget), s7_c_pointer(device))));
}

static s7_pointer lg_gtk_widget_get_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_support_multidevice "gboolean gtk_widget_get_support_multidevice(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_support_multidevice", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_support_multidevice(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_support_multidevice "void gtk_widget_set_support_multidevice(GtkWidget* widget, \
gboolean support_multidevice)"
  s7_pointer _p;
  s7_pointer widget, support_multidevice;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_support_multidevice", 1, widget, "GtkWidget*");
  support_multidevice = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(support_multidevice)) s7_wrong_type_arg_error(sc, "gtk_widget_set_support_multidevice", 2, support_multidevice, "gboolean");
  gtk_widget_set_support_multidevice(s7_c_pointer(widget), lg_boolean(support_multidevice));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_row "gint gtk_icon_view_get_item_row(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_row", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_row", 2, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_row(s7_c_pointer(icon_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_icon_view_get_item_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_column "gint gtk_icon_view_get_item_column(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_column", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_column", 2, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_column(s7_c_pointer(icon_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_statusbar_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_remove_all "void gtk_statusbar_remove_all(GtkStatusbar* statusbar, guint context_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove_all", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove_all", 2, context_id, "guint");
  gtk_statusbar_remove_all(s7_c_pointer(statusbar), s7_integer(context_id));
  return(lg_false);
}

static s7_pointer lg_gtk_window_has_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_has_group "gboolean gtk_window_has_group(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_has_group", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_has_group(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_calendar_select_month(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_select_month "void gtk_calendar_select_month(GtkCalendar* calendar, guint month, \
guint year)"
  s7_pointer _p;
  s7_pointer calendar, month, year;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 1, calendar, "GtkCalendar*");
  month = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(month)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 2, month, "guint");
  year = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(year)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 3, year, "guint");
  gtk_calendar_select_month(s7_c_pointer(calendar), s7_integer(month), s7_integer(year));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_mark_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_mark_day "void gtk_calendar_mark_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_mark_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_mark_day", 2, day, "guint");
  gtk_calendar_mark_day(s7_c_pointer(calendar), s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_unmark_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_unmark_day "void gtk_calendar_unmark_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_unmark_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_unmark_day", 2, day, "guint");
  gtk_calendar_unmark_day(s7_c_pointer(calendar), s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_context_get_source_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_get_source_window "GdkWindow* gdk_drag_context_get_source_window(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_get_source_window", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_drag_context_get_source_window(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_accessible_set_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accessible_set_widget "void gtk_accessible_set_widget(GtkAccessible* accessible, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer accessible, widget;
  _p = args;
  accessible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accessible, GtkAccessible__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_set_widget", 1, accessible, "GtkAccessible*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_set_widget", 2, widget, "GtkWidget*");
  gtk_accessible_set_widget(s7_c_pointer(accessible), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_message_dialog_get_message_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_message_dialog_get_message_area "GtkWidget* gtk_message_dialog_get_message_area(GtkMessageDialog* message_dialog)"
  s7_pointer message_dialog;
  message_dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(message_dialog, GtkMessageDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_message_dialog_get_message_area", 1, message_dialog, "GtkMessageDialog*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_message_dialog_get_message_area(s7_c_pointer(message_dialog))));
}

static s7_pointer lg_gtk_selection_data_get_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_length "gint gtk_selection_data_get_length(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_length", 1, selection_data, "GtkSelectionData*");
  return(s7_make_integer(sc, gtk_selection_data_get_length(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gdk_pango_layout_line_get_clip_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_layout_line_get_clip_region "cairo_region_t* gdk_pango_layout_line_get_clip_region(PangoLayoutLine* line, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  s7_pointer _p;
  s7_pointer line, x_origin, y_origin, index_ranges, n_ranges;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 1, line, "PangoLayoutLine*");
  x_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 2, x_origin, "gint");
  y_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 3, y_origin, "gint");
  index_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(index_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 4, index_ranges, "gint*");
  n_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_ranges)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 5, n_ranges, "gint");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_pango_layout_line_get_clip_region(s7_c_pointer(line), s7_integer(x_origin), s7_integer(y_origin), s7_c_pointer(index_ranges), s7_integer(n_ranges))));
}

static s7_pointer lg_gdk_pango_layout_get_clip_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_layout_get_clip_region "cairo_region_t* gdk_pango_layout_get_clip_region(PangoLayout* layout, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  s7_pointer _p;
  s7_pointer layout, x_origin, y_origin, index_ranges, n_ranges;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 1, layout, "PangoLayout*");
  x_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 2, x_origin, "gint");
  y_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 3, y_origin, "gint");
  index_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(index_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 4, index_ranges, "gint*");
  n_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_ranges)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 5, n_ranges, "gint");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_pango_layout_get_clip_region(s7_c_pointer(layout), s7_integer(x_origin), s7_integer(y_origin), s7_c_pointer(index_ranges), s7_integer(n_ranges))));
}

static s7_pointer lg_gdk_window_shape_combine_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_shape_combine_region "void gdk_window_shape_combine_region(GdkWindow* window, \
cairo_region_t* shape_region, gint offset_x, gint offset_y)"
  s7_pointer _p;
  s7_pointer window, shape_region, offset_x, offset_y;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_shape_combine_region", 1, window, "GdkWindow*");
  shape_region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(shape_region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_shape_combine_region", 2, shape_region, "cairo_region_t*");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset_x)) s7_wrong_type_arg_error(sc, "gdk_window_shape_combine_region", 3, offset_x, "gint");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset_y)) s7_wrong_type_arg_error(sc, "gdk_window_shape_combine_region", 4, offset_y, "gint");
  gdk_window_shape_combine_region(s7_c_pointer(window), s7_c_pointer(shape_region), s7_integer(offset_x), s7_integer(offset_y));
  return(lg_false);
}

static s7_pointer lg_gdk_window_invalidate_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_invalidate_region "void gdk_window_invalidate_region(GdkWindow* window, cairo_region_t* region, \
gboolean invalidate_children)"
  s7_pointer _p;
  s7_pointer window, region, invalidate_children;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_region", 1, window, "GdkWindow*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_region", 2, region, "cairo_region_t*");
  invalidate_children = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(invalidate_children)) s7_wrong_type_arg_error(sc, "gdk_window_invalidate_region", 3, invalidate_children, "gboolean");
  gdk_window_invalidate_region(s7_c_pointer(window), s7_c_pointer(region), lg_boolean(invalidate_children));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_update_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_update_area "cairo_region_t* gdk_window_get_update_area(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_update_area", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_window_get_update_area(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_move_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_move_region "void gdk_window_move_region(GdkWindow* window, cairo_region_t* region, \
gint dx, gint dy)"
  s7_pointer _p;
  s7_pointer window, region, dx, dy;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_move_region", 1, window, "GdkWindow*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_move_region", 2, region, "cairo_region_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "gdk_window_move_region", 3, dx, "gint");
  dy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "gdk_window_move_region", 4, dy, "gint");
  gdk_window_move_region(s7_c_pointer(window), s7_c_pointer(region), s7_integer(dx), s7_integer(dy));
  return(lg_false);
}

static s7_pointer lg_gdk_keymap_get_num_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_num_lock_state "gboolean gdk_keymap_get_num_lock_state(GdkKeymap* keymap)"
  s7_pointer keymap;
  keymap = s7_car(args);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_num_lock_state", 1, keymap, "GdkKeymap*");
  return(s7_make_boolean(sc, gdk_keymap_get_num_lock_state(s7_c_pointer(keymap))));
}

static s7_pointer lg_gdk_window_has_native(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_has_native "gboolean gdk_window_has_native(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_has_native", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_has_native(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_cursor_get_cursor_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_cursor_type "GdkCursorType gdk_cursor_get_cursor_type(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_cursor_type", 1, cursor, "GdkCursor*");
  return(s7_make_integer(sc, gdk_cursor_get_cursor_type(s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_display_is_closed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_closed "gboolean gdk_display_is_closed(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_closed", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_closed(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_window_create_similar_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_create_similar_surface "cairo_surface_t* gdk_window_create_similar_surface(GdkWindow* window, \
cairo_content_t content, int width, int height)"
  s7_pointer _p;
  s7_pointer window, content, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_surface", 1, window, "GdkWindow*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_surface", 2, content, "cairo_content_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_surface", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_surface", 4, height, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gdk_window_create_similar_surface(s7_c_pointer(window), s7_integer(content), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_gtk_expander_set_label_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_label_fill "void gtk_expander_set_label_fill(GtkExpander* expander, gboolean label_fill)"
  s7_pointer _p;
  s7_pointer expander, label_fill;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_fill", 1, expander, "GtkExpander*");
  label_fill = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(label_fill)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_fill", 2, label_fill, "gboolean");
  gtk_expander_set_label_fill(s7_c_pointer(expander), lg_boolean(label_fill));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_label_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_label_fill "gboolean gtk_expander_get_label_fill(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_label_fill", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_label_fill(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_calendar_get_day_is_marked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_day_is_marked "gboolean gtk_calendar_get_day_is_marked(GtkCalendar* calendar, \
guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_day_is_marked", 1, calendar, "GtkCalendar*");
  day = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_day_is_marked", 2, day, "guint");
  return(s7_make_boolean(sc, gtk_calendar_get_day_is_marked(s7_c_pointer(calendar), s7_integer(day))));
}

static s7_pointer lg_gtk_progress_bar_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_inverted "void gtk_progress_bar_set_inverted(GtkProgressBar* pbar, gboolean inverted)"
  s7_pointer _p;
  s7_pointer pbar, inverted;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_inverted", 1, pbar, "GtkProgressBar*");
  inverted = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(inverted)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_inverted", 2, inverted, "gboolean");
  gtk_progress_bar_set_inverted(s7_c_pointer(pbar), lg_boolean(inverted));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_inverted "gboolean gtk_progress_bar_get_inverted(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_inverted", 1, pbar, "GtkProgressBar*");
  return(s7_make_boolean(sc, gtk_progress_bar_get_inverted(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_radio_button_join_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_join_group "void gtk_radio_button_join_group(GtkRadioButton* radio_button, \
GtkRadioButton* group_source)"
  s7_pointer _p;
  s7_pointer radio_button, group_source;
  _p = args;
  radio_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_join_group", 1, radio_button, "GtkRadioButton*");
  group_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group_source, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_join_group", 2, group_source, "GtkRadioButton*");
  gtk_radio_button_join_group(s7_c_pointer(radio_button), s7_c_pointer(group_source));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_new "GtkAdjustment* gtk_adjustment_new(gdouble value, gdouble lower, gdouble upper, \
gdouble step_increment, gdouble page_increment, gdouble page_size)"
  s7_pointer _p;
  s7_pointer value, lower, upper, step_increment, page_increment, page_size;
  _p = args;
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 1, value, "gdouble");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 2, lower, "gdouble");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 3, upper, "gdouble");
  step_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 4, step_increment, "gdouble");
  page_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 5, page_increment, "gdouble");
  page_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 6, page_size, "gdouble");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_adjustment_new(s7_real(value), s7_real(lower), s7_real(upper), s7_real(step_increment), s7_real(page_increment), s7_real(page_size))));
}

static s7_pointer lg_gtk_binding_set_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_binding_set_activate "gboolean gtk_binding_set_activate(GtkBindingSet* binding_set, guint keyval, \
GdkModifierType modifiers, GObject* object)"
  s7_pointer _p;
  s7_pointer binding_set, keyval, modifiers, object;
  _p = args;
  binding_set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(binding_set, GtkBindingSet__sym)) s7_wrong_type_arg_error(sc, "gtk_binding_set_activate", 1, binding_set, "GtkBindingSet*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_binding_set_activate", 2, keyval, "guint");
  modifiers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_binding_set_activate", 3, modifiers, "GdkModifierType");
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_binding_set_activate", 4, object, "GObject*");
  return(s7_make_boolean(sc, gtk_binding_set_activate(s7_c_pointer(binding_set), s7_integer(keyval), s7_integer(modifiers), s7_c_pointer(object))));
}

static s7_pointer lg_gtk_bindings_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_bindings_activate "gboolean gtk_bindings_activate(GObject* object, guint keyval, GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer object, keyval, modifiers;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_bindings_activate", 1, object, "GObject*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_bindings_activate", 2, keyval, "guint");
  modifiers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_bindings_activate", 3, modifiers, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_bindings_activate(s7_c_pointer(object), s7_integer(keyval), s7_integer(modifiers))));
}

static s7_pointer lg_gtk_icon_view_create_drag_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_create_drag_icon "cairo_surface_t* gtk_icon_view_create_drag_icon(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_create_drag_icon", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_create_drag_icon", 2, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gtk_icon_view_create_drag_icon(s7_c_pointer(icon_view), s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_create_row_drag_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_create_row_drag_icon "cairo_surface_t* gtk_tree_view_create_row_drag_icon(GtkTreeView* tree_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_create_row_drag_icon", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_create_row_drag_icon", 2, path, "GtkTreePath*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gtk_tree_view_create_row_drag_icon(s7_c_pointer(tree_view), s7_c_pointer(path))));
}

static s7_pointer lg_gdk_cairo_get_clip_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_get_clip_rectangle "gboolean gdk_cairo_get_clip_rectangle(cairo_t* cr, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer cr, rect;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_get_clip_rectangle", 1, cr, "cairo_t*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_get_clip_rectangle", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gdk_cairo_get_clip_rectangle(s7_c_pointer(cr), s7_c_pointer(rect))));
}

static s7_pointer lg_gdk_cairo_region_create_from_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_region_create_from_surface "cairo_region_t* gdk_cairo_region_create_from_surface(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_region_create_from_surface", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_cairo_region_create_from_surface(s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_window_get_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_screen "GdkScreen* gdk_window_get_screen(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_screen", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gdk_window_get_screen(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_display "GdkDisplay* gdk_window_get_display(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_display", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_window_get_display(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_width "int gdk_window_get_width(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_width", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_width(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_height "int gdk_window_get_height(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_height", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_height(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_cell_renderer_get_request_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_request_mode "GtkSizeRequestMode gtk_cell_renderer_get_request_mode(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_request_mode", 1, cell, "GtkCellRenderer*");
  return(s7_make_integer(sc, gtk_cell_renderer_get_request_mode(s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_width "void gtk_cell_renderer_get_preferred_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  s7_pointer _p;
  s7_pointer cell, widget;
  gint ref_minimum_size;
  gint ref_natural_size;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width", 2, widget, "GtkWidget*");
  gtk_cell_renderer_get_preferred_width(s7_c_pointer(cell), s7_c_pointer(widget), &ref_minimum_size, &ref_natural_size);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_size), s7_make_integer(sc, ref_natural_size)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_height_for_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_height_for_width "void gtk_cell_renderer_get_preferred_height_for_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint width, gint* [minimum_height], gint* [natural_height])"
  s7_pointer _p;
  s7_pointer cell, widget, width;
  gint ref_minimum_height;
  gint ref_natural_height;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 2, widget, "GtkWidget*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 3, width, "gint");
  gtk_cell_renderer_get_preferred_height_for_width(s7_c_pointer(cell), s7_c_pointer(widget), s7_integer(width), &ref_minimum_height, &ref_natural_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_height), s7_make_integer(sc, ref_natural_height)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_height "void gtk_cell_renderer_get_preferred_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  s7_pointer _p;
  s7_pointer cell, widget;
  gint ref_minimum_size;
  gint ref_natural_size;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height", 2, widget, "GtkWidget*");
  gtk_cell_renderer_get_preferred_height(s7_c_pointer(cell), s7_c_pointer(widget), &ref_minimum_size, &ref_natural_size);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_size), s7_make_integer(sc, ref_natural_size)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_width_for_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_width_for_height "void gtk_cell_renderer_get_preferred_width_for_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint height, gint* [minimum_width], gint* [natural_width])"
  s7_pointer _p;
  s7_pointer cell, widget, height;
  gint ref_minimum_width;
  gint ref_natural_width;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 2, widget, "GtkWidget*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 3, height, "gint");
  gtk_cell_renderer_get_preferred_width_for_height(s7_c_pointer(cell), s7_c_pointer(widget), s7_integer(height), &ref_minimum_width, &ref_natural_width);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_width), s7_make_integer(sc, ref_natural_width)));
}

static s7_pointer lg_gtk_drag_set_icon_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_surface "void gtk_drag_set_icon_surface(GdkDragContext* context, cairo_surface_t* surface)"
  s7_pointer _p;
  s7_pointer context, surface;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_surface", 1, context, "GdkDragContext*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_surface", 2, surface, "cairo_surface_t*");
  gtk_drag_set_icon_surface(s7_c_pointer(context), s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_group_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_group_name "void gtk_notebook_set_group_name(GtkNotebook* notebook, gchar* group_name)"
  s7_pointer _p;
  s7_pointer notebook, group_name;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_group_name", 1, notebook, "GtkNotebook*");
  group_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(group_name)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_group_name", 2, group_name, "gchar*");
  gtk_notebook_set_group_name(s7_c_pointer(notebook), (const gchar*)s7_string(group_name));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_group_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_group_name "gchar* gtk_notebook_get_group_name(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_group_name", 1, notebook, "GtkNotebook*");
    return(s7_make_string(sc, (gchar*)gtk_notebook_get_group_name(s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_widget_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_draw "void gtk_widget_draw(GtkWidget* widget, cairo_t* cr)"
  s7_pointer _p;
  s7_pointer widget, cr;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_draw", 1, widget, "GtkWidget*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_draw", 2, cr, "cairo_t*");
  gtk_widget_draw(s7_c_pointer(widget), s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_request_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_request_mode "GtkSizeRequestMode gtk_widget_get_request_mode(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_request_mode", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_request_mode(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_allocated_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_width "int gtk_widget_get_allocated_width(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_width", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_width(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_allocated_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_height "int gtk_widget_get_allocated_height(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_height", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_height(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_halign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_halign "GtkAlign gtk_widget_get_halign(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_halign", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_halign(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_halign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_halign "void gtk_widget_set_halign(GtkWidget* widget, GtkAlign align)"
  s7_pointer _p;
  s7_pointer widget, align;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_halign", 1, widget, "GtkWidget*");
  align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(align)) s7_wrong_type_arg_error(sc, "gtk_widget_set_halign", 2, align, "GtkAlign");
  gtk_widget_set_halign(s7_c_pointer(widget), s7_integer(align));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_valign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_valign "GtkAlign gtk_widget_get_valign(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_valign", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_valign(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_valign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_valign "void gtk_widget_set_valign(GtkWidget* widget, GtkAlign align)"
  s7_pointer _p;
  s7_pointer widget, align;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_valign", 1, widget, "GtkWidget*");
  align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(align)) s7_wrong_type_arg_error(sc, "gtk_widget_set_valign", 2, align, "GtkAlign");
  gtk_widget_set_valign(s7_c_pointer(widget), s7_integer(align));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_top(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_top "gint gtk_widget_get_margin_top(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_top", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_top(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_top(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_top "void gtk_widget_set_margin_top(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_top", 1, widget, "GtkWidget*");
  margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_top", 2, margin, "gint");
  gtk_widget_set_margin_top(s7_c_pointer(widget), s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_bottom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_bottom "gint gtk_widget_get_margin_bottom(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_bottom", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_bottom(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_bottom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_bottom "void gtk_widget_set_margin_bottom(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_bottom", 1, widget, "GtkWidget*");
  margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_bottom", 2, margin, "gint");
  gtk_widget_set_margin_bottom(s7_c_pointer(widget), s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_shape_combine_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_shape_combine_region "void gtk_widget_shape_combine_region(GtkWidget* widget, \
cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer widget, region;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_shape_combine_region", 1, widget, "GtkWidget*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_shape_combine_region", 2, region, "cairo_region_t*");
  gtk_widget_shape_combine_region(s7_c_pointer(widget), s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_input_shape_combine_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_input_shape_combine_region "void gtk_widget_input_shape_combine_region(GtkWidget* widget, \
cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer widget, region;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_input_shape_combine_region", 1, widget, "GtkWidget*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_input_shape_combine_region", 2, region, "cairo_region_t*");
  gtk_widget_input_shape_combine_region(s7_c_pointer(widget), s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_gtk_cairo_transform_to_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cairo_transform_to_window "void gtk_cairo_transform_to_window(cairo_t* cr, GtkWidget* widget, \
GdkWindow* window)"
  s7_pointer _p;
  s7_pointer cr, widget, window;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_cairo_transform_to_window", 1, cr, "cairo_t*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cairo_transform_to_window", 2, widget, "GtkWidget*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_cairo_transform_to_window", 3, window, "GdkWindow*");
  gtk_cairo_transform_to_window(s7_c_pointer(cr), s7_c_pointer(widget), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new_with_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_entry "GtkWidget* gtk_combo_box_new_with_entry( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_new_with_entry()));
}

static s7_pointer lg_gtk_combo_box_get_has_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_has_entry "gboolean gtk_combo_box_get_has_entry(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_has_entry", 1, combo_box, "GtkComboBox*");
  return(s7_make_boolean(sc, gtk_combo_box_get_has_entry(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_entry_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_entry_text_column "void gtk_combo_box_set_entry_text_column(GtkComboBox* combo_box, \
gint text_column)"
  s7_pointer _p;
  s7_pointer combo_box, text_column;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_entry_text_column", 1, combo_box, "GtkComboBox*");
  text_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(text_column)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_entry_text_column", 2, text_column, "gint");
  gtk_combo_box_set_entry_text_column(s7_c_pointer(combo_box), s7_integer(text_column));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_entry_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_entry_text_column "gint gtk_combo_box_get_entry_text_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_entry_text_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_entry_text_column(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_target_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_entry_new "GtkTargetEntry* gtk_target_entry_new(char* target, guint flags, guint info)"
  s7_pointer _p;
  s7_pointer target, flags, info;
  _p = args;
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(target)) s7_wrong_type_arg_error(sc, "gtk_target_entry_new", 1, target, "char*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_target_entry_new", 2, flags, "guint");
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(info)) s7_wrong_type_arg_error(sc, "gtk_target_entry_new", 3, info, "guint");
  return(s7_make_type_with_c_pointer(sc, GtkTargetEntry__sym, gtk_target_entry_new((const char*)(char*)s7_string(target), s7_integer(flags), s7_integer(info))));
}

static s7_pointer lg_gtk_target_entry_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_entry_copy "GtkTargetEntry* gtk_target_entry_copy(GtkTargetEntry* data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_target_entry_copy", 1, data, "GtkTargetEntry*");
  return(s7_make_type_with_c_pointer(sc, GtkTargetEntry__sym, gtk_target_entry_copy(s7_c_pointer(data))));
}

static s7_pointer lg_gtk_target_entry_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_target_entry_free "void gtk_target_entry_free(GtkTargetEntry* data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, GtkTargetEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_target_entry_free", 1, data, "GtkTargetEntry*");
  gtk_target_entry_free(s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_hexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_hexpand "gboolean gtk_widget_get_hexpand(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_hexpand", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_hexpand(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_hexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_hexpand "void gtk_widget_set_hexpand(GtkWidget* widget, gboolean expand)"
  s7_pointer _p;
  s7_pointer widget, expand;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand", 1, widget, "GtkWidget*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand", 2, expand, "gboolean");
  gtk_widget_set_hexpand(s7_c_pointer(widget), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_hexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_hexpand_set "gboolean gtk_widget_get_hexpand_set(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_hexpand_set", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_hexpand_set(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_hexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_hexpand_set "void gtk_widget_set_hexpand_set(GtkWidget* widget, gboolean set)"
  s7_pointer _p;
  s7_pointer widget, set;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand_set", 1, widget, "GtkWidget*");
  set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(set)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand_set", 2, set, "gboolean");
  gtk_widget_set_hexpand_set(s7_c_pointer(widget), lg_boolean(set));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_vexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_vexpand "gboolean gtk_widget_get_vexpand(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_vexpand", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_vexpand(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_vexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_vexpand "void gtk_widget_set_vexpand(GtkWidget* widget, gboolean expand)"
  s7_pointer _p;
  s7_pointer widget, expand;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand", 1, widget, "GtkWidget*");
  expand = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand", 2, expand, "gboolean");
  gtk_widget_set_vexpand(s7_c_pointer(widget), lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_vexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_vexpand_set "gboolean gtk_widget_get_vexpand_set(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_vexpand_set", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_vexpand_set(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_vexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_vexpand_set "void gtk_widget_set_vexpand_set(GtkWidget* widget, gboolean set)"
  s7_pointer _p;
  s7_pointer widget, set;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand_set", 1, widget, "GtkWidget*");
  set = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(set)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand_set", 2, set, "gboolean");
  gtk_widget_set_vexpand_set(s7_c_pointer(widget), lg_boolean(set));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_compute_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_compute_expand "void gtk_widget_queue_compute_expand(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_compute_expand", 1, widget, "GtkWidget*");
  gtk_widget_queue_compute_expand(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_compute_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_compute_expand "gboolean gtk_widget_compute_expand(GtkWidget* widget, GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer widget, orientation;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_expand", 1, widget, "GtkWidget*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_expand", 2, orientation, "GtkOrientation");
  return(s7_make_boolean(sc, gtk_widget_compute_expand(s7_c_pointer(widget), s7_integer(orientation))));
}

static s7_pointer lg_gtk_combo_box_text_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_new "GtkWidget* gtk_combo_box_text_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_text_new()));
}

static s7_pointer lg_gtk_combo_box_text_new_with_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_new_with_entry "GtkWidget* gtk_combo_box_text_new_with_entry( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_text_new_with_entry()));
}

static s7_pointer lg_gtk_combo_box_text_append_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_append_text "void gtk_combo_box_text_append_text(GtkComboBoxText* combo_box, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append_text", 1, combo_box, "GtkComboBoxText*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append_text", 2, text, "gchar*");
  gtk_combo_box_text_append_text(s7_c_pointer(combo_box), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_insert_text "void gtk_combo_box_text_insert_text(GtkComboBoxText* combo_box, \
gint position, gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, position, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 2, position, "gint");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 3, text, "gchar*");
  gtk_combo_box_text_insert_text(s7_c_pointer(combo_box), s7_integer(position), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_prepend_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_prepend_text "void gtk_combo_box_text_prepend_text(GtkComboBoxText* combo_box, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend_text", 1, combo_box, "GtkComboBoxText*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend_text", 2, text, "gchar*");
  gtk_combo_box_text_prepend_text(s7_c_pointer(combo_box), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_remove "void gtk_combo_box_text_remove(GtkComboBoxText* combo_box, gint position)"
  s7_pointer _p;
  s7_pointer combo_box, position;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove", 2, position, "gint");
  gtk_combo_box_text_remove(s7_c_pointer(combo_box), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_get_active_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_get_active_text "gchar* gtk_combo_box_text_get_active_text(GtkComboBoxText* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_get_active_text", 1, combo_box, "GtkComboBoxText*");
  return(s7_make_string(sc, gtk_combo_box_text_get_active_text(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gdk_cairo_set_source_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_set_source_rgba "void gdk_cairo_set_source_rgba(cairo_t* cr, GdkRGBA* rgba)"
  s7_pointer _p;
  s7_pointer cr, rgba;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_rgba", 1, cr, "cairo_t*");
  rgba = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_rgba", 2, rgba, "GdkRGBA*");
  gdk_cairo_set_source_rgba(s7_c_pointer(cr), s7_c_pointer(rgba));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_remove_all "void gtk_combo_box_text_remove_all(GtkComboBoxText* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove_all", 1, combo_box, "GtkComboBoxText*");
  gtk_combo_box_text_remove_all(s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_popup_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_popup_fixed_width "void gtk_combo_box_set_popup_fixed_width(GtkComboBox* combo_box, \
gboolean fixed)"
  s7_pointer _p;
  s7_pointer combo_box, fixed;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_popup_fixed_width", 1, combo_box, "GtkComboBox*");
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(fixed)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_popup_fixed_width", 2, fixed, "gboolean");
  gtk_combo_box_set_popup_fixed_width(s7_c_pointer(combo_box), lg_boolean(fixed));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_popup_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_popup_fixed_width "gboolean gtk_combo_box_get_popup_fixed_width(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_popup_fixed_width", 1, combo_box, "GtkComboBox*");
  return(s7_make_boolean(sc, gtk_combo_box_get_popup_fixed_width(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_scrolled_window_get_min_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_min_content_width "gint gtk_scrolled_window_get_min_content_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_min_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_min_content_width(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_min_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_min_content_width "void gtk_scrolled_window_set_min_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  s7_pointer _p;
  s7_pointer scrolled_window, width;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_width", 2, width, "gint");
  gtk_scrolled_window_set_min_content_width(s7_c_pointer(scrolled_window), s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_min_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_min_content_height "gint gtk_scrolled_window_get_min_content_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_min_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_min_content_height(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_min_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_min_content_height "void gtk_scrolled_window_set_min_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  s7_pointer _p;
  s7_pointer scrolled_window, height;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_height", 2, height, "gint");
  gtk_scrolled_window_set_min_content_height(s7_c_pointer(scrolled_window), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_new "GtkWidget* gtk_grid_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_grid_new()));
}

static s7_pointer lg_gtk_grid_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_attach "void gtk_grid_attach(GtkGrid* grid, GtkWidget* child, gint left, gint top, \
gint width, gint height)"
  s7_pointer _p;
  s7_pointer grid, child, left, top, width, height;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 1, grid, "GtkGrid*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 2, child, "GtkWidget*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 3, left, "gint");
  top = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 4, top, "gint");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 5, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 6, height, "gint");
  gtk_grid_attach(s7_c_pointer(grid), s7_c_pointer(child), s7_integer(left), s7_integer(top), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_attach_next_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_attach_next_to "void gtk_grid_attach_next_to(GtkGrid* grid, GtkWidget* child, GtkWidget* sibling, \
GtkPositionType side, gint width, gint height)"
  s7_pointer _p;
  s7_pointer grid, child, sibling, side, width, height;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 1, grid, "GtkGrid*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 2, child, "GtkWidget*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 3, sibling, "GtkWidget*");
  side = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(side)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 4, side, "GtkPositionType");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 5, width, "gint");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 6, height, "gint");
  gtk_grid_attach_next_to(s7_c_pointer(grid), s7_c_pointer(child), s7_c_pointer(sibling), s7_integer(side), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_set_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_homogeneous "void gtk_grid_set_row_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_homogeneous", 1, grid, "GtkGrid*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_set_row_homogeneous(s7_c_pointer(grid), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_homogeneous "gboolean gtk_grid_get_row_homogeneous(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_homogeneous", 1, grid, "GtkGrid*");
  return(s7_make_boolean(sc, gtk_grid_get_row_homogeneous(s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_spacing "void gtk_grid_set_row_spacing(GtkGrid* grid, guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_spacing", 1, grid, "GtkGrid*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_spacing", 2, spacing, "guint");
  gtk_grid_set_row_spacing(s7_c_pointer(grid), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_spacing "guint gtk_grid_get_row_spacing(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_spacing", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_row_spacing(s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_column_homogeneous "void gtk_grid_set_column_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_homogeneous", 1, grid, "GtkGrid*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_set_column_homogeneous(s7_c_pointer(grid), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_column_homogeneous "gboolean gtk_grid_get_column_homogeneous(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_column_homogeneous", 1, grid, "GtkGrid*");
  return(s7_make_boolean(sc, gtk_grid_get_column_homogeneous(s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_column_spacing "void gtk_grid_set_column_spacing(GtkGrid* grid, guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_spacing", 1, grid, "GtkGrid*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_spacing", 2, spacing, "guint");
  gtk_grid_set_column_spacing(s7_c_pointer(grid), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_column_spacing "guint gtk_grid_get_column_spacing(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_column_spacing", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_column_spacing(s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_scrollable_get_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_hadjustment "GtkAdjustment* gtk_scrollable_get_hadjustment(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_hadjustment", 1, scrollable, "GtkScrollable*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_scrollable_get_hadjustment(s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_hadjustment "void gtk_scrollable_set_hadjustment(GtkScrollable* scrollable, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrollable, hadjustment;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hadjustment", 1, scrollable, "GtkScrollable*");
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrollable_set_hadjustment(s7_c_pointer(scrollable), s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollable_get_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_vadjustment "GtkAdjustment* gtk_scrollable_get_vadjustment(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_vadjustment", 1, scrollable, "GtkScrollable*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_scrollable_get_vadjustment(s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_vadjustment "void gtk_scrollable_set_vadjustment(GtkScrollable* scrollable, \
GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer scrollable, vadjustment;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vadjustment", 1, scrollable, "GtkScrollable*");
  vadjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vadjustment", 2, vadjustment, "GtkAdjustment*");
  gtk_scrollable_set_vadjustment(s7_c_pointer(scrollable), s7_c_pointer(vadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_next_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_next_page "void gtk_assistant_next_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_next_page", 1, assistant, "GtkAssistant*");
  gtk_assistant_next_page(s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_previous_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_previous_page "void gtk_assistant_previous_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_previous_page", 1, assistant, "GtkAssistant*");
  gtk_assistant_previous_page(s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new_with_model_and_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_model_and_entry "GtkWidget* gtk_combo_box_new_with_model_and_entry(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_new_with_model_and_entry", 1, model, "GtkTreeModel*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_combo_box_new_with_model_and_entry(s7_c_pointer(model))));
}

static s7_pointer lg_gtk_scrollable_get_hscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_hscroll_policy "GtkScrollablePolicy gtk_scrollable_get_hscroll_policy(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_hscroll_policy", 1, scrollable, "GtkScrollable*");
  return(s7_make_integer(sc, gtk_scrollable_get_hscroll_policy(s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_hscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_hscroll_policy "void gtk_scrollable_set_hscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  s7_pointer _p;
  s7_pointer scrollable, policy;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hscroll_policy", 1, scrollable, "GtkScrollable*");
  policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hscroll_policy", 2, policy, "GtkScrollablePolicy");
  gtk_scrollable_set_hscroll_policy(s7_c_pointer(scrollable), s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollable_get_vscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_vscroll_policy "GtkScrollablePolicy gtk_scrollable_get_vscroll_policy(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_vscroll_policy", 1, scrollable, "GtkScrollable*");
  return(s7_make_integer(sc, gtk_scrollable_get_vscroll_policy(s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_vscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_vscroll_policy "void gtk_scrollable_set_vscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  s7_pointer _p;
  s7_pointer scrollable, policy;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vscroll_policy", 1, scrollable, "GtkScrollable*");
  policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vscroll_policy", 2, policy, "GtkScrollablePolicy");
  gtk_scrollable_set_vscroll_policy(s7_c_pointer(scrollable), s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_new "GtkWidget* gtk_switch_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_switch_new()));
}

static s7_pointer lg_gtk_switch_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_set_active "void gtk_switch_set_active(GtkSwitch* sw, gboolean is_active)"
  s7_pointer _p;
  s7_pointer sw, is_active;
  _p = args;
  sw = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_set_active", 1, sw, "GtkSwitch*");
  is_active = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_switch_set_active", 2, is_active, "gboolean");
  gtk_switch_set_active(s7_c_pointer(sw), lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_get_active "gboolean gtk_switch_get_active(GtkSwitch* sw)"
  s7_pointer sw;
  sw = s7_car(args);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_get_active", 1, sw, "GtkSwitch*");
  return(s7_make_boolean(sc, gtk_switch_get_active(s7_c_pointer(sw))));
}

static s7_pointer lg_gdk_window_get_clip_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_clip_region "cairo_region_t* gdk_window_get_clip_region(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_clip_region", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_window_get_clip_region(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_visible_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_visible_region "cairo_region_t* gdk_window_get_visible_region(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_visible_region", 1, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_window_get_visible_region(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_border_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_new "GtkBorder* gtk_border_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkBorder__sym, gtk_border_new()));
}

static s7_pointer lg_gtk_border_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_copy "GtkBorder* gtk_border_copy(GtkBorder* border_)"
  s7_pointer border_;
  border_ = s7_car(args);
  if (!s7_is_c_pointer_of_type(border_, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_border_copy", 1, border_, "GtkBorder*");
  return(s7_make_type_with_c_pointer(sc, GtkBorder__sym, gtk_border_copy(s7_c_pointer(border_))));
}

static s7_pointer lg_gtk_border_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_free "void gtk_border_free(GtkBorder* border_)"
  s7_pointer border_;
  border_ = s7_car(args);
  if (!s7_is_c_pointer_of_type(border_, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_border_free", 1, border_, "GtkBorder*");
  gtk_border_free(s7_c_pointer(border_));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_id_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_id_column "gint gtk_combo_box_get_id_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_id_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_id_column(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_id_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_id_column "void gtk_combo_box_set_id_column(GtkComboBox* combo_box, gint id_column)"
  s7_pointer _p;
  s7_pointer combo_box, id_column;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_id_column", 1, combo_box, "GtkComboBox*");
  id_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(id_column)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_id_column", 2, id_column, "gint");
  gtk_combo_box_set_id_column(s7_c_pointer(combo_box), s7_integer(id_column));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active_id "gchar* gtk_combo_box_get_active_id(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_id", 1, combo_box, "GtkComboBox*");
  return(s7_make_string(sc, gtk_combo_box_get_active_id(s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_text_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_insert "void gtk_combo_box_text_insert(GtkComboBoxText* combo_box, gint position, \
gchar* id, gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, position, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 2, position, "gint");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 3, id, "gchar*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 4, text, "gchar*");
  gtk_combo_box_text_insert(s7_c_pointer(combo_box), s7_integer(position), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_append "void gtk_combo_box_text_append(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 1, combo_box, "GtkComboBoxText*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 2, id, "gchar*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 3, text, "gchar*");
  gtk_combo_box_text_append(s7_c_pointer(combo_box), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_prepend "void gtk_combo_box_text_prepend(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 1, combo_box, "GtkComboBoxText*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 2, id, "gchar*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 3, text, "gchar*");
  gtk_combo_box_text_prepend(s7_c_pointer(combo_box), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_button_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_new "GtkWidget* gtk_button_box_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_button_box_new", 1, orientation, "GtkOrientation");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_button_box_new(s7_integer(orientation))));
}

static s7_pointer lg_gtk_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_new "GtkWidget* gtk_box_new(GtkOrientation orientation, gint spacing)"
  s7_pointer _p;
  s7_pointer orientation, spacing;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_box_new", 1, orientation, "GtkOrientation");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_box_new", 2, spacing, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_box_new(s7_integer(orientation), s7_integer(spacing))));
}

static s7_pointer lg_gtk_tree_view_set_cursor_on_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_cursor_on_cell "void gtk_tree_view_set_cursor_on_cell(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* focus_column, GtkCellRenderer* focus_cell, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer tree_view, path, focus_column, focus_cell, start_editing;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 2, path, "GtkTreePath*");
  focus_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 3, focus_column, "GtkTreeViewColumn*");
  focus_cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 4, focus_cell, "GtkCellRenderer*");
  start_editing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 5, start_editing, "gboolean");
  gtk_tree_view_set_cursor_on_cell(s7_c_pointer(tree_view), s7_c_pointer(path), s7_c_pointer(focus_column), s7_c_pointer(focus_cell), lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_rubber_banding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_rubber_banding "void gtk_tree_view_set_rubber_banding(GtkTreeView* tree_view, \
gboolean enable)"
  s7_pointer _p;
  s7_pointer tree_view, enable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_rubber_banding", 1, tree_view, "GtkTreeView*");
  enable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_rubber_banding", 2, enable, "gboolean");
  gtk_tree_view_set_rubber_banding(s7_c_pointer(tree_view), lg_boolean(enable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_rubber_banding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_rubber_banding "gboolean gtk_tree_view_get_rubber_banding(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_rubber_banding", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_rubber_banding(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tooltip_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_markup "void gtk_tooltip_set_markup(GtkTooltip* tooltip, gchar* markup)"
  s7_pointer _p;
  s7_pointer tooltip, markup;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_markup", 1, tooltip, "GtkTooltip*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_markup", 2, markup, "gchar*");
  gtk_tooltip_set_markup(s7_c_pointer(tooltip), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_icon "void gtk_tooltip_set_icon(GtkTooltip* tooltip, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer tooltip, pixbuf;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon", 1, tooltip, "GtkTooltip*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon", 2, pixbuf, "GdkPixbuf*");
  gtk_tooltip_set_icon(s7_c_pointer(tooltip), s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_custom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_custom "void gtk_tooltip_set_custom(GtkTooltip* tooltip, GtkWidget* custom_widget)"
  s7_pointer _p;
  s7_pointer tooltip, custom_widget;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_custom", 1, tooltip, "GtkTooltip*");
  custom_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(custom_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_custom", 2, custom_widget, "GtkWidget*");
  gtk_tooltip_set_custom(s7_c_pointer(tooltip), s7_c_pointer(custom_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_trigger_tooltip_query(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_trigger_tooltip_query "void gtk_tooltip_trigger_tooltip_query(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_trigger_tooltip_query", 1, display, "GdkDisplay*");
  gtk_tooltip_trigger_tooltip_query(s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_new_with_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new_with_area "GtkTreeViewColumn* gtk_tree_view_column_new_with_area(GtkCellArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkCellArea__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_area", 1, area, "GtkCellArea*");
  return(s7_make_type_with_c_pointer(sc, GtkTreeViewColumn__sym, gtk_tree_view_column_new_with_area(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_tree_view_column_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_button "GtkWidget* gtk_tree_view_column_get_button(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_button", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_tree_view_column_get_button(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_focus_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_focus_cell "void gtk_tree_view_column_focus_cell(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer tree_column, cell;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_focus_cell", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_focus_cell", 2, cell, "GtkCellRenderer*");
  gtk_tree_view_column_focus_cell(s7_c_pointer(tree_column), s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_clipboard_wait_is_uris_available(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_wait_is_uris_available "gboolean gtk_clipboard_wait_is_uris_available(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_wait_is_uris_available", 1, clipboard, "GtkClipboard*");
  return(s7_make_boolean(sc, gtk_clipboard_wait_is_uris_available(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_toolbar_set_drop_highlight_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_set_drop_highlight_item "void gtk_toolbar_set_drop_highlight_item(GtkToolbar* toolbar, \
GtkToolItem* tool_item, gint index)"
  s7_pointer _p;
  s7_pointer toolbar, tool_item, index;
  _p = args;
  toolbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toolbar, GtkToolbar__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_drop_highlight_item", 1, toolbar, "GtkToolbar*");
  tool_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_drop_highlight_item", 2, tool_item, "GtkToolItem*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_toolbar_set_drop_highlight_item", 3, index, "gint");
  gtk_toolbar_set_drop_highlight_item(s7_c_pointer(toolbar), s7_c_pointer(tool_item), s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_tool_item_toolbar_reconfigured(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_item_toolbar_reconfigured "void gtk_tool_item_toolbar_reconfigured(GtkToolItem* tool_item)"
  s7_pointer tool_item;
  tool_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool_item, GtkToolItem__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_item_toolbar_reconfigured", 1, tool_item, "GtkToolItem*");
  gtk_tool_item_toolbar_reconfigured(s7_c_pointer(tool_item));
  return(lg_false);
}

static s7_pointer lg_gtk_orientable_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_orientable_set_orientation "void gtk_orientable_set_orientation(GtkOrientable* orientable, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer orientable, orientation;
  _p = args;
  orientable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(orientable, GtkOrientable__sym)) s7_wrong_type_arg_error(sc, "gtk_orientable_set_orientation", 1, orientable, "GtkOrientable*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_orientable_set_orientation", 2, orientation, "GtkOrientation");
  gtk_orientable_set_orientation(s7_c_pointer(orientable), s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_orientable_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_orientable_get_orientation "GtkOrientation gtk_orientable_get_orientation(GtkOrientable* orientable)"
  s7_pointer orientable;
  orientable = s7_car(args);
  if (!s7_is_c_pointer_of_type(orientable, GtkOrientable__sym)) s7_wrong_type_arg_error(sc, "gtk_orientable_get_orientation", 1, orientable, "GtkOrientable*");
  return(s7_make_integer(sc, gtk_orientable_get_orientation(s7_c_pointer(orientable))));
}

static s7_pointer lg_gtk_get_major_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_major_version "guint gtk_get_major_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_major_version()));
}

static s7_pointer lg_gtk_get_minor_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_minor_version "guint gtk_get_minor_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_minor_version()));
}

static s7_pointer lg_gtk_get_micro_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_micro_version "guint gtk_get_micro_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_micro_version()));
}

static s7_pointer lg_gtk_get_binary_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_binary_age "guint gtk_get_binary_age( void)"
    return(s7_make_integer(sc, (guint)gtk_get_binary_age()));
}

static s7_pointer lg_gtk_get_interface_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_interface_age "guint gtk_get_interface_age( void)"
    return(s7_make_integer(sc, (guint)gtk_get_interface_age()));
}

static s7_pointer lg_gtk_progress_bar_set_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_show_text "void gtk_progress_bar_set_show_text(GtkProgressBar* pbar, \
gboolean show_text)"
  s7_pointer _p;
  s7_pointer pbar, show_text;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_show_text", 1, pbar, "GtkProgressBar*");
  show_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_text)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_show_text", 2, show_text, "gboolean");
  gtk_progress_bar_set_show_text(s7_c_pointer(pbar), lg_boolean(show_text));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_show_text "gboolean gtk_progress_bar_get_show_text(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_show_text", 1, pbar, "GtkProgressBar*");
  return(s7_make_boolean(sc, gtk_progress_bar_get_show_text(s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_invisible_new_for_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_invisible_new_for_screen "GtkWidget* gtk_invisible_new_for_screen(GdkScreen* screen)"
  s7_pointer screen;
  screen = s7_car(args);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_invisible_new_for_screen", 1, screen, "GdkScreen*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_invisible_new_for_screen(s7_c_pointer(screen))));
}

static s7_pointer lg_gtk_invisible_set_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_invisible_set_screen "void gtk_invisible_set_screen(GtkInvisible* invisible, GdkScreen* screen)"
  s7_pointer _p;
  s7_pointer invisible, screen;
  _p = args;
  invisible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(invisible, GtkInvisible__sym)) s7_wrong_type_arg_error(sc, "gtk_invisible_set_screen", 1, invisible, "GtkInvisible*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_invisible_set_screen", 2, screen, "GdkScreen*");
  gtk_invisible_set_screen(s7_c_pointer(invisible), s7_c_pointer(screen));
  return(lg_false);
}

static s7_pointer lg_gtk_invisible_get_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_invisible_get_screen "GdkScreen* gtk_invisible_get_screen(GtkInvisible* invisible)"
  s7_pointer invisible;
  invisible = s7_car(args);
  if (!s7_is_c_pointer_of_type(invisible, GtkInvisible__sym)) s7_wrong_type_arg_error(sc, "gtk_invisible_get_screen", 1, invisible, "GtkInvisible*");
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gtk_invisible_get_screen(s7_c_pointer(invisible))));
}

static s7_pointer lg_gtk_entry_get_icon_storage_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_storage_type "GtkImageType gtk_entry_get_icon_storage_type(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_storage_type", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_storage_type", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_integer(sc, gtk_entry_get_icon_storage_type(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_pixbuf "GdkPixbuf* gtk_entry_get_icon_pixbuf(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_pixbuf", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_pixbuf", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_entry_get_icon_pixbuf(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_gicon "GIcon* gtk_entry_get_icon_gicon(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_gicon", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_gicon", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_type_with_c_pointer(sc, GIcon__sym, gtk_entry_get_icon_gicon(s7_c_pointer(entry), s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_container_propagate_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_propagate_draw "void gtk_container_propagate_draw(GtkContainer* container, \
GtkWidget* child, cairo_t* cr)"
  s7_pointer _p;
  s7_pointer container, child, cr;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_propagate_draw", 1, container, "GtkContainer*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_propagate_draw", 2, child, "GtkWidget*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_container_propagate_draw", 3, cr, "cairo_t*");
  gtk_container_propagate_draw(s7_c_pointer(container), s7_c_pointer(child), s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_gtk_container_set_focus_chain(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_set_focus_chain "void gtk_container_set_focus_chain(GtkContainer* container, \
GList* focusable_widgets)"
  s7_pointer _p;
  s7_pointer container, focusable_widgets;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_chain", 1, container, "GtkContainer*");
  focusable_widgets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focusable_widgets, GList__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_chain", 2, focusable_widgets, "GList*");
  gtk_container_set_focus_chain(s7_c_pointer(container), s7_c_pointer(focusable_widgets));
  return(lg_false);
}

static s7_pointer lg_gtk_container_get_focus_chain(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_get_focus_chain "gboolean gtk_container_get_focus_chain(GtkContainer* container, \
GList** [focusable_widgets])"
  s7_pointer _p;
  s7_pointer container;
  GList* ref_focusable_widgets = NULL;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_get_focus_chain", 1, container, "GtkContainer*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_container_get_focus_chain(s7_c_pointer(container), &ref_focusable_widgets));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_focusable_widgets)));
   }
}

static s7_pointer lg_gtk_container_unset_focus_chain(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_unset_focus_chain "void gtk_container_unset_focus_chain(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_unset_focus_chain", 1, container, "GtkContainer*");
  gtk_container_unset_focus_chain(s7_c_pointer(container));
  return(lg_false);
}

static s7_pointer lg_gtk_container_set_focus_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_set_focus_vadjustment "void gtk_container_set_focus_vadjustment(GtkContainer* container, \
GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer container, adjustment;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_vadjustment", 1, container, "GtkContainer*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_vadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_container_set_focus_vadjustment(s7_c_pointer(container), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_container_get_focus_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_get_focus_vadjustment "GtkAdjustment* gtk_container_get_focus_vadjustment(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_get_focus_vadjustment", 1, container, "GtkContainer*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_container_get_focus_vadjustment(s7_c_pointer(container))));
}

static s7_pointer lg_gtk_container_set_focus_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_set_focus_hadjustment "void gtk_container_set_focus_hadjustment(GtkContainer* container, \
GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer container, adjustment;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_hadjustment", 1, container, "GtkContainer*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_container_set_focus_hadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_container_set_focus_hadjustment(s7_c_pointer(container), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_container_get_focus_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_get_focus_hadjustment "GtkAdjustment* gtk_container_get_focus_hadjustment(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_get_focus_hadjustment", 1, container, "GtkContainer*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_container_get_focus_hadjustment(s7_c_pointer(container))));
}

static s7_pointer lg_gtk_assistant_commit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_commit "void gtk_assistant_commit(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_commit", 1, assistant, "GtkAssistant*");
  gtk_assistant_commit(s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_skip_taskbar_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_skip_taskbar_hint "void gtk_window_set_skip_taskbar_hint(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_skip_taskbar_hint", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_skip_taskbar_hint", 2, setting, "gboolean");
  gtk_window_set_skip_taskbar_hint(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_skip_taskbar_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_skip_taskbar_hint "gboolean gtk_window_get_skip_taskbar_hint(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_skip_taskbar_hint", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_skip_taskbar_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_skip_pager_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_skip_pager_hint "void gtk_window_set_skip_pager_hint(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_skip_pager_hint", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_skip_pager_hint", 2, setting, "gboolean");
  gtk_window_set_skip_pager_hint(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_skip_pager_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_skip_pager_hint "gboolean gtk_window_get_skip_pager_hint(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_skip_pager_hint", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_skip_pager_hint(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_screen "void gtk_window_set_screen(GtkWindow* window, GdkScreen* screen)"
  s7_pointer _p;
  s7_pointer window, screen;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_screen", 1, window, "GtkWindow*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_screen", 2, screen, "GdkScreen*");
  gtk_window_set_screen(s7_c_pointer(window), s7_c_pointer(screen));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_screen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_screen "GdkScreen* gtk_window_get_screen(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_screen", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkScreen__sym, gtk_window_get_screen(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_icon_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_icon_from_file "gboolean gtk_window_set_icon_from_file(GtkWindow* window, \
gchar* filename, GError** [err])"
  s7_pointer _p;
  s7_pointer window, filename;
  GError* ref_err = NULL;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_from_file", 1, window, "GtkWindow*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_from_file", 2, filename, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_window_set_icon_from_file(s7_c_pointer(window), (const gchar*)s7_string(filename), &ref_err));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_err)));
   }
}

static s7_pointer lg_gtk_window_set_default_icon_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_icon_from_file "gboolean gtk_window_set_default_icon_from_file(gchar* filename, \
GError** [err])"
  s7_pointer _p;
  s7_pointer filename;
  GError* ref_err = NULL;
  _p = args;
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_icon_from_file", 1, filename, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_window_set_default_icon_from_file((const gchar*)s7_string(filename), &ref_err));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_err)));
   }
}

static s7_pointer lg_gtk_window_fullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_fullscreen "void gtk_window_fullscreen(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen", 1, window, "GtkWindow*");
  gtk_window_fullscreen(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unfullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unfullscreen "void gtk_window_unfullscreen(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unfullscreen", 1, window, "GtkWindow*");
  gtk_window_unfullscreen(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_window_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_window_type "GtkWindowType gtk_window_get_window_type(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_window_type", 1, window, "GtkWindow*");
  return(s7_make_integer(sc, gtk_window_get_window_type(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_group_add_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_add_window "void gtk_window_group_add_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer window_group, window;
  _p = args;
  window_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_add_window", 1, window_group, "GtkWindowGroup*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_add_window", 2, window, "GtkWindow*");
  gtk_window_group_add_window(s7_c_pointer(window_group), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_group_remove_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_remove_window "void gtk_window_group_remove_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer window_group, window;
  _p = args;
  window_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_remove_window", 1, window_group, "GtkWindowGroup*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_remove_window", 2, window, "GtkWindow*");
  gtk_window_group_remove_window(s7_c_pointer(window_group), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_new "GtkWindowGroup* gtk_window_group_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWindowGroup__sym, gtk_window_group_new()));
}

static s7_pointer lg_gtk_window_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_group "GtkWindowGroup* gtk_window_get_group(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_group", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWindowGroup__sym, gtk_window_get_group(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_group_list_windows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_list_windows "GList* gtk_window_group_list_windows(GtkWindowGroup* window_group)"
  s7_pointer window_group;
  window_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_list_windows", 1, window_group, "GtkWindowGroup*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_window_group_list_windows(s7_c_pointer(window_group))));
}

static s7_pointer lg_gtk_window_group_get_current_device_grab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_get_current_device_grab "GtkWidget* gtk_window_group_get_current_device_grab(GtkWindowGroup* window_group, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer window_group, device;
  _p = args;
  window_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_get_current_device_grab", 1, window_group, "GtkWindowGroup*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_get_current_device_grab", 2, device, "GdkDevice*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_group_get_current_device_grab(s7_c_pointer(window_group), s7_c_pointer(device))));
}

static s7_pointer lg_gtk_window_group_get_current_grab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_get_current_grab "GtkWidget* gtk_window_group_get_current_grab(GtkWindowGroup* window_group)"
  s7_pointer window_group;
  window_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_get_current_grab", 1, window_group, "GtkWindowGroup*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_group_get_current_grab(s7_c_pointer(window_group))));
}

static s7_pointer lg_gtk_selection_data_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_data "guchar* gtk_selection_data_get_data(GtkSelectionData* selection_data)"
  s7_pointer selection_data;
  selection_data = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_data", 1, selection_data, "GtkSelectionData*");
  return(s7_make_type_with_c_pointer(sc, guchar__sym, (void *)gtk_selection_data_get_data(s7_c_pointer(selection_data))));
}

static s7_pointer lg_gtk_selection_owner_set_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_owner_set_for_display "gboolean gtk_selection_owner_set_for_display(GdkDisplay* display, \
GtkWidget* widget, GdkAtom selection, guint32 time)"
  s7_pointer _p;
  s7_pointer display, widget, selection, time;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set_for_display", 1, display, "GdkDisplay*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set_for_display", 2, widget, "GtkWidget*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set_for_display", 3, selection, "GdkAtom");
  time = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time)) s7_wrong_type_arg_error(sc, "gtk_selection_owner_set_for_display", 4, time, "guint32");
  return(s7_make_boolean(sc, gtk_selection_owner_set_for_display(s7_c_pointer(display), s7_c_pointer(widget), s7_c_pointer(selection), s7_integer(time))));
}

static s7_pointer lg_gtk_tool_shell_get_text_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_text_orientation "GtkOrientation gtk_tool_shell_get_text_orientation(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_text_orientation", 1, shell, "GtkToolShell*");
  return(s7_make_integer(sc, gtk_tool_shell_get_text_orientation(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_get_text_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_text_alignment "gfloat gtk_tool_shell_get_text_alignment(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_text_alignment", 1, shell, "GtkToolShell*");
  return(s7_make_real(sc, gtk_tool_shell_get_text_alignment(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_get_ellipsize_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_ellipsize_mode "PangoEllipsizeMode gtk_tool_shell_get_ellipsize_mode(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_ellipsize_mode", 1, shell, "GtkToolShell*");
  return(s7_make_integer(sc, gtk_tool_shell_get_ellipsize_mode(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_get_text_size_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_text_size_group "GtkSizeGroup* gtk_tool_shell_get_text_size_group(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_text_size_group", 1, shell, "GtkToolShell*");
  return(s7_make_type_with_c_pointer(sc, GtkSizeGroup__sym, gtk_tool_shell_get_text_size_group(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_orientation "GtkOrientation gtk_tool_shell_get_orientation(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_orientation", 1, shell, "GtkToolShell*");
  return(s7_make_integer(sc, gtk_tool_shell_get_orientation(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_get_style(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_get_style "GtkToolbarStyle gtk_tool_shell_get_style(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_get_style", 1, shell, "GtkToolShell*");
  return(s7_make_integer(sc, gtk_tool_shell_get_style(s7_c_pointer(shell))));
}

static s7_pointer lg_gtk_tool_shell_rebuild_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tool_shell_rebuild_menu "void gtk_tool_shell_rebuild_menu(GtkToolShell* shell)"
  s7_pointer shell;
  shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(shell, GtkToolShell__sym)) s7_wrong_type_arg_error(sc, "gtk_tool_shell_rebuild_menu", 1, shell, "GtkToolShell*");
  gtk_tool_shell_rebuild_menu(s7_c_pointer(shell));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_lock_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_lock_path "void gtk_accel_map_lock_path(gchar* accel_path)"
  s7_pointer accel_path;
  accel_path = s7_car(args);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_map_lock_path", 1, accel_path, "gchar*");
  gtk_accel_map_lock_path((const gchar*)s7_string(accel_path));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_map_unlock_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_map_unlock_path "void gtk_accel_map_unlock_path(gchar* accel_path)"
  s7_pointer accel_path;
  accel_path = s7_car(args);
  if (!s7_is_string(accel_path)) s7_wrong_type_arg_error(sc, "gtk_accel_map_unlock_path", 1, accel_path, "gchar*");
  gtk_accel_map_unlock_path((const gchar*)s7_string(accel_path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_lookup_by_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_by_gicon "GtkIconInfo* gtk_icon_theme_lookup_by_gicon(GtkIconTheme* icon_theme, \
GIcon* icon, gint size, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer icon_theme, icon, size, flags;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 1, icon_theme, "GtkIconTheme*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 2, icon, "GIcon*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 3, size, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 4, flags, "GtkIconLookupFlags");
  return(s7_make_type_with_c_pointer(sc, GtkIconInfo__sym, gtk_icon_theme_lookup_by_gicon(s7_c_pointer(icon_theme), s7_c_pointer(icon), s7_integer(size), s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_info_new_for_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_new_for_pixbuf "GtkIconInfo* gtk_icon_info_new_for_pixbuf(GtkIconTheme* icon_theme, \
GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer icon_theme, pixbuf;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_new_for_pixbuf", 1, icon_theme, "GtkIconTheme*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_new_for_pixbuf", 2, pixbuf, "GdkPixbuf*");
  return(s7_make_type_with_c_pointer(sc, GtkIconInfo__sym, gtk_icon_info_new_for_pixbuf(s7_c_pointer(icon_theme), s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_icon_view_set_item_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_orientation "void gtk_icon_view_set_item_orientation(GtkIconView* icon_view, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer icon_view, orientation;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_orientation", 1, icon_view, "GtkIconView*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_orientation", 2, orientation, "GtkOrientation");
  gtk_icon_view_set_item_orientation(s7_c_pointer(icon_view), s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_orientation "GtkOrientation gtk_icon_view_get_item_orientation(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_orientation", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_orientation(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_text_view_im_context_filter_keypress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_im_context_filter_keypress "gboolean gtk_text_view_im_context_filter_keypress(GtkTextView* text_view, \
GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer text_view, event;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_im_context_filter_keypress", 1, text_view, "GtkTextView*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_im_context_filter_keypress", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_text_view_im_context_filter_keypress(s7_c_pointer(text_view), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_text_view_reset_im_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_reset_im_context "void gtk_text_view_reset_im_context(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_reset_im_context", 1, text_view, "GtkTextView*");
  gtk_text_view_reset_im_context(s7_c_pointer(text_view));
  return(lg_false);
}

static s7_pointer lg_gdk_device_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_position "void gdk_device_get_position(GdkDevice* device, GdkScreen** screen, \
gint* [x], gint* [y])"
  s7_pointer _p;
  s7_pointer device, screen;
  gint ref_x;
  gint ref_y;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_position", 1, device, "GdkDevice*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen___sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_position", 2, screen, "GdkScreen**");
  gdk_device_get_position(s7_c_pointer(device), s7_c_pointer(screen), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gdk_device_get_window_at_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_window_at_position "GdkWindow* gdk_device_get_window_at_position(GdkDevice* device, \
gint* [win_x], gint* [win_y])"
  s7_pointer _p;
  s7_pointer device;
  gint ref_win_x;
  gint ref_win_y;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_window_at_position", 1, device, "GdkDevice*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_device_get_window_at_position(s7_c_pointer(device), &ref_win_x, &ref_win_y));
      return(s7_list(sc, 3, result, s7_make_integer(sc, ref_win_x), s7_make_integer(sc, ref_win_y)));
   }
}

static s7_pointer lg_gtk_cell_view_get_draw_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_draw_sensitive "gboolean gtk_cell_view_get_draw_sensitive(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_draw_sensitive", 1, cell_view, "GtkCellView*");
  return(s7_make_boolean(sc, gtk_cell_view_get_draw_sensitive(s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_cell_view_set_draw_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_draw_sensitive "void gtk_cell_view_set_draw_sensitive(GtkCellView* cell_view, \
gboolean draw_sensitive)"
  s7_pointer _p;
  s7_pointer cell_view, draw_sensitive;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_draw_sensitive", 1, cell_view, "GtkCellView*");
  draw_sensitive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(draw_sensitive)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_draw_sensitive", 2, draw_sensitive, "gboolean");
  gtk_cell_view_set_draw_sensitive(s7_c_pointer(cell_view), lg_boolean(draw_sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_fit_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_fit_model "gboolean gtk_cell_view_get_fit_model(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_fit_model", 1, cell_view, "GtkCellView*");
  return(s7_make_boolean(sc, gtk_cell_view_get_fit_model(s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_cell_view_set_fit_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_fit_model "void gtk_cell_view_set_fit_model(GtkCellView* cell_view, gboolean fit_model)"
  s7_pointer _p;
  s7_pointer cell_view, fit_model;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_fit_model", 1, cell_view, "GtkCellView*");
  fit_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(fit_model)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_fit_model", 2, fit_model, "gboolean");
  gtk_cell_view_set_fit_model(s7_c_pointer(cell_view), lg_boolean(fit_model));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_new_with_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new_with_area "GtkWidget* gtk_icon_view_new_with_area(GtkCellArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkCellArea__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_new_with_area", 1, area, "GtkCellArea*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_icon_view_new_with_area(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_menu_item_set_reserve_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_set_reserve_indicator "void gtk_menu_item_set_reserve_indicator(GtkMenuItem* menu_item, \
gboolean reserve)"
  s7_pointer _p;
  s7_pointer menu_item, reserve;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_reserve_indicator", 1, menu_item, "GtkMenuItem*");
  reserve = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reserve)) s7_wrong_type_arg_error(sc, "gtk_menu_item_set_reserve_indicator", 2, reserve, "gboolean");
  gtk_menu_item_set_reserve_indicator(s7_c_pointer(menu_item), lg_boolean(reserve));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_item_get_reserve_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_item_get_reserve_indicator "gboolean gtk_menu_item_get_reserve_indicator(GtkMenuItem* menu_item)"
  s7_pointer menu_item;
  menu_item = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_item, GtkMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_item_get_reserve_indicator", 1, menu_item, "GtkMenuItem*");
  return(s7_make_boolean(sc, gtk_menu_item_get_reserve_indicator(s7_c_pointer(menu_item))));
}

static s7_pointer lg_gtk_menu_shell_get_selected_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_get_selected_item "GtkWidget* gtk_menu_shell_get_selected_item(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_get_selected_item", 1, menu_shell, "GtkMenuShell*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_shell_get_selected_item(s7_c_pointer(menu_shell))));
}

static s7_pointer lg_gtk_menu_shell_get_parent_shell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_get_parent_shell "GtkWidget* gtk_menu_shell_get_parent_shell(GtkMenuShell* menu_shell)"
  s7_pointer menu_shell;
  menu_shell = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_get_parent_shell", 1, menu_shell, "GtkMenuShell*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_shell_get_parent_shell(s7_c_pointer(menu_shell))));
}

static s7_pointer lg_gtk_selection_data_get_data_with_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_data_get_data_with_length "guchar* gtk_selection_data_get_data_with_length(GtkSelectionData* selection_data, \
gint* [length])"
  s7_pointer _p;
  s7_pointer selection_data;
  gint ref_length;
  _p = args;
  selection_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection_data, GtkSelectionData__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_data_get_data_with_length", 1, selection_data, "GtkSelectionData*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, guchar__sym, (void *)gtk_selection_data_get_data_with_length(s7_c_pointer(selection_data), &ref_length));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_tree_model_iter_previous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_previous "gboolean gtk_tree_model_iter_previous(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_previous", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_previous", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_previous(s7_c_pointer(tree_model), s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_view_is_blank_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_is_blank_at_pos "gboolean gtk_tree_view_is_blank_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  s7_pointer _p;
  s7_pointer tree_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 1, tree_view, "GtkTreeView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 3, y, "gint");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_tree_view_is_blank_at_pos(s7_c_pointer(tree_view), s7_integer(x), s7_integer(y), &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
      return(s7_list(sc, 5, result, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_column), s7_make_integer(sc, ref_cell_x), s7_make_integer(sc, ref_cell_y)));
   }
}

static s7_pointer lg_gtk_widget_set_device_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_device_enabled "void gtk_widget_set_device_enabled(GtkWidget* widget, GdkDevice* device, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer widget, device, enabled;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_device_enabled", 1, widget, "GtkWidget*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_device_enabled", 2, device, "GdkDevice*");
  enabled = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_widget_set_device_enabled", 3, enabled, "gboolean");
  gtk_widget_set_device_enabled(s7_c_pointer(widget), s7_c_pointer(device), lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_device_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_device_enabled "gboolean gtk_widget_get_device_enabled(GtkWidget* widget, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer widget, device;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_device_enabled", 1, widget, "GtkWidget*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_device_enabled", 2, device, "GdkDevice*");
  return(s7_make_boolean(sc, gtk_widget_get_device_enabled(s7_c_pointer(widget), s7_c_pointer(device))));
}

static s7_pointer lg_gtk_window_set_has_user_ref_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_has_user_ref_count "void gtk_window_set_has_user_ref_count(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_has_user_ref_count", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_has_user_ref_count", 2, setting, "gboolean");
  gtk_window_set_has_user_ref_count(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gdk_selection_send_notify(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_send_notify "void gdk_selection_send_notify(GdkWindow* requestor, GdkAtom selection, \
GdkAtom target, GdkAtom property, guint32 time_)"
  s7_pointer _p;
  s7_pointer requestor, selection, target, property, time_;
  _p = args;
  requestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(requestor, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify", 1, requestor, "GdkWindow*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify", 2, selection, "GdkAtom");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify", 3, target, "GdkAtom");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(property, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify", 4, property, "GdkAtom");
  time_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time_)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify", 5, time_, "guint32");
  gdk_selection_send_notify(s7_c_pointer(requestor), s7_c_pointer(selection), s7_c_pointer(target), s7_c_pointer(property), s7_integer(time_));
  return(lg_false);
}

static s7_pointer lg_gdk_selection_send_notify_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_selection_send_notify_for_display "void gdk_selection_send_notify_for_display(GdkDisplay* display, \
GdkWindow* requestor, GdkAtom selection, GdkAtom target, GdkAtom property, guint32 time_)"
  s7_pointer _p;
  s7_pointer display, requestor, selection, target, property, time_;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 1, display, "GdkDisplay*");
  requestor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(requestor, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 2, requestor, "GdkWindow*");
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 3, selection, "GdkAtom");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 4, target, "GdkAtom");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(property, GdkAtom_sym)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 5, property, "GdkAtom");
  time_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(time_)) s7_wrong_type_arg_error(sc, "gdk_selection_send_notify_for_display", 6, time_, "guint32");
  gdk_selection_send_notify_for_display(s7_c_pointer(display), s7_c_pointer(requestor), s7_c_pointer(selection), s7_c_pointer(target), s7_c_pointer(property), s7_integer(time_));
  return(lg_false);
}

static s7_pointer lg_gdk_rgba_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_copy "GdkRGBA* gdk_rgba_copy(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_copy", 1, rgba, "GdkRGBA*");
  return(s7_make_type_with_c_pointer(sc, GdkRGBA__sym, gdk_rgba_copy(s7_c_pointer(rgba))));
}

static s7_pointer lg_gdk_rgba_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_free "void gdk_rgba_free(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_free", 1, rgba, "GdkRGBA*");
  gdk_rgba_free(s7_c_pointer(rgba));
  return(lg_false);
}

static s7_pointer lg_gdk_rgba_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_parse "gboolean gdk_rgba_parse(GdkRGBA* rgba, gchar* spec)"
  s7_pointer _p;
  s7_pointer rgba, spec;
  _p = args;
  rgba = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_parse", 1, rgba, "GdkRGBA*");
  spec = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(spec)) s7_wrong_type_arg_error(sc, "gdk_rgba_parse", 2, spec, "gchar*");
  return(s7_make_boolean(sc, gdk_rgba_parse(s7_c_pointer(rgba), (const gchar*)s7_string(spec))));
}

static s7_pointer lg_gdk_rgba_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_to_string "gchar* gdk_rgba_to_string(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_to_string", 1, rgba, "GdkRGBA*");
  return(s7_make_string(sc, gdk_rgba_to_string(s7_c_pointer(rgba))));
}

static s7_pointer lg_gtk_widget_set_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_state_flags "void gtk_widget_set_state_flags(GtkWidget* widget, GtkStateFlags flags, \
gboolean clear)"
  s7_pointer _p;
  s7_pointer widget, flags, clear;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 1, widget, "GtkWidget*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 2, flags, "GtkStateFlags");
  clear = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(clear)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 3, clear, "gboolean");
  gtk_widget_set_state_flags(s7_c_pointer(widget), s7_integer(flags), lg_boolean(clear));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unset_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unset_state_flags "void gtk_widget_unset_state_flags(GtkWidget* widget, GtkStateFlags flags)"
  s7_pointer _p;
  s7_pointer widget, flags;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unset_state_flags", 1, widget, "GtkWidget*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_widget_unset_state_flags", 2, flags, "GtkStateFlags");
  gtk_widget_unset_state_flags(s7_c_pointer(widget), s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_state_flags "GtkStateFlags gtk_widget_get_state_flags(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_state_flags", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_state_flags(s7_c_pointer(widget))));
}

#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_gtk_entry_get_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_placeholder_text "gchar* gtk_entry_get_placeholder_text(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_placeholder_text", 1, entry, "GtkEntry*");
  return(s7_make_string(sc, gtk_entry_get_placeholder_text(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_placeholder_text "void gtk_entry_set_placeholder_text(GtkEntry* entry, gchar* text)"
  s7_pointer _p;
  s7_pointer entry, text;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_placeholder_text", 1, entry, "GtkEntry*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_entry_set_placeholder_text", 2, text, "gchar*");
  gtk_entry_set_placeholder_text(s7_c_pointer(entry), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_set_resize_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_resize_toplevel "void gtk_expander_set_resize_toplevel(GtkExpander* expander, \
gboolean resize_toplevel)"
  s7_pointer _p;
  s7_pointer expander, resize_toplevel;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_resize_toplevel", 1, expander, "GtkExpander*");
  resize_toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resize_toplevel)) s7_wrong_type_arg_error(sc, "gtk_expander_set_resize_toplevel", 2, resize_toplevel, "gboolean");
  gtk_expander_set_resize_toplevel(s7_c_pointer(expander), lg_boolean(resize_toplevel));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_resize_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_resize_toplevel "gboolean gtk_expander_get_resize_toplevel(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_resize_toplevel", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_resize_toplevel(s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_widget_path_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_path_to_string "char* gtk_widget_path_to_string(GtkWidgetPath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_path_to_string", 1, path, "GtkWidgetPath*");
  return(s7_make_string(sc, gtk_widget_path_to_string(s7_c_pointer(path))));
}

static s7_pointer lg_gtk_button_box_get_child_non_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_get_child_non_homogeneous "gboolean gtk_button_box_get_child_non_homogeneous(GtkButtonBox* widget, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer widget, child;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_get_child_non_homogeneous", 1, widget, "GtkButtonBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_get_child_non_homogeneous", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_button_box_get_child_non_homogeneous(s7_c_pointer(widget), s7_c_pointer(child))));
}

static s7_pointer lg_gtk_button_box_set_child_non_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_box_set_child_non_homogeneous "void gtk_button_box_set_child_non_homogeneous(GtkButtonBox* widget, \
GtkWidget* child, gboolean non_homogeneous)"
  s7_pointer _p;
  s7_pointer widget, child, non_homogeneous;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkButtonBox__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_non_homogeneous", 1, widget, "GtkButtonBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_non_homogeneous", 2, child, "GtkWidget*");
  non_homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(non_homogeneous)) s7_wrong_type_arg_error(sc, "gtk_button_box_set_child_non_homogeneous", 3, non_homogeneous, "gboolean");
  gtk_button_box_set_child_non_homogeneous(s7_c_pointer(widget), s7_c_pointer(child), lg_boolean(non_homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_container_child_notify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_child_notify "void gtk_container_child_notify(GtkContainer* container, GtkWidget* child, \
gchar* property_name)"
  s7_pointer _p;
  s7_pointer container, child, property_name;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_child_notify", 1, container, "GtkContainer*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_child_notify", 2, child, "GtkWidget*");
  property_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(property_name)) s7_wrong_type_arg_error(sc, "gtk_container_child_notify", 3, property_name, "gchar*");
  gtk_container_child_notify(s7_c_pointer(container), s7_c_pointer(child), (const gchar*)s7_string(property_name));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_set_icon_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_icon_gicon "void gtk_drag_source_set_icon_gicon(GtkWidget* widget, GIcon* icon)"
  s7_pointer _p;
  s7_pointer widget, icon;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_gicon", 1, widget, "GtkWidget*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon_gicon", 2, icon, "GIcon*");
  gtk_drag_source_set_icon_gicon(s7_c_pointer(widget), s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_set_icon_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_set_icon_gicon "void gtk_drag_set_icon_gicon(GdkDragContext* context, GIcon* icon, \
gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer context, icon, hot_x, hot_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_gicon", 1, context, "GdkDragContext*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_gicon", 2, icon, "GIcon*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_gicon", 3, hot_x, "gint");
  hot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_set_icon_gicon", 4, hot_y, "gint");
  gtk_drag_set_icon_gicon(s7_c_pointer(context), s7_c_pointer(icon), s7_integer(hot_x), s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_active_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active_id "gboolean gtk_combo_box_set_active_id(GtkComboBox* combo_box, \
gchar* active_id)"
  s7_pointer _p;
  s7_pointer combo_box, active_id;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_id", 1, combo_box, "GtkComboBox*");
  active_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(active_id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_id", 2, active_id, "gchar*");
  return(s7_make_boolean(sc, gtk_combo_box_set_active_id(s7_c_pointer(combo_box), (const gchar*)s7_string(active_id))));
}

static s7_pointer lg_gtk_tree_view_column_get_x_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_x_offset "gint gtk_tree_view_column_get_x_offset(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_x_offset", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_x_offset(s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_overlay_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_new "GtkWidget* gtk_overlay_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_overlay_new()));
}

static s7_pointer lg_gtk_overlay_add_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_add_overlay "void gtk_overlay_add_overlay(GtkOverlay* overlay, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer overlay, widget;
  _p = args;
  overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(overlay, GtkOverlay__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_add_overlay", 1, overlay, "GtkOverlay*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_add_overlay", 2, widget, "GtkWidget*");
  gtk_overlay_add_overlay(s7_c_pointer(overlay), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_minimum_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_minimum_increment "gdouble gtk_adjustment_get_minimum_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_minimum_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_minimum_increment(s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_grid_insert_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_row "void gtk_grid_insert_row(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_row", 1, grid, "GtkGrid*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_row", 2, position, "gint");
  gtk_grid_insert_row(s7_c_pointer(grid), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_insert_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_column "void gtk_grid_insert_column(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_column", 1, grid, "GtkGrid*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_column", 2, position, "gint");
  gtk_grid_insert_column(s7_c_pointer(grid), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_insert_next_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_next_to "void gtk_grid_insert_next_to(GtkGrid* grid, GtkWidget* sibling, \
GtkPositionType side)"
  s7_pointer _p;
  s7_pointer grid, sibling, side;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 1, grid, "GtkGrid*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 2, sibling, "GtkWidget*");
  side = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(side)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 3, side, "GtkPositionType");
  gtk_grid_insert_next_to(s7_c_pointer(grid), s7_c_pointer(sibling), s7_integer(side));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_assign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_assign "void gtk_text_iter_assign(GtkTextIter* iter, GtkTextIter* other)"
  s7_pointer _p;
  s7_pointer iter, other;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_assign", 1, iter, "GtkTextIter*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_assign", 2, other, "GtkTextIter*");
  gtk_text_iter_assign(s7_c_pointer(iter), s7_c_pointer(other));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_has_visible_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_visible_focus "gboolean gtk_widget_has_visible_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_visible_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_visible_focus(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_set_focus_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_focus_visible "void gtk_window_set_focus_visible(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_visible", 1, window, "GtkWindow*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_visible", 2, setting, "gboolean");
  gtk_window_set_focus_visible(s7_c_pointer(window), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_focus_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_focus_visible "gboolean gtk_window_get_focus_visible(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_focus_visible", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_focus_visible(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_font_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_dialog_new "GtkWidget* gtk_font_chooser_dialog_new(gchar* title, GtkWindow* window)"
  s7_pointer _p;
  s7_pointer title, window;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_dialog_new", 1, title, "gchar*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_dialog_new", 2, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_font_chooser_dialog_new((const gchar*)s7_string(title), s7_c_pointer(window))));
}

static s7_pointer lg_gdk_event_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_button "gboolean gdk_event_get_button(GdkEvent* event, guint* button)"
  s7_pointer _p;
  s7_pointer event, button;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_button", 1, event, "GdkEvent*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_button", 2, button, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_button(s7_c_pointer(event), s7_c_pointer(button))));
}

static s7_pointer lg_gdk_event_get_click_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_click_count "gboolean gdk_event_get_click_count(GdkEvent* event, guint* click_count)"
  s7_pointer _p;
  s7_pointer event, click_count;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_click_count", 1, event, "GdkEvent*");
  click_count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(click_count, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_click_count", 2, click_count, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_click_count(s7_c_pointer(event), s7_c_pointer(click_count))));
}

static s7_pointer lg_gdk_event_get_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_keyval "gboolean gdk_event_get_keyval(GdkEvent* event, guint* keyval)"
  s7_pointer _p;
  s7_pointer event, keyval;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keyval", 1, event, "GdkEvent*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keyval, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keyval", 2, keyval, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_keyval(s7_c_pointer(event), s7_c_pointer(keyval))));
}

static s7_pointer lg_gdk_event_get_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_keycode "gboolean gdk_event_get_keycode(GdkEvent* event, guint16* keycode)"
  s7_pointer _p;
  s7_pointer event, keycode;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keycode", 1, event, "GdkEvent*");
  keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keycode, guint16__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keycode", 2, keycode, "guint16*");
  return(s7_make_boolean(sc, gdk_event_get_keycode(s7_c_pointer(event), s7_c_pointer(keycode))));
}

static s7_pointer lg_gdk_event_get_scroll_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_scroll_direction "gboolean gdk_event_get_scroll_direction(GdkEvent* event, \
GdkScrollDirection* [direction])"
  s7_pointer _p;
  s7_pointer event;
  GdkScrollDirection ref_direction;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_scroll_direction", 1, event, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_event_get_scroll_direction(s7_c_pointer(event), &ref_direction));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_direction)));
   }
}

static s7_pointer lg_gtk_grid_get_child_at(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_child_at "GtkWidget* gtk_grid_get_child_at(GtkGrid* grid, gint left, gint top)"
  s7_pointer _p;
  s7_pointer grid, left, top;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 1, grid, "GtkGrid*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 2, left, "gint");
  top = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 3, top, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_grid_get_child_at(s7_c_pointer(grid), s7_integer(left), s7_integer(top))));
}

static s7_pointer lg_gtk_font_chooser_get_font_family(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_family "PangoFontFamily* gtk_font_chooser_get_font_family(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_family", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_type_with_c_pointer(sc, PangoFontFamily__sym, gtk_font_chooser_get_font_family(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_face "PangoFontFace* gtk_font_chooser_get_font_face(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_face", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_type_with_c_pointer(sc, PangoFontFace__sym, gtk_font_chooser_get_font_face(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_size "gint gtk_font_chooser_get_font_size(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_size", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_integer(sc, gtk_font_chooser_get_font_size(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_desc(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_desc "PangoFontDescription* gtk_font_chooser_get_font_desc(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_desc", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_type_with_c_pointer(sc, PangoFontDescription__sym, gtk_font_chooser_get_font_desc(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_font_desc(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font_desc "void gtk_font_chooser_set_font_desc(GtkFontChooser* fontchooser, \
PangoFontDescription* font_desc)"
  s7_pointer _p;
  s7_pointer fontchooser, font_desc;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_desc", 1, fontchooser, "GtkFontChooser*");
  font_desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_desc", 2, font_desc, "PangoFontDescription*");
  gtk_font_chooser_set_font_desc(s7_c_pointer(fontchooser), s7_c_pointer(font_desc));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font "gchar* gtk_font_chooser_get_font(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_string(sc, gtk_font_chooser_get_font(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font "void gtk_font_chooser_set_font(GtkFontChooser* fontchooser, gchar* fontname)"
  s7_pointer _p;
  s7_pointer fontchooser, fontname;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font", 1, fontchooser, "GtkFontChooser*");
  fontname = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(fontname)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font", 2, fontname, "gchar*");
  gtk_font_chooser_set_font(s7_c_pointer(fontchooser), (const gchar*)s7_string(fontname));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_preview_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_preview_text "gchar* gtk_font_chooser_get_preview_text(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_preview_text", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_string(sc, gtk_font_chooser_get_preview_text(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_preview_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_preview_text "void gtk_font_chooser_set_preview_text(GtkFontChooser* fontchooser, \
gchar* text)"
  s7_pointer _p;
  s7_pointer fontchooser, text;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_preview_text", 1, fontchooser, "GtkFontChooser*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_preview_text", 2, text, "gchar*");
  gtk_font_chooser_set_preview_text(s7_c_pointer(fontchooser), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_show_preview_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_show_preview_entry "gboolean gtk_font_chooser_get_show_preview_entry(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_show_preview_entry", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_boolean(sc, gtk_font_chooser_get_show_preview_entry(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_show_preview_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_show_preview_entry "void gtk_font_chooser_set_show_preview_entry(GtkFontChooser* fontchooser, \
gboolean show_preview_entry)"
  s7_pointer _p;
  s7_pointer fontchooser, show_preview_entry;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_show_preview_entry", 1, fontchooser, "GtkFontChooser*");
  show_preview_entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_preview_entry)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_show_preview_entry", 2, show_preview_entry, "gboolean");
  gtk_font_chooser_set_show_preview_entry(s7_c_pointer(fontchooser), lg_boolean(show_preview_entry));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_widget_new "GtkWidget* gtk_font_chooser_widget_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_font_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_gdk_keymap_get_modifier_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_modifier_mask "GdkModifierType gdk_keymap_get_modifier_mask(GdkKeymap* keymap, \
GdkModifierIntent intent)"
  s7_pointer _p;
  s7_pointer keymap, intent;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_modifier_mask", 1, keymap, "GdkKeymap*");
  intent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(intent)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_modifier_mask", 2, intent, "GdkModifierIntent");
  return(s7_make_integer(sc, gdk_keymap_get_modifier_mask(s7_c_pointer(keymap), s7_integer(intent))));
}

static s7_pointer lg_gdk_window_begin_resize_drag_for_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_begin_resize_drag_for_device "void gdk_window_begin_resize_drag_for_device(GdkWindow* window, \
GdkWindowEdge edge, GdkDevice* device, gint button, gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, edge, device, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 1, window, "GdkWindow*");
  edge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(edge)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 2, edge, "GdkWindowEdge");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 3, device, "GdkDevice*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 4, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 5, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 6, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_window_begin_resize_drag_for_device", 7, timestamp, "guint32");
  gdk_window_begin_resize_drag_for_device(s7_c_pointer(window), s7_integer(edge), s7_c_pointer(device), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_window_begin_move_drag_for_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_begin_move_drag_for_device "void gdk_window_begin_move_drag_for_device(GdkWindow* window, \
GdkDevice* device, gint button, gint root_x, gint root_y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, device, button, root_x, root_y, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 2, device, "GdkDevice*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 3, button, "gint");
  root_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_x)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 4, root_x, "gint");
  root_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(root_y)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 5, root_y, "gint");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_window_begin_move_drag_for_device", 6, timestamp, "guint32");
  gdk_window_begin_move_drag_for_device(s7_c_pointer(window), s7_c_pointer(device), s7_integer(button), s7_integer(root_x), s7_integer(root_y), s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_parse_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_parse_with_keycode "void gtk_accelerator_parse_with_keycode(gchar* accelerator, \
guint* accelerator_key, guint** accelerator_codes, GdkModifierType* accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator, accelerator_key, accelerator_codes, accelerator_mods;
  _p = args;
  accelerator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 1, accelerator, "gchar*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_key, guint__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 2, accelerator_key, "guint*");
  accelerator_codes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_codes, guint___sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 3, accelerator_codes, "guint**");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_mods, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 4, accelerator_mods, "GdkModifierType*");
  gtk_accelerator_parse_with_keycode((const gchar*)s7_string(accelerator), s7_c_pointer(accelerator_key), s7_c_pointer(accelerator_codes), s7_c_pointer(accelerator_mods));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_name_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_name_with_keycode "gchar* gtk_accelerator_name_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer display, accelerator_key, keycode, accelerator_mods;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 1, display, "GdkDisplay*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 2, accelerator_key, "guint");
  keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keycode)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 3, keycode, "guint");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 4, accelerator_mods, "GdkModifierType");
  return(s7_make_string(sc, gtk_accelerator_name_with_keycode(s7_c_pointer(display), s7_integer(accelerator_key), s7_integer(keycode), s7_integer(accelerator_mods))));
}

static s7_pointer lg_gtk_accelerator_get_label_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_get_label_with_keycode "gchar* gtk_accelerator_get_label_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer display, accelerator_key, keycode, accelerator_mods;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 1, display, "GdkDisplay*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 2, accelerator_key, "guint");
  keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keycode)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 3, keycode, "guint");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 4, accelerator_mods, "GdkModifierType");
  return(s7_make_string(sc, gtk_accelerator_get_label_with_keycode(s7_c_pointer(display), s7_integer(accelerator_key), s7_integer(keycode), s7_integer(accelerator_mods))));
}

static s7_pointer lg_gtk_application_get_app_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_app_menu "GMenuModel* gtk_application_get_app_menu(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_app_menu", 1, application, "GtkApplication*");
  return(s7_make_type_with_c_pointer(sc, GMenuModel__sym, gtk_application_get_app_menu(s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_set_app_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_set_app_menu "void gtk_application_set_app_menu(GtkApplication* application, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer application, model;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_app_menu", 1, application, "GtkApplication*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_app_menu", 2, model, "GMenuModel*");
  gtk_application_set_app_menu(s7_c_pointer(application), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_application_get_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_menubar "GMenuModel* gtk_application_get_menubar(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_menubar", 1, application, "GtkApplication*");
  return(s7_make_type_with_c_pointer(sc, GMenuModel__sym, gtk_application_get_menubar(s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_set_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_set_menubar "void gtk_application_set_menubar(GtkApplication* application, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer application, model;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_menubar", 1, application, "GtkApplication*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_menubar", 2, model, "GMenuModel*");
  gtk_application_set_menubar(s7_c_pointer(application), s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_compute_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_compute_prefix "gchar* gtk_entry_completion_compute_prefix(GtkEntryCompletion* completion, \
char* key)"
  s7_pointer _p;
  s7_pointer completion, key;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_compute_prefix", 1, completion, "GtkEntryCompletion*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_compute_prefix", 2, key, "char*");
  return(s7_make_string(sc, gtk_entry_completion_compute_prefix(s7_c_pointer(completion), (const char*)(char*)s7_string(key))));
}

static s7_pointer lg_gtk_scale_set_has_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_has_origin "void gtk_scale_set_has_origin(GtkScale* scale, gboolean has_origin)"
  s7_pointer _p;
  s7_pointer scale, has_origin;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_has_origin", 1, scale, "GtkScale*");
  has_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_origin)) s7_wrong_type_arg_error(sc, "gtk_scale_set_has_origin", 2, has_origin, "gboolean");
  gtk_scale_set_has_origin(s7_c_pointer(scale), lg_boolean(has_origin));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_has_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_has_origin "gboolean gtk_scale_get_has_origin(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_has_origin", 1, scale, "GtkScale*");
  return(s7_make_boolean(sc, gtk_scale_get_has_origin(s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_application_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_new "GtkWidget* gtk_application_window_new(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_new", 1, application, "GtkApplication*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_application_window_new(s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_window_set_show_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_set_show_menubar "void gtk_application_window_set_show_menubar(GtkApplicationWindow* window, \
gboolean show_menubar)"
  s7_pointer _p;
  s7_pointer window, show_menubar;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_show_menubar", 1, window, "GtkApplicationWindow*");
  show_menubar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_menubar)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_show_menubar", 2, show_menubar, "gboolean");
  gtk_application_window_set_show_menubar(s7_c_pointer(window), lg_boolean(show_menubar));
  return(lg_false);
}

static s7_pointer lg_gtk_application_window_get_show_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_get_show_menubar "gboolean gtk_application_window_get_show_menubar(GtkApplicationWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_get_show_menubar", 1, window, "GtkApplicationWindow*");
  return(s7_make_boolean(sc, gtk_application_window_get_show_menubar(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_image_new_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_resource "GtkWidget* gtk_image_new_from_resource(gchar* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_resource", 1, resource_path, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new_from_resource((const gchar*)s7_string(resource_path))));
}

static s7_pointer lg_gtk_image_set_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_resource "void gtk_image_set_from_resource(GtkImage* image, gchar* resource_path)"
  s7_pointer _p;
  s7_pointer image, resource_path;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_resource", 1, image, "GtkImage*");
  resource_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_resource", 2, resource_path, "gchar*");
  gtk_image_set_from_resource(s7_c_pointer(image), (const gchar*)s7_string(resource_path));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_attached_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_attached_to "void gtk_window_set_attached_to(GtkWindow* window, GtkWidget* attach_widget)"
  s7_pointer _p;
  s7_pointer window, attach_widget;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_attached_to", 1, window, "GtkWindow*");
  attach_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attach_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_attached_to", 2, attach_widget, "GtkWidget*");
  gtk_window_set_attached_to(s7_c_pointer(window), s7_c_pointer(attach_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_attached_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_attached_to "GtkWidget* gtk_window_get_attached_to(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_attached_to", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_get_attached_to(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_about_dialog_add_credit_section(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_add_credit_section "void gtk_about_dialog_add_credit_section(GtkAboutDialog* about, \
gchar* section_name, gchar** people)"
  s7_pointer _p;
  s7_pointer about, section_name, people;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 1, about, "GtkAboutDialog*");
  section_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(section_name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 2, section_name, "gchar*");
  people = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(people, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 3, people, "gchar**");
  gtk_about_dialog_add_credit_section(s7_c_pointer(about), (const gchar*)s7_string(section_name), (const gchar**)s7_c_pointer(people));
  return(lg_false);
}

static s7_pointer lg_gdk_keymap_get_modifier_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_modifier_state "guint gdk_keymap_get_modifier_state(GdkKeymap* keymap)"
  s7_pointer keymap;
  keymap = s7_car(args);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_modifier_state", 1, keymap, "GdkKeymap*");
  return(s7_make_integer(sc, gdk_keymap_get_modifier_state(s7_c_pointer(keymap))));
}

static s7_pointer lg_gtk_hsv_to_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_hsv_to_rgb "void gtk_hsv_to_rgb(gdouble h, gdouble s, gdouble v, gdouble* [r], gdouble* [g], \
gdouble* [b])"
  s7_pointer _p;
  s7_pointer h, s, v;
  gdouble ref_r;
  gdouble ref_g;
  gdouble ref_b;
  _p = args;
  h = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(h)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 1, h, "gdouble");
  s = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(s)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 2, s, "gdouble");
  v = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(v)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 3, v, "gdouble");
  gtk_hsv_to_rgb(s7_real(h), s7_real(s), s7_real(v), &ref_r, &ref_g, &ref_b);
    return(s7_list(sc, 3, s7_make_real(sc, ref_r), s7_make_real(sc, ref_g), s7_make_real(sc, ref_b)));
}

static s7_pointer lg_gtk_rgb_to_hsv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_rgb_to_hsv "void gtk_rgb_to_hsv(gdouble r, gdouble g, gdouble b, gdouble* [h], gdouble* [s], \
gdouble* [v])"
  s7_pointer _p;
  s7_pointer r, g, b;
  gdouble ref_h;
  gdouble ref_s;
  gdouble ref_v;
  _p = args;
  r = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(r)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 1, r, "gdouble");
  g = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(g)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 2, g, "gdouble");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(b)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 3, b, "gdouble");
  gtk_rgb_to_hsv(s7_real(r), s7_real(g), s7_real(b), &ref_h, &ref_s, &ref_v);
    return(s7_list(sc, 3, s7_make_real(sc, ref_h), s7_make_real(sc, ref_s), s7_make_real(sc, ref_v)));
}

static s7_pointer lg_gtk_color_chooser_get_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_get_rgba "void gtk_color_chooser_get_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer chooser, color;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_rgba", 1, chooser, "GtkColorChooser*");
  color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_rgba", 2, color, "GdkRGBA*");
  gtk_color_chooser_get_rgba(s7_c_pointer(chooser), s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_set_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_set_rgba "void gtk_color_chooser_set_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer chooser, color;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_rgba", 1, chooser, "GtkColorChooser*");
  color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_rgba", 2, color, "GdkRGBA*");
  gtk_color_chooser_set_rgba(s7_c_pointer(chooser), s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_get_use_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_get_use_alpha "gboolean gtk_color_chooser_get_use_alpha(GtkColorChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_use_alpha", 1, chooser, "GtkColorChooser*");
  return(s7_make_boolean(sc, gtk_color_chooser_get_use_alpha(s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_color_chooser_set_use_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_set_use_alpha "void gtk_color_chooser_set_use_alpha(GtkColorChooser* chooser, \
gboolean use_alpha)"
  s7_pointer _p;
  s7_pointer chooser, use_alpha;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_use_alpha", 1, chooser, "GtkColorChooser*");
  use_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_alpha)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_use_alpha", 2, use_alpha, "gboolean");
  gtk_color_chooser_set_use_alpha(s7_c_pointer(chooser), lg_boolean(use_alpha));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_dialog_new "GtkWidget* gtk_color_chooser_dialog_new(gchar* title, GtkWindow* parent)"
  s7_pointer _p;
  s7_pointer title, parent;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_dialog_new", 1, title, "gchar*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_dialog_new", 2, parent, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_color_chooser_dialog_new((const gchar*)s7_string(title), s7_c_pointer(parent))));
}

static s7_pointer lg_gtk_color_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_widget_new "GtkWidget* gtk_color_chooser_widget_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_color_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_gdk_event_get_scroll_deltas(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_scroll_deltas "gboolean gdk_event_get_scroll_deltas(GdkEvent* event, gdouble* [delta_x], \
gdouble* [delta_y])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_delta_x;
  gdouble ref_delta_y;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_scroll_deltas", 1, event, "GdkEvent*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_event_get_scroll_deltas(s7_c_pointer(event), &ref_delta_x, &ref_delta_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_delta_x), s7_make_real(sc, ref_delta_y)));
   }
}

static s7_pointer lg_gtk_color_chooser_add_palette(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_add_palette "void gtk_color_chooser_add_palette(GtkColorChooser* chooser, \
GtkOrientation horizontal, gint colors_per_line, gint n_colors, GdkRGBA* colors)"
  s7_pointer _p;
  s7_pointer chooser, horizontal, colors_per_line, n_colors, colors;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 1, chooser, "GtkColorChooser*");
  horizontal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(horizontal)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 2, horizontal, "GtkOrientation");
  colors_per_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colors_per_line)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 3, colors_per_line, "gint");
  n_colors = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_colors)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 4, n_colors, "gint");
  colors = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(colors, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 5, colors, "GdkRGBA*");
  gtk_color_chooser_add_palette(s7_c_pointer(chooser), s7_integer(horizontal), s7_integer(colors_per_line), s7_integer(n_colors), s7_c_pointer(colors));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_n_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_n_columns "guint gtk_tree_view_get_n_columns(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_n_columns", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_n_columns(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_menu_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_new "GtkWidget* gtk_menu_button_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_button_new()));
}

static s7_pointer lg_gtk_menu_button_set_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_menu_model "void gtk_menu_button_set_menu_model(GtkMenuButton* menu_button, \
GMenuModel* menu_model)"
  s7_pointer _p;
  s7_pointer menu_button, menu_model;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_menu_model", 1, menu_button, "GtkMenuButton*");
  menu_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_menu_model", 2, menu_model, "GMenuModel*");
  gtk_menu_button_set_menu_model(s7_c_pointer(menu_button), s7_c_pointer(menu_model));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_menu_model "GMenuModel* gtk_menu_button_get_menu_model(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_menu_model", 1, menu_button, "GtkMenuButton*");
  return(s7_make_type_with_c_pointer(sc, GMenuModel__sym, gtk_menu_button_get_menu_model(s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_menu_button_set_align_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_align_widget "void gtk_menu_button_set_align_widget(GtkMenuButton* menu_button, \
GtkWidget* align_widget)"
  s7_pointer _p;
  s7_pointer menu_button, align_widget;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_align_widget", 1, menu_button, "GtkMenuButton*");
  align_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(align_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_align_widget", 2, align_widget, "GtkWidget*");
  gtk_menu_button_set_align_widget(s7_c_pointer(menu_button), s7_c_pointer(align_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_align_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_align_widget "GtkWidget* gtk_menu_button_get_align_widget(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_align_widget", 1, menu_button, "GtkMenuButton*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_menu_button_get_align_widget(s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_search_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_entry_new "GtkWidget* gtk_search_entry_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_search_entry_new()));
}

static s7_pointer lg_gtk_level_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_new "GtkWidget* gtk_level_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_level_bar_new()));
}

static s7_pointer lg_gtk_level_bar_new_for_interval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_new_for_interval "GtkWidget* gtk_level_bar_new_for_interval(gdouble min_value, \
gdouble max_value)"
  s7_pointer _p;
  s7_pointer min_value, max_value;
  _p = args;
  min_value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min_value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_new_for_interval", 1, min_value, "gdouble");
  max_value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max_value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_new_for_interval", 2, max_value, "gdouble");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_level_bar_new_for_interval(s7_real(min_value), s7_real(max_value))));
}

static s7_pointer lg_gtk_level_bar_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_mode "void gtk_level_bar_set_mode(GtkLevelBar* self, GtkLevelBarMode mode)"
  s7_pointer _p;
  s7_pointer self, mode;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_mode", 1, self, "GtkLevelBar*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_mode", 2, mode, "GtkLevelBarMode");
  gtk_level_bar_set_mode(s7_c_pointer(self), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_mode "GtkLevelBarMode gtk_level_bar_get_mode(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_mode", 1, self, "GtkLevelBar*");
  return(s7_make_integer(sc, gtk_level_bar_get_mode(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_value "void gtk_level_bar_set_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_value", 2, value, "gdouble");
  gtk_level_bar_set_value(s7_c_pointer(self), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_value "gdouble gtk_level_bar_get_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_value(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_min_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_min_value "void gtk_level_bar_set_min_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_min_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_min_value", 2, value, "gdouble");
  gtk_level_bar_set_min_value(s7_c_pointer(self), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_min_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_min_value "gdouble gtk_level_bar_get_min_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_min_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_min_value(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_max_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_max_value "void gtk_level_bar_set_max_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_max_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_max_value", 2, value, "gdouble");
  gtk_level_bar_set_max_value(s7_c_pointer(self), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_max_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_max_value "gdouble gtk_level_bar_get_max_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_max_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_max_value(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_add_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_add_offset_value "void gtk_level_bar_add_offset_value(GtkLevelBar* self, gchar* name, \
gdouble value)"
  s7_pointer _p;
  s7_pointer self, name, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 2, name, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 3, value, "gdouble");
  gtk_level_bar_add_offset_value(s7_c_pointer(self), (const gchar*)s7_string(name), s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_remove_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_remove_offset_value "void gtk_level_bar_remove_offset_value(GtkLevelBar* self, \
gchar* name)"
  s7_pointer _p;
  s7_pointer self, name;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_remove_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_remove_offset_value", 2, name, "gchar*");
  gtk_level_bar_remove_offset_value(s7_c_pointer(self), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_offset_value "gboolean gtk_level_bar_get_offset_value(GtkLevelBar* self, \
gchar* name, gdouble* [value])"
  s7_pointer _p;
  s7_pointer self, name;
  gdouble ref_value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_offset_value", 2, name, "gchar*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_level_bar_get_offset_value(s7_c_pointer(self), (const gchar*)s7_string(name), &ref_value));
      return(s7_list(sc, 2, result, s7_make_real(sc, ref_value)));
   }
}

static s7_pointer lg_gtk_application_get_active_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_active_window "GtkWindow* gtk_application_get_active_window(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_active_window", 1, application, "GtkApplication*");
  return(s7_make_type_with_c_pointer(sc, GtkWindow__sym, gtk_application_get_active_window(s7_c_pointer(application))));
}

static s7_pointer lg_gtk_entry_set_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_input_purpose "void gtk_entry_set_input_purpose(GtkEntry* entry, GtkInputPurpose purpose)"
  s7_pointer _p;
  s7_pointer entry, purpose;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_purpose", 1, entry, "GtkEntry*");
  purpose = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(purpose)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_purpose", 2, purpose, "GtkInputPurpose");
  gtk_entry_set_input_purpose(s7_c_pointer(entry), s7_integer(purpose));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_input_purpose "GtkInputPurpose gtk_entry_get_input_purpose(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_input_purpose", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_input_purpose(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_input_hints "void gtk_entry_set_input_hints(GtkEntry* entry, GtkInputHints hints)"
  s7_pointer _p;
  s7_pointer entry, hints;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_hints", 1, entry, "GtkEntry*");
  hints = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hints)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_hints", 2, hints, "GtkInputHints");
  gtk_entry_set_input_hints(s7_c_pointer(entry), s7_integer(hints));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_input_hints "GtkInputHints gtk_entry_get_input_hints(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_input_hints", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_input_hints(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_menu_button_get_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_popup "GtkMenu* gtk_menu_button_get_popup(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_popup", 1, menu_button, "GtkMenuButton*");
  return(s7_make_type_with_c_pointer(sc, GtkMenu__sym, gtk_menu_button_get_popup(s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_text_view_set_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_input_purpose "void gtk_text_view_set_input_purpose(GtkTextView* text_view, \
GtkInputPurpose purpose)"
  s7_pointer _p;
  s7_pointer text_view, purpose;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_purpose", 1, text_view, "GtkTextView*");
  purpose = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(purpose)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_purpose", 2, purpose, "GtkInputPurpose");
  gtk_text_view_set_input_purpose(s7_c_pointer(text_view), s7_integer(purpose));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_input_purpose "GtkInputPurpose gtk_text_view_get_input_purpose(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_input_purpose", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_input_purpose(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_input_hints "void gtk_text_view_set_input_hints(GtkTextView* text_view, \
GtkInputHints hints)"
  s7_pointer _p;
  s7_pointer text_view, hints;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_hints", 1, text_view, "GtkTextView*");
  hints = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hints)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_hints", 2, hints, "GtkInputHints");
  gtk_text_view_set_input_hints(s7_c_pointer(text_view), s7_integer(hints));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_input_hints "GtkInputHints gtk_text_view_get_input_hints(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_input_hints", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_input_hints(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_entry_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_attributes "void gtk_entry_set_attributes(GtkEntry* entry, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer entry, attrs;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_attributes", 1, entry, "GtkEntry*");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_attributes", 2, attrs, "PangoAttrList*");
  gtk_entry_set_attributes(s7_c_pointer(entry), s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_attributes "PangoAttrList* gtk_entry_get_attributes(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_attributes", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, PangoAttrList__sym, gtk_entry_get_attributes(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_accel_label_set_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_accel "void gtk_accel_label_set_accel(GtkAccelLabel* accel_label, guint accelerator_key, \
GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer accel_label, accelerator_key, accelerator_mods;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 1, accel_label, "GtkAccelLabel*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 2, accelerator_key, "guint");
  accelerator_mods = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 3, accelerator_mods, "GdkModifierType");
  gtk_accel_label_set_accel(s7_c_pointer(accel_label), s7_integer(accelerator_key), s7_integer(accelerator_mods));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_shell_bind_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_shell_bind_model "void gtk_menu_shell_bind_model(GtkMenuShell* menu_shell, GMenuModel* model, \
gchar* action_namespace, gboolean with_separators)"
  s7_pointer _p;
  s7_pointer menu_shell, model, action_namespace, with_separators;
  _p = args;
  menu_shell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_shell, GtkMenuShell__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_bind_model", 1, menu_shell, "GtkMenuShell*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_bind_model", 2, model, "GMenuModel*");
  action_namespace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action_namespace)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_bind_model", 3, action_namespace, "gchar*");
  with_separators = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(with_separators)) s7_wrong_type_arg_error(sc, "gtk_menu_shell_bind_model", 4, with_separators, "gboolean");
  gtk_menu_shell_bind_model(s7_c_pointer(menu_shell), s7_c_pointer(model), (const gchar*)s7_string(action_namespace), lg_boolean(with_separators));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 8, 0)
static s7_pointer lg_gtk_level_bar_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_inverted "void gtk_level_bar_set_inverted(GtkLevelBar* self, gboolean inverted)"
  s7_pointer _p;
  s7_pointer self, inverted;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_inverted", 1, self, "GtkLevelBar*");
  inverted = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(inverted)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_inverted", 2, inverted, "gboolean");
  gtk_level_bar_set_inverted(s7_c_pointer(self), lg_boolean(inverted));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_inverted "gboolean gtk_level_bar_get_inverted(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_inverted", 1, self, "GtkLevelBar*");
  return(s7_make_boolean(sc, gtk_level_bar_get_inverted(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_widget_is_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_visible "gboolean gtk_widget_is_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_visible(s7_c_pointer(widget))));
}

static s7_pointer lg_gdk_window_set_fullscreen_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_fullscreen_mode "void gdk_window_set_fullscreen_mode(GdkWindow* window, GdkFullscreenMode mode)"
  s7_pointer _p;
  s7_pointer window, mode;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_fullscreen_mode", 1, window, "GdkWindow*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gdk_window_set_fullscreen_mode", 2, mode, "GdkFullscreenMode");
  gdk_window_set_fullscreen_mode(s7_c_pointer(window), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_fullscreen_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_fullscreen_mode "GdkFullscreenMode gdk_window_get_fullscreen_mode(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_fullscreen_mode", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_fullscreen_mode(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_icon_view_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_activate_on_single_click "void gtk_icon_view_set_activate_on_single_click(GtkIconView* icon_view, \
gboolean single)"
  s7_pointer _p;
  s7_pointer icon_view, single;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_activate_on_single_click", 1, icon_view, "GtkIconView*");
  single = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_activate_on_single_click", 2, single, "gboolean");
  gtk_icon_view_set_activate_on_single_click(s7_c_pointer(icon_view), lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_activate_on_single_click "gboolean gtk_icon_view_get_activate_on_single_click(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_activate_on_single_click", 1, icon_view, "GtkIconView*");
  return(s7_make_boolean(sc, gtk_icon_view_get_activate_on_single_click(s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_tree_view_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_activate_on_single_click "gboolean gtk_tree_view_get_activate_on_single_click(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_activate_on_single_click", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_activate_on_single_click(s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_activate_on_single_click "void gtk_tree_view_set_activate_on_single_click(GtkTreeView* tree_view, \
gboolean single)"
  s7_pointer _p;
  s7_pointer tree_view, single;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_activate_on_single_click", 1, tree_view, "GtkTreeView*");
  single = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_activate_on_single_click", 2, single, "gboolean");
  gtk_tree_view_set_activate_on_single_click(s7_c_pointer(tree_view), lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_register_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_register_window "void gtk_widget_register_window(GtkWidget* widget, GdkWindow* window)"
  s7_pointer _p;
  s7_pointer widget, window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_register_window", 1, widget, "GtkWidget*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_register_window", 2, window, "GdkWindow*");
  gtk_widget_register_window(s7_c_pointer(widget), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unregister_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unregister_window "void gtk_widget_unregister_window(GtkWidget* widget, GdkWindow* window)"
  s7_pointer _p;
  s7_pointer widget, window;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unregister_window", 1, widget, "GtkWidget*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unregister_window", 2, window, "GdkWindow*");
  gtk_widget_unregister_window(s7_c_pointer(widget), s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_opacity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_opacity "void gtk_widget_set_opacity(GtkWidget* widget, double opacity)"
  s7_pointer _p;
  s7_pointer widget, opacity;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_opacity", 1, widget, "GtkWidget*");
  opacity = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(opacity)) s7_wrong_type_arg_error(sc, "gtk_widget_set_opacity", 2, opacity, "double");
  gtk_widget_set_opacity(s7_c_pointer(widget), s7_real(opacity));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_opacity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_opacity "double gtk_widget_get_opacity(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_opacity", 1, widget, "GtkWidget*");
  return(s7_make_real(sc, gtk_widget_get_opacity(s7_c_pointer(widget))));
}

static s7_pointer lg_pango_font_map_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_changed "void pango_font_map_changed(PangoFontMap* fontmap)"
  s7_pointer fontmap;
  fontmap = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_changed", 1, fontmap, "PangoFontMap*");
  pango_font_map_changed(s7_c_pointer(fontmap));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_gdk_set_allowed_backends(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_set_allowed_backends "void gdk_set_allowed_backends(gchar* backends)"
  s7_pointer backends;
  backends = s7_car(args);
  if (!s7_is_string(backends)) s7_wrong_type_arg_error(sc, "gdk_set_allowed_backends", 1, backends, "gchar*");
  gdk_set_allowed_backends((const gchar*)s7_string(backends));
  return(lg_false);
}

static s7_pointer lg_gtk_box_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_baseline_position "void gtk_box_set_baseline_position(GtkBox* box, GtkBaselinePosition position)"
  s7_pointer _p;
  s7_pointer box, position;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_baseline_position", 1, box, "GtkBox*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_box_set_baseline_position", 2, position, "GtkBaselinePosition");
  gtk_box_set_baseline_position(s7_c_pointer(box), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_baseline_position "GtkBaselinePosition gtk_box_get_baseline_position(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_baseline_position", 1, box, "GtkBox*");
  return(s7_make_integer(sc, gtk_box_get_baseline_position(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_grid_remove_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_remove_row "void gtk_grid_remove_row(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_row", 1, grid, "GtkGrid*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_row", 2, position, "gint");
  gtk_grid_remove_row(s7_c_pointer(grid), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_remove_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_remove_column "void gtk_grid_remove_column(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_column", 1, grid, "GtkGrid*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_column", 2, position, "gint");
  gtk_grid_remove_column(s7_c_pointer(grid), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_set_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_baseline_position "void gtk_grid_set_row_baseline_position(GtkGrid* grid, \
gint row, GtkBaselinePosition pos)"
  s7_pointer _p;
  s7_pointer grid, row, pos;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 1, grid, "GtkGrid*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 2, row, "gint");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 3, pos, "GtkBaselinePosition");
  gtk_grid_set_row_baseline_position(s7_c_pointer(grid), s7_integer(row), s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_baseline_position "GtkBaselinePosition gtk_grid_get_row_baseline_position(GtkGrid* grid, \
gint row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_baseline_position", 1, grid, "GtkGrid*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_baseline_position", 2, row, "gint");
  return(s7_make_integer(sc, gtk_grid_get_row_baseline_position(s7_c_pointer(grid), s7_integer(row))));
}

static s7_pointer lg_gtk_grid_set_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_baseline_row "void gtk_grid_set_baseline_row(GtkGrid* grid, gint row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_baseline_row", 1, grid, "GtkGrid*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_set_baseline_row", 2, row, "gint");
  gtk_grid_set_baseline_row(s7_c_pointer(grid), s7_integer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_baseline_row "gint gtk_grid_get_baseline_row(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_baseline_row", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_baseline_row(s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_widget_get_allocated_baseline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_baseline "int gtk_widget_get_allocated_baseline(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_baseline", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_baseline(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_init_template(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_init_template "void gtk_widget_init_template(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_init_template", 1, widget, "GtkWidget*");
  gtk_widget_init_template(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_titlebar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_titlebar "void gtk_window_set_titlebar(GtkWindow* window, GtkWidget* titlebar)"
  s7_pointer _p;
  s7_pointer window, titlebar;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_titlebar", 1, window, "GtkWindow*");
  titlebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(titlebar, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_titlebar", 2, titlebar, "GtkWidget*");
  gtk_window_set_titlebar(s7_c_pointer(window), s7_c_pointer(titlebar));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_new "GtkWidget* gtk_places_sidebar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_places_sidebar_new()));
}

static s7_pointer lg_gtk_places_sidebar_get_open_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_open_flags "GtkPlacesOpenFlags gtk_places_sidebar_get_open_flags(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_open_flags", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_integer(sc, gtk_places_sidebar_get_open_flags(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_open_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_open_flags "void gtk_places_sidebar_set_open_flags(GtkPlacesSidebar* sidebar, \
GtkPlacesOpenFlags flags)"
  s7_pointer _p;
  s7_pointer sidebar, flags;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_open_flags", 1, sidebar, "GtkPlacesSidebar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_open_flags", 2, flags, "GtkPlacesOpenFlags");
  gtk_places_sidebar_set_open_flags(s7_c_pointer(sidebar), s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_location "GFile* gtk_places_sidebar_get_location(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_location", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_type_with_c_pointer(sc, GFile__sym, gtk_places_sidebar_get_location(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_location "void gtk_places_sidebar_set_location(GtkPlacesSidebar* sidebar, \
GFile* location)"
  s7_pointer _p;
  s7_pointer sidebar, location;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_location", 1, sidebar, "GtkPlacesSidebar*");
  location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(location, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_location", 2, location, "GFile*");
  gtk_places_sidebar_set_location(s7_c_pointer(sidebar), s7_c_pointer(location));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_show_desktop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_show_desktop "gboolean gtk_places_sidebar_get_show_desktop(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_show_desktop", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_show_desktop(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_show_desktop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_show_desktop "void gtk_places_sidebar_set_show_desktop(GtkPlacesSidebar* sidebar, \
gboolean show_desktop)"
  s7_pointer _p;
  s7_pointer sidebar, show_desktop;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_desktop", 1, sidebar, "GtkPlacesSidebar*");
  show_desktop = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_desktop)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_desktop", 2, show_desktop, "gboolean");
  gtk_places_sidebar_set_show_desktop(s7_c_pointer(sidebar), lg_boolean(show_desktop));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_add_shortcut(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_add_shortcut "void gtk_places_sidebar_add_shortcut(GtkPlacesSidebar* sidebar, \
GFile* location)"
  s7_pointer _p;
  s7_pointer sidebar, location;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_add_shortcut", 1, sidebar, "GtkPlacesSidebar*");
  location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(location, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_add_shortcut", 2, location, "GFile*");
  gtk_places_sidebar_add_shortcut(s7_c_pointer(sidebar), s7_c_pointer(location));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_remove_shortcut(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_remove_shortcut "void gtk_places_sidebar_remove_shortcut(GtkPlacesSidebar* sidebar, \
GFile* location)"
  s7_pointer _p;
  s7_pointer sidebar, location;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_remove_shortcut", 1, sidebar, "GtkPlacesSidebar*");
  location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(location, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_remove_shortcut", 2, location, "GFile*");
  gtk_places_sidebar_remove_shortcut(s7_c_pointer(sidebar), s7_c_pointer(location));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_list_shortcuts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_list_shortcuts "GSList* gtk_places_sidebar_list_shortcuts(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_list_shortcuts", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_type_with_c_pointer(sc, GSList__sym, gtk_places_sidebar_list_shortcuts(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_get_nth_bookmark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_nth_bookmark "GFile* gtk_places_sidebar_get_nth_bookmark(GtkPlacesSidebar* sidebar, \
gint n)"
  s7_pointer _p;
  s7_pointer sidebar, n;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_nth_bookmark", 1, sidebar, "GtkPlacesSidebar*");
  n = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_nth_bookmark", 2, n, "gint");
  return(s7_make_type_with_c_pointer(sc, GFile__sym, gtk_places_sidebar_get_nth_bookmark(s7_c_pointer(sidebar), s7_integer(n))));
}

static s7_pointer lg_gtk_stack_switcher_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_new "GtkWidget* gtk_stack_switcher_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_stack_switcher_new()));
}

static s7_pointer lg_gtk_stack_switcher_set_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_set_stack "void gtk_stack_switcher_set_stack(GtkStackSwitcher* switcher, \
GtkStack* stack)"
  s7_pointer _p;
  s7_pointer switcher, stack;
  _p = args;
  switcher = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(switcher, GtkStackSwitcher__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_set_stack", 1, switcher, "GtkStackSwitcher*");
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_set_stack", 2, stack, "GtkStack*");
  gtk_stack_switcher_set_stack(s7_c_pointer(switcher), s7_c_pointer(stack));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_switcher_get_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_get_stack "GtkStack* gtk_stack_switcher_get_stack(GtkStackSwitcher* switcher)"
  s7_pointer switcher;
  switcher = s7_car(args);
  if (!s7_is_c_pointer_of_type(switcher, GtkStackSwitcher__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_get_stack", 1, switcher, "GtkStackSwitcher*");
  return(s7_make_type_with_c_pointer(sc, GtkStack__sym, gtk_stack_switcher_get_stack(s7_c_pointer(switcher))));
}

static s7_pointer lg_gtk_stack_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_new "GtkWidget* gtk_stack_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_stack_new()));
}

static s7_pointer lg_gtk_stack_add_named(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_add_named "void gtk_stack_add_named(GtkStack* stack, GtkWidget* child, gchar* name)"
  s7_pointer _p;
  s7_pointer stack, child, name;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 1, stack, "GtkStack*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 2, child, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 3, name, "gchar*");
  gtk_stack_add_named(s7_c_pointer(stack), s7_c_pointer(child), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_add_titled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_add_titled "void gtk_stack_add_titled(GtkStack* stack, GtkWidget* child, gchar* name, \
gchar* title)"
  s7_pointer _p;
  s7_pointer stack, child, name, title;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 1, stack, "GtkStack*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 2, child, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 3, name, "gchar*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 4, title, "gchar*");
  gtk_stack_add_titled(s7_c_pointer(stack), s7_c_pointer(child), (const gchar*)s7_string(name), (const gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_set_visible_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child "void gtk_stack_set_visible_child(GtkStack* stack, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer stack, child;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child", 1, stack, "GtkStack*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child", 2, child, "GtkWidget*");
  gtk_stack_set_visible_child(s7_c_pointer(stack), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_visible_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_visible_child "GtkWidget* gtk_stack_get_visible_child(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_visible_child", 1, stack, "GtkStack*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_stack_get_visible_child(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_visible_child_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child_name "void gtk_stack_set_visible_child_name(GtkStack* stack, \
gchar* name)"
  s7_pointer _p;
  s7_pointer stack, name;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_name", 1, stack, "GtkStack*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_name", 2, name, "gchar*");
  gtk_stack_set_visible_child_name(s7_c_pointer(stack), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_visible_child_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_visible_child_name "gchar* gtk_stack_get_visible_child_name(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_visible_child_name", 1, stack, "GtkStack*");
  return(s7_make_string(sc, gtk_stack_get_visible_child_name(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_visible_child_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child_full "void gtk_stack_set_visible_child_full(GtkStack* stack, \
gchar* name, GtkStackTransitionType transition)"
  s7_pointer _p;
  s7_pointer stack, name, transition;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 1, stack, "GtkStack*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 2, name, "gchar*");
  transition = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 3, transition, "GtkStackTransitionType");
  gtk_stack_set_visible_child_full(s7_c_pointer(stack), (const gchar*)s7_string(name), s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_homogeneous "void gtk_stack_set_homogeneous(GtkStack* stack, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer stack, homogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_homogeneous", 1, stack, "GtkStack*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_stack_set_homogeneous(s7_c_pointer(stack), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_homogeneous "gboolean gtk_stack_get_homogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_homogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_homogeneous(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_transition_duration "void gtk_stack_set_transition_duration(GtkStack* stack, \
guint duration)"
  s7_pointer _p;
  s7_pointer stack, duration;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_duration", 1, stack, "GtkStack*");
  duration = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(duration)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_duration", 2, duration, "guint");
  gtk_stack_set_transition_duration(s7_c_pointer(stack), s7_integer(duration));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_duration "guint gtk_stack_get_transition_duration(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_duration", 1, stack, "GtkStack*");
  return(s7_make_integer(sc, gtk_stack_get_transition_duration(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_transition_type "void gtk_stack_set_transition_type(GtkStack* stack, GtkStackTransitionType transition)"
  s7_pointer _p;
  s7_pointer stack, transition;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_type", 1, stack, "GtkStack*");
  transition = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_type", 2, transition, "GtkStackTransitionType");
  gtk_stack_set_transition_type(s7_c_pointer(stack), s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_type "GtkStackTransitionType gtk_stack_get_transition_type(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_type", 1, stack, "GtkStack*");
  return(s7_make_integer(sc, gtk_stack_get_transition_type(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_revealer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_new "GtkWidget* gtk_revealer_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_revealer_new()));
}

static s7_pointer lg_gtk_revealer_get_reveal_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_reveal_child "gboolean gtk_revealer_get_reveal_child(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_reveal_child", 1, revealer, "GtkRevealer*");
  return(s7_make_boolean(sc, gtk_revealer_get_reveal_child(s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_set_reveal_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_reveal_child "void gtk_revealer_set_reveal_child(GtkRevealer* revealer, \
gboolean reveal_child)"
  s7_pointer _p;
  s7_pointer revealer, reveal_child;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_reveal_child", 1, revealer, "GtkRevealer*");
  reveal_child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(reveal_child)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_reveal_child", 2, reveal_child, "gboolean");
  gtk_revealer_set_reveal_child(s7_c_pointer(revealer), lg_boolean(reveal_child));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_get_child_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_child_revealed "gboolean gtk_revealer_get_child_revealed(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_child_revealed", 1, revealer, "GtkRevealer*");
  return(s7_make_boolean(sc, gtk_revealer_get_child_revealed(s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_get_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_transition_duration "guint gtk_revealer_get_transition_duration(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_transition_duration", 1, revealer, "GtkRevealer*");
  return(s7_make_integer(sc, gtk_revealer_get_transition_duration(s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_set_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_transition_duration "void gtk_revealer_set_transition_duration(GtkRevealer* revealer, \
guint duration)"
  s7_pointer _p;
  s7_pointer revealer, duration;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_duration", 1, revealer, "GtkRevealer*");
  duration = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(duration)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_duration", 2, duration, "guint");
  gtk_revealer_set_transition_duration(s7_c_pointer(revealer), s7_integer(duration));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_set_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_transition_type "void gtk_revealer_set_transition_type(GtkRevealer* revealer, \
GtkRevealerTransitionType transition)"
  s7_pointer _p;
  s7_pointer revealer, transition;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_type", 1, revealer, "GtkRevealer*");
  transition = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_type", 2, transition, "GtkRevealerTransitionType");
  gtk_revealer_set_transition_type(s7_c_pointer(revealer), s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_get_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_transition_type "GtkRevealerTransitionType gtk_revealer_get_transition_type(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_transition_type", 1, revealer, "GtkRevealer*");
  return(s7_make_integer(sc, gtk_revealer_get_transition_type(s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_header_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_new "GtkWidget* gtk_header_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_header_bar_new()));
}

static s7_pointer lg_gtk_header_bar_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_title "void gtk_header_bar_set_title(GtkHeaderBar* bar, gchar* title)"
  s7_pointer _p;
  s7_pointer bar, title;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_title", 1, bar, "GtkHeaderBar*");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_title", 2, title, "gchar*");
  gtk_header_bar_set_title(s7_c_pointer(bar), (const gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_title "gchar* gtk_header_bar_get_title(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_title", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_title(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_subtitle "void gtk_header_bar_set_subtitle(GtkHeaderBar* bar, gchar* subtitle)"
  s7_pointer _p;
  s7_pointer bar, subtitle;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_subtitle", 1, bar, "GtkHeaderBar*");
  subtitle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(subtitle)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_subtitle", 2, subtitle, "gchar*");
  gtk_header_bar_set_subtitle(s7_c_pointer(bar), (const gchar*)s7_string(subtitle));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_subtitle "gchar* gtk_header_bar_get_subtitle(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_subtitle", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_subtitle(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_custom_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_custom_title "void gtk_header_bar_set_custom_title(GtkHeaderBar* bar, \
GtkWidget* title_widget)"
  s7_pointer _p;
  s7_pointer bar, title_widget;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_custom_title", 1, bar, "GtkHeaderBar*");
  title_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(title_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_custom_title", 2, title_widget, "GtkWidget*");
  gtk_header_bar_set_custom_title(s7_c_pointer(bar), s7_c_pointer(title_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_custom_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_custom_title "GtkWidget* gtk_header_bar_get_custom_title(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_custom_title", 1, bar, "GtkHeaderBar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_header_bar_get_custom_title(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_pack_start "void gtk_header_bar_pack_start(GtkHeaderBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_start", 1, bar, "GtkHeaderBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_start", 2, child, "GtkWidget*");
  gtk_header_bar_pack_start(s7_c_pointer(bar), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_pack_end "void gtk_header_bar_pack_end(GtkHeaderBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_end", 1, bar, "GtkHeaderBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_end", 2, child, "GtkWidget*");
  gtk_header_bar_pack_end(s7_c_pointer(bar), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_new "GtkWidget* gtk_list_box_row_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_list_box_row_new()));
}

static s7_pointer lg_gtk_list_box_row_get_header(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_header "GtkWidget* gtk_list_box_row_get_header(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_header", 1, row, "GtkListBoxRow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_list_box_row_get_header(s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_row_set_header(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_header "void gtk_list_box_row_set_header(GtkListBoxRow* row, GtkWidget* header)"
  s7_pointer _p;
  s7_pointer row, header;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_header", 1, row, "GtkListBoxRow*");
  header = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(header, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_header", 2, header, "GtkWidget*");
  gtk_list_box_row_set_header(s7_c_pointer(row), s7_c_pointer(header));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_changed "void gtk_list_box_row_changed(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_changed", 1, row, "GtkListBoxRow*");
  gtk_list_box_row_changed(s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_selected_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_selected_row "GtkListBoxRow* gtk_list_box_get_selected_row(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_selected_row", 1, list_box, "GtkListBox*");
  return(s7_make_type_with_c_pointer(sc, GtkListBoxRow__sym, gtk_list_box_get_selected_row(s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_get_row_at_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_row_at_index "GtkListBoxRow* gtk_list_box_get_row_at_index(GtkListBox* list_box, \
gint index_)"
  s7_pointer _p;
  s7_pointer list_box, index_;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_index", 1, list_box, "GtkListBox*");
  index_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index_)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_index", 2, index_, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkListBoxRow__sym, gtk_list_box_get_row_at_index(s7_c_pointer(list_box), s7_integer(index_))));
}

static s7_pointer lg_gtk_list_box_get_row_at_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_row_at_y "GtkListBoxRow* gtk_list_box_get_row_at_y(GtkListBox* list_box, \
gint y)"
  s7_pointer _p;
  s7_pointer list_box, y;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_y", 1, list_box, "GtkListBox*");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_y", 2, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkListBoxRow__sym, gtk_list_box_get_row_at_y(s7_c_pointer(list_box), s7_integer(y))));
}

static s7_pointer lg_gtk_list_box_select_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_select_row "void gtk_list_box_select_row(GtkListBox* list_box, GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer list_box, row;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_row", 1, list_box, "GtkListBox*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_select_row(s7_c_pointer(list_box), s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_placeholder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_placeholder "void gtk_list_box_set_placeholder(GtkListBox* list_box, GtkWidget* placeholder)"
  s7_pointer _p;
  s7_pointer list_box, placeholder;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_placeholder", 1, list_box, "GtkListBox*");
  placeholder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(placeholder, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_placeholder", 2, placeholder, "GtkWidget*");
  gtk_list_box_set_placeholder(s7_c_pointer(list_box), s7_c_pointer(placeholder));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_adjustment "void gtk_list_box_set_adjustment(GtkListBox* list_box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer list_box, adjustment;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_adjustment", 1, list_box, "GtkListBox*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_list_box_set_adjustment(s7_c_pointer(list_box), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_adjustment "GtkAdjustment* gtk_list_box_get_adjustment(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_adjustment", 1, list_box, "GtkListBox*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_list_box_get_adjustment(s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_selection_mode "void gtk_list_box_set_selection_mode(GtkListBox* list_box, \
GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer list_box, mode;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_selection_mode", 1, list_box, "GtkListBox*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_list_box_set_selection_mode(s7_c_pointer(list_box), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_selection_mode "GtkSelectionMode gtk_list_box_get_selection_mode(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_selection_mode", 1, list_box, "GtkListBox*");
  return(s7_make_integer(sc, gtk_list_box_get_selection_mode(s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_invalidate_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_filter "void gtk_list_box_invalidate_filter(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_filter", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_filter(s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_invalidate_sort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_sort "void gtk_list_box_invalidate_sort(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_sort", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_sort(s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_invalidate_headers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_headers "void gtk_list_box_invalidate_headers(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_headers", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_headers(s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_activate_on_single_click "void gtk_list_box_set_activate_on_single_click(GtkListBox* list_box, \
gboolean single)"
  s7_pointer _p;
  s7_pointer list_box, single;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_activate_on_single_click", 1, list_box, "GtkListBox*");
  single = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_activate_on_single_click", 2, single, "gboolean");
  gtk_list_box_set_activate_on_single_click(s7_c_pointer(list_box), lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_activate_on_single_click "gboolean gtk_list_box_get_activate_on_single_click(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_activate_on_single_click", 1, list_box, "GtkListBox*");
  return(s7_make_boolean(sc, gtk_list_box_get_activate_on_single_click(s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_drag_unhighlight_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_drag_unhighlight_row "void gtk_list_box_drag_unhighlight_row(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_unhighlight_row", 1, list_box, "GtkListBox*");
  gtk_list_box_drag_unhighlight_row(s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_drag_highlight_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_drag_highlight_row "void gtk_list_box_drag_highlight_row(GtkListBox* list_box, \
GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer list_box, row;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_highlight_row", 1, list_box, "GtkListBox*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_highlight_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_drag_highlight_row(s7_c_pointer(list_box), s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_new "GtkWidget* gtk_list_box_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_list_box_new()));
}

static s7_pointer lg_gtk_search_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_new "GtkWidget* gtk_search_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_search_bar_new()));
}

static s7_pointer lg_gtk_search_bar_connect_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_connect_entry "void gtk_search_bar_connect_entry(GtkSearchBar* bar, GtkEntry* entry)"
  s7_pointer _p;
  s7_pointer bar, entry;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_connect_entry", 1, bar, "GtkSearchBar*");
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_connect_entry", 2, entry, "GtkEntry*");
  gtk_search_bar_connect_entry(s7_c_pointer(bar), s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_search_bar_get_search_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_get_search_mode "gboolean gtk_search_bar_get_search_mode(GtkSearchBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_get_search_mode", 1, bar, "GtkSearchBar*");
  return(s7_make_boolean(sc, gtk_search_bar_get_search_mode(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_search_bar_set_search_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_set_search_mode "void gtk_search_bar_set_search_mode(GtkSearchBar* bar, gboolean search_mode)"
  s7_pointer _p;
  s7_pointer bar, search_mode;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_search_mode", 1, bar, "GtkSearchBar*");
  search_mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(search_mode)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_search_mode", 2, search_mode, "gboolean");
  gtk_search_bar_set_search_mode(s7_c_pointer(bar), lg_boolean(search_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_search_bar_get_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_get_show_close_button "gboolean gtk_search_bar_get_show_close_button(GtkSearchBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_get_show_close_button", 1, bar, "GtkSearchBar*");
  return(s7_make_boolean(sc, gtk_search_bar_get_show_close_button(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_search_bar_set_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_set_show_close_button "void gtk_search_bar_set_show_close_button(GtkSearchBar* bar, \
gboolean visible)"
  s7_pointer _p;
  s7_pointer bar, visible;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_show_close_button", 1, bar, "GtkSearchBar*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_show_close_button", 2, visible, "gboolean");
  gtk_search_bar_set_show_close_button(s7_c_pointer(bar), lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_search_bar_handle_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_handle_event "gboolean gtk_search_bar_handle_event(GtkSearchBar* bar, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer bar, event;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_handle_event", 1, bar, "GtkSearchBar*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_handle_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_search_bar_handle_event(s7_c_pointer(bar), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_file_chooser_get_current_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_name "gchar* gtk_file_chooser_get_current_name(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_name", 1, chooser, "GtkFileChooser*");
  return(s7_make_string(sc, gtk_file_chooser_get_current_name(s7_c_pointer(chooser))));
}

static s7_pointer lg_gdk_cairo_surface_create_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_surface_create_from_pixbuf "cairo_surface_t* gdk_cairo_surface_create_from_pixbuf(GdkPixbuf* pixbuf, \
int scale, GdkWindow* for_window)"
  s7_pointer _p;
  s7_pointer pixbuf, scale, for_window;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_surface_create_from_pixbuf", 1, pixbuf, "GdkPixbuf*");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gdk_cairo_surface_create_from_pixbuf", 2, scale, "int");
  for_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(for_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_surface_create_from_pixbuf", 3, for_window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gdk_cairo_surface_create_from_pixbuf(s7_c_pointer(pixbuf), s7_integer(scale), s7_c_pointer(for_window))));
}

static s7_pointer lg_gdk_device_get_position_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_position_double "void gdk_device_get_position_double(GdkDevice* device, GdkScreen** [screen], \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer device;
  GdkScreen* ref_screen = NULL;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_position_double", 1, device, "GdkDevice*");
  gdk_device_get_position_double(s7_c_pointer(device), &ref_screen, &ref_x, &ref_y);
    return(s7_list(sc, 3, s7_make_c_pointer(sc, ref_screen), s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_gdk_device_get_window_at_position_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_window_at_position_double "GdkWindow* gdk_device_get_window_at_position_double(GdkDevice* device, \
gdouble* [win_x], gdouble* [win_y])"
  s7_pointer _p;
  s7_pointer device;
  gdouble ref_win_x;
  gdouble ref_win_y;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_window_at_position_double", 1, device, "GdkDevice*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_device_get_window_at_position_double(s7_c_pointer(device), &ref_win_x, &ref_win_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_win_x), s7_make_real(sc, ref_win_y)));
   }
}

static s7_pointer lg_gdk_window_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_scale_factor "gint gdk_window_get_scale_factor(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_scale_factor", 1, window, "GdkWindow*");
  return(s7_make_integer(sc, gdk_window_get_scale_factor(s7_c_pointer(window))));
}

static s7_pointer lg_gdk_window_get_device_position_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_device_position_double "GdkWindow* gdk_window_get_device_position_double(GdkWindow* window, \
GdkDevice* device, gdouble* [x], gdouble* [y], GdkModifierType* [mask])"
  s7_pointer _p;
  s7_pointer window, device;
  gdouble ref_x;
  gdouble ref_y;
  GdkModifierType ref_mask;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_position_double", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_device_position_double", 2, device, "GdkDevice*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_get_device_position_double(s7_c_pointer(window), s7_c_pointer(device), &ref_x, &ref_y, &ref_mask));
      return(s7_list(sc, 4, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y), s7_make_integer(sc, ref_mask)));
   }
}

static s7_pointer lg_gdk_window_create_similar_image_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_create_similar_image_surface "cairo_surface_t* gdk_window_create_similar_image_surface(GdkWindow* window, \
cairo_format_t format, int width, int height, int scale)"
  s7_pointer _p;
  s7_pointer window, format, width, height, scale;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_image_surface", 1, window, "GdkWindow*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_image_surface", 2, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_image_surface", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_image_surface", 4, height, "int");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gdk_window_create_similar_image_surface", 5, scale, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gdk_window_create_similar_image_surface(s7_c_pointer(window), s7_integer(format), s7_integer(width), s7_integer(height), s7_integer(scale))));
}

static s7_pointer lg_gtk_icon_theme_lookup_icon_for_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_icon_for_scale "GtkIconInfo* gtk_icon_theme_lookup_icon_for_scale(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name, size, scale, flags;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon_for_scale", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon_for_scale", 2, icon_name, "gchar*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon_for_scale", 3, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon_for_scale", 4, scale, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon_for_scale", 5, flags, "GtkIconLookupFlags");
  return(s7_make_type_with_c_pointer(sc, GtkIconInfo__sym, gtk_icon_theme_lookup_icon_for_scale(s7_c_pointer(icon_theme), (const gchar*)s7_string(icon_name), s7_integer(size), s7_integer(scale), s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_theme_load_icon_for_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_load_icon_for_scale "GdkPixbuf* gtk_icon_theme_load_icon_for_scale(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GtkIconLookupFlags flags, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name, size, scale, flags;
  GError* ref_error = NULL;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon_for_scale", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon_for_scale", 2, icon_name, "gchar*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon_for_scale", 3, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon_for_scale", 4, scale, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_icon_for_scale", 5, flags, "GtkIconLookupFlags");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, GdkPixbuf__sym, gtk_icon_theme_load_icon_for_scale(s7_c_pointer(icon_theme), (const gchar*)s7_string(icon_name), s7_integer(size), s7_integer(scale), s7_integer(flags), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_icon_theme_load_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_load_surface "cairo_surface_t* gtk_icon_theme_load_surface(GtkIconTheme* icon_theme, \
gchar* icon_name, gint size, gint scale, GdkWindow* for_window, GtkIconLookupFlags flags, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_theme, icon_name, size, scale, for_window, flags;
  GError* ref_error = NULL;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 1, icon_theme, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 2, icon_name, "gchar*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 3, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 4, scale, "gint");
  for_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(for_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 5, for_window, "GdkWindow*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_load_surface", 6, flags, "GtkIconLookupFlags");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gtk_icon_theme_load_surface(s7_c_pointer(icon_theme), (const gchar*)s7_string(icon_name), s7_integer(size), s7_integer(scale), s7_c_pointer(for_window), s7_integer(flags), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_icon_theme_lookup_by_gicon_for_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_by_gicon_for_scale "GtkIconInfo* gtk_icon_theme_lookup_by_gicon_for_scale(GtkIconTheme* icon_theme, \
GIcon* icon, gint size, gint scale, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer icon_theme, icon, size, scale, flags;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", 1, icon_theme, "GtkIconTheme*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", 2, icon, "GIcon*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", 3, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", 4, scale, "gint");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", 5, flags, "GtkIconLookupFlags");
  return(s7_make_type_with_c_pointer(sc, GtkIconInfo__sym, gtk_icon_theme_lookup_by_gicon_for_scale(s7_c_pointer(icon_theme), s7_c_pointer(icon), s7_integer(size), s7_integer(scale), s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_info_get_base_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_get_base_scale "gint gtk_icon_info_get_base_scale(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_get_base_scale", 1, icon_info, "GtkIconInfo*");
  return(s7_make_integer(sc, gtk_icon_info_get_base_scale(s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_icon_info_load_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_load_surface "cairo_surface_t* gtk_icon_info_load_surface(GtkIconInfo* icon_info, \
GdkWindow* for_window, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_info, for_window;
  GError* ref_error = NULL;
  _p = args;
  icon_info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_load_surface", 1, icon_info, "GtkIconInfo*");
  for_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(for_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_load_surface", 2, for_window, "GdkWindow*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gtk_icon_info_load_surface(s7_c_pointer(icon_info), s7_c_pointer(for_window), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_image_new_from_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_surface "GtkWidget* gtk_image_new_from_surface(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_surface", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_image_new_from_surface(s7_c_pointer(surface))));
}

static s7_pointer lg_gtk_image_set_from_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_surface "void gtk_image_set_from_surface(GtkImage* image, cairo_surface_t* surface)"
  s7_pointer _p;
  s7_pointer image, surface;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_surface", 1, image, "GtkImage*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_surface", 2, surface, "cairo_surface_t*");
  gtk_image_set_from_surface(s7_c_pointer(image), s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_index "gint gtk_list_box_row_get_index(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_index", 1, row, "GtkListBoxRow*");
  return(s7_make_integer(sc, gtk_list_box_row_get_index(s7_c_pointer(row))));
}

static s7_pointer lg_gtk_widget_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_scale_factor "gint gtk_widget_get_scale_factor(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_scale_factor", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_scale_factor(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_close(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_close "void gtk_window_close(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_close", 1, window, "GtkWindow*");
  gtk_window_close(s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_show_close_button "void gtk_info_bar_set_show_close_button(GtkInfoBar* info_bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer info_bar, setting;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_show_close_button", 1, info_bar, "GtkInfoBar*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_show_close_button", 2, setting, "gboolean");
  gtk_info_bar_set_show_close_button(s7_c_pointer(info_bar), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_show_close_button "gboolean gtk_info_bar_get_show_close_button(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_show_close_button", 1, info_bar, "GtkInfoBar*");
  return(s7_make_boolean(sc, gtk_info_bar_get_show_close_button(s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_tree_model_rows_reordered_with_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_rows_reordered_with_length "void gtk_tree_model_rows_reordered_with_length(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order, gint length)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter, new_order, length;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 4, new_order, "gint*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 5, length, "gint");
  gtk_tree_model_rows_reordered_with_length(s7_c_pointer(tree_model), s7_c_pointer(path), s7_c_pointer(iter), s7_c_pointer(new_order), s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gdk_cursor_new_from_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_from_surface "GdkCursor* gdk_cursor_new_from_surface(GdkDisplay* display, \
cairo_surface_t* surface, gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer display, surface, x, y;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_surface", 1, display, "GdkDisplay*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_surface", 2, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_surface", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_surface", 4, y, "gdouble");
  return(s7_make_type_with_c_pointer(sc, GdkCursor__sym, gdk_cursor_new_from_surface(s7_c_pointer(display), s7_c_pointer(surface), s7_real(x), s7_real(y))));
}

static s7_pointer lg_gdk_cursor_get_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_surface "cairo_surface_t* gdk_cursor_get_surface(GdkCursor* cursor, gdouble* [x_hot], \
gdouble* [y_hot])"
  s7_pointer _p;
  s7_pointer cursor;
  gdouble ref_x_hot;
  gdouble ref_y_hot;
  _p = args;
  cursor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_surface", 1, cursor, "GdkCursor*");
  {
    s7_pointer result;
    result = s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, gdk_cursor_get_surface(s7_c_pointer(cursor), &ref_x_hot, &ref_y_hot));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x_hot), s7_make_real(sc, ref_y_hot)));
   }
}

static s7_pointer lg_gdk_event_get_event_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_event_type "GdkEventType gdk_event_get_event_type(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_event_type", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_event_get_event_type(s7_c_pointer(event))));
}

static s7_pointer lg_gtk_entry_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_tabs "void gtk_entry_set_tabs(GtkEntry* entry, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer entry, tabs;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_tabs", 1, entry, "GtkEntry*");
  tabs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_tabs", 2, tabs, "PangoTabArray*");
  gtk_entry_set_tabs(s7_c_pointer(entry), s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_tabs "PangoTabArray* gtk_entry_get_tabs(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_tabs", 1, entry, "GtkEntry*");
  return(s7_make_type_with_c_pointer(sc, PangoTabArray__sym, gtk_entry_get_tabs(s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_header_bar_get_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_show_close_button "gboolean gtk_header_bar_get_show_close_button(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_show_close_button", 1, bar, "GtkHeaderBar*");
  return(s7_make_boolean(sc, gtk_header_bar_get_show_close_button(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_show_close_button "void gtk_header_bar_set_show_close_button(GtkHeaderBar* bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer bar, setting;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_show_close_button", 1, bar, "GtkHeaderBar*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_show_close_button", 2, setting, "gboolean");
  gtk_header_bar_set_show_close_button(s7_c_pointer(bar), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_prepend "void gtk_list_box_prepend(GtkListBox* list_box, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer list_box, child;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_prepend", 1, list_box, "GtkListBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_prepend", 2, child, "GtkWidget*");
  gtk_list_box_prepend(s7_c_pointer(list_box), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_insert "void gtk_list_box_insert(GtkListBox* list_box, GtkWidget* child, gint position)"
  s7_pointer _p;
  s7_pointer list_box, child, position;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 1, list_box, "GtkListBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 3, position, "gint");
  gtk_list_box_insert(s7_c_pointer(list_box), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_opaque_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_opaque_region "void gdk_window_set_opaque_region(GdkWindow* window, cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer window, region;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_opaque_region", 1, window, "GdkWindow*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_opaque_region", 2, region, "cairo_region_t*");
  gdk_window_set_opaque_region(s7_c_pointer(window), s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_lines "void gtk_label_set_lines(GtkLabel* label, gint lines)"
  s7_pointer _p;
  s7_pointer label, lines;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_lines", 1, label, "GtkLabel*");
  lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(lines)) s7_wrong_type_arg_error(sc, "gtk_label_set_lines", 2, lines, "gint");
  gtk_label_set_lines(s7_c_pointer(label), s7_integer(lines));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_lines "gint gtk_label_get_lines(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_lines", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_lines(s7_c_pointer(label))));
}

static s7_pointer lg_gdk_event_get_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_window "GdkWindow* gdk_event_get_window(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_window", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_event_get_window(s7_c_pointer(event))));
}

#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_gtk_flow_box_child_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_new "GtkWidget* gtk_flow_box_child_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_flow_box_child_new()));
}

static s7_pointer lg_gtk_flow_box_child_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_get_index "gint gtk_flow_box_child_get_index(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_get_index", 1, child, "GtkFlowBoxChild*");
  return(s7_make_integer(sc, gtk_flow_box_child_get_index(s7_c_pointer(child))));
}

static s7_pointer lg_gtk_flow_box_child_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_is_selected "gboolean gtk_flow_box_child_is_selected(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_is_selected", 1, child, "GtkFlowBoxChild*");
  return(s7_make_boolean(sc, gtk_flow_box_child_is_selected(s7_c_pointer(child))));
}

static s7_pointer lg_gtk_flow_box_child_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_changed "void gtk_flow_box_child_changed(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_changed", 1, child, "GtkFlowBoxChild*");
  gtk_flow_box_child_changed(s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_new "GtkWidget* gtk_flow_box_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_flow_box_new()));
}

static s7_pointer lg_gtk_flow_box_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_homogeneous "void gtk_flow_box_set_homogeneous(GtkFlowBox* box, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer box, homogeneous;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_homogeneous", 1, box, "GtkFlowBox*");
  homogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_flow_box_set_homogeneous(s7_c_pointer(box), lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_homogeneous "gboolean gtk_flow_box_get_homogeneous(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_homogeneous", 1, box, "GtkFlowBox*");
  return(s7_make_boolean(sc, gtk_flow_box_get_homogeneous(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_row_spacing "void gtk_flow_box_set_row_spacing(GtkFlowBox* box, guint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_row_spacing", 1, box, "GtkFlowBox*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_row_spacing", 2, spacing, "guint");
  gtk_flow_box_set_row_spacing(s7_c_pointer(box), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_row_spacing "guint gtk_flow_box_get_row_spacing(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_row_spacing", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_row_spacing(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_column_spacing "void gtk_flow_box_set_column_spacing(GtkFlowBox* box, guint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_column_spacing", 1, box, "GtkFlowBox*");
  spacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_column_spacing", 2, spacing, "guint");
  gtk_flow_box_set_column_spacing(s7_c_pointer(box), s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_column_spacing "guint gtk_flow_box_get_column_spacing(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_column_spacing", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_column_spacing(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_min_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_min_children_per_line "void gtk_flow_box_set_min_children_per_line(GtkFlowBox* box, \
guint n_children)"
  s7_pointer _p;
  s7_pointer box, n_children;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_min_children_per_line", 1, box, "GtkFlowBox*");
  n_children = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_children)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_min_children_per_line", 2, n_children, "guint");
  gtk_flow_box_set_min_children_per_line(s7_c_pointer(box), s7_integer(n_children));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_min_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_min_children_per_line "guint gtk_flow_box_get_min_children_per_line(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_min_children_per_line", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_min_children_per_line(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_max_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_max_children_per_line "void gtk_flow_box_set_max_children_per_line(GtkFlowBox* box, \
guint n_children)"
  s7_pointer _p;
  s7_pointer box, n_children;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_max_children_per_line", 1, box, "GtkFlowBox*");
  n_children = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_children)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_max_children_per_line", 2, n_children, "guint");
  gtk_flow_box_set_max_children_per_line(s7_c_pointer(box), s7_integer(n_children));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_max_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_max_children_per_line "guint gtk_flow_box_get_max_children_per_line(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_max_children_per_line", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_max_children_per_line(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_activate_on_single_click "void gtk_flow_box_set_activate_on_single_click(GtkFlowBox* box, \
gboolean single)"
  s7_pointer _p;
  s7_pointer box, single;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_activate_on_single_click", 1, box, "GtkFlowBox*");
  single = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_activate_on_single_click", 2, single, "gboolean");
  gtk_flow_box_set_activate_on_single_click(s7_c_pointer(box), lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_activate_on_single_click "gboolean gtk_flow_box_get_activate_on_single_click(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_activate_on_single_click", 1, box, "GtkFlowBox*");
  return(s7_make_boolean(sc, gtk_flow_box_get_activate_on_single_click(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_insert "void gtk_flow_box_insert(GtkFlowBox* box, GtkWidget* widget, gint position)"
  s7_pointer _p;
  s7_pointer box, widget, position;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 1, box, "GtkFlowBox*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 2, widget, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 3, position, "gint");
  gtk_flow_box_insert(s7_c_pointer(box), s7_c_pointer(widget), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_child_at_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_child_at_index "GtkFlowBoxChild* gtk_flow_box_get_child_at_index(GtkFlowBox* box, \
gint idx)"
  s7_pointer _p;
  s7_pointer box, idx;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_index", 1, box, "GtkFlowBox*");
  idx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(idx)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_index", 2, idx, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkFlowBoxChild__sym, gtk_flow_box_get_child_at_index(s7_c_pointer(box), s7_integer(idx))));
}

static s7_pointer lg_gtk_flow_box_get_selected_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_selected_children "GList* gtk_flow_box_get_selected_children(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_selected_children", 1, box, "GtkFlowBox*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_flow_box_get_selected_children(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_select_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_select_child "void gtk_flow_box_select_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_child", 1, box, "GtkFlowBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_child", 2, child, "GtkFlowBoxChild*");
  gtk_flow_box_select_child(s7_c_pointer(box), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_unselect_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_unselect_child "void gtk_flow_box_unselect_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_child", 1, box, "GtkFlowBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_child", 2, child, "GtkFlowBoxChild*");
  gtk_flow_box_unselect_child(s7_c_pointer(box), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_select_all "void gtk_flow_box_select_all(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_all", 1, box, "GtkFlowBox*");
  gtk_flow_box_select_all(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_unselect_all "void gtk_flow_box_unselect_all(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_all", 1, box, "GtkFlowBox*");
  gtk_flow_box_unselect_all(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_selection_mode "void gtk_flow_box_set_selection_mode(GtkFlowBox* box, GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer box, mode;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_selection_mode", 1, box, "GtkFlowBox*");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_flow_box_set_selection_mode(s7_c_pointer(box), s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_selection_mode "GtkSelectionMode gtk_flow_box_get_selection_mode(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_selection_mode", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_selection_mode(s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_hadjustment "void gtk_flow_box_set_hadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer box, adjustment;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_hadjustment", 1, box, "GtkFlowBox*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_hadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_flow_box_set_hadjustment(s7_c_pointer(box), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_vadjustment "void gtk_flow_box_set_vadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer box, adjustment;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_vadjustment", 1, box, "GtkFlowBox*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_vadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_flow_box_set_vadjustment(s7_c_pointer(box), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_invalidate_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_invalidate_filter "void gtk_flow_box_invalidate_filter(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_invalidate_filter", 1, box, "GtkFlowBox*");
  gtk_flow_box_invalidate_filter(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_invalidate_sort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_invalidate_sort "void gtk_flow_box_invalidate_sort(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_invalidate_sort", 1, box, "GtkFlowBox*");
  gtk_flow_box_invalidate_sort(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gdk_window_set_event_compression(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_event_compression "void gdk_window_set_event_compression(GdkWindow* window, \
gboolean event_compression)"
  s7_pointer _p;
  s7_pointer window, event_compression;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_event_compression", 1, window, "GdkWindow*");
  event_compression = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(event_compression)) s7_wrong_type_arg_error(sc, "gdk_window_set_event_compression", 2, event_compression, "gboolean");
  gdk_window_set_event_compression(s7_c_pointer(window), lg_boolean(event_compression));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_event_compression(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_event_compression "gboolean gdk_window_get_event_compression(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_event_compression", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_get_event_compression(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_places_sidebar_set_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_local_only "void gtk_places_sidebar_set_local_only(GtkPlacesSidebar* sidebar, \
gboolean local_only)"
  s7_pointer _p;
  s7_pointer sidebar, local_only;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_local_only", 1, sidebar, "GtkPlacesSidebar*");
  local_only = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(local_only)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_local_only", 2, local_only, "gboolean");
  gtk_places_sidebar_set_local_only(s7_c_pointer(sidebar), lg_boolean(local_only));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_local_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_local_only "gboolean gtk_places_sidebar_get_local_only(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_local_only", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_local_only(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_stack_get_transition_running(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_running "gboolean gtk_stack_get_transition_running(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_running", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_transition_running(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_widget_get_margin_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_start "gint gtk_widget_get_margin_start(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_start", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_start(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_start "void gtk_widget_set_margin_start(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_start", 1, widget, "GtkWidget*");
  margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_start", 2, margin, "gint");
  gtk_widget_set_margin_start(s7_c_pointer(widget), s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_end "gint gtk_widget_get_margin_end(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_end", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_end(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_end "void gtk_widget_set_margin_end(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_end", 1, widget, "GtkWidget*");
  margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_end", 2, margin, "gint");
  gtk_widget_set_margin_end(s7_c_pointer(widget), s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel "void gtk_accel_label_get_accel(GtkAccelLabel* accel_label, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  s7_pointer _p;
  s7_pointer accel_label;
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel", 1, accel_label, "GtkAccelLabel*");
  gtk_accel_label_get_accel(s7_c_pointer(accel_label), &ref_accelerator_key, &ref_accelerator_mods);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_accelerator_key), s7_make_integer(sc, ref_accelerator_mods)));
}

static s7_pointer lg_gdk_window_set_shadow_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_shadow_width "void gdk_window_set_shadow_width(GdkWindow* window, gint left, \
gint right, gint top, gint bottom)"
  s7_pointer _p;
  s7_pointer window, left, right, top, bottom;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_shadow_width", 1, window, "GdkWindow*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gdk_window_set_shadow_width", 2, left, "gint");
  right = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(right)) s7_wrong_type_arg_error(sc, "gdk_window_set_shadow_width", 3, right, "gint");
  top = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gdk_window_set_shadow_width", 4, top, "gint");
  bottom = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bottom)) s7_wrong_type_arg_error(sc, "gdk_window_set_shadow_width", 5, bottom, "gint");
  gdk_window_set_shadow_width(s7_c_pointer(window), s7_integer(left), s7_integer(right), s7_integer(top), s7_integer(bottom));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_new "GtkWidget* gtk_action_bar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_action_bar_new()));
}

static s7_pointer lg_gtk_action_bar_get_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_get_center_widget "GtkWidget* gtk_action_bar_get_center_widget(GtkActionBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_get_center_widget", 1, bar, "GtkActionBar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_action_bar_get_center_widget(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_action_bar_set_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_set_center_widget "void gtk_action_bar_set_center_widget(GtkActionBar* bar, \
GtkWidget* center_widget)"
  s7_pointer _p;
  s7_pointer bar, center_widget;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_center_widget", 1, bar, "GtkActionBar*");
  center_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(center_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_center_widget", 2, center_widget, "GtkWidget*");
  gtk_action_bar_set_center_widget(s7_c_pointer(bar), s7_c_pointer(center_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_pack_start "void gtk_action_bar_pack_start(GtkActionBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_start", 1, bar, "GtkActionBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_start", 2, child, "GtkWidget*");
  gtk_action_bar_pack_start(s7_c_pointer(bar), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_pack_end "void gtk_action_bar_pack_end(GtkActionBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_end", 1, bar, "GtkActionBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_end", 2, child, "GtkWidget*");
  gtk_action_bar_pack_end(s7_c_pointer(bar), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_set_has_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_has_subtitle "void gtk_header_bar_set_has_subtitle(GtkHeaderBar* bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer bar, setting;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_has_subtitle", 1, bar, "GtkHeaderBar*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_has_subtitle", 2, setting, "gboolean");
  gtk_header_bar_set_has_subtitle(s7_c_pointer(bar), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_has_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_has_subtitle "gboolean gtk_header_bar_get_has_subtitle(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_has_subtitle", 1, bar, "GtkHeaderBar*");
  return(s7_make_boolean(sc, gtk_header_bar_get_has_subtitle(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_decoration_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_decoration_layout "void gtk_header_bar_set_decoration_layout(GtkHeaderBar* bar, \
gchar* layout)"
  s7_pointer _p;
  s7_pointer bar, layout;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_decoration_layout", 1, bar, "GtkHeaderBar*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(layout)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_decoration_layout", 2, layout, "gchar*");
  gtk_header_bar_set_decoration_layout(s7_c_pointer(bar), (const gchar*)s7_string(layout));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_decoration_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_decoration_layout "gchar* gtk_header_bar_get_decoration_layout(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_decoration_layout", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_decoration_layout(s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_icon_info_is_symbolic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_is_symbolic "gboolean gtk_icon_info_is_symbolic(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_is_symbolic", 1, icon_info, "GtkIconInfo*");
  return(s7_make_boolean(sc, gtk_icon_info_is_symbolic(s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_get_locale_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_locale_direction "GtkTextDirection gtk_get_locale_direction( void)"
  return(s7_make_integer(sc, gtk_get_locale_direction()));
}

static s7_pointer lg_gtk_window_is_maximized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_is_maximized "gboolean gtk_window_is_maximized(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_is_maximized", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_is_maximized(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_dialog_get_header_bar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_header_bar "GtkWidget* gtk_dialog_get_header_bar(GtkDialog* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_header_bar", 1, dialog, "GtkDialog*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_dialog_get_header_bar(s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_popover_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_new "GtkWidget* gtk_popover_new(GtkWidget* relative_to)"
  s7_pointer relative_to;
  relative_to = s7_car(args);
  if (!s7_is_c_pointer_of_type(relative_to, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_new", 1, relative_to, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_popover_new(s7_c_pointer(relative_to))));
}

static s7_pointer lg_gtk_popover_set_relative_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_relative_to "void gtk_popover_set_relative_to(GtkPopover* popover, GtkWidget* relative_to)"
  s7_pointer _p;
  s7_pointer popover, relative_to;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_relative_to", 1, popover, "GtkPopover*");
  relative_to = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(relative_to, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_relative_to", 2, relative_to, "GtkWidget*");
  gtk_popover_set_relative_to(s7_c_pointer(popover), s7_c_pointer(relative_to));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_relative_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_relative_to "GtkWidget* gtk_popover_get_relative_to(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_relative_to", 1, popover, "GtkPopover*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_popover_get_relative_to(s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_popover_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_position "void gtk_popover_set_position(GtkPopover* popover, GtkPositionType position)"
  s7_pointer _p;
  s7_pointer popover, position;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_position", 1, popover, "GtkPopover*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_popover_set_position", 2, position, "GtkPositionType");
  gtk_popover_set_position(s7_c_pointer(popover), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_position "GtkPositionType gtk_popover_get_position(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_position", 1, popover, "GtkPopover*");
  return(s7_make_integer(sc, gtk_popover_get_position(s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_popover_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_modal "void gtk_popover_set_modal(GtkPopover* popover, gboolean modal)"
  s7_pointer _p;
  s7_pointer popover, modal;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_modal", 1, popover, "GtkPopover*");
  modal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_popover_set_modal", 2, modal, "gboolean");
  gtk_popover_set_modal(s7_c_pointer(popover), lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_modal "gboolean gtk_popover_get_modal(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_modal", 1, popover, "GtkPopover*");
  return(s7_make_boolean(sc, gtk_popover_get_modal(s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_entry_set_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_max_width_chars "void gtk_entry_set_max_width_chars(GtkEntry* entry, gint n_chars)"
  s7_pointer _p;
  s7_pointer entry, n_chars;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_width_chars", 1, entry, "GtkEntry*");
  n_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_width_chars", 2, n_chars, "gint");
  gtk_entry_set_max_width_chars(s7_c_pointer(entry), s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_max_width_chars "gint gtk_entry_get_max_width_chars(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_max_width_chars", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_max_width_chars(s7_c_pointer(entry))));
}

static s7_pointer lg_gdk_device_get_last_event_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_last_event_window "GdkWindow* gdk_device_get_last_event_window(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_last_event_window", 1, device, "GdkDevice*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_device_get_last_event_window(s7_c_pointer(device))));
}

#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_gtk_list_box_row_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_is_selected "gboolean gtk_list_box_row_is_selected(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_is_selected", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_is_selected(s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_unselect_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_unselect_row "void gtk_list_box_unselect_row(GtkListBox* box, GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer box, row;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_row", 1, box, "GtkListBox*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_unselect_row(s7_c_pointer(box), s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_select_all "void gtk_list_box_select_all(GtkListBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_all", 1, box, "GtkListBox*");
  gtk_list_box_select_all(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_unselect_all "void gtk_list_box_unselect_all(GtkListBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_all", 1, box, "GtkListBox*");
  gtk_list_box_unselect_all(s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_show_enter_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_show_enter_location "gboolean gtk_places_sidebar_get_show_enter_location(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_show_enter_location", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_show_enter_location(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_show_enter_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_show_enter_location "void gtk_places_sidebar_set_show_enter_location(GtkPlacesSidebar* sidebar, \
gboolean show_enter_location)"
  s7_pointer _p;
  s7_pointer sidebar, show_enter_location;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_enter_location", 1, sidebar, "GtkPlacesSidebar*");
  show_enter_location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_enter_location)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_enter_location", 2, show_enter_location, "gboolean");
  gtk_places_sidebar_set_show_enter_location(s7_c_pointer(sidebar), lg_boolean(show_enter_location));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_set_state "void gtk_switch_set_state(GtkSwitch* sw, gboolean state)"
  s7_pointer _p;
  s7_pointer sw, state;
  _p = args;
  sw = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_set_state", 1, sw, "GtkSwitch*");
  state = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(state)) s7_wrong_type_arg_error(sc, "gtk_switch_set_state", 2, state, "gboolean");
  gtk_switch_set_state(s7_c_pointer(sw), lg_boolean(state));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_get_state "gboolean gtk_switch_get_state(GtkSwitch* sw)"
  s7_pointer sw;
  sw = s7_car(args);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_get_state", 1, sw, "GtkSwitch*");
  return(s7_make_boolean(sc, gtk_switch_get_state(s7_c_pointer(sw))));
}

static s7_pointer lg_gdk_window_show_window_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_show_window_menu "gboolean gdk_window_show_window_menu(GdkWindow* window, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer window, event;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_show_window_menu", 1, window, "GdkWindow*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_window_show_window_menu", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_window_show_window_menu(s7_c_pointer(window), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_widget_get_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_clip "void gtk_widget_get_clip(GtkWidget* widget, GtkAllocation* clip)"
  s7_pointer _p;
  s7_pointer widget, clip;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_clip", 1, widget, "GtkWidget*");
  clip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clip, GtkAllocation__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_clip", 2, clip, "GtkAllocation*");
  gtk_widget_get_clip(s7_c_pointer(widget), s7_c_pointer(clip));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_device "GdkDevice* gtk_gesture_get_device(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_device", 1, gesture, "GtkGesture*");
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gtk_gesture_get_device(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_set_state "gboolean gtk_gesture_set_state(GtkGesture* gesture, GtkEventSequenceState state)"
  s7_pointer _p;
  s7_pointer gesture, state;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_state", 1, gesture, "GtkGesture*");
  state = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(state)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_state", 2, state, "GtkEventSequenceState");
  return(s7_make_boolean(sc, gtk_gesture_set_state(s7_c_pointer(gesture), s7_integer(state))));
}

static s7_pointer lg_gtk_gesture_get_sequence_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_sequence_state "GtkEventSequenceState gtk_gesture_get_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequence_state", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequence_state", 2, sequence, "GdkEventSequence*");
  return(s7_make_integer(sc, gtk_gesture_get_sequence_state(s7_c_pointer(gesture), s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_set_sequence_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_set_sequence_state "gboolean gtk_gesture_set_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence, GtkEventSequenceState state)"
  s7_pointer _p;
  s7_pointer gesture, sequence, state;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 2, sequence, "GdkEventSequence*");
  state = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(state)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 3, state, "GtkEventSequenceState");
  return(s7_make_boolean(sc, gtk_gesture_set_sequence_state(s7_c_pointer(gesture), s7_c_pointer(sequence), s7_integer(state))));
}

static s7_pointer lg_gtk_gesture_get_sequences(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_sequences "GList* gtk_gesture_get_sequences(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequences", 1, gesture, "GtkGesture*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_gesture_get_sequences(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_get_last_updated_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_last_updated_sequence "GdkEventSequence* gtk_gesture_get_last_updated_sequence(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_updated_sequence", 1, gesture, "GtkGesture*");
  return(s7_make_type_with_c_pointer(sc, GdkEventSequence__sym, gtk_gesture_get_last_updated_sequence(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_handles_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_handles_sequence "gboolean gtk_gesture_handles_sequence(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_handles_sequence", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_handles_sequence", 2, sequence, "GdkEventSequence*");
  return(s7_make_boolean(sc, gtk_gesture_handles_sequence(s7_c_pointer(gesture), s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_get_last_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_last_event "GdkEvent* gtk_gesture_get_last_event(GtkGesture* gesture, GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_event", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_event", 2, sequence, "GdkEventSequence*");
    return(s7_make_type_with_c_pointer(sc, GdkEvent__sym, (GdkEvent*)gtk_gesture_get_last_event(s7_c_pointer(gesture), s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_get_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_point "gboolean gtk_gesture_get_point(GtkGesture* gesture, GdkEventSequence* sequence, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_point", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_point", 2, sequence, "GdkEventSequence*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_gesture_get_point(s7_c_pointer(gesture), s7_c_pointer(sequence), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_get_bounding_box(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_bounding_box "gboolean gtk_gesture_get_bounding_box(GtkGesture* gesture, \
GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box", 1, gesture, "GtkGesture*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_gesture_get_bounding_box(s7_c_pointer(gesture), s7_c_pointer(rect))));
}

static s7_pointer lg_gtk_gesture_get_bounding_box_center(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_bounding_box_center "gboolean gtk_gesture_get_bounding_box_center(GtkGesture* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box_center", 1, gesture, "GtkGesture*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_gesture_get_bounding_box_center(s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_is_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_active "gboolean gtk_gesture_is_active(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_active", 1, gesture, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_active(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_is_recognized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_recognized "gboolean gtk_gesture_is_recognized(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_recognized", 1, gesture, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_recognized(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_group "void gtk_gesture_group(GtkGesture* group_gesture, GtkGesture* gesture)"
  s7_pointer _p;
  s7_pointer group_gesture, gesture;
  _p = args;
  group_gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group_gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_group", 1, group_gesture, "GtkGesture*");
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_group", 2, gesture, "GtkGesture*");
  gtk_gesture_group(s7_c_pointer(group_gesture), s7_c_pointer(gesture));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_ungroup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_ungroup "void gtk_gesture_ungroup(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_ungroup", 1, gesture, "GtkGesture*");
  gtk_gesture_ungroup(s7_c_pointer(gesture));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_group "GList* gtk_gesture_get_group(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_group", 1, gesture, "GtkGesture*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gtk_gesture_get_group(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_is_grouped_with(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_grouped_with "gboolean gtk_gesture_is_grouped_with(GtkGesture* gesture, GtkGesture* other)"
  s7_pointer _p;
  s7_pointer gesture, other;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_grouped_with", 1, gesture, "GtkGesture*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_grouped_with", 2, other, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_grouped_with(s7_c_pointer(gesture), s7_c_pointer(other))));
}

static s7_pointer lg_gtk_gesture_drag_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_new "GtkGesture* gtk_gesture_drag_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_drag_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_drag_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_drag_get_start_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_get_start_point "gboolean gtk_gesture_drag_get_start_point(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_drag_get_start_point", 1, gesture, "GtkGestureDrag*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_gesture_drag_get_start_point(s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_drag_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_get_offset "gboolean gtk_gesture_drag_get_offset(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_drag_get_offset", 1, gesture, "GtkGestureDrag*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_gesture_drag_get_offset(s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_long_press_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_long_press_new "GtkGesture* gtk_gesture_long_press_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_long_press_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_long_press_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_pan_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_new "GtkGesture* gtk_gesture_pan_new(GtkWidget* widget, GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer widget, orientation;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_new", 1, widget, "GtkWidget*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_new", 2, orientation, "GtkOrientation");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_pan_new(s7_c_pointer(widget), s7_integer(orientation))));
}

static s7_pointer lg_gtk_gesture_pan_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_get_orientation "GtkOrientation gtk_gesture_pan_get_orientation(GtkGesturePan* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesturePan__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_get_orientation", 1, gesture, "GtkGesturePan*");
  return(s7_make_integer(sc, gtk_gesture_pan_get_orientation(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_pan_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_set_orientation "void gtk_gesture_pan_set_orientation(GtkGesturePan* gesture, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer gesture, orientation;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesturePan__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_set_orientation", 1, gesture, "GtkGesturePan*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_set_orientation", 2, orientation, "GtkOrientation");
  gtk_gesture_pan_set_orientation(s7_c_pointer(gesture), s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_multi_press_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_multi_press_new "GtkGesture* gtk_gesture_multi_press_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_multi_press_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_multi_press_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_multi_press_set_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_multi_press_set_area "void gtk_gesture_multi_press_set_area(GtkGestureMultiPress* gesture, \
GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureMultiPress__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_multi_press_set_area", 1, gesture, "GtkGestureMultiPress*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_multi_press_set_area", 2, rect, "GdkRectangle*");
  gtk_gesture_multi_press_set_area(s7_c_pointer(gesture), s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_multi_press_get_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_multi_press_get_area "gboolean gtk_gesture_multi_press_get_area(GtkGestureMultiPress* gesture, \
GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureMultiPress__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_multi_press_get_area", 1, gesture, "GtkGestureMultiPress*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_multi_press_get_area", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_gesture_multi_press_get_area(s7_c_pointer(gesture), s7_c_pointer(rect))));
}

static s7_pointer lg_gtk_gesture_rotate_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_rotate_new "GtkGesture* gtk_gesture_rotate_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_rotate_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_rotate_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_rotate_get_angle_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_rotate_get_angle_delta "gdouble gtk_gesture_rotate_get_angle_delta(GtkGestureRotate* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureRotate__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_rotate_get_angle_delta", 1, gesture, "GtkGestureRotate*");
  return(s7_make_real(sc, gtk_gesture_rotate_get_angle_delta(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_get_touch_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_touch_only "gboolean gtk_gesture_single_get_touch_only(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_touch_only", 1, gesture, "GtkGestureSingle*");
  return(s7_make_boolean(sc, gtk_gesture_single_get_touch_only(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_touch_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_touch_only "void gtk_gesture_single_set_touch_only(GtkGestureSingle* gesture, \
gboolean touch_only)"
  s7_pointer _p;
  s7_pointer gesture, touch_only;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_touch_only", 1, gesture, "GtkGestureSingle*");
  touch_only = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(touch_only)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_touch_only", 2, touch_only, "gboolean");
  gtk_gesture_single_set_touch_only(s7_c_pointer(gesture), lg_boolean(touch_only));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_exclusive "gboolean gtk_gesture_single_get_exclusive(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_exclusive", 1, gesture, "GtkGestureSingle*");
  return(s7_make_boolean(sc, gtk_gesture_single_get_exclusive(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_exclusive "void gtk_gesture_single_set_exclusive(GtkGestureSingle* gesture, \
gboolean exclusive)"
  s7_pointer _p;
  s7_pointer gesture, exclusive;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_exclusive", 1, gesture, "GtkGestureSingle*");
  exclusive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(exclusive)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_exclusive", 2, exclusive, "gboolean");
  gtk_gesture_single_set_exclusive(s7_c_pointer(gesture), lg_boolean(exclusive));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_button "guint gtk_gesture_single_get_button(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_button", 1, gesture, "GtkGestureSingle*");
  return(s7_make_integer(sc, gtk_gesture_single_get_button(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_button "void gtk_gesture_single_set_button(GtkGestureSingle* gesture, \
guint button)"
  s7_pointer _p;
  s7_pointer gesture, button;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_button", 1, gesture, "GtkGestureSingle*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_button", 2, button, "guint");
  gtk_gesture_single_set_button(s7_c_pointer(gesture), s7_integer(button));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_current_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_current_button "guint gtk_gesture_single_get_current_button(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_current_button", 1, gesture, "GtkGestureSingle*");
  return(s7_make_integer(sc, gtk_gesture_single_get_current_button(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_get_current_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_current_sequence "GdkEventSequence* gtk_gesture_single_get_current_sequence(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_current_sequence", 1, gesture, "GtkGestureSingle*");
  return(s7_make_type_with_c_pointer(sc, GdkEventSequence__sym, gtk_gesture_single_get_current_sequence(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_swipe_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_swipe_new "GtkGesture* gtk_gesture_swipe_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_swipe_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_swipe_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_swipe_get_velocity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_swipe_get_velocity "gboolean gtk_gesture_swipe_get_velocity(GtkGestureSwipe* gesture, \
gdouble* [velocity_x], gdouble* [velocity_y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_velocity_x;
  gdouble ref_velocity_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSwipe__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_swipe_get_velocity", 1, gesture, "GtkGestureSwipe*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_gesture_swipe_get_velocity(s7_c_pointer(gesture), &ref_velocity_x, &ref_velocity_y));
      return(s7_list(sc, 3, result, s7_make_real(sc, ref_velocity_x), s7_make_real(sc, ref_velocity_y)));
   }
}

static s7_pointer lg_gtk_gesture_zoom_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_zoom_new "GtkGesture* gtk_gesture_zoom_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_zoom_new", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkGesture__sym, gtk_gesture_zoom_new(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_gesture_zoom_get_scale_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_zoom_get_scale_delta "gdouble gtk_gesture_zoom_get_scale_delta(GtkGestureZoom* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureZoom__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_zoom_get_scale_delta", 1, gesture, "GtkGestureZoom*");
  return(s7_make_real(sc, gtk_gesture_zoom_get_scale_delta(s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_event_controller_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_widget "GtkWidget* gtk_event_controller_get_widget(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_widget", 1, controller, "GtkEventController*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_event_controller_get_widget(s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_handle_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_handle_event "gboolean gtk_event_controller_handle_event(GtkEventController* controller, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer controller, event;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_handle_event", 1, controller, "GtkEventController*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_handle_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_event_controller_handle_event(s7_c_pointer(controller), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_event_controller_reset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_reset "void gtk_event_controller_reset(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_reset", 1, controller, "GtkEventController*");
  gtk_event_controller_reset(s7_c_pointer(controller));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_get_propagation_phase(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_propagation_phase "GtkPropagationPhase gtk_event_controller_get_propagation_phase(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_propagation_phase", 1, controller, "GtkEventController*");
  return(s7_make_integer(sc, gtk_event_controller_get_propagation_phase(s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_set_propagation_phase(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_set_propagation_phase "void gtk_event_controller_set_propagation_phase(GtkEventController* controller, \
GtkPropagationPhase phase)"
  s7_pointer _p;
  s7_pointer controller, phase;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_phase", 1, controller, "GtkEventController*");
  phase = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(phase)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_phase", 2, phase, "GtkPropagationPhase");
  gtk_event_controller_set_propagation_phase(s7_c_pointer(controller), s7_integer(phase));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_add_resource_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_add_resource_path "void gtk_icon_theme_add_resource_path(GtkIconTheme* icon_theme, \
gchar* path)"
  s7_pointer _p;
  s7_pointer icon_theme, path;
  _p = args;
  icon_theme = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_theme, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_resource_path", 1, icon_theme, "GtkIconTheme*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_resource_path", 2, path, "gchar*");
  gtk_icon_theme_add_resource_path(s7_c_pointer(icon_theme), (const gchar*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_set_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_activatable "void gtk_list_box_row_set_activatable(GtkListBoxRow* row, \
gboolean activatable)"
  s7_pointer _p;
  s7_pointer row, activatable;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_activatable", 1, row, "GtkListBoxRow*");
  activatable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(activatable)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_activatable", 2, activatable, "gboolean");
  gtk_list_box_row_set_activatable(s7_c_pointer(row), lg_boolean(activatable));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_get_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_activatable "gboolean gtk_list_box_row_get_activatable(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_activatable", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_get_activatable(s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_row_set_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_selectable "void gtk_list_box_row_set_selectable(GtkListBoxRow* row, \
gboolean selectable)"
  s7_pointer _p;
  s7_pointer row, selectable;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_selectable", 1, row, "GtkListBoxRow*");
  selectable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(selectable)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_selectable", 2, selectable, "gboolean");
  gtk_list_box_row_set_selectable(s7_c_pointer(row), lg_boolean(selectable));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_get_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_selectable "gboolean gtk_list_box_row_get_selectable(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_selectable", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_get_selectable(s7_c_pointer(row))));
}

static s7_pointer lg_gtk_widget_path_iter_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_path_iter_get_state "GtkStateFlags gtk_widget_path_iter_get_state(GtkWidgetPath* path, \
gint pos)"
  s7_pointer _p;
  s7_pointer path, pos;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_get_state", 1, path, "GtkWidgetPath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_get_state", 2, pos, "gint");
  return(s7_make_integer(sc, gtk_widget_path_iter_get_state(s7_c_pointer(path), s7_integer(pos))));
}

static s7_pointer lg_gtk_widget_path_iter_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_path_iter_set_state "void gtk_widget_path_iter_set_state(GtkWidgetPath* path, \
gint pos, GtkStateFlags state)"
  s7_pointer _p;
  s7_pointer path, pos, state;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_state", 1, path, "GtkWidgetPath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_state", 2, pos, "gint");
  state = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(state)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_state", 3, state, "GtkStateFlags");
  gtk_widget_path_iter_set_state(s7_c_pointer(path), s7_integer(pos), s7_integer(state));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_gdk_cairo_draw_from_gl(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_draw_from_gl "void gdk_cairo_draw_from_gl(cairo_t* cr, GdkWindow* window, int source, \
int source_type, int buffer_scale, int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer cr, window, source, source_type, buffer_scale, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 1, cr, "cairo_t*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 2, window, "GdkWindow*");
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(source)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 3, source, "int");
  source_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(source_type)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 4, source_type, "int");
  buffer_scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(buffer_scale)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 5, buffer_scale, "int");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 6, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 7, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 8, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_cairo_draw_from_gl", 9, height, "int");
  gdk_cairo_draw_from_gl(s7_c_pointer(cr), s7_c_pointer(window), s7_integer(source), s7_integer(source_type), s7_integer(buffer_scale), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gdk_window_mark_paint_from_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_mark_paint_from_clip "void gdk_window_mark_paint_from_clip(GdkWindow* window, \
cairo_t* cr)"
  s7_pointer _p;
  s7_pointer window, cr;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_mark_paint_from_clip", 1, window, "GdkWindow*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_mark_paint_from_clip", 2, cr, "cairo_t*");
  gdk_window_mark_paint_from_clip(s7_c_pointer(window), s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_xalign "void gtk_label_set_xalign(GtkLabel* label, gfloat xalign)"
  s7_pointer _p;
  s7_pointer label, xalign;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_xalign", 1, label, "GtkLabel*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_label_set_xalign", 2, xalign, "gfloat");
  gtk_label_set_xalign(s7_c_pointer(label), s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_xalign "gfloat gtk_label_get_xalign(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_xalign", 1, label, "GtkLabel*");
  return(s7_make_real(sc, gtk_label_get_xalign(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_yalign "void gtk_label_set_yalign(GtkLabel* label, gfloat xalign)"
  s7_pointer _p;
  s7_pointer label, xalign;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_yalign", 1, label, "GtkLabel*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_label_set_yalign", 2, xalign, "gfloat");
  gtk_label_set_yalign(s7_c_pointer(label), s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_yalign "gfloat gtk_label_get_yalign(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_yalign", 1, label, "GtkLabel*");
  return(s7_make_real(sc, gtk_label_get_yalign(s7_c_pointer(label))));
}

static s7_pointer lg_gtk_paned_set_wide_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_set_wide_handle "void gtk_paned_set_wide_handle(GtkPaned* paned, gboolean wide)"
  s7_pointer _p;
  s7_pointer paned, wide;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_set_wide_handle", 1, paned, "GtkPaned*");
  wide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(wide)) s7_wrong_type_arg_error(sc, "gtk_paned_set_wide_handle", 2, wide, "gboolean");
  gtk_paned_set_wide_handle(s7_c_pointer(paned), lg_boolean(wide));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_wide_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_wide_handle "gboolean gtk_paned_get_wide_handle(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_wide_handle", 1, paned, "GtkPaned*");
  return(s7_make_boolean(sc, gtk_paned_get_wide_handle(s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_scrolled_window_set_overlay_scrolling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_overlay_scrolling "void gtk_scrolled_window_set_overlay_scrolling(GtkScrolledWindow* scrolled_window, \
gboolean overlay_scrolling)"
  s7_pointer _p;
  s7_pointer scrolled_window, overlay_scrolling;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_overlay_scrolling", 1, scrolled_window, "GtkScrolledWindow*");
  overlay_scrolling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(overlay_scrolling)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_overlay_scrolling", 2, overlay_scrolling, "gboolean");
  gtk_scrolled_window_set_overlay_scrolling(s7_c_pointer(scrolled_window), lg_boolean(overlay_scrolling));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_overlay_scrolling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_overlay_scrolling "gboolean gtk_scrolled_window_get_overlay_scrolling(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_overlay_scrolling", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_overlay_scrolling(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_text_view_set_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_monospace "void gtk_text_view_set_monospace(GtkTextView* text_view, gboolean monospace)"
  s7_pointer _p;
  s7_pointer text_view, monospace;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_monospace", 1, text_view, "GtkTextView*");
  monospace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(monospace)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_monospace", 2, monospace, "gboolean");
  gtk_text_view_set_monospace(s7_c_pointer(text_view), lg_boolean(monospace));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_monospace "gboolean gtk_text_view_get_monospace(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_monospace", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_monospace(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_window_get_titlebar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_titlebar "GtkWidget* gtk_window_get_titlebar(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_titlebar", 1, window, "GtkWindow*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_window_get_titlebar(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_gl_area_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_new "GtkWidget* gtk_gl_area_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_gl_area_new()));
}

static s7_pointer lg_gtk_gl_area_get_has_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_has_alpha "gboolean gtk_gl_area_get_has_alpha(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_has_alpha", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_has_alpha(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_has_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_has_alpha "void gtk_gl_area_set_has_alpha(GtkGLArea* area, gboolean has_alpha)"
  s7_pointer _p;
  s7_pointer area, has_alpha;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_alpha", 1, area, "GtkGLArea*");
  has_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_alpha)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_alpha", 2, has_alpha, "gboolean");
  gtk_gl_area_set_has_alpha(s7_c_pointer(area), lg_boolean(has_alpha));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_has_depth_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_has_depth_buffer "gboolean gtk_gl_area_get_has_depth_buffer(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_has_depth_buffer", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_has_depth_buffer(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_has_depth_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_has_depth_buffer "void gtk_gl_area_set_has_depth_buffer(GtkGLArea* area, \
gboolean has_depth_buffer)"
  s7_pointer _p;
  s7_pointer area, has_depth_buffer;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_depth_buffer", 1, area, "GtkGLArea*");
  has_depth_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_depth_buffer)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_depth_buffer", 2, has_depth_buffer, "gboolean");
  gtk_gl_area_set_has_depth_buffer(s7_c_pointer(area), lg_boolean(has_depth_buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_context "GdkGLContext* gtk_gl_area_get_context(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_context", 1, area, "GtkGLArea*");
  return(s7_make_type_with_c_pointer(sc, GdkGLContext__sym, gtk_gl_area_get_context(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_make_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_make_current "void gtk_gl_area_make_current(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_make_current", 1, area, "GtkGLArea*");
  gtk_gl_area_make_current(s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_render_check(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_check "void gtk_render_check(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_check", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_check", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_check", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_check", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_check", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_check", 6, height, "gdouble");
  gtk_render_check(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_option(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_option "void gtk_render_option(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_option", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_option", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_option", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_option", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_option", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_option", 6, height, "gdouble");
  gtk_render_option(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_arrow "void gtk_render_arrow(GtkStyleContext* context, cairo_t* cr, gdouble angle, \
gdouble x, gdouble y, gdouble size)"
  s7_pointer _p;
  s7_pointer context, cr, angle, x, y, size;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 2, cr, "cairo_t*");
  angle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 3, angle, "gdouble");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 4, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 5, y, "gdouble");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 6, size, "gdouble");
  gtk_render_arrow(s7_c_pointer(context), s7_c_pointer(cr), s7_real(angle), s7_real(x), s7_real(y), s7_real(size));
  return(lg_false);
}

static s7_pointer lg_gtk_render_background(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_background "void gtk_render_background(GtkStyleContext* context, cairo_t* cr, \
gdouble x, gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_background", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_background", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_background", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_background", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_background", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_background", 6, height, "gdouble");
  gtk_render_background(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_frame "void gtk_render_frame(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 6, height, "gdouble");
  gtk_render_frame(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_expander(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_expander "void gtk_render_expander(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 6, height, "gdouble");
  gtk_render_expander(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_focus "void gtk_render_focus(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 6, height, "gdouble");
  gtk_render_focus(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_layout "void gtk_render_layout(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, layout;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 4, y, "gdouble");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 5, layout, "PangoLayout*");
  gtk_render_layout(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_gtk_render_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_line "void gtk_render_line(GtkStyleContext* context, cairo_t* cr, gdouble x0, \
gdouble y0, gdouble x1, gdouble y1)"
  s7_pointer _p;
  s7_pointer context, cr, x0, y0, x1, y1;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_line", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_line", 2, cr, "cairo_t*");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "gtk_render_line", 3, x0, "gdouble");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "gtk_render_line", 4, y0, "gdouble");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "gtk_render_line", 5, x1, "gdouble");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "gtk_render_line", 6, y1, "gdouble");
  gtk_render_line(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x0), s7_real(y0), s7_real(x1), s7_real(y1));
  return(lg_false);
}

static s7_pointer lg_gtk_render_slider(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_slider "void gtk_render_slider(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height, GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height, orientation;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 6, height, "gdouble");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_render_slider", 7, orientation, "GtkOrientation");
  gtk_render_slider(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height), s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_render_frame_gap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_frame_gap "void gtk_render_frame_gap(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height, GtkPositionType gap_side, gdouble xy0_gap, gdouble xy1_gap)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height, gap_side, xy0_gap, xy1_gap;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 6, height, "gdouble");
  gap_side = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(gap_side)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 7, gap_side, "GtkPositionType");
  xy0_gap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xy0_gap)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 8, xy0_gap, "gdouble");
  xy1_gap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xy1_gap)) s7_wrong_type_arg_error(sc, "gtk_render_frame_gap", 9, xy1_gap, "gdouble");
  gtk_render_frame_gap(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height), s7_integer(gap_side), s7_real(xy0_gap), s7_real(xy1_gap));
  return(lg_false);
}

static s7_pointer lg_gtk_render_extension(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_extension "void gtk_render_extension(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height, GtkPositionType gap_side)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height, gap_side;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 6, height, "gdouble");
  gap_side = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(gap_side)) s7_wrong_type_arg_error(sc, "gtk_render_extension", 7, gap_side, "GtkPositionType");
  gtk_render_extension(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height), s7_integer(gap_side));
  return(lg_false);
}

static s7_pointer lg_gtk_render_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_handle "void gtk_render_handle(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 6, height, "gdouble");
  gtk_render_handle(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_activity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_activity "void gtk_render_activity(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 5, width, "gdouble");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 6, height, "gdouble");
  gtk_render_activity(s7_c_pointer(context), s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_icon "void gtk_render_icon(GtkStyleContext* context, cairo_t* cr, GdkPixbuf* pixbuf, \
gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer context, cr, pixbuf, x, y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 2, cr, "cairo_t*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 3, pixbuf, "GdkPixbuf*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 4, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 5, y, "gdouble");
  gtk_render_icon(s7_c_pointer(context), s7_c_pointer(cr), s7_c_pointer(pixbuf), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_gtk_render_icon_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_icon_surface "void gtk_render_icon_surface(GtkStyleContext* context, cairo_t* cr, \
cairo_surface_t* surface, gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer context, cr, surface, x, y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon_surface", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon_surface", 2, cr, "cairo_t*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon_surface", 3, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_icon_surface", 4, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_icon_surface", 5, y, "gdouble");
  gtk_render_icon_surface(s7_c_pointer(context), s7_c_pointer(cr), s7_c_pointer(surface), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_window "GdkWindow* gdk_gl_context_get_window(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_window", 1, context, "GdkGLContext*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_gl_context_get_window(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_make_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_make_current "void gdk_gl_context_make_current(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_make_current", 1, context, "GdkGLContext*");
  gdk_gl_context_make_current(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_current "GdkGLContext* gdk_gl_context_get_current( void)"
  return(s7_make_type_with_c_pointer(sc, GdkGLContext__sym, gdk_gl_context_get_current()));
}

static s7_pointer lg_gdk_gl_context_clear_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_clear_current "void gdk_gl_context_clear_current( void)"
  gdk_gl_context_clear_current();
  return(lg_false);
}

static s7_pointer lg_gtk_stack_set_hhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_hhomogeneous "void gtk_stack_set_hhomogeneous(GtkStack* stack, gboolean hhomogeneous)"
  s7_pointer _p;
  s7_pointer stack, hhomogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_hhomogeneous", 1, stack, "GtkStack*");
  hhomogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(hhomogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_hhomogeneous", 2, hhomogeneous, "gboolean");
  gtk_stack_set_hhomogeneous(s7_c_pointer(stack), lg_boolean(hhomogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_hhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_hhomogeneous "gboolean gtk_stack_get_hhomogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_hhomogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_hhomogeneous(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_vhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_vhomogeneous "void gtk_stack_set_vhomogeneous(GtkStack* stack, gboolean vhomogeneous)"
  s7_pointer _p;
  s7_pointer stack, vhomogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_vhomogeneous", 1, stack, "GtkStack*");
  vhomogeneous = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(vhomogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_vhomogeneous", 2, vhomogeneous, "gboolean");
  gtk_stack_set_vhomogeneous(s7_c_pointer(stack), lg_boolean(vhomogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_vhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_vhomogeneous "gboolean gtk_stack_get_vhomogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_vhomogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_vhomogeneous(s7_c_pointer(stack))));
}

static s7_pointer lg_gdk_gl_context_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_display "GdkDisplay* gdk_gl_context_get_display(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_display", 1, context, "GdkGLContext*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_gl_context_get_display(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_gl_area_get_has_stencil_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_has_stencil_buffer "gboolean gtk_gl_area_get_has_stencil_buffer(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_has_stencil_buffer", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_has_stencil_buffer(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_has_stencil_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_has_stencil_buffer "void gtk_gl_area_set_has_stencil_buffer(GtkGLArea* area, \
gboolean has_stencil_buffer)"
  s7_pointer _p;
  s7_pointer area, has_stencil_buffer;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_stencil_buffer", 1, area, "GtkGLArea*");
  has_stencil_buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_stencil_buffer)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_stencil_buffer", 2, has_stencil_buffer, "gboolean");
  gtk_gl_area_set_has_stencil_buffer(s7_c_pointer(area), lg_boolean(has_stencil_buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_auto_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_auto_render "gboolean gtk_gl_area_get_auto_render(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_auto_render", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_auto_render(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_auto_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_auto_render "void gtk_gl_area_set_auto_render(GtkGLArea* area, gboolean auto_render)"
  s7_pointer _p;
  s7_pointer area, auto_render;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_auto_render", 1, area, "GtkGLArea*");
  auto_render = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(auto_render)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_auto_render", 2, auto_render, "gboolean");
  gtk_gl_area_set_auto_render(s7_c_pointer(area), lg_boolean(auto_render));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_queue_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_queue_render "void gtk_gl_area_queue_render(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_queue_render", 1, area, "GtkGLArea*");
  gtk_gl_area_queue_render(s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_attach_buffers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_attach_buffers "void gtk_gl_area_attach_buffers(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_attach_buffers", 1, area, "GtkGLArea*");
  gtk_gl_area_attach_buffers(s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_error "GError* gtk_gl_area_get_error(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_error", 1, area, "GtkGLArea*");
  return(s7_make_type_with_c_pointer(sc, GError__sym, gtk_gl_area_get_error(s7_c_pointer(area))));
}

static s7_pointer lg_gtk_popover_menu_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_new "GtkWidget* gtk_popover_menu_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_popover_menu_new()));
}

static s7_pointer lg_gtk_popover_menu_open_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_open_submenu "void gtk_popover_menu_open_submenu(GtkPopoverMenu* popover, \
gchar* name)"
  s7_pointer _p;
  s7_pointer popover, name;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopoverMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_open_submenu", 1, popover, "GtkPopoverMenu*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_open_submenu", 2, name, "gchar*");
  gtk_popover_menu_open_submenu(s7_c_pointer(popover), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_grab_focus_without_selecting(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_grab_focus_without_selecting "void gtk_entry_grab_focus_without_selecting(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_grab_focus_without_selecting", 1, entry, "GtkEntry*");
  gtk_entry_grab_focus_without_selecting(s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollable_get_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_border "gboolean gtk_scrollable_get_border(GtkScrollable* scrollable, \
GtkBorder* border)"
  s7_pointer _p;
  s7_pointer scrollable, border;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_border", 1, scrollable, "GtkScrollable*");
  border = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(border, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_border", 2, border, "GtkBorder*");
  return(s7_make_boolean(sc, gtk_scrollable_get_border(s7_c_pointer(scrollable), s7_c_pointer(border))));
}

static s7_pointer lg_gtk_text_buffer_insert_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_markup "void gtk_text_buffer_insert_markup(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* markup, gint len)"
  s7_pointer _p;
  s7_pointer buffer, iter, markup, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 2, iter, "GtkTextIter*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 3, markup, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 4, len, "gint");
  gtk_text_buffer_insert_markup(s7_c_pointer(buffer), s7_c_pointer(iter), (const gchar*)s7_string(markup), s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gdk_device_get_vendor_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_vendor_id "gchar* gdk_device_get_vendor_id(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_vendor_id", 1, device, "GdkDevice*");
    return(s7_make_string(sc, (gchar*)gdk_device_get_vendor_id(s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_product_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_product_id "gchar* gdk_device_get_product_id(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_product_id", 1, device, "GdkDevice*");
    return(s7_make_string(sc, (gchar*)gdk_device_get_product_id(s7_c_pointer(device))));
}

static s7_pointer lg_gdk_gl_context_get_shared_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_shared_context "GdkGLContext* gdk_gl_context_get_shared_context(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_shared_context", 1, context, "GdkGLContext*");
  return(s7_make_type_with_c_pointer(sc, GdkGLContext__sym, gdk_gl_context_get_shared_context(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_set_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_required_version "void gdk_gl_context_set_required_version(GdkGLContext* context, \
int major, int minor)"
  s7_pointer _p;
  s7_pointer context, major, minor;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 1, context, "GdkGLContext*");
  major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(major)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 2, major, "int");
  minor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(minor)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 3, minor, "int");
  gdk_gl_context_set_required_version(s7_c_pointer(context), s7_integer(major), s7_integer(minor));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_required_version "void gdk_gl_context_get_required_version(GdkGLContext* context, \
int* [major], int* [minor])"
  s7_pointer _p;
  s7_pointer context;
  int ref_major;
  int ref_minor;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_required_version", 1, context, "GdkGLContext*");
  gdk_gl_context_get_required_version(s7_c_pointer(context), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gdk_gl_context_set_debug_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_debug_enabled "void gdk_gl_context_set_debug_enabled(GdkGLContext* context, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer context, enabled;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_debug_enabled", 1, context, "GdkGLContext*");
  enabled = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_debug_enabled", 2, enabled, "gboolean");
  gdk_gl_context_set_debug_enabled(s7_c_pointer(context), lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_debug_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_debug_enabled "gboolean gdk_gl_context_get_debug_enabled(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_debug_enabled", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_debug_enabled(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_set_forward_compatible(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_forward_compatible "void gdk_gl_context_set_forward_compatible(GdkGLContext* context, \
gboolean compatible)"
  s7_pointer _p;
  s7_pointer context, compatible;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_forward_compatible", 1, context, "GdkGLContext*");
  compatible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(compatible)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_forward_compatible", 2, compatible, "gboolean");
  gdk_gl_context_set_forward_compatible(s7_c_pointer(context), lg_boolean(compatible));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_forward_compatible(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_forward_compatible "gboolean gdk_gl_context_get_forward_compatible(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_forward_compatible", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_forward_compatible(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_realize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_realize "gboolean gdk_gl_context_realize(GdkGLContext* context, GError** [error])"
  s7_pointer _p;
  s7_pointer context;
  GError* ref_error = NULL;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_realize", 1, context, "GdkGLContext*");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gdk_gl_context_realize(s7_c_pointer(context), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_clipboard_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get_default "GtkClipboard* gtk_clipboard_get_default(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_default", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GtkClipboard__sym, gtk_clipboard_get_default(s7_c_pointer(display))));
}

static s7_pointer lg_gtk_drag_cancel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_cancel "void gtk_drag_cancel(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_cancel", 1, context, "GdkDragContext*");
  gtk_drag_cancel(s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_search_entry_handle_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_entry_handle_event "gboolean gtk_search_entry_handle_event(GtkSearchEntry* entry, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer entry, event;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkSearchEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_search_entry_handle_event", 1, entry, "GtkSearchEntry*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_search_entry_handle_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_search_entry_handle_event(s7_c_pointer(entry), s7_c_pointer(event))));
}

static s7_pointer lg_gdk_gl_context_get_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_version "void gdk_gl_context_get_version(GdkGLContext* context, int* [major], \
int* [minor])"
  s7_pointer _p;
  s7_pointer context;
  int ref_major;
  int ref_minor;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_version", 1, context, "GdkGLContext*");
  gdk_gl_context_get_version(s7_c_pointer(context), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gtk_gl_area_set_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_required_version "void gtk_gl_area_set_required_version(GtkGLArea* area, \
gint major, gint minor)"
  s7_pointer _p;
  s7_pointer area, major, minor;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 1, area, "GtkGLArea*");
  major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(major)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 2, major, "gint");
  minor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(minor)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 3, minor, "gint");
  gtk_gl_area_set_required_version(s7_c_pointer(area), s7_integer(major), s7_integer(minor));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_required_version "void gtk_gl_area_get_required_version(GtkGLArea* area, \
gint* [major], gint* [minor])"
  s7_pointer _p;
  s7_pointer area;
  gint ref_major;
  gint ref_minor;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_required_version", 1, area, "GtkGLArea*");
  gtk_gl_area_get_required_version(s7_c_pointer(area), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gtk_notebook_detach_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_detach_tab "void gtk_notebook_detach_tab(GtkNotebook* notebook, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_detach_tab", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_detach_tab", 2, child, "GtkWidget*");
  gtk_notebook_detach_tab(s7_c_pointer(notebook), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_sidebar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_new "GtkWidget* gtk_stack_sidebar_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_stack_sidebar_new()));
}

static s7_pointer lg_gtk_stack_sidebar_set_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_set_stack "void gtk_stack_sidebar_set_stack(GtkStackSidebar* sidebar, GtkStack* stack)"
  s7_pointer _p;
  s7_pointer sidebar, stack;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkStackSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_set_stack", 1, sidebar, "GtkStackSidebar*");
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_set_stack", 2, stack, "GtkStack*");
  gtk_stack_sidebar_set_stack(s7_c_pointer(sidebar), s7_c_pointer(stack));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_sidebar_get_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_get_stack "GtkStack* gtk_stack_sidebar_get_stack(GtkStackSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkStackSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_get_stack", 1, sidebar, "GtkStackSidebar*");
  return(s7_make_type_with_c_pointer(sc, GtkStack__sym, gtk_stack_sidebar_get_stack(s7_c_pointer(sidebar))));
}

#endif

#if GTK_CHECK_VERSION(3, 18, 0)
static s7_pointer lg_gdk_keymap_get_scroll_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_get_scroll_lock_state "gboolean gdk_keymap_get_scroll_lock_state(GdkKeymap* keymap)"
  s7_pointer keymap;
  keymap = s7_car(args);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_get_scroll_lock_state", 1, keymap, "GdkKeymap*");
  return(s7_make_boolean(sc, gdk_keymap_get_scroll_lock_state(s7_c_pointer(keymap))));
}

static s7_pointer lg_gtk_radio_menu_item_join_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_menu_item_join_group "void gtk_radio_menu_item_join_group(GtkRadioMenuItem* radio_menu_item, \
GtkRadioMenuItem* group_source)"
  s7_pointer _p;
  s7_pointer radio_menu_item, group_source;
  _p = args;
  radio_menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_menu_item, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_join_group", 1, radio_menu_item, "GtkRadioMenuItem*");
  group_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group_source, GtkRadioMenuItem__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_menu_item_join_group", 2, group_source, "GtkRadioMenuItem*");
  gtk_radio_menu_item_join_group(s7_c_pointer(radio_menu_item), s7_c_pointer(group_source));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_set_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font_map "void gtk_font_chooser_set_font_map(GtkFontChooser* fontchooser, \
PangoFontMap* fontmap)"
  s7_pointer _p;
  s7_pointer fontchooser, fontmap;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_map", 1, fontchooser, "GtkFontChooser*");
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_map", 2, fontmap, "PangoFontMap*");
  gtk_font_chooser_set_font_map(s7_c_pointer(fontchooser), s7_c_pointer(fontmap));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_map "PangoFontMap* gtk_font_chooser_get_font_map(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_map", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_type_with_c_pointer(sc, PangoFontMap__sym, gtk_font_chooser_get_font_map(s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_popover_set_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_default_widget "void gtk_popover_set_default_widget(GtkPopover* popover, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer popover, widget;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_default_widget", 1, popover, "GtkPopover*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_default_widget", 2, widget, "GtkWidget*");
  gtk_popover_set_default_widget(s7_c_pointer(popover), s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_default_widget "GtkWidget* gtk_popover_get_default_widget(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_default_widget", 1, popover, "GtkPopover*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_popover_get_default_widget(s7_c_pointer(popover))));
}

static s7_pointer lg_gdk_window_set_pass_through(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_set_pass_through "void gdk_window_set_pass_through(GdkWindow* window, gboolean pass_through)"
  s7_pointer _p;
  s7_pointer window, pass_through;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_set_pass_through", 1, window, "GdkWindow*");
  pass_through = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(pass_through)) s7_wrong_type_arg_error(sc, "gdk_window_set_pass_through", 2, pass_through, "gboolean");
  gdk_window_set_pass_through(s7_c_pointer(window), lg_boolean(pass_through));
  return(lg_false);
}

static s7_pointer lg_gdk_window_get_pass_through(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_get_pass_through "gboolean gdk_window_get_pass_through(GdkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_get_pass_through", 1, window, "GdkWindow*");
  return(s7_make_boolean(sc, gdk_window_get_pass_through(s7_c_pointer(window))));
}

static s7_pointer lg_gtk_overlay_reorder_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_reorder_overlay "void gtk_overlay_reorder_overlay(GtkOverlay* overlay, GtkWidget* child, \
gint position)"
  s7_pointer _p;
  s7_pointer overlay, child, position;
  _p = args;
  overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(overlay, GtkOverlay__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_reorder_overlay", 1, overlay, "GtkOverlay*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_reorder_overlay", 2, child, "GtkWidget*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_overlay_reorder_overlay", 3, position, "gint");
  gtk_overlay_reorder_overlay(s7_c_pointer(overlay), s7_c_pointer(child), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_overlay_get_overlay_pass_through(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_get_overlay_pass_through "gboolean gtk_overlay_get_overlay_pass_through(GtkOverlay* overlay, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer overlay, widget;
  _p = args;
  overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(overlay, GtkOverlay__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_get_overlay_pass_through", 1, overlay, "GtkOverlay*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_get_overlay_pass_through", 2, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_overlay_get_overlay_pass_through(s7_c_pointer(overlay), s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_overlay_set_overlay_pass_through(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_set_overlay_pass_through "void gtk_overlay_set_overlay_pass_through(GtkOverlay* overlay, \
GtkWidget* widget, gboolean pass_through)"
  s7_pointer _p;
  s7_pointer overlay, widget, pass_through;
  _p = args;
  overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(overlay, GtkOverlay__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_set_overlay_pass_through", 1, overlay, "GtkOverlay*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_set_overlay_pass_through", 2, widget, "GtkWidget*");
  pass_through = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(pass_through)) s7_wrong_type_arg_error(sc, "gtk_overlay_set_overlay_pass_through", 3, pass_through, "gboolean");
  gtk_overlay_set_overlay_pass_through(s7_c_pointer(overlay), s7_c_pointer(widget), lg_boolean(pass_through));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_show_recent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_show_recent "gboolean gtk_places_sidebar_get_show_recent(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_show_recent", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_show_recent(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_show_recent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_show_recent "void gtk_places_sidebar_set_show_recent(GtkPlacesSidebar* sidebar, \
gboolean show_recent)"
  s7_pointer _p;
  s7_pointer sidebar, show_recent;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_recent", 1, sidebar, "GtkPlacesSidebar*");
  show_recent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_recent)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_recent", 2, show_recent, "gboolean");
  gtk_places_sidebar_set_show_recent(s7_c_pointer(sidebar), lg_boolean(show_recent));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_set_drop_targets_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_drop_targets_visible "void gtk_places_sidebar_set_drop_targets_visible(GtkPlacesSidebar* sidebar, \
gboolean visible, GdkDragContext* context)"
  s7_pointer _p;
  s7_pointer sidebar, visible, context;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_drop_targets_visible", 1, sidebar, "GtkPlacesSidebar*");
  visible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_drop_targets_visible", 2, visible, "gboolean");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_drop_targets_visible", 3, context, "GdkDragContext*");
  gtk_places_sidebar_set_drop_targets_visible(s7_c_pointer(sidebar), lg_boolean(visible), s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_show_trash(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_show_trash "gboolean gtk_places_sidebar_get_show_trash(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_show_trash", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_show_trash(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_places_sidebar_set_show_trash(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_show_trash "void gtk_places_sidebar_set_show_trash(GtkPlacesSidebar* sidebar, \
gboolean show_trash)"
  s7_pointer _p;
  s7_pointer sidebar, show_trash;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_trash", 1, sidebar, "GtkPlacesSidebar*");
  show_trash = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_trash)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_trash", 2, show_trash, "gboolean");
  gtk_places_sidebar_set_show_trash(s7_c_pointer(sidebar), lg_boolean(show_trash));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_set_show_other_locations(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_set_show_other_locations "void gtk_places_sidebar_set_show_other_locations(GtkPlacesSidebar* sidebar, \
gboolean show_other_locations)"
  s7_pointer _p;
  s7_pointer sidebar, show_other_locations;
  _p = args;
  sidebar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_other_locations", 1, sidebar, "GtkPlacesSidebar*");
  show_other_locations = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(show_other_locations)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_set_show_other_locations", 2, show_other_locations, "gboolean");
  gtk_places_sidebar_set_show_other_locations(s7_c_pointer(sidebar), lg_boolean(show_other_locations));
  return(lg_false);
}

static s7_pointer lg_gtk_places_sidebar_get_show_other_locations(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_places_sidebar_get_show_other_locations "gboolean gtk_places_sidebar_get_show_other_locations(GtkPlacesSidebar* sidebar)"
  s7_pointer sidebar;
  sidebar = s7_car(args);
  if (!s7_is_c_pointer_of_type(sidebar, GtkPlacesSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_places_sidebar_get_show_other_locations", 1, sidebar, "GtkPlacesSidebar*");
  return(s7_make_boolean(sc, gtk_places_sidebar_get_show_other_locations(s7_c_pointer(sidebar))));
}

static s7_pointer lg_gtk_stack_set_interpolate_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_interpolate_size "void gtk_stack_set_interpolate_size(GtkStack* stack, gboolean interpolate_size)"
  s7_pointer _p;
  s7_pointer stack, interpolate_size;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_interpolate_size", 1, stack, "GtkStack*");
  interpolate_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(interpolate_size)) s7_wrong_type_arg_error(sc, "gtk_stack_set_interpolate_size", 2, interpolate_size, "gboolean");
  gtk_stack_set_interpolate_size(s7_c_pointer(stack), lg_boolean(interpolate_size));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_interpolate_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_interpolate_size "gboolean gtk_stack_get_interpolate_size(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_interpolate_size", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_interpolate_size(s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_widget_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_font_options "void gtk_widget_set_font_options(GtkWidget* widget, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer widget, options;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_options", 1, widget, "GtkWidget*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_options", 2, options, "cairo_font_options_t*");
  gtk_widget_set_font_options(s7_c_pointer(widget), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_font_options "cairo_font_options_t* gtk_widget_get_font_options(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_font_options", 1, widget, "GtkWidget*");
    return(s7_make_type_with_c_pointer(sc, cairo_font_options_t__sym, (cairo_font_options_t*)gtk_widget_get_font_options(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_font_map "void gtk_widget_set_font_map(GtkWidget* widget, PangoFontMap* fontmap)"
  s7_pointer _p;
  s7_pointer widget, fontmap;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_map", 1, widget, "GtkWidget*");
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_map", 2, fontmap, "PangoFontMap*");
  gtk_widget_set_font_map(s7_c_pointer(widget), s7_c_pointer(fontmap));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_font_map "PangoFontMap* gtk_widget_get_font_map(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_font_map", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, PangoFontMap__sym, gtk_widget_get_font_map(s7_c_pointer(widget))));
}

static s7_pointer lg_gdk_window_fullscreen_on_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_fullscreen_on_monitor "void gdk_window_fullscreen_on_monitor(GdkWindow* window, \
gint monitor)"
  s7_pointer _p;
  s7_pointer window, monitor;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_fullscreen_on_monitor", 1, window, "GdkWindow*");
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(monitor)) s7_wrong_type_arg_error(sc, "gdk_window_fullscreen_on_monitor", 2, monitor, "gint");
  gdk_window_fullscreen_on_monitor(s7_c_pointer(window), s7_integer(monitor));
  return(lg_false);
}

static s7_pointer lg_gtk_window_fullscreen_on_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_fullscreen_on_monitor "void gtk_window_fullscreen_on_monitor(GtkWindow* window, \
GdkScreen* screen, gint monitor)"
  s7_pointer _p;
  s7_pointer window, screen, monitor;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen_on_monitor", 1, window, "GtkWindow*");
  screen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(screen, GdkScreen__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen_on_monitor", 2, screen, "GdkScreen*");
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(monitor)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen_on_monitor", 3, monitor, "gint");
  gtk_window_fullscreen_on_monitor(s7_c_pointer(window), s7_c_pointer(screen), s7_integer(monitor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_top_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_top_margin "void gtk_text_view_set_top_margin(GtkTextView* text_view, gint top_margin)"
  s7_pointer _p;
  s7_pointer text_view, top_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_top_margin", 1, text_view, "GtkTextView*");
  top_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_top_margin", 2, top_margin, "gint");
  gtk_text_view_set_top_margin(s7_c_pointer(text_view), s7_integer(top_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_top_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_top_margin "gint gtk_text_view_get_top_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_top_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_top_margin(s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_bottom_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_bottom_margin "void gtk_text_view_set_bottom_margin(GtkTextView* text_view, \
gint bottom_margin)"
  s7_pointer _p;
  s7_pointer text_view, bottom_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_bottom_margin", 1, text_view, "GtkTextView*");
  bottom_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bottom_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_bottom_margin", 2, bottom_margin, "gint");
  gtk_text_view_set_bottom_margin(s7_c_pointer(text_view), s7_integer(bottom_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_bottom_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_bottom_margin "gint gtk_text_view_get_bottom_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_bottom_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_bottom_margin(s7_c_pointer(text_view))));
}

#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_gdk_gl_context_is_legacy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_is_legacy "gboolean gdk_gl_context_is_legacy(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_is_legacy", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_is_legacy(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_rectangle_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_equal "gboolean gdk_rectangle_equal(GdkRectangle* rect1, GdkRectangle* rect2)"
  s7_pointer _p;
  s7_pointer rect1, rect2;
  _p = args;
  rect1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_equal", 1, rect1, "GdkRectangle*");
  rect2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_equal", 2, rect2, "GdkRectangle*");
  return(s7_make_boolean(sc, gdk_rectangle_equal(s7_c_pointer(rect1), s7_c_pointer(rect2))));
}

static s7_pointer lg_gtk_application_window_set_help_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_set_help_overlay "void gtk_application_window_set_help_overlay(GtkApplicationWindow* window, \
GtkShortcutsWindow* help_overlay)"
  s7_pointer _p;
  s7_pointer window, help_overlay;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_help_overlay", 1, window, "GtkApplicationWindow*");
  help_overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(help_overlay, GtkShortcutsWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_help_overlay", 2, help_overlay, "GtkShortcutsWindow*");
  gtk_application_window_set_help_overlay(s7_c_pointer(window), s7_c_pointer(help_overlay));
  return(lg_false);
}

static s7_pointer lg_gtk_settings_reset_property(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_reset_property "void gtk_settings_reset_property(GtkSettings* settings, gchar* name)"
  s7_pointer _p;
  s7_pointer settings, name;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_settings_reset_property", 1, settings, "GtkSettings*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_settings_reset_property", 2, name, "gchar*");
  gtk_settings_reset_property(s7_c_pointer(settings), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_changed "void gtk_text_tag_changed(GtkTextTag* tag, gboolean size_changed)"
  s7_pointer _p;
  s7_pointer tag, size_changed;
  _p = args;
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_changed", 1, tag, "GtkTextTag*");
  size_changed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(size_changed)) s7_wrong_type_arg_error(sc, "gtk_text_tag_changed", 2, size_changed, "gboolean");
  gtk_text_tag_changed(s7_c_pointer(tag), lg_boolean(size_changed));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_path_iter_get_object_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_path_iter_get_object_name "char* gtk_widget_path_iter_get_object_name(GtkWidgetPath* path, \
gint pos)"
  s7_pointer _p;
  s7_pointer path, pos;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_get_object_name", 1, path, "GtkWidgetPath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_get_object_name", 2, pos, "gint");
    return(s7_make_string(sc, (char*)gtk_widget_path_iter_get_object_name(s7_c_pointer(path), s7_integer(pos))));
}

static s7_pointer lg_gtk_widget_path_iter_set_object_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_path_iter_set_object_name "void gtk_widget_path_iter_set_object_name(GtkWidgetPath* path, \
gint pos, char* name)"
  s7_pointer _p;
  s7_pointer path, pos, name;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_object_name", 1, path, "GtkWidgetPath*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_object_name", 2, pos, "gint");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_path_iter_set_object_name", 3, name, "char*");
  gtk_widget_path_iter_set_object_name(s7_c_pointer(path), s7_integer(pos), (const char*)(char*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_allocate "void gtk_widget_queue_allocate(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_allocate", 1, widget, "GtkWidget*");
  gtk_widget_queue_allocate(s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_focus_on_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_focus_on_click "void gtk_widget_set_focus_on_click(GtkWidget* widget, gboolean focus_on_click)"
  s7_pointer _p;
  s7_pointer widget, focus_on_click;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_on_click", 1, widget, "GtkWidget*");
  focus_on_click = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(focus_on_click)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_on_click", 2, focus_on_click, "gboolean");
  gtk_widget_set_focus_on_click(s7_c_pointer(widget), lg_boolean(focus_on_click));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_focus_on_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_focus_on_click "gboolean gtk_widget_get_focus_on_click(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_focus_on_click", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_focus_on_click(s7_c_pointer(widget))));
}

static s7_pointer lg_gdk_drag_context_get_drag_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_get_drag_window "GdkWindow* gdk_drag_context_get_drag_window(GdkDragContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_get_drag_window", 1, context, "GdkDragContext*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_drag_context_get_drag_window(s7_c_pointer(context))));
}

static s7_pointer lg_gtk_popover_set_constrain_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_constrain_to "void gtk_popover_set_constrain_to(GtkPopover* popover, GtkPopoverConstraint constraint)"
  s7_pointer _p;
  s7_pointer popover, constraint;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_constrain_to", 1, popover, "GtkPopover*");
  constraint = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(constraint)) s7_wrong_type_arg_error(sc, "gtk_popover_set_constrain_to", 2, constraint, "GtkPopoverConstraint");
  gtk_popover_set_constrain_to(s7_c_pointer(popover), s7_integer(constraint));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_constrain_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_constrain_to "GtkPopoverConstraint gtk_popover_get_constrain_to(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_constrain_to", 1, popover, "GtkPopover*");
  return(s7_make_integer(sc, gtk_popover_get_constrain_to(s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_text_iter_starts_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_tag "gboolean gtk_text_iter_starts_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_tag(s7_c_pointer(iter), s7_c_pointer(tag))));
}

static s7_pointer lg_gdk_device_get_seat(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_seat "GdkSeat* gdk_device_get_seat(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_seat", 1, device, "GdkDevice*");
  return(s7_make_type_with_c_pointer(sc, GdkSeat__sym, gdk_device_get_seat(s7_c_pointer(device))));
}

static s7_pointer lg_gdk_display_get_default_seat(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_seat "GdkSeat* gdk_display_get_default_seat(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_seat", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkSeat__sym, gdk_display_get_default_seat(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_list_seats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_list_seats "GList* gdk_display_list_seats(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_list_seats", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_display_list_seats(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_drag_begin_from_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_begin_from_point "GdkDragContext* gdk_drag_begin_from_point(GdkWindow* window, GdkDevice* device, \
GList* targets, gint x_root, gint y_root)"
  s7_pointer _p;
  s7_pointer window, device, targets, x_root, y_root;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin_from_point", 1, window, "GdkWindow*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin_from_point", 2, device, "GdkDevice*");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GList__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin_from_point", 3, targets, "GList*");
  x_root = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_root)) s7_wrong_type_arg_error(sc, "gdk_drag_begin_from_point", 4, x_root, "gint");
  y_root = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y_root)) s7_wrong_type_arg_error(sc, "gdk_drag_begin_from_point", 5, y_root, "gint");
  return(s7_make_type_with_c_pointer(sc, GdkDragContext__sym, gdk_drag_begin_from_point(s7_c_pointer(window), s7_c_pointer(device), s7_c_pointer(targets), s7_integer(x_root), s7_integer(y_root))));
}

static s7_pointer lg_gdk_drag_drop_done(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_drop_done "void gdk_drag_drop_done(GdkDragContext* context, gboolean success)"
  s7_pointer _p;
  s7_pointer context, success;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_drop_done", 1, context, "GdkDragContext*");
  success = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(success)) s7_wrong_type_arg_error(sc, "gdk_drag_drop_done", 2, success, "gboolean");
  gdk_drag_drop_done(s7_c_pointer(context), lg_boolean(success));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_context_set_hotspot(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_set_hotspot "void gdk_drag_context_set_hotspot(GdkDragContext* context, \
gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer context, hot_x, hot_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_set_hotspot", 1, context, "GdkDragContext*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gdk_drag_context_set_hotspot", 2, hot_x, "gint");
  hot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gdk_drag_context_set_hotspot", 3, hot_y, "gint");
  gdk_drag_context_set_hotspot(s7_c_pointer(context), s7_integer(hot_x), s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gdk_seat_grab(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_grab "GdkGrabStatus gdk_seat_grab(GdkSeat* seat, GdkWindow* window, GdkSeatCapabilities capabilities, \
gboolean owner_events, GdkCursor* cursor, GdkEvent* event, GdkSeatGrabPrepareFunc prepare_func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer seat, window, capabilities, owner_events, cursor, event, prepare_func, func_info;
  _p = args;
  seat = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 1, seat, "GdkSeat*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 2, window, "GdkWindow*");
  capabilities = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(capabilities)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 3, capabilities, "GdkSeatCapabilities");
  owner_events = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(owner_events)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 4, owner_events, "gboolean");
  cursor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 5, cursor, "GdkCursor*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 6, event, "GdkEvent*");
  prepare_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(prepare_func, GdkSeatGrabPrepareFunc_sym)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 7, prepare_func, "GdkSeatGrabPrepareFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gdk_seat_grab", 8, func_info, "lambda_data");
  {
    s7_pointer result;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    result = s7_make_integer(sc, gdk_seat_grab(s7_c_pointer(seat), s7_c_pointer(window), s7_integer(capabilities), lg_boolean(owner_events), s7_c_pointer(cursor), s7_c_pointer(event), s7_c_pointer(prepare_func), (gpointer)lg_ptr));
    return(result);
   }
}

static s7_pointer lg_gdk_seat_ungrab(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_ungrab "void gdk_seat_ungrab(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_ungrab", 1, seat, "GdkSeat*");
  gdk_seat_ungrab(s7_c_pointer(seat));
  return(lg_false);
}

static s7_pointer lg_gdk_seat_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_display "GdkDisplay* gdk_seat_get_display(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_display", 1, seat, "GdkSeat*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_seat_get_display(s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_capabilities(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_capabilities "GdkSeatCapabilities gdk_seat_get_capabilities(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_capabilities", 1, seat, "GdkSeat*");
  return(s7_make_integer(sc, gdk_seat_get_capabilities(s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_slaves(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_slaves "GList* gdk_seat_get_slaves(GdkSeat* seat, GdkSeatCapabilities capabilities)"
  s7_pointer _p;
  s7_pointer seat, capabilities;
  _p = args;
  seat = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_slaves", 1, seat, "GdkSeat*");
  capabilities = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(capabilities)) s7_wrong_type_arg_error(sc, "gdk_seat_get_slaves", 2, capabilities, "GdkSeatCapabilities");
  return(s7_make_type_with_c_pointer(sc, GList__sym, gdk_seat_get_slaves(s7_c_pointer(seat), s7_integer(capabilities))));
}

static s7_pointer lg_gdk_seat_get_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_pointer "GdkDevice* gdk_seat_get_pointer(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_pointer", 1, seat, "GdkSeat*");
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gdk_seat_get_pointer(s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_keyboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_keyboard "GdkDevice* gdk_seat_get_keyboard(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_keyboard", 1, seat, "GdkSeat*");
  return(s7_make_type_with_c_pointer(sc, GdkDevice__sym, gdk_seat_get_keyboard(s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_drag_context_manage_dnd(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_context_manage_dnd "gboolean gdk_drag_context_manage_dnd(GdkDragContext* context, \
GdkWindow* ipc_window, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer context, ipc_window, actions;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDragContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_manage_dnd", 1, context, "GdkDragContext*");
  ipc_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ipc_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_context_manage_dnd", 2, ipc_window, "GdkWindow*");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gdk_drag_context_manage_dnd", 3, actions, "GdkDragAction");
  return(s7_make_boolean(sc, gdk_drag_context_manage_dnd(s7_c_pointer(context), s7_c_pointer(ipc_window), s7_integer(actions))));
}

static s7_pointer lg_gdk_event_is_scroll_stop_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_is_scroll_stop_event "gboolean gdk_event_is_scroll_stop_event(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_is_scroll_stop_event", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_event_is_scroll_stop_event(s7_c_pointer(event))));
}

static s7_pointer lg_gtk_text_view_reset_cursor_blink(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_reset_cursor_blink "void gtk_text_view_reset_cursor_blink(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_reset_cursor_blink", 1, text_view, "GtkTextView*");
  gtk_text_view_reset_cursor_blink(s7_c_pointer(text_view));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_gdk_device_get_axes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_axes "GdkAxisFlags gdk_device_get_axes(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_axes", 1, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_device_get_axes(s7_c_pointer(device))));
}

static s7_pointer lg_gdk_event_get_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_device_tool "GdkDeviceTool* gdk_event_get_device_tool(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_device_tool", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GdkDeviceTool__sym, gdk_event_get_device_tool(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_set_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_device_tool "void gdk_event_set_device_tool(GdkEvent* event, GdkDeviceTool* tool)"
  s7_pointer _p;
  s7_pointer event, tool;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device_tool", 1, event, "GdkEvent*");
  tool = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tool, GdkDeviceTool__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device_tool", 2, tool, "GdkDeviceTool*");
  gdk_event_set_device_tool(s7_c_pointer(event), s7_c_pointer(tool));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_scancode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_scancode "int gdk_event_get_scancode(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_scancode", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_event_get_scancode(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_gl_context_set_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_use_es "void gdk_gl_context_set_use_es(GdkGLContext* context, int use_es)"
  s7_pointer _p;
  s7_pointer context, use_es;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_use_es", 1, context, "GdkGLContext*");
  use_es = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(use_es)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_use_es", 2, use_es, "int");
  gdk_gl_context_set_use_es(s7_c_pointer(context), s7_integer(use_es));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_use_es "gboolean gdk_gl_context_get_use_es(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_use_es", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_use_es(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_pango_context_get_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_context_get_for_display "PangoContext* gdk_pango_context_get_for_display(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_context_get_for_display", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, PangoContext__sym, gdk_pango_context_get_for_display(s7_c_pointer(display))));
}

static s7_pointer lg_gtk_clipboard_get_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_clipboard_get_selection "GdkAtom gtk_clipboard_get_selection(GtkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GtkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_clipboard_get_selection", 1, clipboard, "GtkClipboard*");
  return(s7_make_type_with_c_pointer(sc, GdkAtom_sym, gtk_clipboard_get_selection(s7_c_pointer(clipboard))));
}

static s7_pointer lg_gtk_gl_area_set_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_use_es "void gtk_gl_area_set_use_es(GtkGLArea* area, gboolean use_es)"
  s7_pointer _p;
  s7_pointer area, use_es;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_use_es", 1, area, "GtkGLArea*");
  use_es = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_es)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_use_es", 2, use_es, "gboolean");
  gtk_gl_area_set_use_es(s7_c_pointer(area), lg_boolean(use_es));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_use_es "gboolean gtk_gl_area_get_use_es(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_use_es", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_use_es(s7_c_pointer(area))));
}

static s7_pointer lg_gdk_device_tool_get_serial(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_tool_get_serial "guint gdk_device_tool_get_serial(GdkDeviceTool* tool)"
  s7_pointer tool;
  tool = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool, GdkDeviceTool__sym)) s7_wrong_type_arg_error(sc, "gdk_device_tool_get_serial", 1, tool, "GdkDeviceTool*");
  return(s7_make_integer(sc, gdk_device_tool_get_serial(s7_c_pointer(tool))));
}

static s7_pointer lg_gdk_display_get_n_monitors(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_n_monitors "int gdk_display_get_n_monitors(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_n_monitors", 1, display, "GdkDisplay*");
  return(s7_make_integer(sc, gdk_display_get_n_monitors(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_monitor "GdkMonitor* gdk_display_get_monitor(GdkDisplay* display, int monitor_num)"
  s7_pointer _p;
  s7_pointer display, monitor_num;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor", 1, display, "GdkDisplay*");
  monitor_num = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(monitor_num)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor", 2, monitor_num, "int");
  return(s7_make_type_with_c_pointer(sc, GdkMonitor__sym, gdk_display_get_monitor(s7_c_pointer(display), s7_integer(monitor_num))));
}

static s7_pointer lg_gdk_display_get_primary_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_primary_monitor "GdkMonitor* gdk_display_get_primary_monitor(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_primary_monitor", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkMonitor__sym, gdk_display_get_primary_monitor(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_monitor_at_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_monitor_at_point "GdkMonitor* gdk_display_get_monitor_at_point(GdkDisplay* display, \
int x, int y)"
  s7_pointer _p;
  s7_pointer display, x, y;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor_at_point", 1, display, "GdkDisplay*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor_at_point", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor_at_point", 3, y, "int");
  return(s7_make_type_with_c_pointer(sc, GdkMonitor__sym, gdk_display_get_monitor_at_point(s7_c_pointer(display), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gdk_display_get_monitor_at_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_monitor_at_window "GdkMonitor* gdk_display_get_monitor_at_window(GdkDisplay* display, \
GdkWindow* window)"
  s7_pointer _p;
  s7_pointer display, window;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor_at_window", 1, display, "GdkDisplay*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor_at_window", 2, window, "GdkWindow*");
  return(s7_make_type_with_c_pointer(sc, GdkMonitor__sym, gdk_display_get_monitor_at_window(s7_c_pointer(display), s7_c_pointer(window))));
}

static s7_pointer lg_gdk_event_get_pointer_emulated(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_pointer_emulated "gboolean gdk_event_get_pointer_emulated(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_pointer_emulated", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_event_get_pointer_emulated(s7_c_pointer(event))));
}

static s7_pointer lg_gtk_menu_place_on_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_place_on_monitor "void gtk_menu_place_on_monitor(GtkMenu* menu, GdkMonitor* monitor)"
  s7_pointer _p;
  s7_pointer menu, monitor;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_place_on_monitor", 1, menu, "GtkMenu*");
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_place_on_monitor", 2, monitor, "GdkMonitor*");
  gtk_menu_place_on_monitor(s7_c_pointer(menu), s7_c_pointer(monitor));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_display "GdkDisplay* gdk_monitor_get_display(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_display", 1, monitor, "GdkMonitor*");
  return(s7_make_type_with_c_pointer(sc, GdkDisplay__sym, gdk_monitor_get_display(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_geometry(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_geometry "void gdk_monitor_get_geometry(GdkMonitor* monitor, GdkRectangle* geometry)"
  s7_pointer _p;
  s7_pointer monitor, geometry;
  _p = args;
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_geometry", 1, monitor, "GdkMonitor*");
  geometry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(geometry, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_geometry", 2, geometry, "GdkRectangle*");
  gdk_monitor_get_geometry(s7_c_pointer(monitor), s7_c_pointer(geometry));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_workarea(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_workarea "void gdk_monitor_get_workarea(GdkMonitor* monitor, GdkRectangle* workarea)"
  s7_pointer _p;
  s7_pointer monitor, workarea;
  _p = args;
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_workarea", 1, monitor, "GdkMonitor*");
  workarea = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(workarea, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_workarea", 2, workarea, "GdkRectangle*");
  gdk_monitor_get_workarea(s7_c_pointer(monitor), s7_c_pointer(workarea));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_width_mm(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_width_mm "int gdk_monitor_get_width_mm(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_width_mm", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_width_mm(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_height_mm(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_height_mm "int gdk_monitor_get_height_mm(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_height_mm", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_height_mm(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_manufacturer(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_manufacturer "char* gdk_monitor_get_manufacturer(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_manufacturer", 1, monitor, "GdkMonitor*");
  return(s7_make_string(sc, gdk_monitor_get_manufacturer(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_model "char* gdk_monitor_get_model(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_model", 1, monitor, "GdkMonitor*");
  return(s7_make_string(sc, gdk_monitor_get_model(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_scale_factor "int gdk_monitor_get_scale_factor(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_scale_factor", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_scale_factor(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_refresh_rate(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_refresh_rate "int gdk_monitor_get_refresh_rate(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_refresh_rate", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_refresh_rate(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_subpixel_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_subpixel_layout "GdkSubpixelLayout gdk_monitor_get_subpixel_layout(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_subpixel_layout", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_subpixel_layout(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_is_primary(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_is_primary "gboolean gdk_monitor_is_primary(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_is_primary", 1, monitor, "GdkMonitor*");
  return(s7_make_boolean(sc, gdk_monitor_is_primary(s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_drawing_context_get_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drawing_context_get_window "GdkWindow* gdk_drawing_context_get_window(GdkDrawingContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drawing_context_get_window", 1, context, "GdkDrawingContext*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_drawing_context_get_window(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_drawing_context_get_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drawing_context_get_clip "cairo_region_t* gdk_drawing_context_get_clip(GdkDrawingContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drawing_context_get_clip", 1, context, "GdkDrawingContext*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_drawing_context_get_clip(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_drawing_context_is_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drawing_context_is_valid "gboolean gdk_drawing_context_is_valid(GdkDrawingContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drawing_context_is_valid", 1, context, "GdkDrawingContext*");
  return(s7_make_boolean(sc, gdk_drawing_context_is_valid(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_drawing_context_get_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drawing_context_get_cairo_context "cairo_t* gdk_drawing_context_get_cairo_context(GdkDrawingContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drawing_context_get_cairo_context", 1, context, "GdkDrawingContext*");
  return(s7_make_type_with_c_pointer(sc, cairo_t__sym, gdk_drawing_context_get_cairo_context(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_cairo_get_drawing_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_get_drawing_context "GdkDrawingContext* gdk_cairo_get_drawing_context(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_get_drawing_context", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, GdkDrawingContext__sym, gdk_cairo_get_drawing_context(s7_c_pointer(cr))));
}

static s7_pointer lg_gtk_scrolled_window_set_max_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_max_content_width "void gtk_scrolled_window_set_max_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  s7_pointer _p;
  s7_pointer scrolled_window, width;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_width", 2, width, "gint");
  gtk_scrolled_window_set_max_content_width(s7_c_pointer(scrolled_window), s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_max_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_max_content_width "gint gtk_scrolled_window_get_max_content_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_max_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_max_content_width(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_max_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_max_content_height "void gtk_scrolled_window_set_max_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  s7_pointer _p;
  s7_pointer scrolled_window, height;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_height", 2, height, "gint");
  gtk_scrolled_window_set_max_content_height(s7_c_pointer(scrolled_window), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_max_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_max_content_height "gint gtk_scrolled_window_get_max_content_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_max_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_max_content_height(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_file_chooser_add_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_choice "void gtk_file_chooser_add_choice(GtkFileChooser* chooser, char* id, \
char* label, char** options, char** option_labels)"
  s7_pointer _p;
  s7_pointer chooser, id, label, options, option_labels;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 2, id, "char*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 3, label, "char*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, char___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 4, options, "char**");
  option_labels = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(option_labels, char___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 5, option_labels, "char**");
  gtk_file_chooser_add_choice(s7_c_pointer(chooser), (const char*)(char*)s7_string(id), (const char*)(char*)s7_string(label), (const char**)s7_c_pointer(options), (const char**)s7_c_pointer(option_labels));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_remove_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_choice "void gtk_file_chooser_remove_choice(GtkFileChooser* chooser, \
char* id)"
  s7_pointer _p;
  s7_pointer chooser, id;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_choice", 2, id, "char*");
  gtk_file_chooser_remove_choice(s7_c_pointer(chooser), (char*)s7_string(id));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_choice "void gtk_file_chooser_set_choice(GtkFileChooser* chooser, char* id, \
char* option)"
  s7_pointer _p;
  s7_pointer chooser, id, option;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 2, id, "char*");
  option = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(option)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 3, option, "char*");
  gtk_file_chooser_set_choice(s7_c_pointer(chooser), (char*)s7_string(id), (char*)s7_string(option));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_choice "char* gtk_file_chooser_get_choice(GtkFileChooser* chooser, char* id)"
  s7_pointer _p;
  s7_pointer chooser, id;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_choice", 2, id, "char*");
  return(s7_make_string(sc, gtk_file_chooser_get_choice(s7_c_pointer(chooser), (const char*)(char*)s7_string(id))));
}

static s7_pointer lg_gdk_device_pad_get_n_groups(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_n_groups "gint gdk_device_pad_get_n_groups(GdkDevicePad* pad)"
  s7_pointer pad;
  pad = s7_car(args);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_groups", 1, pad, "GdkDevicePad*");
  return(s7_make_integer(sc, gdk_device_pad_get_n_groups(s7_c_pointer(pad))));
}

static s7_pointer lg_gdk_device_pad_get_group_n_modes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_group_n_modes "gint gdk_device_pad_get_group_n_modes(GdkDevicePad* pad, \
gint group_idx)"
  s7_pointer _p;
  s7_pointer pad, group_idx;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_group_n_modes", 1, pad, "GdkDevicePad*");
  group_idx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(group_idx)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_group_n_modes", 2, group_idx, "gint");
  return(s7_make_integer(sc, gdk_device_pad_get_group_n_modes(s7_c_pointer(pad), s7_integer(group_idx))));
}

static s7_pointer lg_gdk_device_pad_get_n_features(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_n_features "gint gdk_device_pad_get_n_features(GdkDevicePad* pad, GdkDevicePadFeature feature)"
  s7_pointer _p;
  s7_pointer pad, feature;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_features", 1, pad, "GdkDevicePad*");
  feature = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(feature)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_features", 2, feature, "GdkDevicePadFeature");
  return(s7_make_integer(sc, gdk_device_pad_get_n_features(s7_c_pointer(pad), s7_integer(feature))));
}

static s7_pointer lg_gdk_device_pad_get_feature_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_feature_group "gint gdk_device_pad_get_feature_group(GdkDevicePad* pad, \
GdkDevicePadFeature feature, gint feature_idx)"
  s7_pointer _p;
  s7_pointer pad, feature, feature_idx;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 1, pad, "GdkDevicePad*");
  feature = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(feature)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 2, feature, "GdkDevicePadFeature");
  feature_idx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(feature_idx)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 3, feature_idx, "gint");
  return(s7_make_integer(sc, gdk_device_pad_get_feature_group(s7_c_pointer(pad), s7_integer(feature), s7_integer(feature_idx))));
}

static s7_pointer lg_gtk_menu_popup_at_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_rect "void gtk_menu_popup_at_rect(GtkMenu* menu, GdkWindow* rect_window, \
GdkRectangle* rect, GdkGravity rect_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, rect_window, rect, rect_anchor, menu_anchor, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 1, menu, "GtkMenu*");
  rect_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect_window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 2, rect_window, "GdkWindow*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 3, rect, "GdkRectangle*");
  rect_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rect_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 4, rect_anchor, "GdkGravity");
  menu_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(menu_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 5, menu_anchor, "GdkGravity");
  trigger_event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 6, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_rect(s7_c_pointer(menu), s7_c_pointer(rect_window), s7_c_pointer(rect), s7_integer(rect_anchor), s7_integer(menu_anchor), s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_popup_at_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_widget "void gtk_menu_popup_at_widget(GtkMenu* menu, GtkWidget* widget, \
GdkGravity widget_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, widget, widget_anchor, menu_anchor, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 1, menu, "GtkMenu*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 2, widget, "GtkWidget*");
  widget_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(widget_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 3, widget_anchor, "GdkGravity");
  menu_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(menu_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 4, menu_anchor, "GdkGravity");
  trigger_event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 5, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_widget(s7_c_pointer(menu), s7_c_pointer(widget), s7_integer(widget_anchor), s7_integer(menu_anchor), s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_popup_at_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_pointer "void gtk_menu_popup_at_pointer(GtkMenu* menu, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_pointer", 1, menu, "GtkMenu*");
  trigger_event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_pointer", 2, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_pointer(s7_c_pointer(menu), s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gtk_pad_controller_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_new "GtkPadController* gtk_pad_controller_new(GtkWindow* window, GActionGroup* group, \
GdkDevice* pad)"
  s7_pointer _p;
  s7_pointer window, group, pad;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_new", 1, window, "GtkWindow*");
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GActionGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_new", 2, group, "GActionGroup*");
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_new", 3, pad, "GdkDevice*");
  return(s7_make_type_with_c_pointer(sc, GtkPadController__sym, gtk_pad_controller_new(s7_c_pointer(window), s7_c_pointer(group), s7_c_pointer(pad))));
}

static s7_pointer lg_gtk_pad_controller_set_action_entries(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_set_action_entries "void gtk_pad_controller_set_action_entries(GtkPadController* controller, \
GtkPadActionEntry* entries, gint n_entries)"
  s7_pointer _p;
  s7_pointer controller, entries, n_entries;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkPadController__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 1, controller, "GtkPadController*");
  entries = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entries, GtkPadActionEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 2, entries, "GtkPadActionEntry*");
  n_entries = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_entries)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 3, n_entries, "gint");
  gtk_pad_controller_set_action_entries(s7_c_pointer(controller), s7_c_pointer(entries), s7_integer(n_entries));
  return(lg_false);
}

static s7_pointer lg_gtk_pad_controller_set_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_set_action "void gtk_pad_controller_set_action(GtkPadController* controller, \
GtkPadActionType type, gint index, gint mode, gchar* label, gchar* action_name)"
  s7_pointer _p;
  s7_pointer controller, type, index, mode, label, action_name;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkPadController__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 1, controller, "GtkPadController*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 2, type, "GtkPadActionType");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 3, index, "gint");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 4, mode, "gint");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 5, label, "gchar*");
  action_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action_name)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 6, action_name, "gchar*");
  gtk_pad_controller_set_action(s7_c_pointer(controller), s7_integer(type), s7_integer(index), s7_integer(mode), (const gchar*)s7_string(label), (const gchar*)s7_string(action_name));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_popup "void gtk_popover_popup(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_popup", 1, popover, "GtkPopover*");
  gtk_popover_popup(s7_c_pointer(popover));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_popdown "void gtk_popover_popdown(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_popdown", 1, popover, "GtkPopover*");
  gtk_popover_popdown(s7_c_pointer(popover));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_new "GtkWidget* gtk_shortcut_label_new(gchar* accelerator)"
  s7_pointer accelerator;
  accelerator = s7_car(args);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_new", 1, accelerator, "gchar*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_shortcut_label_new((const gchar*)s7_string(accelerator))));
}

static s7_pointer lg_gtk_shortcut_label_get_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_get_accelerator "gchar* gtk_shortcut_label_get_accelerator(GtkShortcutLabel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_get_accelerator", 1, self, "GtkShortcutLabel*");
    return(s7_make_string(sc, (gchar*)gtk_shortcut_label_get_accelerator(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_label_set_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_set_accelerator "void gtk_shortcut_label_set_accelerator(GtkShortcutLabel* self, \
gchar* accelerator)"
  s7_pointer _p;
  s7_pointer self, accelerator;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_accelerator", 1, self, "GtkShortcutLabel*");
  accelerator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_accelerator", 2, accelerator, "gchar*");
  gtk_shortcut_label_set_accelerator(s7_c_pointer(self), (const gchar*)s7_string(accelerator));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_label_get_disabled_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_get_disabled_text "gchar* gtk_shortcut_label_get_disabled_text(GtkShortcutLabel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_get_disabled_text", 1, self, "GtkShortcutLabel*");
    return(s7_make_string(sc, (gchar*)gtk_shortcut_label_get_disabled_text(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_label_set_disabled_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_set_disabled_text "void gtk_shortcut_label_set_disabled_text(GtkShortcutLabel* self, \
gchar* disabled_text)"
  s7_pointer _p;
  s7_pointer self, disabled_text;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_disabled_text", 1, self, "GtkShortcutLabel*");
  disabled_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(disabled_text)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_disabled_text", 2, disabled_text, "gchar*");
  gtk_shortcut_label_set_disabled_text(s7_c_pointer(self), (const gchar*)s7_string(disabled_text));
  return(lg_false);
}

static s7_pointer lg_gdk_window_end_draw_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_end_draw_frame "void gdk_window_end_draw_frame(GdkWindow* window, GdkDrawingContext* context)"
  s7_pointer _p;
  s7_pointer window, context;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_end_draw_frame", 1, window, "GdkWindow*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_window_end_draw_frame", 2, context, "GdkDrawingContext*");
  gdk_window_end_draw_frame(s7_c_pointer(window), s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_set_propagate_natural_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_propagate_natural_width "void gtk_scrolled_window_set_propagate_natural_width(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  s7_pointer _p;
  s7_pointer scrolled_window, propagate;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_width", 1, scrolled_window, "GtkScrolledWindow*");
  propagate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(propagate)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_width", 2, propagate, "gboolean");
  gtk_scrolled_window_set_propagate_natural_width(s7_c_pointer(scrolled_window), lg_boolean(propagate));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_propagate_natural_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_propagate_natural_width "gboolean gtk_scrolled_window_get_propagate_natural_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_propagate_natural_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_propagate_natural_width(s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_propagate_natural_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_propagate_natural_height "void gtk_scrolled_window_set_propagate_natural_height(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  s7_pointer _p;
  s7_pointer scrolled_window, propagate;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_height", 1, scrolled_window, "GtkScrolledWindow*");
  propagate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(propagate)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_height", 2, propagate, "gboolean");
  gtk_scrolled_window_set_propagate_natural_height(s7_c_pointer(scrolled_window), lg_boolean(propagate));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_propagate_natural_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_propagate_natural_height "gboolean gtk_scrolled_window_get_propagate_natural_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_propagate_natural_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_propagate_natural_height(s7_c_pointer(scrolled_window))));
}

#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static s7_pointer lg_gdk_display_is_composited(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_composited "gboolean gdk_display_is_composited(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_composited", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_composited(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_is_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_rgba "gboolean gdk_display_is_rgba(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_rgba", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_rgba(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_window_new_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_new_toplevel "GdkWindow* gdk_window_new_toplevel(GdkDisplay* display, gint event_mask, \
int width, int height)"
  s7_pointer _p;
  s7_pointer display, event_mask, width, height;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_toplevel", 1, display, "GdkDisplay*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_new_toplevel", 2, event_mask, "gint");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_window_new_toplevel", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_window_new_toplevel", 4, height, "int");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_new_toplevel(s7_c_pointer(display), s7_integer(event_mask), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_gdk_window_new_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_new_popup "GdkWindow* gdk_window_new_popup(GdkDisplay* display, gint event_mask, \
GdkRectangle* position)"
  s7_pointer _p;
  s7_pointer display, event_mask, position;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_popup", 1, display, "GdkDisplay*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_new_popup", 2, event_mask, "gint");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(position, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_popup", 3, position, "GdkRectangle*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_new_popup(s7_c_pointer(display), s7_integer(event_mask), s7_c_pointer(position))));
}

static s7_pointer lg_gdk_window_new_temp(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_new_temp "GdkWindow* gdk_window_new_temp(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_temp", 1, display, "GdkDisplay*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_new_temp(s7_c_pointer(display))));
}

static s7_pointer lg_gdk_window_new_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_new_child "GdkWindow* gdk_window_new_child(GdkWindow* parent, gint event_mask, \
GdkRectangle* position)"
  s7_pointer _p;
  s7_pointer parent, event_mask, position;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_child", 1, parent, "GdkWindow*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_new_child", 2, event_mask, "gint");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(position, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_child", 3, position, "GdkRectangle*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_new_child(s7_c_pointer(parent), s7_integer(event_mask), s7_c_pointer(position))));
}

static s7_pointer lg_gdk_window_new_input(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_new_input "GdkWindow* gdk_window_new_input(GdkWindow* parent, gint event_mask, \
GdkRectangle* position)"
  s7_pointer _p;
  s7_pointer parent, event_mask, position;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_input", 1, parent, "GdkWindow*");
  event_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(event_mask)) s7_wrong_type_arg_error(sc, "gdk_window_new_input", 2, event_mask, "gint");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(position, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_window_new_input", 3, position, "GdkRectangle*");
  return(s7_make_type_with_c_pointer(sc, GdkWindow__sym, gdk_window_new_input(s7_c_pointer(parent), s7_integer(event_mask), s7_c_pointer(position))));
}

static s7_pointer lg_gtk_button_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_icon_name "void gtk_button_set_icon_name(GtkButton* button, char* icon_name)"
  s7_pointer _p;
  s7_pointer button, icon_name;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_icon_name", 1, button, "GtkButton*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_button_set_icon_name", 2, icon_name, "char*");
  gtk_button_set_icon_name(s7_c_pointer(button), (char*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_icon_name "char* gtk_button_get_icon_name(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_icon_name", 1, button, "GtkButton*");
  return(s7_make_string(sc, gtk_button_get_icon_name(s7_c_pointer(button))));
}

static s7_pointer lg_gtk_drawing_area_set_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_content_width "void gtk_drawing_area_set_content_width(GtkDrawingArea* self, \
int width)"
  s7_pointer _p;
  s7_pointer self, width;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_width", 1, self, "GtkDrawingArea*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_width", 2, width, "int");
  gtk_drawing_area_set_content_width(s7_c_pointer(self), s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_drawing_area_get_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_get_content_width "int gtk_drawing_area_get_content_width(GtkDrawingArea* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_get_content_width", 1, self, "GtkDrawingArea*");
  return(s7_make_integer(sc, gtk_drawing_area_get_content_width(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drawing_area_set_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_content_height "void gtk_drawing_area_set_content_height(GtkDrawingArea* self, \
int height)"
  s7_pointer _p;
  s7_pointer self, height;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_height", 1, self, "GtkDrawingArea*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_height", 2, height, "int");
  gtk_drawing_area_set_content_height(s7_c_pointer(self), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_drawing_area_get_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_get_content_height "int gtk_drawing_area_get_content_height(GtkDrawingArea* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_get_content_height", 1, self, "GtkDrawingArea*");
  return(s7_make_integer(sc, gtk_drawing_area_get_content_height(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drawing_area_set_draw_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_draw_func "void gtk_drawing_area_set_draw_func(GtkDrawingArea* self, \
GtkDrawingAreaDrawFunc draw_func, lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer self, draw_func, func_info, destroy;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_draw_func", 1, self, "GtkDrawingArea*");
  draw_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(draw_func, GtkDrawingAreaDrawFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_draw_func", 2, draw_func, "GtkDrawingAreaDrawFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(func_info, lambda_data_sym)) && (func_info != lg_false)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_draw_func", 3, func_info, "lambda_data");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, GDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_draw_func", 4, destroy, "GDestroyNotify");
  gtk_drawing_area_set_draw_func(s7_c_pointer(self), s7_c_pointer(draw_func), (gpointer)lg_ptr, s7_c_pointer(destroy));
  return(lg_false);
}

static s7_pointer lg_gdk_drawing_context_get_paint_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drawing_context_get_paint_context "GdkDrawContext* gdk_drawing_context_get_paint_context(GdkDrawingContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkDrawingContext__sym)) s7_wrong_type_arg_error(sc, "gdk_drawing_context_get_paint_context", 1, context, "GdkDrawingContext*");
  return(s7_make_type_with_c_pointer(sc, GdkDrawContext__sym, gdk_drawing_context_get_paint_context(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_get_damage(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_damage "cairo_region_t* gdk_gl_context_get_damage(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_damage", 1, context, "GdkGLContext*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, gdk_gl_context_get_damage(s7_c_pointer(context))));
}

static s7_pointer lg_gdk_rgba_is_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_is_clear "gboolean gdk_rgba_is_clear(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_is_clear", 1, rgba, "GdkRGBA*");
  return(s7_make_boolean(sc, gdk_rgba_is_clear(s7_c_pointer(rgba))));
}

static s7_pointer lg_gdk_rgba_is_opaque(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_is_opaque "gboolean gdk_rgba_is_opaque(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_is_opaque", 1, rgba, "GdkRGBA*");
  return(s7_make_boolean(sc, gdk_rgba_is_opaque(s7_c_pointer(rgba))));
}

static s7_pointer lg_gdk_window_begin_draw_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_window_begin_draw_frame "GdkDrawingContext* gdk_window_begin_draw_frame(GdkWindow* window, \
GdkDrawContext* context, cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer window, context, region;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GdkWindow__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_draw_frame", 1, window, "GdkWindow*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkDrawContext__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_draw_frame", 2, context, "GdkDrawContext*");
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_window_begin_draw_frame", 3, region, "cairo_region_t*");
  return(s7_make_type_with_c_pointer(sc, GdkDrawingContext__sym, gdk_window_begin_draw_frame(s7_c_pointer(window), s7_c_pointer(context), s7_c_pointer(region))));
}

static s7_pointer lg_gtk_flow_box_get_child_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_child_at_pos "GtkFlowBoxChild* gtk_flow_box_get_child_at_pos(GtkFlowBox* box, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer box, x, y;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 1, box, "GtkFlowBox*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 2, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 3, y, "gint");
  return(s7_make_type_with_c_pointer(sc, GtkFlowBoxChild__sym, gtk_flow_box_get_child_at_pos(s7_c_pointer(box), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_about_dialog_get_system_information(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_system_information "gchar* gtk_about_dialog_get_system_information(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_system_information", 1, about, "GtkAboutDialog*");
    return(s7_make_string(sc, (gchar*)gtk_about_dialog_get_system_information(s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_system_information(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_system_information "void gtk_about_dialog_set_system_information(GtkAboutDialog* about, \
gchar* system_information)"
  s7_pointer _p;
  s7_pointer about, system_information;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_system_information", 1, about, "GtkAboutDialog*");
  system_information = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(system_information)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_system_information", 2, system_information, "gchar*");
  gtk_about_dialog_set_system_information(s7_c_pointer(about), (const gchar*)s7_string(system_information));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_set_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_set_revealed "void gtk_action_bar_set_revealed(GtkActionBar* action_bar, gboolean revealed)"
  s7_pointer _p;
  s7_pointer action_bar, revealed;
  _p = args;
  action_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(action_bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_revealed", 1, action_bar, "GtkActionBar*");
  revealed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(revealed)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_revealed", 2, revealed, "gboolean");
  gtk_action_bar_set_revealed(s7_c_pointer(action_bar), lg_boolean(revealed));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_get_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_get_revealed "gboolean gtk_action_bar_get_revealed(GtkActionBar* action_bar)"
  s7_pointer action_bar;
  action_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(action_bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_get_revealed", 1, action_bar, "GtkActionBar*");
  return(s7_make_boolean(sc, gtk_action_bar_get_revealed(s7_c_pointer(action_bar))));
}

static s7_pointer lg_gtk_check_button_set_draw_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_set_draw_indicator "void gtk_check_button_set_draw_indicator(GtkCheckButton* check_button, \
gboolean draw_indicator)"
  s7_pointer _p;
  s7_pointer check_button, draw_indicator;
  _p = args;
  check_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_draw_indicator", 1, check_button, "GtkCheckButton*");
  draw_indicator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(draw_indicator)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_draw_indicator", 2, draw_indicator, "gboolean");
  gtk_check_button_set_draw_indicator(s7_c_pointer(check_button), lg_boolean(draw_indicator));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_get_draw_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_get_draw_indicator "gboolean gtk_check_button_get_draw_indicator(GtkCheckButton* check_button)"
  s7_pointer check_button;
  check_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_get_draw_indicator", 1, check_button, "GtkCheckButton*");
  return(s7_make_boolean(sc, gtk_check_button_get_draw_indicator(s7_c_pointer(check_button))));
}

static s7_pointer lg_gtk_check_button_set_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_set_inconsistent "void gtk_check_button_set_inconsistent(GtkCheckButton* check_button, \
gboolean inconsistent)"
  s7_pointer _p;
  s7_pointer check_button, inconsistent;
  _p = args;
  check_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_inconsistent", 1, check_button, "GtkCheckButton*");
  inconsistent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(inconsistent)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_inconsistent", 2, inconsistent, "gboolean");
  gtk_check_button_set_inconsistent(s7_c_pointer(check_button), lg_boolean(inconsistent));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_get_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_get_inconsistent "gboolean gtk_check_button_get_inconsistent(GtkCheckButton* check_button)"
  s7_pointer check_button;
  check_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_get_inconsistent", 1, check_button, "GtkCheckButton*");
  return(s7_make_boolean(sc, gtk_check_button_get_inconsistent(s7_c_pointer(check_button))));
}

static s7_pointer lg_gtk_info_bar_set_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_revealed "void gtk_info_bar_set_revealed(GtkInfoBar* info_bar, gboolean revealed)"
  s7_pointer _p;
  s7_pointer info_bar, revealed;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_revealed", 1, info_bar, "GtkInfoBar*");
  revealed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(revealed)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_revealed", 2, revealed, "gboolean");
  gtk_info_bar_set_revealed(s7_c_pointer(info_bar), lg_boolean(revealed));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_revealed "gboolean gtk_info_bar_get_revealed(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_revealed", 1, info_bar, "GtkInfoBar*");
  return(s7_make_boolean(sc, gtk_info_bar_get_revealed(s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_widget_get_first_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_first_child "GtkWidget* gtk_widget_get_first_child(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_first_child", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_first_child(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_last_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_last_child "GtkWidget* gtk_widget_get_last_child(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_last_child", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_last_child(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_next_sibling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_next_sibling "GtkWidget* gtk_widget_get_next_sibling(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_next_sibling", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_next_sibling(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_prev_sibling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_prev_sibling "GtkWidget* gtk_widget_get_prev_sibling(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_prev_sibling", 1, widget, "GtkWidget*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_widget_get_prev_sibling(s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_focus_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_focus_child "void gtk_widget_set_focus_child(GtkWidget* widget, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer widget, child;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_child", 1, widget, "GtkWidget*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_child", 2, child, "GtkWidget*");
  gtk_widget_set_focus_child(s7_c_pointer(widget), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_show_uri_on_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_show_uri_on_window "gboolean gtk_show_uri_on_window(GtkWindow* parent, char* uri, guint32 timestamp, \
GError** [error])"
  s7_pointer _p;
  s7_pointer parent, uri, timestamp;
  GError* ref_error = NULL;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_show_uri_on_window", 1, parent, "GtkWindow*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_show_uri_on_window", 2, uri, "char*");
  timestamp = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_show_uri_on_window", 3, timestamp, "guint32");
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_show_uri_on_window(s7_c_pointer(parent), (const char*)(char*)s7_string(uri), s7_integer(timestamp), &ref_error));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_box_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_pack_start "void gtk_box_pack_start(GtkBox* box, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_pack_start", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_pack_start", 2, child, "GtkWidget*");
  gtk_box_pack_start(s7_c_pointer(box), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_box_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_pack_end "void gtk_box_pack_end(GtkBox* box, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_pack_end", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_pack_end", 2, child, "GtkWidget*");
  gtk_box_pack_end(s7_c_pointer(box), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_insert_after "void gtk_widget_insert_after(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* previous_sibling)"
  s7_pointer _p;
  s7_pointer widget, parent, previous_sibling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 1, widget, "GtkWidget*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 2, parent, "GtkWidget*");
  previous_sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(previous_sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 3, previous_sibling, "GtkWidget*");
  gtk_widget_insert_after(s7_c_pointer(widget), s7_c_pointer(parent), s7_c_pointer(previous_sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_insert_before "void gtk_widget_insert_before(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* next_sibling)"
  s7_pointer _p;
  s7_pointer widget, parent, next_sibling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 1, widget, "GtkWidget*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 2, parent, "GtkWidget*");
  next_sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(next_sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 3, next_sibling, "GtkWidget*");
  gtk_widget_insert_before(s7_c_pointer(widget), s7_c_pointer(parent), s7_c_pointer(next_sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_new "GtkWidget* gtk_center_box_new( void)"
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_center_box_new()));
}

static s7_pointer lg_gtk_center_box_set_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_start_widget "void gtk_center_box_set_start_widget(GtkCenterBox* self, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_start_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_start_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_start_widget(s7_c_pointer(self), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_set_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_center_widget "void gtk_center_box_set_center_widget(GtkCenterBox* self, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_center_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_center_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_center_widget(s7_c_pointer(self), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_set_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_end_widget "void gtk_center_box_set_end_widget(GtkCenterBox* self, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_end_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_end_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_end_widget(s7_c_pointer(self), s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_get_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_start_widget "GtkWidget* gtk_center_box_get_start_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_start_widget", 1, self, "GtkCenterBox*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_center_box_get_start_widget(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_get_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_center_widget "GtkWidget* gtk_center_box_get_center_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_center_widget", 1, self, "GtkCenterBox*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_center_box_get_center_widget(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_get_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_end_widget "GtkWidget* gtk_center_box_get_end_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_end_widget", 1, self, "GtkCenterBox*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_center_box_get_end_widget(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_baseline_position "void gtk_center_box_set_baseline_position(GtkCenterBox* self, \
GtkBaselinePosition position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_baseline_position", 1, self, "GtkCenterBox*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_baseline_position", 2, position, "GtkBaselinePosition");
  gtk_center_box_set_baseline_position(s7_c_pointer(self), s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_baseline_position "GtkBaselinePosition gtk_center_box_get_baseline_position(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_baseline_position", 1, self, "GtkCenterBox*");
  return(s7_make_integer(sc, gtk_center_box_get_baseline_position(s7_c_pointer(self))));
}

static s7_pointer lg_gdk_event_set_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_coords "void gdk_event_set_coords(GdkEvent* event, gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer event, x, y;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 1, event, "GdkEvent*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 3, y, "gdouble");
  gdk_event_set_coords(s7_c_pointer(event), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_gdk_event_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_user_data "void gdk_event_set_user_data(GdkEvent* event, GObject* user_data)"
  s7_pointer _p;
  s7_pointer event, user_data;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_user_data", 1, event, "GdkEvent*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, GObject__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_user_data", 2, user_data, "GObject*");
  gdk_event_set_user_data(s7_c_pointer(event), s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_user_data "GObject* gdk_event_get_user_data(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_user_data", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GObject__sym, gdk_event_get_user_data(s7_c_pointer(event))));
}

static s7_pointer lg_gdk_rectangle_contains_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_contains_point "gboolean gdk_rectangle_contains_point(GdkRectangle* rect, int x, \
int y)"
  s7_pointer _p;
  s7_pointer rect, x, y;
  _p = args;
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 1, rect, "GdkRectangle*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 3, y, "int");
  return(s7_make_boolean(sc, gdk_rectangle_contains_point(s7_c_pointer(rect), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_gtk_get_event_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_event_target "GtkWidget* gtk_get_event_target(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_get_event_target", 1, event, "GdkEvent*");
  return(s7_make_type_with_c_pointer(sc, GtkWidget__sym, gtk_get_event_target(s7_c_pointer(event))));
}

static s7_pointer lg_gtk_accel_label_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_label "void gtk_accel_label_set_label(GtkAccelLabel* accel_label, char* text)"
  s7_pointer _p;
  s7_pointer accel_label, text;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_label", 1, accel_label, "GtkAccelLabel*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_label", 2, text, "char*");
  gtk_accel_label_set_label(s7_c_pointer(accel_label), (const char*)(char*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_label "char* gtk_accel_label_get_label(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_label", 1, accel_label, "GtkAccelLabel*");
    return(s7_make_string(sc, (char*)gtk_accel_label_get_label(s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_label_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_use_underline "void gtk_accel_label_set_use_underline(GtkAccelLabel* accel_label, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer accel_label, setting;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_use_underline", 1, accel_label, "GtkAccelLabel*");
  setting = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_use_underline", 2, setting, "gboolean");
  gtk_accel_label_set_use_underline(s7_c_pointer(accel_label), lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_use_underline "gboolean gtk_accel_label_get_use_underline(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_use_underline", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_boolean(sc, gtk_accel_label_get_use_underline(s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_scrollbar_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_set_adjustment "void gtk_scrollbar_set_adjustment(GtkScrollbar* self, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer self, adjustment;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkScrollbar__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_set_adjustment", 1, self, "GtkScrollbar*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_scrollbar_set_adjustment(s7_c_pointer(self), s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollbar_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_get_adjustment "GtkAdjustment* gtk_scrollbar_get_adjustment(GtkScrollbar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkScrollbar__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_get_adjustment", 1, self, "GtkScrollbar*");
  return(s7_make_type_with_c_pointer(sc, GtkAdjustment__sym, gtk_scrollbar_get_adjustment(s7_c_pointer(self))));
}

static s7_pointer lg_gtk_scrollbar_get_wheel_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_get_wheel_delta "double gtk_scrollbar_get_wheel_delta(GtkScrollbar* self, GdkEventScroll* event)"
  s7_pointer _p;
  s7_pointer self, event;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkScrollbar__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_get_wheel_delta", 1, self, "GtkScrollbar*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventScroll__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_get_wheel_delta", 2, event, "GdkEventScroll*");
  return(s7_make_real(sc, gtk_scrollbar_get_wheel_delta(s7_c_pointer(self), s7_c_pointer(event))));
}

static s7_pointer lg_gtk_spin_button_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_text "char* gtk_spin_button_get_text(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_text", 1, spin_button, "GtkSpinButton*");
    return(s7_make_string(sc, (char*)gtk_spin_button_get_text(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_text "void gtk_spin_button_set_text(GtkSpinButton* spin_button, char* text)"
  s7_pointer _p;
  s7_pointer spin_button, text;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_text", 1, spin_button, "GtkSpinButton*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_text", 2, text, "char*");
  gtk_spin_button_set_text(s7_c_pointer(spin_button), (const char*)(char*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_max_width_chars "int gtk_spin_button_get_max_width_chars(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_max_width_chars", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_max_width_chars(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_max_width_chars "void gtk_spin_button_set_max_width_chars(GtkSpinButton* spin_button, \
int max_width_chars)"
  s7_pointer _p;
  s7_pointer spin_button, max_width_chars;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_max_width_chars", 1, spin_button, "GtkSpinButton*");
  max_width_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_width_chars)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_max_width_chars", 2, max_width_chars, "int");
  gtk_spin_button_set_max_width_chars(s7_c_pointer(spin_button), s7_integer(max_width_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_width_chars "int gtk_spin_button_get_width_chars(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_width_chars", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_width_chars(s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_width_chars "void gtk_spin_button_set_width_chars(GtkSpinButton* spin_button, \
int width_chars;)"
  s7_pointer _p;
  s7_pointer spin_button, width_chars;;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_width_chars", 1, spin_button, "GtkSpinButton*");
  width_chars; = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width_chars;)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_width_chars", 2, width_chars;, "int");
  gtk_spin_button_set_width_chars(s7_c_pointer(spin_button), s7_integer(width_chars;));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_size_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_size_allocate "void gtk_widget_size_allocate(GtkWidget* widget, GtkAllocation* allocation, \
int baseline, GtkAllocation* out_clip)"
  s7_pointer _p;
  s7_pointer widget, allocation, baseline, out_clip;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 1, widget, "GtkWidget*");
  allocation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(allocation, GtkAllocation__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 2, allocation, "GtkAllocation*");
  baseline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(baseline)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 3, baseline, "int");
  out_clip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(out_clip, GtkAllocation__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 4, out_clip, "GtkAllocation*");
  gtk_widget_size_allocate(s7_c_pointer(widget), s7_c_pointer(allocation), s7_integer(baseline), s7_c_pointer(out_clip));
  return(lg_false);
}

#endif

static s7_pointer lg_cairo_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_create "cairo_t* cairo_create(cairo_surface_t* target)"
  s7_pointer target;
  target = s7_car(args);
  if (!s7_is_c_pointer_of_type(target, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_create", 1, target, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_t__sym, cairo_create(s7_c_pointer(target))));
}

static s7_pointer lg_cairo_version(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_version "int cairo_version( void)"
  return(s7_make_integer(sc, cairo_version()));
}

static s7_pointer lg_cairo_version_string(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_version_string "char* cairo_version_string( void)"
  return(s7_make_string(sc, cairo_version_string()));
}

static s7_pointer lg_cairo_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_reference "cairo_t* cairo_reference(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_reference", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_t__sym, cairo_reference(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_destroy "void cairo_destroy(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_destroy", 1, cr, "cairo_t*");
  cairo_destroy(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_save(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_save "void cairo_save(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_save", 1, cr, "cairo_t*");
  cairo_save(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_restore(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_restore "void cairo_restore(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_restore", 1, cr, "cairo_t*");
  cairo_restore(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_push_group(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_push_group "void cairo_push_group(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_push_group", 1, cr, "cairo_t*");
  cairo_push_group(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_push_group_with_content(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_push_group_with_content "void cairo_push_group_with_content(cairo_t* cr, cairo_content_t content)"
  s7_pointer _p;
  s7_pointer cr, content;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_push_group_with_content", 1, cr, "cairo_t*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_push_group_with_content", 2, content, "cairo_content_t");
  cairo_push_group_with_content(s7_c_pointer(cr), s7_integer(content));
  return(lg_false);
}

static s7_pointer lg_cairo_pop_group(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pop_group "cairo_pattern_t* cairo_pop_group(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pop_group", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pop_group(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_pop_group_to_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pop_group_to_source "void cairo_pop_group_to_source(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pop_group_to_source", 1, cr, "cairo_t*");
  cairo_pop_group_to_source(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_set_operator(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_operator "void cairo_set_operator(cairo_t* cr, cairo_operator_t op)"
  s7_pointer _p;
  s7_pointer cr, op;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_operator", 1, cr, "cairo_t*");
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(op)) s7_wrong_type_arg_error(sc, "cairo_set_operator", 2, op, "cairo_operator_t");
  cairo_set_operator(s7_c_pointer(cr), s7_integer(op));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source "void cairo_set_source(cairo_t* cr, cairo_pattern_t* source)"
  s7_pointer _p;
  s7_pointer cr, source;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source", 1, cr, "cairo_t*");
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(source, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source", 2, source, "cairo_pattern_t*");
  cairo_set_source(s7_c_pointer(cr), s7_c_pointer(source));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_rgb "void cairo_set_source_rgb(cairo_t* cr, double red, double green, double blue)"
  s7_pointer _p;
  s7_pointer cr, red, green, blue;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 1, cr, "cairo_t*");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 2, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 3, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 4, blue, "double");
  cairo_set_source_rgb(s7_c_pointer(cr), s7_real(red), s7_real(green), s7_real(blue));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_rgba "void cairo_set_source_rgba(cairo_t* cr, double red, double green, \
double blue, double alpha)"
  s7_pointer _p;
  s7_pointer cr, red, green, blue, alpha;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 1, cr, "cairo_t*");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 2, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 3, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 4, blue, "double");
  alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 5, alpha, "double");
  cairo_set_source_rgba(s7_c_pointer(cr), s7_real(red), s7_real(green), s7_real(blue), s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_surface "void cairo_set_source_surface(cairo_t* cr, cairo_surface_t* surface, \
double x, double y)"
  s7_pointer _p;
  s7_pointer cr, surface, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 1, cr, "cairo_t*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 2, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 3, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 4, y, "double");
  cairo_set_source_surface(s7_c_pointer(cr), s7_c_pointer(surface), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_set_tolerance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_tolerance "void cairo_set_tolerance(cairo_t* cr, double tolerance)"
  s7_pointer _p;
  s7_pointer cr, tolerance;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_tolerance", 1, cr, "cairo_t*");
  tolerance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tolerance)) s7_wrong_type_arg_error(sc, "cairo_set_tolerance", 2, tolerance, "double");
  cairo_set_tolerance(s7_c_pointer(cr), s7_real(tolerance));
  return(lg_false);
}

static s7_pointer lg_cairo_set_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_antialias "void cairo_set_antialias(cairo_t* cr, cairo_antialias_t antialias)"
  s7_pointer _p;
  s7_pointer cr, antialias;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_antialias", 1, cr, "cairo_t*");
  antialias = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(antialias)) s7_wrong_type_arg_error(sc, "cairo_set_antialias", 2, antialias, "cairo_antialias_t");
  cairo_set_antialias(s7_c_pointer(cr), s7_integer(antialias));
  return(lg_false);
}

static s7_pointer lg_cairo_set_fill_rule(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_fill_rule "void cairo_set_fill_rule(cairo_t* cr, cairo_fill_rule_t fill_rule)"
  s7_pointer _p;
  s7_pointer cr, fill_rule;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_fill_rule", 1, cr, "cairo_t*");
  fill_rule = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(fill_rule)) s7_wrong_type_arg_error(sc, "cairo_set_fill_rule", 2, fill_rule, "cairo_fill_rule_t");
  cairo_set_fill_rule(s7_c_pointer(cr), s7_integer(fill_rule));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_width "void cairo_set_line_width(cairo_t* cr, double width)"
  s7_pointer _p;
  s7_pointer cr, width;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_width", 1, cr, "cairo_t*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_set_line_width", 2, width, "double");
  cairo_set_line_width(s7_c_pointer(cr), s7_real(width));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_cap(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_cap "void cairo_set_line_cap(cairo_t* cr, cairo_line_cap_t line_cap)"
  s7_pointer _p;
  s7_pointer cr, line_cap;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_cap", 1, cr, "cairo_t*");
  line_cap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_cap)) s7_wrong_type_arg_error(sc, "cairo_set_line_cap", 2, line_cap, "cairo_line_cap_t");
  cairo_set_line_cap(s7_c_pointer(cr), s7_integer(line_cap));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_join(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_join "void cairo_set_line_join(cairo_t* cr, cairo_line_join_t line_join)"
  s7_pointer _p;
  s7_pointer cr, line_join;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_join", 1, cr, "cairo_t*");
  line_join = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_join)) s7_wrong_type_arg_error(sc, "cairo_set_line_join", 2, line_join, "cairo_line_join_t");
  cairo_set_line_join(s7_c_pointer(cr), s7_integer(line_join));
  return(lg_false);
}

static s7_pointer lg_cairo_set_dash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_dash "void cairo_set_dash(cairo_t* cr, gdouble* dashes, int num_dashes, double offset)"
  s7_pointer _p;
  s7_pointer cr, dashes, num_dashes, offset;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 1, cr, "cairo_t*");
  dashes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dashes, gdouble__sym)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 2, dashes, "gdouble*");
  num_dashes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_dashes)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 3, num_dashes, "int");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 4, offset, "double");
  cairo_set_dash(s7_c_pointer(cr), s7_c_pointer(dashes), s7_integer(num_dashes), s7_real(offset));
  return(lg_false);
}

static s7_pointer lg_cairo_set_miter_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_miter_limit "void cairo_set_miter_limit(cairo_t* cr, double limit)"
  s7_pointer _p;
  s7_pointer cr, limit;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_miter_limit", 1, cr, "cairo_t*");
  limit = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(limit)) s7_wrong_type_arg_error(sc, "cairo_set_miter_limit", 2, limit, "double");
  cairo_set_miter_limit(s7_c_pointer(cr), s7_real(limit));
  return(lg_false);
}

static s7_pointer lg_cairo_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_translate "void cairo_translate(cairo_t* cr, double tx, double ty)"
  s7_pointer _p;
  s7_pointer cr, tx, ty;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_translate", 1, cr, "cairo_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_translate", 2, tx, "double");
  ty = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_translate", 3, ty, "double");
  cairo_translate(s7_c_pointer(cr), s7_real(tx), s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scale "void cairo_scale(cairo_t* cr, double sx, double sy)"
  s7_pointer _p;
  s7_pointer cr, sx, sy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scale", 1, cr, "cairo_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_scale", 2, sx, "double");
  sy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_scale", 3, sy, "double");
  cairo_scale(s7_c_pointer(cr), s7_real(sx), s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rotate "void cairo_rotate(cairo_t* cr, double angle)"
  s7_pointer _p;
  s7_pointer cr, angle;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rotate", 1, cr, "cairo_t*");
  angle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle)) s7_wrong_type_arg_error(sc, "cairo_rotate", 2, angle, "double");
  cairo_rotate(s7_c_pointer(cr), s7_real(angle));
  return(lg_false);
}

static s7_pointer lg_cairo_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_transform "void cairo_transform(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_transform", 1, cr, "cairo_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_transform", 2, matrix, "cairo_matrix_t*");
  cairo_transform(s7_c_pointer(cr), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_matrix "void cairo_set_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_set_matrix(s7_c_pointer(cr), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_identity_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_identity_matrix "void cairo_identity_matrix(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_identity_matrix", 1, cr, "cairo_t*");
  cairo_identity_matrix(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_user_to_device(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_to_device "void cairo_user_to_device(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_user_to_device", 1, cr, "cairo_t*");
  cairo_user_to_device(s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_user_to_device_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_to_device_distance "void cairo_user_to_device_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_user_to_device_distance", 1, cr, "cairo_t*");
  cairo_user_to_device_distance(s7_c_pointer(cr), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_device_to_user(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_to_user "void cairo_device_to_user(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_to_user", 1, cr, "cairo_t*");
  cairo_device_to_user(s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_device_to_user_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_to_user_distance "void cairo_device_to_user_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_to_user_distance", 1, cr, "cairo_t*");
  cairo_device_to_user_distance(s7_c_pointer(cr), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_new_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_new_path "void cairo_new_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_new_path", 1, cr, "cairo_t*");
  cairo_new_path(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_move_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_move_to "void cairo_move_to(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_move_to", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_move_to", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_move_to", 3, y, "double");
  cairo_move_to(s7_c_pointer(cr), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_new_sub_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_new_sub_path "void cairo_new_sub_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_new_sub_path", 1, cr, "cairo_t*");
  cairo_new_sub_path(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_line_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_line_to "void cairo_line_to(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_line_to", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_line_to", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_line_to", 3, y, "double");
  cairo_line_to(s7_c_pointer(cr), s7_real(x), s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_curve_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_curve_to "void cairo_curve_to(cairo_t* cr, double x1, double y1, double x2, double y2, \
double x3, double y3)"
  s7_pointer _p;
  s7_pointer cr, x1, y1, x2, y2, x3, y3;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 1, cr, "cairo_t*");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 2, x1, "double");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 3, y1, "double");
  x2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x2)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 4, x2, "double");
  y2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y2)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 5, y2, "double");
  x3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x3)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 6, x3, "double");
  y3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y3)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 7, y3, "double");
  cairo_curve_to(s7_c_pointer(cr), s7_real(x1), s7_real(y1), s7_real(x2), s7_real(y2), s7_real(x3), s7_real(y3));
  return(lg_false);
}

static s7_pointer lg_cairo_arc(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_arc "void cairo_arc(cairo_t* cr, double xc, double yc, double radius, double angle1, \
double angle2)"
  s7_pointer _p;
  s7_pointer cr, xc, yc, radius, angle1, angle2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_arc", 1, cr, "cairo_t*");
  xc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xc)) s7_wrong_type_arg_error(sc, "cairo_arc", 2, xc, "double");
  yc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yc)) s7_wrong_type_arg_error(sc, "cairo_arc", 3, yc, "double");
  radius = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius)) s7_wrong_type_arg_error(sc, "cairo_arc", 4, radius, "double");
  angle1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle1)) s7_wrong_type_arg_error(sc, "cairo_arc", 5, angle1, "double");
  angle2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle2)) s7_wrong_type_arg_error(sc, "cairo_arc", 6, angle2, "double");
  cairo_arc(s7_c_pointer(cr), s7_real(xc), s7_real(yc), s7_real(radius), s7_real(angle1), s7_real(angle2));
  return(lg_false);
}

static s7_pointer lg_cairo_arc_negative(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_arc_negative "void cairo_arc_negative(cairo_t* cr, double xc, double yc, double radius, \
double angle1, double angle2)"
  s7_pointer _p;
  s7_pointer cr, xc, yc, radius, angle1, angle2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 1, cr, "cairo_t*");
  xc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xc)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 2, xc, "double");
  yc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yc)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 3, yc, "double");
  radius = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 4, radius, "double");
  angle1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle1)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 5, angle1, "double");
  angle2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle2)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 6, angle2, "double");
  cairo_arc_negative(s7_c_pointer(cr), s7_real(xc), s7_real(yc), s7_real(radius), s7_real(angle1), s7_real(angle2));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_move_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_move_to "void cairo_rel_move_to(cairo_t* cr, double dx, double dy)"
  s7_pointer _p;
  s7_pointer cr, dx, dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 1, cr, "cairo_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 2, dx, "double");
  dy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 3, dy, "double");
  cairo_rel_move_to(s7_c_pointer(cr), s7_real(dx), s7_real(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_line_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_line_to "void cairo_rel_line_to(cairo_t* cr, double dx, double dy)"
  s7_pointer _p;
  s7_pointer cr, dx, dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 1, cr, "cairo_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 2, dx, "double");
  dy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 3, dy, "double");
  cairo_rel_line_to(s7_c_pointer(cr), s7_real(dx), s7_real(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_curve_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_curve_to "void cairo_rel_curve_to(cairo_t* cr, double dx1, double dy1, double dx2, \
double dy2, double dx3, double dy3)"
  s7_pointer _p;
  s7_pointer cr, dx1, dy1, dx2, dy2, dx3, dy3;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 1, cr, "cairo_t*");
  dx1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx1)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 2, dx1, "double");
  dy1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy1)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 3, dy1, "double");
  dx2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx2)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 4, dx2, "double");
  dy2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy2)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 5, dy2, "double");
  dx3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx3)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 6, dx3, "double");
  dy3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy3)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 7, dy3, "double");
  cairo_rel_curve_to(s7_c_pointer(cr), s7_real(dx1), s7_real(dy1), s7_real(dx2), s7_real(dy2), s7_real(dx3), s7_real(dy3));
  return(lg_false);
}

static s7_pointer lg_cairo_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rectangle "void cairo_rectangle(cairo_t* cr, double x, double y, double width, double height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 3, y, "double");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 4, width, "double");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 5, height, "double");
  cairo_rectangle(s7_c_pointer(cr), s7_real(x), s7_real(y), s7_real(width), s7_real(height));
  return(lg_false);
}

static s7_pointer lg_cairo_close_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_close_path "void cairo_close_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_close_path", 1, cr, "cairo_t*");
  cairo_close_path(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_paint(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_paint "void cairo_paint(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_paint", 1, cr, "cairo_t*");
  cairo_paint(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_paint_with_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_paint_with_alpha "void cairo_paint_with_alpha(cairo_t* cr, double alpha)"
  s7_pointer _p;
  s7_pointer cr, alpha;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_paint_with_alpha", 1, cr, "cairo_t*");
  alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_paint_with_alpha", 2, alpha, "double");
  cairo_paint_with_alpha(s7_c_pointer(cr), s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_mask "void cairo_mask(cairo_t* cr, cairo_pattern_t* pattern)"
  s7_pointer _p;
  s7_pointer cr, pattern;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask", 1, cr, "cairo_t*");
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask", 2, pattern, "cairo_pattern_t*");
  cairo_mask(s7_c_pointer(cr), s7_c_pointer(pattern));
  return(lg_false);
}

static s7_pointer lg_cairo_mask_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_mask_surface "void cairo_mask_surface(cairo_t* cr, cairo_surface_t* surface, double surface_x, \
double surface_y)"
  s7_pointer _p;
  s7_pointer cr, surface, surface_x, surface_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 1, cr, "cairo_t*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 2, surface, "cairo_surface_t*");
  surface_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(surface_x)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 3, surface_x, "double");
  surface_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(surface_y)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 4, surface_y, "double");
  cairo_mask_surface(s7_c_pointer(cr), s7_c_pointer(surface), s7_real(surface_x), s7_real(surface_y));
  return(lg_false);
}

static s7_pointer lg_cairo_stroke(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_stroke "void cairo_stroke(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_stroke", 1, cr, "cairo_t*");
  cairo_stroke(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_stroke_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_stroke_preserve "void cairo_stroke_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_stroke_preserve", 1, cr, "cairo_t*");
  cairo_stroke_preserve(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_fill "void cairo_fill(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_fill", 1, cr, "cairo_t*");
  cairo_fill(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_fill_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_fill_preserve "void cairo_fill_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_fill_preserve", 1, cr, "cairo_t*");
  cairo_fill_preserve(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_copy_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_page "void cairo_copy_page(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_page", 1, cr, "cairo_t*");
  cairo_copy_page(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_show_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_page "void cairo_show_page(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_page", 1, cr, "cairo_t*");
  cairo_show_page(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_in_stroke(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_stroke "bool cairo_in_stroke(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 3, y, "double");
  return(s7_make_boolean(sc, cairo_in_stroke(s7_c_pointer(cr), s7_real(x), s7_real(y))));
}

static s7_pointer lg_cairo_in_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_fill "bool cairo_in_fill(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 3, y, "double");
  return(s7_make_boolean(sc, cairo_in_fill(s7_c_pointer(cr), s7_real(x), s7_real(y))));
}

static s7_pointer lg_cairo_reset_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_reset_clip "void cairo_reset_clip(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_reset_clip", 1, cr, "cairo_t*");
  cairo_reset_clip(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip "void cairo_clip(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip", 1, cr, "cairo_t*");
  cairo_clip(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_clip_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip_preserve "void cairo_clip_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip_preserve", 1, cr, "cairo_t*");
  cairo_clip_preserve(s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_create "cairo_font_options_t* cairo_font_options_create( void)"
  return(s7_make_type_with_c_pointer(sc, cairo_font_options_t__sym, cairo_font_options_create()));
}

static s7_pointer lg_cairo_font_options_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_copy "cairo_font_options_t* cairo_font_options_copy(cairo_font_options_t* original)"
  s7_pointer original;
  original = s7_car(args);
  if (!s7_is_c_pointer_of_type(original, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_copy", 1, original, "cairo_font_options_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_font_options_t__sym, cairo_font_options_copy(s7_c_pointer(original))));
}

static s7_pointer lg_cairo_font_options_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_destroy "void cairo_font_options_destroy(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_destroy", 1, options, "cairo_font_options_t*");
  cairo_font_options_destroy(s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_status "cairo_status_t cairo_font_options_status(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_status", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_status(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_merge(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_merge "void cairo_font_options_merge(cairo_font_options_t* options, cairo_font_options_t* other)"
  s7_pointer _p;
  s7_pointer options, other;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_merge", 1, options, "cairo_font_options_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_merge", 2, other, "cairo_font_options_t*");
  cairo_font_options_merge(s7_c_pointer(options), s7_c_pointer(other));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_equal "bool cairo_font_options_equal(cairo_font_options_t* options, cairo_font_options_t* other)"
  s7_pointer _p;
  s7_pointer options, other;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_equal", 1, options, "cairo_font_options_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_equal", 2, other, "cairo_font_options_t*");
  return(s7_make_boolean(sc, cairo_font_options_equal(s7_c_pointer(options), s7_c_pointer(other))));
}

static s7_pointer lg_cairo_font_options_hash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_hash "gulong cairo_font_options_hash(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_hash", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_hash(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_antialias "void cairo_font_options_set_antialias(cairo_font_options_t* options, \
cairo_antialias_t antialias)"
  s7_pointer _p;
  s7_pointer options, antialias;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_antialias", 1, options, "cairo_font_options_t*");
  antialias = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(antialias)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_antialias", 2, antialias, "cairo_antialias_t");
  cairo_font_options_set_antialias(s7_c_pointer(options), s7_integer(antialias));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_antialias "cairo_antialias_t cairo_font_options_get_antialias(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_antialias", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_antialias(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_subpixel_order(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_subpixel_order "void cairo_font_options_set_subpixel_order(cairo_font_options_t* options, \
cairo_subpixel_order_t subpixel_order)"
  s7_pointer _p;
  s7_pointer options, subpixel_order;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_subpixel_order", 1, options, "cairo_font_options_t*");
  subpixel_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(subpixel_order)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_subpixel_order", 2, subpixel_order, "cairo_subpixel_order_t");
  cairo_font_options_set_subpixel_order(s7_c_pointer(options), s7_integer(subpixel_order));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_subpixel_order(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_subpixel_order "cairo_subpixel_order_t cairo_font_options_get_subpixel_order(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_subpixel_order", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_subpixel_order(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_hint_style(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_hint_style "void cairo_font_options_set_hint_style(cairo_font_options_t* options, \
cairo_hint_style_t hint_style)"
  s7_pointer _p;
  s7_pointer options, hint_style;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_style", 1, options, "cairo_font_options_t*");
  hint_style = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hint_style)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_style", 2, hint_style, "cairo_hint_style_t");
  cairo_font_options_set_hint_style(s7_c_pointer(options), s7_integer(hint_style));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_hint_style(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_hint_style "cairo_hint_style_t cairo_font_options_get_hint_style(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_hint_style", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_hint_style(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_hint_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_hint_metrics "void cairo_font_options_set_hint_metrics(cairo_font_options_t* options, \
cairo_hint_metrics_t hint_metrics)"
  s7_pointer _p;
  s7_pointer options, hint_metrics;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_metrics", 1, options, "cairo_font_options_t*");
  hint_metrics = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hint_metrics)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_metrics", 2, hint_metrics, "cairo_hint_metrics_t");
  cairo_font_options_set_hint_metrics(s7_c_pointer(options), s7_integer(hint_metrics));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_hint_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_hint_metrics "cairo_hint_metrics_t cairo_font_options_get_hint_metrics(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_hint_metrics", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_hint_metrics(s7_c_pointer(options))));
}

static s7_pointer lg_cairo_select_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_select_font_face "void cairo_select_font_face(cairo_t* cr, char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  s7_pointer _p;
  s7_pointer cr, family, slant, weight;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 1, cr, "cairo_t*");
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 2, family, "char*");
  slant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(slant)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 3, slant, "cairo_font_slant_t");
  weight = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 4, weight, "cairo_font_weight_t");
  cairo_select_font_face(s7_c_pointer(cr), (char*)s7_string(family), s7_integer(slant), s7_integer(weight));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_size(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_size "void cairo_set_font_size(cairo_t* cr, double size)"
  s7_pointer _p;
  s7_pointer cr, size;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_size", 1, cr, "cairo_t*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "cairo_set_font_size", 2, size, "double");
  cairo_set_font_size(s7_c_pointer(cr), s7_real(size));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_matrix "void cairo_set_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_set_font_matrix(s7_c_pointer(cr), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_matrix "void cairo_get_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_get_font_matrix(s7_c_pointer(cr), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_options "void cairo_set_font_options(cairo_t* cr, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer cr, options;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_options", 1, cr, "cairo_t*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_options", 2, options, "cairo_font_options_t*");
  cairo_set_font_options(s7_c_pointer(cr), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_options "void cairo_get_font_options(cairo_t* cr, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer cr, options;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_options", 1, cr, "cairo_t*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_get_font_options(s7_c_pointer(cr), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_set_scaled_font(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_scaled_font "void cairo_set_scaled_font(cairo_t* cr, cairo_scaled_font_t* scaled_font)"
  s7_pointer _p;
  s7_pointer cr, scaled_font;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_scaled_font", 1, cr, "cairo_t*");
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_scaled_font", 2, scaled_font, "cairo_scaled_font_t*");
  cairo_set_scaled_font(s7_c_pointer(cr), s7_c_pointer(scaled_font));
  return(lg_false);
}

static s7_pointer lg_cairo_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_text "void cairo_show_text(cairo_t* cr, char* utf8)"
  s7_pointer _p;
  s7_pointer cr, utf8;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_show_text", 2, utf8, "char*");
  cairo_show_text(s7_c_pointer(cr), (char*)s7_string(utf8));
  return(lg_false);
}

static s7_pointer lg_cairo_show_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_glyphs "void cairo_show_glyphs(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 3, num_glyphs, "int");
  cairo_show_glyphs(s7_c_pointer(cr), s7_c_pointer(glyphs), s7_integer(num_glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_face "cairo_font_face_t* cairo_get_font_face(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_face", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_font_face_t__sym, cairo_get_font_face(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_font_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_extents "void cairo_font_extents(cairo_t* cr, cairo_font_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_extents", 1, cr, "cairo_t*");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_font_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_extents", 2, extents, "cairo_font_extents_t*");
  cairo_font_extents(s7_c_pointer(cr), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_face "void cairo_set_font_face(cairo_t* cr, cairo_font_face_t* font_face)"
  s7_pointer _p;
  s7_pointer cr, font_face;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_face", 1, cr, "cairo_t*");
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_face", 2, font_face, "cairo_font_face_t*");
  cairo_set_font_face(s7_c_pointer(cr), s7_c_pointer(font_face));
  return(lg_false);
}

static s7_pointer lg_cairo_text_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_extents "void cairo_text_extents(cairo_t* cr, char* utf8, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, utf8, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 2, utf8, "char*");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 3, extents, "cairo_text_extents_t*");
  cairo_text_extents(s7_c_pointer(cr), (char*)s7_string(utf8), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_extents "void cairo_glyph_extents(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs, \
cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 3, num_glyphs, "int");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 4, extents, "cairo_text_extents_t*");
  cairo_glyph_extents(s7_c_pointer(cr), s7_c_pointer(glyphs), s7_integer(num_glyphs), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_text_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_path "void cairo_text_path(cairo_t* cr, char* utf8)"
  s7_pointer _p;
  s7_pointer cr, utf8;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_path", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_text_path", 2, utf8, "char*");
  cairo_text_path(s7_c_pointer(cr), (char*)s7_string(utf8));
  return(lg_false);
}

static s7_pointer lg_cairo_glyph_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_path "void cairo_glyph_path(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 3, num_glyphs, "int");
  cairo_glyph_path(s7_c_pointer(cr), s7_c_pointer(glyphs), s7_integer(num_glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_reference "cairo_font_face_t* cairo_font_face_reference(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_reference", 1, font_face, "cairo_font_face_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_font_face_t__sym, cairo_font_face_reference(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_font_face_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_destroy "void cairo_font_face_destroy(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_destroy", 1, font_face, "cairo_font_face_t*");
  cairo_font_face_destroy(s7_c_pointer(font_face));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_status "cairo_status_t cairo_font_face_status(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_status", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_font_face_status(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_font_face_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_get_user_data "gpointer cairo_font_face_get_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer font_face, key;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_user_data", 1, font_face, "cairo_font_face_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, cairo_font_face_get_user_data(s7_c_pointer(font_face), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_font_face_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_set_user_data "cairo_status_t cairo_font_face_set_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key, gpointer user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer font_face, key, user_data, destroy;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 1, font_face, "cairo_font_face_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 3, user_data, "gpointer");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_font_face_set_user_data(s7_c_pointer(font_face), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_scaled_font_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_create "cairo_scaled_font_t* cairo_scaled_font_create(cairo_font_face_t* font_face, \
cairo_matrix_t* font_matrix, cairo_matrix_t* ctm, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer font_face, font_matrix, ctm, options;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 1, font_face, "cairo_font_face_t*");
  font_matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 2, font_matrix, "cairo_matrix_t*");
  ctm = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ctm, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 3, ctm, "cairo_matrix_t*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 4, options, "cairo_font_options_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_scaled_font_t__sym, cairo_scaled_font_create(s7_c_pointer(font_face), s7_c_pointer(font_matrix), s7_c_pointer(ctm), s7_c_pointer(options))));
}

static s7_pointer lg_cairo_scaled_font_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_reference "cairo_scaled_font_t* cairo_scaled_font_reference(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_reference", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_scaled_font_t__sym, cairo_scaled_font_reference(s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_destroy "void cairo_scaled_font_destroy(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_destroy", 1, scaled_font, "cairo_scaled_font_t*");
  cairo_scaled_font_destroy(s7_c_pointer(scaled_font));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_status "cairo_status_t cairo_scaled_font_status(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_status", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_integer(sc, cairo_scaled_font_status(s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_extents "void cairo_scaled_font_extents(cairo_scaled_font_t* scaled_font, \
cairo_font_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_extents", 1, scaled_font, "cairo_scaled_font_t*");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_font_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_extents", 2, extents, "cairo_font_extents_t*");
  cairo_scaled_font_extents(s7_c_pointer(scaled_font), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_text_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_text_extents "void cairo_scaled_font_text_extents(cairo_scaled_font_t* scaled_font, \
char* utf8, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, utf8, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 1, scaled_font, "cairo_scaled_font_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 2, utf8, "char*");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 3, extents, "cairo_text_extents_t*");
  cairo_scaled_font_text_extents(s7_c_pointer(scaled_font), (char*)s7_string(utf8), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_glyph_extents "void cairo_scaled_font_glyph_extents(cairo_scaled_font_t* scaled_font, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, glyphs, num_glyphs, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 1, scaled_font, "cairo_scaled_font_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 3, num_glyphs, "int");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 4, extents, "cairo_text_extents_t*");
  cairo_scaled_font_glyph_extents(s7_c_pointer(scaled_font), s7_c_pointer(glyphs), s7_integer(num_glyphs), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_face "cairo_font_face_t* cairo_scaled_font_get_font_face(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_face", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_font_face_t__sym, cairo_scaled_font_get_font_face(s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_get_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_matrix "void cairo_scaled_font_get_font_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* font_matrix)"
  s7_pointer _p;
  s7_pointer scaled_font, font_matrix;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_matrix", 1, scaled_font, "cairo_scaled_font_t*");
  font_matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_matrix", 2, font_matrix, "cairo_matrix_t*");
  cairo_scaled_font_get_font_matrix(s7_c_pointer(scaled_font), s7_c_pointer(font_matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_ctm(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_ctm "void cairo_scaled_font_get_ctm(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* ctm)"
  s7_pointer _p;
  s7_pointer scaled_font, ctm;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_ctm", 1, scaled_font, "cairo_scaled_font_t*");
  ctm = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ctm, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_ctm", 2, ctm, "cairo_matrix_t*");
  cairo_scaled_font_get_ctm(s7_c_pointer(scaled_font), s7_c_pointer(ctm));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_options "void cairo_scaled_font_get_font_options(cairo_scaled_font_t* scaled_font, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer scaled_font, options;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_options", 1, scaled_font, "cairo_scaled_font_t*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_scaled_font_get_font_options(s7_c_pointer(scaled_font), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_get_operator(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_operator "cairo_operator_t cairo_get_operator(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_operator", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_operator(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_source "cairo_pattern_t* cairo_get_source(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_source", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_get_source(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_tolerance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_tolerance "gdouble cairo_get_tolerance(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_tolerance", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_tolerance(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_antialias "cairo_antialias_t cairo_get_antialias(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_antialias", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_antialias(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_current_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_current_point "void cairo_get_current_point(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_current_point", 1, cr, "cairo_t*");
  cairo_get_current_point(s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_get_fill_rule(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_fill_rule "cairo_fill_rule_t cairo_get_fill_rule(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_fill_rule", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_fill_rule(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_width "gdouble cairo_get_line_width(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_width", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_line_width(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_cap(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_cap "cairo_line_cap_t cairo_get_line_cap(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_cap", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_line_cap(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_join(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_join "cairo_line_join_t cairo_get_line_join(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_join", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_line_join(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_miter_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_miter_limit "gdouble cairo_get_miter_limit(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_miter_limit", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_miter_limit(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_matrix "void cairo_get_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_get_matrix(s7_c_pointer(cr), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_get_target(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_target "cairo_surface_t* cairo_get_target(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_target", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_get_target(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_group_target(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_group_target "cairo_surface_t* cairo_get_group_target(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_group_target", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_get_group_target(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_copy_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_path "cairo_path_t* cairo_copy_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_path", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_path_t__sym, cairo_copy_path(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_copy_path_flat(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_path_flat "cairo_path_t* cairo_copy_path_flat(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_path_flat", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_path_t__sym, cairo_copy_path_flat(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_append_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_append_path "void cairo_append_path(cairo_t* cr, cairo_path_t* path)"
  s7_pointer _p;
  s7_pointer cr, path;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_append_path", 1, cr, "cairo_t*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, cairo_path_t__sym)) s7_wrong_type_arg_error(sc, "cairo_append_path", 2, path, "cairo_path_t*");
  cairo_append_path(s7_c_pointer(cr), s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_cairo_path_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_path_destroy "void cairo_path_destroy(cairo_path_t* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, cairo_path_t__sym)) s7_wrong_type_arg_error(sc, "cairo_path_destroy", 1, path, "cairo_path_t*");
  cairo_path_destroy(s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_cairo_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_status "cairo_status_t cairo_status(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_status", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_status(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_status_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_status_to_string "char* cairo_status_to_string(cairo_status_t status)"
  s7_pointer status;
  status = s7_car(args);
  if (!s7_is_integer(status)) s7_wrong_type_arg_error(sc, "cairo_status_to_string", 1, status, "cairo_status_t");
  return(s7_make_string(sc, cairo_status_to_string(s7_integer(status))));
}

static s7_pointer lg_cairo_surface_create_similar(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_create_similar "cairo_surface_t* cairo_surface_create_similar(cairo_surface_t* other, \
cairo_content_t content, int width, int height)"
  s7_pointer _p;
  s7_pointer other, content, width, height;
  _p = args;
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 1, other, "cairo_surface_t*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 2, content, "cairo_content_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 4, height, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_surface_create_similar(s7_c_pointer(other), s7_integer(content), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_cairo_surface_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_reference "cairo_surface_t* cairo_surface_reference(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_reference", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_surface_reference(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_finish "void cairo_surface_finish(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_finish", 1, surface, "cairo_surface_t*");
  cairo_surface_finish(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_destroy "void cairo_surface_destroy(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_destroy", 1, surface, "cairo_surface_t*");
  cairo_surface_destroy(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_status "cairo_status_t cairo_surface_status(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_status", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_status(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_get_content(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_content "cairo_content_t cairo_surface_get_content(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_content", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_get_content(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_user_data "gpointer cairo_surface_get_user_data(cairo_surface_t* surface, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer surface, key;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_user_data", 1, surface, "cairo_surface_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, gpointer_sym, cairo_surface_get_user_data(s7_c_pointer(surface), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_surface_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_user_data "cairo_status_t cairo_surface_set_user_data(cairo_surface_t* surface, \
cairo_user_data_key_t* key, gpointer user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer surface, key, user_data, destroy;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_user_data", 1, surface, "cairo_surface_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_user_data", 3, user_data, "gpointer");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_surface_set_user_data(s7_c_pointer(surface), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_surface_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_font_options "void cairo_surface_get_font_options(cairo_surface_t* surface, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer surface, options;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_font_options", 1, surface, "cairo_surface_t*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_surface_get_font_options(s7_c_pointer(surface), s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_flush "void cairo_surface_flush(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_flush", 1, surface, "cairo_surface_t*");
  cairo_surface_flush(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_mark_dirty(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_mark_dirty "void cairo_surface_mark_dirty(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty", 1, surface, "cairo_surface_t*");
  cairo_surface_mark_dirty(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_mark_dirty_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_mark_dirty_rectangle "void cairo_surface_mark_dirty_rectangle(cairo_surface_t* surface, \
int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer surface, x, y, width, height;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 1, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 3, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 5, height, "int");
  cairo_surface_mark_dirty_rectangle(s7_c_pointer(surface), s7_integer(x), s7_integer(y), s7_integer(width), s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_set_device_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_device_offset "void cairo_surface_set_device_offset(cairo_surface_t* surface, \
double x_offset, double y_offset)"
  s7_pointer _p;
  s7_pointer surface, x_offset, y_offset;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 1, surface, "cairo_surface_t*");
  x_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x_offset)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 2, x_offset, "double");
  y_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y_offset)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 3, y_offset, "double");
  cairo_surface_set_device_offset(s7_c_pointer(surface), s7_real(x_offset), s7_real(y_offset));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_get_device_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_device_offset "void cairo_surface_get_device_offset(cairo_surface_t* surface, \
gdouble* [x_offset], gdouble* [y_offset])"
  s7_pointer _p;
  s7_pointer surface;
  gdouble ref_x_offset;
  gdouble ref_y_offset;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_device_offset", 1, surface, "cairo_surface_t*");
  cairo_surface_get_device_offset(s7_c_pointer(surface), &ref_x_offset, &ref_y_offset);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x_offset), s7_make_real(sc, ref_y_offset)));
}

static s7_pointer lg_cairo_surface_set_fallback_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_fallback_resolution "void cairo_surface_set_fallback_resolution(cairo_surface_t* surface, \
double x_pixels_per_inch, double y_pixels_per_inch)"
  s7_pointer _p;
  s7_pointer surface, x_pixels_per_inch, y_pixels_per_inch;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 1, surface, "cairo_surface_t*");
  x_pixels_per_inch = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x_pixels_per_inch)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 2, x_pixels_per_inch, "double");
  y_pixels_per_inch = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y_pixels_per_inch)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 3, y_pixels_per_inch, "double");
  cairo_surface_set_fallback_resolution(s7_c_pointer(surface), s7_real(x_pixels_per_inch), s7_real(y_pixels_per_inch));
  return(lg_false);
}

static s7_pointer lg_cairo_image_surface_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create "cairo_surface_t* cairo_image_surface_create(cairo_format_t format, \
int width, int height)"
  s7_pointer _p;
  s7_pointer format, width, height;
  _p = args;
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 1, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 2, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 3, height, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_image_surface_create(s7_integer(format), s7_integer(width), s7_integer(height))));
}

static s7_pointer lg_cairo_image_surface_create_for_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create_for_data "cairo_surface_t* cairo_image_surface_create_for_data(guchar* data, \
cairo_format_t format, int width, int height, int stride)"
  s7_pointer _p;
  s7_pointer data, format, width, height, stride;
  _p = args;
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 1, data, "guchar*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 2, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 4, height, "int");
  stride = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(stride)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 5, stride, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_image_surface_create_for_data(s7_c_pointer(data), s7_integer(format), s7_integer(width), s7_integer(height), s7_integer(stride))));
}

static s7_pointer lg_cairo_image_surface_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_data "guchar* cairo_image_surface_get_data(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_data", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, guchar__sym, cairo_image_surface_get_data(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_format(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_format "cairo_format_t cairo_image_surface_get_format(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_format", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_format(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_width "int cairo_image_surface_get_width(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_width", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_width(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_height "int cairo_image_surface_get_height(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_height", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_height(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_stride(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_stride "int cairo_image_surface_get_stride(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_stride", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_stride(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_create_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_rgb "cairo_pattern_t* cairo_pattern_create_rgb(double red, double green, \
double blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 1, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 2, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 3, blue, "double");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_create_rgb(s7_real(red), s7_real(green), s7_real(blue))));
}

static s7_pointer lg_cairo_pattern_create_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_rgba "cairo_pattern_t* cairo_pattern_create_rgba(double red, double green, \
double blue, double alpha)"
  s7_pointer _p;
  s7_pointer red, green, blue, alpha;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 1, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 2, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 3, blue, "double");
  alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 4, alpha, "double");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_create_rgba(s7_real(red), s7_real(green), s7_real(blue), s7_real(alpha))));
}

static s7_pointer lg_cairo_pattern_create_for_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_for_surface "cairo_pattern_t* cairo_pattern_create_for_surface(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_for_surface", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_create_for_surface(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_create_linear(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_linear "cairo_pattern_t* cairo_pattern_create_linear(double x0, double y0, \
double x1, double y1)"
  s7_pointer _p;
  s7_pointer x0, y0, x1, y1;
  _p = args;
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 1, x0, "double");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 2, y0, "double");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 3, x1, "double");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 4, y1, "double");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_create_linear(s7_real(x0), s7_real(y0), s7_real(x1), s7_real(y1))));
}

static s7_pointer lg_cairo_pattern_create_radial(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_radial "cairo_pattern_t* cairo_pattern_create_radial(double cx0, double cy0, \
double radius0, double cx1, double cy1, double radius1)"
  s7_pointer _p;
  s7_pointer cx0, cy0, radius0, cx1, cy1, radius1;
  _p = args;
  cx0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cx0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 1, cx0, "double");
  cy0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cy0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 2, cy0, "double");
  radius0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 3, radius0, "double");
  cx1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cx1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 4, cx1, "double");
  cy1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cy1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 5, cy1, "double");
  radius1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 6, radius1, "double");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_create_radial(s7_real(cx0), s7_real(cy0), s7_real(radius0), s7_real(cx1), s7_real(cy1), s7_real(radius1))));
}

static s7_pointer lg_cairo_pattern_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_reference "cairo_pattern_t* cairo_pattern_reference(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_reference", 1, pattern, "cairo_pattern_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_pattern_t__sym, cairo_pattern_reference(s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_destroy "void cairo_pattern_destroy(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_destroy", 1, pattern, "cairo_pattern_t*");
  cairo_pattern_destroy(s7_c_pointer(pattern));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_status "cairo_status_t cairo_pattern_status(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_status", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_status(s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_add_color_stop_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_add_color_stop_rgb "void cairo_pattern_add_color_stop_rgb(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue)"
  s7_pointer _p;
  s7_pointer pattern, offset, red, green, blue;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 1, pattern, "cairo_pattern_t*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 2, offset, "double");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 3, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 4, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 5, blue, "double");
  cairo_pattern_add_color_stop_rgb(s7_c_pointer(pattern), s7_real(offset), s7_real(red), s7_real(green), s7_real(blue));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_add_color_stop_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_add_color_stop_rgba "void cairo_pattern_add_color_stop_rgba(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue, double alpha)"
  s7_pointer _p;
  s7_pointer pattern, offset, red, green, blue, alpha;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 1, pattern, "cairo_pattern_t*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 2, offset, "double");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 3, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 4, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 5, blue, "double");
  alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 6, alpha, "double");
  cairo_pattern_add_color_stop_rgba(s7_c_pointer(pattern), s7_real(offset), s7_real(red), s7_real(green), s7_real(blue), s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_matrix "void cairo_pattern_set_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer pattern, matrix;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_matrix", 1, pattern, "cairo_pattern_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_pattern_set_matrix(s7_c_pointer(pattern), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_matrix "void cairo_pattern_get_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer pattern, matrix;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_matrix", 1, pattern, "cairo_pattern_t*");
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_pattern_get_matrix(s7_c_pointer(pattern), s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_set_extend(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_extend "void cairo_pattern_set_extend(cairo_pattern_t* pattern, cairo_extend_t extend)"
  s7_pointer _p;
  s7_pointer pattern, extend;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_extend", 1, pattern, "cairo_pattern_t*");
  extend = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(extend)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_extend", 2, extend, "cairo_extend_t");
  cairo_pattern_set_extend(s7_c_pointer(pattern), s7_integer(extend));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_extend(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_extend "cairo_extend_t cairo_pattern_get_extend(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_extend", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_extend(s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_set_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_filter "void cairo_pattern_set_filter(cairo_pattern_t* pattern, cairo_filter_t filter)"
  s7_pointer _p;
  s7_pointer pattern, filter;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_filter", 1, pattern, "cairo_pattern_t*");
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(filter)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_filter", 2, filter, "cairo_filter_t");
  cairo_pattern_set_filter(s7_c_pointer(pattern), s7_integer(filter));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_filter "cairo_filter_t cairo_pattern_get_filter(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_filter", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_filter(s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_matrix_init(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init "void cairo_matrix_init(cairo_matrix_t* matrix, double xx, double yx, double xy, \
double yy, double x0, double y0)"
  s7_pointer _p;
  s7_pointer matrix, xx, yx, xy, yy, x0, y0;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 1, matrix, "cairo_matrix_t*");
  xx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 2, xx, "double");
  yx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 3, yx, "double");
  xy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 4, xy, "double");
  yy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 5, yy, "double");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 6, x0, "double");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 7, y0, "double");
  cairo_matrix_init(s7_c_pointer(matrix), s7_real(xx), s7_real(yx), s7_real(xy), s7_real(yy), s7_real(x0), s7_real(y0));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_identity(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_identity "void cairo_matrix_init_identity(cairo_matrix_t* matrix)"
  s7_pointer matrix;
  matrix = s7_car(args);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_identity", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_init_identity(s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_translate "void cairo_matrix_init_translate(cairo_matrix_t* matrix, double tx, \
double ty)"
  s7_pointer _p;
  s7_pointer matrix, tx, ty;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 1, matrix, "cairo_matrix_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 2, tx, "double");
  ty = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 3, ty, "double");
  cairo_matrix_init_translate(s7_c_pointer(matrix), s7_real(tx), s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_scale "void cairo_matrix_init_scale(cairo_matrix_t* matrix, double sx, \
double sy)"
  s7_pointer _p;
  s7_pointer matrix, sx, sy;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 1, matrix, "cairo_matrix_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 2, sx, "double");
  sy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 3, sy, "double");
  cairo_matrix_init_scale(s7_c_pointer(matrix), s7_real(sx), s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_rotate "void cairo_matrix_init_rotate(cairo_matrix_t* matrix, double radians)"
  s7_pointer _p;
  s7_pointer matrix, radians;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_rotate", 1, matrix, "cairo_matrix_t*");
  radians = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radians)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_rotate", 2, radians, "double");
  cairo_matrix_init_rotate(s7_c_pointer(matrix), s7_real(radians));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_translate "void cairo_matrix_translate(cairo_matrix_t* matrix, double tx, double ty)"
  s7_pointer _p;
  s7_pointer matrix, tx, ty;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 1, matrix, "cairo_matrix_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 2, tx, "double");
  ty = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 3, ty, "double");
  cairo_matrix_translate(s7_c_pointer(matrix), s7_real(tx), s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_scale "void cairo_matrix_scale(cairo_matrix_t* matrix, double sx, double sy)"
  s7_pointer _p;
  s7_pointer matrix, sx, sy;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 1, matrix, "cairo_matrix_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 2, sx, "double");
  sy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 3, sy, "double");
  cairo_matrix_scale(s7_c_pointer(matrix), s7_real(sx), s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_rotate "void cairo_matrix_rotate(cairo_matrix_t* matrix, double radians)"
  s7_pointer _p;
  s7_pointer matrix, radians;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_rotate", 1, matrix, "cairo_matrix_t*");
  radians = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radians)) s7_wrong_type_arg_error(sc, "cairo_matrix_rotate", 2, radians, "double");
  cairo_matrix_rotate(s7_c_pointer(matrix), s7_real(radians));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_invert(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_invert "cairo_status_t cairo_matrix_invert(cairo_matrix_t* matrix)"
  s7_pointer matrix;
  matrix = s7_car(args);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_invert", 1, matrix, "cairo_matrix_t*");
  return(s7_make_integer(sc, cairo_matrix_invert(s7_c_pointer(matrix))));
}

static s7_pointer lg_cairo_matrix_multiply(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_multiply "void cairo_matrix_multiply(cairo_matrix_t* result, cairo_matrix_t* a, \
cairo_matrix_t* b)"
  s7_pointer _p;
  s7_pointer result, a, b;
  _p = args;
  result = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(result, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 1, result, "cairo_matrix_t*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 2, a, "cairo_matrix_t*");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(b, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 3, b, "cairo_matrix_t*");
  cairo_matrix_multiply(s7_c_pointer(result), s7_c_pointer(a), s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_transform_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_transform_distance "void cairo_matrix_transform_distance(cairo_matrix_t* matrix, \
gdouble* [dx], gdouble* [dy])"
  s7_pointer _p;
  s7_pointer matrix;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_transform_distance", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_transform_distance(s7_c_pointer(matrix), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_matrix_transform_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_transform_point "void cairo_matrix_transform_point(cairo_matrix_t* matrix, gdouble* [x], \
gdouble* [y])"
  s7_pointer _p;
  s7_pointer matrix;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_transform_point", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_transform_point(s7_c_pointer(matrix), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_reference_count "guint cairo_get_reference_count(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_reference_count", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_reference_count(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_user_data "void* cairo_get_user_data(cairo_t* cr, cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer cr, key;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_user_data", 1, cr, "cairo_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, void__sym, cairo_get_user_data(s7_c_pointer(cr), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_user_data "cairo_status_t cairo_set_user_data(cairo_t* cr, cairo_user_data_key_t* key, \
void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer cr, key, user_data, destroy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 1, cr, "cairo_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_set_user_data(s7_c_pointer(cr), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_clip_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip_extents "void cairo_clip_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip_extents", 1, cr, "cairo_t*");
  cairo_clip_extents(s7_c_pointer(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
    return(s7_list(sc, 4, s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_x2), s7_make_real(sc, ref_y2)));
}

static s7_pointer lg_cairo_copy_clip_rectangle_list(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_clip_rectangle_list "cairo_rectangle_list_t* cairo_copy_clip_rectangle_list(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_clip_rectangle_list", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_rectangle_list_t__sym, cairo_copy_clip_rectangle_list(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_rectangle_list_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rectangle_list_destroy "void cairo_rectangle_list_destroy(cairo_rectangle_list_t* rectangle_list)"
  s7_pointer rectangle_list;
  rectangle_list = s7_car(args);
  if (!s7_is_c_pointer_of_type(rectangle_list, cairo_rectangle_list_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rectangle_list_destroy", 1, rectangle_list, "cairo_rectangle_list_t*");
  cairo_rectangle_list_destroy(s7_c_pointer(rectangle_list));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_get_reference_count "guint cairo_font_face_get_reference_count(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_reference_count", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_font_face_get_reference_count(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_scaled_font_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_reference_count "guint cairo_scaled_font_get_reference_count(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_reference_count", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_integer(sc, cairo_scaled_font_get_reference_count(s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_user_data "void* cairo_scaled_font_get_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer scaled_font, key;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_user_data", 1, scaled_font, "cairo_scaled_font_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, void__sym, cairo_scaled_font_get_user_data(s7_c_pointer(scaled_font), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_scaled_font_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_set_user_data "cairo_status_t cairo_scaled_font_set_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer scaled_font, key, user_data, destroy;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 1, scaled_font, "cairo_scaled_font_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_scaled_font_set_user_data(s7_c_pointer(scaled_font), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_get_dash_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_dash_count "int cairo_get_dash_count(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_dash_count", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_dash_count(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_dash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_dash "void cairo_get_dash(cairo_t* cr, double* [dashes], double* [offset])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_dashes;
  double ref_offset;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_dash", 1, cr, "cairo_t*");
  cairo_get_dash(s7_c_pointer(cr), &ref_dashes, &ref_offset);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dashes), s7_make_real(sc, ref_offset)));
}

static s7_pointer lg_cairo_surface_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_reference_count "guint cairo_surface_get_reference_count(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_reference_count", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_get_reference_count(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_reference_count "guint cairo_pattern_get_reference_count(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_reference_count", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_reference_count(s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_user_data "void* cairo_pattern_get_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer pattern, key;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_user_data", 1, pattern, "cairo_pattern_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, void__sym, cairo_pattern_get_user_data(s7_c_pointer(pattern), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_pattern_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_user_data "cairo_status_t cairo_pattern_set_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer pattern, key, user_data, destroy;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 1, pattern, "cairo_pattern_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_pattern_set_user_data(s7_c_pointer(pattern), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_pattern_get_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_rgba "cairo_status_t cairo_pattern_get_rgba(cairo_pattern_t* pattern, double* [red], \
double* [green], double* [blue], double* [alpha])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_rgba", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_rgba(s7_c_pointer(pattern), &ref_red, &ref_green, &ref_blue, &ref_alpha));
      return(s7_list(sc, 5, result, s7_make_real(sc, ref_red), s7_make_real(sc, ref_green), s7_make_real(sc, ref_blue), s7_make_real(sc, ref_alpha)));
   }
}

static s7_pointer lg_cairo_pattern_get_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_surface "cairo_status_t cairo_pattern_get_surface(cairo_pattern_t* pattern, \
cairo_surface_t** [surface])"
  s7_pointer _p;
  s7_pointer pattern;
  cairo_surface_t* ref_surface = NULL;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_surface", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_surface(s7_c_pointer(pattern), &ref_surface));
      return(s7_list(sc, 2, result, s7_make_c_pointer(sc, ref_surface)));
   }
}

static s7_pointer lg_cairo_pattern_get_color_stop_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_color_stop_rgba "cairo_status_t cairo_pattern_get_color_stop_rgba(cairo_pattern_t* pattern, \
int index, double* [offset], double* [red], double* [green], double* [blue], double* [alpha])"
  s7_pointer _p;
  s7_pointer pattern, index;
  double ref_offset;
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_rgba", 1, pattern, "cairo_pattern_t*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_rgba", 2, index, "int");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_color_stop_rgba(s7_c_pointer(pattern), s7_integer(index), &ref_offset, &ref_red, &ref_green, &ref_blue, &ref_alpha));
      return(s7_list(sc, 6, result, s7_make_real(sc, ref_offset), s7_make_real(sc, ref_red), s7_make_real(sc, ref_green), s7_make_real(sc, ref_blue), s7_make_real(sc, ref_alpha)));
   }
}

static s7_pointer lg_cairo_pattern_get_color_stop_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_color_stop_count "cairo_status_t cairo_pattern_get_color_stop_count(cairo_pattern_t* pattern, \
int* [count])"
  s7_pointer _p;
  s7_pointer pattern;
  int ref_count;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_count", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_color_stop_count(s7_c_pointer(pattern), &ref_count));
      return(s7_list(sc, 2, result, s7_make_integer(sc, ref_count)));
   }
}

static s7_pointer lg_cairo_pattern_get_linear_points(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_linear_points "cairo_status_t cairo_pattern_get_linear_points(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [x1], double* [y1])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_x0;
  double ref_y0;
  double ref_x1;
  double ref_y1;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_linear_points", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_linear_points(s7_c_pointer(pattern), &ref_x0, &ref_y0, &ref_x1, &ref_y1));
      return(s7_list(sc, 5, result, s7_make_real(sc, ref_x0), s7_make_real(sc, ref_y0), s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1)));
   }
}

static s7_pointer lg_cairo_pattern_get_radial_circles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_radial_circles "cairo_status_t cairo_pattern_get_radial_circles(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [r0], double* [x1], double* [y1], double* [r1])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_x0;
  double ref_y0;
  double ref_r0;
  double ref_x1;
  double ref_y1;
  double ref_r1;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_radial_circles", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer result;
    result = s7_make_integer(sc, cairo_pattern_get_radial_circles(s7_c_pointer(pattern), &ref_x0, &ref_y0, &ref_r0, &ref_x1, &ref_y1, &ref_r1));
      return(s7_list(sc, 7, result, s7_make_real(sc, ref_x0), s7_make_real(sc, ref_y0), s7_make_real(sc, ref_r0), s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_r1)));
   }
}

static s7_pointer lg_cairo_get_scaled_font(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_scaled_font "cairo_scaled_font_t* cairo_get_scaled_font(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_scaled_font", 1, cr, "cairo_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_scaled_font_t__sym, cairo_get_scaled_font(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_path_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_path_extents "void cairo_path_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_path_extents", 1, cr, "cairo_t*");
  cairo_path_extents(s7_c_pointer(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
    return(s7_list(sc, 4, s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_x2), s7_make_real(sc, ref_y2)));
}

static s7_pointer lg_cairo_has_current_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_has_current_point "bool cairo_has_current_point(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_has_current_point", 1, cr, "cairo_t*");
  return(s7_make_boolean(sc, cairo_has_current_point(s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_surface_copy_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_copy_page "void cairo_surface_copy_page(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_copy_page", 1, surface, "cairo_surface_t*");
  cairo_surface_copy_page(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_show_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_show_page "void cairo_surface_show_page(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_show_page", 1, surface, "cairo_surface_t*");
  cairo_surface_show_page(s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_format_stride_for_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_format_stride_for_width "int cairo_format_stride_for_width(cairo_format_t format, int width)"
  s7_pointer _p;
  s7_pointer format, width;
  _p = args;
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_format_stride_for_width", 1, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_format_stride_for_width", 2, width, "int");
  return(s7_make_integer(sc, cairo_format_stride_for_width(s7_integer(format), s7_integer(width))));
}

static s7_pointer lg_cairo_image_surface_create_from_png(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create_from_png "cairo_surface_t* cairo_image_surface_create_from_png(char* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_from_png", 1, filename, "char*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_image_surface_create_from_png((const char*)(char*)s7_string(filename))));
}

static s7_pointer lg_cairo_surface_write_to_png(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_write_to_png "cairo_status_t cairo_surface_write_to_png(cairo_surface_t* surface, \
char* filename)"
  s7_pointer _p;
  s7_pointer surface, filename;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_write_to_png", 1, surface, "cairo_surface_t*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "cairo_surface_write_to_png", 2, filename, "char*");
  return(s7_make_integer(sc, cairo_surface_write_to_png(s7_c_pointer(surface), (const char*)(char*)s7_string(filename))));
}

#if HAVE_CAIRO_1_8
static s7_pointer lg_cairo_glyph_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_allocate "cairo_glyph_t* cairo_glyph_allocate(int num_glyphs)"
  s7_pointer num_glyphs;
  num_glyphs = s7_car(args);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_allocate", 1, num_glyphs, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_glyph_t__sym, cairo_glyph_allocate(s7_integer(num_glyphs))));
}

static s7_pointer lg_cairo_glyph_free(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_free "void cairo_glyph_free(cairo_glyph_t* glyphs)"
  s7_pointer glyphs;
  glyphs = s7_car(args);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_free", 1, glyphs, "cairo_glyph_t*");
  cairo_glyph_free(s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_text_cluster_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_cluster_allocate "cairo_text_cluster_t* cairo_text_cluster_allocate(int num_clusters)"
  s7_pointer num_clusters;
  num_clusters = s7_car(args);
  if (!s7_is_integer(num_clusters)) s7_wrong_type_arg_error(sc, "cairo_text_cluster_allocate", 1, num_clusters, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_text_cluster_t__sym, cairo_text_cluster_allocate(s7_integer(num_clusters))));
}

static s7_pointer lg_cairo_text_cluster_free(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_cluster_free "void cairo_text_cluster_free(cairo_text_cluster_t* clusters)"
  s7_pointer clusters;
  clusters = s7_car(args);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_cluster_free", 1, clusters, "cairo_text_cluster_t*");
  cairo_text_cluster_free(s7_c_pointer(clusters));
  return(lg_false);
}

static s7_pointer lg_cairo_show_text_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_text_glyphs "void cairo_show_text_glyphs(cairo_t* cr, char* utf8, int utf8_len, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_cluster_t* clusters, int num_clusters, cairo_text_cluster_flags_t cluster_flags)"
  s7_pointer _p;
  s7_pointer cr, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 2, utf8, "char*");
  utf8_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(utf8_len)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 3, utf8_len, "int");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 4, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 5, num_glyphs, "int");
  clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 6, clusters, "cairo_text_cluster_t*");
  num_clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_clusters)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 7, num_clusters, "int");
  cluster_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(cluster_flags)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 8, cluster_flags, "cairo_text_cluster_flags_t");
  cairo_show_text_glyphs(s7_c_pointer(cr), (const char*)(char*)s7_string(utf8), s7_integer(utf8_len), s7_c_pointer(glyphs), s7_integer(num_glyphs), s7_c_pointer(clusters), s7_integer(num_clusters), s7_integer(cluster_flags));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_text_to_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_text_to_glyphs "cairo_status_t cairo_scaled_font_text_to_glyphs(cairo_scaled_font_t* scaled_font, \
double x, double y, char* utf8, int utf8_len, cairo_glyph_t** glyphs, int* num_glyphs, cairo_text_cluster_t** clusters, \
int* num_clusters, cairo_text_cluster_flags_t* cluster_flags)"
  s7_pointer _p;
  s7_pointer scaled_font, x, y, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 1, scaled_font, "cairo_scaled_font_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 3, y, "double");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 4, utf8, "char*");
  utf8_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(utf8_len)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 5, utf8_len, "int");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t___sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 6, glyphs, "cairo_glyph_t**");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(num_glyphs, int__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 7, num_glyphs, "int*");
  clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t___sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 8, clusters, "cairo_text_cluster_t**");
  num_clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(num_clusters, int__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 9, num_clusters, "int*");
  cluster_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cluster_flags, cairo_text_cluster_flags_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 10, cluster_flags, "cairo_text_cluster_flags_t*");
  return(s7_make_integer(sc, cairo_scaled_font_text_to_glyphs(s7_c_pointer(scaled_font), s7_real(x), s7_real(y), (const char*)(char*)s7_string(utf8), s7_integer(utf8_len), s7_c_pointer(glyphs), s7_c_pointer(num_glyphs), s7_c_pointer(clusters), s7_c_pointer(num_clusters), s7_c_pointer(cluster_flags))));
}

static s7_pointer lg_cairo_scaled_font_get_scale_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_scale_matrix "void cairo_scaled_font_get_scale_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* scale_matrix)"
  s7_pointer _p;
  s7_pointer scaled_font, scale_matrix;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_scale_matrix", 1, scaled_font, "cairo_scaled_font_t*");
  scale_matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_scale_matrix", 2, scale_matrix, "cairo_matrix_t*");
  cairo_scaled_font_get_scale_matrix(s7_c_pointer(scaled_font), s7_c_pointer(scale_matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_toy_font_face_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_create "cairo_font_face_t* cairo_toy_font_face_create(char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  s7_pointer _p;
  s7_pointer family, slant, weight;
  _p = args;
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 1, family, "char*");
  slant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(slant)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 2, slant, "cairo_font_slant_t");
  weight = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 3, weight, "cairo_font_weight_t");
  return(s7_make_type_with_c_pointer(sc, cairo_font_face_t__sym, cairo_toy_font_face_create((const char*)(char*)s7_string(family), s7_integer(slant), s7_integer(weight))));
}

static s7_pointer lg_cairo_toy_font_face_get_family(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_family "char* cairo_toy_font_face_get_family(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_family", 1, font_face, "cairo_font_face_t*");
  return(s7_make_string(sc, cairo_toy_font_face_get_family(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_toy_font_face_get_slant(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_slant "cairo_font_slant_t cairo_toy_font_face_get_slant(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_slant", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_toy_font_face_get_slant(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_toy_font_face_get_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_weight "cairo_font_weight_t cairo_toy_font_face_get_weight(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_weight", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_toy_font_face_get_weight(s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_user_font_face_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_font_face_create "cairo_font_face_t* cairo_user_font_face_create( void)"
  return(s7_make_type_with_c_pointer(sc, cairo_font_face_t__sym, cairo_user_font_face_create()));
}

static s7_pointer lg_cairo_surface_get_fallback_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_fallback_resolution "void cairo_surface_get_fallback_resolution(cairo_surface_t* surface, \
double* [x_pixels_per_inch], double* [y_pixels_per_inch])"
  s7_pointer _p;
  s7_pointer surface;
  double ref_x_pixels_per_inch;
  double ref_y_pixels_per_inch;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_fallback_resolution", 1, surface, "cairo_surface_t*");
  cairo_surface_get_fallback_resolution(s7_c_pointer(surface), &ref_x_pixels_per_inch, &ref_y_pixels_per_inch);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x_pixels_per_inch), s7_make_real(sc, ref_y_pixels_per_inch)));
}

static s7_pointer lg_cairo_surface_has_show_text_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_has_show_text_glyphs "cairo_bool_t cairo_surface_has_show_text_glyphs(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_has_show_text_glyphs", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_has_show_text_glyphs(s7_c_pointer(surface))));
}

#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_cairo_in_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_clip "cairo_bool_t cairo_in_clip(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 3, y, "double");
  return(s7_make_integer(sc, cairo_in_clip(s7_c_pointer(cr), s7_real(x), s7_real(y))));
}

static s7_pointer lg_cairo_device_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_reference "cairo_device_t* cairo_device_reference(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_reference", 1, device, "cairo_device_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_device_t__sym, cairo_device_reference(s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_status "cairo_status_t cairo_device_status(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_status", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_status(s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_acquire(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_acquire "cairo_status_t cairo_device_acquire(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_acquire", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_acquire(s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_release(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_release "void cairo_device_release(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_release", 1, device, "cairo_device_t*");
  cairo_device_release(s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_flush "void cairo_device_flush(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_flush", 1, device, "cairo_device_t*");
  cairo_device_flush(s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_finish "void cairo_device_finish(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_finish", 1, device, "cairo_device_t*");
  cairo_device_finish(s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_destroy "void cairo_device_destroy(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_destroy", 1, device, "cairo_device_t*");
  cairo_device_destroy(s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_get_reference_count "guint cairo_device_get_reference_count(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_reference_count", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_get_reference_count(s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_get_user_data "void* cairo_device_get_user_data(cairo_device_t* device, cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer device, key;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_user_data", 1, device, "cairo_device_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(s7_make_type_with_c_pointer(sc, void__sym, cairo_device_get_user_data(s7_c_pointer(device), s7_c_pointer(key))));
}

static s7_pointer lg_cairo_device_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_set_user_data "cairo_status_t cairo_device_set_user_data(cairo_device_t* device, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer device, key, user_data, destroy;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 1, device, "cairo_device_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_device_set_user_data(s7_c_pointer(device), s7_c_pointer(key), s7_c_pointer(user_data), s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_surface_create_for_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_create_for_rectangle "cairo_surface_t* cairo_surface_create_for_rectangle(cairo_surface_t* target, \
double x, double y, double width, double height)"
  s7_pointer _p;
  s7_pointer target, x, y, width, height;
  _p = args;
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 1, target, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 3, y, "double");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 4, width, "double");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 5, height, "double");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_surface_create_for_rectangle(s7_c_pointer(target), s7_real(x), s7_real(y), s7_real(width), s7_real(height))));
}

static s7_pointer lg_cairo_surface_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_device "cairo_device_t* cairo_surface_get_device(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_device", 1, surface, "cairo_surface_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_device_t__sym, cairo_surface_get_device(s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_set_mime_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_mime_data "cairo_status_t cairo_surface_set_mime_data(cairo_surface_t* surface, \
char* mime_type, guchar* data, gulong length, cairo_destroy_func_t destroy, void* closure)"
  s7_pointer _p;
  s7_pointer surface, mime_type, data, length, destroy, closure;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 1, surface, "cairo_surface_t*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 2, mime_type, "char*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 3, data, "guchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 4, length, "gulong");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 5, destroy, "cairo_destroy_func_t");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(closure, void__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 6, closure, "void*");
  return(s7_make_integer(sc, cairo_surface_set_mime_data(s7_c_pointer(surface), (const char*)(char*)s7_string(mime_type), s7_c_pointer(data), s7_integer(length), s7_c_pointer(destroy), s7_c_pointer(closure))));
}

static s7_pointer lg_cairo_recording_surface_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_recording_surface_create "cairo_surface_t* cairo_recording_surface_create(cairo_content_t content, \
cairo_rectangle_t* extents)"
  s7_pointer _p;
  s7_pointer content, extents;
  _p = args;
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_create", 1, content, "cairo_content_t");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_rectangle_t__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_create", 2, extents, "cairo_rectangle_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_surface_t__sym, cairo_recording_surface_create(s7_integer(content), s7_c_pointer(extents))));
}

static s7_pointer lg_cairo_recording_surface_ink_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_recording_surface_ink_extents "void cairo_recording_surface_ink_extents(cairo_surface_t* surface, \
double* x0, double* y0, double* width, double* height)"
  s7_pointer _p;
  s7_pointer surface, x0, y0, width, height;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 1, surface, "cairo_surface_t*");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(x0, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 2, x0, "double*");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(y0, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 3, y0, "double*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(width, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 4, width, "double*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(height, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 5, height, "double*");
  cairo_recording_surface_ink_extents(s7_c_pointer(surface), s7_c_pointer(x0), s7_c_pointer(y0), s7_c_pointer(width), s7_c_pointer(height));
  return(lg_false);
}

static s7_pointer lg_cairo_region_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create "cairo_region_t* cairo_region_create( void)"
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, cairo_region_create()));
}

static s7_pointer lg_cairo_region_create_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create_rectangle "cairo_region_t* cairo_region_create_rectangle(cairo_rectangle_int_t* rectangle)"
  s7_pointer rectangle;
  rectangle = s7_car(args);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangle", 1, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, cairo_region_create_rectangle(s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_create_rectangles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create_rectangles "cairo_region_t* cairo_region_create_rectangles(cairo_rectangle_int_t* rects, \
int count)"
  s7_pointer _p;
  s7_pointer rects, count;
  _p = args;
  rects = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rects, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangles", 1, rects, "cairo_rectangle_int_t*");
  count = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangles", 2, count, "int");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, cairo_region_create_rectangles(s7_c_pointer(rects), s7_integer(count))));
}

static s7_pointer lg_cairo_region_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_copy "cairo_region_t* cairo_region_copy(cairo_region_t* original)"
  s7_pointer original;
  original = s7_car(args);
  if (!s7_is_c_pointer_of_type(original, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_copy", 1, original, "cairo_region_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, cairo_region_copy(s7_c_pointer(original))));
}

static s7_pointer lg_cairo_region_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_reference "cairo_region_t* cairo_region_reference(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_reference", 1, region, "cairo_region_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_t__sym, cairo_region_reference(s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_destroy "void cairo_region_destroy(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_destroy", 1, region, "cairo_region_t*");
  cairo_region_destroy(s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_cairo_region_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_equal "cairo_bool_t cairo_region_equal(cairo_region_t* a, cairo_region_t* b)"
  s7_pointer _p;
  s7_pointer a, b;
  _p = args;
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_equal", 1, a, "cairo_region_t*");
  b = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(b, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_equal", 2, b, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_equal(s7_c_pointer(a), s7_c_pointer(b))));
}

static s7_pointer lg_cairo_region_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_status "cairo_status_t cairo_region_status(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_status", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_status(s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_get_extents "void cairo_region_get_extents(cairo_region_t* region, cairo_rectangle_int_t* extents)"
  s7_pointer _p;
  s7_pointer region, extents;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_extents", 1, region, "cairo_region_t*");
  extents = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_extents", 2, extents, "cairo_rectangle_int_t*");
  cairo_region_get_extents(s7_c_pointer(region), s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_region_num_rectangles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_num_rectangles "int cairo_region_num_rectangles(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_num_rectangles", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_num_rectangles(s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_get_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_get_rectangle "void cairo_region_get_rectangle(cairo_region_t* region, int nth, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer region, nth, rectangle;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 1, region, "cairo_region_t*");
  nth = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(nth)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 2, nth, "int");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 3, rectangle, "cairo_rectangle_int_t*");
  cairo_region_get_rectangle(s7_c_pointer(region), s7_integer(nth), s7_c_pointer(rectangle));
  return(lg_false);
}

static s7_pointer lg_cairo_region_is_empty(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_is_empty "cairo_bool_t cairo_region_is_empty(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_is_empty", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_is_empty(s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_contains_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_contains_rectangle "cairo_region_overlap_t cairo_region_contains_rectangle(cairo_region_t* region, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer region, rectangle;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_rectangle", 1, region, "cairo_region_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_type_with_c_pointer(sc, cairo_region_overlap_t_sym, cairo_region_contains_rectangle(s7_c_pointer(region), s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_contains_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_contains_point "cairo_bool_t cairo_region_contains_point(cairo_region_t* region, \
int x, int y)"
  s7_pointer _p;
  s7_pointer region, x, y;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 1, region, "cairo_region_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 3, y, "int");
  return(s7_make_integer(sc, cairo_region_contains_point(s7_c_pointer(region), s7_integer(x), s7_integer(y))));
}

static s7_pointer lg_cairo_region_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_translate "void cairo_region_translate(cairo_region_t* region, int dx, int dy)"
  s7_pointer _p;
  s7_pointer region, dx, dy;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 1, region, "cairo_region_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 2, dx, "int");
  dy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 3, dy, "int");
  cairo_region_translate(s7_c_pointer(region), s7_integer(dx), s7_integer(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_region_subtract(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_subtract "cairo_status_t cairo_region_subtract(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract", 1, dst, "cairo_region_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_subtract(s7_c_pointer(dst), s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_subtract_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_subtract_rectangle "cairo_status_t cairo_region_subtract_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_subtract_rectangle(s7_c_pointer(dst), s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_intersect(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_intersect "cairo_status_t cairo_region_intersect(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect", 1, dst, "cairo_region_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_intersect(s7_c_pointer(dst), s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_intersect_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_intersect_rectangle "cairo_status_t cairo_region_intersect_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_intersect_rectangle(s7_c_pointer(dst), s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_union(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_union "cairo_status_t cairo_region_union(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union", 1, dst, "cairo_region_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_union(s7_c_pointer(dst), s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_union_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_union_rectangle "cairo_status_t cairo_region_union_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_union_rectangle(s7_c_pointer(dst), s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_xor(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_xor "cairo_status_t cairo_region_xor(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor", 1, dst, "cairo_region_t*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_xor(s7_c_pointer(dst), s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_xor_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_xor_rectangle "cairo_status_t cairo_region_xor_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_xor_rectangle(s7_c_pointer(dst), s7_c_pointer(rectangle))));
}

#endif

static s7_pointer lg_g_signal_connect(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect "gulong g_signal_connect(gpointer instance, gchar* signal_name, GCallback func, lambda_data func_info)"
  s7_pointer obj, name, func, data;
  GCallback callf;
  obj = s7_car(args);
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_signal_connect", 2, name, "gchar*");
  func = s7_caddr(args);
  if (s7_is_aritable(sc, func, 4)) callf = (GCallback)lg_func4;
  else {if (s7_is_aritable(sc, func, 3)) callf = (GCallback)lg_func3; else callf = (GCallback)lg_func2;}
  if (s7_is_pair(s7_cdddr(args))) data = s7_cadddr(args); else data = s7_nil(sc);
  if (data == lg_false) data = s7_nil(sc);
  return(s7_make_integer(sc, 
            g_signal_connect_data((gpointer)s7_c_pointer(obj),
                                  (gchar *)s7_string(name),
                                  callf,
                                  (gpointer)s7_cons(sc, func, data), 
                                  NULL, (GConnectFlags)0)));
}
static s7_pointer lg_GPOINTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), gpointer_sym, lg_false));}
static s7_pointer lg_GDK_DRAG_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDragContext__sym, lg_false));}
static s7_pointer lg_GDK_DEVICE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDevice__sym, lg_false));}
static s7_pointer lg_GDK_KEYMAP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkKeymap__sym, lg_false));}
static s7_pointer lg_GDK_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkWindow__sym, lg_false));}
static s7_pointer lg_GDK_PIXBUF(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkPixbuf__sym, lg_false));}
static s7_pointer lg_GDK_PIXBUF_ANIMATION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkPixbufAnimation__sym, lg_false));}
static s7_pointer lg_GDK_PIXBUF_ANIMATION_ITER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkPixbufAnimationIter__sym, lg_false));}
static s7_pointer lg_GTK_ACCEL_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccelGroup__sym, lg_false));}
static s7_pointer lg_GTK_ACCEL_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccelLabel__sym, lg_false));}
static s7_pointer lg_GTK_ACCESSIBLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccessible__sym, lg_false));}
static s7_pointer lg_GTK_ADJUSTMENT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAdjustment__sym, lg_false));}
static s7_pointer lg_GTK_ASPECT_FRAME(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAspectFrame__sym, lg_false));}
static s7_pointer lg_GTK_BUTTON_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkButtonBox__sym, lg_false));}
static s7_pointer lg_GTK_BIN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkBin__sym, lg_false));}
static s7_pointer lg_GTK_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkBox__sym, lg_false));}
static s7_pointer lg_GTK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkButton__sym, lg_false));}
static s7_pointer lg_GTK_CALENDAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCalendar__sym, lg_false));}
static s7_pointer lg_GTK_CELL_EDITABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellEditable__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRenderer__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_PIXBUF(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererPixbuf__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_TEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererText__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_TOGGLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererToggle__sym, lg_false));}
static s7_pointer lg_GTK_CHECK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCheckButton__sym, lg_false));}
static s7_pointer lg_GTK_CHECK_MENU_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCheckMenuItem__sym, lg_false));}
static s7_pointer lg_GTK_CONTAINER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkContainer__sym, lg_false));}
static s7_pointer lg_GTK_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDialog__sym, lg_false));}
static s7_pointer lg_GTK_DRAWING_AREA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDrawingArea__sym, lg_false));}
static s7_pointer lg_GTK_EDITABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEditable__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntry__sym, lg_false));}
static s7_pointer lg_GTK_FIXED(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFixed__sym, lg_false));}
static s7_pointer lg_GTK_FRAME(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFrame__sym, lg_false));}
static s7_pointer lg_GTK_IMAGE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkImage__sym, lg_false));}
static s7_pointer lg_GTK_IM_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIMContext__sym, lg_false));}
static s7_pointer lg_GTK_IM_CONTEXT_SIMPLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIMContextSimple__sym, lg_false));}
static s7_pointer lg_GTK_INVISIBLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkInvisible__sym, lg_false));}
static s7_pointer lg_GTK_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLabel__sym, lg_false));}
static s7_pointer lg_GTK_LAYOUT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLayout__sym, lg_false));}
static s7_pointer lg_GTK_LIST_STORE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListStore__sym, lg_false));}
static s7_pointer lg_GTK_MENU_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuBar__sym, lg_false));}
static s7_pointer lg_GTK_MENU(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenu__sym, lg_false));}
static s7_pointer lg_GTK_MENU_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuItem__sym, lg_false));}
static s7_pointer lg_GTK_MENU_SHELL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuShell__sym, lg_false));}
static s7_pointer lg_GTK_NOTEBOOK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkNotebook__sym, lg_false));}
static s7_pointer lg_GTK_PANED(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPaned__sym, lg_false));}
static s7_pointer lg_GTK_PROGRESS_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkProgressBar__sym, lg_false));}
static s7_pointer lg_GTK_RADIO_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRadioButton__sym, lg_false));}
static s7_pointer lg_GTK_RADIO_MENU_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRadioMenuItem__sym, lg_false));}
static s7_pointer lg_GTK_RANGE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRange__sym, lg_false));}
static s7_pointer lg_GTK_SCALE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScale__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrollbar__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLED_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrolledWindow__sym, lg_false));}
static s7_pointer lg_GTK_SEPARATOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSeparator__sym, lg_false));}
static s7_pointer lg_GTK_SEPARATOR_MENU_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSeparatorMenuItem__sym, lg_false));}
static s7_pointer lg_GTK_SETTINGS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSettings__sym, lg_false));}
static s7_pointer lg_GTK_SIZE_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSizeGroup__sym, lg_false));}
static s7_pointer lg_GTK_SPIN_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSpinButton__sym, lg_false));}
static s7_pointer lg_GTK_STATUSBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStatusbar__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_BUFFER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextBuffer__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_CHILD_ANCHOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextChildAnchor__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_MARK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextMark__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_TAG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextTag__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_TAG_TABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextTagTable__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextView__sym, lg_false));}
static s7_pointer lg_GTK_TOGGLE_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToggleButton__sym, lg_false));}
static s7_pointer lg_GTK_TOOLBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolbar__sym, lg_false));}
static s7_pointer lg_GTK_TREE_DRAG_SOURCE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeDragSource__sym, lg_false));}
static s7_pointer lg_GTK_TREE_DRAG_DEST(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeDragDest__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModel__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL_SORT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModelSort__sym, lg_false));}
static s7_pointer lg_GTK_TREE_SELECTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeSelection__sym, lg_false));}
static s7_pointer lg_GTK_TREE_SORTABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeSortable__sym, lg_false));}
static s7_pointer lg_GTK_TREE_STORE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeStore__sym, lg_false));}
static s7_pointer lg_GTK_TREE_VIEW_COLUMN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeViewColumn__sym, lg_false));}
static s7_pointer lg_GTK_TREE_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeView__sym, lg_false));}
static s7_pointer lg_GTK_VIEWPORT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkViewport__sym, lg_false));}
static s7_pointer lg_GTK_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWidget__sym, lg_false));}
static s7_pointer lg_GTK_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWindow__sym, lg_false));}
static s7_pointer lg_PANGO_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoContext__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_FAMILY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontFamily__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_FACE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontFace__sym, lg_false));}
static s7_pointer lg_PANGO_FONT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFont__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_MAP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontMap__sym, lg_false));}
static s7_pointer lg_PANGO_LAYOUT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoLayout__sym, lg_false));}
static s7_pointer lg_G_OBJECT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GObject__sym, lg_false));}
static s7_pointer lg_GDK_SCREEN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkScreen__sym, lg_false));}
static s7_pointer lg_GDK_DISPLAY_OBJECT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDisplay__sym, lg_false));}
static s7_pointer lg_GDK_EVENT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEvent__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_ANY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventAny__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_EXPOSE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventExpose__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_NOEXPOSE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventNoExpose__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_VISIBILITY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventVisibility__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_MOTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventMotion__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventButton__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_SCROLL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventScroll__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_KEY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventKey__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_CROSSING(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventCrossing__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_FOCUS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventFocus__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_CONFIGURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventConfigure__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_PROPERTY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventProperty__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_SELECTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventSelection__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_PROXIMITY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventProximity__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_SETTING(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventSetting__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_WINDOWSTATE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventWindowState__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_DND(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventDND__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserWidget__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL_FILTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModelFilter__sym, lg_false));}
static s7_pointer lg_GTK_COMBO_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkComboBox__sym, lg_false));}
static s7_pointer lg_GTK_EXPANDER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkExpander__sym, lg_false));}
static s7_pointer lg_GTK_FONT_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontButton__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorButton__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY_COMPLETION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntryCompletion__sym, lg_false));}
static s7_pointer lg_GTK_RADIO_TOOL_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRadioToolButton__sym, lg_false));}
static s7_pointer lg_GTK_SEPARATOR_TOOL_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSeparatorToolItem__sym, lg_false));}
static s7_pointer lg_GTK_TOGGLE_TOOL_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToggleToolButton__sym, lg_false));}
static s7_pointer lg_GTK_FILE_FILTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileFilter__sym, lg_false));}
static s7_pointer lg_GTK_CELL_LAYOUT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellLayout__sym, lg_false));}
static s7_pointer lg_GTK_CLIPBOARD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkClipboard__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooser__sym, lg_false));}
static s7_pointer lg_GTK_ICON_THEME(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIconTheme__sym, lg_false));}
static s7_pointer lg_GTK_TOOL_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolButton__sym, lg_false));}
static s7_pointer lg_GTK_TOOL_ITEM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolItem__sym, lg_false));}
static s7_pointer lg_GTK_ACCEL_MAP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccelMap_sym, lg_false));}
static s7_pointer lg_GTK_CELL_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellView__sym, lg_false));}
static s7_pointer lg_GTK_ABOUT_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAboutDialog__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_COMBO(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererCombo__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_PROGRESS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererProgress__sym, lg_false));}
static s7_pointer lg_GTK_ICON_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIconView__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserButton__sym, lg_false));}
static s7_pointer lg_GTK_MENU_TOOL_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuToolButton__sym, lg_false));}
static s7_pointer lg_GTK_ASSISTANT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAssistant__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_ACCEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererAccel__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_SPIN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererSpin__sym, lg_false));}
static s7_pointer lg_GTK_LINK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLinkButton__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentChooser__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_CHOOSER_MENU(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentChooserMenu__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentChooserWidget__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_FILTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentFilter__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_MANAGER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentManager__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintContext__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_OPERATION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintOperation__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_SETTINGS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintSettings__sym, lg_false));}
static s7_pointer lg_GTK_TOOLTIP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTooltip__sym, lg_false));}
#if GTK_CHECK_VERSION(2, 18, 0)
static s7_pointer lg_GTK_INFO_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkInfoBar__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY_BUFFER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntryBuffer__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static s7_pointer lg_GTK_SPINNER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSpinner__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_SPINNER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererSpinner__sym, lg_false));}
static s7_pointer lg_GTK_TOOL_PALETTE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolPalette__sym, lg_false));}
static s7_pointer lg_GTK_TOOL_ITEM_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolItemGroup__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_GTK_COMBO_BOX_TEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkComboBoxText__sym, lg_false));}
static s7_pointer lg_GTK_GRID(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGrid__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrollable__sym, lg_false));}
static s7_pointer lg_GDK_RGBA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkRGBA__sym, lg_false));}
static s7_pointer lg_GTK_SWITCH(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSwitch__sym, lg_false));}
static s7_pointer lg_GTK_ORIENTABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkOrientable__sym, lg_false));}
static s7_pointer lg_GTK_WINDOW_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWindowGroup__sym, lg_false));}
static s7_pointer lg_GTK_TOOL_SHELL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToolShell__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_GTK_OVERLAY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkOverlay__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooser__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooserWidget__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_GTK_APPLICATION_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkApplicationWindow__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorWidget__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_GTK_MENU_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuButton__sym, lg_false));}
static s7_pointer lg_GTK_SEARCH_ENTRY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWidget__sym, lg_false));}
static s7_pointer lg_GTK_LEVEL_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLevelBar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_GTK_PLACES_SIDEBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPlacesSidebar__sym, lg_false));}
static s7_pointer lg_GTK_STACK_SWITCHER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStackSwitcher__sym, lg_false));}
static s7_pointer lg_GTK_STACK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStack__sym, lg_false));}
static s7_pointer lg_GTK_REVEALER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRevealer__sym, lg_false));}
static s7_pointer lg_GTK_HEADER_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkHeaderBar__sym, lg_false));}
static s7_pointer lg_GTK_LIST_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListBox__sym, lg_false));}
static s7_pointer lg_GTK_LIST_BOX_ROW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListBoxRow__sym, lg_false));}
static s7_pointer lg_GTK_SEARCH_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSearchBar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_GTK_FLOW_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFlowBox__sym, lg_false));}
static s7_pointer lg_GTK_FLOW_BOX_CHILD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFlowBoxChild__sym, lg_false));}
static s7_pointer lg_GTK_ACTION_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkActionBar__sym, lg_false));}
static s7_pointer lg_GTK_POPOVER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPopover__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_GTK_GESTURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGesture__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_DRAG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureDrag__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_LONG_PRESS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureLongPress__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_ZOOM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureZoom__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_SWIPE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureSwipe__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_SINGLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureSingle__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_PAN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGesturePan__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_MULTI_PRESS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureMultiPress__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_ROTATE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureRotate__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventController__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_GTK_GL_AREA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGLArea__sym, lg_false));}
static s7_pointer lg_GDK_GL_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkGLContext__sym, lg_false));}
static s7_pointer lg_GTK_POPOVER_MENU(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPopoverMenu__sym, lg_false));}
static s7_pointer lg_GTK_STACK_SIDEBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStackSidebar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_GDK_SEAT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkSeat__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_GDK_DEVICE_TOOL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDeviceTool__sym, lg_false));}
static s7_pointer lg_GDK_MONITOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkMonitor__sym, lg_false));}
static s7_pointer lg_GDK_DRAWING_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDrawingContext__sym, lg_false));}
static s7_pointer lg_GDK_DEVICE_PAD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDevicePad__sym, lg_false));}
static s7_pointer lg_GTK_PAD_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPadController__sym, lg_false));}
static s7_pointer lg_GTK_SHORTCUT_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkShortcutLabel__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static s7_pointer lg_GTK_CENTER_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCenterBox__sym, lg_false));}
#endif

static s7_pointer lg_GDK_IS_DRAG_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DRAG_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DEVICE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_KEYMAP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_KEYMAP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_PIXBUF(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_PIXBUF((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_PIXBUF_ANIMATION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_PIXBUF_ANIMATION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_PIXBUF_ANIMATION_ITER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_PIXBUF_ANIMATION_ITER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCEL_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCEL_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCEL_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCEL_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCESSIBLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCESSIBLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ADJUSTMENT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ADJUSTMENT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ASPECT_FRAME(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ASPECT_FRAME((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BUTTON_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BUTTON_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BIN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BIN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CALENDAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CALENDAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_EDITABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_EDITABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_PIXBUF(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_PIXBUF((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_TEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_TEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_TOGGLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_TOGGLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CHECK_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CHECK_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CHECK_MENU_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CHECK_MENU_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CONTAINER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CONTAINER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DRAWING_AREA(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DRAWING_AREA((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EDITABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EDITABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FIXED(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FIXED((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FRAME(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FRAME((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IMAGE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IMAGE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IM_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IM_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IM_CONTEXT_SIMPLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IM_CONTEXT_SIMPLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_INVISIBLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_INVISIBLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LAYOUT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LAYOUT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_STORE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_STORE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_MENU_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_MENU(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_MENU_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_MENU_SHELL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_SHELL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_NOTEBOOK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_NOTEBOOK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PANED(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PANED((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PROGRESS_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PROGRESS_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RADIO_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RADIO_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RADIO_MENU_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RADIO_MENU_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RANGE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RANGE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCALE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCALE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLED_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLED_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEPARATOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEPARATOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEPARATOR_MENU_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEPARATOR_MENU_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SETTINGS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SETTINGS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SIZE_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SIZE_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SPIN_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SPIN_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STATUSBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STATUSBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_BUFFER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_BUFFER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_CHILD_ANCHOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_CHILD_ANCHOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_MARK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_MARK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_TAG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_TAG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_TAG_TABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_TAG_TABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOGGLE_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOGGLE_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOLBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOLBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_DRAG_SOURCE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_DRAG_SOURCE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_DRAG_DEST(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_DRAG_DEST((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL_SORT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL_SORT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_SELECTION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_SELECTION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_SORTABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_SORTABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_STORE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_STORE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_VIEW_COLUMN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_VIEW_COLUMN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_VIEWPORT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_VIEWPORT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_FAMILY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_FAMILY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_FACE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_FACE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_MAP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_MAP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_LAYOUT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_LAYOUT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_G_IS_OBJECT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (G_IS_OBJECT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_SCREEN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_SCREEN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DISPLAY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DISPLAY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL_FILTER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL_FILTER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COMBO_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COMBO_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EXPANDER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EXPANDER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY_COMPLETION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY_COMPLETION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RADIO_TOOL_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RADIO_TOOL_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEPARATOR_TOOL_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEPARATOR_TOOL_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOGGLE_TOOL_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOGGLE_TOOL_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_FILTER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_FILTER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_LAYOUT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_LAYOUT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CLIPBOARD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CLIPBOARD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ICON_THEME(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ICON_THEME((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOL_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOL_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOL_ITEM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOL_ITEM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCEL_MAP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCEL_MAP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ABOUT_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ABOUT_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_COMBO(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_COMBO((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_PROGRESS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_PROGRESS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ICON_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ICON_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_MENU_TOOL_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_TOOL_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ASSISTANT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ASSISTANT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_ACCEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_ACCEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_SPIN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_SPIN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LINK_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LINK_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_CHOOSER_MENU(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_CHOOSER_MENU((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_FILTER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_FILTER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_MANAGER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_MANAGER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_OPERATION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_OPERATION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_SETTINGS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_SETTINGS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOLTIP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOLTIP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#if GTK_CHECK_VERSION(2, 18, 0)
static s7_pointer lg_GTK_IS_INFO_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_INFO_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY_BUFFER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY_BUFFER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
static s7_pointer lg_GTK_IS_SPINNER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SPINNER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_SPINNER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_SPINNER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOL_PALETTE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOL_PALETTE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOL_ITEM_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOL_ITEM_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_GTK_IS_COMBO_BOX_TEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COMBO_BOX_TEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GRID(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GRID((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SWITCH(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SWITCH((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ORIENTABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ORIENTABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WINDOW_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WINDOW_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOL_SHELL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOL_SHELL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_GTK_IS_OVERLAY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_OVERLAY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_GTK_IS_APPLICATION_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_APPLICATION_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_GTK_IS_MENU_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEARCH_ENTRY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEARCH_ENTRY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LEVEL_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LEVEL_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_GTK_IS_PLACES_SIDEBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PLACES_SIDEBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STACK_SWITCHER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK_SWITCHER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STACK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_REVEALER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_REVEALER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_HEADER_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_HEADER_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_BOX_ROW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_BOX_ROW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEARCH_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEARCH_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_GTK_IS_FLOW_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FLOW_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FLOW_BOX_CHILD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FLOW_BOX_CHILD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACTION_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACTION_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_POPOVER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_POPOVER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_GTK_IS_GESTURE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_DRAG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_DRAG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_LONG_PRESS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_LONG_PRESS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_ZOOM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_ZOOM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_SWIPE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_SWIPE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_SINGLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_SINGLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_PAN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_PAN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_MULTI_PRESS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_MULTI_PRESS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_ROTATE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_ROTATE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_GTK_IS_GL_AREA(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GL_AREA((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_GL_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_GL_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_POPOVER_MENU(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_POPOVER_MENU((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STACK_SIDEBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK_SIDEBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_GDK_IS_SEAT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_SEAT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_GDK_IS_DEVICE_TOOL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE_TOOL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_MONITOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_MONITOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DRAWING_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DRAWING_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DEVICE_PAD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE_PAD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PAD_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PAD_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SHORTCUT_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SHORTCUT_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
static s7_pointer lg_GTK_IS_CENTER_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CENTER_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if (GTK_CHECK_VERSION(3, 90, 0))
static s7_pointer lg_gtk_init(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_init "void gtk_init(void)" 
  gtk_init();
  return(lg_false);
}
static s7_pointer lg_gtk_init_check(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_init_check "void gtk_init_check(void)" 
  gtk_init_check();
  return(lg_false);
}
#else
static s7_pointer lg_gtk_init(s7_scheme *sc, s7_pointer args)
{ 
  #define H_gtk_init "void gtk_init(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  s7_pointer argc = NULL, argv = NULL; 
  if (s7_is_pair(args)) {argc = s7_car(args); ref_argc = s7_integer(argc); if (s7_is_pair(s7_cdr(args))) argv = s7_cadr(args);}
  if ((argv) && (ref_argc > 0) && (s7_is_pair(argv)) && (ref_argc <= s7_list_length(sc, argv))) {
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    for (i = 0; i < ref_argc; i++, argv = s7_cdr(argv)) ref_argv[i] = (char *)s7_string(s7_car(argv));}
  }
  gtk_init(&ref_argc, &ref_argv);
  return(argc);
} 

static s7_pointer lg_gtk_init_check(s7_scheme *sc, s7_pointer args)
{ 
  #define H_gtk_init_check "gboolean gtk_init_check(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  s7_pointer argc = NULL, argv = NULL;
  if (s7_is_pair(args)) {argc = s7_car(args); ref_argc = s7_integer(argc); if (s7_is_pair(s7_cdr(args))) argv = s7_cadr(args);}
  if ((argv) && (ref_argc > 0) && (s7_is_pair(argv)) && (ref_argc <= s7_list_length(sc, argv))) {
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    for (i = 0; i < ref_argc; i++, argv = s7_cdr(argv)) ref_argv[i] = (char *)s7_string(s7_car(argv));}
  }
  gtk_init(&ref_argc, &ref_argv);
  return(argc);
} 

#endif

static s7_pointer lg_g_object_get(s7_scheme *sc, s7_pointer args)
{
  s7_pointer val, name, string_type;
  gint temp; gchar *str;
  val = s7_car(args);
  if (!s7_is_c_pointer(val)) s7_wrong_type_arg_error(sc, "g_object_get", 1, val, "gpointer");
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_object_get", 2, name, "string");
  string_type = s7_caddr(args);
  if (string_type == lg_false)
    {g_object_get((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), &temp, NULL); return(s7_make_integer(sc, temp));}
  else {g_object_get((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), &str, NULL); return(s7_make_string(sc, str));}
}

static s7_pointer lg_g_object_set(s7_scheme *sc, s7_pointer args)
{
  s7_pointer val, name, new_val;
  val = s7_car(args);
  if (!s7_is_c_pointer(val)) s7_wrong_type_arg_error(sc, "g_object_set", 1, val, "gpointer");
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_object_set", 2, name, "string");
  new_val = s7_caddr(args);
  if (s7_is_boolean(new_val))
    g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_boolean(sc, new_val), NULL);
  else
    {
      if (s7_is_number(new_val))
        g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_integer(new_val), NULL);
      else g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_string(new_val), NULL);
    }
  return(new_val);
}

static s7_pointer lg_gtk_event_keyval(s7_scheme *sc, s7_pointer args)
{
  GdkEventKey *e;
  e = (GdkEventKey*)s7_c_pointer(s7_car(args));
 if (e) return(s7_make_integer(sc, (int)(e->keyval)));
 return(s7_make_integer(sc, 0));
}

static s7_pointer lg_make_GtkTextIter(s7_scheme *sc, s7_pointer args)
{
  GtkTextIter* result;
  result = (GtkTextIter*)calloc(1, sizeof(GtkTextIter));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GtkTextIter_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_GtkTreeIter(s7_scheme *sc, s7_pointer args)
{
  GtkTreeIter* result;
  result = (GtkTreeIter*)calloc(1, sizeof(GtkTreeIter));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GtkTreeIter_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_PangoRectangle(s7_scheme *sc, s7_pointer args)
{
  PangoRectangle* result;
  result = (PangoRectangle*)calloc(1, sizeof(PangoRectangle));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "PangoRectangle_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_cairo_matrix_t(s7_scheme *sc, s7_pointer args)
{
  cairo_matrix_t* result;
  result = (cairo_matrix_t*)calloc(1, sizeof(cairo_matrix_t));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "cairo_matrix_t_"), make_xm_obj(sc, result)));
}

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_make_GdkRGBA(s7_scheme *sc, s7_pointer args)
{
  GdkRGBA* result;
  result = (GdkRGBA*)calloc(1, sizeof(GdkRGBA));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GdkRGBA_"), make_xm_obj(sc, result)));
}
#endif

static s7_pointer lg_gtk_text_view_get_iter_at_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_at_position "gboolean gtk_text_view_get_iter_at_position(GtkTextView* text_view, GtkTextIter* iter, gint* [trailing], gint x, gint y)"
  gint ref_trailing;
  s7_pointer text_view, iter, x, y, p;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 1, text_view, "GtkTextView*");
  iter = s7_cadr(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 2, iter, "GtkTextIter*");
  p = s7_cdddr(args); x = s7_car(p); y = s7_cadr(p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 4, x, "gint");
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 5, y, "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_text_view_get_iter_at_position((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), 
                                                                  &ref_trailing, s7_integer(x), s7_integer(y)));
    return(s7_list(sc, 2, result, s7_make_integer(sc, ref_trailing)));
   }
#else
  gtk_text_view_get_iter_at_position((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), &ref_trailing, s7_integer(x), s7_integer(y));
  return(s7_list(sc, 1, s7_make_integer(sc, (ref_trailing)));
#endif
}

static s7_pointer lg_gtk_text_view_get_iter_at_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_at_location "gboolean gtk_text_view_get_iter_at_location(GtkTextView* text_view, GtkTextIter* iter, gint x, gint y)"
  s7_pointer text_view, iter, x, y, p;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 1, text_view, "GtkTextView*");
  iter = s7_cadr(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 2, iter, "GtkTextIter*");
  p = s7_cddr(args); x = s7_car(p); y = s7_cadr(p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 4, x, "gint");
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 5, y, "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  return(s7_make_boolean(sc, gtk_text_view_get_iter_at_location((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), s7_integer(x), s7_integer(y))));
#else
  gtk_text_view_get_iter_at_location((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), s7_integer(x), s7_integer(y));
  return(lg_false);
#endif
}



static void define_structs(s7_scheme *sc)
{
  s7_define_function(sc, "GtkTextIter", lg_make_GtkTextIter, 0, 0, 0, "(GtkTextIter): a new GtkTextIter struct");
  s7_define_function(sc, "GtkTreeIter", lg_make_GtkTreeIter, 0, 0, 0, "(GtkTreeIter): a new GtkTreeIter struct");
  s7_define_function(sc, "PangoRectangle", lg_make_PangoRectangle, 0, 0, 0, "(PangoRectangle): a new PangoRectangle struct");
  s7_define_function(sc, "cairo_matrix_t", lg_make_cairo_matrix_t, 0, 0, 0, "(cairo_matrix_t): a new cairo_matrix_t struct");
  s7_define_function(sc, "gtk_text_view_get_iter_at_location", lg_gtk_text_view_get_iter_at_location, 4, 0, 0, H_gtk_text_view_get_iter_at_location);
  s7_define_function(sc, "gtk_text_view_get_iter_at_position", lg_gtk_text_view_get_iter_at_position, 4, 1, 0, H_gtk_text_view_get_iter_at_position);
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_function(sc, "GdkRGBA", lg_make_GdkRGBA, 0, 0, 0, "(GdkRGBA): a new GdkRGBA struct");
#endif
}

static void define_functions(s7_scheme *sc)
{
  s7_pointer s_boolean, s_integer, s_real, s_string, s_any, s_pair, s_float, s_gtk_enum_t, s_pair_false;
  s7_pointer pl_iur, pl_iugi, pl_iuisi, pl_iuuui, pl_iuuuui, pl_iuis, pl_iug, pl_pit, pl_piu, pl_ius, pl_iusi, pl_iu, pl_iuui, pl_pi, pl_iui, pl_iuisut, pl_t, pl_prrru, pl_tts, pl_tti, pl_dusr, pl_dusi, pl_dui, pl_du, pl_dus, pl_pr, pl_ssig, pl_ssi, pl_psgi, pl_suiig, pl_sug, pl_psiuub, pl_psgbiiiit, pl_psrrrb, pl_sui, pl_suuub, pl_psu, pl_psb, pl_su, pl_sus, pl_ps, pl_psg, pl_psi, pl_psugt, pl_psiu, pl_psiiuusu, pl_psut, pl_pur, pl_puuui, pl_pusiig, pl_pusiigu, pl_pusiiugu, pl_puuiig, pl_puur, pl_purru, pl_puiiui, pl_pugi, pl_puuig, pl_puttiiiu, pl_pubi, pl_puiig, pl_puiigi, pl_puigu, pl_puuusuug, pl_pusi, pl_pusiu, pl_putu, pl_puri, pl_pusub, pl_pust, pl_pub, pl_puuiu, pl_pugiiu, pl_pusu, pl_pu, pl_puiiu, pl_puuubu, pl_pugu, pl_puutuuiu, pl_puutu, pl_pui, pl_pussu, pl_puibu, pl_pus, pl_pug, pl_put, pl_pusigu, pl_pusig, pl_puui, pl_puiu, pl_pusiuiu, pl_pusiuibu, pl_pusiiu, pl_puuiiu, pl_b, pl_btiib, pl_bti, pl_bt, pl_tb, pl_g, pl_i, pl_tg, pl_tiu, pl_itiiub, pl_itsub, pl_itstttg, pl_itgiiut, pl_ti, pl_it, pl_s, pl_tsu, pl_tsb, pl_st, pl_tsig, pl_ts, pl_tsi, pl_tsiu, pl_tsiiuui, pl_tsiuui, pl_p, pl_tusiuiui, pl_tuuiu, pl_tussu, pl_tuuuggu, pl_tuuggu, pl_tugiis, pl_tubu, pl_tuurru, pl_tuurrrrgr, pl_tuurrrrg, pl_tuuur, pl_tusg, pl_tuuuui, pl_tugiiu, pl_tuusb, pl_tugui, pl_tuuugi, pl_tuuuub, pl_tuttti, pl_tuuttti, pl_tuisi, pl_tugb, pl_tugs, pl_tugug, pl_turgs, pl_tubi, pl_tuttigsi, pl_tuiiiiui, pl_tuurb, pl_tuuiiiirrrrg, pl_tuuiiiirrrrgi, pl_tuiggu, pl_turrrb, pl_tuubbig, pl_pt, pl_tuuti, pl_tubbi, pl_tuti, pl_tutti, pl_tutui, pl_tutisi, pl_tuuri, pl_tuusit, pl_tuurbr, pl_tuugi, pl_tuit, pl_tusr, pl_tusri, pl_tusi, pl_turi, pl_tuui, pl_tuur, pl_tuig, pl_tur, pl_tub, pl_tui, pl_tu, pl_tus, pl_tusb, pl_tut, pl_tuuut, pl_tug, pl_tutb, pl_tust, pl_tuub, pl_tuus, pl_tuug, pl_tuibu, pl_tuut, pl_tuuig, pl_tuguig, pl_tuubr, pl_tuuub, pl_tuuiuui, pl_tugu, pl_tuuir, pl_tugr, pl_tugi, pl_tuuui, pl_tuib, pl_tusu, pl_tuusi, pl_tugt, pl_tuis, pl_tubiiiu, pl_tuiu, pl_tusiis, pl_tuiiu, pl_tuuug, pl_tusuig, pl_tuuubr, pl_big, pl_bi, pl_bsu, pl_bsigb, pl_bur, pl_buug, pl_buigu, pl_buuti, pl_butib, pl_buiuig, pl_buuusuug, pl_buuit, pl_buti, pl_butti, pl_busi, pl_buusib, pl_busib, pl_buuuub, pl_buuub, pl_buttu, pl_busgu, pl_buurbr, pl_buui, pl_buus, pl_buuui, pl_bug, pl_bu, pl_bus, pl_busu, pl_but, pl_bui, pl_buib, pl_buiu, pl_bub, pl_buub, pl_pb, pl_buig, pl_buuig, pl_igi, pl_gi, pl_iiit, pl_iit, pl_sg, pl_gs, pl_isigutttiiu, pl_isi, pl_isgt, pl_sig, pl_si, pl_is, pl_gussitu, pl_gurrsiu, pl_gus, pl_guut, pl_guuut, pl_guugbuut, pl_pgr, pl_pgu, pl_pgi, pl_gug, pl_pgbi, pl_gu, pl_pg, pl_gui, pl_bpt;

  s_boolean = s7_make_symbol(sc, "boolean?");
  s_integer = s7_make_symbol(sc, "integer?");
  s_real = s7_make_symbol(sc, "real?");
  s_float = s7_make_symbol(sc, "float?");
  s_string = s7_make_symbol(sc, "string?");
  s_pair = s7_make_symbol(sc, "pair?");
  s_pair_false = s7_make_signature(sc, 2, s_pair, s_boolean);
  s_gtk_enum_t = s7_make_symbol(sc, "gtk_enum_t?");
  s_any = s7_t(sc);

  pl_iur = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_real);
  pl_iugi = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_gtk_enum_t, s_integer);
  pl_iuisi = s7_make_circular_signature(sc, 4, 5, s_integer, s_pair_false, s_integer, s_string, s_integer);
  pl_iuuui = s7_make_circular_signature(sc, 4, 5, s_integer, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuuuui = s7_make_circular_signature(sc, 5, 6, s_integer, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuis = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_integer, s_string);
  pl_iug = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_gtk_enum_t);
  pl_pit = s7_make_circular_signature(sc, 2, 3, s_pair, s_integer, s_any);
  pl_piu = s7_make_circular_signature(sc, 2, 3, s_pair, s_integer, s_pair_false);
  pl_ius = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_string);
  pl_iusi = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_string, s_integer);
  pl_iu = s7_make_circular_signature(sc, 1, 2, s_integer, s_pair_false);
  pl_iuui = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_pi = s7_make_circular_signature(sc, 1, 2, s_pair, s_integer);
  pl_iui = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_integer);
  pl_iuisut = s7_make_circular_signature(sc, 5, 6, s_integer, s_pair_false, s_integer, s_string, s_pair_false, s_any);
  pl_t = s7_make_circular_signature(sc, 0, 1, s_any);
  pl_prrru = s7_make_circular_signature(sc, 4, 5, s_pair, s_real, s_real, s_real, s_pair_false);
  pl_tts = s7_make_circular_signature(sc, 2, 3, s_any, s_any, s_string);
  pl_tti = s7_make_circular_signature(sc, 2, 3, s_any, s_any, s_integer);
  pl_dusr = s7_make_circular_signature(sc, 3, 4, s_float, s_pair_false, s_string, s_real);
  pl_dusi = s7_make_circular_signature(sc, 3, 4, s_float, s_pair_false, s_string, s_integer);
  pl_dui = s7_make_circular_signature(sc, 2, 3, s_float, s_pair_false, s_integer);
  pl_du = s7_make_circular_signature(sc, 1, 2, s_float, s_pair_false);
  pl_dus = s7_make_circular_signature(sc, 2, 3, s_float, s_pair_false, s_string);
  pl_pr = s7_make_circular_signature(sc, 1, 2, s_pair, s_real);
  pl_ssig = s7_make_circular_signature(sc, 3, 4, s_string, s_string, s_integer, s_gtk_enum_t);
  pl_ssi = s7_make_circular_signature(sc, 2, 3, s_string, s_string, s_integer);
  pl_psgi = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_gtk_enum_t, s_integer);
  pl_suiig = s7_make_circular_signature(sc, 4, 5, s_string, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_sug = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_gtk_enum_t);
  pl_psiuub = s7_make_circular_signature(sc, 5, 6, s_pair, s_string, s_integer, s_pair_false, s_pair_false, s_boolean);
  pl_psgbiiiit = s7_make_circular_signature(sc, 8, 9, s_pair, s_string, s_gtk_enum_t, s_boolean, s_integer, s_integer, s_integer, s_integer, s_any);
  pl_psrrrb = s7_make_circular_signature(sc, 5, 6, s_pair, s_string, s_real, s_real, s_real, s_boolean);
  pl_sui = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_integer);
  pl_suuub = s7_make_circular_signature(sc, 4, 5, s_string, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_psu = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_pair_false);
  pl_psb = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_boolean);
  pl_su = s7_make_circular_signature(sc, 1, 2, s_string, s_pair_false);
  pl_sus = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_string);
  pl_ps = s7_make_circular_signature(sc, 1, 2, s_pair, s_string);
  pl_psg = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_gtk_enum_t);
  pl_psi = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_integer);
  pl_psugt = s7_make_circular_signature(sc, 4, 5, s_pair, s_string, s_pair_false, s_gtk_enum_t, s_any);
  pl_psiu = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_integer, s_pair_false);
  pl_psiiuusu = s7_make_circular_signature(sc, 7, 8, s_pair, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_string, s_pair_false);
  pl_psut = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_pair_false, s_any);
  pl_pur = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_real);
  pl_puuui = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_pusiig = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_integer, s_gtk_enum_t);
  pl_pusiigu = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_integer, s_gtk_enum_t, s_pair_false);
  pl_pusiiugu = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_integer, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_puuiig = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_puur = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_pair_false, s_real);
  pl_purru = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_real, s_real, s_pair_false);
  pl_puiiui = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_pair_false, s_integer);
  pl_pugi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_integer);
  pl_puuig = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_pair_false, s_integer, s_gtk_enum_t);
  pl_puttiiiu = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_any, s_any, s_integer, s_integer, s_integer, s_pair_false);
  pl_pubi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_boolean, s_integer);
  pl_puiig = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_puiigi = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t, s_integer);
  pl_puigu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_gtk_enum_t, s_pair_false);
  pl_puuusuug = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_pusi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_integer);
  pl_pusiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_integer, s_pair_false);
  pl_putu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_any, s_pair_false);
  pl_puri = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_real, s_integer);
  pl_pusub = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_pair_false, s_boolean);
  pl_pust = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_any);
  pl_pub = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_boolean);
  pl_puuiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_pugiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
  pl_pusu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_pair_false);
  pl_pu = s7_make_circular_signature(sc, 1, 2, s_pair, s_pair_false);
  pl_puiiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_puuubu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_pair_false);
  pl_pugu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_puutuuiu = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_pair_false, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_puutu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_pair_false, s_any, s_pair_false);
  pl_pui = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_integer);
  pl_pussu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_string, s_pair_false);
  pl_puibu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_pus = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_string);
  pl_pug = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_gtk_enum_t);
  pl_put = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_any);
  pl_pusigu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_gtk_enum_t, s_pair_false);
  pl_pusig = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_integer, s_gtk_enum_t);
  pl_puui = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_pair_false, s_integer);
  pl_puiu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_integer, s_pair_false);
  pl_pusiuiu = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false);
  pl_pusiuibu = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_pusiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_integer, s_pair_false);
  pl_puuiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_b = s7_make_circular_signature(sc, 0, 1, s_boolean);
  pl_btiib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_any, s_integer, s_integer, s_boolean);
  pl_bti = s7_make_circular_signature(sc, 2, 3, s_boolean, s_any, s_integer);
  pl_bt = s7_make_circular_signature(sc, 1, 2, s_boolean, s_any);
  pl_tb = s7_make_circular_signature(sc, 1, 2, s_any, s_boolean);
  pl_g = s7_make_circular_signature(sc, 0, 1, s_gtk_enum_t);
  pl_i = s7_make_circular_signature(sc, 0, 1, s_integer);
  pl_tg = s7_make_circular_signature(sc, 1, 2, s_any, s_gtk_enum_t);
  pl_tiu = s7_make_circular_signature(sc, 2, 3, s_any, s_integer, s_pair_false);
  pl_itiiub = s7_make_circular_signature(sc, 5, 6, s_integer, s_any, s_integer, s_integer, s_pair_false, s_boolean);
  pl_itsub = s7_make_circular_signature(sc, 4, 5, s_integer, s_any, s_string, s_pair_false, s_boolean);
  pl_itstttg = s7_make_circular_signature(sc, 6, 7, s_integer, s_any, s_string, s_any, s_any, s_any, s_gtk_enum_t);
  pl_itgiiut = s7_make_circular_signature(sc, 6, 7, s_integer, s_any, s_gtk_enum_t, s_integer, s_integer, s_pair_false, s_any);
  pl_ti = s7_make_circular_signature(sc, 1, 2, s_any, s_integer);
  pl_it = s7_make_circular_signature(sc, 1, 2, s_integer, s_any);
  pl_s = s7_make_circular_signature(sc, 0, 1, s_string);
  pl_tsu = s7_make_circular_signature(sc, 2, 3, s_any, s_string, s_pair_false);
  pl_tsb = s7_make_circular_signature(sc, 2, 3, s_any, s_string, s_boolean);
  pl_st = s7_make_circular_signature(sc, 1, 2, s_string, s_any);
  pl_tsig = s7_make_circular_signature(sc, 3, 4, s_any, s_string, s_integer, s_gtk_enum_t);
  pl_ts = s7_make_circular_signature(sc, 1, 2, s_any, s_string);
  pl_tsi = s7_make_circular_signature(sc, 2, 3, s_any, s_string, s_integer);
  pl_tsiu = s7_make_circular_signature(sc, 3, 4, s_any, s_string, s_integer, s_pair_false);
  pl_tsiiuui = s7_make_circular_signature(sc, 6, 7, s_any, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tsiuui = s7_make_circular_signature(sc, 5, 6, s_any, s_string, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_p = s7_make_circular_signature(sc, 0, 1, s_pair);
  pl_tusiuiui = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false, s_integer);
  pl_tuuiu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_tussu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_string, s_string, s_pair_false);
  pl_tuuuggu = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_tuuggu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_tugiis = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_string);
  pl_tubu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_boolean, s_pair_false);
  pl_tuurru = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_real, s_pair_false);
  pl_tuurrrrgr = s7_make_circular_signature(sc, 8, 9, s_any, s_pair_false, s_pair_false, s_real, s_real, s_real, s_real, s_gtk_enum_t, s_real);
  pl_tuurrrrg = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_pair_false, s_real, s_real, s_real, s_real, s_gtk_enum_t);
  pl_tuuur = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_real);
  pl_tusg = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_gtk_enum_t);
  pl_tuuuui = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_tugiiu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
  pl_tuusb = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_string, s_boolean);
  pl_tugui = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_integer);
  pl_tuuugi = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuuuub = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_tuttti = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_any, s_any, s_any, s_integer);
  pl_tuuttti = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_any, s_any, s_any, s_integer);
  pl_tuisi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_string, s_integer);
  pl_tugb = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_boolean);
  pl_tugs = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_string);
  pl_tugug = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_turgs = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_real, s_gtk_enum_t, s_string);
  pl_tubi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_boolean, s_integer);
  pl_tuttigsi = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_any, s_any, s_integer, s_gtk_enum_t, s_string, s_integer);
  pl_tuiiiiui = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_pair_false, s_integer);
  pl_tuurb = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_boolean);
  pl_tuuiiiirrrrg = s7_make_circular_signature(sc, 11, 12, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t);
  pl_tuuiiiirrrrgi = s7_make_circular_signature(sc, 12, 13, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t, s_integer);
  pl_tuiggu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_integer, s_gtk_enum_t, s_gtk_enum_t, s_pair_false);
  pl_turrrb = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_real, s_real, s_real, s_boolean);
  pl_tuubbig = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_boolean, s_boolean, s_integer, s_gtk_enum_t);
  pl_pt = s7_make_circular_signature(sc, 1, 2, s_pair, s_any);
  pl_tuuti = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_any, s_integer);
  pl_tubbi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_boolean, s_boolean, s_integer);
  pl_tuti = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_any, s_integer);
  pl_tutti = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_any, s_any, s_integer);
  pl_tutui = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_any, s_pair_false, s_integer);
  pl_tutisi = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_any, s_integer, s_string, s_integer);
  pl_tuuri = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_integer);
  pl_tuusit = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_string, s_integer, s_any);
  pl_tuurbr = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_tuugi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuit = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_any);
  pl_tusr = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_real);
  pl_tusri = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_string, s_real, s_integer);
  pl_tusi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_integer);
  pl_turi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_real, s_integer);
  pl_tuui = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_integer);
  pl_tuur = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_real);
  pl_tuig = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tur = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_real);
  pl_tub = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_boolean);
  pl_tui = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_integer);
  pl_tu = s7_make_circular_signature(sc, 1, 2, s_any, s_pair_false);
  pl_tus = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_string);
  pl_tusb = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_boolean);
  pl_tut = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_any);
  pl_tuuut = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_tug = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_gtk_enum_t);
  pl_tutb = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_any, s_boolean);
  pl_tust = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_any);
  pl_tuub = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_boolean);
  pl_tuus = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_string);
  pl_tuug = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_tuibu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_tuut = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_any);
  pl_tuuig = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuguig = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuubr = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_tuuub = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_tuuiuui = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tugu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_tuuir = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_real);
  pl_tugr = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_real);
  pl_tugi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuuui = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_tuib = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_boolean);
  pl_tusu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_pair_false);
  pl_tuusi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_string, s_integer);
  pl_tugt = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_any);
  pl_tuis = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_string);
  pl_tubiiiu = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_boolean, s_integer, s_integer, s_integer, s_pair_false);
  pl_tuiu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_pair_false);
  pl_tusiis = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_string, s_integer, s_integer, s_string);
  pl_tuiiu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_tuuug = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_tusuig = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_string, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuuubr = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_big = s7_make_circular_signature(sc, 2, 3, s_boolean, s_integer, s_gtk_enum_t);
  pl_bi = s7_make_circular_signature(sc, 1, 2, s_boolean, s_integer);
  pl_bsu = s7_make_circular_signature(sc, 2, 3, s_boolean, s_string, s_pair_false);
  pl_bsigb = s7_make_circular_signature(sc, 4, 5, s_boolean, s_string, s_integer, s_gtk_enum_t, s_boolean);
  pl_bur = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_real);
  pl_buug = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_buigu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_integer, s_gtk_enum_t, s_pair_false);
  pl_buuti = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_any, s_integer);
  pl_butib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_any, s_integer, s_boolean);
  pl_buiuig = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_integer, s_pair_false, s_integer, s_gtk_enum_t);
  pl_buuusuug = s7_make_circular_signature(sc, 7, 8, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_buuit = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_integer, s_any);
  pl_buti = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_any, s_integer);
  pl_butti = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_any, s_any, s_integer);
  pl_busi = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_string, s_integer);
  pl_buusib = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_string, s_integer, s_boolean);
  pl_busib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_string, s_integer, s_boolean);
  pl_buuuub = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buuub = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buttu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_any, s_any, s_pair_false);
  pl_busgu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_string, s_gtk_enum_t, s_pair_false);
  pl_buurbr = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_buui = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_integer);
  pl_buus = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_string);
  pl_buuui = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_bug = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_gtk_enum_t);
  pl_bu = s7_make_circular_signature(sc, 1, 2, s_boolean, s_pair_false);
  pl_bus = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_string);
  pl_busu = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_string, s_pair_false);
  pl_but = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_any);
  pl_bui = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_integer);
  pl_buib = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_integer, s_boolean);
  pl_buiu = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_integer, s_pair_false);
  pl_bub = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_boolean);
  pl_buub = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_boolean);
  pl_pb = s7_make_circular_signature(sc, 1, 2, s_pair, s_boolean);
  pl_buig = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_integer, s_gtk_enum_t);
  pl_buuig = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_integer, s_gtk_enum_t);
  pl_igi = s7_make_circular_signature(sc, 2, 3, s_integer, s_gtk_enum_t, s_integer);
  pl_gi = s7_make_circular_signature(sc, 1, 2, s_gtk_enum_t, s_integer);
  pl_iiit = s7_make_circular_signature(sc, 3, 4, s_integer, s_integer, s_integer, s_any);
  pl_iit = s7_make_circular_signature(sc, 2, 3, s_integer, s_integer, s_any);
  pl_sg = s7_make_circular_signature(sc, 1, 2, s_string, s_gtk_enum_t);
  pl_gs = s7_make_circular_signature(sc, 1, 2, s_gtk_enum_t, s_string);
  pl_isigutttiiu = s7_make_circular_signature(sc, 10, 11, s_integer, s_string, s_integer, s_gtk_enum_t, s_pair_false, s_any, s_any, s_any, s_integer, s_integer, s_pair_false);
  pl_isi = s7_make_circular_signature(sc, 2, 3, s_integer, s_string, s_integer);
  pl_isgt = s7_make_circular_signature(sc, 3, 4, s_integer, s_string, s_gtk_enum_t, s_any);
  pl_sig = s7_make_circular_signature(sc, 2, 3, s_string, s_integer, s_gtk_enum_t);
  pl_si = s7_make_circular_signature(sc, 1, 2, s_string, s_integer);
  pl_is = s7_make_circular_signature(sc, 1, 2, s_integer, s_string);
  pl_gussitu = s7_make_circular_signature(sc, 6, 7, s_gtk_enum_t, s_pair_false, s_string, s_string, s_integer, s_any, s_pair_false);
  pl_gurrsiu = s7_make_circular_signature(sc, 6, 7, s_gtk_enum_t, s_pair_false, s_real, s_real, s_string, s_integer, s_pair_false);
  pl_gus = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_string);
  pl_guut = s7_make_circular_signature(sc, 3, 4, s_gtk_enum_t, s_pair_false, s_pair_false, s_any);
  pl_guuut = s7_make_circular_signature(sc, 4, 5, s_gtk_enum_t, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_guugbuut = s7_make_circular_signature(sc, 7, 8, s_gtk_enum_t, s_pair_false, s_pair_false, s_gtk_enum_t, s_boolean, s_pair_false, s_pair_false, s_any);
  pl_pgr = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_real);
  pl_pgu = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_pair_false);
  pl_pgi = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_integer);
  pl_gug = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_pgbi = s7_make_circular_signature(sc, 3, 4, s_pair, s_gtk_enum_t, s_boolean, s_integer);
  pl_gu = s7_make_circular_signature(sc, 1, 2, s_gtk_enum_t, s_pair_false);
  pl_pg = s7_make_circular_signature(sc, 1, 2, s_pair, s_gtk_enum_t);
  pl_gui = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_integer);
  pl_bpt = s7_make_signature(sc, 2, s_pair_false, s_any);

  s7_define_typed_function(sc, "g_unichar_validate", lg_g_unichar_validate, 1, 0, 0, H_g_unichar_validate, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isalnum", lg_g_unichar_isalnum, 1, 0, 0, H_g_unichar_isalnum, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isalpha", lg_g_unichar_isalpha, 1, 0, 0, H_g_unichar_isalpha, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iscntrl", lg_g_unichar_iscntrl, 1, 0, 0, H_g_unichar_iscntrl, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isdefined", lg_g_unichar_isdefined, 1, 0, 0, H_g_unichar_isdefined, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isdigit", lg_g_unichar_isdigit, 1, 0, 0, H_g_unichar_isdigit, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isgraph", lg_g_unichar_isgraph, 1, 0, 0, H_g_unichar_isgraph, pl_bi);
  s7_define_typed_function(sc, "g_unichar_islower", lg_g_unichar_islower, 1, 0, 0, H_g_unichar_islower, pl_bi);
  s7_define_typed_function(sc, "g_unichar_ismark", lg_g_unichar_ismark, 1, 0, 0, H_g_unichar_ismark, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isprint", lg_g_unichar_isprint, 1, 0, 0, H_g_unichar_isprint, pl_bi);
  s7_define_typed_function(sc, "g_unichar_ispunct", lg_g_unichar_ispunct, 1, 0, 0, H_g_unichar_ispunct, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isspace", lg_g_unichar_isspace, 1, 0, 0, H_g_unichar_isspace, pl_bi);
  s7_define_typed_function(sc, "g_unichar_istitle", lg_g_unichar_istitle, 1, 0, 0, H_g_unichar_istitle, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isupper", lg_g_unichar_isupper, 1, 0, 0, H_g_unichar_isupper, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isxdigit", lg_g_unichar_isxdigit, 1, 0, 0, H_g_unichar_isxdigit, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iswide", lg_g_unichar_iswide, 1, 0, 0, H_g_unichar_iswide, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iswide_cjk", lg_g_unichar_iswide_cjk, 1, 0, 0, H_g_unichar_iswide_cjk, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iszerowidth", lg_g_unichar_iszerowidth, 1, 0, 0, H_g_unichar_iszerowidth, pl_bi);
  s7_define_typed_function(sc, "g_unichar_toupper", lg_g_unichar_toupper, 1, 0, 0, H_g_unichar_toupper, pl_i);
  s7_define_typed_function(sc, "g_unichar_tolower", lg_g_unichar_tolower, 1, 0, 0, H_g_unichar_tolower, pl_i);
  s7_define_typed_function(sc, "g_unichar_totitle", lg_g_unichar_totitle, 1, 0, 0, H_g_unichar_totitle, pl_i);
  s7_define_typed_function(sc, "g_unichar_digit_value", lg_g_unichar_digit_value, 1, 0, 0, H_g_unichar_digit_value, pl_i);
  s7_define_typed_function(sc, "g_unichar_xdigit_value", lg_g_unichar_xdigit_value, 1, 0, 0, H_g_unichar_xdigit_value, pl_i);
  s7_define_typed_function(sc, "g_unichar_combining_class", lg_g_unichar_combining_class, 1, 0, 0, H_g_unichar_combining_class, pl_i);
  s7_define_typed_function(sc, "g_unicode_canonical_ordering", lg_g_unicode_canonical_ordering, 2, 0, 0, H_g_unicode_canonical_ordering, pl_tsi);
  s7_define_typed_function(sc, "g_utf8_get_char", lg_g_utf8_get_char, 1, 0, 0, H_g_utf8_get_char, pl_is);
  s7_define_typed_function(sc, "g_utf8_get_char_validated", lg_g_utf8_get_char_validated, 2, 0, 0, H_g_utf8_get_char_validated, pl_isi);
  s7_define_typed_function(sc, "g_utf8_prev_char", lg_g_utf8_prev_char, 1, 0, 0, H_g_utf8_prev_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_find_next_char", lg_g_utf8_find_next_char, 2, 0, 0, H_g_utf8_find_next_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_find_prev_char", lg_g_utf8_find_prev_char, 2, 0, 0, H_g_utf8_find_prev_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_strlen", lg_g_utf8_strlen, 2, 0, 0, H_g_utf8_strlen, pl_isi);
  s7_define_typed_function(sc, "g_utf8_strchr", lg_g_utf8_strchr, 3, 0, 0, H_g_utf8_strchr, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strrchr", lg_g_utf8_strrchr, 3, 0, 0, H_g_utf8_strrchr, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strreverse", lg_g_utf8_strreverse, 2, 0, 0, H_g_utf8_strreverse, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_validate", lg_g_utf8_validate, 2, 1, 0, H_g_utf8_validate, pl_psiu);
  s7_define_typed_function(sc, "g_utf8_strup", lg_g_utf8_strup, 2, 0, 0, H_g_utf8_strup, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strdown", lg_g_utf8_strdown, 2, 0, 0, H_g_utf8_strdown, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_casefold", lg_g_utf8_casefold, 2, 0, 0, H_g_utf8_casefold, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_normalize", lg_g_utf8_normalize, 3, 0, 0, H_g_utf8_normalize, pl_ssig);
  s7_define_typed_function(sc, "g_utf8_collate", lg_g_utf8_collate, 2, 0, 0, H_g_utf8_collate, pl_is);
  s7_define_typed_function(sc, "g_utf8_collate_key", lg_g_utf8_collate_key, 2, 0, 0, H_g_utf8_collate_key, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_collate_key_for_filename", lg_g_utf8_collate_key_for_filename, 2, 0, 0, H_g_utf8_collate_key_for_filename, pl_ssi);
  s7_define_typed_function(sc, "g_cclosure_new", lg_g_cclosure_new, 3, 0, 0, H_g_cclosure_new, pl_pt);
  s7_define_typed_function(sc, "g_signal_newv", lg_g_signal_newv, 0, 0, 1, H_g_signal_newv, pl_isigutttiiu);
  s7_define_typed_function(sc, "g_signal_lookup", lg_g_signal_lookup, 2, 0, 0, H_g_signal_lookup, pl_isi);
  s7_define_typed_function(sc, "g_signal_name", lg_g_signal_name, 1, 0, 0, H_g_signal_name, pl_si);
  s7_define_typed_function(sc, "g_signal_query", lg_g_signal_query, 2, 0, 0, H_g_signal_query, pl_tiu);
  s7_define_typed_function(sc, "g_signal_list_ids", lg_g_signal_list_ids, 2, 0, 0, H_g_signal_list_ids, pl_piu);
  s7_define_typed_function(sc, "g_signal_parse_name", lg_g_signal_parse_name, 3, 2, 0, H_g_signal_parse_name, pl_psiuub);
  s7_define_typed_function(sc, "g_signal_get_invocation_hint", lg_g_signal_get_invocation_hint, 1, 0, 0, H_g_signal_get_invocation_hint, pl_pt);
  s7_define_typed_function(sc, "g_signal_stop_emission", lg_g_signal_stop_emission, 3, 0, 0, H_g_signal_stop_emission, pl_tti);
  s7_define_typed_function(sc, "g_signal_stop_emission_by_name", lg_g_signal_stop_emission_by_name, 2, 0, 0, H_g_signal_stop_emission_by_name, pl_tts);
  s7_define_typed_function(sc, "g_signal_add_emission_hook", lg_g_signal_add_emission_hook, 5, 0, 0, H_g_signal_add_emission_hook, pl_iiit);
  s7_define_typed_function(sc, "g_signal_remove_emission_hook", lg_g_signal_remove_emission_hook, 2, 0, 0, H_g_signal_remove_emission_hook, pl_ti);
  s7_define_typed_function(sc, "g_signal_has_handler_pending", lg_g_signal_has_handler_pending, 4, 0, 0, H_g_signal_has_handler_pending, pl_btiib);
  s7_define_typed_function(sc, "g_signal_connect_closure_by_id", lg_g_signal_connect_closure_by_id, 5, 0, 0, H_g_signal_connect_closure_by_id, pl_itiiub);
  s7_define_typed_function(sc, "g_signal_connect_closure", lg_g_signal_connect_closure, 4, 0, 0, H_g_signal_connect_closure, pl_itsub);
  s7_define_typed_function(sc, "g_signal_connect_data", lg_g_signal_connect_data, 6, 0, 0, H_g_signal_connect_data, pl_itstttg);
  s7_define_typed_function(sc, "g_signal_handler_block", lg_g_signal_handler_block, 2, 0, 0, H_g_signal_handler_block, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_unblock", lg_g_signal_handler_unblock, 2, 0, 0, H_g_signal_handler_unblock, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_disconnect", lg_g_signal_handler_disconnect, 2, 0, 0, H_g_signal_handler_disconnect, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_is_connected", lg_g_signal_handler_is_connected, 2, 0, 0, H_g_signal_handler_is_connected, pl_bti);
  s7_define_typed_function(sc, "g_signal_handler_find", lg_g_signal_handler_find, 7, 0, 0, H_g_signal_handler_find, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_block_matched", lg_g_signal_handlers_block_matched, 7, 0, 0, H_g_signal_handlers_block_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_unblock_matched", lg_g_signal_handlers_unblock_matched, 7, 0, 0, H_g_signal_handlers_unblock_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_disconnect_matched", lg_g_signal_handlers_disconnect_matched, 7, 0, 0, H_g_signal_handlers_disconnect_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_destroy", lg_g_signal_handlers_destroy, 1, 0, 0, H_g_signal_handlers_destroy, pl_t);
  s7_define_typed_function(sc, "g_object_ref", lg_g_object_ref, 1, 0, 0, H_g_object_ref, pl_t);
  s7_define_typed_function(sc, "g_object_unref", lg_g_object_unref, 1, 0, 0, H_g_object_unref, pl_t);
  s7_define_typed_function(sc, "gdk_cursor_new_for_display", lg_gdk_cursor_new_for_display, 2, 0, 0, H_gdk_cursor_new_for_display, pl_pug);
  s7_define_typed_function(sc, "gdk_cursor_get_display", lg_gdk_cursor_get_display, 1, 0, 0, H_gdk_cursor_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_status", lg_gdk_drag_status, 3, 0, 0, H_gdk_drag_status, pl_tugi);
  s7_define_typed_function(sc, "gdk_drop_reply", lg_gdk_drop_reply, 3, 0, 0, H_gdk_drop_reply, pl_tubi);
  s7_define_typed_function(sc, "gdk_drop_finish", lg_gdk_drop_finish, 3, 0, 0, H_gdk_drop_finish, pl_tubi);
  s7_define_typed_function(sc, "gdk_drag_get_selection", lg_gdk_drag_get_selection, 1, 0, 0, H_gdk_drag_get_selection, pl_tu);
  s7_define_typed_function(sc, "gdk_drag_begin", lg_gdk_drag_begin, 2, 0, 0, H_gdk_drag_begin, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_drop", lg_gdk_drag_drop, 2, 0, 0, H_gdk_drag_drop, pl_tui);
  s7_define_typed_function(sc, "gdk_drag_abort", lg_gdk_drag_abort, 2, 0, 0, H_gdk_drag_abort, pl_tui);
  s7_define_typed_function(sc, "gdk_events_pending", lg_gdk_events_pending, 0, 0, 0, H_gdk_events_pending, pl_b);
  s7_define_typed_function(sc, "gdk_event_get", lg_gdk_event_get, 0, 0, 0, H_gdk_event_get, pl_p);
  s7_define_typed_function(sc, "gdk_event_peek", lg_gdk_event_peek, 0, 0, 0, H_gdk_event_peek, pl_p);
  s7_define_typed_function(sc, "gdk_event_put", lg_gdk_event_put, 1, 0, 0, H_gdk_event_put, pl_tu);
  s7_define_typed_function(sc, "gdk_event_copy", lg_gdk_event_copy, 1, 0, 0, H_gdk_event_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_event_free", lg_gdk_event_free, 1, 0, 0, H_gdk_event_free, pl_tu);
  s7_define_typed_function(sc, "gdk_event_get_time", lg_gdk_event_get_time, 1, 0, 0, H_gdk_event_get_time, pl_iu);
  s7_define_typed_function(sc, "gdk_event_get_state", lg_gdk_event_get_state, 1, 1, 0, H_gdk_event_get_state, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_coords", lg_gdk_event_get_coords, 1, 2, 0, H_gdk_event_get_coords, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_root_coords", lg_gdk_event_get_root_coords, 1, 2, 0, H_gdk_event_get_root_coords, pl_pu);
  s7_define_typed_function(sc, "gdk_event_handler_set", lg_gdk_event_handler_set, 3, 0, 0, H_gdk_event_handler_set, pl_t);
  s7_define_typed_function(sc, "gdk_set_show_events", lg_gdk_set_show_events, 1, 0, 0, H_gdk_set_show_events, pl_tb);
  s7_define_typed_function(sc, "gdk_get_show_events", lg_gdk_get_show_events, 0, 0, 0, H_gdk_get_show_events, pl_b);
  s7_define_typed_function(sc, "gdk_init", lg_gdk_init, 0, 2, 0, H_gdk_init, pl_pu);
  s7_define_typed_function(sc, "gdk_init_check", lg_gdk_init_check, 0, 2, 0, H_gdk_init_check, pl_pu);
  s7_define_typed_function(sc, "gdk_get_program_class", lg_gdk_get_program_class, 0, 0, 0, H_gdk_get_program_class, pl_s);
  s7_define_typed_function(sc, "gdk_set_program_class", lg_gdk_set_program_class, 1, 0, 0, H_gdk_set_program_class, pl_ts);
  s7_define_typed_function(sc, "gdk_error_trap_push", lg_gdk_error_trap_push, 0, 0, 0, H_gdk_error_trap_push, pl_t);
  s7_define_typed_function(sc, "gdk_error_trap_pop", lg_gdk_error_trap_pop, 0, 0, 0, H_gdk_error_trap_pop, pl_i);
  s7_define_typed_function(sc, "gdk_get_display_arg_name", lg_gdk_get_display_arg_name, 0, 0, 0, H_gdk_get_display_arg_name, pl_s);
  s7_define_typed_function(sc, "gdk_notify_startup_complete", lg_gdk_notify_startup_complete, 0, 0, 0, H_gdk_notify_startup_complete, pl_t);
  s7_define_typed_function(sc, "gdk_flush", lg_gdk_flush, 0, 0, 0, H_gdk_flush, pl_t);
  s7_define_typed_function(sc, "gdk_beep", lg_gdk_beep, 0, 0, 0, H_gdk_beep, pl_t);
  s7_define_typed_function(sc, "gdk_set_double_click_time", lg_gdk_set_double_click_time, 1, 0, 0, H_gdk_set_double_click_time, pl_ti);
  s7_define_typed_function(sc, "gdk_rectangle_intersect", lg_gdk_rectangle_intersect, 3, 0, 0, H_gdk_rectangle_intersect, pl_bu);
  s7_define_typed_function(sc, "gdk_rectangle_union", lg_gdk_rectangle_union, 3, 0, 0, H_gdk_rectangle_union, pl_tu);
  s7_define_typed_function(sc, "gdk_keymap_get_default", lg_gdk_keymap_get_default, 0, 0, 0, H_gdk_keymap_get_default, pl_p);
  s7_define_typed_function(sc, "gdk_keymap_lookup_key", lg_gdk_keymap_lookup_key, 2, 0, 0, H_gdk_keymap_lookup_key, pl_iu);
  s7_define_typed_function(sc, "gdk_keymap_get_entries_for_keyval", lg_gdk_keymap_get_entries_for_keyval, 2, 2, 0, H_gdk_keymap_get_entries_for_keyval, pl_puiu);
  s7_define_typed_function(sc, "gdk_keymap_get_entries_for_keycode", lg_gdk_keymap_get_entries_for_keycode, 2, 3, 0, H_gdk_keymap_get_entries_for_keycode, pl_puiu);
  s7_define_typed_function(sc, "gdk_keymap_get_direction", lg_gdk_keymap_get_direction, 1, 0, 0, H_gdk_keymap_get_direction, pl_gu);
  s7_define_typed_function(sc, "gdk_keyval_name", lg_gdk_keyval_name, 1, 0, 0, H_gdk_keyval_name, pl_si);
  s7_define_typed_function(sc, "gdk_keyval_from_name", lg_gdk_keyval_from_name, 1, 0, 0, H_gdk_keyval_from_name, pl_is);
  s7_define_typed_function(sc, "gdk_keyval_convert_case", lg_gdk_keyval_convert_case, 1, 2, 0, H_gdk_keyval_convert_case, pl_piu);
  s7_define_typed_function(sc, "gdk_keyval_to_upper", lg_gdk_keyval_to_upper, 1, 0, 0, H_gdk_keyval_to_upper, pl_i);
  s7_define_typed_function(sc, "gdk_keyval_to_lower", lg_gdk_keyval_to_lower, 1, 0, 0, H_gdk_keyval_to_lower, pl_i);
  s7_define_typed_function(sc, "gdk_keyval_is_upper", lg_gdk_keyval_is_upper, 1, 0, 0, H_gdk_keyval_is_upper, pl_bi);
  s7_define_typed_function(sc, "gdk_keyval_is_lower", lg_gdk_keyval_is_lower, 1, 0, 0, H_gdk_keyval_is_lower, pl_bi);
  s7_define_typed_function(sc, "gdk_keyval_to_unicode", lg_gdk_keyval_to_unicode, 1, 0, 0, H_gdk_keyval_to_unicode, pl_i);
  s7_define_typed_function(sc, "gdk_unicode_to_keyval", lg_gdk_unicode_to_keyval, 1, 0, 0, H_gdk_unicode_to_keyval, pl_i);
  s7_define_typed_function(sc, "gdk_pango_context_get", lg_gdk_pango_context_get, 0, 0, 0, H_gdk_pango_context_get, pl_p);
  s7_define_typed_function(sc, "gdk_atom_intern", lg_gdk_atom_intern, 2, 0, 0, H_gdk_atom_intern, pl_tsb);
  s7_define_typed_function(sc, "gdk_atom_name", lg_gdk_atom_name, 1, 0, 0, H_gdk_atom_name, pl_st);
  s7_define_typed_function(sc, "gdk_property_get", lg_gdk_property_get, 0, 0, 1, H_gdk_property_get, pl_puttiiiu);
  s7_define_typed_function(sc, "gdk_property_change", lg_gdk_property_change, 7, 0, 0, H_gdk_property_change, pl_tuttigsi);
  s7_define_typed_function(sc, "gdk_property_delete", lg_gdk_property_delete, 2, 0, 0, H_gdk_property_delete, pl_tut);
  s7_define_typed_function(sc, "gdk_utf8_to_string_target", lg_gdk_utf8_to_string_target, 1, 0, 0, H_gdk_utf8_to_string_target, pl_s);
  s7_define_typed_function(sc, "gdk_selection_owner_set", lg_gdk_selection_owner_set, 4, 0, 0, H_gdk_selection_owner_set, pl_butib);
  s7_define_typed_function(sc, "gdk_selection_owner_get", lg_gdk_selection_owner_get, 1, 0, 0, H_gdk_selection_owner_get, pl_pt);
  s7_define_typed_function(sc, "gdk_selection_convert", lg_gdk_selection_convert, 4, 0, 0, H_gdk_selection_convert, pl_tutti);
  s7_define_typed_function(sc, "gdk_selection_property_get", lg_gdk_selection_property_get, 1, 3, 0, H_gdk_selection_property_get, pl_pu);
  s7_define_typed_function(sc, "gdk_window_destroy", lg_gdk_window_destroy, 1, 0, 0, H_gdk_window_destroy, pl_tu);
  s7_define_typed_function(sc, "gdk_window_get_window_type", lg_gdk_window_get_window_type, 1, 0, 0, H_gdk_window_get_window_type, pl_gu);
  s7_define_typed_function(sc, "gdk_window_show", lg_gdk_window_show, 1, 0, 0, H_gdk_window_show, pl_tu);
  s7_define_typed_function(sc, "gdk_window_hide", lg_gdk_window_hide, 1, 0, 0, H_gdk_window_hide, pl_tu);
  s7_define_typed_function(sc, "gdk_window_withdraw", lg_gdk_window_withdraw, 1, 0, 0, H_gdk_window_withdraw, pl_tu);
  s7_define_typed_function(sc, "gdk_window_show_unraised", lg_gdk_window_show_unraised, 1, 0, 0, H_gdk_window_show_unraised, pl_tu);
  s7_define_typed_function(sc, "gdk_window_move", lg_gdk_window_move, 3, 0, 0, H_gdk_window_move, pl_tui);
  s7_define_typed_function(sc, "gdk_window_resize", lg_gdk_window_resize, 3, 0, 0, H_gdk_window_resize, pl_tui);
  s7_define_typed_function(sc, "gdk_window_move_resize", lg_gdk_window_move_resize, 5, 0, 0, H_gdk_window_move_resize, pl_tui);
  s7_define_typed_function(sc, "gdk_window_raise", lg_gdk_window_raise, 1, 0, 0, H_gdk_window_raise, pl_tu);
  s7_define_typed_function(sc, "gdk_window_lower", lg_gdk_window_lower, 1, 0, 0, H_gdk_window_lower, pl_tu);
  s7_define_typed_function(sc, "gdk_window_focus", lg_gdk_window_focus, 2, 0, 0, H_gdk_window_focus, pl_tui);
  s7_define_typed_function(sc, "gdk_window_set_user_data", lg_gdk_window_set_user_data, 2, 0, 0, H_gdk_window_set_user_data, pl_tut);
  s7_define_typed_function(sc, "gdk_window_add_filter", lg_gdk_window_add_filter, 2, 1, 0, H_gdk_window_add_filter, pl_tut);
  s7_define_typed_function(sc, "gdk_window_remove_filter", lg_gdk_window_remove_filter, 2, 1, 0, H_gdk_window_remove_filter, pl_tut);
  s7_define_typed_function(sc, "gdk_window_scroll", lg_gdk_window_scroll, 3, 0, 0, H_gdk_window_scroll, pl_tui);
  s7_define_typed_function(sc, "gdk_window_set_child_shapes", lg_gdk_window_set_child_shapes, 1, 0, 0, H_gdk_window_set_child_shapes, pl_tu);
  s7_define_typed_function(sc, "gdk_window_merge_child_shapes", lg_gdk_window_merge_child_shapes, 1, 0, 0, H_gdk_window_merge_child_shapes, pl_tu);
  s7_define_typed_function(sc, "gdk_window_is_visible", lg_gdk_window_is_visible, 1, 0, 0, H_gdk_window_is_visible, pl_bu);
  s7_define_typed_function(sc, "gdk_window_is_viewable", lg_gdk_window_is_viewable, 1, 0, 0, H_gdk_window_is_viewable, pl_bu);
  s7_define_typed_function(sc, "gdk_window_get_state", lg_gdk_window_get_state, 1, 0, 0, H_gdk_window_get_state, pl_gu);
  s7_define_typed_function(sc, "gdk_window_get_root_origin", lg_gdk_window_get_root_origin, 1, 2, 0, H_gdk_window_get_root_origin, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_frame_extents", lg_gdk_window_get_frame_extents, 2, 0, 0, H_gdk_window_get_frame_extents, pl_tu);
  s7_define_typed_function(sc, "gdk_window_get_parent", lg_gdk_window_get_parent, 1, 0, 0, H_gdk_window_get_parent, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_toplevel", lg_gdk_window_get_toplevel, 1, 0, 0, H_gdk_window_get_toplevel, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_children", lg_gdk_window_get_children, 1, 0, 0, H_gdk_window_get_children, pl_pu);
  s7_define_typed_function(sc, "gdk_window_peek_children", lg_gdk_window_peek_children, 1, 0, 0, H_gdk_window_peek_children, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_events", lg_gdk_window_get_events, 1, 0, 0, H_gdk_window_get_events, pl_gu);
  s7_define_typed_function(sc, "gdk_window_set_events", lg_gdk_window_set_events, 2, 0, 0, H_gdk_window_set_events, pl_tug);
  s7_define_typed_function(sc, "gdk_window_set_icon_list", lg_gdk_window_set_icon_list, 2, 0, 0, H_gdk_window_set_icon_list, pl_tu);
  s7_define_typed_function(sc, "gdk_window_set_icon_name", lg_gdk_window_set_icon_name, 2, 0, 0, H_gdk_window_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gdk_window_set_group", lg_gdk_window_set_group, 2, 0, 0, H_gdk_window_set_group, pl_tu);
  s7_define_typed_function(sc, "gdk_window_set_decorations", lg_gdk_window_set_decorations, 2, 0, 0, H_gdk_window_set_decorations, pl_tug);
  s7_define_typed_function(sc, "gdk_window_get_decorations", lg_gdk_window_get_decorations, 1, 1, 0, H_gdk_window_get_decorations, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_functions", lg_gdk_window_set_functions, 2, 0, 0, H_gdk_window_set_functions, pl_tug);
  s7_define_typed_function(sc, "gdk_window_iconify", lg_gdk_window_iconify, 1, 0, 0, H_gdk_window_iconify, pl_tu);
  s7_define_typed_function(sc, "gdk_window_deiconify", lg_gdk_window_deiconify, 1, 0, 0, H_gdk_window_deiconify, pl_tu);
  s7_define_typed_function(sc, "gdk_window_stick", lg_gdk_window_stick, 1, 0, 0, H_gdk_window_stick, pl_tu);
  s7_define_typed_function(sc, "gdk_window_unstick", lg_gdk_window_unstick, 1, 0, 0, H_gdk_window_unstick, pl_tu);
  s7_define_typed_function(sc, "gdk_window_maximize", lg_gdk_window_maximize, 1, 0, 0, H_gdk_window_maximize, pl_tu);
  s7_define_typed_function(sc, "gdk_window_unmaximize", lg_gdk_window_unmaximize, 1, 0, 0, H_gdk_window_unmaximize, pl_tu);
  s7_define_typed_function(sc, "gdk_window_register_dnd", lg_gdk_window_register_dnd, 1, 0, 0, H_gdk_window_register_dnd, pl_tu);
  s7_define_typed_function(sc, "gdk_window_begin_resize_drag", lg_gdk_window_begin_resize_drag, 6, 0, 0, H_gdk_window_begin_resize_drag, pl_tugi);
  s7_define_typed_function(sc, "gdk_window_begin_move_drag", lg_gdk_window_begin_move_drag, 5, 0, 0, H_gdk_window_begin_move_drag, pl_tui);
  s7_define_typed_function(sc, "gdk_window_invalidate_rect", lg_gdk_window_invalidate_rect, 3, 0, 0, H_gdk_window_invalidate_rect, pl_tuub);
  s7_define_typed_function(sc, "gdk_window_freeze_updates", lg_gdk_window_freeze_updates, 1, 0, 0, H_gdk_window_freeze_updates, pl_tu);
  s7_define_typed_function(sc, "gdk_window_thaw_updates", lg_gdk_window_thaw_updates, 1, 0, 0, H_gdk_window_thaw_updates, pl_tu);
  s7_define_typed_function(sc, "gdk_window_constrain_size", lg_gdk_window_constrain_size, 4, 2, 0, H_gdk_window_constrain_size, pl_pugiiu);
  s7_define_typed_function(sc, "gdk_window_set_type_hint", lg_gdk_window_set_type_hint, 2, 0, 0, H_gdk_window_set_type_hint, pl_tug);
  s7_define_typed_function(sc, "gdk_window_set_modal_hint", lg_gdk_window_set_modal_hint, 2, 0, 0, H_gdk_window_set_modal_hint, pl_tub);
  s7_define_typed_function(sc, "gdk_window_set_title", lg_gdk_window_set_title, 2, 0, 0, H_gdk_window_set_title, pl_tus);
  s7_define_typed_function(sc, "gdk_window_set_role", lg_gdk_window_set_role, 2, 0, 0, H_gdk_window_set_role, pl_tus);
  s7_define_typed_function(sc, "gdk_window_set_transient_for", lg_gdk_window_set_transient_for, 2, 0, 0, H_gdk_window_set_transient_for, pl_tu);
  s7_define_typed_function(sc, "gdk_window_set_cursor", lg_gdk_window_set_cursor, 2, 0, 0, H_gdk_window_set_cursor, pl_tu);
  s7_define_typed_function(sc, "gdk_window_get_user_data", lg_gdk_window_get_user_data, 1, 1, 0, H_gdk_window_get_user_data, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_position", lg_gdk_window_get_position, 1, 2, 0, H_gdk_window_get_position, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_origin", lg_gdk_window_get_origin, 1, 2, 0, H_gdk_window_get_origin, pl_pu);
  s7_define_typed_function(sc, "gdk_get_default_root_window", lg_gdk_get_default_root_window, 0, 0, 0, H_gdk_get_default_root_window, pl_p);
  s7_define_typed_function(sc, "gdk_pixbuf_error_quark", lg_gdk_pixbuf_error_quark, 0, 0, 0, H_gdk_pixbuf_error_quark, pl_i);
  s7_define_typed_function(sc, "gdk_pixbuf_get_colorspace", lg_gdk_pixbuf_get_colorspace, 1, 0, 0, H_gdk_pixbuf_get_colorspace, pl_gu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_n_channels", lg_gdk_pixbuf_get_n_channels, 1, 0, 0, H_gdk_pixbuf_get_n_channels, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_has_alpha", lg_gdk_pixbuf_get_has_alpha, 1, 0, 0, H_gdk_pixbuf_get_has_alpha, pl_bu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_bits_per_sample", lg_gdk_pixbuf_get_bits_per_sample, 1, 0, 0, H_gdk_pixbuf_get_bits_per_sample, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_pixels", lg_gdk_pixbuf_get_pixels, 1, 0, 0, H_gdk_pixbuf_get_pixels, pl_su);
  s7_define_typed_function(sc, "gdk_pixbuf_get_width", lg_gdk_pixbuf_get_width, 1, 0, 0, H_gdk_pixbuf_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_height", lg_gdk_pixbuf_get_height, 1, 0, 0, H_gdk_pixbuf_get_height, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_rowstride", lg_gdk_pixbuf_get_rowstride, 1, 0, 0, H_gdk_pixbuf_get_rowstride, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_new", lg_gdk_pixbuf_new, 5, 0, 0, H_gdk_pixbuf_new, pl_pgbi);
  s7_define_typed_function(sc, "gdk_pixbuf_copy", lg_gdk_pixbuf_copy, 1, 0, 0, H_gdk_pixbuf_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_new_subpixbuf", lg_gdk_pixbuf_new_subpixbuf, 5, 0, 0, H_gdk_pixbuf_new_subpixbuf, pl_pui);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_file", lg_gdk_pixbuf_new_from_file, 1, 1, 0, H_gdk_pixbuf_new_from_file, pl_psu);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_data", lg_gdk_pixbuf_new_from_data, 0, 0, 1, H_gdk_pixbuf_new_from_data, pl_psgbiiiit);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_xpm_data", lg_gdk_pixbuf_new_from_xpm_data, 1, 0, 0, H_gdk_pixbuf_new_from_xpm_data, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_fill", lg_gdk_pixbuf_fill, 2, 0, 0, H_gdk_pixbuf_fill, pl_tui);
  s7_define_typed_function(sc, "gdk_pixbuf_savev", lg_gdk_pixbuf_savev, 5, 1, 0, H_gdk_pixbuf_savev, pl_pussu);
  s7_define_typed_function(sc, "gdk_pixbuf_add_alpha", lg_gdk_pixbuf_add_alpha, 5, 0, 0, H_gdk_pixbuf_add_alpha, pl_pubi);
  s7_define_typed_function(sc, "gdk_pixbuf_copy_area", lg_gdk_pixbuf_copy_area, 0, 0, 1, H_gdk_pixbuf_copy_area, pl_tuiiiiui);
  s7_define_typed_function(sc, "gdk_pixbuf_saturate_and_pixelate", lg_gdk_pixbuf_saturate_and_pixelate, 4, 0, 0, H_gdk_pixbuf_saturate_and_pixelate, pl_tuurb);
  s7_define_typed_function(sc, "gdk_pixbuf_scale", lg_gdk_pixbuf_scale, 0, 0, 1, H_gdk_pixbuf_scale, pl_tuuiiiirrrrg);
  s7_define_typed_function(sc, "gdk_pixbuf_composite", lg_gdk_pixbuf_composite, 0, 0, 1, H_gdk_pixbuf_composite, pl_tuuiiiirrrrgi);
  s7_define_typed_function(sc, "gdk_pixbuf_composite_color", lg_gdk_pixbuf_composite_color, 0, 0, 1, H_gdk_pixbuf_composite_color, pl_tuuiiiirrrrgi);
  s7_define_typed_function(sc, "gdk_pixbuf_scale_simple", lg_gdk_pixbuf_scale_simple, 4, 0, 0, H_gdk_pixbuf_scale_simple, pl_puiig);
  s7_define_typed_function(sc, "gdk_pixbuf_composite_color_simple", lg_gdk_pixbuf_composite_color_simple, 0, 0, 1, H_gdk_pixbuf_composite_color_simple, pl_puiigi);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_new_from_file", lg_gdk_pixbuf_animation_new_from_file, 1, 1, 0, H_gdk_pixbuf_animation_new_from_file, pl_psu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_get_width", lg_gdk_pixbuf_animation_get_width, 1, 0, 0, H_gdk_pixbuf_animation_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_get_height", lg_gdk_pixbuf_animation_get_height, 1, 0, 0, H_gdk_pixbuf_animation_get_height, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_is_static_image", lg_gdk_pixbuf_animation_is_static_image, 1, 0, 0, H_gdk_pixbuf_animation_is_static_image, pl_bu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_get_static_image", lg_gdk_pixbuf_animation_get_static_image, 1, 0, 0, H_gdk_pixbuf_animation_get_static_image, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_get_iter", lg_gdk_pixbuf_animation_get_iter, 2, 0, 0, H_gdk_pixbuf_animation_get_iter, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_iter_get_delay_time", lg_gdk_pixbuf_animation_iter_get_delay_time, 1, 0, 0, H_gdk_pixbuf_animation_iter_get_delay_time, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_iter_get_pixbuf", lg_gdk_pixbuf_animation_iter_get_pixbuf, 1, 0, 0, H_gdk_pixbuf_animation_iter_get_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_iter_on_currently_loading_frame", lg_gdk_pixbuf_animation_iter_on_currently_loading_frame, 1, 0, 0, H_gdk_pixbuf_animation_iter_on_currently_loading_frame, pl_bu);
  s7_define_typed_function(sc, "gdk_pixbuf_animation_iter_advance", lg_gdk_pixbuf_animation_iter_advance, 2, 0, 0, H_gdk_pixbuf_animation_iter_advance, pl_bu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_option", lg_gdk_pixbuf_get_option, 2, 0, 0, H_gdk_pixbuf_get_option, pl_sus);
  s7_define_typed_function(sc, "gtk_accel_group_new", lg_gtk_accel_group_new, 0, 0, 0, H_gtk_accel_group_new, pl_p);
  s7_define_typed_function(sc, "gtk_accel_group_lock", lg_gtk_accel_group_lock, 1, 0, 0, H_gtk_accel_group_lock, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_group_unlock", lg_gtk_accel_group_unlock, 1, 0, 0, H_gtk_accel_group_unlock, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_group_connect", lg_gtk_accel_group_connect, 5, 0, 0, H_gtk_accel_group_connect, pl_tuiggu);
  s7_define_typed_function(sc, "gtk_accel_group_connect_by_path", lg_gtk_accel_group_connect_by_path, 3, 0, 0, H_gtk_accel_group_connect_by_path, pl_tusu);
  s7_define_typed_function(sc, "gtk_accel_group_disconnect", lg_gtk_accel_group_disconnect, 2, 0, 0, H_gtk_accel_group_disconnect, pl_bu);
  s7_define_typed_function(sc, "gtk_accel_group_disconnect_key", lg_gtk_accel_group_disconnect_key, 3, 0, 0, H_gtk_accel_group_disconnect_key, pl_buig);
  s7_define_typed_function(sc, "gtk_accel_groups_activate", lg_gtk_accel_groups_activate, 3, 0, 0, H_gtk_accel_groups_activate, pl_buig);
  s7_define_typed_function(sc, "gtk_accel_groups_from_object", lg_gtk_accel_groups_from_object, 1, 0, 0, H_gtk_accel_groups_from_object, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_group_find", lg_gtk_accel_group_find, 2, 1, 0, H_gtk_accel_group_find, pl_put);
  s7_define_typed_function(sc, "gtk_accel_group_from_accel_closure", lg_gtk_accel_group_from_accel_closure, 1, 0, 0, H_gtk_accel_group_from_accel_closure, pl_pu);
  s7_define_typed_function(sc, "gtk_accelerator_valid", lg_gtk_accelerator_valid, 2, 0, 0, H_gtk_accelerator_valid, pl_big);
  s7_define_typed_function(sc, "gtk_accelerator_parse", lg_gtk_accelerator_parse, 1, 2, 0, H_gtk_accelerator_parse, pl_psu);
  s7_define_typed_function(sc, "gtk_accelerator_name", lg_gtk_accelerator_name, 2, 0, 0, H_gtk_accelerator_name, pl_sig);
  s7_define_typed_function(sc, "gtk_accelerator_set_default_mod_mask", lg_gtk_accelerator_set_default_mod_mask, 1, 0, 0, H_gtk_accelerator_set_default_mod_mask, pl_tg);
  s7_define_typed_function(sc, "gtk_accel_group_query", lg_gtk_accel_group_query, 3, 1, 0, H_gtk_accel_group_query, pl_puigu);
  s7_define_typed_function(sc, "gtk_accel_group_activate", lg_gtk_accel_group_activate, 5, 0, 0, H_gtk_accel_group_activate, pl_buiuig);
  s7_define_typed_function(sc, "gtk_accel_label_new", lg_gtk_accel_label_new, 1, 0, 0, H_gtk_accel_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel_widget", lg_gtk_accel_label_get_accel_widget, 1, 0, 0, H_gtk_accel_label_get_accel_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel_width", lg_gtk_accel_label_get_accel_width, 1, 0, 0, H_gtk_accel_label_get_accel_width, pl_iu);
  s7_define_typed_function(sc, "gtk_accel_label_set_accel_widget", lg_gtk_accel_label_set_accel_widget, 2, 0, 0, H_gtk_accel_label_set_accel_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_label_set_accel_closure", lg_gtk_accel_label_set_accel_closure, 2, 0, 0, H_gtk_accel_label_set_accel_closure, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_label_refetch", lg_gtk_accel_label_refetch, 1, 0, 0, H_gtk_accel_label_refetch, pl_bu);
  s7_define_typed_function(sc, "gtk_accel_map_add_entry", lg_gtk_accel_map_add_entry, 3, 0, 0, H_gtk_accel_map_add_entry, pl_tsig);
  s7_define_typed_function(sc, "gtk_accel_map_lookup_entry", lg_gtk_accel_map_lookup_entry, 2, 0, 0, H_gtk_accel_map_lookup_entry, pl_bsu);
  s7_define_typed_function(sc, "gtk_accel_map_change_entry", lg_gtk_accel_map_change_entry, 4, 0, 0, H_gtk_accel_map_change_entry, pl_bsigb);
  s7_define_typed_function(sc, "gtk_accel_map_load", lg_gtk_accel_map_load, 1, 0, 0, H_gtk_accel_map_load, pl_ts);
  s7_define_typed_function(sc, "gtk_accel_map_save", lg_gtk_accel_map_save, 1, 0, 0, H_gtk_accel_map_save, pl_ts);
  s7_define_typed_function(sc, "gtk_accel_map_foreach", lg_gtk_accel_map_foreach, 2, 0, 0, H_gtk_accel_map_foreach, pl_t);
  s7_define_typed_function(sc, "gtk_accel_map_load_fd", lg_gtk_accel_map_load_fd, 1, 0, 0, H_gtk_accel_map_load_fd, pl_ti);
  s7_define_typed_function(sc, "gtk_accel_map_save_fd", lg_gtk_accel_map_save_fd, 1, 0, 0, H_gtk_accel_map_save_fd, pl_ti);
  s7_define_typed_function(sc, "gtk_accel_map_add_filter", lg_gtk_accel_map_add_filter, 1, 0, 0, H_gtk_accel_map_add_filter, pl_ts);
  s7_define_typed_function(sc, "gtk_accel_map_foreach_unfiltered", lg_gtk_accel_map_foreach_unfiltered, 2, 0, 0, H_gtk_accel_map_foreach_unfiltered, pl_t);
  s7_define_typed_function(sc, "gtk_adjustment_clamp_page", lg_gtk_adjustment_clamp_page, 3, 0, 0, H_gtk_adjustment_clamp_page, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_value", lg_gtk_adjustment_get_value, 1, 0, 0, H_gtk_adjustment_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_value", lg_gtk_adjustment_set_value, 2, 0, 0, H_gtk_adjustment_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_aspect_frame_new", lg_gtk_aspect_frame_new, 5, 0, 0, H_gtk_aspect_frame_new, pl_psrrrb);
  s7_define_typed_function(sc, "gtk_aspect_frame_set", lg_gtk_aspect_frame_set, 5, 0, 0, H_gtk_aspect_frame_set, pl_turrrb);
  s7_define_typed_function(sc, "gtk_button_box_get_layout", lg_gtk_button_box_get_layout, 1, 0, 0, H_gtk_button_box_get_layout, pl_gu);
  s7_define_typed_function(sc, "gtk_button_box_set_layout", lg_gtk_button_box_set_layout, 2, 0, 0, H_gtk_button_box_set_layout, pl_tug);
  s7_define_typed_function(sc, "gtk_button_box_set_child_secondary", lg_gtk_button_box_set_child_secondary, 3, 0, 0, H_gtk_button_box_set_child_secondary, pl_tuub);
  s7_define_typed_function(sc, "gtk_binding_set_new", lg_gtk_binding_set_new, 1, 0, 0, H_gtk_binding_set_new, pl_ps);
  s7_define_typed_function(sc, "gtk_binding_set_by_class", lg_gtk_binding_set_by_class, 1, 0, 0, H_gtk_binding_set_by_class, pl_pt);
  s7_define_typed_function(sc, "gtk_binding_set_find", lg_gtk_binding_set_find, 1, 0, 0, H_gtk_binding_set_find, pl_ps);
  s7_define_typed_function(sc, "gtk_binding_entry_remove", lg_gtk_binding_entry_remove, 3, 0, 0, H_gtk_binding_entry_remove, pl_tuig);
  s7_define_typed_function(sc, "gtk_bin_get_child", lg_gtk_bin_get_child, 1, 0, 0, H_gtk_bin_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_box_set_homogeneous", lg_gtk_box_set_homogeneous, 2, 0, 0, H_gtk_box_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_box_get_homogeneous", lg_gtk_box_get_homogeneous, 1, 0, 0, H_gtk_box_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_box_set_spacing", lg_gtk_box_set_spacing, 2, 0, 0, H_gtk_box_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_box_get_spacing", lg_gtk_box_get_spacing, 1, 0, 0, H_gtk_box_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_box_reorder_child", lg_gtk_box_reorder_child, 3, 0, 0, H_gtk_box_reorder_child, pl_tuui);
  s7_define_typed_function(sc, "gtk_box_query_child_packing", lg_gtk_box_query_child_packing, 2, 4, 0, H_gtk_box_query_child_packing, pl_pu);
  s7_define_typed_function(sc, "gtk_box_set_child_packing", lg_gtk_box_set_child_packing, 6, 0, 0, H_gtk_box_set_child_packing, pl_tuubbig);
  s7_define_typed_function(sc, "gtk_button_new", lg_gtk_button_new, 0, 0, 0, H_gtk_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_button_new_with_label", lg_gtk_button_new_with_label, 1, 0, 0, H_gtk_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_button_new_with_mnemonic", lg_gtk_button_new_with_mnemonic, 1, 0, 0, H_gtk_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_button_clicked", lg_gtk_button_clicked, 1, 0, 0, H_gtk_button_clicked, pl_tu);
  s7_define_typed_function(sc, "gtk_button_set_relief", lg_gtk_button_set_relief, 2, 0, 0, H_gtk_button_set_relief, pl_tug);
  s7_define_typed_function(sc, "gtk_button_get_relief", lg_gtk_button_get_relief, 1, 0, 0, H_gtk_button_get_relief, pl_gu);
  s7_define_typed_function(sc, "gtk_button_set_label", lg_gtk_button_set_label, 2, 0, 0, H_gtk_button_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_button_get_label", lg_gtk_button_get_label, 1, 0, 0, H_gtk_button_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_button_set_use_underline", lg_gtk_button_set_use_underline, 2, 0, 0, H_gtk_button_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_button_get_use_underline", lg_gtk_button_get_use_underline, 1, 0, 0, H_gtk_button_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_new", lg_gtk_calendar_new, 0, 0, 0, H_gtk_calendar_new, pl_p);
  s7_define_typed_function(sc, "gtk_calendar_select_day", lg_gtk_calendar_select_day, 2, 0, 0, H_gtk_calendar_select_day, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_clear_marks", lg_gtk_calendar_clear_marks, 1, 0, 0, H_gtk_calendar_clear_marks, pl_tu);
  s7_define_typed_function(sc, "gtk_calendar_get_date", lg_gtk_calendar_get_date, 1, 3, 0, H_gtk_calendar_get_date, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_editable_start_editing", lg_gtk_cell_editable_start_editing, 2, 0, 0, H_gtk_cell_editable_start_editing, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_editable_editing_done", lg_gtk_cell_editable_editing_done, 1, 0, 0, H_gtk_cell_editable_editing_done, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_editable_remove_widget", lg_gtk_cell_editable_remove_widget, 1, 0, 0, H_gtk_cell_editable_remove_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_activate", lg_gtk_cell_renderer_activate, 7, 0, 0, H_gtk_cell_renderer_activate, pl_buuusuug);
  s7_define_typed_function(sc, "gtk_cell_renderer_start_editing", lg_gtk_cell_renderer_start_editing, 7, 0, 0, H_gtk_cell_renderer_start_editing, pl_puuusuug);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_fixed_size", lg_gtk_cell_renderer_set_fixed_size, 3, 0, 0, H_gtk_cell_renderer_set_fixed_size, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_fixed_size", lg_gtk_cell_renderer_get_fixed_size, 1, 2, 0, H_gtk_cell_renderer_get_fixed_size, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_pixbuf_new", lg_gtk_cell_renderer_pixbuf_new, 0, 0, 0, H_gtk_cell_renderer_pixbuf_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_text_new", lg_gtk_cell_renderer_text_new, 0, 0, 0, H_gtk_cell_renderer_text_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", lg_gtk_cell_renderer_text_set_fixed_height_from_font, 2, 0, 0, H_gtk_cell_renderer_text_set_fixed_height_from_font, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_new", lg_gtk_cell_renderer_toggle_new, 0, 0, 0, H_gtk_cell_renderer_toggle_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_radio", lg_gtk_cell_renderer_toggle_get_radio, 1, 0, 0, H_gtk_cell_renderer_toggle_get_radio, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_radio", lg_gtk_cell_renderer_toggle_set_radio, 2, 0, 0, H_gtk_cell_renderer_toggle_set_radio, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_active", lg_gtk_cell_renderer_toggle_get_active, 1, 0, 0, H_gtk_cell_renderer_toggle_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_active", lg_gtk_cell_renderer_toggle_set_active, 2, 0, 0, H_gtk_cell_renderer_toggle_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_new", lg_gtk_check_button_new, 0, 0, 0, H_gtk_check_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_check_button_new_with_label", lg_gtk_check_button_new_with_label, 1, 0, 0, H_gtk_check_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_check_button_new_with_mnemonic", lg_gtk_check_button_new_with_mnemonic, 1, 0, 0, H_gtk_check_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_check_menu_item_new", lg_gtk_check_menu_item_new, 0, 0, 0, H_gtk_check_menu_item_new, pl_p);
  s7_define_typed_function(sc, "gtk_check_menu_item_new_with_label", lg_gtk_check_menu_item_new_with_label, 1, 0, 0, H_gtk_check_menu_item_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_check_menu_item_new_with_mnemonic", lg_gtk_check_menu_item_new_with_mnemonic, 1, 0, 0, H_gtk_check_menu_item_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_check_menu_item_set_active", lg_gtk_check_menu_item_set_active, 2, 0, 0, H_gtk_check_menu_item_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_check_menu_item_get_active", lg_gtk_check_menu_item_get_active, 1, 0, 0, H_gtk_check_menu_item_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_check_menu_item_toggled", lg_gtk_check_menu_item_toggled, 1, 0, 0, H_gtk_check_menu_item_toggled, pl_tu);
  s7_define_typed_function(sc, "gtk_check_menu_item_set_inconsistent", lg_gtk_check_menu_item_set_inconsistent, 2, 0, 0, H_gtk_check_menu_item_set_inconsistent, pl_tub);
  s7_define_typed_function(sc, "gtk_check_menu_item_get_inconsistent", lg_gtk_check_menu_item_get_inconsistent, 1, 0, 0, H_gtk_check_menu_item_get_inconsistent, pl_bu);
  s7_define_typed_function(sc, "gtk_clipboard_get", lg_gtk_clipboard_get, 1, 0, 0, H_gtk_clipboard_get, pl_pt);
  s7_define_typed_function(sc, "gtk_clipboard_set_with_data", lg_gtk_clipboard_set_with_data, 5, 1, 0, H_gtk_clipboard_set_with_data, pl_buuit);
  s7_define_typed_function(sc, "gtk_clipboard_get_owner", lg_gtk_clipboard_get_owner, 1, 0, 0, H_gtk_clipboard_get_owner, pl_pu);
  s7_define_typed_function(sc, "gtk_clipboard_clear", lg_gtk_clipboard_clear, 1, 0, 0, H_gtk_clipboard_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_clipboard_set_text", lg_gtk_clipboard_set_text, 3, 0, 0, H_gtk_clipboard_set_text, pl_tusi);
  s7_define_typed_function(sc, "gtk_clipboard_request_contents", lg_gtk_clipboard_request_contents, 3, 1, 0, H_gtk_clipboard_request_contents, pl_tut);
  s7_define_typed_function(sc, "gtk_clipboard_request_text", lg_gtk_clipboard_request_text, 2, 1, 0, H_gtk_clipboard_request_text, pl_tut);
  s7_define_typed_function(sc, "gtk_clipboard_wait_for_contents", lg_gtk_clipboard_wait_for_contents, 2, 0, 0, H_gtk_clipboard_wait_for_contents, pl_put);
  s7_define_typed_function(sc, "gtk_clipboard_wait_for_text", lg_gtk_clipboard_wait_for_text, 1, 0, 0, H_gtk_clipboard_wait_for_text, pl_su);
  s7_define_typed_function(sc, "gtk_clipboard_wait_is_text_available", lg_gtk_clipboard_wait_is_text_available, 1, 0, 0, H_gtk_clipboard_wait_is_text_available, pl_bu);
  s7_define_typed_function(sc, "gtk_container_add", lg_gtk_container_add, 2, 0, 0, H_gtk_container_add, pl_tu);
  s7_define_typed_function(sc, "gtk_container_remove", lg_gtk_container_remove, 2, 0, 0, H_gtk_container_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_container_check_resize", lg_gtk_container_check_resize, 1, 0, 0, H_gtk_container_check_resize, pl_tu);
  s7_define_typed_function(sc, "gtk_container_foreach", lg_gtk_container_foreach, 2, 1, 0, H_gtk_container_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_container_get_children", lg_gtk_container_get_children, 1, 0, 0, H_gtk_container_get_children, pl_pu);
  s7_define_typed_function(sc, "gtk_dialog_new", lg_gtk_dialog_new, 0, 0, 0, H_gtk_dialog_new, pl_p);
  s7_define_typed_function(sc, "gtk_dialog_add_action_widget", lg_gtk_dialog_add_action_widget, 3, 0, 0, H_gtk_dialog_add_action_widget, pl_tuui);
  s7_define_typed_function(sc, "gtk_dialog_add_button", lg_gtk_dialog_add_button, 3, 0, 0, H_gtk_dialog_add_button, pl_pusi);
  s7_define_typed_function(sc, "gtk_dialog_add_buttons", lg_gtk_dialog_add_buttons, 2, 0, 0, H_gtk_dialog_add_buttons, pl_tut);
  s7_define_typed_function(sc, "gtk_dialog_set_response_sensitive", lg_gtk_dialog_set_response_sensitive, 3, 0, 0, H_gtk_dialog_set_response_sensitive, pl_tuib);
  s7_define_typed_function(sc, "gtk_dialog_set_default_response", lg_gtk_dialog_set_default_response, 2, 0, 0, H_gtk_dialog_set_default_response, pl_tui);
  s7_define_typed_function(sc, "gtk_dialog_response", lg_gtk_dialog_response, 2, 0, 0, H_gtk_dialog_response, pl_tui);
  s7_define_typed_function(sc, "gtk_dialog_run", lg_gtk_dialog_run, 1, 0, 0, H_gtk_dialog_run, pl_iu);
  s7_define_typed_function(sc, "gtk_drag_get_data", lg_gtk_drag_get_data, 4, 0, 0, H_gtk_drag_get_data, pl_tuuti);
  s7_define_typed_function(sc, "gtk_drag_finish", lg_gtk_drag_finish, 4, 0, 0, H_gtk_drag_finish, pl_tubbi);
  s7_define_typed_function(sc, "gtk_drag_get_source_widget", lg_gtk_drag_get_source_widget, 1, 0, 0, H_gtk_drag_get_source_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_highlight", lg_gtk_drag_highlight, 1, 0, 0, H_gtk_drag_highlight, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_unhighlight", lg_gtk_drag_unhighlight, 1, 0, 0, H_gtk_drag_unhighlight, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_dest_set", lg_gtk_drag_dest_set, 5, 0, 0, H_gtk_drag_dest_set, pl_tuguig);
  s7_define_typed_function(sc, "gtk_drag_dest_unset", lg_gtk_drag_dest_unset, 1, 0, 0, H_gtk_drag_dest_unset, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_dest_find_target", lg_gtk_drag_dest_find_target, 3, 0, 0, H_gtk_drag_dest_find_target, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_dest_get_target_list", lg_gtk_drag_dest_get_target_list, 1, 0, 0, H_gtk_drag_dest_get_target_list, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_dest_set_target_list", lg_gtk_drag_dest_set_target_list, 2, 0, 0, H_gtk_drag_dest_set_target_list, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_set", lg_gtk_drag_source_set, 5, 0, 0, H_gtk_drag_source_set, pl_tuguig);
  s7_define_typed_function(sc, "gtk_drag_source_unset", lg_gtk_drag_source_unset, 1, 0, 0, H_gtk_drag_source_unset, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_set_icon_pixbuf", lg_gtk_drag_source_set_icon_pixbuf, 2, 0, 0, H_gtk_drag_source_set_icon_pixbuf, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_set_icon_widget", lg_gtk_drag_set_icon_widget, 4, 0, 0, H_gtk_drag_set_icon_widget, pl_tuui);
  s7_define_typed_function(sc, "gtk_drag_set_icon_pixbuf", lg_gtk_drag_set_icon_pixbuf, 4, 0, 0, H_gtk_drag_set_icon_pixbuf, pl_tuui);
  s7_define_typed_function(sc, "gtk_drag_set_icon_default", lg_gtk_drag_set_icon_default, 1, 0, 0, H_gtk_drag_set_icon_default, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_check_threshold", lg_gtk_drag_check_threshold, 5, 0, 0, H_gtk_drag_check_threshold, pl_bui);
  s7_define_typed_function(sc, "gtk_drawing_area_new", lg_gtk_drawing_area_new, 0, 0, 0, H_gtk_drawing_area_new, pl_p);
  s7_define_typed_function(sc, "gtk_editable_select_region", lg_gtk_editable_select_region, 3, 0, 0, H_gtk_editable_select_region, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_selection_bounds", lg_gtk_editable_get_selection_bounds, 1, 2, 0, H_gtk_editable_get_selection_bounds, pl_pu);
  s7_define_typed_function(sc, "gtk_editable_insert_text", lg_gtk_editable_insert_text, 3, 1, 0, H_gtk_editable_insert_text, pl_pusiu);
  s7_define_typed_function(sc, "gtk_editable_delete_text", lg_gtk_editable_delete_text, 3, 0, 0, H_gtk_editable_delete_text, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_chars", lg_gtk_editable_get_chars, 3, 0, 0, H_gtk_editable_get_chars, pl_sui);
  s7_define_typed_function(sc, "gtk_editable_cut_clipboard", lg_gtk_editable_cut_clipboard, 1, 0, 0, H_gtk_editable_cut_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_copy_clipboard", lg_gtk_editable_copy_clipboard, 1, 0, 0, H_gtk_editable_copy_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_paste_clipboard", lg_gtk_editable_paste_clipboard, 1, 0, 0, H_gtk_editable_paste_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_delete_selection", lg_gtk_editable_delete_selection, 1, 0, 0, H_gtk_editable_delete_selection, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_set_position", lg_gtk_editable_set_position, 2, 0, 0, H_gtk_editable_set_position, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_position", lg_gtk_editable_get_position, 1, 0, 0, H_gtk_editable_get_position, pl_iu);
  s7_define_typed_function(sc, "gtk_editable_set_editable", lg_gtk_editable_set_editable, 2, 0, 0, H_gtk_editable_set_editable, pl_tub);
  s7_define_typed_function(sc, "gtk_editable_get_editable", lg_gtk_editable_get_editable, 1, 0, 0, H_gtk_editable_get_editable, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_new", lg_gtk_entry_new, 0, 0, 0, H_gtk_entry_new, pl_p);
  s7_define_typed_function(sc, "gtk_entry_set_visibility", lg_gtk_entry_set_visibility, 2, 0, 0, H_gtk_entry_set_visibility, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_visibility", lg_gtk_entry_get_visibility, 1, 0, 0, H_gtk_entry_get_visibility, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_invisible_char", lg_gtk_entry_set_invisible_char, 2, 0, 0, H_gtk_entry_set_invisible_char, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_invisible_char", lg_gtk_entry_get_invisible_char, 1, 0, 0, H_gtk_entry_get_invisible_char, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_set_has_frame", lg_gtk_entry_set_has_frame, 2, 0, 0, H_gtk_entry_set_has_frame, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_has_frame", lg_gtk_entry_get_has_frame, 1, 0, 0, H_gtk_entry_get_has_frame, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_max_length", lg_gtk_entry_set_max_length, 2, 0, 0, H_gtk_entry_set_max_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_max_length", lg_gtk_entry_get_max_length, 1, 0, 0, H_gtk_entry_get_max_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_set_activates_default", lg_gtk_entry_set_activates_default, 2, 0, 0, H_gtk_entry_set_activates_default, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_activates_default", lg_gtk_entry_get_activates_default, 1, 0, 0, H_gtk_entry_get_activates_default, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_width_chars", lg_gtk_entry_set_width_chars, 2, 0, 0, H_gtk_entry_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_width_chars", lg_gtk_entry_get_width_chars, 1, 0, 0, H_gtk_entry_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_set_text", lg_gtk_entry_set_text, 2, 0, 0, H_gtk_entry_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_entry_get_text", lg_gtk_entry_get_text, 1, 0, 0, H_gtk_entry_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_entry_get_layout", lg_gtk_entry_get_layout, 1, 0, 0, H_gtk_entry_get_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_get_layout_offsets", lg_gtk_entry_get_layout_offsets, 1, 2, 0, H_gtk_entry_get_layout_offsets, pl_pu);
  s7_define_typed_function(sc, "gtk_fixed_new", lg_gtk_fixed_new, 0, 0, 0, H_gtk_fixed_new, pl_p);
  s7_define_typed_function(sc, "gtk_fixed_put", lg_gtk_fixed_put, 4, 0, 0, H_gtk_fixed_put, pl_tuui);
  s7_define_typed_function(sc, "gtk_fixed_move", lg_gtk_fixed_move, 4, 0, 0, H_gtk_fixed_move, pl_tuui);
  s7_define_typed_function(sc, "gtk_frame_new", lg_gtk_frame_new, 1, 0, 0, H_gtk_frame_new, pl_ps);
  s7_define_typed_function(sc, "gtk_frame_set_label", lg_gtk_frame_set_label, 2, 0, 0, H_gtk_frame_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_frame_get_label", lg_gtk_frame_get_label, 1, 0, 0, H_gtk_frame_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_frame_set_label_widget", lg_gtk_frame_set_label_widget, 2, 0, 0, H_gtk_frame_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_frame_get_label_widget", lg_gtk_frame_get_label_widget, 1, 0, 0, H_gtk_frame_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_frame_set_label_align", lg_gtk_frame_set_label_align, 3, 0, 0, H_gtk_frame_set_label_align, pl_tur);
  s7_define_typed_function(sc, "gtk_frame_get_label_align", lg_gtk_frame_get_label_align, 1, 2, 0, H_gtk_frame_get_label_align, pl_pu);
  s7_define_typed_function(sc, "gtk_frame_set_shadow_type", lg_gtk_frame_set_shadow_type, 2, 0, 0, H_gtk_frame_set_shadow_type, pl_tug);
  s7_define_typed_function(sc, "gtk_frame_get_shadow_type", lg_gtk_frame_get_shadow_type, 1, 0, 0, H_gtk_frame_get_shadow_type, pl_gu);
  s7_define_typed_function(sc, "gtk_image_new", lg_gtk_image_new, 0, 0, 0, H_gtk_image_new, pl_p);
  s7_define_typed_function(sc, "gtk_image_new_from_file", lg_gtk_image_new_from_file, 1, 0, 0, H_gtk_image_new_from_file, pl_ps);
  s7_define_typed_function(sc, "gtk_image_new_from_pixbuf", lg_gtk_image_new_from_pixbuf, 1, 0, 0, H_gtk_image_new_from_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_image_new_from_animation", lg_gtk_image_new_from_animation, 1, 0, 0, H_gtk_image_new_from_animation, pl_pu);
  s7_define_typed_function(sc, "gtk_image_set_from_file", lg_gtk_image_set_from_file, 2, 0, 0, H_gtk_image_set_from_file, pl_tus);
  s7_define_typed_function(sc, "gtk_image_set_from_pixbuf", lg_gtk_image_set_from_pixbuf, 2, 0, 0, H_gtk_image_set_from_pixbuf, pl_tu);
  s7_define_typed_function(sc, "gtk_image_set_from_animation", lg_gtk_image_set_from_animation, 2, 0, 0, H_gtk_image_set_from_animation, pl_tu);
  s7_define_typed_function(sc, "gtk_image_get_storage_type", lg_gtk_image_get_storage_type, 1, 0, 0, H_gtk_image_get_storage_type, pl_gu);
  s7_define_typed_function(sc, "gtk_image_get_pixbuf", lg_gtk_image_get_pixbuf, 1, 0, 0, H_gtk_image_get_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_image_get_animation", lg_gtk_image_get_animation, 1, 0, 0, H_gtk_image_get_animation, pl_pu);
  s7_define_typed_function(sc, "gtk_im_context_get_preedit_string", lg_gtk_im_context_get_preedit_string, 1, 3, 0, H_gtk_im_context_get_preedit_string, pl_pu);
  s7_define_typed_function(sc, "gtk_im_context_filter_keypress", lg_gtk_im_context_filter_keypress, 2, 0, 0, H_gtk_im_context_filter_keypress, pl_bu);
  s7_define_typed_function(sc, "gtk_im_context_focus_in", lg_gtk_im_context_focus_in, 1, 0, 0, H_gtk_im_context_focus_in, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_focus_out", lg_gtk_im_context_focus_out, 1, 0, 0, H_gtk_im_context_focus_out, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_reset", lg_gtk_im_context_reset, 1, 0, 0, H_gtk_im_context_reset, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_set_cursor_location", lg_gtk_im_context_set_cursor_location, 2, 0, 0, H_gtk_im_context_set_cursor_location, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_set_use_preedit", lg_gtk_im_context_set_use_preedit, 2, 0, 0, H_gtk_im_context_set_use_preedit, pl_tub);
  s7_define_typed_function(sc, "gtk_im_context_set_surrounding", lg_gtk_im_context_set_surrounding, 4, 0, 0, H_gtk_im_context_set_surrounding, pl_tusi);
  s7_define_typed_function(sc, "gtk_im_context_get_surrounding", lg_gtk_im_context_get_surrounding, 1, 2, 0, H_gtk_im_context_get_surrounding, pl_pu);
  s7_define_typed_function(sc, "gtk_im_context_delete_surrounding", lg_gtk_im_context_delete_surrounding, 3, 0, 0, H_gtk_im_context_delete_surrounding, pl_bui);
  s7_define_typed_function(sc, "gtk_im_context_simple_new", lg_gtk_im_context_simple_new, 0, 0, 0, H_gtk_im_context_simple_new, pl_p);
  s7_define_typed_function(sc, "gtk_im_context_simple_add_table", lg_gtk_im_context_simple_add_table, 4, 0, 0, H_gtk_im_context_simple_add_table, pl_tuui);
  s7_define_typed_function(sc, "gtk_invisible_new", lg_gtk_invisible_new, 0, 0, 0, H_gtk_invisible_new, pl_p);
  s7_define_typed_function(sc, "gtk_label_new", lg_gtk_label_new, 1, 0, 0, H_gtk_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_label_new_with_mnemonic", lg_gtk_label_new_with_mnemonic, 1, 0, 0, H_gtk_label_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_label_set_text", lg_gtk_label_set_text, 2, 0, 0, H_gtk_label_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_text", lg_gtk_label_get_text, 1, 0, 0, H_gtk_label_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_label_set_attributes", lg_gtk_label_set_attributes, 2, 0, 0, H_gtk_label_set_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_label_get_attributes", lg_gtk_label_get_attributes, 1, 0, 0, H_gtk_label_get_attributes, pl_pu);
  s7_define_typed_function(sc, "gtk_label_set_label", lg_gtk_label_set_label, 2, 0, 0, H_gtk_label_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_label", lg_gtk_label_get_label, 1, 0, 0, H_gtk_label_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_label_set_markup", lg_gtk_label_set_markup, 2, 0, 0, H_gtk_label_set_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_use_markup", lg_gtk_label_set_use_markup, 2, 0, 0, H_gtk_label_set_use_markup, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_use_markup", lg_gtk_label_get_use_markup, 1, 0, 0, H_gtk_label_get_use_markup, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_use_underline", lg_gtk_label_set_use_underline, 2, 0, 0, H_gtk_label_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_use_underline", lg_gtk_label_get_use_underline, 1, 0, 0, H_gtk_label_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_markup_with_mnemonic", lg_gtk_label_set_markup_with_mnemonic, 2, 0, 0, H_gtk_label_set_markup_with_mnemonic, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_mnemonic_keyval", lg_gtk_label_get_mnemonic_keyval, 1, 0, 0, H_gtk_label_get_mnemonic_keyval, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_mnemonic_widget", lg_gtk_label_set_mnemonic_widget, 2, 0, 0, H_gtk_label_set_mnemonic_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_label_get_mnemonic_widget", lg_gtk_label_get_mnemonic_widget, 1, 0, 0, H_gtk_label_get_mnemonic_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_label_set_text_with_mnemonic", lg_gtk_label_set_text_with_mnemonic, 2, 0, 0, H_gtk_label_set_text_with_mnemonic, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_justify", lg_gtk_label_set_justify, 2, 0, 0, H_gtk_label_set_justify, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_justify", lg_gtk_label_get_justify, 1, 0, 0, H_gtk_label_get_justify, pl_gu);
  s7_define_typed_function(sc, "gtk_label_set_pattern", lg_gtk_label_set_pattern, 2, 0, 0, H_gtk_label_set_pattern, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_line_wrap", lg_gtk_label_set_line_wrap, 2, 0, 0, H_gtk_label_set_line_wrap, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_line_wrap", lg_gtk_label_get_line_wrap, 1, 0, 0, H_gtk_label_get_line_wrap, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_selectable", lg_gtk_label_set_selectable, 2, 0, 0, H_gtk_label_set_selectable, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_selectable", lg_gtk_label_get_selectable, 1, 0, 0, H_gtk_label_get_selectable, pl_bu);
  s7_define_typed_function(sc, "gtk_label_select_region", lg_gtk_label_select_region, 3, 0, 0, H_gtk_label_select_region, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_selection_bounds", lg_gtk_label_get_selection_bounds, 1, 2, 0, H_gtk_label_get_selection_bounds, pl_pu);
  s7_define_typed_function(sc, "gtk_label_get_layout", lg_gtk_label_get_layout, 1, 0, 0, H_gtk_label_get_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_label_get_layout_offsets", lg_gtk_label_get_layout_offsets, 1, 2, 0, H_gtk_label_get_layout_offsets, pl_pu);
  s7_define_typed_function(sc, "gtk_layout_new", lg_gtk_layout_new, 2, 0, 0, H_gtk_layout_new, pl_pu);
  s7_define_typed_function(sc, "gtk_layout_put", lg_gtk_layout_put, 4, 0, 0, H_gtk_layout_put, pl_tuui);
  s7_define_typed_function(sc, "gtk_layout_move", lg_gtk_layout_move, 4, 0, 0, H_gtk_layout_move, pl_tuui);
  s7_define_typed_function(sc, "gtk_layout_set_size", lg_gtk_layout_set_size, 3, 0, 0, H_gtk_layout_set_size, pl_tui);
  s7_define_typed_function(sc, "gtk_layout_get_size", lg_gtk_layout_get_size, 1, 2, 0, H_gtk_layout_get_size, pl_pu);
  s7_define_typed_function(sc, "gtk_list_store_new", lg_gtk_list_store_new, 2, 0, 0, H_gtk_list_store_new, pl_pit);
  s7_define_typed_function(sc, "gtk_list_store_newv", lg_gtk_list_store_newv, 2, 0, 0, H_gtk_list_store_newv, pl_piu);
  s7_define_typed_function(sc, "gtk_list_store_set_column_types", lg_gtk_list_store_set_column_types, 3, 0, 0, H_gtk_list_store_set_column_types, pl_tuiu);
  s7_define_typed_function(sc, "gtk_list_store_set", lg_gtk_list_store_set, 3, 0, 0, H_gtk_list_store_set, pl_tuut);
  s7_define_typed_function(sc, "gtk_list_store_insert", lg_gtk_list_store_insert, 3, 0, 0, H_gtk_list_store_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_list_store_insert_before", lg_gtk_list_store_insert_before, 3, 0, 0, H_gtk_list_store_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_insert_after", lg_gtk_list_store_insert_after, 3, 0, 0, H_gtk_list_store_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_prepend", lg_gtk_list_store_prepend, 2, 0, 0, H_gtk_list_store_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_append", lg_gtk_list_store_append, 2, 0, 0, H_gtk_list_store_append, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_clear", lg_gtk_list_store_clear, 1, 0, 0, H_gtk_list_store_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_check_version", lg_gtk_check_version, 3, 0, 0, H_gtk_check_version, pl_si);
  s7_define_typed_function(sc, "gtk_disable_setlocale", lg_gtk_disable_setlocale, 0, 0, 0, H_gtk_disable_setlocale, pl_t);
  s7_define_typed_function(sc, "gtk_get_default_language", lg_gtk_get_default_language, 0, 0, 0, H_gtk_get_default_language, pl_p);
  s7_define_typed_function(sc, "gtk_events_pending", lg_gtk_events_pending, 0, 0, 0, H_gtk_events_pending, pl_i);
  s7_define_typed_function(sc, "gtk_main_do_event", lg_gtk_main_do_event, 1, 0, 0, H_gtk_main_do_event, pl_tu);
  s7_define_typed_function(sc, "gtk_main", lg_gtk_main, 0, 0, 0, H_gtk_main, pl_t);
  s7_define_typed_function(sc, "gtk_main_level", lg_gtk_main_level, 0, 0, 0, H_gtk_main_level, pl_i);
  s7_define_typed_function(sc, "gtk_main_quit", lg_gtk_main_quit, 0, 0, 0, H_gtk_main_quit, pl_t);
  s7_define_typed_function(sc, "gtk_main_iteration", lg_gtk_main_iteration, 0, 0, 0, H_gtk_main_iteration, pl_b);
  s7_define_typed_function(sc, "gtk_main_iteration_do", lg_gtk_main_iteration_do, 1, 0, 0, H_gtk_main_iteration_do, pl_b);
  s7_define_typed_function(sc, "gtk_true", lg_gtk_true, 0, 0, 0, H_gtk_true, pl_b);
  s7_define_typed_function(sc, "gtk_false", lg_gtk_false, 0, 0, 0, H_gtk_false, pl_b);
  s7_define_typed_function(sc, "gtk_grab_add", lg_gtk_grab_add, 1, 0, 0, H_gtk_grab_add, pl_tu);
  s7_define_typed_function(sc, "gtk_grab_get_current", lg_gtk_grab_get_current, 0, 0, 0, H_gtk_grab_get_current, pl_p);
  s7_define_typed_function(sc, "gtk_grab_remove", lg_gtk_grab_remove, 1, 0, 0, H_gtk_grab_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_get_current_event", lg_gtk_get_current_event, 0, 0, 0, H_gtk_get_current_event, pl_p);
  s7_define_typed_function(sc, "gtk_get_current_event_time", lg_gtk_get_current_event_time, 0, 0, 0, H_gtk_get_current_event_time, pl_i);
  s7_define_typed_function(sc, "gtk_get_current_event_state", lg_gtk_get_current_event_state, 0, 1, 0, H_gtk_get_current_event_state, pl_pu);
  s7_define_typed_function(sc, "gtk_get_event_widget", lg_gtk_get_event_widget, 1, 0, 0, H_gtk_get_event_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_propagate_event", lg_gtk_propagate_event, 2, 0, 0, H_gtk_propagate_event, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_bar_new", lg_gtk_menu_bar_new, 0, 0, 0, H_gtk_menu_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_menu_new", lg_gtk_menu_new, 0, 0, 0, H_gtk_menu_new, pl_p);
  s7_define_typed_function(sc, "gtk_menu_reposition", lg_gtk_menu_reposition, 1, 0, 0, H_gtk_menu_reposition, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_popdown", lg_gtk_menu_popdown, 1, 0, 0, H_gtk_menu_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_get_active", lg_gtk_menu_get_active, 1, 0, 0, H_gtk_menu_get_active, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_set_active", lg_gtk_menu_set_active, 2, 0, 0, H_gtk_menu_set_active, pl_tui);
  s7_define_typed_function(sc, "gtk_menu_set_accel_group", lg_gtk_menu_set_accel_group, 2, 0, 0, H_gtk_menu_set_accel_group, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_get_accel_group", lg_gtk_menu_get_accel_group, 1, 0, 0, H_gtk_menu_get_accel_group, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_set_accel_path", lg_gtk_menu_set_accel_path, 2, 0, 0, H_gtk_menu_set_accel_path, pl_tus);
  s7_define_typed_function(sc, "gtk_menu_detach", lg_gtk_menu_detach, 1, 0, 0, H_gtk_menu_detach, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_get_attach_widget", lg_gtk_menu_get_attach_widget, 1, 0, 0, H_gtk_menu_get_attach_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_reorder_child", lg_gtk_menu_reorder_child, 3, 0, 0, H_gtk_menu_reorder_child, pl_tuui);
  s7_define_typed_function(sc, "gtk_menu_set_monitor", lg_gtk_menu_set_monitor, 2, 0, 0, H_gtk_menu_set_monitor, pl_tui);
  s7_define_typed_function(sc, "gtk_menu_item_new", lg_gtk_menu_item_new, 0, 0, 0, H_gtk_menu_item_new, pl_p);
  s7_define_typed_function(sc, "gtk_menu_item_new_with_label", lg_gtk_menu_item_new_with_label, 1, 0, 0, H_gtk_menu_item_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_menu_item_new_with_mnemonic", lg_gtk_menu_item_new_with_mnemonic, 1, 0, 0, H_gtk_menu_item_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_menu_item_set_submenu", lg_gtk_menu_item_set_submenu, 2, 0, 0, H_gtk_menu_item_set_submenu, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_item_get_submenu", lg_gtk_menu_item_get_submenu, 1, 0, 0, H_gtk_menu_item_get_submenu, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_item_select", lg_gtk_menu_item_select, 1, 0, 0, H_gtk_menu_item_select, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_item_deselect", lg_gtk_menu_item_deselect, 1, 0, 0, H_gtk_menu_item_deselect, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_item_activate", lg_gtk_menu_item_activate, 1, 0, 0, H_gtk_menu_item_activate, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_item_toggle_size_request", lg_gtk_menu_item_toggle_size_request, 2, 0, 0, H_gtk_menu_item_toggle_size_request, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_item_toggle_size_allocate", lg_gtk_menu_item_toggle_size_allocate, 2, 0, 0, H_gtk_menu_item_toggle_size_allocate, pl_tui);
  s7_define_typed_function(sc, "gtk_menu_item_set_accel_path", lg_gtk_menu_item_set_accel_path, 2, 0, 0, H_gtk_menu_item_set_accel_path, pl_tus);
  s7_define_typed_function(sc, "gtk_menu_shell_append", lg_gtk_menu_shell_append, 2, 0, 0, H_gtk_menu_shell_append, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_shell_prepend", lg_gtk_menu_shell_prepend, 2, 0, 0, H_gtk_menu_shell_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_shell_insert", lg_gtk_menu_shell_insert, 3, 0, 0, H_gtk_menu_shell_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_menu_shell_deactivate", lg_gtk_menu_shell_deactivate, 1, 0, 0, H_gtk_menu_shell_deactivate, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_shell_select_item", lg_gtk_menu_shell_select_item, 2, 0, 0, H_gtk_menu_shell_select_item, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_shell_deselect", lg_gtk_menu_shell_deselect, 1, 0, 0, H_gtk_menu_shell_deselect, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_shell_activate_item", lg_gtk_menu_shell_activate_item, 3, 0, 0, H_gtk_menu_shell_activate_item, pl_tuub);
  s7_define_typed_function(sc, "gtk_notebook_new", lg_gtk_notebook_new, 0, 0, 0, H_gtk_notebook_new, pl_p);
  s7_define_typed_function(sc, "gtk_notebook_remove_page", lg_gtk_notebook_remove_page, 2, 0, 0, H_gtk_notebook_remove_page, pl_tui);
  s7_define_typed_function(sc, "gtk_notebook_get_current_page", lg_gtk_notebook_get_current_page, 1, 0, 0, H_gtk_notebook_get_current_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_get_nth_page", lg_gtk_notebook_get_nth_page, 2, 0, 0, H_gtk_notebook_get_nth_page, pl_pui);
  s7_define_typed_function(sc, "gtk_notebook_page_num", lg_gtk_notebook_page_num, 2, 0, 0, H_gtk_notebook_page_num, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_set_current_page", lg_gtk_notebook_set_current_page, 2, 0, 0, H_gtk_notebook_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_notebook_next_page", lg_gtk_notebook_next_page, 1, 0, 0, H_gtk_notebook_next_page, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_prev_page", lg_gtk_notebook_prev_page, 1, 0, 0, H_gtk_notebook_prev_page, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_show_border", lg_gtk_notebook_set_show_border, 2, 0, 0, H_gtk_notebook_set_show_border, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_show_border", lg_gtk_notebook_get_show_border, 1, 0, 0, H_gtk_notebook_get_show_border, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_show_tabs", lg_gtk_notebook_set_show_tabs, 2, 0, 0, H_gtk_notebook_set_show_tabs, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_show_tabs", lg_gtk_notebook_get_show_tabs, 1, 0, 0, H_gtk_notebook_get_show_tabs, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_pos", lg_gtk_notebook_set_tab_pos, 2, 0, 0, H_gtk_notebook_set_tab_pos, pl_tug);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_pos", lg_gtk_notebook_get_tab_pos, 1, 0, 0, H_gtk_notebook_get_tab_pos, pl_gu);
  s7_define_typed_function(sc, "gtk_notebook_set_scrollable", lg_gtk_notebook_set_scrollable, 2, 0, 0, H_gtk_notebook_set_scrollable, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_scrollable", lg_gtk_notebook_get_scrollable, 1, 0, 0, H_gtk_notebook_get_scrollable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_popup_enable", lg_gtk_notebook_popup_enable, 1, 0, 0, H_gtk_notebook_popup_enable, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_popup_disable", lg_gtk_notebook_popup_disable, 1, 0, 0, H_gtk_notebook_popup_disable, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_label", lg_gtk_notebook_get_tab_label, 2, 0, 0, H_gtk_notebook_get_tab_label, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_label", lg_gtk_notebook_set_tab_label, 3, 0, 0, H_gtk_notebook_set_tab_label, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_label_text", lg_gtk_notebook_set_tab_label_text, 3, 0, 0, H_gtk_notebook_set_tab_label_text, pl_tuus);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_label_text", lg_gtk_notebook_get_tab_label_text, 2, 0, 0, H_gtk_notebook_get_tab_label_text, pl_su);
  s7_define_typed_function(sc, "gtk_notebook_get_menu_label", lg_gtk_notebook_get_menu_label, 2, 0, 0, H_gtk_notebook_get_menu_label, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_set_menu_label", lg_gtk_notebook_set_menu_label, 3, 0, 0, H_gtk_notebook_set_menu_label, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_menu_label_text", lg_gtk_notebook_set_menu_label_text, 3, 0, 0, H_gtk_notebook_set_menu_label_text, pl_tuus);
  s7_define_typed_function(sc, "gtk_notebook_get_menu_label_text", lg_gtk_notebook_get_menu_label_text, 2, 0, 0, H_gtk_notebook_get_menu_label_text, pl_su);
  s7_define_typed_function(sc, "gtk_notebook_reorder_child", lg_gtk_notebook_reorder_child, 3, 0, 0, H_gtk_notebook_reorder_child, pl_tuui);
  s7_define_typed_function(sc, "gtk_notebook_append_page", lg_gtk_notebook_append_page, 3, 0, 0, H_gtk_notebook_append_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_append_page_menu", lg_gtk_notebook_append_page_menu, 4, 0, 0, H_gtk_notebook_append_page_menu, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_prepend_page", lg_gtk_notebook_prepend_page, 3, 0, 0, H_gtk_notebook_prepend_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_prepend_page_menu", lg_gtk_notebook_prepend_page_menu, 4, 0, 0, H_gtk_notebook_prepend_page_menu, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_insert_page", lg_gtk_notebook_insert_page, 4, 0, 0, H_gtk_notebook_insert_page, pl_iuuui);
  s7_define_typed_function(sc, "gtk_notebook_insert_page_menu", lg_gtk_notebook_insert_page_menu, 5, 0, 0, H_gtk_notebook_insert_page_menu, pl_iuuuui);
  s7_define_typed_function(sc, "gtk_paned_add1", lg_gtk_paned_add1, 2, 0, 0, H_gtk_paned_add1, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_add2", lg_gtk_paned_add2, 2, 0, 0, H_gtk_paned_add2, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_pack1", lg_gtk_paned_pack1, 4, 0, 0, H_gtk_paned_pack1, pl_tuub);
  s7_define_typed_function(sc, "gtk_paned_pack2", lg_gtk_paned_pack2, 4, 0, 0, H_gtk_paned_pack2, pl_tuub);
  s7_define_typed_function(sc, "gtk_paned_get_position", lg_gtk_paned_get_position, 1, 0, 0, H_gtk_paned_get_position, pl_iu);
  s7_define_typed_function(sc, "gtk_paned_set_position", lg_gtk_paned_set_position, 2, 0, 0, H_gtk_paned_set_position, pl_tui);
  s7_define_typed_function(sc, "gtk_progress_bar_new", lg_gtk_progress_bar_new, 0, 0, 0, H_gtk_progress_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_progress_bar_pulse", lg_gtk_progress_bar_pulse, 1, 0, 0, H_gtk_progress_bar_pulse, pl_tu);
  s7_define_typed_function(sc, "gtk_progress_bar_set_text", lg_gtk_progress_bar_set_text, 2, 0, 0, H_gtk_progress_bar_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_progress_bar_set_fraction", lg_gtk_progress_bar_set_fraction, 2, 0, 0, H_gtk_progress_bar_set_fraction, pl_tur);
  s7_define_typed_function(sc, "gtk_progress_bar_set_pulse_step", lg_gtk_progress_bar_set_pulse_step, 2, 0, 0, H_gtk_progress_bar_set_pulse_step, pl_tur);
  s7_define_typed_function(sc, "gtk_progress_bar_get_text", lg_gtk_progress_bar_get_text, 1, 0, 0, H_gtk_progress_bar_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_progress_bar_get_fraction", lg_gtk_progress_bar_get_fraction, 1, 0, 0, H_gtk_progress_bar_get_fraction, pl_du);
  s7_define_typed_function(sc, "gtk_progress_bar_get_pulse_step", lg_gtk_progress_bar_get_pulse_step, 1, 0, 0, H_gtk_progress_bar_get_pulse_step, pl_du);
  s7_define_typed_function(sc, "gtk_radio_button_new", lg_gtk_radio_button_new, 1, 0, 0, H_gtk_radio_button_new, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_new_from_widget", lg_gtk_radio_button_new_from_widget, 1, 0, 0, H_gtk_radio_button_new_from_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_label", lg_gtk_radio_button_new_with_label, 2, 0, 0, H_gtk_radio_button_new_with_label, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_label_from_widget", lg_gtk_radio_button_new_with_label_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_label_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_mnemonic", lg_gtk_radio_button_new_with_mnemonic, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_mnemonic_from_widget", lg_gtk_radio_button_new_with_mnemonic_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_get_group", lg_gtk_radio_button_get_group, 1, 0, 0, H_gtk_radio_button_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_set_group", lg_gtk_radio_button_set_group, 2, 0, 0, H_gtk_radio_button_set_group, pl_tu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new", lg_gtk_radio_menu_item_new, 1, 0, 0, H_gtk_radio_menu_item_new, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new_with_label", lg_gtk_radio_menu_item_new_with_label, 2, 0, 0, H_gtk_radio_menu_item_new_with_label, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new_with_mnemonic", lg_gtk_radio_menu_item_new_with_mnemonic, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_menu_item_get_group", lg_gtk_radio_menu_item_get_group, 1, 0, 0, H_gtk_radio_menu_item_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_set_group", lg_gtk_radio_menu_item_set_group, 2, 0, 0, H_gtk_radio_menu_item_set_group, pl_tu);
  s7_define_typed_function(sc, "gtk_range_set_adjustment", lg_gtk_range_set_adjustment, 2, 0, 0, H_gtk_range_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_range_get_adjustment", lg_gtk_range_get_adjustment, 1, 0, 0, H_gtk_range_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_range_set_inverted", lg_gtk_range_set_inverted, 2, 0, 0, H_gtk_range_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_inverted", lg_gtk_range_get_inverted, 1, 0, 0, H_gtk_range_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_increments", lg_gtk_range_set_increments, 3, 0, 0, H_gtk_range_set_increments, pl_tur);
  s7_define_typed_function(sc, "gtk_range_set_range", lg_gtk_range_set_range, 3, 0, 0, H_gtk_range_set_range, pl_tur);
  s7_define_typed_function(sc, "gtk_range_set_value", lg_gtk_range_set_value, 2, 0, 0, H_gtk_range_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_range_get_value", lg_gtk_range_get_value, 1, 0, 0, H_gtk_range_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_scale_set_digits", lg_gtk_scale_set_digits, 2, 0, 0, H_gtk_scale_set_digits, pl_tui);
  s7_define_typed_function(sc, "gtk_scale_get_digits", lg_gtk_scale_get_digits, 1, 0, 0, H_gtk_scale_get_digits, pl_iu);
  s7_define_typed_function(sc, "gtk_scale_set_draw_value", lg_gtk_scale_set_draw_value, 2, 0, 0, H_gtk_scale_set_draw_value, pl_tub);
  s7_define_typed_function(sc, "gtk_scale_get_draw_value", lg_gtk_scale_get_draw_value, 1, 0, 0, H_gtk_scale_get_draw_value, pl_bu);
  s7_define_typed_function(sc, "gtk_scale_set_value_pos", lg_gtk_scale_set_value_pos, 2, 0, 0, H_gtk_scale_set_value_pos, pl_tug);
  s7_define_typed_function(sc, "gtk_scale_get_value_pos", lg_gtk_scale_get_value_pos, 1, 0, 0, H_gtk_scale_get_value_pos, pl_gu);
  s7_define_typed_function(sc, "gtk_scrolled_window_new", lg_gtk_scrolled_window_new, 2, 0, 0, H_gtk_scrolled_window_new, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_hadjustment", lg_gtk_scrolled_window_set_hadjustment, 2, 0, 0, H_gtk_scrolled_window_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_vadjustment", lg_gtk_scrolled_window_set_vadjustment, 2, 0, 0, H_gtk_scrolled_window_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_hadjustment", lg_gtk_scrolled_window_get_hadjustment, 1, 0, 0, H_gtk_scrolled_window_get_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_vadjustment", lg_gtk_scrolled_window_get_vadjustment, 1, 0, 0, H_gtk_scrolled_window_get_vadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_policy", lg_gtk_scrolled_window_set_policy, 3, 0, 0, H_gtk_scrolled_window_set_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_policy", lg_gtk_scrolled_window_get_policy, 1, 2, 0, H_gtk_scrolled_window_get_policy, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_placement", lg_gtk_scrolled_window_set_placement, 2, 0, 0, H_gtk_scrolled_window_set_placement, pl_tug);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_placement", lg_gtk_scrolled_window_get_placement, 1, 0, 0, H_gtk_scrolled_window_get_placement, pl_gu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_shadow_type", lg_gtk_scrolled_window_set_shadow_type, 2, 0, 0, H_gtk_scrolled_window_set_shadow_type, pl_tug);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_shadow_type", lg_gtk_scrolled_window_get_shadow_type, 1, 0, 0, H_gtk_scrolled_window_get_shadow_type, pl_gu);
  s7_define_typed_function(sc, "gtk_target_list_new", lg_gtk_target_list_new, 2, 0, 0, H_gtk_target_list_new, pl_pui);
  s7_define_typed_function(sc, "gtk_target_list_unref", lg_gtk_target_list_unref, 1, 0, 0, H_gtk_target_list_unref, pl_tu);
  s7_define_typed_function(sc, "gtk_target_list_add", lg_gtk_target_list_add, 4, 0, 0, H_gtk_target_list_add, pl_tuti);
  s7_define_typed_function(sc, "gtk_target_list_add_table", lg_gtk_target_list_add_table, 3, 0, 0, H_gtk_target_list_add_table, pl_tuui);
  s7_define_typed_function(sc, "gtk_target_list_remove", lg_gtk_target_list_remove, 2, 0, 0, H_gtk_target_list_remove, pl_tut);
  s7_define_typed_function(sc, "gtk_target_list_find", lg_gtk_target_list_find, 2, 1, 0, H_gtk_target_list_find, pl_putu);
  s7_define_typed_function(sc, "gtk_selection_owner_set", lg_gtk_selection_owner_set, 3, 0, 0, H_gtk_selection_owner_set, pl_buti);
  s7_define_typed_function(sc, "gtk_selection_add_target", lg_gtk_selection_add_target, 4, 0, 0, H_gtk_selection_add_target, pl_tutti);
  s7_define_typed_function(sc, "gtk_selection_add_targets", lg_gtk_selection_add_targets, 4, 0, 0, H_gtk_selection_add_targets, pl_tutui);
  s7_define_typed_function(sc, "gtk_selection_clear_targets", lg_gtk_selection_clear_targets, 2, 0, 0, H_gtk_selection_clear_targets, pl_tut);
  s7_define_typed_function(sc, "gtk_selection_convert", lg_gtk_selection_convert, 4, 0, 0, H_gtk_selection_convert, pl_butti);
  s7_define_typed_function(sc, "gtk_selection_data_set", lg_gtk_selection_data_set, 5, 0, 0, H_gtk_selection_data_set, pl_tutisi);
  s7_define_typed_function(sc, "gtk_selection_data_set_text", lg_gtk_selection_data_set_text, 3, 0, 0, H_gtk_selection_data_set_text, pl_busi);
  s7_define_typed_function(sc, "gtk_selection_data_get_text", lg_gtk_selection_data_get_text, 1, 0, 0, H_gtk_selection_data_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_selection_data_get_targets", lg_gtk_selection_data_get_targets, 1, 2, 0, H_gtk_selection_data_get_targets, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_targets_include_text", lg_gtk_selection_data_targets_include_text, 1, 0, 0, H_gtk_selection_data_targets_include_text, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_remove_all", lg_gtk_selection_remove_all, 1, 0, 0, H_gtk_selection_remove_all, pl_tu);
  s7_define_typed_function(sc, "gtk_selection_data_copy", lg_gtk_selection_data_copy, 1, 0, 0, H_gtk_selection_data_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_free", lg_gtk_selection_data_free, 1, 0, 0, H_gtk_selection_data_free, pl_tu);
  s7_define_typed_function(sc, "gtk_separator_menu_item_new", lg_gtk_separator_menu_item_new, 0, 0, 0, H_gtk_separator_menu_item_new, pl_p);
  s7_define_typed_function(sc, "gtk_settings_get_default", lg_gtk_settings_get_default, 0, 0, 0, H_gtk_settings_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_size_group_new", lg_gtk_size_group_new, 1, 0, 0, H_gtk_size_group_new, pl_pg);
  s7_define_typed_function(sc, "gtk_size_group_set_mode", lg_gtk_size_group_set_mode, 2, 0, 0, H_gtk_size_group_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_size_group_get_mode", lg_gtk_size_group_get_mode, 1, 0, 0, H_gtk_size_group_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_size_group_add_widget", lg_gtk_size_group_add_widget, 2, 0, 0, H_gtk_size_group_add_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_size_group_remove_widget", lg_gtk_size_group_remove_widget, 2, 0, 0, H_gtk_size_group_remove_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_spin_button_configure", lg_gtk_spin_button_configure, 4, 0, 0, H_gtk_spin_button_configure, pl_tuuri);
  s7_define_typed_function(sc, "gtk_spin_button_new", lg_gtk_spin_button_new, 3, 0, 0, H_gtk_spin_button_new, pl_puri);
  s7_define_typed_function(sc, "gtk_spin_button_new_with_range", lg_gtk_spin_button_new_with_range, 3, 0, 0, H_gtk_spin_button_new_with_range, pl_pr);
  s7_define_typed_function(sc, "gtk_spin_button_set_adjustment", lg_gtk_spin_button_set_adjustment, 2, 0, 0, H_gtk_spin_button_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_spin_button_get_adjustment", lg_gtk_spin_button_get_adjustment, 1, 0, 0, H_gtk_spin_button_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_set_digits", lg_gtk_spin_button_set_digits, 2, 0, 0, H_gtk_spin_button_set_digits, pl_tui);
  s7_define_typed_function(sc, "gtk_spin_button_get_digits", lg_gtk_spin_button_get_digits, 1, 0, 0, H_gtk_spin_button_get_digits, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_increments", lg_gtk_spin_button_set_increments, 3, 0, 0, H_gtk_spin_button_set_increments, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_get_increments", lg_gtk_spin_button_get_increments, 1, 2, 0, H_gtk_spin_button_get_increments, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_set_range", lg_gtk_spin_button_set_range, 3, 0, 0, H_gtk_spin_button_set_range, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_get_range", lg_gtk_spin_button_get_range, 1, 2, 0, H_gtk_spin_button_get_range, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_get_value", lg_gtk_spin_button_get_value, 1, 0, 0, H_gtk_spin_button_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_spin_button_get_value_as_int", lg_gtk_spin_button_get_value_as_int, 1, 0, 0, H_gtk_spin_button_get_value_as_int, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_value", lg_gtk_spin_button_set_value, 2, 0, 0, H_gtk_spin_button_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_set_update_policy", lg_gtk_spin_button_set_update_policy, 2, 0, 0, H_gtk_spin_button_set_update_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_spin_button_get_update_policy", lg_gtk_spin_button_get_update_policy, 1, 0, 0, H_gtk_spin_button_get_update_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_spin_button_set_numeric", lg_gtk_spin_button_set_numeric, 2, 0, 0, H_gtk_spin_button_set_numeric, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_numeric", lg_gtk_spin_button_get_numeric, 1, 0, 0, H_gtk_spin_button_get_numeric, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_spin", lg_gtk_spin_button_spin, 3, 0, 0, H_gtk_spin_button_spin, pl_tugr);
  s7_define_typed_function(sc, "gtk_spin_button_set_wrap", lg_gtk_spin_button_set_wrap, 2, 0, 0, H_gtk_spin_button_set_wrap, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_wrap", lg_gtk_spin_button_get_wrap, 1, 0, 0, H_gtk_spin_button_get_wrap, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_set_snap_to_ticks", lg_gtk_spin_button_set_snap_to_ticks, 2, 0, 0, H_gtk_spin_button_set_snap_to_ticks, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_snap_to_ticks", lg_gtk_spin_button_get_snap_to_ticks, 1, 0, 0, H_gtk_spin_button_get_snap_to_ticks, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_update", lg_gtk_spin_button_update, 1, 0, 0, H_gtk_spin_button_update, pl_tu);
  s7_define_typed_function(sc, "gtk_statusbar_new", lg_gtk_statusbar_new, 0, 0, 0, H_gtk_statusbar_new, pl_p);
  s7_define_typed_function(sc, "gtk_statusbar_get_context_id", lg_gtk_statusbar_get_context_id, 2, 0, 0, H_gtk_statusbar_get_context_id, pl_ius);
  s7_define_typed_function(sc, "gtk_statusbar_push", lg_gtk_statusbar_push, 3, 0, 0, H_gtk_statusbar_push, pl_iuis);
  s7_define_typed_function(sc, "gtk_statusbar_pop", lg_gtk_statusbar_pop, 2, 0, 0, H_gtk_statusbar_pop, pl_tui);
  s7_define_typed_function(sc, "gtk_statusbar_remove", lg_gtk_statusbar_remove, 3, 0, 0, H_gtk_statusbar_remove, pl_tui);
  s7_define_typed_function(sc, "gtk_text_buffer_new", lg_gtk_text_buffer_new, 1, 0, 0, H_gtk_text_buffer_new, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_line_count", lg_gtk_text_buffer_get_line_count, 1, 0, 0, H_gtk_text_buffer_get_line_count, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_char_count", lg_gtk_text_buffer_get_char_count, 1, 0, 0, H_gtk_text_buffer_get_char_count, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_tag_table", lg_gtk_text_buffer_get_tag_table, 1, 0, 0, H_gtk_text_buffer_get_tag_table, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_text", lg_gtk_text_buffer_set_text, 3, 0, 0, H_gtk_text_buffer_set_text, pl_tusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert", lg_gtk_text_buffer_insert, 4, 0, 0, H_gtk_text_buffer_insert, pl_tuusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_at_cursor", lg_gtk_text_buffer_insert_at_cursor, 3, 0, 0, H_gtk_text_buffer_insert_at_cursor, pl_tusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_interactive", lg_gtk_text_buffer_insert_interactive, 5, 0, 0, H_gtk_text_buffer_insert_interactive, pl_buusib);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_interactive_at_cursor", lg_gtk_text_buffer_insert_interactive_at_cursor, 4, 0, 0, H_gtk_text_buffer_insert_interactive_at_cursor, pl_busib);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_range", lg_gtk_text_buffer_insert_range, 4, 0, 0, H_gtk_text_buffer_insert_range, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_range_interactive", lg_gtk_text_buffer_insert_range_interactive, 5, 0, 0, H_gtk_text_buffer_insert_range_interactive, pl_buuuub);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_with_tags", lg_gtk_text_buffer_insert_with_tags, 5, 0, 0, H_gtk_text_buffer_insert_with_tags, pl_tuusit);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_with_tags_by_name", lg_gtk_text_buffer_insert_with_tags_by_name, 5, 0, 0, H_gtk_text_buffer_insert_with_tags_by_name, pl_tuusit);
  s7_define_typed_function(sc, "gtk_text_buffer_delete", lg_gtk_text_buffer_delete, 3, 0, 0, H_gtk_text_buffer_delete, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_interactive", lg_gtk_text_buffer_delete_interactive, 4, 0, 0, H_gtk_text_buffer_delete_interactive, pl_buuub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_text", lg_gtk_text_buffer_get_text, 4, 0, 0, H_gtk_text_buffer_get_text, pl_suuub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_slice", lg_gtk_text_buffer_get_slice, 4, 0, 0, H_gtk_text_buffer_get_slice, pl_suuub);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_pixbuf", lg_gtk_text_buffer_insert_pixbuf, 3, 0, 0, H_gtk_text_buffer_insert_pixbuf, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_child_anchor", lg_gtk_text_buffer_insert_child_anchor, 3, 0, 0, H_gtk_text_buffer_insert_child_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_child_anchor", lg_gtk_text_buffer_create_child_anchor, 2, 0, 0, H_gtk_text_buffer_create_child_anchor, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_mark", lg_gtk_text_buffer_create_mark, 4, 0, 0, H_gtk_text_buffer_create_mark, pl_pusub);
  s7_define_typed_function(sc, "gtk_text_buffer_move_mark", lg_gtk_text_buffer_move_mark, 3, 0, 0, H_gtk_text_buffer_move_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_mark", lg_gtk_text_buffer_delete_mark, 2, 0, 0, H_gtk_text_buffer_delete_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_mark", lg_gtk_text_buffer_get_mark, 2, 0, 0, H_gtk_text_buffer_get_mark, pl_pus);
  s7_define_typed_function(sc, "gtk_text_buffer_move_mark_by_name", lg_gtk_text_buffer_move_mark_by_name, 3, 0, 0, H_gtk_text_buffer_move_mark_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_mark_by_name", lg_gtk_text_buffer_delete_mark_by_name, 2, 0, 0, H_gtk_text_buffer_delete_mark_by_name, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_get_insert", lg_gtk_text_buffer_get_insert, 1, 0, 0, H_gtk_text_buffer_get_insert, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_selection_bound", lg_gtk_text_buffer_get_selection_bound, 1, 0, 0, H_gtk_text_buffer_get_selection_bound, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_place_cursor", lg_gtk_text_buffer_place_cursor, 2, 0, 0, H_gtk_text_buffer_place_cursor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_apply_tag", lg_gtk_text_buffer_apply_tag, 4, 0, 0, H_gtk_text_buffer_apply_tag, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_tag", lg_gtk_text_buffer_remove_tag, 4, 0, 0, H_gtk_text_buffer_remove_tag, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_apply_tag_by_name", lg_gtk_text_buffer_apply_tag_by_name, 4, 0, 0, H_gtk_text_buffer_apply_tag_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_tag_by_name", lg_gtk_text_buffer_remove_tag_by_name, 4, 0, 0, H_gtk_text_buffer_remove_tag_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_all_tags", lg_gtk_text_buffer_remove_all_tags, 3, 0, 0, H_gtk_text_buffer_remove_all_tags, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_tag", lg_gtk_text_buffer_create_tag, 2, 1, 0, H_gtk_text_buffer_create_tag, pl_pust);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line_offset", lg_gtk_text_buffer_get_iter_at_line_offset, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_offset, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line_index", lg_gtk_text_buffer_get_iter_at_line_index, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_index, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_offset", lg_gtk_text_buffer_get_iter_at_offset, 3, 0, 0, H_gtk_text_buffer_get_iter_at_offset, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line", lg_gtk_text_buffer_get_iter_at_line, 3, 0, 0, H_gtk_text_buffer_get_iter_at_line, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_start_iter", lg_gtk_text_buffer_get_start_iter, 2, 0, 0, H_gtk_text_buffer_get_start_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_end_iter", lg_gtk_text_buffer_get_end_iter, 2, 0, 0, H_gtk_text_buffer_get_end_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_bounds", lg_gtk_text_buffer_get_bounds, 3, 0, 0, H_gtk_text_buffer_get_bounds, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_mark", lg_gtk_text_buffer_get_iter_at_mark, 3, 0, 0, H_gtk_text_buffer_get_iter_at_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_child_anchor", lg_gtk_text_buffer_get_iter_at_child_anchor, 3, 0, 0, H_gtk_text_buffer_get_iter_at_child_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_modified", lg_gtk_text_buffer_get_modified, 1, 0, 0, H_gtk_text_buffer_get_modified, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_modified", lg_gtk_text_buffer_set_modified, 2, 0, 0, H_gtk_text_buffer_set_modified, pl_tub);
  s7_define_typed_function(sc, "gtk_text_buffer_add_selection_clipboard", lg_gtk_text_buffer_add_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_add_selection_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_selection_clipboard", lg_gtk_text_buffer_remove_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_remove_selection_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_cut_clipboard", lg_gtk_text_buffer_cut_clipboard, 3, 0, 0, H_gtk_text_buffer_cut_clipboard, pl_tuub);
  s7_define_typed_function(sc, "gtk_text_buffer_copy_clipboard", lg_gtk_text_buffer_copy_clipboard, 2, 0, 0, H_gtk_text_buffer_copy_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_paste_clipboard", lg_gtk_text_buffer_paste_clipboard, 4, 0, 0, H_gtk_text_buffer_paste_clipboard, pl_tuuub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_selection_bounds", lg_gtk_text_buffer_get_selection_bounds, 3, 0, 0, H_gtk_text_buffer_get_selection_bounds, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_selection", lg_gtk_text_buffer_delete_selection, 3, 0, 0, H_gtk_text_buffer_delete_selection, pl_bub);
  s7_define_typed_function(sc, "gtk_text_buffer_begin_user_action", lg_gtk_text_buffer_begin_user_action, 1, 0, 0, H_gtk_text_buffer_begin_user_action, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_end_user_action", lg_gtk_text_buffer_end_user_action, 1, 0, 0, H_gtk_text_buffer_end_user_action, pl_tu);
  s7_define_typed_function(sc, "gtk_text_child_anchor_new", lg_gtk_text_child_anchor_new, 0, 0, 0, H_gtk_text_child_anchor_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_child_anchor_get_widgets", lg_gtk_text_child_anchor_get_widgets, 1, 0, 0, H_gtk_text_child_anchor_get_widgets, pl_pu);
  s7_define_typed_function(sc, "gtk_text_child_anchor_get_deleted", lg_gtk_text_child_anchor_get_deleted, 1, 0, 0, H_gtk_text_child_anchor_get_deleted, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_buffer", lg_gtk_text_iter_get_buffer, 1, 0, 0, H_gtk_text_iter_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_copy", lg_gtk_text_iter_copy, 1, 0, 0, H_gtk_text_iter_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_free", lg_gtk_text_iter_free, 1, 0, 0, H_gtk_text_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_text_iter_get_offset", lg_gtk_text_iter_get_offset, 1, 0, 0, H_gtk_text_iter_get_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line", lg_gtk_text_iter_get_line, 1, 0, 0, H_gtk_text_iter_get_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line_offset", lg_gtk_text_iter_get_line_offset, 1, 0, 0, H_gtk_text_iter_get_line_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line_index", lg_gtk_text_iter_get_line_index, 1, 0, 0, H_gtk_text_iter_get_line_index, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_line_offset", lg_gtk_text_iter_get_visible_line_offset, 1, 0, 0, H_gtk_text_iter_get_visible_line_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_line_index", lg_gtk_text_iter_get_visible_line_index, 1, 0, 0, H_gtk_text_iter_get_visible_line_index, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_char", lg_gtk_text_iter_get_char, 1, 0, 0, H_gtk_text_iter_get_char, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_slice", lg_gtk_text_iter_get_slice, 2, 0, 0, H_gtk_text_iter_get_slice, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_text", lg_gtk_text_iter_get_text, 2, 0, 0, H_gtk_text_iter_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_slice", lg_gtk_text_iter_get_visible_slice, 2, 0, 0, H_gtk_text_iter_get_visible_slice, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_text", lg_gtk_text_iter_get_visible_text, 2, 0, 0, H_gtk_text_iter_get_visible_text, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_pixbuf", lg_gtk_text_iter_get_pixbuf, 1, 0, 0, H_gtk_text_iter_get_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_get_marks", lg_gtk_text_iter_get_marks, 1, 0, 0, H_gtk_text_iter_get_marks, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_get_child_anchor", lg_gtk_text_iter_get_child_anchor, 1, 0, 0, H_gtk_text_iter_get_child_anchor, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_get_toggled_tags", lg_gtk_text_iter_get_toggled_tags, 2, 0, 0, H_gtk_text_iter_get_toggled_tags, pl_pub);
  s7_define_typed_function(sc, "gtk_text_iter_ends_tag", lg_gtk_text_iter_ends_tag, 2, 0, 0, H_gtk_text_iter_ends_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_toggles_tag", lg_gtk_text_iter_toggles_tag, 2, 0, 0, H_gtk_text_iter_toggles_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_has_tag", lg_gtk_text_iter_has_tag, 2, 0, 0, H_gtk_text_iter_has_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_tags", lg_gtk_text_iter_get_tags, 1, 0, 0, H_gtk_text_iter_get_tags, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_editable", lg_gtk_text_iter_editable, 2, 0, 0, H_gtk_text_iter_editable, pl_bub);
  s7_define_typed_function(sc, "gtk_text_iter_can_insert", lg_gtk_text_iter_can_insert, 2, 0, 0, H_gtk_text_iter_can_insert, pl_bub);
  s7_define_typed_function(sc, "gtk_text_iter_starts_word", lg_gtk_text_iter_starts_word, 1, 0, 0, H_gtk_text_iter_starts_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_word", lg_gtk_text_iter_ends_word, 1, 0, 0, H_gtk_text_iter_ends_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_inside_word", lg_gtk_text_iter_inside_word, 1, 0, 0, H_gtk_text_iter_inside_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_sentence", lg_gtk_text_iter_starts_sentence, 1, 0, 0, H_gtk_text_iter_starts_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_sentence", lg_gtk_text_iter_ends_sentence, 1, 0, 0, H_gtk_text_iter_ends_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_inside_sentence", lg_gtk_text_iter_inside_sentence, 1, 0, 0, H_gtk_text_iter_inside_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_line", lg_gtk_text_iter_starts_line, 1, 0, 0, H_gtk_text_iter_starts_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_line", lg_gtk_text_iter_ends_line, 1, 0, 0, H_gtk_text_iter_ends_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_is_cursor_position", lg_gtk_text_iter_is_cursor_position, 1, 0, 0, H_gtk_text_iter_is_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_chars_in_line", lg_gtk_text_iter_get_chars_in_line, 1, 0, 0, H_gtk_text_iter_get_chars_in_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_bytes_in_line", lg_gtk_text_iter_get_bytes_in_line, 1, 0, 0, H_gtk_text_iter_get_bytes_in_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_language", lg_gtk_text_iter_get_language, 1, 0, 0, H_gtk_text_iter_get_language, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_is_end", lg_gtk_text_iter_is_end, 1, 0, 0, H_gtk_text_iter_is_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_is_start", lg_gtk_text_iter_is_start, 1, 0, 0, H_gtk_text_iter_is_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_char", lg_gtk_text_iter_forward_char, 1, 0, 0, H_gtk_text_iter_forward_char, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_char", lg_gtk_text_iter_backward_char, 1, 0, 0, H_gtk_text_iter_backward_char, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_chars", lg_gtk_text_iter_forward_chars, 2, 0, 0, H_gtk_text_iter_forward_chars, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_chars", lg_gtk_text_iter_backward_chars, 2, 0, 0, H_gtk_text_iter_backward_chars, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_line", lg_gtk_text_iter_forward_line, 1, 0, 0, H_gtk_text_iter_forward_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_line", lg_gtk_text_iter_backward_line, 1, 0, 0, H_gtk_text_iter_backward_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_lines", lg_gtk_text_iter_forward_lines, 2, 0, 0, H_gtk_text_iter_forward_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_lines", lg_gtk_text_iter_backward_lines, 2, 0, 0, H_gtk_text_iter_backward_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_word_end", lg_gtk_text_iter_forward_word_end, 1, 0, 0, H_gtk_text_iter_forward_word_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_word_start", lg_gtk_text_iter_backward_word_start, 1, 0, 0, H_gtk_text_iter_backward_word_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_word_ends", lg_gtk_text_iter_forward_word_ends, 2, 0, 0, H_gtk_text_iter_forward_word_ends, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_word_starts", lg_gtk_text_iter_backward_word_starts, 2, 0, 0, H_gtk_text_iter_backward_word_starts, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_sentence_end", lg_gtk_text_iter_forward_sentence_end, 1, 0, 0, H_gtk_text_iter_forward_sentence_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_sentence_start", lg_gtk_text_iter_backward_sentence_start, 1, 0, 0, H_gtk_text_iter_backward_sentence_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_sentence_ends", lg_gtk_text_iter_forward_sentence_ends, 2, 0, 0, H_gtk_text_iter_forward_sentence_ends, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_sentence_starts", lg_gtk_text_iter_backward_sentence_starts, 2, 0, 0, H_gtk_text_iter_backward_sentence_starts, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_cursor_position", lg_gtk_text_iter_forward_cursor_position, 1, 0, 0, H_gtk_text_iter_forward_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_cursor_position", lg_gtk_text_iter_backward_cursor_position, 1, 0, 0, H_gtk_text_iter_backward_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_cursor_positions", lg_gtk_text_iter_forward_cursor_positions, 2, 0, 0, H_gtk_text_iter_forward_cursor_positions, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_cursor_positions", lg_gtk_text_iter_backward_cursor_positions, 2, 0, 0, H_gtk_text_iter_backward_cursor_positions, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_set_offset", lg_gtk_text_iter_set_offset, 2, 0, 0, H_gtk_text_iter_set_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line", lg_gtk_text_iter_set_line, 2, 0, 0, H_gtk_text_iter_set_line, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line_offset", lg_gtk_text_iter_set_line_offset, 2, 0, 0, H_gtk_text_iter_set_line_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line_index", lg_gtk_text_iter_set_line_index, 2, 0, 0, H_gtk_text_iter_set_line_index, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_end", lg_gtk_text_iter_forward_to_end, 1, 0, 0, H_gtk_text_iter_forward_to_end, pl_tu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_line_end", lg_gtk_text_iter_forward_to_line_end, 1, 0, 0, H_gtk_text_iter_forward_to_line_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_set_visible_line_offset", lg_gtk_text_iter_set_visible_line_offset, 2, 0, 0, H_gtk_text_iter_set_visible_line_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_visible_line_index", lg_gtk_text_iter_set_visible_line_index, 2, 0, 0, H_gtk_text_iter_set_visible_line_index, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_tag_toggle", lg_gtk_text_iter_forward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_forward_to_tag_toggle, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_to_tag_toggle", lg_gtk_text_iter_backward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_backward_to_tag_toggle, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_find_char", lg_gtk_text_iter_forward_find_char, 4, 0, 0, H_gtk_text_iter_forward_find_char, pl_buttu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_find_char", lg_gtk_text_iter_backward_find_char, 4, 0, 0, H_gtk_text_iter_backward_find_char, pl_buttu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_search", lg_gtk_text_iter_forward_search, 6, 0, 0, H_gtk_text_iter_forward_search, pl_busgu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_search", lg_gtk_text_iter_backward_search, 6, 0, 0, H_gtk_text_iter_backward_search, pl_busgu);
  s7_define_typed_function(sc, "gtk_text_iter_equal", lg_gtk_text_iter_equal, 2, 0, 0, H_gtk_text_iter_equal, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_compare", lg_gtk_text_iter_compare, 2, 0, 0, H_gtk_text_iter_compare, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_in_range", lg_gtk_text_iter_in_range, 3, 0, 0, H_gtk_text_iter_in_range, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_order", lg_gtk_text_iter_order, 2, 0, 0, H_gtk_text_iter_order, pl_tu);
  s7_define_typed_function(sc, "gtk_text_mark_set_visible", lg_gtk_text_mark_set_visible, 2, 0, 0, H_gtk_text_mark_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_text_mark_get_visible", lg_gtk_text_mark_get_visible, 1, 0, 0, H_gtk_text_mark_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_text_mark_get_name", lg_gtk_text_mark_get_name, 1, 0, 0, H_gtk_text_mark_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_text_mark_get_deleted", lg_gtk_text_mark_get_deleted, 1, 0, 0, H_gtk_text_mark_get_deleted, pl_bu);
  s7_define_typed_function(sc, "gtk_text_mark_get_buffer", lg_gtk_text_mark_get_buffer, 1, 0, 0, H_gtk_text_mark_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_mark_get_left_gravity", lg_gtk_text_mark_get_left_gravity, 1, 0, 0, H_gtk_text_mark_get_left_gravity, pl_bu);
  s7_define_typed_function(sc, "gtk_text_tag_new", lg_gtk_text_tag_new, 1, 0, 0, H_gtk_text_tag_new, pl_ps);
  s7_define_typed_function(sc, "gtk_text_tag_get_priority", lg_gtk_text_tag_get_priority, 1, 0, 0, H_gtk_text_tag_get_priority, pl_iu);
  s7_define_typed_function(sc, "gtk_text_tag_set_priority", lg_gtk_text_tag_set_priority, 2, 0, 0, H_gtk_text_tag_set_priority, pl_tui);
  s7_define_typed_function(sc, "gtk_text_tag_event", lg_gtk_text_tag_event, 4, 0, 0, H_gtk_text_tag_event, pl_bu);
  s7_define_typed_function(sc, "gtk_text_attributes_new", lg_gtk_text_attributes_new, 0, 0, 0, H_gtk_text_attributes_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_attributes_copy", lg_gtk_text_attributes_copy, 1, 0, 0, H_gtk_text_attributes_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_text_attributes_copy_values", lg_gtk_text_attributes_copy_values, 2, 0, 0, H_gtk_text_attributes_copy_values, pl_tu);
  s7_define_typed_function(sc, "gtk_text_attributes_unref", lg_gtk_text_attributes_unref, 1, 0, 0, H_gtk_text_attributes_unref, pl_tu);
  s7_define_typed_function(sc, "gtk_text_tag_table_new", lg_gtk_text_tag_table_new, 0, 0, 0, H_gtk_text_tag_table_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_tag_table_add", lg_gtk_text_tag_table_add, 2, 0, 0, H_gtk_text_tag_table_add, pl_tu);
  s7_define_typed_function(sc, "gtk_text_tag_table_remove", lg_gtk_text_tag_table_remove, 2, 0, 0, H_gtk_text_tag_table_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_text_tag_table_lookup", lg_gtk_text_tag_table_lookup, 2, 0, 0, H_gtk_text_tag_table_lookup, pl_pus);
  s7_define_typed_function(sc, "gtk_text_tag_table_foreach", lg_gtk_text_tag_table_foreach, 2, 1, 0, H_gtk_text_tag_table_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_text_tag_table_get_size", lg_gtk_text_tag_table_get_size, 1, 0, 0, H_gtk_text_tag_table_get_size, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_new", lg_gtk_text_view_new, 0, 0, 0, H_gtk_text_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_view_new_with_buffer", lg_gtk_text_view_new_with_buffer, 1, 0, 0, H_gtk_text_view_new_with_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_set_buffer", lg_gtk_text_view_set_buffer, 2, 0, 0, H_gtk_text_view_set_buffer, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_buffer", lg_gtk_text_view_get_buffer, 1, 0, 0, H_gtk_text_view_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_scroll_to_iter", lg_gtk_text_view_scroll_to_iter, 6, 0, 0, H_gtk_text_view_scroll_to_iter, pl_buurbr);
  s7_define_typed_function(sc, "gtk_text_view_scroll_to_mark", lg_gtk_text_view_scroll_to_mark, 6, 0, 0, H_gtk_text_view_scroll_to_mark, pl_tuurbr);
  s7_define_typed_function(sc, "gtk_text_view_scroll_mark_onscreen", lg_gtk_text_view_scroll_mark_onscreen, 2, 0, 0, H_gtk_text_view_scroll_mark_onscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_move_mark_onscreen", lg_gtk_text_view_move_mark_onscreen, 2, 0, 0, H_gtk_text_view_move_mark_onscreen, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_place_cursor_onscreen", lg_gtk_text_view_place_cursor_onscreen, 1, 0, 0, H_gtk_text_view_place_cursor_onscreen, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_get_visible_rect", lg_gtk_text_view_get_visible_rect, 2, 0, 0, H_gtk_text_view_get_visible_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_set_cursor_visible", lg_gtk_text_view_set_cursor_visible, 2, 0, 0, H_gtk_text_view_set_cursor_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_cursor_visible", lg_gtk_text_view_get_cursor_visible, 1, 0, 0, H_gtk_text_view_get_cursor_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_get_iter_location", lg_gtk_text_view_get_iter_location, 3, 0, 0, H_gtk_text_view_get_iter_location, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_line_yrange", lg_gtk_text_view_get_line_yrange, 2, 2, 0, H_gtk_text_view_get_line_yrange, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_get_line_at_y", lg_gtk_text_view_get_line_at_y, 3, 1, 0, H_gtk_text_view_get_line_at_y, pl_puuiu);
  s7_define_typed_function(sc, "gtk_text_view_buffer_to_window_coords", lg_gtk_text_view_buffer_to_window_coords, 4, 2, 0, H_gtk_text_view_buffer_to_window_coords, pl_pugiiu);
  s7_define_typed_function(sc, "gtk_text_view_window_to_buffer_coords", lg_gtk_text_view_window_to_buffer_coords, 4, 2, 0, H_gtk_text_view_window_to_buffer_coords, pl_pugiiu);
  s7_define_typed_function(sc, "gtk_text_view_get_window", lg_gtk_text_view_get_window, 2, 0, 0, H_gtk_text_view_get_window, pl_pug);
  s7_define_typed_function(sc, "gtk_text_view_get_window_type", lg_gtk_text_view_get_window_type, 2, 0, 0, H_gtk_text_view_get_window_type, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_border_window_size", lg_gtk_text_view_set_border_window_size, 3, 0, 0, H_gtk_text_view_set_border_window_size, pl_tugi);
  s7_define_typed_function(sc, "gtk_text_view_get_border_window_size", lg_gtk_text_view_get_border_window_size, 2, 0, 0, H_gtk_text_view_get_border_window_size, pl_iug);
  s7_define_typed_function(sc, "gtk_text_view_forward_display_line", lg_gtk_text_view_forward_display_line, 2, 0, 0, H_gtk_text_view_forward_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_backward_display_line", lg_gtk_text_view_backward_display_line, 2, 0, 0, H_gtk_text_view_backward_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_forward_display_line_end", lg_gtk_text_view_forward_display_line_end, 2, 0, 0, H_gtk_text_view_forward_display_line_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_backward_display_line_start", lg_gtk_text_view_backward_display_line_start, 2, 0, 0, H_gtk_text_view_backward_display_line_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_starts_display_line", lg_gtk_text_view_starts_display_line, 2, 0, 0, H_gtk_text_view_starts_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_move_visually", lg_gtk_text_view_move_visually, 3, 0, 0, H_gtk_text_view_move_visually, pl_buui);
  s7_define_typed_function(sc, "gtk_text_view_add_child_at_anchor", lg_gtk_text_view_add_child_at_anchor, 3, 0, 0, H_gtk_text_view_add_child_at_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_add_child_in_window", lg_gtk_text_view_add_child_in_window, 5, 0, 0, H_gtk_text_view_add_child_in_window, pl_tuugi);
  s7_define_typed_function(sc, "gtk_text_view_move_child", lg_gtk_text_view_move_child, 4, 0, 0, H_gtk_text_view_move_child, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_view_set_wrap_mode", lg_gtk_text_view_set_wrap_mode, 2, 0, 0, H_gtk_text_view_set_wrap_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_wrap_mode", lg_gtk_text_view_get_wrap_mode, 1, 0, 0, H_gtk_text_view_get_wrap_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_editable", lg_gtk_text_view_set_editable, 2, 0, 0, H_gtk_text_view_set_editable, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_editable", lg_gtk_text_view_get_editable, 1, 0, 0, H_gtk_text_view_get_editable, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_above_lines", lg_gtk_text_view_set_pixels_above_lines, 2, 0, 0, H_gtk_text_view_set_pixels_above_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_above_lines", lg_gtk_text_view_get_pixels_above_lines, 1, 0, 0, H_gtk_text_view_get_pixels_above_lines, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_below_lines", lg_gtk_text_view_set_pixels_below_lines, 2, 0, 0, H_gtk_text_view_set_pixels_below_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_below_lines", lg_gtk_text_view_get_pixels_below_lines, 1, 0, 0, H_gtk_text_view_get_pixels_below_lines, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_inside_wrap", lg_gtk_text_view_set_pixels_inside_wrap, 2, 0, 0, H_gtk_text_view_set_pixels_inside_wrap, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_inside_wrap", lg_gtk_text_view_get_pixels_inside_wrap, 1, 0, 0, H_gtk_text_view_get_pixels_inside_wrap, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_justification", lg_gtk_text_view_set_justification, 2, 0, 0, H_gtk_text_view_set_justification, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_justification", lg_gtk_text_view_get_justification, 1, 0, 0, H_gtk_text_view_get_justification, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_left_margin", lg_gtk_text_view_set_left_margin, 2, 0, 0, H_gtk_text_view_set_left_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_left_margin", lg_gtk_text_view_get_left_margin, 1, 0, 0, H_gtk_text_view_get_left_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_right_margin", lg_gtk_text_view_set_right_margin, 2, 0, 0, H_gtk_text_view_set_right_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_right_margin", lg_gtk_text_view_get_right_margin, 1, 0, 0, H_gtk_text_view_get_right_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_indent", lg_gtk_text_view_set_indent, 2, 0, 0, H_gtk_text_view_set_indent, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_indent", lg_gtk_text_view_get_indent, 1, 0, 0, H_gtk_text_view_get_indent, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_tabs", lg_gtk_text_view_set_tabs, 2, 0, 0, H_gtk_text_view_set_tabs, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_tabs", lg_gtk_text_view_get_tabs, 1, 0, 0, H_gtk_text_view_get_tabs, pl_pu);
  s7_define_typed_function(sc, "gtk_toggle_button_new", lg_gtk_toggle_button_new, 0, 0, 0, H_gtk_toggle_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_toggle_button_new_with_label", lg_gtk_toggle_button_new_with_label, 1, 0, 0, H_gtk_toggle_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_toggle_button_new_with_mnemonic", lg_gtk_toggle_button_new_with_mnemonic, 1, 0, 0, H_gtk_toggle_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_toggle_button_set_active", lg_gtk_toggle_button_set_active, 2, 0, 0, H_gtk_toggle_button_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_toggle_button_get_active", lg_gtk_toggle_button_get_active, 1, 0, 0, H_gtk_toggle_button_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_toggle_button_toggled", lg_gtk_toggle_button_toggled, 1, 0, 0, H_gtk_toggle_button_toggled, pl_tu);
  s7_define_typed_function(sc, "gtk_toolbar_new", lg_gtk_toolbar_new, 0, 0, 0, H_gtk_toolbar_new, pl_p);
  s7_define_typed_function(sc, "gtk_toolbar_set_style", lg_gtk_toolbar_set_style, 2, 0, 0, H_gtk_toolbar_set_style, pl_tug);
  s7_define_typed_function(sc, "gtk_toolbar_unset_style", lg_gtk_toolbar_unset_style, 1, 0, 0, H_gtk_toolbar_unset_style, pl_tu);
  s7_define_typed_function(sc, "gtk_toolbar_get_style", lg_gtk_toolbar_get_style, 1, 0, 0, H_gtk_toolbar_get_style, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_drag_source_row_draggable", lg_gtk_tree_drag_source_row_draggable, 2, 0, 0, H_gtk_tree_drag_source_row_draggable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_source_drag_data_delete", lg_gtk_tree_drag_source_drag_data_delete, 2, 0, 0, H_gtk_tree_drag_source_drag_data_delete, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_source_drag_data_get", lg_gtk_tree_drag_source_drag_data_get, 3, 0, 0, H_gtk_tree_drag_source_drag_data_get, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_dest_drag_data_received", lg_gtk_tree_drag_dest_drag_data_received, 3, 0, 0, H_gtk_tree_drag_dest_drag_data_received, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_dest_row_drop_possible", lg_gtk_tree_drag_dest_row_drop_possible, 3, 0, 0, H_gtk_tree_drag_dest_row_drop_possible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_set_row_drag_data", lg_gtk_tree_set_row_drag_data, 3, 0, 0, H_gtk_tree_set_row_drag_data, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_get_row_drag_data", lg_gtk_tree_get_row_drag_data, 1, 2, 0, H_gtk_tree_get_row_drag_data, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_path_new", lg_gtk_tree_path_new, 0, 0, 0, H_gtk_tree_path_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_path_new_from_string", lg_gtk_tree_path_new_from_string, 1, 0, 0, H_gtk_tree_path_new_from_string, pl_ps);
  s7_define_typed_function(sc, "gtk_tree_path_to_string", lg_gtk_tree_path_to_string, 1, 0, 0, H_gtk_tree_path_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_tree_path_new_first", lg_gtk_tree_path_new_first, 0, 0, 0, H_gtk_tree_path_new_first, pl_p);
  s7_define_typed_function(sc, "gtk_tree_path_append_index", lg_gtk_tree_path_append_index, 2, 0, 0, H_gtk_tree_path_append_index, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_path_prepend_index", lg_gtk_tree_path_prepend_index, 2, 0, 0, H_gtk_tree_path_prepend_index, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_path_get_depth", lg_gtk_tree_path_get_depth, 1, 0, 0, H_gtk_tree_path_get_depth, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_path_get_indices", lg_gtk_tree_path_get_indices, 1, 0, 0, H_gtk_tree_path_get_indices, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_path_free", lg_gtk_tree_path_free, 1, 0, 0, H_gtk_tree_path_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_copy", lg_gtk_tree_path_copy, 1, 0, 0, H_gtk_tree_path_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_path_compare", lg_gtk_tree_path_compare, 2, 0, 0, H_gtk_tree_path_compare, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_path_next", lg_gtk_tree_path_next, 1, 0, 0, H_gtk_tree_path_next, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_prev", lg_gtk_tree_path_prev, 1, 0, 0, H_gtk_tree_path_prev, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_up", lg_gtk_tree_path_up, 1, 0, 0, H_gtk_tree_path_up, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_down", lg_gtk_tree_path_down, 1, 0, 0, H_gtk_tree_path_down, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_is_ancestor", lg_gtk_tree_path_is_ancestor, 2, 0, 0, H_gtk_tree_path_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_is_descendant", lg_gtk_tree_path_is_descendant, 2, 0, 0, H_gtk_tree_path_is_descendant, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_new", lg_gtk_tree_row_reference_new, 2, 0, 0, H_gtk_tree_row_reference_new, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_new_proxy", lg_gtk_tree_row_reference_new_proxy, 3, 0, 0, H_gtk_tree_row_reference_new_proxy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_get_path", lg_gtk_tree_row_reference_get_path, 1, 0, 0, H_gtk_tree_row_reference_get_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_valid", lg_gtk_tree_row_reference_valid, 1, 0, 0, H_gtk_tree_row_reference_valid, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_free", lg_gtk_tree_row_reference_free, 1, 0, 0, H_gtk_tree_row_reference_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_inserted", lg_gtk_tree_row_reference_inserted, 2, 0, 0, H_gtk_tree_row_reference_inserted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_deleted", lg_gtk_tree_row_reference_deleted, 2, 0, 0, H_gtk_tree_row_reference_deleted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_reordered", lg_gtk_tree_row_reference_reordered, 4, 0, 0, H_gtk_tree_row_reference_reordered, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_iter_copy", lg_gtk_tree_iter_copy, 1, 0, 0, H_gtk_tree_iter_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_iter_free", lg_gtk_tree_iter_free, 1, 0, 0, H_gtk_tree_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_get_flags", lg_gtk_tree_model_get_flags, 1, 0, 0, H_gtk_tree_model_get_flags, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_model_get_n_columns", lg_gtk_tree_model_get_n_columns, 1, 0, 0, H_gtk_tree_model_get_n_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_get_column_type", lg_gtk_tree_model_get_column_type, 2, 0, 0, H_gtk_tree_model_get_column_type, pl_iui);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter", lg_gtk_tree_model_get_iter, 3, 0, 0, H_gtk_tree_model_get_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter_from_string", lg_gtk_tree_model_get_iter_from_string, 3, 0, 0, H_gtk_tree_model_get_iter_from_string, pl_buus);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter_first", lg_gtk_tree_model_get_iter_first, 2, 0, 0, H_gtk_tree_model_get_iter_first, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_get_path", lg_gtk_tree_model_get_path, 2, 0, 0, H_gtk_tree_model_get_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_next", lg_gtk_tree_model_iter_next, 2, 0, 0, H_gtk_tree_model_iter_next, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_children", lg_gtk_tree_model_iter_children, 3, 0, 0, H_gtk_tree_model_iter_children, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_has_child", lg_gtk_tree_model_iter_has_child, 2, 0, 0, H_gtk_tree_model_iter_has_child, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_n_children", lg_gtk_tree_model_iter_n_children, 2, 0, 0, H_gtk_tree_model_iter_n_children, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_nth_child", lg_gtk_tree_model_iter_nth_child, 4, 0, 0, H_gtk_tree_model_iter_nth_child, pl_buuui);
  s7_define_typed_function(sc, "gtk_tree_model_iter_parent", lg_gtk_tree_model_iter_parent, 3, 0, 0, H_gtk_tree_model_iter_parent, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_ref_node", lg_gtk_tree_model_ref_node, 2, 0, 0, H_gtk_tree_model_ref_node, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_unref_node", lg_gtk_tree_model_unref_node, 2, 0, 0, H_gtk_tree_model_unref_node, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_foreach", lg_gtk_tree_model_foreach, 2, 1, 0, H_gtk_tree_model_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_model_row_changed", lg_gtk_tree_model_row_changed, 3, 0, 0, H_gtk_tree_model_row_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_inserted", lg_gtk_tree_model_row_inserted, 3, 0, 0, H_gtk_tree_model_row_inserted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_has_child_toggled", lg_gtk_tree_model_row_has_child_toggled, 3, 0, 0, H_gtk_tree_model_row_has_child_toggled, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_deleted", lg_gtk_tree_model_row_deleted, 2, 0, 0, H_gtk_tree_model_row_deleted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_rows_reordered", lg_gtk_tree_model_rows_reordered, 4, 0, 0, H_gtk_tree_model_rows_reordered, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_new_with_model", lg_gtk_tree_model_sort_new_with_model, 1, 0, 0, H_gtk_tree_model_sort_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_get_model", lg_gtk_tree_model_sort_get_model, 1, 0, 0, H_gtk_tree_model_sort_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_child_path_to_path", lg_gtk_tree_model_sort_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_sort_convert_child_path_to_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", lg_gtk_tree_model_sort_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_child_iter_to_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_path_to_child_path", lg_gtk_tree_model_sort_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_sort_convert_path_to_child_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", lg_gtk_tree_model_sort_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_iter_to_child_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_reset_default_sort_func", lg_gtk_tree_model_sort_reset_default_sort_func, 1, 0, 0, H_gtk_tree_model_sort_reset_default_sort_func, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_clear_cache", lg_gtk_tree_model_sort_clear_cache, 1, 0, 0, H_gtk_tree_model_sort_clear_cache, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_set_mode", lg_gtk_tree_selection_set_mode, 2, 0, 0, H_gtk_tree_selection_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_selection_get_mode", lg_gtk_tree_selection_get_mode, 1, 0, 0, H_gtk_tree_selection_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_selection_set_select_function", lg_gtk_tree_selection_set_select_function, 4, 0, 0, H_gtk_tree_selection_set_select_function, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_selection_get_user_data", lg_gtk_tree_selection_get_user_data, 1, 0, 0, H_gtk_tree_selection_get_user_data, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_tree_view", lg_gtk_tree_selection_get_tree_view, 1, 0, 0, H_gtk_tree_selection_get_tree_view, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_selected", lg_gtk_tree_selection_get_selected, 3, 0, 0, H_gtk_tree_selection_get_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_selected_foreach", lg_gtk_tree_selection_selected_foreach, 2, 1, 0, H_gtk_tree_selection_selected_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_selection_select_path", lg_gtk_tree_selection_select_path, 2, 0, 0, H_gtk_tree_selection_select_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_path", lg_gtk_tree_selection_unselect_path, 2, 0, 0, H_gtk_tree_selection_unselect_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_iter", lg_gtk_tree_selection_select_iter, 2, 0, 0, H_gtk_tree_selection_select_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_iter", lg_gtk_tree_selection_unselect_iter, 2, 0, 0, H_gtk_tree_selection_unselect_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_path_is_selected", lg_gtk_tree_selection_path_is_selected, 2, 0, 0, H_gtk_tree_selection_path_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_iter_is_selected", lg_gtk_tree_selection_iter_is_selected, 2, 0, 0, H_gtk_tree_selection_iter_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_all", lg_gtk_tree_selection_select_all, 1, 0, 0, H_gtk_tree_selection_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_all", lg_gtk_tree_selection_unselect_all, 1, 0, 0, H_gtk_tree_selection_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_range", lg_gtk_tree_selection_select_range, 3, 0, 0, H_gtk_tree_selection_select_range, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_sortable_sort_column_changed", lg_gtk_tree_sortable_sort_column_changed, 1, 0, 0, H_gtk_tree_sortable_sort_column_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_sortable_get_sort_column_id", lg_gtk_tree_sortable_get_sort_column_id, 1, 2, 0, H_gtk_tree_sortable_get_sort_column_id, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_sort_column_id", lg_gtk_tree_sortable_set_sort_column_id, 3, 0, 0, H_gtk_tree_sortable_set_sort_column_id, pl_tuig);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_sort_func", lg_gtk_tree_sortable_set_sort_func, 5, 0, 0, H_gtk_tree_sortable_set_sort_func, pl_tuit);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_default_sort_func", lg_gtk_tree_sortable_set_default_sort_func, 4, 0, 0, H_gtk_tree_sortable_set_default_sort_func, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_sortable_has_default_sort_func", lg_gtk_tree_sortable_has_default_sort_func, 1, 0, 0, H_gtk_tree_sortable_has_default_sort_func, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_store_new", lg_gtk_tree_store_new, 2, 0, 0, H_gtk_tree_store_new, pl_pit);
  s7_define_typed_function(sc, "gtk_tree_store_newv", lg_gtk_tree_store_newv, 2, 0, 0, H_gtk_tree_store_newv, pl_piu);
  s7_define_typed_function(sc, "gtk_tree_store_set_column_types", lg_gtk_tree_store_set_column_types, 3, 0, 0, H_gtk_tree_store_set_column_types, pl_tuiu);
  s7_define_typed_function(sc, "gtk_tree_store_set", lg_gtk_tree_store_set, 3, 0, 0, H_gtk_tree_store_set, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_store_remove", lg_gtk_tree_store_remove, 2, 0, 0, H_gtk_tree_store_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_insert", lg_gtk_tree_store_insert, 4, 0, 0, H_gtk_tree_store_insert, pl_tuuui);
  s7_define_typed_function(sc, "gtk_tree_store_insert_before", lg_gtk_tree_store_insert_before, 4, 0, 0, H_gtk_tree_store_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_insert_after", lg_gtk_tree_store_insert_after, 4, 0, 0, H_gtk_tree_store_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_prepend", lg_gtk_tree_store_prepend, 3, 0, 0, H_gtk_tree_store_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_append", lg_gtk_tree_store_append, 3, 0, 0, H_gtk_tree_store_append, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_is_ancestor", lg_gtk_tree_store_is_ancestor, 3, 0, 0, H_gtk_tree_store_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_store_iter_depth", lg_gtk_tree_store_iter_depth, 2, 0, 0, H_gtk_tree_store_iter_depth, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_store_clear", lg_gtk_tree_store_clear, 1, 0, 0, H_gtk_tree_store_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_new", lg_gtk_tree_view_column_new, 0, 0, 0, H_gtk_tree_view_column_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_view_column_new_with_attributes", lg_gtk_tree_view_column_new_with_attributes, 3, 0, 0, H_gtk_tree_view_column_new_with_attributes, pl_psut);
  s7_define_typed_function(sc, "gtk_tree_view_column_pack_start", lg_gtk_tree_view_column_pack_start, 3, 0, 0, H_gtk_tree_view_column_pack_start, pl_tuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_pack_end", lg_gtk_tree_view_column_pack_end, 3, 0, 0, H_gtk_tree_view_column_pack_end, pl_tuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_clear", lg_gtk_tree_view_column_clear, 1, 0, 0, H_gtk_tree_view_column_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_add_attribute", lg_gtk_tree_view_column_add_attribute, 4, 0, 0, H_gtk_tree_view_column_add_attribute, pl_tuusi);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_attributes", lg_gtk_tree_view_column_set_attributes, 3, 0, 0, H_gtk_tree_view_column_set_attributes, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_cell_data_func", lg_gtk_tree_view_column_set_cell_data_func, 5, 0, 0, H_gtk_tree_view_column_set_cell_data_func, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_view_column_clear_attributes", lg_gtk_tree_view_column_clear_attributes, 2, 0, 0, H_gtk_tree_view_column_clear_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_spacing", lg_gtk_tree_view_column_set_spacing, 2, 0, 0, H_gtk_tree_view_column_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_spacing", lg_gtk_tree_view_column_get_spacing, 1, 0, 0, H_gtk_tree_view_column_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_visible", lg_gtk_tree_view_column_set_visible, 2, 0, 0, H_gtk_tree_view_column_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_visible", lg_gtk_tree_view_column_get_visible, 1, 0, 0, H_gtk_tree_view_column_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_resizable", lg_gtk_tree_view_column_set_resizable, 2, 0, 0, H_gtk_tree_view_column_set_resizable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_resizable", lg_gtk_tree_view_column_get_resizable, 1, 0, 0, H_gtk_tree_view_column_get_resizable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sizing", lg_gtk_tree_view_column_set_sizing, 2, 0, 0, H_gtk_tree_view_column_set_sizing, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sizing", lg_gtk_tree_view_column_get_sizing, 1, 0, 0, H_gtk_tree_view_column_get_sizing, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_width", lg_gtk_tree_view_column_get_width, 1, 0, 0, H_gtk_tree_view_column_get_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_fixed_width", lg_gtk_tree_view_column_get_fixed_width, 1, 0, 0, H_gtk_tree_view_column_get_fixed_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_fixed_width", lg_gtk_tree_view_column_set_fixed_width, 2, 0, 0, H_gtk_tree_view_column_set_fixed_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_min_width", lg_gtk_tree_view_column_set_min_width, 2, 0, 0, H_gtk_tree_view_column_set_min_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_min_width", lg_gtk_tree_view_column_get_min_width, 1, 0, 0, H_gtk_tree_view_column_get_min_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_max_width", lg_gtk_tree_view_column_set_max_width, 2, 0, 0, H_gtk_tree_view_column_set_max_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_max_width", lg_gtk_tree_view_column_get_max_width, 1, 0, 0, H_gtk_tree_view_column_get_max_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_clicked", lg_gtk_tree_view_column_clicked, 1, 0, 0, H_gtk_tree_view_column_clicked, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_title", lg_gtk_tree_view_column_set_title, 2, 0, 0, H_gtk_tree_view_column_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_title", lg_gtk_tree_view_column_get_title, 1, 0, 0, H_gtk_tree_view_column_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_clickable", lg_gtk_tree_view_column_set_clickable, 2, 0, 0, H_gtk_tree_view_column_set_clickable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_clickable", lg_gtk_tree_view_column_get_clickable, 1, 0, 0, H_gtk_tree_view_column_get_clickable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_widget", lg_gtk_tree_view_column_set_widget, 2, 0, 0, H_gtk_tree_view_column_set_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_widget", lg_gtk_tree_view_column_get_widget, 1, 0, 0, H_gtk_tree_view_column_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_alignment", lg_gtk_tree_view_column_set_alignment, 2, 0, 0, H_gtk_tree_view_column_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_alignment", lg_gtk_tree_view_column_get_alignment, 1, 0, 0, H_gtk_tree_view_column_get_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_reorderable", lg_gtk_tree_view_column_set_reorderable, 2, 0, 0, H_gtk_tree_view_column_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_reorderable", lg_gtk_tree_view_column_get_reorderable, 1, 0, 0, H_gtk_tree_view_column_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_column_id", lg_gtk_tree_view_column_set_sort_column_id, 2, 0, 0, H_gtk_tree_view_column_set_sort_column_id, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_column_id", lg_gtk_tree_view_column_get_sort_column_id, 1, 0, 0, H_gtk_tree_view_column_get_sort_column_id, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_indicator", lg_gtk_tree_view_column_set_sort_indicator, 2, 0, 0, H_gtk_tree_view_column_set_sort_indicator, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_indicator", lg_gtk_tree_view_column_get_sort_indicator, 1, 0, 0, H_gtk_tree_view_column_get_sort_indicator, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_order", lg_gtk_tree_view_column_set_sort_order, 2, 0, 0, H_gtk_tree_view_column_set_sort_order, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_order", lg_gtk_tree_view_column_get_sort_order, 1, 0, 0, H_gtk_tree_view_column_get_sort_order, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_set_cell_data", lg_gtk_tree_view_column_cell_set_cell_data, 5, 0, 0, H_gtk_tree_view_column_cell_set_cell_data, pl_tuuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_get_size", lg_gtk_tree_view_column_cell_get_size, 2, 4, 0, H_gtk_tree_view_column_cell_get_size, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_is_visible", lg_gtk_tree_view_column_cell_is_visible, 1, 0, 0, H_gtk_tree_view_column_cell_is_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_get_position", lg_gtk_tree_view_column_cell_get_position, 2, 2, 0, H_gtk_tree_view_column_cell_get_position, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_new", lg_gtk_tree_view_new, 0, 0, 0, H_gtk_tree_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_view_new_with_model", lg_gtk_tree_view_new_with_model, 1, 0, 0, H_gtk_tree_view_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_model", lg_gtk_tree_view_get_model, 1, 0, 0, H_gtk_tree_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_model", lg_gtk_tree_view_set_model, 2, 0, 0, H_gtk_tree_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_selection", lg_gtk_tree_view_get_selection, 1, 0, 0, H_gtk_tree_view_get_selection, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_headers_visible", lg_gtk_tree_view_get_headers_visible, 1, 0, 0, H_gtk_tree_view_get_headers_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_headers_visible", lg_gtk_tree_view_set_headers_visible, 2, 0, 0, H_gtk_tree_view_set_headers_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_columns_autosize", lg_gtk_tree_view_columns_autosize, 1, 0, 0, H_gtk_tree_view_columns_autosize, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_headers_clickable", lg_gtk_tree_view_set_headers_clickable, 2, 0, 0, H_gtk_tree_view_set_headers_clickable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_append_column", lg_gtk_tree_view_append_column, 2, 0, 0, H_gtk_tree_view_append_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_remove_column", lg_gtk_tree_view_remove_column, 2, 0, 0, H_gtk_tree_view_remove_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column", lg_gtk_tree_view_insert_column, 3, 0, 0, H_gtk_tree_view_insert_column, pl_iuui);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column_with_attributes", lg_gtk_tree_view_insert_column_with_attributes, 5, 0, 0, H_gtk_tree_view_insert_column_with_attributes, pl_iuisut);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column_with_data_func", lg_gtk_tree_view_insert_column_with_data_func, 7, 0, 0, H_gtk_tree_view_insert_column_with_data_func, pl_iuisut);
  s7_define_typed_function(sc, "gtk_tree_view_get_column", lg_gtk_tree_view_get_column, 2, 0, 0, H_gtk_tree_view_get_column, pl_pui);
  s7_define_typed_function(sc, "gtk_tree_view_get_columns", lg_gtk_tree_view_get_columns, 1, 0, 0, H_gtk_tree_view_get_columns, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_move_column_after", lg_gtk_tree_view_move_column_after, 3, 0, 0, H_gtk_tree_view_move_column_after, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_expander_column", lg_gtk_tree_view_set_expander_column, 2, 0, 0, H_gtk_tree_view_set_expander_column, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_expander_column", lg_gtk_tree_view_get_expander_column, 1, 0, 0, H_gtk_tree_view_get_expander_column, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_column_drag_function", lg_gtk_tree_view_set_column_drag_function, 4, 0, 0, H_gtk_tree_view_set_column_drag_function, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_view_scroll_to_point", lg_gtk_tree_view_scroll_to_point, 3, 0, 0, H_gtk_tree_view_scroll_to_point, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_scroll_to_cell", lg_gtk_tree_view_scroll_to_cell, 6, 0, 0, H_gtk_tree_view_scroll_to_cell, pl_tuuubr);
  s7_define_typed_function(sc, "gtk_tree_view_row_activated", lg_gtk_tree_view_row_activated, 3, 0, 0, H_gtk_tree_view_row_activated, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_all", lg_gtk_tree_view_expand_all, 1, 0, 0, H_gtk_tree_view_expand_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_collapse_all", lg_gtk_tree_view_collapse_all, 1, 0, 0, H_gtk_tree_view_collapse_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_row", lg_gtk_tree_view_expand_row, 3, 0, 0, H_gtk_tree_view_expand_row, pl_buub);
  s7_define_typed_function(sc, "gtk_tree_view_collapse_row", lg_gtk_tree_view_collapse_row, 2, 0, 0, H_gtk_tree_view_collapse_row, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_map_expanded_rows", lg_gtk_tree_view_map_expanded_rows, 2, 1, 0, H_gtk_tree_view_map_expanded_rows, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_view_row_expanded", lg_gtk_tree_view_row_expanded, 2, 0, 0, H_gtk_tree_view_row_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_reorderable", lg_gtk_tree_view_set_reorderable, 2, 0, 0, H_gtk_tree_view_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_reorderable", lg_gtk_tree_view_get_reorderable, 1, 0, 0, H_gtk_tree_view_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_cursor", lg_gtk_tree_view_set_cursor, 4, 0, 0, H_gtk_tree_view_set_cursor, pl_tuuub);
  s7_define_typed_function(sc, "gtk_tree_view_get_cursor", lg_gtk_tree_view_get_cursor, 1, 2, 0, H_gtk_tree_view_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_path_at_pos", lg_gtk_tree_view_get_path_at_pos, 3, 4, 0, H_gtk_tree_view_get_path_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_get_cell_area", lg_gtk_tree_view_get_cell_area, 4, 0, 0, H_gtk_tree_view_get_cell_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_background_area", lg_gtk_tree_view_get_background_area, 4, 0, 0, H_gtk_tree_view_get_background_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_visible_rect", lg_gtk_tree_view_get_visible_rect, 2, 0, 0, H_gtk_tree_view_get_visible_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_enable_model_drag_source", lg_gtk_tree_view_enable_model_drag_source, 5, 0, 0, H_gtk_tree_view_enable_model_drag_source, pl_tuguig);
  s7_define_typed_function(sc, "gtk_tree_view_enable_model_drag_dest", lg_gtk_tree_view_enable_model_drag_dest, 4, 0, 0, H_gtk_tree_view_enable_model_drag_dest, pl_tuuig);
  s7_define_typed_function(sc, "gtk_tree_view_unset_rows_drag_source", lg_gtk_tree_view_unset_rows_drag_source, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_source, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_unset_rows_drag_dest", lg_gtk_tree_view_unset_rows_drag_dest, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_dest, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_drag_dest_row", lg_gtk_tree_view_set_drag_dest_row, 3, 0, 0, H_gtk_tree_view_set_drag_dest_row, pl_tuug);
  s7_define_typed_function(sc, "gtk_tree_view_get_drag_dest_row", lg_gtk_tree_view_get_drag_dest_row, 1, 2, 0, H_gtk_tree_view_get_drag_dest_row, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_dest_row_at_pos", lg_gtk_tree_view_get_dest_row_at_pos, 3, 2, 0, H_gtk_tree_view_get_dest_row_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_set_enable_search", lg_gtk_tree_view_set_enable_search, 2, 0, 0, H_gtk_tree_view_set_enable_search, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_enable_search", lg_gtk_tree_view_get_enable_search, 1, 0, 0, H_gtk_tree_view_get_enable_search, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_column", lg_gtk_tree_view_get_search_column, 1, 0, 0, H_gtk_tree_view_get_search_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_column", lg_gtk_tree_view_set_search_column, 2, 0, 0, H_gtk_tree_view_set_search_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_equal_func", lg_gtk_tree_view_get_search_equal_func, 1, 0, 0, H_gtk_tree_view_get_search_equal_func, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_equal_func", lg_gtk_tree_view_set_search_equal_func, 4, 0, 0, H_gtk_tree_view_set_search_equal_func, pl_tut);
  s7_define_typed_function(sc, "gtk_viewport_new", lg_gtk_viewport_new, 2, 0, 0, H_gtk_viewport_new, pl_pu);
  s7_define_typed_function(sc, "gtk_viewport_set_shadow_type", lg_gtk_viewport_set_shadow_type, 2, 0, 0, H_gtk_viewport_set_shadow_type, pl_tug);
  s7_define_typed_function(sc, "gtk_viewport_get_shadow_type", lg_gtk_viewport_get_shadow_type, 1, 0, 0, H_gtk_viewport_get_shadow_type, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_destroy", lg_gtk_widget_destroy, 1, 0, 0, H_gtk_widget_destroy, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_destroyed", lg_gtk_widget_destroyed, 1, 1, 0, H_gtk_widget_destroyed, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_unparent", lg_gtk_widget_unparent, 1, 0, 0, H_gtk_widget_unparent, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_show", lg_gtk_widget_show, 1, 0, 0, H_gtk_widget_show, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_show_now", lg_gtk_widget_show_now, 1, 0, 0, H_gtk_widget_show_now, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_hide", lg_gtk_widget_hide, 1, 0, 0, H_gtk_widget_hide, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_map", lg_gtk_widget_map, 1, 0, 0, H_gtk_widget_map, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_unmap", lg_gtk_widget_unmap, 1, 0, 0, H_gtk_widget_unmap, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_realize", lg_gtk_widget_realize, 1, 0, 0, H_gtk_widget_realize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_unrealize", lg_gtk_widget_unrealize, 1, 0, 0, H_gtk_widget_unrealize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_queue_draw", lg_gtk_widget_queue_draw, 1, 0, 0, H_gtk_widget_queue_draw, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_queue_draw_area", lg_gtk_widget_queue_draw_area, 5, 0, 0, H_gtk_widget_queue_draw_area, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_queue_resize", lg_gtk_widget_queue_resize, 1, 0, 0, H_gtk_widget_queue_resize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_add_accelerator", lg_gtk_widget_add_accelerator, 6, 0, 0, H_gtk_widget_add_accelerator, pl_tusuig);
  s7_define_typed_function(sc, "gtk_widget_remove_accelerator", lg_gtk_widget_remove_accelerator, 4, 0, 0, H_gtk_widget_remove_accelerator, pl_buuig);
  s7_define_typed_function(sc, "gtk_widget_list_accel_closures", lg_gtk_widget_list_accel_closures, 1, 0, 0, H_gtk_widget_list_accel_closures, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_mnemonic_activate", lg_gtk_widget_mnemonic_activate, 2, 0, 0, H_gtk_widget_mnemonic_activate, pl_bub);
  s7_define_typed_function(sc, "gtk_widget_event", lg_gtk_widget_event, 2, 0, 0, H_gtk_widget_event, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_activate", lg_gtk_widget_activate, 1, 0, 0, H_gtk_widget_activate, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_intersect", lg_gtk_widget_intersect, 3, 0, 0, H_gtk_widget_intersect, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_freeze_child_notify", lg_gtk_widget_freeze_child_notify, 1, 0, 0, H_gtk_widget_freeze_child_notify, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_child_notify", lg_gtk_widget_child_notify, 2, 0, 0, H_gtk_widget_child_notify, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_thaw_child_notify", lg_gtk_widget_thaw_child_notify, 1, 0, 0, H_gtk_widget_thaw_child_notify, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_is_focus", lg_gtk_widget_is_focus, 1, 0, 0, H_gtk_widget_is_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_grab_focus", lg_gtk_widget_grab_focus, 1, 0, 0, H_gtk_widget_grab_focus, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_grab_default", lg_gtk_widget_grab_default, 1, 0, 0, H_gtk_widget_grab_default, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_name", lg_gtk_widget_set_name, 2, 0, 0, H_gtk_widget_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_name", lg_gtk_widget_get_name, 1, 0, 0, H_gtk_widget_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_sensitive", lg_gtk_widget_set_sensitive, 2, 0, 0, H_gtk_widget_set_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_redraw_on_allocate", lg_gtk_widget_set_redraw_on_allocate, 2, 0, 0, H_gtk_widget_set_redraw_on_allocate, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_parent", lg_gtk_widget_set_parent, 2, 0, 0, H_gtk_widget_set_parent, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_parent_window", lg_gtk_widget_set_parent_window, 2, 0, 0, H_gtk_widget_set_parent_window, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_child_visible", lg_gtk_widget_set_child_visible, 2, 0, 0, H_gtk_widget_set_child_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_accel_path", lg_gtk_widget_set_accel_path, 3, 0, 0, H_gtk_widget_set_accel_path, pl_tusu);
  s7_define_typed_function(sc, "gtk_widget_get_child_visible", lg_gtk_widget_get_child_visible, 1, 0, 0, H_gtk_widget_get_child_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_parent", lg_gtk_widget_get_parent, 1, 0, 0, H_gtk_widget_get_parent, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_parent_window", lg_gtk_widget_get_parent_window, 1, 0, 0, H_gtk_widget_get_parent_window, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_child_focus", lg_gtk_widget_child_focus, 2, 0, 0, H_gtk_widget_child_focus, pl_bug);
  s7_define_typed_function(sc, "gtk_widget_set_size_request", lg_gtk_widget_set_size_request, 3, 0, 0, H_gtk_widget_set_size_request, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_size_request", lg_gtk_widget_get_size_request, 1, 2, 0, H_gtk_widget_get_size_request, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_toplevel", lg_gtk_widget_get_toplevel, 1, 0, 0, H_gtk_widget_get_toplevel, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_ancestor", lg_gtk_widget_get_ancestor, 2, 0, 0, H_gtk_widget_get_ancestor, pl_pui);
  s7_define_typed_function(sc, "gtk_widget_get_settings", lg_gtk_widget_get_settings, 1, 0, 0, H_gtk_widget_get_settings, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_accessible", lg_gtk_widget_get_accessible, 1, 0, 0, H_gtk_widget_get_accessible, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_is_ancestor", lg_gtk_widget_is_ancestor, 2, 0, 0, H_gtk_widget_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_translate_coordinates", lg_gtk_widget_translate_coordinates, 4, 2, 0, H_gtk_widget_translate_coordinates, pl_puuiiu);
  s7_define_typed_function(sc, "gtk_widget_hide_on_delete", lg_gtk_widget_hide_on_delete, 1, 0, 0, H_gtk_widget_hide_on_delete, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_create_pango_context", lg_gtk_widget_create_pango_context, 1, 0, 0, H_gtk_widget_create_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_pango_context", lg_gtk_widget_get_pango_context, 1, 0, 0, H_gtk_widget_get_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_create_pango_layout", lg_gtk_widget_create_pango_layout, 2, 0, 0, H_gtk_widget_create_pango_layout, pl_pus);
  s7_define_typed_function(sc, "gtk_widget_set_direction", lg_gtk_widget_set_direction, 2, 0, 0, H_gtk_widget_set_direction, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_direction", lg_gtk_widget_get_direction, 1, 0, 0, H_gtk_widget_get_direction, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_default_direction", lg_gtk_widget_set_default_direction, 1, 0, 0, H_gtk_widget_set_default_direction, pl_tg);
  s7_define_typed_function(sc, "gtk_widget_get_default_direction", lg_gtk_widget_get_default_direction, 0, 0, 0, H_gtk_widget_get_default_direction, pl_g);
  s7_define_typed_function(sc, "gtk_widget_can_activate_accel", lg_gtk_widget_can_activate_accel, 2, 0, 0, H_gtk_widget_can_activate_accel, pl_bui);
  s7_define_typed_function(sc, "gtk_window_is_active", lg_gtk_window_is_active, 1, 0, 0, H_gtk_window_is_active, pl_bu);
  s7_define_typed_function(sc, "gtk_window_new", lg_gtk_window_new, 1, 0, 0, H_gtk_window_new, pl_pg);
  s7_define_typed_function(sc, "gtk_window_set_title", lg_gtk_window_set_title, 2, 0, 0, H_gtk_window_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_window_set_auto_startup_notification", lg_gtk_window_set_auto_startup_notification, 1, 0, 0, H_gtk_window_set_auto_startup_notification, pl_tb);
  s7_define_typed_function(sc, "gtk_window_get_title", lg_gtk_window_get_title, 1, 0, 0, H_gtk_window_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_window_set_role", lg_gtk_window_set_role, 2, 0, 0, H_gtk_window_set_role, pl_tus);
  s7_define_typed_function(sc, "gtk_window_get_role", lg_gtk_window_get_role, 1, 0, 0, H_gtk_window_get_role, pl_su);
  s7_define_typed_function(sc, "gtk_window_add_accel_group", lg_gtk_window_add_accel_group, 2, 0, 0, H_gtk_window_add_accel_group, pl_tu);
  s7_define_typed_function(sc, "gtk_window_remove_accel_group", lg_gtk_window_remove_accel_group, 2, 0, 0, H_gtk_window_remove_accel_group, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_position", lg_gtk_window_set_position, 2, 0, 0, H_gtk_window_set_position, pl_tug);
  s7_define_typed_function(sc, "gtk_window_activate_focus", lg_gtk_window_activate_focus, 1, 0, 0, H_gtk_window_activate_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_focus", lg_gtk_window_set_focus, 2, 0, 0, H_gtk_window_set_focus, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_focus", lg_gtk_window_get_focus, 1, 0, 0, H_gtk_window_get_focus, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_default", lg_gtk_window_set_default, 2, 0, 0, H_gtk_window_set_default, pl_tu);
  s7_define_typed_function(sc, "gtk_window_activate_default", lg_gtk_window_activate_default, 1, 0, 0, H_gtk_window_activate_default, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_transient_for", lg_gtk_window_set_transient_for, 2, 0, 0, H_gtk_window_set_transient_for, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_transient_for", lg_gtk_window_get_transient_for, 1, 0, 0, H_gtk_window_get_transient_for, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_type_hint", lg_gtk_window_set_type_hint, 2, 0, 0, H_gtk_window_set_type_hint, pl_tug);
  s7_define_typed_function(sc, "gtk_window_get_type_hint", lg_gtk_window_get_type_hint, 1, 0, 0, H_gtk_window_get_type_hint, pl_gu);
  s7_define_typed_function(sc, "gtk_window_set_destroy_with_parent", lg_gtk_window_set_destroy_with_parent, 2, 0, 0, H_gtk_window_set_destroy_with_parent, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_destroy_with_parent", lg_gtk_window_get_destroy_with_parent, 1, 0, 0, H_gtk_window_get_destroy_with_parent, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_resizable", lg_gtk_window_set_resizable, 2, 0, 0, H_gtk_window_set_resizable, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_resizable", lg_gtk_window_get_resizable, 1, 0, 0, H_gtk_window_get_resizable, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_gravity", lg_gtk_window_set_gravity, 2, 0, 0, H_gtk_window_set_gravity, pl_tug);
  s7_define_typed_function(sc, "gtk_window_get_gravity", lg_gtk_window_get_gravity, 1, 0, 0, H_gtk_window_get_gravity, pl_gu);
  s7_define_typed_function(sc, "gtk_window_set_geometry_hints", lg_gtk_window_set_geometry_hints, 4, 0, 0, H_gtk_window_set_geometry_hints, pl_tuuug);
  s7_define_typed_function(sc, "gtk_window_set_decorated", lg_gtk_window_set_decorated, 2, 0, 0, H_gtk_window_set_decorated, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_decorated", lg_gtk_window_get_decorated, 1, 0, 0, H_gtk_window_get_decorated, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_icon_list", lg_gtk_window_set_icon_list, 2, 0, 0, H_gtk_window_set_icon_list, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_icon_list", lg_gtk_window_get_icon_list, 1, 0, 0, H_gtk_window_get_icon_list, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_icon", lg_gtk_window_set_icon, 2, 0, 0, H_gtk_window_set_icon, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_icon", lg_gtk_window_get_icon, 1, 0, 0, H_gtk_window_get_icon, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_default_icon_list", lg_gtk_window_set_default_icon_list, 1, 0, 0, H_gtk_window_set_default_icon_list, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_default_icon_list", lg_gtk_window_get_default_icon_list, 0, 0, 0, H_gtk_window_get_default_icon_list, pl_p);
  s7_define_typed_function(sc, "gtk_window_set_modal", lg_gtk_window_set_modal, 2, 0, 0, H_gtk_window_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_modal", lg_gtk_window_get_modal, 1, 0, 0, H_gtk_window_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_window_list_toplevels", lg_gtk_window_list_toplevels, 0, 0, 0, H_gtk_window_list_toplevels, pl_p);
  s7_define_typed_function(sc, "gtk_window_add_mnemonic", lg_gtk_window_add_mnemonic, 3, 0, 0, H_gtk_window_add_mnemonic, pl_tuiu);
  s7_define_typed_function(sc, "gtk_window_remove_mnemonic", lg_gtk_window_remove_mnemonic, 3, 0, 0, H_gtk_window_remove_mnemonic, pl_tuiu);
  s7_define_typed_function(sc, "gtk_window_mnemonic_activate", lg_gtk_window_mnemonic_activate, 3, 0, 0, H_gtk_window_mnemonic_activate, pl_buig);
  s7_define_typed_function(sc, "gtk_window_set_mnemonic_modifier", lg_gtk_window_set_mnemonic_modifier, 2, 0, 0, H_gtk_window_set_mnemonic_modifier, pl_tug);
  s7_define_typed_function(sc, "gtk_window_get_mnemonic_modifier", lg_gtk_window_get_mnemonic_modifier, 1, 0, 0, H_gtk_window_get_mnemonic_modifier, pl_gu);
  s7_define_typed_function(sc, "gtk_window_present", lg_gtk_window_present, 1, 0, 0, H_gtk_window_present, pl_tu);
  s7_define_typed_function(sc, "gtk_window_iconify", lg_gtk_window_iconify, 1, 0, 0, H_gtk_window_iconify, pl_tu);
  s7_define_typed_function(sc, "gtk_window_deiconify", lg_gtk_window_deiconify, 1, 0, 0, H_gtk_window_deiconify, pl_tu);
  s7_define_typed_function(sc, "gtk_window_stick", lg_gtk_window_stick, 1, 0, 0, H_gtk_window_stick, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unstick", lg_gtk_window_unstick, 1, 0, 0, H_gtk_window_unstick, pl_tu);
  s7_define_typed_function(sc, "gtk_window_maximize", lg_gtk_window_maximize, 1, 0, 0, H_gtk_window_maximize, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unmaximize", lg_gtk_window_unmaximize, 1, 0, 0, H_gtk_window_unmaximize, pl_tu);
  s7_define_typed_function(sc, "gtk_window_begin_resize_drag", lg_gtk_window_begin_resize_drag, 6, 0, 0, H_gtk_window_begin_resize_drag, pl_tugi);
  s7_define_typed_function(sc, "gtk_window_begin_move_drag", lg_gtk_window_begin_move_drag, 5, 0, 0, H_gtk_window_begin_move_drag, pl_tui);
  s7_define_typed_function(sc, "gtk_window_set_default_size", lg_gtk_window_set_default_size, 3, 0, 0, H_gtk_window_set_default_size, pl_tui);
  s7_define_typed_function(sc, "gtk_window_get_default_size", lg_gtk_window_get_default_size, 1, 2, 0, H_gtk_window_get_default_size, pl_pu);
  s7_define_typed_function(sc, "gtk_window_resize", lg_gtk_window_resize, 3, 0, 0, H_gtk_window_resize, pl_tui);
  s7_define_typed_function(sc, "gtk_window_get_size", lg_gtk_window_get_size, 1, 2, 0, H_gtk_window_get_size, pl_pu);
  s7_define_typed_function(sc, "gtk_window_move", lg_gtk_window_move, 3, 0, 0, H_gtk_window_move, pl_tui);
  s7_define_typed_function(sc, "gtk_window_get_position", lg_gtk_window_get_position, 1, 2, 0, H_gtk_window_get_position, pl_pu);
  s7_define_typed_function(sc, "pango_color_copy", lg_pango_color_copy, 1, 0, 0, H_pango_color_copy, pl_pu);
  s7_define_typed_function(sc, "pango_color_free", lg_pango_color_free, 1, 0, 0, H_pango_color_free, pl_tu);
  s7_define_typed_function(sc, "pango_color_parse", lg_pango_color_parse, 2, 0, 0, H_pango_color_parse, pl_bus);
  s7_define_typed_function(sc, "pango_attr_type_register", lg_pango_attr_type_register, 1, 0, 0, H_pango_attr_type_register, pl_gs);
  s7_define_typed_function(sc, "pango_attribute_copy", lg_pango_attribute_copy, 1, 0, 0, H_pango_attribute_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attribute_destroy", lg_pango_attribute_destroy, 1, 0, 0, H_pango_attribute_destroy, pl_tu);
  s7_define_typed_function(sc, "pango_attribute_equal", lg_pango_attribute_equal, 2, 0, 0, H_pango_attribute_equal, pl_bu);
  s7_define_typed_function(sc, "pango_attr_language_new", lg_pango_attr_language_new, 1, 0, 0, H_pango_attr_language_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_family_new", lg_pango_attr_family_new, 1, 0, 0, H_pango_attr_family_new, pl_ps);
  s7_define_typed_function(sc, "pango_attr_foreground_new", lg_pango_attr_foreground_new, 3, 0, 0, H_pango_attr_foreground_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_background_new", lg_pango_attr_background_new, 3, 0, 0, H_pango_attr_background_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_size_new", lg_pango_attr_size_new, 1, 0, 0, H_pango_attr_size_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_style_new", lg_pango_attr_style_new, 1, 0, 0, H_pango_attr_style_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_weight_new", lg_pango_attr_weight_new, 1, 0, 0, H_pango_attr_weight_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_variant_new", lg_pango_attr_variant_new, 1, 0, 0, H_pango_attr_variant_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_stretch_new", lg_pango_attr_stretch_new, 1, 0, 0, H_pango_attr_stretch_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_font_desc_new", lg_pango_attr_font_desc_new, 1, 0, 0, H_pango_attr_font_desc_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_underline_new", lg_pango_attr_underline_new, 1, 0, 0, H_pango_attr_underline_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_strikethrough_new", lg_pango_attr_strikethrough_new, 1, 0, 0, H_pango_attr_strikethrough_new, pl_pb);
  s7_define_typed_function(sc, "pango_attr_rise_new", lg_pango_attr_rise_new, 1, 0, 0, H_pango_attr_rise_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_shape_new", lg_pango_attr_shape_new, 2, 0, 0, H_pango_attr_shape_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_scale_new", lg_pango_attr_scale_new, 1, 0, 0, H_pango_attr_scale_new, pl_pr);
  s7_define_typed_function(sc, "pango_attr_list_new", lg_pango_attr_list_new, 0, 0, 0, H_pango_attr_list_new, pl_p);
  s7_define_typed_function(sc, "pango_attr_list_unref", lg_pango_attr_list_unref, 1, 0, 0, H_pango_attr_list_unref, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_copy", lg_pango_attr_list_copy, 1, 0, 0, H_pango_attr_list_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attr_list_insert", lg_pango_attr_list_insert, 2, 0, 0, H_pango_attr_list_insert, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_insert_before", lg_pango_attr_list_insert_before, 2, 0, 0, H_pango_attr_list_insert_before, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_change", lg_pango_attr_list_change, 2, 0, 0, H_pango_attr_list_change, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_splice", lg_pango_attr_list_splice, 4, 0, 0, H_pango_attr_list_splice, pl_tuui);
  s7_define_typed_function(sc, "pango_attr_list_get_iterator", lg_pango_attr_list_get_iterator, 1, 0, 0, H_pango_attr_list_get_iterator, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_range", lg_pango_attr_iterator_range, 1, 2, 0, H_pango_attr_iterator_range, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_next", lg_pango_attr_iterator_next, 1, 0, 0, H_pango_attr_iterator_next, pl_bu);
  s7_define_typed_function(sc, "pango_attr_iterator_copy", lg_pango_attr_iterator_copy, 1, 0, 0, H_pango_attr_iterator_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_destroy", lg_pango_attr_iterator_destroy, 1, 0, 0, H_pango_attr_iterator_destroy, pl_tu);
  s7_define_typed_function(sc, "pango_attr_iterator_get", lg_pango_attr_iterator_get, 2, 0, 0, H_pango_attr_iterator_get, pl_pug);
  s7_define_typed_function(sc, "pango_attr_iterator_get_font", lg_pango_attr_iterator_get_font, 2, 2, 0, H_pango_attr_iterator_get_font, pl_pu);
  s7_define_typed_function(sc, "pango_parse_markup", lg_pango_parse_markup, 6, 1, 0, H_pango_parse_markup, pl_psiiuusu);
  s7_define_typed_function(sc, "pango_break", lg_pango_break, 5, 0, 0, H_pango_break, pl_tsiuui);
  s7_define_typed_function(sc, "pango_find_paragraph_boundary", lg_pango_find_paragraph_boundary, 2, 2, 0, H_pango_find_paragraph_boundary, pl_psiu);
  s7_define_typed_function(sc, "pango_get_log_attrs", lg_pango_get_log_attrs, 6, 0, 0, H_pango_get_log_attrs, pl_tsiiuui);
  s7_define_typed_function(sc, "pango_context_list_families", lg_pango_context_list_families, 1, 2, 0, H_pango_context_list_families, pl_pu);
  s7_define_typed_function(sc, "pango_context_load_font", lg_pango_context_load_font, 2, 0, 0, H_pango_context_load_font, pl_pu);
  s7_define_typed_function(sc, "pango_context_load_fontset", lg_pango_context_load_fontset, 3, 0, 0, H_pango_context_load_fontset, pl_pu);
  s7_define_typed_function(sc, "pango_context_get_metrics", lg_pango_context_get_metrics, 3, 0, 0, H_pango_context_get_metrics, pl_pu);
  s7_define_typed_function(sc, "pango_context_set_font_description", lg_pango_context_set_font_description, 2, 0, 0, H_pango_context_set_font_description, pl_tu);
  s7_define_typed_function(sc, "pango_context_get_font_description", lg_pango_context_get_font_description, 1, 0, 0, H_pango_context_get_font_description, pl_pu);
  s7_define_typed_function(sc, "pango_context_get_language", lg_pango_context_get_language, 1, 0, 0, H_pango_context_get_language, pl_pu);
  s7_define_typed_function(sc, "pango_context_set_language", lg_pango_context_set_language, 2, 0, 0, H_pango_context_set_language, pl_tu);
  s7_define_typed_function(sc, "pango_context_set_base_dir", lg_pango_context_set_base_dir, 2, 0, 0, H_pango_context_set_base_dir, pl_tug);
  s7_define_typed_function(sc, "pango_context_get_base_dir", lg_pango_context_get_base_dir, 1, 0, 0, H_pango_context_get_base_dir, pl_gu);
  s7_define_typed_function(sc, "pango_itemize", lg_pango_itemize, 6, 0, 0, H_pango_itemize, pl_pusiiu);
  s7_define_typed_function(sc, "pango_coverage_new", lg_pango_coverage_new, 0, 0, 0, H_pango_coverage_new, pl_p);
  s7_define_typed_function(sc, "pango_coverage_ref", lg_pango_coverage_ref, 1, 0, 0, H_pango_coverage_ref, pl_pu);
  s7_define_typed_function(sc, "pango_coverage_unref", lg_pango_coverage_unref, 1, 0, 0, H_pango_coverage_unref, pl_tu);
  s7_define_typed_function(sc, "pango_coverage_copy", lg_pango_coverage_copy, 1, 0, 0, H_pango_coverage_copy, pl_pu);
  s7_define_typed_function(sc, "pango_coverage_get", lg_pango_coverage_get, 2, 0, 0, H_pango_coverage_get, pl_gui);
  s7_define_typed_function(sc, "pango_coverage_set", lg_pango_coverage_set, 3, 0, 0, H_pango_coverage_set, pl_tuig);
  s7_define_typed_function(sc, "pango_coverage_max", lg_pango_coverage_max, 2, 0, 0, H_pango_coverage_max, pl_tu);
  s7_define_typed_function(sc, "pango_coverage_to_bytes", lg_pango_coverage_to_bytes, 1, 2, 0, H_pango_coverage_to_bytes, pl_pu);
  s7_define_typed_function(sc, "pango_coverage_from_bytes", lg_pango_coverage_from_bytes, 2, 0, 0, H_pango_coverage_from_bytes, pl_psi);
  s7_define_typed_function(sc, "pango_font_description_new", lg_pango_font_description_new, 0, 0, 0, H_pango_font_description_new, pl_p);
  s7_define_typed_function(sc, "pango_font_description_copy", lg_pango_font_description_copy, 1, 0, 0, H_pango_font_description_copy, pl_pu);
  s7_define_typed_function(sc, "pango_font_description_copy_static", lg_pango_font_description_copy_static, 1, 0, 0, H_pango_font_description_copy_static, pl_pu);
  s7_define_typed_function(sc, "pango_font_description_hash", lg_pango_font_description_hash, 1, 0, 0, H_pango_font_description_hash, pl_iu);
  s7_define_typed_function(sc, "pango_font_description_equal", lg_pango_font_description_equal, 2, 0, 0, H_pango_font_description_equal, pl_bu);
  s7_define_typed_function(sc, "pango_font_description_free", lg_pango_font_description_free, 1, 0, 0, H_pango_font_description_free, pl_tu);
  s7_define_typed_function(sc, "pango_font_descriptions_free", lg_pango_font_descriptions_free, 2, 0, 0, H_pango_font_descriptions_free, pl_tui);
  s7_define_typed_function(sc, "pango_font_description_set_family", lg_pango_font_description_set_family, 2, 0, 0, H_pango_font_description_set_family, pl_tus);
  s7_define_typed_function(sc, "pango_font_description_set_family_static", lg_pango_font_description_set_family_static, 2, 0, 0, H_pango_font_description_set_family_static, pl_tus);
  s7_define_typed_function(sc, "pango_font_description_get_family", lg_pango_font_description_get_family, 1, 0, 0, H_pango_font_description_get_family, pl_su);
  s7_define_typed_function(sc, "pango_font_description_set_style", lg_pango_font_description_set_style, 2, 0, 0, H_pango_font_description_set_style, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_style", lg_pango_font_description_get_style, 1, 0, 0, H_pango_font_description_get_style, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_variant", lg_pango_font_description_set_variant, 2, 0, 0, H_pango_font_description_set_variant, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_variant", lg_pango_font_description_get_variant, 1, 0, 0, H_pango_font_description_get_variant, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_weight", lg_pango_font_description_set_weight, 2, 0, 0, H_pango_font_description_set_weight, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_weight", lg_pango_font_description_get_weight, 1, 0, 0, H_pango_font_description_get_weight, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_stretch", lg_pango_font_description_set_stretch, 2, 0, 0, H_pango_font_description_set_stretch, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_stretch", lg_pango_font_description_get_stretch, 1, 0, 0, H_pango_font_description_get_stretch, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_size", lg_pango_font_description_set_size, 2, 0, 0, H_pango_font_description_set_size, pl_tui);
  s7_define_typed_function(sc, "pango_font_description_get_size", lg_pango_font_description_get_size, 1, 0, 0, H_pango_font_description_get_size, pl_iu);
  s7_define_typed_function(sc, "pango_font_description_get_set_fields", lg_pango_font_description_get_set_fields, 1, 0, 0, H_pango_font_description_get_set_fields, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_unset_fields", lg_pango_font_description_unset_fields, 2, 0, 0, H_pango_font_description_unset_fields, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_merge", lg_pango_font_description_merge, 3, 0, 0, H_pango_font_description_merge, pl_tuub);
  s7_define_typed_function(sc, "pango_font_description_merge_static", lg_pango_font_description_merge_static, 3, 0, 0, H_pango_font_description_merge_static, pl_tuub);
  s7_define_typed_function(sc, "pango_font_description_better_match", lg_pango_font_description_better_match, 3, 0, 0, H_pango_font_description_better_match, pl_bu);
  s7_define_typed_function(sc, "pango_font_description_from_string", lg_pango_font_description_from_string, 1, 0, 0, H_pango_font_description_from_string, pl_ps);
  s7_define_typed_function(sc, "pango_font_description_to_string", lg_pango_font_description_to_string, 1, 0, 0, H_pango_font_description_to_string, pl_su);
  s7_define_typed_function(sc, "pango_font_description_to_filename", lg_pango_font_description_to_filename, 1, 0, 0, H_pango_font_description_to_filename, pl_su);
  s7_define_typed_function(sc, "pango_font_metrics_ref", lg_pango_font_metrics_ref, 1, 0, 0, H_pango_font_metrics_ref, pl_pu);
  s7_define_typed_function(sc, "pango_font_metrics_unref", lg_pango_font_metrics_unref, 1, 0, 0, H_pango_font_metrics_unref, pl_tu);
  s7_define_typed_function(sc, "pango_font_metrics_get_ascent", lg_pango_font_metrics_get_ascent, 1, 0, 0, H_pango_font_metrics_get_ascent, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_descent", lg_pango_font_metrics_get_descent, 1, 0, 0, H_pango_font_metrics_get_descent, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_approximate_char_width", lg_pango_font_metrics_get_approximate_char_width, 1, 0, 0, H_pango_font_metrics_get_approximate_char_width, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_approximate_digit_width", lg_pango_font_metrics_get_approximate_digit_width, 1, 0, 0, H_pango_font_metrics_get_approximate_digit_width, pl_iu);
  s7_define_typed_function(sc, "pango_font_family_list_faces", lg_pango_font_family_list_faces, 1, 2, 0, H_pango_font_family_list_faces, pl_pu);
  s7_define_typed_function(sc, "pango_font_family_get_name", lg_pango_font_family_get_name, 1, 0, 0, H_pango_font_family_get_name, pl_su);
  s7_define_typed_function(sc, "pango_font_face_describe", lg_pango_font_face_describe, 1, 0, 0, H_pango_font_face_describe, pl_pu);
  s7_define_typed_function(sc, "pango_font_face_get_face_name", lg_pango_font_face_get_face_name, 1, 0, 0, H_pango_font_face_get_face_name, pl_su);
  s7_define_typed_function(sc, "pango_font_describe", lg_pango_font_describe, 1, 0, 0, H_pango_font_describe, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_coverage", lg_pango_font_get_coverage, 2, 0, 0, H_pango_font_get_coverage, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_metrics", lg_pango_font_get_metrics, 2, 0, 0, H_pango_font_get_metrics, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_glyph_extents", lg_pango_font_get_glyph_extents, 4, 0, 0, H_pango_font_get_glyph_extents, pl_tuiu);
  s7_define_typed_function(sc, "pango_font_map_load_font", lg_pango_font_map_load_font, 3, 0, 0, H_pango_font_map_load_font, pl_pu);
  s7_define_typed_function(sc, "pango_font_map_load_fontset", lg_pango_font_map_load_fontset, 4, 0, 0, H_pango_font_map_load_fontset, pl_pu);
  s7_define_typed_function(sc, "pango_font_map_list_families", lg_pango_font_map_list_families, 1, 2, 0, H_pango_font_map_list_families, pl_pu);
  s7_define_typed_function(sc, "pango_glyph_string_new", lg_pango_glyph_string_new, 0, 0, 0, H_pango_glyph_string_new, pl_p);
  s7_define_typed_function(sc, "pango_glyph_string_set_size", lg_pango_glyph_string_set_size, 2, 0, 0, H_pango_glyph_string_set_size, pl_tui);
  s7_define_typed_function(sc, "pango_glyph_string_copy", lg_pango_glyph_string_copy, 1, 0, 0, H_pango_glyph_string_copy, pl_pu);
  s7_define_typed_function(sc, "pango_glyph_string_free", lg_pango_glyph_string_free, 1, 0, 0, H_pango_glyph_string_free, pl_tu);
  s7_define_typed_function(sc, "pango_glyph_string_extents", lg_pango_glyph_string_extents, 4, 0, 0, H_pango_glyph_string_extents, pl_tu);
  s7_define_typed_function(sc, "pango_glyph_string_extents_range", lg_pango_glyph_string_extents_range, 6, 0, 0, H_pango_glyph_string_extents_range, pl_tuiiu);
  s7_define_typed_function(sc, "pango_glyph_string_get_logical_widths", lg_pango_glyph_string_get_logical_widths, 4, 1, 0, H_pango_glyph_string_get_logical_widths, pl_pusiiu);
  s7_define_typed_function(sc, "pango_glyph_string_index_to_x", lg_pango_glyph_string_index_to_x, 6, 1, 0, H_pango_glyph_string_index_to_x, pl_pusiuibu);
  s7_define_typed_function(sc, "pango_glyph_string_x_to_index", lg_pango_glyph_string_x_to_index, 5, 2, 0, H_pango_glyph_string_x_to_index, pl_pusiuiu);
  s7_define_typed_function(sc, "pango_shape", lg_pango_shape, 4, 0, 0, H_pango_shape, pl_tsiu);
  s7_define_typed_function(sc, "pango_reorder_items", lg_pango_reorder_items, 1, 0, 0, H_pango_reorder_items, pl_pu);
  s7_define_typed_function(sc, "pango_item_new", lg_pango_item_new, 0, 0, 0, H_pango_item_new, pl_p);
  s7_define_typed_function(sc, "pango_item_copy", lg_pango_item_copy, 1, 0, 0, H_pango_item_copy, pl_pu);
  s7_define_typed_function(sc, "pango_item_free", lg_pango_item_free, 1, 0, 0, H_pango_item_free, pl_tu);
  s7_define_typed_function(sc, "pango_item_split", lg_pango_item_split, 3, 0, 0, H_pango_item_split, pl_pui);
  s7_define_typed_function(sc, "pango_layout_new", lg_pango_layout_new, 1, 0, 0, H_pango_layout_new, pl_pu);
  s7_define_typed_function(sc, "pango_layout_copy", lg_pango_layout_copy, 1, 0, 0, H_pango_layout_copy, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_context", lg_pango_layout_get_context, 1, 0, 0, H_pango_layout_get_context, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_attributes", lg_pango_layout_set_attributes, 2, 0, 0, H_pango_layout_set_attributes, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_attributes", lg_pango_layout_get_attributes, 1, 0, 0, H_pango_layout_get_attributes, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_text", lg_pango_layout_set_text, 3, 0, 0, H_pango_layout_set_text, pl_tusi);
  s7_define_typed_function(sc, "pango_layout_get_text", lg_pango_layout_get_text, 1, 0, 0, H_pango_layout_get_text, pl_su);
  s7_define_typed_function(sc, "pango_layout_set_markup", lg_pango_layout_set_markup, 3, 0, 0, H_pango_layout_set_markup, pl_tusi);
  s7_define_typed_function(sc, "pango_layout_set_markup_with_accel", lg_pango_layout_set_markup_with_accel, 5, 0, 0, H_pango_layout_set_markup_with_accel, pl_tusiis);
  s7_define_typed_function(sc, "pango_layout_set_font_description", lg_pango_layout_set_font_description, 2, 0, 0, H_pango_layout_set_font_description, pl_tu);
  s7_define_typed_function(sc, "pango_layout_set_width", lg_pango_layout_set_width, 2, 0, 0, H_pango_layout_set_width, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_width", lg_pango_layout_get_width, 1, 0, 0, H_pango_layout_get_width, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_wrap", lg_pango_layout_set_wrap, 2, 0, 0, H_pango_layout_set_wrap, pl_tug);
  s7_define_typed_function(sc, "pango_layout_get_wrap", lg_pango_layout_get_wrap, 1, 0, 0, H_pango_layout_get_wrap, pl_gu);
  s7_define_typed_function(sc, "pango_layout_set_indent", lg_pango_layout_set_indent, 2, 0, 0, H_pango_layout_set_indent, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_indent", lg_pango_layout_get_indent, 1, 0, 0, H_pango_layout_get_indent, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_spacing", lg_pango_layout_set_spacing, 2, 0, 0, H_pango_layout_set_spacing, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_spacing", lg_pango_layout_get_spacing, 1, 0, 0, H_pango_layout_get_spacing, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_justify", lg_pango_layout_set_justify, 2, 0, 0, H_pango_layout_set_justify, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_justify", lg_pango_layout_get_justify, 1, 0, 0, H_pango_layout_get_justify, pl_bu);
  s7_define_typed_function(sc, "pango_layout_set_alignment", lg_pango_layout_set_alignment, 2, 0, 0, H_pango_layout_set_alignment, pl_tug);
  s7_define_typed_function(sc, "pango_layout_get_alignment", lg_pango_layout_get_alignment, 1, 0, 0, H_pango_layout_get_alignment, pl_gu);
  s7_define_typed_function(sc, "pango_layout_set_tabs", lg_pango_layout_set_tabs, 2, 0, 0, H_pango_layout_set_tabs, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_tabs", lg_pango_layout_get_tabs, 1, 0, 0, H_pango_layout_get_tabs, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_single_paragraph_mode", lg_pango_layout_set_single_paragraph_mode, 2, 0, 0, H_pango_layout_set_single_paragraph_mode, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_single_paragraph_mode", lg_pango_layout_get_single_paragraph_mode, 1, 0, 0, H_pango_layout_get_single_paragraph_mode, pl_bu);
  s7_define_typed_function(sc, "pango_layout_context_changed", lg_pango_layout_context_changed, 1, 0, 0, H_pango_layout_context_changed, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_log_attrs", lg_pango_layout_get_log_attrs, 1, 2, 0, H_pango_layout_get_log_attrs, pl_pu);
  s7_define_typed_function(sc, "pango_layout_index_to_pos", lg_pango_layout_index_to_pos, 3, 0, 0, H_pango_layout_index_to_pos, pl_tuiu);
  s7_define_typed_function(sc, "pango_layout_get_cursor_pos", lg_pango_layout_get_cursor_pos, 4, 0, 0, H_pango_layout_get_cursor_pos, pl_tuiu);
  s7_define_typed_function(sc, "pango_layout_move_cursor_visually", lg_pango_layout_move_cursor_visually, 7, 0, 0, H_pango_layout_move_cursor_visually, pl_tubiiiu);
  s7_define_typed_function(sc, "pango_layout_xy_to_index", lg_pango_layout_xy_to_index, 3, 2, 0, H_pango_layout_xy_to_index, pl_puiiu);
  s7_define_typed_function(sc, "pango_layout_get_extents", lg_pango_layout_get_extents, 3, 0, 0, H_pango_layout_get_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_pixel_extents", lg_pango_layout_get_pixel_extents, 3, 0, 0, H_pango_layout_get_pixel_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_size", lg_pango_layout_get_size, 1, 2, 0, H_pango_layout_get_size, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_pixel_size", lg_pango_layout_get_pixel_size, 1, 2, 0, H_pango_layout_get_pixel_size, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_line_count", lg_pango_layout_get_line_count, 1, 0, 0, H_pango_layout_get_line_count, pl_iu);
  s7_define_typed_function(sc, "pango_layout_get_line", lg_pango_layout_get_line, 2, 0, 0, H_pango_layout_get_line, pl_pui);
  s7_define_typed_function(sc, "pango_layout_get_lines", lg_pango_layout_get_lines, 1, 0, 0, H_pango_layout_get_lines, pl_pu);
  s7_define_typed_function(sc, "pango_layout_line_unref", lg_pango_layout_line_unref, 1, 0, 0, H_pango_layout_line_unref, pl_tu);
  s7_define_typed_function(sc, "pango_layout_line_x_to_index", lg_pango_layout_line_x_to_index, 2, 2, 0, H_pango_layout_line_x_to_index, pl_puiu);
  s7_define_typed_function(sc, "pango_layout_line_index_to_x", lg_pango_layout_line_index_to_x, 3, 1, 0, H_pango_layout_line_index_to_x, pl_puibu);
  s7_define_typed_function(sc, "pango_layout_line_get_x_ranges", lg_pango_layout_line_get_x_ranges, 3, 2, 0, H_pango_layout_line_get_x_ranges, pl_puiiu);
  s7_define_typed_function(sc, "pango_layout_line_get_extents", lg_pango_layout_line_get_extents, 3, 0, 0, H_pango_layout_line_get_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_line_get_pixel_extents", lg_pango_layout_line_get_pixel_extents, 3, 0, 0, H_pango_layout_line_get_pixel_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_iter", lg_pango_layout_get_iter, 1, 0, 0, H_pango_layout_get_iter, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_free", lg_pango_layout_iter_free, 1, 0, 0, H_pango_layout_iter_free, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_index", lg_pango_layout_iter_get_index, 1, 0, 0, H_pango_layout_iter_get_index, pl_iu);
  s7_define_typed_function(sc, "pango_layout_iter_get_run", lg_pango_layout_iter_get_run, 1, 0, 0, H_pango_layout_iter_get_run, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line", lg_pango_layout_iter_get_line, 1, 0, 0, H_pango_layout_iter_get_line, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_at_last_line", lg_pango_layout_iter_at_last_line, 1, 0, 0, H_pango_layout_iter_at_last_line, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_char", lg_pango_layout_iter_next_char, 1, 0, 0, H_pango_layout_iter_next_char, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_cluster", lg_pango_layout_iter_next_cluster, 1, 0, 0, H_pango_layout_iter_next_cluster, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_run", lg_pango_layout_iter_next_run, 1, 0, 0, H_pango_layout_iter_next_run, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_line", lg_pango_layout_iter_next_line, 1, 0, 0, H_pango_layout_iter_next_line, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_get_char_extents", lg_pango_layout_iter_get_char_extents, 2, 0, 0, H_pango_layout_iter_get_char_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_cluster_extents", lg_pango_layout_iter_get_cluster_extents, 3, 0, 0, H_pango_layout_iter_get_cluster_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_run_extents", lg_pango_layout_iter_get_run_extents, 3, 0, 0, H_pango_layout_iter_get_run_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line_extents", lg_pango_layout_iter_get_line_extents, 3, 0, 0, H_pango_layout_iter_get_line_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line_yrange", lg_pango_layout_iter_get_line_yrange, 1, 2, 0, H_pango_layout_iter_get_line_yrange, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_get_layout_extents", lg_pango_layout_iter_get_layout_extents, 3, 0, 0, H_pango_layout_iter_get_layout_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_baseline", lg_pango_layout_iter_get_baseline, 1, 0, 0, H_pango_layout_iter_get_baseline, pl_iu);
  s7_define_typed_function(sc, "pango_language_from_string", lg_pango_language_from_string, 1, 0, 0, H_pango_language_from_string, pl_ps);
  s7_define_typed_function(sc, "pango_language_matches", lg_pango_language_matches, 2, 0, 0, H_pango_language_matches, pl_bus);
  s7_define_typed_function(sc, "G_OBJECT_TYPE", lg_G_OBJECT_TYPE, 1, 0, 0, H_G_OBJECT_TYPE, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_get_string_from_iter", lg_gtk_tree_model_get_string_from_iter, 2, 0, 0, H_gtk_tree_model_get_string_from_iter, pl_su);
  s7_define_typed_function(sc, "gtk_tree_model_sort_iter_is_valid", lg_gtk_tree_model_sort_iter_is_valid, 2, 0, 0, H_gtk_tree_model_sort_iter_is_valid, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_to_path", lg_gtk_tree_view_expand_to_path, 2, 0, 0, H_gtk_tree_view_expand_to_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_selected_rows", lg_gtk_tree_selection_get_selected_rows, 2, 0, 0, H_gtk_tree_selection_get_selected_rows, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_selection_count_selected_rows", lg_gtk_tree_selection_count_selected_rows, 1, 0, 0, H_gtk_tree_selection_count_selected_rows, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_shell_select_first", lg_gtk_menu_shell_select_first, 2, 0, 0, H_gtk_menu_shell_select_first, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_n_pages", lg_gtk_notebook_get_n_pages, 1, 0, 0, H_gtk_notebook_get_n_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_list_store_reorder", lg_gtk_list_store_reorder, 2, 0, 0, H_gtk_list_store_reorder, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_swap", lg_gtk_list_store_swap, 3, 0, 0, H_gtk_list_store_swap, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_move_after", lg_gtk_list_store_move_after, 3, 0, 0, H_gtk_list_store_move_after, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_move_before", lg_gtk_list_store_move_before, 3, 0, 0, H_gtk_list_store_move_before, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_reorder", lg_gtk_tree_store_reorder, 3, 0, 0, H_gtk_tree_store_reorder, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_swap", lg_gtk_tree_store_swap, 3, 0, 0, H_gtk_tree_store_swap, pl_tu);
  s7_define_typed_function(sc, "gdk_display_open", lg_gdk_display_open, 1, 0, 0, H_gdk_display_open, pl_ps);
  s7_define_typed_function(sc, "gdk_display_get_name", lg_gdk_display_get_name, 1, 0, 0, H_gdk_display_get_name, pl_su);
  s7_define_typed_function(sc, "gdk_display_get_default_screen", lg_gdk_display_get_default_screen, 1, 0, 0, H_gdk_display_get_default_screen, pl_pu);
  s7_define_typed_function(sc, "gdk_display_beep", lg_gdk_display_beep, 1, 0, 0, H_gdk_display_beep, pl_tu);
  s7_define_typed_function(sc, "gdk_display_sync", lg_gdk_display_sync, 1, 0, 0, H_gdk_display_sync, pl_tu);
  s7_define_typed_function(sc, "gdk_display_close", lg_gdk_display_close, 1, 0, 0, H_gdk_display_close, pl_tu);
  s7_define_typed_function(sc, "gdk_display_get_event", lg_gdk_display_get_event, 1, 0, 0, H_gdk_display_get_event, pl_pu);
  s7_define_typed_function(sc, "gdk_display_peek_event", lg_gdk_display_peek_event, 1, 0, 0, H_gdk_display_peek_event, pl_pu);
  s7_define_typed_function(sc, "gdk_display_put_event", lg_gdk_display_put_event, 2, 0, 0, H_gdk_display_put_event, pl_tu);
  s7_define_typed_function(sc, "gdk_display_set_double_click_time", lg_gdk_display_set_double_click_time, 2, 0, 0, H_gdk_display_set_double_click_time, pl_tui);
  s7_define_typed_function(sc, "gdk_display_get_default", lg_gdk_display_get_default, 0, 0, 0, H_gdk_display_get_default, pl_p);
  s7_define_typed_function(sc, "gdk_screen_get_root_window", lg_gdk_screen_get_root_window, 1, 0, 0, H_gdk_screen_get_root_window, pl_pu);
  s7_define_typed_function(sc, "gdk_screen_get_display", lg_gdk_screen_get_display, 1, 0, 0, H_gdk_screen_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_screen_get_toplevel_windows", lg_gdk_screen_get_toplevel_windows, 1, 0, 0, H_gdk_screen_get_toplevel_windows, pl_pu);
  s7_define_typed_function(sc, "gdk_screen_get_default", lg_gdk_screen_get_default, 0, 0, 0, H_gdk_screen_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_clipboard_get_for_display", lg_gtk_clipboard_get_for_display, 2, 0, 0, H_gtk_clipboard_get_for_display, pl_put);
  s7_define_typed_function(sc, "gtk_clipboard_get_display", lg_gtk_clipboard_get_display, 1, 0, 0, H_gtk_clipboard_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_screen", lg_gtk_widget_get_screen, 1, 0, 0, H_gtk_widget_get_screen, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_has_screen", lg_gtk_widget_has_screen, 1, 0, 0, H_gtk_widget_has_screen, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_display", lg_gtk_widget_get_display, 1, 0, 0, H_gtk_widget_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_clipboard", lg_gtk_widget_get_clipboard, 2, 0, 0, H_gtk_widget_get_clipboard, pl_put);
  s7_define_typed_function(sc, "g_list_free", lg_g_list_free, 1, 0, 0, H_g_list_free, pl_tu);
  s7_define_typed_function(sc, "g_list_reverse", lg_g_list_reverse, 1, 0, 0, H_g_list_reverse, pl_pu);
  s7_define_typed_function(sc, "g_list_copy", lg_g_list_copy, 1, 0, 0, H_g_list_copy, pl_pu);
  s7_define_typed_function(sc, "g_list_last", lg_g_list_last, 1, 0, 0, H_g_list_last, pl_pu);
  s7_define_typed_function(sc, "g_list_first", lg_g_list_first, 1, 0, 0, H_g_list_first, pl_pu);
  s7_define_typed_function(sc, "g_list_length", lg_g_list_length, 1, 0, 0, H_g_list_length, pl_iu);
  s7_define_typed_function(sc, "g_free", lg_g_free, 1, 0, 0, H_g_free, pl_t);
  s7_define_typed_function(sc, "g_list_remove_link", lg_g_list_remove_link, 2, 0, 0, H_g_list_remove_link, pl_pu);
  s7_define_typed_function(sc, "g_object_get_data", lg_g_object_get_data, 2, 0, 0, H_g_object_get_data, pl_tus);
  s7_define_typed_function(sc, "g_object_set_data", lg_g_object_set_data, 3, 0, 0, H_g_object_set_data, pl_tust);
  s7_define_typed_function(sc, "gdk_cursor_new_from_pixbuf", lg_gdk_cursor_new_from_pixbuf, 4, 0, 0, H_gdk_cursor_new_from_pixbuf, pl_puui);
  s7_define_typed_function(sc, "gdk_display_flush", lg_gdk_display_flush, 1, 0, 0, H_gdk_display_flush, pl_tu);
  s7_define_typed_function(sc, "gdk_display_supports_cursor_alpha", lg_gdk_display_supports_cursor_alpha, 1, 0, 0, H_gdk_display_supports_cursor_alpha, pl_bu);
  s7_define_typed_function(sc, "gdk_display_supports_cursor_color", lg_gdk_display_supports_cursor_color, 1, 0, 0, H_gdk_display_supports_cursor_color, pl_bu);
  s7_define_typed_function(sc, "gdk_display_get_default_cursor_size", lg_gdk_display_get_default_cursor_size, 1, 0, 0, H_gdk_display_get_default_cursor_size, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_maximal_cursor_size", lg_gdk_display_get_maximal_cursor_size, 1, 2, 0, H_gdk_display_get_maximal_cursor_size, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_keep_above", lg_gdk_window_set_keep_above, 2, 0, 0, H_gdk_window_set_keep_above, pl_tub);
  s7_define_typed_function(sc, "gdk_window_set_keep_below", lg_gdk_window_set_keep_below, 2, 0, 0, H_gdk_window_set_keep_below, pl_tub);
  s7_define_typed_function(sc, "gtk_button_box_get_child_secondary", lg_gtk_button_box_get_child_secondary, 2, 0, 0, H_gtk_button_box_get_child_secondary, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_set_display_options", lg_gtk_calendar_set_display_options, 2, 0, 0, H_gtk_calendar_set_display_options, pl_tug);
  s7_define_typed_function(sc, "gtk_calendar_get_display_options", lg_gtk_calendar_get_display_options, 1, 0, 0, H_gtk_calendar_get_display_options, pl_gu);
  s7_define_typed_function(sc, "gtk_check_menu_item_set_draw_as_radio", lg_gtk_check_menu_item_set_draw_as_radio, 2, 0, 0, H_gtk_check_menu_item_set_draw_as_radio, pl_tub);
  s7_define_typed_function(sc, "gtk_check_menu_item_get_draw_as_radio", lg_gtk_check_menu_item_get_draw_as_radio, 1, 0, 0, H_gtk_check_menu_item_get_draw_as_radio, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_completion", lg_gtk_entry_set_completion, 2, 0, 0, H_gtk_entry_set_completion, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_completion", lg_gtk_entry_get_completion, 1, 0, 0, H_gtk_entry_get_completion, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_attach", lg_gtk_menu_attach, 6, 0, 0, H_gtk_menu_attach, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_select_range", lg_gtk_text_buffer_select_range, 3, 0, 0, H_gtk_text_buffer_select_range, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_set_overwrite", lg_gtk_text_view_set_overwrite, 2, 0, 0, H_gtk_text_view_set_overwrite, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_overwrite", lg_gtk_text_view_get_overwrite, 1, 0, 0, H_gtk_text_view_get_overwrite, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_accepts_tab", lg_gtk_text_view_set_accepts_tab, 2, 0, 0, H_gtk_text_view_set_accepts_tab, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_accepts_tab", lg_gtk_text_view_get_accepts_tab, 1, 0, 0, H_gtk_text_view_get_accepts_tab, pl_bu);
  s7_define_typed_function(sc, "gtk_toolbar_insert", lg_gtk_toolbar_insert, 3, 0, 0, H_gtk_toolbar_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_toolbar_get_item_index", lg_gtk_toolbar_get_item_index, 2, 0, 0, H_gtk_toolbar_get_item_index, pl_iu);
  s7_define_typed_function(sc, "gtk_toolbar_get_n_items", lg_gtk_toolbar_get_n_items, 1, 0, 0, H_gtk_toolbar_get_n_items, pl_iu);
  s7_define_typed_function(sc, "gtk_toolbar_get_nth_item", lg_gtk_toolbar_get_nth_item, 2, 0, 0, H_gtk_toolbar_get_nth_item, pl_pui);
  s7_define_typed_function(sc, "gtk_toolbar_set_show_arrow", lg_gtk_toolbar_set_show_arrow, 2, 0, 0, H_gtk_toolbar_set_show_arrow, pl_tub);
  s7_define_typed_function(sc, "gtk_toolbar_get_show_arrow", lg_gtk_toolbar_get_show_arrow, 1, 0, 0, H_gtk_toolbar_get_show_arrow, pl_bu);
  s7_define_typed_function(sc, "gtk_toolbar_get_drop_index", lg_gtk_toolbar_get_drop_index, 3, 0, 0, H_gtk_toolbar_get_drop_index, pl_iui);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_expand", lg_gtk_tree_view_column_set_expand, 2, 0, 0, H_gtk_tree_view_column_set_expand, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_expand", lg_gtk_tree_view_column_get_expand, 1, 0, 0, H_gtk_tree_view_column_get_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_queue_resize_no_redraw", lg_gtk_widget_queue_resize_no_redraw, 1, 0, 0, H_gtk_widget_queue_resize_no_redraw, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_default_icon", lg_gtk_window_set_default_icon, 1, 0, 0, H_gtk_window_set_default_icon, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_keep_above", lg_gtk_window_set_keep_above, 2, 0, 0, H_gtk_window_set_keep_above, pl_tub);
  s7_define_typed_function(sc, "gtk_window_set_keep_below", lg_gtk_window_set_keep_below, 2, 0, 0, H_gtk_window_set_keep_below, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_dialog_new", lg_gtk_file_chooser_dialog_new, 3, 1, 0, H_gtk_file_chooser_dialog_new, pl_psugt);
  s7_define_typed_function(sc, "gtk_file_chooser_widget_new", lg_gtk_file_chooser_widget_new, 1, 0, 0, H_gtk_file_chooser_widget_new, pl_pg);
  s7_define_typed_function(sc, "gtk_tree_model_filter_new", lg_gtk_tree_model_filter_new, 2, 0, 0, H_gtk_tree_model_filter_new, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_set_visible_column", lg_gtk_tree_model_filter_set_visible_column, 2, 0, 0, H_gtk_tree_model_filter_set_visible_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_model_filter_get_model", lg_gtk_tree_model_filter_get_model, 1, 0, 0, H_gtk_tree_model_filter_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", lg_gtk_tree_model_filter_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_iter_to_child_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_child_path_to_path", lg_gtk_tree_model_filter_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_filter_convert_child_path_to_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_path_to_child_path", lg_gtk_tree_model_filter_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_filter_convert_path_to_child_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_refilter", lg_gtk_tree_model_filter_refilter, 1, 0, 0, H_gtk_tree_model_filter_refilter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_clear_cache", lg_gtk_tree_model_filter_clear_cache, 1, 0, 0, H_gtk_tree_model_filter_clear_cache, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_new", lg_gtk_combo_box_new, 0, 0, 0, H_gtk_combo_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_model", lg_gtk_combo_box_new_with_model, 1, 0, 0, H_gtk_combo_box_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_combo_box_set_model", lg_gtk_combo_box_set_model, 2, 0, 0, H_gtk_combo_box_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_set_wrap_width", lg_gtk_combo_box_set_wrap_width, 2, 0, 0, H_gtk_combo_box_set_wrap_width, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_set_row_span_column", lg_gtk_combo_box_set_row_span_column, 2, 0, 0, H_gtk_combo_box_set_row_span_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_set_column_span_column", lg_gtk_combo_box_set_column_span_column, 2, 0, 0, H_gtk_combo_box_set_column_span_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_active", lg_gtk_combo_box_get_active, 1, 0, 0, H_gtk_combo_box_get_active, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_set_active", lg_gtk_combo_box_set_active, 2, 0, 0, H_gtk_combo_box_set_active, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_active_iter", lg_gtk_combo_box_get_active_iter, 2, 0, 0, H_gtk_combo_box_get_active_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_combo_box_set_active_iter", lg_gtk_combo_box_set_active_iter, 2, 0, 0, H_gtk_combo_box_set_active_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_get_model", lg_gtk_combo_box_get_model, 1, 0, 0, H_gtk_combo_box_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_expander_new", lg_gtk_expander_new, 1, 0, 0, H_gtk_expander_new, pl_ps);
  s7_define_typed_function(sc, "gtk_expander_new_with_mnemonic", lg_gtk_expander_new_with_mnemonic, 1, 0, 0, H_gtk_expander_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_expander_set_expanded", lg_gtk_expander_set_expanded, 2, 0, 0, H_gtk_expander_set_expanded, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_expanded", lg_gtk_expander_get_expanded, 1, 0, 0, H_gtk_expander_get_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_expander_set_label", lg_gtk_expander_set_label, 2, 0, 0, H_gtk_expander_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_expander_get_label", lg_gtk_expander_get_label, 1, 0, 0, H_gtk_expander_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_expander_set_use_underline", lg_gtk_expander_set_use_underline, 2, 0, 0, H_gtk_expander_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_use_underline", lg_gtk_expander_get_use_underline, 1, 0, 0, H_gtk_expander_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_expander_set_label_widget", lg_gtk_expander_set_label_widget, 2, 0, 0, H_gtk_expander_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_expander_get_label_widget", lg_gtk_expander_get_label_widget, 1, 0, 0, H_gtk_expander_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_expander_set_use_markup", lg_gtk_expander_set_use_markup, 2, 0, 0, H_gtk_expander_set_use_markup, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_use_markup", lg_gtk_expander_get_use_markup, 1, 0, 0, H_gtk_expander_get_use_markup, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_new", lg_gtk_font_button_new, 0, 0, 0, H_gtk_font_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_font_button_new_with_font", lg_gtk_font_button_new_with_font, 1, 0, 0, H_gtk_font_button_new_with_font, pl_ps);
  s7_define_typed_function(sc, "gtk_font_button_get_title", lg_gtk_font_button_get_title, 1, 0, 0, H_gtk_font_button_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_font_button_set_title", lg_gtk_font_button_set_title, 2, 0, 0, H_gtk_font_button_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_font_button_get_use_font", lg_gtk_font_button_get_use_font, 1, 0, 0, H_gtk_font_button_get_use_font, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_use_font", lg_gtk_font_button_set_use_font, 2, 0, 0, H_gtk_font_button_set_use_font, pl_tub);
  s7_define_typed_function(sc, "gtk_font_button_get_use_size", lg_gtk_font_button_get_use_size, 1, 0, 0, H_gtk_font_button_get_use_size, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_use_size", lg_gtk_font_button_set_use_size, 2, 0, 0, H_gtk_font_button_set_use_size, pl_tub);
  s7_define_typed_function(sc, "gtk_font_button_get_font_name", lg_gtk_font_button_get_font_name, 1, 0, 0, H_gtk_font_button_get_font_name, pl_su);
  s7_define_typed_function(sc, "gtk_font_button_set_font_name", lg_gtk_font_button_set_font_name, 2, 0, 0, H_gtk_font_button_set_font_name, pl_bus);
  s7_define_typed_function(sc, "gtk_font_button_get_show_style", lg_gtk_font_button_get_show_style, 1, 0, 0, H_gtk_font_button_get_show_style, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_show_style", lg_gtk_font_button_set_show_style, 2, 0, 0, H_gtk_font_button_set_show_style, pl_tub);
  s7_define_typed_function(sc, "gtk_font_button_get_show_size", lg_gtk_font_button_get_show_size, 1, 0, 0, H_gtk_font_button_get_show_size, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_show_size", lg_gtk_font_button_set_show_size, 2, 0, 0, H_gtk_font_button_set_show_size, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_new", lg_gtk_entry_completion_new, 0, 0, 0, H_gtk_entry_completion_new, pl_p);
  s7_define_typed_function(sc, "gtk_entry_completion_get_entry", lg_gtk_entry_completion_get_entry, 1, 0, 0, H_gtk_entry_completion_get_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_model", lg_gtk_entry_completion_set_model, 2, 0, 0, H_gtk_entry_completion_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_model", lg_gtk_entry_completion_get_model, 1, 0, 0, H_gtk_entry_completion_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_match_func", lg_gtk_entry_completion_set_match_func, 4, 0, 0, H_gtk_entry_completion_set_match_func, pl_tut);
  s7_define_typed_function(sc, "gtk_entry_completion_set_minimum_key_length", lg_gtk_entry_completion_set_minimum_key_length, 2, 0, 0, H_gtk_entry_completion_set_minimum_key_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_completion_get_minimum_key_length", lg_gtk_entry_completion_get_minimum_key_length, 1, 0, 0, H_gtk_entry_completion_get_minimum_key_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_completion_complete", lg_gtk_entry_completion_complete, 1, 0, 0, H_gtk_entry_completion_complete, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_action_text", lg_gtk_entry_completion_insert_action_text, 3, 0, 0, H_gtk_entry_completion_insert_action_text, pl_tuis);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_action_markup", lg_gtk_entry_completion_insert_action_markup, 3, 0, 0, H_gtk_entry_completion_insert_action_markup, pl_tuis);
  s7_define_typed_function(sc, "gtk_entry_completion_delete_action", lg_gtk_entry_completion_delete_action, 2, 0, 0, H_gtk_entry_completion_delete_action, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_completion_set_text_column", lg_gtk_entry_completion_set_text_column, 2, 0, 0, H_gtk_entry_completion_set_text_column, pl_tui);
  s7_define_typed_function(sc, "gtk_radio_tool_button_new", lg_gtk_radio_tool_button_new, 1, 0, 0, H_gtk_radio_tool_button_new, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_tool_button_new_from_widget", lg_gtk_radio_tool_button_new_from_widget, 1, 0, 0, H_gtk_radio_tool_button_new_from_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_tool_button_get_group", lg_gtk_radio_tool_button_get_group, 1, 0, 0, H_gtk_radio_tool_button_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_tool_button_set_group", lg_gtk_radio_tool_button_set_group, 2, 0, 0, H_gtk_radio_tool_button_set_group, pl_tu);
  s7_define_typed_function(sc, "gtk_separator_tool_item_new", lg_gtk_separator_tool_item_new, 0, 0, 0, H_gtk_separator_tool_item_new, pl_p);
  s7_define_typed_function(sc, "gtk_separator_tool_item_get_draw", lg_gtk_separator_tool_item_get_draw, 1, 0, 0, H_gtk_separator_tool_item_get_draw, pl_bu);
  s7_define_typed_function(sc, "gtk_separator_tool_item_set_draw", lg_gtk_separator_tool_item_set_draw, 2, 0, 0, H_gtk_separator_tool_item_set_draw, pl_tub);
  s7_define_typed_function(sc, "gtk_toggle_tool_button_new", lg_gtk_toggle_tool_button_new, 0, 0, 0, H_gtk_toggle_tool_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_toggle_tool_button_set_active", lg_gtk_toggle_tool_button_set_active, 2, 0, 0, H_gtk_toggle_tool_button_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_toggle_tool_button_get_active", lg_gtk_toggle_tool_button_get_active, 1, 0, 0, H_gtk_toggle_tool_button_get_active, pl_bu);
  s7_define_typed_function(sc, "g_timeout_add_full", lg_g_timeout_add_full, 5, 0, 0, H_g_timeout_add_full, pl_iiit);
  s7_define_typed_function(sc, "g_timeout_add", lg_g_timeout_add, 2, 1, 0, H_g_timeout_add, pl_iit);
  s7_define_typed_function(sc, "g_idle_add", lg_g_idle_add, 1, 1, 0, H_g_idle_add, pl_it);
  s7_define_typed_function(sc, "g_idle_add_full", lg_g_idle_add_full, 4, 0, 0, H_g_idle_add_full, pl_iit);
  s7_define_typed_function(sc, "g_idle_remove_by_data", lg_g_idle_remove_by_data, 1, 0, 0, H_g_idle_remove_by_data, pl_bt);
  s7_define_typed_function(sc, "g_source_remove", lg_g_source_remove, 1, 0, 0, H_g_source_remove, pl_bi);
  s7_define_typed_function(sc, "gtk_file_filter_new", lg_gtk_file_filter_new, 0, 0, 0, H_gtk_file_filter_new, pl_p);
  s7_define_typed_function(sc, "gtk_file_filter_set_name", lg_gtk_file_filter_set_name, 2, 0, 0, H_gtk_file_filter_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_get_name", lg_gtk_file_filter_get_name, 1, 0, 0, H_gtk_file_filter_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_file_filter_add_mime_type", lg_gtk_file_filter_add_mime_type, 2, 0, 0, H_gtk_file_filter_add_mime_type, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_add_pattern", lg_gtk_file_filter_add_pattern, 2, 0, 0, H_gtk_file_filter_add_pattern, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_add_custom", lg_gtk_file_filter_add_custom, 5, 0, 0, H_gtk_file_filter_add_custom, pl_tugt);
  s7_define_typed_function(sc, "gtk_file_filter_get_needed", lg_gtk_file_filter_get_needed, 1, 0, 0, H_gtk_file_filter_get_needed, pl_gu);
  s7_define_typed_function(sc, "gtk_file_filter_filter", lg_gtk_file_filter_filter, 2, 0, 0, H_gtk_file_filter_filter, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_layout_pack_start", lg_gtk_cell_layout_pack_start, 3, 0, 0, H_gtk_cell_layout_pack_start, pl_tuub);
  s7_define_typed_function(sc, "gtk_cell_layout_pack_end", lg_gtk_cell_layout_pack_end, 3, 0, 0, H_gtk_cell_layout_pack_end, pl_tuub);
  s7_define_typed_function(sc, "gtk_cell_layout_clear", lg_gtk_cell_layout_clear, 1, 0, 0, H_gtk_cell_layout_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_layout_set_attributes", lg_gtk_cell_layout_set_attributes, 3, 0, 0, H_gtk_cell_layout_set_attributes, pl_tuut);
  s7_define_typed_function(sc, "gtk_cell_layout_add_attribute", lg_gtk_cell_layout_add_attribute, 4, 0, 0, H_gtk_cell_layout_add_attribute, pl_tuusi);
  s7_define_typed_function(sc, "gtk_cell_layout_set_cell_data_func", lg_gtk_cell_layout_set_cell_data_func, 5, 0, 0, H_gtk_cell_layout_set_cell_data_func, pl_tuut);
  s7_define_typed_function(sc, "gtk_cell_layout_clear_attributes", lg_gtk_cell_layout_clear_attributes, 2, 0, 0, H_gtk_cell_layout_clear_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_action", lg_gtk_file_chooser_set_action, 2, 0, 0, H_gtk_file_chooser_set_action, pl_tug);
  s7_define_typed_function(sc, "gtk_file_chooser_get_action", lg_gtk_file_chooser_get_action, 1, 0, 0, H_gtk_file_chooser_get_action, pl_gu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_local_only", lg_gtk_file_chooser_set_local_only, 2, 0, 0, H_gtk_file_chooser_set_local_only, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_local_only", lg_gtk_file_chooser_get_local_only, 1, 0, 0, H_gtk_file_chooser_get_local_only, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_select_multiple", lg_gtk_file_chooser_set_select_multiple, 2, 0, 0, H_gtk_file_chooser_set_select_multiple, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_select_multiple", lg_gtk_file_chooser_get_select_multiple, 1, 0, 0, H_gtk_file_chooser_get_select_multiple, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_current_name", lg_gtk_file_chooser_set_current_name, 2, 0, 0, H_gtk_file_chooser_set_current_name, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_get_filename", lg_gtk_file_chooser_get_filename, 1, 0, 0, H_gtk_file_chooser_get_filename, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_set_filename", lg_gtk_file_chooser_set_filename, 2, 0, 0, H_gtk_file_chooser_set_filename, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_select_filename", lg_gtk_file_chooser_select_filename, 2, 0, 0, H_gtk_file_chooser_select_filename, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_filename", lg_gtk_file_chooser_unselect_filename, 2, 0, 0, H_gtk_file_chooser_unselect_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_select_all", lg_gtk_file_chooser_select_all, 1, 0, 0, H_gtk_file_chooser_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_all", lg_gtk_file_chooser_unselect_all, 1, 0, 0, H_gtk_file_chooser_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_filenames", lg_gtk_file_chooser_get_filenames, 1, 0, 0, H_gtk_file_chooser_get_filenames, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_current_folder", lg_gtk_file_chooser_set_current_folder, 2, 0, 0, H_gtk_file_chooser_set_current_folder, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_folder", lg_gtk_file_chooser_get_current_folder, 1, 0, 0, H_gtk_file_chooser_get_current_folder, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_get_uri", lg_gtk_file_chooser_get_uri, 1, 0, 0, H_gtk_file_chooser_get_uri, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_set_uri", lg_gtk_file_chooser_set_uri, 2, 0, 0, H_gtk_file_chooser_set_uri, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_select_uri", lg_gtk_file_chooser_select_uri, 2, 0, 0, H_gtk_file_chooser_select_uri, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_uri", lg_gtk_file_chooser_unselect_uri, 2, 0, 0, H_gtk_file_chooser_unselect_uri, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_get_uris", lg_gtk_file_chooser_get_uris, 1, 0, 0, H_gtk_file_chooser_get_uris, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_current_folder_uri", lg_gtk_file_chooser_set_current_folder_uri, 2, 0, 0, H_gtk_file_chooser_set_current_folder_uri, pl_bus);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_folder_uri", lg_gtk_file_chooser_get_current_folder_uri, 1, 0, 0, H_gtk_file_chooser_get_current_folder_uri, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_set_preview_widget", lg_gtk_file_chooser_set_preview_widget, 2, 0, 0, H_gtk_file_chooser_set_preview_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_preview_widget", lg_gtk_file_chooser_get_preview_widget, 1, 0, 0, H_gtk_file_chooser_get_preview_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_preview_widget_active", lg_gtk_file_chooser_set_preview_widget_active, 2, 0, 0, H_gtk_file_chooser_set_preview_widget_active, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_preview_widget_active", lg_gtk_file_chooser_get_preview_widget_active, 1, 0, 0, H_gtk_file_chooser_get_preview_widget_active, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_preview_filename", lg_gtk_file_chooser_get_preview_filename, 1, 0, 0, H_gtk_file_chooser_get_preview_filename, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_get_preview_uri", lg_gtk_file_chooser_get_preview_uri, 1, 0, 0, H_gtk_file_chooser_get_preview_uri, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_set_extra_widget", lg_gtk_file_chooser_set_extra_widget, 2, 0, 0, H_gtk_file_chooser_set_extra_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_extra_widget", lg_gtk_file_chooser_get_extra_widget, 1, 0, 0, H_gtk_file_chooser_get_extra_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_filter", lg_gtk_file_chooser_add_filter, 2, 0, 0, H_gtk_file_chooser_add_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_filter", lg_gtk_file_chooser_remove_filter, 2, 0, 0, H_gtk_file_chooser_remove_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_list_filters", lg_gtk_file_chooser_list_filters, 1, 0, 0, H_gtk_file_chooser_list_filters, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_filter", lg_gtk_file_chooser_set_filter, 2, 0, 0, H_gtk_file_chooser_set_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_filter", lg_gtk_file_chooser_get_filter, 1, 0, 0, H_gtk_file_chooser_get_filter, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_shortcut_folder", lg_gtk_file_chooser_add_shortcut_folder, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder, pl_pusu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_shortcut_folder", lg_gtk_file_chooser_remove_shortcut_folder, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder, pl_pusu);
  s7_define_typed_function(sc, "gtk_file_chooser_list_shortcut_folders", lg_gtk_file_chooser_list_shortcut_folders, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folders, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_shortcut_folder_uri", lg_gtk_file_chooser_add_shortcut_folder_uri, 2, 1, 0, H_gtk_file_chooser_add_shortcut_folder_uri, pl_pusu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_shortcut_folder_uri", lg_gtk_file_chooser_remove_shortcut_folder_uri, 2, 1, 0, H_gtk_file_chooser_remove_shortcut_folder_uri, pl_pusu);
  s7_define_typed_function(sc, "gtk_file_chooser_list_shortcut_folder_uris", lg_gtk_file_chooser_list_shortcut_folder_uris, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folder_uris, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_new", lg_gtk_icon_theme_new, 0, 0, 0, H_gtk_icon_theme_new, pl_p);
  s7_define_typed_function(sc, "gtk_icon_theme_get_default", lg_gtk_icon_theme_get_default, 0, 0, 0, H_gtk_icon_theme_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_icon_theme_get_for_screen", lg_gtk_icon_theme_get_for_screen, 1, 0, 0, H_gtk_icon_theme_get_for_screen, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_set_screen", lg_gtk_icon_theme_set_screen, 2, 0, 0, H_gtk_icon_theme_set_screen, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_theme_get_search_path", lg_gtk_icon_theme_get_search_path, 1, 2, 0, H_gtk_icon_theme_get_search_path, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_append_search_path", lg_gtk_icon_theme_append_search_path, 2, 0, 0, H_gtk_icon_theme_append_search_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_prepend_search_path", lg_gtk_icon_theme_prepend_search_path, 2, 0, 0, H_gtk_icon_theme_prepend_search_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_set_custom_theme", lg_gtk_icon_theme_set_custom_theme, 2, 0, 0, H_gtk_icon_theme_set_custom_theme, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_has_icon", lg_gtk_icon_theme_has_icon, 2, 0, 0, H_gtk_icon_theme_has_icon, pl_bus);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_icon", lg_gtk_icon_theme_lookup_icon, 4, 0, 0, H_gtk_icon_theme_lookup_icon, pl_pusig);
  s7_define_typed_function(sc, "gtk_icon_theme_load_icon", lg_gtk_icon_theme_load_icon, 4, 1, 0, H_gtk_icon_theme_load_icon, pl_pusigu);
  s7_define_typed_function(sc, "gtk_icon_theme_list_icons", lg_gtk_icon_theme_list_icons, 2, 0, 0, H_gtk_icon_theme_list_icons, pl_pus);
  s7_define_typed_function(sc, "gtk_icon_theme_get_example_icon_name", lg_gtk_icon_theme_get_example_icon_name, 1, 0, 0, H_gtk_icon_theme_get_example_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_icon_theme_rescan_if_needed", lg_gtk_icon_theme_rescan_if_needed, 1, 0, 0, H_gtk_icon_theme_rescan_if_needed, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_info_get_base_size", lg_gtk_icon_info_get_base_size, 1, 0, 0, H_gtk_icon_info_get_base_size, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_info_get_filename", lg_gtk_icon_info_get_filename, 1, 0, 0, H_gtk_icon_info_get_filename, pl_su);
  s7_define_typed_function(sc, "gtk_icon_info_load_icon", lg_gtk_icon_info_load_icon, 1, 1, 0, H_gtk_icon_info_load_icon, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_button_new", lg_gtk_tool_button_new, 2, 0, 0, H_gtk_tool_button_new, pl_pus);
  s7_define_typed_function(sc, "gtk_tool_button_set_label", lg_gtk_tool_button_set_label, 2, 0, 0, H_gtk_tool_button_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_tool_button_get_label", lg_gtk_tool_button_get_label, 1, 0, 0, H_gtk_tool_button_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_tool_button_set_use_underline", lg_gtk_tool_button_set_use_underline, 2, 0, 0, H_gtk_tool_button_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_button_get_use_underline", lg_gtk_tool_button_get_use_underline, 1, 0, 0, H_gtk_tool_button_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_button_set_icon_widget", lg_gtk_tool_button_set_icon_widget, 2, 0, 0, H_gtk_tool_button_set_icon_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_tool_button_get_icon_widget", lg_gtk_tool_button_get_icon_widget, 1, 0, 0, H_gtk_tool_button_get_icon_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_button_set_label_widget", lg_gtk_tool_button_set_label_widget, 2, 0, 0, H_gtk_tool_button_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_tool_button_get_label_widget", lg_gtk_tool_button_get_label_widget, 1, 0, 0, H_gtk_tool_button_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_item_new", lg_gtk_tool_item_new, 0, 0, 0, H_gtk_tool_item_new, pl_p);
  s7_define_typed_function(sc, "gtk_tool_item_set_homogeneous", lg_gtk_tool_item_set_homogeneous, 2, 0, 0, H_gtk_tool_item_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_get_homogeneous", lg_gtk_tool_item_get_homogeneous, 1, 0, 0, H_gtk_tool_item_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_set_expand", lg_gtk_tool_item_set_expand, 2, 0, 0, H_gtk_tool_item_set_expand, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_get_expand", lg_gtk_tool_item_get_expand, 1, 0, 0, H_gtk_tool_item_get_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_set_visible_horizontal", lg_gtk_tool_item_set_visible_horizontal, 2, 0, 0, H_gtk_tool_item_set_visible_horizontal, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_get_visible_horizontal", lg_gtk_tool_item_get_visible_horizontal, 1, 0, 0, H_gtk_tool_item_get_visible_horizontal, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_set_visible_vertical", lg_gtk_tool_item_set_visible_vertical, 2, 0, 0, H_gtk_tool_item_set_visible_vertical, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_get_visible_vertical", lg_gtk_tool_item_get_visible_vertical, 1, 0, 0, H_gtk_tool_item_get_visible_vertical, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_get_is_important", lg_gtk_tool_item_get_is_important, 1, 0, 0, H_gtk_tool_item_get_is_important, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_set_is_important", lg_gtk_tool_item_set_is_important, 2, 0, 0, H_gtk_tool_item_set_is_important, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_get_orientation", lg_gtk_tool_item_get_orientation, 1, 0, 0, H_gtk_tool_item_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_get_toolbar_style", lg_gtk_tool_item_get_toolbar_style, 1, 0, 0, H_gtk_tool_item_get_toolbar_style, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_retrieve_proxy_menu_item", lg_gtk_tool_item_retrieve_proxy_menu_item, 1, 0, 0, H_gtk_tool_item_retrieve_proxy_menu_item, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_item_get_proxy_menu_item", lg_gtk_tool_item_get_proxy_menu_item, 2, 0, 0, H_gtk_tool_item_get_proxy_menu_item, pl_pus);
  s7_define_typed_function(sc, "gtk_tool_item_set_proxy_menu_item", lg_gtk_tool_item_set_proxy_menu_item, 3, 0, 0, H_gtk_tool_item_set_proxy_menu_item, pl_tusu);
  s7_define_typed_function(sc, "gtk_list_store_remove", lg_gtk_list_store_remove, 2, 0, 0, H_gtk_list_store_remove, pl_bu);
  s7_define_typed_function(sc, "gdk_display_set_double_click_distance", lg_gdk_display_set_double_click_distance, 2, 0, 0, H_gdk_display_set_double_click_distance, pl_tui);
  s7_define_typed_function(sc, "gdk_display_get_default_group", lg_gdk_display_get_default_group, 1, 0, 0, H_gdk_display_get_default_group, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_group", lg_gdk_window_get_group, 1, 0, 0, H_gdk_window_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_layout_reorder", lg_gtk_cell_layout_reorder, 3, 0, 0, H_gtk_cell_layout_reorder, pl_tuui);
  s7_define_typed_function(sc, "gtk_clipboard_request_targets", lg_gtk_clipboard_request_targets, 2, 1, 0, H_gtk_clipboard_request_targets, pl_tut);
  s7_define_typed_function(sc, "gtk_clipboard_wait_for_targets", lg_gtk_clipboard_wait_for_targets, 1, 2, 0, H_gtk_clipboard_wait_for_targets, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_shell_cancel", lg_gtk_menu_shell_cancel, 1, 0, 0, H_gtk_menu_shell_cancel, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_get_child1", lg_gtk_paned_get_child1, 1, 0, 0, H_gtk_paned_get_child1, pl_pu);
  s7_define_typed_function(sc, "gtk_paned_get_child2", lg_gtk_paned_get_child2, 1, 0, 0, H_gtk_paned_get_child2, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_accept_focus", lg_gtk_window_set_accept_focus, 2, 0, 0, H_gtk_window_set_accept_focus, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_accept_focus", lg_gtk_window_get_accept_focus, 1, 0, 0, H_gtk_window_get_accept_focus, pl_bu);
  s7_define_typed_function(sc, "g_list_nth_data", lg_g_list_nth_data, 2, 0, 0, H_g_list_nth_data, pl_tui);
  s7_define_typed_function(sc, "gtk_accel_map_get", lg_gtk_accel_map_get, 0, 0, 0, H_gtk_accel_map_get, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_popup", lg_gtk_combo_box_popup, 1, 0, 0, H_gtk_combo_box_popup, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_popdown", lg_gtk_combo_box_popdown, 1, 0, 0, H_gtk_combo_box_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new_from_widget", lg_gtk_radio_menu_item_new_from_widget, 1, 0, 0, H_gtk_radio_menu_item_new_from_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new_with_mnemonic_from_widget", lg_gtk_radio_menu_item_new_with_mnemonic_from_widget, 2, 0, 0, H_gtk_radio_menu_item_new_with_mnemonic_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_menu_item_new_with_label_from_widget", lg_gtk_radio_menu_item_new_with_label_from_widget, 2, 0, 0, H_gtk_radio_menu_item_new_with_label_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_scale_get_layout", lg_gtk_scale_get_layout, 1, 0, 0, H_gtk_scale_get_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_get_layout_offsets", lg_gtk_scale_get_layout_offsets, 1, 2, 0, H_gtk_scale_get_layout_offsets, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_source_get_target_list", lg_gtk_drag_source_get_target_list, 1, 0, 0, H_gtk_drag_source_get_target_list, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_source_set_target_list", lg_gtk_drag_source_set_target_list, 2, 0, 0, H_gtk_drag_source_set_target_list, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_set_alignment", lg_gtk_entry_set_alignment, 2, 0, 0, H_gtk_entry_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_alignment", lg_gtk_entry_get_alignment, 1, 0, 0, H_gtk_entry_get_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_file_chooser_set_use_preview_label", lg_gtk_file_chooser_set_use_preview_label, 2, 0, 0, H_gtk_file_chooser_set_use_preview_label, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_use_preview_label", lg_gtk_file_chooser_get_use_preview_label, 1, 0, 0, H_gtk_file_chooser_get_use_preview_label, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_list_mnemonic_labels", lg_gtk_widget_list_mnemonic_labels, 1, 0, 0, H_gtk_widget_list_mnemonic_labels, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_add_mnemonic_label", lg_gtk_widget_add_mnemonic_label, 2, 0, 0, H_gtk_widget_add_mnemonic_label, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_remove_mnemonic_label", lg_gtk_widget_remove_mnemonic_label, 2, 0, 0, H_gtk_widget_remove_mnemonic_label, pl_tu);
  s7_define_typed_function(sc, "gtk_window_activate_key", lg_gtk_window_activate_key, 2, 0, 0, H_gtk_window_activate_key, pl_bu);
  s7_define_typed_function(sc, "gtk_window_propagate_key_event", lg_gtk_window_propagate_key_event, 2, 0, 0, H_gtk_window_propagate_key_event, pl_bu);
  s7_define_typed_function(sc, "g_quark_from_string", lg_g_quark_from_string, 1, 0, 0, H_g_quark_from_string, pl_is);
  s7_define_typed_function(sc, "g_quark_to_string", lg_g_quark_to_string, 1, 0, 0, H_g_quark_to_string, pl_si);
  s7_define_typed_function(sc, "gtk_cell_view_new", lg_gtk_cell_view_new, 0, 0, 0, H_gtk_cell_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_text", lg_gtk_cell_view_new_with_text, 1, 0, 0, H_gtk_cell_view_new_with_text, pl_ps);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_markup", lg_gtk_cell_view_new_with_markup, 1, 0, 0, H_gtk_cell_view_new_with_markup, pl_ps);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_pixbuf", lg_gtk_cell_view_new_with_pixbuf, 1, 0, 0, H_gtk_cell_view_new_with_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_view_set_model", lg_gtk_cell_view_set_model, 2, 0, 0, H_gtk_cell_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_view_set_displayed_row", lg_gtk_cell_view_set_displayed_row, 2, 0, 0, H_gtk_cell_view_set_displayed_row, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_view_get_displayed_row", lg_gtk_cell_view_get_displayed_row, 1, 0, 0, H_gtk_cell_view_get_displayed_row, pl_pu);
  s7_define_typed_function(sc, "gtk_combo_box_get_wrap_width", lg_gtk_combo_box_get_wrap_width, 1, 0, 0, H_gtk_combo_box_get_wrap_width, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_get_row_span_column", lg_gtk_combo_box_get_row_span_column, 1, 0, 0, H_gtk_combo_box_get_row_span_column, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_get_column_span_column", lg_gtk_combo_box_get_column_span_column, 1, 0, 0, H_gtk_combo_box_get_column_span_column, pl_iu);
  s7_define_typed_function(sc, "gtk_drag_dest_add_text_targets", lg_gtk_drag_dest_add_text_targets, 1, 0, 0, H_gtk_drag_dest_add_text_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_add_text_targets", lg_gtk_drag_source_add_text_targets, 1, 0, 0, H_gtk_drag_source_add_text_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_prefix", lg_gtk_entry_completion_insert_prefix, 1, 0, 0, H_gtk_entry_completion_insert_prefix, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_inline_completion", lg_gtk_entry_completion_set_inline_completion, 2, 0, 0, H_gtk_entry_completion_set_inline_completion, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_inline_completion", lg_gtk_entry_completion_get_inline_completion, 1, 0, 0, H_gtk_entry_completion_get_inline_completion, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_completion", lg_gtk_entry_completion_set_popup_completion, 2, 0, 0, H_gtk_entry_completion_set_popup_completion, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_completion", lg_gtk_entry_completion_get_popup_completion, 1, 0, 0, H_gtk_entry_completion_get_popup_completion, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_text_column", lg_gtk_entry_completion_get_text_column, 1, 0, 0, H_gtk_entry_completion_get_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_theme_get_icon_sizes", lg_gtk_icon_theme_get_icon_sizes, 2, 0, 0, H_gtk_icon_theme_get_icon_sizes, pl_pus);
  s7_define_typed_function(sc, "gtk_menu_get_for_attach_widget", lg_gtk_menu_get_for_attach_widget, 1, 0, 0, H_gtk_menu_get_for_attach_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_fixed_height_mode", lg_gtk_tree_view_set_fixed_height_mode, 2, 0, 0, H_gtk_tree_view_set_fixed_height_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_fixed_height_mode", lg_gtk_tree_view_get_fixed_height_mode, 1, 0, 0, H_gtk_tree_view_get_fixed_height_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_hover_selection", lg_gtk_tree_view_set_hover_selection, 2, 0, 0, H_gtk_tree_view_set_hover_selection, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_hover_selection", lg_gtk_tree_view_get_hover_selection, 1, 0, 0, H_gtk_tree_view_get_hover_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_row_separator_func", lg_gtk_tree_view_set_row_separator_func, 4, 0, 0, H_gtk_tree_view_set_row_separator_func, pl_tut);
  s7_define_typed_function(sc, "gtk_window_set_focus_on_map", lg_gtk_window_set_focus_on_map, 2, 0, 0, H_gtk_window_set_focus_on_map, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_focus_on_map", lg_gtk_window_get_focus_on_map, 1, 0, 0, H_gtk_window_get_focus_on_map, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_icon_name", lg_gtk_window_set_icon_name, 2, 0, 0, H_gtk_window_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_window_get_icon_name", lg_gtk_window_get_icon_name, 1, 0, 0, H_gtk_window_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_window_set_default_icon_name", lg_gtk_window_set_default_icon_name, 1, 0, 0, H_gtk_window_set_default_icon_name, pl_ts);
  s7_define_typed_function(sc, "gtk_about_dialog_new", lg_gtk_about_dialog_new, 0, 0, 0, H_gtk_about_dialog_new, pl_p);
  s7_define_typed_function(sc, "gtk_about_dialog_get_version", lg_gtk_about_dialog_get_version, 1, 0, 0, H_gtk_about_dialog_get_version, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_version", lg_gtk_about_dialog_set_version, 2, 0, 0, H_gtk_about_dialog_set_version, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_copyright", lg_gtk_about_dialog_get_copyright, 1, 0, 0, H_gtk_about_dialog_get_copyright, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_copyright", lg_gtk_about_dialog_set_copyright, 2, 0, 0, H_gtk_about_dialog_set_copyright, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_comments", lg_gtk_about_dialog_get_comments, 1, 0, 0, H_gtk_about_dialog_get_comments, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_comments", lg_gtk_about_dialog_set_comments, 2, 0, 0, H_gtk_about_dialog_set_comments, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_website", lg_gtk_about_dialog_get_website, 1, 0, 0, H_gtk_about_dialog_get_website, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_website", lg_gtk_about_dialog_set_website, 2, 0, 0, H_gtk_about_dialog_set_website, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_website_label", lg_gtk_about_dialog_get_website_label, 1, 0, 0, H_gtk_about_dialog_get_website_label, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_website_label", lg_gtk_about_dialog_set_website_label, 2, 0, 0, H_gtk_about_dialog_set_website_label, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_authors", lg_gtk_about_dialog_get_authors, 1, 0, 0, H_gtk_about_dialog_get_authors, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_authors", lg_gtk_about_dialog_set_authors, 2, 0, 0, H_gtk_about_dialog_set_authors, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_documenters", lg_gtk_about_dialog_get_documenters, 1, 0, 0, H_gtk_about_dialog_get_documenters, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_documenters", lg_gtk_about_dialog_set_documenters, 2, 0, 0, H_gtk_about_dialog_set_documenters, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_artists", lg_gtk_about_dialog_get_artists, 1, 0, 0, H_gtk_about_dialog_get_artists, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_artists", lg_gtk_about_dialog_set_artists, 2, 0, 0, H_gtk_about_dialog_set_artists, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_translator_credits", lg_gtk_about_dialog_get_translator_credits, 1, 0, 0, H_gtk_about_dialog_get_translator_credits, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_translator_credits", lg_gtk_about_dialog_set_translator_credits, 2, 0, 0, H_gtk_about_dialog_set_translator_credits, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_logo", lg_gtk_about_dialog_get_logo, 1, 0, 0, H_gtk_about_dialog_get_logo, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_logo", lg_gtk_about_dialog_set_logo, 2, 0, 0, H_gtk_about_dialog_set_logo, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_program_name", lg_gtk_about_dialog_get_program_name, 1, 0, 0, H_gtk_about_dialog_get_program_name, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_program_name", lg_gtk_about_dialog_set_program_name, 2, 0, 0, H_gtk_about_dialog_set_program_name, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_view_new", lg_gtk_icon_view_new, 0, 0, 0, H_gtk_icon_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_icon_view_new_with_model", lg_gtk_icon_view_new_with_model, 1, 0, 0, H_gtk_icon_view_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_model", lg_gtk_icon_view_set_model, 2, 0, 0, H_gtk_icon_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_get_model", lg_gtk_icon_view_get_model, 1, 0, 0, H_gtk_icon_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_text_column", lg_gtk_icon_view_set_text_column, 2, 0, 0, H_gtk_icon_view_set_text_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_text_column", lg_gtk_icon_view_get_text_column, 1, 0, 0, H_gtk_icon_view_get_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_markup_column", lg_gtk_icon_view_set_markup_column, 2, 0, 0, H_gtk_icon_view_set_markup_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_markup_column", lg_gtk_icon_view_get_markup_column, 1, 0, 0, H_gtk_icon_view_get_markup_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_pixbuf_column", lg_gtk_icon_view_set_pixbuf_column, 2, 0, 0, H_gtk_icon_view_set_pixbuf_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_pixbuf_column", lg_gtk_icon_view_get_pixbuf_column, 1, 0, 0, H_gtk_icon_view_get_pixbuf_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_get_path_at_pos", lg_gtk_icon_view_get_path_at_pos, 3, 0, 0, H_gtk_icon_view_get_path_at_pos, pl_pui);
  s7_define_typed_function(sc, "gtk_icon_view_selected_foreach", lg_gtk_icon_view_selected_foreach, 2, 1, 0, H_gtk_icon_view_selected_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_icon_view_set_selection_mode", lg_gtk_icon_view_set_selection_mode, 2, 0, 0, H_gtk_icon_view_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_icon_view_get_selection_mode", lg_gtk_icon_view_get_selection_mode, 1, 0, 0, H_gtk_icon_view_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_icon_view_select_path", lg_gtk_icon_view_select_path, 2, 0, 0, H_gtk_icon_view_select_path, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_unselect_path", lg_gtk_icon_view_unselect_path, 2, 0, 0, H_gtk_icon_view_unselect_path, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_path_is_selected", lg_gtk_icon_view_path_is_selected, 2, 0, 0, H_gtk_icon_view_path_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_get_selected_items", lg_gtk_icon_view_get_selected_items, 1, 0, 0, H_gtk_icon_view_get_selected_items, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_select_all", lg_gtk_icon_view_select_all, 1, 0, 0, H_gtk_icon_view_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_unselect_all", lg_gtk_icon_view_unselect_all, 1, 0, 0, H_gtk_icon_view_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_item_activated", lg_gtk_icon_view_item_activated, 2, 0, 0, H_gtk_icon_view_item_activated, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_combo_new", lg_gtk_cell_renderer_combo_new, 0, 0, 0, H_gtk_cell_renderer_combo_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_progress_new", lg_gtk_cell_renderer_progress_new, 0, 0, 0, H_gtk_cell_renderer_progress_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_set_row_separator_func", lg_gtk_combo_box_set_row_separator_func, 4, 0, 0, H_gtk_combo_box_set_row_separator_func, pl_tut);
  s7_define_typed_function(sc, "gtk_label_set_ellipsize", lg_gtk_label_set_ellipsize, 2, 0, 0, H_gtk_label_set_ellipsize, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_ellipsize", lg_gtk_label_get_ellipsize, 1, 0, 0, H_gtk_label_get_ellipsize, pl_gu);
  s7_define_typed_function(sc, "pango_attr_fallback_new", lg_pango_attr_fallback_new, 1, 0, 0, H_pango_attr_fallback_new, pl_pb);
  s7_define_typed_function(sc, "pango_attr_letter_spacing_new", lg_pango_attr_letter_spacing_new, 1, 0, 0, H_pango_attr_letter_spacing_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_list_filter", lg_pango_attr_list_filter, 3, 0, 0, H_pango_attr_list_filter, pl_put);
  s7_define_typed_function(sc, "pango_attr_iterator_get_attrs", lg_pango_attr_iterator_get_attrs, 1, 0, 0, H_pango_attr_iterator_get_attrs, pl_pu);
  s7_define_typed_function(sc, "pango_font_metrics_get_underline_position", lg_pango_font_metrics_get_underline_position, 1, 0, 0, H_pango_font_metrics_get_underline_position, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_underline_thickness", lg_pango_font_metrics_get_underline_thickness, 1, 0, 0, H_pango_font_metrics_get_underline_thickness, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_strikethrough_position", lg_pango_font_metrics_get_strikethrough_position, 1, 0, 0, H_pango_font_metrics_get_strikethrough_position, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_strikethrough_thickness", lg_pango_font_metrics_get_strikethrough_thickness, 1, 0, 0, H_pango_font_metrics_get_strikethrough_thickness, pl_iu);
  s7_define_typed_function(sc, "pango_font_family_is_monospace", lg_pango_font_family_is_monospace, 1, 0, 0, H_pango_font_family_is_monospace, pl_bu);
  s7_define_typed_function(sc, "pango_font_face_list_sizes", lg_pango_font_face_list_sizes, 1, 2, 0, H_pango_font_face_list_sizes, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_auto_dir", lg_pango_layout_set_auto_dir, 2, 0, 0, H_pango_layout_set_auto_dir, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_auto_dir", lg_pango_layout_get_auto_dir, 1, 0, 0, H_pango_layout_get_auto_dir, pl_bu);
  s7_define_typed_function(sc, "pango_script_for_unichar", lg_pango_script_for_unichar, 1, 0, 0, H_pango_script_for_unichar, pl_gi);
  s7_define_typed_function(sc, "pango_script_iter_new", lg_pango_script_iter_new, 2, 0, 0, H_pango_script_iter_new, pl_psi);
  s7_define_typed_function(sc, "pango_script_iter_get_range", lg_pango_script_iter_get_range, 1, 3, 0, H_pango_script_iter_get_range, pl_pu);
  s7_define_typed_function(sc, "pango_script_iter_next", lg_pango_script_iter_next, 1, 0, 0, H_pango_script_iter_next, pl_bu);
  s7_define_typed_function(sc, "pango_script_iter_free", lg_pango_script_iter_free, 1, 0, 0, H_pango_script_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_new_with_dialog", lg_gtk_file_chooser_button_new_with_dialog, 1, 0, 0, H_gtk_file_chooser_button_new_with_dialog, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_get_title", lg_gtk_file_chooser_button_get_title, 1, 0, 0, H_gtk_file_chooser_button_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_button_set_title", lg_gtk_file_chooser_button_set_title, 2, 0, 0, H_gtk_file_chooser_button_set_title, pl_tus);
  s7_define_typed_function(sc, "gdk_drag_drop_succeeded", lg_gdk_drag_drop_succeeded, 1, 0, 0, H_gdk_drag_drop_succeeded, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_layout_index_to_text_index", lg_gtk_entry_layout_index_to_text_index, 2, 0, 0, H_gtk_entry_layout_index_to_text_index, pl_iui);
  s7_define_typed_function(sc, "gtk_entry_text_index_to_layout_index", lg_gtk_entry_text_index_to_layout_index, 2, 0, 0, H_gtk_entry_text_index_to_layout_index, pl_iui);
  s7_define_typed_function(sc, "gtk_file_chooser_set_show_hidden", lg_gtk_file_chooser_set_show_hidden, 2, 0, 0, H_gtk_file_chooser_set_show_hidden, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_show_hidden", lg_gtk_file_chooser_get_show_hidden, 1, 0, 0, H_gtk_file_chooser_get_show_hidden, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_hover_expand", lg_gtk_tree_view_set_hover_expand, 2, 0, 0, H_gtk_tree_view_set_hover_expand, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_hover_expand", lg_gtk_tree_view_get_hover_expand, 1, 0, 0, H_gtk_tree_view_get_hover_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_rebuild_menu", lg_gtk_tool_item_rebuild_menu, 1, 0, 0, H_gtk_tool_item_rebuild_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_tool_button_new", lg_gtk_menu_tool_button_new, 2, 0, 0, H_gtk_menu_tool_button_new, pl_pus);
  s7_define_typed_function(sc, "gtk_menu_tool_button_set_menu", lg_gtk_menu_tool_button_set_menu, 2, 0, 0, H_gtk_menu_tool_button_set_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_tool_button_get_menu", lg_gtk_menu_tool_button_get_menu, 1, 0, 0, H_gtk_menu_tool_button_get_menu, pl_pu);
  s7_define_typed_function(sc, "gdk_display_supports_clipboard_persistence", lg_gdk_display_supports_clipboard_persistence, 1, 0, 0, H_gdk_display_supports_clipboard_persistence, pl_bu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_logo_icon_name", lg_gtk_about_dialog_get_logo_icon_name, 1, 0, 0, H_gtk_about_dialog_get_logo_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_logo_icon_name", lg_gtk_about_dialog_set_logo_icon_name, 2, 0, 0, H_gtk_about_dialog_set_logo_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_accelerator_get_label", lg_gtk_accelerator_get_label, 2, 0, 0, H_gtk_accelerator_get_label, pl_sig);
  s7_define_typed_function(sc, "gtk_clipboard_wait_is_target_available", lg_gtk_clipboard_wait_is_target_available, 2, 0, 0, H_gtk_clipboard_wait_is_target_available, pl_but);
  s7_define_typed_function(sc, "gtk_clipboard_set_can_store", lg_gtk_clipboard_set_can_store, 3, 0, 0, H_gtk_clipboard_set_can_store, pl_tuui);
  s7_define_typed_function(sc, "gtk_clipboard_store", lg_gtk_clipboard_store, 1, 0, 0, H_gtk_clipboard_store, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_dest_add_image_targets", lg_gtk_drag_dest_add_image_targets, 1, 0, 0, H_gtk_drag_dest_add_image_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_dest_add_uri_targets", lg_gtk_drag_dest_add_uri_targets, 1, 0, 0, H_gtk_drag_dest_add_uri_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_add_image_targets", lg_gtk_drag_source_add_image_targets, 1, 0, 0, H_gtk_drag_source_add_image_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_add_uri_targets", lg_gtk_drag_source_add_uri_targets, 1, 0, 0, H_gtk_drag_source_add_uri_targets, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_get_width_chars", lg_gtk_file_chooser_button_get_width_chars, 1, 0, 0, H_gtk_file_chooser_button_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_set_width_chars", lg_gtk_file_chooser_button_set_width_chars, 2, 0, 0, H_gtk_file_chooser_button_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_image_set_pixel_size", lg_gtk_image_set_pixel_size, 2, 0, 0, H_gtk_image_set_pixel_size, pl_tui);
  s7_define_typed_function(sc, "gtk_image_get_pixel_size", lg_gtk_image_get_pixel_size, 1, 0, 0, H_gtk_image_get_pixel_size, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_width_chars", lg_gtk_label_set_width_chars, 2, 0, 0, H_gtk_label_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_width_chars", lg_gtk_label_get_width_chars, 1, 0, 0, H_gtk_label_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_target_list_add_text_targets", lg_gtk_target_list_add_text_targets, 2, 0, 0, H_gtk_target_list_add_text_targets, pl_tui);
  s7_define_typed_function(sc, "gtk_target_list_add_image_targets", lg_gtk_target_list_add_image_targets, 3, 0, 0, H_gtk_target_list_add_image_targets, pl_tuib);
  s7_define_typed_function(sc, "gtk_target_list_add_uri_targets", lg_gtk_target_list_add_uri_targets, 2, 0, 0, H_gtk_target_list_add_uri_targets, pl_tui);
  s7_define_typed_function(sc, "gtk_selection_data_set_pixbuf", lg_gtk_selection_data_set_pixbuf, 2, 0, 0, H_gtk_selection_data_set_pixbuf, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_data_get_pixbuf", lg_gtk_selection_data_get_pixbuf, 1, 0, 0, H_gtk_selection_data_get_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_set_uris", lg_gtk_selection_data_set_uris, 2, 0, 0, H_gtk_selection_data_set_uris, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_data_get_uris", lg_gtk_selection_data_get_uris, 1, 0, 0, H_gtk_selection_data_get_uris, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_backspace", lg_gtk_text_buffer_backspace, 4, 0, 0, H_gtk_text_buffer_backspace, pl_buub);
  s7_define_typed_function(sc, "gtk_clipboard_set_image", lg_gtk_clipboard_set_image, 2, 0, 0, H_gtk_clipboard_set_image, pl_tu);
  s7_define_typed_function(sc, "gtk_clipboard_request_image", lg_gtk_clipboard_request_image, 2, 1, 0, H_gtk_clipboard_request_image, pl_tut);
  s7_define_typed_function(sc, "gtk_clipboard_wait_for_image", lg_gtk_clipboard_wait_for_image, 1, 0, 0, H_gtk_clipboard_wait_for_image, pl_pu);
  s7_define_typed_function(sc, "gtk_clipboard_wait_is_image_available", lg_gtk_clipboard_wait_is_image_available, 1, 0, 0, H_gtk_clipboard_wait_is_image_available, pl_bu);
  s7_define_typed_function(sc, "gtk_file_filter_add_pixbuf_formats", lg_gtk_file_filter_add_pixbuf_formats, 1, 0, 0, H_gtk_file_filter_add_pixbuf_formats, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_single_line_mode", lg_gtk_label_set_single_line_mode, 2, 0, 0, H_gtk_label_set_single_line_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_single_line_mode", lg_gtk_label_get_single_line_mode, 1, 0, 0, H_gtk_label_get_single_line_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_progress_bar_set_ellipsize", lg_gtk_progress_bar_set_ellipsize, 2, 0, 0, H_gtk_progress_bar_set_ellipsize, pl_tug);
  s7_define_typed_function(sc, "gtk_progress_bar_get_ellipsize", lg_gtk_progress_bar_get_ellipsize, 1, 0, 0, H_gtk_progress_bar_get_ellipsize, pl_gu);
  s7_define_typed_function(sc, "gtk_selection_data_targets_include_image", lg_gtk_selection_data_targets_include_image, 2, 0, 0, H_gtk_selection_data_targets_include_image, pl_bub);
  s7_define_typed_function(sc, "gtk_menu_set_screen", lg_gtk_menu_set_screen, 2, 0, 0, H_gtk_menu_set_screen, pl_tu);
  s7_define_typed_function(sc, "pango_attr_underline_color_new", lg_pango_attr_underline_color_new, 3, 0, 0, H_pango_attr_underline_color_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_strikethrough_color_new", lg_pango_attr_strikethrough_color_new, 3, 0, 0, H_pango_attr_strikethrough_color_new, pl_pi);
  s7_define_typed_function(sc, "pango_renderer_draw_layout", lg_pango_renderer_draw_layout, 4, 0, 0, H_pango_renderer_draw_layout, pl_tuui);
  s7_define_typed_function(sc, "pango_renderer_draw_layout_line", lg_pango_renderer_draw_layout_line, 4, 0, 0, H_pango_renderer_draw_layout_line, pl_tuui);
  s7_define_typed_function(sc, "pango_renderer_draw_glyphs", lg_pango_renderer_draw_glyphs, 5, 0, 0, H_pango_renderer_draw_glyphs, pl_tuuui);
  s7_define_typed_function(sc, "pango_renderer_draw_rectangle", lg_pango_renderer_draw_rectangle, 6, 0, 0, H_pango_renderer_draw_rectangle, pl_tugi);
  s7_define_typed_function(sc, "pango_renderer_draw_error_underline", lg_pango_renderer_draw_error_underline, 5, 0, 0, H_pango_renderer_draw_error_underline, pl_tui);
  s7_define_typed_function(sc, "pango_renderer_draw_trapezoid", lg_pango_renderer_draw_trapezoid, 0, 0, 1, H_pango_renderer_draw_trapezoid, pl_tugr);
  s7_define_typed_function(sc, "pango_renderer_draw_glyph", lg_pango_renderer_draw_glyph, 5, 0, 0, H_pango_renderer_draw_glyph, pl_tuuir);
  s7_define_typed_function(sc, "pango_renderer_activate", lg_pango_renderer_activate, 1, 0, 0, H_pango_renderer_activate, pl_tu);
  s7_define_typed_function(sc, "pango_renderer_deactivate", lg_pango_renderer_deactivate, 1, 0, 0, H_pango_renderer_deactivate, pl_tu);
  s7_define_typed_function(sc, "pango_renderer_part_changed", lg_pango_renderer_part_changed, 2, 0, 0, H_pango_renderer_part_changed, pl_tug);
  s7_define_typed_function(sc, "pango_renderer_set_color", lg_pango_renderer_set_color, 3, 0, 0, H_pango_renderer_set_color, pl_tugu);
  s7_define_typed_function(sc, "pango_renderer_get_color", lg_pango_renderer_get_color, 2, 0, 0, H_pango_renderer_get_color, pl_pug);
  s7_define_typed_function(sc, "pango_renderer_set_matrix", lg_pango_renderer_set_matrix, 2, 0, 0, H_pango_renderer_set_matrix, pl_tu);
  s7_define_typed_function(sc, "g_log_set_handler", lg_g_log_set_handler, 3, 1, 0, H_g_log_set_handler, pl_isgt);
  s7_define_typed_function(sc, "g_log_remove_handler", lg_g_log_remove_handler, 2, 0, 0, H_g_log_remove_handler, pl_tsi);
  s7_define_typed_function(sc, "gtk_cell_renderer_stop_editing", lg_gtk_cell_renderer_stop_editing, 2, 0, 0, H_gtk_cell_renderer_stop_editing, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_button_new", lg_gtk_file_chooser_button_new, 2, 0, 0, H_gtk_file_chooser_button_new, pl_psg);
  s7_define_typed_function(sc, "gtk_icon_view_set_columns", lg_gtk_icon_view_set_columns, 2, 0, 0, H_gtk_icon_view_set_columns, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_columns", lg_gtk_icon_view_get_columns, 1, 0, 0, H_gtk_icon_view_get_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_width", lg_gtk_icon_view_set_item_width, 2, 0, 0, H_gtk_icon_view_set_item_width, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_width", lg_gtk_icon_view_get_item_width, 1, 0, 0, H_gtk_icon_view_get_item_width, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_spacing", lg_gtk_icon_view_set_spacing, 2, 0, 0, H_gtk_icon_view_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_spacing", lg_gtk_icon_view_get_spacing, 1, 0, 0, H_gtk_icon_view_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_row_spacing", lg_gtk_icon_view_set_row_spacing, 2, 0, 0, H_gtk_icon_view_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_row_spacing", lg_gtk_icon_view_get_row_spacing, 1, 0, 0, H_gtk_icon_view_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_column_spacing", lg_gtk_icon_view_set_column_spacing, 2, 0, 0, H_gtk_icon_view_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_column_spacing", lg_gtk_icon_view_get_column_spacing, 1, 0, 0, H_gtk_icon_view_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_margin", lg_gtk_icon_view_set_margin, 2, 0, 0, H_gtk_icon_view_set_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_margin", lg_gtk_icon_view_get_margin, 1, 0, 0, H_gtk_icon_view_get_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_max_width_chars", lg_gtk_label_set_max_width_chars, 2, 0, 0, H_gtk_label_set_max_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_max_width_chars", lg_gtk_label_get_max_width_chars, 1, 0, 0, H_gtk_label_get_max_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_list_store_insert_with_values", lg_gtk_list_store_insert_with_values, 3, 0, 0, H_gtk_list_store_insert_with_values, pl_tuui);
  s7_define_typed_function(sc, "gtk_list_store_insert_with_valuesv", lg_gtk_list_store_insert_with_valuesv, 6, 0, 0, H_gtk_list_store_insert_with_valuesv, pl_tuuiuui);
  s7_define_typed_function(sc, "pango_attr_size_new_absolute", lg_pango_attr_size_new_absolute, 1, 0, 0, H_pango_attr_size_new_absolute, pl_pi);
  s7_define_typed_function(sc, "pango_font_description_set_absolute_size", lg_pango_font_description_set_absolute_size, 2, 0, 0, H_pango_font_description_set_absolute_size, pl_tur);
  s7_define_typed_function(sc, "pango_layout_get_font_description", lg_pango_layout_get_font_description, 1, 0, 0, H_pango_layout_get_font_description, pl_pu);
  s7_define_typed_function(sc, "gdk_cursor_new_from_name", lg_gdk_cursor_new_from_name, 2, 0, 0, H_gdk_cursor_new_from_name, pl_pus);
  s7_define_typed_function(sc, "gdk_cursor_get_image", lg_gdk_cursor_get_image, 1, 0, 0, H_gdk_cursor_get_image, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_urgency_hint", lg_gdk_window_set_urgency_hint, 2, 0, 0, H_gdk_window_set_urgency_hint, pl_tub);
  s7_define_typed_function(sc, "gtk_dialog_get_response_for_widget", lg_gtk_dialog_get_response_for_widget, 2, 0, 0, H_gtk_dialog_get_response_for_widget, pl_iu);
  s7_define_typed_function(sc, "gtk_drag_source_set_icon_name", lg_gtk_drag_source_set_icon_name, 2, 0, 0, H_gtk_drag_source_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_drag_set_icon_name", lg_gtk_drag_set_icon_name, 4, 0, 0, H_gtk_drag_set_icon_name, pl_tusi);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_set_width", lg_gtk_entry_completion_set_popup_set_width, 2, 0, 0, H_gtk_entry_completion_set_popup_set_width, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_set_width", lg_gtk_entry_completion_get_popup_set_width, 1, 0, 0, H_gtk_entry_completion_get_popup_set_width, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_single_match", lg_gtk_entry_completion_set_popup_single_match, 2, 0, 0, H_gtk_entry_completion_set_popup_single_match, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_single_match", lg_gtk_entry_completion_get_popup_single_match, 1, 0, 0, H_gtk_entry_completion_get_popup_single_match, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_at_pos", lg_gtk_icon_view_get_item_at_pos, 3, 2, 0, H_gtk_icon_view_get_item_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_icon_view_get_visible_range", lg_gtk_icon_view_get_visible_range, 1, 2, 0, H_gtk_icon_view_get_visible_range, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_cursor", lg_gtk_icon_view_set_cursor, 4, 0, 0, H_gtk_icon_view_set_cursor, pl_tuuub);
  s7_define_typed_function(sc, "gtk_icon_view_get_cursor", lg_gtk_icon_view_get_cursor, 1, 2, 0, H_gtk_icon_view_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_scroll_to_path", lg_gtk_icon_view_scroll_to_path, 5, 0, 0, H_gtk_icon_view_scroll_to_path, pl_tuubr);
  s7_define_typed_function(sc, "gtk_icon_view_enable_model_drag_source", lg_gtk_icon_view_enable_model_drag_source, 5, 0, 0, H_gtk_icon_view_enable_model_drag_source, pl_tuguig);
  s7_define_typed_function(sc, "gtk_icon_view_enable_model_drag_dest", lg_gtk_icon_view_enable_model_drag_dest, 4, 0, 0, H_gtk_icon_view_enable_model_drag_dest, pl_tuuig);
  s7_define_typed_function(sc, "gtk_icon_view_unset_model_drag_source", lg_gtk_icon_view_unset_model_drag_source, 1, 0, 0, H_gtk_icon_view_unset_model_drag_source, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_unset_model_drag_dest", lg_gtk_icon_view_unset_model_drag_dest, 1, 0, 0, H_gtk_icon_view_unset_model_drag_dest, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_set_reorderable", lg_gtk_icon_view_set_reorderable, 2, 0, 0, H_gtk_icon_view_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_reorderable", lg_gtk_icon_view_get_reorderable, 1, 0, 0, H_gtk_icon_view_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_drag_dest_item", lg_gtk_icon_view_set_drag_dest_item, 3, 0, 0, H_gtk_icon_view_set_drag_dest_item, pl_tuug);
  s7_define_typed_function(sc, "gtk_icon_view_get_drag_dest_item", lg_gtk_icon_view_get_drag_dest_item, 1, 2, 0, H_gtk_icon_view_get_drag_dest_item, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_get_dest_item_at_pos", lg_gtk_icon_view_get_dest_item_at_pos, 3, 2, 0, H_gtk_icon_view_get_dest_item_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_image_clear", lg_gtk_image_clear, 1, 0, 0, H_gtk_image_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_bar_get_pack_direction", lg_gtk_menu_bar_get_pack_direction, 1, 0, 0, H_gtk_menu_bar_get_pack_direction, pl_gu);
  s7_define_typed_function(sc, "gtk_menu_bar_set_pack_direction", lg_gtk_menu_bar_set_pack_direction, 2, 0, 0, H_gtk_menu_bar_set_pack_direction, pl_tug);
  s7_define_typed_function(sc, "gtk_menu_bar_get_child_pack_direction", lg_gtk_menu_bar_get_child_pack_direction, 1, 0, 0, H_gtk_menu_bar_get_child_pack_direction, pl_gu);
  s7_define_typed_function(sc, "gtk_menu_bar_set_child_pack_direction", lg_gtk_menu_bar_set_child_pack_direction, 2, 0, 0, H_gtk_menu_bar_set_child_pack_direction, pl_tug);
  s7_define_typed_function(sc, "gtk_menu_shell_get_take_focus", lg_gtk_menu_shell_get_take_focus, 1, 0, 0, H_gtk_menu_shell_get_take_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_menu_shell_set_take_focus", lg_gtk_menu_shell_set_take_focus, 2, 0, 0, H_gtk_menu_shell_set_take_focus, pl_tub);
  s7_define_typed_function(sc, "gtk_text_iter_forward_visible_line", lg_gtk_text_iter_forward_visible_line, 1, 0, 0, H_gtk_text_iter_forward_visible_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_visible_line", lg_gtk_text_iter_backward_visible_line, 1, 0, 0, H_gtk_text_iter_backward_visible_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_visible_lines", lg_gtk_text_iter_forward_visible_lines, 2, 0, 0, H_gtk_text_iter_forward_visible_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_visible_lines", lg_gtk_text_iter_backward_visible_lines, 2, 0, 0, H_gtk_text_iter_backward_visible_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_tool_button_set_icon_name", lg_gtk_tool_button_set_icon_name, 2, 0, 0, H_gtk_tool_button_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_tool_button_get_icon_name", lg_gtk_tool_button_get_icon_name, 1, 0, 0, H_gtk_tool_button_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_window_set_urgency_hint", lg_gtk_window_set_urgency_hint, 2, 0, 0, H_gtk_window_set_urgency_hint, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_urgency_hint", lg_gtk_window_get_urgency_hint, 1, 0, 0, H_gtk_window_get_urgency_hint, pl_bu);
  s7_define_typed_function(sc, "gtk_window_present_with_time", lg_gtk_window_present_with_time, 2, 0, 0, H_gtk_window_present_with_time, pl_tui);
  s7_define_typed_function(sc, "gtk_file_chooser_set_do_overwrite_confirmation", lg_gtk_file_chooser_set_do_overwrite_confirmation, 2, 0, 0, H_gtk_file_chooser_set_do_overwrite_confirmation, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_do_overwrite_confirmation", lg_gtk_file_chooser_get_do_overwrite_confirmation, 1, 0, 0, H_gtk_file_chooser_get_do_overwrite_confirmation, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_get_model", lg_gtk_tree_row_reference_get_model, 1, 0, 0, H_gtk_tree_row_reference_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_queue_resize", lg_gtk_tree_view_column_queue_resize, 1, 0, 0, H_gtk_tree_view_column_queue_resize, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_visible_range", lg_gtk_tree_view_get_visible_range, 1, 2, 0, H_gtk_tree_view_get_visible_range, pl_pu);
  s7_define_typed_function(sc, "gtk_text_attributes_ref", lg_gtk_text_attributes_ref, 1, 0, 0, H_gtk_text_attributes_ref, pl_pu);
  s7_define_typed_function(sc, "pango_attr_list_ref", lg_pango_attr_list_ref, 1, 0, 0, H_pango_attr_list_ref, pl_pu);
  s7_define_typed_function(sc, "pango_layout_line_ref", lg_pango_layout_line_ref, 1, 0, 0, H_pango_layout_line_ref, pl_pu);
  s7_define_typed_function(sc, "pango_layout_index_to_line_x", lg_pango_layout_index_to_line_x, 3, 2, 0, H_pango_layout_index_to_line_x, pl_puibu);
  s7_define_typed_function(sc, "gtk_target_list_ref", lg_gtk_target_list_ref, 1, 0, 0, H_gtk_target_list_ref, pl_pu);
  s7_define_typed_function(sc, "gdk_display_supports_shapes", lg_gdk_display_supports_shapes, 1, 0, 0, H_gdk_display_supports_shapes, pl_bu);
  s7_define_typed_function(sc, "gdk_display_supports_input_shapes", lg_gdk_display_supports_input_shapes, 1, 0, 0, H_gdk_display_supports_input_shapes, pl_bu);
  s7_define_typed_function(sc, "gdk_screen_set_resolution", lg_gdk_screen_set_resolution, 2, 0, 0, H_gdk_screen_set_resolution, pl_tur);
  s7_define_typed_function(sc, "gdk_screen_get_resolution", lg_gdk_screen_get_resolution, 1, 0, 0, H_gdk_screen_get_resolution, pl_du);
  s7_define_typed_function(sc, "gdk_window_get_type_hint", lg_gdk_window_get_type_hint, 1, 0, 0, H_gdk_window_get_type_hint, pl_gu);
  s7_define_typed_function(sc, "gtk_clipboard_request_rich_text", lg_gtk_clipboard_request_rich_text, 3, 1, 0, H_gtk_clipboard_request_rich_text, pl_tuut);
  s7_define_typed_function(sc, "gtk_clipboard_wait_for_rich_text", lg_gtk_clipboard_wait_for_rich_text, 3, 1, 0, H_gtk_clipboard_wait_for_rich_text, pl_pu);
  s7_define_typed_function(sc, "gtk_clipboard_wait_is_rich_text_available", lg_gtk_clipboard_wait_is_rich_text_available, 2, 0, 0, H_gtk_clipboard_wait_is_rich_text_available, pl_bu);
  s7_define_typed_function(sc, "gtk_drag_dest_set_track_motion", lg_gtk_drag_dest_set_track_motion, 2, 0, 0, H_gtk_drag_dest_set_track_motion, pl_tub);
  s7_define_typed_function(sc, "gtk_drag_dest_get_track_motion", lg_gtk_drag_dest_get_track_motion, 1, 0, 0, H_gtk_drag_dest_get_track_motion, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_reorderable", lg_gtk_notebook_get_tab_reorderable, 2, 0, 0, H_gtk_notebook_get_tab_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_reorderable", lg_gtk_notebook_set_tab_reorderable, 3, 0, 0, H_gtk_notebook_set_tab_reorderable, pl_tuub);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_detachable", lg_gtk_notebook_get_tab_detachable, 2, 0, 0, H_gtk_notebook_get_tab_detachable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_detachable", lg_gtk_notebook_set_tab_detachable, 3, 0, 0, H_gtk_notebook_set_tab_detachable, pl_tuub);
  s7_define_typed_function(sc, "gtk_range_set_lower_stepper_sensitivity", lg_gtk_range_set_lower_stepper_sensitivity, 2, 0, 0, H_gtk_range_set_lower_stepper_sensitivity, pl_tug);
  s7_define_typed_function(sc, "gtk_range_get_lower_stepper_sensitivity", lg_gtk_range_get_lower_stepper_sensitivity, 1, 0, 0, H_gtk_range_get_lower_stepper_sensitivity, pl_gu);
  s7_define_typed_function(sc, "gtk_range_set_upper_stepper_sensitivity", lg_gtk_range_set_upper_stepper_sensitivity, 2, 0, 0, H_gtk_range_set_upper_stepper_sensitivity, pl_tug);
  s7_define_typed_function(sc, "gtk_range_get_upper_stepper_sensitivity", lg_gtk_range_get_upper_stepper_sensitivity, 1, 0, 0, H_gtk_range_get_upper_stepper_sensitivity, pl_gu);
  s7_define_typed_function(sc, "gtk_scrolled_window_unset_placement", lg_gtk_scrolled_window_unset_placement, 1, 0, 0, H_gtk_scrolled_window_unset_placement, pl_tu);
  s7_define_typed_function(sc, "gtk_target_list_add_rich_text_targets", lg_gtk_target_list_add_rich_text_targets, 4, 0, 0, H_gtk_target_list_add_rich_text_targets, pl_tuibu);
  s7_define_typed_function(sc, "gtk_target_table_new_from_list", lg_gtk_target_table_new_from_list, 1, 1, 0, H_gtk_target_table_new_from_list, pl_pu);
  s7_define_typed_function(sc, "gtk_target_table_free", lg_gtk_target_table_free, 2, 0, 0, H_gtk_target_table_free, pl_tui);
  s7_define_typed_function(sc, "gtk_selection_data_targets_include_rich_text", lg_gtk_selection_data_targets_include_rich_text, 2, 0, 0, H_gtk_selection_data_targets_include_rich_text, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_data_targets_include_uri", lg_gtk_selection_data_targets_include_uri, 1, 0, 0, H_gtk_selection_data_targets_include_uri, pl_bu);
  s7_define_typed_function(sc, "gtk_targets_include_text", lg_gtk_targets_include_text, 2, 0, 0, H_gtk_targets_include_text, pl_bui);
  s7_define_typed_function(sc, "gtk_targets_include_rich_text", lg_gtk_targets_include_rich_text, 3, 0, 0, H_gtk_targets_include_rich_text, pl_buiu);
  s7_define_typed_function(sc, "gtk_targets_include_image", lg_gtk_targets_include_image, 3, 0, 0, H_gtk_targets_include_image, pl_buib);
  s7_define_typed_function(sc, "gtk_targets_include_uri", lg_gtk_targets_include_uri, 2, 0, 0, H_gtk_targets_include_uri, pl_bui);
  s7_define_typed_function(sc, "gtk_size_group_get_widgets", lg_gtk_size_group_get_widgets, 1, 0, 0, H_gtk_size_group_get_widgets, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_has_selection", lg_gtk_text_buffer_get_has_selection, 1, 0, 0, H_gtk_text_buffer_get_has_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_copy_target_list", lg_gtk_text_buffer_get_copy_target_list, 1, 0, 0, H_gtk_text_buffer_get_copy_target_list, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_paste_target_list", lg_gtk_text_buffer_get_paste_target_list, 1, 0, 0, H_gtk_text_buffer_get_paste_target_list, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_headers_clickable", lg_gtk_tree_view_get_headers_clickable, 1, 0, 0, H_gtk_tree_view_get_headers_clickable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_entry", lg_gtk_tree_view_get_search_entry, 1, 0, 0, H_gtk_tree_view_get_search_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_entry", lg_gtk_tree_view_set_search_entry, 2, 0, 0, H_gtk_tree_view_set_search_entry, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_position_func", lg_gtk_tree_view_get_search_position_func, 1, 0, 0, H_gtk_tree_view_get_search_position_func, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_position_func", lg_gtk_tree_view_set_search_position_func, 3, 1, 0, H_gtk_tree_view_set_search_position_func, pl_tut);
  s7_define_typed_function(sc, "gtk_window_set_deletable", lg_gtk_window_set_deletable, 2, 0, 0, H_gtk_window_set_deletable, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_deletable", lg_gtk_window_get_deletable, 1, 0, 0, H_gtk_window_get_deletable, pl_bu);
  s7_define_typed_function(sc, "gtk_assistant_new", lg_gtk_assistant_new, 0, 0, 0, H_gtk_assistant_new, pl_p);
  s7_define_typed_function(sc, "gtk_assistant_get_current_page", lg_gtk_assistant_get_current_page, 1, 0, 0, H_gtk_assistant_get_current_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_set_current_page", lg_gtk_assistant_set_current_page, 2, 0, 0, H_gtk_assistant_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_assistant_get_n_pages", lg_gtk_assistant_get_n_pages, 1, 0, 0, H_gtk_assistant_get_n_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_get_nth_page", lg_gtk_assistant_get_nth_page, 2, 0, 0, H_gtk_assistant_get_nth_page, pl_pui);
  s7_define_typed_function(sc, "gtk_assistant_prepend_page", lg_gtk_assistant_prepend_page, 2, 0, 0, H_gtk_assistant_prepend_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_append_page", lg_gtk_assistant_append_page, 2, 0, 0, H_gtk_assistant_append_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_insert_page", lg_gtk_assistant_insert_page, 3, 0, 0, H_gtk_assistant_insert_page, pl_iuui);
  s7_define_typed_function(sc, "gtk_assistant_set_forward_page_func", lg_gtk_assistant_set_forward_page_func, 3, 1, 0, H_gtk_assistant_set_forward_page_func, pl_tut);
  s7_define_typed_function(sc, "gtk_assistant_set_page_type", lg_gtk_assistant_set_page_type, 3, 0, 0, H_gtk_assistant_set_page_type, pl_tuug);
  s7_define_typed_function(sc, "gtk_assistant_get_page_type", lg_gtk_assistant_get_page_type, 2, 0, 0, H_gtk_assistant_get_page_type, pl_gu);
  s7_define_typed_function(sc, "gtk_assistant_set_page_title", lg_gtk_assistant_set_page_title, 3, 0, 0, H_gtk_assistant_set_page_title, pl_tuus);
  s7_define_typed_function(sc, "gtk_assistant_get_page_title", lg_gtk_assistant_get_page_title, 2, 0, 0, H_gtk_assistant_get_page_title, pl_su);
  s7_define_typed_function(sc, "gtk_assistant_set_page_complete", lg_gtk_assistant_set_page_complete, 3, 0, 0, H_gtk_assistant_set_page_complete, pl_tuub);
  s7_define_typed_function(sc, "gtk_assistant_get_page_complete", lg_gtk_assistant_get_page_complete, 2, 0, 0, H_gtk_assistant_get_page_complete, pl_bu);
  s7_define_typed_function(sc, "gtk_assistant_add_action_widget", lg_gtk_assistant_add_action_widget, 2, 0, 0, H_gtk_assistant_add_action_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_remove_action_widget", lg_gtk_assistant_remove_action_widget, 2, 0, 0, H_gtk_assistant_remove_action_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_update_buttons_state", lg_gtk_assistant_update_buttons_state, 1, 0, 0, H_gtk_assistant_update_buttons_state, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_accel_new", lg_gtk_cell_renderer_accel_new, 0, 0, 0, H_gtk_cell_renderer_accel_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_spin_new", lg_gtk_cell_renderer_spin_new, 0, 0, 0, H_gtk_cell_renderer_spin_new, pl_p);
  s7_define_typed_function(sc, "gtk_link_button_new", lg_gtk_link_button_new, 1, 0, 0, H_gtk_link_button_new, pl_ps);
  s7_define_typed_function(sc, "gtk_link_button_new_with_label", lg_gtk_link_button_new_with_label, 2, 0, 0, H_gtk_link_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_link_button_get_uri", lg_gtk_link_button_get_uri, 1, 0, 0, H_gtk_link_button_get_uri, pl_su);
  s7_define_typed_function(sc, "gtk_link_button_set_uri", lg_gtk_link_button_set_uri, 2, 0, 0, H_gtk_link_button_set_uri, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_chooser_error_quark", lg_gtk_recent_chooser_error_quark, 0, 0, 0, H_gtk_recent_chooser_error_quark, pl_i);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_show_private", lg_gtk_recent_chooser_set_show_private, 2, 0, 0, H_gtk_recent_chooser_set_show_private, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_show_private", lg_gtk_recent_chooser_get_show_private, 1, 0, 0, H_gtk_recent_chooser_get_show_private, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_show_not_found", lg_gtk_recent_chooser_set_show_not_found, 2, 0, 0, H_gtk_recent_chooser_set_show_not_found, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_show_not_found", lg_gtk_recent_chooser_get_show_not_found, 1, 0, 0, H_gtk_recent_chooser_get_show_not_found, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_select_multiple", lg_gtk_recent_chooser_set_select_multiple, 2, 0, 0, H_gtk_recent_chooser_set_select_multiple, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_select_multiple", lg_gtk_recent_chooser_get_select_multiple, 1, 0, 0, H_gtk_recent_chooser_get_select_multiple, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_limit", lg_gtk_recent_chooser_set_limit, 2, 0, 0, H_gtk_recent_chooser_set_limit, pl_tui);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_limit", lg_gtk_recent_chooser_get_limit, 1, 0, 0, H_gtk_recent_chooser_get_limit, pl_iu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_local_only", lg_gtk_recent_chooser_set_local_only, 2, 0, 0, H_gtk_recent_chooser_set_local_only, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_local_only", lg_gtk_recent_chooser_get_local_only, 1, 0, 0, H_gtk_recent_chooser_get_local_only, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_show_tips", lg_gtk_recent_chooser_set_show_tips, 2, 0, 0, H_gtk_recent_chooser_set_show_tips, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_show_tips", lg_gtk_recent_chooser_get_show_tips, 1, 0, 0, H_gtk_recent_chooser_get_show_tips, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_show_icons", lg_gtk_recent_chooser_set_show_icons, 2, 0, 0, H_gtk_recent_chooser_set_show_icons, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_show_icons", lg_gtk_recent_chooser_get_show_icons, 1, 0, 0, H_gtk_recent_chooser_get_show_icons, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_sort_type", lg_gtk_recent_chooser_set_sort_type, 2, 0, 0, H_gtk_recent_chooser_set_sort_type, pl_tug);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_sort_type", lg_gtk_recent_chooser_get_sort_type, 1, 0, 0, H_gtk_recent_chooser_get_sort_type, pl_gu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_sort_func", lg_gtk_recent_chooser_set_sort_func, 3, 1, 0, H_gtk_recent_chooser_set_sort_func, pl_tut);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_current_uri", lg_gtk_recent_chooser_set_current_uri, 2, 1, 0, H_gtk_recent_chooser_set_current_uri, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_current_uri", lg_gtk_recent_chooser_get_current_uri, 1, 0, 0, H_gtk_recent_chooser_get_current_uri, pl_su);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_current_item", lg_gtk_recent_chooser_get_current_item, 1, 0, 0, H_gtk_recent_chooser_get_current_item, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_select_uri", lg_gtk_recent_chooser_select_uri, 2, 1, 0, H_gtk_recent_chooser_select_uri, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_chooser_unselect_uri", lg_gtk_recent_chooser_unselect_uri, 2, 0, 0, H_gtk_recent_chooser_unselect_uri, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_chooser_select_all", lg_gtk_recent_chooser_select_all, 1, 0, 0, H_gtk_recent_chooser_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_chooser_unselect_all", lg_gtk_recent_chooser_unselect_all, 1, 0, 0, H_gtk_recent_chooser_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_items", lg_gtk_recent_chooser_get_items, 1, 0, 0, H_gtk_recent_chooser_get_items, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_uris", lg_gtk_recent_chooser_get_uris, 1, 1, 0, H_gtk_recent_chooser_get_uris, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_add_filter", lg_gtk_recent_chooser_add_filter, 2, 0, 0, H_gtk_recent_chooser_add_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_chooser_remove_filter", lg_gtk_recent_chooser_remove_filter, 2, 0, 0, H_gtk_recent_chooser_remove_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_chooser_list_filters", lg_gtk_recent_chooser_list_filters, 1, 0, 0, H_gtk_recent_chooser_list_filters, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_set_filter", lg_gtk_recent_chooser_set_filter, 2, 0, 0, H_gtk_recent_chooser_set_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_chooser_get_filter", lg_gtk_recent_chooser_get_filter, 1, 0, 0, H_gtk_recent_chooser_get_filter, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_menu_new", lg_gtk_recent_chooser_menu_new, 0, 0, 0, H_gtk_recent_chooser_menu_new, pl_p);
  s7_define_typed_function(sc, "gtk_recent_chooser_menu_new_for_manager", lg_gtk_recent_chooser_menu_new_for_manager, 1, 0, 0, H_gtk_recent_chooser_menu_new_for_manager, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_chooser_menu_get_show_numbers", lg_gtk_recent_chooser_menu_get_show_numbers, 1, 0, 0, H_gtk_recent_chooser_menu_get_show_numbers, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_chooser_menu_set_show_numbers", lg_gtk_recent_chooser_menu_set_show_numbers, 2, 0, 0, H_gtk_recent_chooser_menu_set_show_numbers, pl_tub);
  s7_define_typed_function(sc, "gtk_recent_chooser_widget_new", lg_gtk_recent_chooser_widget_new, 0, 0, 0, H_gtk_recent_chooser_widget_new, pl_p);
  s7_define_typed_function(sc, "gtk_recent_chooser_widget_new_for_manager", lg_gtk_recent_chooser_widget_new_for_manager, 1, 0, 0, H_gtk_recent_chooser_widget_new_for_manager, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_filter_new", lg_gtk_recent_filter_new, 0, 0, 0, H_gtk_recent_filter_new, pl_p);
  s7_define_typed_function(sc, "gtk_recent_filter_set_name", lg_gtk_recent_filter_set_name, 2, 0, 0, H_gtk_recent_filter_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_filter_get_name", lg_gtk_recent_filter_get_name, 1, 0, 0, H_gtk_recent_filter_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_recent_filter_add_mime_type", lg_gtk_recent_filter_add_mime_type, 2, 0, 0, H_gtk_recent_filter_add_mime_type, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_filter_add_pattern", lg_gtk_recent_filter_add_pattern, 2, 0, 0, H_gtk_recent_filter_add_pattern, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_filter_add_pixbuf_formats", lg_gtk_recent_filter_add_pixbuf_formats, 1, 0, 0, H_gtk_recent_filter_add_pixbuf_formats, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_filter_add_application", lg_gtk_recent_filter_add_application, 2, 0, 0, H_gtk_recent_filter_add_application, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_filter_add_group", lg_gtk_recent_filter_add_group, 2, 0, 0, H_gtk_recent_filter_add_group, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_filter_add_age", lg_gtk_recent_filter_add_age, 2, 0, 0, H_gtk_recent_filter_add_age, pl_tui);
  s7_define_typed_function(sc, "gtk_recent_manager_error_quark", lg_gtk_recent_manager_error_quark, 0, 0, 0, H_gtk_recent_manager_error_quark, pl_i);
  s7_define_typed_function(sc, "gtk_recent_manager_new", lg_gtk_recent_manager_new, 0, 0, 0, H_gtk_recent_manager_new, pl_p);
  s7_define_typed_function(sc, "gtk_recent_manager_get_default", lg_gtk_recent_manager_get_default, 0, 0, 0, H_gtk_recent_manager_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_recent_manager_remove_item", lg_gtk_recent_manager_remove_item, 2, 1, 0, H_gtk_recent_manager_remove_item, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_manager_lookup_item", lg_gtk_recent_manager_lookup_item, 2, 1, 0, H_gtk_recent_manager_lookup_item, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_manager_has_item", lg_gtk_recent_manager_has_item, 2, 0, 0, H_gtk_recent_manager_has_item, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_manager_move_item", lg_gtk_recent_manager_move_item, 3, 1, 0, H_gtk_recent_manager_move_item, pl_pussu);
  s7_define_typed_function(sc, "gtk_recent_manager_get_items", lg_gtk_recent_manager_get_items, 1, 0, 0, H_gtk_recent_manager_get_items, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_manager_purge_items", lg_gtk_recent_manager_purge_items, 1, 1, 0, H_gtk_recent_manager_purge_items, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_ref", lg_gtk_recent_info_ref, 1, 0, 0, H_gtk_recent_info_ref, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_unref", lg_gtk_recent_info_unref, 1, 0, 0, H_gtk_recent_info_unref, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_uri", lg_gtk_recent_info_get_uri, 1, 0, 0, H_gtk_recent_info_get_uri, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_display_name", lg_gtk_recent_info_get_display_name, 1, 0, 0, H_gtk_recent_info_get_display_name, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_description", lg_gtk_recent_info_get_description, 1, 0, 0, H_gtk_recent_info_get_description, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_mime_type", lg_gtk_recent_info_get_mime_type, 1, 0, 0, H_gtk_recent_info_get_mime_type, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_added", lg_gtk_recent_info_get_added, 1, 0, 0, H_gtk_recent_info_get_added, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_modified", lg_gtk_recent_info_get_modified, 1, 0, 0, H_gtk_recent_info_get_modified, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_visited", lg_gtk_recent_info_get_visited, 1, 0, 0, H_gtk_recent_info_get_visited, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_private_hint", lg_gtk_recent_info_get_private_hint, 1, 0, 0, H_gtk_recent_info_get_private_hint, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_get_applications", lg_gtk_recent_info_get_applications, 1, 1, 0, H_gtk_recent_info_get_applications, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_last_application", lg_gtk_recent_info_last_application, 1, 0, 0, H_gtk_recent_info_last_application, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_has_application", lg_gtk_recent_info_has_application, 2, 0, 0, H_gtk_recent_info_has_application, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_info_get_groups", lg_gtk_recent_info_get_groups, 1, 1, 0, H_gtk_recent_info_get_groups, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_has_group", lg_gtk_recent_info_has_group, 2, 0, 0, H_gtk_recent_info_has_group, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_info_get_icon", lg_gtk_recent_info_get_icon, 2, 0, 0, H_gtk_recent_info_get_icon, pl_pui);
  s7_define_typed_function(sc, "gtk_recent_info_get_short_name", lg_gtk_recent_info_get_short_name, 1, 0, 0, H_gtk_recent_info_get_short_name, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_uri_display", lg_gtk_recent_info_get_uri_display, 1, 0, 0, H_gtk_recent_info_get_uri_display, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_age", lg_gtk_recent_info_get_age, 1, 0, 0, H_gtk_recent_info_get_age, pl_iu);
  s7_define_typed_function(sc, "gtk_recent_info_is_local", lg_gtk_recent_info_is_local, 1, 0, 0, H_gtk_recent_info_is_local, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_exists", lg_gtk_recent_info_exists, 1, 0, 0, H_gtk_recent_info_exists, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_match", lg_gtk_recent_info_match, 2, 0, 0, H_gtk_recent_info_match, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_register_serialize_format", lg_gtk_text_buffer_register_serialize_format, 5, 0, 0, H_gtk_text_buffer_register_serialize_format, pl_tust);
  s7_define_typed_function(sc, "gtk_text_buffer_register_serialize_tagset", lg_gtk_text_buffer_register_serialize_tagset, 2, 0, 0, H_gtk_text_buffer_register_serialize_tagset, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_register_deserialize_format", lg_gtk_text_buffer_register_deserialize_format, 5, 0, 0, H_gtk_text_buffer_register_deserialize_format, pl_tust);
  s7_define_typed_function(sc, "gtk_text_buffer_register_deserialize_tagset", lg_gtk_text_buffer_register_deserialize_tagset, 2, 0, 0, H_gtk_text_buffer_register_deserialize_tagset, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_unregister_serialize_format", lg_gtk_text_buffer_unregister_serialize_format, 2, 0, 0, H_gtk_text_buffer_unregister_serialize_format, pl_tut);
  s7_define_typed_function(sc, "gtk_text_buffer_unregister_deserialize_format", lg_gtk_text_buffer_unregister_deserialize_format, 2, 0, 0, H_gtk_text_buffer_unregister_deserialize_format, pl_tut);
  s7_define_typed_function(sc, "gtk_text_buffer_deserialize_set_can_create_tags", lg_gtk_text_buffer_deserialize_set_can_create_tags, 3, 0, 0, H_gtk_text_buffer_deserialize_set_can_create_tags, pl_tutb);
  s7_define_typed_function(sc, "gtk_text_buffer_deserialize_get_can_create_tags", lg_gtk_text_buffer_deserialize_get_can_create_tags, 2, 0, 0, H_gtk_text_buffer_deserialize_get_can_create_tags, pl_but);
  s7_define_typed_function(sc, "gtk_text_buffer_get_serialize_formats", lg_gtk_text_buffer_get_serialize_formats, 1, 1, 0, H_gtk_text_buffer_get_serialize_formats, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_deserialize_formats", lg_gtk_text_buffer_get_deserialize_formats, 1, 1, 0, H_gtk_text_buffer_get_deserialize_formats, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_serialize", lg_gtk_text_buffer_serialize, 5, 1, 0, H_gtk_text_buffer_serialize, pl_puutu);
  s7_define_typed_function(sc, "gtk_text_buffer_deserialize", lg_gtk_text_buffer_deserialize, 6, 1, 0, H_gtk_text_buffer_deserialize, pl_puutuuiu);
  s7_define_typed_function(sc, "gtk_recent_manager_add_item", lg_gtk_recent_manager_add_item, 2, 0, 0, H_gtk_recent_manager_add_item, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_manager_add_full", lg_gtk_recent_manager_add_full, 3, 0, 0, H_gtk_recent_manager_add_full, pl_busu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", lg_gtk_tree_model_filter_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_child_iter_to_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_grid_lines", lg_gtk_tree_view_get_grid_lines, 1, 0, 0, H_gtk_tree_view_get_grid_lines, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_set_grid_lines", lg_gtk_tree_view_set_grid_lines, 2, 0, 0, H_gtk_tree_view_set_grid_lines, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_get_enable_tree_lines", lg_gtk_tree_view_get_enable_tree_lines, 1, 0, 0, H_gtk_tree_view_get_enable_tree_lines, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_enable_tree_lines", lg_gtk_tree_view_set_enable_tree_lines, 2, 0, 0, H_gtk_tree_view_set_enable_tree_lines, pl_tub);
  s7_define_typed_function(sc, "gtk_label_set_line_wrap_mode", lg_gtk_label_set_line_wrap_mode, 2, 0, 0, H_gtk_label_set_line_wrap_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_line_wrap_mode", lg_gtk_label_get_line_wrap_mode, 1, 0, 0, H_gtk_label_get_line_wrap_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_print_context_get_cairo_context", lg_gtk_print_context_get_cairo_context, 1, 0, 0, H_gtk_print_context_get_cairo_context, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_get_page_setup", lg_gtk_print_context_get_page_setup, 1, 0, 0, H_gtk_print_context_get_page_setup, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_get_width", lg_gtk_print_context_get_width, 1, 0, 0, H_gtk_print_context_get_width, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_height", lg_gtk_print_context_get_height, 1, 0, 0, H_gtk_print_context_get_height, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_dpi_x", lg_gtk_print_context_get_dpi_x, 1, 0, 0, H_gtk_print_context_get_dpi_x, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_dpi_y", lg_gtk_print_context_get_dpi_y, 1, 0, 0, H_gtk_print_context_get_dpi_y, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_create_pango_context", lg_gtk_print_context_create_pango_context, 1, 0, 0, H_gtk_print_context_create_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_create_pango_layout", lg_gtk_print_context_create_pango_layout, 1, 0, 0, H_gtk_print_context_create_pango_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_set_cairo_context", lg_gtk_print_context_set_cairo_context, 4, 0, 0, H_gtk_print_context_set_cairo_context, pl_tuur);
  s7_define_typed_function(sc, "gtk_print_operation_new", lg_gtk_print_operation_new, 0, 0, 0, H_gtk_print_operation_new, pl_p);
  s7_define_typed_function(sc, "gtk_print_operation_set_default_page_setup", lg_gtk_print_operation_set_default_page_setup, 2, 0, 0, H_gtk_print_operation_set_default_page_setup, pl_tu);
  s7_define_typed_function(sc, "gtk_print_operation_get_default_page_setup", lg_gtk_print_operation_get_default_page_setup, 1, 0, 0, H_gtk_print_operation_get_default_page_setup, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_set_print_settings", lg_gtk_print_operation_set_print_settings, 2, 0, 0, H_gtk_print_operation_set_print_settings, pl_tu);
  s7_define_typed_function(sc, "gtk_print_operation_get_print_settings", lg_gtk_print_operation_get_print_settings, 1, 0, 0, H_gtk_print_operation_get_print_settings, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_set_job_name", lg_gtk_print_operation_set_job_name, 2, 0, 0, H_gtk_print_operation_set_job_name, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_set_n_pages", lg_gtk_print_operation_set_n_pages, 2, 0, 0, H_gtk_print_operation_set_n_pages, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_current_page", lg_gtk_print_operation_set_current_page, 2, 0, 0, H_gtk_print_operation_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_use_full_page", lg_gtk_print_operation_set_use_full_page, 2, 0, 0, H_gtk_print_operation_set_use_full_page, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_unit", lg_gtk_print_operation_set_unit, 2, 0, 0, H_gtk_print_operation_set_unit, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_export_filename", lg_gtk_print_operation_set_export_filename, 2, 0, 0, H_gtk_print_operation_set_export_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_set_track_print_status", lg_gtk_print_operation_set_track_print_status, 2, 0, 0, H_gtk_print_operation_set_track_print_status, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_show_progress", lg_gtk_print_operation_set_show_progress, 2, 0, 0, H_gtk_print_operation_set_show_progress, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_allow_async", lg_gtk_print_operation_set_allow_async, 2, 0, 0, H_gtk_print_operation_set_allow_async, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_custom_tab_label", lg_gtk_print_operation_set_custom_tab_label, 2, 0, 0, H_gtk_print_operation_set_custom_tab_label, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_run", lg_gtk_print_operation_run, 3, 1, 0, H_gtk_print_operation_run, pl_pugu);
  s7_define_typed_function(sc, "gtk_print_operation_get_error", lg_gtk_print_operation_get_error, 1, 1, 0, H_gtk_print_operation_get_error, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_get_status", lg_gtk_print_operation_get_status, 1, 0, 0, H_gtk_print_operation_get_status, pl_gu);
  s7_define_typed_function(sc, "gtk_print_operation_get_status_string", lg_gtk_print_operation_get_status_string, 1, 0, 0, H_gtk_print_operation_get_status_string, pl_su);
  s7_define_typed_function(sc, "gtk_print_operation_is_finished", lg_gtk_print_operation_is_finished, 1, 0, 0, H_gtk_print_operation_is_finished, pl_bu);
  s7_define_typed_function(sc, "gtk_print_operation_cancel", lg_gtk_print_operation_cancel, 1, 0, 0, H_gtk_print_operation_cancel, pl_tu);
  s7_define_typed_function(sc, "gtk_print_run_page_setup_dialog", lg_gtk_print_run_page_setup_dialog, 3, 0, 0, H_gtk_print_run_page_setup_dialog, pl_pu);
  s7_define_typed_function(sc, "gtk_print_run_page_setup_dialog_async", lg_gtk_print_run_page_setup_dialog_async, 5, 0, 0, H_gtk_print_run_page_setup_dialog_async, pl_tuuut);
  s7_define_typed_function(sc, "gtk_print_settings_new", lg_gtk_print_settings_new, 0, 0, 0, H_gtk_print_settings_new, pl_p);
  s7_define_typed_function(sc, "gtk_print_settings_copy", lg_gtk_print_settings_copy, 1, 0, 0, H_gtk_print_settings_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_has_key", lg_gtk_print_settings_has_key, 2, 0, 0, H_gtk_print_settings_has_key, pl_bus);
  s7_define_typed_function(sc, "gtk_print_settings_get", lg_gtk_print_settings_get, 2, 0, 0, H_gtk_print_settings_get, pl_sus);
  s7_define_typed_function(sc, "gtk_print_settings_set", lg_gtk_print_settings_set, 3, 0, 0, H_gtk_print_settings_set, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_unset", lg_gtk_print_settings_unset, 2, 0, 0, H_gtk_print_settings_unset, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_foreach", lg_gtk_print_settings_foreach, 3, 0, 0, H_gtk_print_settings_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_print_settings_get_bool", lg_gtk_print_settings_get_bool, 2, 0, 0, H_gtk_print_settings_get_bool, pl_bus);
  s7_define_typed_function(sc, "gtk_print_settings_set_bool", lg_gtk_print_settings_set_bool, 3, 0, 0, H_gtk_print_settings_set_bool, pl_tusb);
  s7_define_typed_function(sc, "gtk_print_settings_get_double", lg_gtk_print_settings_get_double, 2, 0, 0, H_gtk_print_settings_get_double, pl_dus);
  s7_define_typed_function(sc, "gtk_print_settings_get_double_with_default", lg_gtk_print_settings_get_double_with_default, 3, 0, 0, H_gtk_print_settings_get_double_with_default, pl_dusr);
  s7_define_typed_function(sc, "gtk_print_settings_set_double", lg_gtk_print_settings_set_double, 3, 0, 0, H_gtk_print_settings_set_double, pl_tusr);
  s7_define_typed_function(sc, "gtk_print_settings_get_length", lg_gtk_print_settings_get_length, 3, 0, 0, H_gtk_print_settings_get_length, pl_dusi);
  s7_define_typed_function(sc, "gtk_print_settings_set_length", lg_gtk_print_settings_set_length, 4, 0, 0, H_gtk_print_settings_set_length, pl_tusri);
  s7_define_typed_function(sc, "gtk_print_settings_get_int", lg_gtk_print_settings_get_int, 2, 0, 0, H_gtk_print_settings_get_int, pl_ius);
  s7_define_typed_function(sc, "gtk_print_settings_get_int_with_default", lg_gtk_print_settings_get_int_with_default, 3, 0, 0, H_gtk_print_settings_get_int_with_default, pl_iusi);
  s7_define_typed_function(sc, "gtk_print_settings_set_int", lg_gtk_print_settings_set_int, 3, 0, 0, H_gtk_print_settings_set_int, pl_tusi);
  s7_define_typed_function(sc, "gtk_print_settings_get_printer", lg_gtk_print_settings_get_printer, 1, 0, 0, H_gtk_print_settings_get_printer, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_printer", lg_gtk_print_settings_set_printer, 2, 0, 0, H_gtk_print_settings_set_printer, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_orientation", lg_gtk_print_settings_get_orientation, 1, 0, 0, H_gtk_print_settings_get_orientation, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_orientation", lg_gtk_print_settings_set_orientation, 2, 0, 0, H_gtk_print_settings_set_orientation, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_size", lg_gtk_print_settings_get_paper_size, 1, 0, 0, H_gtk_print_settings_get_paper_size, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_size", lg_gtk_print_settings_set_paper_size, 2, 0, 0, H_gtk_print_settings_set_paper_size, pl_tu);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_width", lg_gtk_print_settings_get_paper_width, 2, 0, 0, H_gtk_print_settings_get_paper_width, pl_dui);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_width", lg_gtk_print_settings_set_paper_width, 3, 0, 0, H_gtk_print_settings_set_paper_width, pl_turi);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_height", lg_gtk_print_settings_get_paper_height, 2, 0, 0, H_gtk_print_settings_get_paper_height, pl_dui);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_height", lg_gtk_print_settings_set_paper_height, 3, 0, 0, H_gtk_print_settings_set_paper_height, pl_turi);
  s7_define_typed_function(sc, "gtk_print_settings_get_use_color", lg_gtk_print_settings_get_use_color, 1, 0, 0, H_gtk_print_settings_get_use_color, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_use_color", lg_gtk_print_settings_set_use_color, 2, 0, 0, H_gtk_print_settings_set_use_color, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_collate", lg_gtk_print_settings_get_collate, 1, 0, 0, H_gtk_print_settings_get_collate, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_collate", lg_gtk_print_settings_set_collate, 2, 0, 0, H_gtk_print_settings_set_collate, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_reverse", lg_gtk_print_settings_get_reverse, 1, 0, 0, H_gtk_print_settings_get_reverse, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_reverse", lg_gtk_print_settings_set_reverse, 2, 0, 0, H_gtk_print_settings_set_reverse, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_duplex", lg_gtk_print_settings_get_duplex, 1, 0, 0, H_gtk_print_settings_get_duplex, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_duplex", lg_gtk_print_settings_set_duplex, 2, 0, 0, H_gtk_print_settings_set_duplex, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_quality", lg_gtk_print_settings_get_quality, 1, 0, 0, H_gtk_print_settings_get_quality, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_quality", lg_gtk_print_settings_set_quality, 2, 0, 0, H_gtk_print_settings_set_quality, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_n_copies", lg_gtk_print_settings_get_n_copies, 1, 0, 0, H_gtk_print_settings_get_n_copies, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_n_copies", lg_gtk_print_settings_set_n_copies, 2, 0, 0, H_gtk_print_settings_set_n_copies, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_number_up", lg_gtk_print_settings_get_number_up, 1, 0, 0, H_gtk_print_settings_get_number_up, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_number_up", lg_gtk_print_settings_set_number_up, 2, 0, 0, H_gtk_print_settings_set_number_up, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_resolution", lg_gtk_print_settings_get_resolution, 1, 0, 0, H_gtk_print_settings_get_resolution, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_resolution", lg_gtk_print_settings_set_resolution, 2, 0, 0, H_gtk_print_settings_set_resolution, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_scale", lg_gtk_print_settings_get_scale, 1, 0, 0, H_gtk_print_settings_get_scale, pl_du);
  s7_define_typed_function(sc, "gtk_print_settings_set_scale", lg_gtk_print_settings_set_scale, 2, 0, 0, H_gtk_print_settings_set_scale, pl_tur);
  s7_define_typed_function(sc, "gtk_print_settings_get_print_pages", lg_gtk_print_settings_get_print_pages, 1, 0, 0, H_gtk_print_settings_get_print_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_print_pages", lg_gtk_print_settings_set_print_pages, 2, 0, 0, H_gtk_print_settings_set_print_pages, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_page_ranges", lg_gtk_print_settings_get_page_ranges, 2, 0, 0, H_gtk_print_settings_get_page_ranges, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_set_page_ranges", lg_gtk_print_settings_set_page_ranges, 3, 0, 0, H_gtk_print_settings_set_page_ranges, pl_tuui);
  s7_define_typed_function(sc, "gtk_print_settings_get_page_set", lg_gtk_print_settings_get_page_set, 1, 0, 0, H_gtk_print_settings_get_page_set, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_page_set", lg_gtk_print_settings_set_page_set, 2, 0, 0, H_gtk_print_settings_set_page_set, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_default_source", lg_gtk_print_settings_get_default_source, 1, 0, 0, H_gtk_print_settings_get_default_source, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_default_source", lg_gtk_print_settings_set_default_source, 2, 0, 0, H_gtk_print_settings_set_default_source, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_media_type", lg_gtk_print_settings_get_media_type, 1, 0, 0, H_gtk_print_settings_get_media_type, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_media_type", lg_gtk_print_settings_set_media_type, 2, 0, 0, H_gtk_print_settings_set_media_type, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_dither", lg_gtk_print_settings_get_dither, 1, 0, 0, H_gtk_print_settings_get_dither, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_dither", lg_gtk_print_settings_set_dither, 2, 0, 0, H_gtk_print_settings_set_dither, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_finishings", lg_gtk_print_settings_get_finishings, 1, 0, 0, H_gtk_print_settings_get_finishings, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_finishings", lg_gtk_print_settings_set_finishings, 2, 0, 0, H_gtk_print_settings_set_finishings, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_output_bin", lg_gtk_print_settings_get_output_bin, 1, 0, 0, H_gtk_print_settings_get_output_bin, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_output_bin", lg_gtk_print_settings_set_output_bin, 2, 0, 0, H_gtk_print_settings_set_output_bin, pl_tus);
  s7_define_typed_function(sc, "gtk_settings_get_for_screen", lg_gtk_settings_get_for_screen, 1, 0, 0, H_gtk_settings_get_for_screen, pl_pu);
  s7_define_typed_function(sc, "pango_cairo_create_layout", lg_pango_cairo_create_layout, 1, 0, 0, H_pango_cairo_create_layout, pl_pu);
  s7_define_typed_function(sc, "pango_cairo_update_layout", lg_pango_cairo_update_layout, 2, 0, 0, H_pango_cairo_update_layout, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_update_context", lg_pango_cairo_update_context, 2, 0, 0, H_pango_cairo_update_context, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_context_set_font_options", lg_pango_cairo_context_set_font_options, 2, 0, 0, H_pango_cairo_context_set_font_options, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_context_get_font_options", lg_pango_cairo_context_get_font_options, 1, 0, 0, H_pango_cairo_context_get_font_options, pl_pu);
  s7_define_typed_function(sc, "pango_cairo_context_set_resolution", lg_pango_cairo_context_set_resolution, 2, 0, 0, H_pango_cairo_context_set_resolution, pl_tur);
  s7_define_typed_function(sc, "pango_cairo_context_get_resolution", lg_pango_cairo_context_get_resolution, 1, 0, 0, H_pango_cairo_context_get_resolution, pl_du);
  s7_define_typed_function(sc, "pango_cairo_show_glyph_string", lg_pango_cairo_show_glyph_string, 3, 0, 0, H_pango_cairo_show_glyph_string, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_layout_line", lg_pango_cairo_show_layout_line, 2, 0, 0, H_pango_cairo_show_layout_line, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_layout", lg_pango_cairo_show_layout, 2, 0, 0, H_pango_cairo_show_layout, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_error_underline", lg_pango_cairo_show_error_underline, 5, 0, 0, H_pango_cairo_show_error_underline, pl_tur);
  s7_define_typed_function(sc, "pango_cairo_glyph_string_path", lg_pango_cairo_glyph_string_path, 3, 0, 0, H_pango_cairo_glyph_string_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_layout_line_path", lg_pango_cairo_layout_line_path, 2, 0, 0, H_pango_cairo_layout_line_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_layout_path", lg_pango_cairo_layout_path, 2, 0, 0, H_pango_cairo_layout_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_error_underline_path", lg_pango_cairo_error_underline_path, 5, 0, 0, H_pango_cairo_error_underline_path, pl_tur);
  s7_define_typed_function(sc, "gdk_cairo_set_source_pixbuf", lg_gdk_cairo_set_source_pixbuf, 4, 0, 0, H_gdk_cairo_set_source_pixbuf, pl_tuur);
  s7_define_typed_function(sc, "gdk_cairo_rectangle", lg_gdk_cairo_rectangle, 2, 0, 0, H_gdk_cairo_rectangle, pl_tu);
  s7_define_typed_function(sc, "gdk_event_request_motions", lg_gdk_event_request_motions, 1, 0, 0, H_gdk_event_request_motions, pl_tu);
  s7_define_typed_function(sc, "gdk_notify_startup_complete_with_id", lg_gdk_notify_startup_complete_with_id, 1, 0, 0, H_gdk_notify_startup_complete_with_id, pl_ts);
  s7_define_typed_function(sc, "gdk_threads_add_idle_full", lg_gdk_threads_add_idle_full, 4, 0, 0, H_gdk_threads_add_idle_full, pl_iit);
  s7_define_typed_function(sc, "gdk_threads_add_idle", lg_gdk_threads_add_idle, 1, 1, 0, H_gdk_threads_add_idle, pl_it);
  s7_define_typed_function(sc, "gdk_threads_add_timeout_full", lg_gdk_threads_add_timeout_full, 5, 0, 0, H_gdk_threads_add_timeout_full, pl_iiit);
  s7_define_typed_function(sc, "gdk_threads_add_timeout", lg_gdk_threads_add_timeout, 2, 1, 0, H_gdk_threads_add_timeout, pl_iit);
  s7_define_typed_function(sc, "gdk_window_set_startup_id", lg_gdk_window_set_startup_id, 2, 0, 0, H_gdk_window_set_startup_id, pl_tus);
  s7_define_typed_function(sc, "gdk_window_beep", lg_gdk_window_beep, 1, 0, 0, H_gdk_window_beep, pl_tu);
  s7_define_typed_function(sc, "gdk_window_set_opacity", lg_gdk_window_set_opacity, 2, 0, 0, H_gdk_window_set_opacity, pl_tur);
  s7_define_typed_function(sc, "gtk_binding_entry_skip", lg_gtk_binding_entry_skip, 3, 0, 0, H_gtk_binding_entry_skip, pl_tuig);
  s7_define_typed_function(sc, "gtk_cell_layout_get_cells", lg_gtk_cell_layout_get_cells, 1, 0, 0, H_gtk_cell_layout_get_cells, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_inline_selection", lg_gtk_entry_completion_set_inline_selection, 2, 0, 0, H_gtk_entry_completion_set_inline_selection, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_inline_selection", lg_gtk_entry_completion_get_inline_selection, 1, 0, 0, H_gtk_entry_completion_get_inline_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_completion_prefix", lg_gtk_entry_completion_get_completion_prefix, 1, 0, 0, H_gtk_entry_completion_get_completion_prefix, pl_su);
  s7_define_typed_function(sc, "gtk_entry_set_cursor_hadjustment", lg_gtk_entry_set_cursor_hadjustment, 2, 0, 0, H_gtk_entry_set_cursor_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_cursor_hadjustment", lg_gtk_entry_get_cursor_hadjustment, 1, 0, 0, H_gtk_entry_get_cursor_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_list_contexts", lg_gtk_icon_theme_list_contexts, 1, 0, 0, H_gtk_icon_theme_list_contexts, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_new_from_file", lg_gtk_print_settings_new_from_file, 1, 1, 0, H_gtk_print_settings_new_from_file, pl_psu);
  s7_define_typed_function(sc, "gtk_print_settings_to_file", lg_gtk_print_settings_to_file, 2, 1, 0, H_gtk_print_settings_to_file, pl_pusu);
  s7_define_typed_function(sc, "gtk_range_set_show_fill_level", lg_gtk_range_set_show_fill_level, 2, 0, 0, H_gtk_range_set_show_fill_level, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_show_fill_level", lg_gtk_range_get_show_fill_level, 1, 0, 0, H_gtk_range_get_show_fill_level, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_restrict_to_fill_level", lg_gtk_range_set_restrict_to_fill_level, 2, 0, 0, H_gtk_range_set_restrict_to_fill_level, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_restrict_to_fill_level", lg_gtk_range_get_restrict_to_fill_level, 1, 0, 0, H_gtk_range_get_restrict_to_fill_level, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_fill_level", lg_gtk_range_set_fill_level, 2, 0, 0, H_gtk_range_set_fill_level, pl_tur);
  s7_define_typed_function(sc, "gtk_range_get_fill_level", lg_gtk_range_get_fill_level, 1, 0, 0, H_gtk_range_get_fill_level, pl_du);
  s7_define_typed_function(sc, "gtk_tree_view_set_show_expanders", lg_gtk_tree_view_set_show_expanders, 2, 0, 0, H_gtk_tree_view_set_show_expanders, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_show_expanders", lg_gtk_tree_view_get_show_expanders, 1, 0, 0, H_gtk_tree_view_get_show_expanders, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_level_indentation", lg_gtk_tree_view_set_level_indentation, 2, 0, 0, H_gtk_tree_view_set_level_indentation, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_level_indentation", lg_gtk_tree_view_get_level_indentation, 1, 0, 0, H_gtk_tree_view_get_level_indentation, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_keynav_failed", lg_gtk_widget_keynav_failed, 2, 0, 0, H_gtk_widget_keynav_failed, pl_bug);
  s7_define_typed_function(sc, "gtk_widget_error_bell", lg_gtk_widget_error_bell, 1, 0, 0, H_gtk_widget_error_bell, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_tooltip_window", lg_gtk_widget_set_tooltip_window, 2, 0, 0, H_gtk_widget_set_tooltip_window, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_tooltip_window", lg_gtk_widget_get_tooltip_window, 1, 0, 0, H_gtk_widget_get_tooltip_window, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_trigger_tooltip_query", lg_gtk_widget_trigger_tooltip_query, 1, 0, 0, H_gtk_widget_trigger_tooltip_query, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_startup_id", lg_gtk_window_set_startup_id, 2, 0, 0, H_gtk_window_set_startup_id, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_add_mark", lg_gtk_text_buffer_add_mark, 3, 0, 0, H_gtk_text_buffer_add_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_mark_new", lg_gtk_text_mark_new, 2, 0, 0, H_gtk_text_mark_new, pl_psb);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_tree_view", lg_gtk_tree_view_column_get_tree_view, 1, 0, 0, H_gtk_tree_view_column_get_tree_view, pl_pu);
  s7_define_typed_function(sc, "gtk_tooltip_set_text", lg_gtk_tooltip_set_text, 2, 0, 0, H_gtk_tooltip_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_tree_view_convert_widget_to_tree_coords", lg_gtk_tree_view_convert_widget_to_tree_coords, 3, 2, 0, H_gtk_tree_view_convert_widget_to_tree_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_tree_to_widget_coords", lg_gtk_tree_view_convert_tree_to_widget_coords, 3, 2, 0, H_gtk_tree_view_convert_tree_to_widget_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", lg_gtk_tree_view_convert_widget_to_bin_window_coords, 3, 2, 0, H_gtk_tree_view_convert_widget_to_bin_window_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", lg_gtk_tree_view_convert_bin_window_to_widget_coords, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_widget_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", lg_gtk_tree_view_convert_tree_to_bin_window_coords, 3, 2, 0, H_gtk_tree_view_convert_tree_to_bin_window_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", lg_gtk_tree_view_convert_bin_window_to_tree_coords, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_tree_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_widget_set_tooltip_text", lg_gtk_widget_set_tooltip_text, 2, 0, 0, H_gtk_widget_set_tooltip_text, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_tooltip_text", lg_gtk_widget_get_tooltip_text, 1, 0, 0, H_gtk_widget_get_tooltip_text, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_tooltip_markup", lg_gtk_widget_set_tooltip_markup, 2, 0, 0, H_gtk_widget_set_tooltip_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_tooltip_markup", lg_gtk_widget_get_tooltip_markup, 1, 0, 0, H_gtk_widget_get_tooltip_markup, pl_su);
  s7_define_typed_function(sc, "gtk_tree_view_is_rubber_banding_active", lg_gtk_tree_view_is_rubber_banding_active, 1, 0, 0, H_gtk_tree_view_is_rubber_banding_active, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_item", lg_gtk_icon_view_set_tooltip_item, 3, 0, 0, H_gtk_icon_view_set_tooltip_item, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_cell", lg_gtk_icon_view_set_tooltip_cell, 4, 0, 0, H_gtk_icon_view_set_tooltip_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_get_tooltip_context", lg_gtk_icon_view_get_tooltip_context, 3, 4, 0, H_gtk_icon_view_get_tooltip_context, pl_puuubu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_column", lg_gtk_icon_view_set_tooltip_column, 2, 0, 0, H_gtk_icon_view_set_tooltip_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_tooltip_column", lg_gtk_icon_view_get_tooltip_column, 1, 0, 0, H_gtk_icon_view_get_tooltip_column, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_tool_button_set_arrow_tooltip_text", lg_gtk_menu_tool_button_set_arrow_tooltip_text, 2, 0, 0, H_gtk_menu_tool_button_set_arrow_tooltip_text, pl_tus);
  s7_define_typed_function(sc, "gtk_menu_tool_button_set_arrow_tooltip_markup", lg_gtk_menu_tool_button_set_arrow_tooltip_markup, 2, 0, 0, H_gtk_menu_tool_button_set_arrow_tooltip_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_tool_item_set_tooltip_text", lg_gtk_tool_item_set_tooltip_text, 2, 0, 0, H_gtk_tool_item_set_tooltip_text, pl_tus);
  s7_define_typed_function(sc, "gtk_tool_item_set_tooltip_markup", lg_gtk_tool_item_set_tooltip_markup, 2, 0, 0, H_gtk_tool_item_set_tooltip_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_tooltip_set_tip_area", lg_gtk_tooltip_set_tip_area, 2, 0, 0, H_gtk_tooltip_set_tip_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_row", lg_gtk_tree_view_set_tooltip_row, 3, 0, 0, H_gtk_tree_view_set_tooltip_row, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_cell", lg_gtk_tree_view_set_tooltip_cell, 5, 0, 0, H_gtk_tree_view_set_tooltip_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_tooltip_context", lg_gtk_tree_view_get_tooltip_context, 3, 4, 0, H_gtk_tree_view_get_tooltip_context, pl_puuubu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_column", lg_gtk_tree_view_set_tooltip_column, 2, 0, 0, H_gtk_tree_view_set_tooltip_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_tooltip_column", lg_gtk_tree_view_get_tooltip_column, 1, 0, 0, H_gtk_tree_view_get_tooltip_column, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_has_tooltip", lg_gtk_widget_set_has_tooltip, 2, 0, 0, H_gtk_widget_set_has_tooltip, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_has_tooltip", lg_gtk_widget_get_has_tooltip, 1, 0, 0, H_gtk_widget_get_has_tooltip, pl_bu);
#if GTK_CHECK_VERSION(2, 14, 0)
  s7_define_typed_function(sc, "gtk_calendar_set_detail_func", lg_gtk_calendar_set_detail_func, 4, 0, 0, H_gtk_calendar_set_detail_func, pl_tut);
  s7_define_typed_function(sc, "gtk_calendar_set_detail_width_chars", lg_gtk_calendar_set_detail_width_chars, 2, 0, 0, H_gtk_calendar_set_detail_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_set_detail_height_rows", lg_gtk_calendar_set_detail_height_rows, 2, 0, 0, H_gtk_calendar_set_detail_height_rows, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_get_detail_width_chars", lg_gtk_calendar_get_detail_width_chars, 1, 0, 0, H_gtk_calendar_get_detail_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_calendar_get_detail_height_rows", lg_gtk_calendar_get_detail_height_rows, 1, 0, 0, H_gtk_calendar_get_detail_height_rows, pl_iu);
  s7_define_typed_function(sc, "gtk_accel_group_get_is_locked", lg_gtk_accel_group_get_is_locked, 1, 0, 0, H_gtk_accel_group_get_is_locked, pl_bu);
  s7_define_typed_function(sc, "gtk_dialog_get_content_area", lg_gtk_dialog_get_content_area, 1, 0, 0, H_gtk_dialog_get_content_area, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_overwrite_mode", lg_gtk_entry_set_overwrite_mode, 2, 0, 0, H_gtk_entry_set_overwrite_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_overwrite_mode", lg_gtk_entry_get_overwrite_mode, 1, 0, 0, H_gtk_entry_get_overwrite_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_get_text_length", lg_gtk_entry_get_text_length, 1, 0, 0, H_gtk_entry_get_text_length, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_get_accel_path", lg_gtk_menu_get_accel_path, 1, 0, 0, H_gtk_menu_get_accel_path, pl_su);
  s7_define_typed_function(sc, "gtk_menu_get_monitor", lg_gtk_menu_get_monitor, 1, 0, 0, H_gtk_menu_get_monitor, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_item_get_accel_path", lg_gtk_menu_item_get_accel_path, 1, 0, 0, H_gtk_menu_item_get_accel_path, pl_su);
  s7_define_typed_function(sc, "gtk_scale_button_get_plus_button", lg_gtk_scale_button_get_plus_button, 1, 0, 0, H_gtk_scale_button_get_plus_button, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_button_get_minus_button", lg_gtk_scale_button_get_minus_button, 1, 0, 0, H_gtk_scale_button_get_minus_button, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_button_get_popup", lg_gtk_scale_button_get_popup, 1, 0, 0, H_gtk_scale_button_get_popup, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_get_target", lg_gtk_selection_data_get_target, 1, 0, 0, H_gtk_selection_data_get_target, pl_tu);
  s7_define_typed_function(sc, "gtk_selection_data_get_data_type", lg_gtk_selection_data_get_data_type, 1, 0, 0, H_gtk_selection_data_get_data_type, pl_tu);
  s7_define_typed_function(sc, "gtk_selection_data_get_format", lg_gtk_selection_data_get_format, 1, 0, 0, H_gtk_selection_data_get_format, pl_iu);
  s7_define_typed_function(sc, "gtk_selection_data_get_display", lg_gtk_selection_data_get_display, 1, 0, 0, H_gtk_selection_data_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_window", lg_gtk_widget_get_window, 1, 0, 0, H_gtk_widget_get_window, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_group_get_modifier_mask", lg_gtk_accel_group_get_modifier_mask, 1, 0, 0, H_gtk_accel_group_get_modifier_mask, pl_gu);
  s7_define_typed_function(sc, "gdk_threads_add_timeout_seconds_full", lg_gdk_threads_add_timeout_seconds_full, 5, 0, 0, H_gdk_threads_add_timeout_seconds_full, pl_iiit);
  s7_define_typed_function(sc, "gdk_threads_add_timeout_seconds", lg_gdk_threads_add_timeout_seconds, 2, 1, 0, H_gdk_threads_add_timeout_seconds, pl_iit);
  s7_define_typed_function(sc, "gtk_adjustment_get_lower", lg_gtk_adjustment_get_lower, 1, 0, 0, H_gtk_adjustment_get_lower, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_lower", lg_gtk_adjustment_set_lower, 2, 0, 0, H_gtk_adjustment_set_lower, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_upper", lg_gtk_adjustment_get_upper, 1, 0, 0, H_gtk_adjustment_get_upper, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_upper", lg_gtk_adjustment_set_upper, 2, 0, 0, H_gtk_adjustment_set_upper, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_step_increment", lg_gtk_adjustment_get_step_increment, 1, 0, 0, H_gtk_adjustment_get_step_increment, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_step_increment", lg_gtk_adjustment_set_step_increment, 2, 0, 0, H_gtk_adjustment_set_step_increment, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_page_increment", lg_gtk_adjustment_get_page_increment, 1, 0, 0, H_gtk_adjustment_get_page_increment, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_page_increment", lg_gtk_adjustment_set_page_increment, 2, 0, 0, H_gtk_adjustment_set_page_increment, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_page_size", lg_gtk_adjustment_get_page_size, 1, 0, 0, H_gtk_adjustment_get_page_size, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_page_size", lg_gtk_adjustment_set_page_size, 2, 0, 0, H_gtk_adjustment_set_page_size, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_configure", lg_gtk_adjustment_configure, 7, 0, 0, H_gtk_adjustment_configure, pl_tur);
  s7_define_typed_function(sc, "gtk_combo_box_set_button_sensitivity", lg_gtk_combo_box_set_button_sensitivity, 2, 0, 0, H_gtk_combo_box_set_button_sensitivity, pl_tug);
  s7_define_typed_function(sc, "gtk_combo_box_get_button_sensitivity", lg_gtk_combo_box_get_button_sensitivity, 1, 0, 0, H_gtk_combo_box_get_button_sensitivity, pl_gu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_file", lg_gtk_file_chooser_get_file, 1, 0, 0, H_gtk_file_chooser_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_file", lg_gtk_file_chooser_set_file, 2, 1, 0, H_gtk_file_chooser_set_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_select_file", lg_gtk_file_chooser_select_file, 2, 1, 0, H_gtk_file_chooser_select_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_file", lg_gtk_file_chooser_unselect_file, 2, 0, 0, H_gtk_file_chooser_unselect_file, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_files", lg_gtk_file_chooser_get_files, 1, 0, 0, H_gtk_file_chooser_get_files, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_current_folder_file", lg_gtk_file_chooser_set_current_folder_file, 2, 1, 0, H_gtk_file_chooser_set_current_folder_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_folder_file", lg_gtk_file_chooser_get_current_folder_file, 1, 0, 0, H_gtk_file_chooser_get_current_folder_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_preview_file", lg_gtk_file_chooser_get_preview_file, 1, 0, 0, H_gtk_file_chooser_get_preview_file, pl_pu);
  s7_define_typed_function(sc, "gtk_window_get_default_widget", lg_gtk_window_get_default_widget, 1, 0, 0, H_gtk_window_get_default_widget, pl_pu);
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
  s7_define_typed_function(sc, "gtk_link_button_get_visited", lg_gtk_link_button_get_visited, 1, 0, 0, H_gtk_link_button_get_visited, pl_bu);
  s7_define_typed_function(sc, "gtk_link_button_set_visited", lg_gtk_link_button_set_visited, 2, 0, 0, H_gtk_link_button_set_visited, pl_tub);
  s7_define_typed_function(sc, "gdk_keymap_get_caps_lock_state", lg_gdk_keymap_get_caps_lock_state, 1, 0, 0, H_gdk_keymap_get_caps_lock_state, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_view_get_model", lg_gtk_cell_view_get_model, 1, 0, 0, H_gtk_cell_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_unset_invisible_char", lg_gtk_entry_unset_invisible_char, 1, 0, 0, H_gtk_entry_unset_invisible_char, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_set_progress_fraction", lg_gtk_entry_set_progress_fraction, 2, 0, 0, H_gtk_entry_set_progress_fraction, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_progress_fraction", lg_gtk_entry_get_progress_fraction, 1, 0, 0, H_gtk_entry_get_progress_fraction, pl_du);
  s7_define_typed_function(sc, "gtk_entry_set_progress_pulse_step", lg_gtk_entry_set_progress_pulse_step, 2, 0, 0, H_gtk_entry_set_progress_pulse_step, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_progress_pulse_step", lg_gtk_entry_get_progress_pulse_step, 1, 0, 0, H_gtk_entry_get_progress_pulse_step, pl_du);
  s7_define_typed_function(sc, "gtk_entry_progress_pulse", lg_gtk_entry_progress_pulse, 1, 0, 0, H_gtk_entry_progress_pulse, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_set_icon_from_pixbuf", lg_gtk_entry_set_icon_from_pixbuf, 3, 0, 0, H_gtk_entry_set_icon_from_pixbuf, pl_tugu);
  s7_define_typed_function(sc, "gtk_entry_set_icon_from_icon_name", lg_gtk_entry_set_icon_from_icon_name, 3, 0, 0, H_gtk_entry_set_icon_from_icon_name, pl_tugs);
  s7_define_typed_function(sc, "gtk_entry_set_icon_from_gicon", lg_gtk_entry_set_icon_from_gicon, 3, 0, 0, H_gtk_entry_set_icon_from_gicon, pl_tugu);
  s7_define_typed_function(sc, "gtk_entry_get_icon_name", lg_gtk_entry_get_icon_name, 2, 0, 0, H_gtk_entry_get_icon_name, pl_sug);
  s7_define_typed_function(sc, "gtk_entry_set_icon_activatable", lg_gtk_entry_set_icon_activatable, 3, 0, 0, H_gtk_entry_set_icon_activatable, pl_tugb);
  s7_define_typed_function(sc, "gtk_entry_get_icon_activatable", lg_gtk_entry_get_icon_activatable, 2, 0, 0, H_gtk_entry_get_icon_activatable, pl_bug);
  s7_define_typed_function(sc, "gtk_entry_set_icon_sensitive", lg_gtk_entry_set_icon_sensitive, 3, 0, 0, H_gtk_entry_set_icon_sensitive, pl_tugb);
  s7_define_typed_function(sc, "gtk_entry_get_icon_sensitive", lg_gtk_entry_get_icon_sensitive, 2, 0, 0, H_gtk_entry_get_icon_sensitive, pl_bug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_at_pos", lg_gtk_entry_get_icon_at_pos, 3, 0, 0, H_gtk_entry_get_icon_at_pos, pl_iui);
  s7_define_typed_function(sc, "gtk_entry_set_icon_tooltip_text", lg_gtk_entry_set_icon_tooltip_text, 3, 0, 0, H_gtk_entry_set_icon_tooltip_text, pl_tugs);
  s7_define_typed_function(sc, "gtk_entry_set_icon_tooltip_markup", lg_gtk_entry_set_icon_tooltip_markup, 3, 0, 0, H_gtk_entry_set_icon_tooltip_markup, pl_tugs);
  s7_define_typed_function(sc, "gtk_entry_set_icon_drag_source", lg_gtk_entry_set_icon_drag_source, 4, 0, 0, H_gtk_entry_set_icon_drag_source, pl_tugug);
  s7_define_typed_function(sc, "gtk_entry_get_current_icon_drag_source", lg_gtk_entry_get_current_icon_drag_source, 1, 0, 0, H_gtk_entry_get_current_icon_drag_source, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_item_set_label", lg_gtk_menu_item_set_label, 2, 0, 0, H_gtk_menu_item_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_menu_item_get_label", lg_gtk_menu_item_get_label, 1, 0, 0, H_gtk_menu_item_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_menu_item_set_use_underline", lg_gtk_menu_item_set_use_underline, 2, 0, 0, H_gtk_menu_item_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_item_get_use_underline", lg_gtk_menu_item_get_use_underline, 1, 0, 0, H_gtk_menu_item_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_data_get_selection", lg_gtk_selection_data_get_selection, 1, 0, 0, H_gtk_selection_data_get_selection, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_icon_tooltip_text", lg_gtk_entry_get_icon_tooltip_text, 2, 0, 0, H_gtk_entry_get_icon_tooltip_text, pl_sug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_tooltip_markup", lg_gtk_entry_get_icon_tooltip_markup, 2, 0, 0, H_gtk_entry_get_icon_tooltip_markup, pl_sug);
  s7_define_typed_function(sc, "gtk_scale_add_mark", lg_gtk_scale_add_mark, 4, 0, 0, H_gtk_scale_add_mark, pl_turgs);
  s7_define_typed_function(sc, "gtk_scale_clear_marks", lg_gtk_scale_clear_marks, 1, 0, 0, H_gtk_scale_clear_marks, pl_tu);
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
  s7_define_typed_function(sc, "gtk_window_get_default_icon_name", lg_gtk_window_get_default_icon_name, 0, 0, 0, H_gtk_window_get_default_icon_name, pl_s);
  s7_define_typed_function(sc, "gtk_label_get_current_uri", lg_gtk_label_get_current_uri, 1, 0, 0, H_gtk_label_get_current_uri, pl_su);
  s7_define_typed_function(sc, "gtk_info_bar_new", lg_gtk_info_bar_new, 0, 0, 0, H_gtk_info_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_info_bar_get_action_area", lg_gtk_info_bar_get_action_area, 1, 0, 0, H_gtk_info_bar_get_action_area, pl_pu);
  s7_define_typed_function(sc, "gtk_info_bar_get_content_area", lg_gtk_info_bar_get_content_area, 1, 0, 0, H_gtk_info_bar_get_content_area, pl_pu);
  s7_define_typed_function(sc, "gtk_info_bar_add_action_widget", lg_gtk_info_bar_add_action_widget, 3, 0, 0, H_gtk_info_bar_add_action_widget, pl_tuui);
  s7_define_typed_function(sc, "gtk_info_bar_add_button", lg_gtk_info_bar_add_button, 3, 0, 0, H_gtk_info_bar_add_button, pl_pusi);
  s7_define_typed_function(sc, "gtk_info_bar_set_response_sensitive", lg_gtk_info_bar_set_response_sensitive, 3, 0, 0, H_gtk_info_bar_set_response_sensitive, pl_tuib);
  s7_define_typed_function(sc, "gtk_info_bar_set_default_response", lg_gtk_info_bar_set_default_response, 2, 0, 0, H_gtk_info_bar_set_default_response, pl_tui);
  s7_define_typed_function(sc, "gtk_info_bar_response", lg_gtk_info_bar_response, 2, 0, 0, H_gtk_info_bar_response, pl_tui);
  s7_define_typed_function(sc, "gtk_info_bar_set_message_type", lg_gtk_info_bar_set_message_type, 2, 0, 0, H_gtk_info_bar_set_message_type, pl_tug);
  s7_define_typed_function(sc, "gtk_info_bar_get_message_type", lg_gtk_info_bar_get_message_type, 1, 0, 0, H_gtk_info_bar_get_message_type, pl_gu);
  s7_define_typed_function(sc, "gdk_window_get_root_coords", lg_gdk_window_get_root_coords, 3, 2, 0, H_gdk_window_get_root_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_menu_set_reserve_toggle_size", lg_gtk_menu_set_reserve_toggle_size, 2, 0, 0, H_gtk_menu_set_reserve_toggle_size, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_get_reserve_toggle_size", lg_gtk_menu_get_reserve_toggle_size, 1, 0, 0, H_gtk_menu_get_reserve_toggle_size, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_new_with_buffer", lg_gtk_entry_new_with_buffer, 1, 0, 0, H_gtk_entry_new_with_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_get_buffer", lg_gtk_entry_get_buffer, 1, 0, 0, H_gtk_entry_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_buffer", lg_gtk_entry_set_buffer, 2, 0, 0, H_gtk_entry_set_buffer, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_track_visited_links", lg_gtk_label_set_track_visited_links, 2, 0, 0, H_gtk_label_set_track_visited_links, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_track_visited_links", lg_gtk_label_get_track_visited_links, 1, 0, 0, H_gtk_label_get_track_visited_links, pl_bu);
  s7_define_typed_function(sc, "gtk_print_operation_set_embed_page_setup", lg_gtk_print_operation_set_embed_page_setup, 2, 0, 0, H_gtk_print_operation_set_embed_page_setup, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_get_embed_page_setup", lg_gtk_print_operation_get_embed_page_setup, 1, 0, 0, H_gtk_print_operation_get_embed_page_setup, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_buffer_new", lg_gtk_entry_buffer_new, 2, 0, 0, H_gtk_entry_buffer_new, pl_psi);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_bytes", lg_gtk_entry_buffer_get_bytes, 1, 0, 0, H_gtk_entry_buffer_get_bytes, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_length", lg_gtk_entry_buffer_get_length, 1, 0, 0, H_gtk_entry_buffer_get_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_text", lg_gtk_entry_buffer_get_text, 1, 0, 0, H_gtk_entry_buffer_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_entry_buffer_set_text", lg_gtk_entry_buffer_set_text, 3, 0, 0, H_gtk_entry_buffer_set_text, pl_tusi);
  s7_define_typed_function(sc, "gtk_entry_buffer_set_max_length", lg_gtk_entry_buffer_set_max_length, 2, 0, 0, H_gtk_entry_buffer_set_max_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_max_length", lg_gtk_entry_buffer_get_max_length, 1, 0, 0, H_gtk_entry_buffer_get_max_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_insert_text", lg_gtk_entry_buffer_insert_text, 4, 0, 0, H_gtk_entry_buffer_insert_text, pl_iuisi);
  s7_define_typed_function(sc, "gtk_entry_buffer_delete_text", lg_gtk_entry_buffer_delete_text, 3, 0, 0, H_gtk_entry_buffer_delete_text, pl_iui);
  s7_define_typed_function(sc, "gtk_entry_buffer_emit_inserted_text", lg_gtk_entry_buffer_emit_inserted_text, 4, 0, 0, H_gtk_entry_buffer_emit_inserted_text, pl_tuisi);
  s7_define_typed_function(sc, "gtk_entry_buffer_emit_deleted_text", lg_gtk_entry_buffer_emit_deleted_text, 3, 0, 0, H_gtk_entry_buffer_emit_deleted_text, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_alignment", lg_gtk_cell_renderer_set_alignment, 3, 0, 0, H_gtk_cell_renderer_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_alignment", lg_gtk_cell_renderer_get_alignment, 1, 2, 0, H_gtk_cell_renderer_get_alignment, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_padding", lg_gtk_cell_renderer_set_padding, 3, 0, 0, H_gtk_cell_renderer_set_padding, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_padding", lg_gtk_cell_renderer_get_padding, 1, 2, 0, H_gtk_cell_renderer_get_padding, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_visible", lg_gtk_cell_renderer_set_visible, 2, 0, 0, H_gtk_cell_renderer_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_visible", lg_gtk_cell_renderer_get_visible, 1, 0, 0, H_gtk_cell_renderer_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_sensitive", lg_gtk_cell_renderer_set_sensitive, 2, 0, 0, H_gtk_cell_renderer_set_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_sensitive", lg_gtk_cell_renderer_get_sensitive, 1, 0, 0, H_gtk_cell_renderer_get_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_activatable", lg_gtk_cell_renderer_toggle_get_activatable, 1, 0, 0, H_gtk_cell_renderer_toggle_get_activatable, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_activatable", lg_gtk_cell_renderer_toggle_set_activatable, 2, 0, 0, H_gtk_cell_renderer_toggle_set_activatable, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_can_focus", lg_gtk_widget_set_can_focus, 2, 0, 0, H_gtk_widget_set_can_focus, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_can_focus", lg_gtk_widget_get_can_focus, 1, 0, 0, H_gtk_widget_get_can_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_has_focus", lg_gtk_widget_has_focus, 1, 0, 0, H_gtk_widget_has_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_can_default", lg_gtk_widget_set_can_default, 2, 0, 0, H_gtk_widget_set_can_default, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_can_default", lg_gtk_widget_get_can_default, 1, 0, 0, H_gtk_widget_get_can_default, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_has_default", lg_gtk_widget_has_default, 1, 0, 0, H_gtk_widget_has_default, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_sensitive", lg_gtk_widget_get_sensitive, 1, 0, 0, H_gtk_widget_get_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_sensitive", lg_gtk_widget_is_sensitive, 1, 0, 0, H_gtk_widget_is_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_has_window", lg_gtk_widget_set_has_window, 2, 0, 0, H_gtk_widget_set_has_window, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_has_window", lg_gtk_widget_get_has_window, 1, 0, 0, H_gtk_widget_get_has_window, pl_bu);
  s7_define_typed_function(sc, "gdk_window_get_cursor", lg_gdk_window_get_cursor, 1, 0, 0, H_gdk_window_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_create_folders", lg_gtk_file_chooser_set_create_folders, 2, 0, 0, H_gtk_file_chooser_set_create_folders, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_create_folders", lg_gtk_file_chooser_get_create_folders, 1, 0, 0, H_gtk_file_chooser_get_create_folders, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_padding", lg_gtk_icon_view_set_item_padding, 2, 0, 0, H_gtk_icon_view_set_item_padding, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_padding", lg_gtk_icon_view_get_item_padding, 1, 0, 0, H_gtk_icon_view_get_item_padding, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_has_grab", lg_gtk_widget_has_grab, 1, 0, 0, H_gtk_widget_has_grab, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_visible", lg_gtk_widget_set_visible, 2, 0, 0, H_gtk_widget_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_visible", lg_gtk_widget_get_visible, 1, 0, 0, H_gtk_widget_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_flippable", lg_gtk_range_set_flippable, 2, 0, 0, H_gtk_range_set_flippable, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_flippable", lg_gtk_range_get_flippable, 1, 0, 0, H_gtk_range_get_flippable, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_toplevel", lg_gtk_widget_is_toplevel, 1, 0, 0, H_gtk_widget_is_toplevel, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_drawable", lg_gtk_widget_is_drawable, 1, 0, 0, H_gtk_widget_is_drawable, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_window", lg_gtk_widget_set_window, 2, 0, 0, H_gtk_widget_set_window, pl_tu);
  s7_define_typed_function(sc, "gdk_window_is_destroyed", lg_gdk_window_is_destroyed, 1, 0, 0, H_gdk_window_is_destroyed, pl_bu);
  s7_define_typed_function(sc, "gdk_window_restack", lg_gdk_window_restack, 3, 0, 0, H_gdk_window_restack, pl_tuub);
  s7_define_typed_function(sc, "gtk_widget_set_receives_default", lg_gtk_widget_set_receives_default, 2, 0, 0, H_gtk_widget_set_receives_default, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_receives_default", lg_gtk_widget_get_receives_default, 1, 0, 0, H_gtk_widget_get_receives_default, pl_bu);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  s7_define_typed_function(sc, "gtk_dialog_get_widget_for_response", lg_gtk_dialog_get_widget_for_response, 2, 0, 0, H_gtk_dialog_get_widget_for_response, pl_pui);
  s7_define_typed_function(sc, "gtk_spinner_new", lg_gtk_spinner_new, 0, 0, 0, H_gtk_spinner_new, pl_p);
  s7_define_typed_function(sc, "gtk_spinner_start", lg_gtk_spinner_start, 1, 0, 0, H_gtk_spinner_start, pl_tu);
  s7_define_typed_function(sc, "gtk_spinner_stop", lg_gtk_spinner_stop, 1, 0, 0, H_gtk_spinner_stop, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_spinner_new", lg_gtk_cell_renderer_spinner_new, 0, 0, 0, H_gtk_cell_renderer_spinner_new, pl_p);
  s7_define_typed_function(sc, "gtk_notebook_get_action_widget", lg_gtk_notebook_get_action_widget, 2, 0, 0, H_gtk_notebook_get_action_widget, pl_pug);
  s7_define_typed_function(sc, "gtk_notebook_set_action_widget", lg_gtk_notebook_set_action_widget, 3, 0, 0, H_gtk_notebook_set_action_widget, pl_tuug);
  s7_define_typed_function(sc, "gtk_statusbar_get_message_area", lg_gtk_statusbar_get_message_area, 1, 0, 0, H_gtk_statusbar_get_message_area, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_item_get_ellipsize_mode", lg_gtk_tool_item_get_ellipsize_mode, 1, 0, 0, H_gtk_tool_item_get_ellipsize_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_get_text_alignment", lg_gtk_tool_item_get_text_alignment, 1, 0, 0, H_gtk_tool_item_get_text_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_tool_item_get_text_orientation", lg_gtk_tool_item_get_text_orientation, 1, 0, 0, H_gtk_tool_item_get_text_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_get_text_size_group", lg_gtk_tool_item_get_text_size_group, 1, 0, 0, H_gtk_tool_item_get_text_size_group, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_palette_new", lg_gtk_tool_palette_new, 0, 0, 0, H_gtk_tool_palette_new, pl_p);
  s7_define_typed_function(sc, "gtk_tool_palette_set_group_position", lg_gtk_tool_palette_set_group_position, 3, 0, 0, H_gtk_tool_palette_set_group_position, pl_tuui);
  s7_define_typed_function(sc, "gtk_tool_palette_set_exclusive", lg_gtk_tool_palette_set_exclusive, 3, 0, 0, H_gtk_tool_palette_set_exclusive, pl_tuub);
  s7_define_typed_function(sc, "gtk_tool_palette_set_expand", lg_gtk_tool_palette_set_expand, 3, 0, 0, H_gtk_tool_palette_set_expand, pl_tuub);
  s7_define_typed_function(sc, "gtk_tool_palette_get_group_position", lg_gtk_tool_palette_get_group_position, 2, 0, 0, H_gtk_tool_palette_get_group_position, pl_iu);
  s7_define_typed_function(sc, "gtk_tool_palette_get_exclusive", lg_gtk_tool_palette_get_exclusive, 2, 0, 0, H_gtk_tool_palette_get_exclusive, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_palette_get_expand", lg_gtk_tool_palette_get_expand, 2, 0, 0, H_gtk_tool_palette_get_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_palette_unset_icon_size", lg_gtk_tool_palette_unset_icon_size, 1, 0, 0, H_gtk_tool_palette_unset_icon_size, pl_tu);
  s7_define_typed_function(sc, "gtk_tool_palette_set_style", lg_gtk_tool_palette_set_style, 2, 0, 0, H_gtk_tool_palette_set_style, pl_tug);
  s7_define_typed_function(sc, "gtk_tool_palette_unset_style", lg_gtk_tool_palette_unset_style, 1, 0, 0, H_gtk_tool_palette_unset_style, pl_tu);
  s7_define_typed_function(sc, "gtk_tool_palette_get_style", lg_gtk_tool_palette_get_style, 1, 0, 0, H_gtk_tool_palette_get_style, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_palette_get_drop_item", lg_gtk_tool_palette_get_drop_item, 3, 0, 0, H_gtk_tool_palette_get_drop_item, pl_pui);
  s7_define_typed_function(sc, "gtk_tool_palette_get_drop_group", lg_gtk_tool_palette_get_drop_group, 3, 0, 0, H_gtk_tool_palette_get_drop_group, pl_pui);
  s7_define_typed_function(sc, "gtk_tool_palette_get_drag_item", lg_gtk_tool_palette_get_drag_item, 2, 0, 0, H_gtk_tool_palette_get_drag_item, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_palette_set_drag_source", lg_gtk_tool_palette_set_drag_source, 2, 0, 0, H_gtk_tool_palette_set_drag_source, pl_tug);
  s7_define_typed_function(sc, "gtk_tool_palette_add_drag_dest", lg_gtk_tool_palette_add_drag_dest, 5, 0, 0, H_gtk_tool_palette_add_drag_dest, pl_tuug);
  s7_define_typed_function(sc, "gtk_tool_palette_get_drag_target_item", lg_gtk_tool_palette_get_drag_target_item, 0, 0, 0, H_gtk_tool_palette_get_drag_target_item, pl_p);
  s7_define_typed_function(sc, "gtk_tool_palette_get_drag_target_group", lg_gtk_tool_palette_get_drag_target_group, 0, 0, 0, H_gtk_tool_palette_get_drag_target_group, pl_p);
  s7_define_typed_function(sc, "gtk_tool_item_group_new", lg_gtk_tool_item_group_new, 1, 0, 0, H_gtk_tool_item_group_new, pl_ps);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_label", lg_gtk_tool_item_group_set_label, 2, 0, 0, H_gtk_tool_item_group_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_label_widget", lg_gtk_tool_item_group_set_label_widget, 2, 0, 0, H_gtk_tool_item_group_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_collapsed", lg_gtk_tool_item_group_set_collapsed, 2, 0, 0, H_gtk_tool_item_group_set_collapsed, pl_tub);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_ellipsize", lg_gtk_tool_item_group_set_ellipsize, 2, 0, 0, H_gtk_tool_item_group_set_ellipsize, pl_tug);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_header_relief", lg_gtk_tool_item_group_set_header_relief, 2, 0, 0, H_gtk_tool_item_group_set_header_relief, pl_tug);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_label", lg_gtk_tool_item_group_get_label, 1, 0, 0, H_gtk_tool_item_group_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_label_widget", lg_gtk_tool_item_group_get_label_widget, 1, 0, 0, H_gtk_tool_item_group_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_collapsed", lg_gtk_tool_item_group_get_collapsed, 1, 0, 0, H_gtk_tool_item_group_get_collapsed, pl_bu);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_ellipsize", lg_gtk_tool_item_group_get_ellipsize, 1, 0, 0, H_gtk_tool_item_group_get_ellipsize, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_header_relief", lg_gtk_tool_item_group_get_header_relief, 1, 0, 0, H_gtk_tool_item_group_get_header_relief, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_item_group_insert", lg_gtk_tool_item_group_insert, 3, 0, 0, H_gtk_tool_item_group_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_tool_item_group_set_item_position", lg_gtk_tool_item_group_set_item_position, 3, 0, 0, H_gtk_tool_item_group_set_item_position, pl_tuui);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_item_position", lg_gtk_tool_item_group_get_item_position, 2, 0, 0, H_gtk_tool_item_group_get_item_position, pl_iu);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_n_items", lg_gtk_tool_item_group_get_n_items, 1, 0, 0, H_gtk_tool_item_group_get_n_items, pl_iu);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_nth_item", lg_gtk_tool_item_group_get_nth_item, 2, 0, 0, H_gtk_tool_item_group_get_nth_item, pl_pui);
  s7_define_typed_function(sc, "gtk_tool_item_group_get_drop_item", lg_gtk_tool_item_group_get_drop_item, 3, 0, 0, H_gtk_tool_item_group_get_drop_item, pl_pui);
  s7_define_typed_function(sc, "gtk_window_set_mnemonics_visible", lg_gtk_window_set_mnemonics_visible, 2, 0, 0, H_gtk_window_set_mnemonics_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_mnemonics_visible", lg_gtk_window_get_mnemonics_visible, 1, 0, 0, H_gtk_window_get_mnemonics_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_slider_size_fixed", lg_gtk_range_set_slider_size_fixed, 2, 0, 0, H_gtk_range_set_slider_size_fixed, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_slider_size_fixed", lg_gtk_range_get_slider_size_fixed, 1, 0, 0, H_gtk_range_get_slider_size_fixed, pl_bu);
  s7_define_typed_function(sc, "gtk_range_get_range_rect", lg_gtk_range_get_range_rect, 2, 0, 0, H_gtk_range_get_range_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_range_get_slider_range", lg_gtk_range_get_slider_range, 1, 2, 0, H_gtk_range_get_slider_range, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_realized", lg_gtk_widget_set_realized, 2, 0, 0, H_gtk_widget_set_realized, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_realized", lg_gtk_widget_get_realized, 1, 0, 0, H_gtk_widget_get_realized, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_mapped", lg_gtk_widget_get_mapped, 1, 0, 0, H_gtk_widget_get_mapped, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "gdk_window_get_geometry", lg_gdk_window_get_geometry, 1, 4, 0, H_gdk_window_get_geometry, pl_pu);
  s7_define_typed_function(sc, "gdk_keymap_add_virtual_modifiers", lg_gdk_keymap_add_virtual_modifiers, 2, 0, 0, H_gdk_keymap_add_virtual_modifiers, pl_tu);
  s7_define_typed_function(sc, "gdk_window_coords_to_parent", lg_gdk_window_coords_to_parent, 3, 2, 0, H_gdk_window_coords_to_parent, pl_purru);
  s7_define_typed_function(sc, "gdk_window_coords_from_parent", lg_gdk_window_coords_from_parent, 3, 2, 0, H_gdk_window_coords_from_parent, pl_purru);
  s7_define_typed_function(sc, "gtk_accessible_get_widget", lg_gtk_accessible_get_widget, 1, 0, 0, H_gtk_accessible_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_send_focus_change", lg_gtk_widget_send_focus_change, 2, 0, 0, H_gtk_widget_send_focus_change, pl_bu);
  s7_define_typed_function(sc, "gdk_drag_context_set_device", lg_gdk_drag_context_set_device, 2, 0, 0, H_gdk_drag_context_set_device, pl_tu);
  s7_define_typed_function(sc, "gdk_drag_context_get_device", lg_gdk_drag_context_get_device, 1, 0, 0, H_gdk_drag_context_get_device, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_context_list_targets", lg_gdk_drag_context_list_targets, 1, 0, 0, H_gdk_drag_context_list_targets, pl_pu);
  s7_define_typed_function(sc, "gdk_event_set_device", lg_gdk_event_set_device, 2, 0, 0, H_gdk_event_set_device, pl_tu);
  s7_define_typed_function(sc, "gdk_event_get_device", lg_gdk_event_get_device, 1, 0, 0, H_gdk_event_get_device, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_distance", lg_gdk_events_get_distance, 2, 1, 0, H_gdk_events_get_distance, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_angle", lg_gdk_events_get_angle, 2, 1, 0, H_gdk_events_get_angle, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_center", lg_gdk_events_get_center, 2, 2, 0, H_gdk_events_get_center, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_accept_focus", lg_gdk_window_get_accept_focus, 1, 0, 0, H_gdk_window_get_accept_focus, pl_bu);
  s7_define_typed_function(sc, "gdk_window_get_focus_on_map", lg_gdk_window_get_focus_on_map, 1, 0, 0, H_gdk_window_get_focus_on_map, pl_bu);
  s7_define_typed_function(sc, "gdk_window_is_input_only", lg_gdk_window_is_input_only, 1, 0, 0, H_gdk_window_is_input_only, pl_bu);
  s7_define_typed_function(sc, "gdk_window_is_shaped", lg_gdk_window_is_shaped, 1, 0, 0, H_gdk_window_is_shaped, pl_bu);
  s7_define_typed_function(sc, "gdk_window_get_modal_hint", lg_gdk_window_get_modal_hint, 1, 0, 0, H_gdk_window_get_modal_hint, pl_bu);
  s7_define_typed_function(sc, "gdk_window_set_device_cursor", lg_gdk_window_set_device_cursor, 3, 0, 0, H_gdk_window_set_device_cursor, pl_tu);
  s7_define_typed_function(sc, "gdk_window_get_device_cursor", lg_gdk_window_get_device_cursor, 2, 0, 0, H_gdk_window_get_device_cursor, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_device_position", lg_gdk_window_get_device_position, 2, 3, 0, H_gdk_window_get_device_position, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_device_events", lg_gdk_window_set_device_events, 3, 0, 0, H_gdk_window_set_device_events, pl_tuug);
  s7_define_typed_function(sc, "gdk_window_get_device_events", lg_gdk_window_get_device_events, 2, 0, 0, H_gdk_window_get_device_events, pl_gu);
  s7_define_typed_function(sc, "gtk_combo_box_popup_for_device", lg_gtk_combo_box_popup_for_device, 2, 0, 0, H_gtk_combo_box_popup_for_device, pl_tu);
  s7_define_typed_function(sc, "gtk_device_grab_add", lg_gtk_device_grab_add, 3, 0, 0, H_gtk_device_grab_add, pl_tuub);
  s7_define_typed_function(sc, "gtk_device_grab_remove", lg_gtk_device_grab_remove, 2, 0, 0, H_gtk_device_grab_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_get_current_event_device", lg_gtk_get_current_event_device, 0, 0, 0, H_gtk_get_current_event_device, pl_p);
  s7_define_typed_function(sc, "gtk_paned_new", lg_gtk_paned_new, 1, 0, 0, H_gtk_paned_new, pl_pg);
  s7_define_typed_function(sc, "gtk_scale_new", lg_gtk_scale_new, 2, 0, 0, H_gtk_scale_new, pl_pgu);
  s7_define_typed_function(sc, "gtk_scale_new_with_range", lg_gtk_scale_new_with_range, 4, 0, 0, H_gtk_scale_new_with_range, pl_pgr);
  s7_define_typed_function(sc, "gtk_scrollbar_new", lg_gtk_scrollbar_new, 2, 0, 0, H_gtk_scrollbar_new, pl_pgu);
  s7_define_typed_function(sc, "gtk_separator_new", lg_gtk_separator_new, 1, 0, 0, H_gtk_separator_new, pl_pg);
  s7_define_typed_function(sc, "gtk_widget_device_is_shadowed", lg_gtk_widget_device_is_shadowed, 2, 0, 0, H_gtk_widget_device_is_shadowed, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_support_multidevice", lg_gtk_widget_get_support_multidevice, 1, 0, 0, H_gtk_widget_get_support_multidevice, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_support_multidevice", lg_gtk_widget_set_support_multidevice, 2, 0, 0, H_gtk_widget_set_support_multidevice, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_row", lg_gtk_icon_view_get_item_row, 2, 0, 0, H_gtk_icon_view_get_item_row, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_column", lg_gtk_icon_view_get_item_column, 2, 0, 0, H_gtk_icon_view_get_item_column, pl_iu);
  s7_define_typed_function(sc, "gtk_statusbar_remove_all", lg_gtk_statusbar_remove_all, 2, 0, 0, H_gtk_statusbar_remove_all, pl_tui);
  s7_define_typed_function(sc, "gtk_window_has_group", lg_gtk_window_has_group, 1, 0, 0, H_gtk_window_has_group, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_select_month", lg_gtk_calendar_select_month, 3, 0, 0, H_gtk_calendar_select_month, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_mark_day", lg_gtk_calendar_mark_day, 2, 0, 0, H_gtk_calendar_mark_day, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_unmark_day", lg_gtk_calendar_unmark_day, 2, 0, 0, H_gtk_calendar_unmark_day, pl_tui);
  s7_define_typed_function(sc, "gdk_drag_context_get_source_window", lg_gdk_drag_context_get_source_window, 1, 0, 0, H_gdk_drag_context_get_source_window, pl_pu);
  s7_define_typed_function(sc, "gtk_accessible_set_widget", lg_gtk_accessible_set_widget, 2, 0, 0, H_gtk_accessible_set_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_message_dialog_get_message_area", lg_gtk_message_dialog_get_message_area, 1, 0, 0, H_gtk_message_dialog_get_message_area, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_get_length", lg_gtk_selection_data_get_length, 1, 0, 0, H_gtk_selection_data_get_length, pl_iu);
  s7_define_typed_function(sc, "gdk_pango_layout_line_get_clip_region", lg_gdk_pango_layout_line_get_clip_region, 5, 0, 0, H_gdk_pango_layout_line_get_clip_region, pl_puiiui);
  s7_define_typed_function(sc, "gdk_pango_layout_get_clip_region", lg_gdk_pango_layout_get_clip_region, 5, 0, 0, H_gdk_pango_layout_get_clip_region, pl_puiiui);
  s7_define_typed_function(sc, "gdk_window_shape_combine_region", lg_gdk_window_shape_combine_region, 4, 0, 0, H_gdk_window_shape_combine_region, pl_tuui);
  s7_define_typed_function(sc, "gdk_window_invalidate_region", lg_gdk_window_invalidate_region, 3, 0, 0, H_gdk_window_invalidate_region, pl_tuub);
  s7_define_typed_function(sc, "gdk_window_get_update_area", lg_gdk_window_get_update_area, 1, 0, 0, H_gdk_window_get_update_area, pl_pu);
  s7_define_typed_function(sc, "gdk_window_move_region", lg_gdk_window_move_region, 4, 0, 0, H_gdk_window_move_region, pl_tuui);
  s7_define_typed_function(sc, "gdk_keymap_get_num_lock_state", lg_gdk_keymap_get_num_lock_state, 1, 0, 0, H_gdk_keymap_get_num_lock_state, pl_bu);
  s7_define_typed_function(sc, "gdk_window_has_native", lg_gdk_window_has_native, 1, 0, 0, H_gdk_window_has_native, pl_bu);
  s7_define_typed_function(sc, "gdk_cursor_get_cursor_type", lg_gdk_cursor_get_cursor_type, 1, 0, 0, H_gdk_cursor_get_cursor_type, pl_gu);
  s7_define_typed_function(sc, "gdk_display_is_closed", lg_gdk_display_is_closed, 1, 0, 0, H_gdk_display_is_closed, pl_bu);
  s7_define_typed_function(sc, "gdk_window_create_similar_surface", lg_gdk_window_create_similar_surface, 4, 0, 0, H_gdk_window_create_similar_surface, pl_pugi);
  s7_define_typed_function(sc, "gtk_expander_set_label_fill", lg_gtk_expander_set_label_fill, 2, 0, 0, H_gtk_expander_set_label_fill, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_label_fill", lg_gtk_expander_get_label_fill, 1, 0, 0, H_gtk_expander_get_label_fill, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_get_day_is_marked", lg_gtk_calendar_get_day_is_marked, 2, 0, 0, H_gtk_calendar_get_day_is_marked, pl_bui);
  s7_define_typed_function(sc, "gtk_progress_bar_set_inverted", lg_gtk_progress_bar_set_inverted, 2, 0, 0, H_gtk_progress_bar_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_progress_bar_get_inverted", lg_gtk_progress_bar_get_inverted, 1, 0, 0, H_gtk_progress_bar_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_radio_button_join_group", lg_gtk_radio_button_join_group, 2, 0, 0, H_gtk_radio_button_join_group, pl_tu);
  s7_define_typed_function(sc, "gtk_adjustment_new", lg_gtk_adjustment_new, 6, 0, 0, H_gtk_adjustment_new, pl_pr);
  s7_define_typed_function(sc, "gtk_binding_set_activate", lg_gtk_binding_set_activate, 4, 0, 0, H_gtk_binding_set_activate, pl_buigu);
  s7_define_typed_function(sc, "gtk_bindings_activate", lg_gtk_bindings_activate, 3, 0, 0, H_gtk_bindings_activate, pl_buig);
  s7_define_typed_function(sc, "gtk_icon_view_create_drag_icon", lg_gtk_icon_view_create_drag_icon, 2, 0, 0, H_gtk_icon_view_create_drag_icon, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_create_row_drag_icon", lg_gtk_tree_view_create_row_drag_icon, 2, 0, 0, H_gtk_tree_view_create_row_drag_icon, pl_pu);
  s7_define_typed_function(sc, "gdk_cairo_get_clip_rectangle", lg_gdk_cairo_get_clip_rectangle, 2, 0, 0, H_gdk_cairo_get_clip_rectangle, pl_bu);
  s7_define_typed_function(sc, "gdk_cairo_region_create_from_surface", lg_gdk_cairo_region_create_from_surface, 1, 0, 0, H_gdk_cairo_region_create_from_surface, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_screen", lg_gdk_window_get_screen, 1, 0, 0, H_gdk_window_get_screen, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_display", lg_gdk_window_get_display, 1, 0, 0, H_gdk_window_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_width", lg_gdk_window_get_width, 1, 0, 0, H_gdk_window_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_window_get_height", lg_gdk_window_get_height, 1, 0, 0, H_gdk_window_get_height, pl_iu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_request_mode", lg_gtk_cell_renderer_get_request_mode, 1, 0, 0, H_gtk_cell_renderer_get_request_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_width", lg_gtk_cell_renderer_get_preferred_width, 2, 2, 0, H_gtk_cell_renderer_get_preferred_width, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_height_for_width", lg_gtk_cell_renderer_get_preferred_height_for_width, 3, 2, 0, H_gtk_cell_renderer_get_preferred_height_for_width, pl_puuiu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_height", lg_gtk_cell_renderer_get_preferred_height, 2, 2, 0, H_gtk_cell_renderer_get_preferred_height, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_width_for_height", lg_gtk_cell_renderer_get_preferred_width_for_height, 3, 2, 0, H_gtk_cell_renderer_get_preferred_width_for_height, pl_puuiu);
  s7_define_typed_function(sc, "gtk_drag_set_icon_surface", lg_gtk_drag_set_icon_surface, 2, 0, 0, H_gtk_drag_set_icon_surface, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_group_name", lg_gtk_notebook_set_group_name, 2, 0, 0, H_gtk_notebook_set_group_name, pl_tus);
  s7_define_typed_function(sc, "gtk_notebook_get_group_name", lg_gtk_notebook_get_group_name, 1, 0, 0, H_gtk_notebook_get_group_name, pl_su);
  s7_define_typed_function(sc, "gtk_widget_draw", lg_gtk_widget_draw, 2, 0, 0, H_gtk_widget_draw, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_request_mode", lg_gtk_widget_get_request_mode, 1, 0, 0, H_gtk_widget_get_request_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_width", lg_gtk_widget_get_allocated_width, 1, 0, 0, H_gtk_widget_get_allocated_width, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_height", lg_gtk_widget_get_allocated_height, 1, 0, 0, H_gtk_widget_get_allocated_height, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_halign", lg_gtk_widget_get_halign, 1, 0, 0, H_gtk_widget_get_halign, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_halign", lg_gtk_widget_set_halign, 2, 0, 0, H_gtk_widget_set_halign, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_valign", lg_gtk_widget_get_valign, 1, 0, 0, H_gtk_widget_get_valign, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_valign", lg_gtk_widget_set_valign, 2, 0, 0, H_gtk_widget_set_valign, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_margin_top", lg_gtk_widget_get_margin_top, 1, 0, 0, H_gtk_widget_get_margin_top, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_top", lg_gtk_widget_set_margin_top, 2, 0, 0, H_gtk_widget_set_margin_top, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_margin_bottom", lg_gtk_widget_get_margin_bottom, 1, 0, 0, H_gtk_widget_get_margin_bottom, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_bottom", lg_gtk_widget_set_margin_bottom, 2, 0, 0, H_gtk_widget_set_margin_bottom, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_shape_combine_region", lg_gtk_widget_shape_combine_region, 2, 0, 0, H_gtk_widget_shape_combine_region, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_input_shape_combine_region", lg_gtk_widget_input_shape_combine_region, 2, 0, 0, H_gtk_widget_input_shape_combine_region, pl_tu);
  s7_define_typed_function(sc, "gtk_cairo_transform_to_window", lg_gtk_cairo_transform_to_window, 3, 0, 0, H_gtk_cairo_transform_to_window, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_entry", lg_gtk_combo_box_new_with_entry, 0, 0, 0, H_gtk_combo_box_new_with_entry, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_get_has_entry", lg_gtk_combo_box_get_has_entry, 1, 0, 0, H_gtk_combo_box_get_has_entry, pl_bu);
  s7_define_typed_function(sc, "gtk_combo_box_set_entry_text_column", lg_gtk_combo_box_set_entry_text_column, 2, 0, 0, H_gtk_combo_box_set_entry_text_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_entry_text_column", lg_gtk_combo_box_get_entry_text_column, 1, 0, 0, H_gtk_combo_box_get_entry_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_target_entry_new", lg_gtk_target_entry_new, 3, 0, 0, H_gtk_target_entry_new, pl_psi);
  s7_define_typed_function(sc, "gtk_target_entry_copy", lg_gtk_target_entry_copy, 1, 0, 0, H_gtk_target_entry_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_target_entry_free", lg_gtk_target_entry_free, 1, 0, 0, H_gtk_target_entry_free, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_hexpand", lg_gtk_widget_get_hexpand, 1, 0, 0, H_gtk_widget_get_hexpand, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_hexpand", lg_gtk_widget_set_hexpand, 2, 0, 0, H_gtk_widget_set_hexpand, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_hexpand_set", lg_gtk_widget_get_hexpand_set, 1, 0, 0, H_gtk_widget_get_hexpand_set, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_hexpand_set", lg_gtk_widget_set_hexpand_set, 2, 0, 0, H_gtk_widget_set_hexpand_set, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_vexpand", lg_gtk_widget_get_vexpand, 1, 0, 0, H_gtk_widget_get_vexpand, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_vexpand", lg_gtk_widget_set_vexpand, 2, 0, 0, H_gtk_widget_set_vexpand, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_vexpand_set", lg_gtk_widget_get_vexpand_set, 1, 0, 0, H_gtk_widget_get_vexpand_set, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_vexpand_set", lg_gtk_widget_set_vexpand_set, 2, 0, 0, H_gtk_widget_set_vexpand_set, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_queue_compute_expand", lg_gtk_widget_queue_compute_expand, 1, 0, 0, H_gtk_widget_queue_compute_expand, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_compute_expand", lg_gtk_widget_compute_expand, 2, 0, 0, H_gtk_widget_compute_expand, pl_bug);
  s7_define_typed_function(sc, "gtk_combo_box_text_new", lg_gtk_combo_box_text_new, 0, 0, 0, H_gtk_combo_box_text_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_text_new_with_entry", lg_gtk_combo_box_text_new_with_entry, 0, 0, 0, H_gtk_combo_box_text_new_with_entry, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_text_append_text", lg_gtk_combo_box_text_append_text, 2, 0, 0, H_gtk_combo_box_text_append_text, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_insert_text", lg_gtk_combo_box_text_insert_text, 3, 0, 0, H_gtk_combo_box_text_insert_text, pl_tuis);
  s7_define_typed_function(sc, "gtk_combo_box_text_prepend_text", lg_gtk_combo_box_text_prepend_text, 2, 0, 0, H_gtk_combo_box_text_prepend_text, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_remove", lg_gtk_combo_box_text_remove, 2, 0, 0, H_gtk_combo_box_text_remove, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_text_get_active_text", lg_gtk_combo_box_text_get_active_text, 1, 0, 0, H_gtk_combo_box_text_get_active_text, pl_su);
  s7_define_typed_function(sc, "gdk_cairo_set_source_rgba", lg_gdk_cairo_set_source_rgba, 2, 0, 0, H_gdk_cairo_set_source_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_text_remove_all", lg_gtk_combo_box_text_remove_all, 1, 0, 0, H_gtk_combo_box_text_remove_all, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_set_popup_fixed_width", lg_gtk_combo_box_set_popup_fixed_width, 2, 0, 0, H_gtk_combo_box_set_popup_fixed_width, pl_tub);
  s7_define_typed_function(sc, "gtk_combo_box_get_popup_fixed_width", lg_gtk_combo_box_get_popup_fixed_width, 1, 0, 0, H_gtk_combo_box_get_popup_fixed_width, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_min_content_width", lg_gtk_scrolled_window_get_min_content_width, 1, 0, 0, H_gtk_scrolled_window_get_min_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_min_content_width", lg_gtk_scrolled_window_set_min_content_width, 2, 0, 0, H_gtk_scrolled_window_set_min_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_min_content_height", lg_gtk_scrolled_window_get_min_content_height, 1, 0, 0, H_gtk_scrolled_window_get_min_content_height, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_min_content_height", lg_gtk_scrolled_window_set_min_content_height, 2, 0, 0, H_gtk_scrolled_window_set_min_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_new", lg_gtk_grid_new, 0, 0, 0, H_gtk_grid_new, pl_p);
  s7_define_typed_function(sc, "gtk_grid_attach", lg_gtk_grid_attach, 6, 0, 0, H_gtk_grid_attach, pl_tuui);
  s7_define_typed_function(sc, "gtk_grid_attach_next_to", lg_gtk_grid_attach_next_to, 6, 0, 0, H_gtk_grid_attach_next_to, pl_tuuugi);
  s7_define_typed_function(sc, "gtk_grid_set_row_homogeneous", lg_gtk_grid_set_row_homogeneous, 2, 0, 0, H_gtk_grid_set_row_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_get_row_homogeneous", lg_gtk_grid_get_row_homogeneous, 1, 0, 0, H_gtk_grid_get_row_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_set_row_spacing", lg_gtk_grid_set_row_spacing, 2, 0, 0, H_gtk_grid_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_row_spacing", lg_gtk_grid_get_row_spacing, 1, 0, 0, H_gtk_grid_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_set_column_homogeneous", lg_gtk_grid_set_column_homogeneous, 2, 0, 0, H_gtk_grid_set_column_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_get_column_homogeneous", lg_gtk_grid_get_column_homogeneous, 1, 0, 0, H_gtk_grid_get_column_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_set_column_spacing", lg_gtk_grid_set_column_spacing, 2, 0, 0, H_gtk_grid_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_column_spacing", lg_gtk_grid_get_column_spacing, 1, 0, 0, H_gtk_grid_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_scrollable_get_hadjustment", lg_gtk_scrollable_get_hadjustment, 1, 0, 0, H_gtk_scrollable_get_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_set_hadjustment", lg_gtk_scrollable_set_hadjustment, 2, 0, 0, H_gtk_scrollable_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrollable_get_vadjustment", lg_gtk_scrollable_get_vadjustment, 1, 0, 0, H_gtk_scrollable_get_vadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_set_vadjustment", lg_gtk_scrollable_set_vadjustment, 2, 0, 0, H_gtk_scrollable_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_next_page", lg_gtk_assistant_next_page, 1, 0, 0, H_gtk_assistant_next_page, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_previous_page", lg_gtk_assistant_previous_page, 1, 0, 0, H_gtk_assistant_previous_page, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_model_and_entry", lg_gtk_combo_box_new_with_model_and_entry, 1, 0, 0, H_gtk_combo_box_new_with_model_and_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_get_hscroll_policy", lg_gtk_scrollable_get_hscroll_policy, 1, 0, 0, H_gtk_scrollable_get_hscroll_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_scrollable_set_hscroll_policy", lg_gtk_scrollable_set_hscroll_policy, 2, 0, 0, H_gtk_scrollable_set_hscroll_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_scrollable_get_vscroll_policy", lg_gtk_scrollable_get_vscroll_policy, 1, 0, 0, H_gtk_scrollable_get_vscroll_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_scrollable_set_vscroll_policy", lg_gtk_scrollable_set_vscroll_policy, 2, 0, 0, H_gtk_scrollable_set_vscroll_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_switch_new", lg_gtk_switch_new, 0, 0, 0, H_gtk_switch_new, pl_p);
  s7_define_typed_function(sc, "gtk_switch_set_active", lg_gtk_switch_set_active, 2, 0, 0, H_gtk_switch_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_switch_get_active", lg_gtk_switch_get_active, 1, 0, 0, H_gtk_switch_get_active, pl_bu);
  s7_define_typed_function(sc, "gdk_window_get_clip_region", lg_gdk_window_get_clip_region, 1, 0, 0, H_gdk_window_get_clip_region, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_visible_region", lg_gdk_window_get_visible_region, 1, 0, 0, H_gdk_window_get_visible_region, pl_pu);
  s7_define_typed_function(sc, "gtk_border_new", lg_gtk_border_new, 0, 0, 0, H_gtk_border_new, pl_p);
  s7_define_typed_function(sc, "gtk_border_copy", lg_gtk_border_copy, 1, 0, 0, H_gtk_border_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_border_free", lg_gtk_border_free, 1, 0, 0, H_gtk_border_free, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_get_id_column", lg_gtk_combo_box_get_id_column, 1, 0, 0, H_gtk_combo_box_get_id_column, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_set_id_column", lg_gtk_combo_box_set_id_column, 2, 0, 0, H_gtk_combo_box_set_id_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_active_id", lg_gtk_combo_box_get_active_id, 1, 0, 0, H_gtk_combo_box_get_active_id, pl_su);
  s7_define_typed_function(sc, "gtk_combo_box_text_insert", lg_gtk_combo_box_text_insert, 4, 0, 0, H_gtk_combo_box_text_insert, pl_tuis);
  s7_define_typed_function(sc, "gtk_combo_box_text_append", lg_gtk_combo_box_text_append, 3, 0, 0, H_gtk_combo_box_text_append, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_prepend", lg_gtk_combo_box_text_prepend, 3, 0, 0, H_gtk_combo_box_text_prepend, pl_tus);
  s7_define_typed_function(sc, "gtk_button_box_new", lg_gtk_button_box_new, 1, 0, 0, H_gtk_button_box_new, pl_pg);
  s7_define_typed_function(sc, "gtk_box_new", lg_gtk_box_new, 2, 0, 0, H_gtk_box_new, pl_pgi);
  s7_define_typed_function(sc, "gtk_tree_view_set_cursor_on_cell", lg_gtk_tree_view_set_cursor_on_cell, 5, 0, 0, H_gtk_tree_view_set_cursor_on_cell, pl_tuuuub);
  s7_define_typed_function(sc, "gtk_tree_view_set_rubber_banding", lg_gtk_tree_view_set_rubber_banding, 2, 0, 0, H_gtk_tree_view_set_rubber_banding, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_rubber_banding", lg_gtk_tree_view_get_rubber_banding, 1, 0, 0, H_gtk_tree_view_get_rubber_banding, pl_bu);
  s7_define_typed_function(sc, "gtk_tooltip_set_markup", lg_gtk_tooltip_set_markup, 2, 0, 0, H_gtk_tooltip_set_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_tooltip_set_icon", lg_gtk_tooltip_set_icon, 2, 0, 0, H_gtk_tooltip_set_icon, pl_tu);
  s7_define_typed_function(sc, "gtk_tooltip_set_custom", lg_gtk_tooltip_set_custom, 2, 0, 0, H_gtk_tooltip_set_custom, pl_tu);
  s7_define_typed_function(sc, "gtk_tooltip_trigger_tooltip_query", lg_gtk_tooltip_trigger_tooltip_query, 1, 0, 0, H_gtk_tooltip_trigger_tooltip_query, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_new_with_area", lg_gtk_tree_view_column_new_with_area, 1, 0, 0, H_gtk_tree_view_column_new_with_area, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_button", lg_gtk_tree_view_column_get_button, 1, 0, 0, H_gtk_tree_view_column_get_button, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_focus_cell", lg_gtk_tree_view_column_focus_cell, 2, 0, 0, H_gtk_tree_view_column_focus_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_clipboard_wait_is_uris_available", lg_gtk_clipboard_wait_is_uris_available, 1, 0, 0, H_gtk_clipboard_wait_is_uris_available, pl_bu);
  s7_define_typed_function(sc, "gtk_toolbar_set_drop_highlight_item", lg_gtk_toolbar_set_drop_highlight_item, 3, 0, 0, H_gtk_toolbar_set_drop_highlight_item, pl_tuui);
  s7_define_typed_function(sc, "gtk_tool_item_toolbar_reconfigured", lg_gtk_tool_item_toolbar_reconfigured, 1, 0, 0, H_gtk_tool_item_toolbar_reconfigured, pl_tu);
  s7_define_typed_function(sc, "gtk_orientable_set_orientation", lg_gtk_orientable_set_orientation, 2, 0, 0, H_gtk_orientable_set_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_orientable_get_orientation", lg_gtk_orientable_get_orientation, 1, 0, 0, H_gtk_orientable_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_get_major_version", lg_gtk_get_major_version, 0, 0, 0, H_gtk_get_major_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_minor_version", lg_gtk_get_minor_version, 0, 0, 0, H_gtk_get_minor_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_micro_version", lg_gtk_get_micro_version, 0, 0, 0, H_gtk_get_micro_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_binary_age", lg_gtk_get_binary_age, 0, 0, 0, H_gtk_get_binary_age, pl_i);
  s7_define_typed_function(sc, "gtk_get_interface_age", lg_gtk_get_interface_age, 0, 0, 0, H_gtk_get_interface_age, pl_i);
  s7_define_typed_function(sc, "gtk_progress_bar_set_show_text", lg_gtk_progress_bar_set_show_text, 2, 0, 0, H_gtk_progress_bar_set_show_text, pl_tub);
  s7_define_typed_function(sc, "gtk_progress_bar_get_show_text", lg_gtk_progress_bar_get_show_text, 1, 0, 0, H_gtk_progress_bar_get_show_text, pl_bu);
  s7_define_typed_function(sc, "gtk_invisible_new_for_screen", lg_gtk_invisible_new_for_screen, 1, 0, 0, H_gtk_invisible_new_for_screen, pl_pu);
  s7_define_typed_function(sc, "gtk_invisible_set_screen", lg_gtk_invisible_set_screen, 2, 0, 0, H_gtk_invisible_set_screen, pl_tu);
  s7_define_typed_function(sc, "gtk_invisible_get_screen", lg_gtk_invisible_get_screen, 1, 0, 0, H_gtk_invisible_get_screen, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_get_icon_storage_type", lg_gtk_entry_get_icon_storage_type, 2, 0, 0, H_gtk_entry_get_icon_storage_type, pl_gug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_pixbuf", lg_gtk_entry_get_icon_pixbuf, 2, 0, 0, H_gtk_entry_get_icon_pixbuf, pl_pug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_gicon", lg_gtk_entry_get_icon_gicon, 2, 0, 0, H_gtk_entry_get_icon_gicon, pl_pug);
  s7_define_typed_function(sc, "gtk_container_propagate_draw", lg_gtk_container_propagate_draw, 3, 0, 0, H_gtk_container_propagate_draw, pl_tu);
  s7_define_typed_function(sc, "gtk_container_set_focus_chain", lg_gtk_container_set_focus_chain, 2, 0, 0, H_gtk_container_set_focus_chain, pl_tu);
  s7_define_typed_function(sc, "gtk_container_get_focus_chain", lg_gtk_container_get_focus_chain, 1, 1, 0, H_gtk_container_get_focus_chain, pl_pu);
  s7_define_typed_function(sc, "gtk_container_unset_focus_chain", lg_gtk_container_unset_focus_chain, 1, 0, 0, H_gtk_container_unset_focus_chain, pl_tu);
  s7_define_typed_function(sc, "gtk_container_set_focus_vadjustment", lg_gtk_container_set_focus_vadjustment, 2, 0, 0, H_gtk_container_set_focus_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_container_get_focus_vadjustment", lg_gtk_container_get_focus_vadjustment, 1, 0, 0, H_gtk_container_get_focus_vadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_container_set_focus_hadjustment", lg_gtk_container_set_focus_hadjustment, 2, 0, 0, H_gtk_container_set_focus_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_container_get_focus_hadjustment", lg_gtk_container_get_focus_hadjustment, 1, 0, 0, H_gtk_container_get_focus_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_assistant_commit", lg_gtk_assistant_commit, 1, 0, 0, H_gtk_assistant_commit, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_skip_taskbar_hint", lg_gtk_window_set_skip_taskbar_hint, 2, 0, 0, H_gtk_window_set_skip_taskbar_hint, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_skip_taskbar_hint", lg_gtk_window_get_skip_taskbar_hint, 1, 0, 0, H_gtk_window_get_skip_taskbar_hint, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_skip_pager_hint", lg_gtk_window_set_skip_pager_hint, 2, 0, 0, H_gtk_window_set_skip_pager_hint, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_skip_pager_hint", lg_gtk_window_get_skip_pager_hint, 1, 0, 0, H_gtk_window_get_skip_pager_hint, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_screen", lg_gtk_window_set_screen, 2, 0, 0, H_gtk_window_set_screen, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_screen", lg_gtk_window_get_screen, 1, 0, 0, H_gtk_window_get_screen, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_icon_from_file", lg_gtk_window_set_icon_from_file, 2, 1, 0, H_gtk_window_set_icon_from_file, pl_pusu);
  s7_define_typed_function(sc, "gtk_window_set_default_icon_from_file", lg_gtk_window_set_default_icon_from_file, 1, 1, 0, H_gtk_window_set_default_icon_from_file, pl_psu);
  s7_define_typed_function(sc, "gtk_window_fullscreen", lg_gtk_window_fullscreen, 1, 0, 0, H_gtk_window_fullscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unfullscreen", lg_gtk_window_unfullscreen, 1, 0, 0, H_gtk_window_unfullscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_window_type", lg_gtk_window_get_window_type, 1, 0, 0, H_gtk_window_get_window_type, pl_gu);
  s7_define_typed_function(sc, "gtk_window_group_add_window", lg_gtk_window_group_add_window, 2, 0, 0, H_gtk_window_group_add_window, pl_tu);
  s7_define_typed_function(sc, "gtk_window_group_remove_window", lg_gtk_window_group_remove_window, 2, 0, 0, H_gtk_window_group_remove_window, pl_tu);
  s7_define_typed_function(sc, "gtk_window_group_new", lg_gtk_window_group_new, 0, 0, 0, H_gtk_window_group_new, pl_p);
  s7_define_typed_function(sc, "gtk_window_get_group", lg_gtk_window_get_group, 1, 0, 0, H_gtk_window_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_window_group_list_windows", lg_gtk_window_group_list_windows, 1, 0, 0, H_gtk_window_group_list_windows, pl_pu);
  s7_define_typed_function(sc, "gtk_window_group_get_current_device_grab", lg_gtk_window_group_get_current_device_grab, 2, 0, 0, H_gtk_window_group_get_current_device_grab, pl_pu);
  s7_define_typed_function(sc, "gtk_window_group_get_current_grab", lg_gtk_window_group_get_current_grab, 1, 0, 0, H_gtk_window_group_get_current_grab, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_get_data", lg_gtk_selection_data_get_data, 1, 0, 0, H_gtk_selection_data_get_data, pl_su);
  s7_define_typed_function(sc, "gtk_selection_owner_set_for_display", lg_gtk_selection_owner_set_for_display, 4, 0, 0, H_gtk_selection_owner_set_for_display, pl_buuti);
  s7_define_typed_function(sc, "gtk_tool_shell_get_text_orientation", lg_gtk_tool_shell_get_text_orientation, 1, 0, 0, H_gtk_tool_shell_get_text_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_shell_get_text_alignment", lg_gtk_tool_shell_get_text_alignment, 1, 0, 0, H_gtk_tool_shell_get_text_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_tool_shell_get_ellipsize_mode", lg_gtk_tool_shell_get_ellipsize_mode, 1, 0, 0, H_gtk_tool_shell_get_ellipsize_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_shell_get_text_size_group", lg_gtk_tool_shell_get_text_size_group, 1, 0, 0, H_gtk_tool_shell_get_text_size_group, pl_pu);
  s7_define_typed_function(sc, "gtk_tool_shell_get_orientation", lg_gtk_tool_shell_get_orientation, 1, 0, 0, H_gtk_tool_shell_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_shell_get_style", lg_gtk_tool_shell_get_style, 1, 0, 0, H_gtk_tool_shell_get_style, pl_gu);
  s7_define_typed_function(sc, "gtk_tool_shell_rebuild_menu", lg_gtk_tool_shell_rebuild_menu, 1, 0, 0, H_gtk_tool_shell_rebuild_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_map_lock_path", lg_gtk_accel_map_lock_path, 1, 0, 0, H_gtk_accel_map_lock_path, pl_ts);
  s7_define_typed_function(sc, "gtk_accel_map_unlock_path", lg_gtk_accel_map_unlock_path, 1, 0, 0, H_gtk_accel_map_unlock_path, pl_ts);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_by_gicon", lg_gtk_icon_theme_lookup_by_gicon, 4, 0, 0, H_gtk_icon_theme_lookup_by_gicon, pl_puuig);
  s7_define_typed_function(sc, "gtk_icon_info_new_for_pixbuf", lg_gtk_icon_info_new_for_pixbuf, 2, 0, 0, H_gtk_icon_info_new_for_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_orientation", lg_gtk_icon_view_set_item_orientation, 2, 0, 0, H_gtk_icon_view_set_item_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_orientation", lg_gtk_icon_view_get_item_orientation, 1, 0, 0, H_gtk_icon_view_get_item_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_im_context_filter_keypress", lg_gtk_text_view_im_context_filter_keypress, 2, 0, 0, H_gtk_text_view_im_context_filter_keypress, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_reset_im_context", lg_gtk_text_view_reset_im_context, 1, 0, 0, H_gtk_text_view_reset_im_context, pl_tu);
  s7_define_typed_function(sc, "gdk_device_get_position", lg_gdk_device_get_position, 2, 2, 0, H_gdk_device_get_position, pl_pu);
  s7_define_typed_function(sc, "gdk_device_get_window_at_position", lg_gdk_device_get_window_at_position, 1, 2, 0, H_gdk_device_get_window_at_position, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_view_get_draw_sensitive", lg_gtk_cell_view_get_draw_sensitive, 1, 0, 0, H_gtk_cell_view_get_draw_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_view_set_draw_sensitive", lg_gtk_cell_view_set_draw_sensitive, 2, 0, 0, H_gtk_cell_view_set_draw_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_view_get_fit_model", lg_gtk_cell_view_get_fit_model, 1, 0, 0, H_gtk_cell_view_get_fit_model, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_view_set_fit_model", lg_gtk_cell_view_set_fit_model, 2, 0, 0, H_gtk_cell_view_set_fit_model, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_new_with_area", lg_gtk_icon_view_new_with_area, 1, 0, 0, H_gtk_icon_view_new_with_area, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_item_set_reserve_indicator", lg_gtk_menu_item_set_reserve_indicator, 2, 0, 0, H_gtk_menu_item_set_reserve_indicator, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_item_get_reserve_indicator", lg_gtk_menu_item_get_reserve_indicator, 1, 0, 0, H_gtk_menu_item_get_reserve_indicator, pl_bu);
  s7_define_typed_function(sc, "gtk_menu_shell_get_selected_item", lg_gtk_menu_shell_get_selected_item, 1, 0, 0, H_gtk_menu_shell_get_selected_item, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_shell_get_parent_shell", lg_gtk_menu_shell_get_parent_shell, 1, 0, 0, H_gtk_menu_shell_get_parent_shell, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_data_get_data_with_length", lg_gtk_selection_data_get_data_with_length, 1, 1, 0, H_gtk_selection_data_get_data_with_length, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_previous", lg_gtk_tree_model_iter_previous, 2, 0, 0, H_gtk_tree_model_iter_previous, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_is_blank_at_pos", lg_gtk_tree_view_is_blank_at_pos, 3, 4, 0, H_gtk_tree_view_is_blank_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_widget_set_device_enabled", lg_gtk_widget_set_device_enabled, 3, 0, 0, H_gtk_widget_set_device_enabled, pl_tuub);
  s7_define_typed_function(sc, "gtk_widget_get_device_enabled", lg_gtk_widget_get_device_enabled, 2, 0, 0, H_gtk_widget_get_device_enabled, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_has_user_ref_count", lg_gtk_window_set_has_user_ref_count, 2, 0, 0, H_gtk_window_set_has_user_ref_count, pl_tub);
  s7_define_typed_function(sc, "gdk_selection_send_notify", lg_gdk_selection_send_notify, 5, 0, 0, H_gdk_selection_send_notify, pl_tuttti);
  s7_define_typed_function(sc, "gdk_selection_send_notify_for_display", lg_gdk_selection_send_notify_for_display, 6, 0, 0, H_gdk_selection_send_notify_for_display, pl_tuuttti);
  s7_define_typed_function(sc, "gdk_rgba_copy", lg_gdk_rgba_copy, 1, 0, 0, H_gdk_rgba_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_rgba_free", lg_gdk_rgba_free, 1, 0, 0, H_gdk_rgba_free, pl_tu);
  s7_define_typed_function(sc, "gdk_rgba_parse", lg_gdk_rgba_parse, 2, 0, 0, H_gdk_rgba_parse, pl_bus);
  s7_define_typed_function(sc, "gdk_rgba_to_string", lg_gdk_rgba_to_string, 1, 0, 0, H_gdk_rgba_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_state_flags", lg_gtk_widget_set_state_flags, 3, 0, 0, H_gtk_widget_set_state_flags, pl_tugb);
  s7_define_typed_function(sc, "gtk_widget_unset_state_flags", lg_gtk_widget_unset_state_flags, 2, 0, 0, H_gtk_widget_unset_state_flags, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_state_flags", lg_gtk_widget_get_state_flags, 1, 0, 0, H_gtk_widget_get_state_flags, pl_gu);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "gtk_entry_get_placeholder_text", lg_gtk_entry_get_placeholder_text, 1, 0, 0, H_gtk_entry_get_placeholder_text, pl_su);
  s7_define_typed_function(sc, "gtk_entry_set_placeholder_text", lg_gtk_entry_set_placeholder_text, 2, 0, 0, H_gtk_entry_set_placeholder_text, pl_tus);
  s7_define_typed_function(sc, "gtk_expander_set_resize_toplevel", lg_gtk_expander_set_resize_toplevel, 2, 0, 0, H_gtk_expander_set_resize_toplevel, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_resize_toplevel", lg_gtk_expander_get_resize_toplevel, 1, 0, 0, H_gtk_expander_get_resize_toplevel, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_path_to_string", lg_gtk_widget_path_to_string, 1, 0, 0, H_gtk_widget_path_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_button_box_get_child_non_homogeneous", lg_gtk_button_box_get_child_non_homogeneous, 2, 0, 0, H_gtk_button_box_get_child_non_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_button_box_set_child_non_homogeneous", lg_gtk_button_box_set_child_non_homogeneous, 3, 0, 0, H_gtk_button_box_set_child_non_homogeneous, pl_tuub);
  s7_define_typed_function(sc, "gtk_container_child_notify", lg_gtk_container_child_notify, 3, 0, 0, H_gtk_container_child_notify, pl_tuus);
  s7_define_typed_function(sc, "gtk_drag_source_set_icon_gicon", lg_gtk_drag_source_set_icon_gicon, 2, 0, 0, H_gtk_drag_source_set_icon_gicon, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_set_icon_gicon", lg_gtk_drag_set_icon_gicon, 4, 0, 0, H_gtk_drag_set_icon_gicon, pl_tuui);
  s7_define_typed_function(sc, "gtk_combo_box_set_active_id", lg_gtk_combo_box_set_active_id, 2, 0, 0, H_gtk_combo_box_set_active_id, pl_bus);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_x_offset", lg_gtk_tree_view_column_get_x_offset, 1, 0, 0, H_gtk_tree_view_column_get_x_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_overlay_new", lg_gtk_overlay_new, 0, 0, 0, H_gtk_overlay_new, pl_p);
  s7_define_typed_function(sc, "gtk_overlay_add_overlay", lg_gtk_overlay_add_overlay, 2, 0, 0, H_gtk_overlay_add_overlay, pl_tu);
  s7_define_typed_function(sc, "gtk_adjustment_get_minimum_increment", lg_gtk_adjustment_get_minimum_increment, 1, 0, 0, H_gtk_adjustment_get_minimum_increment, pl_du);
  s7_define_typed_function(sc, "gtk_grid_insert_row", lg_gtk_grid_insert_row, 2, 0, 0, H_gtk_grid_insert_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_insert_column", lg_gtk_grid_insert_column, 2, 0, 0, H_gtk_grid_insert_column, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_insert_next_to", lg_gtk_grid_insert_next_to, 3, 0, 0, H_gtk_grid_insert_next_to, pl_tuug);
  s7_define_typed_function(sc, "gtk_text_iter_assign", lg_gtk_text_iter_assign, 2, 0, 0, H_gtk_text_iter_assign, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_has_visible_focus", lg_gtk_widget_has_visible_focus, 1, 0, 0, H_gtk_widget_has_visible_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_focus_visible", lg_gtk_window_set_focus_visible, 2, 0, 0, H_gtk_window_set_focus_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_focus_visible", lg_gtk_window_get_focus_visible, 1, 0, 0, H_gtk_window_get_focus_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_font_chooser_dialog_new", lg_gtk_font_chooser_dialog_new, 2, 0, 0, H_gtk_font_chooser_dialog_new, pl_psu);
  s7_define_typed_function(sc, "gdk_event_get_button", lg_gdk_event_get_button, 2, 0, 0, H_gdk_event_get_button, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_click_count", lg_gdk_event_get_click_count, 2, 0, 0, H_gdk_event_get_click_count, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_keyval", lg_gdk_event_get_keyval, 2, 0, 0, H_gdk_event_get_keyval, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_keycode", lg_gdk_event_get_keycode, 2, 0, 0, H_gdk_event_get_keycode, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_scroll_direction", lg_gdk_event_get_scroll_direction, 1, 1, 0, H_gdk_event_get_scroll_direction, pl_pu);
  s7_define_typed_function(sc, "gtk_grid_get_child_at", lg_gtk_grid_get_child_at, 3, 0, 0, H_gtk_grid_get_child_at, pl_pui);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_family", lg_gtk_font_chooser_get_font_family, 1, 0, 0, H_gtk_font_chooser_get_font_family, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_face", lg_gtk_font_chooser_get_font_face, 1, 0, 0, H_gtk_font_chooser_get_font_face, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_size", lg_gtk_font_chooser_get_font_size, 1, 0, 0, H_gtk_font_chooser_get_font_size, pl_iu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_desc", lg_gtk_font_chooser_get_font_desc, 1, 0, 0, H_gtk_font_chooser_get_font_desc, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_set_font_desc", lg_gtk_font_chooser_set_font_desc, 2, 0, 0, H_gtk_font_chooser_set_font_desc, pl_tu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font", lg_gtk_font_chooser_get_font, 1, 0, 0, H_gtk_font_chooser_get_font, pl_su);
  s7_define_typed_function(sc, "gtk_font_chooser_set_font", lg_gtk_font_chooser_set_font, 2, 0, 0, H_gtk_font_chooser_set_font, pl_tus);
  s7_define_typed_function(sc, "gtk_font_chooser_get_preview_text", lg_gtk_font_chooser_get_preview_text, 1, 0, 0, H_gtk_font_chooser_get_preview_text, pl_su);
  s7_define_typed_function(sc, "gtk_font_chooser_set_preview_text", lg_gtk_font_chooser_set_preview_text, 2, 0, 0, H_gtk_font_chooser_set_preview_text, pl_tus);
  s7_define_typed_function(sc, "gtk_font_chooser_get_show_preview_entry", lg_gtk_font_chooser_get_show_preview_entry, 1, 0, 0, H_gtk_font_chooser_get_show_preview_entry, pl_bu);
  s7_define_typed_function(sc, "gtk_font_chooser_set_show_preview_entry", lg_gtk_font_chooser_set_show_preview_entry, 2, 0, 0, H_gtk_font_chooser_set_show_preview_entry, pl_tub);
  s7_define_typed_function(sc, "gtk_font_chooser_widget_new", lg_gtk_font_chooser_widget_new, 0, 0, 0, H_gtk_font_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "gdk_keymap_get_modifier_mask", lg_gdk_keymap_get_modifier_mask, 2, 0, 0, H_gdk_keymap_get_modifier_mask, pl_gug);
  s7_define_typed_function(sc, "gdk_window_begin_resize_drag_for_device", lg_gdk_window_begin_resize_drag_for_device, 7, 0, 0, H_gdk_window_begin_resize_drag_for_device, pl_tugui);
  s7_define_typed_function(sc, "gdk_window_begin_move_drag_for_device", lg_gdk_window_begin_move_drag_for_device, 6, 0, 0, H_gdk_window_begin_move_drag_for_device, pl_tuui);
  s7_define_typed_function(sc, "gtk_accelerator_parse_with_keycode", lg_gtk_accelerator_parse_with_keycode, 4, 0, 0, H_gtk_accelerator_parse_with_keycode, pl_tsu);
  s7_define_typed_function(sc, "gtk_accelerator_name_with_keycode", lg_gtk_accelerator_name_with_keycode, 4, 0, 0, H_gtk_accelerator_name_with_keycode, pl_suiig);
  s7_define_typed_function(sc, "gtk_accelerator_get_label_with_keycode", lg_gtk_accelerator_get_label_with_keycode, 4, 0, 0, H_gtk_accelerator_get_label_with_keycode, pl_suiig);
  s7_define_typed_function(sc, "gtk_application_get_app_menu", lg_gtk_application_get_app_menu, 1, 0, 0, H_gtk_application_get_app_menu, pl_pu);
  s7_define_typed_function(sc, "gtk_application_set_app_menu", lg_gtk_application_set_app_menu, 2, 0, 0, H_gtk_application_set_app_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_application_get_menubar", lg_gtk_application_get_menubar, 1, 0, 0, H_gtk_application_get_menubar, pl_pu);
  s7_define_typed_function(sc, "gtk_application_set_menubar", lg_gtk_application_set_menubar, 2, 0, 0, H_gtk_application_set_menubar, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_compute_prefix", lg_gtk_entry_completion_compute_prefix, 2, 0, 0, H_gtk_entry_completion_compute_prefix, pl_sus);
  s7_define_typed_function(sc, "gtk_scale_set_has_origin", lg_gtk_scale_set_has_origin, 2, 0, 0, H_gtk_scale_set_has_origin, pl_tub);
  s7_define_typed_function(sc, "gtk_scale_get_has_origin", lg_gtk_scale_get_has_origin, 1, 0, 0, H_gtk_scale_get_has_origin, pl_bu);
  s7_define_typed_function(sc, "gtk_application_window_new", lg_gtk_application_window_new, 1, 0, 0, H_gtk_application_window_new, pl_pu);
  s7_define_typed_function(sc, "gtk_application_window_set_show_menubar", lg_gtk_application_window_set_show_menubar, 2, 0, 0, H_gtk_application_window_set_show_menubar, pl_tub);
  s7_define_typed_function(sc, "gtk_application_window_get_show_menubar", lg_gtk_application_window_get_show_menubar, 1, 0, 0, H_gtk_application_window_get_show_menubar, pl_bu);
  s7_define_typed_function(sc, "gtk_image_new_from_resource", lg_gtk_image_new_from_resource, 1, 0, 0, H_gtk_image_new_from_resource, pl_ps);
  s7_define_typed_function(sc, "gtk_image_set_from_resource", lg_gtk_image_set_from_resource, 2, 0, 0, H_gtk_image_set_from_resource, pl_tus);
  s7_define_typed_function(sc, "gtk_window_set_attached_to", lg_gtk_window_set_attached_to, 2, 0, 0, H_gtk_window_set_attached_to, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_attached_to", lg_gtk_window_get_attached_to, 1, 0, 0, H_gtk_window_get_attached_to, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_add_credit_section", lg_gtk_about_dialog_add_credit_section, 3, 0, 0, H_gtk_about_dialog_add_credit_section, pl_tusu);
  s7_define_typed_function(sc, "gdk_keymap_get_modifier_state", lg_gdk_keymap_get_modifier_state, 1, 0, 0, H_gdk_keymap_get_modifier_state, pl_iu);
  s7_define_typed_function(sc, "gtk_hsv_to_rgb", lg_gtk_hsv_to_rgb, 3, 3, 0, H_gtk_hsv_to_rgb, pl_prrru);
  s7_define_typed_function(sc, "gtk_rgb_to_hsv", lg_gtk_rgb_to_hsv, 3, 3, 0, H_gtk_rgb_to_hsv, pl_prrru);
  s7_define_typed_function(sc, "gtk_color_chooser_get_rgba", lg_gtk_color_chooser_get_rgba, 2, 0, 0, H_gtk_color_chooser_get_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_color_chooser_set_rgba", lg_gtk_color_chooser_set_rgba, 2, 0, 0, H_gtk_color_chooser_set_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_color_chooser_get_use_alpha", lg_gtk_color_chooser_get_use_alpha, 1, 0, 0, H_gtk_color_chooser_get_use_alpha, pl_bu);
  s7_define_typed_function(sc, "gtk_color_chooser_set_use_alpha", lg_gtk_color_chooser_set_use_alpha, 2, 0, 0, H_gtk_color_chooser_set_use_alpha, pl_tub);
  s7_define_typed_function(sc, "gtk_color_chooser_dialog_new", lg_gtk_color_chooser_dialog_new, 2, 0, 0, H_gtk_color_chooser_dialog_new, pl_psu);
  s7_define_typed_function(sc, "gtk_color_chooser_widget_new", lg_gtk_color_chooser_widget_new, 0, 0, 0, H_gtk_color_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "gdk_event_get_scroll_deltas", lg_gdk_event_get_scroll_deltas, 1, 2, 0, H_gdk_event_get_scroll_deltas, pl_pu);
  s7_define_typed_function(sc, "gtk_color_chooser_add_palette", lg_gtk_color_chooser_add_palette, 5, 0, 0, H_gtk_color_chooser_add_palette, pl_tugiiu);
  s7_define_typed_function(sc, "gtk_tree_view_get_n_columns", lg_gtk_tree_view_get_n_columns, 1, 0, 0, H_gtk_tree_view_get_n_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_button_new", lg_gtk_menu_button_new, 0, 0, 0, H_gtk_menu_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_menu_button_set_menu_model", lg_gtk_menu_button_set_menu_model, 2, 0, 0, H_gtk_menu_button_set_menu_model, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_get_menu_model", lg_gtk_menu_button_get_menu_model, 1, 0, 0, H_gtk_menu_button_get_menu_model, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_button_set_align_widget", lg_gtk_menu_button_set_align_widget, 2, 0, 0, H_gtk_menu_button_set_align_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_get_align_widget", lg_gtk_menu_button_get_align_widget, 1, 0, 0, H_gtk_menu_button_get_align_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_search_entry_new", lg_gtk_search_entry_new, 0, 0, 0, H_gtk_search_entry_new, pl_p);
  s7_define_typed_function(sc, "gtk_level_bar_new", lg_gtk_level_bar_new, 0, 0, 0, H_gtk_level_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_level_bar_new_for_interval", lg_gtk_level_bar_new_for_interval, 2, 0, 0, H_gtk_level_bar_new_for_interval, pl_pr);
  s7_define_typed_function(sc, "gtk_level_bar_set_mode", lg_gtk_level_bar_set_mode, 2, 0, 0, H_gtk_level_bar_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_level_bar_get_mode", lg_gtk_level_bar_get_mode, 1, 0, 0, H_gtk_level_bar_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_level_bar_set_value", lg_gtk_level_bar_set_value, 2, 0, 0, H_gtk_level_bar_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_value", lg_gtk_level_bar_get_value, 1, 0, 0, H_gtk_level_bar_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_set_min_value", lg_gtk_level_bar_set_min_value, 2, 0, 0, H_gtk_level_bar_set_min_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_min_value", lg_gtk_level_bar_get_min_value, 1, 0, 0, H_gtk_level_bar_get_min_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_set_max_value", lg_gtk_level_bar_set_max_value, 2, 0, 0, H_gtk_level_bar_set_max_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_max_value", lg_gtk_level_bar_get_max_value, 1, 0, 0, H_gtk_level_bar_get_max_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_add_offset_value", lg_gtk_level_bar_add_offset_value, 3, 0, 0, H_gtk_level_bar_add_offset_value, pl_tusr);
  s7_define_typed_function(sc, "gtk_level_bar_remove_offset_value", lg_gtk_level_bar_remove_offset_value, 2, 0, 0, H_gtk_level_bar_remove_offset_value, pl_tus);
  s7_define_typed_function(sc, "gtk_level_bar_get_offset_value", lg_gtk_level_bar_get_offset_value, 2, 1, 0, H_gtk_level_bar_get_offset_value, pl_pusu);
  s7_define_typed_function(sc, "gtk_application_get_active_window", lg_gtk_application_get_active_window, 1, 0, 0, H_gtk_application_get_active_window, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_input_purpose", lg_gtk_entry_set_input_purpose, 2, 0, 0, H_gtk_entry_set_input_purpose, pl_tug);
  s7_define_typed_function(sc, "gtk_entry_get_input_purpose", lg_gtk_entry_get_input_purpose, 1, 0, 0, H_gtk_entry_get_input_purpose, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_input_hints", lg_gtk_entry_set_input_hints, 2, 0, 0, H_gtk_entry_set_input_hints, pl_tug);
  s7_define_typed_function(sc, "gtk_entry_get_input_hints", lg_gtk_entry_get_input_hints, 1, 0, 0, H_gtk_entry_get_input_hints, pl_gu);
  s7_define_typed_function(sc, "gtk_menu_button_get_popup", lg_gtk_menu_button_get_popup, 1, 0, 0, H_gtk_menu_button_get_popup, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_set_input_purpose", lg_gtk_text_view_set_input_purpose, 2, 0, 0, H_gtk_text_view_set_input_purpose, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_input_purpose", lg_gtk_text_view_get_input_purpose, 1, 0, 0, H_gtk_text_view_get_input_purpose, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_input_hints", lg_gtk_text_view_set_input_hints, 2, 0, 0, H_gtk_text_view_set_input_hints, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_input_hints", lg_gtk_text_view_get_input_hints, 1, 0, 0, H_gtk_text_view_get_input_hints, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_attributes", lg_gtk_entry_set_attributes, 2, 0, 0, H_gtk_entry_set_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_attributes", lg_gtk_entry_get_attributes, 1, 0, 0, H_gtk_entry_get_attributes, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_label_set_accel", lg_gtk_accel_label_set_accel, 3, 0, 0, H_gtk_accel_label_set_accel, pl_tuig);
  s7_define_typed_function(sc, "gtk_menu_shell_bind_model", lg_gtk_menu_shell_bind_model, 4, 0, 0, H_gtk_menu_shell_bind_model, pl_tuusb);
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  s7_define_typed_function(sc, "gtk_level_bar_set_inverted", lg_gtk_level_bar_set_inverted, 2, 0, 0, H_gtk_level_bar_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_level_bar_get_inverted", lg_gtk_level_bar_get_inverted, 1, 0, 0, H_gtk_level_bar_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_visible", lg_gtk_widget_is_visible, 1, 0, 0, H_gtk_widget_is_visible, pl_bu);
  s7_define_typed_function(sc, "gdk_window_set_fullscreen_mode", lg_gdk_window_set_fullscreen_mode, 2, 0, 0, H_gdk_window_set_fullscreen_mode, pl_tug);
  s7_define_typed_function(sc, "gdk_window_get_fullscreen_mode", lg_gdk_window_get_fullscreen_mode, 1, 0, 0, H_gdk_window_get_fullscreen_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_icon_view_set_activate_on_single_click", lg_gtk_icon_view_set_activate_on_single_click, 2, 0, 0, H_gtk_icon_view_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_activate_on_single_click", lg_gtk_icon_view_get_activate_on_single_click, 1, 0, 0, H_gtk_icon_view_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_activate_on_single_click", lg_gtk_tree_view_get_activate_on_single_click, 1, 0, 0, H_gtk_tree_view_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_activate_on_single_click", lg_gtk_tree_view_set_activate_on_single_click, 2, 0, 0, H_gtk_tree_view_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_register_window", lg_gtk_widget_register_window, 2, 0, 0, H_gtk_widget_register_window, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_unregister_window", lg_gtk_widget_unregister_window, 2, 0, 0, H_gtk_widget_unregister_window, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_opacity", lg_gtk_widget_set_opacity, 2, 0, 0, H_gtk_widget_set_opacity, pl_tur);
  s7_define_typed_function(sc, "gtk_widget_get_opacity", lg_gtk_widget_get_opacity, 1, 0, 0, H_gtk_widget_get_opacity, pl_du);
  s7_define_typed_function(sc, "pango_font_map_changed", lg_pango_font_map_changed, 1, 0, 0, H_pango_font_map_changed, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "gdk_set_allowed_backends", lg_gdk_set_allowed_backends, 1, 0, 0, H_gdk_set_allowed_backends, pl_ts);
  s7_define_typed_function(sc, "gtk_box_set_baseline_position", lg_gtk_box_set_baseline_position, 2, 0, 0, H_gtk_box_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_box_get_baseline_position", lg_gtk_box_get_baseline_position, 1, 0, 0, H_gtk_box_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gtk_grid_remove_row", lg_gtk_grid_remove_row, 2, 0, 0, H_gtk_grid_remove_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_remove_column", lg_gtk_grid_remove_column, 2, 0, 0, H_gtk_grid_remove_column, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_set_row_baseline_position", lg_gtk_grid_set_row_baseline_position, 3, 0, 0, H_gtk_grid_set_row_baseline_position, pl_tuig);
  s7_define_typed_function(sc, "gtk_grid_get_row_baseline_position", lg_gtk_grid_get_row_baseline_position, 2, 0, 0, H_gtk_grid_get_row_baseline_position, pl_gui);
  s7_define_typed_function(sc, "gtk_grid_set_baseline_row", lg_gtk_grid_set_baseline_row, 2, 0, 0, H_gtk_grid_set_baseline_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_baseline_row", lg_gtk_grid_get_baseline_row, 1, 0, 0, H_gtk_grid_get_baseline_row, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_baseline", lg_gtk_widget_get_allocated_baseline, 1, 0, 0, H_gtk_widget_get_allocated_baseline, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_init_template", lg_gtk_widget_init_template, 1, 0, 0, H_gtk_widget_init_template, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_titlebar", lg_gtk_window_set_titlebar, 2, 0, 0, H_gtk_window_set_titlebar, pl_tu);
  s7_define_typed_function(sc, "gtk_places_sidebar_new", lg_gtk_places_sidebar_new, 0, 0, 0, H_gtk_places_sidebar_new, pl_p);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_open_flags", lg_gtk_places_sidebar_get_open_flags, 1, 0, 0, H_gtk_places_sidebar_get_open_flags, pl_gu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_open_flags", lg_gtk_places_sidebar_set_open_flags, 2, 0, 0, H_gtk_places_sidebar_set_open_flags, pl_tug);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_location", lg_gtk_places_sidebar_get_location, 1, 0, 0, H_gtk_places_sidebar_get_location, pl_pu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_location", lg_gtk_places_sidebar_set_location, 2, 0, 0, H_gtk_places_sidebar_set_location, pl_tu);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_show_desktop", lg_gtk_places_sidebar_get_show_desktop, 1, 0, 0, H_gtk_places_sidebar_get_show_desktop, pl_bu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_show_desktop", lg_gtk_places_sidebar_set_show_desktop, 2, 0, 0, H_gtk_places_sidebar_set_show_desktop, pl_tub);
  s7_define_typed_function(sc, "gtk_places_sidebar_add_shortcut", lg_gtk_places_sidebar_add_shortcut, 2, 0, 0, H_gtk_places_sidebar_add_shortcut, pl_tu);
  s7_define_typed_function(sc, "gtk_places_sidebar_remove_shortcut", lg_gtk_places_sidebar_remove_shortcut, 2, 0, 0, H_gtk_places_sidebar_remove_shortcut, pl_tu);
  s7_define_typed_function(sc, "gtk_places_sidebar_list_shortcuts", lg_gtk_places_sidebar_list_shortcuts, 1, 0, 0, H_gtk_places_sidebar_list_shortcuts, pl_pu);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_nth_bookmark", lg_gtk_places_sidebar_get_nth_bookmark, 2, 0, 0, H_gtk_places_sidebar_get_nth_bookmark, pl_pui);
  s7_define_typed_function(sc, "gtk_stack_switcher_new", lg_gtk_stack_switcher_new, 0, 0, 0, H_gtk_stack_switcher_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_switcher_set_stack", lg_gtk_stack_switcher_set_stack, 2, 0, 0, H_gtk_stack_switcher_set_stack, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_switcher_get_stack", lg_gtk_stack_switcher_get_stack, 1, 0, 0, H_gtk_stack_switcher_get_stack, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_new", lg_gtk_stack_new, 0, 0, 0, H_gtk_stack_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_add_named", lg_gtk_stack_add_named, 3, 0, 0, H_gtk_stack_add_named, pl_tuus);
  s7_define_typed_function(sc, "gtk_stack_add_titled", lg_gtk_stack_add_titled, 4, 0, 0, H_gtk_stack_add_titled, pl_tuus);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child", lg_gtk_stack_set_visible_child, 2, 0, 0, H_gtk_stack_set_visible_child, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_get_visible_child", lg_gtk_stack_get_visible_child, 1, 0, 0, H_gtk_stack_get_visible_child, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child_name", lg_gtk_stack_set_visible_child_name, 2, 0, 0, H_gtk_stack_set_visible_child_name, pl_tus);
  s7_define_typed_function(sc, "gtk_stack_get_visible_child_name", lg_gtk_stack_get_visible_child_name, 1, 0, 0, H_gtk_stack_get_visible_child_name, pl_su);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child_full", lg_gtk_stack_set_visible_child_full, 3, 0, 0, H_gtk_stack_set_visible_child_full, pl_tusg);
  s7_define_typed_function(sc, "gtk_stack_set_homogeneous", lg_gtk_stack_set_homogeneous, 2, 0, 0, H_gtk_stack_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_homogeneous", lg_gtk_stack_get_homogeneous, 1, 0, 0, H_gtk_stack_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_set_transition_duration", lg_gtk_stack_set_transition_duration, 2, 0, 0, H_gtk_stack_set_transition_duration, pl_tui);
  s7_define_typed_function(sc, "gtk_stack_get_transition_duration", lg_gtk_stack_get_transition_duration, 1, 0, 0, H_gtk_stack_get_transition_duration, pl_iu);
  s7_define_typed_function(sc, "gtk_stack_set_transition_type", lg_gtk_stack_set_transition_type, 2, 0, 0, H_gtk_stack_set_transition_type, pl_tug);
  s7_define_typed_function(sc, "gtk_stack_get_transition_type", lg_gtk_stack_get_transition_type, 1, 0, 0, H_gtk_stack_get_transition_type, pl_gu);
  s7_define_typed_function(sc, "gtk_revealer_new", lg_gtk_revealer_new, 0, 0, 0, H_gtk_revealer_new, pl_p);
  s7_define_typed_function(sc, "gtk_revealer_get_reveal_child", lg_gtk_revealer_get_reveal_child, 1, 0, 0, H_gtk_revealer_get_reveal_child, pl_bu);
  s7_define_typed_function(sc, "gtk_revealer_set_reveal_child", lg_gtk_revealer_set_reveal_child, 2, 0, 0, H_gtk_revealer_set_reveal_child, pl_tub);
  s7_define_typed_function(sc, "gtk_revealer_get_child_revealed", lg_gtk_revealer_get_child_revealed, 1, 0, 0, H_gtk_revealer_get_child_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_revealer_get_transition_duration", lg_gtk_revealer_get_transition_duration, 1, 0, 0, H_gtk_revealer_get_transition_duration, pl_iu);
  s7_define_typed_function(sc, "gtk_revealer_set_transition_duration", lg_gtk_revealer_set_transition_duration, 2, 0, 0, H_gtk_revealer_set_transition_duration, pl_tui);
  s7_define_typed_function(sc, "gtk_revealer_set_transition_type", lg_gtk_revealer_set_transition_type, 2, 0, 0, H_gtk_revealer_set_transition_type, pl_tug);
  s7_define_typed_function(sc, "gtk_revealer_get_transition_type", lg_gtk_revealer_get_transition_type, 1, 0, 0, H_gtk_revealer_get_transition_type, pl_gu);
  s7_define_typed_function(sc, "gtk_header_bar_new", lg_gtk_header_bar_new, 0, 0, 0, H_gtk_header_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_header_bar_set_title", lg_gtk_header_bar_set_title, 2, 0, 0, H_gtk_header_bar_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_title", lg_gtk_header_bar_get_title, 1, 0, 0, H_gtk_header_bar_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_header_bar_set_subtitle", lg_gtk_header_bar_set_subtitle, 2, 0, 0, H_gtk_header_bar_set_subtitle, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_subtitle", lg_gtk_header_bar_get_subtitle, 1, 0, 0, H_gtk_header_bar_get_subtitle, pl_su);
  s7_define_typed_function(sc, "gtk_header_bar_set_custom_title", lg_gtk_header_bar_set_custom_title, 2, 0, 0, H_gtk_header_bar_set_custom_title, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_get_custom_title", lg_gtk_header_bar_get_custom_title, 1, 0, 0, H_gtk_header_bar_get_custom_title, pl_pu);
  s7_define_typed_function(sc, "gtk_header_bar_pack_start", lg_gtk_header_bar_pack_start, 2, 0, 0, H_gtk_header_bar_pack_start, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_pack_end", lg_gtk_header_bar_pack_end, 2, 0, 0, H_gtk_header_bar_pack_end, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_row_new", lg_gtk_list_box_row_new, 0, 0, 0, H_gtk_list_box_row_new, pl_p);
  s7_define_typed_function(sc, "gtk_list_box_row_get_header", lg_gtk_list_box_row_get_header, 1, 0, 0, H_gtk_list_box_row_get_header, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_row_set_header", lg_gtk_list_box_row_set_header, 2, 0, 0, H_gtk_list_box_row_set_header, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_row_changed", lg_gtk_list_box_row_changed, 1, 0, 0, H_gtk_list_box_row_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_get_selected_row", lg_gtk_list_box_get_selected_row, 1, 0, 0, H_gtk_list_box_get_selected_row, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_get_row_at_index", lg_gtk_list_box_get_row_at_index, 2, 0, 0, H_gtk_list_box_get_row_at_index, pl_pui);
  s7_define_typed_function(sc, "gtk_list_box_get_row_at_y", lg_gtk_list_box_get_row_at_y, 2, 0, 0, H_gtk_list_box_get_row_at_y, pl_pui);
  s7_define_typed_function(sc, "gtk_list_box_select_row", lg_gtk_list_box_select_row, 2, 0, 0, H_gtk_list_box_select_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_placeholder", lg_gtk_list_box_set_placeholder, 2, 0, 0, H_gtk_list_box_set_placeholder, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_adjustment", lg_gtk_list_box_set_adjustment, 2, 0, 0, H_gtk_list_box_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_get_adjustment", lg_gtk_list_box_get_adjustment, 1, 0, 0, H_gtk_list_box_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_set_selection_mode", lg_gtk_list_box_set_selection_mode, 2, 0, 0, H_gtk_list_box_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_list_box_get_selection_mode", lg_gtk_list_box_get_selection_mode, 1, 0, 0, H_gtk_list_box_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_filter", lg_gtk_list_box_invalidate_filter, 1, 0, 0, H_gtk_list_box_invalidate_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_sort", lg_gtk_list_box_invalidate_sort, 1, 0, 0, H_gtk_list_box_invalidate_sort, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_headers", lg_gtk_list_box_invalidate_headers, 1, 0, 0, H_gtk_list_box_invalidate_headers, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_activate_on_single_click", lg_gtk_list_box_set_activate_on_single_click, 2, 0, 0, H_gtk_list_box_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_get_activate_on_single_click", lg_gtk_list_box_get_activate_on_single_click, 1, 0, 0, H_gtk_list_box_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_drag_unhighlight_row", lg_gtk_list_box_drag_unhighlight_row, 1, 0, 0, H_gtk_list_box_drag_unhighlight_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_drag_highlight_row", lg_gtk_list_box_drag_highlight_row, 2, 0, 0, H_gtk_list_box_drag_highlight_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_new", lg_gtk_list_box_new, 0, 0, 0, H_gtk_list_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_search_bar_new", lg_gtk_search_bar_new, 0, 0, 0, H_gtk_search_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_search_bar_connect_entry", lg_gtk_search_bar_connect_entry, 2, 0, 0, H_gtk_search_bar_connect_entry, pl_tu);
  s7_define_typed_function(sc, "gtk_search_bar_get_search_mode", lg_gtk_search_bar_get_search_mode, 1, 0, 0, H_gtk_search_bar_get_search_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_search_bar_set_search_mode", lg_gtk_search_bar_set_search_mode, 2, 0, 0, H_gtk_search_bar_set_search_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_search_bar_get_show_close_button", lg_gtk_search_bar_get_show_close_button, 1, 0, 0, H_gtk_search_bar_get_show_close_button, pl_bu);
  s7_define_typed_function(sc, "gtk_search_bar_set_show_close_button", lg_gtk_search_bar_set_show_close_button, 2, 0, 0, H_gtk_search_bar_set_show_close_button, pl_tub);
  s7_define_typed_function(sc, "gtk_search_bar_handle_event", lg_gtk_search_bar_handle_event, 2, 0, 0, H_gtk_search_bar_handle_event, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_name", lg_gtk_file_chooser_get_current_name, 1, 0, 0, H_gtk_file_chooser_get_current_name, pl_su);
  s7_define_typed_function(sc, "gdk_cairo_surface_create_from_pixbuf", lg_gdk_cairo_surface_create_from_pixbuf, 3, 0, 0, H_gdk_cairo_surface_create_from_pixbuf, pl_puiu);
  s7_define_typed_function(sc, "gdk_device_get_position_double", lg_gdk_device_get_position_double, 1, 3, 0, H_gdk_device_get_position_double, pl_pu);
  s7_define_typed_function(sc, "gdk_device_get_window_at_position_double", lg_gdk_device_get_window_at_position_double, 1, 2, 0, H_gdk_device_get_window_at_position_double, pl_pu);
  s7_define_typed_function(sc, "gdk_window_get_scale_factor", lg_gdk_window_get_scale_factor, 1, 0, 0, H_gdk_window_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gdk_window_get_device_position_double", lg_gdk_window_get_device_position_double, 2, 3, 0, H_gdk_window_get_device_position_double, pl_pu);
  s7_define_typed_function(sc, "gdk_window_create_similar_image_surface", lg_gdk_window_create_similar_image_surface, 5, 0, 0, H_gdk_window_create_similar_image_surface, pl_pugi);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_icon_for_scale", lg_gtk_icon_theme_lookup_icon_for_scale, 5, 0, 0, H_gtk_icon_theme_lookup_icon_for_scale, pl_pusiig);
  s7_define_typed_function(sc, "gtk_icon_theme_load_icon_for_scale", lg_gtk_icon_theme_load_icon_for_scale, 5, 1, 0, H_gtk_icon_theme_load_icon_for_scale, pl_pusiigu);
  s7_define_typed_function(sc, "gtk_icon_theme_load_surface", lg_gtk_icon_theme_load_surface, 6, 1, 0, H_gtk_icon_theme_load_surface, pl_pusiiugu);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_by_gicon_for_scale", lg_gtk_icon_theme_lookup_by_gicon_for_scale, 5, 0, 0, H_gtk_icon_theme_lookup_by_gicon_for_scale, pl_puuiig);
  s7_define_typed_function(sc, "gtk_icon_info_get_base_scale", lg_gtk_icon_info_get_base_scale, 1, 0, 0, H_gtk_icon_info_get_base_scale, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_info_load_surface", lg_gtk_icon_info_load_surface, 2, 1, 0, H_gtk_icon_info_load_surface, pl_pu);
  s7_define_typed_function(sc, "gtk_image_new_from_surface", lg_gtk_image_new_from_surface, 1, 0, 0, H_gtk_image_new_from_surface, pl_pu);
  s7_define_typed_function(sc, "gtk_image_set_from_surface", lg_gtk_image_set_from_surface, 2, 0, 0, H_gtk_image_set_from_surface, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_row_get_index", lg_gtk_list_box_row_get_index, 1, 0, 0, H_gtk_list_box_row_get_index, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_scale_factor", lg_gtk_widget_get_scale_factor, 1, 0, 0, H_gtk_widget_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gtk_window_close", lg_gtk_window_close, 1, 0, 0, H_gtk_window_close, pl_tu);
  s7_define_typed_function(sc, "gtk_info_bar_set_show_close_button", lg_gtk_info_bar_set_show_close_button, 2, 0, 0, H_gtk_info_bar_set_show_close_button, pl_tub);
  s7_define_typed_function(sc, "gtk_info_bar_get_show_close_button", lg_gtk_info_bar_get_show_close_button, 1, 0, 0, H_gtk_info_bar_get_show_close_button, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_rows_reordered_with_length", lg_gtk_tree_model_rows_reordered_with_length, 5, 0, 0, H_gtk_tree_model_rows_reordered_with_length, pl_tuuuui);
  s7_define_typed_function(sc, "gdk_cursor_new_from_surface", lg_gdk_cursor_new_from_surface, 4, 0, 0, H_gdk_cursor_new_from_surface, pl_puur);
  s7_define_typed_function(sc, "gdk_cursor_get_surface", lg_gdk_cursor_get_surface, 1, 2, 0, H_gdk_cursor_get_surface, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_event_type", lg_gdk_event_get_event_type, 1, 0, 0, H_gdk_event_get_event_type, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_tabs", lg_gtk_entry_set_tabs, 2, 0, 0, H_gtk_entry_set_tabs, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_tabs", lg_gtk_entry_get_tabs, 1, 0, 0, H_gtk_entry_get_tabs, pl_pu);
  s7_define_typed_function(sc, "gtk_header_bar_get_show_close_button", lg_gtk_header_bar_get_show_close_button, 1, 0, 0, H_gtk_header_bar_get_show_close_button, pl_bu);
  s7_define_typed_function(sc, "gtk_header_bar_set_show_close_button", lg_gtk_header_bar_set_show_close_button, 2, 0, 0, H_gtk_header_bar_set_show_close_button, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_prepend", lg_gtk_list_box_prepend, 2, 0, 0, H_gtk_list_box_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_insert", lg_gtk_list_box_insert, 3, 0, 0, H_gtk_list_box_insert, pl_tuui);
  s7_define_typed_function(sc, "gdk_window_set_opaque_region", lg_gdk_window_set_opaque_region, 2, 0, 0, H_gdk_window_set_opaque_region, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_lines", lg_gtk_label_set_lines, 2, 0, 0, H_gtk_label_set_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_lines", lg_gtk_label_get_lines, 1, 0, 0, H_gtk_label_get_lines, pl_iu);
  s7_define_typed_function(sc, "gdk_event_get_window", lg_gdk_event_get_window, 1, 0, 0, H_gdk_event_get_window, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "gtk_flow_box_child_new", lg_gtk_flow_box_child_new, 0, 0, 0, H_gtk_flow_box_child_new, pl_p);
  s7_define_typed_function(sc, "gtk_flow_box_child_get_index", lg_gtk_flow_box_child_get_index, 1, 0, 0, H_gtk_flow_box_child_get_index, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_child_is_selected", lg_gtk_flow_box_child_is_selected, 1, 0, 0, H_gtk_flow_box_child_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_child_changed", lg_gtk_flow_box_child_changed, 1, 0, 0, H_gtk_flow_box_child_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_new", lg_gtk_flow_box_new, 0, 0, 0, H_gtk_flow_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_flow_box_set_homogeneous", lg_gtk_flow_box_set_homogeneous, 2, 0, 0, H_gtk_flow_box_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_flow_box_get_homogeneous", lg_gtk_flow_box_get_homogeneous, 1, 0, 0, H_gtk_flow_box_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_set_row_spacing", lg_gtk_flow_box_set_row_spacing, 2, 0, 0, H_gtk_flow_box_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_row_spacing", lg_gtk_flow_box_get_row_spacing, 1, 0, 0, H_gtk_flow_box_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_column_spacing", lg_gtk_flow_box_set_column_spacing, 2, 0, 0, H_gtk_flow_box_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_column_spacing", lg_gtk_flow_box_get_column_spacing, 1, 0, 0, H_gtk_flow_box_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_min_children_per_line", lg_gtk_flow_box_set_min_children_per_line, 2, 0, 0, H_gtk_flow_box_set_min_children_per_line, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_min_children_per_line", lg_gtk_flow_box_get_min_children_per_line, 1, 0, 0, H_gtk_flow_box_get_min_children_per_line, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_max_children_per_line", lg_gtk_flow_box_set_max_children_per_line, 2, 0, 0, H_gtk_flow_box_set_max_children_per_line, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_max_children_per_line", lg_gtk_flow_box_get_max_children_per_line, 1, 0, 0, H_gtk_flow_box_get_max_children_per_line, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_activate_on_single_click", lg_gtk_flow_box_set_activate_on_single_click, 2, 0, 0, H_gtk_flow_box_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_flow_box_get_activate_on_single_click", lg_gtk_flow_box_get_activate_on_single_click, 1, 0, 0, H_gtk_flow_box_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_insert", lg_gtk_flow_box_insert, 3, 0, 0, H_gtk_flow_box_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_flow_box_get_child_at_index", lg_gtk_flow_box_get_child_at_index, 2, 0, 0, H_gtk_flow_box_get_child_at_index, pl_pui);
  s7_define_typed_function(sc, "gtk_flow_box_get_selected_children", lg_gtk_flow_box_get_selected_children, 1, 0, 0, H_gtk_flow_box_get_selected_children, pl_pu);
  s7_define_typed_function(sc, "gtk_flow_box_select_child", lg_gtk_flow_box_select_child, 2, 0, 0, H_gtk_flow_box_select_child, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_unselect_child", lg_gtk_flow_box_unselect_child, 2, 0, 0, H_gtk_flow_box_unselect_child, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_select_all", lg_gtk_flow_box_select_all, 1, 0, 0, H_gtk_flow_box_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_unselect_all", lg_gtk_flow_box_unselect_all, 1, 0, 0, H_gtk_flow_box_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_set_selection_mode", lg_gtk_flow_box_set_selection_mode, 2, 0, 0, H_gtk_flow_box_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_flow_box_get_selection_mode", lg_gtk_flow_box_get_selection_mode, 1, 0, 0, H_gtk_flow_box_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_flow_box_set_hadjustment", lg_gtk_flow_box_set_hadjustment, 2, 0, 0, H_gtk_flow_box_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_set_vadjustment", lg_gtk_flow_box_set_vadjustment, 2, 0, 0, H_gtk_flow_box_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_invalidate_filter", lg_gtk_flow_box_invalidate_filter, 1, 0, 0, H_gtk_flow_box_invalidate_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_invalidate_sort", lg_gtk_flow_box_invalidate_sort, 1, 0, 0, H_gtk_flow_box_invalidate_sort, pl_tu);
  s7_define_typed_function(sc, "gdk_window_set_event_compression", lg_gdk_window_set_event_compression, 2, 0, 0, H_gdk_window_set_event_compression, pl_tub);
  s7_define_typed_function(sc, "gdk_window_get_event_compression", lg_gdk_window_get_event_compression, 1, 0, 0, H_gdk_window_get_event_compression, pl_bu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_local_only", lg_gtk_places_sidebar_set_local_only, 2, 0, 0, H_gtk_places_sidebar_set_local_only, pl_tub);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_local_only", lg_gtk_places_sidebar_get_local_only, 1, 0, 0, H_gtk_places_sidebar_get_local_only, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_get_transition_running", lg_gtk_stack_get_transition_running, 1, 0, 0, H_gtk_stack_get_transition_running, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_margin_start", lg_gtk_widget_get_margin_start, 1, 0, 0, H_gtk_widget_get_margin_start, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_start", lg_gtk_widget_set_margin_start, 2, 0, 0, H_gtk_widget_set_margin_start, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_margin_end", lg_gtk_widget_get_margin_end, 1, 0, 0, H_gtk_widget_get_margin_end, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_end", lg_gtk_widget_set_margin_end, 2, 0, 0, H_gtk_widget_set_margin_end, pl_tui);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel", lg_gtk_accel_label_get_accel, 1, 2, 0, H_gtk_accel_label_get_accel, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_shadow_width", lg_gdk_window_set_shadow_width, 5, 0, 0, H_gdk_window_set_shadow_width, pl_tui);
  s7_define_typed_function(sc, "gtk_action_bar_new", lg_gtk_action_bar_new, 0, 0, 0, H_gtk_action_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_action_bar_get_center_widget", lg_gtk_action_bar_get_center_widget, 1, 0, 0, H_gtk_action_bar_get_center_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_action_bar_set_center_widget", lg_gtk_action_bar_set_center_widget, 2, 0, 0, H_gtk_action_bar_set_center_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_action_bar_pack_start", lg_gtk_action_bar_pack_start, 2, 0, 0, H_gtk_action_bar_pack_start, pl_tu);
  s7_define_typed_function(sc, "gtk_action_bar_pack_end", lg_gtk_action_bar_pack_end, 2, 0, 0, H_gtk_action_bar_pack_end, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_set_has_subtitle", lg_gtk_header_bar_set_has_subtitle, 2, 0, 0, H_gtk_header_bar_set_has_subtitle, pl_tub);
  s7_define_typed_function(sc, "gtk_header_bar_get_has_subtitle", lg_gtk_header_bar_get_has_subtitle, 1, 0, 0, H_gtk_header_bar_get_has_subtitle, pl_bu);
  s7_define_typed_function(sc, "gtk_header_bar_set_decoration_layout", lg_gtk_header_bar_set_decoration_layout, 2, 0, 0, H_gtk_header_bar_set_decoration_layout, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_decoration_layout", lg_gtk_header_bar_get_decoration_layout, 1, 0, 0, H_gtk_header_bar_get_decoration_layout, pl_su);
  s7_define_typed_function(sc, "gtk_icon_info_is_symbolic", lg_gtk_icon_info_is_symbolic, 1, 0, 0, H_gtk_icon_info_is_symbolic, pl_bu);
  s7_define_typed_function(sc, "gtk_get_locale_direction", lg_gtk_get_locale_direction, 0, 0, 0, H_gtk_get_locale_direction, pl_g);
  s7_define_typed_function(sc, "gtk_window_is_maximized", lg_gtk_window_is_maximized, 1, 0, 0, H_gtk_window_is_maximized, pl_bu);
  s7_define_typed_function(sc, "gtk_dialog_get_header_bar", lg_gtk_dialog_get_header_bar, 1, 0, 0, H_gtk_dialog_get_header_bar, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_new", lg_gtk_popover_new, 1, 0, 0, H_gtk_popover_new, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_set_relative_to", lg_gtk_popover_set_relative_to, 2, 0, 0, H_gtk_popover_set_relative_to, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_get_relative_to", lg_gtk_popover_get_relative_to, 1, 0, 0, H_gtk_popover_get_relative_to, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_set_position", lg_gtk_popover_set_position, 2, 0, 0, H_gtk_popover_set_position, pl_tug);
  s7_define_typed_function(sc, "gtk_popover_get_position", lg_gtk_popover_get_position, 1, 0, 0, H_gtk_popover_get_position, pl_gu);
  s7_define_typed_function(sc, "gtk_popover_set_modal", lg_gtk_popover_set_modal, 2, 0, 0, H_gtk_popover_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_popover_get_modal", lg_gtk_popover_get_modal, 1, 0, 0, H_gtk_popover_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_max_width_chars", lg_gtk_entry_set_max_width_chars, 2, 0, 0, H_gtk_entry_set_max_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_max_width_chars", lg_gtk_entry_get_max_width_chars, 1, 0, 0, H_gtk_entry_get_max_width_chars, pl_iu);
  s7_define_typed_function(sc, "gdk_device_get_last_event_window", lg_gdk_device_get_last_event_window, 1, 0, 0, H_gdk_device_get_last_event_window, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "gtk_list_box_row_is_selected", lg_gtk_list_box_row_is_selected, 1, 0, 0, H_gtk_list_box_row_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_unselect_row", lg_gtk_list_box_unselect_row, 2, 0, 0, H_gtk_list_box_unselect_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_select_all", lg_gtk_list_box_select_all, 1, 0, 0, H_gtk_list_box_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_unselect_all", lg_gtk_list_box_unselect_all, 1, 0, 0, H_gtk_list_box_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_show_enter_location", lg_gtk_places_sidebar_get_show_enter_location, 1, 0, 0, H_gtk_places_sidebar_get_show_enter_location, pl_bu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_show_enter_location", lg_gtk_places_sidebar_set_show_enter_location, 2, 0, 0, H_gtk_places_sidebar_set_show_enter_location, pl_tub);
  s7_define_typed_function(sc, "gtk_switch_set_state", lg_gtk_switch_set_state, 2, 0, 0, H_gtk_switch_set_state, pl_tub);
  s7_define_typed_function(sc, "gtk_switch_get_state", lg_gtk_switch_get_state, 1, 0, 0, H_gtk_switch_get_state, pl_bu);
  s7_define_typed_function(sc, "gdk_window_show_window_menu", lg_gdk_window_show_window_menu, 2, 0, 0, H_gdk_window_show_window_menu, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_clip", lg_gtk_widget_get_clip, 2, 0, 0, H_gtk_widget_get_clip, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_get_device", lg_gtk_gesture_get_device, 1, 0, 0, H_gtk_gesture_get_device, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_set_state", lg_gtk_gesture_set_state, 2, 0, 0, H_gtk_gesture_set_state, pl_bui);
  s7_define_typed_function(sc, "gtk_gesture_get_sequence_state", lg_gtk_gesture_get_sequence_state, 2, 0, 0, H_gtk_gesture_get_sequence_state, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_set_sequence_state", lg_gtk_gesture_set_sequence_state, 3, 0, 0, H_gtk_gesture_set_sequence_state, pl_buui);
  s7_define_typed_function(sc, "gtk_gesture_get_sequences", lg_gtk_gesture_get_sequences, 1, 0, 0, H_gtk_gesture_get_sequences, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_last_updated_sequence", lg_gtk_gesture_get_last_updated_sequence, 1, 0, 0, H_gtk_gesture_get_last_updated_sequence, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_handles_sequence", lg_gtk_gesture_handles_sequence, 2, 0, 0, H_gtk_gesture_handles_sequence, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_get_last_event", lg_gtk_gesture_get_last_event, 2, 0, 0, H_gtk_gesture_get_last_event, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_point", lg_gtk_gesture_get_point, 2, 2, 0, H_gtk_gesture_get_point, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_bounding_box", lg_gtk_gesture_get_bounding_box, 2, 0, 0, H_gtk_gesture_get_bounding_box, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_get_bounding_box_center", lg_gtk_gesture_get_bounding_box_center, 1, 2, 0, H_gtk_gesture_get_bounding_box_center, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_is_active", lg_gtk_gesture_is_active, 1, 0, 0, H_gtk_gesture_is_active, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_is_recognized", lg_gtk_gesture_is_recognized, 1, 0, 0, H_gtk_gesture_is_recognized, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_group", lg_gtk_gesture_group, 2, 0, 0, H_gtk_gesture_group, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_ungroup", lg_gtk_gesture_ungroup, 1, 0, 0, H_gtk_gesture_ungroup, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_get_group", lg_gtk_gesture_get_group, 1, 0, 0, H_gtk_gesture_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_is_grouped_with", lg_gtk_gesture_is_grouped_with, 2, 0, 0, H_gtk_gesture_is_grouped_with, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_drag_new", lg_gtk_gesture_drag_new, 1, 0, 0, H_gtk_gesture_drag_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_drag_get_start_point", lg_gtk_gesture_drag_get_start_point, 1, 2, 0, H_gtk_gesture_drag_get_start_point, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_drag_get_offset", lg_gtk_gesture_drag_get_offset, 1, 2, 0, H_gtk_gesture_drag_get_offset, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_long_press_new", lg_gtk_gesture_long_press_new, 1, 0, 0, H_gtk_gesture_long_press_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_pan_new", lg_gtk_gesture_pan_new, 2, 0, 0, H_gtk_gesture_pan_new, pl_pug);
  s7_define_typed_function(sc, "gtk_gesture_pan_get_orientation", lg_gtk_gesture_pan_get_orientation, 1, 0, 0, H_gtk_gesture_pan_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_gesture_pan_set_orientation", lg_gtk_gesture_pan_set_orientation, 2, 0, 0, H_gtk_gesture_pan_set_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_gesture_multi_press_new", lg_gtk_gesture_multi_press_new, 1, 0, 0, H_gtk_gesture_multi_press_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_multi_press_set_area", lg_gtk_gesture_multi_press_set_area, 2, 0, 0, H_gtk_gesture_multi_press_set_area, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_multi_press_get_area", lg_gtk_gesture_multi_press_get_area, 2, 0, 0, H_gtk_gesture_multi_press_get_area, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_rotate_new", lg_gtk_gesture_rotate_new, 1, 0, 0, H_gtk_gesture_rotate_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_rotate_get_angle_delta", lg_gtk_gesture_rotate_get_angle_delta, 1, 0, 0, H_gtk_gesture_rotate_get_angle_delta, pl_du);
  s7_define_typed_function(sc, "gtk_gesture_single_get_touch_only", lg_gtk_gesture_single_get_touch_only, 1, 0, 0, H_gtk_gesture_single_get_touch_only, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_touch_only", lg_gtk_gesture_single_set_touch_only, 2, 0, 0, H_gtk_gesture_single_set_touch_only, pl_tub);
  s7_define_typed_function(sc, "gtk_gesture_single_get_exclusive", lg_gtk_gesture_single_get_exclusive, 1, 0, 0, H_gtk_gesture_single_get_exclusive, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_exclusive", lg_gtk_gesture_single_set_exclusive, 2, 0, 0, H_gtk_gesture_single_set_exclusive, pl_tub);
  s7_define_typed_function(sc, "gtk_gesture_single_get_button", lg_gtk_gesture_single_get_button, 1, 0, 0, H_gtk_gesture_single_get_button, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_button", lg_gtk_gesture_single_set_button, 2, 0, 0, H_gtk_gesture_single_set_button, pl_tui);
  s7_define_typed_function(sc, "gtk_gesture_single_get_current_button", lg_gtk_gesture_single_get_current_button, 1, 0, 0, H_gtk_gesture_single_get_current_button, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_single_get_current_sequence", lg_gtk_gesture_single_get_current_sequence, 1, 0, 0, H_gtk_gesture_single_get_current_sequence, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_swipe_new", lg_gtk_gesture_swipe_new, 1, 0, 0, H_gtk_gesture_swipe_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_swipe_get_velocity", lg_gtk_gesture_swipe_get_velocity, 1, 2, 0, H_gtk_gesture_swipe_get_velocity, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_zoom_new", lg_gtk_gesture_zoom_new, 1, 0, 0, H_gtk_gesture_zoom_new, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_zoom_get_scale_delta", lg_gtk_gesture_zoom_get_scale_delta, 1, 0, 0, H_gtk_gesture_zoom_get_scale_delta, pl_du);
  s7_define_typed_function(sc, "gtk_event_controller_get_widget", lg_gtk_event_controller_get_widget, 1, 0, 0, H_gtk_event_controller_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_event_controller_handle_event", lg_gtk_event_controller_handle_event, 2, 0, 0, H_gtk_event_controller_handle_event, pl_bu);
  s7_define_typed_function(sc, "gtk_event_controller_reset", lg_gtk_event_controller_reset, 1, 0, 0, H_gtk_event_controller_reset, pl_tu);
  s7_define_typed_function(sc, "gtk_event_controller_get_propagation_phase", lg_gtk_event_controller_get_propagation_phase, 1, 0, 0, H_gtk_event_controller_get_propagation_phase, pl_gu);
  s7_define_typed_function(sc, "gtk_event_controller_set_propagation_phase", lg_gtk_event_controller_set_propagation_phase, 2, 0, 0, H_gtk_event_controller_set_propagation_phase, pl_tug);
  s7_define_typed_function(sc, "gtk_icon_theme_add_resource_path", lg_gtk_icon_theme_add_resource_path, 2, 0, 0, H_gtk_icon_theme_add_resource_path, pl_tus);
  s7_define_typed_function(sc, "gtk_list_box_row_set_activatable", lg_gtk_list_box_row_set_activatable, 2, 0, 0, H_gtk_list_box_row_set_activatable, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_row_get_activatable", lg_gtk_list_box_row_get_activatable, 1, 0, 0, H_gtk_list_box_row_get_activatable, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_row_set_selectable", lg_gtk_list_box_row_set_selectable, 2, 0, 0, H_gtk_list_box_row_set_selectable, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_row_get_selectable", lg_gtk_list_box_row_get_selectable, 1, 0, 0, H_gtk_list_box_row_get_selectable, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_path_iter_get_state", lg_gtk_widget_path_iter_get_state, 2, 0, 0, H_gtk_widget_path_iter_get_state, pl_gui);
  s7_define_typed_function(sc, "gtk_widget_path_iter_set_state", lg_gtk_widget_path_iter_set_state, 3, 0, 0, H_gtk_widget_path_iter_set_state, pl_tuig);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "gdk_cairo_draw_from_gl", lg_gdk_cairo_draw_from_gl, 0, 0, 1, H_gdk_cairo_draw_from_gl, pl_tuui);
  s7_define_typed_function(sc, "gdk_window_mark_paint_from_clip", lg_gdk_window_mark_paint_from_clip, 2, 0, 0, H_gdk_window_mark_paint_from_clip, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_xalign", lg_gtk_label_set_xalign, 2, 0, 0, H_gtk_label_set_xalign, pl_tur);
  s7_define_typed_function(sc, "gtk_label_get_xalign", lg_gtk_label_get_xalign, 1, 0, 0, H_gtk_label_get_xalign, pl_du);
  s7_define_typed_function(sc, "gtk_label_set_yalign", lg_gtk_label_set_yalign, 2, 0, 0, H_gtk_label_set_yalign, pl_tur);
  s7_define_typed_function(sc, "gtk_label_get_yalign", lg_gtk_label_get_yalign, 1, 0, 0, H_gtk_label_get_yalign, pl_du);
  s7_define_typed_function(sc, "gtk_paned_set_wide_handle", lg_gtk_paned_set_wide_handle, 2, 0, 0, H_gtk_paned_set_wide_handle, pl_tub);
  s7_define_typed_function(sc, "gtk_paned_get_wide_handle", lg_gtk_paned_get_wide_handle, 1, 0, 0, H_gtk_paned_get_wide_handle, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_overlay_scrolling", lg_gtk_scrolled_window_set_overlay_scrolling, 2, 0, 0, H_gtk_scrolled_window_set_overlay_scrolling, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_overlay_scrolling", lg_gtk_scrolled_window_get_overlay_scrolling, 1, 0, 0, H_gtk_scrolled_window_get_overlay_scrolling, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_monospace", lg_gtk_text_view_set_monospace, 2, 0, 0, H_gtk_text_view_set_monospace, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_monospace", lg_gtk_text_view_get_monospace, 1, 0, 0, H_gtk_text_view_get_monospace, pl_bu);
  s7_define_typed_function(sc, "gtk_window_get_titlebar", lg_gtk_window_get_titlebar, 1, 0, 0, H_gtk_window_get_titlebar, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_new", lg_gtk_gl_area_new, 0, 0, 0, H_gtk_gl_area_new, pl_p);
  s7_define_typed_function(sc, "gtk_gl_area_get_has_alpha", lg_gtk_gl_area_get_has_alpha, 1, 0, 0, H_gtk_gl_area_get_has_alpha, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_has_alpha", lg_gtk_gl_area_set_has_alpha, 2, 0, 0, H_gtk_gl_area_set_has_alpha, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_has_depth_buffer", lg_gtk_gl_area_get_has_depth_buffer, 1, 0, 0, H_gtk_gl_area_get_has_depth_buffer, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_has_depth_buffer", lg_gtk_gl_area_set_has_depth_buffer, 2, 0, 0, H_gtk_gl_area_set_has_depth_buffer, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_context", lg_gtk_gl_area_get_context, 1, 0, 0, H_gtk_gl_area_get_context, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_make_current", lg_gtk_gl_area_make_current, 1, 0, 0, H_gtk_gl_area_make_current, pl_tu);
  s7_define_typed_function(sc, "gtk_render_check", lg_gtk_render_check, 6, 0, 0, H_gtk_render_check, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_option", lg_gtk_render_option, 6, 0, 0, H_gtk_render_option, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_arrow", lg_gtk_render_arrow, 6, 0, 0, H_gtk_render_arrow, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_background", lg_gtk_render_background, 6, 0, 0, H_gtk_render_background, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_frame", lg_gtk_render_frame, 6, 0, 0, H_gtk_render_frame, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_expander", lg_gtk_render_expander, 6, 0, 0, H_gtk_render_expander, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_focus", lg_gtk_render_focus, 6, 0, 0, H_gtk_render_focus, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_layout", lg_gtk_render_layout, 5, 0, 0, H_gtk_render_layout, pl_tuurru);
  s7_define_typed_function(sc, "gtk_render_line", lg_gtk_render_line, 6, 0, 0, H_gtk_render_line, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_slider", lg_gtk_render_slider, 7, 0, 0, H_gtk_render_slider, pl_tuurrrrg);
  s7_define_typed_function(sc, "gtk_render_frame_gap", lg_gtk_render_frame_gap, 0, 0, 1, H_gtk_render_frame_gap, pl_tuurrrrgr);
  s7_define_typed_function(sc, "gtk_render_extension", lg_gtk_render_extension, 7, 0, 0, H_gtk_render_extension, pl_tuurrrrg);
  s7_define_typed_function(sc, "gtk_render_handle", lg_gtk_render_handle, 6, 0, 0, H_gtk_render_handle, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_activity", lg_gtk_render_activity, 6, 0, 0, H_gtk_render_activity, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_icon", lg_gtk_render_icon, 5, 0, 0, H_gtk_render_icon, pl_tuuur);
  s7_define_typed_function(sc, "gtk_render_icon_surface", lg_gtk_render_icon_surface, 5, 0, 0, H_gtk_render_icon_surface, pl_tuuur);
  s7_define_typed_function(sc, "gdk_gl_context_get_window", lg_gdk_gl_context_get_window, 1, 0, 0, H_gdk_gl_context_get_window, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_make_current", lg_gdk_gl_context_make_current, 1, 0, 0, H_gdk_gl_context_make_current, pl_tu);
  s7_define_typed_function(sc, "gdk_gl_context_get_current", lg_gdk_gl_context_get_current, 0, 0, 0, H_gdk_gl_context_get_current, pl_p);
  s7_define_typed_function(sc, "gdk_gl_context_clear_current", lg_gdk_gl_context_clear_current, 0, 0, 0, H_gdk_gl_context_clear_current, pl_t);
  s7_define_typed_function(sc, "gtk_stack_set_hhomogeneous", lg_gtk_stack_set_hhomogeneous, 2, 0, 0, H_gtk_stack_set_hhomogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_hhomogeneous", lg_gtk_stack_get_hhomogeneous, 1, 0, 0, H_gtk_stack_get_hhomogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_set_vhomogeneous", lg_gtk_stack_set_vhomogeneous, 2, 0, 0, H_gtk_stack_set_vhomogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_vhomogeneous", lg_gtk_stack_get_vhomogeneous, 1, 0, 0, H_gtk_stack_get_vhomogeneous, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_get_display", lg_gdk_gl_context_get_display, 1, 0, 0, H_gdk_gl_context_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_get_has_stencil_buffer", lg_gtk_gl_area_get_has_stencil_buffer, 1, 0, 0, H_gtk_gl_area_get_has_stencil_buffer, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_has_stencil_buffer", lg_gtk_gl_area_set_has_stencil_buffer, 2, 0, 0, H_gtk_gl_area_set_has_stencil_buffer, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_auto_render", lg_gtk_gl_area_get_auto_render, 1, 0, 0, H_gtk_gl_area_get_auto_render, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_auto_render", lg_gtk_gl_area_set_auto_render, 2, 0, 0, H_gtk_gl_area_set_auto_render, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_queue_render", lg_gtk_gl_area_queue_render, 1, 0, 0, H_gtk_gl_area_queue_render, pl_tu);
  s7_define_typed_function(sc, "gtk_gl_area_attach_buffers", lg_gtk_gl_area_attach_buffers, 1, 0, 0, H_gtk_gl_area_attach_buffers, pl_tu);
  s7_define_typed_function(sc, "gtk_gl_area_get_error", lg_gtk_gl_area_get_error, 1, 0, 0, H_gtk_gl_area_get_error, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_menu_new", lg_gtk_popover_menu_new, 0, 0, 0, H_gtk_popover_menu_new, pl_p);
  s7_define_typed_function(sc, "gtk_popover_menu_open_submenu", lg_gtk_popover_menu_open_submenu, 2, 0, 0, H_gtk_popover_menu_open_submenu, pl_tus);
  s7_define_typed_function(sc, "gtk_entry_grab_focus_without_selecting", lg_gtk_entry_grab_focus_without_selecting, 1, 0, 0, H_gtk_entry_grab_focus_without_selecting, pl_tu);
  s7_define_typed_function(sc, "gtk_scrollable_get_border", lg_gtk_scrollable_get_border, 2, 0, 0, H_gtk_scrollable_get_border, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_markup", lg_gtk_text_buffer_insert_markup, 4, 0, 0, H_gtk_text_buffer_insert_markup, pl_tuusi);
  s7_define_typed_function(sc, "gdk_device_get_vendor_id", lg_gdk_device_get_vendor_id, 1, 0, 0, H_gdk_device_get_vendor_id, pl_su);
  s7_define_typed_function(sc, "gdk_device_get_product_id", lg_gdk_device_get_product_id, 1, 0, 0, H_gdk_device_get_product_id, pl_su);
  s7_define_typed_function(sc, "gdk_gl_context_get_shared_context", lg_gdk_gl_context_get_shared_context, 1, 0, 0, H_gdk_gl_context_get_shared_context, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_set_required_version", lg_gdk_gl_context_set_required_version, 3, 0, 0, H_gdk_gl_context_set_required_version, pl_tui);
  s7_define_typed_function(sc, "gdk_gl_context_get_required_version", lg_gdk_gl_context_get_required_version, 1, 2, 0, H_gdk_gl_context_get_required_version, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_set_debug_enabled", lg_gdk_gl_context_set_debug_enabled, 2, 0, 0, H_gdk_gl_context_set_debug_enabled, pl_tub);
  s7_define_typed_function(sc, "gdk_gl_context_get_debug_enabled", lg_gdk_gl_context_get_debug_enabled, 1, 0, 0, H_gdk_gl_context_get_debug_enabled, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_set_forward_compatible", lg_gdk_gl_context_set_forward_compatible, 2, 0, 0, H_gdk_gl_context_set_forward_compatible, pl_tub);
  s7_define_typed_function(sc, "gdk_gl_context_get_forward_compatible", lg_gdk_gl_context_get_forward_compatible, 1, 0, 0, H_gdk_gl_context_get_forward_compatible, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_realize", lg_gdk_gl_context_realize, 1, 1, 0, H_gdk_gl_context_realize, pl_pu);
  s7_define_typed_function(sc, "gtk_clipboard_get_default", lg_gtk_clipboard_get_default, 1, 0, 0, H_gtk_clipboard_get_default, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_cancel", lg_gtk_drag_cancel, 1, 0, 0, H_gtk_drag_cancel, pl_tu);
  s7_define_typed_function(sc, "gtk_search_entry_handle_event", lg_gtk_search_entry_handle_event, 2, 0, 0, H_gtk_search_entry_handle_event, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_get_version", lg_gdk_gl_context_get_version, 1, 2, 0, H_gdk_gl_context_get_version, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_set_required_version", lg_gtk_gl_area_set_required_version, 3, 0, 0, H_gtk_gl_area_set_required_version, pl_tui);
  s7_define_typed_function(sc, "gtk_gl_area_get_required_version", lg_gtk_gl_area_get_required_version, 1, 2, 0, H_gtk_gl_area_get_required_version, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_detach_tab", lg_gtk_notebook_detach_tab, 2, 0, 0, H_gtk_notebook_detach_tab, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_sidebar_new", lg_gtk_stack_sidebar_new, 0, 0, 0, H_gtk_stack_sidebar_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_sidebar_set_stack", lg_gtk_stack_sidebar_set_stack, 2, 0, 0, H_gtk_stack_sidebar_set_stack, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_sidebar_get_stack", lg_gtk_stack_sidebar_get_stack, 1, 0, 0, H_gtk_stack_sidebar_get_stack, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  s7_define_typed_function(sc, "gdk_keymap_get_scroll_lock_state", lg_gdk_keymap_get_scroll_lock_state, 1, 0, 0, H_gdk_keymap_get_scroll_lock_state, pl_bu);
  s7_define_typed_function(sc, "gtk_radio_menu_item_join_group", lg_gtk_radio_menu_item_join_group, 2, 0, 0, H_gtk_radio_menu_item_join_group, pl_tu);
  s7_define_typed_function(sc, "gtk_font_chooser_set_font_map", lg_gtk_font_chooser_set_font_map, 2, 0, 0, H_gtk_font_chooser_set_font_map, pl_tu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_map", lg_gtk_font_chooser_get_font_map, 1, 0, 0, H_gtk_font_chooser_get_font_map, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_set_default_widget", lg_gtk_popover_set_default_widget, 2, 0, 0, H_gtk_popover_set_default_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_get_default_widget", lg_gtk_popover_get_default_widget, 1, 0, 0, H_gtk_popover_get_default_widget, pl_pu);
  s7_define_typed_function(sc, "gdk_window_set_pass_through", lg_gdk_window_set_pass_through, 2, 0, 0, H_gdk_window_set_pass_through, pl_tub);
  s7_define_typed_function(sc, "gdk_window_get_pass_through", lg_gdk_window_get_pass_through, 1, 0, 0, H_gdk_window_get_pass_through, pl_bu);
  s7_define_typed_function(sc, "gtk_overlay_reorder_overlay", lg_gtk_overlay_reorder_overlay, 3, 0, 0, H_gtk_overlay_reorder_overlay, pl_tuui);
  s7_define_typed_function(sc, "gtk_overlay_get_overlay_pass_through", lg_gtk_overlay_get_overlay_pass_through, 2, 0, 0, H_gtk_overlay_get_overlay_pass_through, pl_bu);
  s7_define_typed_function(sc, "gtk_overlay_set_overlay_pass_through", lg_gtk_overlay_set_overlay_pass_through, 3, 0, 0, H_gtk_overlay_set_overlay_pass_through, pl_tuub);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_show_recent", lg_gtk_places_sidebar_get_show_recent, 1, 0, 0, H_gtk_places_sidebar_get_show_recent, pl_bu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_show_recent", lg_gtk_places_sidebar_set_show_recent, 2, 0, 0, H_gtk_places_sidebar_set_show_recent, pl_tub);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_drop_targets_visible", lg_gtk_places_sidebar_set_drop_targets_visible, 3, 0, 0, H_gtk_places_sidebar_set_drop_targets_visible, pl_tubu);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_show_trash", lg_gtk_places_sidebar_get_show_trash, 1, 0, 0, H_gtk_places_sidebar_get_show_trash, pl_bu);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_show_trash", lg_gtk_places_sidebar_set_show_trash, 2, 0, 0, H_gtk_places_sidebar_set_show_trash, pl_tub);
  s7_define_typed_function(sc, "gtk_places_sidebar_set_show_other_locations", lg_gtk_places_sidebar_set_show_other_locations, 2, 0, 0, H_gtk_places_sidebar_set_show_other_locations, pl_tub);
  s7_define_typed_function(sc, "gtk_places_sidebar_get_show_other_locations", lg_gtk_places_sidebar_get_show_other_locations, 1, 0, 0, H_gtk_places_sidebar_get_show_other_locations, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_set_interpolate_size", lg_gtk_stack_set_interpolate_size, 2, 0, 0, H_gtk_stack_set_interpolate_size, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_interpolate_size", lg_gtk_stack_get_interpolate_size, 1, 0, 0, H_gtk_stack_get_interpolate_size, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_font_options", lg_gtk_widget_set_font_options, 2, 0, 0, H_gtk_widget_set_font_options, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_font_options", lg_gtk_widget_get_font_options, 1, 0, 0, H_gtk_widget_get_font_options, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_font_map", lg_gtk_widget_set_font_map, 2, 0, 0, H_gtk_widget_set_font_map, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_font_map", lg_gtk_widget_get_font_map, 1, 0, 0, H_gtk_widget_get_font_map, pl_pu);
  s7_define_typed_function(sc, "gdk_window_fullscreen_on_monitor", lg_gdk_window_fullscreen_on_monitor, 2, 0, 0, H_gdk_window_fullscreen_on_monitor, pl_tui);
  s7_define_typed_function(sc, "gtk_window_fullscreen_on_monitor", lg_gtk_window_fullscreen_on_monitor, 3, 0, 0, H_gtk_window_fullscreen_on_monitor, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_view_set_top_margin", lg_gtk_text_view_set_top_margin, 2, 0, 0, H_gtk_text_view_set_top_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_top_margin", lg_gtk_text_view_get_top_margin, 1, 0, 0, H_gtk_text_view_get_top_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_bottom_margin", lg_gtk_text_view_set_bottom_margin, 2, 0, 0, H_gtk_text_view_set_bottom_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_bottom_margin", lg_gtk_text_view_get_bottom_margin, 1, 0, 0, H_gtk_text_view_get_bottom_margin, pl_iu);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "gdk_gl_context_is_legacy", lg_gdk_gl_context_is_legacy, 1, 0, 0, H_gdk_gl_context_is_legacy, pl_bu);
  s7_define_typed_function(sc, "gdk_rectangle_equal", lg_gdk_rectangle_equal, 2, 0, 0, H_gdk_rectangle_equal, pl_bu);
  s7_define_typed_function(sc, "gtk_application_window_set_help_overlay", lg_gtk_application_window_set_help_overlay, 2, 0, 0, H_gtk_application_window_set_help_overlay, pl_tu);
  s7_define_typed_function(sc, "gtk_settings_reset_property", lg_gtk_settings_reset_property, 2, 0, 0, H_gtk_settings_reset_property, pl_tus);
  s7_define_typed_function(sc, "gtk_text_tag_changed", lg_gtk_text_tag_changed, 2, 0, 0, H_gtk_text_tag_changed, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_path_iter_get_object_name", lg_gtk_widget_path_iter_get_object_name, 2, 0, 0, H_gtk_widget_path_iter_get_object_name, pl_sui);
  s7_define_typed_function(sc, "gtk_widget_path_iter_set_object_name", lg_gtk_widget_path_iter_set_object_name, 3, 0, 0, H_gtk_widget_path_iter_set_object_name, pl_tuis);
  s7_define_typed_function(sc, "gtk_widget_queue_allocate", lg_gtk_widget_queue_allocate, 1, 0, 0, H_gtk_widget_queue_allocate, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_focus_on_click", lg_gtk_widget_set_focus_on_click, 2, 0, 0, H_gtk_widget_set_focus_on_click, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_focus_on_click", lg_gtk_widget_get_focus_on_click, 1, 0, 0, H_gtk_widget_get_focus_on_click, pl_bu);
  s7_define_typed_function(sc, "gdk_drag_context_get_drag_window", lg_gdk_drag_context_get_drag_window, 1, 0, 0, H_gdk_drag_context_get_drag_window, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_set_constrain_to", lg_gtk_popover_set_constrain_to, 2, 0, 0, H_gtk_popover_set_constrain_to, pl_tug);
  s7_define_typed_function(sc, "gtk_popover_get_constrain_to", lg_gtk_popover_get_constrain_to, 1, 0, 0, H_gtk_popover_get_constrain_to, pl_gu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_tag", lg_gtk_text_iter_starts_tag, 2, 0, 0, H_gtk_text_iter_starts_tag, pl_bu);
  s7_define_typed_function(sc, "gdk_device_get_seat", lg_gdk_device_get_seat, 1, 0, 0, H_gdk_device_get_seat, pl_pu);
  s7_define_typed_function(sc, "gdk_display_get_default_seat", lg_gdk_display_get_default_seat, 1, 0, 0, H_gdk_display_get_default_seat, pl_pu);
  s7_define_typed_function(sc, "gdk_display_list_seats", lg_gdk_display_list_seats, 1, 0, 0, H_gdk_display_list_seats, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_begin_from_point", lg_gdk_drag_begin_from_point, 5, 0, 0, H_gdk_drag_begin_from_point, pl_puuui);
  s7_define_typed_function(sc, "gdk_drag_drop_done", lg_gdk_drag_drop_done, 2, 0, 0, H_gdk_drag_drop_done, pl_tub);
  s7_define_typed_function(sc, "gdk_drag_context_set_hotspot", lg_gdk_drag_context_set_hotspot, 3, 0, 0, H_gdk_drag_context_set_hotspot, pl_tui);
  s7_define_typed_function(sc, "gdk_seat_grab", lg_gdk_seat_grab, 0, 0, 1, H_gdk_seat_grab, pl_guugbuut);
  s7_define_typed_function(sc, "gdk_seat_ungrab", lg_gdk_seat_ungrab, 1, 0, 0, H_gdk_seat_ungrab, pl_tu);
  s7_define_typed_function(sc, "gdk_seat_get_display", lg_gdk_seat_get_display, 1, 0, 0, H_gdk_seat_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_seat_get_capabilities", lg_gdk_seat_get_capabilities, 1, 0, 0, H_gdk_seat_get_capabilities, pl_gu);
  s7_define_typed_function(sc, "gdk_seat_get_slaves", lg_gdk_seat_get_slaves, 2, 0, 0, H_gdk_seat_get_slaves, pl_pug);
  s7_define_typed_function(sc, "gdk_seat_get_pointer", lg_gdk_seat_get_pointer, 1, 0, 0, H_gdk_seat_get_pointer, pl_pu);
  s7_define_typed_function(sc, "gdk_seat_get_keyboard", lg_gdk_seat_get_keyboard, 1, 0, 0, H_gdk_seat_get_keyboard, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_context_manage_dnd", lg_gdk_drag_context_manage_dnd, 3, 0, 0, H_gdk_drag_context_manage_dnd, pl_buug);
  s7_define_typed_function(sc, "gdk_event_is_scroll_stop_event", lg_gdk_event_is_scroll_stop_event, 1, 0, 0, H_gdk_event_is_scroll_stop_event, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_reset_cursor_blink", lg_gtk_text_view_reset_cursor_blink, 1, 0, 0, H_gtk_text_view_reset_cursor_blink, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "gdk_device_get_axes", lg_gdk_device_get_axes, 1, 0, 0, H_gdk_device_get_axes, pl_gu);
  s7_define_typed_function(sc, "gdk_event_get_device_tool", lg_gdk_event_get_device_tool, 1, 0, 0, H_gdk_event_get_device_tool, pl_pu);
  s7_define_typed_function(sc, "gdk_event_set_device_tool", lg_gdk_event_set_device_tool, 2, 0, 0, H_gdk_event_set_device_tool, pl_tu);
  s7_define_typed_function(sc, "gdk_event_get_scancode", lg_gdk_event_get_scancode, 1, 0, 0, H_gdk_event_get_scancode, pl_iu);
  s7_define_typed_function(sc, "gdk_gl_context_set_use_es", lg_gdk_gl_context_set_use_es, 2, 0, 0, H_gdk_gl_context_set_use_es, pl_tui);
  s7_define_typed_function(sc, "gdk_gl_context_get_use_es", lg_gdk_gl_context_get_use_es, 1, 0, 0, H_gdk_gl_context_get_use_es, pl_bu);
  s7_define_typed_function(sc, "gdk_pango_context_get_for_display", lg_gdk_pango_context_get_for_display, 1, 0, 0, H_gdk_pango_context_get_for_display, pl_pu);
  s7_define_typed_function(sc, "gtk_clipboard_get_selection", lg_gtk_clipboard_get_selection, 1, 0, 0, H_gtk_clipboard_get_selection, pl_tu);
  s7_define_typed_function(sc, "gtk_gl_area_set_use_es", lg_gtk_gl_area_set_use_es, 2, 0, 0, H_gtk_gl_area_set_use_es, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_use_es", lg_gtk_gl_area_get_use_es, 1, 0, 0, H_gtk_gl_area_get_use_es, pl_bu);
  s7_define_typed_function(sc, "gdk_device_tool_get_serial", lg_gdk_device_tool_get_serial, 1, 0, 0, H_gdk_device_tool_get_serial, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_n_monitors", lg_gdk_display_get_n_monitors, 1, 0, 0, H_gdk_display_get_n_monitors, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_monitor", lg_gdk_display_get_monitor, 2, 0, 0, H_gdk_display_get_monitor, pl_pui);
  s7_define_typed_function(sc, "gdk_display_get_primary_monitor", lg_gdk_display_get_primary_monitor, 1, 0, 0, H_gdk_display_get_primary_monitor, pl_pu);
  s7_define_typed_function(sc, "gdk_display_get_monitor_at_point", lg_gdk_display_get_monitor_at_point, 3, 0, 0, H_gdk_display_get_monitor_at_point, pl_pui);
  s7_define_typed_function(sc, "gdk_display_get_monitor_at_window", lg_gdk_display_get_monitor_at_window, 2, 0, 0, H_gdk_display_get_monitor_at_window, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_pointer_emulated", lg_gdk_event_get_pointer_emulated, 1, 0, 0, H_gdk_event_get_pointer_emulated, pl_bu);
  s7_define_typed_function(sc, "gtk_menu_place_on_monitor", lg_gtk_menu_place_on_monitor, 2, 0, 0, H_gtk_menu_place_on_monitor, pl_tu);
  s7_define_typed_function(sc, "gdk_monitor_get_display", lg_gdk_monitor_get_display, 1, 0, 0, H_gdk_monitor_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_monitor_get_geometry", lg_gdk_monitor_get_geometry, 2, 0, 0, H_gdk_monitor_get_geometry, pl_tu);
  s7_define_typed_function(sc, "gdk_monitor_get_workarea", lg_gdk_monitor_get_workarea, 2, 0, 0, H_gdk_monitor_get_workarea, pl_tu);
  s7_define_typed_function(sc, "gdk_monitor_get_width_mm", lg_gdk_monitor_get_width_mm, 1, 0, 0, H_gdk_monitor_get_width_mm, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_height_mm", lg_gdk_monitor_get_height_mm, 1, 0, 0, H_gdk_monitor_get_height_mm, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_manufacturer", lg_gdk_monitor_get_manufacturer, 1, 0, 0, H_gdk_monitor_get_manufacturer, pl_su);
  s7_define_typed_function(sc, "gdk_monitor_get_model", lg_gdk_monitor_get_model, 1, 0, 0, H_gdk_monitor_get_model, pl_su);
  s7_define_typed_function(sc, "gdk_monitor_get_scale_factor", lg_gdk_monitor_get_scale_factor, 1, 0, 0, H_gdk_monitor_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_refresh_rate", lg_gdk_monitor_get_refresh_rate, 1, 0, 0, H_gdk_monitor_get_refresh_rate, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_subpixel_layout", lg_gdk_monitor_get_subpixel_layout, 1, 0, 0, H_gdk_monitor_get_subpixel_layout, pl_gu);
  s7_define_typed_function(sc, "gdk_monitor_is_primary", lg_gdk_monitor_is_primary, 1, 0, 0, H_gdk_monitor_is_primary, pl_bu);
  s7_define_typed_function(sc, "gdk_drawing_context_get_window", lg_gdk_drawing_context_get_window, 1, 0, 0, H_gdk_drawing_context_get_window, pl_pu);
  s7_define_typed_function(sc, "gdk_drawing_context_get_clip", lg_gdk_drawing_context_get_clip, 1, 0, 0, H_gdk_drawing_context_get_clip, pl_pu);
  s7_define_typed_function(sc, "gdk_drawing_context_is_valid", lg_gdk_drawing_context_is_valid, 1, 0, 0, H_gdk_drawing_context_is_valid, pl_bu);
  s7_define_typed_function(sc, "gdk_drawing_context_get_cairo_context", lg_gdk_drawing_context_get_cairo_context, 1, 0, 0, H_gdk_drawing_context_get_cairo_context, pl_pu);
  s7_define_typed_function(sc, "gdk_cairo_get_drawing_context", lg_gdk_cairo_get_drawing_context, 1, 0, 0, H_gdk_cairo_get_drawing_context, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_max_content_width", lg_gtk_scrolled_window_set_max_content_width, 2, 0, 0, H_gtk_scrolled_window_set_max_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_max_content_width", lg_gtk_scrolled_window_get_max_content_width, 1, 0, 0, H_gtk_scrolled_window_get_max_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_max_content_height", lg_gtk_scrolled_window_set_max_content_height, 2, 0, 0, H_gtk_scrolled_window_set_max_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_max_content_height", lg_gtk_scrolled_window_get_max_content_height, 1, 0, 0, H_gtk_scrolled_window_get_max_content_height, pl_iu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_choice", lg_gtk_file_chooser_add_choice, 5, 0, 0, H_gtk_file_chooser_add_choice, pl_tussu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_choice", lg_gtk_file_chooser_remove_choice, 2, 0, 0, H_gtk_file_chooser_remove_choice, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_set_choice", lg_gtk_file_chooser_set_choice, 3, 0, 0, H_gtk_file_chooser_set_choice, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_get_choice", lg_gtk_file_chooser_get_choice, 2, 0, 0, H_gtk_file_chooser_get_choice, pl_sus);
  s7_define_typed_function(sc, "gdk_device_pad_get_n_groups", lg_gdk_device_pad_get_n_groups, 1, 0, 0, H_gdk_device_pad_get_n_groups, pl_iu);
  s7_define_typed_function(sc, "gdk_device_pad_get_group_n_modes", lg_gdk_device_pad_get_group_n_modes, 2, 0, 0, H_gdk_device_pad_get_group_n_modes, pl_iui);
  s7_define_typed_function(sc, "gdk_device_pad_get_n_features", lg_gdk_device_pad_get_n_features, 2, 0, 0, H_gdk_device_pad_get_n_features, pl_iug);
  s7_define_typed_function(sc, "gdk_device_pad_get_feature_group", lg_gdk_device_pad_get_feature_group, 3, 0, 0, H_gdk_device_pad_get_feature_group, pl_iugi);
  s7_define_typed_function(sc, "gtk_menu_popup_at_rect", lg_gtk_menu_popup_at_rect, 6, 0, 0, H_gtk_menu_popup_at_rect, pl_tuuuggu);
  s7_define_typed_function(sc, "gtk_menu_popup_at_widget", lg_gtk_menu_popup_at_widget, 5, 0, 0, H_gtk_menu_popup_at_widget, pl_tuuggu);
  s7_define_typed_function(sc, "gtk_menu_popup_at_pointer", lg_gtk_menu_popup_at_pointer, 2, 0, 0, H_gtk_menu_popup_at_pointer, pl_tu);
  s7_define_typed_function(sc, "gtk_pad_controller_new", lg_gtk_pad_controller_new, 3, 0, 0, H_gtk_pad_controller_new, pl_pu);
  s7_define_typed_function(sc, "gtk_pad_controller_set_action_entries", lg_gtk_pad_controller_set_action_entries, 3, 0, 0, H_gtk_pad_controller_set_action_entries, pl_tuui);
  s7_define_typed_function(sc, "gtk_pad_controller_set_action", lg_gtk_pad_controller_set_action, 6, 0, 0, H_gtk_pad_controller_set_action, pl_tugiis);
  s7_define_typed_function(sc, "gtk_popover_popup", lg_gtk_popover_popup, 1, 0, 0, H_gtk_popover_popup, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_popdown", lg_gtk_popover_popdown, 1, 0, 0, H_gtk_popover_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_label_new", lg_gtk_shortcut_label_new, 1, 0, 0, H_gtk_shortcut_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_shortcut_label_get_accelerator", lg_gtk_shortcut_label_get_accelerator, 1, 0, 0, H_gtk_shortcut_label_get_accelerator, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_label_set_accelerator", lg_gtk_shortcut_label_set_accelerator, 2, 0, 0, H_gtk_shortcut_label_set_accelerator, pl_tus);
  s7_define_typed_function(sc, "gtk_shortcut_label_get_disabled_text", lg_gtk_shortcut_label_get_disabled_text, 1, 0, 0, H_gtk_shortcut_label_get_disabled_text, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_label_set_disabled_text", lg_gtk_shortcut_label_set_disabled_text, 2, 0, 0, H_gtk_shortcut_label_set_disabled_text, pl_tus);
  s7_define_typed_function(sc, "gdk_window_end_draw_frame", lg_gdk_window_end_draw_frame, 2, 0, 0, H_gdk_window_end_draw_frame, pl_tu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_propagate_natural_width", lg_gtk_scrolled_window_set_propagate_natural_width, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_width, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_propagate_natural_width", lg_gtk_scrolled_window_get_propagate_natural_width, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_width, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_propagate_natural_height", lg_gtk_scrolled_window_set_propagate_natural_height, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_height, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_propagate_natural_height", lg_gtk_scrolled_window_get_propagate_natural_height, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_height, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  s7_define_typed_function(sc, "gdk_display_is_composited", lg_gdk_display_is_composited, 1, 0, 0, H_gdk_display_is_composited, pl_bu);
  s7_define_typed_function(sc, "gdk_display_is_rgba", lg_gdk_display_is_rgba, 1, 0, 0, H_gdk_display_is_rgba, pl_bu);
  s7_define_typed_function(sc, "gdk_window_new_toplevel", lg_gdk_window_new_toplevel, 4, 0, 0, H_gdk_window_new_toplevel, pl_pui);
  s7_define_typed_function(sc, "gdk_window_new_popup", lg_gdk_window_new_popup, 3, 0, 0, H_gdk_window_new_popup, pl_puiu);
  s7_define_typed_function(sc, "gdk_window_new_temp", lg_gdk_window_new_temp, 1, 0, 0, H_gdk_window_new_temp, pl_pu);
  s7_define_typed_function(sc, "gdk_window_new_child", lg_gdk_window_new_child, 3, 0, 0, H_gdk_window_new_child, pl_puiu);
  s7_define_typed_function(sc, "gdk_window_new_input", lg_gdk_window_new_input, 3, 0, 0, H_gdk_window_new_input, pl_puiu);
  s7_define_typed_function(sc, "gtk_button_set_icon_name", lg_gtk_button_set_icon_name, 2, 0, 0, H_gtk_button_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_button_get_icon_name", lg_gtk_button_get_icon_name, 1, 0, 0, H_gtk_button_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_drawing_area_set_content_width", lg_gtk_drawing_area_set_content_width, 2, 0, 0, H_gtk_drawing_area_set_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_drawing_area_get_content_width", lg_gtk_drawing_area_get_content_width, 1, 0, 0, H_gtk_drawing_area_get_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_drawing_area_set_content_height", lg_gtk_drawing_area_set_content_height, 2, 0, 0, H_gtk_drawing_area_set_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_drawing_area_get_content_height", lg_gtk_drawing_area_get_content_height, 1, 0, 0, H_gtk_drawing_area_get_content_height, pl_iu);
  s7_define_typed_function(sc, "gtk_drawing_area_set_draw_func", lg_gtk_drawing_area_set_draw_func, 3, 1, 0, H_gtk_drawing_area_set_draw_func, pl_tut);
  s7_define_typed_function(sc, "gdk_drawing_context_get_paint_context", lg_gdk_drawing_context_get_paint_context, 1, 0, 0, H_gdk_drawing_context_get_paint_context, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_get_damage", lg_gdk_gl_context_get_damage, 1, 0, 0, H_gdk_gl_context_get_damage, pl_pu);
  s7_define_typed_function(sc, "gdk_rgba_is_clear", lg_gdk_rgba_is_clear, 1, 0, 0, H_gdk_rgba_is_clear, pl_bu);
  s7_define_typed_function(sc, "gdk_rgba_is_opaque", lg_gdk_rgba_is_opaque, 1, 0, 0, H_gdk_rgba_is_opaque, pl_bu);
  s7_define_typed_function(sc, "gdk_window_begin_draw_frame", lg_gdk_window_begin_draw_frame, 3, 0, 0, H_gdk_window_begin_draw_frame, pl_pu);
  s7_define_typed_function(sc, "gtk_flow_box_get_child_at_pos", lg_gtk_flow_box_get_child_at_pos, 3, 0, 0, H_gtk_flow_box_get_child_at_pos, pl_pui);
  s7_define_typed_function(sc, "gtk_about_dialog_get_system_information", lg_gtk_about_dialog_get_system_information, 1, 0, 0, H_gtk_about_dialog_get_system_information, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_system_information", lg_gtk_about_dialog_set_system_information, 2, 0, 0, H_gtk_about_dialog_set_system_information, pl_tus);
  s7_define_typed_function(sc, "gtk_action_bar_set_revealed", lg_gtk_action_bar_set_revealed, 2, 0, 0, H_gtk_action_bar_set_revealed, pl_tub);
  s7_define_typed_function(sc, "gtk_action_bar_get_revealed", lg_gtk_action_bar_get_revealed, 1, 0, 0, H_gtk_action_bar_get_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_check_button_set_draw_indicator", lg_gtk_check_button_set_draw_indicator, 2, 0, 0, H_gtk_check_button_set_draw_indicator, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_get_draw_indicator", lg_gtk_check_button_get_draw_indicator, 1, 0, 0, H_gtk_check_button_get_draw_indicator, pl_bu);
  s7_define_typed_function(sc, "gtk_check_button_set_inconsistent", lg_gtk_check_button_set_inconsistent, 2, 0, 0, H_gtk_check_button_set_inconsistent, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_get_inconsistent", lg_gtk_check_button_get_inconsistent, 1, 0, 0, H_gtk_check_button_get_inconsistent, pl_bu);
  s7_define_typed_function(sc, "gtk_info_bar_set_revealed", lg_gtk_info_bar_set_revealed, 2, 0, 0, H_gtk_info_bar_set_revealed, pl_tub);
  s7_define_typed_function(sc, "gtk_info_bar_get_revealed", lg_gtk_info_bar_get_revealed, 1, 0, 0, H_gtk_info_bar_get_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_first_child", lg_gtk_widget_get_first_child, 1, 0, 0, H_gtk_widget_get_first_child, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_last_child", lg_gtk_widget_get_last_child, 1, 0, 0, H_gtk_widget_get_last_child, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_next_sibling", lg_gtk_widget_get_next_sibling, 1, 0, 0, H_gtk_widget_get_next_sibling, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_prev_sibling", lg_gtk_widget_get_prev_sibling, 1, 0, 0, H_gtk_widget_get_prev_sibling, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_focus_child", lg_gtk_widget_set_focus_child, 2, 0, 0, H_gtk_widget_set_focus_child, pl_tu);
  s7_define_typed_function(sc, "gtk_show_uri_on_window", lg_gtk_show_uri_on_window, 3, 1, 0, H_gtk_show_uri_on_window, pl_pusiu);
  s7_define_typed_function(sc, "gtk_box_pack_start", lg_gtk_box_pack_start, 2, 0, 0, H_gtk_box_pack_start, pl_tu);
  s7_define_typed_function(sc, "gtk_box_pack_end", lg_gtk_box_pack_end, 2, 0, 0, H_gtk_box_pack_end, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_insert_after", lg_gtk_widget_insert_after, 3, 0, 0, H_gtk_widget_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_insert_before", lg_gtk_widget_insert_before, 3, 0, 0, H_gtk_widget_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_new", lg_gtk_center_box_new, 0, 0, 0, H_gtk_center_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_center_box_set_start_widget", lg_gtk_center_box_set_start_widget, 2, 0, 0, H_gtk_center_box_set_start_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_set_center_widget", lg_gtk_center_box_set_center_widget, 2, 0, 0, H_gtk_center_box_set_center_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_set_end_widget", lg_gtk_center_box_set_end_widget, 2, 0, 0, H_gtk_center_box_set_end_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_get_start_widget", lg_gtk_center_box_get_start_widget, 1, 0, 0, H_gtk_center_box_get_start_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_get_center_widget", lg_gtk_center_box_get_center_widget, 1, 0, 0, H_gtk_center_box_get_center_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_get_end_widget", lg_gtk_center_box_get_end_widget, 1, 0, 0, H_gtk_center_box_get_end_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_set_baseline_position", lg_gtk_center_box_set_baseline_position, 2, 0, 0, H_gtk_center_box_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_center_box_get_baseline_position", lg_gtk_center_box_get_baseline_position, 1, 0, 0, H_gtk_center_box_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gdk_event_set_coords", lg_gdk_event_set_coords, 3, 0, 0, H_gdk_event_set_coords, pl_tur);
  s7_define_typed_function(sc, "gdk_event_set_user_data", lg_gdk_event_set_user_data, 2, 0, 0, H_gdk_event_set_user_data, pl_tu);
  s7_define_typed_function(sc, "gdk_event_get_user_data", lg_gdk_event_get_user_data, 1, 0, 0, H_gdk_event_get_user_data, pl_pu);
  s7_define_typed_function(sc, "gdk_rectangle_contains_point", lg_gdk_rectangle_contains_point, 3, 0, 0, H_gdk_rectangle_contains_point, pl_bui);
  s7_define_typed_function(sc, "gtk_get_event_target", lg_gtk_get_event_target, 1, 0, 0, H_gtk_get_event_target, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_label_set_label", lg_gtk_accel_label_set_label, 2, 0, 0, H_gtk_accel_label_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_accel_label_get_label", lg_gtk_accel_label_get_label, 1, 0, 0, H_gtk_accel_label_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_accel_label_set_use_underline", lg_gtk_accel_label_set_use_underline, 2, 0, 0, H_gtk_accel_label_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_accel_label_get_use_underline", lg_gtk_accel_label_get_use_underline, 1, 0, 0, H_gtk_accel_label_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_scrollbar_set_adjustment", lg_gtk_scrollbar_set_adjustment, 2, 0, 0, H_gtk_scrollbar_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrollbar_get_adjustment", lg_gtk_scrollbar_get_adjustment, 1, 0, 0, H_gtk_scrollbar_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollbar_get_wheel_delta", lg_gtk_scrollbar_get_wheel_delta, 2, 0, 0, H_gtk_scrollbar_get_wheel_delta, pl_du);
  s7_define_typed_function(sc, "gtk_spin_button_get_text", lg_gtk_spin_button_get_text, 1, 0, 0, H_gtk_spin_button_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_spin_button_set_text", lg_gtk_spin_button_set_text, 2, 0, 0, H_gtk_spin_button_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_spin_button_get_max_width_chars", lg_gtk_spin_button_get_max_width_chars, 1, 0, 0, H_gtk_spin_button_get_max_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_max_width_chars", lg_gtk_spin_button_set_max_width_chars, 2, 0, 0, H_gtk_spin_button_set_max_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_spin_button_get_width_chars", lg_gtk_spin_button_get_width_chars, 1, 0, 0, H_gtk_spin_button_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_width_chars", lg_gtk_spin_button_set_width_chars, 2, 0, 0, H_gtk_spin_button_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_size_allocate", lg_gtk_widget_size_allocate, 4, 0, 0, H_gtk_widget_size_allocate, pl_tuuiu);
#endif

  s7_define_typed_function(sc, "cairo_create", lg_cairo_create, 1, 0, 0, H_cairo_create, pl_pu);
  s7_define_typed_function(sc, "cairo_version", lg_cairo_version, 0, 0, 0, H_cairo_version, pl_i);
  s7_define_typed_function(sc, "cairo_version_string", lg_cairo_version_string, 0, 0, 0, H_cairo_version_string, pl_s);
  s7_define_typed_function(sc, "cairo_reference", lg_cairo_reference, 1, 0, 0, H_cairo_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_destroy", lg_cairo_destroy, 1, 0, 0, H_cairo_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_save", lg_cairo_save, 1, 0, 0, H_cairo_save, pl_tu);
  s7_define_typed_function(sc, "cairo_restore", lg_cairo_restore, 1, 0, 0, H_cairo_restore, pl_tu);
  s7_define_typed_function(sc, "cairo_push_group", lg_cairo_push_group, 1, 0, 0, H_cairo_push_group, pl_tu);
  s7_define_typed_function(sc, "cairo_push_group_with_content", lg_cairo_push_group_with_content, 2, 0, 0, H_cairo_push_group_with_content, pl_tug);
  s7_define_typed_function(sc, "cairo_pop_group", lg_cairo_pop_group, 1, 0, 0, H_cairo_pop_group, pl_pu);
  s7_define_typed_function(sc, "cairo_pop_group_to_source", lg_cairo_pop_group_to_source, 1, 0, 0, H_cairo_pop_group_to_source, pl_tu);
  s7_define_typed_function(sc, "cairo_set_operator", lg_cairo_set_operator, 2, 0, 0, H_cairo_set_operator, pl_tug);
  s7_define_typed_function(sc, "cairo_set_source", lg_cairo_set_source, 2, 0, 0, H_cairo_set_source, pl_tu);
  s7_define_typed_function(sc, "cairo_set_source_rgb", lg_cairo_set_source_rgb, 4, 0, 0, H_cairo_set_source_rgb, pl_tur);
  s7_define_typed_function(sc, "cairo_set_source_rgba", lg_cairo_set_source_rgba, 5, 0, 0, H_cairo_set_source_rgba, pl_tur);
  s7_define_typed_function(sc, "cairo_set_source_surface", lg_cairo_set_source_surface, 4, 0, 0, H_cairo_set_source_surface, pl_tuur);
  s7_define_typed_function(sc, "cairo_set_tolerance", lg_cairo_set_tolerance, 2, 0, 0, H_cairo_set_tolerance, pl_tur);
  s7_define_typed_function(sc, "cairo_set_antialias", lg_cairo_set_antialias, 2, 0, 0, H_cairo_set_antialias, pl_tug);
  s7_define_typed_function(sc, "cairo_set_fill_rule", lg_cairo_set_fill_rule, 2, 0, 0, H_cairo_set_fill_rule, pl_tug);
  s7_define_typed_function(sc, "cairo_set_line_width", lg_cairo_set_line_width, 2, 0, 0, H_cairo_set_line_width, pl_tur);
  s7_define_typed_function(sc, "cairo_set_line_cap", lg_cairo_set_line_cap, 2, 0, 0, H_cairo_set_line_cap, pl_tug);
  s7_define_typed_function(sc, "cairo_set_line_join", lg_cairo_set_line_join, 2, 0, 0, H_cairo_set_line_join, pl_tug);
  s7_define_typed_function(sc, "cairo_set_dash", lg_cairo_set_dash, 4, 0, 0, H_cairo_set_dash, pl_tuuir);
  s7_define_typed_function(sc, "cairo_set_miter_limit", lg_cairo_set_miter_limit, 2, 0, 0, H_cairo_set_miter_limit, pl_tur);
  s7_define_typed_function(sc, "cairo_translate", lg_cairo_translate, 3, 0, 0, H_cairo_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_scale", lg_cairo_scale, 3, 0, 0, H_cairo_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_rotate", lg_cairo_rotate, 2, 0, 0, H_cairo_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_transform", lg_cairo_transform, 2, 0, 0, H_cairo_transform, pl_tu);
  s7_define_typed_function(sc, "cairo_set_matrix", lg_cairo_set_matrix, 2, 0, 0, H_cairo_set_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_identity_matrix", lg_cairo_identity_matrix, 1, 0, 0, H_cairo_identity_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_user_to_device", lg_cairo_user_to_device, 1, 2, 0, H_cairo_user_to_device, pl_pu);
  s7_define_typed_function(sc, "cairo_user_to_device_distance", lg_cairo_user_to_device_distance, 1, 2, 0, H_cairo_user_to_device_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_device_to_user", lg_cairo_device_to_user, 1, 2, 0, H_cairo_device_to_user, pl_pu);
  s7_define_typed_function(sc, "cairo_device_to_user_distance", lg_cairo_device_to_user_distance, 1, 2, 0, H_cairo_device_to_user_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_new_path", lg_cairo_new_path, 1, 0, 0, H_cairo_new_path, pl_tu);
  s7_define_typed_function(sc, "cairo_move_to", lg_cairo_move_to, 3, 0, 0, H_cairo_move_to, pl_tur);
  s7_define_typed_function(sc, "cairo_new_sub_path", lg_cairo_new_sub_path, 1, 0, 0, H_cairo_new_sub_path, pl_tu);
  s7_define_typed_function(sc, "cairo_line_to", lg_cairo_line_to, 3, 0, 0, H_cairo_line_to, pl_tur);
  s7_define_typed_function(sc, "cairo_curve_to", lg_cairo_curve_to, 7, 0, 0, H_cairo_curve_to, pl_tur);
  s7_define_typed_function(sc, "cairo_arc", lg_cairo_arc, 6, 0, 0, H_cairo_arc, pl_tur);
  s7_define_typed_function(sc, "cairo_arc_negative", lg_cairo_arc_negative, 6, 0, 0, H_cairo_arc_negative, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_move_to", lg_cairo_rel_move_to, 3, 0, 0, H_cairo_rel_move_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_line_to", lg_cairo_rel_line_to, 3, 0, 0, H_cairo_rel_line_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_curve_to", lg_cairo_rel_curve_to, 7, 0, 0, H_cairo_rel_curve_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rectangle", lg_cairo_rectangle, 5, 0, 0, H_cairo_rectangle, pl_tur);
  s7_define_typed_function(sc, "cairo_close_path", lg_cairo_close_path, 1, 0, 0, H_cairo_close_path, pl_tu);
  s7_define_typed_function(sc, "cairo_paint", lg_cairo_paint, 1, 0, 0, H_cairo_paint, pl_tu);
  s7_define_typed_function(sc, "cairo_paint_with_alpha", lg_cairo_paint_with_alpha, 2, 0, 0, H_cairo_paint_with_alpha, pl_tur);
  s7_define_typed_function(sc, "cairo_mask", lg_cairo_mask, 2, 0, 0, H_cairo_mask, pl_tu);
  s7_define_typed_function(sc, "cairo_mask_surface", lg_cairo_mask_surface, 4, 0, 0, H_cairo_mask_surface, pl_tuur);
  s7_define_typed_function(sc, "cairo_stroke", lg_cairo_stroke, 1, 0, 0, H_cairo_stroke, pl_tu);
  s7_define_typed_function(sc, "cairo_stroke_preserve", lg_cairo_stroke_preserve, 1, 0, 0, H_cairo_stroke_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_fill", lg_cairo_fill, 1, 0, 0, H_cairo_fill, pl_tu);
  s7_define_typed_function(sc, "cairo_fill_preserve", lg_cairo_fill_preserve, 1, 0, 0, H_cairo_fill_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_copy_page", lg_cairo_copy_page, 1, 0, 0, H_cairo_copy_page, pl_tu);
  s7_define_typed_function(sc, "cairo_show_page", lg_cairo_show_page, 1, 0, 0, H_cairo_show_page, pl_tu);
  s7_define_typed_function(sc, "cairo_in_stroke", lg_cairo_in_stroke, 3, 0, 0, H_cairo_in_stroke, pl_bur);
  s7_define_typed_function(sc, "cairo_in_fill", lg_cairo_in_fill, 3, 0, 0, H_cairo_in_fill, pl_bur);
  s7_define_typed_function(sc, "cairo_reset_clip", lg_cairo_reset_clip, 1, 0, 0, H_cairo_reset_clip, pl_tu);
  s7_define_typed_function(sc, "cairo_clip", lg_cairo_clip, 1, 0, 0, H_cairo_clip, pl_tu);
  s7_define_typed_function(sc, "cairo_clip_preserve", lg_cairo_clip_preserve, 1, 0, 0, H_cairo_clip_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_create", lg_cairo_font_options_create, 0, 0, 0, H_cairo_font_options_create, pl_p);
  s7_define_typed_function(sc, "cairo_font_options_copy", lg_cairo_font_options_copy, 1, 0, 0, H_cairo_font_options_copy, pl_pu);
  s7_define_typed_function(sc, "cairo_font_options_destroy", lg_cairo_font_options_destroy, 1, 0, 0, H_cairo_font_options_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_status", lg_cairo_font_options_status, 1, 0, 0, H_cairo_font_options_status, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_merge", lg_cairo_font_options_merge, 2, 0, 0, H_cairo_font_options_merge, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_equal", lg_cairo_font_options_equal, 2, 0, 0, H_cairo_font_options_equal, pl_bu);
  s7_define_typed_function(sc, "cairo_font_options_hash", lg_cairo_font_options_hash, 1, 0, 0, H_cairo_font_options_hash, pl_iu);
  s7_define_typed_function(sc, "cairo_font_options_set_antialias", lg_cairo_font_options_set_antialias, 2, 0, 0, H_cairo_font_options_set_antialias, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_antialias", lg_cairo_font_options_get_antialias, 1, 0, 0, H_cairo_font_options_get_antialias, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_subpixel_order", lg_cairo_font_options_set_subpixel_order, 2, 0, 0, H_cairo_font_options_set_subpixel_order, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_subpixel_order", lg_cairo_font_options_get_subpixel_order, 1, 0, 0, H_cairo_font_options_get_subpixel_order, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_hint_style", lg_cairo_font_options_set_hint_style, 2, 0, 0, H_cairo_font_options_set_hint_style, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_hint_style", lg_cairo_font_options_get_hint_style, 1, 0, 0, H_cairo_font_options_get_hint_style, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_hint_metrics", lg_cairo_font_options_set_hint_metrics, 2, 0, 0, H_cairo_font_options_set_hint_metrics, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_hint_metrics", lg_cairo_font_options_get_hint_metrics, 1, 0, 0, H_cairo_font_options_get_hint_metrics, pl_gu);
  s7_define_typed_function(sc, "cairo_select_font_face", lg_cairo_select_font_face, 4, 0, 0, H_cairo_select_font_face, pl_tusg);
  s7_define_typed_function(sc, "cairo_set_font_size", lg_cairo_set_font_size, 2, 0, 0, H_cairo_set_font_size, pl_tur);
  s7_define_typed_function(sc, "cairo_set_font_matrix", lg_cairo_set_font_matrix, 2, 0, 0, H_cairo_set_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_get_font_matrix", lg_cairo_get_font_matrix, 2, 0, 0, H_cairo_get_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_set_font_options", lg_cairo_set_font_options, 2, 0, 0, H_cairo_set_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_get_font_options", lg_cairo_get_font_options, 2, 0, 0, H_cairo_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_set_scaled_font", lg_cairo_set_scaled_font, 2, 0, 0, H_cairo_set_scaled_font, pl_tu);
  s7_define_typed_function(sc, "cairo_show_text", lg_cairo_show_text, 2, 0, 0, H_cairo_show_text, pl_tus);
  s7_define_typed_function(sc, "cairo_show_glyphs", lg_cairo_show_glyphs, 3, 0, 0, H_cairo_show_glyphs, pl_tuui);
  s7_define_typed_function(sc, "cairo_get_font_face", lg_cairo_get_font_face, 1, 0, 0, H_cairo_get_font_face, pl_pu);
  s7_define_typed_function(sc, "cairo_font_extents", lg_cairo_font_extents, 2, 0, 0, H_cairo_font_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_set_font_face", lg_cairo_set_font_face, 2, 0, 0, H_cairo_set_font_face, pl_tu);
  s7_define_typed_function(sc, "cairo_text_extents", lg_cairo_text_extents, 3, 0, 0, H_cairo_text_extents, pl_tusu);
  s7_define_typed_function(sc, "cairo_glyph_extents", lg_cairo_glyph_extents, 4, 0, 0, H_cairo_glyph_extents, pl_tuuiu);
  s7_define_typed_function(sc, "cairo_text_path", lg_cairo_text_path, 2, 0, 0, H_cairo_text_path, pl_tus);
  s7_define_typed_function(sc, "cairo_glyph_path", lg_cairo_glyph_path, 3, 0, 0, H_cairo_glyph_path, pl_tuui);
  s7_define_typed_function(sc, "cairo_font_face_reference", lg_cairo_font_face_reference, 1, 0, 0, H_cairo_font_face_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_font_face_destroy", lg_cairo_font_face_destroy, 1, 0, 0, H_cairo_font_face_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_status", lg_cairo_font_face_status, 1, 0, 0, H_cairo_font_face_status, pl_gu);
  s7_define_typed_function(sc, "cairo_font_face_get_user_data", lg_cairo_font_face_get_user_data, 2, 0, 0, H_cairo_font_face_get_user_data, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_set_user_data", lg_cairo_font_face_set_user_data, 4, 0, 0, H_cairo_font_face_set_user_data, pl_guut);
  s7_define_typed_function(sc, "cairo_scaled_font_create", lg_cairo_scaled_font_create, 4, 0, 0, H_cairo_scaled_font_create, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_reference", lg_cairo_scaled_font_reference, 1, 0, 0, H_cairo_scaled_font_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_destroy", lg_cairo_scaled_font_destroy, 1, 0, 0, H_cairo_scaled_font_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_status", lg_cairo_scaled_font_status, 1, 0, 0, H_cairo_scaled_font_status, pl_gu);
  s7_define_typed_function(sc, "cairo_scaled_font_extents", lg_cairo_scaled_font_extents, 2, 0, 0, H_cairo_scaled_font_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_text_extents", lg_cairo_scaled_font_text_extents, 3, 0, 0, H_cairo_scaled_font_text_extents, pl_tusu);
  s7_define_typed_function(sc, "cairo_scaled_font_glyph_extents", lg_cairo_scaled_font_glyph_extents, 4, 0, 0, H_cairo_scaled_font_glyph_extents, pl_tuuiu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_face", lg_cairo_scaled_font_get_font_face, 1, 0, 0, H_cairo_scaled_font_get_font_face, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_matrix", lg_cairo_scaled_font_get_font_matrix, 2, 0, 0, H_cairo_scaled_font_get_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_ctm", lg_cairo_scaled_font_get_ctm, 2, 0, 0, H_cairo_scaled_font_get_ctm, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_options", lg_cairo_scaled_font_get_font_options, 2, 0, 0, H_cairo_scaled_font_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_get_operator", lg_cairo_get_operator, 1, 0, 0, H_cairo_get_operator, pl_gu);
  s7_define_typed_function(sc, "cairo_get_source", lg_cairo_get_source, 1, 0, 0, H_cairo_get_source, pl_pu);
  s7_define_typed_function(sc, "cairo_get_tolerance", lg_cairo_get_tolerance, 1, 0, 0, H_cairo_get_tolerance, pl_du);
  s7_define_typed_function(sc, "cairo_get_antialias", lg_cairo_get_antialias, 1, 0, 0, H_cairo_get_antialias, pl_gu);
  s7_define_typed_function(sc, "cairo_get_current_point", lg_cairo_get_current_point, 1, 2, 0, H_cairo_get_current_point, pl_pu);
  s7_define_typed_function(sc, "cairo_get_fill_rule", lg_cairo_get_fill_rule, 1, 0, 0, H_cairo_get_fill_rule, pl_gu);
  s7_define_typed_function(sc, "cairo_get_line_width", lg_cairo_get_line_width, 1, 0, 0, H_cairo_get_line_width, pl_du);
  s7_define_typed_function(sc, "cairo_get_line_cap", lg_cairo_get_line_cap, 1, 0, 0, H_cairo_get_line_cap, pl_gu);
  s7_define_typed_function(sc, "cairo_get_line_join", lg_cairo_get_line_join, 1, 0, 0, H_cairo_get_line_join, pl_gu);
  s7_define_typed_function(sc, "cairo_get_miter_limit", lg_cairo_get_miter_limit, 1, 0, 0, H_cairo_get_miter_limit, pl_du);
  s7_define_typed_function(sc, "cairo_get_matrix", lg_cairo_get_matrix, 2, 0, 0, H_cairo_get_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_get_target", lg_cairo_get_target, 1, 0, 0, H_cairo_get_target, pl_pu);
  s7_define_typed_function(sc, "cairo_get_group_target", lg_cairo_get_group_target, 1, 0, 0, H_cairo_get_group_target, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_path", lg_cairo_copy_path, 1, 0, 0, H_cairo_copy_path, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_path_flat", lg_cairo_copy_path_flat, 1, 0, 0, H_cairo_copy_path_flat, pl_pu);
  s7_define_typed_function(sc, "cairo_append_path", lg_cairo_append_path, 2, 0, 0, H_cairo_append_path, pl_tu);
  s7_define_typed_function(sc, "cairo_path_destroy", lg_cairo_path_destroy, 1, 0, 0, H_cairo_path_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_status", lg_cairo_status, 1, 0, 0, H_cairo_status, pl_gu);
  s7_define_typed_function(sc, "cairo_status_to_string", lg_cairo_status_to_string, 1, 0, 0, H_cairo_status_to_string, pl_sg);
  s7_define_typed_function(sc, "cairo_surface_create_similar", lg_cairo_surface_create_similar, 4, 0, 0, H_cairo_surface_create_similar, pl_pugi);
  s7_define_typed_function(sc, "cairo_surface_reference", lg_cairo_surface_reference, 1, 0, 0, H_cairo_surface_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_finish", lg_cairo_surface_finish, 1, 0, 0, H_cairo_surface_finish, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_destroy", lg_cairo_surface_destroy, 1, 0, 0, H_cairo_surface_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_status", lg_cairo_surface_status, 1, 0, 0, H_cairo_surface_status, pl_gu);
  s7_define_typed_function(sc, "cairo_surface_get_content", lg_cairo_surface_get_content, 1, 0, 0, H_cairo_surface_get_content, pl_gu);
  s7_define_typed_function(sc, "cairo_surface_get_user_data", lg_cairo_surface_get_user_data, 2, 0, 0, H_cairo_surface_get_user_data, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_set_user_data", lg_cairo_surface_set_user_data, 4, 0, 0, H_cairo_surface_set_user_data, pl_guut);
  s7_define_typed_function(sc, "cairo_surface_get_font_options", lg_cairo_surface_get_font_options, 2, 0, 0, H_cairo_surface_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_flush", lg_cairo_surface_flush, 1, 0, 0, H_cairo_surface_flush, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_mark_dirty", lg_cairo_surface_mark_dirty, 1, 0, 0, H_cairo_surface_mark_dirty, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_mark_dirty_rectangle", lg_cairo_surface_mark_dirty_rectangle, 5, 0, 0, H_cairo_surface_mark_dirty_rectangle, pl_tui);
  s7_define_typed_function(sc, "cairo_surface_set_device_offset", lg_cairo_surface_set_device_offset, 3, 0, 0, H_cairo_surface_set_device_offset, pl_tur);
  s7_define_typed_function(sc, "cairo_surface_get_device_offset", lg_cairo_surface_get_device_offset, 1, 2, 0, H_cairo_surface_get_device_offset, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_set_fallback_resolution", lg_cairo_surface_set_fallback_resolution, 3, 0, 0, H_cairo_surface_set_fallback_resolution, pl_tur);
  s7_define_typed_function(sc, "cairo_image_surface_create", lg_cairo_image_surface_create, 3, 0, 0, H_cairo_image_surface_create, pl_pgi);
  s7_define_typed_function(sc, "cairo_image_surface_create_for_data", lg_cairo_image_surface_create_for_data, 5, 0, 0, H_cairo_image_surface_create_for_data, pl_psgi);
  s7_define_typed_function(sc, "cairo_image_surface_get_data", lg_cairo_image_surface_get_data, 1, 0, 0, H_cairo_image_surface_get_data, pl_su);
  s7_define_typed_function(sc, "cairo_image_surface_get_format", lg_cairo_image_surface_get_format, 1, 0, 0, H_cairo_image_surface_get_format, pl_gu);
  s7_define_typed_function(sc, "cairo_image_surface_get_width", lg_cairo_image_surface_get_width, 1, 0, 0, H_cairo_image_surface_get_width, pl_iu);
  s7_define_typed_function(sc, "cairo_image_surface_get_height", lg_cairo_image_surface_get_height, 1, 0, 0, H_cairo_image_surface_get_height, pl_iu);
  s7_define_typed_function(sc, "cairo_image_surface_get_stride", lg_cairo_image_surface_get_stride, 1, 0, 0, H_cairo_image_surface_get_stride, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_create_rgb", lg_cairo_pattern_create_rgb, 3, 0, 0, H_cairo_pattern_create_rgb, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_rgba", lg_cairo_pattern_create_rgba, 4, 0, 0, H_cairo_pattern_create_rgba, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_for_surface", lg_cairo_pattern_create_for_surface, 1, 0, 0, H_cairo_pattern_create_for_surface, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_create_linear", lg_cairo_pattern_create_linear, 4, 0, 0, H_cairo_pattern_create_linear, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_radial", lg_cairo_pattern_create_radial, 6, 0, 0, H_cairo_pattern_create_radial, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_reference", lg_cairo_pattern_reference, 1, 0, 0, H_cairo_pattern_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_destroy", lg_cairo_pattern_destroy, 1, 0, 0, H_cairo_pattern_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_status", lg_cairo_pattern_status, 1, 0, 0, H_cairo_pattern_status, pl_gu);
  s7_define_typed_function(sc, "cairo_pattern_add_color_stop_rgb", lg_cairo_pattern_add_color_stop_rgb, 5, 0, 0, H_cairo_pattern_add_color_stop_rgb, pl_tur);
  s7_define_typed_function(sc, "cairo_pattern_add_color_stop_rgba", lg_cairo_pattern_add_color_stop_rgba, 6, 0, 0, H_cairo_pattern_add_color_stop_rgba, pl_tur);
  s7_define_typed_function(sc, "cairo_pattern_set_matrix", lg_cairo_pattern_set_matrix, 2, 0, 0, H_cairo_pattern_set_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_get_matrix", lg_cairo_pattern_get_matrix, 2, 0, 0, H_cairo_pattern_get_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_set_extend", lg_cairo_pattern_set_extend, 2, 0, 0, H_cairo_pattern_set_extend, pl_tug);
  s7_define_typed_function(sc, "cairo_pattern_get_extend", lg_cairo_pattern_get_extend, 1, 0, 0, H_cairo_pattern_get_extend, pl_gu);
  s7_define_typed_function(sc, "cairo_pattern_set_filter", lg_cairo_pattern_set_filter, 2, 0, 0, H_cairo_pattern_set_filter, pl_tug);
  s7_define_typed_function(sc, "cairo_pattern_get_filter", lg_cairo_pattern_get_filter, 1, 0, 0, H_cairo_pattern_get_filter, pl_gu);
  s7_define_typed_function(sc, "cairo_matrix_init", lg_cairo_matrix_init, 7, 0, 0, H_cairo_matrix_init, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_identity", lg_cairo_matrix_init_identity, 1, 0, 0, H_cairo_matrix_init_identity, pl_tu);
  s7_define_typed_function(sc, "cairo_matrix_init_translate", lg_cairo_matrix_init_translate, 3, 0, 0, H_cairo_matrix_init_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_scale", lg_cairo_matrix_init_scale, 3, 0, 0, H_cairo_matrix_init_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_rotate", lg_cairo_matrix_init_rotate, 2, 0, 0, H_cairo_matrix_init_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_translate", lg_cairo_matrix_translate, 3, 0, 0, H_cairo_matrix_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_scale", lg_cairo_matrix_scale, 3, 0, 0, H_cairo_matrix_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_rotate", lg_cairo_matrix_rotate, 2, 0, 0, H_cairo_matrix_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_invert", lg_cairo_matrix_invert, 1, 0, 0, H_cairo_matrix_invert, pl_gu);
  s7_define_typed_function(sc, "cairo_matrix_multiply", lg_cairo_matrix_multiply, 3, 0, 0, H_cairo_matrix_multiply, pl_tu);
  s7_define_typed_function(sc, "cairo_matrix_transform_distance", lg_cairo_matrix_transform_distance, 1, 2, 0, H_cairo_matrix_transform_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_matrix_transform_point", lg_cairo_matrix_transform_point, 1, 2, 0, H_cairo_matrix_transform_point, pl_pu);
  s7_define_typed_function(sc, "cairo_get_reference_count", lg_cairo_get_reference_count, 1, 0, 0, H_cairo_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_get_user_data", lg_cairo_get_user_data, 2, 0, 0, H_cairo_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_set_user_data", lg_cairo_set_user_data, 4, 0, 0, H_cairo_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_clip_extents", lg_cairo_clip_extents, 1, 4, 0, H_cairo_clip_extents, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_clip_rectangle_list", lg_cairo_copy_clip_rectangle_list, 1, 0, 0, H_cairo_copy_clip_rectangle_list, pl_pu);
  s7_define_typed_function(sc, "cairo_rectangle_list_destroy", lg_cairo_rectangle_list_destroy, 1, 0, 0, H_cairo_rectangle_list_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_get_reference_count", lg_cairo_font_face_get_reference_count, 1, 0, 0, H_cairo_font_face_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_reference_count", lg_cairo_scaled_font_get_reference_count, 1, 0, 0, H_cairo_scaled_font_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_user_data", lg_cairo_scaled_font_get_user_data, 2, 0, 0, H_cairo_scaled_font_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_set_user_data", lg_cairo_scaled_font_set_user_data, 4, 0, 0, H_cairo_scaled_font_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_get_dash_count", lg_cairo_get_dash_count, 1, 0, 0, H_cairo_get_dash_count, pl_iu);
  s7_define_typed_function(sc, "cairo_get_dash", lg_cairo_get_dash, 1, 2, 0, H_cairo_get_dash, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_get_reference_count", lg_cairo_surface_get_reference_count, 1, 0, 0, H_cairo_surface_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_get_reference_count", lg_cairo_pattern_get_reference_count, 1, 0, 0, H_cairo_pattern_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_get_user_data", lg_cairo_pattern_get_user_data, 2, 0, 0, H_cairo_pattern_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_set_user_data", lg_cairo_pattern_set_user_data, 4, 0, 0, H_cairo_pattern_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_pattern_get_rgba", lg_cairo_pattern_get_rgba, 1, 4, 0, H_cairo_pattern_get_rgba, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_surface", lg_cairo_pattern_get_surface, 1, 1, 0, H_cairo_pattern_get_surface, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_color_stop_rgba", lg_cairo_pattern_get_color_stop_rgba, 2, 5, 0, H_cairo_pattern_get_color_stop_rgba, pl_puiu);
  s7_define_typed_function(sc, "cairo_pattern_get_color_stop_count", lg_cairo_pattern_get_color_stop_count, 1, 1, 0, H_cairo_pattern_get_color_stop_count, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_linear_points", lg_cairo_pattern_get_linear_points, 1, 4, 0, H_cairo_pattern_get_linear_points, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_radial_circles", lg_cairo_pattern_get_radial_circles, 1, 6, 0, H_cairo_pattern_get_radial_circles, pl_pu);
  s7_define_typed_function(sc, "cairo_get_scaled_font", lg_cairo_get_scaled_font, 1, 0, 0, H_cairo_get_scaled_font, pl_pu);
  s7_define_typed_function(sc, "cairo_path_extents", lg_cairo_path_extents, 1, 4, 0, H_cairo_path_extents, pl_pu);
  s7_define_typed_function(sc, "cairo_has_current_point", lg_cairo_has_current_point, 1, 0, 0, H_cairo_has_current_point, pl_bu);
  s7_define_typed_function(sc, "cairo_surface_copy_page", lg_cairo_surface_copy_page, 1, 0, 0, H_cairo_surface_copy_page, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_show_page", lg_cairo_surface_show_page, 1, 0, 0, H_cairo_surface_show_page, pl_tu);
  s7_define_typed_function(sc, "cairo_format_stride_for_width", lg_cairo_format_stride_for_width, 2, 0, 0, H_cairo_format_stride_for_width, pl_igi);
  s7_define_typed_function(sc, "cairo_image_surface_create_from_png", lg_cairo_image_surface_create_from_png, 1, 0, 0, H_cairo_image_surface_create_from_png, pl_ps);
  s7_define_typed_function(sc, "cairo_surface_write_to_png", lg_cairo_surface_write_to_png, 2, 0, 0, H_cairo_surface_write_to_png, pl_gus);
#if HAVE_CAIRO_1_8
  s7_define_typed_function(sc, "cairo_glyph_allocate", lg_cairo_glyph_allocate, 1, 0, 0, H_cairo_glyph_allocate, pl_pi);
  s7_define_typed_function(sc, "cairo_glyph_free", lg_cairo_glyph_free, 1, 0, 0, H_cairo_glyph_free, pl_tu);
  s7_define_typed_function(sc, "cairo_text_cluster_allocate", lg_cairo_text_cluster_allocate, 1, 0, 0, H_cairo_text_cluster_allocate, pl_pi);
  s7_define_typed_function(sc, "cairo_text_cluster_free", lg_cairo_text_cluster_free, 1, 0, 0, H_cairo_text_cluster_free, pl_tu);
  s7_define_typed_function(sc, "cairo_show_text_glyphs", lg_cairo_show_text_glyphs, 0, 0, 1, H_cairo_show_text_glyphs, pl_tusiuiui);
  s7_define_typed_function(sc, "cairo_scaled_font_text_to_glyphs", lg_cairo_scaled_font_text_to_glyphs, 0, 0, 1, H_cairo_scaled_font_text_to_glyphs, pl_gurrsiu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_scale_matrix", lg_cairo_scaled_font_get_scale_matrix, 2, 0, 0, H_cairo_scaled_font_get_scale_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_toy_font_face_create", lg_cairo_toy_font_face_create, 3, 0, 0, H_cairo_toy_font_face_create, pl_psg);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_family", lg_cairo_toy_font_face_get_family, 1, 0, 0, H_cairo_toy_font_face_get_family, pl_su);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_slant", lg_cairo_toy_font_face_get_slant, 1, 0, 0, H_cairo_toy_font_face_get_slant, pl_gu);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_weight", lg_cairo_toy_font_face_get_weight, 1, 0, 0, H_cairo_toy_font_face_get_weight, pl_gu);
  s7_define_typed_function(sc, "cairo_user_font_face_create", lg_cairo_user_font_face_create, 0, 0, 0, H_cairo_user_font_face_create, pl_p);
  s7_define_typed_function(sc, "cairo_surface_get_fallback_resolution", lg_cairo_surface_get_fallback_resolution, 1, 2, 0, H_cairo_surface_get_fallback_resolution, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_has_show_text_glyphs", lg_cairo_surface_has_show_text_glyphs, 1, 0, 0, H_cairo_surface_has_show_text_glyphs, pl_iu);
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "cairo_in_clip", lg_cairo_in_clip, 3, 0, 0, H_cairo_in_clip, pl_iur);
  s7_define_typed_function(sc, "cairo_device_reference", lg_cairo_device_reference, 1, 0, 0, H_cairo_device_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_device_status", lg_cairo_device_status, 1, 0, 0, H_cairo_device_status, pl_gu);
  s7_define_typed_function(sc, "cairo_device_acquire", lg_cairo_device_acquire, 1, 0, 0, H_cairo_device_acquire, pl_gu);
  s7_define_typed_function(sc, "cairo_device_release", lg_cairo_device_release, 1, 0, 0, H_cairo_device_release, pl_tu);
  s7_define_typed_function(sc, "cairo_device_flush", lg_cairo_device_flush, 1, 0, 0, H_cairo_device_flush, pl_tu);
  s7_define_typed_function(sc, "cairo_device_finish", lg_cairo_device_finish, 1, 0, 0, H_cairo_device_finish, pl_tu);
  s7_define_typed_function(sc, "cairo_device_destroy", lg_cairo_device_destroy, 1, 0, 0, H_cairo_device_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_device_get_reference_count", lg_cairo_device_get_reference_count, 1, 0, 0, H_cairo_device_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_device_get_user_data", lg_cairo_device_get_user_data, 2, 0, 0, H_cairo_device_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_device_set_user_data", lg_cairo_device_set_user_data, 4, 0, 0, H_cairo_device_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_surface_create_for_rectangle", lg_cairo_surface_create_for_rectangle, 5, 0, 0, H_cairo_surface_create_for_rectangle, pl_pur);
  s7_define_typed_function(sc, "cairo_surface_get_device", lg_cairo_surface_get_device, 1, 0, 0, H_cairo_surface_get_device, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_set_mime_data", lg_cairo_surface_set_mime_data, 6, 0, 0, H_cairo_surface_set_mime_data, pl_gussitu);
  s7_define_typed_function(sc, "cairo_recording_surface_create", lg_cairo_recording_surface_create, 2, 0, 0, H_cairo_recording_surface_create, pl_pgu);
  s7_define_typed_function(sc, "cairo_recording_surface_ink_extents", lg_cairo_recording_surface_ink_extents, 5, 0, 0, H_cairo_recording_surface_ink_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_region_create", lg_cairo_region_create, 0, 0, 0, H_cairo_region_create, pl_p);
  s7_define_typed_function(sc, "cairo_region_create_rectangle", lg_cairo_region_create_rectangle, 1, 0, 0, H_cairo_region_create_rectangle, pl_pu);
  s7_define_typed_function(sc, "cairo_region_create_rectangles", lg_cairo_region_create_rectangles, 2, 0, 0, H_cairo_region_create_rectangles, pl_pui);
  s7_define_typed_function(sc, "cairo_region_copy", lg_cairo_region_copy, 1, 0, 0, H_cairo_region_copy, pl_pu);
  s7_define_typed_function(sc, "cairo_region_reference", lg_cairo_region_reference, 1, 0, 0, H_cairo_region_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_region_destroy", lg_cairo_region_destroy, 1, 0, 0, H_cairo_region_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_region_equal", lg_cairo_region_equal, 2, 0, 0, H_cairo_region_equal, pl_iu);
  s7_define_typed_function(sc, "cairo_region_status", lg_cairo_region_status, 1, 0, 0, H_cairo_region_status, pl_gu);
  s7_define_typed_function(sc, "cairo_region_get_extents", lg_cairo_region_get_extents, 2, 0, 0, H_cairo_region_get_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_region_num_rectangles", lg_cairo_region_num_rectangles, 1, 0, 0, H_cairo_region_num_rectangles, pl_iu);
  s7_define_typed_function(sc, "cairo_region_get_rectangle", lg_cairo_region_get_rectangle, 3, 0, 0, H_cairo_region_get_rectangle, pl_tuiu);
  s7_define_typed_function(sc, "cairo_region_is_empty", lg_cairo_region_is_empty, 1, 0, 0, H_cairo_region_is_empty, pl_iu);
  s7_define_typed_function(sc, "cairo_region_contains_rectangle", lg_cairo_region_contains_rectangle, 2, 0, 0, H_cairo_region_contains_rectangle, pl_tu);
  s7_define_typed_function(sc, "cairo_region_contains_point", lg_cairo_region_contains_point, 3, 0, 0, H_cairo_region_contains_point, pl_iui);
  s7_define_typed_function(sc, "cairo_region_translate", lg_cairo_region_translate, 3, 0, 0, H_cairo_region_translate, pl_tui);
  s7_define_typed_function(sc, "cairo_region_subtract", lg_cairo_region_subtract, 2, 0, 0, H_cairo_region_subtract, pl_gu);
  s7_define_typed_function(sc, "cairo_region_subtract_rectangle", lg_cairo_region_subtract_rectangle, 2, 0, 0, H_cairo_region_subtract_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_intersect", lg_cairo_region_intersect, 2, 0, 0, H_cairo_region_intersect, pl_gu);
  s7_define_typed_function(sc, "cairo_region_intersect_rectangle", lg_cairo_region_intersect_rectangle, 2, 0, 0, H_cairo_region_intersect_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_union", lg_cairo_region_union, 2, 0, 0, H_cairo_region_union, pl_gu);
  s7_define_typed_function(sc, "cairo_region_union_rectangle", lg_cairo_region_union_rectangle, 2, 0, 0, H_cairo_region_union_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_xor", lg_cairo_region_xor, 2, 0, 0, H_cairo_region_xor, pl_gu);
  s7_define_typed_function(sc, "cairo_region_xor_rectangle", lg_cairo_region_xor_rectangle, 2, 0, 0, H_cairo_region_xor_rectangle, pl_gu);
#endif

  s7_define_typed_function(sc, "GPOINTER", lg_GPOINTER, 1, 0, 0, "(GPOINTER obj) casts obj to GPOINTER", NULL);
  s7_define_typed_function(sc, "GDK_DRAG_CONTEXT", lg_GDK_DRAG_CONTEXT, 1, 0, 0, "(GDK_DRAG_CONTEXT obj) casts obj to GDK_DRAG_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GDK_DEVICE", lg_GDK_DEVICE, 1, 0, 0, "(GDK_DEVICE obj) casts obj to GDK_DEVICE", pl_bpt);
  s7_define_typed_function(sc, "GDK_KEYMAP", lg_GDK_KEYMAP, 1, 0, 0, "(GDK_KEYMAP obj) casts obj to GDK_KEYMAP", pl_bpt);
  s7_define_typed_function(sc, "GDK_WINDOW", lg_GDK_WINDOW, 1, 0, 0, "(GDK_WINDOW obj) casts obj to GDK_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "GDK_PIXBUF", lg_GDK_PIXBUF, 1, 0, 0, "(GDK_PIXBUF obj) casts obj to GDK_PIXBUF", pl_bpt);
  s7_define_typed_function(sc, "GDK_PIXBUF_ANIMATION", lg_GDK_PIXBUF_ANIMATION, 1, 0, 0, "(GDK_PIXBUF_ANIMATION obj) casts obj to GDK_PIXBUF_ANIMATION", pl_bpt);
  s7_define_typed_function(sc, "GDK_PIXBUF_ANIMATION_ITER", lg_GDK_PIXBUF_ANIMATION_ITER, 1, 0, 0, "(GDK_PIXBUF_ANIMATION_ITER obj) casts obj to GDK_PIXBUF_ANIMATION_ITER", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCEL_GROUP", lg_GTK_ACCEL_GROUP, 1, 0, 0, "(GTK_ACCEL_GROUP obj) casts obj to GTK_ACCEL_GROUP", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCEL_LABEL", lg_GTK_ACCEL_LABEL, 1, 0, 0, "(GTK_ACCEL_LABEL obj) casts obj to GTK_ACCEL_LABEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCESSIBLE", lg_GTK_ACCESSIBLE, 1, 0, 0, "(GTK_ACCESSIBLE obj) casts obj to GTK_ACCESSIBLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_ADJUSTMENT", lg_GTK_ADJUSTMENT, 1, 0, 0, "(GTK_ADJUSTMENT obj) casts obj to GTK_ADJUSTMENT", pl_bpt);
  s7_define_typed_function(sc, "GTK_ASPECT_FRAME", lg_GTK_ASPECT_FRAME, 1, 0, 0, "(GTK_ASPECT_FRAME obj) casts obj to GTK_ASPECT_FRAME", pl_bpt);
  s7_define_typed_function(sc, "GTK_BUTTON_BOX", lg_GTK_BUTTON_BOX, 1, 0, 0, "(GTK_BUTTON_BOX obj) casts obj to GTK_BUTTON_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_BIN", lg_GTK_BIN, 1, 0, 0, "(GTK_BIN obj) casts obj to GTK_BIN", pl_bpt);
  s7_define_typed_function(sc, "GTK_BOX", lg_GTK_BOX, 1, 0, 0, "(GTK_BOX obj) casts obj to GTK_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_BUTTON", lg_GTK_BUTTON, 1, 0, 0, "(GTK_BUTTON obj) casts obj to GTK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_CALENDAR", lg_GTK_CALENDAR, 1, 0, 0, "(GTK_CALENDAR obj) casts obj to GTK_CALENDAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_EDITABLE", lg_GTK_CELL_EDITABLE, 1, 0, 0, "(GTK_CELL_EDITABLE obj) casts obj to GTK_CELL_EDITABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER", lg_GTK_CELL_RENDERER, 1, 0, 0, "(GTK_CELL_RENDERER obj) casts obj to GTK_CELL_RENDERER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_PIXBUF", lg_GTK_CELL_RENDERER_PIXBUF, 1, 0, 0, "(GTK_CELL_RENDERER_PIXBUF obj) casts obj to GTK_CELL_RENDERER_PIXBUF", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_TEXT", lg_GTK_CELL_RENDERER_TEXT, 1, 0, 0, "(GTK_CELL_RENDERER_TEXT obj) casts obj to GTK_CELL_RENDERER_TEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_TOGGLE", lg_GTK_CELL_RENDERER_TOGGLE, 1, 0, 0, "(GTK_CELL_RENDERER_TOGGLE obj) casts obj to GTK_CELL_RENDERER_TOGGLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_CHECK_BUTTON", lg_GTK_CHECK_BUTTON, 1, 0, 0, "(GTK_CHECK_BUTTON obj) casts obj to GTK_CHECK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_CHECK_MENU_ITEM", lg_GTK_CHECK_MENU_ITEM, 1, 0, 0, "(GTK_CHECK_MENU_ITEM obj) casts obj to GTK_CHECK_MENU_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_CONTAINER", lg_GTK_CONTAINER, 1, 0, 0, "(GTK_CONTAINER obj) casts obj to GTK_CONTAINER", pl_bpt);
  s7_define_typed_function(sc, "GTK_DIALOG", lg_GTK_DIALOG, 1, 0, 0, "(GTK_DIALOG obj) casts obj to GTK_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_DRAWING_AREA", lg_GTK_DRAWING_AREA, 1, 0, 0, "(GTK_DRAWING_AREA obj) casts obj to GTK_DRAWING_AREA", pl_bpt);
  s7_define_typed_function(sc, "GTK_EDITABLE", lg_GTK_EDITABLE, 1, 0, 0, "(GTK_EDITABLE obj) casts obj to GTK_EDITABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY", lg_GTK_ENTRY, 1, 0, 0, "(GTK_ENTRY obj) casts obj to GTK_ENTRY", pl_bpt);
  s7_define_typed_function(sc, "GTK_FIXED", lg_GTK_FIXED, 1, 0, 0, "(GTK_FIXED obj) casts obj to GTK_FIXED", pl_bpt);
  s7_define_typed_function(sc, "GTK_FRAME", lg_GTK_FRAME, 1, 0, 0, "(GTK_FRAME obj) casts obj to GTK_FRAME", pl_bpt);
  s7_define_typed_function(sc, "GTK_IMAGE", lg_GTK_IMAGE, 1, 0, 0, "(GTK_IMAGE obj) casts obj to GTK_IMAGE", pl_bpt);
  s7_define_typed_function(sc, "GTK_IM_CONTEXT", lg_GTK_IM_CONTEXT, 1, 0, 0, "(GTK_IM_CONTEXT obj) casts obj to GTK_IM_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_IM_CONTEXT_SIMPLE", lg_GTK_IM_CONTEXT_SIMPLE, 1, 0, 0, "(GTK_IM_CONTEXT_SIMPLE obj) casts obj to GTK_IM_CONTEXT_SIMPLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_INVISIBLE", lg_GTK_INVISIBLE, 1, 0, 0, "(GTK_INVISIBLE obj) casts obj to GTK_INVISIBLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_LABEL", lg_GTK_LABEL, 1, 0, 0, "(GTK_LABEL obj) casts obj to GTK_LABEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_LAYOUT", lg_GTK_LAYOUT, 1, 0, 0, "(GTK_LAYOUT obj) casts obj to GTK_LAYOUT", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_STORE", lg_GTK_LIST_STORE, 1, 0, 0, "(GTK_LIST_STORE obj) casts obj to GTK_LIST_STORE", pl_bpt);
  s7_define_typed_function(sc, "GTK_MENU_BAR", lg_GTK_MENU_BAR, 1, 0, 0, "(GTK_MENU_BAR obj) casts obj to GTK_MENU_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_MENU", lg_GTK_MENU, 1, 0, 0, "(GTK_MENU obj) casts obj to GTK_MENU", pl_bpt);
  s7_define_typed_function(sc, "GTK_MENU_ITEM", lg_GTK_MENU_ITEM, 1, 0, 0, "(GTK_MENU_ITEM obj) casts obj to GTK_MENU_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_MENU_SHELL", lg_GTK_MENU_SHELL, 1, 0, 0, "(GTK_MENU_SHELL obj) casts obj to GTK_MENU_SHELL", pl_bpt);
  s7_define_typed_function(sc, "GTK_NOTEBOOK", lg_GTK_NOTEBOOK, 1, 0, 0, "(GTK_NOTEBOOK obj) casts obj to GTK_NOTEBOOK", pl_bpt);
  s7_define_typed_function(sc, "GTK_PANED", lg_GTK_PANED, 1, 0, 0, "(GTK_PANED obj) casts obj to GTK_PANED", pl_bpt);
  s7_define_typed_function(sc, "GTK_PROGRESS_BAR", lg_GTK_PROGRESS_BAR, 1, 0, 0, "(GTK_PROGRESS_BAR obj) casts obj to GTK_PROGRESS_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_RADIO_BUTTON", lg_GTK_RADIO_BUTTON, 1, 0, 0, "(GTK_RADIO_BUTTON obj) casts obj to GTK_RADIO_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_RADIO_MENU_ITEM", lg_GTK_RADIO_MENU_ITEM, 1, 0, 0, "(GTK_RADIO_MENU_ITEM obj) casts obj to GTK_RADIO_MENU_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_RANGE", lg_GTK_RANGE, 1, 0, 0, "(GTK_RANGE obj) casts obj to GTK_RANGE", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCALE", lg_GTK_SCALE, 1, 0, 0, "(GTK_SCALE obj) casts obj to GTK_SCALE", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLBAR", lg_GTK_SCROLLBAR, 1, 0, 0, "(GTK_SCROLLBAR obj) casts obj to GTK_SCROLLBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLED_WINDOW", lg_GTK_SCROLLED_WINDOW, 1, 0, 0, "(GTK_SCROLLED_WINDOW obj) casts obj to GTK_SCROLLED_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEPARATOR", lg_GTK_SEPARATOR, 1, 0, 0, "(GTK_SEPARATOR obj) casts obj to GTK_SEPARATOR", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEPARATOR_MENU_ITEM", lg_GTK_SEPARATOR_MENU_ITEM, 1, 0, 0, "(GTK_SEPARATOR_MENU_ITEM obj) casts obj to GTK_SEPARATOR_MENU_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_SETTINGS", lg_GTK_SETTINGS, 1, 0, 0, "(GTK_SETTINGS obj) casts obj to GTK_SETTINGS", pl_bpt);
  s7_define_typed_function(sc, "GTK_SIZE_GROUP", lg_GTK_SIZE_GROUP, 1, 0, 0, "(GTK_SIZE_GROUP obj) casts obj to GTK_SIZE_GROUP", pl_bpt);
  s7_define_typed_function(sc, "GTK_SPIN_BUTTON", lg_GTK_SPIN_BUTTON, 1, 0, 0, "(GTK_SPIN_BUTTON obj) casts obj to GTK_SPIN_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_STATUSBAR", lg_GTK_STATUSBAR, 1, 0, 0, "(GTK_STATUSBAR obj) casts obj to GTK_STATUSBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_BUFFER", lg_GTK_TEXT_BUFFER, 1, 0, 0, "(GTK_TEXT_BUFFER obj) casts obj to GTK_TEXT_BUFFER", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_CHILD_ANCHOR", lg_GTK_TEXT_CHILD_ANCHOR, 1, 0, 0, "(GTK_TEXT_CHILD_ANCHOR obj) casts obj to GTK_TEXT_CHILD_ANCHOR", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_MARK", lg_GTK_TEXT_MARK, 1, 0, 0, "(GTK_TEXT_MARK obj) casts obj to GTK_TEXT_MARK", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_TAG", lg_GTK_TEXT_TAG, 1, 0, 0, "(GTK_TEXT_TAG obj) casts obj to GTK_TEXT_TAG", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_TAG_TABLE", lg_GTK_TEXT_TAG_TABLE, 1, 0, 0, "(GTK_TEXT_TAG_TABLE obj) casts obj to GTK_TEXT_TAG_TABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_VIEW", lg_GTK_TEXT_VIEW, 1, 0, 0, "(GTK_TEXT_VIEW obj) casts obj to GTK_TEXT_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOGGLE_BUTTON", lg_GTK_TOGGLE_BUTTON, 1, 0, 0, "(GTK_TOGGLE_BUTTON obj) casts obj to GTK_TOGGLE_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOLBAR", lg_GTK_TOOLBAR, 1, 0, 0, "(GTK_TOOLBAR obj) casts obj to GTK_TOOLBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_DRAG_SOURCE", lg_GTK_TREE_DRAG_SOURCE, 1, 0, 0, "(GTK_TREE_DRAG_SOURCE obj) casts obj to GTK_TREE_DRAG_SOURCE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_DRAG_DEST", lg_GTK_TREE_DRAG_DEST, 1, 0, 0, "(GTK_TREE_DRAG_DEST obj) casts obj to GTK_TREE_DRAG_DEST", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL", lg_GTK_TREE_MODEL, 1, 0, 0, "(GTK_TREE_MODEL obj) casts obj to GTK_TREE_MODEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL_SORT", lg_GTK_TREE_MODEL_SORT, 1, 0, 0, "(GTK_TREE_MODEL_SORT obj) casts obj to GTK_TREE_MODEL_SORT", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_SELECTION", lg_GTK_TREE_SELECTION, 1, 0, 0, "(GTK_TREE_SELECTION obj) casts obj to GTK_TREE_SELECTION", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_SORTABLE", lg_GTK_TREE_SORTABLE, 1, 0, 0, "(GTK_TREE_SORTABLE obj) casts obj to GTK_TREE_SORTABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_STORE", lg_GTK_TREE_STORE, 1, 0, 0, "(GTK_TREE_STORE obj) casts obj to GTK_TREE_STORE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_VIEW_COLUMN", lg_GTK_TREE_VIEW_COLUMN, 1, 0, 0, "(GTK_TREE_VIEW_COLUMN obj) casts obj to GTK_TREE_VIEW_COLUMN", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_VIEW", lg_GTK_TREE_VIEW, 1, 0, 0, "(GTK_TREE_VIEW obj) casts obj to GTK_TREE_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_VIEWPORT", lg_GTK_VIEWPORT, 1, 0, 0, "(GTK_VIEWPORT obj) casts obj to GTK_VIEWPORT", pl_bpt);
  s7_define_typed_function(sc, "GTK_WIDGET", lg_GTK_WIDGET, 1, 0, 0, "(GTK_WIDGET obj) casts obj to GTK_WIDGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_WINDOW", lg_GTK_WINDOW, 1, 0, 0, "(GTK_WINDOW obj) casts obj to GTK_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "PANGO_CONTEXT", lg_PANGO_CONTEXT, 1, 0, 0, "(PANGO_CONTEXT obj) casts obj to PANGO_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_FAMILY", lg_PANGO_FONT_FAMILY, 1, 0, 0, "(PANGO_FONT_FAMILY obj) casts obj to PANGO_FONT_FAMILY", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_FACE", lg_PANGO_FONT_FACE, 1, 0, 0, "(PANGO_FONT_FACE obj) casts obj to PANGO_FONT_FACE", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT", lg_PANGO_FONT, 1, 0, 0, "(PANGO_FONT obj) casts obj to PANGO_FONT", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_MAP", lg_PANGO_FONT_MAP, 1, 0, 0, "(PANGO_FONT_MAP obj) casts obj to PANGO_FONT_MAP", pl_bpt);
  s7_define_typed_function(sc, "PANGO_LAYOUT", lg_PANGO_LAYOUT, 1, 0, 0, "(PANGO_LAYOUT obj) casts obj to PANGO_LAYOUT", pl_bpt);
  s7_define_typed_function(sc, "G_OBJECT", lg_G_OBJECT, 1, 0, 0, "(G_OBJECT obj) casts obj to G_OBJECT", pl_bpt);
  s7_define_typed_function(sc, "GDK_SCREEN", lg_GDK_SCREEN, 1, 0, 0, "(GDK_SCREEN obj) casts obj to GDK_SCREEN", pl_bpt);
  s7_define_typed_function(sc, "GDK_DISPLAY_OBJECT", lg_GDK_DISPLAY_OBJECT, 1, 0, 0, "(GDK_DISPLAY_OBJECT obj) casts obj to GDK_DISPLAY_OBJECT", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT", lg_GDK_EVENT, 1, 0, 0, "(GDK_EVENT obj) casts obj to GDK_EVENT", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_ANY", lg_GDK_EVENT_ANY, 1, 0, 0, "(GDK_EVENT_ANY obj) casts obj to GDK_EVENT_ANY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_EXPOSE", lg_GDK_EVENT_EXPOSE, 1, 0, 0, "(GDK_EVENT_EXPOSE obj) casts obj to GDK_EVENT_EXPOSE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_NOEXPOSE", lg_GDK_EVENT_NOEXPOSE, 1, 0, 0, "(GDK_EVENT_NOEXPOSE obj) casts obj to GDK_EVENT_NOEXPOSE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_VISIBILITY", lg_GDK_EVENT_VISIBILITY, 1, 0, 0, "(GDK_EVENT_VISIBILITY obj) casts obj to GDK_EVENT_VISIBILITY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_MOTION", lg_GDK_EVENT_MOTION, 1, 0, 0, "(GDK_EVENT_MOTION obj) casts obj to GDK_EVENT_MOTION", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_BUTTON", lg_GDK_EVENT_BUTTON, 1, 0, 0, "(GDK_EVENT_BUTTON obj) casts obj to GDK_EVENT_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_SCROLL", lg_GDK_EVENT_SCROLL, 1, 0, 0, "(GDK_EVENT_SCROLL obj) casts obj to GDK_EVENT_SCROLL", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_KEY", lg_GDK_EVENT_KEY, 1, 0, 0, "(GDK_EVENT_KEY obj) casts obj to GDK_EVENT_KEY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_CROSSING", lg_GDK_EVENT_CROSSING, 1, 0, 0, "(GDK_EVENT_CROSSING obj) casts obj to GDK_EVENT_CROSSING", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_FOCUS", lg_GDK_EVENT_FOCUS, 1, 0, 0, "(GDK_EVENT_FOCUS obj) casts obj to GDK_EVENT_FOCUS", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_CONFIGURE", lg_GDK_EVENT_CONFIGURE, 1, 0, 0, "(GDK_EVENT_CONFIGURE obj) casts obj to GDK_EVENT_CONFIGURE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_PROPERTY", lg_GDK_EVENT_PROPERTY, 1, 0, 0, "(GDK_EVENT_PROPERTY obj) casts obj to GDK_EVENT_PROPERTY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_SELECTION", lg_GDK_EVENT_SELECTION, 1, 0, 0, "(GDK_EVENT_SELECTION obj) casts obj to GDK_EVENT_SELECTION", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_PROXIMITY", lg_GDK_EVENT_PROXIMITY, 1, 0, 0, "(GDK_EVENT_PROXIMITY obj) casts obj to GDK_EVENT_PROXIMITY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_SETTING", lg_GDK_EVENT_SETTING, 1, 0, 0, "(GDK_EVENT_SETTING obj) casts obj to GDK_EVENT_SETTING", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_WINDOWSTATE", lg_GDK_EVENT_WINDOWSTATE, 1, 0, 0, "(GDK_EVENT_WINDOWSTATE obj) casts obj to GDK_EVENT_WINDOWSTATE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_DND", lg_GDK_EVENT_DND, 1, 0, 0, "(GDK_EVENT_DND obj) casts obj to GDK_EVENT_DND", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_DIALOG", lg_GTK_FILE_CHOOSER_DIALOG, 1, 0, 0, "(GTK_FILE_CHOOSER_DIALOG obj) casts obj to GTK_FILE_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_WIDGET", lg_GTK_FILE_CHOOSER_WIDGET, 1, 0, 0, "(GTK_FILE_CHOOSER_WIDGET obj) casts obj to GTK_FILE_CHOOSER_WIDGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL_FILTER", lg_GTK_TREE_MODEL_FILTER, 1, 0, 0, "(GTK_TREE_MODEL_FILTER obj) casts obj to GTK_TREE_MODEL_FILTER", pl_bpt);
  s7_define_typed_function(sc, "GTK_COMBO_BOX", lg_GTK_COMBO_BOX, 1, 0, 0, "(GTK_COMBO_BOX obj) casts obj to GTK_COMBO_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_EXPANDER", lg_GTK_EXPANDER, 1, 0, 0, "(GTK_EXPANDER obj) casts obj to GTK_EXPANDER", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_BUTTON", lg_GTK_FONT_BUTTON, 1, 0, 0, "(GTK_FONT_BUTTON obj) casts obj to GTK_FONT_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_BUTTON", lg_GTK_COLOR_BUTTON, 1, 0, 0, "(GTK_COLOR_BUTTON obj) casts obj to GTK_COLOR_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY_COMPLETION", lg_GTK_ENTRY_COMPLETION, 1, 0, 0, "(GTK_ENTRY_COMPLETION obj) casts obj to GTK_ENTRY_COMPLETION", pl_bpt);
  s7_define_typed_function(sc, "GTK_RADIO_TOOL_BUTTON", lg_GTK_RADIO_TOOL_BUTTON, 1, 0, 0, "(GTK_RADIO_TOOL_BUTTON obj) casts obj to GTK_RADIO_TOOL_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEPARATOR_TOOL_ITEM", lg_GTK_SEPARATOR_TOOL_ITEM, 1, 0, 0, "(GTK_SEPARATOR_TOOL_ITEM obj) casts obj to GTK_SEPARATOR_TOOL_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOGGLE_TOOL_BUTTON", lg_GTK_TOGGLE_TOOL_BUTTON, 1, 0, 0, "(GTK_TOGGLE_TOOL_BUTTON obj) casts obj to GTK_TOGGLE_TOOL_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_FILTER", lg_GTK_FILE_FILTER, 1, 0, 0, "(GTK_FILE_FILTER obj) casts obj to GTK_FILE_FILTER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_LAYOUT", lg_GTK_CELL_LAYOUT, 1, 0, 0, "(GTK_CELL_LAYOUT obj) casts obj to GTK_CELL_LAYOUT", pl_bpt);
  s7_define_typed_function(sc, "GTK_CLIPBOARD", lg_GTK_CLIPBOARD, 1, 0, 0, "(GTK_CLIPBOARD obj) casts obj to GTK_CLIPBOARD", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER", lg_GTK_FILE_CHOOSER, 1, 0, 0, "(GTK_FILE_CHOOSER obj) casts obj to GTK_FILE_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_ICON_THEME", lg_GTK_ICON_THEME, 1, 0, 0, "(GTK_ICON_THEME obj) casts obj to GTK_ICON_THEME", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOL_BUTTON", lg_GTK_TOOL_BUTTON, 1, 0, 0, "(GTK_TOOL_BUTTON obj) casts obj to GTK_TOOL_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOL_ITEM", lg_GTK_TOOL_ITEM, 1, 0, 0, "(GTK_TOOL_ITEM obj) casts obj to GTK_TOOL_ITEM", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCEL_MAP", lg_GTK_ACCEL_MAP, 1, 0, 0, "(GTK_ACCEL_MAP obj) casts obj to GTK_ACCEL_MAP", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_VIEW", lg_GTK_CELL_VIEW, 1, 0, 0, "(GTK_CELL_VIEW obj) casts obj to GTK_CELL_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_ABOUT_DIALOG", lg_GTK_ABOUT_DIALOG, 1, 0, 0, "(GTK_ABOUT_DIALOG obj) casts obj to GTK_ABOUT_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_COMBO", lg_GTK_CELL_RENDERER_COMBO, 1, 0, 0, "(GTK_CELL_RENDERER_COMBO obj) casts obj to GTK_CELL_RENDERER_COMBO", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_PROGRESS", lg_GTK_CELL_RENDERER_PROGRESS, 1, 0, 0, "(GTK_CELL_RENDERER_PROGRESS obj) casts obj to GTK_CELL_RENDERER_PROGRESS", pl_bpt);
  s7_define_typed_function(sc, "GTK_ICON_VIEW", lg_GTK_ICON_VIEW, 1, 0, 0, "(GTK_ICON_VIEW obj) casts obj to GTK_ICON_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_BUTTON", lg_GTK_FILE_CHOOSER_BUTTON, 1, 0, 0, "(GTK_FILE_CHOOSER_BUTTON obj) casts obj to GTK_FILE_CHOOSER_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_MENU_TOOL_BUTTON", lg_GTK_MENU_TOOL_BUTTON, 1, 0, 0, "(GTK_MENU_TOOL_BUTTON obj) casts obj to GTK_MENU_TOOL_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_ASSISTANT", lg_GTK_ASSISTANT, 1, 0, 0, "(GTK_ASSISTANT obj) casts obj to GTK_ASSISTANT", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_ACCEL", lg_GTK_CELL_RENDERER_ACCEL, 1, 0, 0, "(GTK_CELL_RENDERER_ACCEL obj) casts obj to GTK_CELL_RENDERER_ACCEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_SPIN", lg_GTK_CELL_RENDERER_SPIN, 1, 0, 0, "(GTK_CELL_RENDERER_SPIN obj) casts obj to GTK_CELL_RENDERER_SPIN", pl_bpt);
  s7_define_typed_function(sc, "GTK_LINK_BUTTON", lg_GTK_LINK_BUTTON, 1, 0, 0, "(GTK_LINK_BUTTON obj) casts obj to GTK_LINK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_CHOOSER_DIALOG", lg_GTK_RECENT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_RECENT_CHOOSER_DIALOG obj) casts obj to GTK_RECENT_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_CHOOSER", lg_GTK_RECENT_CHOOSER, 1, 0, 0, "(GTK_RECENT_CHOOSER obj) casts obj to GTK_RECENT_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_CHOOSER_MENU", lg_GTK_RECENT_CHOOSER_MENU, 1, 0, 0, "(GTK_RECENT_CHOOSER_MENU obj) casts obj to GTK_RECENT_CHOOSER_MENU", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_CHOOSER_WIDGET", lg_GTK_RECENT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_RECENT_CHOOSER_WIDGET obj) casts obj to GTK_RECENT_CHOOSER_WIDGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_FILTER", lg_GTK_RECENT_FILTER, 1, 0, 0, "(GTK_RECENT_FILTER obj) casts obj to GTK_RECENT_FILTER", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_MANAGER", lg_GTK_RECENT_MANAGER, 1, 0, 0, "(GTK_RECENT_MANAGER obj) casts obj to GTK_RECENT_MANAGER", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_CONTEXT", lg_GTK_PRINT_CONTEXT, 1, 0, 0, "(GTK_PRINT_CONTEXT obj) casts obj to GTK_PRINT_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_OPERATION", lg_GTK_PRINT_OPERATION, 1, 0, 0, "(GTK_PRINT_OPERATION obj) casts obj to GTK_PRINT_OPERATION", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_SETTINGS", lg_GTK_PRINT_SETTINGS, 1, 0, 0, "(GTK_PRINT_SETTINGS obj) casts obj to GTK_PRINT_SETTINGS", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOLTIP", lg_GTK_TOOLTIP, 1, 0, 0, "(GTK_TOOLTIP obj) casts obj to GTK_TOOLTIP", pl_bpt);
#if GTK_CHECK_VERSION(2, 18, 0)
  s7_define_typed_function(sc, "GTK_INFO_BAR", lg_GTK_INFO_BAR, 1, 0, 0, "(GTK_INFO_BAR obj) casts obj to GTK_INFO_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY_BUFFER", lg_GTK_ENTRY_BUFFER, 1, 0, 0, "(GTK_ENTRY_BUFFER obj) casts obj to GTK_ENTRY_BUFFER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  s7_define_typed_function(sc, "GTK_SPINNER", lg_GTK_SPINNER, 1, 0, 0, "(GTK_SPINNER obj) casts obj to GTK_SPINNER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_SPINNER", lg_GTK_CELL_RENDERER_SPINNER, 1, 0, 0, "(GTK_CELL_RENDERER_SPINNER obj) casts obj to GTK_CELL_RENDERER_SPINNER", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOL_PALETTE", lg_GTK_TOOL_PALETTE, 1, 0, 0, "(GTK_TOOL_PALETTE obj) casts obj to GTK_TOOL_PALETTE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOL_ITEM_GROUP", lg_GTK_TOOL_ITEM_GROUP, 1, 0, 0, "(GTK_TOOL_ITEM_GROUP obj) casts obj to GTK_TOOL_ITEM_GROUP", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "GTK_COMBO_BOX_TEXT", lg_GTK_COMBO_BOX_TEXT, 1, 0, 0, "(GTK_COMBO_BOX_TEXT obj) casts obj to GTK_COMBO_BOX_TEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_GRID", lg_GTK_GRID, 1, 0, 0, "(GTK_GRID obj) casts obj to GTK_GRID", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLABLE", lg_GTK_SCROLLABLE, 1, 0, 0, "(GTK_SCROLLABLE obj) casts obj to GTK_SCROLLABLE", pl_bpt);
  s7_define_typed_function(sc, "GDK_RGBA", lg_GDK_RGBA, 1, 0, 0, "(GDK_RGBA obj) casts obj to GDK_RGBA", pl_bpt);
  s7_define_typed_function(sc, "GTK_SWITCH", lg_GTK_SWITCH, 1, 0, 0, "(GTK_SWITCH obj) casts obj to GTK_SWITCH", pl_bpt);
  s7_define_typed_function(sc, "GTK_ORIENTABLE", lg_GTK_ORIENTABLE, 1, 0, 0, "(GTK_ORIENTABLE obj) casts obj to GTK_ORIENTABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_WINDOW_GROUP", lg_GTK_WINDOW_GROUP, 1, 0, 0, "(GTK_WINDOW_GROUP obj) casts obj to GTK_WINDOW_GROUP", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOL_SHELL", lg_GTK_TOOL_SHELL, 1, 0, 0, "(GTK_TOOL_SHELL obj) casts obj to GTK_TOOL_SHELL", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "GTK_OVERLAY", lg_GTK_OVERLAY, 1, 0, 0, "(GTK_OVERLAY obj) casts obj to GTK_OVERLAY", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER", lg_GTK_FONT_CHOOSER, 1, 0, 0, "(GTK_FONT_CHOOSER obj) casts obj to GTK_FONT_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER_DIALOG", lg_GTK_FONT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_FONT_CHOOSER_DIALOG obj) casts obj to GTK_FONT_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER_WIDGET", lg_GTK_FONT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_FONT_CHOOSER_WIDGET obj) casts obj to GTK_FONT_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "GTK_APPLICATION_WINDOW", lg_GTK_APPLICATION_WINDOW, 1, 0, 0, "(GTK_APPLICATION_WINDOW obj) casts obj to GTK_APPLICATION_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_CHOOSER_DIALOG", lg_GTK_COLOR_CHOOSER_DIALOG, 1, 0, 0, "(GTK_COLOR_CHOOSER_DIALOG obj) casts obj to GTK_COLOR_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_CHOOSER_WIDGET", lg_GTK_COLOR_CHOOSER_WIDGET, 1, 0, 0, "(GTK_COLOR_CHOOSER_WIDGET obj) casts obj to GTK_COLOR_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "GTK_MENU_BUTTON", lg_GTK_MENU_BUTTON, 1, 0, 0, "(GTK_MENU_BUTTON obj) casts obj to GTK_MENU_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEARCH_ENTRY", lg_GTK_SEARCH_ENTRY, 1, 0, 0, "(GTK_SEARCH_ENTRY obj) casts obj to GTK_SEARCH_ENTRY", pl_bpt);
  s7_define_typed_function(sc, "GTK_LEVEL_BAR", lg_GTK_LEVEL_BAR, 1, 0, 0, "(GTK_LEVEL_BAR obj) casts obj to GTK_LEVEL_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "GTK_PLACES_SIDEBAR", lg_GTK_PLACES_SIDEBAR, 1, 0, 0, "(GTK_PLACES_SIDEBAR obj) casts obj to GTK_PLACES_SIDEBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_STACK_SWITCHER", lg_GTK_STACK_SWITCHER, 1, 0, 0, "(GTK_STACK_SWITCHER obj) casts obj to GTK_STACK_SWITCHER", pl_bpt);
  s7_define_typed_function(sc, "GTK_STACK", lg_GTK_STACK, 1, 0, 0, "(GTK_STACK obj) casts obj to GTK_STACK", pl_bpt);
  s7_define_typed_function(sc, "GTK_REVEALER", lg_GTK_REVEALER, 1, 0, 0, "(GTK_REVEALER obj) casts obj to GTK_REVEALER", pl_bpt);
  s7_define_typed_function(sc, "GTK_HEADER_BAR", lg_GTK_HEADER_BAR, 1, 0, 0, "(GTK_HEADER_BAR obj) casts obj to GTK_HEADER_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_BOX", lg_GTK_LIST_BOX, 1, 0, 0, "(GTK_LIST_BOX obj) casts obj to GTK_LIST_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_BOX_ROW", lg_GTK_LIST_BOX_ROW, 1, 0, 0, "(GTK_LIST_BOX_ROW obj) casts obj to GTK_LIST_BOX_ROW", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEARCH_BAR", lg_GTK_SEARCH_BAR, 1, 0, 0, "(GTK_SEARCH_BAR obj) casts obj to GTK_SEARCH_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "GTK_FLOW_BOX", lg_GTK_FLOW_BOX, 1, 0, 0, "(GTK_FLOW_BOX obj) casts obj to GTK_FLOW_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_FLOW_BOX_CHILD", lg_GTK_FLOW_BOX_CHILD, 1, 0, 0, "(GTK_FLOW_BOX_CHILD obj) casts obj to GTK_FLOW_BOX_CHILD", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACTION_BAR", lg_GTK_ACTION_BAR, 1, 0, 0, "(GTK_ACTION_BAR obj) casts obj to GTK_ACTION_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_POPOVER", lg_GTK_POPOVER, 1, 0, 0, "(GTK_POPOVER obj) casts obj to GTK_POPOVER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "GTK_GESTURE", lg_GTK_GESTURE, 1, 0, 0, "(GTK_GESTURE obj) casts obj to GTK_GESTURE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_DRAG", lg_GTK_GESTURE_DRAG, 1, 0, 0, "(GTK_GESTURE_DRAG obj) casts obj to GTK_GESTURE_DRAG", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_LONG_PRESS", lg_GTK_GESTURE_LONG_PRESS, 1, 0, 0, "(GTK_GESTURE_LONG_PRESS obj) casts obj to GTK_GESTURE_LONG_PRESS", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_ZOOM", lg_GTK_GESTURE_ZOOM, 1, 0, 0, "(GTK_GESTURE_ZOOM obj) casts obj to GTK_GESTURE_ZOOM", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_SWIPE", lg_GTK_GESTURE_SWIPE, 1, 0, 0, "(GTK_GESTURE_SWIPE obj) casts obj to GTK_GESTURE_SWIPE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_SINGLE", lg_GTK_GESTURE_SINGLE, 1, 0, 0, "(GTK_GESTURE_SINGLE obj) casts obj to GTK_GESTURE_SINGLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_PAN", lg_GTK_GESTURE_PAN, 1, 0, 0, "(GTK_GESTURE_PAN obj) casts obj to GTK_GESTURE_PAN", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_MULTI_PRESS", lg_GTK_GESTURE_MULTI_PRESS, 1, 0, 0, "(GTK_GESTURE_MULTI_PRESS obj) casts obj to GTK_GESTURE_MULTI_PRESS", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_ROTATE", lg_GTK_GESTURE_ROTATE, 1, 0, 0, "(GTK_GESTURE_ROTATE obj) casts obj to GTK_GESTURE_ROTATE", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER", lg_GTK_EVENT_CONTROLLER, 1, 0, 0, "(GTK_EVENT_CONTROLLER obj) casts obj to GTK_EVENT_CONTROLLER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "GTK_GL_AREA", lg_GTK_GL_AREA, 1, 0, 0, "(GTK_GL_AREA obj) casts obj to GTK_GL_AREA", pl_bpt);
  s7_define_typed_function(sc, "GDK_GL_CONTEXT", lg_GDK_GL_CONTEXT, 1, 0, 0, "(GDK_GL_CONTEXT obj) casts obj to GDK_GL_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_POPOVER_MENU", lg_GTK_POPOVER_MENU, 1, 0, 0, "(GTK_POPOVER_MENU obj) casts obj to GTK_POPOVER_MENU", pl_bpt);
  s7_define_typed_function(sc, "GTK_STACK_SIDEBAR", lg_GTK_STACK_SIDEBAR, 1, 0, 0, "(GTK_STACK_SIDEBAR obj) casts obj to GTK_STACK_SIDEBAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "GDK_SEAT", lg_GDK_SEAT, 1, 0, 0, "(GDK_SEAT obj) casts obj to GDK_SEAT", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "GDK_DEVICE_TOOL", lg_GDK_DEVICE_TOOL, 1, 0, 0, "(GDK_DEVICE_TOOL obj) casts obj to GDK_DEVICE_TOOL", pl_bpt);
  s7_define_typed_function(sc, "GDK_MONITOR", lg_GDK_MONITOR, 1, 0, 0, "(GDK_MONITOR obj) casts obj to GDK_MONITOR", pl_bpt);
  s7_define_typed_function(sc, "GDK_DRAWING_CONTEXT", lg_GDK_DRAWING_CONTEXT, 1, 0, 0, "(GDK_DRAWING_CONTEXT obj) casts obj to GDK_DRAWING_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GDK_DEVICE_PAD", lg_GDK_DEVICE_PAD, 1, 0, 0, "(GDK_DEVICE_PAD obj) casts obj to GDK_DEVICE_PAD", pl_bpt);
  s7_define_typed_function(sc, "GTK_PAD_CONTROLLER", lg_GTK_PAD_CONTROLLER, 1, 0, 0, "(GTK_PAD_CONTROLLER obj) casts obj to GTK_PAD_CONTROLLER", pl_bpt);
  s7_define_typed_function(sc, "GTK_SHORTCUT_LABEL", lg_GTK_SHORTCUT_LABEL, 1, 0, 0, "(GTK_SHORTCUT_LABEL obj) casts obj to GTK_SHORTCUT_LABEL", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  s7_define_typed_function(sc, "GTK_CENTER_BOX", lg_GTK_CENTER_BOX, 1, 0, 0, "(GTK_CENTER_BOX obj) casts obj to GTK_CENTER_BOX", pl_bpt);
#endif

  s7_define_function(sc, "g_object_get", lg_g_object_get, 3, 0, 0, NULL);
  s7_define_function(sc, "g_object_set", lg_g_object_set, 3, 0, 0, NULL);
  s7_define_function(sc, "gtk_event_keyval", lg_gtk_event_keyval, 1, 0, 0, NULL);
#if (GTK_CHECK_VERSION(3, 90, 0))
  s7_define_function(sc, "gtk_init", lg_gtk_init, 0, 0, 0, NULL);
  s7_define_function(sc, "gtk_init_check", lg_gtk_init_check, 0, 0, 0, NULL);
#else
  s7_define_function(sc, "gtk_init", lg_gtk_init, 0, 2, 0, NULL);
  s7_define_function(sc, "gtk_init_check", lg_gtk_init_check, 0, 2, 0, NULL);
  s7_define_function(sc, "gtk_widget_set_events", lg_gtk_widget_set_events, 2, 0, 0, H_gtk_widget_set_events);
#endif
  s7_define_typed_function(sc, "GDK_IS_DRAG_CONTEXT", lg_GDK_IS_DRAG_CONTEXT, 1, 0, 0, "(GDK_IS_DRAG_CONTEXT obj): #t if obj is a GdkDragContext*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DEVICE", lg_GDK_IS_DEVICE, 1, 0, 0, "(GDK_IS_DEVICE obj): #t if obj is a GdkDevice*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_KEYMAP", lg_GDK_IS_KEYMAP, 1, 0, 0, "(GDK_IS_KEYMAP obj): #t if obj is a GdkKeymap*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_WINDOW", lg_GDK_IS_WINDOW, 1, 0, 0, "(GDK_IS_WINDOW obj): #t if obj is a GdkWindow*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_PIXBUF", lg_GDK_IS_PIXBUF, 1, 0, 0, "(GDK_IS_PIXBUF obj): #t if obj is a GdkPixbuf*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_PIXBUF_ANIMATION", lg_GDK_IS_PIXBUF_ANIMATION, 1, 0, 0, "(GDK_IS_PIXBUF_ANIMATION obj): #t if obj is a GdkPixbufAnimation*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_PIXBUF_ANIMATION_ITER", lg_GDK_IS_PIXBUF_ANIMATION_ITER, 1, 0, 0, "(GDK_IS_PIXBUF_ANIMATION_ITER obj): #t if obj is a GdkPixbufAnimationIter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCEL_GROUP", lg_GTK_IS_ACCEL_GROUP, 1, 0, 0, "(GTK_IS_ACCEL_GROUP obj): #t if obj is a GtkAccelGroup*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCEL_LABEL", lg_GTK_IS_ACCEL_LABEL, 1, 0, 0, "(GTK_IS_ACCEL_LABEL obj): #t if obj is a GtkAccelLabel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCESSIBLE", lg_GTK_IS_ACCESSIBLE, 1, 0, 0, "(GTK_IS_ACCESSIBLE obj): #t if obj is a GtkAccessible*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ADJUSTMENT", lg_GTK_IS_ADJUSTMENT, 1, 0, 0, "(GTK_IS_ADJUSTMENT obj): #t if obj is a GtkAdjustment*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ASPECT_FRAME", lg_GTK_IS_ASPECT_FRAME, 1, 0, 0, "(GTK_IS_ASPECT_FRAME obj): #t if obj is a GtkAspectFrame*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BUTTON_BOX", lg_GTK_IS_BUTTON_BOX, 1, 0, 0, "(GTK_IS_BUTTON_BOX obj): #t if obj is a GtkButtonBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BIN", lg_GTK_IS_BIN, 1, 0, 0, "(GTK_IS_BIN obj): #t if obj is a GtkBin*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BOX", lg_GTK_IS_BOX, 1, 0, 0, "(GTK_IS_BOX obj): #t if obj is a GtkBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BUTTON", lg_GTK_IS_BUTTON, 1, 0, 0, "(GTK_IS_BUTTON obj): #t if obj is a GtkButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CALENDAR", lg_GTK_IS_CALENDAR, 1, 0, 0, "(GTK_IS_CALENDAR obj): #t if obj is a GtkCalendar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_EDITABLE", lg_GTK_IS_CELL_EDITABLE, 1, 0, 0, "(GTK_IS_CELL_EDITABLE obj): #t if obj is a GtkCellEditable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER", lg_GTK_IS_CELL_RENDERER, 1, 0, 0, "(GTK_IS_CELL_RENDERER obj): #t if obj is a GtkCellRenderer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_PIXBUF", lg_GTK_IS_CELL_RENDERER_PIXBUF, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PIXBUF obj): #t if obj is a GtkCellRendererPixbuf*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_TEXT", lg_GTK_IS_CELL_RENDERER_TEXT, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TEXT obj): #t if obj is a GtkCellRendererText*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_TOGGLE", lg_GTK_IS_CELL_RENDERER_TOGGLE, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TOGGLE obj): #t if obj is a GtkCellRendererToggle*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CHECK_BUTTON", lg_GTK_IS_CHECK_BUTTON, 1, 0, 0, "(GTK_IS_CHECK_BUTTON obj): #t if obj is a GtkCheckButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CHECK_MENU_ITEM", lg_GTK_IS_CHECK_MENU_ITEM, 1, 0, 0, "(GTK_IS_CHECK_MENU_ITEM obj): #t if obj is a GtkCheckMenuItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CONTAINER", lg_GTK_IS_CONTAINER, 1, 0, 0, "(GTK_IS_CONTAINER obj): #t if obj is a GtkContainer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DIALOG", lg_GTK_IS_DIALOG, 1, 0, 0, "(GTK_IS_DIALOG obj): #t if obj is a GtkDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DRAWING_AREA", lg_GTK_IS_DRAWING_AREA, 1, 0, 0, "(GTK_IS_DRAWING_AREA obj): #t if obj is a GtkDrawingArea*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EDITABLE", lg_GTK_IS_EDITABLE, 1, 0, 0, "(GTK_IS_EDITABLE obj): #t if obj is a GtkEditable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY", lg_GTK_IS_ENTRY, 1, 0, 0, "(GTK_IS_ENTRY obj): #t if obj is a GtkEntry*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FIXED", lg_GTK_IS_FIXED, 1, 0, 0, "(GTK_IS_FIXED obj): #t if obj is a GtkFixed*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FRAME", lg_GTK_IS_FRAME, 1, 0, 0, "(GTK_IS_FRAME obj): #t if obj is a GtkFrame*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IMAGE", lg_GTK_IS_IMAGE, 1, 0, 0, "(GTK_IS_IMAGE obj): #t if obj is a GtkImage*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IM_CONTEXT", lg_GTK_IS_IM_CONTEXT, 1, 0, 0, "(GTK_IS_IM_CONTEXT obj): #t if obj is a GtkIMContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IM_CONTEXT_SIMPLE", lg_GTK_IS_IM_CONTEXT_SIMPLE, 1, 0, 0, "(GTK_IS_IM_CONTEXT_SIMPLE obj): #t if obj is a GtkIMContextSimple*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_INVISIBLE", lg_GTK_IS_INVISIBLE, 1, 0, 0, "(GTK_IS_INVISIBLE obj): #t if obj is a GtkInvisible*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LABEL", lg_GTK_IS_LABEL, 1, 0, 0, "(GTK_IS_LABEL obj): #t if obj is a GtkLabel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LAYOUT", lg_GTK_IS_LAYOUT, 1, 0, 0, "(GTK_IS_LAYOUT obj): #t if obj is a GtkLayout*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_STORE", lg_GTK_IS_LIST_STORE, 1, 0, 0, "(GTK_IS_LIST_STORE obj): #t if obj is a GtkListStore*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_MENU_BAR", lg_GTK_IS_MENU_BAR, 1, 0, 0, "(GTK_IS_MENU_BAR obj): #t if obj is a GtkMenuBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_MENU", lg_GTK_IS_MENU, 1, 0, 0, "(GTK_IS_MENU obj): #t if obj is a GtkMenu*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_MENU_ITEM", lg_GTK_IS_MENU_ITEM, 1, 0, 0, "(GTK_IS_MENU_ITEM obj): #t if obj is a GtkMenuItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_MENU_SHELL", lg_GTK_IS_MENU_SHELL, 1, 0, 0, "(GTK_IS_MENU_SHELL obj): #t if obj is a GtkMenuShell*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_NOTEBOOK", lg_GTK_IS_NOTEBOOK, 1, 0, 0, "(GTK_IS_NOTEBOOK obj): #t if obj is a GtkNotebook*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PANED", lg_GTK_IS_PANED, 1, 0, 0, "(GTK_IS_PANED obj): #t if obj is a GtkPaned*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PROGRESS_BAR", lg_GTK_IS_PROGRESS_BAR, 1, 0, 0, "(GTK_IS_PROGRESS_BAR obj): #t if obj is a GtkProgressBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RADIO_BUTTON", lg_GTK_IS_RADIO_BUTTON, 1, 0, 0, "(GTK_IS_RADIO_BUTTON obj): #t if obj is a GtkRadioButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RADIO_MENU_ITEM", lg_GTK_IS_RADIO_MENU_ITEM, 1, 0, 0, "(GTK_IS_RADIO_MENU_ITEM obj): #t if obj is a GtkRadioMenuItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RANGE", lg_GTK_IS_RANGE, 1, 0, 0, "(GTK_IS_RANGE obj): #t if obj is a GtkRange*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCALE", lg_GTK_IS_SCALE, 1, 0, 0, "(GTK_IS_SCALE obj): #t if obj is a GtkScale*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLBAR", lg_GTK_IS_SCROLLBAR, 1, 0, 0, "(GTK_IS_SCROLLBAR obj): #t if obj is a GtkScrollbar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLED_WINDOW", lg_GTK_IS_SCROLLED_WINDOW, 1, 0, 0, "(GTK_IS_SCROLLED_WINDOW obj): #t if obj is a GtkScrolledWindow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEPARATOR", lg_GTK_IS_SEPARATOR, 1, 0, 0, "(GTK_IS_SEPARATOR obj): #t if obj is a GtkSeparator*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEPARATOR_MENU_ITEM", lg_GTK_IS_SEPARATOR_MENU_ITEM, 1, 0, 0, "(GTK_IS_SEPARATOR_MENU_ITEM obj): #t if obj is a GtkSeparatorMenuItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SETTINGS", lg_GTK_IS_SETTINGS, 1, 0, 0, "(GTK_IS_SETTINGS obj): #t if obj is a GtkSettings*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SIZE_GROUP", lg_GTK_IS_SIZE_GROUP, 1, 0, 0, "(GTK_IS_SIZE_GROUP obj): #t if obj is a GtkSizeGroup*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SPIN_BUTTON", lg_GTK_IS_SPIN_BUTTON, 1, 0, 0, "(GTK_IS_SPIN_BUTTON obj): #t if obj is a GtkSpinButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STATUSBAR", lg_GTK_IS_STATUSBAR, 1, 0, 0, "(GTK_IS_STATUSBAR obj): #t if obj is a GtkStatusbar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_BUFFER", lg_GTK_IS_TEXT_BUFFER, 1, 0, 0, "(GTK_IS_TEXT_BUFFER obj): #t if obj is a GtkTextBuffer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_CHILD_ANCHOR", lg_GTK_IS_TEXT_CHILD_ANCHOR, 1, 0, 0, "(GTK_IS_TEXT_CHILD_ANCHOR obj): #t if obj is a GtkTextChildAnchor*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_MARK", lg_GTK_IS_TEXT_MARK, 1, 0, 0, "(GTK_IS_TEXT_MARK obj): #t if obj is a GtkTextMark*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_TAG", lg_GTK_IS_TEXT_TAG, 1, 0, 0, "(GTK_IS_TEXT_TAG obj): #t if obj is a GtkTextTag*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_TAG_TABLE", lg_GTK_IS_TEXT_TAG_TABLE, 1, 0, 0, "(GTK_IS_TEXT_TAG_TABLE obj): #t if obj is a GtkTextTagTable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_VIEW", lg_GTK_IS_TEXT_VIEW, 1, 0, 0, "(GTK_IS_TEXT_VIEW obj): #t if obj is a GtkTextView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOGGLE_BUTTON", lg_GTK_IS_TOGGLE_BUTTON, 1, 0, 0, "(GTK_IS_TOGGLE_BUTTON obj): #t if obj is a GtkToggleButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOLBAR", lg_GTK_IS_TOOLBAR, 1, 0, 0, "(GTK_IS_TOOLBAR obj): #t if obj is a GtkToolbar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_DRAG_SOURCE", lg_GTK_IS_TREE_DRAG_SOURCE, 1, 0, 0, "(GTK_IS_TREE_DRAG_SOURCE obj): #t if obj is a GtkTreeDragSource*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_DRAG_DEST", lg_GTK_IS_TREE_DRAG_DEST, 1, 0, 0, "(GTK_IS_TREE_DRAG_DEST obj): #t if obj is a GtkTreeDragDest*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL", lg_GTK_IS_TREE_MODEL, 1, 0, 0, "(GTK_IS_TREE_MODEL obj): #t if obj is a GtkTreeModel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL_SORT", lg_GTK_IS_TREE_MODEL_SORT, 1, 0, 0, "(GTK_IS_TREE_MODEL_SORT obj): #t if obj is a GtkTreeModelSort*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_SELECTION", lg_GTK_IS_TREE_SELECTION, 1, 0, 0, "(GTK_IS_TREE_SELECTION obj): #t if obj is a GtkTreeSelection*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_SORTABLE", lg_GTK_IS_TREE_SORTABLE, 1, 0, 0, "(GTK_IS_TREE_SORTABLE obj): #t if obj is a GtkTreeSortable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_STORE", lg_GTK_IS_TREE_STORE, 1, 0, 0, "(GTK_IS_TREE_STORE obj): #t if obj is a GtkTreeStore*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_VIEW_COLUMN", lg_GTK_IS_TREE_VIEW_COLUMN, 1, 0, 0, "(GTK_IS_TREE_VIEW_COLUMN obj): #t if obj is a GtkTreeViewColumn*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_VIEW", lg_GTK_IS_TREE_VIEW, 1, 0, 0, "(GTK_IS_TREE_VIEW obj): #t if obj is a GtkTreeView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_VIEWPORT", lg_GTK_IS_VIEWPORT, 1, 0, 0, "(GTK_IS_VIEWPORT obj): #t if obj is a GtkViewport*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WIDGET", lg_GTK_IS_WIDGET, 1, 0, 0, "(GTK_IS_WIDGET obj): #t if obj is a GtkWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WINDOW", lg_GTK_IS_WINDOW, 1, 0, 0, "(GTK_IS_WINDOW obj): #t if obj is a GtkWindow*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_CONTEXT", lg_PANGO_IS_CONTEXT, 1, 0, 0, "(PANGO_IS_CONTEXT obj): #t if obj is a PangoContext*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_FAMILY", lg_PANGO_IS_FONT_FAMILY, 1, 0, 0, "(PANGO_IS_FONT_FAMILY obj): #t if obj is a PangoFontFamily*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_FACE", lg_PANGO_IS_FONT_FACE, 1, 0, 0, "(PANGO_IS_FONT_FACE obj): #t if obj is a PangoFontFace*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT", lg_PANGO_IS_FONT, 1, 0, 0, "(PANGO_IS_FONT obj): #t if obj is a PangoFont*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_MAP", lg_PANGO_IS_FONT_MAP, 1, 0, 0, "(PANGO_IS_FONT_MAP obj): #t if obj is a PangoFontMap*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_LAYOUT", lg_PANGO_IS_LAYOUT, 1, 0, 0, "(PANGO_IS_LAYOUT obj): #t if obj is a PangoLayout*", pl_bt);
  s7_define_typed_function(sc, "G_IS_OBJECT", lg_G_IS_OBJECT, 1, 0, 0, "(G_IS_OBJECT obj): #t if obj is a GObject*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_SCREEN", lg_GDK_IS_SCREEN, 1, 0, 0, "(GDK_IS_SCREEN obj): #t if obj is a GdkScreen*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DISPLAY", lg_GDK_IS_DISPLAY, 1, 0, 0, "(GDK_IS_DISPLAY obj): #t if obj is a GdkDisplay*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_DIALOG", lg_GTK_IS_FILE_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_DIALOG obj): #t if obj is a GtkFileChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_WIDGET", lg_GTK_IS_FILE_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_WIDGET obj): #t if obj is a GtkFileChooserWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL_FILTER", lg_GTK_IS_TREE_MODEL_FILTER, 1, 0, 0, "(GTK_IS_TREE_MODEL_FILTER obj): #t if obj is a GtkTreeModelFilter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COMBO_BOX", lg_GTK_IS_COMBO_BOX, 1, 0, 0, "(GTK_IS_COMBO_BOX obj): #t if obj is a GtkComboBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EXPANDER", lg_GTK_IS_EXPANDER, 1, 0, 0, "(GTK_IS_EXPANDER obj): #t if obj is a GtkExpander*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_BUTTON", lg_GTK_IS_FONT_BUTTON, 1, 0, 0, "(GTK_IS_FONT_BUTTON obj): #t if obj is a GtkFontButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_BUTTON", lg_GTK_IS_COLOR_BUTTON, 1, 0, 0, "(GTK_IS_COLOR_BUTTON obj): #t if obj is a GtkColorButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY_COMPLETION", lg_GTK_IS_ENTRY_COMPLETION, 1, 0, 0, "(GTK_IS_ENTRY_COMPLETION obj): #t if obj is a GtkEntryCompletion*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RADIO_TOOL_BUTTON", lg_GTK_IS_RADIO_TOOL_BUTTON, 1, 0, 0, "(GTK_IS_RADIO_TOOL_BUTTON obj): #t if obj is a GtkRadioToolButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEPARATOR_TOOL_ITEM", lg_GTK_IS_SEPARATOR_TOOL_ITEM, 1, 0, 0, "(GTK_IS_SEPARATOR_TOOL_ITEM obj): #t if obj is a GtkSeparatorToolItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOGGLE_TOOL_BUTTON", lg_GTK_IS_TOGGLE_TOOL_BUTTON, 1, 0, 0, "(GTK_IS_TOGGLE_TOOL_BUTTON obj): #t if obj is a GtkToggleToolButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_FILTER", lg_GTK_IS_FILE_FILTER, 1, 0, 0, "(GTK_IS_FILE_FILTER obj): #t if obj is a GtkFileFilter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_LAYOUT", lg_GTK_IS_CELL_LAYOUT, 1, 0, 0, "(GTK_IS_CELL_LAYOUT obj): #t if obj is a GtkCellLayout*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CLIPBOARD", lg_GTK_IS_CLIPBOARD, 1, 0, 0, "(GTK_IS_CLIPBOARD obj): #t if obj is a GtkClipboard*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER", lg_GTK_IS_FILE_CHOOSER, 1, 0, 0, "(GTK_IS_FILE_CHOOSER obj): #t if obj is a GtkFileChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ICON_THEME", lg_GTK_IS_ICON_THEME, 1, 0, 0, "(GTK_IS_ICON_THEME obj): #t if obj is a GtkIconTheme*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOL_BUTTON", lg_GTK_IS_TOOL_BUTTON, 1, 0, 0, "(GTK_IS_TOOL_BUTTON obj): #t if obj is a GtkToolButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOL_ITEM", lg_GTK_IS_TOOL_ITEM, 1, 0, 0, "(GTK_IS_TOOL_ITEM obj): #t if obj is a GtkToolItem*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCEL_MAP", lg_GTK_IS_ACCEL_MAP, 1, 0, 0, "(GTK_IS_ACCEL_MAP obj): #t if obj is a GtkAccelMap", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_VIEW", lg_GTK_IS_CELL_VIEW, 1, 0, 0, "(GTK_IS_CELL_VIEW obj): #t if obj is a GtkCellView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ABOUT_DIALOG", lg_GTK_IS_ABOUT_DIALOG, 1, 0, 0, "(GTK_IS_ABOUT_DIALOG obj): #t if obj is a GtkAboutDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_COMBO", lg_GTK_IS_CELL_RENDERER_COMBO, 1, 0, 0, "(GTK_IS_CELL_RENDERER_COMBO obj): #t if obj is a GtkCellRendererCombo*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_PROGRESS", lg_GTK_IS_CELL_RENDERER_PROGRESS, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PROGRESS obj): #t if obj is a GtkCellRendererProgress*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ICON_VIEW", lg_GTK_IS_ICON_VIEW, 1, 0, 0, "(GTK_IS_ICON_VIEW obj): #t if obj is a GtkIconView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_BUTTON", lg_GTK_IS_FILE_CHOOSER_BUTTON, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_BUTTON obj): #t if obj is a GtkFileChooserButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_MENU_TOOL_BUTTON", lg_GTK_IS_MENU_TOOL_BUTTON, 1, 0, 0, "(GTK_IS_MENU_TOOL_BUTTON obj): #t if obj is a GtkMenuToolButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ASSISTANT", lg_GTK_IS_ASSISTANT, 1, 0, 0, "(GTK_IS_ASSISTANT obj): #t if obj is a GtkAssistant*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_ACCEL", lg_GTK_IS_CELL_RENDERER_ACCEL, 1, 0, 0, "(GTK_IS_CELL_RENDERER_ACCEL obj): #t if obj is a GtkCellRendererAccel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_SPIN", lg_GTK_IS_CELL_RENDERER_SPIN, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPIN obj): #t if obj is a GtkCellRendererSpin*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LINK_BUTTON", lg_GTK_IS_LINK_BUTTON, 1, 0, 0, "(GTK_IS_LINK_BUTTON obj): #t if obj is a GtkLinkButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_CHOOSER_DIALOG", lg_GTK_IS_RECENT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_DIALOG obj): #t if obj is a GtkRecentChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_CHOOSER", lg_GTK_IS_RECENT_CHOOSER, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER obj): #t if obj is a GtkRecentChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_CHOOSER_MENU", lg_GTK_IS_RECENT_CHOOSER_MENU, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_MENU obj): #t if obj is a GtkRecentChooserMenu*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_CHOOSER_WIDGET", lg_GTK_IS_RECENT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_RECENT_CHOOSER_WIDGET obj): #t if obj is a GtkRecentChooserWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_FILTER", lg_GTK_IS_RECENT_FILTER, 1, 0, 0, "(GTK_IS_RECENT_FILTER obj): #t if obj is a GtkRecentFilter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_MANAGER", lg_GTK_IS_RECENT_MANAGER, 1, 0, 0, "(GTK_IS_RECENT_MANAGER obj): #t if obj is a GtkRecentManager*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_CONTEXT", lg_GTK_IS_PRINT_CONTEXT, 1, 0, 0, "(GTK_IS_PRINT_CONTEXT obj): #t if obj is a GtkPrintContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_OPERATION", lg_GTK_IS_PRINT_OPERATION, 1, 0, 0, "(GTK_IS_PRINT_OPERATION obj): #t if obj is a GtkPrintOperation*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_SETTINGS", lg_GTK_IS_PRINT_SETTINGS, 1, 0, 0, "(GTK_IS_PRINT_SETTINGS obj): #t if obj is a GtkPrintSettings*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOLTIP", lg_GTK_IS_TOOLTIP, 1, 0, 0, "(GTK_IS_TOOLTIP obj): #t if obj is a GtkTooltip*", pl_bt);
#if GTK_CHECK_VERSION(2, 18, 0)
  s7_define_typed_function(sc, "GTK_IS_INFO_BAR", lg_GTK_IS_INFO_BAR, 1, 0, 0, "(GTK_IS_INFO_BAR obj): #t if obj is a GtkInfoBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY_BUFFER", lg_GTK_IS_ENTRY_BUFFER, 1, 0, 0, "(GTK_IS_ENTRY_BUFFER obj): #t if obj is a GtkEntryBuffer*", pl_bt);
#endif

#if GTK_CHECK_VERSION(2, 20, 0)
  s7_define_typed_function(sc, "GTK_IS_SPINNER", lg_GTK_IS_SPINNER, 1, 0, 0, "(GTK_IS_SPINNER obj): #t if obj is a GtkSpinner*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_SPINNER", lg_GTK_IS_CELL_RENDERER_SPINNER, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPINNER obj): #t if obj is a GtkCellRendererSpinner*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOL_PALETTE", lg_GTK_IS_TOOL_PALETTE, 1, 0, 0, "(GTK_IS_TOOL_PALETTE obj): #t if obj is a GtkToolPalette*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOL_ITEM_GROUP", lg_GTK_IS_TOOL_ITEM_GROUP, 1, 0, 0, "(GTK_IS_TOOL_ITEM_GROUP obj): #t if obj is a GtkToolItemGroup*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "GTK_IS_COMBO_BOX_TEXT", lg_GTK_IS_COMBO_BOX_TEXT, 1, 0, 0, "(GTK_IS_COMBO_BOX_TEXT obj): #t if obj is a GtkComboBoxText*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GRID", lg_GTK_IS_GRID, 1, 0, 0, "(GTK_IS_GRID obj): #t if obj is a GtkGrid*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLABLE", lg_GTK_IS_SCROLLABLE, 1, 0, 0, "(GTK_IS_SCROLLABLE obj): #t if obj is a GtkScrollable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SWITCH", lg_GTK_IS_SWITCH, 1, 0, 0, "(GTK_IS_SWITCH obj): #t if obj is a GtkSwitch*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ORIENTABLE", lg_GTK_IS_ORIENTABLE, 1, 0, 0, "(GTK_IS_ORIENTABLE obj): #t if obj is a GtkOrientable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WINDOW_GROUP", lg_GTK_IS_WINDOW_GROUP, 1, 0, 0, "(GTK_IS_WINDOW_GROUP obj): #t if obj is a GtkWindowGroup*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOL_SHELL", lg_GTK_IS_TOOL_SHELL, 1, 0, 0, "(GTK_IS_TOOL_SHELL obj): #t if obj is a GtkToolShell*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "GTK_IS_OVERLAY", lg_GTK_IS_OVERLAY, 1, 0, 0, "(GTK_IS_OVERLAY obj): #t if obj is a GtkOverlay*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER", lg_GTK_IS_FONT_CHOOSER, 1, 0, 0, "(GTK_IS_FONT_CHOOSER obj): #t if obj is a GtkFontChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER_DIALOG", lg_GTK_IS_FONT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_DIALOG obj): #t if obj is a GtkFontChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER_WIDGET", lg_GTK_IS_FONT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_WIDGET obj): #t if obj is a GtkFontChooserWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "GTK_IS_APPLICATION_WINDOW", lg_GTK_IS_APPLICATION_WINDOW, 1, 0, 0, "(GTK_IS_APPLICATION_WINDOW obj): #t if obj is a GtkApplicationWindow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_CHOOSER_DIALOG", lg_GTK_IS_COLOR_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_DIALOG obj): #t if obj is a GtkColorChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_CHOOSER_WIDGET", lg_GTK_IS_COLOR_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_WIDGET obj): #t if obj is a GtkColorWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "GTK_IS_MENU_BUTTON", lg_GTK_IS_MENU_BUTTON, 1, 0, 0, "(GTK_IS_MENU_BUTTON obj): #t if obj is a GtkMenuButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEARCH_ENTRY", lg_GTK_IS_SEARCH_ENTRY, 1, 0, 0, "(GTK_IS_SEARCH_ENTRY obj): #t if obj is a GtkWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LEVEL_BAR", lg_GTK_IS_LEVEL_BAR, 1, 0, 0, "(GTK_IS_LEVEL_BAR obj): #t if obj is a GtkLevelBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "GTK_IS_PLACES_SIDEBAR", lg_GTK_IS_PLACES_SIDEBAR, 1, 0, 0, "(GTK_IS_PLACES_SIDEBAR obj): #t if obj is a GtkPlacesSidebar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STACK_SWITCHER", lg_GTK_IS_STACK_SWITCHER, 1, 0, 0, "(GTK_IS_STACK_SWITCHER obj): #t if obj is a GtkStackSwitcher*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STACK", lg_GTK_IS_STACK, 1, 0, 0, "(GTK_IS_STACK obj): #t if obj is a GtkStack*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_REVEALER", lg_GTK_IS_REVEALER, 1, 0, 0, "(GTK_IS_REVEALER obj): #t if obj is a GtkRevealer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_HEADER_BAR", lg_GTK_IS_HEADER_BAR, 1, 0, 0, "(GTK_IS_HEADER_BAR obj): #t if obj is a GtkHeaderBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_BOX", lg_GTK_IS_LIST_BOX, 1, 0, 0, "(GTK_IS_LIST_BOX obj): #t if obj is a GtkListBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_BOX_ROW", lg_GTK_IS_LIST_BOX_ROW, 1, 0, 0, "(GTK_IS_LIST_BOX_ROW obj): #t if obj is a GtkListBoxRow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEARCH_BAR", lg_GTK_IS_SEARCH_BAR, 1, 0, 0, "(GTK_IS_SEARCH_BAR obj): #t if obj is a GtkSearchBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "GTK_IS_FLOW_BOX", lg_GTK_IS_FLOW_BOX, 1, 0, 0, "(GTK_IS_FLOW_BOX obj): #t if obj is a GtkFlowBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FLOW_BOX_CHILD", lg_GTK_IS_FLOW_BOX_CHILD, 1, 0, 0, "(GTK_IS_FLOW_BOX_CHILD obj): #t if obj is a GtkFlowBoxChild*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACTION_BAR", lg_GTK_IS_ACTION_BAR, 1, 0, 0, "(GTK_IS_ACTION_BAR obj): #t if obj is a GtkActionBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_POPOVER", lg_GTK_IS_POPOVER, 1, 0, 0, "(GTK_IS_POPOVER obj): #t if obj is a GtkPopover*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "GTK_IS_GESTURE", lg_GTK_IS_GESTURE, 1, 0, 0, "(GTK_IS_GESTURE obj): #t if obj is a GtkGesture*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_DRAG", lg_GTK_IS_GESTURE_DRAG, 1, 0, 0, "(GTK_IS_GESTURE_DRAG obj): #t if obj is a GtkGestureDrag*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_LONG_PRESS", lg_GTK_IS_GESTURE_LONG_PRESS, 1, 0, 0, "(GTK_IS_GESTURE_LONG_PRESS obj): #t if obj is a GtkGestureLongPress*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_ZOOM", lg_GTK_IS_GESTURE_ZOOM, 1, 0, 0, "(GTK_IS_GESTURE_ZOOM obj): #t if obj is a GtkGestureZoom*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_SWIPE", lg_GTK_IS_GESTURE_SWIPE, 1, 0, 0, "(GTK_IS_GESTURE_SWIPE obj): #t if obj is a GtkGestureSwipe*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_SINGLE", lg_GTK_IS_GESTURE_SINGLE, 1, 0, 0, "(GTK_IS_GESTURE_SINGLE obj): #t if obj is a GtkGestureSingle*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_PAN", lg_GTK_IS_GESTURE_PAN, 1, 0, 0, "(GTK_IS_GESTURE_PAN obj): #t if obj is a GtkGesturePan*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_MULTI_PRESS", lg_GTK_IS_GESTURE_MULTI_PRESS, 1, 0, 0, "(GTK_IS_GESTURE_MULTI_PRESS obj): #t if obj is a GtkGestureMultiPress*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_ROTATE", lg_GTK_IS_GESTURE_ROTATE, 1, 0, 0, "(GTK_IS_GESTURE_ROTATE obj): #t if obj is a GtkGestureRotate*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER", lg_GTK_IS_EVENT_CONTROLLER, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER obj): #t if obj is a GtkEventController*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "GTK_IS_GL_AREA", lg_GTK_IS_GL_AREA, 1, 0, 0, "(GTK_IS_GL_AREA obj): #t if obj is a GtkGLArea*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_GL_CONTEXT", lg_GDK_IS_GL_CONTEXT, 1, 0, 0, "(GDK_IS_GL_CONTEXT obj): #t if obj is a GdkGLContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_POPOVER_MENU", lg_GTK_IS_POPOVER_MENU, 1, 0, 0, "(GTK_IS_POPOVER_MENU obj): #t if obj is a GtkPopoverMenu*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STACK_SIDEBAR", lg_GTK_IS_STACK_SIDEBAR, 1, 0, 0, "(GTK_IS_STACK_SIDEBAR obj): #t if obj is a GtkStackSidebar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "GDK_IS_SEAT", lg_GDK_IS_SEAT, 1, 0, 0, "(GDK_IS_SEAT obj): #t if obj is a GdkSeat*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "GDK_IS_DEVICE_TOOL", lg_GDK_IS_DEVICE_TOOL, 1, 0, 0, "(GDK_IS_DEVICE_TOOL obj): #t if obj is a GdkDeviceTool*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_MONITOR", lg_GDK_IS_MONITOR, 1, 0, 0, "(GDK_IS_MONITOR obj): #t if obj is a GdkMonitor*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DRAWING_CONTEXT", lg_GDK_IS_DRAWING_CONTEXT, 1, 0, 0, "(GDK_IS_DRAWING_CONTEXT obj): #t if obj is a GdkDrawingContext*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DEVICE_PAD", lg_GDK_IS_DEVICE_PAD, 1, 0, 0, "(GDK_IS_DEVICE_PAD obj): #t if obj is a GdkDevicePad*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PAD_CONTROLLER", lg_GTK_IS_PAD_CONTROLLER, 1, 0, 0, "(GTK_IS_PAD_CONTROLLER obj): #t if obj is a GtkPadController*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SHORTCUT_LABEL", lg_GTK_IS_SHORTCUT_LABEL, 1, 0, 0, "(GTK_IS_SHORTCUT_LABEL obj): #t if obj is a GtkShortcutLabel*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  s7_define_typed_function(sc, "GTK_IS_CENTER_BOX", lg_GTK_IS_CENTER_BOX, 1, 0, 0, "(GTK_IS_CENTER_BOX obj): #t if obj is a GtkCenterBox*", pl_bt);
#endif

}

static void define_integers(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

#if !GLIB_CHECK_VERSION(2,35,0)
  g_type_init();
#endif
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_DEFAULT"), s7_make_integer(sc, G_NORMALIZE_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFD"), s7_make_integer(sc, G_NORMALIZE_NFD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_DEFAULT_COMPOSE"), s7_make_integer(sc, G_NORMALIZE_DEFAULT_COMPOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFC"), s7_make_integer(sc, G_NORMALIZE_NFC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_ALL"), s7_make_integer(sc, G_NORMALIZE_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFKD"), s7_make_integer(sc, G_NORMALIZE_NFKD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_ALL_COMPOSE"), s7_make_integer(sc, G_NORMALIZE_ALL_COMPOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFKC"), s7_make_integer(sc, G_NORMALIZE_NFKC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_FIRST"), s7_make_integer(sc, G_SIGNAL_RUN_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_LAST"), s7_make_integer(sc, G_SIGNAL_RUN_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_CLEANUP"), s7_make_integer(sc, G_SIGNAL_RUN_CLEANUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_NO_RECURSE"), s7_make_integer(sc, G_SIGNAL_NO_RECURSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_DETAILED"), s7_make_integer(sc, G_SIGNAL_DETAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_ACTION"), s7_make_integer(sc, G_SIGNAL_ACTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_NO_HOOKS"), s7_make_integer(sc, G_SIGNAL_NO_HOOKS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_CONNECT_AFTER"), s7_make_integer(sc, G_CONNECT_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_CONNECT_SWAPPED"), s7_make_integer(sc, G_CONNECT_SWAPPED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_ID"), s7_make_integer(sc, G_SIGNAL_MATCH_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_DETAIL"), s7_make_integer(sc, G_SIGNAL_MATCH_DETAIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_CLOSURE"), s7_make_integer(sc, G_SIGNAL_MATCH_CLOSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_FUNC"), s7_make_integer(sc, G_SIGNAL_MATCH_FUNC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_DATA"), s7_make_integer(sc, G_SIGNAL_MATCH_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_UNBLOCKED"), s7_make_integer(sc, G_SIGNAL_MATCH_UNBLOCKED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_X_CURSOR"), s7_make_integer(sc, GDK_X_CURSOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ARROW"), s7_make_integer(sc, GDK_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BASED_ARROW_DOWN"), s7_make_integer(sc, GDK_BASED_ARROW_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BASED_ARROW_UP"), s7_make_integer(sc, GDK_BASED_ARROW_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOAT"), s7_make_integer(sc, GDK_BOAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOGOSITY"), s7_make_integer(sc, GDK_BOGOSITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOTTOM_LEFT_CORNER"), s7_make_integer(sc, GDK_BOTTOM_LEFT_CORNER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOTTOM_RIGHT_CORNER"), s7_make_integer(sc, GDK_BOTTOM_RIGHT_CORNER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOTTOM_SIDE"), s7_make_integer(sc, GDK_BOTTOM_SIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOTTOM_TEE"), s7_make_integer(sc, GDK_BOTTOM_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BOX_SPIRAL"), s7_make_integer(sc, GDK_BOX_SPIRAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CENTER_PTR"), s7_make_integer(sc, GDK_CENTER_PTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CIRCLE"), s7_make_integer(sc, GDK_CIRCLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CLOCK"), s7_make_integer(sc, GDK_CLOCK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_COFFEE_MUG"), s7_make_integer(sc, GDK_COFFEE_MUG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSS"), s7_make_integer(sc, GDK_CROSS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSS_REVERSE"), s7_make_integer(sc, GDK_CROSS_REVERSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSHAIR"), s7_make_integer(sc, GDK_CROSSHAIR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DIAMOND_CROSS"), s7_make_integer(sc, GDK_DIAMOND_CROSS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DOT"), s7_make_integer(sc, GDK_DOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DOTBOX"), s7_make_integer(sc, GDK_DOTBOX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DOUBLE_ARROW"), s7_make_integer(sc, GDK_DOUBLE_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAFT_LARGE"), s7_make_integer(sc, GDK_DRAFT_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAFT_SMALL"), s7_make_integer(sc, GDK_DRAFT_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAPED_BOX"), s7_make_integer(sc, GDK_DRAPED_BOX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_EXCHANGE"), s7_make_integer(sc, GDK_EXCHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FLEUR"), s7_make_integer(sc, GDK_FLEUR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GOBBLER"), s7_make_integer(sc, GDK_GOBBLER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GUMBY"), s7_make_integer(sc, GDK_GUMBY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HAND1"), s7_make_integer(sc, GDK_HAND1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HAND2"), s7_make_integer(sc, GDK_HAND2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HEART"), s7_make_integer(sc, GDK_HEART));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ICON"), s7_make_integer(sc, GDK_ICON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_IRON_CROSS"), s7_make_integer(sc, GDK_IRON_CROSS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEFT_PTR"), s7_make_integer(sc, GDK_LEFT_PTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEFT_SIDE"), s7_make_integer(sc, GDK_LEFT_SIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEFT_TEE"), s7_make_integer(sc, GDK_LEFT_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEFTBUTTON"), s7_make_integer(sc, GDK_LEFTBUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LL_ANGLE"), s7_make_integer(sc, GDK_LL_ANGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LR_ANGLE"), s7_make_integer(sc, GDK_LR_ANGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MAN"), s7_make_integer(sc, GDK_MAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MIDDLEBUTTON"), s7_make_integer(sc, GDK_MIDDLEBUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOUSE"), s7_make_integer(sc, GDK_MOUSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PENCIL"), s7_make_integer(sc, GDK_PENCIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIRATE"), s7_make_integer(sc, GDK_PIRATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PLUS"), s7_make_integer(sc, GDK_PLUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_QUESTION_ARROW"), s7_make_integer(sc, GDK_QUESTION_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RIGHT_PTR"), s7_make_integer(sc, GDK_RIGHT_PTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RIGHT_SIDE"), s7_make_integer(sc, GDK_RIGHT_SIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RIGHT_TEE"), s7_make_integer(sc, GDK_RIGHT_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RIGHTBUTTON"), s7_make_integer(sc, GDK_RIGHTBUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RTL_LOGO"), s7_make_integer(sc, GDK_RTL_LOGO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SAILBOAT"), s7_make_integer(sc, GDK_SAILBOAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_DOWN_ARROW"), s7_make_integer(sc, GDK_SB_DOWN_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_H_DOUBLE_ARROW"), s7_make_integer(sc, GDK_SB_H_DOUBLE_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_LEFT_ARROW"), s7_make_integer(sc, GDK_SB_LEFT_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_RIGHT_ARROW"), s7_make_integer(sc, GDK_SB_RIGHT_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_UP_ARROW"), s7_make_integer(sc, GDK_SB_UP_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SB_V_DOUBLE_ARROW"), s7_make_integer(sc, GDK_SB_V_DOUBLE_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SHUTTLE"), s7_make_integer(sc, GDK_SHUTTLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SIZING"), s7_make_integer(sc, GDK_SIZING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SPIDER"), s7_make_integer(sc, GDK_SPIDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SPRAYCAN"), s7_make_integer(sc, GDK_SPRAYCAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_STAR"), s7_make_integer(sc, GDK_STAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TARGET"), s7_make_integer(sc, GDK_TARGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TCROSS"), s7_make_integer(sc, GDK_TCROSS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOP_LEFT_ARROW"), s7_make_integer(sc, GDK_TOP_LEFT_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOP_LEFT_CORNER"), s7_make_integer(sc, GDK_TOP_LEFT_CORNER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOP_RIGHT_CORNER"), s7_make_integer(sc, GDK_TOP_RIGHT_CORNER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOP_SIDE"), s7_make_integer(sc, GDK_TOP_SIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOP_TEE"), s7_make_integer(sc, GDK_TOP_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TREK"), s7_make_integer(sc, GDK_TREK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_UL_ANGLE"), s7_make_integer(sc, GDK_UL_ANGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_UMBRELLA"), s7_make_integer(sc, GDK_UMBRELLA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_UR_ANGLE"), s7_make_integer(sc, GDK_UR_ANGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WATCH"), s7_make_integer(sc, GDK_WATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_XTERM"), s7_make_integer(sc, GDK_XTERM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LAST_CURSOR "), s7_make_integer(sc, GDK_LAST_CURSOR ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_DEFAULT"), s7_make_integer(sc, GDK_ACTION_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_COPY"), s7_make_integer(sc, GDK_ACTION_COPY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_MOVE"), s7_make_integer(sc, GDK_ACTION_MOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_LINK"), s7_make_integer(sc, GDK_ACTION_LINK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_PRIVATE"), s7_make_integer(sc, GDK_ACTION_PRIVATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_ASK"), s7_make_integer(sc, GDK_ACTION_ASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PRIORITY_EVENTS"), s7_make_integer(sc, GDK_PRIORITY_EVENTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PRIORITY_REDRAW"), s7_make_integer(sc, GDK_PRIORITY_REDRAW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTHING"), s7_make_integer(sc, GDK_NOTHING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DELETE"), s7_make_integer(sc, GDK_DELETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DESTROY"), s7_make_integer(sc, GDK_DESTROY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_EXPOSE"), s7_make_integer(sc, GDK_EXPOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOTION_NOTIFY"), s7_make_integer(sc, GDK_MOTION_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_PRESS"), s7_make_integer(sc, GDK_BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_2BUTTON_PRESS"), s7_make_integer(sc, GDK_2BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_3BUTTON_PRESS"), s7_make_integer(sc, GDK_3BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_RELEASE"), s7_make_integer(sc, GDK_BUTTON_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_PRESS"), s7_make_integer(sc, GDK_KEY_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_RELEASE"), s7_make_integer(sc, GDK_KEY_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ENTER_NOTIFY"), s7_make_integer(sc, GDK_ENTER_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEAVE_NOTIFY"), s7_make_integer(sc, GDK_LEAVE_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FOCUS_CHANGE"), s7_make_integer(sc, GDK_FOCUS_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CONFIGURE"), s7_make_integer(sc, GDK_CONFIGURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MAP"), s7_make_integer(sc, GDK_MAP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_UNMAP"), s7_make_integer(sc, GDK_UNMAP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROPERTY_NOTIFY"), s7_make_integer(sc, GDK_PROPERTY_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_CLEAR"), s7_make_integer(sc, GDK_SELECTION_CLEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_REQUEST"), s7_make_integer(sc, GDK_SELECTION_REQUEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_NOTIFY"), s7_make_integer(sc, GDK_SELECTION_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_IN"), s7_make_integer(sc, GDK_PROXIMITY_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_OUT"), s7_make_integer(sc, GDK_PROXIMITY_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_ENTER"), s7_make_integer(sc, GDK_DRAG_ENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_LEAVE"), s7_make_integer(sc, GDK_DRAG_LEAVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_MOTION"), s7_make_integer(sc, GDK_DRAG_MOTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_STATUS"), s7_make_integer(sc, GDK_DRAG_STATUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DROP_START"), s7_make_integer(sc, GDK_DROP_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DROP_FINISHED"), s7_make_integer(sc, GDK_DROP_FINISHED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CLIENT_EVENT"), s7_make_integer(sc, GDK_CLIENT_EVENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_VISIBILITY_NOTIFY"), s7_make_integer(sc, GDK_VISIBILITY_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL"), s7_make_integer(sc, GDK_SCROLL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE"), s7_make_integer(sc, GDK_WINDOW_STATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SETTING"), s7_make_integer(sc, GDK_SETTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_OWNER_CHANGE"), s7_make_integer(sc, GDK_OWNER_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_BROKEN"), s7_make_integer(sc, GDK_GRAB_BROKEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_EXPOSURE_MASK"), s7_make_integer(sc, GDK_EXPOSURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_POINTER_MOTION_MASK"), s7_make_integer(sc, GDK_POINTER_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON1_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON1_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON2_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON2_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON3_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON3_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_PRESS_MASK"), s7_make_integer(sc, GDK_BUTTON_PRESS_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_RELEASE_MASK"), s7_make_integer(sc, GDK_BUTTON_RELEASE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_PRESS_MASK"), s7_make_integer(sc, GDK_KEY_PRESS_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_RELEASE_MASK"), s7_make_integer(sc, GDK_KEY_RELEASE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ENTER_NOTIFY_MASK"), s7_make_integer(sc, GDK_ENTER_NOTIFY_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEAVE_NOTIFY_MASK"), s7_make_integer(sc, GDK_LEAVE_NOTIFY_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FOCUS_CHANGE_MASK"), s7_make_integer(sc, GDK_FOCUS_CHANGE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_STRUCTURE_MASK"), s7_make_integer(sc, GDK_STRUCTURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROPERTY_CHANGE_MASK"), s7_make_integer(sc, GDK_PROPERTY_CHANGE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_VISIBILITY_NOTIFY_MASK"), s7_make_integer(sc, GDK_VISIBILITY_NOTIFY_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_IN_MASK"), s7_make_integer(sc, GDK_PROXIMITY_IN_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_OUT_MASK"), s7_make_integer(sc, GDK_PROXIMITY_OUT_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBSTRUCTURE_MASK"), s7_make_integer(sc, GDK_SUBSTRUCTURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_MASK"), s7_make_integer(sc, GDK_SCROLL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ALL_EVENTS_MASK"), s7_make_integer(sc, GDK_ALL_EVENTS_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_UP"), s7_make_integer(sc, GDK_SCROLL_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_DOWN"), s7_make_integer(sc, GDK_SCROLL_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_LEFT"), s7_make_integer(sc, GDK_SCROLL_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_RIGHT"), s7_make_integer(sc, GDK_SCROLL_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_ANCESTOR"), s7_make_integer(sc, GDK_NOTIFY_ANCESTOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_VIRTUAL"), s7_make_integer(sc, GDK_NOTIFY_VIRTUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_INFERIOR"), s7_make_integer(sc, GDK_NOTIFY_INFERIOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_NONLINEAR"), s7_make_integer(sc, GDK_NOTIFY_NONLINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_NONLINEAR_VIRTUAL"), s7_make_integer(sc, GDK_NOTIFY_NONLINEAR_VIRTUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_UNKNOWN"), s7_make_integer(sc, GDK_NOTIFY_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_NORMAL"), s7_make_integer(sc, GDK_CROSSING_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GRAB"), s7_make_integer(sc, GDK_CROSSING_GRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_UNGRAB"), s7_make_integer(sc, GDK_CROSSING_UNGRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROPERTY_NEW_VALUE"), s7_make_integer(sc, GDK_PROPERTY_NEW_VALUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROPERTY_DELETE"), s7_make_integer(sc, GDK_PROPERTY_DELETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_WITHDRAWN"), s7_make_integer(sc, GDK_WINDOW_STATE_WITHDRAWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_ICONIFIED"), s7_make_integer(sc, GDK_WINDOW_STATE_ICONIFIED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_MAXIMIZED"), s7_make_integer(sc, GDK_WINDOW_STATE_MAXIMIZED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_STICKY"), s7_make_integer(sc, GDK_WINDOW_STATE_STICKY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SETTING_ACTION_NEW"), s7_make_integer(sc, GDK_SETTING_ACTION_NEW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SETTING_ACTION_CHANGED"), s7_make_integer(sc, GDK_SETTING_ACTION_CHANGED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SETTING_ACTION_DELETED"), s7_make_integer(sc, GDK_SETTING_ACTION_DELETED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROP_MODE_REPLACE"), s7_make_integer(sc, GDK_PROP_MODE_REPLACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROP_MODE_PREPEND"), s7_make_integer(sc, GDK_PROP_MODE_PREPEND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROP_MODE_APPEND"), s7_make_integer(sc, GDK_PROP_MODE_APPEND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CURRENT_TIME"), s7_make_integer(sc, GDK_CURRENT_TIME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PARENT_RELATIVE"), s7_make_integer(sc, GDK_PARENT_RELATIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LSB_FIRST"), s7_make_integer(sc, GDK_LSB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MSB_FIRST"), s7_make_integer(sc, GDK_MSB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SHIFT_MASK"), s7_make_integer(sc, GDK_SHIFT_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LOCK_MASK"), s7_make_integer(sc, GDK_LOCK_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CONTROL_MASK"), s7_make_integer(sc, GDK_CONTROL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOD1_MASK"), s7_make_integer(sc, GDK_MOD1_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOD2_MASK"), s7_make_integer(sc, GDK_MOD2_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOD3_MASK"), s7_make_integer(sc, GDK_MOD3_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOD4_MASK"), s7_make_integer(sc, GDK_MOD4_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOD5_MASK"), s7_make_integer(sc, GDK_MOD5_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON1_MASK"), s7_make_integer(sc, GDK_BUTTON1_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON2_MASK"), s7_make_integer(sc, GDK_BUTTON2_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON3_MASK"), s7_make_integer(sc, GDK_BUTTON3_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON4_MASK"), s7_make_integer(sc, GDK_BUTTON4_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON5_MASK"), s7_make_integer(sc, GDK_BUTTON5_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_RELEASE_MASK"), s7_make_integer(sc, GDK_RELEASE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_MASK"), s7_make_integer(sc, GDK_MODIFIER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_OK"), s7_make_integer(sc, GDK_OK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ERROR"), s7_make_integer(sc, GDK_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ERROR_PARAM"), s7_make_integer(sc, GDK_ERROR_PARAM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ERROR_FILE"), s7_make_integer(sc, GDK_ERROR_FILE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ERROR_MEM"), s7_make_integer(sc, GDK_ERROR_MEM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_SUCCESS"), s7_make_integer(sc, GDK_GRAB_SUCCESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_ALREADY_GRABBED"), s7_make_integer(sc, GDK_GRAB_ALREADY_GRABBED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_INVALID_TIME"), s7_make_integer(sc, GDK_GRAB_INVALID_TIME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_NOT_VIEWABLE"), s7_make_integer(sc, GDK_GRAB_NOT_VIEWABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_FROZEN"), s7_make_integer(sc, GDK_GRAB_FROZEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INPUT_OUTPUT"), s7_make_integer(sc, GDK_INPUT_OUTPUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INPUT_ONLY"), s7_make_integer(sc, GDK_INPUT_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_ROOT"), s7_make_integer(sc, GDK_WINDOW_ROOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TOPLEVEL"), s7_make_integer(sc, GDK_WINDOW_TOPLEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_CHILD"), s7_make_integer(sc, GDK_WINDOW_CHILD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TEMP"), s7_make_integer(sc, GDK_WINDOW_TEMP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_FOREIGN"), s7_make_integer(sc, GDK_WINDOW_FOREIGN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_TITLE"), s7_make_integer(sc, GDK_WA_TITLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_X"), s7_make_integer(sc, GDK_WA_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_Y"), s7_make_integer(sc, GDK_WA_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_CURSOR"), s7_make_integer(sc, GDK_WA_CURSOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_VISUAL"), s7_make_integer(sc, GDK_WA_VISUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_WMCLASS"), s7_make_integer(sc, GDK_WA_WMCLASS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WA_NOREDIR"), s7_make_integer(sc, GDK_WA_NOREDIR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_POS"), s7_make_integer(sc, GDK_HINT_POS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_MIN_SIZE"), s7_make_integer(sc, GDK_HINT_MIN_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_MAX_SIZE"), s7_make_integer(sc, GDK_HINT_MAX_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_BASE_SIZE"), s7_make_integer(sc, GDK_HINT_BASE_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_ASPECT"), s7_make_integer(sc, GDK_HINT_ASPECT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_RESIZE_INC"), s7_make_integer(sc, GDK_HINT_RESIZE_INC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_WIN_GRAVITY"), s7_make_integer(sc, GDK_HINT_WIN_GRAVITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_USER_POS"), s7_make_integer(sc, GDK_HINT_USER_POS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HINT_USER_SIZE"), s7_make_integer(sc, GDK_HINT_USER_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_NORMAL"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_DIALOG"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_DIALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_MENU"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_TOOLBAR"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_TOOLBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_ALL"), s7_make_integer(sc, GDK_DECOR_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_BORDER"), s7_make_integer(sc, GDK_DECOR_BORDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_RESIZEH"), s7_make_integer(sc, GDK_DECOR_RESIZEH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_TITLE"), s7_make_integer(sc, GDK_DECOR_TITLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_MENU"), s7_make_integer(sc, GDK_DECOR_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_MINIMIZE"), s7_make_integer(sc, GDK_DECOR_MINIMIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DECOR_MAXIMIZE"), s7_make_integer(sc, GDK_DECOR_MAXIMIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_ALL"), s7_make_integer(sc, GDK_FUNC_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_RESIZE"), s7_make_integer(sc, GDK_FUNC_RESIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_MOVE"), s7_make_integer(sc, GDK_FUNC_MOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_MINIMIZE"), s7_make_integer(sc, GDK_FUNC_MINIMIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_MAXIMIZE"), s7_make_integer(sc, GDK_FUNC_MAXIMIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FUNC_CLOSE"), s7_make_integer(sc, GDK_FUNC_CLOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_NORTH_WEST"), s7_make_integer(sc, GDK_GRAVITY_NORTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_NORTH"), s7_make_integer(sc, GDK_GRAVITY_NORTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_NORTH_EAST"), s7_make_integer(sc, GDK_GRAVITY_NORTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_WEST"), s7_make_integer(sc, GDK_GRAVITY_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_CENTER"), s7_make_integer(sc, GDK_GRAVITY_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_EAST"), s7_make_integer(sc, GDK_GRAVITY_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_SOUTH_WEST"), s7_make_integer(sc, GDK_GRAVITY_SOUTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_SOUTH"), s7_make_integer(sc, GDK_GRAVITY_SOUTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_SOUTH_EAST"), s7_make_integer(sc, GDK_GRAVITY_SOUTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAVITY_STATIC"), s7_make_integer(sc, GDK_GRAVITY_STATIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_NORTH_WEST"), s7_make_integer(sc, GDK_WINDOW_EDGE_NORTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_NORTH"), s7_make_integer(sc, GDK_WINDOW_EDGE_NORTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_NORTH_EAST"), s7_make_integer(sc, GDK_WINDOW_EDGE_NORTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_WEST"), s7_make_integer(sc, GDK_WINDOW_EDGE_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_EAST"), s7_make_integer(sc, GDK_WINDOW_EDGE_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_SOUTH_WEST"), s7_make_integer(sc, GDK_WINDOW_EDGE_SOUTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_SOUTH"), s7_make_integer(sc, GDK_WINDOW_EDGE_SOUTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_EDGE_SOUTH_EAST"), s7_make_integer(sc, GDK_WINDOW_EDGE_SOUTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ALPHA_BILEVEL"), s7_make_integer(sc, GDK_PIXBUF_ALPHA_BILEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ALPHA_FULL"), s7_make_integer(sc, GDK_PIXBUF_ALPHA_FULL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_COLORSPACE_RGB"), s7_make_integer(sc, GDK_COLORSPACE_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_CORRUPT_IMAGE"), s7_make_integer(sc, GDK_PIXBUF_ERROR_CORRUPT_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY"), s7_make_integer(sc, GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_BAD_OPTION"), s7_make_integer(sc, GDK_PIXBUF_ERROR_BAD_OPTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_UNKNOWN_TYPE"), s7_make_integer(sc, GDK_PIXBUF_ERROR_UNKNOWN_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION"), s7_make_integer(sc, GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_FAILED"), s7_make_integer(sc, GDK_PIXBUF_ERROR_FAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_NEAREST"), s7_make_integer(sc, GDK_INTERP_NEAREST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_TILES"), s7_make_integer(sc, GDK_INTERP_TILES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_BILINEAR"), s7_make_integer(sc, GDK_INTERP_BILINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_HYPER"), s7_make_integer(sc, GDK_INTERP_HYPER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ACCEL_VISIBLE"), s7_make_integer(sc, GTK_ACCEL_VISIBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ACCEL_LOCKED"), s7_make_integer(sc, GTK_ACCEL_LOCKED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ACCEL_MASK"), s7_make_integer(sc, GTK_ACCEL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_HEADING"), s7_make_integer(sc, GTK_CALENDAR_SHOW_HEADING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_DAY_NAMES"), s7_make_integer(sc, GTK_CALENDAR_SHOW_DAY_NAMES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_NO_MONTH_CHANGE"), s7_make_integer(sc, GTK_CALENDAR_NO_MONTH_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_WEEK_NUMBERS"), s7_make_integer(sc, GTK_CALENDAR_SHOW_WEEK_NUMBERS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_SELECTED"), s7_make_integer(sc, GTK_CELL_RENDERER_SELECTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_PRELIT"), s7_make_integer(sc, GTK_CELL_RENDERER_PRELIT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_INSENSITIVE"), s7_make_integer(sc, GTK_CELL_RENDERER_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_SORTED"), s7_make_integer(sc, GTK_CELL_RENDERER_SORTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_FOCUSED"), s7_make_integer(sc, GTK_CELL_RENDERER_FOCUSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIALOG_MODAL"), s7_make_integer(sc, GTK_DIALOG_MODAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIALOG_DESTROY_WITH_PARENT"), s7_make_integer(sc, GTK_DIALOG_DESTROY_WITH_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_NONE"), s7_make_integer(sc, GTK_RESPONSE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_REJECT"), s7_make_integer(sc, GTK_RESPONSE_REJECT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_ACCEPT"), s7_make_integer(sc, GTK_RESPONSE_ACCEPT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_DELETE_EVENT"), s7_make_integer(sc, GTK_RESPONSE_DELETE_EVENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_OK"), s7_make_integer(sc, GTK_RESPONSE_OK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_CANCEL"), s7_make_integer(sc, GTK_RESPONSE_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_CLOSE"), s7_make_integer(sc, GTK_RESPONSE_CLOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_YES"), s7_make_integer(sc, GTK_RESPONSE_YES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_NO"), s7_make_integer(sc, GTK_RESPONSE_NO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_APPLY"), s7_make_integer(sc, GTK_RESPONSE_APPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_HELP"), s7_make_integer(sc, GTK_RESPONSE_HELP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_MOTION"), s7_make_integer(sc, GTK_DEST_DEFAULT_MOTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_HIGHLIGHT"), s7_make_integer(sc, GTK_DEST_DEFAULT_HIGHLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_DROP"), s7_make_integer(sc, GTK_DEST_DEFAULT_DROP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_ALL"), s7_make_integer(sc, GTK_DEST_DEFAULT_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONBOX_SPREAD"), s7_make_integer(sc, GTK_BUTTONBOX_SPREAD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONBOX_EDGE"), s7_make_integer(sc, GTK_BUTTONBOX_EDGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONBOX_START"), s7_make_integer(sc, GTK_BUTTONBOX_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONBOX_END"), s7_make_integer(sc, GTK_BUTTONBOX_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONBOX_CENTER"), s7_make_integer(sc, GTK_BUTTONBOX_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_CHARS"), s7_make_integer(sc, GTK_DELETE_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WORD_ENDS"), s7_make_integer(sc, GTK_DELETE_WORD_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WORDS"), s7_make_integer(sc, GTK_DELETE_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_DISPLAY_LINES"), s7_make_integer(sc, GTK_DELETE_DISPLAY_LINES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_DISPLAY_LINE_ENDS"), s7_make_integer(sc, GTK_DELETE_DISPLAY_LINE_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_PARAGRAPH_ENDS"), s7_make_integer(sc, GTK_DELETE_PARAGRAPH_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_PARAGRAPHS"), s7_make_integer(sc, GTK_DELETE_PARAGRAPHS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WHITESPACE"), s7_make_integer(sc, GTK_DELETE_WHITESPACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_TAB_FORWARD"), s7_make_integer(sc, GTK_DIR_TAB_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_TAB_BACKWARD"), s7_make_integer(sc, GTK_DIR_TAB_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_UP"), s7_make_integer(sc, GTK_DIR_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_DOWN"), s7_make_integer(sc, GTK_DIR_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_LEFT"), s7_make_integer(sc, GTK_DIR_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_RIGHT"), s7_make_integer(sc, GTK_DIR_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_NONE"), s7_make_integer(sc, GTK_TEXT_DIR_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_LTR"), s7_make_integer(sc, GTK_TEXT_DIR_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_RTL"), s7_make_integer(sc, GTK_TEXT_DIR_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_LEFT"), s7_make_integer(sc, GTK_JUSTIFY_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_RIGHT"), s7_make_integer(sc, GTK_JUSTIFY_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_CENTER"), s7_make_integer(sc, GTK_JUSTIFY_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_FILL"), s7_make_integer(sc, GTK_JUSTIFY_FILL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_PARENT"), s7_make_integer(sc, GTK_MENU_DIR_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_CHILD"), s7_make_integer(sc, GTK_MENU_DIR_CHILD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_NEXT"), s7_make_integer(sc, GTK_MENU_DIR_NEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_PREV"), s7_make_integer(sc, GTK_MENU_DIR_PREV));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_LOGICAL_POSITIONS"), s7_make_integer(sc, GTK_MOVEMENT_LOGICAL_POSITIONS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_VISUAL_POSITIONS"), s7_make_integer(sc, GTK_MOVEMENT_VISUAL_POSITIONS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_WORDS"), s7_make_integer(sc, GTK_MOVEMENT_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_DISPLAY_LINES"), s7_make_integer(sc, GTK_MOVEMENT_DISPLAY_LINES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_DISPLAY_LINE_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_DISPLAY_LINE_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PARAGRAPHS"), s7_make_integer(sc, GTK_MOVEMENT_PARAGRAPHS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PARAGRAPH_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_PARAGRAPH_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PAGES"), s7_make_integer(sc, GTK_MOVEMENT_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_BUFFER_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_BUFFER_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ORIENTATION_HORIZONTAL"), s7_make_integer(sc, GTK_ORIENTATION_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ORIENTATION_VERTICAL"), s7_make_integer(sc, GTK_ORIENTATION_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_TOP_LEFT"), s7_make_integer(sc, GTK_CORNER_TOP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_BOTTOM_LEFT"), s7_make_integer(sc, GTK_CORNER_BOTTOM_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_TOP_RIGHT"), s7_make_integer(sc, GTK_CORNER_TOP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_BOTTOM_RIGHT"), s7_make_integer(sc, GTK_CORNER_BOTTOM_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_START"), s7_make_integer(sc, GTK_PACK_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_END"), s7_make_integer(sc, GTK_PACK_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_ALWAYS"), s7_make_integer(sc, GTK_POLICY_ALWAYS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_AUTOMATIC"), s7_make_integer(sc, GTK_POLICY_AUTOMATIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_NEVER"), s7_make_integer(sc, GTK_POLICY_NEVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_LEFT"), s7_make_integer(sc, GTK_POS_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_RIGHT"), s7_make_integer(sc, GTK_POS_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_TOP"), s7_make_integer(sc, GTK_POS_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_BOTTOM"), s7_make_integer(sc, GTK_POS_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RELIEF_NORMAL"), s7_make_integer(sc, GTK_RELIEF_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RELIEF_HALF"), s7_make_integer(sc, GTK_RELIEF_HALF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RELIEF_NONE"), s7_make_integer(sc, GTK_RELIEF_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESIZE_PARENT"), s7_make_integer(sc, GTK_RESIZE_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESIZE_QUEUE"), s7_make_integer(sc, GTK_RESIZE_QUEUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESIZE_IMMEDIATE"), s7_make_integer(sc, GTK_RESIZE_IMMEDIATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_NONE"), s7_make_integer(sc, GTK_SCROLL_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_JUMP"), s7_make_integer(sc, GTK_SCROLL_JUMP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_BACKWARD"), s7_make_integer(sc, GTK_SCROLL_STEP_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_FORWARD"), s7_make_integer(sc, GTK_SCROLL_STEP_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_BACKWARD"), s7_make_integer(sc, GTK_SCROLL_PAGE_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_FORWARD"), s7_make_integer(sc, GTK_SCROLL_PAGE_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_UP"), s7_make_integer(sc, GTK_SCROLL_STEP_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_DOWN"), s7_make_integer(sc, GTK_SCROLL_STEP_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_UP"), s7_make_integer(sc, GTK_SCROLL_PAGE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_DOWN"), s7_make_integer(sc, GTK_SCROLL_PAGE_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_LEFT"), s7_make_integer(sc, GTK_SCROLL_STEP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_RIGHT"), s7_make_integer(sc, GTK_SCROLL_STEP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_LEFT"), s7_make_integer(sc, GTK_SCROLL_PAGE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_RIGHT"), s7_make_integer(sc, GTK_SCROLL_PAGE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_START"), s7_make_integer(sc, GTK_SCROLL_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_END"), s7_make_integer(sc, GTK_SCROLL_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_NONE"), s7_make_integer(sc, GTK_SELECTION_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_SINGLE"), s7_make_integer(sc, GTK_SELECTION_SINGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_BROWSE"), s7_make_integer(sc, GTK_SELECTION_BROWSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_MULTIPLE"), s7_make_integer(sc, GTK_SELECTION_MULTIPLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHADOW_NONE"), s7_make_integer(sc, GTK_SHADOW_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHADOW_IN"), s7_make_integer(sc, GTK_SHADOW_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHADOW_OUT"), s7_make_integer(sc, GTK_SHADOW_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHADOW_ETCHED_IN"), s7_make_integer(sc, GTK_SHADOW_ETCHED_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHADOW_ETCHED_OUT"), s7_make_integer(sc, GTK_SHADOW_ETCHED_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOLBAR_ICONS"), s7_make_integer(sc, GTK_TOOLBAR_ICONS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOLBAR_TEXT"), s7_make_integer(sc, GTK_TOOLBAR_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOLBAR_BOTH"), s7_make_integer(sc, GTK_TOOLBAR_BOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOLBAR_BOTH_HORIZ"), s7_make_integer(sc, GTK_TOOLBAR_BOTH_HORIZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WIN_POS_NONE"), s7_make_integer(sc, GTK_WIN_POS_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WIN_POS_CENTER"), s7_make_integer(sc, GTK_WIN_POS_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WIN_POS_MOUSE"), s7_make_integer(sc, GTK_WIN_POS_MOUSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WIN_POS_CENTER_ALWAYS"), s7_make_integer(sc, GTK_WIN_POS_CENTER_ALWAYS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WIN_POS_CENTER_ON_PARENT"), s7_make_integer(sc, GTK_WIN_POS_CENTER_ON_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WINDOW_TOPLEVEL"), s7_make_integer(sc, GTK_WINDOW_TOPLEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WINDOW_POPUP"), s7_make_integer(sc, GTK_WINDOW_POPUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_NONE"), s7_make_integer(sc, GTK_WRAP_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_CHAR"), s7_make_integer(sc, GTK_WRAP_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_WORD"), s7_make_integer(sc, GTK_WRAP_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SORT_ASCENDING"), s7_make_integer(sc, GTK_SORT_ASCENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SORT_DESCENDING"), s7_make_integer(sc, GTK_SORT_DESCENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_EMPTY"), s7_make_integer(sc, GTK_IMAGE_EMPTY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_PIXBUF"), s7_make_integer(sc, GTK_IMAGE_PIXBUF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_STOCK"), s7_make_integer(sc, GTK_IMAGE_STOCK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_ICON_SET"), s7_make_integer(sc, GTK_IMAGE_ICON_SET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_ANIMATION"), s7_make_integer(sc, GTK_IMAGE_ANIMATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MAX_COMPOSE_LEN"), s7_make_integer(sc, GTK_MAX_COMPOSE_LEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRIORITY_RESIZE"), s7_make_integer(sc, GTK_PRIORITY_RESIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_INFO"), s7_make_integer(sc, GTK_MESSAGE_INFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_WARNING"), s7_make_integer(sc, GTK_MESSAGE_WARNING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_QUESTION"), s7_make_integer(sc, GTK_MESSAGE_QUESTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_ERROR"), s7_make_integer(sc, GTK_MESSAGE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_NONE"), s7_make_integer(sc, GTK_BUTTONS_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_OK"), s7_make_integer(sc, GTK_BUTTONS_OK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_CLOSE"), s7_make_integer(sc, GTK_BUTTONS_CLOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_CANCEL"), s7_make_integer(sc, GTK_BUTTONS_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_YES_NO"), s7_make_integer(sc, GTK_BUTTONS_YES_NO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_OK_CANCEL"), s7_make_integer(sc, GTK_BUTTONS_OK_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_NOTEBOOK_TAB_FIRST"), s7_make_integer(sc, GTK_NOTEBOOK_TAB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_NOTEBOOK_TAB_LAST"), s7_make_integer(sc, GTK_NOTEBOOK_TAB_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_NONE"), s7_make_integer(sc, GTK_SIZE_GROUP_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_HORIZONTAL"), s7_make_integer(sc, GTK_SIZE_GROUP_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_VERTICAL"), s7_make_integer(sc, GTK_SIZE_GROUP_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_BOTH"), s7_make_integer(sc, GTK_SIZE_GROUP_BOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_ERROR"), s7_make_integer(sc, GTK_INPUT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_UPDATE_ALWAYS"), s7_make_integer(sc, GTK_UPDATE_ALWAYS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_UPDATE_IF_VALID"), s7_make_integer(sc, GTK_UPDATE_IF_VALID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_STEP_FORWARD"), s7_make_integer(sc, GTK_SPIN_STEP_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_STEP_BACKWARD"), s7_make_integer(sc, GTK_SPIN_STEP_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_PAGE_FORWARD"), s7_make_integer(sc, GTK_SPIN_PAGE_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_PAGE_BACKWARD"), s7_make_integer(sc, GTK_SPIN_PAGE_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_HOME"), s7_make_integer(sc, GTK_SPIN_HOME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_END"), s7_make_integer(sc, GTK_SPIN_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_USER_DEFINED"), s7_make_integer(sc, GTK_SPIN_USER_DEFINED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_VISIBLE_ONLY"), s7_make_integer(sc, GTK_TEXT_SEARCH_VISIBLE_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_TEXT_ONLY"), s7_make_integer(sc, GTK_TEXT_SEARCH_TEXT_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_PRIVATE"), s7_make_integer(sc, GTK_TEXT_WINDOW_PRIVATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_WIDGET"), s7_make_integer(sc, GTK_TEXT_WINDOW_WIDGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_TEXT"), s7_make_integer(sc, GTK_TEXT_WINDOW_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_LEFT"), s7_make_integer(sc, GTK_TEXT_WINDOW_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_RIGHT"), s7_make_integer(sc, GTK_TEXT_WINDOW_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_TOP"), s7_make_integer(sc, GTK_TEXT_WINDOW_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_BOTTOM"), s7_make_integer(sc, GTK_TEXT_WINDOW_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_VIEW_PRIORITY_VALIDATE"), s7_make_integer(sc, GTK_TEXT_VIEW_PRIORITY_VALIDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_MODEL_ITERS_PERSIST"), s7_make_integer(sc, GTK_TREE_MODEL_ITERS_PERSIST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_MODEL_LIST_ONLY"), s7_make_integer(sc, GTK_TREE_MODEL_LIST_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_GROW_ONLY"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_GROW_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_AUTOSIZE"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_AUTOSIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_FIXED"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_FIXED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_BEFORE"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_BEFORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_AFTER"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_INTO_OR_BEFORE"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_INTO_OR_BEFORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_INTO_OR_AFTER"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_INTO_OR_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_INVALID"), s7_make_integer(sc, PANGO_ATTR_INVALID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_LANGUAGE"), s7_make_integer(sc, PANGO_ATTR_LANGUAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FAMILY"), s7_make_integer(sc, PANGO_ATTR_FAMILY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STYLE"), s7_make_integer(sc, PANGO_ATTR_STYLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_WEIGHT"), s7_make_integer(sc, PANGO_ATTR_WEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_VARIANT"), s7_make_integer(sc, PANGO_ATTR_VARIANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRETCH"), s7_make_integer(sc, PANGO_ATTR_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SIZE"), s7_make_integer(sc, PANGO_ATTR_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FONT_DESC"), s7_make_integer(sc, PANGO_ATTR_FONT_DESC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FOREGROUND"), s7_make_integer(sc, PANGO_ATTR_FOREGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_BACKGROUND"), s7_make_integer(sc, PANGO_ATTR_BACKGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_UNDERLINE"), s7_make_integer(sc, PANGO_ATTR_UNDERLINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRIKETHROUGH"), s7_make_integer(sc, PANGO_ATTR_STRIKETHROUGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_RISE"), s7_make_integer(sc, PANGO_ATTR_RISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SHAPE"), s7_make_integer(sc, PANGO_ATTR_SHAPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SCALE"), s7_make_integer(sc, PANGO_ATTR_SCALE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_NONE"), s7_make_integer(sc, PANGO_UNDERLINE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_SINGLE"), s7_make_integer(sc, PANGO_UNDERLINE_SINGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_DOUBLE"), s7_make_integer(sc, PANGO_UNDERLINE_DOUBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_LOW"), s7_make_integer(sc, PANGO_UNDERLINE_LOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_NONE"), s7_make_integer(sc, PANGO_COVERAGE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_FALLBACK"), s7_make_integer(sc, PANGO_COVERAGE_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_APPROXIMATE"), s7_make_integer(sc, PANGO_COVERAGE_APPROXIMATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_EXACT"), s7_make_integer(sc, PANGO_COVERAGE_EXACT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_NORMAL"), s7_make_integer(sc, PANGO_STYLE_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_OBLIQUE"), s7_make_integer(sc, PANGO_STYLE_OBLIQUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_ITALIC"), s7_make_integer(sc, PANGO_STYLE_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_VARIANT_NORMAL"), s7_make_integer(sc, PANGO_VARIANT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_VARIANT_SMALL_CAPS"), s7_make_integer(sc, PANGO_VARIANT_SMALL_CAPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_ULTRALIGHT"), s7_make_integer(sc, PANGO_WEIGHT_ULTRALIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_LIGHT"), s7_make_integer(sc, PANGO_WEIGHT_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_NORMAL"), s7_make_integer(sc, PANGO_WEIGHT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_BOLD"), s7_make_integer(sc, PANGO_WEIGHT_BOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_ULTRABOLD"), s7_make_integer(sc, PANGO_WEIGHT_ULTRABOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_HEAVY"), s7_make_integer(sc, PANGO_WEIGHT_HEAVY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_ULTRA_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_ULTRA_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXTRA_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_EXTRA_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_SEMI_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_SEMI_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_NORMAL"), s7_make_integer(sc, PANGO_STRETCH_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_SEMI_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_SEMI_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXTRA_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_EXTRA_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_ULTRA_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_ULTRA_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_FAMILY"), s7_make_integer(sc, PANGO_FONT_MASK_FAMILY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_STYLE"), s7_make_integer(sc, PANGO_FONT_MASK_STYLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_VARIANT"), s7_make_integer(sc, PANGO_FONT_MASK_VARIANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_WEIGHT"), s7_make_integer(sc, PANGO_FONT_MASK_WEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_STRETCH"), s7_make_integer(sc, PANGO_FONT_MASK_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_SIZE"), s7_make_integer(sc, PANGO_FONT_MASK_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_LEFT"), s7_make_integer(sc, PANGO_ALIGN_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_CENTER"), s7_make_integer(sc, PANGO_ALIGN_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_RIGHT"), s7_make_integer(sc, PANGO_ALIGN_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_WORD"), s7_make_integer(sc, PANGO_WRAP_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_CHAR"), s7_make_integer(sc, PANGO_WRAP_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_LTR"), s7_make_integer(sc, PANGO_DIRECTION_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_RTL"), s7_make_integer(sc, PANGO_DIRECTION_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_TTB_LTR"), s7_make_integer(sc, PANGO_DIRECTION_TTB_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_TTB_RTL"), s7_make_integer(sc, PANGO_DIRECTION_TTB_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_FULLSCREEN"), s7_make_integer(sc, GDK_WINDOW_STATE_FULLSCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_ABOVE"), s7_make_integer(sc, GDK_WINDOW_STATE_ABOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_BELOW"), s7_make_integer(sc, GDK_WINDOW_STATE_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_HORIZONTAL_PAGES"), s7_make_integer(sc, GTK_MOVEMENT_HORIZONTAL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEPS"), s7_make_integer(sc, GTK_SCROLL_STEPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGES"), s7_make_integer(sc, GTK_SCROLL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_ENDS"), s7_make_integer(sc, GTK_SCROLL_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_STEPS"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_STEPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_PAGES"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_ENDS"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_WORD_CHAR"), s7_make_integer(sc, GTK_WRAP_WORD_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_FILENAME"), s7_make_integer(sc, GTK_FILE_FILTER_FILENAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_URI"), s7_make_integer(sc, GTK_FILE_FILTER_URI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_DISPLAY_NAME"), s7_make_integer(sc, GTK_FILE_FILTER_DISPLAY_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_MIME_TYPE"), s7_make_integer(sc, GTK_FILE_FILTER_MIME_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_NO_SVG"), s7_make_integer(sc, GTK_ICON_LOOKUP_NO_SVG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_FORCE_SVG"), s7_make_integer(sc, GTK_ICON_LOOKUP_FORCE_SVG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_USE_BUILTIN"), s7_make_integer(sc, GTK_ICON_LOOKUP_USE_BUILTIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_GENERIC_FALLBACK"), s7_make_integer(sc, GTK_ICON_LOOKUP_GENERIC_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_OPEN"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_OPEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_SAVE"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_SAVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_HIGH"), s7_make_integer(sc, G_PRIORITY_HIGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_DEFAULT"), s7_make_integer(sc, G_PRIORITY_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_HIGH_IDLE"), s7_make_integer(sc, G_PRIORITY_HIGH_IDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_DEFAULT_IDLE"), s7_make_integer(sc, G_PRIORITY_DEFAULT_IDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_LOW"), s7_make_integer(sc, G_PRIORITY_LOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FALLBACK"), s7_make_integer(sc, PANGO_ATTR_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_LETTER_SPACING"), s7_make_integer(sc, PANGO_ATTR_LETTER_SPACING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_ERROR"), s7_make_integer(sc, PANGO_UNDERLINE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_WORD_CHAR"), s7_make_integer(sc, PANGO_WRAP_WORD_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_NONE"), s7_make_integer(sc, PANGO_ELLIPSIZE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_START"), s7_make_integer(sc, PANGO_ELLIPSIZE_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_MIDDLE"), s7_make_integer(sc, PANGO_ELLIPSIZE_MIDDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_END"), s7_make_integer(sc, PANGO_ELLIPSIZE_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_INVALID_CODE"), s7_make_integer(sc, PANGO_SCRIPT_INVALID_CODE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_COMMON"), s7_make_integer(sc, PANGO_SCRIPT_COMMON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_INHERITED"), s7_make_integer(sc, PANGO_SCRIPT_INHERITED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ARABIC"), s7_make_integer(sc, PANGO_SCRIPT_ARABIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ARMENIAN"), s7_make_integer(sc, PANGO_SCRIPT_ARMENIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BENGALI"), s7_make_integer(sc, PANGO_SCRIPT_BENGALI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BOPOMOFO"), s7_make_integer(sc, PANGO_SCRIPT_BOPOMOFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CHEROKEE"), s7_make_integer(sc, PANGO_SCRIPT_CHEROKEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_COPTIC"), s7_make_integer(sc, PANGO_SCRIPT_COPTIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CYRILLIC"), s7_make_integer(sc, PANGO_SCRIPT_CYRILLIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_DESERET"), s7_make_integer(sc, PANGO_SCRIPT_DESERET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_DEVANAGARI"), s7_make_integer(sc, PANGO_SCRIPT_DEVANAGARI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ETHIOPIC"), s7_make_integer(sc, PANGO_SCRIPT_ETHIOPIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GEORGIAN"), s7_make_integer(sc, PANGO_SCRIPT_GEORGIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GOTHIC"), s7_make_integer(sc, PANGO_SCRIPT_GOTHIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GREEK"), s7_make_integer(sc, PANGO_SCRIPT_GREEK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GUJARATI"), s7_make_integer(sc, PANGO_SCRIPT_GUJARATI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GURMUKHI"), s7_make_integer(sc, PANGO_SCRIPT_GURMUKHI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HAN"), s7_make_integer(sc, PANGO_SCRIPT_HAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HANGUL"), s7_make_integer(sc, PANGO_SCRIPT_HANGUL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HEBREW"), s7_make_integer(sc, PANGO_SCRIPT_HEBREW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HIRAGANA"), s7_make_integer(sc, PANGO_SCRIPT_HIRAGANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KANNADA"), s7_make_integer(sc, PANGO_SCRIPT_KANNADA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KATAKANA"), s7_make_integer(sc, PANGO_SCRIPT_KATAKANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KHMER"), s7_make_integer(sc, PANGO_SCRIPT_KHMER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LAO"), s7_make_integer(sc, PANGO_SCRIPT_LAO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LATIN"), s7_make_integer(sc, PANGO_SCRIPT_LATIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MALAYALAM"), s7_make_integer(sc, PANGO_SCRIPT_MALAYALAM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MONGOLIAN"), s7_make_integer(sc, PANGO_SCRIPT_MONGOLIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MYANMAR"), s7_make_integer(sc, PANGO_SCRIPT_MYANMAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OGHAM"), s7_make_integer(sc, PANGO_SCRIPT_OGHAM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OLD_ITALIC"), s7_make_integer(sc, PANGO_SCRIPT_OLD_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ORIYA"), s7_make_integer(sc, PANGO_SCRIPT_ORIYA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_RUNIC"), s7_make_integer(sc, PANGO_SCRIPT_RUNIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SINHALA"), s7_make_integer(sc, PANGO_SCRIPT_SINHALA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SYRIAC"), s7_make_integer(sc, PANGO_SCRIPT_SYRIAC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAMIL"), s7_make_integer(sc, PANGO_SCRIPT_TAMIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TELUGU"), s7_make_integer(sc, PANGO_SCRIPT_TELUGU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_THAANA"), s7_make_integer(sc, PANGO_SCRIPT_THAANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_THAI"), s7_make_integer(sc, PANGO_SCRIPT_THAI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TIBETAN"), s7_make_integer(sc, PANGO_SCRIPT_TIBETAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CANADIAN_ABORIGINAL"), s7_make_integer(sc, PANGO_SCRIPT_CANADIAN_ABORIGINAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_YI"), s7_make_integer(sc, PANGO_SCRIPT_YI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAGALOG"), s7_make_integer(sc, PANGO_SCRIPT_TAGALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HANUNOO"), s7_make_integer(sc, PANGO_SCRIPT_HANUNOO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BUHID"), s7_make_integer(sc, PANGO_SCRIPT_BUHID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAGBANWA"), s7_make_integer(sc, PANGO_SCRIPT_TAGBANWA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BRAILLE"), s7_make_integer(sc, PANGO_SCRIPT_BRAILLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CYPRIOT"), s7_make_integer(sc, PANGO_SCRIPT_CYPRIOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LIMBU"), s7_make_integer(sc, PANGO_SCRIPT_LIMBU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OSMANYA"), s7_make_integer(sc, PANGO_SCRIPT_OSMANYA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SHAVIAN"), s7_make_integer(sc, PANGO_SCRIPT_SHAVIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LINEAR_B"), s7_make_integer(sc, PANGO_SCRIPT_LINEAR_B));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAI_LE"), s7_make_integer(sc, PANGO_SCRIPT_TAI_LE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_UGARITIC"), s7_make_integer(sc, PANGO_SCRIPT_UGARITIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_TAB_LEFT"), s7_make_integer(sc, PANGO_TAB_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_WEAK_LTR"), s7_make_integer(sc, PANGO_DIRECTION_WEAK_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_WEAK_RTL"), s7_make_integer(sc, PANGO_DIRECTION_WEAK_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_NEUTRAL"), s7_make_integer(sc, PANGO_DIRECTION_NEUTRAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID"), s7_make_integer(sc, GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID"), s7_make_integer(sc, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_ICON_NAME"), s7_make_integer(sc, GTK_IMAGE_ICON_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_UNDERLINE_COLOR"), s7_make_integer(sc, PANGO_ATTR_UNDERLINE_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRIKETHROUGH_COLOR"), s7_make_integer(sc, PANGO_ATTR_STRIKETHROUGH_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_FOREGROUND"), s7_make_integer(sc, PANGO_RENDER_PART_FOREGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_BACKGROUND"), s7_make_integer(sc, PANGO_RENDER_PART_BACKGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_UNDERLINE"), s7_make_integer(sc, PANGO_RENDER_PART_UNDERLINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_STRIKETHROUGH"), s7_make_integer(sc, PANGO_RENDER_PART_STRIKETHROUGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FLAG_RECURSION"), s7_make_integer(sc, G_LOG_FLAG_RECURSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FLAG_FATAL"), s7_make_integer(sc, G_LOG_FLAG_FATAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_ERROR"), s7_make_integer(sc, G_LOG_LEVEL_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_CRITICAL"), s7_make_integer(sc, G_LOG_LEVEL_CRITICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_WARNING"), s7_make_integer(sc, G_LOG_LEVEL_WARNING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_MESSAGE"), s7_make_integer(sc, G_LOG_LEVEL_MESSAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_INFO"), s7_make_integer(sc, G_LOG_LEVEL_INFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_DEBUG"), s7_make_integer(sc, G_LOG_LEVEL_DEBUG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_MASK"), s7_make_integer(sc, G_LOG_LEVEL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FATAL_MASK"), s7_make_integer(sc, G_LOG_FATAL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_SEMIBOLD"), s7_make_integer(sc, PANGO_WEIGHT_SEMIBOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_DIRECTION_LTR"), s7_make_integer(sc, GTK_PACK_DIRECTION_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_DIRECTION_RTL"), s7_make_integer(sc, GTK_PACK_DIRECTION_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_DIRECTION_TTB"), s7_make_integer(sc, GTK_PACK_DIRECTION_TTB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_DIRECTION_BTT"), s7_make_integer(sc, GTK_PACK_DIRECTION_BTT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_NO_DROP"), s7_make_integer(sc, GTK_ICON_VIEW_NO_DROP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_INTO"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_INTO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_LEFT"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_RIGHT"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_ABOVE"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_ABOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_BELOW"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM"), s7_make_integer(sc, GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME"), s7_make_integer(sc, GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN"), s7_make_integer(sc, GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_NEW_TAI_LUE"), s7_make_integer(sc, PANGO_SCRIPT_NEW_TAI_LUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BUGINESE"), s7_make_integer(sc, PANGO_SCRIPT_BUGINESE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GLAGOLITIC"), s7_make_integer(sc, PANGO_SCRIPT_GLAGOLITIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TIFINAGH"), s7_make_integer(sc, PANGO_SCRIPT_TIFINAGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SYLOTI_NAGRI"), s7_make_integer(sc, PANGO_SCRIPT_SYLOTI_NAGRI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OLD_PERSIAN"), s7_make_integer(sc, PANGO_SCRIPT_OLD_PERSIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KHAROSHTHI"), s7_make_integer(sc, PANGO_SCRIPT_KHAROSHTHI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUPER_MASK"), s7_make_integer(sc, GDK_SUPER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HYPER_MASK"), s7_make_integer(sc, GDK_HYPER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_META_MASK"), s7_make_integer(sc, GDK_META_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_AUTO"), s7_make_integer(sc, GTK_SENSITIVITY_AUTO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_ON"), s7_make_integer(sc, GTK_SENSITIVITY_ON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_OFF"), s7_make_integer(sc, GTK_SENSITIVITY_OFF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_TEXT"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CONTENT"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CONTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_INTRO"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_INTRO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CONFIRM"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CONFIRM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_SUMMARY"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_SUMMARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_PROGRESS"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_PROGRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_ACCEL_MODE_GTK"), s7_make_integer(sc, GTK_CELL_RENDERER_ACCEL_MODE_GTK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_ACCEL_MODE_OTHER"), s7_make_integer(sc, GTK_CELL_RENDERER_ACCEL_MODE_OTHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_SORT_NONE"), s7_make_integer(sc, GTK_RECENT_SORT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_SORT_MRU"), s7_make_integer(sc, GTK_RECENT_SORT_MRU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_SORT_LRU"), s7_make_integer(sc, GTK_RECENT_SORT_LRU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_SORT_CUSTOM"), s7_make_integer(sc, GTK_RECENT_SORT_CUSTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_CHOOSER_ERROR_NOT_FOUND"), s7_make_integer(sc, GTK_RECENT_CHOOSER_ERROR_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_CHOOSER_ERROR_INVALID_URI"), s7_make_integer(sc, GTK_RECENT_CHOOSER_ERROR_INVALID_URI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_NOT_FOUND"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_INVALID_URI"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_INVALID_URI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_READ"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_READ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_WRITE"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_WRITE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_UNKNOWN"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_OTHER"), s7_make_integer(sc, GTK_MESSAGE_OTHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_NONE"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_HORIZONTAL"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_VERTICAL"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_BOTH"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_BOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_INITIAL"), s7_make_integer(sc, GTK_PRINT_STATUS_INITIAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PREPARING"), s7_make_integer(sc, GTK_PRINT_STATUS_PREPARING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_GENERATING_DATA"), s7_make_integer(sc, GTK_PRINT_STATUS_GENERATING_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_SENDING_DATA"), s7_make_integer(sc, GTK_PRINT_STATUS_SENDING_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PENDING"), s7_make_integer(sc, GTK_PRINT_STATUS_PENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PENDING_ISSUE"), s7_make_integer(sc, GTK_PRINT_STATUS_PENDING_ISSUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PRINTING"), s7_make_integer(sc, GTK_PRINT_STATUS_PRINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_FINISHED"), s7_make_integer(sc, GTK_PRINT_STATUS_FINISHED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_FINISHED_ABORTED"), s7_make_integer(sc, GTK_PRINT_STATUS_FINISHED_ABORTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_ERROR"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_APPLY"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_APPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_CANCEL"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_IN_PROGRESS"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_IN_PROGRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PRINT"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PRINT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PREVIEW"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PREVIEW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_EXPORT"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_EXPORT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_GENERAL"), s7_make_integer(sc, GTK_PRINT_ERROR_GENERAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_INTERNAL_ERROR"), s7_make_integer(sc, GTK_PRINT_ERROR_INTERNAL_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_NOMEM"), s7_make_integer(sc, GTK_PRINT_ERROR_NOMEM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_INVALID_FILE"), s7_make_integer(sc, GTK_PRINT_ERROR_INVALID_FILE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_SUCCESS"), s7_make_integer(sc, GTK_DRAG_RESULT_SUCCESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_NO_TARGET"), s7_make_integer(sc, GTK_DRAG_RESULT_NO_TARGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_USER_CANCELLED"), s7_make_integer(sc, GTK_DRAG_RESULT_USER_CANCELLED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_TIMEOUT_EXPIRED"), s7_make_integer(sc, GTK_DRAG_RESULT_TIMEOUT_EXPIRED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_GRAB_BROKEN"), s7_make_integer(sc, GTK_DRAG_RESULT_GRAB_BROKEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DRAG_RESULT_ERROR"), s7_make_integer(sc, GTK_DRAG_RESULT_ERROR));
#if GTK_CHECK_VERSION(2, 14, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_DETAILS"), s7_make_integer(sc, GTK_CALENDAR_SHOW_DETAILS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GTK_GRAB"), s7_make_integer(sc, GDK_CROSSING_GTK_GRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GTK_UNGRAB"), s7_make_integer(sc, GDK_CROSSING_GTK_UNGRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_STATE_CHANGED"), s7_make_integer(sc, GDK_CROSSING_STATE_CHANGED));
#endif

#if GTK_CHECK_VERSION(2, 16, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_ICON_PRIMARY"), s7_make_integer(sc, GTK_ENTRY_ICON_PRIMARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_ICON_SECONDARY"), s7_make_integer(sc, GTK_ENTRY_ICON_SECONDARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BLANK_CURSOR "), s7_make_integer(sc, GDK_BLANK_CURSOR ));
#endif

#if GTK_CHECK_VERSION(2, 18, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_THIN"), s7_make_integer(sc, PANGO_WEIGHT_THIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_BOOK"), s7_make_integer(sc, PANGO_WEIGHT_BOOK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_MEDIUM"), s7_make_integer(sc, PANGO_WEIGHT_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_OFFSCREEN"), s7_make_integer(sc, GDK_WINDOW_OFFSCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_BUFFER_MAX_SIZE"), s7_make_integer(sc, GTK_ENTRY_BUFFER_MAX_SIZE));
#endif

#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_VoidSymbol"), s7_make_integer(sc, GDK_KEY_VoidSymbol));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_BackSpace"), s7_make_integer(sc, GDK_KEY_BackSpace));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Tab"), s7_make_integer(sc, GDK_KEY_Tab));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Linefeed"), s7_make_integer(sc, GDK_KEY_Linefeed));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Clear"), s7_make_integer(sc, GDK_KEY_Clear));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Return"), s7_make_integer(sc, GDK_KEY_Return));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Pause"), s7_make_integer(sc, GDK_KEY_Pause));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Scroll_Lock"), s7_make_integer(sc, GDK_KEY_Scroll_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Sys_Req"), s7_make_integer(sc, GDK_KEY_Sys_Req));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Escape"), s7_make_integer(sc, GDK_KEY_Escape));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Delete"), s7_make_integer(sc, GDK_KEY_Delete));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Home"), s7_make_integer(sc, GDK_KEY_Home));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Left"), s7_make_integer(sc, GDK_KEY_Left));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Up"), s7_make_integer(sc, GDK_KEY_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Right"), s7_make_integer(sc, GDK_KEY_Right));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Down"), s7_make_integer(sc, GDK_KEY_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Prior"), s7_make_integer(sc, GDK_KEY_Prior));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Page_Up"), s7_make_integer(sc, GDK_KEY_Page_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Next"), s7_make_integer(sc, GDK_KEY_Next));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Page_Down"), s7_make_integer(sc, GDK_KEY_Page_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_End"), s7_make_integer(sc, GDK_KEY_End));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Begin"), s7_make_integer(sc, GDK_KEY_Begin));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Select"), s7_make_integer(sc, GDK_KEY_Select));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Print"), s7_make_integer(sc, GDK_KEY_Print));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Execute"), s7_make_integer(sc, GDK_KEY_Execute));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Insert"), s7_make_integer(sc, GDK_KEY_Insert));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Undo"), s7_make_integer(sc, GDK_KEY_Undo));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Redo"), s7_make_integer(sc, GDK_KEY_Redo));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Menu"), s7_make_integer(sc, GDK_KEY_Menu));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Find"), s7_make_integer(sc, GDK_KEY_Find));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Cancel"), s7_make_integer(sc, GDK_KEY_Cancel));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Help"), s7_make_integer(sc, GDK_KEY_Help));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Break"), s7_make_integer(sc, GDK_KEY_Break));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Mode_switch"), s7_make_integer(sc, GDK_KEY_Mode_switch));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_script_switch"), s7_make_integer(sc, GDK_KEY_script_switch));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Num_Lock"), s7_make_integer(sc, GDK_KEY_Num_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Space"), s7_make_integer(sc, GDK_KEY_KP_Space));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Tab"), s7_make_integer(sc, GDK_KEY_KP_Tab));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Enter"), s7_make_integer(sc, GDK_KEY_KP_Enter));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F1"), s7_make_integer(sc, GDK_KEY_KP_F1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F2"), s7_make_integer(sc, GDK_KEY_KP_F2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F3"), s7_make_integer(sc, GDK_KEY_KP_F3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F4"), s7_make_integer(sc, GDK_KEY_KP_F4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Home"), s7_make_integer(sc, GDK_KEY_KP_Home));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Left"), s7_make_integer(sc, GDK_KEY_KP_Left));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Up"), s7_make_integer(sc, GDK_KEY_KP_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Right"), s7_make_integer(sc, GDK_KEY_KP_Right));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Down"), s7_make_integer(sc, GDK_KEY_KP_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Prior"), s7_make_integer(sc, GDK_KEY_KP_Prior));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Page_Up"), s7_make_integer(sc, GDK_KEY_KP_Page_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Next"), s7_make_integer(sc, GDK_KEY_KP_Next));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Page_Down"), s7_make_integer(sc, GDK_KEY_KP_Page_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_End"), s7_make_integer(sc, GDK_KEY_KP_End));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Begin"), s7_make_integer(sc, GDK_KEY_KP_Begin));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Insert"), s7_make_integer(sc, GDK_KEY_KP_Insert));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Delete"), s7_make_integer(sc, GDK_KEY_KP_Delete));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Equal"), s7_make_integer(sc, GDK_KEY_KP_Equal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Multiply"), s7_make_integer(sc, GDK_KEY_KP_Multiply));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Add"), s7_make_integer(sc, GDK_KEY_KP_Add));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Separator"), s7_make_integer(sc, GDK_KEY_KP_Separator));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Subtract"), s7_make_integer(sc, GDK_KEY_KP_Subtract));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Decimal"), s7_make_integer(sc, GDK_KEY_KP_Decimal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Divide"), s7_make_integer(sc, GDK_KEY_KP_Divide));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_0"), s7_make_integer(sc, GDK_KEY_KP_0));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_1"), s7_make_integer(sc, GDK_KEY_KP_1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_2"), s7_make_integer(sc, GDK_KEY_KP_2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_3"), s7_make_integer(sc, GDK_KEY_KP_3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_4"), s7_make_integer(sc, GDK_KEY_KP_4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_5"), s7_make_integer(sc, GDK_KEY_KP_5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_6"), s7_make_integer(sc, GDK_KEY_KP_6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_7"), s7_make_integer(sc, GDK_KEY_KP_7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_8"), s7_make_integer(sc, GDK_KEY_KP_8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_9"), s7_make_integer(sc, GDK_KEY_KP_9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F1"), s7_make_integer(sc, GDK_KEY_F1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F2"), s7_make_integer(sc, GDK_KEY_F2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F3"), s7_make_integer(sc, GDK_KEY_F3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F4"), s7_make_integer(sc, GDK_KEY_F4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F5"), s7_make_integer(sc, GDK_KEY_F5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F6"), s7_make_integer(sc, GDK_KEY_F6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F7"), s7_make_integer(sc, GDK_KEY_F7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F8"), s7_make_integer(sc, GDK_KEY_F8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F9"), s7_make_integer(sc, GDK_KEY_F9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F10"), s7_make_integer(sc, GDK_KEY_F10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F11"), s7_make_integer(sc, GDK_KEY_F11));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L1"), s7_make_integer(sc, GDK_KEY_L1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F12"), s7_make_integer(sc, GDK_KEY_F12));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L2"), s7_make_integer(sc, GDK_KEY_L2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F13"), s7_make_integer(sc, GDK_KEY_F13));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L3"), s7_make_integer(sc, GDK_KEY_L3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F14"), s7_make_integer(sc, GDK_KEY_F14));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L4"), s7_make_integer(sc, GDK_KEY_L4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F15"), s7_make_integer(sc, GDK_KEY_F15));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L5"), s7_make_integer(sc, GDK_KEY_L5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F16"), s7_make_integer(sc, GDK_KEY_F16));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L6"), s7_make_integer(sc, GDK_KEY_L6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F17"), s7_make_integer(sc, GDK_KEY_F17));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L7"), s7_make_integer(sc, GDK_KEY_L7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F18"), s7_make_integer(sc, GDK_KEY_F18));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L8"), s7_make_integer(sc, GDK_KEY_L8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F19"), s7_make_integer(sc, GDK_KEY_F19));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L9"), s7_make_integer(sc, GDK_KEY_L9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F20"), s7_make_integer(sc, GDK_KEY_F20));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L10"), s7_make_integer(sc, GDK_KEY_L10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F21"), s7_make_integer(sc, GDK_KEY_F21));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R1"), s7_make_integer(sc, GDK_KEY_R1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F22"), s7_make_integer(sc, GDK_KEY_F22));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R2"), s7_make_integer(sc, GDK_KEY_R2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F23"), s7_make_integer(sc, GDK_KEY_F23));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R3"), s7_make_integer(sc, GDK_KEY_R3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F24"), s7_make_integer(sc, GDK_KEY_F24));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R4"), s7_make_integer(sc, GDK_KEY_R4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F25"), s7_make_integer(sc, GDK_KEY_F25));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R5"), s7_make_integer(sc, GDK_KEY_R5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F26"), s7_make_integer(sc, GDK_KEY_F26));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R6"), s7_make_integer(sc, GDK_KEY_R6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F27"), s7_make_integer(sc, GDK_KEY_F27));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R7"), s7_make_integer(sc, GDK_KEY_R7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F28"), s7_make_integer(sc, GDK_KEY_F28));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R8"), s7_make_integer(sc, GDK_KEY_R8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F29"), s7_make_integer(sc, GDK_KEY_F29));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R9"), s7_make_integer(sc, GDK_KEY_R9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F30"), s7_make_integer(sc, GDK_KEY_F30));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R10"), s7_make_integer(sc, GDK_KEY_R10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F31"), s7_make_integer(sc, GDK_KEY_F31));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R11"), s7_make_integer(sc, GDK_KEY_R11));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F32"), s7_make_integer(sc, GDK_KEY_F32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R12"), s7_make_integer(sc, GDK_KEY_R12));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F33"), s7_make_integer(sc, GDK_KEY_F33));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R13"), s7_make_integer(sc, GDK_KEY_R13));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F34"), s7_make_integer(sc, GDK_KEY_F34));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R14"), s7_make_integer(sc, GDK_KEY_R14));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F35"), s7_make_integer(sc, GDK_KEY_F35));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R15"), s7_make_integer(sc, GDK_KEY_R15));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_L"), s7_make_integer(sc, GDK_KEY_Shift_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_R"), s7_make_integer(sc, GDK_KEY_Shift_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Control_L"), s7_make_integer(sc, GDK_KEY_Control_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Control_R"), s7_make_integer(sc, GDK_KEY_Control_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Caps_Lock"), s7_make_integer(sc, GDK_KEY_Caps_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_Lock"), s7_make_integer(sc, GDK_KEY_Shift_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Meta_L"), s7_make_integer(sc, GDK_KEY_Meta_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Meta_R"), s7_make_integer(sc, GDK_KEY_Meta_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Alt_L"), s7_make_integer(sc, GDK_KEY_Alt_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Alt_R"), s7_make_integer(sc, GDK_KEY_Alt_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_space"), s7_make_integer(sc, GDK_KEY_space));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_exclam"), s7_make_integer(sc, GDK_KEY_exclam));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quotedbl"), s7_make_integer(sc, GDK_KEY_quotedbl));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_numbersign"), s7_make_integer(sc, GDK_KEY_numbersign));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_dollar"), s7_make_integer(sc, GDK_KEY_dollar));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_percent"), s7_make_integer(sc, GDK_KEY_percent));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_ampersand"), s7_make_integer(sc, GDK_KEY_ampersand));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_apostrophe"), s7_make_integer(sc, GDK_KEY_apostrophe));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quoteright"), s7_make_integer(sc, GDK_KEY_quoteright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_parenleft"), s7_make_integer(sc, GDK_KEY_parenleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_parenright"), s7_make_integer(sc, GDK_KEY_parenright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asterisk"), s7_make_integer(sc, GDK_KEY_asterisk));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_plus"), s7_make_integer(sc, GDK_KEY_plus));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_comma"), s7_make_integer(sc, GDK_KEY_comma));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_minus"), s7_make_integer(sc, GDK_KEY_minus));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_period"), s7_make_integer(sc, GDK_KEY_period));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_slash"), s7_make_integer(sc, GDK_KEY_slash));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_0"), s7_make_integer(sc, GDK_KEY_0));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_1"), s7_make_integer(sc, GDK_KEY_1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_2"), s7_make_integer(sc, GDK_KEY_2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_3"), s7_make_integer(sc, GDK_KEY_3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_4"), s7_make_integer(sc, GDK_KEY_4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_5"), s7_make_integer(sc, GDK_KEY_5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_6"), s7_make_integer(sc, GDK_KEY_6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_7"), s7_make_integer(sc, GDK_KEY_7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_8"), s7_make_integer(sc, GDK_KEY_8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_9"), s7_make_integer(sc, GDK_KEY_9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_colon"), s7_make_integer(sc, GDK_KEY_colon));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_semicolon"), s7_make_integer(sc, GDK_KEY_semicolon));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_less"), s7_make_integer(sc, GDK_KEY_less));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_equal"), s7_make_integer(sc, GDK_KEY_equal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_greater"), s7_make_integer(sc, GDK_KEY_greater));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_question"), s7_make_integer(sc, GDK_KEY_question));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_at"), s7_make_integer(sc, GDK_KEY_at));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_A"), s7_make_integer(sc, GDK_KEY_A));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_B"), s7_make_integer(sc, GDK_KEY_B));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_C"), s7_make_integer(sc, GDK_KEY_C));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_D"), s7_make_integer(sc, GDK_KEY_D));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_E"), s7_make_integer(sc, GDK_KEY_E));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F"), s7_make_integer(sc, GDK_KEY_F));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_G"), s7_make_integer(sc, GDK_KEY_G));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_H"), s7_make_integer(sc, GDK_KEY_H));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_I"), s7_make_integer(sc, GDK_KEY_I));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_J"), s7_make_integer(sc, GDK_KEY_J));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_K"), s7_make_integer(sc, GDK_KEY_K));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L"), s7_make_integer(sc, GDK_KEY_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_M"), s7_make_integer(sc, GDK_KEY_M));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_N"), s7_make_integer(sc, GDK_KEY_N));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_O"), s7_make_integer(sc, GDK_KEY_O));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_P"), s7_make_integer(sc, GDK_KEY_P));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Q"), s7_make_integer(sc, GDK_KEY_Q));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R"), s7_make_integer(sc, GDK_KEY_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_S"), s7_make_integer(sc, GDK_KEY_S));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_T"), s7_make_integer(sc, GDK_KEY_T));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_U"), s7_make_integer(sc, GDK_KEY_U));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_V"), s7_make_integer(sc, GDK_KEY_V));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_W"), s7_make_integer(sc, GDK_KEY_W));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_X"), s7_make_integer(sc, GDK_KEY_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Y"), s7_make_integer(sc, GDK_KEY_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Z"), s7_make_integer(sc, GDK_KEY_Z));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bracketleft"), s7_make_integer(sc, GDK_KEY_bracketleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_backslash"), s7_make_integer(sc, GDK_KEY_backslash));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bracketright"), s7_make_integer(sc, GDK_KEY_bracketright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asciicircum"), s7_make_integer(sc, GDK_KEY_asciicircum));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_underscore"), s7_make_integer(sc, GDK_KEY_underscore));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_grave"), s7_make_integer(sc, GDK_KEY_grave));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quoteleft"), s7_make_integer(sc, GDK_KEY_quoteleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_a"), s7_make_integer(sc, GDK_KEY_a));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_b"), s7_make_integer(sc, GDK_KEY_b));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_c"), s7_make_integer(sc, GDK_KEY_c));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_d"), s7_make_integer(sc, GDK_KEY_d));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_e"), s7_make_integer(sc, GDK_KEY_e));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_f"), s7_make_integer(sc, GDK_KEY_f));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_g"), s7_make_integer(sc, GDK_KEY_g));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_h"), s7_make_integer(sc, GDK_KEY_h));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_i"), s7_make_integer(sc, GDK_KEY_i));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_j"), s7_make_integer(sc, GDK_KEY_j));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_k"), s7_make_integer(sc, GDK_KEY_k));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_l"), s7_make_integer(sc, GDK_KEY_l));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_m"), s7_make_integer(sc, GDK_KEY_m));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_n"), s7_make_integer(sc, GDK_KEY_n));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_o"), s7_make_integer(sc, GDK_KEY_o));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_p"), s7_make_integer(sc, GDK_KEY_p));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_q"), s7_make_integer(sc, GDK_KEY_q));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_r"), s7_make_integer(sc, GDK_KEY_r));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_s"), s7_make_integer(sc, GDK_KEY_s));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_t"), s7_make_integer(sc, GDK_KEY_t));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_u"), s7_make_integer(sc, GDK_KEY_u));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_v"), s7_make_integer(sc, GDK_KEY_v));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_w"), s7_make_integer(sc, GDK_KEY_w));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_x"), s7_make_integer(sc, GDK_KEY_x));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_y"), s7_make_integer(sc, GDK_KEY_y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_z"), s7_make_integer(sc, GDK_KEY_z));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_braceleft"), s7_make_integer(sc, GDK_KEY_braceleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bar"), s7_make_integer(sc, GDK_KEY_bar));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_braceright"), s7_make_integer(sc, GDK_KEY_braceright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asciitilde"), s7_make_integer(sc, GDK_KEY_asciitilde));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH"), s7_make_integer(sc, GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT"), s7_make_integer(sc, GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CUSTOM"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CUSTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_CASE_INSENSITIVE"), s7_make_integer(sc, GTK_TEXT_SEARCH_CASE_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_MINIMUM"), s7_make_integer(sc, GTK_SCROLL_MINIMUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_NATURAL"), s7_make_integer(sc, GTK_SCROLL_NATURAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TARGET_SAME_APP"), s7_make_integer(sc, GTK_TARGET_SAME_APP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TARGET_SAME_WIDGET"), s7_make_integer(sc, GTK_TARGET_SAME_WIDGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TARGET_OTHER_APP"), s7_make_integer(sc, GTK_TARGET_OTHER_APP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TARGET_OTHER_WIDGET"), s7_make_integer(sc, GTK_TARGET_OTHER_WIDGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_FILL"), s7_make_integer(sc, GTK_ALIGN_FILL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_START"), s7_make_integer(sc, GTK_ALIGN_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_END"), s7_make_integer(sc, GTK_ALIGN_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_CENTER"), s7_make_integer(sc, GTK_ALIGN_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOL_PALETTE_DRAG_ITEMS"), s7_make_integer(sc, GTK_TOOL_PALETTE_DRAG_ITEMS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TOOL_PALETTE_DRAG_GROUPS"), s7_make_integer(sc, GTK_TOOL_PALETTE_DRAG_GROUPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_GICON"), s7_make_integer(sc, GTK_IMAGE_GICON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_NONEXISTENT"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_NONEXISTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_BAD_FILENAME"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_BAD_FILENAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_FORCE_SIZE"), s7_make_integer(sc, GTK_ICON_LOOKUP_FORCE_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_THEME_NOT_FOUND"), s7_make_integer(sc, GTK_ICON_THEME_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_THEME_FAILED"), s7_make_integer(sc, GTK_ICON_THEME_FAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_NORMAL"), s7_make_integer(sc, GTK_STATE_FLAG_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_ACTIVE"), s7_make_integer(sc, GTK_STATE_FLAG_ACTIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_PRELIGHT"), s7_make_integer(sc, GTK_STATE_FLAG_PRELIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_SELECTED"), s7_make_integer(sc, GTK_STATE_FLAG_SELECTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_INSENSITIVE"), s7_make_integer(sc, GTK_STATE_FLAG_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_INCONSISTENT"), s7_make_integer(sc, GTK_STATE_FLAG_INCONSISTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_FOCUSED"), s7_make_integer(sc, GTK_STATE_FLAG_FOCUSED));
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_CONSTANT_SIZE"), s7_make_integer(sc, GTK_SIZE_REQUEST_CONSTANT_SIZE));
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR"), s7_make_integer(sc, GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_CONTEXT_MENU"), s7_make_integer(sc, GDK_MODIFIER_INTENT_CONTEXT_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_EXTEND_SELECTION"), s7_make_integer(sc, GDK_MODIFIER_INTENT_EXTEND_SELECTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_MODIFY_SELECTION"), s7_make_integer(sc, GDK_MODIFIER_INTENT_MODIFY_SELECTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_NO_TEXT_INPUT"), s7_make_integer(sc, GDK_MODIFIER_INTENT_NO_TEXT_INPUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_SHIFT_GROUP"), s7_make_integer(sc, GDK_MODIFIER_INTENT_SHIFT_GROUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REGION_ONLY"), s7_make_integer(sc, GTK_REGION_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_FOCUSED"), s7_make_integer(sc, GDK_WINDOW_STATE_FOCUSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_EXPANDABLE"), s7_make_integer(sc, GTK_CELL_RENDERER_EXPANDABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_EXPANDED"), s7_make_integer(sc, GTK_CELL_RENDERER_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_BACKDROP"), s7_make_integer(sc, GTK_STATE_FLAG_BACKDROP));
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_BEGIN"), s7_make_integer(sc, GDK_TOUCH_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_UPDATE"), s7_make_integer(sc, GDK_TOUCH_UPDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_END"), s7_make_integer(sc, GDK_TOUCH_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_CANCEL"), s7_make_integer(sc, GDK_TOUCH_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_SMOOTH"), s7_make_integer(sc, GDK_SCROLL_SMOOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_TOUCH_BEGIN"), s7_make_integer(sc, GDK_CROSSING_TOUCH_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_TOUCH_END"), s7_make_integer(sc, GDK_CROSSING_TOUCH_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_DEVICE_SWITCH"), s7_make_integer(sc, GDK_CROSSING_DEVICE_SWITCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_MASK"), s7_make_integer(sc, GDK_TOUCH_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SMOOTH_SCROLL_MASK"), s7_make_integer(sc, GDK_SMOOTH_SCROLL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_MODE_CONTINUOUS"), s7_make_integer(sc, GTK_LEVEL_BAR_MODE_CONTINUOUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_MODE_DISCRETE"), s7_make_integer(sc, GTK_LEVEL_BAR_MODE_DISCRETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_FREE_FORM"), s7_make_integer(sc, GTK_INPUT_PURPOSE_FREE_FORM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_ALPHA"), s7_make_integer(sc, GTK_INPUT_PURPOSE_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_DIGITS"), s7_make_integer(sc, GTK_INPUT_PURPOSE_DIGITS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_NUMBER"), s7_make_integer(sc, GTK_INPUT_PURPOSE_NUMBER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PHONE"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PHONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_URL"), s7_make_integer(sc, GTK_INPUT_PURPOSE_URL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_EMAIL"), s7_make_integer(sc, GTK_INPUT_PURPOSE_EMAIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_NAME"), s7_make_integer(sc, GTK_INPUT_PURPOSE_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PASSWORD"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PASSWORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PIN"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_NONE"), s7_make_integer(sc, GTK_INPUT_HINT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_SPELLCHECK"), s7_make_integer(sc, GTK_INPUT_HINT_SPELLCHECK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_NO_SPELLCHECK"), s7_make_integer(sc, GTK_INPUT_HINT_NO_SPELLCHECK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_WORD_COMPLETION"), s7_make_integer(sc, GTK_INPUT_HINT_WORD_COMPLETION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_LOWERCASE"), s7_make_integer(sc, GTK_INPUT_HINT_LOWERCASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_CHARS"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_WORDS"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_SENTENCES"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_SENTENCES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_INHIBIT_OSK"), s7_make_integer(sc, GTK_INPUT_HINT_INHIBIT_OSK));
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DIR_LTR"), s7_make_integer(sc, GTK_STATE_FLAG_DIR_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DIR_RTL"), s7_make_integer(sc, GTK_STATE_FLAG_DIR_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FULLSCREEN_ON_CURRENT_MONITOR"), s7_make_integer(sc, GDK_FULLSCREEN_ON_CURRENT_MONITOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FULLSCREEN_ON_ALL_MONITORS"), s7_make_integer(sc, GDK_FULLSCREEN_ON_ALL_MONITORS));
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_BASELINE"), s7_make_integer(sc, GTK_ALIGN_BASELINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_TOP"), s7_make_integer(sc, GTK_BASELINE_POSITION_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_CENTER"), s7_make_integer(sc, GTK_BASELINE_POSITION_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_BOTTOM"), s7_make_integer(sc, GTK_BASELINE_POSITION_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NORMAL"), s7_make_integer(sc, GTK_PLACES_OPEN_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NEW_TAB"), s7_make_integer(sc, GTK_PLACES_OPEN_NEW_TAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NEW_WINDOW"), s7_make_integer(sc, GTK_PLACES_OPEN_NEW_WINDOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_NONE"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_CROSSFADE"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_CROSSFADE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_NONE"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_CROSSFADE"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_STATE_TILED"), s7_make_integer(sc, GDK_WINDOW_STATE_TILED));
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN));
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_NONE"), s7_make_integer(sc, GTK_PHASE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_CAPTURE"), s7_make_integer(sc, GTK_PHASE_CAPTURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_BUBBLE"), s7_make_integer(sc, GTK_PHASE_BUBBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_TARGET"), s7_make_integer(sc, GTK_PHASE_TARGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_VIEW_LAYER_BELOW"), s7_make_integer(sc, GTK_TEXT_VIEW_LAYER_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_VIEW_LAYER_ABOVE"), s7_make_integer(sc, GTK_TEXT_VIEW_LAYER_ABOVE));
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_EXTERNAL"), s7_make_integer(sc, GTK_POLICY_EXTERNAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_SEMILIGHT"), s7_make_integer(sc, PANGO_WEIGHT_SEMILIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_EXTEND_SELECTION_WORD"), s7_make_integer(sc, GTK_TEXT_EXTEND_SELECTION_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_EXTEND_SELECTION_LINE"), s7_make_integer(sc, GTK_TEXT_EXTEND_SELECTION_LINE));
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_SWIPE"), s7_make_integer(sc, GDK_TOUCHPAD_SWIPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_PINCH"), s7_make_integer(sc, GDK_TOUCHPAD_PINCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_BEGIN"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_UPDATE"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_UPDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_END"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_CANCEL"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_MASK"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK"), s7_make_integer(sc, GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK));
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_ACCELERATOR"), s7_make_integer(sc, GTK_SHORTCUT_ACCELERATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_PINCH"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_PINCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_STRETCH"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POPOVER_CONSTRAINT_NONE"), s7_make_integer(sc, GTK_POPOVER_CONSTRAINT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POPOVER_CONSTRAINT_WINDOW"), s7_make_integer(sc, GTK_POPOVER_CONSTRAINT_WINDOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_SPLASHSCREEN"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_SPLASHSCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_UTILITY"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_UTILITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_DOCK"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_DOCK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_DESKTOP"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_DESKTOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_POPUP_MENU"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_POPUP_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_TOOLTIP"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_TOOLTIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_NOTIFICATION"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_NOTIFICATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_COMBO"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_COMBO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_WINDOW_TYPE_HINT_DND"), s7_make_integer(sc, GDK_WINDOW_TYPE_HINT_DND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_NONE"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_POINTER"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_POINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_TOUCH"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_TOUCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_TABLET_STYLUS"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_TABLET_STYLUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_KEYBOARD"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_KEYBOARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_ALL_POINTING"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_ALL_POINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_ALL"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DROP_ACTIVE"), s7_make_integer(sc, GTK_STATE_FLAG_DROP_ACTIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_NO_TARGET"), s7_make_integer(sc, GDK_DRAG_CANCEL_NO_TARGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_USER_CANCELLED"), s7_make_integer(sc, GDK_DRAG_CANCEL_USER_CANCELLED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_ERROR"), s7_make_integer(sc, GDK_DRAG_CANCEL_ERROR));
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_IGNORE"), s7_make_integer(sc, GDK_AXIS_IGNORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_X"), s7_make_integer(sc, GDK_AXIS_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_Y"), s7_make_integer(sc, GDK_AXIS_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_PRESSURE"), s7_make_integer(sc, GDK_AXIS_PRESSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_XTILT"), s7_make_integer(sc, GDK_AXIS_XTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_YTILT"), s7_make_integer(sc, GDK_AXIS_YTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_WHEEL"), s7_make_integer(sc, GDK_AXIS_WHEEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_LAST"), s7_make_integer(sc, GDK_AXIS_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_X"), s7_make_integer(sc, GDK_AXIS_FLAG_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_Y"), s7_make_integer(sc, GDK_AXIS_FLAG_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_PRESSURE"), s7_make_integer(sc, GDK_AXIS_FLAG_PRESSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_XTILT"), s7_make_integer(sc, GDK_AXIS_FLAG_XTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_YTILT"), s7_make_integer(sc, GDK_AXIS_FLAG_YTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_WHEEL"), s7_make_integer(sc, GDK_AXIS_FLAG_WHEEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_DISTANCE"), s7_make_integer(sc, GDK_AXIS_FLAG_DISTANCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_ROTATION"), s7_make_integer(sc, GDK_AXIS_FLAG_ROTATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_SLIDER"), s7_make_integer(sc, GDK_AXIS_FLAG_SLIDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_UNKNOWN"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_PEN"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_PEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_ERASER"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_ERASER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_BRUSH"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_BRUSH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_PENCIL"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_PENCIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_AIRBRUSH"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_AIRBRUSH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_MOUSE"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_MOUSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_LENS"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_LENS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_UNKNOWN"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_NONE"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_BUTTON"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_BUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_RING"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_STRIP"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_STRIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_BUTTON_PRESS"), s7_make_integer(sc, GDK_PAD_BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_BUTTON_RELEASE"), s7_make_integer(sc, GDK_PAD_BUTTON_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_RING"), s7_make_integer(sc, GDK_PAD_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_STRIP"), s7_make_integer(sc, GDK_PAD_STRIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_GROUP_MODE"), s7_make_integer(sc, GDK_PAD_GROUP_MODE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TABLET_PAD_MASK"), s7_make_integer(sc, GDK_TABLET_PAD_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP_X"), s7_make_integer(sc, GDK_ANCHOR_FLIP_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP_Y"), s7_make_integer(sc, GDK_ANCHOR_FLIP_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE_X"), s7_make_integer(sc, GDK_ANCHOR_SLIDE_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE_Y"), s7_make_integer(sc, GDK_ANCHOR_SLIDE_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE_X"), s7_make_integer(sc, GDK_ANCHOR_RESIZE_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE_Y"), s7_make_integer(sc, GDK_ANCHOR_RESIZE_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP"), s7_make_integer(sc, GDK_ANCHOR_FLIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE"), s7_make_integer(sc, GDK_ANCHOR_SLIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE"), s7_make_integer(sc, GDK_ANCHOR_RESIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_BUTTON"), s7_make_integer(sc, GTK_PAD_ACTION_BUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_RING"), s7_make_integer(sc, GTK_PAD_ACTION_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_STRIP"), s7_make_integer(sc, GTK_PAD_ACTION_STRIP));
#endif

#if GTK_CHECK_VERSION(3, 99, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_SWIPE_LEFT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_SWIPE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_SWIPE_RIGHT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_SWIPE_RIGHT));
#endif

  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SUCCESS"), s7_make_integer(sc, CAIRO_STATUS_SUCCESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NO_MEMORY"), s7_make_integer(sc, CAIRO_STATUS_NO_MEMORY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_RESTORE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_RESTORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_POP_GROUP"), s7_make_integer(sc, CAIRO_STATUS_INVALID_POP_GROUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NO_CURRENT_POINT"), s7_make_integer(sc, CAIRO_STATUS_NO_CURRENT_POINT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_MATRIX"), s7_make_integer(sc, CAIRO_STATUS_INVALID_MATRIX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STATUS"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STATUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NULL_POINTER"), s7_make_integer(sc, CAIRO_STATUS_NULL_POINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STRING"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STRING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_PATH_DATA"), s7_make_integer(sc, CAIRO_STATUS_INVALID_PATH_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_READ_ERROR"), s7_make_integer(sc, CAIRO_STATUS_READ_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_WRITE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_WRITE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SURFACE_FINISHED"), s7_make_integer(sc, CAIRO_STATUS_SURFACE_FINISHED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SURFACE_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_SURFACE_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_PATTERN_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_PATTERN_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_CONTENT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_CONTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_FORMAT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_VISUAL"), s7_make_integer(sc, CAIRO_STATUS_INVALID_VISUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_FILE_NOT_FOUND"), s7_make_integer(sc, CAIRO_STATUS_FILE_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_DASH"), s7_make_integer(sc, CAIRO_STATUS_INVALID_DASH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_DSC_COMMENT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_DSC_COMMENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_INDEX"), s7_make_integer(sc, CAIRO_STATUS_INVALID_INDEX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_CLIP_NOT_REPRESENTABLE"), s7_make_integer(sc, CAIRO_STATUS_CLIP_NOT_REPRESENTABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_TEMP_FILE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_TEMP_FILE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STRIDE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STRIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_COLOR"), s7_make_integer(sc, CAIRO_CONTENT_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_ALPHA"), s7_make_integer(sc, CAIRO_CONTENT_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_COLOR_ALPHA"), s7_make_integer(sc, CAIRO_CONTENT_COLOR_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_CLEAR"), s7_make_integer(sc, CAIRO_OPERATOR_CLEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SOURCE"), s7_make_integer(sc, CAIRO_OPERATOR_SOURCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OVER"), s7_make_integer(sc, CAIRO_OPERATOR_OVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_IN"), s7_make_integer(sc, CAIRO_OPERATOR_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OUT"), s7_make_integer(sc, CAIRO_OPERATOR_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_ATOP"), s7_make_integer(sc, CAIRO_OPERATOR_ATOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST"), s7_make_integer(sc, CAIRO_OPERATOR_DEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_OVER"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_OVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_IN"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_OUT"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_ATOP"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_ATOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_XOR"), s7_make_integer(sc, CAIRO_OPERATOR_XOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_ADD"), s7_make_integer(sc, CAIRO_OPERATOR_ADD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SATURATE"), s7_make_integer(sc, CAIRO_OPERATOR_SATURATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_DEFAULT"), s7_make_integer(sc, CAIRO_ANTIALIAS_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_NONE"), s7_make_integer(sc, CAIRO_ANTIALIAS_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_GRAY"), s7_make_integer(sc, CAIRO_ANTIALIAS_GRAY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_SUBPIXEL"), s7_make_integer(sc, CAIRO_ANTIALIAS_SUBPIXEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILL_RULE_WINDING"), s7_make_integer(sc, CAIRO_FILL_RULE_WINDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILL_RULE_EVEN_ODD"), s7_make_integer(sc, CAIRO_FILL_RULE_EVEN_ODD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_BUTT"), s7_make_integer(sc, CAIRO_LINE_CAP_BUTT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_ROUND"), s7_make_integer(sc, CAIRO_LINE_CAP_ROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_SQUARE"), s7_make_integer(sc, CAIRO_LINE_CAP_SQUARE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_MITER"), s7_make_integer(sc, CAIRO_LINE_JOIN_MITER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_ROUND"), s7_make_integer(sc, CAIRO_LINE_JOIN_ROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_BEVEL"), s7_make_integer(sc, CAIRO_LINE_JOIN_BEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_NORMAL"), s7_make_integer(sc, CAIRO_FONT_SLANT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_ITALIC"), s7_make_integer(sc, CAIRO_FONT_SLANT_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_OBLIQUE"), s7_make_integer(sc, CAIRO_FONT_SLANT_OBLIQUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_WEIGHT_NORMAL"), s7_make_integer(sc, CAIRO_FONT_WEIGHT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_WEIGHT_BOLD"), s7_make_integer(sc, CAIRO_FONT_WEIGHT_BOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_DEFAULT"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_RGB"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_BGR"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_VRGB"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_VRGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_VBGR"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_VBGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_DEFAULT"), s7_make_integer(sc, CAIRO_HINT_STYLE_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_NONE"), s7_make_integer(sc, CAIRO_HINT_STYLE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_SLIGHT"), s7_make_integer(sc, CAIRO_HINT_STYLE_SLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_MEDIUM"), s7_make_integer(sc, CAIRO_HINT_STYLE_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_FULL"), s7_make_integer(sc, CAIRO_HINT_STYLE_FULL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_DEFAULT"), s7_make_integer(sc, CAIRO_HINT_METRICS_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_OFF"), s7_make_integer(sc, CAIRO_HINT_METRICS_OFF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_ON"), s7_make_integer(sc, CAIRO_HINT_METRICS_ON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_TOY"), s7_make_integer(sc, CAIRO_FONT_TYPE_TOY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_FT"), s7_make_integer(sc, CAIRO_FONT_TYPE_FT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_WIN32"), s7_make_integer(sc, CAIRO_FONT_TYPE_WIN32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_QUARTZ"), s7_make_integer(sc, CAIRO_FONT_TYPE_QUARTZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_MOVE_TO"), s7_make_integer(sc, CAIRO_PATH_MOVE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_LINE_TO"), s7_make_integer(sc, CAIRO_PATH_LINE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_CURVE_TO"), s7_make_integer(sc, CAIRO_PATH_CURVE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_CLOSE_PATH"), s7_make_integer(sc, CAIRO_PATH_CLOSE_PATH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_IMAGE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_PDF"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_PDF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_PS"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_PS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XLIB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XLIB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XCB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XCB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_GLITZ"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_GLITZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QUARTZ"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QUARTZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_WIN32"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_WIN32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_BEOS"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_BEOS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_DIRECTFB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_DIRECTFB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SVG"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SVG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_OS2"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_OS2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_WIN32_PRINTING"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_WIN32_PRINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QUARTZ_IMAGE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QUARTZ_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_ARGB32"), s7_make_integer(sc, CAIRO_FORMAT_ARGB32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_RGB24"), s7_make_integer(sc, CAIRO_FORMAT_RGB24));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_A8"), s7_make_integer(sc, CAIRO_FORMAT_A8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_A1"), s7_make_integer(sc, CAIRO_FORMAT_A1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_SOLID"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_SOLID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_SURFACE"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_SURFACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_LINEAR"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_LINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_RADIAL"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_RADIAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_NONE"), s7_make_integer(sc, CAIRO_EXTEND_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_REPEAT"), s7_make_integer(sc, CAIRO_EXTEND_REPEAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_REFLECT"), s7_make_integer(sc, CAIRO_EXTEND_REFLECT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_PAD"), s7_make_integer(sc, CAIRO_EXTEND_PAD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_FAST"), s7_make_integer(sc, CAIRO_FILTER_FAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_GOOD"), s7_make_integer(sc, CAIRO_FILTER_GOOD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_BEST"), s7_make_integer(sc, CAIRO_FILTER_BEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_NEAREST"), s7_make_integer(sc, CAIRO_FILTER_NEAREST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_BILINEAR"), s7_make_integer(sc, CAIRO_FILTER_BILINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_GAUSSIAN"), s7_make_integer(sc, CAIRO_FILTER_GAUSSIAN));
#if HAVE_CAIRO_1_8
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_FONT_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_FONT_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_IMMUTABLE"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_IMMUTABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_ERROR"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NEGATIVE_COUNT"), s7_make_integer(sc, CAIRO_STATUS_NEGATIVE_COUNT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_CLUSTERS"), s7_make_integer(sc, CAIRO_STATUS_INVALID_CLUSTERS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_SLANT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_SLANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_WEIGHT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_WEIGHT));
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_SIZE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_DEVICE_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_DEVICE_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_DEVICE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_DEVICE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_MULTIPLY"), s7_make_integer(sc, CAIRO_OPERATOR_MULTIPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SCREEN"), s7_make_integer(sc, CAIRO_OPERATOR_SCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OVERLAY"), s7_make_integer(sc, CAIRO_OPERATOR_OVERLAY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DARKEN"), s7_make_integer(sc, CAIRO_OPERATOR_DARKEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_LIGHTEN"), s7_make_integer(sc, CAIRO_OPERATOR_LIGHTEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_COLOR_DODGE"), s7_make_integer(sc, CAIRO_OPERATOR_COLOR_DODGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_COLOR_BURN"), s7_make_integer(sc, CAIRO_OPERATOR_COLOR_BURN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HARD_LIGHT"), s7_make_integer(sc, CAIRO_OPERATOR_HARD_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SOFT_LIGHT"), s7_make_integer(sc, CAIRO_OPERATOR_SOFT_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DIFFERENCE"), s7_make_integer(sc, CAIRO_OPERATOR_DIFFERENCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_EXCLUSION"), s7_make_integer(sc, CAIRO_OPERATOR_EXCLUSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_HUE"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_HUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_SATURATION"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_SATURATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_COLOR"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_LUMINOSITY"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_LUMINOSITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SCRIPT"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SCRIPT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QT"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_RECORDING"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_RECORDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_VG"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_VG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_GL"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_GL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_DRM"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_DRM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_TEE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XML"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XML));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SKIA"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SKIA));
#endif

}

static void define_doubles(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_XX_SMALL"), s7_make_real(sc, PANGO_SCALE_XX_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_X_SMALL"), s7_make_real(sc, PANGO_SCALE_X_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_SMALL"), s7_make_real(sc, PANGO_SCALE_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_MEDIUM"), s7_make_real(sc, PANGO_SCALE_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_LARGE"), s7_make_real(sc, PANGO_SCALE_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_X_LARGE"), s7_make_real(sc, PANGO_SCALE_X_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_XX_LARGE"), s7_make_real(sc, PANGO_SCALE_XX_LARGE));
}


static void define_atoms(s7_scheme *sc)
{
  s7_pointer cur_env, gdkatom_symbol;
  cur_env = s7_curlet(sc);
  gdkatom_symbol = s7_make_symbol(sc, "GdkAtom");

  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_PRIMARY"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_PRIMARY, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_SECONDARY"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_SECONDARY, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_CLIPBOARD"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_CLIPBOARD, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TARGET_BITMAP"), s7_make_c_pointer_with_type(sc, GDK_TARGET_BITMAP, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TARGET_DRAWABLE"), s7_make_c_pointer_with_type(sc, GDK_TARGET_DRAWABLE, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TARGET_STRING"), s7_make_c_pointer_with_type(sc, GDK_TARGET_STRING, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_ATOM"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_ATOM, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_BITMAP"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_BITMAP, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_DRAWABLE"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_DRAWABLE, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_INTEGER"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_INTEGER, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_WINDOW"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_WINDOW, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SELECTION_TYPE_STRING"), s7_make_c_pointer_with_type(sc, GDK_SELECTION_TYPE_STRING, gdkatom_symbol, lg_false));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NONE"), s7_make_c_pointer_with_type(sc, GDK_NONE, gdkatom_symbol, lg_false));
}


static void define_symbols(s7_scheme *sc)
{
  GdkEventScroll__sym = s7_make_symbol(sc, "GdkEventScroll_");
  GtkScrollbar__sym = s7_make_symbol(sc, "GtkScrollbar_");
  GtkCenterBox__sym = s7_make_symbol(sc, "GtkCenterBox_");
  GtkCheckButton__sym = s7_make_symbol(sc, "GtkCheckButton_");
  GdkDrawContext__sym = s7_make_symbol(sc, "GdkDrawContext_");
  GtkDrawingAreaDrawFunc_sym = s7_make_symbol(sc, "GtkDrawingAreaDrawFunc");
  GtkShortcutLabel__sym = s7_make_symbol(sc, "GtkShortcutLabel_");
  GtkPadActionEntry__sym = s7_make_symbol(sc, "GtkPadActionEntry_");
  GActionGroup__sym = s7_make_symbol(sc, "GActionGroup_");
  GtkPadController__sym = s7_make_symbol(sc, "GtkPadController_");
  GdkDevicePad__sym = s7_make_symbol(sc, "GdkDevicePad_");
  GdkDrawingContext__sym = s7_make_symbol(sc, "GdkDrawingContext_");
  GdkMonitor__sym = s7_make_symbol(sc, "GdkMonitor_");
  GdkDeviceTool__sym = s7_make_symbol(sc, "GdkDeviceTool_");
  GdkSeatGrabPrepareFunc_sym = s7_make_symbol(sc, "GdkSeatGrabPrepareFunc");
  GtkShortcutsWindow__sym = s7_make_symbol(sc, "GtkShortcutsWindow_");
  GtkStackSidebar__sym = s7_make_symbol(sc, "GtkStackSidebar_");
  GtkSearchEntry__sym = s7_make_symbol(sc, "GtkSearchEntry_");
  GtkPopoverMenu__sym = s7_make_symbol(sc, "GtkPopoverMenu_");
  GtkStyleContext__sym = s7_make_symbol(sc, "GtkStyleContext_");
  GdkGLContext__sym = s7_make_symbol(sc, "GdkGLContext_");
  GtkGLArea__sym = s7_make_symbol(sc, "GtkGLArea_");
  GtkEventController__sym = s7_make_symbol(sc, "GtkEventController_");
  GtkGestureZoom__sym = s7_make_symbol(sc, "GtkGestureZoom_");
  GtkGestureSwipe__sym = s7_make_symbol(sc, "GtkGestureSwipe_");
  GtkGestureSingle__sym = s7_make_symbol(sc, "GtkGestureSingle_");
  GtkGestureRotate__sym = s7_make_symbol(sc, "GtkGestureRotate_");
  GtkGestureMultiPress__sym = s7_make_symbol(sc, "GtkGestureMultiPress_");
  GtkGesturePan__sym = s7_make_symbol(sc, "GtkGesturePan_");
  GtkGestureDrag__sym = s7_make_symbol(sc, "GtkGestureDrag_");
  GdkEventSequence__sym = s7_make_symbol(sc, "GdkEventSequence_");
  GtkGesture__sym = s7_make_symbol(sc, "GtkGesture_");
  GtkAllocation__sym = s7_make_symbol(sc, "GtkAllocation_");
  GtkPopover__sym = s7_make_symbol(sc, "GtkPopover_");
  GtkActionBar__sym = s7_make_symbol(sc, "GtkActionBar_");
  GtkFlowBox__sym = s7_make_symbol(sc, "GtkFlowBox_");
  GtkFlowBoxChild__sym = s7_make_symbol(sc, "GtkFlowBoxChild_");
  GtkSearchBar__sym = s7_make_symbol(sc, "GtkSearchBar_");
  GtkListBox__sym = s7_make_symbol(sc, "GtkListBox_");
  GtkListBoxRow__sym = s7_make_symbol(sc, "GtkListBoxRow_");
  GtkHeaderBar__sym = s7_make_symbol(sc, "GtkHeaderBar_");
  GtkRevealer__sym = s7_make_symbol(sc, "GtkRevealer_");
  GtkStack__sym = s7_make_symbol(sc, "GtkStack_");
  GtkStackSwitcher__sym = s7_make_symbol(sc, "GtkStackSwitcher_");
  GtkPlacesSidebar__sym = s7_make_symbol(sc, "GtkPlacesSidebar_");
  GtkLevelBar__sym = s7_make_symbol(sc, "GtkLevelBar_");
  GtkMenuButton__sym = s7_make_symbol(sc, "GtkMenuButton_");
  GtkColorChooser__sym = s7_make_symbol(sc, "GtkColorChooser_");
  GtkApplicationWindow__sym = s7_make_symbol(sc, "GtkApplicationWindow_");
  GtkApplication__sym = s7_make_symbol(sc, "GtkApplication_");
  GMenuModel__sym = s7_make_symbol(sc, "GMenuModel_");
  guint___sym = s7_make_symbol(sc, "guint__");
  GtkFontChooser__sym = s7_make_symbol(sc, "GtkFontChooser_");
  GtkOverlay__sym = s7_make_symbol(sc, "GtkOverlay_");
  GtkWidgetPath__sym = s7_make_symbol(sc, "GtkWidgetPath_");
  GdkScreen___sym = s7_make_symbol(sc, "GdkScreen__");
  GtkToolShell__sym = s7_make_symbol(sc, "GtkToolShell_");
  GtkWindowGroup__sym = s7_make_symbol(sc, "GtkWindowGroup_");
  GtkInvisible__sym = s7_make_symbol(sc, "GtkInvisible_");
  GtkOrientable__sym = s7_make_symbol(sc, "GtkOrientable_");
  GtkCellArea__sym = s7_make_symbol(sc, "GtkCellArea_");
  GtkBorder__sym = s7_make_symbol(sc, "GtkBorder_");
  GtkSwitch__sym = s7_make_symbol(sc, "GtkSwitch_");
  GtkScrollable__sym = s7_make_symbol(sc, "GtkScrollable_");
  GtkGrid__sym = s7_make_symbol(sc, "GtkGrid_");
  GdkRGBA__sym = s7_make_symbol(sc, "GdkRGBA_");
  GtkComboBoxText__sym = s7_make_symbol(sc, "GtkComboBoxText_");
  cairo_region_overlap_t_sym = s7_make_symbol(sc, "cairo_region_overlap_t");
  cairo_rectangle_int_t__sym = s7_make_symbol(sc, "cairo_rectangle_int_t_");
  double__sym = s7_make_symbol(sc, "double_");
  cairo_rectangle_t__sym = s7_make_symbol(sc, "cairo_rectangle_t_");
  cairo_device_t__sym = s7_make_symbol(sc, "cairo_device_t_");
  cairo_text_cluster_flags_t__sym = s7_make_symbol(sc, "cairo_text_cluster_flags_t_");
  cairo_text_cluster_t___sym = s7_make_symbol(sc, "cairo_text_cluster_t__");
  cairo_glyph_t___sym = s7_make_symbol(sc, "cairo_glyph_t__");
  cairo_text_cluster_t__sym = s7_make_symbol(sc, "cairo_text_cluster_t_");
  cairo_region_t__sym = s7_make_symbol(sc, "cairo_region_t_");
  GtkMessageDialog__sym = s7_make_symbol(sc, "GtkMessageDialog_");
  GdkDevice__sym = s7_make_symbol(sc, "GdkDevice_");
  GtkAccessible__sym = s7_make_symbol(sc, "GtkAccessible_");
  GdkModifierType__sym = s7_make_symbol(sc, "GdkModifierType_");
  GtkToolItemGroup__sym = s7_make_symbol(sc, "GtkToolItemGroup_");
  GtkToolPalette__sym = s7_make_symbol(sc, "GtkToolPalette_");
  GtkSpinner__sym = s7_make_symbol(sc, "GtkSpinner_");
  GtkEntryBuffer__sym = s7_make_symbol(sc, "GtkEntryBuffer_");
  GtkInfoBar__sym = s7_make_symbol(sc, "GtkInfoBar_");
  GIcon__sym = s7_make_symbol(sc, "GIcon_");
  GFile__sym = s7_make_symbol(sc, "GFile_");
  GtkScaleButton__sym = s7_make_symbol(sc, "GtkScaleButton_");
  GtkCalendarDetailFunc_sym = s7_make_symbol(sc, "GtkCalendarDetailFunc");
  GtkTooltip__sym = s7_make_symbol(sc, "GtkTooltip_");
  cairo_rectangle_list_t__sym = s7_make_symbol(sc, "cairo_rectangle_list_t_");
  void__sym = s7_make_symbol(sc, "void_");
  cairo_path_t__sym = s7_make_symbol(sc, "cairo_path_t_");
  cairo_destroy_func_t_sym = s7_make_symbol(sc, "cairo_destroy_func_t");
  cairo_user_data_key_t__sym = s7_make_symbol(sc, "cairo_user_data_key_t_");
  cairo_text_extents_t__sym = s7_make_symbol(sc, "cairo_text_extents_t_");
  cairo_font_extents_t__sym = s7_make_symbol(sc, "cairo_font_extents_t_");
  cairo_font_face_t__sym = s7_make_symbol(sc, "cairo_font_face_t_");
  cairo_glyph_t__sym = s7_make_symbol(sc, "cairo_glyph_t_");
  cairo_scaled_font_t__sym = s7_make_symbol(sc, "cairo_scaled_font_t_");
  cairo_matrix_t__sym = s7_make_symbol(sc, "cairo_matrix_t_");
  cairo_pattern_t__sym = s7_make_symbol(sc, "cairo_pattern_t_");
  GtkPageRange__sym = s7_make_symbol(sc, "GtkPageRange_");
  GtkPaperSize__sym = s7_make_symbol(sc, "GtkPaperSize_");
  GtkPrintSettingsFunc_sym = s7_make_symbol(sc, "GtkPrintSettingsFunc");
  GtkPageSetupDoneFunc_sym = s7_make_symbol(sc, "GtkPageSetupDoneFunc");
  GtkPrintSettings__sym = s7_make_symbol(sc, "GtkPrintSettings_");
  GtkPrintOperation__sym = s7_make_symbol(sc, "GtkPrintOperation_");
  GtkPageSetup__sym = s7_make_symbol(sc, "GtkPageSetup_");
  GtkPrintContext__sym = s7_make_symbol(sc, "GtkPrintContext_");
  cairo_surface_t__sym = s7_make_symbol(sc, "cairo_surface_t_");
  GtkRecentData__sym = s7_make_symbol(sc, "GtkRecentData_");
  GtkTextBufferDeserializeFunc_sym = s7_make_symbol(sc, "GtkTextBufferDeserializeFunc");
  GtkTextBufferSerializeFunc_sym = s7_make_symbol(sc, "GtkTextBufferSerializeFunc");
  GtkRecentChooserMenu__sym = s7_make_symbol(sc, "GtkRecentChooserMenu_");
  GtkRecentManager__sym = s7_make_symbol(sc, "GtkRecentManager_");
  GtkRecentFilter__sym = s7_make_symbol(sc, "GtkRecentFilter_");
  GtkRecentSortFunc_sym = s7_make_symbol(sc, "GtkRecentSortFunc");
  GtkRecentChooser__sym = s7_make_symbol(sc, "GtkRecentChooser_");
  GtkLinkButton__sym = s7_make_symbol(sc, "GtkLinkButton_");
  GtkAssistantPageFunc_sym = s7_make_symbol(sc, "GtkAssistantPageFunc");
  GtkAssistant__sym = s7_make_symbol(sc, "GtkAssistant_");
  GDestroyNotify_sym = s7_make_symbol(sc, "GDestroyNotify");
  GtkTreeViewSearchPositionFunc_sym = s7_make_symbol(sc, "GtkTreeViewSearchPositionFunc");
  GtkClipboardRichTextReceivedFunc_sym = s7_make_symbol(sc, "GtkClipboardRichTextReceivedFunc");
  GtkMenuBar__sym = s7_make_symbol(sc, "GtkMenuBar_");
  GValue__sym = s7_make_symbol(sc, "GValue_");
  GLogFunc_sym = s7_make_symbol(sc, "GLogFunc");
  PangoMatrix__sym = s7_make_symbol(sc, "PangoMatrix_");
  PangoRenderer__sym = s7_make_symbol(sc, "PangoRenderer_");
  GtkClipboardImageReceivedFunc_sym = s7_make_symbol(sc, "GtkClipboardImageReceivedFunc");
  GtkMenuToolButton__sym = s7_make_symbol(sc, "GtkMenuToolButton_");
  GtkFileChooserButton__sym = s7_make_symbol(sc, "GtkFileChooserButton_");
  PangoScriptIter__sym = s7_make_symbol(sc, "PangoScriptIter_");
  PangoAttrFilterFunc_sym = s7_make_symbol(sc, "PangoAttrFilterFunc");
  GtkIconViewForeachFunc_sym = s7_make_symbol(sc, "GtkIconViewForeachFunc");
  GtkAboutDialog__sym = s7_make_symbol(sc, "GtkAboutDialog_");
  GtkTreeViewRowSeparatorFunc_sym = s7_make_symbol(sc, "GtkTreeViewRowSeparatorFunc");
  GtkCellView__sym = s7_make_symbol(sc, "GtkCellView_");
  GtkAccelMap__sym = s7_make_symbol(sc, "GtkAccelMap_");
  GtkClipboardTargetsReceivedFunc_sym = s7_make_symbol(sc, "GtkClipboardTargetsReceivedFunc");
  GtkToolButton__sym = s7_make_symbol(sc, "GtkToolButton_");
  GtkIconInfo__sym = s7_make_symbol(sc, "GtkIconInfo_");
  GtkIconTheme__sym = s7_make_symbol(sc, "GtkIconTheme_");
  GtkFileChooser__sym = s7_make_symbol(sc, "GtkFileChooser_");
  GtkCellLayoutDataFunc_sym = s7_make_symbol(sc, "GtkCellLayoutDataFunc");
  GtkCellLayout__sym = s7_make_symbol(sc, "GtkCellLayout_");
  GtkFileFilterFunc_sym = s7_make_symbol(sc, "GtkFileFilterFunc");
  GtkFileFilter__sym = s7_make_symbol(sc, "GtkFileFilter_");
  GSourceFunc_sym = s7_make_symbol(sc, "GSourceFunc");
  GtkToggleToolButton__sym = s7_make_symbol(sc, "GtkToggleToolButton_");
  GtkSeparatorToolItem__sym = s7_make_symbol(sc, "GtkSeparatorToolItem_");
  GtkRadioToolButton__sym = s7_make_symbol(sc, "GtkRadioToolButton_");
  GtkEntryCompletionMatchFunc_sym = s7_make_symbol(sc, "GtkEntryCompletionMatchFunc");
  GtkFontButton__sym = s7_make_symbol(sc, "GtkFontButton_");
  GtkExpander__sym = s7_make_symbol(sc, "GtkExpander_");
  GtkComboBox__sym = s7_make_symbol(sc, "GtkComboBox_");
  GtkTreeModelFilter__sym = s7_make_symbol(sc, "GtkTreeModelFilter_");
  GtkToolItem__sym = s7_make_symbol(sc, "GtkToolItem_");
  GdkScreen__sym = s7_make_symbol(sc, "GdkScreen_");
  PangoLayoutRun__sym = s7_make_symbol(sc, "PangoLayoutRun_");
  PangoLayoutIter__sym = s7_make_symbol(sc, "PangoLayoutIter_");
  PangoLayoutLine__sym = s7_make_symbol(sc, "PangoLayoutLine_");
  int__sym = s7_make_symbol(sc, "int_");
  PangoItem__sym = s7_make_symbol(sc, "PangoItem_");
  PangoGlyphString__sym = s7_make_symbol(sc, "PangoGlyphString_");
  PangoFontMap__sym = s7_make_symbol(sc, "PangoFontMap_");
  PangoFontFace__sym = s7_make_symbol(sc, "PangoFontFace_");
  PangoFontFace___sym = s7_make_symbol(sc, "PangoFontFace__");
  PangoFontFamily__sym = s7_make_symbol(sc, "PangoFontFamily_");
  PangoFontDescription___sym = s7_make_symbol(sc, "PangoFontDescription__");
  PangoCoverage__sym = s7_make_symbol(sc, "PangoCoverage_");
  PangoFontMetrics__sym = s7_make_symbol(sc, "PangoFontMetrics_");
  PangoFontset__sym = s7_make_symbol(sc, "PangoFontset_");
  PangoFont__sym = s7_make_symbol(sc, "PangoFont_");
  PangoFontFamily___sym = s7_make_symbol(sc, "PangoFontFamily__");
  PangoLogAttr__sym = s7_make_symbol(sc, "PangoLogAttr_");
  PangoAnalysis__sym = s7_make_symbol(sc, "PangoAnalysis_");
  PangoAttrList___sym = s7_make_symbol(sc, "PangoAttrList__");
  PangoAttrIterator__sym = s7_make_symbol(sc, "PangoAttrIterator_");
  PangoRectangle__sym = s7_make_symbol(sc, "PangoRectangle_");
  PangoAttribute__sym = s7_make_symbol(sc, "PangoAttribute_");
  PangoColor__sym = s7_make_symbol(sc, "PangoColor_");
  GtkWindow__sym = s7_make_symbol(sc, "GtkWindow_");
  AtkObject__sym = s7_make_symbol(sc, "AtkObject_");
  GtkViewport__sym = s7_make_symbol(sc, "GtkViewport_");
  GtkTreeViewSearchEqualFunc_sym = s7_make_symbol(sc, "GtkTreeViewSearchEqualFunc");
  GtkTreeViewMappingFunc_sym = s7_make_symbol(sc, "GtkTreeViewMappingFunc");
  GtkTreeViewColumnDropFunc_sym = s7_make_symbol(sc, "GtkTreeViewColumnDropFunc");
  GtkTreeCellDataFunc_sym = s7_make_symbol(sc, "GtkTreeCellDataFunc");
  GtkTreeStore__sym = s7_make_symbol(sc, "GtkTreeStore_");
  GtkTreeIterCompareFunc_sym = s7_make_symbol(sc, "GtkTreeIterCompareFunc");
  GtkTreeSortable__sym = s7_make_symbol(sc, "GtkTreeSortable_");
  GtkTreeSelectionForeachFunc_sym = s7_make_symbol(sc, "GtkTreeSelectionForeachFunc");
  GtkTreeModel___sym = s7_make_symbol(sc, "GtkTreeModel__");
  GtkTreeSelectionFunc_sym = s7_make_symbol(sc, "GtkTreeSelectionFunc");
  GtkTreeModelSort__sym = s7_make_symbol(sc, "GtkTreeModelSort_");
  GtkTreeModelForeachFunc_sym = s7_make_symbol(sc, "GtkTreeModelForeachFunc");
  GtkTreeRowReference__sym = s7_make_symbol(sc, "GtkTreeRowReference_");
  GtkTreeDragDest__sym = s7_make_symbol(sc, "GtkTreeDragDest_");
  GtkTreeDragSource__sym = s7_make_symbol(sc, "GtkTreeDragSource_");
  GtkToolbar__sym = s7_make_symbol(sc, "GtkToolbar_");
  GtkToggleButton__sym = s7_make_symbol(sc, "GtkToggleButton_");
  PangoTabArray__sym = s7_make_symbol(sc, "PangoTabArray_");
  GtkTextView__sym = s7_make_symbol(sc, "GtkTextView_");
  GtkTextTagTableForeach_sym = s7_make_symbol(sc, "GtkTextTagTableForeach");
  GtkTextAttributes__sym = s7_make_symbol(sc, "GtkTextAttributes_");
  GtkTextCharPredicate_sym = s7_make_symbol(sc, "GtkTextCharPredicate");
  GtkTextMark__sym = s7_make_symbol(sc, "GtkTextMark_");
  GtkTextChildAnchor__sym = s7_make_symbol(sc, "GtkTextChildAnchor_");
  GtkTextIter__sym = s7_make_symbol(sc, "GtkTextIter_");
  GtkTextTagTable__sym = s7_make_symbol(sc, "GtkTextTagTable_");
  GtkTextBuffer__sym = s7_make_symbol(sc, "GtkTextBuffer_");
  GtkStatusbar__sym = s7_make_symbol(sc, "GtkStatusbar_");
  GtkSpinButton__sym = s7_make_symbol(sc, "GtkSpinButton_");
  GtkSizeGroup__sym = s7_make_symbol(sc, "GtkSizeGroup_");
  GtkSettings__sym = s7_make_symbol(sc, "GtkSettings_");
  GtkScrolledWindow__sym = s7_make_symbol(sc, "GtkScrolledWindow_");
  GtkScale__sym = s7_make_symbol(sc, "GtkScale_");
  GtkRange__sym = s7_make_symbol(sc, "GtkRange_");
  GtkRadioMenuItem__sym = s7_make_symbol(sc, "GtkRadioMenuItem_");
  GtkRadioButton__sym = s7_make_symbol(sc, "GtkRadioButton_");
  GtkProgressBar__sym = s7_make_symbol(sc, "GtkProgressBar_");
  GtkPaned__sym = s7_make_symbol(sc, "GtkPaned_");
  GtkNotebook__sym = s7_make_symbol(sc, "GtkNotebook_");
  GtkMenuShell__sym = s7_make_symbol(sc, "GtkMenuShell_");
  gint__sym = s7_make_symbol(sc, "gint_");
  GtkMenuItem__sym = s7_make_symbol(sc, "GtkMenuItem_");
  GtkMenu__sym = s7_make_symbol(sc, "GtkMenu_");
  PangoLanguage__sym = s7_make_symbol(sc, "PangoLanguage_");
  GtkListStore__sym = s7_make_symbol(sc, "GtkListStore_");
  GtkLayout__sym = s7_make_symbol(sc, "GtkLayout_");
  GtkLabel__sym = s7_make_symbol(sc, "GtkLabel_");
  guint16__sym = s7_make_symbol(sc, "guint16_");
  GtkIMContextSimple__sym = s7_make_symbol(sc, "GtkIMContextSimple_");
  GdkEventKey__sym = s7_make_symbol(sc, "GdkEventKey_");
  PangoAttrList__sym = s7_make_symbol(sc, "PangoAttrList_");
  GtkIMContext__sym = s7_make_symbol(sc, "GtkIMContext_");
  GtkImage__sym = s7_make_symbol(sc, "GtkImage_");
  GtkFrame__sym = s7_make_symbol(sc, "GtkFrame_");
  GtkFixed__sym = s7_make_symbol(sc, "GtkFixed_");
  PangoLayout__sym = s7_make_symbol(sc, "PangoLayout_");
  GtkEntry__sym = s7_make_symbol(sc, "GtkEntry_");
  GtkEditable__sym = s7_make_symbol(sc, "GtkEditable_");
  GtkTargetList__sym = s7_make_symbol(sc, "GtkTargetList_");
  etc_sym = s7_make_symbol(sc, "etc");
  GtkDialog__sym = s7_make_symbol(sc, "GtkDialog_");
  GtkCallback_sym = s7_make_symbol(sc, "GtkCallback");
  GtkContainer__sym = s7_make_symbol(sc, "GtkContainer_");
  GtkClipboardTextReceivedFunc_sym = s7_make_symbol(sc, "GtkClipboardTextReceivedFunc");
  GtkClipboardReceivedFunc_sym = s7_make_symbol(sc, "GtkClipboardReceivedFunc");
  GtkClipboardClearFunc_sym = s7_make_symbol(sc, "GtkClipboardClearFunc");
  GtkClipboardGetFunc_sym = s7_make_symbol(sc, "GtkClipboardGetFunc");
  GtkTargetEntry__sym = s7_make_symbol(sc, "GtkTargetEntry_");
  GtkCheckMenuItem__sym = s7_make_symbol(sc, "GtkCheckMenuItem_");
  GtkCellRendererToggle__sym = s7_make_symbol(sc, "GtkCellRendererToggle_");
  GtkCellRendererText__sym = s7_make_symbol(sc, "GtkCellRendererText_");
  GtkCellEditable__sym = s7_make_symbol(sc, "GtkCellEditable_");
  GtkCalendar__sym = s7_make_symbol(sc, "GtkCalendar_");
  GtkButton__sym = s7_make_symbol(sc, "GtkButton_");
  GtkBox__sym = s7_make_symbol(sc, "GtkBox_");
  GtkBin__sym = s7_make_symbol(sc, "GtkBin_");
  GtkBindingSet__sym = s7_make_symbol(sc, "GtkBindingSet_");
  GtkButtonBox__sym = s7_make_symbol(sc, "GtkButtonBox_");
  GtkAspectFrame__sym = s7_make_symbol(sc, "GtkAspectFrame_");
  GtkAdjustment__sym = s7_make_symbol(sc, "GtkAdjustment_");
  GtkAccelMapForeach_sym = s7_make_symbol(sc, "GtkAccelMapForeach");
  GtkAccelLabel__sym = s7_make_symbol(sc, "GtkAccelLabel_");
  GtkAccelGroupEntry__sym = s7_make_symbol(sc, "GtkAccelGroupEntry_");
  lambda3_sym = s7_make_symbol(sc, "lambda3");
  GSList__sym = s7_make_symbol(sc, "GSList_");
  GObject__sym = s7_make_symbol(sc, "GObject_");
  GtkAccelGroup__sym = s7_make_symbol(sc, "GtkAccelGroup_");
  GTimeVal__sym = s7_make_symbol(sc, "GTimeVal_");
  GdkPixbufAnimationIter__sym = s7_make_symbol(sc, "GdkPixbufAnimationIter_");
  GdkPixbufAnimation__sym = s7_make_symbol(sc, "GdkPixbufAnimation_");
  char___sym = s7_make_symbol(sc, "char__");
  GdkPixbufDestroyNotify_sym = s7_make_symbol(sc, "GdkPixbufDestroyNotify");
  GError__sym = s7_make_symbol(sc, "GError_");
  GdkGeometry__sym = s7_make_symbol(sc, "GdkGeometry_");
  GdkFilterFunc_sym = s7_make_symbol(sc, "GdkFilterFunc");
  guchar__sym = s7_make_symbol(sc, "guchar_");
  PangoContext__sym = s7_make_symbol(sc, "PangoContext_");
  GdkKeymapKey__sym = s7_make_symbol(sc, "GdkKeymapKey_");
  GdkKeymap__sym = s7_make_symbol(sc, "GdkKeymap_");
  GdkRectangle__sym = s7_make_symbol(sc, "GdkRectangle_");
  gchar___sym = s7_make_symbol(sc, "gchar__");
  GdkEventFunc_sym = s7_make_symbol(sc, "GdkEventFunc");
  GList__sym = s7_make_symbol(sc, "GList_");
  GdkDragContext__sym = s7_make_symbol(sc, "GdkDragContext_");
  GdkDisplay__sym = s7_make_symbol(sc, "GdkDisplay_");
  GdkCursor__sym = s7_make_symbol(sc, "GdkCursor_");
  GtkDestroyNotify_sym = s7_make_symbol(sc, "GtkDestroyNotify");
  GSignalEmissionHook_sym = s7_make_symbol(sc, "GSignalEmissionHook");
  GSignalInvocationHint__sym = s7_make_symbol(sc, "GSignalInvocationHint_");
  guint__sym = s7_make_symbol(sc, "guint_");
  GSignalQuery__sym = s7_make_symbol(sc, "GSignalQuery_");
  GType__sym = s7_make_symbol(sc, "GType_");
  GSignalCMarshaller_sym = s7_make_symbol(sc, "GSignalCMarshaller");
  gpointer_sym = s7_make_symbol(sc, "gpointer");
  GSignalAccumulator_sym = s7_make_symbol(sc, "GSignalAccumulator");
  GClosureNotify_sym = s7_make_symbol(sc, "GClosureNotify");
  GCallback_sym = s7_make_symbol(sc, "GCallback");
  gunichar__sym = s7_make_symbol(sc, "gunichar_");
  void_sym = s7_make_symbol(sc, "void");
  GtkDrawingArea__sym = s7_make_symbol(sc, "GtkDrawingArea_");
  GdkSeat__sym = s7_make_symbol(sc, "GdkSeat_");
  GtkRecentInfo__sym = s7_make_symbol(sc, "GtkRecentInfo_");
  guint8__sym = s7_make_symbol(sc, "guint8_");
  GdkAtom_sym = s7_make_symbol(sc, "GdkAtom");
  GdkPixbuf__sym = s7_make_symbol(sc, "GdkPixbuf_");
  GtkIconView__sym = s7_make_symbol(sc, "GtkIconView_");
  GtkEntryCompletion__sym = s7_make_symbol(sc, "GtkEntryCompletion_");
  GtkFileFilterInfo__sym = s7_make_symbol(sc, "GtkFileFilterInfo_");
  GtkTreeSelection__sym = s7_make_symbol(sc, "GtkTreeSelection_");
  GtkCellRenderer__sym = s7_make_symbol(sc, "GtkCellRenderer_");
  GtkTreeViewColumn__sym = s7_make_symbol(sc, "GtkTreeViewColumn_");
  GtkTreeView__sym = s7_make_symbol(sc, "GtkTreeView_");
  GdkAtom__sym = s7_make_symbol(sc, "GdkAtom_");
  GtkSelectionData__sym = s7_make_symbol(sc, "GtkSelectionData_");
  GtkClipboard__sym = s7_make_symbol(sc, "GtkClipboard_");
  GtkTreeIter__sym = s7_make_symbol(sc, "GtkTreeIter_");
  GtkTreePath__sym = s7_make_symbol(sc, "GtkTreePath_");
  GtkTreeModel__sym = s7_make_symbol(sc, "GtkTreeModel_");
  GtkTextTag__sym = s7_make_symbol(sc, "GtkTextTag_");
  GdkXEvent__sym = s7_make_symbol(sc, "GdkXEvent_");
  GtkWidget__sym = s7_make_symbol(sc, "GtkWidget_");
  lambda_data_sym = s7_make_symbol(sc, "lambda_data");
  GClosure__sym = s7_make_symbol(sc, "GClosure_");
  GtkAccelKey__sym = s7_make_symbol(sc, "GtkAccelKey_");
  GdkEventMotion__sym = s7_make_symbol(sc, "GdkEventMotion_");
  gdouble__sym = s7_make_symbol(sc, "gdouble_");
  GdkEventAny__sym = s7_make_symbol(sc, "GdkEventAny_");
  GdkEvent__sym = s7_make_symbol(sc, "GdkEvent_");
  GdkWindow__sym = s7_make_symbol(sc, "GdkWindow_");
  cairo_t__sym = s7_make_symbol(sc, "cairo_t_");
  cairo_font_options_t__sym = s7_make_symbol(sc, "cairo_font_options_t_");
  PangoFontDescription__sym = s7_make_symbol(sc, "PangoFontDescription_");
}


static void define_strings(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PRINTER"), s7_make_string(sc, GTK_PRINT_SETTINGS_PRINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_ORIENTATION"), s7_make_string(sc, GTK_PRINT_SETTINGS_ORIENTATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_FORMAT"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_WIDTH"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_WIDTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_HEIGHT"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_HEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_N_COPIES"), s7_make_string(sc, GTK_PRINT_SETTINGS_N_COPIES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DEFAULT_SOURCE"), s7_make_string(sc, GTK_PRINT_SETTINGS_DEFAULT_SOURCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_QUALITY"), s7_make_string(sc, GTK_PRINT_SETTINGS_QUALITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_RESOLUTION"), s7_make_string(sc, GTK_PRINT_SETTINGS_RESOLUTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_USE_COLOR"), s7_make_string(sc, GTK_PRINT_SETTINGS_USE_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DUPLEX"), s7_make_string(sc, GTK_PRINT_SETTINGS_DUPLEX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_COLLATE"), s7_make_string(sc, GTK_PRINT_SETTINGS_COLLATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_REVERSE"), s7_make_string(sc, GTK_PRINT_SETTINGS_REVERSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_MEDIA_TYPE"), s7_make_string(sc, GTK_PRINT_SETTINGS_MEDIA_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DITHER"), s7_make_string(sc, GTK_PRINT_SETTINGS_DITHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_SCALE"), s7_make_string(sc, GTK_PRINT_SETTINGS_SCALE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PRINT_PAGES"), s7_make_string(sc, GTK_PRINT_SETTINGS_PRINT_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAGE_RANGES"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAGE_RANGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAGE_SET"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAGE_SET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_FINISHINGS"), s7_make_string(sc, GTK_PRINT_SETTINGS_FINISHINGS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_NUMBER_UP"), s7_make_string(sc, GTK_PRINT_SETTINGS_NUMBER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_BIN"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_BIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_URI"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_URI));
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_HIGHLIGHT"), s7_make_string(sc, GTK_STYLE_CLASS_HIGHLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_FRAME"), s7_make_string(sc, GTK_STYLE_CLASS_FRAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DND"), s7_make_string(sc, GTK_STYLE_CLASS_DND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_HORIZONTAL"), s7_make_string(sc, GTK_STYLE_CLASS_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_VERTICAL"), s7_make_string(sc, GTK_STYLE_CLASS_VERTICAL));
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_OFFSET_FULL"), s7_make_string(sc, GTK_LEVEL_BAR_OFFSET_FULL));
#endif

#if HAVE_CAIRO_1_9_12 && GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_JPEG"), s7_make_string(sc, CAIRO_MIME_TYPE_JPEG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_PNG"), s7_make_string(sc, CAIRO_MIME_TYPE_PNG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_JP2"), s7_make_string(sc, CAIRO_MIME_TYPE_JP2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_URI"), s7_make_string(sc, CAIRO_MIME_TYPE_URI));
#endif

}

typedef struct {const char *name, *type; int64_t value;} enummer_t;
static enummer_t enum_info[] = {
#if GTK_CHECK_VERSION(2, 0, 0)
        {"G_NORMALIZE_DEFAULT", "GNormalizeMode", G_NORMALIZE_DEFAULT},
        {"G_NORMALIZE_NFD", "GNormalizeMode", G_NORMALIZE_NFD},
        {"G_NORMALIZE_DEFAULT_COMPOSE", "GNormalizeMode", G_NORMALIZE_DEFAULT_COMPOSE},
        {"G_NORMALIZE_NFC", "GNormalizeMode", G_NORMALIZE_NFC},
        {"G_NORMALIZE_ALL", "GNormalizeMode", G_NORMALIZE_ALL},
        {"G_NORMALIZE_NFKD", "GNormalizeMode", G_NORMALIZE_NFKD},
        {"G_NORMALIZE_ALL_COMPOSE", "GNormalizeMode", G_NORMALIZE_ALL_COMPOSE},
        {"G_NORMALIZE_NFKC", "GNormalizeMode", G_NORMALIZE_NFKC},
        {"G_SIGNAL_RUN_FIRST", "GSignalFlags", G_SIGNAL_RUN_FIRST},
        {"G_SIGNAL_RUN_LAST", "GSignalFlags", G_SIGNAL_RUN_LAST},
        {"G_SIGNAL_RUN_CLEANUP", "GSignalFlags", G_SIGNAL_RUN_CLEANUP},
        {"G_SIGNAL_NO_RECURSE", "GSignalFlags", G_SIGNAL_NO_RECURSE},
        {"G_SIGNAL_DETAILED", "GSignalFlags", G_SIGNAL_DETAILED},
        {"G_SIGNAL_ACTION", "GSignalFlags", G_SIGNAL_ACTION},
        {"G_SIGNAL_NO_HOOKS", "GSignalFlags", G_SIGNAL_NO_HOOKS},
        {"G_CONNECT_AFTER", "GConnectFlags", G_CONNECT_AFTER},
        {"G_CONNECT_SWAPPED", "GConnectFlags", G_CONNECT_SWAPPED},
        {"G_SIGNAL_MATCH_ID", "GSignalMatchType", G_SIGNAL_MATCH_ID},
        {"G_SIGNAL_MATCH_DETAIL", "GSignalMatchType", G_SIGNAL_MATCH_DETAIL},
        {"G_SIGNAL_MATCH_CLOSURE", "GSignalMatchType", G_SIGNAL_MATCH_CLOSURE},
        {"G_SIGNAL_MATCH_FUNC", "GSignalMatchType", G_SIGNAL_MATCH_FUNC},
        {"G_SIGNAL_MATCH_DATA", "GSignalMatchType", G_SIGNAL_MATCH_DATA},
        {"G_SIGNAL_MATCH_UNBLOCKED", "GSignalMatchType", G_SIGNAL_MATCH_UNBLOCKED},
        {"GDK_X_CURSOR", "GdkCursorType", GDK_X_CURSOR},
        {"GDK_ARROW", "GdkCursorType", GDK_ARROW},
        {"GDK_BASED_ARROW_DOWN", "GdkCursorType", GDK_BASED_ARROW_DOWN},
        {"GDK_BASED_ARROW_UP", "GdkCursorType", GDK_BASED_ARROW_UP},
        {"GDK_BOAT", "GdkCursorType", GDK_BOAT},
        {"GDK_BOGOSITY", "GdkCursorType", GDK_BOGOSITY},
        {"GDK_BOTTOM_LEFT_CORNER", "GdkCursorType", GDK_BOTTOM_LEFT_CORNER},
        {"GDK_BOTTOM_RIGHT_CORNER", "GdkCursorType", GDK_BOTTOM_RIGHT_CORNER},
        {"GDK_BOTTOM_SIDE", "GdkCursorType", GDK_BOTTOM_SIDE},
        {"GDK_BOTTOM_TEE", "GdkCursorType", GDK_BOTTOM_TEE},
        {"GDK_BOX_SPIRAL", "GdkCursorType", GDK_BOX_SPIRAL},
        {"GDK_CENTER_PTR", "GdkCursorType", GDK_CENTER_PTR},
        {"GDK_CIRCLE", "GdkCursorType", GDK_CIRCLE},
        {"GDK_CLOCK", "GdkCursorType", GDK_CLOCK},
        {"GDK_COFFEE_MUG", "GdkCursorType", GDK_COFFEE_MUG},
        {"GDK_CROSS", "GdkCursorType", GDK_CROSS},
        {"GDK_CROSS_REVERSE", "GdkCursorType", GDK_CROSS_REVERSE},
        {"GDK_CROSSHAIR", "GdkCursorType", GDK_CROSSHAIR},
        {"GDK_DIAMOND_CROSS", "GdkCursorType", GDK_DIAMOND_CROSS},
        {"GDK_DOT", "GdkCursorType", GDK_DOT},
        {"GDK_DOTBOX", "GdkCursorType", GDK_DOTBOX},
        {"GDK_DOUBLE_ARROW", "GdkCursorType", GDK_DOUBLE_ARROW},
        {"GDK_DRAFT_LARGE", "GdkCursorType", GDK_DRAFT_LARGE},
        {"GDK_DRAFT_SMALL", "GdkCursorType", GDK_DRAFT_SMALL},
        {"GDK_DRAPED_BOX", "GdkCursorType", GDK_DRAPED_BOX},
        {"GDK_EXCHANGE", "GdkCursorType", GDK_EXCHANGE},
        {"GDK_FLEUR", "GdkCursorType", GDK_FLEUR},
        {"GDK_GOBBLER", "GdkCursorType", GDK_GOBBLER},
        {"GDK_GUMBY", "GdkCursorType", GDK_GUMBY},
        {"GDK_HAND1", "GdkCursorType", GDK_HAND1},
        {"GDK_HAND2", "GdkCursorType", GDK_HAND2},
        {"GDK_HEART", "GdkCursorType", GDK_HEART},
        {"GDK_ICON", "GdkCursorType", GDK_ICON},
        {"GDK_IRON_CROSS", "GdkCursorType", GDK_IRON_CROSS},
        {"GDK_LEFT_PTR", "GdkCursorType", GDK_LEFT_PTR},
        {"GDK_LEFT_SIDE", "GdkCursorType", GDK_LEFT_SIDE},
        {"GDK_LEFT_TEE", "GdkCursorType", GDK_LEFT_TEE},
        {"GDK_LEFTBUTTON", "GdkCursorType", GDK_LEFTBUTTON},
        {"GDK_LL_ANGLE", "GdkCursorType", GDK_LL_ANGLE},
        {"GDK_LR_ANGLE", "GdkCursorType", GDK_LR_ANGLE},
        {"GDK_MAN", "GdkCursorType", GDK_MAN},
        {"GDK_MIDDLEBUTTON", "GdkCursorType", GDK_MIDDLEBUTTON},
        {"GDK_MOUSE", "GdkCursorType", GDK_MOUSE},
        {"GDK_PENCIL", "GdkCursorType", GDK_PENCIL},
        {"GDK_PIRATE", "GdkCursorType", GDK_PIRATE},
        {"GDK_PLUS", "GdkCursorType", GDK_PLUS},
        {"GDK_QUESTION_ARROW", "GdkCursorType", GDK_QUESTION_ARROW},
        {"GDK_RIGHT_PTR", "GdkCursorType", GDK_RIGHT_PTR},
        {"GDK_RIGHT_SIDE", "GdkCursorType", GDK_RIGHT_SIDE},
        {"GDK_RIGHT_TEE", "GdkCursorType", GDK_RIGHT_TEE},
        {"GDK_RIGHTBUTTON", "GdkCursorType", GDK_RIGHTBUTTON},
        {"GDK_RTL_LOGO", "GdkCursorType", GDK_RTL_LOGO},
        {"GDK_SAILBOAT", "GdkCursorType", GDK_SAILBOAT},
        {"GDK_SB_DOWN_ARROW", "GdkCursorType", GDK_SB_DOWN_ARROW},
        {"GDK_SB_H_DOUBLE_ARROW", "GdkCursorType", GDK_SB_H_DOUBLE_ARROW},
        {"GDK_SB_LEFT_ARROW", "GdkCursorType", GDK_SB_LEFT_ARROW},
        {"GDK_SB_RIGHT_ARROW", "GdkCursorType", GDK_SB_RIGHT_ARROW},
        {"GDK_SB_UP_ARROW", "GdkCursorType", GDK_SB_UP_ARROW},
        {"GDK_SB_V_DOUBLE_ARROW", "GdkCursorType", GDK_SB_V_DOUBLE_ARROW},
        {"GDK_SHUTTLE", "GdkCursorType", GDK_SHUTTLE},
        {"GDK_SIZING", "GdkCursorType", GDK_SIZING},
        {"GDK_SPIDER", "GdkCursorType", GDK_SPIDER},
        {"GDK_SPRAYCAN", "GdkCursorType", GDK_SPRAYCAN},
        {"GDK_STAR", "GdkCursorType", GDK_STAR},
        {"GDK_TARGET", "GdkCursorType", GDK_TARGET},
        {"GDK_TCROSS", "GdkCursorType", GDK_TCROSS},
        {"GDK_TOP_LEFT_ARROW", "GdkCursorType", GDK_TOP_LEFT_ARROW},
        {"GDK_TOP_LEFT_CORNER", "GdkCursorType", GDK_TOP_LEFT_CORNER},
        {"GDK_TOP_RIGHT_CORNER", "GdkCursorType", GDK_TOP_RIGHT_CORNER},
        {"GDK_TOP_SIDE", "GdkCursorType", GDK_TOP_SIDE},
        {"GDK_TOP_TEE", "GdkCursorType", GDK_TOP_TEE},
        {"GDK_TREK", "GdkCursorType", GDK_TREK},
        {"GDK_UL_ANGLE", "GdkCursorType", GDK_UL_ANGLE},
        {"GDK_UMBRELLA", "GdkCursorType", GDK_UMBRELLA},
        {"GDK_UR_ANGLE", "GdkCursorType", GDK_UR_ANGLE},
        {"GDK_WATCH", "GdkCursorType", GDK_WATCH},
        {"GDK_XTERM", "GdkCursorType", GDK_XTERM},
        {"GDK_LAST_CURSOR ", "GdkCursorType", GDK_LAST_CURSOR },
        {"GDK_ACTION_DEFAULT", "GdkDragAction", GDK_ACTION_DEFAULT},
        {"GDK_ACTION_COPY", "GdkDragAction", GDK_ACTION_COPY},
        {"GDK_ACTION_MOVE", "GdkDragAction", GDK_ACTION_MOVE},
        {"GDK_ACTION_LINK", "GdkDragAction", GDK_ACTION_LINK},
        {"GDK_ACTION_PRIVATE", "GdkDragAction", GDK_ACTION_PRIVATE},
        {"GDK_ACTION_ASK", "GdkDragAction", GDK_ACTION_ASK},
        {"GDK_NOTHING", "GdkEventType", GDK_NOTHING},
        {"GDK_DELETE", "GdkEventType", GDK_DELETE},
        {"GDK_DESTROY", "GdkEventType", GDK_DESTROY},
        {"GDK_EXPOSE", "GdkEventType", GDK_EXPOSE},
        {"GDK_MOTION_NOTIFY", "GdkEventType", GDK_MOTION_NOTIFY},
        {"GDK_BUTTON_PRESS", "GdkEventType", GDK_BUTTON_PRESS},
        {"GDK_2BUTTON_PRESS", "GdkEventType", GDK_2BUTTON_PRESS},
        {"GDK_3BUTTON_PRESS", "GdkEventType", GDK_3BUTTON_PRESS},
        {"GDK_BUTTON_RELEASE", "GdkEventType", GDK_BUTTON_RELEASE},
        {"GDK_KEY_PRESS", "GdkEventType", GDK_KEY_PRESS},
        {"GDK_KEY_RELEASE", "GdkEventType", GDK_KEY_RELEASE},
        {"GDK_ENTER_NOTIFY", "GdkEventType", GDK_ENTER_NOTIFY},
        {"GDK_LEAVE_NOTIFY", "GdkEventType", GDK_LEAVE_NOTIFY},
        {"GDK_FOCUS_CHANGE", "GdkEventType", GDK_FOCUS_CHANGE},
        {"GDK_CONFIGURE", "GdkEventType", GDK_CONFIGURE},
        {"GDK_MAP", "GdkEventType", GDK_MAP},
        {"GDK_UNMAP", "GdkEventType", GDK_UNMAP},
        {"GDK_PROPERTY_NOTIFY", "GdkEventType", GDK_PROPERTY_NOTIFY},
        {"GDK_SELECTION_CLEAR", "GdkEventType", GDK_SELECTION_CLEAR},
        {"GDK_SELECTION_REQUEST", "GdkEventType", GDK_SELECTION_REQUEST},
        {"GDK_SELECTION_NOTIFY", "GdkEventType", GDK_SELECTION_NOTIFY},
        {"GDK_PROXIMITY_IN", "GdkEventType", GDK_PROXIMITY_IN},
        {"GDK_PROXIMITY_OUT", "GdkEventType", GDK_PROXIMITY_OUT},
        {"GDK_DRAG_ENTER", "GdkEventType", GDK_DRAG_ENTER},
        {"GDK_DRAG_LEAVE", "GdkEventType", GDK_DRAG_LEAVE},
        {"GDK_DRAG_MOTION", "GdkEventType", GDK_DRAG_MOTION},
        {"GDK_DRAG_STATUS", "GdkEventType", GDK_DRAG_STATUS},
        {"GDK_DROP_START", "GdkEventType", GDK_DROP_START},
        {"GDK_DROP_FINISHED", "GdkEventType", GDK_DROP_FINISHED},
        {"GDK_CLIENT_EVENT", "GdkEventType", GDK_CLIENT_EVENT},
        {"GDK_VISIBILITY_NOTIFY", "GdkEventType", GDK_VISIBILITY_NOTIFY},
        {"GDK_SCROLL", "GdkEventType", GDK_SCROLL},
        {"GDK_WINDOW_STATE", "GdkEventType", GDK_WINDOW_STATE},
        {"GDK_SETTING", "GdkEventType", GDK_SETTING},
        {"GDK_OWNER_CHANGE", "GdkEventType", GDK_OWNER_CHANGE},
        {"GDK_GRAB_BROKEN", "GdkEventType", GDK_GRAB_BROKEN},
        {"GDK_EXPOSURE_MASK", "GdkEventMask", GDK_EXPOSURE_MASK},
        {"GDK_POINTER_MOTION_MASK", "GdkEventMask", GDK_POINTER_MOTION_MASK},
        {"GDK_BUTTON_MOTION_MASK", "GdkEventMask", GDK_BUTTON_MOTION_MASK},
        {"GDK_BUTTON1_MOTION_MASK", "GdkEventMask", GDK_BUTTON1_MOTION_MASK},
        {"GDK_BUTTON2_MOTION_MASK", "GdkEventMask", GDK_BUTTON2_MOTION_MASK},
        {"GDK_BUTTON3_MOTION_MASK", "GdkEventMask", GDK_BUTTON3_MOTION_MASK},
        {"GDK_BUTTON_PRESS_MASK", "GdkEventMask", GDK_BUTTON_PRESS_MASK},
        {"GDK_BUTTON_RELEASE_MASK", "GdkEventMask", GDK_BUTTON_RELEASE_MASK},
        {"GDK_KEY_PRESS_MASK", "GdkEventMask", GDK_KEY_PRESS_MASK},
        {"GDK_KEY_RELEASE_MASK", "GdkEventMask", GDK_KEY_RELEASE_MASK},
        {"GDK_ENTER_NOTIFY_MASK", "GdkEventMask", GDK_ENTER_NOTIFY_MASK},
        {"GDK_LEAVE_NOTIFY_MASK", "GdkEventMask", GDK_LEAVE_NOTIFY_MASK},
        {"GDK_FOCUS_CHANGE_MASK", "GdkEventMask", GDK_FOCUS_CHANGE_MASK},
        {"GDK_STRUCTURE_MASK", "GdkEventMask", GDK_STRUCTURE_MASK},
        {"GDK_PROPERTY_CHANGE_MASK", "GdkEventMask", GDK_PROPERTY_CHANGE_MASK},
        {"GDK_VISIBILITY_NOTIFY_MASK", "GdkEventMask", GDK_VISIBILITY_NOTIFY_MASK},
        {"GDK_PROXIMITY_IN_MASK", "GdkEventMask", GDK_PROXIMITY_IN_MASK},
        {"GDK_PROXIMITY_OUT_MASK", "GdkEventMask", GDK_PROXIMITY_OUT_MASK},
        {"GDK_SUBSTRUCTURE_MASK", "GdkEventMask", GDK_SUBSTRUCTURE_MASK},
        {"GDK_SCROLL_MASK", "GdkEventMask", GDK_SCROLL_MASK},
        {"GDK_ALL_EVENTS_MASK", "GdkEventMask", GDK_ALL_EVENTS_MASK},
        {"GDK_SCROLL_UP", "GdkScrollDirection", GDK_SCROLL_UP},
        {"GDK_SCROLL_DOWN", "GdkScrollDirection", GDK_SCROLL_DOWN},
        {"GDK_SCROLL_LEFT", "GdkScrollDirection", GDK_SCROLL_LEFT},
        {"GDK_SCROLL_RIGHT", "GdkScrollDirection", GDK_SCROLL_RIGHT},
        {"GDK_NOTIFY_ANCESTOR", "GdkNotifyType", GDK_NOTIFY_ANCESTOR},
        {"GDK_NOTIFY_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_VIRTUAL},
        {"GDK_NOTIFY_INFERIOR", "GdkNotifyType", GDK_NOTIFY_INFERIOR},
        {"GDK_NOTIFY_NONLINEAR", "GdkNotifyType", GDK_NOTIFY_NONLINEAR},
        {"GDK_NOTIFY_NONLINEAR_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_NONLINEAR_VIRTUAL},
        {"GDK_NOTIFY_UNKNOWN", "GdkNotifyType", GDK_NOTIFY_UNKNOWN},
        {"GDK_CROSSING_NORMAL", "GdkCrossingMode", GDK_CROSSING_NORMAL},
        {"GDK_CROSSING_GRAB", "GdkNotifyType", GDK_CROSSING_GRAB},
        {"GDK_CROSSING_UNGRAB", "GdkNotifyType", GDK_CROSSING_UNGRAB},
        {"GDK_PROPERTY_NEW_VALUE", "GdkPropertyState", GDK_PROPERTY_NEW_VALUE},
        {"GDK_PROPERTY_DELETE", "GdkPropertyState", GDK_PROPERTY_DELETE},
        {"GDK_WINDOW_STATE_WITHDRAWN", "GdkWindowState", GDK_WINDOW_STATE_WITHDRAWN},
        {"GDK_WINDOW_STATE_ICONIFIED", "GdkWindowState", GDK_WINDOW_STATE_ICONIFIED},
        {"GDK_WINDOW_STATE_MAXIMIZED", "GdkWindowState", GDK_WINDOW_STATE_MAXIMIZED},
        {"GDK_WINDOW_STATE_STICKY", "GdkWindowState", GDK_WINDOW_STATE_STICKY},
        {"GDK_SETTING_ACTION_NEW", "GdkSettingAction", GDK_SETTING_ACTION_NEW},
        {"GDK_SETTING_ACTION_CHANGED", "GdkSettingAction", GDK_SETTING_ACTION_CHANGED},
        {"GDK_SETTING_ACTION_DELETED", "GdkSettingAction", GDK_SETTING_ACTION_DELETED},
        {"GDK_PROP_MODE_REPLACE", "GdkPropMode", GDK_PROP_MODE_REPLACE},
        {"GDK_PROP_MODE_PREPEND", "GdkPropMode", GDK_PROP_MODE_PREPEND},
        {"GDK_PROP_MODE_APPEND", "GdkPropMode", GDK_PROP_MODE_APPEND},
        {"GDK_LSB_FIRST", "GdkByteOrder", GDK_LSB_FIRST},
        {"GDK_MSB_FIRST", "GdkByteOrder", GDK_MSB_FIRST},
        {"GDK_SHIFT_MASK", "GdkModifierType", GDK_SHIFT_MASK},
        {"GDK_LOCK_MASK", "GdkModifierType", GDK_LOCK_MASK},
        {"GDK_CONTROL_MASK", "GdkModifierType", GDK_CONTROL_MASK},
        {"GDK_MOD1_MASK", "GdkModifierType", GDK_MOD1_MASK},
        {"GDK_MOD2_MASK", "GdkModifierType", GDK_MOD2_MASK},
        {"GDK_MOD3_MASK", "GdkModifierType", GDK_MOD3_MASK},
        {"GDK_MOD4_MASK", "GdkModifierType", GDK_MOD4_MASK},
        {"GDK_MOD5_MASK", "GdkModifierType", GDK_MOD5_MASK},
        {"GDK_BUTTON1_MASK", "GdkModifierType", GDK_BUTTON1_MASK},
        {"GDK_BUTTON2_MASK", "GdkModifierType", GDK_BUTTON2_MASK},
        {"GDK_BUTTON3_MASK", "GdkModifierType", GDK_BUTTON3_MASK},
        {"GDK_BUTTON4_MASK", "GdkModifierType", GDK_BUTTON4_MASK},
        {"GDK_BUTTON5_MASK", "GdkModifierType", GDK_BUTTON5_MASK},
        {"GDK_RELEASE_MASK", "GdkModifierType", GDK_RELEASE_MASK},
        {"GDK_MODIFIER_MASK", "GdkModifierType", GDK_MODIFIER_MASK},
        {"GDK_OK", "GdkStatus", GDK_OK},
        {"GDK_ERROR", "GdkStatus", GDK_ERROR},
        {"GDK_ERROR_PARAM", "GdkStatus", GDK_ERROR_PARAM},
        {"GDK_ERROR_FILE", "GdkStatus", GDK_ERROR_FILE},
        {"GDK_ERROR_MEM", "GdkStatus", GDK_ERROR_MEM},
        {"GDK_GRAB_SUCCESS", "GdkGrabStatus", GDK_GRAB_SUCCESS},
        {"GDK_GRAB_ALREADY_GRABBED", "GdkGrabStatus", GDK_GRAB_ALREADY_GRABBED},
        {"GDK_GRAB_INVALID_TIME", "GdkGrabStatus", GDK_GRAB_INVALID_TIME},
        {"GDK_GRAB_NOT_VIEWABLE", "GdkGrabStatus", GDK_GRAB_NOT_VIEWABLE},
        {"GDK_GRAB_FROZEN", "GdkGrabStatus", GDK_GRAB_FROZEN},
        {"GDK_INPUT_OUTPUT", "GdkWindowClass", GDK_INPUT_OUTPUT},
        {"GDK_INPUT_ONLY", "GdkWindowClass", GDK_INPUT_ONLY},
        {"GDK_WINDOW_ROOT", "GdkWindowType", GDK_WINDOW_ROOT},
        {"GDK_WINDOW_TOPLEVEL", "GdkWindowType", GDK_WINDOW_TOPLEVEL},
        {"GDK_WINDOW_CHILD", "GdkWindowType", GDK_WINDOW_CHILD},
        {"GDK_WINDOW_TEMP", "GdkWindowType", GDK_WINDOW_TEMP},
        {"GDK_WINDOW_FOREIGN", "GdkWindowType", GDK_WINDOW_FOREIGN},
        {"GDK_WA_TITLE", "GdkWindowAttributesType", GDK_WA_TITLE},
        {"GDK_WA_X", "GdkWindowAttributesType", GDK_WA_X},
        {"GDK_WA_Y", "GdkWindowAttributesType", GDK_WA_Y},
        {"GDK_WA_CURSOR", "GdkWindowAttributesType", GDK_WA_CURSOR},
        {"GDK_WA_VISUAL", "GdkWindowAttributesType", GDK_WA_VISUAL},
        {"GDK_WA_WMCLASS", "GdkWindowAttributesType", GDK_WA_WMCLASS},
        {"GDK_WA_NOREDIR", "GdkWindowAttributesType", GDK_WA_NOREDIR},
        {"GDK_HINT_POS", "GdkWindowHints", GDK_HINT_POS},
        {"GDK_HINT_MIN_SIZE", "GdkWindowHints", GDK_HINT_MIN_SIZE},
        {"GDK_HINT_MAX_SIZE", "GdkWindowHints", GDK_HINT_MAX_SIZE},
        {"GDK_HINT_BASE_SIZE", "GdkWindowHints", GDK_HINT_BASE_SIZE},
        {"GDK_HINT_ASPECT", "GdkWindowHints", GDK_HINT_ASPECT},
        {"GDK_HINT_RESIZE_INC", "GdkWindowHints", GDK_HINT_RESIZE_INC},
        {"GDK_HINT_WIN_GRAVITY", "GdkWindowHints", GDK_HINT_WIN_GRAVITY},
        {"GDK_HINT_USER_POS", "GdkWindowHints", GDK_HINT_USER_POS},
        {"GDK_HINT_USER_SIZE", "GdkWindowHints", GDK_HINT_USER_SIZE},
        {"GDK_WINDOW_TYPE_HINT_NORMAL", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_NORMAL},
        {"GDK_WINDOW_TYPE_HINT_DIALOG", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DIALOG},
        {"GDK_WINDOW_TYPE_HINT_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_MENU},
        {"GDK_WINDOW_TYPE_HINT_TOOLBAR", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_TOOLBAR},
        {"GDK_DECOR_ALL", "GdkWMDecoration", GDK_DECOR_ALL},
        {"GDK_DECOR_BORDER", "GdkWMDecoration", GDK_DECOR_BORDER},
        {"GDK_DECOR_RESIZEH", "GdkWMDecoration", GDK_DECOR_RESIZEH},
        {"GDK_DECOR_TITLE", "GdkWMDecoration", GDK_DECOR_TITLE},
        {"GDK_DECOR_MENU", "GdkWMDecoration", GDK_DECOR_MENU},
        {"GDK_DECOR_MINIMIZE", "GdkWMDecoration", GDK_DECOR_MINIMIZE},
        {"GDK_DECOR_MAXIMIZE", "GdkWMDecoration", GDK_DECOR_MAXIMIZE},
        {"GDK_FUNC_ALL", "GdkWMFunction", GDK_FUNC_ALL},
        {"GDK_FUNC_RESIZE", "GdkWMFunction", GDK_FUNC_RESIZE},
        {"GDK_FUNC_MOVE", "GdkWMFunction", GDK_FUNC_MOVE},
        {"GDK_FUNC_MINIMIZE", "GdkWMFunction", GDK_FUNC_MINIMIZE},
        {"GDK_FUNC_MAXIMIZE", "GdkWMFunction", GDK_FUNC_MAXIMIZE},
        {"GDK_FUNC_CLOSE", "GdkWMFunction", GDK_FUNC_CLOSE},
        {"GDK_GRAVITY_NORTH_WEST", "GdkGravity", GDK_GRAVITY_NORTH_WEST},
        {"GDK_GRAVITY_NORTH", "GdkGravity", GDK_GRAVITY_NORTH},
        {"GDK_GRAVITY_NORTH_EAST", "GdkGravity", GDK_GRAVITY_NORTH_EAST},
        {"GDK_GRAVITY_WEST", "GdkGravity", GDK_GRAVITY_WEST},
        {"GDK_GRAVITY_CENTER", "GdkGravity", GDK_GRAVITY_CENTER},
        {"GDK_GRAVITY_EAST", "GdkGravity", GDK_GRAVITY_EAST},
        {"GDK_GRAVITY_SOUTH_WEST", "GdkGravity", GDK_GRAVITY_SOUTH_WEST},
        {"GDK_GRAVITY_SOUTH", "GdkGravity", GDK_GRAVITY_SOUTH},
        {"GDK_GRAVITY_SOUTH_EAST", "GdkGravity", GDK_GRAVITY_SOUTH_EAST},
        {"GDK_GRAVITY_STATIC", "GdkGravity", GDK_GRAVITY_STATIC},
        {"GDK_WINDOW_EDGE_NORTH_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH_WEST},
        {"GDK_WINDOW_EDGE_NORTH", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH},
        {"GDK_WINDOW_EDGE_NORTH_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_NORTH_EAST},
        {"GDK_WINDOW_EDGE_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_WEST},
        {"GDK_WINDOW_EDGE_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_EAST},
        {"GDK_WINDOW_EDGE_SOUTH_WEST", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH_WEST},
        {"GDK_WINDOW_EDGE_SOUTH", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH},
        {"GDK_WINDOW_EDGE_SOUTH_EAST", "GdkWindowEdge", GDK_WINDOW_EDGE_SOUTH_EAST},
        {"GDK_PIXBUF_ALPHA_BILEVEL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_BILEVEL},
        {"GDK_PIXBUF_ALPHA_FULL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_FULL},
        {"GDK_COLORSPACE_RGB", "GdkColorspace", GDK_COLORSPACE_RGB},
        {"GDK_PIXBUF_ERROR_CORRUPT_IMAGE", "GdkPixbufError", GDK_PIXBUF_ERROR_CORRUPT_IMAGE},
        {"GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY", "GdkPixbufError", GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY},
        {"GDK_PIXBUF_ERROR_BAD_OPTION", "GdkPixbufError", GDK_PIXBUF_ERROR_BAD_OPTION},
        {"GDK_PIXBUF_ERROR_UNKNOWN_TYPE", "GdkPixbufError", GDK_PIXBUF_ERROR_UNKNOWN_TYPE},
        {"GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION", "GdkPixbufError", GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION},
        {"GDK_PIXBUF_ERROR_FAILED", "GdkPixbufError", GDK_PIXBUF_ERROR_FAILED},
        {"GDK_INTERP_NEAREST", "GdkInterpType", GDK_INTERP_NEAREST},
        {"GDK_INTERP_TILES", "GdkInterpType", GDK_INTERP_TILES},
        {"GDK_INTERP_BILINEAR", "GdkInterpType", GDK_INTERP_BILINEAR},
        {"GDK_INTERP_HYPER", "GdkInterpType", GDK_INTERP_HYPER},
        {"GTK_ACCEL_VISIBLE", "GtkAccelFlags", GTK_ACCEL_VISIBLE},
        {"GTK_ACCEL_LOCKED", "GtkAccelFlags", GTK_ACCEL_LOCKED},
        {"GTK_ACCEL_MASK", "GtkAccelFlags", GTK_ACCEL_MASK},
        {"GTK_CALENDAR_SHOW_HEADING", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_HEADING},
        {"GTK_CALENDAR_SHOW_DAY_NAMES", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DAY_NAMES},
        {"GTK_CALENDAR_NO_MONTH_CHANGE", "GtkCalendarDisplayOptions", GTK_CALENDAR_NO_MONTH_CHANGE},
        {"GTK_CALENDAR_SHOW_WEEK_NUMBERS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_WEEK_NUMBERS},
        {"GTK_CELL_RENDERER_SELECTED", "GtkCellRendererState", GTK_CELL_RENDERER_SELECTED},
        {"GTK_CELL_RENDERER_PRELIT", "GtkCellRendererState", GTK_CELL_RENDERER_PRELIT},
        {"GTK_CELL_RENDERER_INSENSITIVE", "GtkCellRendererState", GTK_CELL_RENDERER_INSENSITIVE},
        {"GTK_CELL_RENDERER_SORTED", "GtkCellRendererState", GTK_CELL_RENDERER_SORTED},
        {"GTK_CELL_RENDERER_FOCUSED", "GtkCellRendererState", GTK_CELL_RENDERER_FOCUSED},
        {"GTK_DIALOG_MODAL", "GtkDialogFlags", GTK_DIALOG_MODAL},
        {"GTK_DIALOG_DESTROY_WITH_PARENT", "GtkDialogFlags", GTK_DIALOG_DESTROY_WITH_PARENT},
        {"GTK_RESPONSE_NONE", "GtkResponseType", GTK_RESPONSE_NONE},
        {"GTK_RESPONSE_REJECT", "GtkResponseType", GTK_RESPONSE_REJECT},
        {"GTK_RESPONSE_ACCEPT", "GtkResponseType", GTK_RESPONSE_ACCEPT},
        {"GTK_RESPONSE_DELETE_EVENT", "GtkResponseType", GTK_RESPONSE_DELETE_EVENT},
        {"GTK_RESPONSE_OK", "GtkResponseType", GTK_RESPONSE_OK},
        {"GTK_RESPONSE_CANCEL", "GtkResponseType", GTK_RESPONSE_CANCEL},
        {"GTK_RESPONSE_CLOSE", "GtkResponseType", GTK_RESPONSE_CLOSE},
        {"GTK_RESPONSE_YES", "GtkResponseType", GTK_RESPONSE_YES},
        {"GTK_RESPONSE_NO", "GtkResponseType", GTK_RESPONSE_NO},
        {"GTK_RESPONSE_APPLY", "GtkResponseType", GTK_RESPONSE_APPLY},
        {"GTK_RESPONSE_HELP", "GtkResponseType", GTK_RESPONSE_HELP},
        {"GTK_DEST_DEFAULT_MOTION", "GtkDestDefaults", GTK_DEST_DEFAULT_MOTION},
        {"GTK_DEST_DEFAULT_HIGHLIGHT", "GtkDestDefaults", GTK_DEST_DEFAULT_HIGHLIGHT},
        {"GTK_DEST_DEFAULT_DROP", "GtkDestDefaults", GTK_DEST_DEFAULT_DROP},
        {"GTK_DEST_DEFAULT_ALL", "GtkDestDefaults", GTK_DEST_DEFAULT_ALL},
        {"GTK_BUTTONBOX_SPREAD", "GtkButtonBoxStyle", GTK_BUTTONBOX_SPREAD},
        {"GTK_BUTTONBOX_EDGE", "GtkButtonBoxStyle", GTK_BUTTONBOX_EDGE},
        {"GTK_BUTTONBOX_START", "GtkButtonBoxStyle", GTK_BUTTONBOX_START},
        {"GTK_BUTTONBOX_END", "GtkButtonBoxStyle", GTK_BUTTONBOX_END},
        {"GTK_BUTTONBOX_CENTER", "GtkButtonBoxStyle", GTK_BUTTONBOX_CENTER},
        {"GTK_DELETE_CHARS", "GtkDeleteType", GTK_DELETE_CHARS},
        {"GTK_DELETE_WORD_ENDS", "GtkDeleteType", GTK_DELETE_WORD_ENDS},
        {"GTK_DELETE_WORDS", "GtkDeleteType", GTK_DELETE_WORDS},
        {"GTK_DELETE_DISPLAY_LINES", "GtkDeleteType", GTK_DELETE_DISPLAY_LINES},
        {"GTK_DELETE_DISPLAY_LINE_ENDS", "GtkDeleteType", GTK_DELETE_DISPLAY_LINE_ENDS},
        {"GTK_DELETE_PARAGRAPH_ENDS", "GtkDeleteType", GTK_DELETE_PARAGRAPH_ENDS},
        {"GTK_DELETE_PARAGRAPHS", "GtkDeleteType", GTK_DELETE_PARAGRAPHS},
        {"GTK_DELETE_WHITESPACE", "GtkDeleteType", GTK_DELETE_WHITESPACE},
        {"GTK_DIR_TAB_FORWARD", "GtkDirectionType", GTK_DIR_TAB_FORWARD},
        {"GTK_DIR_TAB_BACKWARD", "GtkDirectionType", GTK_DIR_TAB_BACKWARD},
        {"GTK_DIR_UP", "GtkDirectionType", GTK_DIR_UP},
        {"GTK_DIR_DOWN", "GtkDirectionType", GTK_DIR_DOWN},
        {"GTK_DIR_LEFT", "GtkDirectionType", GTK_DIR_LEFT},
        {"GTK_DIR_RIGHT", "GtkDirectionType", GTK_DIR_RIGHT},
        {"GTK_TEXT_DIR_NONE", "GtkTextDirection", GTK_TEXT_DIR_NONE},
        {"GTK_TEXT_DIR_LTR", "GtkTextDirection", GTK_TEXT_DIR_LTR},
        {"GTK_TEXT_DIR_RTL", "GtkTextDirection", GTK_TEXT_DIR_RTL},
        {"GTK_JUSTIFY_LEFT", "GtkJustification", GTK_JUSTIFY_LEFT},
        {"GTK_JUSTIFY_RIGHT", "GtkJustification", GTK_JUSTIFY_RIGHT},
        {"GTK_JUSTIFY_CENTER", "GtkJustification", GTK_JUSTIFY_CENTER},
        {"GTK_JUSTIFY_FILL", "GtkJustification", GTK_JUSTIFY_FILL},
        {"GTK_MENU_DIR_PARENT", "GtkMenuDirectionType", GTK_MENU_DIR_PARENT},
        {"GTK_MENU_DIR_CHILD", "GtkMenuDirectionType", GTK_MENU_DIR_CHILD},
        {"GTK_MENU_DIR_NEXT", "GtkMenuDirectionType", GTK_MENU_DIR_NEXT},
        {"GTK_MENU_DIR_PREV", "GtkMenuDirectionType", GTK_MENU_DIR_PREV},
        {"GTK_MOVEMENT_LOGICAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_LOGICAL_POSITIONS},
        {"GTK_MOVEMENT_VISUAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_VISUAL_POSITIONS},
        {"GTK_MOVEMENT_WORDS", "GtkMovementStep", GTK_MOVEMENT_WORDS},
        {"GTK_MOVEMENT_DISPLAY_LINES", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINES},
        {"GTK_MOVEMENT_DISPLAY_LINE_ENDS", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINE_ENDS},
        {"GTK_MOVEMENT_PARAGRAPHS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPHS},
        {"GTK_MOVEMENT_PARAGRAPH_ENDS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPH_ENDS},
        {"GTK_MOVEMENT_PAGES", "GtkMovementStep", GTK_MOVEMENT_PAGES},
        {"GTK_MOVEMENT_BUFFER_ENDS", "GtkMovementStep", GTK_MOVEMENT_BUFFER_ENDS},
        {"GTK_ORIENTATION_HORIZONTAL", "GtkOrientation", GTK_ORIENTATION_HORIZONTAL},
        {"GTK_ORIENTATION_VERTICAL", "GtkOrientation", GTK_ORIENTATION_VERTICAL},
        {"GTK_CORNER_TOP_LEFT", "GtkCornerType", GTK_CORNER_TOP_LEFT},
        {"GTK_CORNER_BOTTOM_LEFT", "GtkCornerType", GTK_CORNER_BOTTOM_LEFT},
        {"GTK_CORNER_TOP_RIGHT", "GtkCornerType", GTK_CORNER_TOP_RIGHT},
        {"GTK_CORNER_BOTTOM_RIGHT", "GtkCornerType", GTK_CORNER_BOTTOM_RIGHT},
        {"GTK_PACK_START", "GtkPackType", GTK_PACK_START},
        {"GTK_PACK_END", "GtkPackType", GTK_PACK_END},
        {"GTK_POLICY_ALWAYS", "GtkPolicyType", GTK_POLICY_ALWAYS},
        {"GTK_POLICY_AUTOMATIC", "GtkPolicyType", GTK_POLICY_AUTOMATIC},
        {"GTK_POLICY_NEVER", "GtkPolicyType", GTK_POLICY_NEVER},
        {"GTK_POS_LEFT", "GtkPositionType", GTK_POS_LEFT},
        {"GTK_POS_RIGHT", "GtkPositionType", GTK_POS_RIGHT},
        {"GTK_POS_TOP", "GtkPositionType", GTK_POS_TOP},
        {"GTK_POS_BOTTOM", "GtkPositionType", GTK_POS_BOTTOM},
        {"GTK_RELIEF_NORMAL", "GtkReliefStyle", GTK_RELIEF_NORMAL},
        {"GTK_RELIEF_HALF", "GtkReliefStyle", GTK_RELIEF_HALF},
        {"GTK_RELIEF_NONE", "GtkReliefStyle", GTK_RELIEF_NONE},
        {"GTK_RESIZE_PARENT", "GtkResizeMode", GTK_RESIZE_PARENT},
        {"GTK_RESIZE_QUEUE", "GtkResizeMode", GTK_RESIZE_QUEUE},
        {"GTK_RESIZE_IMMEDIATE", "GtkResizeMode", GTK_RESIZE_IMMEDIATE},
        {"GTK_SCROLL_NONE", "GtkScrollType", GTK_SCROLL_NONE},
        {"GTK_SCROLL_JUMP", "GtkScrollType", GTK_SCROLL_JUMP},
        {"GTK_SCROLL_STEP_BACKWARD", "GtkScrollType", GTK_SCROLL_STEP_BACKWARD},
        {"GTK_SCROLL_STEP_FORWARD", "GtkScrollType", GTK_SCROLL_STEP_FORWARD},
        {"GTK_SCROLL_PAGE_BACKWARD", "GtkScrollType", GTK_SCROLL_PAGE_BACKWARD},
        {"GTK_SCROLL_PAGE_FORWARD", "GtkScrollType", GTK_SCROLL_PAGE_FORWARD},
        {"GTK_SCROLL_STEP_UP", "GtkScrollType", GTK_SCROLL_STEP_UP},
        {"GTK_SCROLL_STEP_DOWN", "GtkScrollType", GTK_SCROLL_STEP_DOWN},
        {"GTK_SCROLL_PAGE_UP", "GtkScrollType", GTK_SCROLL_PAGE_UP},
        {"GTK_SCROLL_PAGE_DOWN", "GtkScrollType", GTK_SCROLL_PAGE_DOWN},
        {"GTK_SCROLL_STEP_LEFT", "GtkScrollType", GTK_SCROLL_STEP_LEFT},
        {"GTK_SCROLL_STEP_RIGHT", "GtkScrollType", GTK_SCROLL_STEP_RIGHT},
        {"GTK_SCROLL_PAGE_LEFT", "GtkScrollType", GTK_SCROLL_PAGE_LEFT},
        {"GTK_SCROLL_PAGE_RIGHT", "GtkScrollType", GTK_SCROLL_PAGE_RIGHT},
        {"GTK_SCROLL_START", "GtkScrollType", GTK_SCROLL_START},
        {"GTK_SCROLL_END", "GtkScrollType", GTK_SCROLL_END},
        {"GTK_SELECTION_NONE", "GtkSelectionMode", GTK_SELECTION_NONE},
        {"GTK_SELECTION_SINGLE", "GtkSelectionMode", GTK_SELECTION_SINGLE},
        {"GTK_SELECTION_BROWSE", "GtkSelectionMode", GTK_SELECTION_BROWSE},
        {"GTK_SELECTION_MULTIPLE", "GtkSelectionMode", GTK_SELECTION_MULTIPLE},
        {"GTK_SHADOW_NONE", "GtkShadowType", GTK_SHADOW_NONE},
        {"GTK_SHADOW_IN", "GtkShadowType", GTK_SHADOW_IN},
        {"GTK_SHADOW_OUT", "GtkShadowType", GTK_SHADOW_OUT},
        {"GTK_SHADOW_ETCHED_IN", "GtkShadowType", GTK_SHADOW_ETCHED_IN},
        {"GTK_SHADOW_ETCHED_OUT", "GtkShadowType", GTK_SHADOW_ETCHED_OUT},
        {"GTK_TOOLBAR_ICONS", "GtkToolbarStyle", GTK_TOOLBAR_ICONS},
        {"GTK_TOOLBAR_TEXT", "GtkToolbarStyle", GTK_TOOLBAR_TEXT},
        {"GTK_TOOLBAR_BOTH", "GtkToolbarStyle", GTK_TOOLBAR_BOTH},
        {"GTK_TOOLBAR_BOTH_HORIZ", "GtkToolbarStyle", GTK_TOOLBAR_BOTH_HORIZ},
        {"GTK_WIN_POS_NONE", "GtkWindowPosition", GTK_WIN_POS_NONE},
        {"GTK_WIN_POS_CENTER", "GtkWindowPosition", GTK_WIN_POS_CENTER},
        {"GTK_WIN_POS_MOUSE", "GtkWindowPosition", GTK_WIN_POS_MOUSE},
        {"GTK_WIN_POS_CENTER_ALWAYS", "GtkWindowPosition", GTK_WIN_POS_CENTER_ALWAYS},
        {"GTK_WIN_POS_CENTER_ON_PARENT", "GtkWindowPosition", GTK_WIN_POS_CENTER_ON_PARENT},
        {"GTK_WINDOW_TOPLEVEL", "GtkWindowType", GTK_WINDOW_TOPLEVEL},
        {"GTK_WINDOW_POPUP", "GtkWindowType", GTK_WINDOW_POPUP},
        {"GTK_WRAP_NONE", "GtkWrapMode", GTK_WRAP_NONE},
        {"GTK_WRAP_CHAR", "GtkWrapMode", GTK_WRAP_CHAR},
        {"GTK_WRAP_WORD", "GtkWrapMode", GTK_WRAP_WORD},
        {"GTK_SORT_ASCENDING", "GtkSortType", GTK_SORT_ASCENDING},
        {"GTK_SORT_DESCENDING", "GtkSortType", GTK_SORT_DESCENDING},
        {"GTK_IMAGE_EMPTY", "GtkImageType", GTK_IMAGE_EMPTY},
        {"GTK_IMAGE_PIXBUF", "GtkImageType", GTK_IMAGE_PIXBUF},
        {"GTK_IMAGE_STOCK", "GtkImageType", GTK_IMAGE_STOCK},
        {"GTK_IMAGE_ICON_SET", "GtkImageType", GTK_IMAGE_ICON_SET},
        {"GTK_IMAGE_ANIMATION", "GtkImageType", GTK_IMAGE_ANIMATION},
        {"GTK_MESSAGE_INFO", "GtkMessageType", GTK_MESSAGE_INFO},
        {"GTK_MESSAGE_WARNING", "GtkMessageType", GTK_MESSAGE_WARNING},
        {"GTK_MESSAGE_QUESTION", "GtkMessageType", GTK_MESSAGE_QUESTION},
        {"GTK_MESSAGE_ERROR", "GtkMessageType", GTK_MESSAGE_ERROR},
        {"GTK_BUTTONS_NONE", "GtkButtonsType", GTK_BUTTONS_NONE},
        {"GTK_BUTTONS_OK", "GtkButtonsType", GTK_BUTTONS_OK},
        {"GTK_BUTTONS_CLOSE", "GtkButtonsType", GTK_BUTTONS_CLOSE},
        {"GTK_BUTTONS_CANCEL", "GtkButtonsType", GTK_BUTTONS_CANCEL},
        {"GTK_BUTTONS_YES_NO", "GtkButtonsType", GTK_BUTTONS_YES_NO},
        {"GTK_BUTTONS_OK_CANCEL", "GtkButtonsType", GTK_BUTTONS_OK_CANCEL},
        {"GTK_NOTEBOOK_TAB_FIRST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_FIRST},
        {"GTK_NOTEBOOK_TAB_LAST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_LAST},
        {"GTK_SIZE_GROUP_NONE", "GtkSizeGroupMode", GTK_SIZE_GROUP_NONE},
        {"GTK_SIZE_GROUP_HORIZONTAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_HORIZONTAL},
        {"GTK_SIZE_GROUP_VERTICAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_VERTICAL},
        {"GTK_SIZE_GROUP_BOTH", "GtkSizeGroupMode", GTK_SIZE_GROUP_BOTH},
        {"GTK_UPDATE_ALWAYS", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_ALWAYS},
        {"GTK_UPDATE_IF_VALID", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_IF_VALID},
        {"GTK_SPIN_STEP_FORWARD", "GtkSpinType", GTK_SPIN_STEP_FORWARD},
        {"GTK_SPIN_STEP_BACKWARD", "GtkSpinType", GTK_SPIN_STEP_BACKWARD},
        {"GTK_SPIN_PAGE_FORWARD", "GtkSpinType", GTK_SPIN_PAGE_FORWARD},
        {"GTK_SPIN_PAGE_BACKWARD", "GtkSpinType", GTK_SPIN_PAGE_BACKWARD},
        {"GTK_SPIN_HOME", "GtkSpinType", GTK_SPIN_HOME},
        {"GTK_SPIN_END", "GtkSpinType", GTK_SPIN_END},
        {"GTK_TEXT_SEARCH_VISIBLE_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_VISIBLE_ONLY},
        {"GTK_TEXT_SEARCH_TEXT_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_TEXT_ONLY},
        {"GTK_TEXT_WINDOW_PRIVATE", "GtkTextWindowType", GTK_TEXT_WINDOW_PRIVATE},
        {"GTK_TEXT_WINDOW_WIDGET", "GtkTextWindowType", GTK_TEXT_WINDOW_WIDGET},
        {"GTK_TEXT_WINDOW_TEXT", "GtkTextWindowType", GTK_TEXT_WINDOW_TEXT},
        {"GTK_TEXT_WINDOW_LEFT", "GtkTextWindowType", GTK_TEXT_WINDOW_LEFT},
        {"GTK_TEXT_WINDOW_RIGHT", "GtkTextWindowType", GTK_TEXT_WINDOW_RIGHT},
        {"GTK_TEXT_WINDOW_TOP", "GtkTextWindowType", GTK_TEXT_WINDOW_TOP},
        {"GTK_TEXT_WINDOW_BOTTOM", "GtkTextWindowType", GTK_TEXT_WINDOW_BOTTOM},
        {"GTK_TREE_MODEL_ITERS_PERSIST", "GtkTreeModelFlags", GTK_TREE_MODEL_ITERS_PERSIST},
        {"GTK_TREE_MODEL_LIST_ONLY", "GtkTreeModelFlags", GTK_TREE_MODEL_LIST_ONLY},
        {"GTK_TREE_VIEW_COLUMN_GROW_ONLY", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_GROW_ONLY},
        {"GTK_TREE_VIEW_COLUMN_AUTOSIZE", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_AUTOSIZE},
        {"GTK_TREE_VIEW_COLUMN_FIXED", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_FIXED},
        {"GTK_TREE_VIEW_DROP_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_BEFORE},
        {"GTK_TREE_VIEW_DROP_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_AFTER},
        {"GTK_TREE_VIEW_DROP_INTO_OR_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_BEFORE},
        {"GTK_TREE_VIEW_DROP_INTO_OR_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_AFTER},
        {"PANGO_ATTR_INVALID", "PangoAttrType", PANGO_ATTR_INVALID},
        {"PANGO_ATTR_LANGUAGE", "PangoAttrType", PANGO_ATTR_LANGUAGE},
        {"PANGO_ATTR_FAMILY", "PangoAttrType", PANGO_ATTR_FAMILY},
        {"PANGO_ATTR_STYLE", "PangoAttrType", PANGO_ATTR_STYLE},
        {"PANGO_ATTR_WEIGHT", "PangoAttrType", PANGO_ATTR_WEIGHT},
        {"PANGO_ATTR_VARIANT", "PangoAttrType", PANGO_ATTR_VARIANT},
        {"PANGO_ATTR_STRETCH", "PangoAttrType", PANGO_ATTR_STRETCH},
        {"PANGO_ATTR_SIZE", "PangoAttrType", PANGO_ATTR_SIZE},
        {"PANGO_ATTR_FONT_DESC", "PangoAttrType", PANGO_ATTR_FONT_DESC},
        {"PANGO_ATTR_FOREGROUND", "PangoAttrType", PANGO_ATTR_FOREGROUND},
        {"PANGO_ATTR_BACKGROUND", "PangoAttrType", PANGO_ATTR_BACKGROUND},
        {"PANGO_ATTR_UNDERLINE", "PangoAttrType", PANGO_ATTR_UNDERLINE},
        {"PANGO_ATTR_STRIKETHROUGH", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH},
        {"PANGO_ATTR_RISE", "PangoAttrType", PANGO_ATTR_RISE},
        {"PANGO_ATTR_SHAPE", "PangoAttrType", PANGO_ATTR_SHAPE},
        {"PANGO_ATTR_SCALE", "PangoAttrType", PANGO_ATTR_SCALE},
        {"PANGO_UNDERLINE_NONE", "PangoUnderline", PANGO_UNDERLINE_NONE},
        {"PANGO_UNDERLINE_SINGLE", "PangoUnderline", PANGO_UNDERLINE_SINGLE},
        {"PANGO_UNDERLINE_DOUBLE", "PangoUnderline", PANGO_UNDERLINE_DOUBLE},
        {"PANGO_UNDERLINE_LOW", "PangoUnderline", PANGO_UNDERLINE_LOW},
        {"PANGO_COVERAGE_NONE", "PangoCoverageLevel", PANGO_COVERAGE_NONE},
        {"PANGO_COVERAGE_FALLBACK", "PangoCoverageLevel", PANGO_COVERAGE_FALLBACK},
        {"PANGO_COVERAGE_APPROXIMATE", "PangoCoverageLevel", PANGO_COVERAGE_APPROXIMATE},
        {"PANGO_COVERAGE_EXACT", "PangoCoverageLevel", PANGO_COVERAGE_EXACT},
        {"PANGO_STYLE_NORMAL", "PangoStyle", PANGO_STYLE_NORMAL},
        {"PANGO_STYLE_OBLIQUE", "PangoStyle", PANGO_STYLE_OBLIQUE},
        {"PANGO_STYLE_ITALIC", "PangoStyle", PANGO_STYLE_ITALIC},
        {"PANGO_VARIANT_NORMAL", "PangoVariant", PANGO_VARIANT_NORMAL},
        {"PANGO_VARIANT_SMALL_CAPS", "PangoVariant", PANGO_VARIANT_SMALL_CAPS},
        {"PANGO_WEIGHT_ULTRALIGHT", "PangoWeight", PANGO_WEIGHT_ULTRALIGHT},
        {"PANGO_WEIGHT_LIGHT", "PangoWeight", PANGO_WEIGHT_LIGHT},
        {"PANGO_WEIGHT_NORMAL", "PangoWeight", PANGO_WEIGHT_NORMAL},
        {"PANGO_WEIGHT_BOLD", "PangoWeight", PANGO_WEIGHT_BOLD},
        {"PANGO_WEIGHT_ULTRABOLD", "PangoWeight", PANGO_WEIGHT_ULTRABOLD},
        {"PANGO_WEIGHT_HEAVY", "PangoWeight", PANGO_WEIGHT_HEAVY},
        {"PANGO_STRETCH_ULTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_ULTRA_CONDENSED},
        {"PANGO_STRETCH_EXTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_EXTRA_CONDENSED},
        {"PANGO_STRETCH_CONDENSED", "PangoStretch", PANGO_STRETCH_CONDENSED},
        {"PANGO_STRETCH_SEMI_CONDENSED", "PangoStretch", PANGO_STRETCH_SEMI_CONDENSED},
        {"PANGO_STRETCH_NORMAL", "PangoStretch", PANGO_STRETCH_NORMAL},
        {"PANGO_STRETCH_SEMI_EXPANDED", "PangoStretch", PANGO_STRETCH_SEMI_EXPANDED},
        {"PANGO_STRETCH_EXPANDED", "PangoStretch", PANGO_STRETCH_EXPANDED},
        {"PANGO_STRETCH_EXTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_EXTRA_EXPANDED},
        {"PANGO_STRETCH_ULTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_ULTRA_EXPANDED},
        {"PANGO_FONT_MASK_FAMILY", "PangoFontMask", PANGO_FONT_MASK_FAMILY},
        {"PANGO_FONT_MASK_STYLE", "PangoFontMask", PANGO_FONT_MASK_STYLE},
        {"PANGO_FONT_MASK_VARIANT", "PangoFontMask", PANGO_FONT_MASK_VARIANT},
        {"PANGO_FONT_MASK_WEIGHT", "PangoFontMask", PANGO_FONT_MASK_WEIGHT},
        {"PANGO_FONT_MASK_STRETCH", "PangoFontMask", PANGO_FONT_MASK_STRETCH},
        {"PANGO_FONT_MASK_SIZE", "PangoFontMask", PANGO_FONT_MASK_SIZE},
        {"PANGO_ALIGN_LEFT", "PangoAlignment", PANGO_ALIGN_LEFT},
        {"PANGO_ALIGN_CENTER", "PangoAlignment", PANGO_ALIGN_CENTER},
        {"PANGO_ALIGN_RIGHT", "PangoAlignment", PANGO_ALIGN_RIGHT},
        {"PANGO_WRAP_WORD", "PangoWrapMode", PANGO_WRAP_WORD},
        {"PANGO_WRAP_CHAR", "PangoWrapMode", PANGO_WRAP_CHAR},
        {"PANGO_DIRECTION_LTR", "PangoDirection", PANGO_DIRECTION_LTR},
        {"PANGO_DIRECTION_RTL", "PangoDirection", PANGO_DIRECTION_RTL},
        {"PANGO_DIRECTION_TTB_LTR", "PangoDirection", PANGO_DIRECTION_TTB_LTR},
        {"PANGO_DIRECTION_TTB_RTL", "PangoDirection", PANGO_DIRECTION_TTB_RTL},
        {"GDK_WINDOW_STATE_FULLSCREEN", "GdkWindowState", GDK_WINDOW_STATE_FULLSCREEN},
        {"GDK_WINDOW_STATE_ABOVE", "GdkWindowState", GDK_WINDOW_STATE_ABOVE},
        {"GDK_WINDOW_STATE_BELOW", "GdkWindowState", GDK_WINDOW_STATE_BELOW},
        {"GTK_MOVEMENT_HORIZONTAL_PAGES", "GtkMovementStep", GTK_MOVEMENT_HORIZONTAL_PAGES},
        {"GTK_SCROLL_STEPS", "GtkScrollStep", GTK_SCROLL_STEPS},
        {"GTK_SCROLL_PAGES", "GtkScrollStep", GTK_SCROLL_PAGES},
        {"GTK_SCROLL_ENDS", "GtkScrollStep", GTK_SCROLL_ENDS},
        {"GTK_SCROLL_HORIZONTAL_STEPS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_STEPS},
        {"GTK_SCROLL_HORIZONTAL_PAGES", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_PAGES},
        {"GTK_SCROLL_HORIZONTAL_ENDS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_ENDS},
        {"GTK_WRAP_WORD_CHAR", "GtkWrapMode", GTK_WRAP_WORD_CHAR},
        {"GTK_FILE_FILTER_FILENAME", "GtkFileFilterFlags", GTK_FILE_FILTER_FILENAME},
        {"GTK_FILE_FILTER_URI", "GtkFileFilterFlags", GTK_FILE_FILTER_URI},
        {"GTK_FILE_FILTER_DISPLAY_NAME", "GtkFileFilterFlags", GTK_FILE_FILTER_DISPLAY_NAME},
        {"GTK_FILE_FILTER_MIME_TYPE", "GtkFileFilterFlags", GTK_FILE_FILTER_MIME_TYPE},
        {"GTK_ICON_LOOKUP_NO_SVG", "GtkIconLookupFlags", GTK_ICON_LOOKUP_NO_SVG},
        {"GTK_ICON_LOOKUP_FORCE_SVG", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_SVG},
        {"GTK_ICON_LOOKUP_USE_BUILTIN", "GtkIconLookupFlags", GTK_ICON_LOOKUP_USE_BUILTIN},
        {"GTK_ICON_LOOKUP_GENERIC_FALLBACK", "GtkIconLookupFlags", GTK_ICON_LOOKUP_GENERIC_FALLBACK},
        {"GTK_FILE_CHOOSER_ACTION_OPEN", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_OPEN},
        {"GTK_FILE_CHOOSER_ACTION_SAVE", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SAVE},
        {"GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER},
        {"GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER},
        {"PANGO_ATTR_FALLBACK", "PangoAttrType", PANGO_ATTR_FALLBACK},
        {"PANGO_ATTR_LETTER_SPACING", "PangoAttrType", PANGO_ATTR_LETTER_SPACING},
        {"PANGO_UNDERLINE_ERROR", "PangoUnderline", PANGO_UNDERLINE_ERROR},
        {"PANGO_WRAP_WORD_CHAR", "PangoWrapMode", PANGO_WRAP_WORD_CHAR},
        {"PANGO_ELLIPSIZE_NONE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_NONE},
        {"PANGO_ELLIPSIZE_START", "PangoEllipsizeMode", PANGO_ELLIPSIZE_START},
        {"PANGO_ELLIPSIZE_MIDDLE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_MIDDLE},
        {"PANGO_ELLIPSIZE_END", "PangoEllipsizeMode", PANGO_ELLIPSIZE_END},
        {"PANGO_SCRIPT_INVALID_CODE", "PangoScript", PANGO_SCRIPT_INVALID_CODE},
        {"PANGO_SCRIPT_COMMON", "PangoScript", PANGO_SCRIPT_COMMON},
        {"PANGO_SCRIPT_INHERITED", "PangoScript", PANGO_SCRIPT_INHERITED},
        {"PANGO_SCRIPT_ARABIC", "PangoScript", PANGO_SCRIPT_ARABIC},
        {"PANGO_SCRIPT_ARMENIAN", "PangoScript", PANGO_SCRIPT_ARMENIAN},
        {"PANGO_SCRIPT_BENGALI", "PangoScript", PANGO_SCRIPT_BENGALI},
        {"PANGO_SCRIPT_BOPOMOFO", "PangoScript", PANGO_SCRIPT_BOPOMOFO},
        {"PANGO_SCRIPT_CHEROKEE", "PangoScript", PANGO_SCRIPT_CHEROKEE},
        {"PANGO_SCRIPT_COPTIC", "PangoScript", PANGO_SCRIPT_COPTIC},
        {"PANGO_SCRIPT_CYRILLIC", "PangoScript", PANGO_SCRIPT_CYRILLIC},
        {"PANGO_SCRIPT_DESERET", "PangoScript", PANGO_SCRIPT_DESERET},
        {"PANGO_SCRIPT_DEVANAGARI", "PangoScript", PANGO_SCRIPT_DEVANAGARI},
        {"PANGO_SCRIPT_ETHIOPIC", "PangoScript", PANGO_SCRIPT_ETHIOPIC},
        {"PANGO_SCRIPT_GEORGIAN", "PangoScript", PANGO_SCRIPT_GEORGIAN},
        {"PANGO_SCRIPT_GOTHIC", "PangoScript", PANGO_SCRIPT_GOTHIC},
        {"PANGO_SCRIPT_GREEK", "PangoScript", PANGO_SCRIPT_GREEK},
        {"PANGO_SCRIPT_GUJARATI", "PangoScript", PANGO_SCRIPT_GUJARATI},
        {"PANGO_SCRIPT_GURMUKHI", "PangoScript", PANGO_SCRIPT_GURMUKHI},
        {"PANGO_SCRIPT_HAN", "PangoScript", PANGO_SCRIPT_HAN},
        {"PANGO_SCRIPT_HANGUL", "PangoScript", PANGO_SCRIPT_HANGUL},
        {"PANGO_SCRIPT_HEBREW", "PangoScript", PANGO_SCRIPT_HEBREW},
        {"PANGO_SCRIPT_HIRAGANA", "PangoScript", PANGO_SCRIPT_HIRAGANA},
        {"PANGO_SCRIPT_KANNADA", "PangoScript", PANGO_SCRIPT_KANNADA},
        {"PANGO_SCRIPT_KATAKANA", "PangoScript", PANGO_SCRIPT_KATAKANA},
        {"PANGO_SCRIPT_KHMER", "PangoScript", PANGO_SCRIPT_KHMER},
        {"PANGO_SCRIPT_LAO", "PangoScript", PANGO_SCRIPT_LAO},
        {"PANGO_SCRIPT_LATIN", "PangoScript", PANGO_SCRIPT_LATIN},
        {"PANGO_SCRIPT_MALAYALAM", "PangoScript", PANGO_SCRIPT_MALAYALAM},
        {"PANGO_SCRIPT_MONGOLIAN", "PangoScript", PANGO_SCRIPT_MONGOLIAN},
        {"PANGO_SCRIPT_MYANMAR", "PangoScript", PANGO_SCRIPT_MYANMAR},
        {"PANGO_SCRIPT_OGHAM", "PangoScript", PANGO_SCRIPT_OGHAM},
        {"PANGO_SCRIPT_OLD_ITALIC", "PangoScript", PANGO_SCRIPT_OLD_ITALIC},
        {"PANGO_SCRIPT_ORIYA", "PangoScript", PANGO_SCRIPT_ORIYA},
        {"PANGO_SCRIPT_RUNIC", "PangoScript", PANGO_SCRIPT_RUNIC},
        {"PANGO_SCRIPT_SINHALA", "PangoScript", PANGO_SCRIPT_SINHALA},
        {"PANGO_SCRIPT_SYRIAC", "PangoScript", PANGO_SCRIPT_SYRIAC},
        {"PANGO_SCRIPT_TAMIL", "PangoScript", PANGO_SCRIPT_TAMIL},
        {"PANGO_SCRIPT_TELUGU", "PangoScript", PANGO_SCRIPT_TELUGU},
        {"PANGO_SCRIPT_THAANA", "PangoScript", PANGO_SCRIPT_THAANA},
        {"PANGO_SCRIPT_THAI", "PangoScript", PANGO_SCRIPT_THAI},
        {"PANGO_SCRIPT_TIBETAN", "PangoScript", PANGO_SCRIPT_TIBETAN},
        {"PANGO_SCRIPT_CANADIAN_ABORIGINAL", "PangoScript", PANGO_SCRIPT_CANADIAN_ABORIGINAL},
        {"PANGO_SCRIPT_YI", "PangoScript", PANGO_SCRIPT_YI},
        {"PANGO_SCRIPT_TAGALOG", "PangoScript", PANGO_SCRIPT_TAGALOG},
        {"PANGO_SCRIPT_HANUNOO", "PangoScript", PANGO_SCRIPT_HANUNOO},
        {"PANGO_SCRIPT_BUHID", "PangoScript", PANGO_SCRIPT_BUHID},
        {"PANGO_SCRIPT_TAGBANWA", "PangoScript", PANGO_SCRIPT_TAGBANWA},
        {"PANGO_SCRIPT_BRAILLE", "PangoScript", PANGO_SCRIPT_BRAILLE},
        {"PANGO_SCRIPT_CYPRIOT", "PangoScript", PANGO_SCRIPT_CYPRIOT},
        {"PANGO_SCRIPT_LIMBU", "PangoScript", PANGO_SCRIPT_LIMBU},
        {"PANGO_SCRIPT_OSMANYA", "PangoScript", PANGO_SCRIPT_OSMANYA},
        {"PANGO_SCRIPT_SHAVIAN", "PangoScript", PANGO_SCRIPT_SHAVIAN},
        {"PANGO_SCRIPT_LINEAR_B", "PangoScript", PANGO_SCRIPT_LINEAR_B},
        {"PANGO_SCRIPT_TAI_LE", "PangoScript", PANGO_SCRIPT_TAI_LE},
        {"PANGO_SCRIPT_UGARITIC", "PangoScript", PANGO_SCRIPT_UGARITIC},
        {"PANGO_TAB_LEFT", "PangoTabAlign", PANGO_TAB_LEFT},
        {"PANGO_DIRECTION_WEAK_LTR", "PangoDirection", PANGO_DIRECTION_WEAK_LTR},
        {"PANGO_DIRECTION_WEAK_RTL", "PangoDirection", PANGO_DIRECTION_WEAK_RTL},
        {"PANGO_DIRECTION_NEUTRAL", "PangoDirection", PANGO_DIRECTION_NEUTRAL},
        {"GTK_IMAGE_ICON_NAME", "GtkImageType", GTK_IMAGE_ICON_NAME},
        {"PANGO_ATTR_UNDERLINE_COLOR", "PangoAttrType", PANGO_ATTR_UNDERLINE_COLOR},
        {"PANGO_ATTR_STRIKETHROUGH_COLOR", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH_COLOR},
        {"PANGO_RENDER_PART_FOREGROUND", "PangoRenderPart", PANGO_RENDER_PART_FOREGROUND},
        {"PANGO_RENDER_PART_BACKGROUND", "PangoRenderPart", PANGO_RENDER_PART_BACKGROUND},
        {"PANGO_RENDER_PART_UNDERLINE", "PangoRenderPart", PANGO_RENDER_PART_UNDERLINE},
        {"PANGO_RENDER_PART_STRIKETHROUGH", "PangoRenderPart", PANGO_RENDER_PART_STRIKETHROUGH},
        {"G_LOG_FLAG_RECURSION", "GLogLevelFlags", G_LOG_FLAG_RECURSION},
        {"G_LOG_FLAG_FATAL", "GLogLevelFlags", G_LOG_FLAG_FATAL},
        {"G_LOG_LEVEL_ERROR", "GLogLevelFlags", G_LOG_LEVEL_ERROR},
        {"G_LOG_LEVEL_CRITICAL", "GLogLevelFlags", G_LOG_LEVEL_CRITICAL},
        {"G_LOG_LEVEL_WARNING", "GLogLevelFlags", G_LOG_LEVEL_WARNING},
        {"G_LOG_LEVEL_MESSAGE", "GLogLevelFlags", G_LOG_LEVEL_MESSAGE},
        {"G_LOG_LEVEL_INFO", "GLogLevelFlags", G_LOG_LEVEL_INFO},
        {"G_LOG_LEVEL_DEBUG", "GLogLevelFlags", G_LOG_LEVEL_DEBUG},
        {"G_LOG_LEVEL_MASK", "GLogLevelFlags", G_LOG_LEVEL_MASK},
        {"G_LOG_FATAL_MASK", "GLogLevelFlags", G_LOG_FATAL_MASK},
        {"GTK_PACK_DIRECTION_LTR", "GtkPackDirection", GTK_PACK_DIRECTION_LTR},
        {"GTK_PACK_DIRECTION_RTL", "GtkPackDirection", GTK_PACK_DIRECTION_RTL},
        {"GTK_PACK_DIRECTION_TTB", "GtkPackDirection", GTK_PACK_DIRECTION_TTB},
        {"GTK_PACK_DIRECTION_BTT", "GtkPackDirection", GTK_PACK_DIRECTION_BTT},
        {"GTK_ICON_VIEW_NO_DROP", "GtkIconViewDropPosition", GTK_ICON_VIEW_NO_DROP},
        {"GTK_ICON_VIEW_DROP_INTO", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_INTO},
        {"GTK_ICON_VIEW_DROP_LEFT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_LEFT},
        {"GTK_ICON_VIEW_DROP_RIGHT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_RIGHT},
        {"GTK_ICON_VIEW_DROP_ABOVE", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_ABOVE},
        {"GTK_ICON_VIEW_DROP_BELOW", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_BELOW},
        {"GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM},
        {"GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME},
        {"GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN", "GtkFileChooserConfirmation", GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN},
        {"PANGO_SCRIPT_NEW_TAI_LUE", "PangoScript", PANGO_SCRIPT_NEW_TAI_LUE},
        {"PANGO_SCRIPT_BUGINESE", "PangoScript", PANGO_SCRIPT_BUGINESE},
        {"PANGO_SCRIPT_GLAGOLITIC", "PangoScript", PANGO_SCRIPT_GLAGOLITIC},
        {"PANGO_SCRIPT_TIFINAGH", "PangoScript", PANGO_SCRIPT_TIFINAGH},
        {"PANGO_SCRIPT_SYLOTI_NAGRI", "PangoScript", PANGO_SCRIPT_SYLOTI_NAGRI},
        {"PANGO_SCRIPT_OLD_PERSIAN", "PangoScript", PANGO_SCRIPT_OLD_PERSIAN},
        {"PANGO_SCRIPT_KHAROSHTHI", "PangoScript", PANGO_SCRIPT_KHAROSHTHI},
        {"GDK_SUPER_MASK", "GdkModifierType", GDK_SUPER_MASK},
        {"GDK_HYPER_MASK", "GdkModifierType", GDK_HYPER_MASK},
        {"GDK_META_MASK", "GdkModifierType", GDK_META_MASK},
        {"GTK_SENSITIVITY_AUTO", "GtkSensitivityType", GTK_SENSITIVITY_AUTO},
        {"GTK_SENSITIVITY_ON", "GtkSensitivityType", GTK_SENSITIVITY_ON},
        {"GTK_SENSITIVITY_OFF", "GtkSensitivityType", GTK_SENSITIVITY_OFF},
        {"GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS},
        {"GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT},
        {"GTK_TEXT_BUFFER_TARGET_INFO_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_TEXT},
        {"GTK_ASSISTANT_PAGE_CONTENT", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONTENT},
        {"GTK_ASSISTANT_PAGE_INTRO", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_INTRO},
        {"GTK_ASSISTANT_PAGE_CONFIRM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONFIRM},
        {"GTK_ASSISTANT_PAGE_SUMMARY", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_SUMMARY},
        {"GTK_ASSISTANT_PAGE_PROGRESS", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_PROGRESS},
        {"GTK_CELL_RENDERER_ACCEL_MODE_GTK", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_GTK},
        {"GTK_CELL_RENDERER_ACCEL_MODE_OTHER", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER},
        {"GTK_RECENT_SORT_NONE", "GtkRecentSortType", GTK_RECENT_SORT_NONE},
        {"GTK_RECENT_SORT_MRU", "GtkRecentSortType", GTK_RECENT_SORT_MRU},
        {"GTK_RECENT_SORT_LRU", "GtkRecentSortType", GTK_RECENT_SORT_LRU},
        {"GTK_RECENT_SORT_CUSTOM", "GtkRecentSortType", GTK_RECENT_SORT_CUSTOM},
        {"GTK_RECENT_CHOOSER_ERROR_NOT_FOUND", "GtkRecentChooserError", GTK_RECENT_CHOOSER_ERROR_NOT_FOUND},
        {"GTK_RECENT_CHOOSER_ERROR_INVALID_URI", "GtkRecentChooserError", GTK_RECENT_CHOOSER_ERROR_INVALID_URI},
        {"GTK_RECENT_MANAGER_ERROR_NOT_FOUND", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_FOUND},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_URI", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_URI},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING},
        {"GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED},
        {"GTK_RECENT_MANAGER_ERROR_READ", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_READ},
        {"GTK_RECENT_MANAGER_ERROR_WRITE", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_WRITE},
        {"GTK_RECENT_MANAGER_ERROR_UNKNOWN", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_UNKNOWN},
        {"GTK_MESSAGE_OTHER", "GtkMessageType", GTK_MESSAGE_OTHER},
        {"GTK_TREE_VIEW_GRID_LINES_NONE", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_NONE},
        {"GTK_TREE_VIEW_GRID_LINES_HORIZONTAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_HORIZONTAL},
        {"GTK_TREE_VIEW_GRID_LINES_VERTICAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_VERTICAL},
        {"GTK_TREE_VIEW_GRID_LINES_BOTH", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_BOTH},
        {"GTK_PRINT_STATUS_INITIAL", "GtkPrintStatus", GTK_PRINT_STATUS_INITIAL},
        {"GTK_PRINT_STATUS_PREPARING", "GtkPrintStatus", GTK_PRINT_STATUS_PREPARING},
        {"GTK_PRINT_STATUS_GENERATING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_GENERATING_DATA},
        {"GTK_PRINT_STATUS_SENDING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_SENDING_DATA},
        {"GTK_PRINT_STATUS_PENDING", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING},
        {"GTK_PRINT_STATUS_PENDING_ISSUE", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING_ISSUE},
        {"GTK_PRINT_STATUS_PRINTING", "GtkPrintStatus", GTK_PRINT_STATUS_PRINTING},
        {"GTK_PRINT_STATUS_FINISHED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED},
        {"GTK_PRINT_STATUS_FINISHED_ABORTED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED_ABORTED},
        {"GTK_PRINT_OPERATION_RESULT_ERROR", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_ERROR},
        {"GTK_PRINT_OPERATION_RESULT_APPLY", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_APPLY},
        {"GTK_PRINT_OPERATION_RESULT_CANCEL", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_CANCEL},
        {"GTK_PRINT_OPERATION_RESULT_IN_PROGRESS", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_IN_PROGRESS},
        {"GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG},
        {"GTK_PRINT_OPERATION_ACTION_PRINT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT},
        {"GTK_PRINT_OPERATION_ACTION_PREVIEW", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PREVIEW},
        {"GTK_PRINT_OPERATION_ACTION_EXPORT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_EXPORT},
        {"GTK_PRINT_ERROR_GENERAL", "GtkPrintError", GTK_PRINT_ERROR_GENERAL},
        {"GTK_PRINT_ERROR_INTERNAL_ERROR", "GtkPrintError", GTK_PRINT_ERROR_INTERNAL_ERROR},
        {"GTK_PRINT_ERROR_NOMEM", "GtkPrintError", GTK_PRINT_ERROR_NOMEM},
        {"GTK_PRINT_ERROR_INVALID_FILE", "GtkPrintError", GTK_PRINT_ERROR_INVALID_FILE},
        {"CAIRO_STATUS_SUCCESS", "cairo_status_t", CAIRO_STATUS_SUCCESS},
        {"CAIRO_STATUS_NO_MEMORY", "cairo_status_t", CAIRO_STATUS_NO_MEMORY},
        {"CAIRO_STATUS_INVALID_RESTORE", "cairo_status_t", CAIRO_STATUS_INVALID_RESTORE},
        {"CAIRO_STATUS_INVALID_POP_GROUP", "cairo_status_t", CAIRO_STATUS_INVALID_POP_GROUP},
        {"CAIRO_STATUS_NO_CURRENT_POINT", "cairo_status_t", CAIRO_STATUS_NO_CURRENT_POINT},
        {"CAIRO_STATUS_INVALID_MATRIX", "cairo_status_t", CAIRO_STATUS_INVALID_MATRIX},
        {"CAIRO_STATUS_INVALID_STATUS", "cairo_status_t", CAIRO_STATUS_INVALID_STATUS},
        {"CAIRO_STATUS_NULL_POINTER", "cairo_status_t", CAIRO_STATUS_NULL_POINTER},
        {"CAIRO_STATUS_INVALID_STRING", "cairo_status_t", CAIRO_STATUS_INVALID_STRING},
        {"CAIRO_STATUS_INVALID_PATH_DATA", "cairo_status_t", CAIRO_STATUS_INVALID_PATH_DATA},
        {"CAIRO_STATUS_READ_ERROR", "cairo_status_t", CAIRO_STATUS_READ_ERROR},
        {"CAIRO_STATUS_WRITE_ERROR", "cairo_status_t", CAIRO_STATUS_WRITE_ERROR},
        {"CAIRO_STATUS_SURFACE_FINISHED", "cairo_status_t", CAIRO_STATUS_SURFACE_FINISHED},
        {"CAIRO_STATUS_SURFACE_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_SURFACE_TYPE_MISMATCH},
        {"CAIRO_STATUS_PATTERN_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_PATTERN_TYPE_MISMATCH},
        {"CAIRO_STATUS_INVALID_CONTENT", "cairo_status_t", CAIRO_STATUS_INVALID_CONTENT},
        {"CAIRO_STATUS_INVALID_FORMAT", "cairo_status_t", CAIRO_STATUS_INVALID_FORMAT},
        {"CAIRO_STATUS_INVALID_VISUAL", "cairo_status_t", CAIRO_STATUS_INVALID_VISUAL},
        {"CAIRO_STATUS_FILE_NOT_FOUND", "cairo_status_t", CAIRO_STATUS_FILE_NOT_FOUND},
        {"CAIRO_STATUS_INVALID_DASH", "cairo_status_t", CAIRO_STATUS_INVALID_DASH},
        {"CAIRO_STATUS_INVALID_DSC_COMMENT", "cairo_status_t", CAIRO_STATUS_INVALID_DSC_COMMENT},
        {"CAIRO_STATUS_INVALID_INDEX", "cairo_status_t", CAIRO_STATUS_INVALID_INDEX},
        {"CAIRO_STATUS_CLIP_NOT_REPRESENTABLE", "cairo_status_t", CAIRO_STATUS_CLIP_NOT_REPRESENTABLE},
        {"CAIRO_STATUS_TEMP_FILE_ERROR", "cairo_status_t", CAIRO_STATUS_TEMP_FILE_ERROR},
        {"CAIRO_STATUS_INVALID_STRIDE", "cairo_status_t", CAIRO_STATUS_INVALID_STRIDE},
        {"CAIRO_CONTENT_COLOR", "cairo_content_t", CAIRO_CONTENT_COLOR},
        {"CAIRO_CONTENT_ALPHA", "cairo_content_t", CAIRO_CONTENT_ALPHA},
        {"CAIRO_CONTENT_COLOR_ALPHA", "cairo_content_t", CAIRO_CONTENT_COLOR_ALPHA},
        {"CAIRO_OPERATOR_CLEAR", "cairo_operator_t", CAIRO_OPERATOR_CLEAR},
        {"CAIRO_OPERATOR_SOURCE", "cairo_operator_t", CAIRO_OPERATOR_SOURCE},
        {"CAIRO_OPERATOR_OVER", "cairo_operator_t", CAIRO_OPERATOR_OVER},
        {"CAIRO_OPERATOR_IN", "cairo_operator_t", CAIRO_OPERATOR_IN},
        {"CAIRO_OPERATOR_OUT", "cairo_operator_t", CAIRO_OPERATOR_OUT},
        {"CAIRO_OPERATOR_ATOP", "cairo_operator_t", CAIRO_OPERATOR_ATOP},
        {"CAIRO_OPERATOR_DEST", "cairo_operator_t", CAIRO_OPERATOR_DEST},
        {"CAIRO_OPERATOR_DEST_OVER", "cairo_operator_t", CAIRO_OPERATOR_DEST_OVER},
        {"CAIRO_OPERATOR_DEST_IN", "cairo_operator_t", CAIRO_OPERATOR_DEST_IN},
        {"CAIRO_OPERATOR_DEST_OUT", "cairo_operator_t", CAIRO_OPERATOR_DEST_OUT},
        {"CAIRO_OPERATOR_DEST_ATOP", "cairo_operator_t", CAIRO_OPERATOR_DEST_ATOP},
        {"CAIRO_OPERATOR_XOR", "cairo_operator_t", CAIRO_OPERATOR_XOR},
        {"CAIRO_OPERATOR_ADD", "cairo_operator_t", CAIRO_OPERATOR_ADD},
        {"CAIRO_OPERATOR_SATURATE", "cairo_operator_t", CAIRO_OPERATOR_SATURATE},
        {"CAIRO_ANTIALIAS_DEFAULT", "cairo_antialias_t", CAIRO_ANTIALIAS_DEFAULT},
        {"CAIRO_ANTIALIAS_NONE", "cairo_antialias_t", CAIRO_ANTIALIAS_NONE},
        {"CAIRO_ANTIALIAS_GRAY", "cairo_antialias_t", CAIRO_ANTIALIAS_GRAY},
        {"CAIRO_ANTIALIAS_SUBPIXEL", "cairo_antialias_t", CAIRO_ANTIALIAS_SUBPIXEL},
        {"CAIRO_FILL_RULE_WINDING", "cairo_fill_rule_t", CAIRO_FILL_RULE_WINDING},
        {"CAIRO_FILL_RULE_EVEN_ODD", "cairo_fill_rule_t", CAIRO_FILL_RULE_EVEN_ODD},
        {"CAIRO_LINE_CAP_BUTT", "cairo_line_cap_t", CAIRO_LINE_CAP_BUTT},
        {"CAIRO_LINE_CAP_ROUND", "cairo_line_cap_t", CAIRO_LINE_CAP_ROUND},
        {"CAIRO_LINE_CAP_SQUARE", "cairo_line_cap_t", CAIRO_LINE_CAP_SQUARE},
        {"CAIRO_LINE_JOIN_MITER", "cairo_line_join_t", CAIRO_LINE_JOIN_MITER},
        {"CAIRO_LINE_JOIN_ROUND", "cairo_line_join_t", CAIRO_LINE_JOIN_ROUND},
        {"CAIRO_LINE_JOIN_BEVEL", "cairo_line_join_t", CAIRO_LINE_JOIN_BEVEL},
        {"CAIRO_FONT_SLANT_NORMAL", "cairo_font_slant_t", CAIRO_FONT_SLANT_NORMAL},
        {"CAIRO_FONT_SLANT_ITALIC", "cairo_font_slant_t", CAIRO_FONT_SLANT_ITALIC},
        {"CAIRO_FONT_SLANT_OBLIQUE", "cairo_font_slant_t", CAIRO_FONT_SLANT_OBLIQUE},
        {"CAIRO_FONT_WEIGHT_NORMAL", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_NORMAL},
        {"CAIRO_FONT_WEIGHT_BOLD", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_BOLD},
        {"CAIRO_SUBPIXEL_ORDER_DEFAULT", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_DEFAULT},
        {"CAIRO_SUBPIXEL_ORDER_RGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_RGB},
        {"CAIRO_SUBPIXEL_ORDER_BGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_BGR},
        {"CAIRO_SUBPIXEL_ORDER_VRGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VRGB},
        {"CAIRO_SUBPIXEL_ORDER_VBGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VBGR},
        {"CAIRO_HINT_STYLE_DEFAULT", "cairo_hint_style_t", CAIRO_HINT_STYLE_DEFAULT},
        {"CAIRO_HINT_STYLE_NONE", "cairo_hint_style_t", CAIRO_HINT_STYLE_NONE},
        {"CAIRO_HINT_STYLE_SLIGHT", "cairo_hint_style_t", CAIRO_HINT_STYLE_SLIGHT},
        {"CAIRO_HINT_STYLE_MEDIUM", "cairo_hint_style_t", CAIRO_HINT_STYLE_MEDIUM},
        {"CAIRO_HINT_STYLE_FULL", "cairo_hint_style_t", CAIRO_HINT_STYLE_FULL},
        {"CAIRO_HINT_METRICS_DEFAULT", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_DEFAULT},
        {"CAIRO_HINT_METRICS_OFF", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_OFF},
        {"CAIRO_HINT_METRICS_ON", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_ON},
        {"CAIRO_FONT_TYPE_TOY", "cairo_font_type_t", CAIRO_FONT_TYPE_TOY},
        {"CAIRO_FONT_TYPE_FT", "cairo_font_type_t", CAIRO_FONT_TYPE_FT},
        {"CAIRO_FONT_TYPE_WIN32", "cairo_font_type_t", CAIRO_FONT_TYPE_WIN32},
        {"CAIRO_FONT_TYPE_QUARTZ", "cairo_font_type_t", CAIRO_FONT_TYPE_QUARTZ},
        {"CAIRO_PATH_MOVE_TO", "cairo_path_data_type_t", CAIRO_PATH_MOVE_TO},
        {"CAIRO_PATH_LINE_TO", "cairo_path_data_type_t", CAIRO_PATH_LINE_TO},
        {"CAIRO_PATH_CURVE_TO", "cairo_path_data_type_t", CAIRO_PATH_CURVE_TO},
        {"CAIRO_PATH_CLOSE_PATH", "cairo_path_data_type_t", CAIRO_PATH_CLOSE_PATH},
        {"CAIRO_SURFACE_TYPE_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_IMAGE},
        {"CAIRO_SURFACE_TYPE_PDF", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PDF},
        {"CAIRO_SURFACE_TYPE_PS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PS},
        {"CAIRO_SURFACE_TYPE_XLIB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XLIB},
        {"CAIRO_SURFACE_TYPE_XCB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XCB},
        {"CAIRO_SURFACE_TYPE_GLITZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_GLITZ},
        {"CAIRO_SURFACE_TYPE_QUARTZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ},
        {"CAIRO_SURFACE_TYPE_WIN32", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32},
        {"CAIRO_SURFACE_TYPE_BEOS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_BEOS},
        {"CAIRO_SURFACE_TYPE_DIRECTFB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_DIRECTFB},
        {"CAIRO_SURFACE_TYPE_SVG", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_SVG},
        {"CAIRO_SURFACE_TYPE_OS2", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_OS2},
        {"CAIRO_SURFACE_TYPE_WIN32_PRINTING", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32_PRINTING},
        {"CAIRO_SURFACE_TYPE_QUARTZ_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ_IMAGE},
        {"CAIRO_FORMAT_ARGB32", "cairo_format_t", CAIRO_FORMAT_ARGB32},
        {"CAIRO_FORMAT_RGB24", "cairo_format_t", CAIRO_FORMAT_RGB24},
        {"CAIRO_FORMAT_A8", "cairo_format_t", CAIRO_FORMAT_A8},
        {"CAIRO_FORMAT_A1", "cairo_format_t", CAIRO_FORMAT_A1},
        {"CAIRO_PATTERN_TYPE_SOLID", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SOLID},
        {"CAIRO_PATTERN_TYPE_SURFACE", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SURFACE},
        {"CAIRO_PATTERN_TYPE_LINEAR", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_LINEAR},
        {"CAIRO_PATTERN_TYPE_RADIAL", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_RADIAL},
        {"CAIRO_EXTEND_NONE", "cairo_extend_t", CAIRO_EXTEND_NONE},
        {"CAIRO_EXTEND_REPEAT", "cairo_extend_t", CAIRO_EXTEND_REPEAT},
        {"CAIRO_EXTEND_REFLECT", "cairo_extend_t", CAIRO_EXTEND_REFLECT},
        {"CAIRO_EXTEND_PAD", "cairo_extend_t", CAIRO_EXTEND_PAD},
        {"CAIRO_FILTER_FAST", "cairo_filter_t", CAIRO_FILTER_FAST},
        {"CAIRO_FILTER_GOOD", "cairo_filter_t", CAIRO_FILTER_GOOD},
        {"CAIRO_FILTER_BEST", "cairo_filter_t", CAIRO_FILTER_BEST},
        {"CAIRO_FILTER_NEAREST", "cairo_filter_t", CAIRO_FILTER_NEAREST},
        {"CAIRO_FILTER_BILINEAR", "cairo_filter_t", CAIRO_FILTER_BILINEAR},
        {"CAIRO_FILTER_GAUSSIAN", "cairo_filter_t", CAIRO_FILTER_GAUSSIAN},
        {"GTK_DRAG_RESULT_SUCCESS", "GtkDragResult", GTK_DRAG_RESULT_SUCCESS},
        {"GTK_DRAG_RESULT_NO_TARGET", "GtkDragResult", GTK_DRAG_RESULT_NO_TARGET},
        {"GTK_DRAG_RESULT_USER_CANCELLED", "GtkDragResult", GTK_DRAG_RESULT_USER_CANCELLED},
        {"GTK_DRAG_RESULT_TIMEOUT_EXPIRED", "GtkDragResult", GTK_DRAG_RESULT_TIMEOUT_EXPIRED},
        {"GTK_DRAG_RESULT_GRAB_BROKEN", "GtkDragResult", GTK_DRAG_RESULT_GRAB_BROKEN},
        {"GTK_DRAG_RESULT_ERROR", "GtkDragResult", GTK_DRAG_RESULT_ERROR},
#endif
#if GTK_CHECK_VERSION(2, 14, 0)
        {"GTK_CALENDAR_SHOW_DETAILS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DETAILS},
        {"GDK_CROSSING_GTK_GRAB", "GdkCrossingMode", GDK_CROSSING_GTK_GRAB},
        {"GDK_CROSSING_GTK_UNGRAB", "GdkCrossingMode", GDK_CROSSING_GTK_UNGRAB},
        {"GDK_CROSSING_STATE_CHANGED", "GdkCrossingMode", GDK_CROSSING_STATE_CHANGED},
#endif
#if GTK_CHECK_VERSION(2, 16, 0)
        {"GTK_ENTRY_ICON_PRIMARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_PRIMARY},
        {"GTK_ENTRY_ICON_SECONDARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_SECONDARY},
        {"GDK_BLANK_CURSOR ", "GdkCursorType", GDK_BLANK_CURSOR },
#endif
#if GTK_CHECK_VERSION(2, 18, 0)
        {"PANGO_WEIGHT_THIN", "PangoWeight", PANGO_WEIGHT_THIN},
        {"PANGO_WEIGHT_BOOK", "PangoWeight", PANGO_WEIGHT_BOOK},
        {"PANGO_WEIGHT_MEDIUM", "PangoWeight", PANGO_WEIGHT_MEDIUM},
        {"GDK_WINDOW_OFFSCREEN", "GdkWindowType", GDK_WINDOW_OFFSCREEN},
#endif
#if GTK_CHECK_VERSION(3, 0, 0)
        {"GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH", "GtkSizeRequestMode", GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH},
        {"GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT", "GtkSizeRequestMode", GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT},
        {"GTK_ASSISTANT_PAGE_CUSTOM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CUSTOM},
        {"GTK_TEXT_SEARCH_CASE_INSENSITIVE", "GtkTextSearchFlags", GTK_TEXT_SEARCH_CASE_INSENSITIVE},
        {"GTK_SCROLL_MINIMUM", "GtkScrollablePolicy", GTK_SCROLL_MINIMUM},
        {"GTK_SCROLL_NATURAL", "GtkScrollablePolicy", GTK_SCROLL_NATURAL},
        {"GTK_TARGET_SAME_APP", "GtkTargetFlags", GTK_TARGET_SAME_APP},
        {"GTK_TARGET_SAME_WIDGET", "GtkTargetFlags", GTK_TARGET_SAME_WIDGET},
        {"GTK_TARGET_OTHER_APP", "GtkTargetFlags", GTK_TARGET_OTHER_APP},
        {"GTK_TARGET_OTHER_WIDGET", "GtkTargetFlags", GTK_TARGET_OTHER_WIDGET},
        {"GTK_ALIGN_FILL", "GtkAlign", GTK_ALIGN_FILL},
        {"GTK_ALIGN_START", "GtkAlign", GTK_ALIGN_START},
        {"GTK_ALIGN_END", "GtkAlign", GTK_ALIGN_END},
        {"GTK_ALIGN_CENTER", "GtkAlign", GTK_ALIGN_CENTER},
        {"GTK_TOOL_PALETTE_DRAG_ITEMS", "GtkToolPaletteDragTargets", GTK_TOOL_PALETTE_DRAG_ITEMS},
        {"GTK_TOOL_PALETTE_DRAG_GROUPS", "GtkToolPaletteDragTargets", GTK_TOOL_PALETTE_DRAG_GROUPS},
        {"GTK_IMAGE_GICON", "GtkImageType", GTK_IMAGE_GICON},
        {"GTK_FILE_CHOOSER_ERROR_NONEXISTENT", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_NONEXISTENT},
        {"GTK_FILE_CHOOSER_ERROR_BAD_FILENAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_BAD_FILENAME},
        {"GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS},
        {"GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME},
        {"GTK_ICON_LOOKUP_FORCE_SIZE", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_SIZE},
        {"GTK_ICON_THEME_NOT_FOUND", "GtkIconThemeError", GTK_ICON_THEME_NOT_FOUND},
        {"GTK_ICON_THEME_FAILED", "GtkIconThemeError", GTK_ICON_THEME_FAILED},
        {"GTK_STATE_FLAG_NORMAL", "GtkStateFlags", GTK_STATE_FLAG_NORMAL},
        {"GTK_STATE_FLAG_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_ACTIVE},
        {"GTK_STATE_FLAG_PRELIGHT", "GtkStateFlags", GTK_STATE_FLAG_PRELIGHT},
        {"GTK_STATE_FLAG_SELECTED", "GtkStateFlags", GTK_STATE_FLAG_SELECTED},
        {"GTK_STATE_FLAG_INSENSITIVE", "GtkStateFlags", GTK_STATE_FLAG_INSENSITIVE},
        {"GTK_STATE_FLAG_INCONSISTENT", "GtkStateFlags", GTK_STATE_FLAG_INCONSISTENT},
        {"GTK_STATE_FLAG_FOCUSED", "GtkStateFlags", GTK_STATE_FLAG_FOCUSED},
#endif
#if GTK_CHECK_VERSION(3, 10, 0)
        {"GTK_ALIGN_BASELINE", "GtkAlign", GTK_ALIGN_BASELINE},
        {"GTK_BASELINE_POSITION_TOP", "GtkBaselinePosition", GTK_BASELINE_POSITION_TOP},
        {"GTK_BASELINE_POSITION_CENTER", "GtkBaselinePosition", GTK_BASELINE_POSITION_CENTER},
        {"GTK_BASELINE_POSITION_BOTTOM", "GtkBaselinePosition", GTK_BASELINE_POSITION_BOTTOM},
        {"GTK_PLACES_OPEN_NORMAL", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NORMAL},
        {"GTK_PLACES_OPEN_NEW_TAB", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_TAB},
        {"GTK_PLACES_OPEN_NEW_WINDOW", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_WINDOW},
        {"GTK_STACK_TRANSITION_TYPE_NONE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_NONE},
        {"GTK_STACK_TRANSITION_TYPE_CROSSFADE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_CROSSFADE},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN},
        {"GTK_REVEALER_TRANSITION_TYPE_NONE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_NONE},
        {"GTK_REVEALER_TRANSITION_TYPE_CROSSFADE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_CROSSFADE},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN},
        {"GDK_WINDOW_STATE_TILED", "GdkWindowState", GDK_WINDOW_STATE_TILED},
#endif
#if GTK_CHECK_VERSION(3, 12, 0)
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP},
        {"GTK_STACK_TRANSITION_TYPE_OVER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_UP},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN},
#endif
#if GTK_CHECK_VERSION(3, 14, 0)
        {"GTK_PHASE_NONE", "GtkPropagationPhase", GTK_PHASE_NONE},
        {"GTK_PHASE_CAPTURE", "GtkPropagationPhase", GTK_PHASE_CAPTURE},
        {"GTK_PHASE_BUBBLE", "GtkPropagationPhase", GTK_PHASE_BUBBLE},
        {"GTK_PHASE_TARGET", "GtkPropagationPhase", GTK_PHASE_TARGET},
        {"GTK_TEXT_VIEW_LAYER_BELOW", "GtkTextViewLayer", GTK_TEXT_VIEW_LAYER_BELOW},
        {"GTK_TEXT_VIEW_LAYER_ABOVE", "GtkTextViewLayer", GTK_TEXT_VIEW_LAYER_ABOVE},
#endif
#if GTK_CHECK_VERSION(3, 16, 0)
        {"GTK_POLICY_EXTERNAL", "GtkPolicyType", GTK_POLICY_EXTERNAL},
        {"PANGO_WEIGHT_SEMILIGHT", "PangoWeight", PANGO_WEIGHT_SEMILIGHT},
        {"GTK_TEXT_EXTEND_SELECTION_WORD", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_WORD},
        {"GTK_TEXT_EXTEND_SELECTION_LINE", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_LINE},
#endif
#if GTK_CHECK_VERSION(3, 18, 0)
        {"GDK_TOUCHPAD_SWIPE", "GdkEventType", GDK_TOUCHPAD_SWIPE},
        {"GDK_TOUCHPAD_PINCH", "GdkEventType", GDK_TOUCHPAD_PINCH},
        {"GDK_TOUCHPAD_GESTURE_PHASE_BEGIN", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_BEGIN},
        {"GDK_TOUCHPAD_GESTURE_PHASE_UPDATE", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_UPDATE},
        {"GDK_TOUCHPAD_GESTURE_PHASE_END", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_END},
        {"GDK_TOUCHPAD_GESTURE_PHASE_CANCEL", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_CANCEL},
        {"GDK_TOUCHPAD_GESTURE_MASK", "GdkEventMask", GDK_TOUCHPAD_GESTURE_MASK},
        {"GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK", "GdkModifierIntent", GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK},
#endif
#if GTK_CHECK_VERSION(3, 2, 0)
        {"GTK_SIZE_REQUEST_CONSTANT_SIZE", "GtkSizeRequestMode", GTK_SIZE_REQUEST_CONSTANT_SIZE},
#endif
#if GTK_CHECK_VERSION(3, 20, 0)
        {"GTK_SHORTCUT_ACCELERATOR", "GtkShortcutType", GTK_SHORTCUT_ACCELERATOR},
        {"GTK_SHORTCUT_GESTURE_PINCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_PINCH},
        {"GTK_SHORTCUT_GESTURE_STRETCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_STRETCH},
        {"GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT},
        {"GTK_SHORTCUT_GESTURE", "GtkShortcutType", GTK_SHORTCUT_GESTURE},
        {"GTK_POPOVER_CONSTRAINT_NONE", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_NONE},
        {"GTK_POPOVER_CONSTRAINT_WINDOW", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_WINDOW},
        {"GDK_WINDOW_TYPE_HINT_SPLASHSCREEN", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_SPLASHSCREEN},
        {"GDK_WINDOW_TYPE_HINT_UTILITY", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_UTILITY},
        {"GDK_WINDOW_TYPE_HINT_DOCK", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DOCK},
        {"GDK_WINDOW_TYPE_HINT_DESKTOP", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DESKTOP},
        {"GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU},
        {"GDK_WINDOW_TYPE_HINT_POPUP_MENU", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_POPUP_MENU},
        {"GDK_WINDOW_TYPE_HINT_TOOLTIP", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_TOOLTIP},
        {"GDK_WINDOW_TYPE_HINT_NOTIFICATION", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_NOTIFICATION},
        {"GDK_WINDOW_TYPE_HINT_COMBO", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_COMBO},
        {"GDK_WINDOW_TYPE_HINT_DND", "GdkWindowTypeHint", GDK_WINDOW_TYPE_HINT_DND},
        {"GDK_SEAT_CAPABILITY_NONE", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_NONE},
        {"GDK_SEAT_CAPABILITY_POINTER", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_POINTER},
        {"GDK_SEAT_CAPABILITY_TOUCH", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TOUCH},
        {"GDK_SEAT_CAPABILITY_TABLET_STYLUS", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TABLET_STYLUS},
        {"GDK_SEAT_CAPABILITY_KEYBOARD", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_KEYBOARD},
        {"GDK_SEAT_CAPABILITY_ALL_POINTING", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL_POINTING},
        {"GDK_SEAT_CAPABILITY_ALL", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL},
        {"GTK_STATE_FLAG_DROP_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_DROP_ACTIVE},
        {"GDK_DRAG_CANCEL_NO_TARGET", "GdkDragCancelReason", GDK_DRAG_CANCEL_NO_TARGET},
        {"GDK_DRAG_CANCEL_USER_CANCELLED", "GdkDragCancelReason", GDK_DRAG_CANCEL_USER_CANCELLED},
        {"GDK_DRAG_CANCEL_ERROR", "GdkDragCancelReason", GDK_DRAG_CANCEL_ERROR},
#endif
#if GTK_CHECK_VERSION(3, 22, 0)
        {"GDK_AXIS_IGNORE", "GdkAxisUse", GDK_AXIS_IGNORE},
        {"GDK_AXIS_X", "GdkAxisUse", GDK_AXIS_X},
        {"GDK_AXIS_Y", "GdkAxisUse", GDK_AXIS_Y},
        {"GDK_AXIS_PRESSURE", "GdkAxisUse", GDK_AXIS_PRESSURE},
        {"GDK_AXIS_XTILT", "GdkAxisUse", GDK_AXIS_XTILT},
        {"GDK_AXIS_YTILT", "GdkAxisUse", GDK_AXIS_YTILT},
        {"GDK_AXIS_WHEEL", "GdkAxisUse", GDK_AXIS_WHEEL},
        {"GDK_AXIS_LAST", "GdkAxisUse", GDK_AXIS_LAST},
        {"GDK_AXIS_FLAG_X", "GdkAxisFlags", GDK_AXIS_FLAG_X},
        {"GDK_AXIS_FLAG_Y", "GdkAxisFlags", GDK_AXIS_FLAG_Y},
        {"GDK_AXIS_FLAG_PRESSURE", "GdkAxisFlags", GDK_AXIS_FLAG_PRESSURE},
        {"GDK_AXIS_FLAG_XTILT", "GdkAxisFlags", GDK_AXIS_FLAG_XTILT},
        {"GDK_AXIS_FLAG_YTILT", "GdkAxisFlags", GDK_AXIS_FLAG_YTILT},
        {"GDK_AXIS_FLAG_WHEEL", "GdkAxisFlags", GDK_AXIS_FLAG_WHEEL},
        {"GDK_AXIS_FLAG_DISTANCE", "GdkAxisFlags", GDK_AXIS_FLAG_DISTANCE},
        {"GDK_AXIS_FLAG_ROTATION", "GdkAxisFlags", GDK_AXIS_FLAG_ROTATION},
        {"GDK_AXIS_FLAG_SLIDER", "GdkAxisFlags", GDK_AXIS_FLAG_SLIDER},
        {"GDK_DEVICE_TOOL_TYPE_UNKNOWN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_UNKNOWN},
        {"GDK_DEVICE_TOOL_TYPE_PEN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PEN},
        {"GDK_DEVICE_TOOL_TYPE_ERASER", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_ERASER},
        {"GDK_DEVICE_TOOL_TYPE_BRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_BRUSH},
        {"GDK_DEVICE_TOOL_TYPE_PENCIL", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PENCIL},
        {"GDK_DEVICE_TOOL_TYPE_AIRBRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_AIRBRUSH},
        {"GDK_DEVICE_TOOL_TYPE_MOUSE", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_MOUSE},
        {"GDK_DEVICE_TOOL_TYPE_LENS", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_LENS},
        {"GDK_SUBPIXEL_LAYOUT_UNKNOWN", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_UNKNOWN},
        {"GDK_SUBPIXEL_LAYOUT_NONE", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_NONE},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR},
        {"GDK_DEVICE_PAD_FEATURE_BUTTON", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_BUTTON},
        {"GDK_DEVICE_PAD_FEATURE_RING", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_RING},
        {"GDK_DEVICE_PAD_FEATURE_STRIP", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_STRIP},
        {"GDK_PAD_BUTTON_PRESS", "GdkEventType", GDK_PAD_BUTTON_PRESS},
        {"GDK_PAD_BUTTON_RELEASE", "GdkEventType", GDK_PAD_BUTTON_RELEASE},
        {"GDK_PAD_RING", "GdkEventType", GDK_PAD_RING},
        {"GDK_PAD_STRIP", "GdkEventType", GDK_PAD_STRIP},
        {"GDK_PAD_GROUP_MODE", "GdkEventType", GDK_PAD_GROUP_MODE},
        {"GDK_TABLET_PAD_MASK", "GdkEventMask", GDK_TABLET_PAD_MASK},
        {"GDK_ANCHOR_FLIP_X", "GdkAnchorHints", GDK_ANCHOR_FLIP_X},
        {"GDK_ANCHOR_FLIP_Y", "GdkAnchorHints", GDK_ANCHOR_FLIP_Y},
        {"GDK_ANCHOR_SLIDE_X", "GdkAnchorHints", GDK_ANCHOR_SLIDE_X},
        {"GDK_ANCHOR_SLIDE_Y", "GdkAnchorHints", GDK_ANCHOR_SLIDE_Y},
        {"GDK_ANCHOR_RESIZE_X", "GdkAnchorHints", GDK_ANCHOR_RESIZE_X},
        {"GDK_ANCHOR_RESIZE_Y", "GdkAnchorHints", GDK_ANCHOR_RESIZE_Y},
        {"GDK_ANCHOR_FLIP", "GdkAnchorHints", GDK_ANCHOR_FLIP},
        {"GDK_ANCHOR_SLIDE", "GdkAnchorHints", GDK_ANCHOR_SLIDE},
        {"GDK_ANCHOR_RESIZE", "GdkAnchorHints", GDK_ANCHOR_RESIZE},
        {"GTK_PAD_ACTION_BUTTON", "GtkPadActionType", GTK_PAD_ACTION_BUTTON},
        {"GTK_PAD_ACTION_RING", "GtkPadActionType", GTK_PAD_ACTION_RING},
        {"GTK_PAD_ACTION_STRIP", "GtkPadActionType", GTK_PAD_ACTION_STRIP},
#endif
#if GTK_CHECK_VERSION(3, 4, 0)
        {"GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR", "GdkModifierIntent", GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR},
        {"GDK_MODIFIER_INTENT_CONTEXT_MENU", "GdkModifierIntent", GDK_MODIFIER_INTENT_CONTEXT_MENU},
        {"GDK_MODIFIER_INTENT_EXTEND_SELECTION", "GdkModifierIntent", GDK_MODIFIER_INTENT_EXTEND_SELECTION},
        {"GDK_MODIFIER_INTENT_MODIFY_SELECTION", "GdkModifierIntent", GDK_MODIFIER_INTENT_MODIFY_SELECTION},
        {"GDK_MODIFIER_INTENT_NO_TEXT_INPUT", "GdkModifierIntent", GDK_MODIFIER_INTENT_NO_TEXT_INPUT},
        {"GDK_MODIFIER_INTENT_SHIFT_GROUP", "GdkModifierIntent", GDK_MODIFIER_INTENT_SHIFT_GROUP},
        {"GTK_REGION_ONLY", "GtkRegionFlags", GTK_REGION_ONLY},
        {"GDK_WINDOW_STATE_FOCUSED", "GdkWindowState", GDK_WINDOW_STATE_FOCUSED},
        {"GTK_CELL_RENDERER_EXPANDABLE", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDABLE},
        {"GTK_CELL_RENDERER_EXPANDED", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDED},
        {"GTK_STATE_FLAG_BACKDROP", "GtkStateFlags", GTK_STATE_FLAG_BACKDROP},
#endif
#if GTK_CHECK_VERSION(3, 6, 0)
        {"GDK_TOUCH_BEGIN", "GdkEventType", GDK_TOUCH_BEGIN},
        {"GDK_TOUCH_UPDATE", "GdkEventType", GDK_TOUCH_UPDATE},
        {"GDK_TOUCH_END", "GdkEventType", GDK_TOUCH_END},
        {"GDK_TOUCH_CANCEL", "GdkEventType", GDK_TOUCH_CANCEL},
        {"GDK_SCROLL_SMOOTH", "GdkScrollDirection", GDK_SCROLL_SMOOTH},
        {"GDK_CROSSING_TOUCH_BEGIN", "GdkCrossingMode", GDK_CROSSING_TOUCH_BEGIN},
        {"GDK_CROSSING_TOUCH_END", "GdkCrossingMode", GDK_CROSSING_TOUCH_END},
        {"GDK_CROSSING_DEVICE_SWITCH", "GdkCrossingMode", GDK_CROSSING_DEVICE_SWITCH},
        {"GDK_TOUCH_MASK", "GdkEventMask", GDK_TOUCH_MASK},
        {"GDK_SMOOTH_SCROLL_MASK", "GdkEventMask", GDK_SMOOTH_SCROLL_MASK},
        {"GTK_LEVEL_BAR_MODE_CONTINUOUS", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_CONTINUOUS},
        {"GTK_LEVEL_BAR_MODE_DISCRETE", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_DISCRETE},
        {"GTK_INPUT_PURPOSE_FREE_FORM", "GtkInputPurpose", GTK_INPUT_PURPOSE_FREE_FORM},
        {"GTK_INPUT_PURPOSE_ALPHA", "GtkInputPurpose", GTK_INPUT_PURPOSE_ALPHA},
        {"GTK_INPUT_PURPOSE_DIGITS", "GtkInputPurpose", GTK_INPUT_PURPOSE_DIGITS},
        {"GTK_INPUT_PURPOSE_NUMBER", "GtkInputPurpose", GTK_INPUT_PURPOSE_NUMBER},
        {"GTK_INPUT_PURPOSE_PHONE", "GtkInputPurpose", GTK_INPUT_PURPOSE_PHONE},
        {"GTK_INPUT_PURPOSE_URL", "GtkInputPurpose", GTK_INPUT_PURPOSE_URL},
        {"GTK_INPUT_PURPOSE_EMAIL", "GtkInputPurpose", GTK_INPUT_PURPOSE_EMAIL},
        {"GTK_INPUT_PURPOSE_NAME", "GtkInputPurpose", GTK_INPUT_PURPOSE_NAME},
        {"GTK_INPUT_PURPOSE_PASSWORD", "GtkInputPurpose", GTK_INPUT_PURPOSE_PASSWORD},
        {"GTK_INPUT_PURPOSE_PIN", "GtkInputPurpose", GTK_INPUT_PURPOSE_PIN},
        {"GTK_INPUT_HINT_NONE", "GtkInputHints", GTK_INPUT_HINT_NONE},
        {"GTK_INPUT_HINT_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_SPELLCHECK},
        {"GTK_INPUT_HINT_NO_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_NO_SPELLCHECK},
        {"GTK_INPUT_HINT_WORD_COMPLETION", "GtkInputHints", GTK_INPUT_HINT_WORD_COMPLETION},
        {"GTK_INPUT_HINT_LOWERCASE", "GtkInputHints", GTK_INPUT_HINT_LOWERCASE},
        {"GTK_INPUT_HINT_UPPERCASE_CHARS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_CHARS},
        {"GTK_INPUT_HINT_UPPERCASE_WORDS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_WORDS},
        {"GTK_INPUT_HINT_UPPERCASE_SENTENCES", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_SENTENCES},
        {"GTK_INPUT_HINT_INHIBIT_OSK", "GtkInputHints", GTK_INPUT_HINT_INHIBIT_OSK},
#endif
#if GTK_CHECK_VERSION(3, 8, 0)
        {"GTK_STATE_FLAG_DIR_LTR", "GtkStateFlags", GTK_STATE_FLAG_DIR_LTR},
        {"GTK_STATE_FLAG_DIR_RTL", "GtkStateFlags", GTK_STATE_FLAG_DIR_RTL},
        {"GDK_FULLSCREEN_ON_CURRENT_MONITOR", "GdkFullscreenMode", GDK_FULLSCREEN_ON_CURRENT_MONITOR},
        {"GDK_FULLSCREEN_ON_ALL_MONITORS", "GdkFullscreenMode", GDK_FULLSCREEN_ON_ALL_MONITORS},
#endif
#if GTK_CHECK_VERSION(3, 99, 0)
        {"GTK_SHORTCUT_GESTURE_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_RIGHT},
#endif
        {NULL, NULL, 0}};

static s7_pointer enum_value_to_name(s7_scheme *sc, int64_t val, const char *type) 
{ 
  int k; 
  int64_t range_min = 0, range_max = 0; 
  bool range_set = false; 
  for (k = 0; ; k++) 
    { 
      enummer_t nt; 
      nt = enum_info[k]; 
      if (!nt.name) 
	break; 
      if (strcmp(nt.type, type) == 0) 
	{ 
	  if (nt.value == val)        /* ... value should be <nt.name> */ 
	    return(s7_make_string(sc, nt.name)); 
	  if (!range_set) 
	    { 
	      range_min = nt.value; 
	      range_max = nt.value; 
	      range_set = true; 
	    } 
	  else 
	    { 
	      if (range_min > nt.value) range_min = nt.value; 
	      if (range_max < nt.value) range_max = nt.value; 
	    } 
	} 
    } 
  if (range_set)       /* here we found a matching name, its type is wrong, and it's out of range */ 
    { 
      char *range_string; 
      s7_pointer str; 
      range_string = (char *)malloc(256 * sizeof(char)); 
      snprintf(range_string, 256, "between %" PRId64 " and %" PRId64, range_min, range_max); 
      str = s7_make_string(sc, range_string); 
      free(range_string); 
      return(str);                            /* ... value should be between <min> and <max> */ 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static s7_pointer g_gtk_enum_t(s7_scheme *sc, s7_pointer args) 
{ 
  s7_pointer form, argn, func, arg; 
  const char *doc_string, *p; 
  int arg_number; 
  form = s7_car(args);  
  argn = s7_cadr(args); 
  arg_number = s7_integer(argn); 
  arg = s7_list_ref(sc, form, arg_number); 
  if ((!s7_is_integer(arg)) && 
      (!s7_is_symbol(arg))) 
    return(s7_make_symbol(sc, "integer?")); 
  func = s7_car(form); 
  doc_string = s7_procedure_documentation(sc, func); 
  p = strchr(doc_string, (int)'('); 
  if (p) 
    { 
      int i; 
      for (i = 1; i < arg_number; i++) 
	p = strchr((char *)(p + 1), (int)','); 
      if (p) 
	{ 
	  const char *e; 
	  p += 2; /* past comma and space */ 
	  e = strchr(p, (int)' '); 
	  if (e) 
	    { 
	      int len; 
	      char *type; 
	      len = e - p + 1; 
	      type = (char *)malloc(len * sizeof(char)); 
	      for (i = 0; i < len; i++) type[i] = p[i]; 
	      type[len - 1] = '\0'; 
	      if (s7_is_symbol(arg)) 
		{ 
		  const char *arg_name; 
		  arg_name = s7_symbol_name(arg); /* no free */ 
		  for (i = 0; ; i++) 
		    { 
		      enummer_t et; 
		      et = enum_info[i]; 
		      if (!et.name) 
			break; 
		      if (strcmp(et.name, arg_name) == 0) 
			{ 
			  if (strcmp(et.type, type) == 0)                 /* success -- name and type match */ 
			    { 
			      free(type); 
			      return(s7_t(sc)); 
			    } 
			  return(enum_value_to_name(sc, et.value, type)); /* here the type is wrong, so try to find the correct name */ 
			} 
		    } 
		  return(s7_make_symbol(sc, "integer?"));               /* here we got no matches, so return 'integer? */ 
		} 
	      return(enum_value_to_name(sc, s7_integer(arg), type));      /* here arg is an integer */ 
	    } 
	} 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static void define_lint(s7_scheme *sc)
{
  s7_define_safe_function(sc, "gtk_enum_t?", g_gtk_enum_t, 2, 0, 0, "lint helper");
}

void libgtk_s7_init(s7_scheme *sc);
void libgtk_s7_init(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

  cbsc = sc;
  lg_true = s7_t(sc);
  lg_false = s7_f(sc);
  define_xm_obj(sc);
  define_integers(sc);
  define_doubles(sc);
  define_atoms(sc);
  define_strings(sc);
  define_symbols(sc);
  define_lint(sc);
  define_structs(sc);
  define_functions(sc);
  s7_define_function(sc, "g_signal_connect", lg_g_signal_connect, 3, 1, 0, H_g_signal_connect);

  s7_provide(sc, "libgtk");
  #if GTK_CHECK_VERSION(3, 90, 0)
    s7_provide(sc, "gtk4");
  #else
    #if GTK_CHECK_VERSION(3, 0, 0)
      s7_provide(sc, "gtk3");
    #else
      s7_provide(sc, "gtk2");
    #endif
  #endif
  s7_define(sc, cur_env, s7_make_symbol(sc, "libgtk-version"), s7_make_string(sc, "08-Sep-17"));
}
/* gcc -c libgtk_s7.c -o libgtk_s7.o -I. -fPIC `pkg-config --libs gtk+-3.0 --cflags` -lm -ldl */
/* gcc libgtk_s7.o -shared -o libgtk_s7.so */
/* (load "libgtk_s7.so" (define *gtk* (inlet 'init_func 'libgtk_s7_init))) */
